| package |
package := Package name: 'SmaCC C Parser'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains an example C parser. The parser isn''t that useful though as it does not do any preprocessing.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #CParser;
	add: #CScanner;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	yourself).

package!

"Class Definitions"!

SmaCCParser subclass: #CParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #CScanner
	instanceVariableNames: 'typeNames'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

CParser guid: (GUID fromString: '{D6016F41-E219-4EA1-B838-19C207A1D9E5}')!
CParser comment: ''!
!CParser categoriesForClass!Unclassified! !
!CParser methodsFor!

addTypeName: aString 
	scanner addTypeName: aString!

reduceActionForenum_specifier3: nodes
	self addTypeName: (nodes at: 2) value.
	^self reduceFor: nodes!

reduceActionForinit_declaration1: nodes
	(nodes at: 1) first value = 'typedef'
		ifTrue:
			[1
				to: (nodes at: 2) size
				by: 2
				do: [:i | self addTypeName: ((nodes at: 2) at: i) value]].
	^self reduceFor: nodes!

reduceTable
^#(
	#(127 1 #reduceFor:) 
	#(111 1 #reduceFor:) 
	#(117 1 #reduceFor:) 
	#(110 1 #reduceFor:) 
	#(109 1 #reduceFor:) 
	#(128 1 #reduceFor:) 
	#(113 1 #reduceFor:) 
	#(105 1 #reduceFor:) 
	#(151 1 #reduceFor:) 
	#(150 1 #reduceFor:) 
	#(131 1 #reduceFor:) 
	#(127 2 #reduceFor:) 
	#(116 2 #reduceActionForenum_specifier3:) 
	#(107 2 #reduceFor:) 
	#(106 2 #reduceActionForinit_declaration1:) 
	#(108 1 #reduceFor:) 
	#(112 1 #reduceFor:) 
	#(105 2 #reduceFor:) 
	#(115 2 #reduceActionForenum_specifier3:) 
	#(150 2 #reduceFor:) 
	#(146 1 #reduceFor:) 
	#(147 2 #reduceFor:) 
	#(151 2 #reduceFor:) 
	#(128 3 #reduceFor:) 
	#(131 2 #reduceFor:) 
	#(127 3 #reduceFor:) 
	#(126 1 #reduceFor:) 
	#(125 1 #reduceFor:) 
	#(147 3 #reduceFor:) 
	#(122 1 #reduceFor:) 
	#(84 1 #reduceFor:) 
	#(130 1 #reduceFor:) 
	#(134 1 #reduceFor:) 
	#(129 1 #reduceFor:) 
	#(132 1 #reduceFor:) 
	#(89 1 #reduceFor:) 
	#(102 1 #reduceFor:) 
	#(104 1 #reduceFor:) 
	#(90 1 #reduceFor:) 
	#(92 1 #reduceFor:) 
	#(93 1 #reduceFor:) 
	#(94 1 #reduceFor:) 
	#(95 1 #reduceFor:) 
	#(96 1 #reduceFor:) 
	#(97 1 #reduceFor:) 
	#(98 1 #reduceFor:) 
	#(119 1 #reduceFor:) 
	#(101 1 #reduceFor:) 
	#(85 1 #reduceFor:) 
	#(120 1 #reduceFor:) 
	#(100 1 #reduceFor:) 
	#(88 1 #reduceFor:) 
	#(140 1 #reduceFor:) 
	#(139 2 #reduceFor:) 
	#(87 1 #reduceFor:) 
	#(118 1 #reduceFor:) 
	#(144 1 #reduceFor:) 
	#(145 1 #reduceFor:) 
	#(146 2 #reduceFor:) 
	#(116 4 #reduceFor:) 
	#(108 3 #reduceFor:) 
	#(99 1 #reduceFor:) 
	#(112 3 #reduceFor:) 
	#(147 4 #reduceFor:) 
	#(115 4 #reduceFor:) 
	#(84 2 #reduceFor:) 
	#(122 2 #reduceFor:) 
	#(123 1 #reduceFor:) 
	#(124 1 #reduceFor:) 
	#(135 1 #reduceFor:) 
	#(134 2 #reduceFor:) 
	#(128 4 #reduceFor:) 
	#(88 2 #reduceFor:) 
	#(91 1 #reduceFor:) 
	#(120 2 #reduceFor:) 
	#(143 2 #reduceFor:) 
	#(103 1 #reduceFor:) 
	#(140 2 #reduceFor:) 
	#(139 3 #reduceFor:) 
	#(145 2 #reduceFor:) 
	#(116 5 #reduceActionForenum_specifier3:) 
	#(126 3 #reduceFor:) 
	#(125 3 #reduceFor:) 
	#(137 1 #reduceFor:) 
	#(115 5 #reduceActionForenum_specifier3:) 
	#(124 2 #reduceFor:) 
	#(121 3 #reduceFor:) 
	#(136 2 #reduceFor:) 
	#(135 2 #reduceFor:) 
	#(130 3 #reduceFor:) 
	#(129 3 #reduceFor:) 
	#(132 3 #reduceFor:) 
	#(102 3 #reduceFor:) 
	#(91 2 #reduceFor:) 
	#(92 3 #reduceFor:) 
	#(93 3 #reduceFor:) 
	#(94 3 #reduceFor:) 
	#(95 3 #reduceFor:) 
	#(96 3 #reduceFor:) 
	#(97 3 #reduceFor:) 
	#(98 3 #reduceFor:) 
	#(100 3 #reduceFor:) 
	#(101 3 #reduceFor:) 
	#(119 3 #reduceFor:) 
	#(120 3 #reduceFor:) 
	#(86 1 #reduceFor:) 
	#(138 3 #reduceFor:) 
	#(143 3 #reduceFor:) 
	#(87 3 #reduceFor:) 
	#(118 3 #reduceFor:) 
	#(139 4 #reduceFor:) 
	#(99 3 #reduceFor:) 
	#(123 3 #reduceFor:) 
	#(124 3 #reduceFor:) 
	#(136 3 #reduceFor:) 
	#(90 4 #reduceFor:) 
	#(88 4 #reduceFor:) 
	#(120 4 #reduceFor:) 
	#(138 4 #reduceFor:) 
	#(99 4 #reduceFor:) 
	#(137 3 #reduceFor:) 
	#(136 4 #reduceFor:) 
	#(85 5 #reduceFor:) 
	#(86 3 #reduceFor:) 
	#(141 5 #reduceFor:) 
	#(142 5 #reduceFor:) 
	#(142 6 #reduceFor:) 
	#(142 7 #reduceFor:) 
	#(141 7 #reduceFor:)
	).!

transitionTable
^#(
#[1 0 9 0 24 0 13 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 105 0 101 0 106 0 105 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 121 0 113 0 125 0 115 0 129 0 116 0 133 0 117 0 137 0 127 0 141 0 128 0 145 0 133 0 149 0 147 0 153 0 150 0 157 0 151] 
#[1 0 9 0 24 0 13 0 34 0 93 0 76 0 137 0 127 0 141 0 128 0 161 0 150] 
#[1 0 6 0 23 0 6 0 24 0 6 0 26 0 13 0 34 0 17 0 39 0 21 0 40 0 6 0 76 0 6 0 79 0 165 0 111 0 169 0 127 0 173 0 131] 
#[0 0 10 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 10 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[1 0 177 0 76 0 181 0 81] 
#[0 0 14 0 76 0 81] 
#[0 0 14 0 76 0 81] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 22 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 22 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 22 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 22 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 22 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 26 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[1 0 9 0 24 0 13 0 34 0 185 0 58 0 93 0 76 0 189 0 108 0 193 0 112 0 137 0 127 0 141 0 128 0 197 0 150] 
#[0 0 201 0 58] 
#[0 0 30 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 0 34 0 23 0 34 0 24 0 34 0 26 0 34 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 34 0 58 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 34 0 76 0 34 0 79 0 205 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133] 
#[1 0 34 0 23 0 34 0 24 0 34 0 26 0 34 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 34 0 58 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 34 0 76 0 34 0 79 0 209 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133] 
#[1 0 34 0 23 0 34 0 24 0 34 0 26 0 34 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 34 0 58 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 34 0 76 0 34 0 79 0 213 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133] 
#[0 0 38 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[1 0 217 0 76 0 221 0 81] 
#[1 0 9 0 24 0 93 0 76 0 225 0 128] 
#[1 0 42 0 13 0 42 0 14 0 42 0 23 0 229 0 24 0 42 0 26 0 42 0 39 0 42 0 40 0 42 0 41 0 42 0 42 0 42 0 43 0 42 0 46 0 42 0 52 0 42 0 55 0 42 0 57 0 42 0 58 0 42 0 63 0 42 0 64 0 42 0 66 0 42 0 67 0 42 0 68 0 42 0 69 0 42 0 70 0 42 0 71 0 42 0 72 0 42 0 73 0 233 0 79 0 42 0 81 0 42 0 133] 
#[0 0 18 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 30 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 237 0 81 0 241 0 105 0 101 0 106 0 245 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133 0 249 0 139 0 253 0 146] 
#[1 0 9 0 24 0 13 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 0 97 0 105 0 101 0 106 0 105 0 107 0 109 0 109 0 113 0 110 0 117 0 111 1 1 0 113 0 125 0 115 0 129 0 116 0 133 0 117 0 137 0 127 0 141 0 128 0 145 0 133 0 149 0 147 0 0 0 148 0 153 0 150] 
#[0 1 5 0 23] 
#[0 0 46 0 23 0 24 0 26 0 34 0 39 0 40 0 76 0 79] 
#[0 0 50 0 23 0 24 0 26 0 76 0 79] 
#[1 0 50 0 23 0 50 0 24 0 50 0 26 0 13 0 34 0 17 0 39 0 21 0 40 0 50 0 76 0 50 0 79 1 9 0 111 1 13 0 127] 
#[1 0 54 0 14 0 54 0 23 0 54 0 24 0 54 0 26 0 54 0 34 0 54 0 39 0 54 0 40 0 54 0 41 0 54 0 42 0 54 0 43 0 54 0 46 0 54 0 52 0 54 0 55 0 54 0 57 0 54 0 58 0 54 0 63 0 54 0 64 0 54 0 66 0 54 0 67 0 54 0 68 0 54 0 69 0 54 0 70 0 54 0 71 0 54 0 72 0 54 0 73 0 54 0 76 0 54 0 79 1 17 0 81 0 54 0 133] 
#[1 1 21 0 76 1 25 0 125 1 29 0 126] 
#[0 0 58 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[1 1 33 0 26 0 62 0 58] 
#[0 0 66 0 26 0 58] 
#[1 1 37 0 13 0 70 0 26 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 70 0 58 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 237 0 81 0 241 0 105 0 101 0 106 0 245 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133 1 41 0 139 1 45 0 146] 
#[0 0 58 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[0 0 74 0 23 0 24 0 26 0 34 0 58 0 76 0 79] 
#[0 0 74 0 23 0 24 0 26 0 34 0 58 0 76 0 79] 
#[0 0 74 0 23 0 24 0 26 0 34 0 58 0 76 0 79] 
#[1 0 78 0 14 0 78 0 23 0 78 0 24 0 78 0 26 0 78 0 34 0 78 0 39 0 78 0 40 0 78 0 41 0 78 0 42 0 78 0 43 0 78 0 46 0 78 0 52 0 78 0 55 0 78 0 57 0 78 0 58 0 78 0 63 0 78 0 64 0 78 0 66 0 78 0 67 0 78 0 68 0 78 0 69 0 78 0 70 0 78 0 71 0 78 0 72 0 78 0 73 0 78 0 76 0 78 0 79 1 49 0 81 0 78 0 133] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 1 53 0 84 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 1 65 0 121 1 69 0 122 0 145 0 133] 
#[1 0 82 0 13 0 82 0 14 0 82 0 23 0 229 0 24 0 82 0 26 0 82 0 39 0 82 0 40 0 82 0 41 0 82 0 42 0 82 0 43 0 82 0 46 0 82 0 52 0 82 0 55 0 82 0 57 0 82 0 58 0 82 0 63 0 82 0 64 0 82 0 66 0 82 0 67 0 82 0 68 0 82 0 69 0 82 0 70 0 82 0 71 0 82 0 72 0 82 0 73 0 233 0 79 0 82 0 81 0 82 0 133] 
#[1 1 73 0 23 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 77 0 76 1 81 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 1 85 0 129 1 89 0 130 1 93 0 132 0 145 0 133 1 97 0 134] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 153 0 80 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 213 0 104 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 1 233 0 45 0 37 0 46 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 0 41 0 52 2 1 0 53 2 5 0 54 0 45 0 55 0 49 0 57 2 9 0 58 0 53 0 63 0 57 0 64 2 13 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 21 0 82 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 0 241 0 105 0 101 0 106 0 245 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 37 0 118 1 217 0 119 1 221 0 120 0 145 0 133 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 2 65 0 144 2 69 0 145 2 73 0 146] 
#[1 0 9 0 24 0 13 0 34 0 185 0 58 0 93 0 76 0 189 0 108 0 193 0 112 0 137 0 127 0 141 0 128 2 77 0 150] 
#[0 0 86 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133] 
#[0 0 90 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 237 0 81 0 241 0 105 0 101 0 106 2 81 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133 2 85 0 139] 
#[0 0 94 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[0 0 98 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[0 0 102 0 23 0 24 0 26 0 34 0 39 0 40 0 76 0 79] 
#[0 0 106 0 23 0 24 0 26 0 76 0 79] 
#[1 1 21 0 76 2 89 0 125 1 29 0 126] 
#[1 2 93 0 13 0 110 0 26 0 110 0 82] 
#[1 2 97 0 26 2 101 0 82] 
#[0 0 114 0 26 0 82] 
#[1 0 9 0 24 0 13 0 34 0 93 0 76 2 105 0 112 0 137 0 127 0 141 0 128 2 77 0 150] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 109 0 81 2 25 0 85 2 113 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 2 117 0 99 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 0 118 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 237 0 81 0 241 0 105 0 101 0 106 2 81 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133 2 121 0 139] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 2 125 0 84 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 1 65 0 121 1 69 0 122 0 145 0 133] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 2 129 0 82 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 133 0 121 1 69 0 122 0 145 0 133] 
#[1 0 122 0 14 0 122 0 23 0 122 0 24 0 122 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 0 122 0 76 0 122 0 79 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 137 0 122 0 145 0 133] 
#[1 0 122 0 14 0 122 0 23 0 122 0 24 0 122 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 0 122 0 76 0 122 0 79 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 141 0 122 0 145 0 133] 
#[0 0 126 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 72 0 73 0 82 0 133] 
#[1 2 145 0 14 0 9 0 24 0 13 0 34 0 93 0 76 2 149 0 123 2 153 0 124 0 137 0 127 0 141 0 128 2 157 0 150] 
#[0 0 98 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[0 0 130 0 23 0 26] 
#[1 0 134 0 23 2 161 0 24 0 134 0 26 0 13 0 34 0 93 0 76 2 165 0 79 2 169 0 127 0 141 0 128 2 173 0 135 2 177 0 136 2 181 0 150] 
#[0 2 185 0 23] 
#[1 2 189 0 23 2 193 0 26] 
#[1 0 138 0 23 2 197 0 26] 
#[0 0 142 0 23 0 26] 
#[1 1 101 0 19 1 105 0 20 2 201 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 205 0 88 1 165 0 89 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 2 201 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 209 0 88 1 165 0 89 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 2 213 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 217 0 118 1 217 0 119 1 221 0 120 2 221 0 122 0 145 0 133] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[1 1 101 0 19 1 105 0 20 2 225 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 229 0 88 1 165 0 89 1 209 0 102 1 221 0 120] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 0 146 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 0 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 0 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 0 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 0 98 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[0 0 154 0 14 0 26 0 58 0 80 0 82] 
#[0 0 158 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 2 233 0 90 1 209 0 102 1 221 0 120] 
#[0 0 162 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 14 0 15 0 16 0 17 0 23 0 25 0 26 0 27 0 29 0 30 0 34 0 35 0 58 0 80 0 82] 
#[1 0 166 0 1 0 166 0 2 0 166 0 3 0 166 0 4 0 166 0 5 0 166 0 6 0 166 0 7 0 166 0 8 0 166 0 9 0 166 0 10 0 166 0 14 0 166 0 15 0 166 0 16 2 237 0 17 0 166 0 23 0 166 0 25 0 166 0 26 0 166 0 27 2 241 0 29 0 166 0 30 2 245 0 34 0 166 0 35 0 166 0 58 0 166 0 80 0 166 0 82] 
#[1 0 170 0 1 0 170 0 2 0 170 0 3 0 170 0 4 0 170 0 5 0 170 0 6 0 170 0 7 0 170 0 8 0 170 0 9 0 170 0 10 0 170 0 14 0 170 0 15 0 170 0 16 0 170 0 23 0 170 0 25 0 170 0 26 0 170 0 27 2 249 0 30 2 253 0 35 0 170 0 58 0 170 0 80 0 170 0 82] 
#[1 0 174 0 1 0 174 0 2 0 174 0 3 0 174 0 4 0 174 0 5 0 174 0 6 0 174 0 7 0 174 0 8 3 1 0 9 0 174 0 10 0 174 0 14 0 174 0 15 0 174 0 16 0 174 0 23 0 174 0 25 0 174 0 26 3 5 0 27 0 174 0 58 0 174 0 80 0 174 0 82] 
#[1 0 178 0 1 0 178 0 2 0 178 0 3 3 9 0 4 3 13 0 5 3 17 0 6 0 178 0 7 0 178 0 8 3 21 0 10 0 178 0 14 0 178 0 15 0 178 0 16 0 178 0 23 0 178 0 25 0 178 0 26 0 178 0 58 0 178 0 80 0 178 0 82] 
#[1 0 182 0 1 3 25 0 2 3 29 0 3 0 182 0 7 0 182 0 8 0 182 0 14 0 182 0 15 0 182 0 16 0 182 0 23 0 182 0 25 0 182 0 26 0 182 0 58 0 182 0 80 0 182 0 82] 
#[1 0 186 0 1 0 186 0 7 0 186 0 8 0 186 0 14 0 186 0 15 0 186 0 16 0 186 0 23 3 33 0 25 0 186 0 26 0 186 0 58 0 186 0 80 0 186 0 82] 
#[1 3 37 0 1 0 190 0 7 0 190 0 8 0 190 0 14 0 190 0 15 0 190 0 16 0 190 0 23 0 190 0 26 0 190 0 58 0 190 0 80 0 190 0 82] 
#[1 3 41 0 7 0 194 0 14 0 194 0 15 0 194 0 16 0 194 0 23 0 194 0 26 0 194 0 58 0 194 0 80 0 194 0 82] 
#[1 0 198 0 14 3 45 0 15 3 49 0 16 0 198 0 23 0 198 0 26 0 198 0 58 0 198 0 80 0 198 0 82] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 3 53 0 80] 
#[1 0 206 0 7 3 57 0 8 0 206 0 14 0 206 0 15 0 206 0 16 0 206 0 23 0 206 0 26 0 206 0 58 0 206 0 80 0 206 0 82] 
#[1 0 210 0 1 0 210 0 2 0 210 0 3 0 210 0 4 0 210 0 5 0 210 0 6 0 210 0 7 0 210 0 8 0 210 0 9 0 210 0 10 0 210 0 11 0 210 0 12 0 210 0 13 0 210 0 14 0 210 0 15 0 210 0 16 0 210 0 17 0 210 0 18 3 61 0 19 3 65 0 20 3 69 0 21 3 73 0 22 0 210 0 23 3 77 0 24 0 210 0 25 0 210 0 26 0 210 0 27 0 210 0 29 0 210 0 30 0 210 0 33 0 210 0 34 0 210 0 35 0 210 0 36 0 210 0 56 0 210 0 58 0 210 0 59 0 210 0 60 0 210 0 61 0 210 0 62 3 81 0 79 0 210 0 80 0 210 0 82] 
#[0 3 85 0 58] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 3 89 0 104 1 217 0 119 1 221 0 120] 
#[0 3 93 0 14] 
#[0 3 97 0 76] 
#[0 3 101 0 58] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 3 105 0 144] 
#[0 3 109 0 24] 
#[0 3 113 0 24] 
#[0 3 117 0 24] 
#[0 3 121 0 24] 
#[0 0 214 0 19 0 20 0 23 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 3 125 0 58 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 3 129 0 118 1 217 0 119 1 221 0 120] 
#[1 0 150 0 1 0 150 0 2 0 150 0 3 0 150 0 4 0 150 0 5 0 150 0 6 0 150 0 7 0 150 0 8 0 150 0 9 0 150 0 10 0 150 0 11 0 150 0 12 0 150 0 13 3 133 0 14 0 150 0 15 0 150 0 16 0 150 0 17 0 150 0 18 0 150 0 19 0 150 0 20 0 150 0 21 0 150 0 22 0 150 0 24 0 150 0 25 0 150 0 26 0 150 0 27 0 150 0 29 0 150 0 30 0 150 0 33 0 150 0 34 0 150 0 35 0 150 0 36 0 150 0 56 0 150 0 58 0 150 0 59 0 150 0 60 0 150 0 61 0 150 0 62 0 150 0 79] 
#[0 0 218 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[0 0 222 0 14 0 23 0 26 0 58 0 80 0 82] 
#[0 0 226 0 14 0 23 0 26 0 58 0 80] 
#[1 0 158 0 1 0 158 0 2 0 158 0 3 0 158 0 4 0 158 0 5 0 158 0 6 0 158 0 7 0 158 0 8 0 158 0 9 0 158 0 10 3 137 0 11 3 141 0 12 3 145 0 13 0 158 0 14 0 158 0 15 0 158 0 16 0 158 0 17 3 149 0 18 0 158 0 23 0 158 0 25 0 158 0 26 0 158 0 27 0 158 0 29 0 158 0 30 3 153 0 33 0 158 0 34 0 158 0 35 3 157 0 36 3 161 0 56 0 158 0 58 3 165 0 59 3 169 0 60 3 173 0 61 3 177 0 62 0 158 0 80 0 158 0 82 3 181 0 103] 
#[1 3 185 0 26 3 189 0 58] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 230 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 0 234 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 3 193 0 82 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 3 197 0 144] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 1 233 0 45 0 37 0 46 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 0 41 0 52 2 1 0 53 2 5 0 54 0 45 0 55 0 49 0 57 2 9 0 58 0 53 0 63 0 57 0 64 2 13 0 65 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 3 201 0 82 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 0 241 0 105 0 101 0 106 2 81 0 107 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 37 0 118 1 217 0 119 1 221 0 120 0 145 0 133 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 2 65 0 144 3 205 0 145] 
#[1 1 37 0 13 0 70 0 26 0 70 0 58] 
#[0 0 238 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133] 
#[0 0 118 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 2 97 0 26 3 209 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 3 213 0 104 1 217 0 119 1 221 0 120] 
#[1 1 21 0 76 3 217 0 126] 
#[0 0 242 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 0 246 0 26 0 58] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 109 0 81 2 25 0 85 2 113 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 3 221 0 99 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120 3 225 0 137] 
#[0 0 250 0 26 0 58 0 82] 
#[0 0 254 0 26 0 58] 
#[0 1 2 0 24 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 133 0 148] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 3 229 0 82 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 133 0 121 1 69 0 122 0 145 0 133] 
#[0 1 6 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 1 10 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 72 0 73 0 82 0 133] 
#[0 1 14 0 14 0 23 0 24 0 34 0 76 0 79] 
#[0 1 14 0 14 0 23 0 24 0 34 0 76 0 79] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 3 233 0 104 1 217 0 119 1 221 0 120] 
#[1 3 237 0 26 3 241 0 58] 
#[0 1 18 0 26 0 58] 
#[1 3 245 0 14 1 22 0 26 1 22 0 58] 
#[1 3 249 0 23 2 161 0 24 0 13 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 0 93 0 76 2 165 0 79 1 81 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 169 0 127 0 141 0 128 3 253 0 129 1 93 0 132 0 145 0 133 1 97 0 134 4 1 0 135 2 177 0 136 0 161 0 150] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 4 5 0 80 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 9 0 104 1 217 0 119 1 221 0 120] 
#[1 1 26 0 23 2 161 0 24 1 26 0 26 0 93 0 76 2 165 0 79 0 225 0 128 4 13 0 136] 
#[0 1 30 0 23 0 26] 
#[1 1 26 0 23 4 17 0 24 1 26 0 26 4 21 0 79] 
#[0 1 30 0 23 0 26] 
#[0 1 34 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[0 1 34 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[0 4 25 0 76] 
#[1 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 4 29 0 74 1 81 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 0 145 0 133 4 33 0 134] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 217 0 118 1 217 0 119 1 221 0 120] 
#[0 1 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[0 1 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[0 4 37 0 23] 
#[1 4 41 0 23 3 185 0 26] 
#[1 1 42 0 23 4 45 0 24 0 13 0 34 2 165 0 79 4 49 0 127 4 53 0 135 2 177 0 136] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 85 0 72 0 89 0 73 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 4 57 0 91 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 57 0 110 1 61 0 111 0 125 0 115 0 129 0 116 0 133 0 117 2 217 0 118 1 217 0 119 1 221 0 120 2 221 0 122 0 145 0 133] 
#[0 1 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[0 1 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 4 61 0 90 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 4 65 0 90 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 4 69 0 90 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 4 73 0 92 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 4 77 0 92 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 4 81 0 93 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 4 85 0 93 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 89 0 94 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 93 0 94 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 97 0 94 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 4 101 0 94 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 4 105 0 95 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 4 109 0 95 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 4 113 0 96 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 4 117 0 97 1 209 0 102 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 209 0 102 4 121 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 125 0 118 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 4 129 0 100 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 1 34 0 13 0 14 0 23 0 24 0 26 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 79 0 81 0 133] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 4 133 0 98 1 209 0 102 1 221 0 120] 
#[0 1 46 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 1 46 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 4 137 0 76] 
#[0 4 141 0 76] 
#[1 1 101 0 19 1 105 0 20 4 145 0 23 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 4 149 0 86 4 153 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 157 0 118 1 217 0 119 1 221 0 120] 
#[0 1 50 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 4 161 0 14] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 4 165 0 144] 
#[0 4 169 0 58] 
#[0 1 50 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 4 173 0 54] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 2 9 0 58 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 4 177 0 140] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 181 0 118 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 185 0 118 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 189 0 118 1 217 0 119 1 221 0 120] 
#[0 1 50 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[1 3 185 0 26 4 193 0 58] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 4 197 0 144] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[0 1 54 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 76 0 77 0 78] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 4 201 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 4 205 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 1 58 0 19 0 20 0 23 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 62 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[0 1 66 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 62 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 4 209 0 82 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 3 197 0 144] 
#[0 1 70 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 1 74 0 26 0 82] 
#[0 1 78 0 26 0 82] 
#[0 1 82 0 26 0 82] 
#[1 4 213 0 26 4 217 0 82] 
#[0 1 86 0 14 0 23 0 24 0 26 0 34 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 57 0 58 0 63 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 79 0 133] 
#[0 1 90 0 26 0 58] 
#[1 2 145 0 14 0 9 0 24 0 13 0 34 0 93 0 76 4 221 0 124 0 137 0 127 0 141 0 128 2 157 0 150] 
#[0 1 94 0 39 0 40 0 41 0 42 0 43 0 46 0 52 0 55 0 66 0 67 0 68 0 69 0 72 0 73 0 82 0 133] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 225 0 104 1 217 0 119 1 221 0 120] 
#[0 1 98 0 23 0 24 0 26 0 79] 
#[0 4 229 0 23] 
#[0 4 233 0 23] 
#[0 1 98 0 23 0 24 0 26 0 79] 
#[0 4 237 0 80] 
#[1 1 102 0 23 4 17 0 24 1 102 0 26 4 21 0 79] 
#[1 4 241 0 23 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 1 81 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 4 245 0 129 1 93 0 132 0 145 0 133 1 97 0 134] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 4 249 0 80 1 157 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 4 253 0 104 1 217 0 119 1 221 0 120] 
#[0 1 106 0 23 0 26] 
#[0 1 110 0 23] 
#[0 1 114 0 23 0 26] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 1 161 0 88 1 165 0 89 5 1 0 90 1 209 0 102 1 221 0 120] 
#[0 1 118 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[1 3 249 0 23 4 45 0 24 0 13 0 34 0 17 0 39 0 21 0 40 0 25 0 41 0 29 0 42 0 33 0 43 0 37 0 46 0 41 0 52 0 45 0 55 0 49 0 57 0 53 0 63 0 57 0 64 0 61 0 66 0 65 0 67 0 69 0 68 0 73 0 69 0 77 0 70 0 81 0 71 0 85 0 72 0 89 0 73 2 165 0 79 1 81 0 105 0 109 0 109 0 113 0 110 0 117 0 111 0 125 0 115 0 129 0 116 0 133 0 117 4 49 0 127 3 253 0 129 1 93 0 132 0 145 0 133 1 97 0 134 4 1 0 135 2 177 0 136] 
#[1 1 26 0 23 4 45 0 24 2 165 0 79 4 13 0 136] 
#[0 1 122 0 23] 
#[0 5 5 0 23] 
#[0 1 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 14 0 15 0 16 0 17 0 23 0 25 0 26 0 27 0 29 0 30 0 34 0 35 0 58 0 80 0 82] 
#[0 1 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 14 0 15 0 16 0 17 0 23 0 25 0 26 0 27 0 29 0 30 0 34 0 35 0 58 0 80 0 82] 
#[0 1 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 14 0 15 0 16 0 17 0 23 0 25 0 26 0 27 0 29 0 30 0 34 0 35 0 58 0 80 0 82] 
#[1 1 130 0 1 1 130 0 2 1 130 0 3 1 130 0 4 1 130 0 5 1 130 0 6 1 130 0 7 1 130 0 8 1 130 0 9 1 130 0 10 1 130 0 14 1 130 0 15 1 130 0 16 2 237 0 17 1 130 0 23 1 130 0 25 1 130 0 26 1 130 0 27 2 241 0 29 1 130 0 30 2 245 0 34 1 130 0 35 1 130 0 58 1 130 0 80 1 130 0 82] 
#[1 1 130 0 1 1 130 0 2 1 130 0 3 1 130 0 4 1 130 0 5 1 130 0 6 1 130 0 7 1 130 0 8 1 130 0 9 1 130 0 10 1 130 0 14 1 130 0 15 1 130 0 16 2 237 0 17 1 130 0 23 1 130 0 25 1 130 0 26 1 130 0 27 2 241 0 29 1 130 0 30 2 245 0 34 1 130 0 35 1 130 0 58 1 130 0 80 1 130 0 82] 
#[1 1 134 0 1 1 134 0 2 1 134 0 3 1 134 0 4 1 134 0 5 1 134 0 6 1 134 0 7 1 134 0 8 1 134 0 9 1 134 0 10 1 134 0 14 1 134 0 15 1 134 0 16 1 134 0 23 1 134 0 25 1 134 0 26 1 134 0 27 2 249 0 30 2 253 0 35 1 134 0 58 1 134 0 80 1 134 0 82] 
#[1 1 134 0 1 1 134 0 2 1 134 0 3 1 134 0 4 1 134 0 5 1 134 0 6 1 134 0 7 1 134 0 8 1 134 0 9 1 134 0 10 1 134 0 14 1 134 0 15 1 134 0 16 1 134 0 23 1 134 0 25 1 134 0 26 1 134 0 27 2 249 0 30 2 253 0 35 1 134 0 58 1 134 0 80 1 134 0 82] 
#[1 1 138 0 1 1 138 0 2 1 138 0 3 1 138 0 4 1 138 0 5 1 138 0 6 1 138 0 7 1 138 0 8 3 1 0 9 1 138 0 10 1 138 0 14 1 138 0 15 1 138 0 16 1 138 0 23 1 138 0 25 1 138 0 26 3 5 0 27 1 138 0 58 1 138 0 80 1 138 0 82] 
#[1 1 138 0 1 1 138 0 2 1 138 0 3 1 138 0 4 1 138 0 5 1 138 0 6 1 138 0 7 1 138 0 8 3 1 0 9 1 138 0 10 1 138 0 14 1 138 0 15 1 138 0 16 1 138 0 23 1 138 0 25 1 138 0 26 3 5 0 27 1 138 0 58 1 138 0 80 1 138 0 82] 
#[1 1 138 0 1 1 138 0 2 1 138 0 3 1 138 0 4 1 138 0 5 1 138 0 6 1 138 0 7 1 138 0 8 3 1 0 9 1 138 0 10 1 138 0 14 1 138 0 15 1 138 0 16 1 138 0 23 1 138 0 25 1 138 0 26 3 5 0 27 1 138 0 58 1 138 0 80 1 138 0 82] 
#[1 1 138 0 1 1 138 0 2 1 138 0 3 1 138 0 4 1 138 0 5 1 138 0 6 1 138 0 7 1 138 0 8 3 1 0 9 1 138 0 10 1 138 0 14 1 138 0 15 1 138 0 16 1 138 0 23 1 138 0 25 1 138 0 26 3 5 0 27 1 138 0 58 1 138 0 80 1 138 0 82] 
#[1 1 142 0 1 1 142 0 2 1 142 0 3 3 9 0 4 3 13 0 5 3 17 0 6 1 142 0 7 1 142 0 8 3 21 0 10 1 142 0 14 1 142 0 15 1 142 0 16 1 142 0 23 1 142 0 25 1 142 0 26 1 142 0 58 1 142 0 80 1 142 0 82] 
#[1 1 142 0 1 1 142 0 2 1 142 0 3 3 9 0 4 3 13 0 5 3 17 0 6 1 142 0 7 1 142 0 8 3 21 0 10 1 142 0 14 1 142 0 15 1 142 0 16 1 142 0 23 1 142 0 25 1 142 0 26 1 142 0 58 1 142 0 80 1 142 0 82] 
#[1 1 146 0 1 3 25 0 2 3 29 0 3 1 146 0 7 1 146 0 8 1 146 0 14 1 146 0 15 1 146 0 16 1 146 0 23 1 146 0 25 1 146 0 26 1 146 0 58 1 146 0 80 1 146 0 82] 
#[1 1 150 0 1 1 150 0 7 1 150 0 8 1 150 0 14 1 150 0 15 1 150 0 16 1 150 0 23 3 33 0 25 1 150 0 26 1 150 0 58 1 150 0 80 1 150 0 82] 
#[1 1 154 0 7 3 57 0 8 1 154 0 14 1 154 0 15 1 154 0 16 1 154 0 23 1 154 0 26 1 154 0 58 1 154 0 80 1 154 0 82] 
#[1 5 9 0 14 3 185 0 26] 
#[1 3 41 0 7 1 158 0 14 1 158 0 15 1 158 0 16 1 158 0 23 1 158 0 26 1 158 0 58 1 158 0 80 1 158 0 82] 
#[1 3 37 0 1 1 162 0 7 1 162 0 8 1 162 0 14 1 162 0 15 1 162 0 16 1 162 0 23 1 162 0 26 1 162 0 58 1 162 0 80 1 162 0 82] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[1 5 13 0 23 5 17 0 26] 
#[0 1 170 0 23 0 26] 
#[1 3 185 0 26 5 21 0 80] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 25 0 144] 
#[0 1 174 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 178 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 5 29 0 24] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 2 9 0 58 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 5 33 0 140] 
#[1 5 37 0 23 3 185 0 26] 
#[1 5 41 0 23 3 185 0 26] 
#[1 5 45 0 23 3 185 0 26] 
#[0 1 178 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 174 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 182 0 14 0 23 0 26 0 58 0 80 0 82] 
#[0 1 186 0 14 0 23 0 26 0 58 0 80] 
#[0 1 190 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 58 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 76 0 77 0 78 0 81 0 82 0 133 0 148] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 109 0 81 5 49 0 82 2 25 0 85 2 113 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 5 53 0 99 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 1 194 0 26 0 58 0 82] 
#[0 1 198 0 26 0 58] 
#[0 1 202 0 26 0 58] 
#[0 1 206 0 23 0 24 0 26 0 79] 
#[0 1 206 0 23 0 24 0 26 0 79] 
#[0 1 206 0 23 0 24 0 26 0 79] 
#[0 1 206 0 23 0 24 0 26 0 79] 
#[0 5 57 0 23] 
#[0 1 206 0 23 0 24 0 26 0 79] 
#[0 5 61 0 80] 
#[0 1 210 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[0 1 214 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 23 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 80 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 5 65 0 85 1 161 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 1 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 5 69 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 1 217 0 119 1 221 0 120] 
#[0 1 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 21 0 22 0 23 0 24 0 25 0 26 0 27 0 29 0 30 0 33 0 34 0 35 0 36 0 56 0 58 0 59 0 60 0 61 0 62 0 79 0 80 0 82] 
#[0 1 222 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 5 73 0 118 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 5 77 0 23 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 141 0 76 1 145 0 77 1 149 0 78 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 5 81 0 118 1 217 0 119 1 221 0 120] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 85 0 144] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 89 0 144] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 93 0 144] 
#[0 1 226 0 26 0 58 0 82] 
#[0 1 230 0 26 0 82] 
#[0 1 234 0 23 0 24 0 26 0 79] 
#[0 1 234 0 23 0 24 0 26 0 79] 
#[0 1 238 0 14 0 23 0 26 0 58 0 80 0 82] 
#[0 1 242 0 23 0 26] 
#[1 5 97 0 23 3 185 0 26] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 101 0 144] 
#[1 5 105 0 23 3 185 0 26] 
#[1 1 246 0 19 1 246 0 20 1 246 0 24 1 246 0 25 1 246 0 28 1 246 0 30 1 246 0 31 1 246 0 32 1 246 0 34 1 246 0 35 1 246 0 37 1 246 0 38 5 109 0 44 1 246 0 45 1 246 0 47 1 246 0 48 1 246 0 49 1 246 0 50 1 246 0 51 1 246 0 53 1 246 0 54 1 246 0 58 1 246 0 65 1 246 0 76 1 246 0 77 1 246 0 78 1 246 0 81 1 246 0 82] 
#[0 1 246 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 1 250 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 5 113 0 58] 
#[0 1 254 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 117 0 144] 
#[1 1 101 0 19 1 105 0 20 1 109 0 24 1 113 0 25 1 117 0 28 1 121 0 30 1 125 0 31 1 129 0 32 1 133 0 34 1 137 0 35 1 225 0 37 1 229 0 38 1 233 0 45 1 237 0 47 1 241 0 48 1 245 0 49 1 249 0 50 1 253 0 51 2 1 0 53 2 5 0 54 2 9 0 58 2 13 0 65 2 17 0 76 1 145 0 77 1 149 0 78 0 237 0 81 2 25 0 85 2 29 0 87 2 33 0 88 1 165 0 89 1 169 0 90 1 173 0 92 1 177 0 93 1 181 0 94 1 185 0 95 1 189 0 96 1 193 0 97 1 197 0 98 1 201 0 100 1 205 0 101 1 209 0 102 2 37 0 118 1 217 0 119 1 221 0 120 2 41 0 138 2 45 0 139 2 49 0 140 2 53 0 141 2 57 0 142 2 61 0 143 5 121 0 144] 
#[0 2 2 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 2 2 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82] 
#[0 2 6 0 19 0 20 0 24 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 37 0 38 0 44 0 45 0 47 0 48 0 49 0 50 0 51 0 53 0 54 0 58 0 65 0 76 0 77 0 78 0 81 0 82]
	).! !
!CParser categoriesFor: #addTypeName:!private!scanning! !
!CParser categoriesFor: #reduceActionForenum_specifier3:!generated-reduction actions!public! !
!CParser categoriesFor: #reduceActionForinit_declaration1:!generated-reduction actions!public! !
!CParser categoriesFor: #reduceTable!generated!public! !
!CParser categoriesFor: #transitionTable!generated!public! !

!CParser class methodsFor!

definitionComment
"<H>
	: [a-fA-F0-9]
	;
<IS>
	: [uUlL]	
	;
<D>
	: [0-9]
	;
<E>
	: [Ee][\+\-]?<D>+	
	;
<FS>
	: [fFlL]	
	;
<ELLIPSIS> 
	: \.\.\. 
	;
<comment>
	: (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/)
	;
<LETTER>
	: [a-zA-Z_] 
	;
<DIGIT> 
	: [0-9] 
	;
<IDENTIFIER>
	: <LETTER> (<LETTER>|<DIGIT>)*
	;
<CONSTANT>
	: (0[xX]<H>+<IS>?) 
	| (<D>+<IS>?) 
	| (<D>+<E><FS>?) 
	| <D>*\.<D>+<E>?<FS>? 
	| (L? \' ( (\\ .) | ([^\\\""]) )+ \')
	;
<STRING_LITERAL>
	: L? \"" ( (\\ .) | ([^\\\""]) )* \""
	;
<LEFT_BLOCK>
	: \[ | (\< \:)
	;
<RIGHT_BLOCK>
	: \] | (\: \>)	
	;
<LEFT_BRACE>
	: \{ | (\< \%)
	;
<RIGHT_BRACE>
	: \} | (\% \>)
	;
<whitespace>
	: \s+
	;

%id <TypeName> <IDENTIFIER> <CONSTANT> ;

translationUnit
	: external_declaration
	| translationUnit external_declaration
	;
primary_expression
	: <IDENTIFIER>
	| <CONSTANT>
	| <STRING_LITERAL>
	| ""("" expression "")""
	;
postfix_expression
	: primary_expression
	| postfix_expression <LEFT_BLOCK> expression <RIGHT_BLOCK>
	| postfix_expression ""("" "")""
	| postfix_expression ""("" argument_expression_list "")""
	| postfix_expression ""."" <IDENTIFIER>
	| postfix_expression ""->"" <IDENTIFIER>
	| postfix_expression ""++""
	| postfix_expression ""--""
	;
argument_expression_list
	: assignment_expression
	| argument_expression_list "","" assignment_expression
	;
unary_expression
	: postfix_expression
	| ""++"" unary_expression
	| ""--"" unary_expression
	| unary_operator cast_expression
	| ""sizeof"" unary_expression
	| ""sizeof"" ""("" type_name "")""
	;
unary_operator
	: ""&""
	| ""*""
	| ""+""
	| ""-""
	| ""~""
	| ""!!""
	;
cast_expression
	: unary_expression
	| ""("" type_name "")"" cast_expression
	;
multiplicative_expression
	: cast_expression
	| multiplicative_expression ""*"" cast_expression
	| multiplicative_expression ""/"" cast_expression
	| multiplicative_expression ""%"" cast_expression
	;
additive_expression
	: multiplicative_expression
	| additive_expression ""+"" multiplicative_expression
	| additive_expression ""-"" multiplicative_expression
	;
shift_expression
	: additive_expression
	| shift_expression ""<<"" additive_expression
	| shift_expression "">>"" additive_expression
	;
relational_expression
	: shift_expression
	| relational_expression ""<"" shift_expression
	| relational_expression "">"" shift_expression
	| relational_expression ""<="" shift_expression
	| relational_expression "">="" shift_expression
	;
equality_expression
	: relational_expression
	| equality_expression ""=="" relational_expression
	| equality_expression ""!!="" relational_expression
	;
and_expression
	: equality_expression
	| and_expression ""&"" equality_expression
	;
exclusive_or_expression
	: and_expression
	| exclusive_or_expression ""^"" and_expression
	;
inclusive_or_expression
	: exclusive_or_expression
	| inclusive_or_expression ""|"" exclusive_or_expression
	;
logical_and_expression
	: inclusive_or_expression
	| logical_and_expression ""&&"" inclusive_or_expression
	;
logical_or_expression
	: logical_and_expression
	| logical_or_expression ""||"" logical_and_expression
	;
conditional_expression
	: logical_or_expression
	| logical_or_expression ""?"" expression "":"" conditional_expression
	;
assignment_expression
	: conditional_expression
	| unary_expression assignment_operator assignment_expression
	;
assignment_operator
	: ""=""
	| ""*=""
	| ""/=""
	| ""%=""
	| ""+=""
	| ""-=""
	| ""<<=""
	| "">>=""
	| ""&=""
	| ""^=""
	| ""|=""
	;
expression
	: assignment_expression
	| expression "","" assignment_expression
	;
constant_expression
	: conditional_expression
	;
declaration
	: declaration_specifiers "";""
	| init_declaration "";""
	;
init_declaration
	: declaration_specifiers init_declarator_list 
		{'1' first value = 'typedef'
			ifTrue: 
				[1 to: '2' size by: 2 do: [:i | self addTypeName: ('2' at: i) value]].
		self reduceFor: nodes}
	;
declaration_specifiers
	: storage_class_specifier
	| storage_class_specifier declaration_specifiers
	| type_specifier
	| type_specifier declaration_specifiers
	| type_qualifier
	| type_qualifier declaration_specifiers
	;
init_declarator_list
	: init_declarator
	| init_declarator_list "","" init_declarator
	;
init_declarator
	: declarator
	| declarator ""="" initializer
	;
storage_class_specifier
	: ""typedef""
	| ""extern""
	| ""static""
	| ""auto""
	| ""register""
	;
type_specifier
	: ""void""
	| ""char""
	| ""short""
	| ""int""
	| ""long""
	| ""float""
	| ""double""
	| ""signed""
	| ""unsigned""
	| struct_or_union_specifier
	| enum_specifier
	| <TypeName>
	;
struct_or_union_specifier
	: struct_or_union <IDENTIFIER> <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE> {self addTypeName: '2' value. self reduceFor: nodes}
	| struct_or_union <LEFT_BRACE> struct_declaration_list <RIGHT_BRACE>
	| struct_or_union <IDENTIFIER> {self addTypeName: '2' value. self reduceFor: nodes}
	;
struct_or_union
	: ""struct""
	| ""union""
	;
struct_declaration_list
	: struct_declaration
	| struct_declaration_list struct_declaration
	;
struct_declaration
	: specifier_qualifier_list struct_declarator_list "";""
	;
specifier_qualifier_list
	: type_specifier specifier_qualifier_list
	| type_specifier
	| type_qualifier specifier_qualifier_list
	| type_qualifier
	;
struct_declarator_list
	: struct_declarator
	| struct_declarator_list "","" struct_declarator
	;
struct_declarator
	: declarator
	| "":"" constant_expression
	| declarator "":"" constant_expression
	;
enum_specifier
	: ""enum"" <LEFT_BRACE> enumerator_list <RIGHT_BRACE>
	| ""enum"" <IDENTIFIER> <LEFT_BRACE> enumerator_list <RIGHT_BRACE>  {self addTypeName: '2' value. self reduceFor: nodes}
	| ""enum"" <IDENTIFIER>  {self addTypeName: '2' value. self reduceFor: nodes}
	;
enumerator_list
	: enumerator
	| enumerator_list "","" enumerator
	;
enumerator
	: <IDENTIFIER>
	| <IDENTIFIER> ""="" constant_expression
	;
type_qualifier
	: ""const""
	| ""volatile""
	;
declarator
	: pointer direct_declarator
	| direct_declarator
	;
direct_declarator
	: <IDENTIFIER>
	| ""("" declarator "")""
	| direct_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_declarator ""("" parameter_type_list "")""
	| direct_declarator ""("" identifier_list "")""
	| direct_declarator ""("" "")""
	;
pointer
	: ""*""
	| ""*"" type_qualifier_list
	| ""*"" pointer
	| ""*"" type_qualifier_list pointer
	;
type_qualifier_list
	: type_qualifier
	| type_qualifier_list type_qualifier
	;
parameter_type_list
	: parameter_list
	| parameter_list "","" <ELLIPSIS>
	;
parameter_list
	: parameter_declaration
	| parameter_list "","" parameter_declaration
	;
parameter_declaration
	: declaration_specifiers declarator
	| declaration_specifiers abstract_declarator
	| declaration_specifiers
	;
identifier_list
	: <IDENTIFIER>
	| identifier_list "","" <IDENTIFIER>
	;
type_name
	: specifier_qualifier_list
	| specifier_qualifier_list abstract_declarator
	;
abstract_declarator
	: pointer
	| direct_abstract_declarator
	| pointer direct_abstract_declarator
	;
direct_abstract_declarator
	: ""("" abstract_declarator "")""
	| <LEFT_BLOCK> <RIGHT_BLOCK>
	| <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> <RIGHT_BLOCK>
	| direct_abstract_declarator <LEFT_BLOCK> constant_expression <RIGHT_BLOCK>
	| ""("" "")""
	| ""("" parameter_type_list "")""
	| direct_abstract_declarator ""("" "")""
	| direct_abstract_declarator ""("" parameter_type_list "")""
	;
initializer
	: assignment_expression
	| <LEFT_BRACE> initializer_list <RIGHT_BRACE>
	| <LEFT_BRACE> initializer_list "","" <RIGHT_BRACE>
	;
initializer_list
	: initializer
	| initializer_list "","" initializer
	;
statement
	: labeled_statement
	| compound_statement
	| expression_statement
	| selection_statement
	| iteration_statement
	| jump_statement
	;
labeled_statement
	: <IDENTIFIER> "":"" statement
	| ""case"" constant_expression "":"" statement
	| ""default"" "":"" statement
	;
compound_statement
	: <LEFT_BRACE> <RIGHT_BRACE>
	| <LEFT_BRACE> statement_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list <RIGHT_BRACE>
	| <LEFT_BRACE> declaration_list statement_list <RIGHT_BRACE>
	;
declaration_list
	: declaration
	| declaration_list declaration
	;
statement_list
	: statement
	| statement_list statement
	;
expression_statement
	: "";""
	| expression "";""
	;
selection_statement
	: ""if"" ""("" expression "")"" statement
	| ""if"" ""("" expression "")"" statement ""else"" statement
	| ""switch"" ""("" expression "")"" statement
	;
iteration_statement
	: ""while"" ""("" expression "")"" statement
	| ""do"" statement ""while"" ""("" expression "")"" "";""
	| ""for"" ""("" expression_statement expression_statement "")"" statement
	| ""for"" ""("" expression_statement expression_statement expression "")"" statement
	;
jump_statement
	: ""goto"" <IDENTIFIER> "";""
	| ""continue"" "";""
	| ""break"" "";""
	| ""return"" "";""
	| ""return"" expression "";""
	;
external_declaration
	: function_definition
	| declaration
	;
function_definition
	: declaration_specifiers declarator declaration_list compound_statement
	| declaration_specifiers declarator compound_statement
	| declarator declaration_list compound_statement
	| declarator compound_statement
	;"!

fileExtension
	^'.c'!

fileExtensionType
	^'C files'!

scannerClass
	^CScanner!

startingStateFortranslationUnit
	^1! !
!CParser class categoriesFor: #definitionComment!generated!public! !
!CParser class categoriesFor: #fileExtension!file types!public! !
!CParser class categoriesFor: #fileExtensionType!file types!public! !
!CParser class categoriesFor: #scannerClass!generated-accessing!public! !
!CParser class categoriesFor: #startingStateFortranslationUnit!generated!public! !

CScanner guid: (GUID fromString: '{F4C8AD06-29E2-4598-9C18-4ABBF0BD08E7}')!
CScanner comment: ''!
!CScanner categoriesForClass!Unclassified! !
!CScanner methodsFor!

addTypeName: aString 
	typeNames add: aString!

CONSTANTId
	^77!

emptySymbolTokenId
	^148!

errorTokenId
	^149!

IDENTIFIER
	| name |
	name := outputStream contents.
	matchActions := (typeNames includes: name)
		ifTrue: [Array with: self TypeNameId]
		ifFalse: [Array with: self IDENTIFIERId].
	outputStream reset.
	^SmaCCToken
		value: name
		start: start
		ids: matchActions!

IDENTIFIERId
	^76!

initialize
	super initialize.
	typeNames := Set new!

scan1
	[self step.
	currentCharacter == $" ifTrue: [^self recordAndReportMatch: #(78)].
	currentCharacter == $\
		ifTrue:
			[self step.
			^self scan1]] repeat!

scan10
	[self recordMatch: #(77).
	self step.
	currentCharacter == $. ifTrue: [^self scan9].
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan6].
	('LUlu' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(77)].
	^self reportLastMatch!

scan2
	self step.
	currentCharacter == $\ ifTrue: [^self scan4].
	(currentCharacter <= $!! or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]])
		ifTrue: [^self scan3].
	^self reportLastMatch!

scan3
	[self step.
	currentCharacter == $'
		ifTrue:
			[[self recordMatch: #(77).
			self step.
			currentCharacter == $'] whileTrue.
			currentCharacter == $\ ifTrue: [^self scan4].
			(currentCharacter <= $!!
				or:
					[(currentCharacter between: $# and: $&) or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]])
				ifTrue: [^self scan3].
			^self reportLastMatch].
	currentCharacter == $\ ifTrue: [^self scan4].
	currentCharacter <= $!!
		or: [(currentCharacter between: $# and: $&) or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]]
		whileTrue.
	^self reportLastMatch!

scan4
	self step.
	^self scan3!

scan5
	[self recordMatch: #(77).
	self step.
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan6].
	('FLfl' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(77)].
	^self reportLastMatch!

scan6
	self step.
	('+-' includes: currentCharacter) ifTrue: [self step].
	currentCharacter isDigit ifTrue: [^self scan7].
	^self reportLastMatch!

scan7
	[self recordMatch: #(77).
	self step.
	currentCharacter isDigit] whileTrue.
	('FLfl' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(77)].
	^self reportLastMatch!

scan8
	[self step.
	currentCharacter == $*
		ifTrue:
			[[self step.
			currentCharacter == $*] whileTrue.
			currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(75)].
			^self scan8]] repeat!

scan9
	self step.
	currentCharacter isDigit ifTrue: [^self scan5].
	^self reportLastMatch!

scanForToken
	self step.
	currentCharacter == $!!
		ifTrue:
			[self recordMatch: #(28).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(2)].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $%
		ifTrue:
			[self recordMatch: #(17).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(33)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(82)].
			^self reportLastMatch].
	currentCharacter == $&
		ifTrue:
			[self recordMatch: #(25).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(7)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(61)].
			^self reportLastMatch].
	currentCharacter == $' ifTrue: [^self scan2].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(24)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(23)].
	currentCharacter == $*
		ifTrue:
			[self recordMatch: #(34).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(12)].
			^self reportLastMatch].
	currentCharacter == $+
		ifTrue:
			[self recordMatch: #(35).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(20)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(18)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(26)].
	currentCharacter == $-
		ifTrue:
			[self recordMatch: #(30).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(19)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(56)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(21)].
			^self reportLastMatch].
	currentCharacter == $.
		ifTrue:
			[self recordMatch: #(22).
			self step.
			currentCharacter == $.
				ifTrue:
					[self step.
					currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(74)].
					^self reportLastMatch].
			currentCharacter isDigit ifTrue: [^self scan5].
			^self reportLastMatch].
	currentCharacter == $/
		ifTrue:
			[self recordMatch: #(29).
			self step.
			currentCharacter == $* ifTrue: [^self scan8].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(11)].
			^self reportLastMatch].
	currentCharacter == $0
		ifTrue:
			[self recordMatch: #(77).
			self step.
			currentCharacter == $. ifTrue: [^self scan9].
			currentCharacter isDigit ifTrue: [^self scan10].
			('Ee' includes: currentCharacter) ifTrue: [^self scan6].
			('Xx' includes: currentCharacter)
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[[self recordMatch: #(77).
							self step.
							currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]] whileTrue.
							('LUlu' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(77)]].
					^self reportLastMatch].
			('LUlu' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(77)].
			^self reportLastMatch].
	currentCharacter == $:
		ifTrue:
			[self recordMatch: #(14).
			self step.
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(80)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(58)].
	currentCharacter == $<
		ifTrue:
			[self recordMatch: #(10).
			self step.
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(81)].
			currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(79)].
			currentCharacter == $<
				ifTrue:
					[self recordMatch: #(27).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(36)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(5)].
			^self reportLastMatch].
	currentCharacter == $=
		ifTrue:
			[self recordMatch: #(13).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(3)].
			^self reportLastMatch].
	currentCharacter == $>
		ifTrue:
			[self recordMatch: #(6).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(4)].
			currentCharacter == $>
				ifTrue:
					[self recordMatch: #(9).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(62)]].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(15)].
	currentCharacter == $L
		ifTrue:
			[self recordMatch: #(76).
			self step.
			currentCharacter == $" ifTrue: [^self scan1].
			currentCharacter == $' ifTrue: [^self scan2].
			((currentCharacter between: $0 and: $9)
				or: [(currentCharacter between: $A and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]])
				ifTrue:
					[[self recordMatch: #(76).
					self step.
					(currentCharacter between: $0 and: $9)
						or:
							[(currentCharacter between: $A and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]]]
						whileTrue].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(79)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(80)].
	currentCharacter == $^
		ifTrue:
			[self recordMatch: #(1).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(60)].
			^self reportLastMatch].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(81)].
	currentCharacter == $|
		ifTrue:
			[self recordMatch: #(8).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(59)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(16)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(82)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(31)].
	currentCharacter isDigit ifTrue: [^self scan10].
	currentCharacter isWhitespace
		ifTrue:
			[[self recordMatch: #(83).
			self step.
			currentCharacter isWhitespace] whileTrue.
			^self reportLastMatch].
	((currentCharacter between: $A and: $K)
		or: [(currentCharacter between: $M and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]])
		ifTrue:
			[[self recordMatch: #(76).
			self step.
			(currentCharacter between: $0 and: $9)
				or: [(currentCharacter between: $A and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]]]
				whileTrue].
	^self reportLastMatch!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #comment #IDENTIFIER nil nil nil nil nil nil #whitespace)!

TypeNameId
	^133! !
!CScanner categoriesFor: #addTypeName:!private!scanning! !
!CScanner categoriesFor: #CONSTANTId!generated!public! !
!CScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!CScanner categoriesFor: #errorTokenId!generated!public! !
!CScanner categoriesFor: #IDENTIFIER!public!scanning! !
!CScanner categoriesFor: #IDENTIFIERId!generated!public! !
!CScanner categoriesFor: #initialize!initialize-release!private! !
!CScanner categoriesFor: #scan1!generated!public! !
!CScanner categoriesFor: #scan10!generated!public! !
!CScanner categoriesFor: #scan2!generated!public! !
!CScanner categoriesFor: #scan3!generated!public! !
!CScanner categoriesFor: #scan4!generated!public! !
!CScanner categoriesFor: #scan5!generated!public! !
!CScanner categoriesFor: #scan6!generated!public! !
!CScanner categoriesFor: #scan7!generated!public! !
!CScanner categoriesFor: #scan8!generated!public! !
!CScanner categoriesFor: #scan9!generated!public! !
!CScanner categoriesFor: #scanForToken!generated!public! !
!CScanner categoriesFor: #tokenActions!generated!public! !
!CScanner categoriesFor: #TypeNameId!generated!public! !

!CScanner class methodsFor!

initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(76 'auto' 63) #(76 'break' 37) #(76 'case' 38) #(76 'char' 68) #(76 'const' 40) #(76 'continue' 48) #(76 'default' 45) #(76 'do' 49) #(76 'double' 55) #(76 'else' 44) #(76 'enum' 41) #(76 'extern' 64) #(76 'float' 73) #(76 'for' 50) #(76 'goto' 47) #(76 'if' 51) #(76 'int' 66) #(76 'long' 67) #(76 'register' 71) #(76 'return' 65) #(76 'short' 69) #(76 'signed' 46) #(76 'sizeof' 32) #(76 'static' 70) #(76 'struct' 43) #(76 'switch' 53) #(76 'typedef' 57) #(76 'union' 42) #(76 'unsigned' 52) #(76 'void' 72) #(76 'volatile' 39) #(76 'while' 54))
		do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last].
	^keywordMap!

needsLineNumbers
	^true! !
!CScanner class categoriesFor: #initializeKeywordMap!generated-initialization!public! !
!CScanner class categoriesFor: #needsLineNumbers!private!testing! !

"Binary Globals"!

