| package |
package := Package name: 'SmaCC Rewrite Engine Tests'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains some tests for the SmaCC Rewrite Engine.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #SmaCCRewriteTest;
	add: #SmaCCRewriteTestBinaryExpressionNode;
	add: #SmaCCRewriteTestExpressionNode;
	add: #SmaCCRewriteTestExpressionNodeVisitor;
	add: #SmaCCRewriteTestNumberNode;
	add: #SmaCCRewriteTestParser;
	add: #SmaCCRewriteTestScanner;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\SmaCC GLR Runtime\SmaCC GLR Runtime';
	add: '..\SmaCC Rewrite Engine\SmaCC Rewrite Engine';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	add: '..\..\..\Camp Smalltalk\SUnit\SUnit';
	yourself).

package!

"Class Definitions"!

SmaCCParseNode subclass: #SmaCCRewriteTestExpressionNode
	instanceVariableNames: 'leftParens rightParens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteTestExpressionNode subclass: #SmaCCRewriteTestBinaryExpressionNode
	instanceVariableNames: 'left operator right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteTestExpressionNode subclass: #SmaCCRewriteTestNumberNode
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNodeVisitor subclass: #SmaCCRewriteTestExpressionNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGLRParser subclass: #SmaCCRewriteTestParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #SmaCCRewriteTestScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
TestCase subclass: #SmaCCRewriteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SmaCCRewriteTestExpressionNode guid: (GUID fromString: '{3926BA98-DF67-42A6-AE25-3C3959D58488}')!
SmaCCRewriteTestExpressionNode comment: ''!
!SmaCCRewriteTestExpressionNode categoriesForClass!Unclassified! !
!SmaCCRewriteTestExpressionNode methodsFor!

acceptVisitor: anExpressionVisitor
	^anExpressionVisitor visitExpression: self!

ignoredCompositeTokenVariables
	^#(#leftParens #rightParens)!

initialize
	super initialize.
	leftParens := OrderedCollection new: 2.
	rightParens := OrderedCollection new: 2.!

leftParens
	^leftParens!

leftParens: anOrderedCollection
	leftParens := anOrderedCollection!

rightParens
	^rightParens!

rightParens: anOrderedCollection
	rightParens := anOrderedCollection! !
!SmaCCRewriteTestExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #leftParens!generated!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #leftParens:!generated!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #rightParens!generated!public! !
!SmaCCRewriteTestExpressionNode categoriesFor: #rightParens:!generated!public! !

SmaCCRewriteTestBinaryExpressionNode guid: (GUID fromString: '{E40B8642-F40E-4761-963F-A5B1AC149C6C}')!
SmaCCRewriteTestBinaryExpressionNode comment: ''!
!SmaCCRewriteTestBinaryExpressionNode categoriesForClass!Unclassified! !
!SmaCCRewriteTestBinaryExpressionNode methodsFor!

acceptVisitor: anExpressionVisitor
	^anExpressionVisitor visitBinaryExpression: self!

left
	^left!

left: aSmaCCRewriteTestExpressionNode
	self left notNil ifTrue: [self left parent: nil].
	left := aSmaCCRewriteTestExpressionNode.
	self left notNil ifTrue: [self left parent: self]!

nodeVariables
	^#(#left #right)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

right
	^right!

right: aSmaCCRewriteTestExpressionNode
	self right notNil ifTrue: [self right parent: nil].
	right := aSmaCCRewriteTestExpressionNode.
	self right notNil ifTrue: [self right parent: self]!

tokenVariables
	^#(#operator)! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #left!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #left:!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #nodeVariables!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #operator!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #operator:!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #right!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #right:!generated!public! !
!SmaCCRewriteTestBinaryExpressionNode categoriesFor: #tokenVariables!generated!public! !

SmaCCRewriteTestNumberNode guid: (GUID fromString: '{8A2F7446-23EE-414B-8C47-BA0A8FCC795D}')!
SmaCCRewriteTestNumberNode comment: ''!
!SmaCCRewriteTestNumberNode categoriesForClass!Unclassified! !
!SmaCCRewriteTestNumberNode methodsFor!

acceptVisitor: anExpressionVisitor
	^anExpressionVisitor visitNumber: self!

number
	^number!

number: aSmaCCToken
	number := aSmaCCToken!

tokenVariables
	^#(#number)! !
!SmaCCRewriteTestNumberNode categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCRewriteTestNumberNode categoriesFor: #number!generated!public! !
!SmaCCRewriteTestNumberNode categoriesFor: #number:!generated!public! !
!SmaCCRewriteTestNumberNode categoriesFor: #tokenVariables!generated!public! !

SmaCCRewriteTestExpressionNodeVisitor guid: (GUID fromString: '{9502454D-5986-4B15-AD33-19FB2AE2730D}')!
SmaCCRewriteTestExpressionNodeVisitor comment: ''!
!SmaCCRewriteTestExpressionNodeVisitor categoriesForClass!Unclassified! !
!SmaCCRewriteTestExpressionNodeVisitor methodsFor!

visitBinaryExpression: aBinaryExpression
	^self visitExpression: aBinaryExpression!

visitExpression: anExpression
	^self visitSmaCCParseNode: anExpression!

visitNumber: aNumber
	^self visitExpression: aNumber! !
!SmaCCRewriteTestExpressionNodeVisitor categoriesFor: #visitBinaryExpression:!generated!public! !
!SmaCCRewriteTestExpressionNodeVisitor categoriesFor: #visitExpression:!generated!public! !
!SmaCCRewriteTestExpressionNodeVisitor categoriesFor: #visitNumber:!generated!public! !

SmaCCRewriteTestParser guid: (GUID fromString: '{9016CE79-B43A-46FD-8FA0-FDA86494F5DC}')!
SmaCCRewriteTestParser comment: ''!
!SmaCCRewriteTestParser categoriesForClass!Unclassified! !
!SmaCCRewriteTestParser methodsFor!

reduceActionForExpression1: nodes
	| result |
	result := nodes at: 2.
	result addFirstToken: (nodes at: 1) to: result leftParens.
	result addToken: (nodes at: 3) to: result rightParens.
	^result!

reduceActionForExpression4: nodes
	| result |
	result := SmaCCRewriteTestBinaryExpressionNode new.
	result left: (nodes at: 1).
	result operator: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionForExpression7: nodes
	| result |
	result := SmaCCRewriteTestNumberNode new.
	result number: (nodes at: 1).
	^result!

reduceTable
^#(
	#(11 1 #reduceActionForExpression7:) 
	#(11 3 #reduceActionForExpression1:) 
	#(11 3 #reduceActionForExpression4:)
	).!

symbolTypes
	^#(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCRewriteTestExpressionNode #SmaCCRewriteTestExpressionNode #SmaCCToken #SmaCCToken)!

transitionTable
^#(
#[1 0 9 0 5 0 13 0 8 0 17 0 11] 
#[1 0 9 0 5 0 13 0 8 0 21 0 11] 
#[0 0 6 0 1 0 2 0 3 0 4 0 6 0 7 0 13] 
#[1 0 25 0 1 0 29 0 2 0 33 0 4 0 37 0 6 0 41 0 7 0 0 0 13] 
#[1 0 25 0 1 0 29 0 2 0 45 0 3 0 33 0 4 0 37 0 6 0 41 0 7] 
#[1 0 9 0 5 0 13 0 8 0 49 0 11] 
#[1 0 9 0 5 0 13 0 8 0 53 0 11] 
#[1 0 9 0 5 0 13 0 8 0 57 0 11] 
#[1 0 9 0 5 0 13 0 8 0 61 0 11] 
#[1 0 9 0 5 0 13 0 8 0 65 0 11] 
#[0 0 10 0 1 0 2 0 3 0 4 0 6 0 7 0 13] 
#[1 0 14 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 37 0 6 0 14 0 7 0 14 0 13] 
#[1 0 25 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 37 0 6 0 41 0 7 0 14 0 13] 
#[1 0 25 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 37 0 6 0 41 0 7 0 14 0 13] 
#[1 0 14 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 37 0 6 0 14 0 7 0 14 0 13] 
#[1 0 14 0 1 0 14 0 2 0 14 0 3 0 14 0 4 0 37 0 6 0 14 0 7 0 14 0 13]
	).! !
!SmaCCRewriteTestParser categoriesFor: #reduceActionForExpression1:!generated-reduction actions!public! !
!SmaCCRewriteTestParser categoriesFor: #reduceActionForExpression4:!generated-reduction actions!public! !
!SmaCCRewriteTestParser categoriesFor: #reduceActionForExpression7:!generated-reduction actions!public! !
!SmaCCRewriteTestParser categoriesFor: #reduceTable!generated!public! !
!SmaCCRewriteTestParser categoriesFor: #symbolTypes!generated!public! !
!SmaCCRewriteTestParser categoriesFor: #transitionTable!generated!public! !

!SmaCCRewriteTestParser class methodsFor!

definitionComment
"%glr;

%left ""+"" ""-"";
%left ""*"" ""/"";
%right ""^"";

%prefix SmaCCRewriteTest;
%suffix Node;
%root Expression;
%ignore_variables leftParen rightParen;

%hierarchy Expression (
	Number
	BinaryExpression
	);

<number>
	: \d+
	;

<whitespace>
	: \s+
	;

<patternToken>
	: \` [^\`]* \`
	;

Expression
	: ""("" 'leftParen' Expression "")"" 'rightParen' {{Expression}}
	| Expression 'left' ""+"" 'operator' Expression 'right' {{BinaryExpression}}
	| Expression 'left' ""-"" 'operator' Expression 'right' {{BinaryExpression}}
	| Expression 'left' ""*"" 'operator' Expression 'right' {{BinaryExpression}}
	| Expression 'left' ""/"" 'operator' Expression 'right' {{BinaryExpression}}
	| Expression 'left' ""^"" 'operator' Expression 'right' {{BinaryExpression}}
	| <number> 'number' {{Number}}
	;


"!

scannerClass
	^SmaCCRewriteTestScanner!

startingStateForExpression
	^1! !
!SmaCCRewriteTestParser class categoriesFor: #definitionComment!generated!public! !
!SmaCCRewriteTestParser class categoriesFor: #scannerClass!generated-accessing!public! !
!SmaCCRewriteTestParser class categoriesFor: #startingStateForExpression!generated!public! !

SmaCCRewriteTestScanner guid: (GUID fromString: '{0D5BCD4F-6E37-4D2A-BB3C-0463F40E5C84}')!
SmaCCRewriteTestScanner comment: ''!
!SmaCCRewriteTestScanner categoriesForClass!Unclassified! !
!SmaCCRewriteTestScanner methodsFor!

emptySymbolTokenId
	^13!

errorTokenId
	^14!

scanForToken
	self step.
	currentCharacter == $`
		ifTrue:
			[[self step.
			currentCharacter == $` ifTrue: [^self recordAndReportMatch: #(10)]] repeat].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(6)].
	currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(2)].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(3)].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(1)].
	currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(7)].
	currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(4)].
	currentCharacter isDigit
		ifTrue:
			[[self recordMatch: #(8).
			self step.
			currentCharacter isDigit] whileTrue.
			^self reportLastMatch].
	((currentCharacter between: Character tab and: Character cr) or: [currentCharacter == Character space])
		ifTrue:
			[[self recordMatch: #(9).
			self step.
			(currentCharacter between: Character tab and: Character cr) or: [currentCharacter == Character space]] whileTrue].
	^self reportLastMatch!

tokenActions
	^#(nil nil nil nil nil nil nil nil #whitespace #patternToken)! !
!SmaCCRewriteTestScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!SmaCCRewriteTestScanner categoriesFor: #errorTokenId!generated!public! !
!SmaCCRewriteTestScanner categoriesFor: #scanForToken!generated!public! !
!SmaCCRewriteTestScanner categoriesFor: #tokenActions!generated!public! !

SmaCCRewriteTest guid: (GUID fromString: '{C7F00C32-5C49-4FA8-B658-1F21006D17EF}')!
SmaCCRewriteTest comment: ''!
!SmaCCRewriteTest categoriesForClass!Unclassified! !
!SmaCCRewriteTest methodsFor!

compareRewrite: sourceString isEqualTo: resultString using: aSmaCCRewriteEngine
	| tree rewriteResult |
	tree := self parserClass parse: sourceString.
	rewriteResult := aSmaCCRewriteEngine rewriteTree: tree.
	self assert: rewriteResult = resultString!

lispRewriter
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					>>>`a{testBlock: [:node | 
									| myParent grandParent | 
									myParent := node parent. 
									grandParent := myParent parent.
									myParent class = grandParent class and: [myParent operator = grandParent operator]]}`
								`op{beToken;testBlock: [:token | token value ~= ''^'']}` `b`<<<
					->
					>>>`a` `b`<<<

					>>>`a`^`b`<<<
					->
					>>>(expt `a` `b`)<<<

					>>>`a` `op{beToken}` `b`<<<
					->
					>>>(`op` `a` `b`)<<<').
	^rewriter!

parserClass
	^SmaCCRewriteTestParser!

postfixRewriter
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					>>>`a` `op{beToken}` `b`<<<
					->
					>>>`a` `b` `op`<<<').
	^rewriter!

testAddParens
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					>>>`a` `op{beToken}` `b`<<<
					->
					>>>`(a)` `op` `(b)`<<<').
	self
		compareRewrite: '1+(1+1)'
		isEqualTo: '(1) + ((1) + (1))'
		using: rewriter!

testCodeExpressionToRemoveParens
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					>>>`a{testBlock: [:node | node leftParens notEmpty]}`<<<
					->
					>>>``match leftParens do: [:each | self delete: each].
							match rightParens do: [:each | self delete: each].
							match nodesDo: [:each | self rewrite: each]``<<<').
	self
		compareRewrite: '(1)+ ( 1 +(1))'
		isEqualTo: '1+  1 +1'
		using: rewriter!

testCodeToRemoveParens
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'SmaCCRewriteTestExpressionNode
					->
					[match leftParens do: [:each | self delete: each].
					self processChildren.
					match rightParens do: [:each | self delete: each]]').
	self
		compareRewrite: '(1)+ ( 1 +(1))'
		isEqualTo: '1+  1 +1'
		using: rewriter!

testExpressions
	| stream coreExpression |
	stream := WriteStream on: String new.
	(1 to: 25) do: [:i | stream nextPutAll: '1 +'] separatedBy: [stream space].
	coreExpression := stream contents.
	self
		compareRewrite: coreExpression , ' 1'
		isEqualTo: '1 ' , coreExpression
		using: self postfixRewriter!

testLispExpressions
	self
		compareRewrite: '1+2*3^4+5'
		isEqualTo: '(+ 1 (* 2 (expt 3 4)) 5)'
		using: self lispRewriter!

testMultipleInsertAfters
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'SmaCCRewriteTestBinaryExpressionNode
					->
					[match parent notNil 
						ifTrue:
							[self insert: ''()'' after: match.
							self insert: ''[]'' after: match].
					self continue]').
	self
		compareRewrite: '1+1+1'
		isEqualTo: '1+1()[]+1'
		using: rewriter!

testNoChanges
	self
		compareRewrite: '2'
		isEqualTo: '2'
		using: self postfixRewriter!

testOneExpression
	self
		compareRewrite: '2+3'
		isEqualTo: '2 3 +'
		using: self postfixRewriter!

testTwoExpressions
	self
		compareRewrite: '1+2*3'
		isEqualTo: '1 2 3 * +'
		using: self postfixRewriter!

testTypeAddParens
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					SmaCCRewriteTestBinaryExpressionNode
					->
					>>>`(left)` `operator` `(right)`<<<').
	self
		compareRewrite: '1+(1+1)'
		isEqualTo: '(1) + ((1) + (1))'
		using: rewriter!

testWhitespace
	self
		compareRewrite:
			'1+
	2
	*3'
		isEqualTo:
			'1 
	2
	 3 * +'
		using: self whitespacePostfixRewriter!

testWithParens
	self
		compareRewrite: '1+(2+3)'
		isEqualTo: '1 2 3 + +'
		using: self postfixRewriter!

whitespacePostfixRewriter
	| rewriter |
	rewriter := SmaCCRewriteEngine new.
	rewriter
		rewriteRule:
			(SmaCCRewriteRuleFileParser
				parse:
					'Parser: SmaCCRewriteTestParser
					>>>`a` `op{beToken}` `b`<<<
					->
					>>>`\a\` `\b\` `op`<<<').
	^rewriter! !
!SmaCCRewriteTest categoriesFor: #compareRewrite:isEqualTo:using:!private! !
!SmaCCRewriteTest categoriesFor: #lispRewriter!private! !
!SmaCCRewriteTest categoriesFor: #parserClass!private! !
!SmaCCRewriteTest categoriesFor: #postfixRewriter!private! !
!SmaCCRewriteTest categoriesFor: #testAddParens!private!tests! !
!SmaCCRewriteTest categoriesFor: #testCodeExpressionToRemoveParens!private!tests! !
!SmaCCRewriteTest categoriesFor: #testCodeToRemoveParens!private!tests! !
!SmaCCRewriteTest categoriesFor: #testExpressions!private!tests! !
!SmaCCRewriteTest categoriesFor: #testLispExpressions!private!tests! !
!SmaCCRewriteTest categoriesFor: #testMultipleInsertAfters!private!tests! !
!SmaCCRewriteTest categoriesFor: #testNoChanges!private!tests! !
!SmaCCRewriteTest categoriesFor: #testOneExpression!private!tests! !
!SmaCCRewriteTest categoriesFor: #testTwoExpressions!private!tests! !
!SmaCCRewriteTest categoriesFor: #testTypeAddParens!private!tests! !
!SmaCCRewriteTest categoriesFor: #testWhitespace!private!tests! !
!SmaCCRewriteTest categoriesFor: #testWithParens!private!tests! !
!SmaCCRewriteTest categoriesFor: #whitespacePostfixRewriter!private! !

"Binary Globals"!

