| package |
package := Package name: 'SmaCC Rewrite Engine UI'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains a UI that can be used create transformations for files.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'.

package basicScriptAt: #postinstall put: '[Smalltalk developmentSystem addSystemFolderIcon: SmaCCTransformationToolkit toolsFolderIcon] on: Error do: [:ex | ] !!'.
package basicScriptAt: #preuninstall put: '[Smalltalk developmentSystem removeSystemFolderIcon: SmaCCTransformationToolkit toolsFolderIcon] on: Error do: [:ex | ]!!'.

package classNames
	add: #SmaCCRewriteComponentPresenter;
	add: #SmaCCRewriteMatchPresenter;
	add: #SmaCCRewritePresenter;
	add: #SmaCCTransformationExpressionStyler;
	add: #SmaCCTransformationPresenter;
	add: #SmaCCTransformationToolkit;
	add: #ValueHolderAspectAdaptor;
	yourself.

package methodNames
	add: #SmaCCAbstractRewrite -> #treeIcon;
	add: #SmaCCRewriteMatch -> #type;
	add: #SmaCCRewriteTransformation -> #type;
	add: 'SmaCCAbstractRewrite class' -> #icon;
	add: 'SmaCCAbstractRewrite class' -> #treeIcon;
	add: 'SmaCCParser class' -> #addContextMenuItemsTo:;
	add: 'SmaCCRewrite class' -> #treeIcon;
	add: 'SmaCCRewriteCodeTransformation class' -> #type;
	add: 'SmaCCRewriteFile class' -> #treeIcon;
	add: 'SmaCCRewriteMatch class' -> #type;
	add: 'SmaCCRewriteStringTransformation class' -> #type;
	add: 'SmaCCRewriteTransformation class' -> #type;
	add: 'SmaCCRewriteTreeMatch class' -> #type;
	add: 'SmaCCRewriteTypeMatch class' -> #type;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Boolean\Dolphin Boolean Presenter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Cards\Dolphin Card Containers';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Choice\Dolphin Choice Presenter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Prompters\Dolphin Choice Prompter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Common Controls\Dolphin Common Controls';
	add: '..\..\..\Object Arts\Dolphin\MVP\Dialogs\Common\Dolphin Common Dialogs';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Control Bars\Dolphin Control Bars';
	add: '..\..\..\Object Arts\Dolphin\MVP\Dialogs\Find\Dolphin Find Dialog';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\List\Dolphin List Models';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\List\Dolphin List Presenter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Deprecated\Dolphin MVP (Deprecated)';
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\..\..\Object Arts\Dolphin\MVP\Dialogs\Progress\Dolphin Progress Dialog';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Prompters\Dolphin Prompter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Scintilla\Dolphin Scintilla View';
	add: '..\..\..\Object Arts\Dolphin\MVP\Views\Sliding Tray\Dolphin Slidey-Inney-Outey Thing';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Text\Dolphin Text Presenter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\Tree\Dolphin Tree Models';
	add: '..\..\..\Object Arts\Dolphin\MVP\Presenters\Tree\Dolphin Tree Presenter';
	add: '..\..\..\Object Arts\Dolphin\MVP\Type Converters\Dolphin Type Converters';
	add: '..\..\..\Object Arts\Dolphin\MVP\Models\Value\Dolphin Value Models';
	add: '..\IDB MultipleFileOpenDialog';
	add: '..\..\Refactoring Browser\Formatters\RBFormatters';
	add: '..\SmaCC Rewrite Engine\SmaCC Rewrite Engine';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	add: '..\..\..\Object Arts\Dolphin\System\Compiler\Smalltalk Parser';
	yourself).

package!

"Class Definitions"!

ValueAspectAdaptor subclass: #ValueHolderAspectAdaptor
	instanceVariableNames: 'oldValue'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Shell subclass: #SmaCCTransformationToolkit
	instanceVariableNames: 'configurationFilename progressPresenter fileStatusModel resultStatusModel transformationFiles transformedString totals runCount'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ValuePresenter subclass: #SmaCCRewriteComponentPresenter
	instanceVariableNames: 'previousCopies'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ValuePresenter subclass: #SmaCCRewritePresenter
	instanceVariableNames: 'parserModel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteComponentPresenter subclass: #SmaCCRewriteMatchPresenter
	instanceVariableNames: 'classModel treeModel codeModel startingStateModel debugModel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteComponentPresenter subclass: #SmaCCTransformationPresenter
	instanceVariableNames: 'codeModel stringModel'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
ScintillaStyler subclass: #SmaCCTransformationExpressionStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!SmaCCAbstractRewrite methodsFor!

treeIcon
	^self class treeIcon! !
!SmaCCAbstractRewrite categoriesFor: #treeIcon!accessing!public! !

!SmaCCAbstractRewrite class methodsFor!

icon
	^self treeIcon ifNil: [super icon]!

treeIcon
	^nil! !
!SmaCCAbstractRewrite class categoriesFor: #icon!accessing!public! !
!SmaCCAbstractRewrite class categoriesFor: #treeIcon!accessing!public! !

!SmaCCParser class methodsFor!

addContextMenuItemsTo: aMenu
	! !
!SmaCCParser class categoriesFor: #addContextMenuItemsTo:!accessing!public! !

!SmaCCRewrite class methodsFor!

treeIcon
	^Icon fromId: 'SystemBrowserShell.ico'! !
!SmaCCRewrite class categoriesFor: #treeIcon!accessing!public! !

!SmaCCRewriteCodeTransformation class methodsFor!

type
	^#Code! !
!SmaCCRewriteCodeTransformation class categoriesFor: #type!accessing!public! !

!SmaCCRewriteFile class methodsFor!

treeIcon
	^Icon fromId: 'Package.ico'! !
!SmaCCRewriteFile class categoriesFor: #treeIcon!accessing!public! !

!SmaCCRewriteMatch methodsFor!

type
	^self class type! !
!SmaCCRewriteMatch categoriesFor: #type!accessing!public! !

!SmaCCRewriteMatch class methodsFor!

type
	^nil! !
!SmaCCRewriteMatch class categoriesFor: #type!accessing!public! !

!SmaCCRewriteStringTransformation class methodsFor!

type
	^#String! !
!SmaCCRewriteStringTransformation class categoriesFor: #type!accessing!public! !

!SmaCCRewriteTransformation methodsFor!

type
	^self class type! !
!SmaCCRewriteTransformation categoriesFor: #type!accessing!public! !

!SmaCCRewriteTransformation class methodsFor!

type
	^nil! !
!SmaCCRewriteTransformation class categoriesFor: #type!accessing!public! !

!SmaCCRewriteTreeMatch class methodsFor!

type
	^#Tree! !
!SmaCCRewriteTreeMatch class categoriesFor: #type!accessing!public! !

!SmaCCRewriteTypeMatch class methodsFor!

type
	^#Type! !
!SmaCCRewriteTypeMatch class categoriesFor: #type!accessing!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

ValueHolderAspectAdaptor guid: (GUID fromString: '{E1E3558C-2246-4116-813A-7F954364C5C9}')!
ValueHolderAspectAdaptor comment: ''!
!ValueHolderAspectAdaptor categoriesForClass!MVP-Models! !
!ValueHolderAspectAdaptor methodsFor!

changedModelValue
	oldValue removeEventsTriggeredFor: self.
	oldValue := self subject.
	oldValue notNil
		ifTrue:
			[oldValue
				when: self getSelector
				send: #notifyChanged
				to: self].
	self notifyChanged!

setValue: anObject
	self canSet ifTrue: [super setValue: anObject]!

subject
	^subject isNil ifTrue: [nil] ifFalse: [subject value]!

subject: anObject
	subject notNil ifTrue: [subject removeEventsTriggeredFor: self].
	super subject: anObject.
	subject notNil
		ifTrue:
			[subject
				when: #valueChanged
				send: #changedModelValue
				to: self]!

value
	^self canGet ifTrue: [super value] ifFalse: [nil]! !
!ValueHolderAspectAdaptor categoriesFor: #changedModelValue!private! !
!ValueHolderAspectAdaptor categoriesFor: #setValue:!public! !
!ValueHolderAspectAdaptor categoriesFor: #subject!public! !
!ValueHolderAspectAdaptor categoriesFor: #subject:!public! !
!ValueHolderAspectAdaptor categoriesFor: #value!public! !

SmaCCTransformationToolkit guid: (GUID fromString: '{2FFCD76E-469B-46C0-BE7D-464B8230C451}')!
SmaCCTransformationToolkit comment: ''!
!SmaCCTransformationToolkit categoriesForClass!Unclassified! !
!SmaCCTransformationToolkit methodsFor!

addedTransformation: aSmaCCAbstractRewrite under: aSmaCCFileRewrite
	self rewriteTreePresenter model add: aSmaCCAbstractRewrite asChildOf: aSmaCCFileRewrite!

addFiles
	| types filenames dialog parser |
	parser := self model inputParserClass.
	types := #(#('All files (*.*)' '*.*')).
	parser notNil
		ifTrue:
			[types := (Array
				with: (Array with: parser fileExtensionType , ' (*' , parser fileExtension , ')' with: '*' , parser fileExtension))
				, types].
	dialog := MultipleFileOpenDialog new.
	filenames := dialog
		maxFileCount: 1024;
		fileTypes: types;
		caption: 'Open files';
		showModal.
	filenames isNil ifTrue: [^self].
	self model files: (self model files , filenames) asSet asSortedCollection!

addResult: aSmaCCRewriteResult
	self resultsPresenter model
		perform: ((self resultsPresenter model list isKindOf: SortedCollection) ifTrue: [#add:] ifFalse: [#addFirst:])
		with: aSmaCCRewriteResult.
	self updatePercent.
	self updateResultStatusBarWith: aSmaCCRewriteResult!

addRewriteFile
	self openOrCreateTransformationsFile ifNotNil: [:new | self addTransformation: new]!

addTransformation
	self addTransformation: SmaCCRewrite newInstance!

addTransformation: aSmaCCAbstractRewrite
	self model addTransformation: aSmaCCAbstractRewrite under: self selectedTransformation.
	self rewriteTreePresenter selection: aSmaCCAbstractRewrite!

changedRewrite
	self rewriteTreePresenter setFocus.
	self rewriteEditorPresenter value: self selectedTransformation.
	self invalidateUserInterface!

configurationFilename
	^configurationFilename
		ifNil:
			[| types |
			types := self rewriteConfigurationFileTypes.
			configurationFilename := (FileSaveDialog new)
				fileTypes: types;
				caption: 'Save rewrite configuration';
				showModal]!

createComponents
	| treePresenter |
	super createComponents.
	self add: self createParserClassPresenter name: 'inputParserClass'.
	self add: self createParserClassPresenter name: 'validationParserClass'.
	self add: ListPresenter new name: 'files'.
	self filesPresenter model searchPolicy: SearchPolicy equality.
	self add: TextPresenter new name: 'outputDirectory'.
	self add: BooleanPresenter new name: 'createSubdirectories'.
	self add: ListPresenter new name: 'results'.
	self add: TextPresenter new name: 'input'.
	self add: TextPresenter new name: 'output'.
	self add: ListPresenter new name: 'resultRewrites'.
	self add: TextPresenter new name: 'server'.
	treePresenter := TreePresenter on: self treeModel.
	self add: treePresenter name: 'rewriteTree'.
	self add: SmaCCRewritePresenter new name: 'rewriteEditor'.
	self add: TextPresenter new name: 'fileFinder'.
	self initializeTotals.
	fileStatusModel := 'Files: 0' asValue.
	resultStatusModel := '' asValue!

createParserClassPresenter
	| presenter |
	presenter := ChoicePresenter new.
	presenter choices: (SmaCCParser allSubclasses asSortedCollection: [:a :b | a name < b name]).
	^presenter!

createSchematicWiring
	| imageManager |
	super createSchematicWiring.
	self
		when: #closeRequested:
		send: #onCloseRequested:
		to: self.
	(self resultRewritesPresenter)
		when: #selectionChanged
			send: #underlineResult
			to: self;
		when: #actionPerformed
			send: #gotoRewrite
			to: self.
	(self resultsPresenter)
		when: #selectionChanged
			send: #updateFilesSelection
			to: self;
		when: #actionPerformed
			send: #openResult
			to: self.
	(self filesPresenter)
		when: #selectionChanged
			send: #resetOutput
			to: self;
		when: #actionPerformed
			send: #openFileResult
			to: self.
	self inputPresenter
		when: #valueChanged
		send: #updateLineNumberWidth:
		to: self
		with: self inputPresenter view.
	self outputPresenter
		when: #valueChanged
		send: #updateLineNumberWidth:
		to: self
		with: self outputPresenter view.
	self
		updateLineNumberWidth: self inputPresenter view;
		updateLineNumberWidth: self outputPresenter view.
	(self rewriteTreePresenter)
		when: #selectionChanged
			send: #changedRewrite
			to: self;
		when: #drag:
			send: #dragStart:
			to: self;
		when: #drop:
			send: #dragDrop:
			to: self;
		when: #dragEnter:
			send: #dragOver:
			to: self;
		when: #dragOver:
			send: #dragOver:
			to: self.
	(self view viewNamed: 'fileStatus') model: fileStatusModel.
	(self view viewNamed: 'resultStatus') model: resultStatusModel.
	imageManager := ImageManager new.
	(self resultsPresenter view)
		imageManager: imageManager;
		getImageBlock:
				[:each | 
					(each type notNil ifTrue: [Icon perform: each type] ifFalse: [True icon])
						ifNotNil: [:icon | imageManager addImage: icon]].
	(self rewriteTreePresenter view)
		imageManager: imageManager;
		getImageBlock: [:each | imageManager addImage: each treeIcon].
	(self presenterNamed: 'fileFinder')
		when: #valueChanged
		send: #findFile
		to: self!

currentTextViewDo: aBlock
	| focusView |
	focusView := View focus.
	(focusView isKindOf: ScintillaView) ifTrue: [aBlock value: focusView]!

debugRewrite
	| selection oldBlock |
	selection := self resultRewritesPresenter selection.
	oldBlock := SmaCCRewriteProcessor haltBlock.
	SmaCCRewriteProcessor
		haltBlock:
			[:rewrite :node | 
			rewrite == selection rewrite
				and:
					[node class == selection nodeClass
						and: [node startPosition = selection nodeInterval start and: [node stopPosition = selection nodeInterval stop]]]].
	[self openFileResult] ensure: [SmaCCRewriteProcessor haltBlock: oldBlock]!

deleteTransformation
	(MessageBox confirm: 'Are you sure you want to delete this transformation?') ifFalse: [^self].
	self model removeTransformation: self selectedTransformation!

dragDrop: aSession
	| target source file |
	target := aSession suggestedTarget.
	target isNil
		ifTrue:
			[Sound errorBeep.
			^false].
	file := target parent.
	file isNil
		ifTrue:
			[Sound errorBeep.
			^false].
	source := self dragSource: aSession.
	(source isNil or: [file isUnder: source])
		ifTrue:
			[Sound errorBeep.
			^false].
	aSession operation = #move
		ifTrue:
			[(self model)
				removeTransformation: source;
				addTransformation: source
					under: file
					before: target.
			^true].
	aSession operation = #copy
		ifTrue:
			[source := source copy.
			self model
				addTransformation: source
				under: file
				before: target.
			^true].
	Sound errorBeep.
	^false!

dragOver: aSession
	| target source |
	target := aSession suggestedTarget.
	source := self dragSource: aSession.
	(source notNil
		and: [target notNil and: [target ~= source and: [target parent notNil and: [(target parent isUnder: source) not]]]])
		ifTrue:
			[| isMove |
			isMove := target topParent == source topParent.
			aSession operation: (isMove ifTrue: [#move] ifFalse: [#copy]).
			isMove ifFalse: [aSession supportedOperations: #(#copy)].
			^true].
	^false!

dragSource: aSession
	aSession dragObjects do: [:each | (each isFormatAvailable: #Transformation) ifTrue: [^each format: #Transformation]].
	^nil!

dragStart: aSession
	| dragObject |
	aSession suggestedSource
		ifNotNil:
			[:value | 
			| stream |
			stream := WriteStream on: String new.
			value localSaveOn: stream.
			dragObject := (aSession newDragObject: value)
				format: #Transformation data: value;
				format: #String data: stream contents;
				yourself].
	dragObject notNil ifTrue: [aSession dragObjects: (OrderedCollection with: dragObject)]!

exportResults
	| filename stream |
	filename := (FileSaveDialog new)
		caption: 'Save results';
		showModal.
	filename isNil ifTrue: [^self].
	stream := FileStream write: filename.
	[(self resultsPresenter list collect: [:each | each asTabDelimitedString]) asSortedCollection
		do:
			[:each | 
			stream
				nextPutAll: each;
				cr]] ensure: [stream close]!

fileNamesFromClipboard
	| files stream outStream char endBlock |
	files := Set new.
	stream := ReadStream on: (Clipboard current getTextIfNone: ['']).
	outStream := WriteStream on: String new.
	endBlock := [outStream position > 0
		ifTrue:
			[files add: outStream contents.
			outStream reset]].
	[stream atEnd]
		whileFalse:
			[char := stream next.
			(char isAlphaNumeric or: [char == $_ or: [char == $ ]]) ifTrue: [outStream nextPut: char] ifFalse: [endBlock value]].
	endBlock value.
	^files!

filesPresenter
	^self presenterNamed: 'files'!

findDialogClass
	^AdvancedFindDialog!

findFile
	| name file |
	name := (self presenterNamed: 'fileFinder') value.
	name isEmpty ifTrue: [^self].
	name := name asLowercase.
	file := self filesPresenter list
		detect: [:each | (File splitStemFrom: each) asLowercase beginsWith: name]
		ifNone: [self filesPresenter list detect: [:each | (each asLowercase indexOfSubCollection: name) > 0] ifNone: [^self]].
	self filesPresenter selection: (Array with: file).
	self filesPresenter view ensureSelectionVisible!

findRewrite
	| details |
	details := FindDetails new.
	^self findDialogClass showModeless: self on: details!

findText
	self isRewriteTreeFocused ifTrue: [self findRewrite] ifFalse: [self currentTextViewDo: [:each | each find]]!

formatText
	self
		currentTextViewDo:
			[:each | 
			| text tree code |
			text := each plainText.
			tree := SmalltalkParser parseExpression: text onError: [:err | ^self].
			code := RBConfigurableFormatter format: tree.
			each
				plainText: code;
				value: code]!

gotoRewrite
	self resultRewritesPresenter hasSelection ifFalse: [^self].
	self resultRewritesPresenter selection
		ifNotNil:
			[:value | 
			(self rewriteTreePresenter)
				selection: nil;
				selection: value rewrite]!

initializeTotals
	totals := Array new: 3 withAll: 0!

inputPresenter
	^self presenterNamed: 'input'!

isRewriteTreeFocused
	^self rewriteTreePresenter view == View focus!

loadConfigurationFile: aString into: aModel
	aModel loadFile: aString.
	configurationFilename := aString!

model: aSmaCCTransformationToolkitModel
	super model: aSmaCCTransformationToolkitModel.
	self outputDirectoryPresenter model: (self model aspectValue: #outputDirectory triggers: #outputDirectory).
	(self presenterNamed: 'createSubdirectories')
		model: (self model aspectValue: #createSubdirectories triggers: #createSubdirectories).
	(self model)
		when: #rewrites
			send: #updateRewrites
			to: self;
		when: #files
			send: #updateFiles
			to: self;
		when: #resultAdded
			send: #addResult:
			to: self;
		when: #inputParserClass
			send: #updateMenuItems
			to: self;
		when: #addTransformation:under:
			send: #addedTransformation:under:
			to: self;
		when: #removedTransformation:
			send: #removedTransformation:
			to: self.
	self
		updateMenuItems;
		updateRewrites;
		updateFiles!

newWindow
	(self class createOn: self model) show!

nextRewriteAfter: aSmaCCRewrite
	| index parent current |
	(aSmaCCRewrite isComposite and: [aSmaCCRewrite rewrites notEmpty]) ifTrue: [^aSmaCCRewrite rewrites first].
	current := aSmaCCRewrite.
	[parent := current parent.
	parent isNil ifTrue: [^nil].
	index := parent rewrites identityIndexOf: current.
	index = 0 ifTrue: [^nil].
	index < parent rewrites size ifTrue: [^parent rewrites at: index + 1].
	current := parent] repeat!

nextRewritesDo: aBlock
	| current |
	current := self rewriteTreePresenter selection ifNil: [self model rewrites].
	[current := self nextRewriteAfter: current.
	current notNil] whileTrue: [aBlock value: current]!

onCloseRequested: boolValueHolder
	boolValueHolder value: (self model isModified not or: [self promptToSaveChanges])!

onFind: findDetails
	self
		nextRewritesDo:
			[:each | 
			| stream string |
			stream := WriteStream on: String new.
			each localSaveOn: stream.
			string := stream contents.
			('*' , findDetails pattern , '*' match: string ignoreCase: findDetails isCaseSensitive not)
				ifTrue: [^self rewriteTreePresenter selection: each]].
	Sound warningBeep!

openConfiguration
	| types filename |
	(self model isModified not or: [self promptToSaveChanges]) ifFalse: [^self].
	types := self rewriteConfigurationFileTypes.
	filename := (FileOpenDialog new)
		fileTypes: types;
		caption: 'Open rewrite configuration';
		showModal.
	filename isNil ifTrue: [^self].
	self loadConfigurationFile: filename into: self model.
	self resultsPresenter list: OrderedCollection new.
	self initializeTotals!

openFileResult
	| selections |
	selections := self filesPresenter selectionOrNil.
	(selections isNil or: [selections isEmpty]) ifTrue: [^self].
	self openResultFor: selections first!

openOrCreateTransformationsFile
	| types filename current |
	types := #(#('Rewrites (*.rw)' '*.rw') #('All files (*.*)' '*.*')).
	filename := (FileSaveDialog new)
		fileTypes: types;
		caption: 'Rewrites';
		showModal.
	filename isNil ifTrue: [^nil].
	current := self selectedTransformation.
	[current notNil]
		whileTrue:
			[current filename asUppercase = filename asUppercase ifTrue: [^MessageBox warning: 'Cannot add file under itself'].
			current := current parent].
	^self model openRewriteFile: filename!

openResult
	| selectedItem |
	selectedItem := self resultsPresenter selectionOrNil.
	selectedItem isNil ifTrue: [^self].
	self openResultFor: selectedItem filename!

openResultFor: filename
	| result processor |
	result := SmaCCRewriteCompleteResult new.
	processor := SmaCCRewriteProcessor new.
	processor rules: self model rewrites.
	processor parserClass: self model inputParserClass.
	processor validationParserClass: self model validationParserClass.
	processor debug: true.
	[processor processFile: filename usingResult: result] ensure: [processor debug: false].
	self showResult: result!

openRewrites
	self rewriteTreePresenter selection: nil.
	self openOrCreateTransformationsFile ifNotNil: [:value | self model rewrites: value]!

outputDirectoryPresenter
	^self presenterNamed: 'outputDirectory'!

outputPresenter
	^self presenterNamed: 'output'!

progressPresenter
	^progressPresenter ifNil: [[:value | ]]!

promptToSaveChanges
	^(MessageBox confirm: 'The definition has been modified. Do you wish to retain your changes?') not!

queryCommand: aCommandQuery
	| cmd |
	cmd := aCommandQuery commandSymbol.
	cmd = #gotoRewrite ifTrue: [^aCommandQuery isEnabled: self resultRewritesPresenter hasSelection].
	cmd == #setServer ifTrue: [aCommandQuery text: 'Set Se&rver (' , self model server , ')'].
	cmd == #setInputParser
		ifTrue:
			[aCommandQuery
				text:
					'Input Parser'
						, (self model inputParserClass isNil ifTrue: [''] ifFalse: [' (' , self model inputParserClass name , ')'])
						, '...'].
	cmd == #setValidationParser
		ifTrue:
			[aCommandQuery
				text:
					'Validation Parser'
						,
							(self model validationParserClass isNil ifTrue: [''] ifFalse: [' (' , self model validationParserClass name , ')'])
						, '...'].
	cmd = #toggleUseServer ifTrue: [aCommandQuery isChecked: self model runOnServer].
	(#(#findText #replaceText #formatText) includes: cmd)
		ifTrue:
			[| enabled |
			enabled := self isRewriteTreeFocused and: [cmd ~= #formatText].
			self currentTextViewDo: [:v | enabled := true].
			^aCommandQuery isEnabled: enabled].
	(#(#addRewriteFile #addTransformation) includes: cmd)
		ifTrue:
			[^aCommandQuery isEnabled: (self selectedTransformation notNil and: [self selectedTransformation isComposite])].
	cmd = #deleteTransformation
		ifTrue: [^aCommandQuery isEnabled: (self selectedTransformation notNil and: [self selectedTransformation isRoot not])].
	cmd = #viewFile
		ifTrue:
			[^aCommandQuery
				isEnabled: (self filesPresenter selectionOrNil notNil and: [self filesPresenter selectionOrNil notEmpty])].
	^super queryCommand: aCommandQuery!

remainingFiles
	| ran |
	ran := self resultsPresenter list collect: [:each | each filename].
	^self model files reject: [:each | ran includes: each]!

removedTransformation: aSmaCCAbstractRewrite
	self rewriteTreePresenter model remove: aSmaCCAbstractRewrite ifAbsent: []!

removeFiles
	| list |
	list := OrderedCollection withAll: self model files.
	list removeAll: self filesPresenter selections.
	self model files: list!

replaceText
	self currentTextViewDo: [:each | each findReplace]!

resetOutput
	self inputPresenter value: ''.
	self outputPresenter value: ''.
	transformedString := SmaCCAnnotatedString on: ''!

resultRewritesPresenter
	^self presenterNamed: 'resultRewrites'!

resultsPresenter
	^self presenterNamed: 'results'!

rewriteConfigurationFileTypes
	^#(#('Rewrite configuration (*.rwc)' '*.rwc') #('All files (*.*)' '*.*'))!

rewriteEditorPresenter
	^self presenterNamed: 'rewriteEditor'!

rewriteTreePresenter
	^self presenterNamed: 'rewriteTree'!

runOn: aCollection
	transformationFiles := aCollection.
	runCount := 0.
	(self model runOnServer and: [self model areRewritesModified])
		ifTrue:
			[(MessageBox confirm: 'Do you want to save your transformations before running on the server?')
				ifTrue: [self saveRewrites]].
	ProgressDialog
		showModalWhile:
			[:progress | 
			progressPresenter := progress.
			[progressPresenter text: 'Transforming ' , aCollection size printString , ' files'.
			self setupForRunning.
			self model runOn: aCollection] ensure: [progressPresenter := nil]]!

runOnModels: aCollection
	| todo processes semaphore forkedSize |
	forkedSize := 8.
	todo := SharedQueue new.
	runCount := 0.
	transformationFiles := OrderedCollection new.
	aCollection
		do:
			[:each | 
			transformationFiles addAll: each files.
			todo nextPut: each.
			each
				when: #resultAdded
				send: #addResult:
				to: self].
	ProgressDialog
		showModalWhile:
			[:progress | 
			semaphore := Semaphore new.
			processes := OrderedCollection new.
			progressPresenter := progress.
			[progressPresenter text: 'Transforming ' , transformationFiles size printString , ' files'.
			self setupForRunning.
			forkedSize
				timesRepeat:
					[[[[todo size > 0]
						whileTrue:
							[| item |
							item := todo next.
							item runOn: item files]] ensure: [semaphore signal]] fork].
			forkedSize timesRepeat: [semaphore wait]]
				ensure:
					[processes do: [:each | each terminate].
					progressPresenter := nil]]!

saveConfiguration
	| filename |
	self model rewrites isUpToDate
		ifFalse:
			[(MessageBox confirm: 'The rewrite files have been modified. Do you wish to overwrite the files?') ifFalse: [^self]].
	filename := self configurationFilename.
	filename isNil ifTrue: [^self].
	self model saveTo: filename!

saveRewrites
	(self model rewrites notNil and: [self model rewrites isUpToDate])
		ifFalse:
			[(MessageBox confirm: 'The rewrite files have been modified. Do you wish to overwrite the files?') ifFalse: [^self]].
	self model saveRewrites!

selectedTransformation
	^self rewriteTreePresenter selectionOrNil!

selectErrorFiles
	| files |
	files := Set new.
	self fileNamesFromClipboard
		do:
			[:name | 
			(self model files detect: [:each | name sameAs: (File splitStemFrom: each)] ifNone: [nil])
				ifNotNil: [:value | files add: value]].
	files notEmpty ifTrue: [self filesPresenter selections: files asArray]!

selectInputLocation
	| range annotations |
	transformedString isNil ifTrue: [^self].
	range := self inputPresenter selectionRange.
	annotations := transformedString annotationsInOriginalRange: range.
	(self presenterNamed: 'resultRewrites') list: annotations!

selectOutputLocation
	| range annotations |
	transformedString isNil ifTrue: [^self].
	range := self outputPresenter selectionRange.
	annotations := transformedString annotationsInNewRange: range.
	(self presenterNamed: 'resultRewrites') list: annotations!

setInputParser
	| class |
	class := ChoicePrompter
		choices: (SmaCCParser allSubclasses asSortedCollection: [:a :b | a name < b name])
		caption: 'Select input parser class'.
	class isNil ifTrue: [^self].
	self model inputParserClass: class!

setServer
	(Prompter
		on: self model server
		prompt: 'Enter server location'
		caption: 'Server') ifNotNil: [:value | self model server: value]!

setStyler: aScintillaView for: aSmaCCParserClass
	aSmaCCParserClass isNil ifTrue: [^self].
	(#('.st' '.sym') includes: aSmaCCParserClass fileExtension)
		ifTrue:
			[aScintillaView
				lexer: #smalltalk;
				textStyles: ScintillaView smalltalkTextStyles].
	(#('.pas' '.dpr' '.dfm') includes: aSmaCCParserClass fileExtension)
		ifTrue:
			[aScintillaView
				lexer: #pascal;
				textStyles: self class pascalTextStyle].
	(#('.java' '.c' '.cs') includes: aSmaCCParserClass fileExtension)
		ifTrue:
			[aScintillaView
				lexer: #cpp;
				textStyles: self class cTextStyle]!

setupForRunning
	| newList removed |
	newList := OrderedCollection new.
	removed := OrderedCollection new.
	self resultsPresenter list
		do: [:each | (transformationFiles includes: each filename) ifTrue: [removed add: each] ifFalse: [newList add: each]].
	self updateResultStatusBarWithoutAll: removed.
	self resultsPresenter list: newList.
	resultStatusModel value: ''!

setValidationParser
	| class |
	class := ChoicePrompter
		choices: (SmaCCParser allSubclasses asSortedCollection: [:a :b | a name < b name])
		caption: 'Select validation parser class'.
	class isNil ifTrue: [^self].
	self model validationParserClass: class!

showResult: aSmaCCRewriteResult
	| scintilla |
	transformedString := aSmaCCRewriteResult transformedString ifNil: [SmaCCAnnotatedString on: ''].
	self inputPresenter value: aSmaCCRewriteResult inputSource.
	self setStyler: self inputPresenter view for: self model inputParserClass.
	self outputPresenter value: (aSmaCCRewriteResult outputSource ifNil: ['']).
	self setStyler: self outputPresenter view for: self model validationParserClass.
	self
		updateLineNumberWidth: self inputPresenter view;
		updateLineNumberWidth: self outputPresenter view.
	scintilla := aSmaCCRewriteResult outputSource isNil ifTrue: [self inputPresenter] ifFalse: [self outputPresenter].
	scintilla setFocus.
	aSmaCCRewriteResult interval notNil ifTrue: [scintilla selectionRange: aSmaCCRewriteResult interval]!

toggleUseServer
	self model toggleUseServer!

transformAll
	self runOn: self model files!

transformRemaining
	self runOn: self remainingFiles!

transformSelected
	self runOn: self filesPresenter selections!

transformWithErrorsOrWarnings
	| files |
	files := (self resultsPresenter list select: [:each | each isError or: [each isWarning]])
		collect: [:each | each filename].
	self runOn: files!

treeModel
	| treeModel |
	treeModel := VirtualTreeModel
		withRoots:
			((self model isNil or: [self model rewrites isNil]) ifTrue: [#()] ifFalse: [Array with: self model rewrites]).
	treeModel getChildrenBlock: [:each | each rewrites].
	treeModel getParentBlock: [:each | each parent].
	^treeModel!

underlineInput
	| selection indicators |
	self resultRewritesPresenter hasSelection
		ifTrue:
			[selection := self resultRewritesPresenter selection.
			indicators := Array
				with:
					(ScintillaIndicator
						type: 3
						range: selection nodeInterval
						tag: selection rewrite displayString).
			self inputPresenter view goto: selection nodeInterval start]
		ifFalse: [indicators := #()].
	self inputPresenter view indicators: indicators!

underlineOutput
	| selection indicators |
	self resultRewritesPresenter hasSelection
		ifTrue:
			[selection := self resultRewritesPresenter selection.
			indicators := (transformedString annotationRangesFor: selection)
				collect:
					[:each | 
					ScintillaIndicator
						type: 3
						range: each
						tag: selection rewrite displayString].
			indicators notEmpty ifTrue: [self outputPresenter view goto: indicators first range start]]
		ifFalse: [indicators := #()].
	self outputPresenter view indicators: indicators!

underlineResult
	self underlineInput.
	self underlineOutput!

updateFiles
	self filesPresenter list: self model files.
	fileStatusModel value: ('Files: <1p>' expandMacrosWith: self model files size)!

updateFilesSelection
	| selection |
	selection := self resultsPresenter selectionOrNil.
	selection isNil ifTrue: [^self].
	(self model files includes: selection filename)
		ifTrue: [self filesPresenter selections: (Array with: selection filename)]!

updateLineNumberWidth: aScintillaView
	aScintillaView lineNumberMargin ifNotNil: [:margin | margin width: aScintillaView requiredLineMarginWidth]!

updateMenuItems
	| menu |
	menu := Menu new.
	menu addCommandDescription: ((CommandDescription command: #find description: 'Find') acceleratorKeyString: 'Ctrl+F').
	self model inputParserClass notNil ifTrue: [self model inputParserClass addContextMenuItemsTo: menu].
	self inputPresenter view contextMenu: menu!

updatePercent
	runCount := runCount + 1.
	self progressPresenter value: runCount * 100 / transformationFiles size!

updateResultStatusBarWith: aSmaCCRewriteResult
	totals at: 1 put: totals first + 1.
	aSmaCCRewriteResult isError ifTrue: [totals at: 2 put: (totals at: 2) + 1].
	aSmaCCRewriteResult isWarning ifTrue: [totals at: 3 put: totals last + 1].
	self updateStatusBar!

updateResultStatusBarWithoutAll: aCollection
	aCollection
		do:
			[:each | 
			totals at: 1 put: totals first - 1.
			each isError ifTrue: [totals at: 2 put: (totals at: 2) - 1].
			each isWarning ifTrue: [totals at: 3 put: totals last - 1]].
	self updateStatusBar!

updateRewrites
	self rewriteTreePresenter model: self treeModel!

updateStatusBar
	| resultString |
	resultString := 'Total: <1p> Errors: <2p> Warnings: <3p>' expandMacrosWithArguments: totals.
	resultStatusModel value: resultString!

validateUserInterface
	super validateUserInterface.
	self inputPresenter view hasFocus ifTrue: [self selectInputLocation].
	self outputPresenter view hasFocus ifTrue: [self selectOutputLocation]!

viewFile
	| scintilla inputSource stream selectedItem |
	selectedItem := self filesPresenter selectionOrNil.
	(selectedItem isNil or: [selectedItem isEmpty]) ifTrue: [^self].
	selectedItem := selectedItem first.
	stream := FileStream read: selectedItem.
	inputSource := [stream contents] ensure: [stream close].
	transformedString := SmaCCAnnotatedString on: ''.
	self inputPresenter value: inputSource.
	self setStyler: self inputPresenter view for: self model inputParserClass.
	self outputPresenter value: ''.
	self setStyler: self outputPresenter view for: self model validationParserClass.
	self
		updateLineNumberWidth: self inputPresenter view;
		updateLineNumberWidth: self outputPresenter view.
	scintilla := self inputPresenter.
	scintilla setFocus! !
!SmaCCTransformationToolkit categoriesFor: #addedTransformation:under:!private! !
!SmaCCTransformationToolkit categoriesFor: #addFiles!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #addResult:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #addRewriteFile!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #addTransformation!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #addTransformation:!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #changedRewrite!actions-rewrites!public! !
!SmaCCTransformationToolkit categoriesFor: #configurationFilename!accessing!private! !
!SmaCCTransformationToolkit categoriesFor: #createComponents!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #createParserClassPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #createSchematicWiring!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #currentTextViewDo:!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #debugRewrite!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #deleteTransformation!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #dragDrop:!actions-drag and drop!public! !
!SmaCCTransformationToolkit categoriesFor: #dragOver:!actions-drag and drop!public! !
!SmaCCTransformationToolkit categoriesFor: #dragSource:!actions-drag and drop!public! !
!SmaCCTransformationToolkit categoriesFor: #dragStart:!actions-drag and drop!public! !
!SmaCCTransformationToolkit categoriesFor: #exportResults!actions-drag and drop!public! !
!SmaCCTransformationToolkit categoriesFor: #fileNamesFromClipboard!public! !
!SmaCCTransformationToolkit categoriesFor: #filesPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #findDialogClass!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #findFile!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #findRewrite!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #findText!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #formatText!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #gotoRewrite!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #initializeTotals!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #inputPresenter!presenters!public! !
!SmaCCTransformationToolkit categoriesFor: #isRewriteTreeFocused!public!testing! !
!SmaCCTransformationToolkit categoriesFor: #loadConfigurationFile:into:!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #model:!accessing!public! !
!SmaCCTransformationToolkit categoriesFor: #newWindow!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #nextRewriteAfter:!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #nextRewritesDo:!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #onCloseRequested:!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #onFind:!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #openConfiguration!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #openFileResult!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #openOrCreateTransformationsFile!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #openResult!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #openResultFor:!private! !
!SmaCCTransformationToolkit categoriesFor: #openRewrites!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #outputDirectoryPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #outputPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #progressPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #promptToSaveChanges!public!testing! !
!SmaCCTransformationToolkit categoriesFor: #queryCommand:!commands!private! !
!SmaCCTransformationToolkit categoriesFor: #remainingFiles!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #removedTransformation:!private! !
!SmaCCTransformationToolkit categoriesFor: #removeFiles!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #replaceText!actions-editing!private! !
!SmaCCTransformationToolkit categoriesFor: #resetOutput!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #resultRewritesPresenter!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #resultsPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #rewriteConfigurationFileTypes!private! !
!SmaCCTransformationToolkit categoriesFor: #rewriteEditorPresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #rewriteTreePresenter!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #runOn:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #runOnModels:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #saveConfiguration!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #saveRewrites!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #selectedTransformation!private! !
!SmaCCTransformationToolkit categoriesFor: #selectErrorFiles!public! !
!SmaCCTransformationToolkit categoriesFor: #selectInputLocation!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #selectOutputLocation!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #setInputParser!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #setServer!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #setStyler:for:!private! !
!SmaCCTransformationToolkit categoriesFor: #setupForRunning!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #setValidationParser!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #showResult:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #toggleUseServer!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #transformAll!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #transformRemaining!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #transformSelected!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #transformWithErrorsOrWarnings!actions-running!public! !
!SmaCCTransformationToolkit categoriesFor: #treeModel!presenters!private! !
!SmaCCTransformationToolkit categoriesFor: #underlineInput!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #underlineOutput!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #underlineResult!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #updateFiles!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #updateFilesSelection!actions!public! !
!SmaCCTransformationToolkit categoriesFor: #updateLineNumberWidth:!private! !
!SmaCCTransformationToolkit categoriesFor: #updateMenuItems!accessing!public! !
!SmaCCTransformationToolkit categoriesFor: #updatePercent!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #updateResultStatusBarWith:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #updateResultStatusBarWithoutAll:!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #updateRewrites!actions-rewrites!private! !
!SmaCCTransformationToolkit categoriesFor: #updateStatusBar!actions-running!private! !
!SmaCCTransformationToolkit categoriesFor: #validateUserInterface!initializing!private! !
!SmaCCTransformationToolkit categoriesFor: #viewFile!actions-running!private! !

!SmaCCTransformationToolkit class methodsFor!

cTextStyle
	| answer |
	answer := ScintillaView defaultTextStyles.
	answer
		add:
				((ScintillaTextStyle name: #comment)
						id: 1;
						forecolor: (Color fromHTMLSpec: '#007F00');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #lineComment)
						id: 2;
						forecolor: (Color fromHTMLSpec: '#007F00');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #docComment)
						id: 3;
						forecolor: (Color fromHTMLSpec: '#7F7F7F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #number)
						id: 4;
						forecolor: (Color fromHTMLSpec: '#007F7F');
						yourself);
		add:
				((ScintillaTextStyle name: #keyword)
						id: 5;
						forecolor: (Color fromHTMLSpec: '#00007F');
						isBold: true;
						yourself);
		add:
				((ScintillaTextStyle name: #doubleQuotedString)
						id: 6;
						forecolor: (Color fromHTMLSpec: '#7F007F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #singleQuotedString)
						id: 7;
						forecolor: (Color fromHTMLSpec: '#7F007F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #uuid)
						id: 8;
						forecolor: (Color fromHTMLSpec: '#804080');
						yourself);
		add:
				((ScintillaTextStyle name: #preprocessor)
						id: 9;
						forecolor: (Color fromHTMLSpec: '#7F7F00');
						yourself);
		add:
				((ScintillaTextStyle name: #operators)
						id: 10;
						forecolor: Color black;
						isBold: true;
						yourself);
		add:
				((ScintillaTextStyle name: #identifiers)
						id: 11;
						yourself);
		add:
				((ScintillaTextStyle name: #endOfLineString)
						id: 12;
						forecolor: (Color fromHTMLSpec: '#000000');
						isBackcolorExtendedToEndOfLine: true;
						backcolor: (Color fromHTMLSpec: '#E0C0E0');
						yourself);
		add:
				((ScintillaTextStyle name: #verbatimString)
						id: 13;
						forecolor: (Color fromHTMLSpec: '#007F00');
						isBackcolorExtendedToEndOfLine: true;
						backcolor: (Color fromHTMLSpec: '#E0FFE0');
						yourself);
		add:
				((ScintillaTextStyle name: #regularExpression)
						id: 14;
						forecolor: (Color fromHTMLSpec: '#3F7F3F');
						isBackcolorExtendedToEndOfLine: true;
						backcolor: (Color fromHTMLSpec: '#E0F0FF');
						yourself);
		add:
				((ScintillaTextStyle name: #docComment1)
						id: 15;
						forecolor: (Color fromHTMLSpec: '#7F7F7F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #keywords2)
						id: 16;
						forecolor: (Color fromHTMLSpec: '#B00040');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #commentKeyword)
						id: 17;
						forecolor: (Color fromHTMLSpec: '#3060A0');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #commentKeywordError)
						id: 18;
						forecolor: (Color fromHTMLSpec: '#804020');
						isItalic: true;
						yourself).
	^answer!

defaultModel
	^SmaCCTransformationToolkitModel new!

pascalTextStyle
	| answer |
	answer := ScintillaView defaultTextStyles.
	answer
		add:
				((ScintillaTextStyle name: #comment)
						id: 1;
						forecolor: (Color fromHTMLSpec: '#007F00');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #lineComment)
						id: 2;
						forecolor: (Color fromHTMLSpec: '#007F00');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #docComment)
						id: 3;
						forecolor: (Color fromHTMLSpec: '#7F7F7F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #number)
						id: 4;
						forecolor: (Color fromHTMLSpec: '#007F7F');
						yourself);
		add:
				((ScintillaTextStyle name: #keyword)
						id: 5;
						forecolor: (Color fromHTMLSpec: '#00007F');
						isBold: true;
						yourself);
		add:
				((ScintillaTextStyle name: #doubleQuotedString)
						id: 6;
						forecolor: (Color fromHTMLSpec: '#7F007F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #singleQuotedString)
						id: 7;
						forecolor: (Color fromHTMLSpec: '#7F007F');
						isItalic: true;
						yourself);
		add:
				((ScintillaTextStyle name: #symbols)
						id: 8;
						forecolor: (Color fromHTMLSpec: '#007F7F');
						yourself);
		add:
				((ScintillaTextStyle name: #preprocessor)
						id: 9;
						forecolor: (Color fromHTMLSpec: '#7F7F00');
						yourself);
		add:
				((ScintillaTextStyle name: #operators)
						id: 10;
						forecolor: Color black;
						yourself);
		add:
				((ScintillaTextStyle name: #inlineAsm)
						id: 14;
						forecolor: (Color fromHTMLSpec: '#008080');
						yourself);
		add:
				((ScintillaTextStyle name: #defaultIdentifiers)
						id: 32;
						forecolor: (Color fromHTMLSpec: '#800000');
						yourself);
		add:
				((ScintillaTextStyle name: #braceHighlight)
						id: 34;
						forecolor: (Color fromHTMLSpec: '#0000FF');
						yourself);
		add:
				((ScintillaTextStyle name: #braceHighlight)
						id: 35;
						forecolor: (Color fromHTMLSpec: '#FF0000');
						yourself).
	^answer!

resource_Default_view
	"Answer the literal data from which the 'Default view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Default_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ShellView)  98 27 0 0 98 2 27131905 131073 416 0 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 551 0 0 0 416 788230 ##(Smalltalk.BorderLayout)  1 1 0 410 8 ##(Smalltalk.StatusBar)  98 18 0 416 98 2 8 1140853004 1 560 0 482 8 4278190080 0 7 0 263174 ##(Smalltalk.Font)  0 16 459014 ##(Smalltalk.LOGFONT)  8 #[243 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 144 1 0 0 0 0 0 0 3 2 1 34 65 114 105 97 108 0 159 4 0 134 63 1 0 0 204 53 63 1 2 0 20 59 0 0 0 0 247 0 5 86 111 1] 328198 ##(Smalltalk.Point)  193 193 0 560 0 8 4294902461 234 256 98 6 853766 ##(Smalltalk.StatusBarItem)  1 -1 560 0 459270 ##(Smalltalk.Message)  8 #displayString 98 0 0 0 8 'resultStatus' 834 1 -1 560 0 866 896 98 0 0 1114638 ##(Smalltalk.STBSingletonProxy)  8 ##(Smalltalk.IconImageManager)  8 #current 8 'fileStatus' 834 1 -1 560 0 866 896 98 0 787814 3 ##(Smalltalk.BlockClosure)  0 0 918822 ##(Smalltalk.CompiledMethod)  2 3 832 8 #defaultGetImageBlock 341583395 8 #[30 105 226 0 106] 8 #iconImageIndex 1136 7 257 0 0 8 'validationStatus' 98 2 944 848 1115142 ##(Smalltalk.StatusBarNullItem)  513 1 560 0 852230 ##(Smalltalk.FramingLayout)  234 240 98 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 1 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 754 1 1163 754 1609 49 560 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 69 2 0 0 36 3 0 0 93 2 0 0] 98 0 754 193 193 0 27 0 0 410 8 ##(Smalltalk.CardContainer)  98 16 0 416 98 2 8 1140850688 131073 1600 0 482 8 4278190080 0 7 0 0 0 1600 655878 ##(Smalltalk.CardLayout)  202 208 98 3 721414 ##(Smalltalk.Association)  8 'Configuration' 410 8 ##(Smalltalk.ContainerView)  98 15 0 1600 98 2 8 1409286144 131073 1824 0 0 0 7 0 0 0 1824 1298 234 240 98 4 410 8 ##(Smalltalk.ListView)  98 30 0 1824 98 2 8 1140920397 1025 1952 590662 2 ##(Smalltalk.ListModel)  202 208 1344 0 1002 8 ##(Smalltalk.SearchPolicy)  8 #identity 482 8 4278190080 0 7 0 0 0 1952 0 8 4294902503 866 896 98 0 8 ##(Smalltalk.IconicListAbstract)  1008 0 0 0 0 0 0 202 208 98 5 920646 5 ##(Smalltalk.ListViewColumn)  8 'File' 601 8 #left 866 8 #filename 98 0 1122 0 0 1180966 ##(Smalltalk.CompiledExpression)  2 1 864 8 'doIt' 8 '[:a :b | a filename <= b filename]' 8 #[30 105 226 0 226 32 130 106] 2336 2368 7 513 0 0 0 1952 0 1 0 0 2258 8 'Error' 501 2304 866 8 #errorString 98 0 1122 0 0 2386 2 1 1120 8 'doIt' 8 '[:a :b | a errorString isNil or: [b errorString notNil and: [a errorString <= b errorString]]]' 8 #[30 105 226 0 223 2 58 106 226 32 222 6 226 0 226 32 130 106 59 106] 2512 2544 7 513 0 0 0 1952 0 1 0 0 2258 8 'Transformation' 401 2304 866 8 #transformation 98 0 1122 0 0 2386 3 1 864 8 'doIt' 8 '[:a :b | a transformation isNil or: [b transformation notNil and: [a transformation displayString <= b transformation displayString]]]' 8 #[31 105 226 0 223 2 58 106 226 32 222 8 226 0 159 226 32 159 130 106 59 106] 2672 896 2704 7 513 0 0 0 1952 0 1 0 0 2258 8 'Line' 151 2304 866 8 #startLine 98 0 1122 0 0 2386 2 1 864 8 'doIt' 8 '[:a :b | a startLine isNil or: [b startLine notNil and: [a startLine <= b startLine]]]' 8 #[30 105 226 0 223 2 58 106 226 32 222 6 226 0 226 32 130 106 59 106] 2832 2864 7 513 0 0 0 1952 0 1 0 0 2258 8 'Column' 151 2304 866 8 #startColumn 2848 1122 0 0 2386 2 1 864 8 'doIt' 8 '[:a :b | a startColumn isNil or: [b startColumn notNil and: [a startColumn <= b startColumn]]]' 8 #[30 105 226 0 223 2 58 106 226 32 222 6 226 0 226 32 130 106 59 106] 2992 3008 7 513 0 0 0 1952 0 1 0 0 8 #report 1344 0 131169 0 0 1362 202 208 98 2 1426 1456 98 2 754 1 501 754 1593 607 1952 1426 8 #text: 98 1 8 'File' 1952 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 250 0 0 0 28 3 0 0 41 2 0 0] 98 0 1584 0 27 1181766 2 ##(Smalltalk.FramingConstraints)  1002 8 ##(Smalltalk.FramingCalculation)  8 #fixedParentLeft 1 1002 3376 8 #fixedParentRight 1 1002 3376 8 #fixedPreviousBottom 1 1002 3376 8 #fixedParentBottom 1 410 1840 98 15 0 1824 98 2 8 1140850688 131073 3504 0 0 0 7 0 0 0 3504 1298 234 240 98 14 410 8 ##(Smalltalk.Toolbar)  98 25 0 3504 98 2 8 1409289164 131137 3616 0 0 0 519 0 674 0 16 706 8 #[243 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 144 1 0 0 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] 754 193 193 0 3616 482 8 4278190080 8 4294902404 234 256 1344 234 256 98 4 32713 1115910 ##(Smalltalk.ToolbarIconButton)  32713 0 3616 1 1180998 4 ##(Smalltalk.CommandDescription)  8 #removeFiles 8 'Remove files' 1 1 263494 3 ##(Smalltalk.Icon)  0 16 1002 8 ##(Smalltalk.ImageRelativeFileLocator)  1040 8 'EditClear.ico' 2032142 ##(Smalltalk.STBExternalResourceLibraryProxy)  8 'dolphindr006.dll' 0 395334 3 ##(Smalltalk.Bitmap)  0 16 0 0 0 0 3 754 33 33 1 32711 3858 32711 0 3616 1 3890 8 #addFiles 8 'Add files' 1 1 3954 0 16 3984 8 'FileOpen.ico' 4048 4082 0 16 0 0 0 0 3 754 33 33 1 98 2 4128 3872 234 240 98 4 4224 1 4096 3 0 1 0 754 33 33 754 45 45 0 656198 1 ##(Smalltalk.FlowLayout)  1 1 1 1362 202 208 98 2 1426 1456 98 2 754 1523 61 754 51 321 3616 1426 8 #updateSize 1344 3616 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 249 2 0 0 30 0 0 0 18 3 0 0 190 0 0 0] 98 0 1584 0 27 3330 1002 3376 8 #fixedViewRight -49 3408 -19 1002 3376 8 #fixedPreviousTop 1 3440 1 410 8 ##(Smalltalk.TextEdit)  98 16 0 3504 98 2 8 1140850816 1025 4640 0 482 8 4278190080 0 7 0 0 0 4640 0 8 4294902491 852486 ##(Smalltalk.NullConverter)  0 0 5 1362 202 208 98 3 1426 1456 98 2 754 241 21 754 1273 39 4640 1426 8 #selectionRange: 98 1 525062 ##(Smalltalk.Interval)  3 1 3 4640 1426 8 #isTextModified: 98 1 32 4640 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 120 0 0 0 10 0 0 0 244 2 0 0 29 0 0 0] 98 0 1584 0 27 3330 3360 241 3408 -79 1002 3376 8 #fixedParentTop 21 1002 3376 8 #fixedViewTop 39 410 8 ##(Smalltalk.StaticText)  98 16 0 3504 98 2 8 1140850944 1 5168 0 0 0 7 0 0 0 5168 0 8 4294902493 4770 0 0 0 1362 202 208 98 2 1426 1456 98 2 754 21 401 754 191 39 5168 1426 3232 98 1 8 'Output Directory:' 5168 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 10 0 0 0 200 0 0 0 105 0 0 0 219 0 0 0] 98 0 1584 0 27 3330 3360 21 1002 3376 8 #fixedViewLeft 191 3440 21 5136 39 410 8 ##(Smalltalk.MultipleSelectionListBox)  98 17 0 3504 98 2 8 1144064257 1025 5536 2034 202 208 1344 0 2080 482 8 4278190080 0 7 265030 4 ##(Smalltalk.Menu)  0 16 98 4 984134 2 ##(Smalltalk.CommandMenuItem)  1 3890 8 #transformAll 8 'Transform All' 1 1 0 0 0 5730 1 3890 8 #transformRemaining 8 'Transform Remaining' 1 1 0 0 0 5730 1 3890 8 #transformSelected 8 'Transform Selected' 1 1 0 0 0 5730 1 3890 8 #transformWithErrorsOrWarnings 8 'Transform All with Errors' 1 1 0 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 5536 0 8 4294902495 866 896 98 0 1344 0 1362 202 208 98 3 1426 1456 98 2 754 241 61 754 1273 321 5536 1426 8 #contextMenu: 98 1 5696 5536 1426 8 #horizontalExtent: 98 1 1 5536 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 120 0 0 0 30 0 0 0 244 2 0 0 190 0 0 0] 98 0 1584 0 27 3330 3360 241 3408 -79 4608 1 5136 321 410 8 ##(Smalltalk.CheckBox)  98 16 0 3504 98 2 8 1409363203 1 6336 721990 2 ##(Smalltalk.ValueHolder)  0 0 1002 2096 8 #never 32 0 0 7 0 0 0 6336 0 8 4294902499 4770 0 0 0 1362 202 208 98 2 1426 1456 98 2 754 1243 401 754 271 41 6336 1426 3232 98 1 8 'Create Subdirectories' 6336 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 109 2 0 0 200 0 0 0 244 2 0 0 220 0 0 0] 98 0 1584 0 27 3330 1002 3376 8 #fixedPreviousRight 11 3408 -79 4608 1 5136 41 410 4656 98 16 0 3504 98 2 8 1140916352 1025 6768 0 482 8 4278190080 0 7 0 0 0 6768 0 8 4294902491 4770 0 0 1 1362 202 208 98 3 1426 1456 98 2 754 241 401 754 993 39 6768 1426 4928 98 1 4962 3 1 3 6768 1426 5008 98 1 32 6768 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 120 0 0 0 200 0 0 0 104 2 0 0 219 0 0 0] 98 0 1584 0 27 3330 6736 31 3408 -359 4608 1 5136 39 410 5184 98 16 0 3504 98 2 8 1140850944 1 7152 0 0 0 7 0 0 0 7152 0 8 4294902493 4770 0 0 0 1362 202 208 98 2 1426 1456 98 2 754 21 61 754 191 41 7152 1426 3232 98 1 8 'Files:' 7152 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 10 0 0 0 30 0 0 0 105 0 0 0 50 0 0 0] 98 0 1584 0 27 3330 3360 21 5504 191 3440 3 5136 41 234 256 98 10 6768 8 'outputDirectory' 4640 8 'fileFinder' 6336 8 'createSubdirectories' 5536 8 'files' 5168 8 'outputDirectoryLabel' 0 1362 202 208 98 1 1426 1456 98 2 754 1 1 754 1593 501 3504 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 28 3 0 0 250 0 0 0] 98 7 4640 7152 5536 3616 5168 6768 6336 1584 0 27 3330 3360 1 3408 1 5104 1 5104 501 234 256 98 2 1952 8 'results' 0 1362 202 208 98 1 1426 1456 98 2 754 9 49 754 1593 1107 1824 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 4 0 0 0 24 0 0 0 32 3 0 0 65 2 0 0] 98 2 3504 1952 1584 0 27 1778 8 'Transformations' 410 1840 98 15 0 1600 98 2 8 1409286144 131073 8000 0 0 0 5 0 0 0 8000 1180166 ##(Smalltalk.ProportionalLayout)  234 240 98 4 410 1840 98 15 0 8000 98 2 8 1140850688 131073 8128 0 0 0 5 0 0 0 8128 530 1 1 410 3632 98 25 0 8128 98 2 8 1409289036 131137 8208 0 721158 ##(Smalltalk.SystemColor)  31 0 517 0 674 0 16 706 8 #[243 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 144 1 0 0 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] 754 193 193 0 8208 482 8 4278190080 8 4294902404 234 256 1344 234 256 98 6 32715 3858 32715 0 8208 1 3890 8 #addRewriteFile 8 'Add transformation file' 1 1 3954 0 16 3984 8 'Package.ico' 4048 4082 0 16 0 0 0 0 3 754 33 33 1 32717 3858 32717 0 8208 1 3890 8 #addTransformation 8 'Add transformation' 1 1 3954 0 16 3984 8 'SystemBrowserShell.ico' 4048 4082 0 16 0 0 0 0 3 754 33 33 1 32719 3858 32719 0 8208 1 3890 8 #deleteTransformation 8 'Delete transformation' 1 1 3954 0 16 3984 8 'EditClear.ico' 4048 4082 0 16 0 0 0 0 3 754 33 33 1 98 4 8464 8592 1050118 ##(Smalltalk.ToolbarSeparator)  0 0 8208 3 0 1 8720 234 240 98 6 8816 5 8560 1 8688 3 0 1 0 754 33 33 754 45 45 0 4338 1 1 1 1362 202 208 98 2 1426 1456 98 2 754 1 1 754 521 51 8208 1426 4496 1344 8208 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 4 1 0 0 25 0 0 0] 98 0 1584 0 27 0 0 0 410 8 ##(Smalltalk.TreeView)  98 27 0 8128 98 2 8 1140916263 1025 9152 590918 3 ##(Smalltalk.TreeModel)  0 2080 525062 ##(Smalltalk.TreeNode)  0 0 0 234 256 1344 482 8 4278190080 0 29 0 0 0 9152 0 8 4294902381 866 896 98 0 0 1008 0 0 0 0 0 234 240 1344 17 8 #smallIcons 1 0 1362 202 208 98 1 1426 1456 98 2 754 1 51 754 521 1057 9152 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 25 0 0 0 4 1 0 0 41 2 0 0] 98 0 1584 0 27 234 256 98 2 9152 8 'rewriteTree' 0 1362 202 208 98 1 1426 1456 98 2 754 1 1 754 521 1107 8128 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 4 1 0 0 41 2 0 0] 98 2 8208 9152 1584 0 27 524806 ##(Smalltalk.Fraction)  1041 1575 410 8 ##(Smalltalk.ReferenceView)  98 14 0 8000 98 2 8 1140850688 131073 9824 0 0 0 5 0 0 0 9824 1180166 ##(Smalltalk.ResourceIdentifier)  8 ##(Smalltalk.SmaCCRewritePresenter)  8 #resource_Default_view 0 1362 202 208 98 1 1426 1456 98 2 754 539 1 754 1055 1107 9824 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 13 1 0 0 0 0 0 0 28 3 0 0 41 2 0 0] 1344 1584 0 27 9794 2109 1575 32 234 256 98 4 9824 8 'rewriteEditor' 410 8 ##(Smalltalk.Splitter)  98 12 0 8000 98 2 8 1140850688 1 10176 0 8274 31 0 517 0 0 0 10176 1362 202 208 98 1 1426 1456 98 2 754 521 1 754 19 1107 10176 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 4 1 0 0 0 0 0 0 13 1 0 0 41 2 0 0] 98 0 1584 0 27 8 'Splitter' 0 1362 202 208 98 1 1426 1456 98 2 754 9 49 754 1593 1107 8000 1522 8 #[44 0 0 0 0 0 0 0 0 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 4 0 0 0 24 0 0 0 32 3 0 0 65 2 0 0] 98 3 8128 10176 9824 1584 0 27 1778 8 'Result' 410 1840 98 15 0 1600 98 2 8 1409286144 131073 10640 0 0 0 5 0 0 0 10640 8066 234 240 98 2 410 1840 98 15 0 10640 98 2 8 1140850688 131073 10752 0 0 0 5 0 0 0 10752 8066 234 240 1344 32 234 256 1344 0 1362 202 208 98 1 1426 1456 98 2 754 1 1 754 1593 725 10752 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 28 3 0 0 106 1 0 0] 98 3 410 1840 98 15 0 10752 98 2 8 1140850688 131073 11024 0 0 0 5 0 0 0 11024 530 1 1 410 5184 98 16 0 11024 98 2 8 1140850944 1 11104 0 0 0 5 0 0 0 11104 0 8 4294902493 4770 0 0 0 1362 202 208 98 2 1426 1456 98 2 754 1 1 754 787 39 11104 1426 3232 98 1 8 'Input:' 11104 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 137 1 0 0 19 0 0 0] 98 0 1584 0 27 0 0 0 410 8 ##(Smalltalk.ScintillaView)  98 46 0 11024 98 2 8 1176571972 1025 11408 6418 0 32 1002 2096 8 #equality 0 482 8 4278190080 0 5 5682 0 16 98 1 5730 1 3890 8 #find 8 'Find' 9357 1 0 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 11408 0 8 4294902443 4770 0 0 11 0 234 256 98 2 8 #normal 1182726 ##(Smalltalk.ScintillaTextStyle)  1 0 0 1 0 0 0 0 11744 0 0 0 98 40 11776 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1245510 1 ##(Smalltalk.NullScintillaStyler)  11744 234 256 98 2 8 #default 1639942 ##(Smalltalk.ScintillaMarkerDefinition)  1 1 786694 ##(Smalltalk.IndexedColor)  33554433 11922 33554471 11408 8 #circle 202 208 1344 0 63 0 0 0 0 0 11922 33554447 0 0 0 0 0 0 8 '' 3 234 256 98 2 8 #container 11712 0 0 0 0 1 0 0 1362 202 208 98 9 1426 1456 98 2 754 1 39 754 787 687 11408 1426 6192 98 1 11568 11408 1426 4928 98 1 4962 3 1 3 11408 1426 5008 98 1 32 11408 1426 8 #modificationEventMask: 98 1 9215 11408 1426 8 #indicatorDefinitions: 98 1 98 3 1836038 ##(Smalltalk.ScintillaIndicatorDefinition)  1 11408 65025 3 12418 3 11408 33423361 5 12418 5 11408 511 1 11408 1426 8 #margins: 98 1 98 3 984582 ##(Smalltalk.ScintillaMargin)  1 11408 1 3 32 1 12546 3 11408 33 1 16 67108863 12546 5 11408 1 1 16 -67108863 11408 1426 8 #tabIndents: 98 1 16 11408 1426 8 #tabWidth: 98 1 9 11408 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 19 0 0 0 137 1 0 0 106 1 0 0] 98 0 1584 0 27 234 256 98 2 11408 8 'input' 0 1362 202 208 98 1 1426 1456 98 2 754 1 1 754 787 725 11024 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 137 1 0 0 106 1 0 0] 98 2 11104 11408 1584 0 27 410 10192 98 12 0 10752 98 2 8 1140850688 1 12960 0 8274 31 0 517 0 0 0 12960 1362 202 208 98 1 1426 1456 98 2 754 787 1 754 19 725 12960 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 137 1 0 0 0 0 0 0 146 1 0 0 106 1 0 0] 98 0 1584 0 27 410 1840 98 15 0 10752 98 2 8 1140850688 131073 13200 0 0 0 5 0 0 0 13200 530 1 1 410 5184 98 16 0 13200 98 2 8 1140850944 1 13280 0 0 0 5 0 0 0 13280 0 8 4294902493 4770 0 0 0 1362 202 208 98 2 1426 1456 98 2 754 1 1 754 789 39 13280 1426 3232 98 1 8 'Output:' 13280 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 138 1 0 0 19 0 0 0] 98 0 1584 0 27 0 0 0 410 11424 98 46 0 13200 98 2 8 1176571972 1025 13584 6418 0 32 11504 0 482 11552 0 5 5682 0 16 98 2 5730 1 3890 11632 8 'Find' 9357 1 0 0 0 5730 1 3890 8 #findReplace 8 'Replace' 9361 1 0 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 13584 0 8 4294902443 4770 0 0 11 0 234 256 98 2 11744 11762 1 0 0 1 0 0 0 0 11744 0 0 0 98 40 13904 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 11810 11744 234 256 98 2 11872 11890 1 1 11936 11952 13584 11968 202 208 1344 0 63 0 0 0 0 0 12000 0 0 0 0 0 0 8 '' 3 234 256 98 2 12064 13872 0 0 0 0 1 0 0 1362 202 208 98 9 1426 1456 98 2 754 1 39 754 789 687 13584 1426 6192 98 1 13680 13584 1426 4928 98 1 4962 3 1 3 13584 1426 5008 98 1 32 13584 1426 12320 98 1 9215 13584 1426 12368 98 1 98 3 12418 1 13584 65025 3 12418 3 13584 33423361 5 12418 5 13584 511 1 13584 1426 12496 98 1 98 3 12546 1 13584 1 3 32 1 12546 3 13584 33 1 16 67108863 12546 5 13584 1 1 16 -67108863 13584 1426 12624 98 1 16 13584 1426 12672 98 1 9 13584 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 19 0 0 0 138 1 0 0 106 1 0 0] 98 0 1584 0 27 234 256 98 2 13584 8 'output' 0 1362 202 208 98 1 1426 1456 98 2 754 805 1 754 789 725 13200 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 146 1 0 0 0 0 0 0 28 3 0 0 106 1 0 0] 98 2 13280 13584 1584 0 27 1584 0 27 5 16 234 256 98 2 410 8 ##(Smalltalk.SlideyInneyOuteyThing)  98 23 0 10640 98 2 8 1409286144 131073 14864 0 482 8 4278190080 0 517 0 0 0 14864 1714 202 208 98 1 1778 8 'Rewrites' 410 1968 98 30 0 410 8 ##(Smalltalk.SlidingCardTray)  98 22 0 14864 98 2 8 1140850688 131073 15088 0 482 14960 0 5 0 0 0 15088 14976 234 256 98 2 15056 8 'resultRewrites' 0 410 8 ##(Smalltalk.TabViewXP)  98 28 0 14864 98 2 8 1140916738 1 15232 2034 202 208 98 1 15040 0 2080 482 14960 0 1 0 0 0 15232 0 8 4294902511 8 ##(Smalltalk.BasicListAbstract)  2208 1008 0 0 0 0 0 8 #noIcons 0 0 0 0 0 1362 202 208 98 3 1426 1456 98 2 754 1 1 754 1593 365 15232 1426 8 #selectionByIndex:ifAbsent: 98 2 3 1426 8 #yourself 1344 0 15232 1426 8 #tcmSetExtendedStyle:dwExStyle: 98 2 -1 1 15232 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 28 3 0 0 182 0 0 0] 98 0 1584 0 27 0 14864 754 33 33 1049862 ##(Smalltalk.ButtonInteractor)  15088 0 590342 ##(Smalltalk.Rectangle)  754 1541 3 754 1573 35 1 3890 8 #togglePin 8 'Pin or Unpin the tray' 1 1 0 0 0 1362 202 208 98 1 1426 1456 98 2 754 9 9 754 1577 309 15088 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 4 0 0 0 4 0 0 0 24 3 0 0 158 0 0 0] 98 1 15056 1584 0 27 98 2 8 1140920397 1025 15056 2034 202 208 1344 0 2080 482 8 4278190080 0 5 5682 0 16 98 2 5730 1 3890 8 #gotoRewrite 8 'Goto Rewrite' 1025 1 0 0 0 5730 1 3890 8 #debugRewrite 8 'Debug' 1 1 0 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 15056 0 8 4294902503 866 896 98 0 2208 1008 0 0 0 0 0 0 202 208 98 3 2258 8 'Rewrite' 523 2304 866 8 #rewrite 98 0 1122 0 0 2386 3 1 1120 8 'doIt' 8 '[:a :b | a rewrite displayString < b rewrite displayString]' 8 #[31 105 226 0 159 226 32 159 128 106] 16432 896 16464 7 513 0 0 0 15056 0 3 0 0 2258 8 'Node' 525 2304 866 8 #nodeClass 16448 1122 0 0 2386 3 1 1120 8 'doIt' 8 '[:a :b | a nodeClass name < b nodeClass name]' 8 #[31 105 226 0 159 226 32 159 128 106] 16592 8 #name 16608 7 513 0 0 0 15056 0 3 0 0 2258 8 'Location' 523 2304 866 8 #nodeInterval 98 0 1122 0 0 2386 4 1 1120 8 'doIt' 8 '[:a :b | a nodeInterval start < b nodeInterval start or: [a nodeInterval start = b nodeInterval  start and: [a nodeInterval stop > b nodeInterval  stop]]]' 8 #[32 105 226 0 159 226 32 159 128 119 58 106 226 0 159 226 32 159 132 125 226 0 160 226 32 160 129 106 59 106] 16752 8 #start 8 #stop 16784 7 513 0 0 0 15056 0 3 0 0 3088 1344 0 131169 0 0 1362 202 208 98 3 1426 1456 98 2 754 1 37 754 1577 273 15056 1426 6192 98 1 16128 15056 1426 3232 98 1 8 'Rewrite' 15056 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 18 0 0 0 20 3 0 0 154 0 0 0] 98 0 1584 0 27 15056 234 256 1344 0 15232 15088 754 201 201 401 1 31 0 0 1362 202 208 98 1 1426 1456 98 2 754 1 743 754 1593 365 14864 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 115 1 0 0 28 3 0 0 41 2 0 0] 98 2 15088 15232 1584 0 27 8 'slidey' 0 1362 202 208 98 1 1426 1456 98 2 754 9 49 754 1593 1107 10640 1522 8 #[44 0 0 0 0 0 0 0 0 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 4 0 0 0 24 0 0 0 32 3 0 0 65 2 0 0] 98 3 10752 410 10192 98 12 0 10640 98 2 8 1140850688 1 17504 0 482 8 4278190080 0 517 0 0 0 17504 1362 202 208 98 1 1426 1456 98 2 754 1 725 754 1593 19 17504 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 106 1 0 0 28 3 0 0 115 1 0 0] 98 0 1584 0 27 14864 1584 0 27 1824 234 256 98 6 10640 8 'outputTab' 8000 8 'rewriteFileEditor' 1824 8 'configurationTab' 0 410 15248 98 28 0 1600 98 2 8 1140916736 1 17840 2034 202 208 98 3 1808 7984 10624 0 2080 1680 0 1 0 0 0 17840 0 8 4294902511 1122 0 0 1154 2 3 8 ##(Smalltalk.ListControlView)  8 #defaultGetTextBlock 575230339 8 #[30 105 226 0 106] 896 17968 7 257 0 1122 0 0 1154 2 3 2208 1184 579598755 8 #[30 105 226 0 106] 1216 18048 7 257 0 1008 0 0 0 0 0 15408 0 0 0 0 0 1362 202 208 98 3 1426 1456 98 2 754 1 1 754 1609 1163 17840 1426 15552 98 2 3 15584 17840 1426 15632 98 2 -1 1 17840 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 36 3 0 0 69 2 0 0] 98 0 1584 0 27 1362 202 208 98 1 1426 1456 98 2 754 1 1 754 1609 1163 1600 1522 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 36 3 0 0 69 2 0 0] 98 4 1824 8000 10640 17840 1584 0 27 234 256 98 4 1600 8 'tabs' 560 8 'status' 0 461638 4 ##(Smalltalk.MenuBar)  0 16 98 3 5682 0 16 98 9 5730 1 3890 8 #openConfiguration 8 '&Open Configuration' 9375 1 0 0 0 5730 1 3890 8 #saveConfiguration 8 'Save Configuration' 9383 1 0 0 0 983366 1 ##(Smalltalk.DividerMenuItem)  4097 5730 1 3890 8 #openRewrites 8 'Open Rewrites' 1025 1 0 0 0 5730 1 3890 8 #saveRewrites 8 'Save Rewrites' 1025 1 0 0 0 18754 4097 5730 1 3890 8 #newWindow 8 'New &Window' 1 1 0 0 0 18754 4097 5730 1 3890 8 #exit 8 'E&xit' 17639 1 0 0 0 8 '&File' 0 134217729 0 0 32753 0 0 5682 0 16 98 4 5730 1 3890 8 #findText 8 '&Find' 9357 1 0 0 0 5730 1 3890 8 #replaceText 8 '&Replace' 9361 1 0 0 0 18754 4097 5730 1 3890 8 #formatText 8 'F&ormat' 9385 1 0 0 0 8 '&Edit' 0 134217729 0 0 32761 0 0 5682 0 16 98 17 5730 1 3890 8 #setInputParser 8 'Input Parser...' 1025 1 0 0 0 5730 1 3890 8 #setValidationParser 8 'Validation Parser...' 1025 1 0 0 0 18754 4097 5730 1 3890 8 #setServer 8 'Set Se&rver ()...' 1 1 0 0 0 18754 4097 5730 1 3890 8 #toggleUseServer 8 '&Use Server' 1025 1 0 0 0 18754 4097 5730 1 3890 5776 8 'Transform &All' 13477 1 0 0 0 5730 1 3890 5840 8 'Transform Re&maining' 1025 1 0 0 0 5730 1 3890 5904 8 'Transform &Selected' 9381 1 0 0 0 5730 1 3890 5968 8 'Transform All With &Errors Or Warnings' 1025 1 0 0 0 18754 4097 5730 1 3890 8 #viewFile 8 'View Input File' 1 1 0 0 0 18754 4097 5730 1 3890 8 #exportResults 8 'Export Results...' 1 1 0 0 0 18754 4097 5730 1 3890 8 #selectErrorFiles 8 'Select all files from errors' 1025 1 0 0 0 8 '&Transform' 0 134217729 0 0 32785 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 0 1 0 0 0 0 1 0 0 1362 202 208 98 3 1426 1456 98 2 754 2879 21 754 1641 1321 416 1426 3232 98 1 8 'SmaCC Transformation Toolkit' 416 1426 8 #updateMenuBar 1344 416 1522 8 #[44 0 0 0 0 0 0 0 0 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 159 5 0 0 10 0 0 0 211 8 0 0 158 2 0 0] 98 2 1600 560 1584 0 27 )!

toolsFolderIcon
	^(Smalltalk at: #SmalltalkSystemIcon)
		icon: self icon
		description: 'SmaCC Transformation Toolkit'
		openBlock: [:folder :item | self show]! !
!SmaCCTransformationToolkit class categoriesFor: #cTextStyle!public! !
!SmaCCTransformationToolkit class categoriesFor: #defaultModel!public! !
!SmaCCTransformationToolkit class categoriesFor: #pascalTextStyle!public! !
!SmaCCTransformationToolkit class categoriesFor: #resource_Default_view!public!resources-views! !
!SmaCCTransformationToolkit class categoriesFor: #toolsFolderIcon!public! !

SmaCCRewriteComponentPresenter guid: (GUID fromString: '{D54DDA05-7662-409E-A3AC-3069987C92A7}')!
SmaCCRewriteComponentPresenter comment: ''!
!SmaCCRewriteComponentPresenter categoriesForClass!Unclassified! !
!SmaCCRewriteComponentPresenter methodsFor!

attribute
	self subclassResponsibility!

buildPreviousCopies
	previousCopies := Dictionary new!

changedType
	| type |
	self removeEditorComponents.
	type := (self presenterNamed: 'type') value.
	self value notNil ifTrue: [previousCopies at: self value class put: self value copy].
	type ~= self modelType
		ifTrue:
			[previousCopies
				keysAndValuesDo:
					[:key :value | 
					key type = type
						ifTrue:
							[| new |
							new := value copy.
							self parentPresenter value perform: self attribute with: new.
							self value: new]]].
	self perform: ('changedTypeTo' , (type ifNil: ['None'])) asSymbol!

changedTypeToNone
	!

createComponents
	super createComponents.
	self
		add: self newTypePresenter name: 'type';
		add: Presenter new name: 'editor'.
	self buildPreviousCopies!

createDropDownOnModel: aModel items: aCollection
	| presenter |
	presenter := ChoicePresenter
		create: 'Drop down list'
		in: self editorPresenter
		on: aModel.
	presenter choices: aCollection.
	(presenter view)
		position: Point zero;
		extent: self editorView extent x @ 25;
		isManaged: false;
		isTabStop: true;
		isGroupStop: false.
	self editorView layoutManager north: presenter view!

createSchematicWiring
	super createSchematicWiring.
	(self presenterNamed: 'type')
		when: #valueChanged
		send: #changedType
		to: self!

createScintillaViewOnModel: aModel
	| presenter |
	presenter := TextPresenter
		create: 'Scintilla view'
		in: self editorPresenter
		on: aModel.
	(presenter view)
		position: Point zero;
		extent: self editorView extent;
		isManaged: false;
		isTabStop: true;
		isGroupStop: false.
	self editorView layoutManager center: presenter view.
	^presenter!

editorPresenter
	^self presenterNamed: 'editor'!

editorView
	^self editorPresenter view!

modelType
	^self value ifNotNil: [:match | match type]!

newTypePresenter
	self subclassResponsibility!

onValueChanged
	| matchType |
	super onValueChanged.
	matchType := self modelType.
	(self presenterNamed: 'type') value: matchType.
	self editorPresenter allSubPresentersDo: [:each | (each respondsTo: #onValueChanged) ifTrue: [each onValueChanged]]!

removeEditorComponents
	self editorPresenter subPresenters copy do: [:each | self editorPresenter remove: each].
	#(#north: #east: #south: #west: #center:) do: [:each | self editorView layoutManager perform: each with: nil]!

rewriteTextStyles
	| answer |
	answer := ScintillaView defaultTextStyles.
	answer
		add:
				((ScintillaTextStyle name: #text)
						id: 1;
						forecolor: (Color fromHTMLSpec: '#000000');
						isBold: true;
						yourself);
		add:
				((ScintillaTextStyle name: #pattern)
						id: 2;
						forecolor: (Color fromHTMLSpec: '#0000FF');
						isBold: true;
						yourself);
		add:
				((ScintillaTextStyle name: #error)
						id: 3;
						forecolor: (Color fromHTMLSpec: '#FF0000');
						isBold: true;
						yourself).
	^answer!

smalltalkTextStyles
	^ScintillaView smalltalkTextStyles! !
!SmaCCRewriteComponentPresenter categoriesFor: #attribute!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #buildPreviousCopies!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #changedType!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #changedTypeToNone!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #createComponents!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #createDropDownOnModel:items:!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #createSchematicWiring!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #createScintillaViewOnModel:!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #editorPresenter!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #editorView!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #modelType!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #newTypePresenter!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #onValueChanged!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #removeEditorComponents!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #rewriteTextStyles!public! !
!SmaCCRewriteComponentPresenter categoriesFor: #smalltalkTextStyles!public! !

!SmaCCRewriteComponentPresenter class methodsFor!

resource_Default_view
	"Answer the literal data from which the 'Default view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Default_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ContainerView)  98 15 0 0 98 2 8 1409286144 131073 416 0 721158 ##(Smalltalk.SystemColor)  31 0 5 0 0 0 416 852230 ##(Smalltalk.FramingLayout)  234 240 98 4 410 432 98 15 0 416 98 2 8 1140850688 131073 592 0 498 31 0 5 0 0 0 592 788230 ##(Smalltalk.BorderLayout)  1 5 0 0 0 0 0 234 256 98 0 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 1 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 328198 ##(Smalltalk.Point)  1 51 866 701 441 592 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 25 0 0 0 94 1 0 0 245 0 0 0] 98 0 866 193 193 0 27 1181766 2 ##(Smalltalk.FramingConstraints)  1114638 ##(Smalltalk.STBSingletonProxy)  8 ##(Smalltalk.FramingCalculation)  8 #fixedParentLeft 1 1034 1056 8 #fixedParentRight 1 1034 1056 8 #fixedPreviousBottom 5 1034 1056 8 #fixedParentBottom 1 410 8 ##(Smalltalk.ComboBox)  98 17 0 416 98 2 8 1412498947 1025 1184 590662 2 ##(Smalltalk.ListModel)  202 208 720 0 1034 8 ##(Smalltalk.SearchPolicy)  8 #identity 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 5 0 0 0 1184 0 8 4294903757 459270 ##(Smalltalk.Message)  8 #displayString 98 0 720 401 738 202 208 98 1 802 832 98 2 866 1 1 866 301 47 1184 914 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 150 0 0 0 23 0 0 0] 98 0 976 0 27 994 1040 1 1034 1056 8 #fixedViewLeft 301 1034 1056 8 #fixedParentTop 1 1034 1056 8 #fixedViewTop 47 234 256 98 4 592 8 'editor' 1184 8 'type' 0 738 202 208 98 1 802 832 98 2 866 2879 21 866 701 491 416 914 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 159 5 0 0 10 0 0 0 253 6 0 0 255 0 0 0] 98 2 1184 592 976 0 27 )! !
!SmaCCRewriteComponentPresenter class categoriesFor: #resource_Default_view!public!resources-views! !

SmaCCRewritePresenter guid: (GUID fromString: '{5300D1D4-1D3A-42F7-84F8-4940A2D828BC}')!
SmaCCRewritePresenter comment: ''!
!SmaCCRewritePresenter categoriesForClass!MVP-Presenters! !
!SmaCCRewritePresenter methodsFor!

commentViews
	^#('commentLabel' 'comment')!

createComponents
	| presenter |
	super createComponents.
	self add: TextPresenter new name: 'comment'.
	self add: SmaCCRewriteMatchPresenter new name: 'matchEditor'.
	self add: SmaCCTransformationPresenter new name: 'transformationEditor'.
	parserModel := ValueHolderAspectAdaptor subject: self model aspect: #parserClass.
	presenter := ChoicePresenter on: parserModel.
	presenter choices: (SmaCCParser allSubclasses asSortedCollection: [:a :b | a name < b name]).
	self add: presenter name: 'parser'!

model: anObject
	parserModel subject: anObject.
	super model: anObject!

onValueChanged
	| rewrite |
	super onValueChanged.
	rewrite := self value.
	rewrite isNil ifTrue: [^self view hide].
	self view show.
	(rewrite isKindOf: SmaCCRewriteFile) ifTrue: [self showRewriteFile: rewrite] ifFalse: [self showRewriteRule: rewrite]!

onViewAvailable
	self view hide.
	^super onViewAvailable!

showRewriteFile: rewrite
	(self view viewNamed: 'rewritePanel') hide.
	(self view viewNamed: 'filePanel') show.
	self commentViews do: [:each | (self view viewNamed: each) hide]!

showRewriteRule: rewrite
	| transformation match |
	(self view viewNamed: 'filePanel') hide.
	(self view viewNamed: 'rewritePanel') show.
	self commentViews do: [:each | (self view viewNamed: each) show].
	match := rewrite match.
	transformation := rewrite transformation.
	(self presenterNamed: 'matchEditor') value: match.
	(self presenterNamed: 'transformationEditor') value: transformation.
	(self presenterNamed: 'comment') model: (ValueHolderAspectAdaptor subject: self model aspect: #comment).
	self view invalidate! !
!SmaCCRewritePresenter categoriesFor: #commentViews!public! !
!SmaCCRewritePresenter categoriesFor: #createComponents!public! !
!SmaCCRewritePresenter categoriesFor: #model:!public! !
!SmaCCRewritePresenter categoriesFor: #onValueChanged!public! !
!SmaCCRewritePresenter categoriesFor: #onViewAvailable!public! !
!SmaCCRewritePresenter categoriesFor: #showRewriteFile:!public! !
!SmaCCRewritePresenter categoriesFor: #showRewriteRule:!public! !

!SmaCCRewritePresenter class methodsFor!

resource_Default_view
	"Answer the literal data from which the 'Default view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Default_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ContainerView)  98 15 0 0 98 2 8 1409286144 131073 416 0 721158 ##(Smalltalk.SystemColor)  31 0 5 0 0 0 416 852230 ##(Smalltalk.FramingLayout)  234 240 98 8 410 432 98 15 0 416 98 2 8 1140850688 131073 592 0 0 0 5 0 0 0 592 1180166 ##(Smalltalk.ProportionalLayout)  234 240 98 0 16 234 256 98 4 410 8 ##(Smalltalk.ReferenceView)  98 14 0 592 98 2 8 1140850688 131073 752 0 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 5 0 0 0 752 1180166 ##(Smalltalk.ResourceIdentifier)  8 ##(Smalltalk.SmaCCRewriteMatchPresenter)  8 #resource_Default_view 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 1 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 328198 ##(Smalltalk.Point)  1 1 1074 771 253 752 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 129 1 0 0 126 0 0 0] 704 1074 193 193 0 27 8 'matchEditor' 410 768 98 14 0 592 98 2 8 1140850688 131073 1200 0 834 864 0 5 0 0 0 1200 882 8 ##(Smalltalk.SmaCCTransformationPresenter)  928 0 946 202 208 98 1 1010 1040 98 2 1074 1 271 1074 771 255 1200 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 135 0 0 0 129 1 0 0 6 1 0 0] 704 1168 0 27 8 'transformationEditor' 0 946 202 208 98 1 1010 1040 98 2 1074 1 47 1074 771 525 592 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 23 0 0 0 129 1 0 0 29 1 0 0] 98 3 752 410 8 ##(Smalltalk.Splitter)  98 12 0 592 98 2 8 1140850688 1 1632 0 498 31 0 517 0 0 0 1632 946 202 208 98 1 1010 1040 98 2 1074 1 253 1074 771 19 1632 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 126 0 0 0 129 1 0 0 135 0 0 0] 98 0 1168 0 27 1200 1168 0 27 1181766 2 ##(Smalltalk.FramingConstraints)  1114638 ##(Smalltalk.STBSingletonProxy)  8 ##(Smalltalk.FramingCalculation)  8 #fixedParentLeft 1 1930 1952 8 #fixedParentRight 1 1930 1952 8 #fixedPreviousBottom 9 1930 1952 8 #fixedParentBottom 1 410 432 98 15 0 416 98 2 8 1140850688 131073 2080 0 0 0 5 0 0 0 2080 530 234 240 98 4 410 8 ##(Smalltalk.ComboBox)  98 17 0 2080 98 2 8 1412498947 1025 2192 590662 2 ##(Smalltalk.ListModel)  202 208 704 0 1930 8 ##(Smalltalk.SearchPolicy)  8 #identity 834 8 4278190080 0 5 0 0 0 2192 0 8 4294903343 459270 ##(Smalltalk.Message)  8 #displayString 98 0 704 401 946 202 208 98 1 1010 1040 98 2 1074 121 7 1074 651 47 2192 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 60 0 0 0 3 0 0 0 129 1 0 0 26 0 0 0] 98 0 1168 0 27 1890 1930 1952 8 #fixedPreviousRight 1 1984 1 1930 1952 8 #fixedPreviousTop -3 1930 1952 8 #fixedViewTop 47 410 8 ##(Smalltalk.StaticText)  98 16 0 2080 98 2 8 1140850944 1 2752 0 0 0 5 0 0 0 2752 0 8 4294903309 852486 ##(Smalltalk.NullConverter)  0 0 0 946 202 208 98 2 1010 1040 98 2 1074 1 11 1074 121 39 2752 1010 8 #text: 98 1 8 'Parser:' 2752 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 5 0 0 0 60 0 0 0 24 0 0 0] 98 0 1168 0 27 1890 1936 1 1930 1952 8 #fixedViewLeft 121 1930 1952 8 #fixedParentTop 11 2720 39 234 256 98 2 2192 8 'parser' 0 946 202 208 98 1 1010 1040 98 2 1074 1 1 1074 771 571 2080 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 129 1 0 0 29 1 0 0] 98 2 2752 2192 1168 0 27 1890 1936 1 1984 1 3152 1 2048 1 410 8 ##(Smalltalk.TextEdit)  98 16 0 416 98 2 8 1140916352 1025 3408 0 834 8 4278190080 0 5 0 0 0 3408 0 8 4294903287 2850 0 0 1 946 202 208 98 3 1010 1040 98 2 1074 121 1 1074 651 39 3408 1010 8 #selectionRange: 98 1 525062 ##(Smalltalk.Interval)  3 1 3 3408 1010 8 #isTextModified: 98 1 32 3408 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 60 0 0 0 0 0 0 0 129 1 0 0 19 0 0 0] 98 0 1168 0 27 1890 2656 1 1984 1 2688 1 2720 39 410 2768 98 16 0 416 98 2 8 1140850944 1 3856 0 0 0 5 0 0 0 3856 0 8 4294903309 2850 0 0 0 946 202 208 98 2 1010 1040 98 2 1074 1 1 1074 121 39 3856 1010 3008 98 1 8 'Comment:' 3856 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 60 0 0 0 19 0 0 0] 98 0 1168 0 27 1890 1936 1 3120 121 3152 1 2720 39 234 256 98 8 592 8 'rewritePanel' 2080 8 'filePanel' 3408 8 'comment' 3856 8 'commentLabel' 0 946 202 208 98 1 1010 1040 98 2 1074 2879 21 1074 771 571 416 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 159 5 0 0 10 0 0 0 32 7 0 0 39 1 0 0] 98 4 3856 3408 592 2080 1168 0 27 )! !
!SmaCCRewritePresenter class categoriesFor: #resource_Default_view!public!resources-views! !

SmaCCRewriteMatchPresenter guid: (GUID fromString: '{D30A600A-DE51-49D9-8968-B83857287E2F}')!
SmaCCRewriteMatchPresenter comment: ''!
!SmaCCRewriteMatchPresenter categoriesForClass!Unclassified! !
!SmaCCRewriteMatchPresenter methodsFor!

attribute
	^#match:!

buildPreviousCopies
	super buildPreviousCopies.
	previousCopies
		at: SmaCCRewriteTreeMatch put: SmaCCRewriteTreeMatch new;
		at: SmaCCRewriteTypeMatch put: (SmaCCRewriteTypeMatch on: SmaCCParseNode)!

changedTypeToTree
	| subView code nodes presenter |
	presenter := Presenter new.
	self editorPresenter add: presenter name: 'tree'.
	subView := self class loadViewResource: 'Tree view' inContext: self editorView.
	self editorView layoutManager center: subView.
	code := TextPresenter on: treeModel.
	presenter add: code name: 'code'.
	nodes := ChoicePresenter on: startingStateModel.
	nodes choices: self parserStartingStates.
	presenter add: nodes name: 'startingState'.
	presenter view: subView.
	(code view)
		textStyles: self rewriteTextStyles;
		styler: SmaCCTransformationExpressionStyler new.
	presenter onViewOpened!

changedTypeToType
	| subView code nodes presenter debug |
	presenter := Presenter new.
	self editorPresenter add: presenter name: 'types'.
	subView := self class loadViewResource: 'Type view' inContext: self editorView.
	self editorView layoutManager center: subView.
	code := TextPresenter on: codeModel.
	presenter add: code name: 'code'.
	nodes := ChoicePresenter on: classModel.
	nodes choices: (SmaCCParseNode withAllSubclasses asSortedCollection: [:a :b | a name < b name]).
	presenter add: nodes name: 'nodes'.
	debug := BooleanPresenter on: debugModel.
	presenter add: debug name: 'debug'.
	presenter view: subView.
	(code view)
		lexer: #smalltalk;
		textStyles: self smalltalkTextStyles.
	presenter onViewOpened!

createComponents
	super createComponents.
	classModel := ValueHolderAspectAdaptor subject: self model aspect: #nodeClass.
	treeModel := ValueHolderAspectAdaptor subject: self model aspect: #source.
	codeModel := ValueHolderAspectAdaptor subject: self model aspect: #code.
	startingStateModel := ValueHolderAspectAdaptor subject: self model aspect: #startingState.
	debugModel := ValueHolderAspectAdaptor subject: self model aspect: #enableDebug!

model: anObject
	classModel subject: anObject.
	treeModel subject: anObject.
	codeModel subject: anObject.
	startingStateModel subject: anObject.
	debugModel subject: anObject.
	super model: anObject!

newTypePresenter
	^(ChoicePresenter new)
		choices: (SmaCCRewriteMatch withAllSubclasses collect: [:each | each type]) asSet asSortedCollection;
		yourself!

parserStartingStates
	self value isNil ifTrue: [^#()].
	^((self value parserClass class allSelectors select: [:each | each beginsWith: 'startingStateFor'])
		collect: [:each | each asString copyFrom: 17 to: each size]) asSortedCollection! !
!SmaCCRewriteMatchPresenter categoriesFor: #attribute!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #buildPreviousCopies!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #changedTypeToTree!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #changedTypeToType!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #createComponents!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #model:!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #newTypePresenter!public! !
!SmaCCRewriteMatchPresenter categoriesFor: #parserStartingStates!public! !

!SmaCCRewriteMatchPresenter class methodsFor!

resource_Tree_view
	"Answer the literal data from which the 'Tree view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Tree_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ContainerView)  98 15 0 0 98 2 8 1409286144 131073 416 0 721158 ##(Smalltalk.SystemColor)  31 0 5 0 0 0 416 788230 ##(Smalltalk.BorderLayout)  1 1 410 432 98 15 0 416 98 2 8 1140850688 131073 560 0 498 31 0 5 0 0 0 560 530 11 5 0 0 0 410 8 ##(Smalltalk.StaticText)  98 16 0 560 98 2 8 1140850944 1 656 0 0 0 5 0 0 0 656 0 8 4294903309 852486 ##(Smalltalk.NullConverter)  0 0 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 2 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 328198 ##(Smalltalk.Point)  1 1 914 81 55 656 850 8 #text: 98 1 8 'State:' 656 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 40 0 0 0 27 0 0 0] 98 0 914 193 193 0 27 410 8 ##(Smalltalk.ComboBox)  98 17 0 560 98 2 8 1412498947 1025 1104 590662 2 ##(Smalltalk.ListModel)  202 208 98 0 0 1114638 ##(Smalltalk.STBSingletonProxy)  8 ##(Smalltalk.SearchPolicy)  8 #identity 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 5 0 0 0 1104 0 8 4294903343 459270 ##(Smalltalk.Message)  8 #displayString 98 0 1232 401 786 202 208 98 1 850 880 98 2 914 91 1 914 611 47 1104 1026 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 45 0 0 0 0 0 0 0 94 1 0 0 23 0 0 0] 98 0 1088 0 27 234 256 98 2 1104 8 'startingState' 0 786 202 208 98 1 850 880 98 2 914 1 1 914 701 55 560 1026 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 94 1 0 0 27 0 0 0] 98 2 656 1104 1088 0 27 0 0 0 410 8 ##(Smalltalk.ScintillaView)  98 46 0 416 98 2 8 1176571972 1025 1808 721990 2 ##(Smalltalk.ValueHolder)  0 32 1258 1280 8 #equality 0 1314 8 4278190080 0 5 0 0 0 1808 0 8 4294902919 754 0 0 9 0 234 256 98 2 8 #normal 1182726 ##(Smalltalk.ScintillaTextStyle)  1 0 0 1 0 0 0 0 2048 0 0 0 98 40 2080 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1245510 1 ##(Smalltalk.NullScintillaStyler)  2048 234 256 98 2 8 #default 1639942 ##(Smalltalk.ScintillaMarkerDefinition)  1 1 786694 ##(Smalltalk.IndexedColor)  33554433 2226 33554471 1808 8 #circle 202 208 1232 0 63 0 0 0 0 0 2226 33554447 0 0 0 0 0 0 8 '' 3 234 256 98 2 8 #container 2016 0 0 0 0 1 0 0 786 202 208 98 8 850 880 98 2 914 1 55 914 701 437 1808 850 8 #selectionRange: 98 1 525062 ##(Smalltalk.Interval)  3 1 3 1808 850 8 #isTextModified: 98 1 32 1808 850 8 #modificationEventMask: 98 1 9215 1808 850 8 #indicatorDefinitions: 98 1 98 3 1836038 ##(Smalltalk.ScintillaIndicatorDefinition)  1 1808 65025 3 2738 3 1808 33423361 5 2738 5 1808 511 1 1808 850 8 #margins: 98 1 98 3 984582 ##(Smalltalk.ScintillaMargin)  1 1808 1 3 32 1 2866 3 1808 33 1 16 67108863 2866 5 1808 1 1 16 -67108863 1808 850 8 #tabIndents: 98 1 16 1808 850 8 #tabWidth: 98 1 9 1808 1026 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 27 0 0 0 94 1 0 0 245 0 0 0] 98 0 1088 0 27 234 256 98 4 1808 8 'code' 560 8 'editor' 0 786 202 208 98 2 850 880 98 2 914 2879 21 914 701 491 416 850 976 98 1 8 'tree' 416 1026 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 159 5 0 0 10 0 0 0 253 6 0 0 255 0 0 0] 98 2 560 1808 1088 0 27 )!

resource_Type_view
	"Answer the literal data from which the 'Type view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Type_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ContainerView)  98 15 0 0 98 2 8 1409286144 131073 416 0 721158 ##(Smalltalk.SystemColor)  31 0 5 0 0 0 416 788230 ##(Smalltalk.BorderLayout)  1 1 410 432 98 15 0 416 98 2 8 1140850688 131073 560 0 498 31 0 5 0 0 0 560 530 11 5 0 0 410 8 ##(Smalltalk.CheckBox)  98 16 0 560 98 2 8 1409363203 1 656 721990 2 ##(Smalltalk.ValueHolder)  0 0 1114638 ##(Smalltalk.STBSingletonProxy)  8 ##(Smalltalk.SearchPolicy)  8 #never 32 0 0 5 0 0 0 656 0 8 4294903007 852486 ##(Smalltalk.NullConverter)  0 0 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 2 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 328198 ##(Smalltalk.Point)  581 1 1010 121 55 656 946 8 #text: 98 1 8 'Debug' 656 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 34 1 0 0 0 0 0 0 94 1 0 0 27 0 0 0] 98 0 1010 193 193 0 27 410 8 ##(Smalltalk.StaticText)  98 16 0 560 98 2 8 1140850944 1 1200 0 0 0 5 0 0 0 1200 0 8 4294903309 850 0 0 0 882 202 208 98 2 946 976 98 2 1010 1 1 1010 81 55 1200 946 1072 98 1 8 'Class:' 1200 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 40 0 0 0 27 0 0 0] 98 0 1184 0 27 410 8 ##(Smalltalk.ComboBox)  98 17 0 560 98 2 8 1412498947 1025 1520 590662 2 ##(Smalltalk.ListModel)  202 208 98 0 0 778 800 8 #identity 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 5 0 0 0 1520 0 8 4294903343 459270 ##(Smalltalk.Message)  8 #displayString 98 0 1648 401 882 202 208 98 1 946 976 98 2 1010 91 1 1010 481 47 1520 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 45 0 0 0 0 0 0 0 29 1 0 0 23 0 0 0] 98 0 1184 0 27 234 256 98 4 656 8 'debug' 1520 8 'nodes' 0 882 202 208 98 1 946 976 98 2 1010 1 1 1010 701 55 560 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 94 1 0 0 27 0 0 0] 98 3 1200 1520 656 1184 0 27 0 0 0 410 8 ##(Smalltalk.ScintillaView)  98 46 0 416 98 2 8 1176571972 1025 2208 738 0 32 778 800 8 #equality 0 1698 8 4278190080 0 5 0 0 0 2208 0 8 4294902919 850 0 0 9 0 234 256 98 2 8 #normal 1182726 ##(Smalltalk.ScintillaTextStyle)  1 0 0 1 0 0 0 0 2432 0 0 0 98 40 2464 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1245510 1 ##(Smalltalk.NullScintillaStyler)  2432 234 256 98 2 8 #default 1639942 ##(Smalltalk.ScintillaMarkerDefinition)  1 1 786694 ##(Smalltalk.IndexedColor)  33554433 2610 33554471 2208 8 #circle 202 208 1648 0 63 0 0 0 0 0 2610 33554447 0 0 0 0 0 0 8 '' 3 234 256 98 2 8 #container 2400 0 0 0 0 1 0 0 882 202 208 98 8 946 976 98 2 1010 1 55 1010 701 437 2208 946 8 #selectionRange: 98 1 525062 ##(Smalltalk.Interval)  3 1 3 2208 946 8 #isTextModified: 98 1 32 2208 946 8 #modificationEventMask: 98 1 9215 2208 946 8 #indicatorDefinitions: 98 1 98 3 1836038 ##(Smalltalk.ScintillaIndicatorDefinition)  1 2208 65025 3 3122 3 2208 33423361 5 3122 5 2208 511 1 2208 946 8 #margins: 98 1 98 3 984582 ##(Smalltalk.ScintillaMargin)  1 2208 1 3 32 1 3250 3 2208 33 1 16 67108863 3250 5 2208 1 1 16 -67108863 2208 946 8 #tabIndents: 98 1 16 2208 946 8 #tabWidth: 98 1 9 2208 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 27 0 0 0 94 1 0 0 245 0 0 0] 98 0 1184 0 27 234 256 98 4 560 8 'editor' 2208 8 'code' 0 882 202 208 98 2 946 976 98 2 1010 2879 21 1010 701 491 416 946 1072 98 1 8 'types' 416 1122 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 159 5 0 0 10 0 0 0 253 6 0 0 255 0 0 0] 98 2 560 2208 1184 0 27 )! !
!SmaCCRewriteMatchPresenter class categoriesFor: #resource_Tree_view!public!resources-views! !
!SmaCCRewriteMatchPresenter class categoriesFor: #resource_Type_view!public!resources-views! !

SmaCCTransformationPresenter guid: (GUID fromString: '{000D79CA-A905-4E43-A568-528ABD7F17E9}')!
SmaCCTransformationPresenter comment: ''!
!SmaCCTransformationPresenter categoriesForClass!Unclassified! !
!SmaCCTransformationPresenter methodsFor!

attribute
	^#transformation:!

buildPreviousCopies
	super buildPreviousCopies.
	previousCopies
		at: SmaCCRewriteCodeTransformation put: (SmaCCRewriteCodeTransformation on: 'self continue');
		at: SmaCCRewriteStringTransformation put: SmaCCRewriteStringTransformation new!

changedTypeToCode
	| presenter |
	presenter := self createScintillaViewOnModel: codeModel.
	(presenter view)
		lexer: #smalltalk;
		textStyles: self smalltalkTextStyles!

changedTypeToString
	| presenter |
	presenter := self createScintillaViewOnModel: stringModel.
	(presenter view)
		textStyles: self rewriteTextStyles;
		styler: SmaCCTransformationExpressionStyler new!

createComponents
	super createComponents.
	codeModel := ValueHolderAspectAdaptor subject: self model aspect: #code.
	stringModel := ValueHolderAspectAdaptor subject: self model aspect: #string!

model: anObject
	stringModel subject: anObject.
	codeModel subject: anObject.
	super model: anObject!

newTypePresenter
	^(ChoicePresenter new)
		choices: (SmaCCRewriteTransformation withAllSubclasses collect: [:each | each type]) asSet asSortedCollection;
		yourself! !
!SmaCCTransformationPresenter categoriesFor: #attribute!public! !
!SmaCCTransformationPresenter categoriesFor: #buildPreviousCopies!public! !
!SmaCCTransformationPresenter categoriesFor: #changedTypeToCode!public! !
!SmaCCTransformationPresenter categoriesFor: #changedTypeToString!public! !
!SmaCCTransformationPresenter categoriesFor: #createComponents!public! !
!SmaCCTransformationPresenter categoriesFor: #model:!public! !
!SmaCCTransformationPresenter categoriesFor: #newTypePresenter!public! !

SmaCCTransformationExpressionStyler guid: (GUID fromString: '{4B6BACF9-C32D-49B6-AD2A-31544672BC6E}')!
SmaCCTransformationExpressionStyler comment: ''!
!SmaCCTransformationExpressionStyler categoriesForClass!Kernel-Objects! !
!SmaCCTransformationExpressionStyler methodsFor!

colorText: aString in: aScintillaView startingAt: aSmallInteger
	| lastIndex nextIndex |
	aScintillaView startStylingFrom: 1.
	lastIndex := 1.
	[lastIndex between: 1 and: aString size]
		whileTrue:
			[nextIndex := aString
				nextIndexOf: $`
				from: lastIndex
				to: aString size.
			nextIndex = 0 ifTrue: [^aScintillaView applyStyle: #text toNext: aString size - lastIndex + 1].
			lastIndex = nextIndex ifFalse: [aScintillaView applyStyle: #text toNext: nextIndex - lastIndex].
			lastIndex := nextIndex.
			nextIndex := aString
				nextIndexOf: $`
				from: lastIndex + 1
				to: aString size.
			nextIndex = 0 ifTrue: [^aScintillaView applyStyle: #error toNext: aString size - lastIndex + 2].
			aScintillaView applyStyle: #pattern toNext: nextIndex - lastIndex + 1.
			lastIndex := nextIndex + 1]! !
!SmaCCTransformationExpressionStyler categoriesFor: #colorText:in:startingAt:!public! !

"Binary Globals"!

