| package |
package := Package name: 'SmaCC Rewrite Engine'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains code that can be used to rewrite items parsed by SmaCC.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #SmaCCAbstractRewrite;
	add: #SmaCCAnnotatedString;
	add: #SmaCCAnnotatedStringInterval;
	add: #SmaCCCodeReplaceExpression;
	add: #SmaCCCompositeReplaceExpression;
	add: #SmaCCNodeReplaceExpression;
	add: #SmaCCReplaceExpression;
	add: #SmaCCReplaceExpressionParser;
	add: #SmaCCReplaceExpressionScanner;
	add: #SmaCCReplaceExpressionVisitor;
	add: #SmaCCRewrite;
	add: #SmaCCRewriteAnnotation;
	add: #SmaCCRewriteCodeTransformation;
	add: #SmaCCRewriteCompleteResult;
	add: #SmaCCRewriteEngine;
	add: #SmaCCRewriteFile;
	add: #SmaCCRewriteLink;
	add: #SmaCCRewriteMatch;
	add: #SmaCCRewriteMatchContext;
	add: #SmaCCRewriteProcessor;
	add: #SmaCCRewriteResult;
	add: #SmaCCRewriteRuleFileParser;
	add: #SmaCCRewriteRuleFileScanner;
	add: #SmaCCRewriteStringTransformation;
	add: #SmaCCRewriteTransformation;
	add: #SmaCCRewriteTreeMatch;
	add: #SmaCCRewriteTypeMatch;
	add: #SmaCCStringReplaceExpression;
	add: #SmaCCTransformationToolkitModel;
	yourself.

package methodNames
	add: #String -> #splitFirstOn:andThen:do:;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\Sockets\Dolphin Sockets';
	add: '..\..\Refactoring Browser\Parser\RBParser';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	add: '..\SmaCC Source Editing\SmaCC Source Editing';
	add: '..\..\..\Object Arts\Dolphin\System\Compiler\Smalltalk Parser';
	yourself).

package!

"Class Definitions"!

Object subclass: #SmaCCRewriteAnnotation
	instanceVariableNames: 'nodeClass nodeInterval rewrite'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteEngine
	instanceVariableNames: 'rewriteRule source newStarts newStops properties methods processedNodes outputDirectory outputFilename'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteLink
	instanceVariableNames: 'rewrite next'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteMatch
	instanceVariableNames: 'rewrite'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteMatchContext
	instanceVariableNames: 'rewriteEngine match nodes strings continuation'
	classVariableNames: 'Continue SilentProperties'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteProcessor
	instanceVariableNames: 'rules parserClass inputDirectory outputDirectory files validationParserClass rewriteEngine baseDirectory'
	classVariableNames: 'Debug HaltBlock'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteResult
	instanceVariableNames: 'filename errorString type startLine startColumn interval transformation'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRewriteTransformation
	instanceVariableNames: 'rewrite'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Model subclass: #SmaCCAbstractRewrite
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Model subclass: #SmaCCTransformationToolkitModel
	instanceVariableNames: 'modified files inputParserClass validationParserClass rewrites outputDirectory server runOnServer createSubdirectories'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCAbstractRewrite subclass: #SmaCCRewrite
	instanceVariableNames: 'comment match transformation engine'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCAbstractRewrite subclass: #SmaCCRewriteFile
	instanceVariableNames: 'filename rewrites parserClass isModified timestamp cachedLists'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNode subclass: #SmaCCReplaceExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReplaceExpression subclass: #SmaCCCodeReplaceExpression
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReplaceExpression subclass: #SmaCCCompositeReplaceExpression
	instanceVariableNames: 'expressions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReplaceExpression subclass: #SmaCCNodeReplaceExpression
	instanceVariableNames: 'beforeWhitespace beforePrefix prefix name postfix afterPostfix afterWhitespace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReplaceExpression subclass: #SmaCCStringReplaceExpression
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNodeVisitor subclass: #SmaCCReplaceExpressionVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParser subclass: #SmaCCReplaceExpressionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParser subclass: #SmaCCRewriteRuleFileParser
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteMatch subclass: #SmaCCRewriteTreeMatch
	instanceVariableNames: 'startingState source trees'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteMatch subclass: #SmaCCRewriteTypeMatch
	instanceVariableNames: 'nodeClass code method enableDebug'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteResult subclass: #SmaCCRewriteCompleteResult
	instanceVariableNames: 'inputSource outputSource transformedString'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteTransformation subclass: #SmaCCRewriteCodeTransformation
	instanceVariableNames: 'code method'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRewriteTransformation subclass: #SmaCCRewriteStringTransformation
	instanceVariableNames: 'string expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #SmaCCReplaceExpressionScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #SmaCCRewriteRuleFileScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'rewriter'!
SmaCCString subclass: #SmaCCAnnotatedString
	instanceVariableNames: 'node rule'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCStringInterval subclass: #SmaCCAnnotatedStringInterval
	instanceVariableNames: 'annotations'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

!String methodsFor!

splitFirstOn: firstCharacter andThen: secondCharacter do: aBlock
	(self subStrings: firstCharacter)
		do:
			[:each | 
			| index |
			index := each indexOf: secondCharacter.
			index ~= 0 ifTrue: [aBlock value: (each copyFrom: 1 to: index - 1) value: (each copyFrom: index + 1 to: each size)]]! !
!String categoriesFor: #splitFirstOn:andThen:do:!public! !

"End of package definition"!

"Source Globals"!

"Classes"!

SmaCCRewriteAnnotation guid: (GUID fromString: '{E9744CBB-633A-401C-8F64-FDB1E1E0606A}')!
SmaCCRewriteAnnotation comment: ''!
!SmaCCRewriteAnnotation categoriesForClass!Kernel-Objects! !
!SmaCCRewriteAnnotation methodsFor!

= anObject
	^self class = anObject class
		and:
			[self nodeClass = anObject nodeClass
				and: [self nodeInterval = anObject nodeInterval and: [self rewrite = anObject rewrite]]]!

hash
	^(nodeClass hash bitXor: nodeInterval hash) bitXor: rewrite hash!

nodeClass
	^nodeClass!

nodeClass: aBehavior
	nodeClass := aBehavior!

nodeInterval
	^nodeInterval!

nodeInterval: anInterval
	nodeInterval := anInterval!

printOn: aStream
	super printOn: aStream.
	aStream
		nextPut: $(;
		print: nodeClass;
		print: nodeInterval;
		nextPutAll: ', ';
		nextPutAll: rewrite displayString;
		nextPut: $)!

rewrite
	^rewrite!

rewrite: aSmaCCRewrite
	rewrite := aSmaCCRewrite! !
!SmaCCRewriteAnnotation categoriesFor: #=!comparing!public! !
!SmaCCRewriteAnnotation categoriesFor: #hash!comparing!public! !
!SmaCCRewriteAnnotation categoriesFor: #nodeClass!accessing!private! !
!SmaCCRewriteAnnotation categoriesFor: #nodeClass:!accessing!private! !
!SmaCCRewriteAnnotation categoriesFor: #nodeInterval!accessing!private! !
!SmaCCRewriteAnnotation categoriesFor: #nodeInterval:!accessing!private! !
!SmaCCRewriteAnnotation categoriesFor: #printOn:!printing!public! !
!SmaCCRewriteAnnotation categoriesFor: #rewrite!accessing!private! !
!SmaCCRewriteAnnotation categoriesFor: #rewrite:!accessing!private! !

!SmaCCRewriteAnnotation class methodsFor!

onNode: aSmaCCParseNode rewrite: aSmaCCRewrite
	^(self new)
		nodeClass: aSmaCCParseNode class;
		nodeInterval: (aSmaCCParseNode startPosition to: aSmaCCParseNode stopPosition);
		rewrite: aSmaCCRewrite;
		yourself! !
!SmaCCRewriteAnnotation class categoriesFor: #onNode:rewrite:!instance creation!public! !

SmaCCRewriteEngine guid: (GUID fromString: '{FDA78A9D-8536-48DF-B2D9-56B22327719F}')!
SmaCCRewriteEngine comment: ''!
!SmaCCRewriteEngine categoriesForClass!Unclassified! !
!SmaCCRewriteEngine methodsFor!

additionalFiles
	^self propertyAt: #additionalFiles ifAbsentPut: [Dictionary new]!

addMethodNamed: aSymbol as: aBlock
	methods at: aSymbol put: aBlock!

addRewrites: aCollection
	aCollection do: [:each | self rewriteRule: each]!

finished
	newStarts := IdentityDictionary new.
	newStops := IdentityDictionary new.
	properties := Dictionary new.
	processedNodes := IdentitySet new!

initialize
	super initialize.
	newStarts := IdentityDictionary new.
	newStops := IdentityDictionary new.
	properties := Dictionary new.
	methods := IdentityDictionary new.
	processedNodes := IdentitySet new!

markAsProcessed: aSmaCCNode
	processedNodes add: aSmaCCNode!

methodNamed: aSymbol
	^methods at: aSymbol ifAbsent: [nil]!

outputDirectory
	^outputDirectory!

outputDirectory: aString
	outputDirectory := aString!

outputFilename
	^outputFilename!

outputFilename: aString
	outputFilename := aString!

processChildrenOf: aSmaCCNode
	^aSmaCCNode nodesDo: [:each | self rewriteNode: each]!

properties
	^properties!

properties: aDictionary
	properties := aDictionary!

propertyAt: aString
	^properties at: aString ifAbsent: [nil]!

propertyAt: aString ifAbsent: aBlock
	^properties at: aString ifAbsent: aBlock!

propertyAt: aString ifAbsentPut: aBlock
	^properties at: aString ifAbsentPut: aBlock!

propertyAt: aString put: anObject
	^properties at: aString put: anObject!

removeProperty: aString
	^properties removeKey: aString ifAbsent: [nil]!

rewrite: aSmaCCParseNode
	self rewriteNode: aSmaCCParseNode.
	^source copyFrom: (self startPositionForNode: aSmaCCParseNode) to: (self stopPositionForNode: aSmaCCParseNode)!

rewriteNode: aSmaCCNode
	(aSmaCCNode isNil or: [processedNodes includes: aSmaCCNode]) ifTrue: [^self].
	self markAsProcessed: aSmaCCNode.
	rewriteRule performOn: aSmaCCNode continuation: [self processChildrenOf: aSmaCCNode]!

rewriteRule
	^rewriteRule!

rewriteRule: aSmaCCAbstractRewrite
	rewriteRule := aSmaCCAbstractRewrite.
	aSmaCCAbstractRewrite engine: self!

rewriteTree: aSmaCCParseNode
	source isNil ifTrue: [source := aSmaCCParseNode completeSource copy].
	^(self rewrite: aSmaCCParseNode) asString!

setPosition: anIndex in: aSequenceableCollection
	| i lastPosition |
	lastPosition := aSequenceableCollection last.
	i := aSequenceableCollection size.
	[i > 0 and: [lastPosition = (aSequenceableCollection at: i)]]
		whileTrue:
			[aSequenceableCollection at: i put: anIndex.
			i := i - 1]!

setStartPositionForNode: aSmaCCParseNode to: anIndex
	| position current |
	current := aSmaCCParseNode.
	position := self startPositionForNode: aSmaCCParseNode.
	[newStarts at: current put: anIndex.
	current := current parent.
	current notNil and: [position = (self startPositionForNode: current)]] whileTrue!

setStopPositionForNode: aSmaCCParseNode to: anIndex
	| position current |
	current := aSmaCCParseNode.
	position := self stopPositionForNode: aSmaCCParseNode.
	[newStops at: current put: anIndex.
	current := current parent.
	current notNil and: [position = (self stopPositionForNode: current)]] whileTrue!

source
	^source!

source: aSmaCCString
	source := aSmaCCString!

startPositionForNode: aSmaCCParseNode
	((aSmaCCParseNode isKindOf: SmaCCParseNode) and: [aSmaCCParseNode parent isNil]) ifTrue: [^source startIndex].
	^newStarts at: aSmaCCParseNode ifAbsent: [aSmaCCParseNode startPosition]!

stopPositionForNode: aSmaCCParseNode
	((aSmaCCParseNode isKindOf: SmaCCParseNode) and: [aSmaCCParseNode parent isNil]) ifTrue: [^source stopIndex].
	^newStops at: aSmaCCParseNode ifAbsent: [aSmaCCParseNode stopPosition]!

updateStartPositionFor: aSmaCCParseNode to: startPosition whenEqualTo: anIndex
	anIndex = (self startPositionForNode: aSmaCCParseNode) ifTrue: [self setStartPositionForNode: aSmaCCParseNode to: startPosition]!

updateStopPositionFor: aSmaCCParseNode to: stopPosition whenEqualTo: anIndex
	anIndex = (self stopPositionForNode: aSmaCCParseNode) ifTrue: [self setStopPositionForNode: aSmaCCParseNode to: stopPosition]! !
!SmaCCRewriteEngine categoriesFor: #additionalFiles!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #addMethodNamed:as:!accessing-methods!public! !
!SmaCCRewriteEngine categoriesFor: #addRewrites:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #finished!private! !
!SmaCCRewriteEngine categoriesFor: #initialize!initialize-release!public! !
!SmaCCRewriteEngine categoriesFor: #markAsProcessed:!private! !
!SmaCCRewriteEngine categoriesFor: #methodNamed:!accessing-methods!public! !
!SmaCCRewriteEngine categoriesFor: #outputDirectory!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #outputDirectory:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #outputFilename!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #outputFilename:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #processChildrenOf:!private! !
!SmaCCRewriteEngine categoriesFor: #properties!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #properties:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #propertyAt:!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #propertyAt:ifAbsent:!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #propertyAt:ifAbsentPut:!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #propertyAt:put:!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #removeProperty:!accessing-properites!private! !
!SmaCCRewriteEngine categoriesFor: #rewrite:!private! !
!SmaCCRewriteEngine categoriesFor: #rewriteNode:!private! !
!SmaCCRewriteEngine categoriesFor: #rewriteRule!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #rewriteRule:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #rewriteTree:!private!rewriting! !
!SmaCCRewriteEngine categoriesFor: #setPosition:in:!private! !
!SmaCCRewriteEngine categoriesFor: #setStartPositionForNode:to:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #setStopPositionForNode:to:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #source!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #source:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #startPositionForNode:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #stopPositionForNode:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #updateStartPositionFor:to:whenEqualTo:!accessing!private! !
!SmaCCRewriteEngine categoriesFor: #updateStopPositionFor:to:whenEqualTo:!accessing!private! !

!SmaCCRewriteEngine class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCRewriteEngine class categoriesFor: #new!instance creation!private! !

SmaCCRewriteLink guid: (GUID fromString: '{88494C53-79DE-4D07-8DC2-0E85F9638358}')!
SmaCCRewriteLink comment: ''!
!SmaCCRewriteLink categoriesForClass!Unclassified! !
!SmaCCRewriteLink methodsFor!

next
	^next!

next: anObject
	next := anObject!

printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: rewrite displayString;
		nextPut: $)!

rewrite
	^rewrite!

rewrite: anObject
	rewrite := anObject! !
!SmaCCRewriteLink categoriesFor: #next!accessing!private! !
!SmaCCRewriteLink categoriesFor: #next:!accessing!private! !
!SmaCCRewriteLink categoriesFor: #printOn:!printing!public! !
!SmaCCRewriteLink categoriesFor: #rewrite!accessing!private! !
!SmaCCRewriteLink categoriesFor: #rewrite:!accessing!private! !

SmaCCRewriteMatch guid: (GUID fromString: '{4F08AAA0-C363-46E6-B13A-6E2AB07A010C}')!
SmaCCRewriteMatch comment: ''!
!SmaCCRewriteMatch categoriesForClass!Unclassified! !
!SmaCCRewriteMatch methodsFor!

canMatch: aClass
	^true!

displayOn: aStream
	self printOn: aStream!

displayString
	| stream |
	stream := WriteStream on: String new.
	self displayOn: stream.
	^stream contents!

match: aSmaCCRewriteMatchContext
	self subclassResponsibility!

modified
	rewrite notNil ifTrue: [rewrite modified]!

parserClass
	^rewrite parserClass!

postCopy
	super postCopy.
	rewrite := nil!

rewrite
	^rewrite!

rewrite: anObject
	rewrite := anObject!

saveOn: aStream
	self subclassResponsibility! !
!SmaCCRewriteMatch categoriesFor: #canMatch:!public!testing! !
!SmaCCRewriteMatch categoriesFor: #displayOn:!printing!public! !
!SmaCCRewriteMatch categoriesFor: #displayString!printing!public! !
!SmaCCRewriteMatch categoriesFor: #match:!matching!private! !
!SmaCCRewriteMatch categoriesFor: #modified!public! !
!SmaCCRewriteMatch categoriesFor: #parserClass!accessing!private! !
!SmaCCRewriteMatch categoriesFor: #postCopy!copying!public! !
!SmaCCRewriteMatch categoriesFor: #rewrite!accessing!private! !
!SmaCCRewriteMatch categoriesFor: #rewrite:!accessing!private! !
!SmaCCRewriteMatch categoriesFor: #saveOn:!public! !

SmaCCRewriteMatchContext guid: (GUID fromString: '{3DFC0653-C47B-4EB0-8EFB-10F7D9C623FD}')!
SmaCCRewriteMatchContext comment: ''!
!SmaCCRewriteMatchContext categoriesForClass!Unclassified! !
!SmaCCRewriteMatchContext methodsFor!

additionalFiles
	^rewriteEngine additionalFiles!

addMethodNamed: aSymbol as: aBlock
	rewriteEngine addMethodNamed: aSymbol as: aBlock!

addNewlineWhitespace: aString to: source
	| outputStream inputStream |
	(aString notNil and: [aString notEmpty]) ifFalse: [^source].
	outputStream := WriteStream on: String new.
	inputStream := ReadStream on: source asString.
	[inputStream atEnd]
		whileFalse:
			[| char endOfLine |
			endOfLine := false.
			char := inputStream next.
			char = Character lf ifTrue: [endOfLine := true].
			char = Character cr
				ifTrue:
					[endOfLine := true.
					inputStream peek = Character lf
						ifTrue:
							[outputStream nextPut: char.
							char := inputStream next]].
			outputStream nextPut: char.
			endOfLine ifTrue: [outputStream nextPutAll: aString]].
	^outputStream contents!

addProperty: aSymbol withValue: anObject
	| property |
	property := anObject.
	self addMethodNamed: aSymbol as: [property].
	self addMethodNamed: (aSymbol , ':') asSymbol as: [:value | property := value]!

characterAt: anIndex
	^self source at: anIndex!

characterAtEndOf: aSmaCCNode
	| index |
	index := self stopIndexFor: aSmaCCNode.
	^self characterAt: ((self source isRemoved: index) ifTrue: [self source previousIndex: index] ifFalse: [index])!

charactersAtAndAfter: startPosition matchesToken: aSmaCCToken
	| string position |
	position := startPosition.
	position isNil ifTrue: [^false].
	string := aSmaCCToken value.
	1
		to: string size
		do:
			[:i | 
			(string at: i) = (self originalSource at: position) ifFalse: [^false].
			position := self nextIndex: position].
	^true!

charactersAtAndBefore: stopPosition matchesToken: aSmaCCToken
	| string position |
	position := stopPosition.
	position isNil ifTrue: [^false].
	string := aSmaCCToken value.
	string size
		to: 1
		do:
			[:i | 
			(string at: i) = (self originalSource at: position) ifFalse: [^false].
			position := self previousIndex: position].
	^true!

computeStringFor: value
	(value isKindOf: Collection)
		ifTrue:
			[| first last |
			first := last := nil.
			value
				do:
					[:each | 
					(each isKindOf: SmaCCParseNode)
						ifTrue:
							[self processChild: each.
							first isNil ifTrue: [first := self startIndexFor: each].
							(self stopIndexFor: each) ifNotNil: [:i | i ~= 0 ifTrue: [last := i]]]
						ifFalse:
							[(each isKindOf: SmaCCToken)
								ifTrue:
									[first isNil ifTrue: [first := value startPosition].
									last := value stopPosition]]].
			(first notNil and: [last notNil]) ifTrue: [^self sourceFrom: first to: last]].
	(value isKindOf: SmaCCParseNode) ifTrue: [^self rewrite: value].
	^(value isKindOf: SmaCCToken) ifTrue: [value value] ifFalse: [value]!

context: aDictionary
	aDictionary
		keysAndValuesDo:
			[:key :value | 
			| cachedString |
			nodes at: key name put: value.
			strings at: key name put: [cachedString ifNil: [cachedString := self computeStringFor: value]]]!

continue
	continuation value!

delete: anObject
	| start stop |
	start := self startIndexFor: anObject.
	stop := self stopIndexFor: anObject.
	self deleteFrom: start to: stop!

deleteAll: aCollection
	aCollection isNil ifTrue: [^self].
	aCollection do: [:each | self delete: each]!

deleteAllWithWhitespaceAfter: aCollection
	aCollection isNil ifTrue: [^self].
	aCollection do: [:each | self deleteWithWhitespaceAfter: each]!

deleteAllWithWhitespaceBefore: aCollection
	aCollection isNil ifTrue: [^self].
	aCollection do: [:each | self deleteWithWhitespaceBefore: each]!

deleteFrom: start to: stop
	| startIndex stopIndex |
	startIndex := self startIndexFor: start.
	stopIndex := self stopIndexFor: stop.
	(startIndex isNil or: [stopIndex isNil]) ifTrue: [^self].
	self source deleteFrom: startIndex to: stopIndex!

deleteWhitespaceAfter: anObject
	| anIndex |
	anIndex := self stopIndexFor: anObject.
	self source deleteWhitespaceAfterIndex: anIndex!

deleteWhitespaceBefore: anObject
	| anIndex |
	anIndex := self startIndexFor: anObject.
	self source deleteWhitespaceBeforeIndex: anIndex!

deleteWithWhitespaceAfter: anObject
	self deleteWhitespaceAfter: anObject.
	self delete: anObject!

deleteWithWhitespaceBefore: anObject
	self deleteWhitespaceBefore: anObject.
	self delete: anObject!

doesNotUnderstand: aMessage
	| method |
	method := rewriteEngine methodNamed: aMessage selector.
	method isNil
		ifTrue:
			[SilentProperties
				ifTrue:
					[aMessage arguments size = 1
						ifTrue:
							[^rewriteEngine
								propertyAt: (aMessage selector copyFrom: 1 to: aMessage selector size - 1) asSymbol
								put: aMessage arguments first].
					aMessage arguments isEmpty ifTrue: [^rewriteEngine propertyAt: aMessage selector ifAbsent: [nil]]].
			^super doesNotUnderstand: aMessage].
	method argumentCount - 1 = aMessage arguments size
		ifTrue: [^method valueWithArguments: (Array with: self) , aMessage arguments].
	^method valueWithArguments: aMessage arguments!

forNode: aSmaCCParseNode rewriter: aSmaCCRewriteEngine continuation: aBlock
	rewriteEngine := aSmaCCRewriteEngine.
	match := aSmaCCParseNode.
	continuation := aBlock.
	nodes := Dictionary new.
	strings := Dictionary new!

hasChild: anObject position: positionSelector
	| position node |
	node := nil.
	(anObject isKindOf: SequenceableCollection)
		ifTrue: [node := positionSelector = #startPosition ifTrue: [anObject first] ifFalse: [anObject last]].
	(anObject isKindOf: SmaCCParseNode) ifTrue: [node := anObject].
	anObject isNil ifTrue: [^false].
	position := node perform: positionSelector.
	node nodesDo: [:child | (child perform: positionSelector) = position ifTrue: [^true]].
	^false!

hasChildAtEndOf: anObject
	^self hasChild: anObject position: #stopPosition!

hasChildAtStartOf: anObject
	^self hasChild: anObject position: #startPosition!

insert: aString after: anObject
	| position endPosition anIndex |
	anIndex := self stopIndexFor: anObject.
	anIndex isNil ifTrue: [^nil].
	position := self source insert: aString at: (self source nextIndex: anIndex).
	position isNil ifTrue: [^nil].
	endPosition := position + (aString size - 1).
	self
		updateStopPositionFor: ((anObject isKindOf: SmaCCParseNode) ifTrue: [anObject] ifFalse: [match])
		to: endPosition
		whenEqualTo: anIndex.
	^position!

insert: aString afterAll: aCollection
	aCollection isNil ifTrue: [^self].
	aCollection do: [:each | self insert: aString after: each]!

insert: aSequenceableCollection around: aNode
	self insert: aSequenceableCollection first before: aNode.
	self insert: aSequenceableCollection last after: aNode!

insert: aString before: anObject
	| position anIndex |
	anIndex := self startIndexFor: anObject.
	anIndex isNil ifTrue: [^nil].
	position := self source insert: aString at: anIndex.
	rewriteEngine
		updateStartPositionFor: ((anObject isKindOf: SmaCCParseNode) ifTrue: [anObject] ifFalse: [match])
		to: position
		whenEqualTo: anIndex.
	^position!

insert: aString beforeAll: aCollection
	aCollection isNil ifTrue: [^self].
	aCollection do: [:each | self insert: aString before: each]!

isAtEndOfParent: anObject
	(anObject isKindOf: Collection) ifTrue: [anObject reverseDo: [:each | ^self isAtEndOfParent: each]].
	^(anObject isKindOf: SmaCCParseNode)
		and: [anObject parent notNil and: [anObject parent stopPosition = anObject stopPosition]]!

isAtStartOfParent: anObject
	(anObject isKindOf: Collection) ifTrue: [anObject do: [:each | ^self isAtStartOfParent: each]].
	^(anObject isKindOf: SmaCCParseNode)
		and: [anObject parent notNil and: [anObject parent startPosition = anObject startPosition]]!

markAllAsProcessed: aCollection
	aCollection do: [:each | self markAsProcessed: each]!

markAsProcessed: aSmaCCParseNode
	rewriteEngine markAsProcessed: aSmaCCParseNode!

match
	^match!

match: anObject
	match := anObject!

move: anObject after: anotherObject
	^self
		move: anObject
		after: anotherObject
		withWhitespace: ''!

move: anObject after: anotherObject withWhitespace: aString
	| start stop oldStop |
	start := self startIndexFor: anObject.
	stop := self stopIndexFor: anObject.
	oldStop := self stopIndexFor: anotherObject.
	self source
		moveFrom: start
		to: stop
		after: oldStop.
	aString notEmpty
		ifTrue:
			[self source
				addNewLineWhitespace: aString
				from: start
				to: stop].
	rewriteEngine
		updateStopPositionFor: ((anotherObject isKindOf: SmaCCParseNode) ifTrue: [anotherObject] ifFalse: [match])
		to: stop
		whenEqualTo: oldStop.
	^self startIndexFor: anotherObject!

move: anObject before: anotherObject
	^self
		move: anObject
		before: anotherObject
		withWhitespace: ''!

move: anObject before: anotherObject withWhitespace: aString
	| start stop oldStart |
	start := self startIndexFor: anObject.
	stop := self stopIndexFor: anObject.
	oldStart := self startIndexFor: anotherObject.
	self source
		moveFrom: start
		to: stop
		before: oldStart.
	aString notEmpty
		ifTrue:
			[self source
				addNewLineWhitespace: aString
				from: start
				to: stop].
	rewriteEngine
		updateStartPositionFor: ((anotherObject isKindOf: SmaCCParseNode) ifTrue: [anotherObject] ifFalse: [match])
		to: start
		whenEqualTo: oldStart.
	^self startIndexFor: anObject!

move: anObject replacing: anotherObject withWhitespace: aString
	| oldStop |
	oldStop := self stopIndexFor: anotherObject.
	self
		move: anObject
		after: anotherObject
		withWhitespace: aString.
	self deleteFrom: (self startIndexFor: anotherObject) to: oldStop.
	^self startIndexFor: anObject!

moveFrom: startIndex to: stopIndex after: anObject
	^self source
		moveFrom: (self startIndexFor: startIndex)
		to: (self stopIndexFor: stopIndex)
		after: (self startIndexFor: anObject)!

moveFrom: startIndex to: stopIndex before: anObject
	^self source
		moveFrom: (self startIndexFor: startIndex)
		to: (self stopIndexFor: stopIndex)
		before: (self startIndexFor: anObject)!

nextIndex: position
	^self originalSource nextIndex: position!

nodeFor: aString
	^nodes at: aString ifAbsent: [nil]!

originalSource
	^match completeSource!

originalStartIndexFor: anObject
	^((anObject isKindOf: SmaCCParseNode) or: [anObject isKindOf: SmaCCToken])
		ifTrue: [anObject startPosition]
		ifFalse: [anObject]!

originalStartPosition: anObject
	(anObject isKindOf: Collection) ifTrue: [anObject do: [:each | ^self originalStartPosition: each]].
	((anObject isKindOf: SmaCCParseNode) or: [anObject isKindOf: SmaCCToken]) ifTrue: [^anObject startPosition].
	^nil!

originalStopPosition: anObject
	(anObject isKindOf: Collection) ifTrue: [anObject reverseDo: [:each | ^self originalStopPosition: each]].
	((anObject isKindOf: SmaCCParseNode) or: [anObject isKindOf: SmaCCToken]) ifTrue: [^anObject stopPosition].
	^nil!

outputDirectory
	^rewriteEngine outputDirectory!

outputDirectory: aString
	^rewriteEngine outputDirectory: aString!

outputFilename
	^rewriteEngine outputFilename!

outputFilename: aString
	^rewriteEngine outputFilename: aString!

parseCsvLine: aString
	| readStream record value |
	aString isEmpty ifTrue: [^nil].
	record := OrderedCollection new.
	readStream := ReadStream on: aString.
	[readStream atEnd]
		whileFalse:
			[readStream peek = $"
				ifTrue:
					[readStream next.
					value := ''.
					[value := value , (readStream upTo: $").
					readStream peek = $"]
						whileTrue:
							[value := value copyWith: $".
							readStream next].
					readStream peekFor: $,.
					record add: value]
				ifFalse: [record add: (readStream upTo: $,)]].
	^record!

parseCsvStream: aStream withHeader: aBoolean
	| array result header line |
	header := nil.
	result := OrderedCollection new.
	[aStream atEnd]
		whileFalse:
			[array := self parseCsvLine: aStream nextLine.
			array notNil
				ifTrue:
					[aBoolean
						ifTrue:
							[header isNil
								ifTrue: [header := array]
								ifFalse:
									[line := Dictionary new.
									1 to: (header size min: array size) do: [:i | line at: (header at: i) put: (array at: i)].
									array size + 1 to: header size do: [:i | line at: (header at: i) put: nil].
									result add: line]]
						ifFalse: [result add: array]]].
	^result!

previousIndex: position
	^self originalSource previousIndex: position!

processChild: aSmaCCParseNode
	rewriteEngine rewriteNode: aSmaCCParseNode!

processChildren
	match nodesDo: [:each | self processChild: each]!

processChildren: aCollection
	aCollection do: [:each | self processChild: each]!

propertyAt: aString
	^rewriteEngine propertyAt: aString!

propertyAt: aString ifAbsent: aBlock
	^rewriteEngine propertyAt: aString ifAbsent: aBlock!

propertyAt: aString ifAbsentPut: aBlock
	^rewriteEngine propertyAt: aString ifAbsentPut: aBlock!

propertyAt: aString put: anObject
	^rewriteEngine propertyAt: aString put: anObject!

removeProperty: aString
	^rewriteEngine removeProperty: aString!

replace: anObject with: aString
	anObject isNil ifTrue: [^self].
	self delete: anObject.
	self insert: aString before: anObject!

replaceAll: aCollection with: aString
	aCollection do: [:each | self replace: each with: aString]!

replaceFrom: startIndex to: stopIndex with: aString
	self insert: aString before: startIndex.
	self deleteFrom: startIndex to: stopIndex!

rewrite: aSmaCCParseNode
	^rewriteEngine rewrite: aSmaCCParseNode!

rewriteEngine
	^rewriteEngine!

rewriteEngine: anObject
	rewriteEngine := anObject!

safe: aBlock
	^aBlock on: (ExceptionSet with: Error with: StackOverflow) do: [:ex | ex return]!

smaccStringClass
	^self source class!

source
	^rewriteEngine source!

sourceFor: anObject
	anObject isNil ifTrue: [^''].
	^(self sourceFrom: (self startIndexFor: anObject) to: (self stopIndexFor: anObject)) asString!

sourceFrom: first to: last
	^(self source copyFrom: (self startIndexFor: first) to: (self stopIndexFor: last)) asString!

startIndexFor: anObject
	^((anObject isKindOf: SmaCCParseNode) or: [anObject isKindOf: SmaCCToken])
		ifTrue: [rewriteEngine startPositionForNode: anObject]
		ifFalse: [anObject]!

startOfLineWhitespaceBefore: anObject
	^self originalSource startOfLineWhitespaceBeforeIndex: (self originalStartIndexFor: anObject)!

stopIndexFor: anObject
	^((anObject isKindOf: SmaCCParseNode) or: [anObject isKindOf: SmaCCToken])
		ifTrue: [rewriteEngine stopPositionForNode: anObject]
		ifFalse: [anObject]!

stringFor: aString
	^(strings at: aString ifAbsent: [['']]) value!

updateStopPositionFor: node to: endPosition whenEqualTo: anIndex
	rewriteEngine
		updateStopPositionFor: node
		to: endPosition
		whenEqualTo: anIndex!

whitespaceAfter: anObject
	^self originalSource whitespaceAfterIndex: (self stopIndexFor: anObject)!

whitespaceBefore: anObject
	^self originalSource whitespaceBeforeIndex: (self originalStartIndexFor: anObject)! !
!SmaCCRewriteMatchContext categoriesFor: #additionalFiles!accessing-properites!public! !
!SmaCCRewriteMatchContext categoriesFor: #addMethodNamed:as:!accessing-methods!public! !
!SmaCCRewriteMatchContext categoriesFor: #addNewlineWhitespace:to:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #addProperty:withValue:!accessing-methods!public! !
!SmaCCRewriteMatchContext categoriesFor: #characterAt:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #characterAtEndOf:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #charactersAtAndAfter:matchesToken:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #charactersAtAndBefore:matchesToken:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #computeStringFor:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #context:!initialize-release!private! !
!SmaCCRewriteMatchContext categoriesFor: #continue!private!processing! !
!SmaCCRewriteMatchContext categoriesFor: #delete:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteAll:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteAllWithWhitespaceAfter:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteAllWithWhitespaceBefore:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteFrom:to:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteWhitespaceAfter:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteWhitespaceBefore:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteWithWhitespaceAfter:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #deleteWithWhitespaceBefore:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #doesNotUnderstand:!accessing-methods!private! !
!SmaCCRewriteMatchContext categoriesFor: #forNode:rewriter:continuation:!initialize-release!private! !
!SmaCCRewriteMatchContext categoriesFor: #hasChild:position:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #hasChildAtEndOf:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #hasChildAtStartOf:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #insert:after:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #insert:afterAll:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #insert:around:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #insert:before:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #insert:beforeAll:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #isAtEndOfParent:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #isAtStartOfParent:!private!testing! !
!SmaCCRewriteMatchContext categoriesFor: #markAllAsProcessed:!processing!public! !
!SmaCCRewriteMatchContext categoriesFor: #markAsProcessed:!processing!public! !
!SmaCCRewriteMatchContext categoriesFor: #match!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #match:!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #move:after:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #move:after:withWhitespace:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #move:before:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #move:before:withWhitespace:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #move:replacing:withWhitespace:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #moveFrom:to:after:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #moveFrom:to:before:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #nextIndex:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #nodeFor:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #originalSource!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #originalStartIndexFor:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #originalStartPosition:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #originalStopPosition:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #outputDirectory!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #outputDirectory:!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #outputFilename!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #outputFilename:!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #parseCsvLine:!parsing!public! !
!SmaCCRewriteMatchContext categoriesFor: #parseCsvStream:withHeader:!parsing!public! !
!SmaCCRewriteMatchContext categoriesFor: #previousIndex:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #processChild:!private!processing! !
!SmaCCRewriteMatchContext categoriesFor: #processChildren!private!processing! !
!SmaCCRewriteMatchContext categoriesFor: #processChildren:!private!processing! !
!SmaCCRewriteMatchContext categoriesFor: #propertyAt:!accessing-properites!private! !
!SmaCCRewriteMatchContext categoriesFor: #propertyAt:ifAbsent:!accessing-properites!private! !
!SmaCCRewriteMatchContext categoriesFor: #propertyAt:ifAbsentPut:!accessing-properites!private! !
!SmaCCRewriteMatchContext categoriesFor: #propertyAt:put:!accessing-properites!private! !
!SmaCCRewriteMatchContext categoriesFor: #removeProperty:!accessing-properites!private! !
!SmaCCRewriteMatchContext categoriesFor: #replace:with:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #replaceAll:with:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #replaceFrom:to:with:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #rewrite:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #rewriteEngine!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #rewriteEngine:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #safe:!accessing!public! !
!SmaCCRewriteMatchContext categoriesFor: #smaccStringClass!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #source!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #sourceFor:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #sourceFrom:to:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #startIndexFor:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #startOfLineWhitespaceBefore:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #stopIndexFor:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #stringFor:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #updateStopPositionFor:to:whenEqualTo:!private!source editing! !
!SmaCCRewriteMatchContext categoriesFor: #whitespaceAfter:!accessing!private! !
!SmaCCRewriteMatchContext categoriesFor: #whitespaceBefore:!accessing!private! !

!SmaCCRewriteMatchContext class methodsFor!

continue
	^Continue!

forNode: aSmaCCParseNode rewriter: aSmaCCRewriteEngine continuation: aBlock
	^(self new)
		forNode: aSmaCCParseNode
			rewriter: aSmaCCRewriteEngine
			continuation: aBlock;
		yourself!

initialize
	Continue := Object new.
	SilentProperties := false!

silentProperties
	^SilentProperties!

silentProperties: anObject
	SilentProperties := anObject! !
!SmaCCRewriteMatchContext class categoriesFor: #continue!accessing!public! !
!SmaCCRewriteMatchContext class categoriesFor: #forNode:rewriter:continuation:!instance creation!private! !
!SmaCCRewriteMatchContext class categoriesFor: #initialize!class initialization!public! !
!SmaCCRewriteMatchContext class categoriesFor: #silentProperties!accessing!private! !
!SmaCCRewriteMatchContext class categoriesFor: #silentProperties:!accessing!private! !

SmaCCRewriteProcessor guid: (GUID fromString: '{9B17937A-26E8-41E4-ACC5-0695DE3C8751}')!
SmaCCRewriteProcessor comment: ''!
!SmaCCRewriteProcessor categoriesForClass!Kernel-Objects! !
!SmaCCRewriteProcessor methodsFor!

baseDirectory
	^baseDirectory ifNil: ['']!

baseDirectory: aString
	baseDirectory := aString!

debug
	^self class debug!

debug: aBoolean
	self class debug: aBoolean!

engine
	rewriteEngine isNil
		ifTrue:
			[rewriteEngine := SmaCCRewriteEngine new.
			rewriteEngine rewriteRule: self rules].
	^rewriteEngine!

extension
	^self parserClass fileExtension!

files
	^files ifNil: [files := self inputFilenames]!

files: aCollection
	files := aCollection!

inputDirectory
	^inputDirectory!

inputDirectory: aString
	inputDirectory := aString!

inputFilenames
	| names |
	names := OrderedCollection new.
	File
		forAll: '*' , self extension
		in: self inputDirectory
		do: [:each | names add: each path].
	^names!

outputDirectory
	^outputDirectory!

outputDirectory: aString
	outputDirectory := aString!

parseFile: aString
	| source |
	source := self sourceFor: aString.
	^self parserClass parse: source!

parserClass
	^parserClass!

parserClass: aSmaCCParserClass
	parserClass := aSmaCCParserClass!

parseRewriteRuleFile: aString
	rules := SmaCCRewriteRuleFileParser parseFile: aString!

processAllNotifying: postBlock
	self files do: [:each | postBlock value: (self processFile: each)]!

processFile: aString
	^self processFile: aString usingResult: SmaCCRewriteResult new!

processFile: aString usingResult: aSmaCCRewriteResult
	| input output tree stream subdirectory fullFilename |
	(Smalltalk includesKey: #Smalltalk) ifFalse: [Smalltalk at: #Smalltalk put: Smalltalk].	"Add Smalltalk back if it got stripped"
	aSmaCCRewriteResult filename: aString.
	[input := self sourceFor: aString.
	aSmaCCRewriteResult inputSource: input.
	stream := SmaCCLineNumberStream on: (ReadStream on: input).
	tree := [self parserClass parseStream: stream]
		on: SmaCCParserError
		do:
			[:ex | 
			| parser token |
			parser := ex tag.
			token := parser errorToken.
			token notNil
				ifTrue:
					[aSmaCCRewriteResult
						startLine: (stream lineNumberFor: token startPosition);
						startColumn: (stream columnNumberFor: token startPosition);
						interval: (token startPosition to: token stopPosition)].
			ex pass].
	tree
		completeSource: input;
		filename: aString.
	subdirectory := self baseDirectory isEmpty
		ifTrue: ['']
		ifFalse: [(File splitPathFrom: aString) copyFrom: self baseDirectory size + 1].
	fullFilename := (self outputDirectory isNil or: [self outputDirectory isEmpty])
		ifTrue: ['']
		ifFalse: [(File appendPathDelimiter: self outputDirectory) , subdirectory].
	(self engine)
		source: (aSmaCCRewriteResult smaccStringClass on: input);
		outputDirectory: fullFilename;
		outputFilename:
				(File splitStemFrom: aString)
						, (self validationParserClass isNil ifTrue: [''] ifFalse: [self validationParserClass fileExtension]).
	output := [self engine rewriteTree: tree]
		on: Error
		do:
			[:ex | 
			| frame node |
			frame := Processor activeProcess topFrame.
			[frame isNil or: [(frame receiver isKindOf: SmaCCRewrite) and: [frame method selector = #performOn:continuation:]]]
				whileFalse: [frame := frame sender].
			frame notNil
				ifTrue:
					[node := frame argAt: 1.
					aSmaCCRewriteResult
						startLine: (stream lineNumberFor: node startPosition);
						startColumn: (stream columnNumberFor: node startPosition);
						interval: (node startPosition to: node stopPosition);
						transformation: frame receiver].
			ex pass].
	aSmaCCRewriteResult
		outputSource: output;
		transformedString: self engine source.
	(self outputDirectory isNil or: [self outputDirectory isEmpty])
		ifFalse:
			[self
				saveOutput: output
				in:
					self engine outputDirectory
						,
							((self engine outputDirectory isEmpty or: [self engine outputDirectory last = File pathDelimiter])
								ifTrue: ['']
								ifFalse: [String with: File pathDelimiter]) , self engine outputFilename.
			self engine additionalFiles keysAndValuesDo: [:file :text | self saveOutput: text in: file]].
	self engine finished.
	aSmaCCRewriteResult class == SmaCCRewriteResult ifFalse: [self validate: output forResult: aSmaCCRewriteResult]]
		on: Error
		do:
			[:ex | 
			aSmaCCRewriteResult type: (output isNil ifTrue: [#error] ifFalse: [#warning]).
			aSmaCCRewriteResult errorString: ex description.
			(self debug and: [Processor activeProcess respondsTo: #debug]) ifTrue: [Processor activeProcess debug].
			SessionManager current cmdLineFlags do: [:each | (each sameAs: 'error') ifTrue: [ex pass]].
			ex return].
	MemoryManager current compact.
	^aSmaCCRewriteResult!

ruleFile: aString
	self parseRewriteRuleFile: aString!

rules
	^rules!

rules: aCollection
	rules := aCollection!

saveOutput: aString in: aFilename
	| stream directory |
	(aFilename isNil or: [aFilename isEmpty]) ifTrue: [^self].
	aString isEmpty ifTrue: [^self].
	directory := File splitPathFrom: aFilename.
	File createDirectoryPath: directory.
	stream := FileStream write: aFilename.
	[stream nextPutAll: aString] ensure: [stream close]!

sourceFor: aString
	| stream |
	stream := FileStream read: aString.
	^[([#[239 187 191] allSatisfy: [:each | stream peekFor: (Character value: each)]]
		on: Error
		do: [:ex | ex return: false]) ifFalse: [stream position: 0].	"HACK to handle UTF-8 streams"
	stream upToEnd] ensure: [stream close]!

validate: aString forResult: aSmaCCRewriteResult
	| stream |
	self validationParserClass isNil ifTrue: [^self].
	stream := SmaCCLineNumberStream on: (ReadStream on: aString).
	[self validationParserClass parseStream: stream]
		on: SmaCCParserError
		do:
			[:ex | 
			| parser token |
			parser := ex tag.
			token := parser errorToken.
			token notNil
				ifTrue:
					[aSmaCCRewriteResult
						startLine: (stream lineNumberFor: (token startPosition ifNil: [1]));
						startColumn: (stream columnNumberFor: (token startPosition ifNil: [1]));
						interval: ((token startPosition ifNil: [1]) to: (token stopPosition ifNil: [1]))].
			aSmaCCRewriteResult
				errorString: 'Validation error';
				type: #warning]!

validationParserClass
	^validationParserClass!

validationParserClass: aSmaCCParserClass
	validationParserClass := aSmaCCParserClass! !
!SmaCCRewriteProcessor categoriesFor: #baseDirectory!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #baseDirectory:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #debug!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #debug:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #engine!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #extension!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #files!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #files:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #inputDirectory!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #inputDirectory:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #inputFilenames!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #outputDirectory!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #outputDirectory:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #parseFile:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #parserClass!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #parserClass:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #parseRewriteRuleFile:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #processAllNotifying:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #processFile:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #processFile:usingResult:!accessing!public! !
!SmaCCRewriteProcessor categoriesFor: #ruleFile:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #rules!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #rules:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #saveOutput:in:!accessing!public! !
!SmaCCRewriteProcessor categoriesFor: #sourceFor:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #validate:forResult:!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #validationParserClass!accessing!private! !
!SmaCCRewriteProcessor categoriesFor: #validationParserClass:!accessing!private! !

!SmaCCRewriteProcessor class methodsFor!

debug
	^Debug ifNil: [false]!

debug: aBoolean
	Debug := aBoolean!

haltBlock
	^HaltBlock ifNil: [[:rewrite :node | false]]!

haltBlock: aBlock
	HaltBlock := aBlock! !
!SmaCCRewriteProcessor class categoriesFor: #debug!accessing!public! !
!SmaCCRewriteProcessor class categoriesFor: #debug:!accessing!public! !
!SmaCCRewriteProcessor class categoriesFor: #haltBlock!public! !
!SmaCCRewriteProcessor class categoriesFor: #haltBlock:!public! !

SmaCCRewriteResult guid: (GUID fromString: '{779183E1-E7C0-4F62-BC0D-38EE8E6B6426}')!
SmaCCRewriteResult comment: ''!
!SmaCCRewriteResult categoriesForClass!Kernel-Objects! !
!SmaCCRewriteResult methodsFor!

asSocketString
	| stream null |
	stream := WriteStream on: String new.
	null := Character value: 0.
	stream
		nextPutAll: 'FILENAME=';
		nextPutAll: filename;
		nextPut: null.
	errorString notNil
		ifTrue:
			[stream
				nextPutAll: 'ERRORSTRING=';
				nextPutAll: errorString;
				nextPut: null].
	type notNil
		ifTrue:
			[stream
				nextPutAll: 'TYPE=';
				nextPutAll: type;
				nextPut: null].
	startLine notNil
		ifTrue:
			[stream
				nextPutAll: 'STARTLINE=';
				print: startLine;
				nextPut: null].
	startColumn notNil
		ifTrue:
			[stream
				nextPutAll: 'STARTCOLUMN=';
				print: startColumn;
				nextPut: null].
	interval notNil
		ifTrue:
			[stream
				nextPutAll: 'INTERVAL=';
				print: interval start;
				nextPut: $-;
				print: interval stop;
				nextPut: null].
	transformation notNil
		ifTrue:
			[stream
				nextPutAll: 'TRANSFORMATION=';
				nextPutAll: transformation displayString;
				nextPut: null].
	^stream contents!

asTabDelimitedString
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: filename;
		tab;
		nextPutAll: (errorString ifNil: ['']);
		tab;
		nextPutAll: (type ifNil: ['']);
		tab;
		nextPutAll: (startLine ifNil: [''] ifNotNil: [:value | value printString]);
		tab;
		nextPutAll: (startColumn ifNil: [''] ifNotNil: [:value | value printString]);
		tab;
		nextPutAll: (transformation ifNil: [''] ifNotNil: [:value | value displayString]).
	^stream contents!

errorString
	^errorString!

errorString: anObject
	errorString := anObject!

filename
	^filename!

filename: anObject
	filename := anObject!

inputSource
	^''!

inputSource: aString!

interval
	^interval!

interval: anObject
	interval := anObject!

isError
	^type = #error!

isWarning
	^type = #warning!

outputSource
	^''!

outputSource: aString!

smaccStringClass
	^SmaCCString!

startColumn
	^startColumn!

startColumn: anInteger
	startColumn := anInteger!

startLine
	^startLine!

startLine: anInteger
	startLine := anInteger!

transformation
	^transformation!

transformation: anObject
	transformation := anObject!

transformedString
	^SmaCCAnnotatedString on: ''!

transformedString: aSmaCCAnnotatedString!

type
	^type!

type: aSymbol
	type := aSymbol! !
!SmaCCRewriteResult categoriesFor: #asSocketString!converting!public! !
!SmaCCRewriteResult categoriesFor: #asTabDelimitedString!converting!public! !
!SmaCCRewriteResult categoriesFor: #errorString!accessing!private! !
!SmaCCRewriteResult categoriesFor: #errorString:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #filename!accessing!private! !
!SmaCCRewriteResult categoriesFor: #filename:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #inputSource!public! !
!SmaCCRewriteResult categoriesFor: #inputSource:!accessing!public! !
!SmaCCRewriteResult categoriesFor: #interval!accessing!private! !
!SmaCCRewriteResult categoriesFor: #interval:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #isError!public!testing! !
!SmaCCRewriteResult categoriesFor: #isWarning!public!testing! !
!SmaCCRewriteResult categoriesFor: #outputSource!public! !
!SmaCCRewriteResult categoriesFor: #outputSource:!accessing!public! !
!SmaCCRewriteResult categoriesFor: #smaccStringClass!accessing!public! !
!SmaCCRewriteResult categoriesFor: #startColumn!accessing!private! !
!SmaCCRewriteResult categoriesFor: #startColumn:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #startLine!accessing!private! !
!SmaCCRewriteResult categoriesFor: #startLine:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #transformation!accessing!private! !
!SmaCCRewriteResult categoriesFor: #transformation:!accessing!private! !
!SmaCCRewriteResult categoriesFor: #transformedString!public! !
!SmaCCRewriteResult categoriesFor: #transformedString:!accessing!public! !
!SmaCCRewriteResult categoriesFor: #type!accessing!private! !
!SmaCCRewriteResult categoriesFor: #type:!accessing!private! !

!SmaCCRewriteResult class methodsFor!

fromSocketString: aString
	| result |
	result := self new.
	aString
		splitFirstOn: (Character value: 0)
		andThen: $=
		do:
			[:key :value | 
			key = 'FILENAME' ifTrue: [result filename: value].
			key = 'ERRORSTRING' ifTrue: [result errorString: value].
			key = 'TYPE' ifTrue: [result type: value asSymbol].
			key = 'STARTLINE' ifTrue: [result startLine: (Number fromString: value)].
			key = 'STARTCOLUMN' ifTrue: [result startColumn: (Number fromString: value)].
			key = 'INTERVAL'
				ifTrue:
					[| items |
					items := value subStrings: $-.
					result interval: ((Number fromString: items first) to: (Number fromString: items last))].
			key = 'TRANSFORMATION' ifTrue: [result transformation: value]].
	^result! !
!SmaCCRewriteResult class categoriesFor: #fromSocketString:!instance creation!public! !

SmaCCRewriteTransformation guid: (GUID fromString: '{2BD2A754-C09C-47DF-B510-754729E3B982}')!
SmaCCRewriteTransformation comment: ''!
!SmaCCRewriteTransformation categoriesForClass!Unclassified! !
!SmaCCRewriteTransformation methodsFor!

modified
	rewrite notNil ifTrue: [rewrite modified]!

postCopy
	super postCopy.
	rewrite := nil!

rewrite
	^rewrite!

rewrite: aSmaCCRewrite
	rewrite := aSmaCCRewrite!

saveOn: aStream
	self subclassResponsibility!

transformUsingContext: aSmaCCRewriteMatchContext
	self subclassResponsibility! !
!SmaCCRewriteTransformation categoriesFor: #modified!public! !
!SmaCCRewriteTransformation categoriesFor: #postCopy!copying!public! !
!SmaCCRewriteTransformation categoriesFor: #rewrite!accessing!private! !
!SmaCCRewriteTransformation categoriesFor: #rewrite:!accessing!private! !
!SmaCCRewriteTransformation categoriesFor: #saveOn:!public!saving! !
!SmaCCRewriteTransformation categoriesFor: #transformUsingContext:!private!transforming! !

SmaCCAbstractRewrite guid: (GUID fromString: '{8A0A51DD-ACCB-4914-BA8E-009F94FA25E0}')!
SmaCCAbstractRewrite comment: ''!
!SmaCCAbstractRewrite categoriesForClass!Unclassified! !
!SmaCCAbstractRewrite methodsFor!

displayOn: aStream
	self subclassResponsibility!

displayString
	| stream |
	stream := WriteStream on: String new.
	self displayOn: stream.
	^stream contents!

engine: aSmaCCRewriteEngine
	self subclassResponsibility!

finishedLoading!

isComposite
	^false!

isRoot
	^parent isNil!

isUnder: aSmaCCAbstractRewrite
	| current |
	current := self.
	[current notNil and: [current ~= aSmaCCAbstractRewrite]] whileTrue: [current := current parent].
	^current notNil!

isUpToDate
	^true!

listForClass: aClass into: aSmaCCRewriteLink
	self subclassResponsibility!

localSaveOn: aStream
	self subclassResponsibility!

modified
	parent notNil ifTrue: [parent modified]!

parent
	^parent!

parent: aSmaCCAbstractRewrite
	parent := aSmaCCAbstractRewrite!

parserClass
	^parent notNil ifTrue: [parent parserClass] ifFalse: [nil]!

performOn: aSmaCCNode continuation: aBlock
	self subclassResponsibility!

postCopy
	super postCopy.
	parent := nil!

rewrites
	^#()!

saveOn: aStream
	self localSaveOn: aStream!

topParent
	^parent ifNil: [self] ifNotNil: [:value | value topParent]! !
!SmaCCAbstractRewrite categoriesFor: #displayOn:!printing!public! !
!SmaCCAbstractRewrite categoriesFor: #displayString!printing!public! !
!SmaCCAbstractRewrite categoriesFor: #engine:!initialize-release!public! !
!SmaCCAbstractRewrite categoriesFor: #finishedLoading!accessing!public! !
!SmaCCAbstractRewrite categoriesFor: #isComposite!public!testing! !
!SmaCCAbstractRewrite categoriesFor: #isRoot!public!testing! !
!SmaCCAbstractRewrite categoriesFor: #isUnder:!public!testing! !
!SmaCCAbstractRewrite categoriesFor: #isUpToDate!public!testing! !
!SmaCCAbstractRewrite categoriesFor: #listForClass:into:!accessing!public! !
!SmaCCAbstractRewrite categoriesFor: #localSaveOn:!public!saving! !
!SmaCCAbstractRewrite categoriesFor: #modified!public! !
!SmaCCAbstractRewrite categoriesFor: #parent!accessing!private! !
!SmaCCAbstractRewrite categoriesFor: #parent:!accessing!private! !
!SmaCCAbstractRewrite categoriesFor: #parserClass!accessing!public! !
!SmaCCAbstractRewrite categoriesFor: #performOn:continuation:!public!rewriting! !
!SmaCCAbstractRewrite categoriesFor: #postCopy!copying!public! !
!SmaCCAbstractRewrite categoriesFor: #rewrites!accessing!public! !
!SmaCCAbstractRewrite categoriesFor: #saveOn:!public!saving! !
!SmaCCAbstractRewrite categoriesFor: #topParent!accessing!public! !

SmaCCTransformationToolkitModel guid: (GUID fromString: '{60291132-0052-4552-9D3A-3F0F9D85099C}')!
SmaCCTransformationToolkitModel comment: ''!
!SmaCCTransformationToolkitModel categoriesForClass!MVP-Models! !
!SmaCCTransformationToolkitModel methodsFor!

addTransformation: aSmaCCAbstractRewrite under: aSmaCCRewriteFile
	self
		addTransformation: aSmaCCAbstractRewrite
		under: aSmaCCRewriteFile
		before: nil!

addTransformation: aSmaCCAbstractRewrite under: aSmaCCRewriteFile before: anotherSmaCCAbstractRewrite
	anotherSmaCCAbstractRewrite isNil
		ifTrue: [aSmaCCRewriteFile addTransformation: aSmaCCAbstractRewrite]
		ifFalse: [aSmaCCRewriteFile addTransformation: aSmaCCAbstractRewrite before: anotherSmaCCAbstractRewrite].
	self
		trigger: #addTransformation:under:
		with: aSmaCCAbstractRewrite
		with: aSmaCCRewriteFile!

areRewritesModified
	^self rewrites notNil and: [self rewrites isModified]!

commonParentDirectory
	| common |
	(self files isEmpty or: [self createSubdirectories not]) ifTrue: [^''].
	common := File splitPathFrom: self files first.
	self files
		do:
			[:each | 
			[each beginsWith: common]
				whileFalse:
					[common := (common isEmpty or: [common size = 3 and: [(common at: 2) = $:]])
						ifTrue: ['']
						ifFalse: [File splitPathFrom: (common copyFrom: 1 to: common size - 1)]]].
	^common!

createSubdirectories
	^createSubdirectories ifNil: [false]!

createSubdirectories: aBoolean
	createSubdirectories := aBoolean.
	modified := true.
	self trigger: #createSubdirectories with: aBoolean!

files
	^files ifNil: [#()]!

files: aCollection
	files := aCollection.
	modified := true.
	self trigger: #files with: aCollection!

initialize
	super initialize.
	modified := false!

inputParserClass
	^inputParserClass!

inputParserClass: aSmaCCParserClass
	inputParserClass := aSmaCCParserClass.
	modified := true.
	self trigger: #inputParserClass with: aSmaCCParserClass!

isModified
	^modified or: [self areRewritesModified]!

isModified: aBoolean
	modified := aBoolean!

loadFile: aString
	| stream |
	stream := FileStream read: aString.
	[Compiler
		evaluate: stream contents
		for: self
		logged: false.
	self isModified: false] ensure: [stream close]!

loadRewriteFile: aString
	aString isNil ifTrue: [^self].
	self rewrites: (self openRewriteFile: aString)!

localRunOn: aCollection
	(SmaCCRewriteProcessor new)
		rules: self rewrites;
		parserClass: self inputParserClass;
		validationParserClass: self validationParserClass;
		files: aCollection;
		outputDirectory: self outputDirectory;
		baseDirectory: self commonParentDirectory;
		processAllNotifying: [:each | self trigger: #resultAdded with: each]!

openRewriteFile: filename
	^(File exists: filename)
		ifTrue: [SmaCCRewriteRuleFileParser parseFile: filename]
		ifFalse:
			[(SmaCCRewriteFile new)
				filename: filename;
				yourself]!

outputDirectory
	^outputDirectory ifNil: ['']!

outputDirectory: aString
	outputDirectory := aString.
	modified := true.
	self trigger: #outputDirectory with: aString!

removeTransformation: aSmaCCAbstractRewrite
	aSmaCCAbstractRewrite parent removeTransformation: aSmaCCAbstractRewrite.
	self trigger: #removedTransformation: with: aSmaCCAbstractRewrite!

rewrites
	^rewrites!

rewrites: aSmaCCRewrite
	rewrites := aSmaCCRewrite.
	modified := true.
	self trigger: #rewrites with: aSmaCCRewrite!

runOn: tranformationFiles
	self runOnServer ifTrue: [self serverRunOn: tranformationFiles] ifFalse: [self localRunOn: tranformationFiles]!

runOnServer
	^runOnServer ifNil: [false]!

runOnServer: aBoolean
	runOnServer := aBoolean.
	modified := true.
	self trigger: #runOnServer with: aBoolean!

saveRewrites
	self rewrites save!

saveTo: filename
	| stream |
	stream := FileStream write: filename.
	[stream
		nextPutAll: 'self';
		crtab;
		nextPutAll: 'inputParserClass: ';
		nextPutAll: self inputParserClass storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'validationParserClass: ';
		nextPutAll: self validationParserClass storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'loadRewriteFile: ';
		nextPutAll: self rewrites filename storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'files: ';
		nextPutAll: self files asArray storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'outputDirectory: ';
		nextPutAll: self outputDirectory storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'createSubdirectories: ';
		nextPutAll: self createSubdirectories storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'server: ';
		nextPutAll: self server storeString;
		nextPut: $;;
		crtab;
		nextPutAll: 'runOnServer: ';
		nextPutAll: self runOnServer storeString] ensure: [stream close].
	modified := false.
	self areRewritesModified ifTrue: [self saveRewrites]!

server
	^(server isNil or: [server isEmpty]) ifTrue: ['localhost'] ifFalse: [server]!

server: aString
	server := aString.
	modified := true.
	self trigger: #server with: aString!

serverAndPort: defaultPort from: aString
	| serverName port parts |
	parts := aString subStrings: $:.
	(parts size = 2 and: [parts last notEmpty and: [parts last allSatisfy: [:each | each isDigit]]])
		ifTrue:
			[serverName := parts first.
			port := Number fromString: parts last]
		ifFalse:
			[serverName := aString.
			port := defaultPort].
	^Array with: serverName with: port!

serverName
	^(self serverAndPort: 36rSM from: self server) first!

serverPort
	^(self serverAndPort: 36rSM from: self server) last!

serverRunOn: aCollection
	| baseString stream socket request |
	baseString := 'INPUTPARSER=' , self inputParserClass name , ';REWRITEFILE=' , self rewrites filename.
	self outputDirectory notEmpty ifTrue: [baseString := baseString , ';OUTPUTDIRECTORY=' , self outputDirectory].
	baseString := baseString , ';BASEDIRECTORY=' , self commonParentDirectory.
	self validationParserClass notNil
		ifTrue: [baseString := baseString , ';OUTPUTPARSER=' , self validationParserClass name].
	stream := WriteStream on: String new.
	aCollection
		do:
			[:each | 
			stream
				nextPutAll: baseString;
				nextPutAll: ';FILE=';
				nextPutAll: each;
				nextPut: (Character value: 0)].
	request := stream contents.
	socket := Socket2 port: self serverPort host: self serverName.
	socket connect.
	[(socket writeStream)
		nextPut: $1 asInteger;
		nextDWORDPut: request size;
		nextPutAll: request asByteArray;
		flush.
	aCollection size
		timesRepeat:
			[self
				trigger: #resultAdded
				with: (SmaCCRewriteResult fromSocketString: (socket readStream next: socket readStream nextDWORD) asString)]]
		ensure: [socket close]!

toggleUseServer
	self runOnServer: self runOnServer not!

validationParserClass
	^validationParserClass!

validationParserClass: aSmaCCParserClass
	validationParserClass := aSmaCCParserClass.
	modified := true.
	self trigger: #validationParserClass with: aSmaCCParserClass! !
!SmaCCTransformationToolkitModel categoriesFor: #addTransformation:under:!actions-rewrites!public! !
!SmaCCTransformationToolkitModel categoriesFor: #addTransformation:under:before:!actions-rewrites!public! !
!SmaCCTransformationToolkitModel categoriesFor: #areRewritesModified!public!testing! !
!SmaCCTransformationToolkitModel categoriesFor: #commonParentDirectory!public!running! !
!SmaCCTransformationToolkitModel categoriesFor: #createSubdirectories!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #createSubdirectories:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #files!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #files:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #initialize!initialize/release!public! !
!SmaCCTransformationToolkitModel categoriesFor: #inputParserClass!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #inputParserClass:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #isModified!public!testing! !
!SmaCCTransformationToolkitModel categoriesFor: #isModified:!public!testing! !
!SmaCCTransformationToolkitModel categoriesFor: #loadFile:!actions!public! !
!SmaCCTransformationToolkitModel categoriesFor: #loadRewriteFile:!public! !
!SmaCCTransformationToolkitModel categoriesFor: #localRunOn:!public!running! !
!SmaCCTransformationToolkitModel categoriesFor: #openRewriteFile:!actions-rewrites!private! !
!SmaCCTransformationToolkitModel categoriesFor: #outputDirectory!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #outputDirectory:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #removeTransformation:!actions-rewrites!public! !
!SmaCCTransformationToolkitModel categoriesFor: #rewrites!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #rewrites:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #runOn:!actions-running!private! !
!SmaCCTransformationToolkitModel categoriesFor: #runOnServer!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #runOnServer:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #saveRewrites!public! !
!SmaCCTransformationToolkitModel categoriesFor: #saveTo:!public! !
!SmaCCTransformationToolkitModel categoriesFor: #server!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #server:!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #serverAndPort:from:!private! !
!SmaCCTransformationToolkitModel categoriesFor: #serverName!accessing!public! !
!SmaCCTransformationToolkitModel categoriesFor: #serverPort!accessing!public! !
!SmaCCTransformationToolkitModel categoriesFor: #serverRunOn:!public!running! !
!SmaCCTransformationToolkitModel categoriesFor: #toggleUseServer!public! !
!SmaCCTransformationToolkitModel categoriesFor: #validationParserClass!accessing!private! !
!SmaCCTransformationToolkitModel categoriesFor: #validationParserClass:!accessing!private! !

SmaCCRewrite guid: (GUID fromString: '{0532F369-10EC-4267-9861-51ED20FD4557}')!
SmaCCRewrite comment: ''!
!SmaCCRewrite categoriesForClass!Unclassified! !
!SmaCCRewrite methodsFor!

comment
	^comment ifNil: ['']!

comment: aString
	comment := aString.
	self trigger: #comment!

displayOn: aStream
	self comment notEmpty ifTrue: [aStream nextPutAll: self comment] ifFalse: [match displayOn: aStream]!

engine: aSmaCCRewriteEngine
	engine := aSmaCCRewriteEngine!

listForClass: aClass into: aSmaCCRewriteLink
	| next |
	(match canMatch: aClass) ifFalse: [^aSmaCCRewriteLink].
	next := SmaCCRewriteLink new.
	next rewrite: self.
	aSmaCCRewriteLink next: next.
	^next!

localSaveOn: aStream
	self comment notEmpty
		ifTrue:
			[aStream
				nextPut: $";
				nextPutAll: (self comment copyReplaceAll: '"' with: '""');
				nextPut: $";
				cr].
	match saveOn: aStream.
	aStream
		cr;
		nextPutAll: '->';
		cr.
	transformation saveOn: aStream!

match
	^match!

match: aSmaCCRewriteMatch
	match := aSmaCCRewriteMatch.
	match rewrite: self.
	self modified.
	self trigger: #match!

performOn: aSmaCCNode continuation: aBlock
	| matchedContext dictionary result previousNode previousRule |
	previousNode := engine source node.
	previousRule := engine source rule.
	(engine source)
		node: aSmaCCNode;
		rule: self.
	matchedContext := SmaCCRewriteMatchContext
		forNode: aSmaCCNode
		rewriter: engine
		continuation: aBlock.
	dictionary := match match: matchedContext.
	result := dictionary notNil.
	result
		ifTrue:
			[matchedContext context: dictionary.
			result := (transformation transformUsingContext: matchedContext) ~~ SmaCCRewriteMatchContext continue].
	(engine source)
		node: previousNode;
		rule: previousRule.
	^result!

postCopy
	super postCopy.
	self match: self match copy.
	self transformation: self transformation copy.
	engine := nil!

transformation
	^transformation!

transformation: aSmaCCRewriteTransformation
	transformation := aSmaCCRewriteTransformation.
	transformation rewrite: self.
	self modified.
	self trigger: #transformation! !
!SmaCCRewrite categoriesFor: #comment!accessing!private! !
!SmaCCRewrite categoriesFor: #comment:!accessing!public! !
!SmaCCRewrite categoriesFor: #displayOn:!printing!public! !
!SmaCCRewrite categoriesFor: #engine:!initialize-release!public! !
!SmaCCRewrite categoriesFor: #listForClass:into:!accessing!public! !
!SmaCCRewrite categoriesFor: #localSaveOn:!public!saving! !
!SmaCCRewrite categoriesFor: #match!accessing!private! !
!SmaCCRewrite categoriesFor: #match:!accessing!public! !
!SmaCCRewrite categoriesFor: #performOn:continuation:!public!rewriting! !
!SmaCCRewrite categoriesFor: #postCopy!copying!public! !
!SmaCCRewrite categoriesFor: #transformation!accessing!private! !
!SmaCCRewrite categoriesFor: #transformation:!accessing!public! !

!SmaCCRewrite class methodsFor!

comment: aString match: aSmaCCRewriteMatch transformation: aSmaCCRewriteTransformation
	^(self new)
		comment: aString;
		match: aSmaCCRewriteMatch;
		transformation: aSmaCCRewriteTransformation;
		yourself!

newInstance
	^self
		comment: ''
		match: (SmaCCRewriteTypeMatch on: SmaCCParseNode)
		transformation: (SmaCCRewriteCodeTransformation on: 'self continue')! !
!SmaCCRewrite class categoriesFor: #comment:match:transformation:!instance creation!private! !
!SmaCCRewrite class categoriesFor: #newInstance!instance creation!private! !

SmaCCRewriteFile guid: (GUID fromString: '{602A9032-570E-4378-A159-EB36AD9D3055}')!
SmaCCRewriteFile comment: ''!
!SmaCCRewriteFile categoriesForClass!Unclassified! !
!SmaCCRewriteFile methodsFor!

= anObject
	self class = anObject class ifFalse: [^false].
	^self filename = anObject filename!

addTransformation: aSmaCCAbstractRewrite
	rewrites add: aSmaCCAbstractRewrite.
	aSmaCCAbstractRewrite parent: self.
	self modified!

addTransformation: aSmaCCAbstractRewrite before: anotherSmaCCAbstractRewrite
	rewrites add: aSmaCCAbstractRewrite before: anotherSmaCCAbstractRewrite.
	aSmaCCAbstractRewrite parent: self.
	self modified!

currentFileTimestamp
	^filename ifNotNil: [:name | File lastWriteTime: name]!

directory
	^File appendPathDelimiter: (File splitPathFrom: filename)!

displayOn: aStream
	aStream nextPutAll: (File splitFilenameFrom: filename)!

engine: aSmaCCRewriteEngine
	rewrites do: [:each | each engine: aSmaCCRewriteEngine]!

filename
	^filename!

filename: aString
	filename := aString.
	timestamp := self currentFileTimestamp.
	self modified!

finishedLoading
	isModified := false.
	rewrites do: [:each | each finishedLoading]!

hash
	^self class hash bitXor: self filename hash!

import: aString
	| name rewriteFile |
	name := self directory , aString.
	(File exists: name) ifFalse: [name := aString].
	rewriteFile := SmaCCRewriteRuleFileParser parseFile: name.
	self addTransformation: rewriteFile!

initialize
	super initialize.
	rewrites := OrderedCollection new.
	isModified := false.
	cachedLists := IdentityDictionary new!

isComposite
	^true!

isModified
	^isModified!

isUpToDate
	^timestamp = self currentFileTimestamp and: [rewrites allSatisfy: [:each | each isUpToDate]]!

listForClass: aClass into: aSmaCCRewriteLink
	^rewrites inject: aSmaCCRewriteLink into: [:sum :each | each listForClass: aClass into: sum]!

localSaveOn: aStream
	aStream
		nextPutAll: 'Import: ''';
		nextPutAll: self relativeFilename;
		nextPut: $'!

modified
	isModified := true.
	cachedLists := IdentityDictionary new.
	super modified!

parserClass
	^parserClass ifNil: [super parserClass]!

parserClass: aSmaCCParserClass
	parserClass := aSmaCCParserClass.
	self modified.
	self trigger: #parserClass!

performLink: aSmaCCRewriteLink on: aSmaCCNode continuation: aBlock
	| link continuation |
	link := aSmaCCRewriteLink.
	continuation := [self
		performLink: link next
		on: aSmaCCNode
		continuation: aBlock].
	[link notNil]
		whileTrue:
			[(link rewrite performOn: aSmaCCNode continuation: continuation) ifTrue: [^true].
			link := link next].
	^aBlock value!

performOn: aSmaCCNode continuation: aBlock
	| link |
	link := cachedLists
		at: aSmaCCNode class
		ifAbsentPut:
			[| first |
			first := SmaCCRewriteLink new.
			self listForClass: aSmaCCNode class into: first.
			first next].
	^self performLink: link on: aSmaCCNode continuation: aBlock!

postCopy
	| oldRewrites |
	super postCopy.
	oldRewrites := self rewrites.
	rewrites := OrderedCollection new: oldRewrites size.
	oldRewrites do: [:each | self addTransformation: each copy].
	cachedLists := IdentityDictionary new!

relativeFilename
	| parentDirectory |
	parent isNil ifTrue: [^filename].
	parentDirectory := parent directory.
	^(filename beginsWith: parentDirectory)
		ifTrue: [filename copyFrom: parentDirectory size + 1 to: filename size]
		ifFalse: [filename]!

removeTransformation: aSmaCCAbstractRewrite
	rewrites remove: aSmaCCAbstractRewrite ifAbsent: [].
	aSmaCCAbstractRewrite parent: nil.
	self modified!

rewrites
	^rewrites!

rewrites: aCollection
	rewrites := aCollection.
	self modified!

save
	| stream |
	stream := FileStream write: filename.
	[parserClass notNil
		ifTrue:
			[stream
				nextPutAll: 'Parser: ';
				nextPutAll: parserClass name;
				cr;
				cr].
	rewrites
		do: [:each | each saveOn: stream]
		separatedBy:
			[stream
				cr;
				cr].
	isModified := false] ensure: [stream close].
	timestamp := self currentFileTimestamp!

saveOn: aStream
	super saveOn: aStream.
	self save! !
!SmaCCRewriteFile categoriesFor: #=!comparing!public! !
!SmaCCRewriteFile categoriesFor: #addTransformation:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #addTransformation:before:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #currentFileTimestamp!accessing!public! !
!SmaCCRewriteFile categoriesFor: #directory!accessing!public! !
!SmaCCRewriteFile categoriesFor: #displayOn:!printing!public! !
!SmaCCRewriteFile categoriesFor: #engine:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #filename!accessing!private! !
!SmaCCRewriteFile categoriesFor: #filename:!accessing!private! !
!SmaCCRewriteFile categoriesFor: #finishedLoading!accessing!public! !
!SmaCCRewriteFile categoriesFor: #hash!comparing!public! !
!SmaCCRewriteFile categoriesFor: #import:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #initialize!initialize-release!public! !
!SmaCCRewriteFile categoriesFor: #isComposite!public!testing! !
!SmaCCRewriteFile categoriesFor: #isModified!public!testing! !
!SmaCCRewriteFile categoriesFor: #isUpToDate!public!testing! !
!SmaCCRewriteFile categoriesFor: #listForClass:into:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #localSaveOn:!public!saving! !
!SmaCCRewriteFile categoriesFor: #modified!accessing!public! !
!SmaCCRewriteFile categoriesFor: #parserClass!accessing!private! !
!SmaCCRewriteFile categoriesFor: #parserClass:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #performLink:on:continuation:!public!rewriting! !
!SmaCCRewriteFile categoriesFor: #performOn:continuation:!public!rewriting! !
!SmaCCRewriteFile categoriesFor: #postCopy!copying!public! !
!SmaCCRewriteFile categoriesFor: #relativeFilename!accessing!private! !
!SmaCCRewriteFile categoriesFor: #removeTransformation:!accessing!public! !
!SmaCCRewriteFile categoriesFor: #rewrites!accessing!private! !
!SmaCCRewriteFile categoriesFor: #rewrites:!accessing!private! !
!SmaCCRewriteFile categoriesFor: #save!public!saving! !
!SmaCCRewriteFile categoriesFor: #saveOn:!public!saving! !

!SmaCCRewriteFile class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCRewriteFile class categoriesFor: #new!instance creation!public! !

SmaCCReplaceExpression guid: (GUID fromString: '{B945525D-634A-4EEA-B46F-45E80EA172A6}')!
SmaCCReplaceExpression comment: ''!
!SmaCCReplaceExpression categoriesForClass!Unclassified! !
!SmaCCReplaceExpression methodsFor!

acceptVisitor: aReplaceVisitor
	^aReplaceVisitor visitReplace: self!

evaluateInContext: aSmaCCRewriteMatchContext
	self subclassResponsibility! !
!SmaCCReplaceExpression categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCReplaceExpression categoriesFor: #evaluateInContext:!evaluating!private! !

SmaCCCodeReplaceExpression guid: (GUID fromString: '{05F7F39B-D26E-4D16-9726-93D95E6B6098}')!
SmaCCCodeReplaceExpression comment: ''!
!SmaCCCodeReplaceExpression categoriesForClass!Unclassified! !
!SmaCCCodeReplaceExpression methodsFor!

acceptVisitor: aReplaceVisitor
	^aReplaceVisitor visitCodeReplace: self!

code
	^code!

code: aSmaCCToken
	code := aSmaCCToken!

evaluateInContext: aSmaCCRewriteMatchContext
	| value |
	value := self method value: aSmaCCRewriteMatchContext withArguments: #().
	^(value isString or: [value isKindOf: SmaCCString])
		ifTrue: [value]
		ifFalse: [aSmaCCRewriteMatchContext sourceFrom: aSmaCCRewriteMatchContext match startPosition to: aSmaCCRewriteMatchContext match stopPosition]!

method
	^self
		attributeNamed: #method
		ifAbsentPut:
			[| source method tree |
			source := 'code ' , code value.
			tree := SmalltalkParser parseMethod: source.
			tree body statements isEmpty ifTrue: [tree := SmalltalkParser parseMethod: 'code ^'''''].
			tree body addReturn.
			source := tree formattedCode.
			method := [Compiler compile: source in: SmaCCRewriteMatchContext]
				on: CompilerErrorNotification
				do: [:ex | Error signal: ex errorMessage , ' (' , ex range printString , ')'].
			method sourceDescriptor: source.
			method]!

tokenVariables
	^#(#code)! !
!SmaCCCodeReplaceExpression categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCCodeReplaceExpression categoriesFor: #code!generated!public! !
!SmaCCCodeReplaceExpression categoriesFor: #code:!generated!public! !
!SmaCCCodeReplaceExpression categoriesFor: #evaluateInContext:!evaluating!public! !
!SmaCCCodeReplaceExpression categoriesFor: #method!evaluating!private! !
!SmaCCCodeReplaceExpression categoriesFor: #tokenVariables!generated!public! !

SmaCCCompositeReplaceExpression guid: (GUID fromString: '{A570F8E0-F0B7-43F7-B569-8808EE24668C}')!
SmaCCCompositeReplaceExpression comment: ''!
!SmaCCCompositeReplaceExpression categoriesForClass!Unclassified! !
!SmaCCCompositeReplaceExpression methodsFor!

acceptVisitor: aReplaceVisitor
	^aReplaceVisitor visitCompositeReplace: self!

compositeNodeVariables
	^#(#expressions)!

evaluateInContext: aSmaCCRewriteMatchContext
	| result |
	result := aSmaCCRewriteMatchContext smaccStringClass new.
	self expressions reverseDo: [:each | result addPrefix: (each evaluateInContext: aSmaCCRewriteMatchContext)].
	^result!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.! !
!SmaCCCompositeReplaceExpression categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCCompositeReplaceExpression categoriesFor: #compositeNodeVariables!generated!public! !
!SmaCCCompositeReplaceExpression categoriesFor: #evaluateInContext:!evaluating!private! !
!SmaCCCompositeReplaceExpression categoriesFor: #expressions!generated!public! !
!SmaCCCompositeReplaceExpression categoriesFor: #expressions:!generated!public! !
!SmaCCCompositeReplaceExpression categoriesFor: #initialize!generated-initialize-release!public! !

SmaCCNodeReplaceExpression guid: (GUID fromString: '{E3E7959C-57A9-405D-982F-CF8C57414854}')!
SmaCCNodeReplaceExpression comment: ''!
!SmaCCNodeReplaceExpression categoriesForClass!Unclassified! !
!SmaCCNodeReplaceExpression methodsFor!

acceptVisitor: aReplaceVisitor
	^aReplaceVisitor visitNodeReplace: self!

addPostfixTo: aSmaCCString inContext: aSmaCCRewriteMatchContext
	| node position string |
	node := aSmaCCRewriteMatchContext nodeFor: name value.
	(aSmaCCRewriteMatchContext isAtEndOfParent: node)
		ifFalse:
			[position := aSmaCCRewriteMatchContext originalStopPosition: node.
			string := nil.
			afterPostfix notNil
				ifTrue:
					[(aSmaCCRewriteMatchContext
						charactersAtAndAfter: (aSmaCCRewriteMatchContext nextIndex: position)
						matchesToken: afterPostfix)
						ifTrue: [afterPostfix value size timesRepeat: [position := aSmaCCRewriteMatchContext nextIndex: position]].
					string := afterPostfix value].
			afterWhitespace notNil ifTrue: [aSmaCCString addPrefix: (aSmaCCRewriteMatchContext whitespaceAfter: position)].
			string notNil ifTrue: [aSmaCCString addPrefix: string]].
	postfix notNil ifTrue: [aSmaCCString addPrefix: postfix value]!

addPrefixTo: aSmaCCString inContext: aSmaCCRewriteMatchContext
	| node startPosition |
	node := aSmaCCRewriteMatchContext nodeFor: name value.
	startPosition := aSmaCCRewriteMatchContext originalStartPosition: node.
	prefix notNil ifTrue: [aSmaCCString addPrefix: prefix value].
	(aSmaCCRewriteMatchContext isAtStartOfParent: node) ifTrue: [^self].
	beforePrefix notNil
		ifTrue:
			[(aSmaCCRewriteMatchContext
				charactersAtAndBefore: (aSmaCCRewriteMatchContext previousIndex: startPosition)
				matchesToken: beforePrefix)
				ifTrue:
					[beforePrefix value size timesRepeat: [startPosition := aSmaCCRewriteMatchContext previousIndex: startPosition]].
			aSmaCCString addPrefix: beforePrefix value].
	beforeWhitespace notNil ifTrue: [aSmaCCString addPrefix: (aSmaCCRewriteMatchContext whitespaceBefore: startPosition)]!

afterPostfix
	^afterPostfix!

afterPostfix: aSmaCCToken
	afterPostfix := aSmaCCToken!

afterWhitespace
	^afterWhitespace!

afterWhitespace: aSmaCCToken
	afterWhitespace := aSmaCCToken!

beforePrefix
	^beforePrefix!

beforePrefix: aSmaCCToken
	beforePrefix := aSmaCCToken!

beforeWhitespace
	^beforeWhitespace!

beforeWhitespace: aSmaCCToken
	beforeWhitespace := aSmaCCToken!

evaluateInContext: aSmaCCRewriteMatchContext
	| result |
	result := aSmaCCRewriteMatchContext smaccStringClass new.
	self addPostfixTo: result inContext: aSmaCCRewriteMatchContext.
	result addPrefix: (aSmaCCRewriteMatchContext stringFor: name value).
	self addPrefixTo: result inContext: aSmaCCRewriteMatchContext.
	^result!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

postfix
	^postfix!

postfix: aSmaCCToken
	postfix := aSmaCCToken!

prefix
	^prefix!

prefix: aSmaCCToken
	prefix := aSmaCCToken!

tokenVariables
	^#(#beforeWhitespace #beforePrefix #prefix #name #postfix #afterPostfix #afterWhitespace)! !
!SmaCCNodeReplaceExpression categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #addPostfixTo:inContext:!private! !
!SmaCCNodeReplaceExpression categoriesFor: #addPrefixTo:inContext:!private! !
!SmaCCNodeReplaceExpression categoriesFor: #afterPostfix!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #afterPostfix:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #afterWhitespace!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #afterWhitespace:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #beforePrefix!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #beforePrefix:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #beforeWhitespace!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #beforeWhitespace:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #evaluateInContext:!evaluating!private! !
!SmaCCNodeReplaceExpression categoriesFor: #name!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #name:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #postfix!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #postfix:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #prefix!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #prefix:!generated!public! !
!SmaCCNodeReplaceExpression categoriesFor: #tokenVariables!generated!public! !

SmaCCStringReplaceExpression guid: (GUID fromString: '{CE11BCE2-827D-4F71-A3EC-14E4C04DF667}')!
SmaCCStringReplaceExpression comment: ''!
!SmaCCStringReplaceExpression categoriesForClass!Unclassified! !
!SmaCCStringReplaceExpression methodsFor!

acceptVisitor: aReplaceVisitor
	^aReplaceVisitor visitStringReplace: self!

evaluateInContext: aSmaCCRewriteMatchContext
	^string value!

string
	^string!

string: aSmaCCToken
	string := aSmaCCToken!

tokenVariables
	^#(#string)! !
!SmaCCStringReplaceExpression categoriesFor: #acceptVisitor:!generated!public! !
!SmaCCStringReplaceExpression categoriesFor: #evaluateInContext:!evaluating!private! !
!SmaCCStringReplaceExpression categoriesFor: #string!generated!public! !
!SmaCCStringReplaceExpression categoriesFor: #string:!generated!public! !
!SmaCCStringReplaceExpression categoriesFor: #tokenVariables!generated!public! !

SmaCCReplaceExpressionVisitor guid: (GUID fromString: '{65A30383-8CCB-4D8C-A6A5-A8DF902D2DD2}')!
SmaCCReplaceExpressionVisitor comment: ''!
!SmaCCReplaceExpressionVisitor categoriesForClass!Unclassified! !
!SmaCCReplaceExpressionVisitor methodsFor!

visitCodeReplace: aCodeReplace
	^self visitReplace: aCodeReplace!

visitCompositeReplace: aCompositeReplace
	^self visitReplace: aCompositeReplace!

visitNodeReplace: aNodeReplace
	^self visitReplace: aNodeReplace!

visitReplace: aReplace
	^self visitSmaCCParseNode: aReplace!

visitStringReplace: aStringReplace
	^self visitReplace: aStringReplace! !
!SmaCCReplaceExpressionVisitor categoriesFor: #visitCodeReplace:!generated!public! !
!SmaCCReplaceExpressionVisitor categoriesFor: #visitCompositeReplace:!generated!public! !
!SmaCCReplaceExpressionVisitor categoriesFor: #visitNodeReplace:!generated!public! !
!SmaCCReplaceExpressionVisitor categoriesFor: #visitReplace:!generated!public! !
!SmaCCReplaceExpressionVisitor categoriesFor: #visitStringReplace:!generated!public! !

SmaCCReplaceExpressionParser guid: (GUID fromString: '{8E251CF5-B731-45ED-8422-6844BA9ADDF6}')!
SmaCCReplaceExpressionParser comment: ''!
!SmaCCReplaceExpressionParser categoriesForClass!Unclassified! !
!SmaCCReplaceExpressionParser methodsFor!

reduceActionForCodeReplace1: nodes
	| result |
	result := SmaCCCodeReplaceExpression new.
	result code: (nodes at: 3).
	^result!

reduceActionForExpression1: nodes
	| result |
	result := SmaCCCompositeReplaceExpression new.
	result addNodes: (nodes at: 1) to: result expressions.
	^result!

reduceActionForNodeReplace1: nodes
	| result |
	result := SmaCCNodeReplaceExpression new.
	result beforeWhitespace: ((nodes at: 3) at: 1).
	result beforePrefix: ((nodes at: 3) at: 2).
	result prefix: ((nodes at: 3) at: 3).
	result name: (nodes at: 4).
	result postfix: ((nodes at: 5) at: 1).
	result afterPostfix: ((nodes at: 5) at: 2).
	result afterWhitespace: ((nodes at: 5) at: 3).
	^result!

reduceActionForPostfixModifiers1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 3).
	result at: 3 put: (nodes at: 4).
	^result!

reduceActionForPrefixModifiers1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 4).
	^result!

reduceActionForPrefixModifiers2: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	result at: 3 put: (nodes at: 2).
	^result!

reduceActionForRewriteExpression1: nodes
	^nodes at: 1!

reduceActionForRewriteExpressions1: nodes
	| result |
	result := OrderedCollection new: 2.
	^result!

reduceActionForRewriteExpressions2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	self add: (nodes at: 2) to: result.
	^result!

reduceActionForStringReplace1: nodes
	| result |
	result := SmaCCStringReplaceExpression new.
	result string: (nodes at: 1).
	^result!

reduceActionForSwitchStateToCode1: nodes
	self state: #code.
	^nil!

reduceActionForSwitchStateToDefault1: nodes
	self state: #default.
	^nil!

reduceActionForSwitchStateToExpression1: nodes
	self state: #expression.
	^nil!

reduceTable
^#(
	#(13 0 #reduceActionForRewriteExpressions1:) 
	#(19 0 #reduceActionForSwitchStateToExpression1:) 
	#(8 0 #reduceActionForSwitchStateToCode1:) 
	#(11 1 #reduceActionForExpression1:) 
	#(9 1 #reduceActionForStringReplace1:) 
	#(20 1 #reduceActionForRewriteExpression1:) 
	#(13 2 #reduceActionForRewriteExpressions2:) 
	#(18 0 #nil) 
	#(15 0 #reduceActionForSwitchStateToDefault1:) 
	#(18 1 #reduceActionForRewriteExpression1:) 
	#(21 0 #nil) 
	#(16 1 #reduceActionForRewriteExpression1:) 
	#(21 1 #reduceActionForRewriteExpression1:) 
	#(22 2 #reduceActionForPrefixModifiers2:) 
	#(17 5 #reduceActionForCodeReplace1:) 
	#(22 4 #reduceActionForPrefixModifiers1:) 
	#(14 2 #reduceActionForPrefixModifiers2:) 
	#(12 7 #reduceActionForNodeReplace1:) 
	#(14 4 #reduceActionForPostfixModifiers1:)
	).!

symbolTypes
	^#(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken nil #SmaCCStringReplaceExpression #SmaCCCompositeReplaceExpression #SmaCCCompositeReplaceExpression #SmaCCNodeReplaceExpression #OrderedCollection #OrderedCollection nil #SmaCCToken #SmaCCCodeReplaceExpression #SmaCCToken nil #SmaCCReplaceExpression #SmaCCToken #OrderedCollection #SmaCCToken #SmaCCToken #SmaCCToken)!

transitionTable
^#(
#[1 0 6 0 5 0 6 0 6 0 6 0 7 0 9 0 11 0 13 0 13 0 6 0 23] 
#[0 0 0 0 23] 
#[1 0 17 0 5 0 10 0 6 0 14 0 7 0 21 0 8 0 25 0 9 0 29 0 12 0 33 0 17 0 37 0 19 0 41 0 20 0 18 0 23] 
#[0 0 22 0 5 0 6 0 7 0 23] 
#[0 0 45 0 7] 
#[0 0 26 0 5 0 6 0 7 0 23] 
#[0 0 26 0 5 0 6 0 7 0 23] 
#[0 0 26 0 5 0 6 0 7 0 23] 
#[0 0 49 0 6] 
#[0 0 30 0 5 0 6 0 7 0 23] 
#[0 0 53 0 25] 
#[1 0 34 0 1 0 57 0 2 0 34 0 3 0 61 0 18 0 65 0 22] 
#[1 0 38 0 7 0 69 0 15] 
#[0 0 42 0 1 0 3 0 6] 
#[1 0 46 0 1 0 73 0 3 0 77 0 16 0 81 0 21] 
#[0 0 85 0 1] 
#[0 0 89 0 7] 
#[0 0 50 0 1 0 2 0 4 0 6] 
#[1 0 54 0 1 0 93 0 4] 
#[0 0 58 0 1] 
#[1 0 46 0 2 0 73 0 3 0 46 0 4 0 46 0 6 0 97 0 14 0 101 0 16 0 105 0 21] 
#[0 0 62 0 5 0 6 0 7 0 23] 
#[1 0 46 0 1 0 73 0 3 0 101 0 16 0 109 0 21] 
#[1 0 38 0 6 0 113 0 15] 
#[0 0 54 0 1 0 2 0 4 0 6] 
#[1 0 57 0 2 0 117 0 4 0 34 0 6 0 121 0 18] 
#[0 0 66 0 1] 
#[0 0 125 0 6] 
#[1 0 73 0 3 0 129 0 16] 
#[0 0 70 0 6] 
#[0 0 74 0 5 0 6 0 7 0 23] 
#[1 0 57 0 2 0 34 0 6 0 133 0 18] 
#[0 0 78 0 6]
	).! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForCodeReplace1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForExpression1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForNodeReplace1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForPostfixModifiers1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForPrefixModifiers1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForPrefixModifiers2:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForRewriteExpression1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForRewriteExpressions1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForRewriteExpressions2:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForStringReplace1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForSwitchStateToCode1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForSwitchStateToDefault1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceActionForSwitchStateToExpression1:!generated-reduction actions!public! !
!SmaCCReplaceExpressionParser categoriesFor: #reduceTable!generated!public! !
!SmaCCReplaceExpressionParser categoriesFor: #symbolTypes!generated!public! !
!SmaCCReplaceExpressionParser categoriesFor: #transitionTable!generated!public! !

!SmaCCReplaceExpressionParser class methodsFor!

definitionComment
"%excludes expression code ;
%id <codeExpression>;

expression <name>
	: (<isLetter> | _) (<isLetter> | _ | <isDigit>) *
	;
expression <newline>
	: \\
	;
expression <special_characters>
	: [\~\!!\@\#\$\%\^\&\*\(\)\-\+\=\|\{\[\]\}\<\,\>\.\?\/\;\:\'\""]+
	;
expression <end_of_expression_character>
	: _
	;
<string>
	: [^`]+
	;
default expression <backquote>
	: `
	;
default code <double_backquote>
	: ``
	;

%prefix SmaCC;
%suffix Expression;
%root Replace;

Expression
	: RewriteExpressions {{CompositeReplace}}
	;
RewriteExpressions
	: 
	| RewriteExpressions RewriteExpression 'expression'
	;
RewriteExpression
	: StringReplace
	| NodeReplace
	| CodeReplace
	;
StringReplace
	: <string> 'string' {{StringReplace}}
	;
NodeReplace
	: SwitchStateToExpression <backquote> PrefixModifiers <name> 'name' PostfixModifiers SwitchStateToDefault <backquote> {{NodeReplace}}
	;
SwitchStateToDefault
	: {self state: #default. nil}
	;
SwitchStateToExpression
	: {self state: #expression. nil}
	;
CodeReplace
	: SwitchStateToCode <double_backquote> <codeExpression> 'code' SwitchStateToDefault <double_backquote> {{CodeReplace}}
	;
SwitchStateToCode
	: {self state: #code. nil}
	;
PrefixModifiers
	: OptionalWhitespace 'beforeWhitespace' Characters 'beforePrefix' <end_of_expression_character> OptionalCharacters 'prefix'
	| OptionalWhitespace 'beforeWhitespace' OptionalCharacters 'prefix'
	;
PostfixModifiers
	: OptionalCharacters 'postfix' <end_of_expression_character> Characters 'afterPostfix' OptionalWhitespace 'afterWhitespace'
	| OptionalCharacters 'postfix' OptionalWhitespace 'afterWhitespace'
	;
OptionalWhitespace
	: 
	| <newline>
	;
OptionalCharacters
	: 
	| Characters
	;
Characters
	: <special_characters> 'characters'
	;"!

scannerClass
	^SmaCCReplaceExpressionScanner!

startingStateForExpression
	^1! !
!SmaCCReplaceExpressionParser class categoriesFor: #definitionComment!generated!public! !
!SmaCCReplaceExpressionParser class categoriesFor: #scannerClass!generated-accessing!public! !
!SmaCCReplaceExpressionParser class categoriesFor: #startingStateForExpression!generated!public! !

SmaCCRewriteRuleFileParser guid: (GUID fromString: '{BEBFE294-5D0F-4E2E-893B-D27785BD0355}')!
SmaCCRewriteRuleFileParser comment: ''!
!SmaCCRewriteRuleFileParser categoriesForClass!Unclassified! !
!SmaCCRewriteRuleFileParser methodsFor!

filename: aString
	filename := aString!

lookupClass: aSmaCCToken
	| string block |
	string := aSmaCCToken value.
	block := [:each | each name asString = string ifTrue: [^each]].
	SmaCCParseNode withAllSubclasses do: block.
	SmaCCParser allSubclassesDo: block.
	^nil!

reduceActionForComment2: nodes
	^((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size - 1) copyReplaceAll: '""' with: '"'!

reduceActionForFile1: nodes
	^nodes at: 1!

reduceActionForImport1: nodes
	^((nodes at: 3) value copyFrom: 2 to: (nodes at: 3) value size - 1) copyReplaceAll: '''''' with: ''''!

reduceActionForMatch1: nodes
	^(SmaCCRewriteTreeMatch new)
		source: (nodes at: 1);
		yourself!

reduceActionForMatch2: nodes
	^(SmaCCRewriteTreeMatch new)
		source: (nodes at: 2);
		startingState: (nodes at: 1) value;
		yourself!

reduceActionForMatch3: nodes
	^SmaCCRewriteTypeMatch on: (self lookupClass: (nodes at: 1))!

reduceActionForMatch4: nodes
	^(SmaCCRewriteTypeMatch on: (self lookupClass: (nodes at: 1)))
		code: (nodes at: 2);
		yourself!

reduceActionForParserClass1: nodes
	^self lookupClass: (nodes at: 3)!

reduceActionForRule1: nodes
	^SmaCCRewrite
		comment: (nodes at: 1)
		match: (nodes at: 2)
		transformation: (nodes at: 4)!

reduceActionForRules1: nodes
	^(SmaCCRewriteFile new)
		filename: filename;
		yourself!

reduceActionForRules2: nodes
	^(nodes at: 1)
		addTransformation: (nodes at: 2);
		yourself!

reduceActionForRules3: nodes
	^(nodes at: 1)
		parserClass: (nodes at: 2);
		yourself!

reduceActionForRules4: nodes
	^(nodes at: 1)
		import: (nodes at: 2);
		yourself!

reduceActionForStartSmalltalkExpression1: nodes
	^self scanSmalltalkExpression!

reduceActionForStartStringExpression1: nodes
	^self scanStringExpression!

reduceActionForTransformation1: nodes
	^SmaCCRewriteStringTransformation on: (nodes at: 1)!

reduceActionForTransformation2: nodes
	^SmaCCRewriteCodeTransformation on: (nodes at: 1)!

reduceTable
^#(
	#(14 0 #reduceActionForRules1:) 
	#(17 0 #nil) 
	#(16 1 #reduceActionForFile1:) 
	#(17 1 #reduceActionForComment2:) 
	#(23 0 #reduceActionForStartStringExpression1:) 
	#(14 2 #reduceActionForRules2:) 
	#(14 2 #reduceActionForRules4:) 
	#(14 2 #reduceActionForRules3:) 
	#(24 0 #reduceActionForStartSmalltalkExpression1:) 
	#(18 1 #reduceActionForMatch3:) 
	#(18 1 #reduceActionForMatch1:) 
	#(27 3 #reduceActionForParserClass1:) 
	#(26 3 #reduceActionForImport1:) 
	#(18 2 #reduceActionForMatch2:) 
	#(18 2 #reduceActionForMatch4:) 
	#(20 4 #reduceActionForRule1:) 
	#(19 1 #reduceActionForTransformation1:) 
	#(19 1 #reduceActionForTransformation2:) 
	#(21 3 #reduceActionForFile1:) 
	#(22 3 #reduceActionForFile1:)
	).!

scanSmalltalkExpression
	^scanner scanSmalltalkExpression!

scanStringExpression
	^scanner scanStringExpression!

transitionTable
^#(
#[1 0 6 0 2 0 6 0 3 0 6 0 7 0 6 0 9 0 6 0 11 0 9 0 14 0 13 0 16 0 6 0 25] 
#[1 0 17 0 2 0 21 0 3 0 10 0 7 0 10 0 9 0 25 0 11 0 29 0 17 0 33 0 20 0 14 0 25 0 37 0 26 0 41 0 27] 
#[0 0 0 0 25] 
#[0 0 45 0 1] 
#[0 0 49 0 1] 
#[0 0 18 0 7 0 9] 
#[1 0 22 0 7 0 53 0 9 0 57 0 18 0 61 0 21 0 65 0 23] 
#[0 0 26 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 30 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 34 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 69 0 9] 
#[0 0 73 0 10] 
#[1 0 38 0 5 0 22 0 7 0 42 0 8 0 77 0 21 0 81 0 22 0 65 0 23 0 85 0 24] 
#[0 0 89 0 8] 
#[0 0 46 0 8] 
#[0 0 93 0 7] 
#[0 0 50 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 54 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 58 0 8] 
#[0 0 62 0 8] 
#[0 0 97 0 5] 
#[1 0 38 0 5 0 22 0 7 0 101 0 19 0 105 0 21 0 109 0 22 0 65 0 23 0 85 0 24] 
#[0 0 113 0 6] 
#[0 0 117 0 4] 
#[0 0 66 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 70 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 74 0 2 0 3 0 7 0 9 0 11 0 25] 
#[0 0 78 0 2 0 3 0 7 0 8 0 9 0 11 0 25] 
#[0 0 82 0 2 0 3 0 7 0 8 0 9 0 11 0 25]
	).!

tryAllTokens
	^true! !
!SmaCCRewriteRuleFileParser categoriesFor: #filename:!private! !
!SmaCCRewriteRuleFileParser categoriesFor: #lookupClass:!private! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForComment2:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForFile1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForImport1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForMatch1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForMatch2:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForMatch3:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForMatch4:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForParserClass1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForRule1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForRules1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForRules2:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForRules3:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForRules4:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForStartSmalltalkExpression1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForStartStringExpression1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForTransformation1:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceActionForTransformation2:!generated-reduction actions!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #reduceTable!generated!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #scanSmalltalkExpression!private! !
!SmaCCRewriteRuleFileParser categoriesFor: #scanStringExpression!private! !
!SmaCCRewriteRuleFileParser categoriesFor: #transitionTable!generated!public! !
!SmaCCRewriteRuleFileParser categoriesFor: #tryAllTokens!private! !

!SmaCCRewriteRuleFileParser class methodsFor!

definitionComment
"<singleName>
	: (<isLetter> | _) (<isLetter> | <isDigit> | _)*
	;
<name>
	: <singleName> (\. <singleName>)*
	;
<string>
	: (\' [^\']* \') +
	;
<cmt>
	: (\""[^\""]*\"")+
	;
<whitespace>
	: <isSeparator>+
	;
File
	: Rules {'1'}
	;
Rules
	: {SmaCCRewriteFile new filename: filename; yourself}
	| Rules Rule {'1' addTransformation: '2'; yourself}
	| Rules ParserClass {'1' parserClass: '2'; yourself}
	| Rules Import {'1' import: '2'; yourself}
	;
ParserClass
	: ""Parser"" "":"" <name> 'name' {self lookupClass: name}
	;
Import
	: ""Import"" "":"" <string> 'name' {(name value copyFrom: 2 to: name value size - 1) copyReplaceAll: '''''' with: ''''}
	;
Rule
	: Comment 'comment' Match 'match' ""->"" Transformation 'transformation' {SmaCCRewrite comment: comment match: match transformation: transformation}
	;
Comment
	: {nil}
	| <cmt> {('1' value copyFrom: 2 to: '1' value size - 1) copyReplaceAll: '""""' with: '""'}
	;
Match
	: StringExpression {SmaCCRewriteTreeMatch new source: '1'; yourself}
	| <name> 'state' StringExpression 'exp' {SmaCCRewriteTreeMatch new source: exp; startingState: state value; yourself}
	| <name> {SmaCCRewriteTypeMatch on: (self lookupClass: '1')}
	| <name> Block {(SmaCCRewriteTypeMatch on: (self lookupClass: '1')) code: '2'; yourself}
	;
StringExpression
	: StartStringExpression 'string' "">>>"" ""<<<"" {string}
	;
Transformation
	: StringExpression {SmaCCRewriteStringTransformation on: '1'}
	| Block {SmaCCRewriteCodeTransformation on: '1'}
	;
Block
	: StartSmalltalkExpression 'string' ""[""  ""]"" {string}
	;
StartStringExpression
	: {self scanStringExpression}
	;
StartSmalltalkExpression
	: {self scanSmalltalkExpression}
	;"!

fileExtension
	^'.rw'!

fileExtensionType
	^'SmaCC Rewrite files'!

parseFile: aString
	| stream |
	stream := FileStream read: aString.
	^[| parser |
	parser := self on: stream.
	parser filename: aString.
	(parser parse)
		filename: aString;
		finishedLoading;
		yourself] ensure: [stream close]!

scannerClass
	^SmaCCRewriteRuleFileScanner!

startingStateForFile
	^1! !
!SmaCCRewriteRuleFileParser class categoriesFor: #definitionComment!generated!public! !
!SmaCCRewriteRuleFileParser class categoriesFor: #fileExtension!file types!public! !
!SmaCCRewriteRuleFileParser class categoriesFor: #fileExtensionType!file types!public! !
!SmaCCRewriteRuleFileParser class categoriesFor: #parseFile:!accessing!private! !
!SmaCCRewriteRuleFileParser class categoriesFor: #scannerClass!generated-accessing!public! !
!SmaCCRewriteRuleFileParser class categoriesFor: #startingStateForFile!generated!public! !

SmaCCRewriteTreeMatch guid: (GUID fromString: '{2E32E284-C060-430E-9B60-88BE4A96ECF4}')!
SmaCCRewriteTreeMatch comment: ''!
!SmaCCRewriteTreeMatch categoriesForClass!Unclassified! !
!SmaCCRewriteTreeMatch methodsFor!

canMatch: aClass
	^self trees anySatisfy: [:each | each class == aClass or: [each isKindOf: SmaCCPatternNode]]!

displayOn: aStream
	aStream nextPutAll: (source isNil ifTrue: ['"Empty"'] ifFalse: [source])!

match: aSmaCCRewriteMatchContext
	| context |
	1
		to: self trees size
		do:
			[:i | 
			context := Dictionary new.
			((trees at: i) match: aSmaCCRewriteMatchContext match inContext: context) ifTrue: [^context]].
	^nil!

saveOn: aStream
	startingState notNil
		ifTrue:
			[aStream
				nextPutAll: startingState;
				cr].
	aStream
		nextPutAll: '>>>';
		nextPutAll: source;
		nextPutAll: '<<<'!

source
	^source!

source: aString
	source := aString.
	trees := nil.
	self modified!

startingState
	^startingState!

startingState: aString
	startingState := aString.
	self modified!

startingStateIndex
	startingState isNil ifTrue: [^1].
	^self parserClass perform: ('startingStateFor' , startingState) asSymbol!

trees
	^trees
		ifNil:
			[trees := [self parserClass parseAndCacheAll: source startingAt: self startingStateIndex]
				on: SmaCCParserError
				do: [:ex | ex return: #()]]! !
!SmaCCRewriteTreeMatch categoriesFor: #canMatch:!public!testing! !
!SmaCCRewriteTreeMatch categoriesFor: #displayOn:!printing!public! !
!SmaCCRewriteTreeMatch categoriesFor: #match:!matching!public! !
!SmaCCRewriteTreeMatch categoriesFor: #saveOn:!public! !
!SmaCCRewriteTreeMatch categoriesFor: #source!public! !
!SmaCCRewriteTreeMatch categoriesFor: #source:!public! !
!SmaCCRewriteTreeMatch categoriesFor: #startingState!public! !
!SmaCCRewriteTreeMatch categoriesFor: #startingState:!public! !
!SmaCCRewriteTreeMatch categoriesFor: #startingStateIndex!initialize-release!private! !
!SmaCCRewriteTreeMatch categoriesFor: #trees!initialize-release!private! !

SmaCCRewriteTypeMatch guid: (GUID fromString: '{62EBBDA7-B126-4F96-9F3D-B2EEC16084EB}')!
SmaCCRewriteTypeMatch comment: ''!
!SmaCCRewriteTypeMatch categoriesForClass!Unclassified! !
!SmaCCRewriteTypeMatch methodsFor!

canMatch: aClass
	^aClass includesBehavior: nodeClass!

code
	^code!

code: aString
	code := aString.
	method := nil.
	self modified!

codeMatches: aSmaCCParseNode
	(code isNil or: [code isEmpty]) ifTrue: [^true].
	^(enableDebug and: [SmaCCRewriteProcessor debug])
		ifTrue: [self methodMatches: aSmaCCParseNode]
		ifFalse: [[self methodMatches: aSmaCCParseNode] on: Error do: [:ex | ex return: false]]!

displayOn: aStream
	aStream nextPutAll: nodeClass name!

enableDebug
	^enableDebug!

enableDebug: aBoolean
	enableDebug := aBoolean!

match: aSmaCCRewriteMatchContext
	| dictionary |
	(aSmaCCRewriteMatchContext match isKindOf: nodeClass) ifFalse: [^nil].
	(self codeMatches: aSmaCCRewriteMatchContext) ifFalse: [^nil].
	dictionary := Dictionary new.
	aSmaCCRewriteMatchContext match
		allGettersDo:
			[:each | dictionary at: (SmaCCPatternToken value: each asString) put: (aSmaCCRewriteMatchContext match perform: each)].
	^dictionary!

method
	method isNil
		ifTrue:
			[| source tree |
			source := 'code ' , code.
			tree := SmalltalkParser parseMethod: source.
			tree body statements isEmpty ifTrue: [^method := Object compiledMethodAt: #notNil].
			tree body addReturn.
			source := tree formattedCode.
			method := [Compiler compile: source in: SmaCCRewriteMatchContext]
				on: CompilerErrorNotification
				do: [:ex | Error signal: ex errorMessage , ' (' , ex range printString , ')'].
			method sourceDescriptor: source].
	^method!

methodMatches: aSmaCCParseNode
	^(self method value: aSmaCCParseNode withArguments: #()) = true!

nodeClass
	^nodeClass!

nodeClass: aClass
	nodeClass := aClass.
	self modified!

saveOn: aStream
	aStream nextPutAll: nodeClass name.
	(code isNil or: [code isEmpty]) ifTrue: [^self].
	aStream
		cr;
		nextPut: $[;
		nextPutAll: code;
		nextPut: $]! !
!SmaCCRewriteTypeMatch categoriesFor: #canMatch:!public!testing! !
!SmaCCRewriteTypeMatch categoriesFor: #code!accessing!private! !
!SmaCCRewriteTypeMatch categoriesFor: #code:!accessing!private! !
!SmaCCRewriteTypeMatch categoriesFor: #codeMatches:!matching!private! !
!SmaCCRewriteTypeMatch categoriesFor: #displayOn:!printing!public! !
!SmaCCRewriteTypeMatch categoriesFor: #enableDebug!accessing!private! !
!SmaCCRewriteTypeMatch categoriesFor: #enableDebug:!accessing!private! !
!SmaCCRewriteTypeMatch categoriesFor: #match:!matching!private! !
!SmaCCRewriteTypeMatch categoriesFor: #method!private! !
!SmaCCRewriteTypeMatch categoriesFor: #methodMatches:!matching!private! !
!SmaCCRewriteTypeMatch categoriesFor: #nodeClass!accessing!private! !
!SmaCCRewriteTypeMatch categoriesFor: #nodeClass:!initialize-release!private! !
!SmaCCRewriteTypeMatch categoriesFor: #saveOn:!public!saving! !

!SmaCCRewriteTypeMatch class methodsFor!

on: aClass
	^(self new)
		enableDebug: false;
		nodeClass: aClass;
		yourself! !
!SmaCCRewriteTypeMatch class categoriesFor: #on:!instance creation!private! !

SmaCCRewriteCompleteResult guid: (GUID fromString: '{49811653-7A02-4E17-8DDA-F1CFAD132ED0}')!
SmaCCRewriteCompleteResult comment: ''!
!SmaCCRewriteCompleteResult categoriesForClass!Kernel-Objects! !
!SmaCCRewriteCompleteResult methodsFor!

inputSource
	^inputSource!

inputSource: aString
	inputSource := aString!

outputSource
	^outputSource!

outputSource: aString
	outputSource := aString!

smaccStringClass
	^SmaCCAnnotatedString!

transformedString
	^transformedString!

transformedString: aSmaCCAnnotatedString
	transformedString := aSmaCCAnnotatedString! !
!SmaCCRewriteCompleteResult categoriesFor: #inputSource!accessing!private! !
!SmaCCRewriteCompleteResult categoriesFor: #inputSource:!accessing!private! !
!SmaCCRewriteCompleteResult categoriesFor: #outputSource!accessing!private! !
!SmaCCRewriteCompleteResult categoriesFor: #outputSource:!accessing!private! !
!SmaCCRewriteCompleteResult categoriesFor: #smaccStringClass!accessing!public! !
!SmaCCRewriteCompleteResult categoriesFor: #transformedString!accessing!private! !
!SmaCCRewriteCompleteResult categoriesFor: #transformedString:!accessing!private! !

SmaCCRewriteCodeTransformation guid: (GUID fromString: '{B224CD86-2160-4BA9-A494-3F2513629EF2}')!
SmaCCRewriteCodeTransformation comment: ''!
!SmaCCRewriteCodeTransformation categoriesForClass!Unclassified! !
!SmaCCRewriteCodeTransformation methodsFor!

code
	^code!

code: aString
	code := aString.
	method := nil.
	self modified!

method
	method isNil
		ifTrue:
			[| source tree rewriter |
			source := 'code ' , code.
			tree := SmalltalkParser parseMethod: source.
			tree body addReturn.
			rewriter := ParseTreeRewriter new.
			rewriter replace: '^self continue' with: '^Continue'.
			rewriter executeTree: tree.
			method := [Compiler compile: rewriter tree formattedCode in: SmaCCRewriteMatchContext]
				on: CompilerErrorNotification
				do: [:ex | Error signal: ex errorMessage , ' (' , ex range printString , ')'].
			method sourceDescriptor: rewriter tree formattedCode].
	^method!

saveOn: aStream
	aStream
		nextPut: $[;
		nextPutAll: code;
		nextPut: $]!

transformUsingContext: aSmaCCRewriteMatchContext
	(SmaCCRewriteProcessor haltBlock value: rewrite value: aSmaCCRewriteMatchContext match)
		ifTrue:
			[Processor activeProcess
				debug: 'Debugging ' , rewrite displayString
				topFrame: Processor activeProcess topFrame
				resumable: true].
	^self method value: aSmaCCRewriteMatchContext withArguments: #()! !
!SmaCCRewriteCodeTransformation categoriesFor: #code!accessing!private! !
!SmaCCRewriteCodeTransformation categoriesFor: #code:!initialize-release!private! !
!SmaCCRewriteCodeTransformation categoriesFor: #method!accessing!private! !
!SmaCCRewriteCodeTransformation categoriesFor: #saveOn:!public!saving! !
!SmaCCRewriteCodeTransformation categoriesFor: #transformUsingContext:!public!transforming! !

!SmaCCRewriteCodeTransformation class methodsFor!

on: aString
	^(self new)
		code: aString;
		yourself! !
!SmaCCRewriteCodeTransformation class categoriesFor: #on:!instance creation!private! !

SmaCCRewriteStringTransformation guid: (GUID fromString: '{B50B5E7A-1C89-4D44-9EA2-321014B4EC74}')!
SmaCCRewriteStringTransformation comment: ''!
!SmaCCRewriteStringTransformation categoriesForClass!Unclassified! !
!SmaCCRewriteStringTransformation methodsFor!

expression
	^expression ifNil: [expression := SmaCCReplaceExpressionParser parse: self string]!

saveOn: aStream
	aStream
		nextPutAll: '>>>';
		nextPutAll: self string;
		nextPutAll: '<<<'!

string
	^string ifNil: ['']!

string: aString
	string := aString.
	expression := nil.
	self modified!

transformUsingContext: aSmaCCRewriteMatchContext
	| newSource |
	newSource := self expression evaluateInContext: aSmaCCRewriteMatchContext.
	aSmaCCRewriteMatchContext replace: aSmaCCRewriteMatchContext match with: newSource! !
!SmaCCRewriteStringTransformation categoriesFor: #expression!accessing!private! !
!SmaCCRewriteStringTransformation categoriesFor: #saveOn:!public! !
!SmaCCRewriteStringTransformation categoriesFor: #string!initialize-release!private! !
!SmaCCRewriteStringTransformation categoriesFor: #string:!initialize-release!private! !
!SmaCCRewriteStringTransformation categoriesFor: #transformUsingContext:!private!transforming! !

!SmaCCRewriteStringTransformation class methodsFor!

on: aString
	^(self new)
		string: aString;
		yourself! !
!SmaCCRewriteStringTransformation class categoriesFor: #on:!instance creation!private! !

SmaCCReplaceExpressionScanner guid: (GUID fromString: '{0CAA4988-4DD7-42C3-A7D1-CB14A7AB5D7E}')!
SmaCCReplaceExpressionScanner comment: ''!
!SmaCCReplaceExpressionScanner categoriesForClass!Unclassified! !
!SmaCCReplaceExpressionScanner methodsFor!

codeExpressionId
	^25!

emptySymbolTokenId
	^23!

errorTokenId
	^24!

isValidCode
	SmalltalkParser parseExpression: outputStream contents onError: [:s :p | ^false].
	^true!

next
	state = #code
		ifTrue:
			[self resetScanner.
			returnMatchBlock := [:match | ^match].
			^self scanCode].
	^super next!

scanCode
	outputStream reset.
	[outputStream nextPutAll: (stream upTo: $`).
	stream peek == $`
		ifTrue:
			[self isValidCode
				ifTrue:
					[stream skip: -1.
					state := #default.
					^self recordAndReportMatch: (Array with: self codeExpressionId)]].
	stream atEnd ifTrue: [^self reportLastMatch].
	outputStream nextPut: $`] repeat!

scanForToken
	state == #expression
		ifTrue:
			[self step.
			currentCharacter == $\ ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $_
				ifTrue:
					[self recordMatch: #(1 4).
					self step.
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(1).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $` ifTrue: [^self recordAndReportMatch: #(6)].
			((currentCharacter between: $!! and: $/)
				or:
					[(currentCharacter between: $: and: $@)
						or:
							[currentCharacter == $[ or: [(currentCharacter between: $] and: $^) or: [currentCharacter between: ${ and: $~]]]])
				ifTrue:
					[[self recordMatch: #(3).
					self step.
					(currentCharacter between: $!! and: $/)
						or:
							[(currentCharacter between: $: and: $@)
								or:
									[currentCharacter == $[ or: [(currentCharacter between: $] and: $^) or: [currentCharacter between: ${ and: $~]]]]]
						whileTrue.
					^self reportLastMatch].
			currentCharacter isLetter
				ifTrue:
					[[self recordMatch: #(1).
					self step.
					currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
			^self reportLastMatch].
	state == #default
		ifTrue:
			[self step.
			currentCharacter == $`
				ifTrue:
					[self recordMatch: #(6).
					self step.
					currentCharacter == $` ifTrue: [^self recordAndReportMatch: #(7)].
					^self reportLastMatch].
			true
				ifTrue:
					[[self recordMatch: #(5).
					self step.
					currentCharacter ~~ $`] whileTrue].
			^self reportLastMatch].
	state == #code ifTrue: [(self scanForString: '``') ifTrue: [^self recordAndReportMatch: #(7)]].
	^self reportLastMatch! !
!SmaCCReplaceExpressionScanner categoriesFor: #codeExpressionId!generated!public! !
!SmaCCReplaceExpressionScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!SmaCCReplaceExpressionScanner categoriesFor: #errorTokenId!generated!public! !
!SmaCCReplaceExpressionScanner categoriesFor: #isValidCode!public!testing! !
!SmaCCReplaceExpressionScanner categoriesFor: #next!accessing!private! !
!SmaCCReplaceExpressionScanner categoriesFor: #scanCode!private! !
!SmaCCReplaceExpressionScanner categoriesFor: #scanForToken!generated!public! !

SmaCCRewriteRuleFileScanner guid: (GUID fromString: '{D1040282-D228-4CB4-893D-FA3B9359531A}')!
SmaCCRewriteRuleFileScanner comment: ''!
!SmaCCRewriteRuleFileScanner categoriesForClass!Unclassified! !
!SmaCCRewriteRuleFileScanner methodsFor!

emptySymbolTokenId
	^25!

errorTokenId
	^13!

fixExpression: expression
	| rewriter tree |
	rewriter := self class rewriter.
	rewriter isNil ifTrue: [^expression].
	tree := SmalltalkParser parseExpression: expression.
	[rewriter executeTree: tree] whileTrue: [tree := rewriter tree].
	^tree formattedCode!

isValidSmalltalk: aString
	SmalltalkParser parseExpression: aString onError: [:e :p | ^false].
	^true!

scan1
	[self step.
	currentCharacter == $"
		ifTrue:
			[self recordMatch: #(11).
			self step.
			currentCharacter == $" ifTrue: [^self scan1].
			^self reportLastMatch]] repeat!

scan2
	[self step.
	currentCharacter == $'
		ifTrue:
			[self recordMatch: #(10).
			self step.
			currentCharacter == $' ifTrue: [^self scan2].
			^self reportLastMatch]] repeat!

scan3
	[self recordMatch: #(9).
	self step.
	currentCharacter == $.
		ifTrue:
			[self step.
			(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan3].
			^self reportLastMatch].
	currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue.
	^self reportLastMatch!

scanForToken
	self step.
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $' ifTrue: [^self scan2].
	currentCharacter == $-
		ifTrue:
			[self step.
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(8)].
			^self reportLastMatch].
	currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(1)].
	currentCharacter == $<
		ifTrue:
			[(self scanForString: '<<') ifTrue: [^self recordAndReportMatch: #(6)].
			^self reportLastMatch].
	currentCharacter == $>
		ifTrue:
			[(self scanForString: '>>') ifTrue: [^self recordAndReportMatch: #(7)].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(4)].
	currentCharacter isWhitespace
		ifTrue:
			[[self recordMatch: #(12).
			self step.
			currentCharacter isWhitespace] whileTrue.
			^self reportLastMatch].
	(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan3].
	^self reportLastMatch!

scanSmalltalkExpression
	| expression |
	expression := ''.
	[stream atEnd ifTrue: [self error: 'Invalid Smalltalk expression'].
	expression := expression , (stream upTo: $]).
	self isValidSmalltalk: expression] whileFalse: [expression := expression copyWith: $]].
	stream skip: -1.
	^self fixExpression: expression!

scanStringExpression
	| string |
	string := stream upToAll: '<<<'.
	stream skip: -3.
	^string!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil #whitespace)! !
!SmaCCRewriteRuleFileScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #errorTokenId!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #fixExpression:!private! !
!SmaCCRewriteRuleFileScanner categoriesFor: #isValidSmalltalk:!private! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scan1!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scan2!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scan3!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scanForToken!generated!public! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scanSmalltalkExpression!private! !
!SmaCCRewriteRuleFileScanner categoriesFor: #scanStringExpression!private! !
!SmaCCRewriteRuleFileScanner categoriesFor: #tokenActions!generated!public! !

!SmaCCRewriteRuleFileScanner class methodsFor!

initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(9 'Import' 3) #(9 'Parser' 2))
		do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last].
	^keywordMap!

rewriter
	^rewriter!

rewriter: aParseTreeRewriter
	rewriter := aParseTreeRewriter! !
!SmaCCRewriteRuleFileScanner class categoriesFor: #initializeKeywordMap!generated-initialization!public! !
!SmaCCRewriteRuleFileScanner class categoriesFor: #rewriter!accessing!private! !
!SmaCCRewriteRuleFileScanner class categoriesFor: #rewriter:!accessing!private! !

SmaCCAnnotatedString guid: (GUID fromString: '{2D8DE1CE-C717-411B-AAE7-9159FB0E0D4C}')!
SmaCCAnnotatedString comment: ''!
!SmaCCAnnotatedString categoriesForClass!Unclassified! !
!SmaCCAnnotatedString methodsFor!

addAnnotationTo: aSmaCCAnnotatedStringInterval
	(node isNil or: [rule isNil]) ifTrue: [^self].
	aSmaCCAnnotatedStringInterval addAnnotation: (SmaCCRewriteAnnotation onNode: node rewrite: rule)!

intervalClass
	^SmaCCAnnotatedStringInterval!

newIntervalFor: aString
	| interval |
	interval := super newIntervalFor: aString.
	self addAnnotationTo: interval.
	^interval!

node
	^node!

node: aSmaCCParseNode
	node := aSmaCCParseNode!

removeInterval: startInterval
	| result |
	result := super removeInterval: startInterval.
	self addAnnotationTo: result.
	^result!

rule
	^rule!

rule: aSmaCCRewrite
	rule := aSmaCCRewrite! !
!SmaCCAnnotatedString categoriesFor: #addAnnotationTo:!public! !
!SmaCCAnnotatedString categoriesFor: #intervalClass!public! !
!SmaCCAnnotatedString categoriesFor: #newIntervalFor:!public! !
!SmaCCAnnotatedString categoriesFor: #node!accessing!private! !
!SmaCCAnnotatedString categoriesFor: #node:!accessing!private! !
!SmaCCAnnotatedString categoriesFor: #removeInterval:!public! !
!SmaCCAnnotatedString categoriesFor: #rule!accessing!private! !
!SmaCCAnnotatedString categoriesFor: #rule:!accessing!private! !

SmaCCAnnotatedStringInterval guid: (GUID fromString: '{DC95DEB8-D6E7-4D39-88A5-1FBCC844BAD9}')!
SmaCCAnnotatedStringInterval comment: ''!
!SmaCCAnnotatedStringInterval categoriesForClass!Unclassified! !
!SmaCCAnnotatedStringInterval methodsFor!

addAllAnnotations: aCollection
	self annotations addAll: aCollection!

addAnnotation: aSmaCCRewriteAnnotation
	| collection |
	collection := self annotations.
	(collection notEmpty and: [collection last = aSmaCCRewriteAnnotation]) ifTrue: [^self].
	collection add: aSmaCCRewriteAnnotation!

annotations
	^annotations ifNil: [annotations := OrderedCollection new: 2]!

annotations: aSequenceableCollection
	annotations := aSequenceableCollection!

canBeMergedWith: nextSmaCCStringInterval
	"We want to keep the annotations, so we don't allow merging"

	^false!

postCopy
	super postCopy.
	annotations := annotations copy! !
!SmaCCAnnotatedStringInterval categoriesFor: #addAllAnnotations:!public! !
!SmaCCAnnotatedStringInterval categoriesFor: #addAnnotation:!public! !
!SmaCCAnnotatedStringInterval categoriesFor: #annotations!public! !
!SmaCCAnnotatedStringInterval categoriesFor: #annotations:!public! !
!SmaCCAnnotatedStringInterval categoriesFor: #canBeMergedWith:!public!testing! !
!SmaCCAnnotatedStringInterval categoriesFor: #postCopy!public!testing! !

"Binary Globals"!

