| package |
package := Package name: 'SmaCC Server Session'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains a session manager that is used by both the rewrite server and rewriter worker.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.'.


package classNames
	add: #SmaCCServerSessionManager;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\..\Object Arts\Dolphin\MVP\Base\Dolphin MVP Base';
	add: '..\US NotifyView';
	yourself).

package!

"Class Definitions"!

RuntimeSessionManager subclass: #SmaCCServerSessionManager
	instanceVariableNames: 'notifyIcon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SmaCCServerSessionManager guid: (GUID fromString: '{C31B4EF7-F124-4CC7-AB04-DEAB93FF80B6}')!
SmaCCServerSessionManager comment: ''!
!SmaCCServerSessionManager categoriesForClass!System-Support! !
!SmaCCServerSessionManager methodsFor!

arguments
	| arguments |
	arguments := OrderedCollection new.
	2
		to: self argc
		do:
			[:i | 
			| arg |
			arg := self argv at: i.
			('/-' includes: arg first) ifFalse: [arguments add: arg]].
	^arguments!

keepAlive!

main
	self showNotifyView.
	[self startServer] fork!

menu
	| menu |
	menu := Menu new.
	menu text: 'Server'.
	menu
		addItem:
			(CommandMenuItem
				commandDescription:
					(ClosedCommandDescription
						command: #exit
						description: 'E&xit'
						receiver: self)).
	^menu!

notifyIcon
	^nil!

notifyMessage
	^'Running'!

onExit
	notifyIcon notNil ifTrue: [notifyIcon hide].
	^super onExit!

showNotifyView
	notifyIcon := NotifyAreaIcon icon: self notifyIcon message: self notifyMessage.
	notifyIcon
		when: #rightButtonPressed
		send: #showTrayMenu
		to: self.
	notifyIcon show!

showTrayMenu
	self menu showIn: NotifyAreaView default position: Cursor position!

startServer
	self subclassResponsibility! !
!SmaCCServerSessionManager categoriesFor: #arguments!public! !
!SmaCCServerSessionManager categoriesFor: #keepAlive!public! !
!SmaCCServerSessionManager categoriesFor: #main!public! !
!SmaCCServerSessionManager categoriesFor: #menu!public! !
!SmaCCServerSessionManager categoriesFor: #notifyIcon!public! !
!SmaCCServerSessionManager categoriesFor: #notifyMessage!public! !
!SmaCCServerSessionManager categoriesFor: #onExit!public! !
!SmaCCServerSessionManager categoriesFor: #showNotifyView!public! !
!SmaCCServerSessionManager categoriesFor: #showTrayMenu!public! !
!SmaCCServerSessionManager categoriesFor: #startServer!public! !

"Binary Globals"!

