| package |
package := Package name: 'SmaCC CSharp'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains an example C# parser.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #CSAddAccessorDeclarationNode;
	add: #CSAnonymousFunctionParameterNode;
	add: #CSAnonymousMethodExpressionNode;
	add: #CSAnonymousObjectCreationExpressionNode;
	add: #CSArgumentNode;
	add: #CSArrayCreationExpressionNode;
	add: #CSArrayInitializerNode;
	add: #CSArrayParameterNode;
	add: #CSArrayTypeNode;
	add: #CSAssignmentNode;
	add: #CSAttributeNode;
	add: #CSAttributeValueNode;
	add: #CSBaseAccessNode;
	add: #CSBinaryExpressionNode;
	add: #CSBlockStatementNode;
	add: #CSBreakStatementNode;
	add: #CSCastExpressionNode;
	add: #CSCheckedExpressionNode;
	add: #CSCheckedStatementNode;
	add: #CSClassDeclarationNode;
	add: #CSCollectionInitializerNode;
	add: #CSCompilationUnitNode;
	add: #CSConditionalExpressionNode;
	add: #CSConstantDeclarationNode;
	add: #CSConstantDeclaratorNode;
	add: #CSConstDeclaratorNode;
	add: #CSConstructorConstraintNode;
	add: #CSConstructorDeclarationNode;
	add: #CSConstructorInitializerNode;
	add: #CSContinueStatementNode;
	add: #CSDeclarationNode;
	add: #CSDeclarationStatementNode;
	add: #CSDefaultValueExpressionNode;
	add: #CSDelegateCreationExpressionNode;
	add: #CSDelegateDeclarationNode;
	add: #CSDestructorDeclarationNode;
	add: #CSDoStatementNode;
	add: #CSElementAccessNode;
	add: #CSElementInitializerNode;
	add: #CSEmptyStatementNode;
	add: #CSEnumDeclarationNode;
	add: #CSEventDeclarationNode;
	add: #CSExplicitAnonymousFunctionSignatureNode;
	add: #CSExpressionNode;
	add: #CSExpressionStatementNode;
	add: #CSExternAliasDirectiveNode;
	add: #CSFieldDeclarationNode;
	add: #CSFinallyClauseNode;
	add: #CSFixedParameterNode;
	add: #CSFixedPointerDeclaratorNode;
	add: #CSFixedSizeBufferDeclarationNode;
	add: #CSFixedSizeBufferDeclaratorNode;
	add: #CSFixedStatementNode;
	add: #CSForeachStatementNode;
	add: #CSForStatementNode;
	add: #CSGeneralCatchClauseNode;
	add: #CSGetAccessorDeclarationNode;
	add: #CSGotoStatementNode;
	add: #CSharpParser;
	add: #CSharpScanner;
	add: #CSIfStatementNode;
	add: #CSImplicitAnonymousFunctionSignatureNode;
	add: #CSIndexerDeclarationNode;
	add: #CSInterfaceDeclarationNode;
	add: #CSInterfaceEventDeclarationNode;
	add: #CSInterfaceIndexerDeclarationNode;
	add: #CSInterfaceMethodDeclarationNode;
	add: #CSInterfacePropertyAccessorNode;
	add: #CSInterfacePropertyDeclarationNode;
	add: #CSInvocationExpressionNode;
	add: #CSLabeledStatementNode;
	add: #CSLambdaExpressionNode;
	add: #CSLiteralExpressionNode;
	add: #CSLocalConstantDeclarationNode;
	add: #CSLocalVariableDeclarationNode;
	add: #CSLocalVariableDeclaratorNode;
	add: #CSLockStatementNode;
	add: #CSMemberAccessNode;
	add: #CSMemberDeclaratorNode;
	add: #CSMemberInitializerNode;
	add: #CSMethodBodyNode;
	add: #CSMethodDeclarationNode;
	add: #CSMethodHeaderNode;
	add: #CSNamedArgumentNode;
	add: #CSNamespaceDeclarationNode;
	add: #CSNullableTypeNode;
	add: #CSObjectCreationExpressionNode;
	add: #CSObjectInitializerNode;
	add: #CSOperatorDeclarationNode;
	add: #CSPointerElementAccessNode;
	add: #CSPointerMemberAccessNode;
	add: #CSPointerTypeNode;
	add: #CSPostExpressionNode;
	add: #CSPrefixExpressionNode;
	add: #CSPrimaryConstraintNode;
	add: #CSProgramNode;
	add: #CSProgramNodeVisitor;
	add: #CSPropertyDeclarationNode;
	add: #CSQualifiedAliasMemberNode;
	add: #CSQualifiedIdentifierNode;
	add: #CSQueryExpressionNode;
	add: #CSRankSpecifierNode;
	add: #CSRemoveAccessorDeclarationNode;
	add: #CSReturnStatementNode;
	add: #CSSetAccessorDeclarationNode;
	add: #CSSimpleNameNode;
	add: #CSSimpleTypeNode;
	add: #CSSizeofExpressionNode;
	add: #CSSpecificCatchClauseNode;
	add: #CSStackallocInitializerNode;
	add: #CSStatementListNode;
	add: #CSStatementNode;
	add: #CSStaticConstructorDeclarationNode;
	add: #CSStructDeclarationNode;
	add: #CSSwitchLabelNode;
	add: #CSSwitchSectionNode;
	add: #CSSwitchStatementNode;
	add: #CSThisAccessNode;
	add: #CSThrowStatementNode;
	add: #CSTryStatementNode;
	add: #CSTypeArgumentListNode;
	add: #CSTypeConstraintNode;
	add: #CSTypeNameNode;
	add: #CSTypeNode;
	add: #CSTypeofExpressionNode;
	add: #CSTypeParameterConstraintsClauseNode;
	add: #CSTypeParameterListNode;
	add: #CSUnboundTypeNameNode;
	add: #CSUncheckedExpressionNode;
	add: #CSUncheckedStatementNode;
	add: #CSUnsafeStatementNode;
	add: #CSUsingAliasDirectiveNode;
	add: #CSUsingNamespaceDirectiveNode;
	add: #CSUsingStatementNode;
	add: #CSVariableDeclaratorNode;
	add: #CSVarTypeNode;
	add: #CSVoidTypeNode;
	add: #CSWhileStatementNode;
	add: #CSYieldStatementNode;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\SmaCC GLR Runtime\SmaCC GLR Runtime';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	yourself).

package!

"Class Definitions"!

SmaCCParseNode subclass: #CSProgramNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSAddAccessorDeclarationNode
	instanceVariableNames: '_attributes addToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSAnonymousFunctionParameterNode
	instanceVariableNames: 'modifier type name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSArgumentNode
	instanceVariableNames: 'expression refToken outToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSArrayInitializerNode
	instanceVariableNames: 'leftBraceToken initializers commaTokens rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSArrayParameterNode
	instanceVariableNames: '_attributes paramsToken type name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSAttributeNode
	instanceVariableNames: 'leftBracket target colon attributeValues commas rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSAttributeValueNode
	instanceVariableNames: 'name leftParen arguments commas rightParen'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSCollectionInitializerNode
	instanceVariableNames: 'leftBraceToken initializers commaTokens rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSCompilationUnitNode
	instanceVariableNames: 'directives _attributes declarations'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSConstantDeclaratorNode
	instanceVariableNames: 'identifierToken equalToken expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSConstDeclaratorNode
	instanceVariableNames: 'name equalToken expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSConstructorConstraintNode
	instanceVariableNames: 'newToken leftParenToken rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSConstructorInitializerNode
	instanceVariableNames: 'colonToken baseToken leftParenToken arguments commaTokens rightParenToken thisToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSDeclarationNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSElementInitializerNode
	instanceVariableNames: 'expressions leftBraceToken commaTokens rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSExplicitAnonymousFunctionSignatureNode
	instanceVariableNames: 'leftParenToken parameters commaTokens rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSExpressionNode
	instanceVariableNames: '_leftParens _rightParens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSExternAliasDirectiveNode
	instanceVariableNames: 'externToken aliasToken identifierToken semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSFinallyClauseNode
	instanceVariableNames: 'finallyToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSFixedParameterNode
	instanceVariableNames: '_attributes modifier type name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSFixedPointerDeclaratorNode
	instanceVariableNames: 'identifierToken equalToken andToken expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSFixedSizeBufferDeclaratorNode
	instanceVariableNames: 'name leftBracketToken expression rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSGeneralCatchClauseNode
	instanceVariableNames: 'catchToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSGetAccessorDeclarationNode
	instanceVariableNames: '_attributes modifiers getToken body semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSImplicitAnonymousFunctionSignatureNode
	instanceVariableNames: 'leftParenToken names commaTokens rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSInterfacePropertyAccessorNode
	instanceVariableNames: '_attributes accessorType semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSLocalVariableDeclaratorNode
	instanceVariableNames: 'name equalToken expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSMemberDeclaratorNode
	instanceVariableNames: 'name access identifierToken equalToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSMemberInitializerNode
	instanceVariableNames: 'identifier equalToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSMethodBodyNode
	instanceVariableNames: 'block semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSMethodHeaderNode
	instanceVariableNames: '_attributes modifiers partialToken returnType name interface periodToken typeParameters leftParenToken parameters commas rightParenToken constraintClauses'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSNamedArgumentNode
	instanceVariableNames: 'name equal value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSObjectInitializerNode
	instanceVariableNames: 'leftBraceToken initializers commaTokens rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSPrimaryConstraintNode
	instanceVariableNames: 'classToken structToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSQualifiedIdentifierNode
	instanceVariableNames: 'names periodTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSRankSpecifierNode
	instanceVariableNames: 'leftBracketToken commaTokens rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSRemoveAccessorDeclarationNode
	instanceVariableNames: '_attributes removeToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSSetAccessorDeclarationNode
	instanceVariableNames: '_attributes modifiers setToken body semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSSpecificCatchClauseNode
	instanceVariableNames: 'catchToken leftParenToken type name rightParenToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSStackallocInitializerNode
	instanceVariableNames: 'stackallocToken type leftBracketToken expression rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSStatementListNode
	instanceVariableNames: 'expressions commaTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSStatementNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSSwitchLabelNode
	instanceVariableNames: 'caseToken expression colonToken defaultToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSSwitchSectionNode
	instanceVariableNames: 'labels statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSTypeArgumentListNode
	instanceVariableNames: 'lessThanToken types commaTokens greaterThanToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSTypeConstraintNode
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSTypeParameterConstraintsClauseNode
	instanceVariableNames: 'whereToken parameter colon constraints commaTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSTypeParameterListNode
	instanceVariableNames: 'lessThan _attributes parameters commaTokens greaterThan'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSUnboundTypeNameNode
	instanceVariableNames: 'identifierTokens lessThanTokens commas gtTokens colonColonToken periodTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSUsingAliasDirectiveNode
	instanceVariableNames: 'usingToken name equalToken namespace semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSUsingNamespaceDirectiveNode
	instanceVariableNames: 'usingToken namespace semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSProgramNode subclass: #CSVariableDeclaratorNode
	instanceVariableNames: 'identifierToken equalToken initializer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSClassDeclarationNode
	instanceVariableNames: '_attributes modifiers partialToken classToken name typeParameters colonToken supertypes commas commaToken constraintClauses leftBraceToken declarations rightBraceToken semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSConstantDeclarationNode
	instanceVariableNames: '_attributes modifiers constToken type declarators commaTokens semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSConstructorDeclarationNode
	instanceVariableNames: '_attributes modifiers identifierToken leftParenToken parameters commas rightParenToken initializer block semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSDelegateDeclarationNode
	instanceVariableNames: '_attributes modifiers delegateToken type name typeParameters leftParen parameters commas rightParen constraintClauses semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSDestructorDeclarationNode
	instanceVariableNames: '_attributes modifiers tildeToken identifierToken leftParenToken rightParenToken body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSEnumDeclarationNode
	instanceVariableNames: '_attributes modifiers enumToken name colonToken type leftBrace declarations commas rightBrace semicolon equal value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSEventDeclarationNode
	instanceVariableNames: '_attributes modifiers eventToken type declarators commaTokens semicolonToken name interface periodToken leftBraceToken addDeclaration removeDeclaration rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSFieldDeclarationNode
	instanceVariableNames: '_attributes newTokens publicTokens protectedTokens internalTokens privateTokens staticTokens readonlyTokens volatileTokens unsafeTokens type declarators commaTokens semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSFixedSizeBufferDeclarationNode
	instanceVariableNames: '_attributes modifiers fixedToken type declarators semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSIndexerDeclarationNode
	instanceVariableNames: '_attributes modifiers returnType thisToken leftBracketToken parameters commas rightBracketToken type periodToken leftBraceToken getAccessor setAccessor rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSInterfaceDeclarationNode
	instanceVariableNames: '_attributes modifiers partialToken interfaceToken name typeParameters colon supertypes commas constraintClauses leftBrace declarations rightBrace semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSInterfaceEventDeclarationNode
	instanceVariableNames: '_attributes modifier eventToken type name semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSInterfaceIndexerDeclarationNode
	instanceVariableNames: '_attributes modifier type thisToken leftBracket parameters commas rightBracket leftBrace getAccessor setAccessor rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSInterfaceMethodDeclarationNode
	instanceVariableNames: '_attributes modifier type name typeParameters leftParen parameters commas rightParen constraintClauses semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSInterfacePropertyDeclarationNode
	instanceVariableNames: '_attributes modifier type name leftBrace getAccessor setAccessor rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSLocalConstantDeclarationNode
	instanceVariableNames: 'constToken type declarators commaTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSLocalVariableDeclarationNode
	instanceVariableNames: 'type declarators commaTokens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSMethodDeclarationNode
	instanceVariableNames: 'header body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSNamespaceDeclarationNode
	instanceVariableNames: 'namespaceToken identifier leftBraceToken directives declarations rightBraceToken semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSOperatorDeclarationNode
	instanceVariableNames: '_attributes modifiers returnType operatorToken operator leftParenToken types arguments rightParenToken commaToken implicitToken explicitToken body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSPropertyDeclarationNode
	instanceVariableNames: '_attributes modifiers type name interface periodToken leftBraceToken getAccessor setAccessor rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSStaticConstructorDeclarationNode
	instanceVariableNames: '_attributes modifiers staticToken unsafeToken identifierToken leftParenToken rightParenToken block semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSDeclarationNode subclass: #CSStructDeclarationNode
	instanceVariableNames: '_attributes modifiers partialToken structToken identifierToken typeParameters colonToken supertypes commas constraintClauses leftBraceToken declarations rightBraceToken semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSAnonymousMethodExpressionNode
	instanceVariableNames: 'delegateToken signature block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSAnonymousObjectCreationExpressionNode
	instanceVariableNames: 'newToken leftBraceToken declarators commaTokens rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSArrayCreationExpressionNode
	instanceVariableNames: 'newToken type leftBracketToken expressions commaTokens rightBracketToken rankSpecifiers arrayInitializer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSAssignmentNode
	instanceVariableNames: 'lhs operator rhs'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSBaseAccessNode
	instanceVariableNames: 'baseToken periodToken identifier leftBracketToken expressions commaTokens rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSBinaryExpressionNode
	instanceVariableNames: 'left operator right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSCastExpressionNode
	instanceVariableNames: 'leftParenToken type rightParenToken expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSCheckedExpressionNode
	instanceVariableNames: 'checkedToken leftParenToken expression rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSConditionalExpressionNode
	instanceVariableNames: 'booleanExpression questionMarkToken trueExpression colonToken falseExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSDefaultValueExpressionNode
	instanceVariableNames: 'defaultToken leftParenToken type rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSDelegateCreationExpressionNode
	instanceVariableNames: 'newToken type leftParenToken expression rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSElementAccessNode
	instanceVariableNames: 'baseExpression leftBracketToken expressions commaTokens rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSInvocationExpressionNode
	instanceVariableNames: 'expression leftParenToken arguments commaTokens rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSLambdaExpressionNode
	instanceVariableNames: 'signature equalGreaterThanToken body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSLiteralExpressionNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSMemberAccessNode
	instanceVariableNames: 'expression periodToken identifier typeArguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSObjectCreationExpressionNode
	instanceVariableNames: 'newToken type leftParenToken arguments commaTokens rightParenToken initializer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSPointerElementAccessNode
	instanceVariableNames: 'expression leftBracketToken indexExpression rightBracketToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSPointerMemberAccessNode
	instanceVariableNames: 'expression arrowToken name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSPostExpressionNode
	instanceVariableNames: 'expression operator'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSPrefixExpressionNode
	instanceVariableNames: 'operator expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSQueryExpressionNode
	instanceVariableNames: 'fromTokens types identifierTokens inTokens expressions letTokens equalTokens whereTokens joinTokens joinInExpressions onTokens joinOnExpressions equalsTokens joinEqualsExpressions intoTokens orderbyTokens ascendingTokens descendingTokens commaTokens selectTokens groupTokens groupExpressions byTokens groupByExpressions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSSimpleNameNode
	instanceVariableNames: 'identifierToken typeArguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSSizeofExpressionNode
	instanceVariableNames: 'sizeofToken leftParenToken type rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSThisAccessNode
	instanceVariableNames: 'thisToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSTypeofExpressionNode
	instanceVariableNames: 'typeofToken leftParenToken type rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSExpressionNode subclass: #CSUncheckedExpressionNode
	instanceVariableNames: 'uncheckedToken leftParenToken expression rightParenToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSBlockStatementNode
	instanceVariableNames: 'leftBraceToken statements rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSBreakStatementNode
	instanceVariableNames: 'breakToken semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSCheckedStatementNode
	instanceVariableNames: 'checkedToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSContinueStatementNode
	instanceVariableNames: 'continueToken semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSDeclarationStatementNode
	instanceVariableNames: 'declaration semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSDoStatementNode
	instanceVariableNames: 'doToken statement whileToken leftParenToken expression rightParenToken semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSEmptyStatementNode
	instanceVariableNames: 'semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSExpressionStatementNode
	instanceVariableNames: 'expression semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSFixedStatementNode
	instanceVariableNames: 'fixedToken leftParenToken type declarators commaTokens rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSForeachStatementNode
	instanceVariableNames: 'foreachToken leftParenToken type name inToken expression rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSForStatementNode
	instanceVariableNames: 'forToken leftParenToken initializer semicolonTokens condition iterator rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSGotoStatementNode
	instanceVariableNames: 'gotoToken identifierToken semicolonToken caseToken expression defaultToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSIfStatementNode
	instanceVariableNames: 'ifToken leftParenToken expression rightParenToken thenStatement elseToken elseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSLabeledStatementNode
	instanceVariableNames: 'identifierToken colonToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSLockStatementNode
	instanceVariableNames: 'lockToken leftParenToken expression rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSReturnStatementNode
	instanceVariableNames: 'returnToken expression semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSSwitchStatementNode
	instanceVariableNames: 'switchToken leftParenToken expression rightParenToken leftBraceToken sections rightBraceToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSThrowStatementNode
	instanceVariableNames: 'throwToken expression semicolonToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSTryStatementNode
	instanceVariableNames: 'tryToken block clauses finally'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSUncheckedStatementNode
	instanceVariableNames: 'uncheckedToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSUnsafeStatementNode
	instanceVariableNames: 'unsafeToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSUsingStatementNode
	instanceVariableNames: 'usingToken leftParenToken expression rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSWhileStatementNode
	instanceVariableNames: 'whileToken leftParenToken expression rightParenToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSStatementNode subclass: #CSYieldStatementNode
	instanceVariableNames: 'yieldToken returnToken expression semicolonToken breakToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSArrayTypeNode
	instanceVariableNames: 'type rankSpecifiers'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSNullableTypeNode
	instanceVariableNames: 'type questionMarkToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSPointerTypeNode
	instanceVariableNames: 'type timesToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSQualifiedAliasMemberNode
	instanceVariableNames: 'global colonColonToken name typeArguments'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSSimpleTypeNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSTypeNameNode
	instanceVariableNames: 'name typeArguments namespace periodToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSVarTypeNode
	instanceVariableNames: 'varToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
CSTypeNode subclass: #CSVoidTypeNode
	instanceVariableNames: 'voidToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNodeVisitor subclass: #CSProgramNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGLRParser subclass: #CSharpParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #CSharpScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

CSProgramNode guid: (GUID fromString: '{FCB7D514-FFBC-4C01-866E-A6C35E984627}')!
CSProgramNode comment: ''!
!CSProgramNode categoriesForClass!Unclassified! !
!CSProgramNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitProgram: self! !
!CSProgramNode categoriesFor: #acceptVisitor:!generated!public! !

CSAddAccessorDeclarationNode guid: (GUID fromString: '{AA2086B3-76BD-4E68-A775-6F408E3204B2}')!
CSAddAccessorDeclarationNode comment: ''!
!CSAddAccessorDeclarationNode categoriesForClass!Unclassified! !
!CSAddAccessorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAddAccessorDeclaration: self!

addToken
	^addToken!

addToken: aSmaCCToken
	addToken := aSmaCCToken!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

compositeNodeVariables
	^#(#_attributes)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#addToken)! !
!CSAddAccessorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #addToken!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #addToken:!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #block!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #block:!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSAddAccessorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSAddAccessorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSAnonymousFunctionParameterNode guid: (GUID fromString: '{B099453C-FD0A-492E-8A21-2D9FC885DA1E}')!
CSAnonymousFunctionParameterNode comment: ''!
!CSAnonymousFunctionParameterNode categoriesForClass!Unclassified! !
!CSAnonymousFunctionParameterNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnonymousFunctionParameter: self!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type)!

tokenVariables
	^#(#modifier #name)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSAnonymousFunctionParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #modifier!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #modifier:!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #name!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #name:!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #nodeVariables!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #tokenVariables!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #type!generated!public! !
!CSAnonymousFunctionParameterNode categoriesFor: #type:!generated!public! !

CSArgumentNode guid: (GUID fromString: '{6B8BC2B0-C400-40B6-B21F-C6DF57251463}')!
CSArgumentNode comment: ''!
!CSArgumentNode categoriesForClass!Unclassified! !
!CSArgumentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArgument: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

outToken
	^outToken!

outToken: aSmaCCToken
	outToken := aSmaCCToken!

refToken
	^refToken!

refToken: aSmaCCToken
	refToken := aSmaCCToken!

tokenVariables
	^#(#refToken #outToken)! !
!CSArgumentNode categoriesFor: #acceptVisitor:!generated!public! !
!CSArgumentNode categoriesFor: #expression!generated!public! !
!CSArgumentNode categoriesFor: #expression:!generated!public! !
!CSArgumentNode categoriesFor: #nodeVariables!generated!public! !
!CSArgumentNode categoriesFor: #outToken!generated!public! !
!CSArgumentNode categoriesFor: #outToken:!generated!public! !
!CSArgumentNode categoriesFor: #refToken!generated!public! !
!CSArgumentNode categoriesFor: #refToken:!generated!public! !
!CSArgumentNode categoriesFor: #tokenVariables!generated!public! !

CSArrayInitializerNode guid: (GUID fromString: '{BFB3EA1E-591F-4370-9BFC-E2A4702B9A6E}')!
CSArrayInitializerNode comment: ''!
!CSArrayInitializerNode categoriesForClass!Unclassified! !
!CSArrayInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayInitializer: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#initializers)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	initializers := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

initializers
	^initializers!

initializers: anOrderedCollection
	self setParents: self initializers to: nil.
	initializers := anOrderedCollection.
	self setParents: self initializers to: self!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

tokenVariables
	^#(#leftBraceToken #rightBraceToken)! !
!CSArrayInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSArrayInitializerNode categoriesFor: #commaTokens!generated!public! !
!CSArrayInitializerNode categoriesFor: #commaTokens:!generated!public! !
!CSArrayInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSArrayInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSArrayInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSArrayInitializerNode categoriesFor: #initializers!generated!public! !
!CSArrayInitializerNode categoriesFor: #initializers:!generated!public! !
!CSArrayInitializerNode categoriesFor: #leftBraceToken!generated!public! !
!CSArrayInitializerNode categoriesFor: #leftBraceToken:!generated!public! !
!CSArrayInitializerNode categoriesFor: #rightBraceToken!generated!public! !
!CSArrayInitializerNode categoriesFor: #rightBraceToken:!generated!public! !
!CSArrayInitializerNode categoriesFor: #tokenVariables!generated!public! !

CSArrayParameterNode guid: (GUID fromString: '{698EDB80-DE84-42C6-806E-5913773135F1}')!
CSArrayParameterNode comment: ''!
!CSArrayParameterNode categoriesForClass!Unclassified! !
!CSArrayParameterNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayParameter: self!

compositeNodeVariables
	^#(#_attributes)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type)!

paramsToken
	^paramsToken!

paramsToken: aSmaCCToken
	paramsToken := aSmaCCToken!

tokenVariables
	^#(#paramsToken #name)!

type
	^type!

type: aCSArrayTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSArrayTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSArrayParameterNode categoriesFor: #_attributes!generated!public! !
!CSArrayParameterNode categoriesFor: #_attributes:!generated!public! !
!CSArrayParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!CSArrayParameterNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSArrayParameterNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSArrayParameterNode categoriesFor: #name!generated!public! !
!CSArrayParameterNode categoriesFor: #name:!generated!public! !
!CSArrayParameterNode categoriesFor: #nodeVariables!generated!public! !
!CSArrayParameterNode categoriesFor: #paramsToken!generated!public! !
!CSArrayParameterNode categoriesFor: #paramsToken:!generated!public! !
!CSArrayParameterNode categoriesFor: #tokenVariables!generated!public! !
!CSArrayParameterNode categoriesFor: #type!generated!public! !
!CSArrayParameterNode categoriesFor: #type:!generated!public! !

CSAttributeNode guid: (GUID fromString: '{5DF5EE7E-3660-498F-B629-E51790AFC7F3}')!
CSAttributeNode comment: ''!
!CSAttributeNode categoriesForClass!Unclassified! !
!CSAttributeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAttribute: self!

attributeValues
	^attributeValues!

attributeValues: anOrderedCollection
	self setParents: self attributeValues to: nil.
	attributeValues := anOrderedCollection.
	self setParents: self attributeValues to: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#attributeValues)!

compositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	attributeValues := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBracket
	^leftBracket!

leftBracket: aSmaCCToken
	leftBracket := aSmaCCToken!

rightBracket
	^rightBracket!

rightBracket: aSmaCCToken
	rightBracket := aSmaCCToken!

target
	^target!

target: aSmaCCToken
	target := aSmaCCToken!

tokenVariables
	^#(#leftBracket #target #colon #rightBracket)! !
!CSAttributeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAttributeNode categoriesFor: #attributeValues!generated!public! !
!CSAttributeNode categoriesFor: #attributeValues:!generated!public! !
!CSAttributeNode categoriesFor: #colon!generated!public! !
!CSAttributeNode categoriesFor: #colon:!generated!public! !
!CSAttributeNode categoriesFor: #commas!generated!public! !
!CSAttributeNode categoriesFor: #commas:!generated!public! !
!CSAttributeNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSAttributeNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSAttributeNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSAttributeNode categoriesFor: #leftBracket!generated!public! !
!CSAttributeNode categoriesFor: #leftBracket:!generated!public! !
!CSAttributeNode categoriesFor: #rightBracket!generated!public! !
!CSAttributeNode categoriesFor: #rightBracket:!generated!public! !
!CSAttributeNode categoriesFor: #target!generated!public! !
!CSAttributeNode categoriesFor: #target:!generated!public! !
!CSAttributeNode categoriesFor: #tokenVariables!generated!public! !

CSAttributeValueNode guid: (GUID fromString: '{75B4F943-D2BC-47AD-A70D-08BD67CDE85E}')!
CSAttributeValueNode comment: ''!
!CSAttributeValueNode categoriesForClass!Unclassified! !
!CSAttributeValueNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAttributeValue: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

compositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

name
	^name!

name: aCSTypeNode
	self name notNil ifTrue: [self name parent: nil].
	name := aCSTypeNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

tokenVariables
	^#(#leftParen #rightParen)! !
!CSAttributeValueNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAttributeValueNode categoriesFor: #arguments!generated!public! !
!CSAttributeValueNode categoriesFor: #arguments:!generated!public! !
!CSAttributeValueNode categoriesFor: #commas!generated!public! !
!CSAttributeValueNode categoriesFor: #commas:!generated!public! !
!CSAttributeValueNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSAttributeValueNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSAttributeValueNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSAttributeValueNode categoriesFor: #leftParen!generated!public! !
!CSAttributeValueNode categoriesFor: #leftParen:!generated!public! !
!CSAttributeValueNode categoriesFor: #name!generated!public! !
!CSAttributeValueNode categoriesFor: #name:!generated!public! !
!CSAttributeValueNode categoriesFor: #nodeVariables!generated!public! !
!CSAttributeValueNode categoriesFor: #rightParen!generated!public! !
!CSAttributeValueNode categoriesFor: #rightParen:!generated!public! !
!CSAttributeValueNode categoriesFor: #tokenVariables!generated!public! !

CSCollectionInitializerNode guid: (GUID fromString: '{858C30EA-A53F-4AB0-9703-12BA17DDDBE2}')!
CSCollectionInitializerNode comment: ''!
!CSCollectionInitializerNode categoriesForClass!Unclassified! !
!CSCollectionInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCollectionInitializer: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#initializers)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	initializers := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

initializers
	^initializers!

initializers: anOrderedCollection
	self setParents: self initializers to: nil.
	initializers := anOrderedCollection.
	self setParents: self initializers to: self!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

tokenVariables
	^#(#leftBraceToken #rightBraceToken)! !
!CSCollectionInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSCollectionInitializerNode categoriesFor: #commaTokens!generated!public! !
!CSCollectionInitializerNode categoriesFor: #commaTokens:!generated!public! !
!CSCollectionInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSCollectionInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSCollectionInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSCollectionInitializerNode categoriesFor: #initializers!generated!public! !
!CSCollectionInitializerNode categoriesFor: #initializers:!generated!public! !
!CSCollectionInitializerNode categoriesFor: #leftBraceToken!generated!public! !
!CSCollectionInitializerNode categoriesFor: #leftBraceToken:!generated!public! !
!CSCollectionInitializerNode categoriesFor: #rightBraceToken!generated!public! !
!CSCollectionInitializerNode categoriesFor: #rightBraceToken:!generated!public! !
!CSCollectionInitializerNode categoriesFor: #tokenVariables!generated!public! !

CSCompilationUnitNode guid: (GUID fromString: '{408F5B39-B237-41D3-8CE4-1CA0B57CE3AC}')!
CSCompilationUnitNode comment: ''!
!CSCompilationUnitNode categoriesForClass!Unclassified! !
!CSCompilationUnitNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCompilationUnit: self!

compositeNodeVariables
	^#(#directives #_attributes #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

directives
	^directives!

directives: anOrderedCollection
	self setParents: self directives to: nil.
	directives := anOrderedCollection.
	self setParents: self directives to: self!

initialize
	super initialize.
	directives := OrderedCollection new: 2.
	_attributes := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.! !
!CSCompilationUnitNode categoriesFor: #_attributes!generated!public! !
!CSCompilationUnitNode categoriesFor: #_attributes:!generated!public! !
!CSCompilationUnitNode categoriesFor: #acceptVisitor:!generated!public! !
!CSCompilationUnitNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSCompilationUnitNode categoriesFor: #declarations!generated!public! !
!CSCompilationUnitNode categoriesFor: #declarations:!generated!public! !
!CSCompilationUnitNode categoriesFor: #directives!generated!public! !
!CSCompilationUnitNode categoriesFor: #directives:!generated!public! !
!CSCompilationUnitNode categoriesFor: #initialize!generated-initialize-release!public! !

CSConstantDeclaratorNode guid: (GUID fromString: '{494F01DC-482C-446D-A70B-715EF28A3AC6}')!
CSConstantDeclaratorNode comment: ''!
!CSConstantDeclaratorNode categoriesForClass!Unclassified! !
!CSConstantDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstantDeclarator: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#identifierToken #equalToken)! !
!CSConstantDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #expression!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #expression:!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #identifierToken!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #identifierToken:!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSConstantDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSConstDeclaratorNode guid: (GUID fromString: '{B8EE31C6-3A37-4FB1-9F57-5CF885F0CA99}')!
CSConstDeclaratorNode comment: ''!
!CSConstDeclaratorNode categoriesForClass!Unclassified! !
!CSConstDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstDeclarator: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#name #equalToken)! !
!CSConstDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSConstDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSConstDeclaratorNode categoriesFor: #expression!generated!public! !
!CSConstDeclaratorNode categoriesFor: #expression:!generated!public! !
!CSConstDeclaratorNode categoriesFor: #name!generated!public! !
!CSConstDeclaratorNode categoriesFor: #name:!generated!public! !
!CSConstDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSConstDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSConstructorConstraintNode guid: (GUID fromString: '{08FD93A9-EEA1-4867-9957-F892B9CB2D2A}')!
CSConstructorConstraintNode comment: ''!
!CSConstructorConstraintNode categoriesForClass!Unclassified! !
!CSConstructorConstraintNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstructorConstraint: self!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#newToken #leftParenToken #rightParenToken)! !
!CSConstructorConstraintNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstructorConstraintNode categoriesFor: #leftParenToken!generated!public! !
!CSConstructorConstraintNode categoriesFor: #leftParenToken:!generated!public! !
!CSConstructorConstraintNode categoriesFor: #newToken!generated!public! !
!CSConstructorConstraintNode categoriesFor: #newToken:!generated!public! !
!CSConstructorConstraintNode categoriesFor: #rightParenToken!generated!public! !
!CSConstructorConstraintNode categoriesFor: #rightParenToken:!generated!public! !
!CSConstructorConstraintNode categoriesFor: #tokenVariables!generated!public! !

CSConstructorInitializerNode guid: (GUID fromString: '{02C4C980-8FE1-4924-998C-D089A050766F}')!
CSConstructorInitializerNode comment: ''!
!CSConstructorInitializerNode categoriesForClass!Unclassified! !
!CSConstructorInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstructorInitializer: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

baseToken
	^baseToken!

baseToken: aSmaCCToken
	baseToken := aSmaCCToken!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#colonToken #baseToken #leftParenToken #rightParenToken #thisToken)! !
!CSConstructorInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #arguments!generated!public! !
!CSConstructorInitializerNode categoriesFor: #arguments:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #baseToken!generated!public! !
!CSConstructorInitializerNode categoriesFor: #baseToken:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #colonToken!generated!public! !
!CSConstructorInitializerNode categoriesFor: #colonToken:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #commaTokens!generated!public! !
!CSConstructorInitializerNode categoriesFor: #commaTokens:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSConstructorInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSConstructorInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSConstructorInitializerNode categoriesFor: #leftParenToken!generated!public! !
!CSConstructorInitializerNode categoriesFor: #leftParenToken:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #rightParenToken!generated!public! !
!CSConstructorInitializerNode categoriesFor: #rightParenToken:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #thisToken!generated!public! !
!CSConstructorInitializerNode categoriesFor: #thisToken:!generated!public! !
!CSConstructorInitializerNode categoriesFor: #tokenVariables!generated!public! !

CSDeclarationNode guid: (GUID fromString: '{213059FF-9369-4723-8D0D-5146348C0251}')!
CSDeclarationNode comment: ''!
!CSDeclarationNode categoriesForClass!Unclassified! !
!CSDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDeclaration: self! !
!CSDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !

CSElementInitializerNode guid: (GUID fromString: '{832FB1D5-AB5E-4352-8BFD-FE5F567D7660}')!
CSElementInitializerNode comment: ''!
!CSElementInitializerNode categoriesForClass!Unclassified! !
!CSElementInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitElementInitializer: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

tokenVariables
	^#(#leftBraceToken #rightBraceToken)! !
!CSElementInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSElementInitializerNode categoriesFor: #commaTokens!generated!public! !
!CSElementInitializerNode categoriesFor: #commaTokens:!generated!public! !
!CSElementInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSElementInitializerNode categoriesFor: #expressions!generated!public! !
!CSElementInitializerNode categoriesFor: #expressions:!generated!public! !
!CSElementInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSElementInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSElementInitializerNode categoriesFor: #leftBraceToken!generated!public! !
!CSElementInitializerNode categoriesFor: #leftBraceToken:!generated!public! !
!CSElementInitializerNode categoriesFor: #rightBraceToken!generated!public! !
!CSElementInitializerNode categoriesFor: #rightBraceToken:!generated!public! !
!CSElementInitializerNode categoriesFor: #tokenVariables!generated!public! !

CSExplicitAnonymousFunctionSignatureNode guid: (GUID fromString: '{26585F7F-F604-40FB-ADB2-E06E6744C37F}')!
CSExplicitAnonymousFunctionSignatureNode comment: ''!
!CSExplicitAnonymousFunctionSignatureNode categoriesForClass!Unclassified! !
!CSExplicitAnonymousFunctionSignatureNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExplicitAnonymousFunctionSignature: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#parameters)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	parameters := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#leftParenToken #rightParenToken)! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #acceptVisitor:!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #commaTokens!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #commaTokens:!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #leftParenToken!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #leftParenToken:!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #parameters!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #parameters:!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #rightParenToken!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #rightParenToken:!generated!public! !
!CSExplicitAnonymousFunctionSignatureNode categoriesFor: #tokenVariables!generated!public! !

CSExpressionNode guid: (GUID fromString: '{900229B1-02C7-405D-B57B-763E65B72108}')!
CSExpressionNode comment: ''!
!CSExpressionNode categoriesForClass!Unclassified! !
!CSExpressionNode methodsFor!

_leftParens
	^_leftParens!

_leftParens: anOrderedCollection
	_leftParens := anOrderedCollection!

_rightParens
	^_rightParens!

_rightParens: anOrderedCollection
	_rightParens := anOrderedCollection!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpression: self!

ignoredCompositeTokenVariables
	^#(#_leftParens #_rightParens)!

initialize
	super initialize.
	_leftParens := OrderedCollection new: 2.
	_rightParens := OrderedCollection new: 2.! !
!CSExpressionNode categoriesFor: #_leftParens!generated!public! !
!CSExpressionNode categoriesFor: #_leftParens:!generated!public! !
!CSExpressionNode categoriesFor: #_rightParens!generated!public! !
!CSExpressionNode categoriesFor: #_rightParens:!generated!public! !
!CSExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !

CSExternAliasDirectiveNode guid: (GUID fromString: '{7775C810-EE79-4A0A-96B6-92170650968B}')!
CSExternAliasDirectiveNode comment: ''!
!CSExternAliasDirectiveNode categoriesForClass!Unclassified! !
!CSExternAliasDirectiveNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExternAliasDirective: self!

aliasToken
	^aliasToken!

aliasToken: aSmaCCToken
	aliasToken := aSmaCCToken!

externToken
	^externToken!

externToken: aSmaCCToken
	externToken := aSmaCCToken!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#externToken #aliasToken #identifierToken)! !
!CSExternAliasDirectiveNode categoriesFor: #acceptVisitor:!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #aliasToken!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #aliasToken:!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #externToken!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #externToken:!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #identifierToken!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #identifierToken:!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #semicolonToken!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #semicolonToken:!generated!public! !
!CSExternAliasDirectiveNode categoriesFor: #tokenVariables!generated!public! !

CSFinallyClauseNode guid: (GUID fromString: '{CA26FD91-F101-4336-B3F4-BAD42FE1E0DB}')!
CSFinallyClauseNode comment: ''!
!CSFinallyClauseNode categoriesForClass!Unclassified! !
!CSFinallyClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFinallyClause: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

finallyToken
	^finallyToken!

finallyToken: aSmaCCToken
	finallyToken := aSmaCCToken!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#finallyToken)! !
!CSFinallyClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFinallyClauseNode categoriesFor: #block!generated!public! !
!CSFinallyClauseNode categoriesFor: #block:!generated!public! !
!CSFinallyClauseNode categoriesFor: #finallyToken!generated!public! !
!CSFinallyClauseNode categoriesFor: #finallyToken:!generated!public! !
!CSFinallyClauseNode categoriesFor: #nodeVariables!generated!public! !
!CSFinallyClauseNode categoriesFor: #tokenVariables!generated!public! !

CSFixedParameterNode guid: (GUID fromString: '{CE4643A5-D493-405A-9363-ECA7C90AF9A8}')!
CSFixedParameterNode comment: ''!
!CSFixedParameterNode categoriesForClass!Unclassified! !
!CSFixedParameterNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFixedParameter: self!

compositeNodeVariables
	^#(#_attributes)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type)!

tokenVariables
	^#(#modifier #name)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSFixedParameterNode categoriesFor: #_attributes!generated!public! !
!CSFixedParameterNode categoriesFor: #_attributes:!generated!public! !
!CSFixedParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFixedParameterNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSFixedParameterNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSFixedParameterNode categoriesFor: #modifier!generated!public! !
!CSFixedParameterNode categoriesFor: #modifier:!generated!public! !
!CSFixedParameterNode categoriesFor: #name!generated!public! !
!CSFixedParameterNode categoriesFor: #name:!generated!public! !
!CSFixedParameterNode categoriesFor: #nodeVariables!generated!public! !
!CSFixedParameterNode categoriesFor: #tokenVariables!generated!public! !
!CSFixedParameterNode categoriesFor: #type!generated!public! !
!CSFixedParameterNode categoriesFor: #type:!generated!public! !

CSFixedPointerDeclaratorNode guid: (GUID fromString: '{CBA720BE-C795-40FF-BE6F-AB3D23F70537}')!
CSFixedPointerDeclaratorNode comment: ''!
!CSFixedPointerDeclaratorNode categoriesForClass!Unclassified! !
!CSFixedPointerDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFixedPointerDeclarator: self!

andToken
	^andToken!

andToken: aSmaCCToken
	andToken := aSmaCCToken!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#identifierToken #equalToken #andToken)! !
!CSFixedPointerDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #andToken!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #andToken:!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #expression!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #expression:!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #identifierToken!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #identifierToken:!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSFixedPointerDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSFixedSizeBufferDeclaratorNode guid: (GUID fromString: '{B4876961-18A0-40DA-916F-B0D385492827}')!
CSFixedSizeBufferDeclaratorNode comment: ''!
!CSFixedSizeBufferDeclaratorNode categoriesForClass!Unclassified! !
!CSFixedSizeBufferDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFixedSizeBufferDeclarator: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#name #leftBracketToken #rightBracketToken)! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #expression!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #expression:!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #leftBracketToken!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #leftBracketToken:!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #name!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #name:!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #rightBracketToken!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #rightBracketToken:!generated!public! !
!CSFixedSizeBufferDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSGeneralCatchClauseNode guid: (GUID fromString: '{7BBC003E-C56C-4B4C-B419-7E76C43B4654}')!
CSGeneralCatchClauseNode comment: ''!
!CSGeneralCatchClauseNode categoriesForClass!Unclassified! !
!CSGeneralCatchClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitGeneralCatchClause: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

catchToken
	^catchToken!

catchToken: aSmaCCToken
	catchToken := aSmaCCToken!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#catchToken)! !
!CSGeneralCatchClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #block!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #block:!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #catchToken!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #catchToken:!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #nodeVariables!generated!public! !
!CSGeneralCatchClauseNode categoriesFor: #tokenVariables!generated!public! !

CSGetAccessorDeclarationNode guid: (GUID fromString: '{C743C74F-9A06-4A49-A7FF-9D7F106CEBBC}')!
CSGetAccessorDeclarationNode comment: ''!
!CSGetAccessorDeclarationNode categoriesForClass!Unclassified! !
!CSGetAccessorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitGetAccessorDeclaration: self!

body
	^body!

body: aCSBlockStatementNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSBlockStatementNode.
	self body notNil ifTrue: [self body parent: self]!

compositeNodeVariables
	^#(#_attributes)!

compositeTokenVariables
	^#(#modifiers)!

getToken
	^getToken!

getToken: aSmaCCToken
	getToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#body)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#getToken)! !
!CSGetAccessorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #body!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #body:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #getToken!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #getToken:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSGetAccessorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSGetAccessorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSImplicitAnonymousFunctionSignatureNode guid: (GUID fromString: '{D2DA31B1-E970-4023-8608-F6BC8B5A9C10}')!
CSImplicitAnonymousFunctionSignatureNode comment: ''!
!CSImplicitAnonymousFunctionSignatureNode categoriesForClass!Unclassified! !
!CSImplicitAnonymousFunctionSignatureNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitImplicitAnonymousFunctionSignature: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeTokenVariables
	^#(#names)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	names := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

names
	^names!

names: anOrderedCollection
	names := anOrderedCollection!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#leftParenToken #rightParenToken)! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #acceptVisitor:!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #commaTokens!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #commaTokens:!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #leftParenToken!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #leftParenToken:!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #names!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #names:!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #rightParenToken!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #rightParenToken:!generated!public! !
!CSImplicitAnonymousFunctionSignatureNode categoriesFor: #tokenVariables!generated!public! !

CSInterfacePropertyAccessorNode guid: (GUID fromString: '{140DE88A-EADE-430A-8518-830F64455E06}')!
CSInterfacePropertyAccessorNode comment: ''!
!CSInterfacePropertyAccessorNode categoriesForClass!Unclassified! !
!CSInterfacePropertyAccessorNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfacePropertyAccessor: self!

accessorType
	^accessorType!

accessorType: aSmaCCToken
	accessorType := aSmaCCToken!

compositeNodeVariables
	^#(#_attributes)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#accessorType #semicolon)! !
!CSInterfacePropertyAccessorNode categoriesFor: #_attributes!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #_attributes:!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #accessorType!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #accessorType:!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #semicolon!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #semicolon:!generated!public! !
!CSInterfacePropertyAccessorNode categoriesFor: #tokenVariables!generated!public! !

CSLocalVariableDeclaratorNode guid: (GUID fromString: '{ABB4A3CD-1BD9-4DEE-BF1B-A975DA32AB19}')!
CSLocalVariableDeclaratorNode comment: ''!
!CSLocalVariableDeclaratorNode categoriesForClass!Unclassified! !
!CSLocalVariableDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLocalVariableDeclarator: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

expression
	^expression!

expression: aCSProgramNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSProgramNode.
	self expression notNil ifTrue: [self expression parent: self]!

name
	^name!

name: aCSSimpleNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aCSSimpleNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name #expression)!

tokenVariables
	^#(#equalToken)! !
!CSLocalVariableDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #expression!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #expression:!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #name!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #name:!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSLocalVariableDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSMemberDeclaratorNode guid: (GUID fromString: '{47644CBF-4CF0-4ADA-82B6-72C8EDE9A34F}')!
CSMemberDeclaratorNode comment: ''!
!CSMemberDeclaratorNode categoriesForClass!Unclassified! !
!CSMemberDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMemberDeclarator: self!

access
	^access!

access: aCSMemberAccessNode
	self access notNil ifTrue: [self access parent: nil].
	access := aCSMemberAccessNode.
	self access notNil ifTrue: [self access parent: self]!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

name
	^name!

name: aCSSimpleNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aCSSimpleNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name #access #value)!

tokenVariables
	^#(#identifierToken #equalToken)!

value
	^value!

value: aCSExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aCSExpressionNode.
	self value notNil ifTrue: [self value parent: self]! !
!CSMemberDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #access!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #access:!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #identifierToken!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #identifierToken:!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #name!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #name:!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #tokenVariables!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #value!generated!public! !
!CSMemberDeclaratorNode categoriesFor: #value:!generated!public! !

CSMemberInitializerNode guid: (GUID fromString: '{F158EC0A-1D58-4C98-AA22-ACDD57251DB3}')!
CSMemberInitializerNode comment: ''!
!CSMemberInitializerNode categoriesForClass!Unclassified! !
!CSMemberInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMemberInitializer: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

nodeVariables
	^#(#value)!

tokenVariables
	^#(#identifier #equalToken)!

value
	^value!

value: aCSProgramNode
	self value notNil ifTrue: [self value parent: nil].
	value := aCSProgramNode.
	self value notNil ifTrue: [self value parent: self]! !
!CSMemberInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMemberInitializerNode categoriesFor: #equalToken!generated!public! !
!CSMemberInitializerNode categoriesFor: #equalToken:!generated!public! !
!CSMemberInitializerNode categoriesFor: #identifier!generated!public! !
!CSMemberInitializerNode categoriesFor: #identifier:!generated!public! !
!CSMemberInitializerNode categoriesFor: #nodeVariables!generated!public! !
!CSMemberInitializerNode categoriesFor: #tokenVariables!generated!public! !
!CSMemberInitializerNode categoriesFor: #value!generated!public! !
!CSMemberInitializerNode categoriesFor: #value:!generated!public! !

CSMethodBodyNode guid: (GUID fromString: '{998CD33A-2B92-4456-92B8-E7F86DD1EFDC}')!
CSMethodBodyNode comment: ''!
!CSMethodBodyNode categoriesForClass!Unclassified! !
!CSMethodBodyNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodBody: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#block)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken! !
!CSMethodBodyNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMethodBodyNode categoriesFor: #block!generated!public! !
!CSMethodBodyNode categoriesFor: #block:!generated!public! !
!CSMethodBodyNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSMethodBodyNode categoriesFor: #nodeVariables!generated!public! !
!CSMethodBodyNode categoriesFor: #semicolonToken!generated!public! !
!CSMethodBodyNode categoriesFor: #semicolonToken:!generated!public! !

CSMethodHeaderNode guid: (GUID fromString: '{D8768429-2D57-4EB4-B658-3469D08CE55A}')!
CSMethodHeaderNode comment: ''!
!CSMethodHeaderNode categoriesForClass!Unclassified! !
!CSMethodHeaderNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodHeader: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters #constraintClauses)!

compositeTokenVariables
	^#(#modifiers #commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.!

interface
	^interface!

interface: aCSTypeNode
	self interface notNil ifTrue: [self interface parent: nil].
	interface := aCSTypeNode.
	self interface notNil ifTrue: [self interface parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#returnType #interface #typeParameters)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

partialToken
	^partialToken!

partialToken: aSmaCCToken
	partialToken := aSmaCCToken!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

returnType
	^returnType!

returnType: aCSTypeNode
	self returnType notNil ifTrue: [self returnType parent: nil].
	returnType := aCSTypeNode.
	self returnType notNil ifTrue: [self returnType parent: self]!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#partialToken #name #periodToken #leftParenToken #rightParenToken)!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSMethodHeaderNode categoriesFor: #_attributes!generated!public! !
!CSMethodHeaderNode categoriesFor: #_attributes:!generated!public! !
!CSMethodHeaderNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMethodHeaderNode categoriesFor: #commas!generated!public! !
!CSMethodHeaderNode categoriesFor: #commas:!generated!public! !
!CSMethodHeaderNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSMethodHeaderNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSMethodHeaderNode categoriesFor: #constraintClauses!generated!public! !
!CSMethodHeaderNode categoriesFor: #constraintClauses:!generated!public! !
!CSMethodHeaderNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSMethodHeaderNode categoriesFor: #interface!generated!public! !
!CSMethodHeaderNode categoriesFor: #interface:!generated!public! !
!CSMethodHeaderNode categoriesFor: #leftParenToken!generated!public! !
!CSMethodHeaderNode categoriesFor: #leftParenToken:!generated!public! !
!CSMethodHeaderNode categoriesFor: #modifiers!generated!public! !
!CSMethodHeaderNode categoriesFor: #modifiers:!generated!public! !
!CSMethodHeaderNode categoriesFor: #name!generated!public! !
!CSMethodHeaderNode categoriesFor: #name:!generated!public! !
!CSMethodHeaderNode categoriesFor: #nodeVariables!generated!public! !
!CSMethodHeaderNode categoriesFor: #parameters!generated!public! !
!CSMethodHeaderNode categoriesFor: #parameters:!generated!public! !
!CSMethodHeaderNode categoriesFor: #partialToken!generated!public! !
!CSMethodHeaderNode categoriesFor: #partialToken:!generated!public! !
!CSMethodHeaderNode categoriesFor: #periodToken!generated!public! !
!CSMethodHeaderNode categoriesFor: #periodToken:!generated!public! !
!CSMethodHeaderNode categoriesFor: #returnType!generated!public! !
!CSMethodHeaderNode categoriesFor: #returnType:!generated!public! !
!CSMethodHeaderNode categoriesFor: #rightParenToken!generated!public! !
!CSMethodHeaderNode categoriesFor: #rightParenToken:!generated!public! !
!CSMethodHeaderNode categoriesFor: #tokenVariables!generated!public! !
!CSMethodHeaderNode categoriesFor: #typeParameters!generated!public! !
!CSMethodHeaderNode categoriesFor: #typeParameters:!generated!public! !

CSNamedArgumentNode guid: (GUID fromString: '{86603152-93A8-4EA2-9431-BAB2A05D9432}')!
CSNamedArgumentNode comment: ''!
!CSNamedArgumentNode categoriesForClass!Unclassified! !
!CSNamedArgumentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNamedArgument: self!

equal
	^equal!

equal: aSmaCCToken
	equal := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#value)!

tokenVariables
	^#(#name #equal)!

value
	^value!

value: aCSExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aCSExpressionNode.
	self value notNil ifTrue: [self value parent: self]! !
!CSNamedArgumentNode categoriesFor: #acceptVisitor:!generated!public! !
!CSNamedArgumentNode categoriesFor: #equal!generated!public! !
!CSNamedArgumentNode categoriesFor: #equal:!generated!public! !
!CSNamedArgumentNode categoriesFor: #name!generated!public! !
!CSNamedArgumentNode categoriesFor: #name:!generated!public! !
!CSNamedArgumentNode categoriesFor: #nodeVariables!generated!public! !
!CSNamedArgumentNode categoriesFor: #tokenVariables!generated!public! !
!CSNamedArgumentNode categoriesFor: #value!generated!public! !
!CSNamedArgumentNode categoriesFor: #value:!generated!public! !

CSObjectInitializerNode guid: (GUID fromString: '{62AB9F0E-0B1F-44A4-8352-C29148E1C140}')!
CSObjectInitializerNode comment: ''!
!CSObjectInitializerNode categoriesForClass!Unclassified! !
!CSObjectInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitObjectInitializer: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#initializers)!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	initializers := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

initializers
	^initializers!

initializers: anOrderedCollection
	self setParents: self initializers to: nil.
	initializers := anOrderedCollection.
	self setParents: self initializers to: self!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

tokenVariables
	^#(#leftBraceToken #rightBraceToken)! !
!CSObjectInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSObjectInitializerNode categoriesFor: #commaTokens!generated!public! !
!CSObjectInitializerNode categoriesFor: #commaTokens:!generated!public! !
!CSObjectInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSObjectInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSObjectInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSObjectInitializerNode categoriesFor: #initializers!generated!public! !
!CSObjectInitializerNode categoriesFor: #initializers:!generated!public! !
!CSObjectInitializerNode categoriesFor: #leftBraceToken!generated!public! !
!CSObjectInitializerNode categoriesFor: #leftBraceToken:!generated!public! !
!CSObjectInitializerNode categoriesFor: #rightBraceToken!generated!public! !
!CSObjectInitializerNode categoriesFor: #rightBraceToken:!generated!public! !
!CSObjectInitializerNode categoriesFor: #tokenVariables!generated!public! !

CSPrimaryConstraintNode guid: (GUID fromString: '{F27D1E48-9DDC-446D-8E76-A513768A167B}')!
CSPrimaryConstraintNode comment: ''!
!CSPrimaryConstraintNode categoriesForClass!Unclassified! !
!CSPrimaryConstraintNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPrimaryConstraint: self!

classToken
	^classToken!

classToken: aSmaCCToken
	classToken := aSmaCCToken!

structToken
	^structToken!

structToken: aSmaCCToken
	structToken := aSmaCCToken!

tokenVariables
	^#(#classToken #structToken)! !
!CSPrimaryConstraintNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPrimaryConstraintNode categoriesFor: #classToken!generated!public! !
!CSPrimaryConstraintNode categoriesFor: #classToken:!generated!public! !
!CSPrimaryConstraintNode categoriesFor: #structToken!generated!public! !
!CSPrimaryConstraintNode categoriesFor: #structToken:!generated!public! !
!CSPrimaryConstraintNode categoriesFor: #tokenVariables!generated!public! !

CSQualifiedIdentifierNode guid: (GUID fromString: '{FB819788-8783-4BD8-AFCC-4422CD27F4EE}')!
CSQualifiedIdentifierNode comment: ''!
!CSQualifiedIdentifierNode categoriesForClass!Unclassified! !
!CSQualifiedIdentifierNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitQualifiedIdentifier: self!

compositeTokenVariables
	^#(#names #periodTokens)!

initialize
	super initialize.
	names := OrderedCollection new: 2.
	periodTokens := OrderedCollection new: 2.!

names
	^names!

names: anOrderedCollection
	names := anOrderedCollection!

periodTokens
	^periodTokens!

periodTokens: anOrderedCollection
	periodTokens := anOrderedCollection! !
!CSQualifiedIdentifierNode categoriesFor: #acceptVisitor:!generated!public! !
!CSQualifiedIdentifierNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSQualifiedIdentifierNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSQualifiedIdentifierNode categoriesFor: #names!generated!public! !
!CSQualifiedIdentifierNode categoriesFor: #names:!generated!public! !
!CSQualifiedIdentifierNode categoriesFor: #periodTokens!generated!public! !
!CSQualifiedIdentifierNode categoriesFor: #periodTokens:!generated!public! !

CSRankSpecifierNode guid: (GUID fromString: '{FD1DA486-6A60-43AA-B9A7-AB6F79A0CD2B}')!
CSRankSpecifierNode comment: ''!
!CSRankSpecifierNode categoriesForClass!Unclassified! !
!CSRankSpecifierNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitRankSpecifier: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	commaTokens := OrderedCollection new: 2.!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#leftBracketToken #rightBracketToken)! !
!CSRankSpecifierNode categoriesFor: #acceptVisitor:!generated!public! !
!CSRankSpecifierNode categoriesFor: #commaTokens!generated!public! !
!CSRankSpecifierNode categoriesFor: #commaTokens:!generated!public! !
!CSRankSpecifierNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSRankSpecifierNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSRankSpecifierNode categoriesFor: #leftBracketToken!generated!public! !
!CSRankSpecifierNode categoriesFor: #leftBracketToken:!generated!public! !
!CSRankSpecifierNode categoriesFor: #rightBracketToken!generated!public! !
!CSRankSpecifierNode categoriesFor: #rightBracketToken:!generated!public! !
!CSRankSpecifierNode categoriesFor: #tokenVariables!generated!public! !

CSRemoveAccessorDeclarationNode guid: (GUID fromString: '{C94A9614-EA43-4D20-AA22-30B2B7F20173}')!
CSRemoveAccessorDeclarationNode comment: ''!
!CSRemoveAccessorDeclarationNode categoriesForClass!Unclassified! !
!CSRemoveAccessorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitRemoveAccessorDeclaration: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

compositeNodeVariables
	^#(#_attributes)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

nodeVariables
	^#(#block)!

removeToken
	^removeToken!

removeToken: aSmaCCToken
	removeToken := aSmaCCToken!

tokenVariables
	^#(#removeToken)! !
!CSRemoveAccessorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #block!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #block:!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #removeToken!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #removeToken:!generated!public! !
!CSRemoveAccessorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSSetAccessorDeclarationNode guid: (GUID fromString: '{CA4E13E7-3D63-4D0A-B676-4E0247CAFBE6}')!
CSSetAccessorDeclarationNode comment: ''!
!CSSetAccessorDeclarationNode categoriesForClass!Unclassified! !
!CSSetAccessorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSetAccessorDeclaration: self!

body
	^body!

body: aCSBlockStatementNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSBlockStatementNode.
	self body notNil ifTrue: [self body parent: self]!

compositeNodeVariables
	^#(#_attributes)!

compositeTokenVariables
	^#(#modifiers)!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#body)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

setToken
	^setToken!

setToken: aSmaCCToken
	setToken := aSmaCCToken!

tokenVariables
	^#(#setToken)! !
!CSSetAccessorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #body!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #body:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSSetAccessorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #setToken!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #setToken:!generated!public! !
!CSSetAccessorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSSpecificCatchClauseNode guid: (GUID fromString: '{7984F647-B0BF-425B-921F-5EC3DF570E6E}')!
CSSpecificCatchClauseNode comment: ''!
!CSSpecificCatchClauseNode categoriesForClass!Unclassified! !
!CSSpecificCatchClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSpecificCatchClause: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

catchToken
	^catchToken!

catchToken: aSmaCCToken
	catchToken := aSmaCCToken!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #block)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#catchToken #leftParenToken #name #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSSpecificCatchClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #block!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #block:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #catchToken!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #catchToken:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #leftParenToken!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #leftParenToken:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #name!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #name:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #nodeVariables!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #rightParenToken!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #rightParenToken:!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #tokenVariables!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #type!generated!public! !
!CSSpecificCatchClauseNode categoriesFor: #type:!generated!public! !

CSStackallocInitializerNode guid: (GUID fromString: '{AD10DD99-5EC0-4EDD-93B0-A940AF144D2E}')!
CSStackallocInitializerNode comment: ''!
!CSStackallocInitializerNode categoriesForClass!Unclassified! !
!CSStackallocInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStackallocInitializer: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

nodeVariables
	^#(#type #expression)!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

stackallocToken
	^stackallocToken!

stackallocToken: aSmaCCToken
	stackallocToken := aSmaCCToken!

tokenVariables
	^#(#stackallocToken #leftBracketToken #rightBracketToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSStackallocInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!CSStackallocInitializerNode categoriesFor: #expression!generated!public! !
!CSStackallocInitializerNode categoriesFor: #expression:!generated!public! !
!CSStackallocInitializerNode categoriesFor: #leftBracketToken!generated!public! !
!CSStackallocInitializerNode categoriesFor: #leftBracketToken:!generated!public! !
!CSStackallocInitializerNode categoriesFor: #nodeVariables!generated!public! !
!CSStackallocInitializerNode categoriesFor: #rightBracketToken!generated!public! !
!CSStackallocInitializerNode categoriesFor: #rightBracketToken:!generated!public! !
!CSStackallocInitializerNode categoriesFor: #stackallocToken!generated!public! !
!CSStackallocInitializerNode categoriesFor: #stackallocToken:!generated!public! !
!CSStackallocInitializerNode categoriesFor: #tokenVariables!generated!public! !
!CSStackallocInitializerNode categoriesFor: #type!generated!public! !
!CSStackallocInitializerNode categoriesFor: #type:!generated!public! !

CSStatementListNode guid: (GUID fromString: '{05E39E79-E8A0-479A-80EC-01D467E6C5FF}')!
CSStatementListNode comment: ''!
!CSStatementListNode categoriesForClass!Unclassified! !
!CSStatementListNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStatementList: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.! !
!CSStatementListNode categoriesFor: #acceptVisitor:!generated!public! !
!CSStatementListNode categoriesFor: #commaTokens!generated!public! !
!CSStatementListNode categoriesFor: #commaTokens:!generated!public! !
!CSStatementListNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSStatementListNode categoriesFor: #expressions!generated!public! !
!CSStatementListNode categoriesFor: #expressions:!generated!public! !
!CSStatementListNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSStatementListNode categoriesFor: #initialize!generated-initialize-release!public! !

CSStatementNode guid: (GUID fromString: '{A85E8E29-B0FB-4522-A7A9-BF97E11FAB4E}')!
CSStatementNode comment: ''!
!CSStatementNode categoriesForClass!Unclassified! !
!CSStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStatement: self! !
!CSStatementNode categoriesFor: #acceptVisitor:!generated!public! !

CSSwitchLabelNode guid: (GUID fromString: '{C1D6127A-FE95-41E0-AF9F-D757E7D26909}')!
CSSwitchLabelNode comment: ''!
!CSSwitchLabelNode categoriesForClass!Unclassified! !
!CSSwitchLabelNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchLabel: self!

caseToken
	^caseToken!

caseToken: aSmaCCToken
	caseToken := aSmaCCToken!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#caseToken #colonToken #defaultToken)! !
!CSSwitchLabelNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSwitchLabelNode categoriesFor: #caseToken!generated!public! !
!CSSwitchLabelNode categoriesFor: #caseToken:!generated!public! !
!CSSwitchLabelNode categoriesFor: #colonToken!generated!public! !
!CSSwitchLabelNode categoriesFor: #colonToken:!generated!public! !
!CSSwitchLabelNode categoriesFor: #defaultToken!generated!public! !
!CSSwitchLabelNode categoriesFor: #defaultToken:!generated!public! !
!CSSwitchLabelNode categoriesFor: #expression!generated!public! !
!CSSwitchLabelNode categoriesFor: #expression:!generated!public! !
!CSSwitchLabelNode categoriesFor: #nodeVariables!generated!public! !
!CSSwitchLabelNode categoriesFor: #tokenVariables!generated!public! !

CSSwitchSectionNode guid: (GUID fromString: '{15A86C3A-D796-4BE1-BD0E-560E47A9B441}')!
CSSwitchSectionNode comment: ''!
!CSSwitchSectionNode categoriesForClass!Unclassified! !
!CSSwitchSectionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchSection: self!

compositeNodeVariables
	^#(#labels #statements)!

initialize
	super initialize.
	labels := OrderedCollection new: 2.
	statements := OrderedCollection new: 2.!

labels
	^labels!

labels: anOrderedCollection
	self setParents: self labels to: nil.
	labels := anOrderedCollection.
	self setParents: self labels to: self!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self! !
!CSSwitchSectionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSwitchSectionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSSwitchSectionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSSwitchSectionNode categoriesFor: #labels!generated!public! !
!CSSwitchSectionNode categoriesFor: #labels:!generated!public! !
!CSSwitchSectionNode categoriesFor: #statements!generated!public! !
!CSSwitchSectionNode categoriesFor: #statements:!generated!public! !

CSTypeArgumentListNode guid: (GUID fromString: '{EA028052-CFD2-48AF-8DBE-4531957AE8B2}')!
CSTypeArgumentListNode comment: ''!
!CSTypeArgumentListNode categoriesForClass!Unclassified! !
!CSTypeArgumentListNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeArgumentList: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#types)!

greaterThanToken
	^greaterThanToken!

greaterThanToken: aSmaCCToken
	greaterThanToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	types := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

lessThanToken
	^lessThanToken!

lessThanToken: aSmaCCToken
	lessThanToken := aSmaCCToken!

tokenVariables
	^#(#lessThanToken #greaterThanToken)!

types
	^types!

types: anOrderedCollection
	self setParents: self types to: nil.
	types := anOrderedCollection.
	self setParents: self types to: self! !
!CSTypeArgumentListNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeArgumentListNode categoriesFor: #commaTokens!generated!public! !
!CSTypeArgumentListNode categoriesFor: #commaTokens:!generated!public! !
!CSTypeArgumentListNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSTypeArgumentListNode categoriesFor: #greaterThanToken!generated!public! !
!CSTypeArgumentListNode categoriesFor: #greaterThanToken:!generated!public! !
!CSTypeArgumentListNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSTypeArgumentListNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSTypeArgumentListNode categoriesFor: #lessThanToken!generated!public! !
!CSTypeArgumentListNode categoriesFor: #lessThanToken:!generated!public! !
!CSTypeArgumentListNode categoriesFor: #tokenVariables!generated!public! !
!CSTypeArgumentListNode categoriesFor: #types!generated!public! !
!CSTypeArgumentListNode categoriesFor: #types:!generated!public! !

CSTypeConstraintNode guid: (GUID fromString: '{E62C023C-98EE-4B24-858E-1ECA1BD67DE4}')!
CSTypeConstraintNode comment: ''!
!CSTypeConstraintNode categoriesForClass!Unclassified! !
!CSTypeConstraintNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeConstraint: self!

nodeVariables
	^#(#type)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSTypeConstraintNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeConstraintNode categoriesFor: #nodeVariables!generated!public! !
!CSTypeConstraintNode categoriesFor: #type!generated!public! !
!CSTypeConstraintNode categoriesFor: #type:!generated!public! !

CSTypeNode guid: (GUID fromString: '{48355FCE-BC4B-4522-8A62-EA80E4D5ACD0}')!
CSTypeNode comment: ''!
!CSTypeNode categoriesForClass!Unclassified! !
!CSTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitType: self! !
!CSTypeNode categoriesFor: #acceptVisitor:!generated!public! !

CSTypeParameterConstraintsClauseNode guid: (GUID fromString: '{49CE8E9F-5775-4A4C-950A-5A370BBF49B9}')!
CSTypeParameterConstraintsClauseNode comment: ''!
!CSTypeParameterConstraintsClauseNode categoriesForClass!Unclassified! !
!CSTypeParameterConstraintsClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeParameterConstraintsClause: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#constraints)!

constraints
	^constraints!

constraints: anOrderedCollection
	self setParents: self constraints to: nil.
	constraints := anOrderedCollection.
	self setParents: self constraints to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	constraints := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

nodeVariables
	^#(#parameter)!

parameter
	^parameter!

parameter: aCSTypeNameNode
	self parameter notNil ifTrue: [self parameter parent: nil].
	parameter := aCSTypeNameNode.
	self parameter notNil ifTrue: [self parameter parent: self]!

tokenVariables
	^#(#whereToken #colon)!

whereToken
	^whereToken!

whereToken: aSmaCCToken
	whereToken := aSmaCCToken! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #colon!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #colon:!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #commaTokens!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #commaTokens:!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #constraints!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #constraints:!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #nodeVariables!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #parameter!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #parameter:!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #tokenVariables!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #whereToken!generated!public! !
!CSTypeParameterConstraintsClauseNode categoriesFor: #whereToken:!generated!public! !

CSTypeParameterListNode guid: (GUID fromString: '{469E0CB4-0F39-4109-BC9E-C5B9E7DE2227}')!
CSTypeParameterListNode comment: ''!
!CSTypeParameterListNode categoriesForClass!Unclassified! !
!CSTypeParameterListNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeParameterList: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters)!

greaterThan
	^greaterThan!

greaterThan: aSmaCCToken
	greaterThan := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

lessThan
	^lessThan!

lessThan: aSmaCCToken
	lessThan := aSmaCCToken!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

tokenVariables
	^#(#lessThan #greaterThan)! !
!CSTypeParameterListNode categoriesFor: #_attributes!generated!public! !
!CSTypeParameterListNode categoriesFor: #_attributes:!generated!public! !
!CSTypeParameterListNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeParameterListNode categoriesFor: #commaTokens!generated!public! !
!CSTypeParameterListNode categoriesFor: #commaTokens:!generated!public! !
!CSTypeParameterListNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSTypeParameterListNode categoriesFor: #greaterThan!generated!public! !
!CSTypeParameterListNode categoriesFor: #greaterThan:!generated!public! !
!CSTypeParameterListNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSTypeParameterListNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSTypeParameterListNode categoriesFor: #lessThan!generated!public! !
!CSTypeParameterListNode categoriesFor: #lessThan:!generated!public! !
!CSTypeParameterListNode categoriesFor: #parameters!generated!public! !
!CSTypeParameterListNode categoriesFor: #parameters:!generated!public! !
!CSTypeParameterListNode categoriesFor: #tokenVariables!generated!public! !

CSUnboundTypeNameNode guid: (GUID fromString: '{FAEAEA16-9A4F-412E-9B83-CD2A1D3B884B}')!
CSUnboundTypeNameNode comment: ''!
!CSUnboundTypeNameNode categoriesForClass!Unclassified! !
!CSUnboundTypeNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnboundTypeName: self!

colonColonToken
	^colonColonToken!

colonColonToken: aSmaCCToken
	colonColonToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeTokenVariables
	^#(#identifierTokens #lessThanTokens #commas #gtTokens #periodTokens)!

gtTokens
	^gtTokens!

gtTokens: anOrderedCollection
	gtTokens := anOrderedCollection!

identifierTokens
	^identifierTokens!

identifierTokens: anOrderedCollection
	identifierTokens := anOrderedCollection!

initialize
	super initialize.
	identifierTokens := OrderedCollection new: 2.
	lessThanTokens := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	gtTokens := OrderedCollection new: 2.
	periodTokens := OrderedCollection new: 2.!

lessThanTokens
	^lessThanTokens!

lessThanTokens: anOrderedCollection
	lessThanTokens := anOrderedCollection!

periodTokens
	^periodTokens!

periodTokens: anOrderedCollection
	periodTokens := anOrderedCollection!

tokenVariables
	^#(#colonColonToken)! !
!CSUnboundTypeNameNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #colonColonToken!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #colonColonToken:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #commas!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #commas:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #gtTokens!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #gtTokens:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #identifierTokens!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #identifierTokens:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSUnboundTypeNameNode categoriesFor: #lessThanTokens!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #lessThanTokens:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #periodTokens!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #periodTokens:!generated!public! !
!CSUnboundTypeNameNode categoriesFor: #tokenVariables!generated!public! !

CSUsingAliasDirectiveNode guid: (GUID fromString: '{39815FC2-A6A4-44F3-8698-6910589DA188}')!
CSUsingAliasDirectiveNode comment: ''!
!CSUsingAliasDirectiveNode categoriesForClass!Unclassified! !
!CSUsingAliasDirectiveNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUsingAliasDirective: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

namespace
	^namespace!

namespace: aCSTypeNode
	self namespace notNil ifTrue: [self namespace parent: nil].
	namespace := aCSTypeNode.
	self namespace notNil ifTrue: [self namespace parent: self]!

nodeVariables
	^#(#namespace)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#usingToken #name #equalToken)!

usingToken
	^usingToken!

usingToken: aSmaCCToken
	usingToken := aSmaCCToken! !
!CSUsingAliasDirectiveNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #equalToken!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #equalToken:!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #name!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #name:!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #namespace!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #namespace:!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #nodeVariables!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #semicolonToken!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #semicolonToken:!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #tokenVariables!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #usingToken!generated!public! !
!CSUsingAliasDirectiveNode categoriesFor: #usingToken:!generated!public! !

CSUsingNamespaceDirectiveNode guid: (GUID fromString: '{DE5FF914-2769-48F8-9DB4-407E69953F18}')!
CSUsingNamespaceDirectiveNode comment: ''!
!CSUsingNamespaceDirectiveNode categoriesForClass!Unclassified! !
!CSUsingNamespaceDirectiveNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUsingNamespaceDirective: self!

ignoredTokenVariables
	^#(#semicolonToken)!

namespace
	^namespace!

namespace: aCSTypeNode
	self namespace notNil ifTrue: [self namespace parent: nil].
	namespace := aCSTypeNode.
	self namespace notNil ifTrue: [self namespace parent: self]!

nodeVariables
	^#(#namespace)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#usingToken)!

usingToken
	^usingToken!

usingToken: aSmaCCToken
	usingToken := aSmaCCToken! !
!CSUsingNamespaceDirectiveNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #namespace!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #namespace:!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #nodeVariables!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #semicolonToken!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #semicolonToken:!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #tokenVariables!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #usingToken!generated!public! !
!CSUsingNamespaceDirectiveNode categoriesFor: #usingToken:!generated!public! !

CSVariableDeclaratorNode guid: (GUID fromString: '{E50C8B52-FD42-4283-BD48-D7B85575CFA0}')!
CSVariableDeclaratorNode comment: ''!
!CSVariableDeclaratorNode categoriesForClass!Unclassified! !
!CSVariableDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableDeclarator: self!

equalToken
	^equalToken!

equalToken: aSmaCCToken
	equalToken := aSmaCCToken!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

initializer
	^initializer!

initializer: aCSProgramNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aCSProgramNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

nodeVariables
	^#(#initializer)!

tokenVariables
	^#(#identifierToken #equalToken)! !
!CSVariableDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #equalToken!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #equalToken:!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #identifierToken!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #identifierToken:!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #initializer!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #initializer:!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!CSVariableDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

CSClassDeclarationNode guid: (GUID fromString: '{D4F6B8D8-8C42-4733-B6F0-78E4907E2CAB}')!
CSClassDeclarationNode comment: ''!
!CSClassDeclarationNode categoriesForClass!Unclassified! !
!CSClassDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitClassDeclaration: self!

classToken
	^classToken!

classToken: aSmaCCToken
	classToken := aSmaCCToken!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

commaToken
	^commaToken!

commaToken: aSmaCCToken
	commaToken := aSmaCCToken!

compositeNodeVariables
	^#(#_attributes #supertypes #constraintClauses #declarations)!

compositeTokenVariables
	^#(#modifiers #commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

ignoredTokenVariables
	^#(#commaToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	supertypes := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#typeParameters)!

partialToken
	^partialToken!

partialToken: aSmaCCToken
	partialToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

supertypes
	^supertypes!

supertypes: anOrderedCollection
	self setParents: self supertypes to: nil.
	supertypes := anOrderedCollection.
	self setParents: self supertypes to: self!

tokenVariables
	^#(#partialToken #classToken #name #colonToken #leftBraceToken #rightBraceToken #semicolon)!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSClassDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSClassDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSClassDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSClassDeclarationNode categoriesFor: #classToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #classToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #colonToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #colonToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #commas!generated!public! !
!CSClassDeclarationNode categoriesFor: #commas:!generated!public! !
!CSClassDeclarationNode categoriesFor: #commaToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #commaToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSClassDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSClassDeclarationNode categoriesFor: #constraintClauses!generated!public! !
!CSClassDeclarationNode categoriesFor: #constraintClauses:!generated!public! !
!CSClassDeclarationNode categoriesFor: #declarations!generated!public! !
!CSClassDeclarationNode categoriesFor: #declarations:!generated!public! !
!CSClassDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSClassDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSClassDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSClassDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSClassDeclarationNode categoriesFor: #name!generated!public! !
!CSClassDeclarationNode categoriesFor: #name:!generated!public! !
!CSClassDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSClassDeclarationNode categoriesFor: #partialToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #partialToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSClassDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSClassDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSClassDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSClassDeclarationNode categoriesFor: #supertypes!generated!public! !
!CSClassDeclarationNode categoriesFor: #supertypes:!generated!public! !
!CSClassDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSClassDeclarationNode categoriesFor: #typeParameters!generated!public! !
!CSClassDeclarationNode categoriesFor: #typeParameters:!generated!public! !

CSConstantDeclarationNode guid: (GUID fromString: '{B6112315-0DB6-4DBD-9913-D7F4DF2E2DE0}')!
CSConstantDeclarationNode comment: ''!
!CSConstantDeclarationNode categoriesForClass!Unclassified! !
!CSConstantDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstantDeclaration: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #declarators)!

compositeTokenVariables
	^#(#modifiers)!

constToken
	^constToken!

constToken: aSmaCCToken
	constToken := aSmaCCToken!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#type)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#constToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSConstantDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSConstantDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #commaTokens!generated!public! !
!CSConstantDeclarationNode categoriesFor: #commaTokens:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #constToken!generated!public! !
!CSConstantDeclarationNode categoriesFor: #constToken:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #declarators!generated!public! !
!CSConstantDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSConstantDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSConstantDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSConstantDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSConstantDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSConstantDeclarationNode categoriesFor: #type!generated!public! !
!CSConstantDeclarationNode categoriesFor: #type:!generated!public! !

CSConstructorDeclarationNode guid: (GUID fromString: '{173D5720-5062-406D-8DB1-54DE30272C6F}')!
CSConstructorDeclarationNode comment: ''!
!CSConstructorDeclarationNode categoriesForClass!Unclassified! !
!CSConstructorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstructorDeclaration: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters)!

compositeTokenVariables
	^#(#modifiers #commas)!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

initializer
	^initializer!

initializer: aCSConstructorInitializerNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aCSConstructorInitializerNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#initializer #block)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#identifierToken #leftParenToken #rightParenToken)! !
!CSConstructorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #block!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #block:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #commas!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #commas:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #identifierToken!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #identifierToken:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSConstructorDeclarationNode categoriesFor: #initializer!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #initializer:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #leftParenToken!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #leftParenToken:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #parameters!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #parameters:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #rightParenToken!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #rightParenToken:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSConstructorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSDelegateDeclarationNode guid: (GUID fromString: '{B61395AB-D215-49F3-A531-E2CBA2D6CD02}')!
CSDelegateDeclarationNode comment: ''!
!CSDelegateDeclarationNode categoriesForClass!Unclassified! !
!CSDelegateDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDelegateDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters #constraintClauses)!

compositeTokenVariables
	^#(#modifiers #commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

delegateToken
	^delegateToken!

delegateToken: aSmaCCToken
	delegateToken := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #typeParameters)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#delegateToken #name #leftParen #rightParen #semicolon)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSDelegateDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #commas!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #commas:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #constraintClauses!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #constraintClauses:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #delegateToken!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #delegateToken:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSDelegateDeclarationNode categoriesFor: #leftParen!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #leftParen:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #name!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #name:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #parameters!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #parameters:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #rightParen!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #rightParen:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #type!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #type:!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #typeParameters!generated!public! !
!CSDelegateDeclarationNode categoriesFor: #typeParameters:!generated!public! !

CSDestructorDeclarationNode guid: (GUID fromString: '{8E176821-3058-4E57-B4CD-94B79DD2E657}')!
CSDestructorDeclarationNode comment: ''!
!CSDestructorDeclarationNode categoriesForClass!Unclassified! !
!CSDestructorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDestructorDeclaration: self!

body
	^body!

body: aCSMethodBodyNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSMethodBodyNode.
	self body notNil ifTrue: [self body parent: self]!

compositeNodeVariables
	^#(#_attributes)!

compositeTokenVariables
	^#(#modifiers)!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#body)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tildeToken
	^tildeToken!

tildeToken: aSmaCCToken
	tildeToken := aSmaCCToken!

tokenVariables
	^#(#tildeToken #identifierToken #leftParenToken #rightParenToken)! !
!CSDestructorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #body!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #body:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #identifierToken!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #identifierToken:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSDestructorDeclarationNode categoriesFor: #leftParenToken!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #leftParenToken:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #rightParenToken!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #rightParenToken:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #tildeToken!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #tildeToken:!generated!public! !
!CSDestructorDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSEnumDeclarationNode guid: (GUID fromString: '{941EE8A0-752C-4384-A24C-9454E1D04C5A}')!
CSEnumDeclarationNode comment: ''!
!CSEnumDeclarationNode categoriesForClass!Unclassified! !
!CSEnumDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEnumDeclaration: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #declarations)!

compositeTokenVariables
	^#(#modifiers #commas)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

enumToken
	^enumToken!

enumToken: aSmaCCToken
	enumToken := aSmaCCToken!

equal
	^equal!

equal: aSmaCCToken
	equal := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#value)!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#enumToken #name #colonToken #type #leftBrace #rightBrace #semicolon #equal)!

type
	^type!

type: aSmaCCToken
	type := aSmaCCToken!

value
	^value!

value: aCSExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aCSExpressionNode.
	self value notNil ifTrue: [self value parent: self]! !
!CSEnumDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSEnumDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #colonToken!generated!public! !
!CSEnumDeclarationNode categoriesFor: #colonToken:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #commas!generated!public! !
!CSEnumDeclarationNode categoriesFor: #commas:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSEnumDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSEnumDeclarationNode categoriesFor: #declarations!generated!public! !
!CSEnumDeclarationNode categoriesFor: #declarations:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #enumToken!generated!public! !
!CSEnumDeclarationNode categoriesFor: #enumToken:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #equal!generated!public! !
!CSEnumDeclarationNode categoriesFor: #equal:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSEnumDeclarationNode categoriesFor: #leftBrace!generated!public! !
!CSEnumDeclarationNode categoriesFor: #leftBrace:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSEnumDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #name!generated!public! !
!CSEnumDeclarationNode categoriesFor: #name:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSEnumDeclarationNode categoriesFor: #rightBrace!generated!public! !
!CSEnumDeclarationNode categoriesFor: #rightBrace:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSEnumDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSEnumDeclarationNode categoriesFor: #type!generated!public! !
!CSEnumDeclarationNode categoriesFor: #type:!generated!public! !
!CSEnumDeclarationNode categoriesFor: #value!generated!public! !
!CSEnumDeclarationNode categoriesFor: #value:!generated!public! !

CSEventDeclarationNode guid: (GUID fromString: '{887F5FED-7F72-4333-A02F-278BBC82EC39}')!
CSEventDeclarationNode comment: ''!
!CSEventDeclarationNode categoriesForClass!Unclassified! !
!CSEventDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEventDeclaration: self!

addDeclaration
	^addDeclaration!

addDeclaration: aCSAddAccessorDeclarationNode
	self addDeclaration notNil ifTrue: [self addDeclaration parent: nil].
	addDeclaration := aCSAddAccessorDeclarationNode.
	self addDeclaration notNil ifTrue: [self addDeclaration parent: self]!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #declarators)!

compositeTokenVariables
	^#(#modifiers)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

eventToken
	^eventToken!

eventToken: aSmaCCToken
	eventToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

interface
	^interface!

interface: aCSTypeNode
	self interface notNil ifTrue: [self interface parent: nil].
	interface := aCSTypeNode.
	self interface notNil ifTrue: [self interface parent: self]!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #interface #addDeclaration #removeDeclaration)!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

removeDeclaration
	^removeDeclaration!

removeDeclaration: aCSRemoveAccessorDeclarationNode
	self removeDeclaration notNil ifTrue: [self removeDeclaration parent: nil].
	removeDeclaration := aCSRemoveAccessorDeclarationNode.
	self removeDeclaration notNil ifTrue: [self removeDeclaration parent: self]!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#eventToken #name #periodToken #leftBraceToken #rightBraceToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSEventDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSEventDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSEventDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSEventDeclarationNode categoriesFor: #addDeclaration!generated!public! !
!CSEventDeclarationNode categoriesFor: #addDeclaration:!generated!public! !
!CSEventDeclarationNode categoriesFor: #commaTokens!generated!public! !
!CSEventDeclarationNode categoriesFor: #commaTokens:!generated!public! !
!CSEventDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #declarators!generated!public! !
!CSEventDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSEventDeclarationNode categoriesFor: #eventToken!generated!public! !
!CSEventDeclarationNode categoriesFor: #eventToken:!generated!public! !
!CSEventDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSEventDeclarationNode categoriesFor: #interface!generated!public! !
!CSEventDeclarationNode categoriesFor: #interface:!generated!public! !
!CSEventDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSEventDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSEventDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSEventDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSEventDeclarationNode categoriesFor: #name!generated!public! !
!CSEventDeclarationNode categoriesFor: #name:!generated!public! !
!CSEventDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #periodToken!generated!public! !
!CSEventDeclarationNode categoriesFor: #periodToken:!generated!public! !
!CSEventDeclarationNode categoriesFor: #removeDeclaration!generated!public! !
!CSEventDeclarationNode categoriesFor: #removeDeclaration:!generated!public! !
!CSEventDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSEventDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSEventDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSEventDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSEventDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSEventDeclarationNode categoriesFor: #type!generated!public! !
!CSEventDeclarationNode categoriesFor: #type:!generated!public! !

CSFieldDeclarationNode guid: (GUID fromString: '{CFA632AE-5A73-45D5-84DC-51870C64A1B8}')!
CSFieldDeclarationNode comment: ''!
!CSFieldDeclarationNode categoriesForClass!Unclassified! !
!CSFieldDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFieldDeclaration: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #declarators)!

compositeTokenVariables
	^#(#newTokens #publicTokens #protectedTokens #internalTokens #privateTokens #staticTokens #readonlyTokens #volatileTokens #unsafeTokens)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	newTokens := OrderedCollection new: 2.
	publicTokens := OrderedCollection new: 2.
	protectedTokens := OrderedCollection new: 2.
	internalTokens := OrderedCollection new: 2.
	privateTokens := OrderedCollection new: 2.
	staticTokens := OrderedCollection new: 2.
	readonlyTokens := OrderedCollection new: 2.
	volatileTokens := OrderedCollection new: 2.
	unsafeTokens := OrderedCollection new: 2.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

internalTokens
	^internalTokens!

internalTokens: anOrderedCollection
	internalTokens := anOrderedCollection!

newTokens
	^newTokens!

newTokens: anOrderedCollection
	newTokens := anOrderedCollection!

nodeVariables
	^#(#type)!

privateTokens
	^privateTokens!

privateTokens: anOrderedCollection
	privateTokens := anOrderedCollection!

protectedTokens
	^protectedTokens!

protectedTokens: anOrderedCollection
	protectedTokens := anOrderedCollection!

publicTokens
	^publicTokens!

publicTokens: anOrderedCollection
	publicTokens := anOrderedCollection!

readonlyTokens
	^readonlyTokens!

readonlyTokens: anOrderedCollection
	readonlyTokens := anOrderedCollection!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

staticTokens
	^staticTokens!

staticTokens: anOrderedCollection
	staticTokens := anOrderedCollection!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]!

unsafeTokens
	^unsafeTokens!

unsafeTokens: anOrderedCollection
	unsafeTokens := anOrderedCollection!

volatileTokens
	^volatileTokens!

volatileTokens: anOrderedCollection
	volatileTokens := anOrderedCollection! !
!CSFieldDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSFieldDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #commaTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #commaTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSFieldDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSFieldDeclarationNode categoriesFor: #declarators!generated!public! !
!CSFieldDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSFieldDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSFieldDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSFieldDeclarationNode categoriesFor: #internalTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #internalTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #newTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #newTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSFieldDeclarationNode categoriesFor: #privateTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #privateTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #protectedTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #protectedTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #publicTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #publicTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #readonlyTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #readonlyTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSFieldDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #staticTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #staticTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #type!generated!public! !
!CSFieldDeclarationNode categoriesFor: #type:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #unsafeTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #unsafeTokens:!generated!public! !
!CSFieldDeclarationNode categoriesFor: #volatileTokens!generated!public! !
!CSFieldDeclarationNode categoriesFor: #volatileTokens:!generated!public! !

CSFixedSizeBufferDeclarationNode guid: (GUID fromString: '{D1A0A8C6-61A6-4CBA-A839-3213234D4EE5}')!
CSFixedSizeBufferDeclarationNode comment: ''!
!CSFixedSizeBufferDeclarationNode categoriesForClass!Unclassified! !
!CSFixedSizeBufferDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFixedSizeBufferDeclaration: self!

compositeNodeVariables
	^#(#_attributes #declarators)!

compositeTokenVariables
	^#(#modifiers)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

fixedToken
	^fixedToken!

fixedToken: aSmaCCToken
	fixedToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	declarators := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#type)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#fixedToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #declarators!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #fixedToken!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #fixedToken:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #type!generated!public! !
!CSFixedSizeBufferDeclarationNode categoriesFor: #type:!generated!public! !

CSIndexerDeclarationNode guid: (GUID fromString: '{978161CB-7AB4-4A12-B7A3-472C0742E39D}')!
CSIndexerDeclarationNode comment: ''!
!CSIndexerDeclarationNode categoriesForClass!Unclassified! !
!CSIndexerDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIndexerDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters)!

compositeTokenVariables
	^#(#modifiers #commas)!

getAccessor
	^getAccessor!

getAccessor: aCSGetAccessorDeclarationNode
	self getAccessor notNil ifTrue: [self getAccessor parent: nil].
	getAccessor := aCSGetAccessorDeclarationNode.
	self getAccessor notNil ifTrue: [self getAccessor parent: self]!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#returnType #type #getAccessor #setAccessor)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

returnType
	^returnType!

returnType: aCSTypeNode
	self returnType notNil ifTrue: [self returnType parent: nil].
	returnType := aCSTypeNode.
	self returnType notNil ifTrue: [self returnType parent: self]!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

setAccessor
	^setAccessor!

setAccessor: aCSSetAccessorDeclarationNode
	self setAccessor notNil ifTrue: [self setAccessor parent: nil].
	setAccessor := aCSSetAccessorDeclarationNode.
	self setAccessor notNil ifTrue: [self setAccessor parent: self]!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#thisToken #leftBracketToken #rightBracketToken #periodToken #leftBraceToken #rightBraceToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSIndexerDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #commas!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #commas:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #getAccessor!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #getAccessor:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSIndexerDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #leftBracketToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #leftBracketToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #parameters!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #parameters:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #periodToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #periodToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #returnType!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #returnType:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #rightBracketToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #rightBracketToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #setAccessor!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #setAccessor:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #thisToken!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #thisToken:!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #type!generated!public! !
!CSIndexerDeclarationNode categoriesFor: #type:!generated!public! !

CSInterfaceDeclarationNode guid: (GUID fromString: '{0079C93C-24BB-4F5F-B03A-A7E9962D2445}')!
CSInterfaceDeclarationNode comment: ''!
!CSInterfaceDeclarationNode categoriesForClass!Unclassified! !
!CSInterfaceDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfaceDeclaration: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #supertypes #constraintClauses #declarations)!

compositeTokenVariables
	^#(#modifiers #commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	supertypes := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

interfaceToken
	^interfaceToken!

interfaceToken: aSmaCCToken
	interfaceToken := aSmaCCToken!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#typeParameters)!

partialToken
	^partialToken!

partialToken: aSmaCCToken
	partialToken := aSmaCCToken!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

supertypes
	^supertypes!

supertypes: anOrderedCollection
	self setParents: self supertypes to: nil.
	supertypes := anOrderedCollection.
	self setParents: self supertypes to: self!

tokenVariables
	^#(#partialToken #interfaceToken #name #colon #leftBrace #rightBrace #semicolon)!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSInterfaceDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #colon!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #colon:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #commas!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #commas:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #constraintClauses!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #constraintClauses:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #declarations!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #declarations:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfaceDeclarationNode categoriesFor: #interfaceToken!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #interfaceToken:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #leftBrace!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #leftBrace:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #name!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #name:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #partialToken!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #partialToken:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #rightBrace!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #rightBrace:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #supertypes!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #supertypes:!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #typeParameters!generated!public! !
!CSInterfaceDeclarationNode categoriesFor: #typeParameters:!generated!public! !

CSInterfaceEventDeclarationNode guid: (GUID fromString: '{7387E76E-51D1-49DA-B62D-0A24A9DC712D}')!
CSInterfaceEventDeclarationNode comment: ''!
!CSInterfaceEventDeclarationNode categoriesForClass!Unclassified! !
!CSInterfaceEventDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfaceEventDeclaration: self!

compositeNodeVariables
	^#(#_attributes)!

eventToken
	^eventToken!

eventToken: aSmaCCToken
	eventToken := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#modifier #eventToken #name #semicolon)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSInterfaceEventDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #eventToken!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #eventToken:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #modifier!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #modifier:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #name!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #name:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #type!generated!public! !
!CSInterfaceEventDeclarationNode categoriesFor: #type:!generated!public! !

CSInterfaceIndexerDeclarationNode guid: (GUID fromString: '{D9F21E44-55C3-43C9-8235-1A51CC739AF6}')!
CSInterfaceIndexerDeclarationNode comment: ''!
!CSInterfaceIndexerDeclarationNode categoriesForClass!Unclassified! !
!CSInterfaceIndexerDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfaceIndexerDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters)!

compositeTokenVariables
	^#(#commas)!

getAccessor
	^getAccessor!

getAccessor: aCSInterfacePropertyAccessorNode
	self getAccessor notNil ifTrue: [self getAccessor parent: nil].
	getAccessor := aCSInterfacePropertyAccessorNode.
	self getAccessor notNil ifTrue: [self getAccessor parent: self]!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

leftBracket
	^leftBracket!

leftBracket: aSmaCCToken
	leftBracket := aSmaCCToken!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

nodeVariables
	^#(#type #getAccessor #setAccessor)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

rightBracket
	^rightBracket!

rightBracket: aSmaCCToken
	rightBracket := aSmaCCToken!

setAccessor
	^setAccessor!

setAccessor: aCSInterfacePropertyAccessorNode
	self setAccessor notNil ifTrue: [self setAccessor parent: nil].
	setAccessor := aCSInterfacePropertyAccessorNode.
	self setAccessor notNil ifTrue: [self setAccessor parent: self]!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#modifier #thisToken #leftBracket #rightBracket #leftBrace #rightBrace)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #commas!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #commas:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #getAccessor!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #getAccessor:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #leftBrace!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #leftBrace:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #leftBracket!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #leftBracket:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #modifier!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #modifier:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #parameters!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #parameters:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #rightBrace!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #rightBrace:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #rightBracket!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #rightBracket:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #setAccessor!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #setAccessor:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #thisToken!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #thisToken:!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #type!generated!public! !
!CSInterfaceIndexerDeclarationNode categoriesFor: #type:!generated!public! !

CSInterfaceMethodDeclarationNode guid: (GUID fromString: '{75DD1165-F5C9-4254-9F0E-1F7C3B259777}')!
CSInterfaceMethodDeclarationNode comment: ''!
!CSInterfaceMethodDeclarationNode categoriesForClass!Unclassified! !
!CSInterfaceMethodDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfaceMethodDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #parameters #constraintClauses)!

compositeTokenVariables
	^#(#commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #typeParameters)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#modifier #name #leftParen #rightParen #semicolon)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSInterfaceMethodDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #commas!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #commas:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #constraintClauses!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #constraintClauses:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #leftParen!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #leftParen:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #modifier!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #modifier:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #name!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #name:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #parameters!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #parameters:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #rightParen!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #rightParen:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #type!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #type:!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #typeParameters!generated!public! !
!CSInterfaceMethodDeclarationNode categoriesFor: #typeParameters:!generated!public! !

CSInterfacePropertyDeclarationNode guid: (GUID fromString: '{6605AC5B-11F9-40A4-8916-0F229F2E5F05}')!
CSInterfacePropertyDeclarationNode comment: ''!
!CSInterfacePropertyDeclarationNode categoriesForClass!Unclassified! !
!CSInterfacePropertyDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterfacePropertyDeclaration: self!

compositeNodeVariables
	^#(#_attributes)!

getAccessor
	^getAccessor!

getAccessor: aCSInterfacePropertyAccessorNode
	self getAccessor notNil ifTrue: [self getAccessor parent: nil].
	getAccessor := aCSInterfacePropertyAccessorNode.
	self getAccessor notNil ifTrue: [self getAccessor parent: self]!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

modifier
	^modifier!

modifier: aSmaCCToken
	modifier := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #getAccessor #setAccessor)!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

setAccessor
	^setAccessor!

setAccessor: aCSInterfacePropertyAccessorNode
	self setAccessor notNil ifTrue: [self setAccessor parent: nil].
	setAccessor := aCSInterfacePropertyAccessorNode.
	self setAccessor notNil ifTrue: [self setAccessor parent: self]!

tokenVariables
	^#(#modifier #name #leftBrace #rightBrace)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSInterfacePropertyDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #getAccessor!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #getAccessor:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #leftBrace!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #leftBrace:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #modifier!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #modifier:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #name!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #name:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #rightBrace!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #rightBrace:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #setAccessor!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #setAccessor:!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #type!generated!public! !
!CSInterfacePropertyDeclarationNode categoriesFor: #type:!generated!public! !

CSLocalConstantDeclarationNode guid: (GUID fromString: '{70BADD84-D002-4074-976B-570989EA313D}')!
CSLocalConstantDeclarationNode comment: ''!
!CSLocalConstantDeclarationNode categoriesForClass!Unclassified! !
!CSLocalConstantDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLocalConstantDeclaration: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#declarators)!

constToken
	^constToken!

constToken: aSmaCCToken
	constToken := aSmaCCToken!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

nodeVariables
	^#(#type)!

tokenVariables
	^#(#constToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSLocalConstantDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #commaTokens!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #commaTokens:!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #constToken!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #constToken:!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #declarators!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSLocalConstantDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #type!generated!public! !
!CSLocalConstantDeclarationNode categoriesFor: #type:!generated!public! !

CSLocalVariableDeclarationNode guid: (GUID fromString: '{5CFF762C-1F7F-4A1A-AF45-C11EEE68A8D2}')!
CSLocalVariableDeclarationNode comment: ''!
!CSLocalVariableDeclarationNode categoriesForClass!Unclassified! !
!CSLocalVariableDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLocalVariableDeclaration: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#declarators)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

nodeVariables
	^#(#type)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSLocalVariableDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #commaTokens!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #commaTokens:!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #declarators!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #declarators:!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSLocalVariableDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #type!generated!public! !
!CSLocalVariableDeclarationNode categoriesFor: #type:!generated!public! !

CSMethodDeclarationNode guid: (GUID fromString: '{33DF240C-D28E-4C7E-81D8-8FFB09FD2B7E}')!
CSMethodDeclarationNode comment: ''!
!CSMethodDeclarationNode categoriesForClass!Unclassified! !
!CSMethodDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodDeclaration: self!

body
	^body!

body: aCSMethodBodyNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSMethodBodyNode.
	self body notNil ifTrue: [self body parent: self]!

header
	^header!

header: aCSMethodHeaderNode
	self header notNil ifTrue: [self header parent: nil].
	header := aCSMethodHeaderNode.
	self header notNil ifTrue: [self header parent: self]!

nodeVariables
	^#(#header #body)! !
!CSMethodDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMethodDeclarationNode categoriesFor: #body!generated!public! !
!CSMethodDeclarationNode categoriesFor: #body:!generated!public! !
!CSMethodDeclarationNode categoriesFor: #header!generated!public! !
!CSMethodDeclarationNode categoriesFor: #header:!generated!public! !
!CSMethodDeclarationNode categoriesFor: #nodeVariables!generated!public! !

CSNamespaceDeclarationNode guid: (GUID fromString: '{23E0D20B-D625-4303-9A47-A725C597D35A}')!
CSNamespaceDeclarationNode comment: ''!
!CSNamespaceDeclarationNode categoriesForClass!Unclassified! !
!CSNamespaceDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNamespaceDeclaration: self!

compositeNodeVariables
	^#(#directives #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

directives
	^directives!

directives: anOrderedCollection
	self setParents: self directives to: nil.
	directives := anOrderedCollection.
	self setParents: self directives to: self!

identifier
	^identifier!

identifier: aCSQualifiedIdentifierNode
	self identifier notNil ifTrue: [self identifier parent: nil].
	identifier := aCSQualifiedIdentifierNode.
	self identifier notNil ifTrue: [self identifier parent: self]!

initialize
	super initialize.
	directives := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

namespaceToken
	^namespaceToken!

namespaceToken: aSmaCCToken
	namespaceToken := aSmaCCToken!

nodeVariables
	^#(#identifier)!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#namespaceToken #leftBraceToken #rightBraceToken #semicolon)! !
!CSNamespaceDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #declarations!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #declarations:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #directives!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #directives:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #identifier!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #identifier:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSNamespaceDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #namespaceToken!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #namespaceToken:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSNamespaceDeclarationNode categoriesFor: #tokenVariables!generated!public! !

CSOperatorDeclarationNode guid: (GUID fromString: '{61BAA084-4842-4D5D-AC76-781AD4E5FB25}')!
CSOperatorDeclarationNode comment: ''!
!CSOperatorDeclarationNode categoriesForClass!Unclassified! !
!CSOperatorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitOperatorDeclaration: self!

arguments
	^arguments!

arguments: anOrderedCollection
	arguments := anOrderedCollection!

body
	^body!

body: aCSMethodBodyNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSMethodBodyNode.
	self body notNil ifTrue: [self body parent: self]!

commaToken
	^commaToken!

commaToken: aSmaCCToken
	commaToken := aSmaCCToken!

compositeNodeVariables
	^#(#_attributes #types)!

compositeTokenVariables
	^#(#modifiers #arguments)!

explicitToken
	^explicitToken!

explicitToken: aSmaCCToken
	explicitToken := aSmaCCToken!

ignoredTokenVariables
	^#(#commaToken)!

implicitToken
	^implicitToken!

implicitToken: aSmaCCToken
	implicitToken := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	types := OrderedCollection new: 2.
	arguments := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#returnType #body)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

operatorToken
	^operatorToken!

operatorToken: aSmaCCToken
	operatorToken := aSmaCCToken!

returnType
	^returnType!

returnType: aCSTypeNode
	self returnType notNil ifTrue: [self returnType parent: nil].
	returnType := aCSTypeNode.
	self returnType notNil ifTrue: [self returnType parent: self]!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#operatorToken #operator #leftParenToken #rightParenToken #implicitToken #explicitToken)!

types
	^types!

types: anOrderedCollection
	self setParents: self types to: nil.
	types := anOrderedCollection.
	self setParents: self types to: self! !
!CSOperatorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #arguments!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #arguments:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #body!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #body:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #commaToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #commaToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #explicitToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #explicitToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #implicitToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #implicitToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSOperatorDeclarationNode categoriesFor: #leftParenToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #leftParenToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #operator!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #operator:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #operatorToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #operatorToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #returnType!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #returnType:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #rightParenToken!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #rightParenToken:!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #types!generated!public! !
!CSOperatorDeclarationNode categoriesFor: #types:!generated!public! !

CSPropertyDeclarationNode guid: (GUID fromString: '{266148E4-8E2B-452A-8CFD-02EC5CC9D9BB}')!
CSPropertyDeclarationNode comment: ''!
!CSPropertyDeclarationNode categoriesForClass!Unclassified! !
!CSPropertyDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPropertyDeclaration: self!

compositeNodeVariables
	^#(#_attributes)!

compositeTokenVariables
	^#(#modifiers)!

getAccessor
	^getAccessor!

getAccessor: aCSGetAccessorDeclarationNode
	self getAccessor notNil ifTrue: [self getAccessor parent: nil].
	getAccessor := aCSGetAccessorDeclarationNode.
	self getAccessor notNil ifTrue: [self getAccessor parent: self]!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.!

interface
	^interface!

interface: aCSTypeNode
	self interface notNil ifTrue: [self interface parent: nil].
	interface := aCSTypeNode.
	self interface notNil ifTrue: [self interface parent: self]!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #interface #getAccessor #setAccessor)!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

setAccessor
	^setAccessor!

setAccessor: aCSSetAccessorDeclarationNode
	self setAccessor notNil ifTrue: [self setAccessor parent: nil].
	setAccessor := aCSSetAccessorDeclarationNode.
	self setAccessor notNil ifTrue: [self setAccessor parent: self]!

tokenVariables
	^#(#name #periodToken #leftBraceToken #rightBraceToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSPropertyDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #getAccessor!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #getAccessor:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSPropertyDeclarationNode categoriesFor: #interface!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #interface:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #name!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #name:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #periodToken!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #periodToken:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #setAccessor!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #setAccessor:!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #type!generated!public! !
!CSPropertyDeclarationNode categoriesFor: #type:!generated!public! !

CSStaticConstructorDeclarationNode guid: (GUID fromString: '{F4CDD896-0969-4351-AA1A-DAA34B0CDE52}')!
CSStaticConstructorDeclarationNode comment: ''!
!CSStaticConstructorDeclarationNode categoriesForClass!Unclassified! !
!CSStaticConstructorDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStaticConstructorDeclaration: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

compositeNodeVariables
	^#(#_attributes)!

compositeTokenVariables
	^#(#modifiers)!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#block)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

staticToken
	^staticToken!

staticToken: aSmaCCToken
	staticToken := aSmaCCToken!

tokenVariables
	^#(#staticToken #unsafeToken #identifierToken #leftParenToken #rightParenToken)!

unsafeToken
	^unsafeToken!

unsafeToken: aSmaCCToken
	unsafeToken := aSmaCCToken! !
!CSStaticConstructorDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #block!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #block:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #identifierToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #identifierToken:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #leftParenToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #leftParenToken:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #rightParenToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #rightParenToken:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #semicolonToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #semicolonToken:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #staticToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #staticToken:!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #unsafeToken!generated!public! !
!CSStaticConstructorDeclarationNode categoriesFor: #unsafeToken:!generated!public! !

CSStructDeclarationNode guid: (GUID fromString: '{882EF091-FD47-420B-9131-34EDF6C1C16A}')!
CSStructDeclarationNode comment: ''!
!CSStructDeclarationNode categoriesForClass!Unclassified! !
!CSStructDeclarationNode methodsFor!

_attributes
	^_attributes!

_attributes: anOrderedCollection
	self setParents: self _attributes to: nil.
	_attributes := anOrderedCollection.
	self setParents: self _attributes to: self!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStructDeclaration: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#_attributes #supertypes #constraintClauses #declarations)!

compositeTokenVariables
	^#(#modifiers #commas)!

constraintClauses
	^constraintClauses!

constraintClauses: anOrderedCollection
	self setParents: self constraintClauses to: nil.
	constraintClauses := anOrderedCollection.
	self setParents: self constraintClauses to: self!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

initialize
	super initialize.
	_attributes := OrderedCollection new: 2.
	modifiers := OrderedCollection new: 2.
	supertypes := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constraintClauses := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	modifiers := anOrderedCollection!

nodeVariables
	^#(#typeParameters)!

partialToken
	^partialToken!

partialToken: aSmaCCToken
	partialToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

structToken
	^structToken!

structToken: aSmaCCToken
	structToken := aSmaCCToken!

supertypes
	^supertypes!

supertypes: anOrderedCollection
	self setParents: self supertypes to: nil.
	supertypes := anOrderedCollection.
	self setParents: self supertypes to: self!

tokenVariables
	^#(#partialToken #structToken #identifierToken #colonToken #leftBraceToken #rightBraceToken #semicolon)!

typeParameters
	^typeParameters!

typeParameters: aCSTypeParameterListNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aCSTypeParameterListNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!CSStructDeclarationNode categoriesFor: #_attributes!generated!public! !
!CSStructDeclarationNode categoriesFor: #_attributes:!generated!public! !
!CSStructDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!CSStructDeclarationNode categoriesFor: #colonToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #colonToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #commas!generated!public! !
!CSStructDeclarationNode categoriesFor: #commas:!generated!public! !
!CSStructDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSStructDeclarationNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSStructDeclarationNode categoriesFor: #constraintClauses!generated!public! !
!CSStructDeclarationNode categoriesFor: #constraintClauses:!generated!public! !
!CSStructDeclarationNode categoriesFor: #declarations!generated!public! !
!CSStructDeclarationNode categoriesFor: #declarations:!generated!public! !
!CSStructDeclarationNode categoriesFor: #identifierToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #identifierToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSStructDeclarationNode categoriesFor: #leftBraceToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #leftBraceToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #modifiers!generated!public! !
!CSStructDeclarationNode categoriesFor: #modifiers:!generated!public! !
!CSStructDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!CSStructDeclarationNode categoriesFor: #partialToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #partialToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #rightBraceToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #rightBraceToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #semicolon!generated!public! !
!CSStructDeclarationNode categoriesFor: #semicolon:!generated!public! !
!CSStructDeclarationNode categoriesFor: #structToken!generated!public! !
!CSStructDeclarationNode categoriesFor: #structToken:!generated!public! !
!CSStructDeclarationNode categoriesFor: #supertypes!generated!public! !
!CSStructDeclarationNode categoriesFor: #supertypes:!generated!public! !
!CSStructDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!CSStructDeclarationNode categoriesFor: #typeParameters!generated!public! !
!CSStructDeclarationNode categoriesFor: #typeParameters:!generated!public! !

CSAnonymousMethodExpressionNode guid: (GUID fromString: '{73CE65BF-78B4-4DEF-8110-41523E8BBF3F}')!
CSAnonymousMethodExpressionNode comment: ''!
!CSAnonymousMethodExpressionNode categoriesForClass!Unclassified! !
!CSAnonymousMethodExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnonymousMethodExpression: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

delegateToken
	^delegateToken!

delegateToken: aSmaCCToken
	delegateToken := aSmaCCToken!

nodeVariables
	^#(#signature #block)!

signature
	^signature!

signature: aCSExplicitAnonymousFunctionSignatureNode
	self signature notNil ifTrue: [self signature parent: nil].
	signature := aCSExplicitAnonymousFunctionSignatureNode.
	self signature notNil ifTrue: [self signature parent: self]!

tokenVariables
	^#(#delegateToken)! !
!CSAnonymousMethodExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #block!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #block:!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #delegateToken!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #delegateToken:!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #signature!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #signature:!generated!public! !
!CSAnonymousMethodExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSAnonymousObjectCreationExpressionNode guid: (GUID fromString: '{121FA817-CED9-4BC1-8C6E-B73966B0D525}')!
CSAnonymousObjectCreationExpressionNode comment: ''!
!CSAnonymousObjectCreationExpressionNode categoriesForClass!Unclassified! !
!CSAnonymousObjectCreationExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnonymousObjectCreationExpression: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#declarators)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

tokenVariables
	^#(#newToken #leftBraceToken #rightBraceToken)! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #commaTokens!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #commaTokens:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #declarators!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #declarators:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #leftBraceToken!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #leftBraceToken:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #newToken!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #newToken:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #rightBraceToken!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #rightBraceToken:!generated!public! !
!CSAnonymousObjectCreationExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSArrayCreationExpressionNode guid: (GUID fromString: '{05BE59F5-E67B-4F5C-9C7D-64DCC6C53210}')!
CSArrayCreationExpressionNode comment: ''!
!CSArrayCreationExpressionNode categoriesForClass!Unclassified! !
!CSArrayCreationExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayCreationExpression: self!

arrayInitializer
	^arrayInitializer!

arrayInitializer: aCSArrayInitializerNode
	self arrayInitializer notNil ifTrue: [self arrayInitializer parent: nil].
	arrayInitializer := aCSArrayInitializerNode.
	self arrayInitializer notNil ifTrue: [self arrayInitializer parent: self]!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#expressions #rankSpecifiers)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.
	rankSpecifiers := OrderedCollection new: 2.!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#type #arrayInitializer)!

rankSpecifiers
	^rankSpecifiers!

rankSpecifiers: anOrderedCollection
	self setParents: self rankSpecifiers to: nil.
	rankSpecifiers := anOrderedCollection.
	self setParents: self rankSpecifiers to: self!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#newToken #leftBracketToken #rightBracketToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSArrayCreationExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #arrayInitializer!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #arrayInitializer:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #commaTokens!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #commaTokens:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #expressions!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #expressions:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSArrayCreationExpressionNode categoriesFor: #leftBracketToken!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #leftBracketToken:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #newToken!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #newToken:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #rankSpecifiers!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #rankSpecifiers:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #rightBracketToken!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #rightBracketToken:!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #type!generated!public! !
!CSArrayCreationExpressionNode categoriesFor: #type:!generated!public! !

CSAssignmentNode guid: (GUID fromString: '{E2452A8C-F4D2-45B3-9217-13981217BEC2}')!
CSAssignmentNode comment: ''!
!CSAssignmentNode categoriesForClass!Unclassified! !
!CSAssignmentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAssignment: self!

lhs
	^lhs!

lhs: aCSExpressionNode
	self lhs notNil ifTrue: [self lhs parent: nil].
	lhs := aCSExpressionNode.
	self lhs notNil ifTrue: [self lhs parent: self]!

nodeVariables
	^#(#lhs #rhs)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

rhs
	^rhs!

rhs: aCSExpressionNode
	self rhs notNil ifTrue: [self rhs parent: nil].
	rhs := aCSExpressionNode.
	self rhs notNil ifTrue: [self rhs parent: self]!

tokenVariables
	^#(#operator)! !
!CSAssignmentNode categoriesFor: #acceptVisitor:!generated!public! !
!CSAssignmentNode categoriesFor: #lhs!generated!public! !
!CSAssignmentNode categoriesFor: #lhs:!generated!public! !
!CSAssignmentNode categoriesFor: #nodeVariables!generated!public! !
!CSAssignmentNode categoriesFor: #operator!generated!public! !
!CSAssignmentNode categoriesFor: #operator:!generated!public! !
!CSAssignmentNode categoriesFor: #rhs!generated!public! !
!CSAssignmentNode categoriesFor: #rhs:!generated!public! !
!CSAssignmentNode categoriesFor: #tokenVariables!generated!public! !

CSBaseAccessNode guid: (GUID fromString: '{04E9B014-FEFF-48A6-8AC4-F560F2DE43F2}')!
CSBaseAccessNode comment: ''!
!CSBaseAccessNode categoriesForClass!Unclassified! !
!CSBaseAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBaseAccess: self!

baseToken
	^baseToken!

baseToken: aSmaCCToken
	baseToken := aSmaCCToken!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#baseToken #periodToken #identifier #leftBracketToken #rightBracketToken)! !
!CSBaseAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSBaseAccessNode categoriesFor: #baseToken!generated!public! !
!CSBaseAccessNode categoriesFor: #baseToken:!generated!public! !
!CSBaseAccessNode categoriesFor: #commaTokens!generated!public! !
!CSBaseAccessNode categoriesFor: #commaTokens:!generated!public! !
!CSBaseAccessNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSBaseAccessNode categoriesFor: #expressions!generated!public! !
!CSBaseAccessNode categoriesFor: #expressions:!generated!public! !
!CSBaseAccessNode categoriesFor: #identifier!generated!public! !
!CSBaseAccessNode categoriesFor: #identifier:!generated!public! !
!CSBaseAccessNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSBaseAccessNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSBaseAccessNode categoriesFor: #leftBracketToken!generated!public! !
!CSBaseAccessNode categoriesFor: #leftBracketToken:!generated!public! !
!CSBaseAccessNode categoriesFor: #periodToken!generated!public! !
!CSBaseAccessNode categoriesFor: #periodToken:!generated!public! !
!CSBaseAccessNode categoriesFor: #rightBracketToken!generated!public! !
!CSBaseAccessNode categoriesFor: #rightBracketToken:!generated!public! !
!CSBaseAccessNode categoriesFor: #tokenVariables!generated!public! !

CSBinaryExpressionNode guid: (GUID fromString: '{131CCF1F-C819-4D66-8F49-E870C7FF9AB4}')!
CSBinaryExpressionNode comment: ''!
!CSBinaryExpressionNode categoriesForClass!Unclassified! !
!CSBinaryExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBinaryExpression: self!

left
	^left!

left: aCSExpressionNode
	self left notNil ifTrue: [self left parent: nil].
	left := aCSExpressionNode.
	self left notNil ifTrue: [self left parent: self]!

nodeVariables
	^#(#left #right)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

right
	^right!

right: aCSProgramNode
	self right notNil ifTrue: [self right parent: nil].
	right := aCSProgramNode.
	self right notNil ifTrue: [self right parent: self]!

tokenVariables
	^#(#operator)! !
!CSBinaryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSBinaryExpressionNode categoriesFor: #left!generated!public! !
!CSBinaryExpressionNode categoriesFor: #left:!generated!public! !
!CSBinaryExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSBinaryExpressionNode categoriesFor: #operator!generated!public! !
!CSBinaryExpressionNode categoriesFor: #operator:!generated!public! !
!CSBinaryExpressionNode categoriesFor: #right!generated!public! !
!CSBinaryExpressionNode categoriesFor: #right:!generated!public! !
!CSBinaryExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSCastExpressionNode guid: (GUID fromString: '{B0E9933E-4ED5-4860-B167-25C711F09ECE}')!
CSCastExpressionNode comment: ''!
!CSCastExpressionNode categoriesForClass!Unclassified! !
!CSCastExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCastExpression: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#type #expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#leftParenToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSCastExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSCastExpressionNode categoriesFor: #expression!generated!public! !
!CSCastExpressionNode categoriesFor: #expression:!generated!public! !
!CSCastExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSCastExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSCastExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSCastExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSCastExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSCastExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSCastExpressionNode categoriesFor: #type!generated!public! !
!CSCastExpressionNode categoriesFor: #type:!generated!public! !

CSCheckedExpressionNode guid: (GUID fromString: '{5F0DCCBB-87A4-4246-99BA-635F606877D0}')!
CSCheckedExpressionNode comment: ''!
!CSCheckedExpressionNode categoriesForClass!Unclassified! !
!CSCheckedExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCheckedExpression: self!

checkedToken
	^checkedToken!

checkedToken: aSmaCCToken
	checkedToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#checkedToken #leftParenToken #rightParenToken)! !
!CSCheckedExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSCheckedExpressionNode categoriesFor: #checkedToken!generated!public! !
!CSCheckedExpressionNode categoriesFor: #checkedToken:!generated!public! !
!CSCheckedExpressionNode categoriesFor: #expression!generated!public! !
!CSCheckedExpressionNode categoriesFor: #expression:!generated!public! !
!CSCheckedExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSCheckedExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSCheckedExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSCheckedExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSCheckedExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSCheckedExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSConditionalExpressionNode guid: (GUID fromString: '{05CB7185-49BA-48F4-BBC6-11BBBB9F9B12}')!
CSConditionalExpressionNode comment: ''!
!CSConditionalExpressionNode categoriesForClass!Unclassified! !
!CSConditionalExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConditionalExpression: self!

booleanExpression
	^booleanExpression!

booleanExpression: aCSExpressionNode
	self booleanExpression notNil ifTrue: [self booleanExpression parent: nil].
	booleanExpression := aCSExpressionNode.
	self booleanExpression notNil ifTrue: [self booleanExpression parent: self]!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

falseExpression
	^falseExpression!

falseExpression: aCSExpressionNode
	self falseExpression notNil ifTrue: [self falseExpression parent: nil].
	falseExpression := aCSExpressionNode.
	self falseExpression notNil ifTrue: [self falseExpression parent: self]!

nodeVariables
	^#(#booleanExpression #trueExpression #falseExpression)!

questionMarkToken
	^questionMarkToken!

questionMarkToken: aSmaCCToken
	questionMarkToken := aSmaCCToken!

tokenVariables
	^#(#questionMarkToken #colonToken)!

trueExpression
	^trueExpression!

trueExpression: aCSExpressionNode
	self trueExpression notNil ifTrue: [self trueExpression parent: nil].
	trueExpression := aCSExpressionNode.
	self trueExpression notNil ifTrue: [self trueExpression parent: self]! !
!CSConditionalExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSConditionalExpressionNode categoriesFor: #booleanExpression!generated!public! !
!CSConditionalExpressionNode categoriesFor: #booleanExpression:!generated!public! !
!CSConditionalExpressionNode categoriesFor: #colonToken!generated!public! !
!CSConditionalExpressionNode categoriesFor: #colonToken:!generated!public! !
!CSConditionalExpressionNode categoriesFor: #falseExpression!generated!public! !
!CSConditionalExpressionNode categoriesFor: #falseExpression:!generated!public! !
!CSConditionalExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSConditionalExpressionNode categoriesFor: #questionMarkToken!generated!public! !
!CSConditionalExpressionNode categoriesFor: #questionMarkToken:!generated!public! !
!CSConditionalExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSConditionalExpressionNode categoriesFor: #trueExpression!generated!public! !
!CSConditionalExpressionNode categoriesFor: #trueExpression:!generated!public! !

CSDefaultValueExpressionNode guid: (GUID fromString: '{BCA11455-6E09-4717-BD46-AF34FC3DE146}')!
CSDefaultValueExpressionNode comment: ''!
!CSDefaultValueExpressionNode categoriesForClass!Unclassified! !
!CSDefaultValueExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDefaultValueExpression: self!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#type)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#defaultToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSDefaultValueExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #defaultToken!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #defaultToken:!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #type!generated!public! !
!CSDefaultValueExpressionNode categoriesFor: #type:!generated!public! !

CSDelegateCreationExpressionNode guid: (GUID fromString: '{2DE7581A-578E-461B-971D-E7899AFDFE7D}')!
CSDelegateCreationExpressionNode comment: ''!
!CSDelegateCreationExpressionNode categoriesForClass!Unclassified! !
!CSDelegateCreationExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDelegateCreationExpression: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#type #expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#newToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSDelegateCreationExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #expression!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #expression:!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #newToken!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #newToken:!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #type!generated!public! !
!CSDelegateCreationExpressionNode categoriesFor: #type:!generated!public! !

CSElementAccessNode guid: (GUID fromString: '{C76B7A96-5C0C-4983-8B6D-C29997CE0A7D}')!
CSElementAccessNode comment: ''!
!CSElementAccessNode categoriesForClass!Unclassified! !
!CSElementAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitElementAccess: self!

baseExpression
	^baseExpression!

baseExpression: aCSExpressionNode
	self baseExpression notNil ifTrue: [self baseExpression parent: nil].
	baseExpression := aCSExpressionNode.
	self baseExpression notNil ifTrue: [self baseExpression parent: self]!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

nodeVariables
	^#(#baseExpression)!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#leftBracketToken #rightBracketToken)! !
!CSElementAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSElementAccessNode categoriesFor: #baseExpression!generated!public! !
!CSElementAccessNode categoriesFor: #baseExpression:!generated!public! !
!CSElementAccessNode categoriesFor: #commaTokens!generated!public! !
!CSElementAccessNode categoriesFor: #commaTokens:!generated!public! !
!CSElementAccessNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSElementAccessNode categoriesFor: #expressions!generated!public! !
!CSElementAccessNode categoriesFor: #expressions:!generated!public! !
!CSElementAccessNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSElementAccessNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSElementAccessNode categoriesFor: #leftBracketToken!generated!public! !
!CSElementAccessNode categoriesFor: #leftBracketToken:!generated!public! !
!CSElementAccessNode categoriesFor: #nodeVariables!generated!public! !
!CSElementAccessNode categoriesFor: #rightBracketToken!generated!public! !
!CSElementAccessNode categoriesFor: #rightBracketToken:!generated!public! !
!CSElementAccessNode categoriesFor: #tokenVariables!generated!public! !

CSInvocationExpressionNode guid: (GUID fromString: '{68EC69DB-B7EA-43D9-97D3-695D91DFBA68}')!
CSInvocationExpressionNode comment: ''!
!CSInvocationExpressionNode categoriesForClass!Unclassified! !
!CSInvocationExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInvocationExpression: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#leftParenToken #rightParenToken)! !
!CSInvocationExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #arguments!generated!public! !
!CSInvocationExpressionNode categoriesFor: #arguments:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #commaTokens!generated!public! !
!CSInvocationExpressionNode categoriesFor: #commaTokens:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSInvocationExpressionNode categoriesFor: #expression!generated!public! !
!CSInvocationExpressionNode categoriesFor: #expression:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSInvocationExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSInvocationExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSInvocationExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSInvocationExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSInvocationExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSInvocationExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSLambdaExpressionNode guid: (GUID fromString: '{84290746-2AC3-4411-BBE0-9125CB572A3B}')!
CSLambdaExpressionNode comment: ''!
!CSLambdaExpressionNode categoriesForClass!Unclassified! !
!CSLambdaExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLambdaExpression: self!

body
	^body!

body: aCSProgramNode
	self body notNil ifTrue: [self body parent: nil].
	body := aCSProgramNode.
	self body notNil ifTrue: [self body parent: self]!

equalGreaterThanToken
	^equalGreaterThanToken!

equalGreaterThanToken: aSmaCCToken
	equalGreaterThanToken := aSmaCCToken!

nodeVariables
	^#(#signature #body)!

signature
	^signature!

signature: aCSProgramNode
	self signature notNil ifTrue: [self signature parent: nil].
	signature := aCSProgramNode.
	self signature notNil ifTrue: [self signature parent: self]!

tokenVariables
	^#(#equalGreaterThanToken)! !
!CSLambdaExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLambdaExpressionNode categoriesFor: #body!generated!public! !
!CSLambdaExpressionNode categoriesFor: #body:!generated!public! !
!CSLambdaExpressionNode categoriesFor: #equalGreaterThanToken!generated!public! !
!CSLambdaExpressionNode categoriesFor: #equalGreaterThanToken:!generated!public! !
!CSLambdaExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSLambdaExpressionNode categoriesFor: #signature!generated!public! !
!CSLambdaExpressionNode categoriesFor: #signature:!generated!public! !
!CSLambdaExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSLiteralExpressionNode guid: (GUID fromString: '{9B1B27E2-AB0A-4043-9CE5-61305DFC771B}')!
CSLiteralExpressionNode comment: ''!
!CSLiteralExpressionNode categoriesForClass!Unclassified! !
!CSLiteralExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLiteralExpression: self!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#token)! !
!CSLiteralExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLiteralExpressionNode categoriesFor: #token!generated!public! !
!CSLiteralExpressionNode categoriesFor: #token:!generated!public! !
!CSLiteralExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSMemberAccessNode guid: (GUID fromString: '{87ACC5BE-8825-422D-990D-664BFABA9034}')!
CSMemberAccessNode comment: ''!
!CSMemberAccessNode categoriesForClass!Unclassified! !
!CSMemberAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMemberAccess: self!

expression
	^expression!

expression: aCSProgramNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSProgramNode.
	self expression notNil ifTrue: [self expression parent: self]!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

nodeVariables
	^#(#expression #typeArguments)!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

tokenVariables
	^#(#periodToken #identifier)!

typeArguments
	^typeArguments!

typeArguments: aCSTypeArgumentListNode
	self typeArguments notNil ifTrue: [self typeArguments parent: nil].
	typeArguments := aCSTypeArgumentListNode.
	self typeArguments notNil ifTrue: [self typeArguments parent: self]! !
!CSMemberAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSMemberAccessNode categoriesFor: #expression!generated!public! !
!CSMemberAccessNode categoriesFor: #expression:!generated!public! !
!CSMemberAccessNode categoriesFor: #identifier!generated!public! !
!CSMemberAccessNode categoriesFor: #identifier:!generated!public! !
!CSMemberAccessNode categoriesFor: #nodeVariables!generated!public! !
!CSMemberAccessNode categoriesFor: #periodToken!generated!public! !
!CSMemberAccessNode categoriesFor: #periodToken:!generated!public! !
!CSMemberAccessNode categoriesFor: #tokenVariables!generated!public! !
!CSMemberAccessNode categoriesFor: #typeArguments!generated!public! !
!CSMemberAccessNode categoriesFor: #typeArguments:!generated!public! !

CSObjectCreationExpressionNode guid: (GUID fromString: '{AC80E786-C3A2-4624-B7BB-8582312E10AD}')!
CSObjectCreationExpressionNode comment: ''!
!CSObjectCreationExpressionNode categoriesForClass!Unclassified! !
!CSObjectCreationExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitObjectCreationExpression: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

initializer
	^initializer!

initializer: aCSProgramNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aCSProgramNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#type #initializer)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#newToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSObjectCreationExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #arguments!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #arguments:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #commaTokens!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #commaTokens:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSObjectCreationExpressionNode categoriesFor: #initializer!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #initializer:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #newToken!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #newToken:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #type!generated!public! !
!CSObjectCreationExpressionNode categoriesFor: #type:!generated!public! !

CSPointerElementAccessNode guid: (GUID fromString: '{F60CD14E-8A16-4B78-9746-5487E453657E}')!
CSPointerElementAccessNode comment: ''!
!CSPointerElementAccessNode categoriesForClass!Unclassified! !
!CSPointerElementAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPointerElementAccess: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

indexExpression
	^indexExpression!

indexExpression: aCSExpressionNode
	self indexExpression notNil ifTrue: [self indexExpression parent: nil].
	indexExpression := aCSExpressionNode.
	self indexExpression notNil ifTrue: [self indexExpression parent: self]!

leftBracketToken
	^leftBracketToken!

leftBracketToken: aSmaCCToken
	leftBracketToken := aSmaCCToken!

nodeVariables
	^#(#expression #indexExpression)!

rightBracketToken
	^rightBracketToken!

rightBracketToken: aSmaCCToken
	rightBracketToken := aSmaCCToken!

tokenVariables
	^#(#leftBracketToken #rightBracketToken)! !
!CSPointerElementAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPointerElementAccessNode categoriesFor: #expression!generated!public! !
!CSPointerElementAccessNode categoriesFor: #expression:!generated!public! !
!CSPointerElementAccessNode categoriesFor: #indexExpression!generated!public! !
!CSPointerElementAccessNode categoriesFor: #indexExpression:!generated!public! !
!CSPointerElementAccessNode categoriesFor: #leftBracketToken!generated!public! !
!CSPointerElementAccessNode categoriesFor: #leftBracketToken:!generated!public! !
!CSPointerElementAccessNode categoriesFor: #nodeVariables!generated!public! !
!CSPointerElementAccessNode categoriesFor: #rightBracketToken!generated!public! !
!CSPointerElementAccessNode categoriesFor: #rightBracketToken:!generated!public! !
!CSPointerElementAccessNode categoriesFor: #tokenVariables!generated!public! !

CSPointerMemberAccessNode guid: (GUID fromString: '{644AE279-98DC-48DC-AB02-EBF00B611479}')!
CSPointerMemberAccessNode comment: ''!
!CSPointerMemberAccessNode categoriesForClass!Unclassified! !
!CSPointerMemberAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPointerMemberAccess: self!

arrowToken
	^arrowToken!

arrowToken: aSmaCCToken
	arrowToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#arrowToken #name)! !
!CSPointerMemberAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #arrowToken!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #arrowToken:!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #expression!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #expression:!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #name!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #name:!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #nodeVariables!generated!public! !
!CSPointerMemberAccessNode categoriesFor: #tokenVariables!generated!public! !

CSPostExpressionNode guid: (GUID fromString: '{0C0F61AF-5FC9-44A0-A2B8-10100289E70C}')!
CSPostExpressionNode comment: ''!
!CSPostExpressionNode categoriesForClass!Unclassified! !
!CSPostExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPostExpression: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

tokenVariables
	^#(#operator)! !
!CSPostExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPostExpressionNode categoriesFor: #expression!generated!public! !
!CSPostExpressionNode categoriesFor: #expression:!generated!public! !
!CSPostExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSPostExpressionNode categoriesFor: #operator!generated!public! !
!CSPostExpressionNode categoriesFor: #operator:!generated!public! !
!CSPostExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSPrefixExpressionNode guid: (GUID fromString: '{2D5D9C3B-5361-46CC-9BCD-A13532314F38}')!
CSPrefixExpressionNode comment: ''!
!CSPrefixExpressionNode categoriesForClass!Unclassified! !
!CSPrefixExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPrefixExpression: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

tokenVariables
	^#(#operator)! !
!CSPrefixExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPrefixExpressionNode categoriesFor: #expression!generated!public! !
!CSPrefixExpressionNode categoriesFor: #expression:!generated!public! !
!CSPrefixExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSPrefixExpressionNode categoriesFor: #operator!generated!public! !
!CSPrefixExpressionNode categoriesFor: #operator:!generated!public! !
!CSPrefixExpressionNode categoriesFor: #tokenVariables!generated!public! !

CSQueryExpressionNode guid: (GUID fromString: '{730F2957-8CEB-4AED-BC34-A844D0A9C60E}')!
CSQueryExpressionNode comment: ''!
!CSQueryExpressionNode categoriesForClass!Unclassified! !
!CSQueryExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitQueryExpression: self!

ascendingTokens
	^ascendingTokens!

ascendingTokens: anOrderedCollection
	ascendingTokens := anOrderedCollection!

byTokens
	^byTokens!

byTokens: anOrderedCollection
	byTokens := anOrderedCollection!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#types #expressions #joinInExpressions #joinOnExpressions #joinEqualsExpressions #groupExpressions #groupByExpressions)!

compositeTokenVariables
	^#(#fromTokens #identifierTokens #inTokens #letTokens #equalTokens #whereTokens #joinTokens #onTokens #equalsTokens #intoTokens #orderbyTokens #ascendingTokens #descendingTokens #selectTokens #groupTokens #byTokens)!

descendingTokens
	^descendingTokens!

descendingTokens: anOrderedCollection
	descendingTokens := anOrderedCollection!

equalsTokens
	^equalsTokens!

equalsTokens: anOrderedCollection
	equalsTokens := anOrderedCollection!

equalTokens
	^equalTokens!

equalTokens: anOrderedCollection
	equalTokens := anOrderedCollection!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

fromTokens
	^fromTokens!

fromTokens: anOrderedCollection
	fromTokens := anOrderedCollection!

groupByExpressions
	^groupByExpressions!

groupByExpressions: anOrderedCollection
	self setParents: self groupByExpressions to: nil.
	groupByExpressions := anOrderedCollection.
	self setParents: self groupByExpressions to: self!

groupExpressions
	^groupExpressions!

groupExpressions: anOrderedCollection
	self setParents: self groupExpressions to: nil.
	groupExpressions := anOrderedCollection.
	self setParents: self groupExpressions to: self!

groupTokens
	^groupTokens!

groupTokens: anOrderedCollection
	groupTokens := anOrderedCollection!

identifierTokens
	^identifierTokens!

identifierTokens: anOrderedCollection
	identifierTokens := anOrderedCollection!

ignoredCompositeTokenVariables
	^#(#commaTokens #_leftParens #_rightParens)!

initialize
	super initialize.
	fromTokens := OrderedCollection new: 2.
	types := OrderedCollection new: 2.
	identifierTokens := OrderedCollection new: 2.
	inTokens := OrderedCollection new: 2.
	expressions := OrderedCollection new: 2.
	letTokens := OrderedCollection new: 2.
	equalTokens := OrderedCollection new: 2.
	whereTokens := OrderedCollection new: 2.
	joinTokens := OrderedCollection new: 2.
	joinInExpressions := OrderedCollection new: 2.
	onTokens := OrderedCollection new: 2.
	joinOnExpressions := OrderedCollection new: 2.
	equalsTokens := OrderedCollection new: 2.
	joinEqualsExpressions := OrderedCollection new: 2.
	intoTokens := OrderedCollection new: 2.
	orderbyTokens := OrderedCollection new: 2.
	ascendingTokens := OrderedCollection new: 2.
	descendingTokens := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.
	selectTokens := OrderedCollection new: 2.
	groupTokens := OrderedCollection new: 2.
	groupExpressions := OrderedCollection new: 2.
	byTokens := OrderedCollection new: 2.
	groupByExpressions := OrderedCollection new: 2.!

inTokens
	^inTokens!

inTokens: anOrderedCollection
	inTokens := anOrderedCollection!

intoTokens
	^intoTokens!

intoTokens: anOrderedCollection
	intoTokens := anOrderedCollection!

joinEqualsExpressions
	^joinEqualsExpressions!

joinEqualsExpressions: anOrderedCollection
	self setParents: self joinEqualsExpressions to: nil.
	joinEqualsExpressions := anOrderedCollection.
	self setParents: self joinEqualsExpressions to: self!

joinInExpressions
	^joinInExpressions!

joinInExpressions: anOrderedCollection
	self setParents: self joinInExpressions to: nil.
	joinInExpressions := anOrderedCollection.
	self setParents: self joinInExpressions to: self!

joinOnExpressions
	^joinOnExpressions!

joinOnExpressions: anOrderedCollection
	self setParents: self joinOnExpressions to: nil.
	joinOnExpressions := anOrderedCollection.
	self setParents: self joinOnExpressions to: self!

joinTokens
	^joinTokens!

joinTokens: anOrderedCollection
	joinTokens := anOrderedCollection!

letTokens
	^letTokens!

letTokens: anOrderedCollection
	letTokens := anOrderedCollection!

onTokens
	^onTokens!

onTokens: anOrderedCollection
	onTokens := anOrderedCollection!

orderbyTokens
	^orderbyTokens!

orderbyTokens: anOrderedCollection
	orderbyTokens := anOrderedCollection!

selectTokens
	^selectTokens!

selectTokens: anOrderedCollection
	selectTokens := anOrderedCollection!

types
	^types!

types: anOrderedCollection
	self setParents: self types to: nil.
	types := anOrderedCollection.
	self setParents: self types to: self!

whereTokens
	^whereTokens!

whereTokens: anOrderedCollection
	whereTokens := anOrderedCollection! !
!CSQueryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSQueryExpressionNode categoriesFor: #ascendingTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #ascendingTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #byTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #byTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #commaTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #commaTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSQueryExpressionNode categoriesFor: #compositeTokenVariables!generated!public! !
!CSQueryExpressionNode categoriesFor: #descendingTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #descendingTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #equalsTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #equalsTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #equalTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #equalTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #expressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #expressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #fromTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #fromTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupByExpressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupByExpressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupExpressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupExpressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #groupTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #identifierTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #identifierTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSQueryExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSQueryExpressionNode categoriesFor: #inTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #inTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #intoTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #intoTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinEqualsExpressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinEqualsExpressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinInExpressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinInExpressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinOnExpressions!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinOnExpressions:!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #joinTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #letTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #letTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #onTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #onTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #orderbyTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #orderbyTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #selectTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #selectTokens:!generated!public! !
!CSQueryExpressionNode categoriesFor: #types!generated!public! !
!CSQueryExpressionNode categoriesFor: #types:!generated!public! !
!CSQueryExpressionNode categoriesFor: #whereTokens!generated!public! !
!CSQueryExpressionNode categoriesFor: #whereTokens:!generated!public! !

CSSimpleNameNode guid: (GUID fromString: '{0EC0EA20-95A9-4251-AC16-CE5F86CC9B6C}')!
CSSimpleNameNode comment: ''!
!CSSimpleNameNode categoriesForClass!Unclassified! !
!CSSimpleNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSimpleName: self!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

nodeVariables
	^#(#typeArguments)!

tokenVariables
	^#(#identifierToken)!

typeArguments
	^typeArguments!

typeArguments: aCSTypeArgumentListNode
	self typeArguments notNil ifTrue: [self typeArguments parent: nil].
	typeArguments := aCSTypeArgumentListNode.
	self typeArguments notNil ifTrue: [self typeArguments parent: self]! !
!CSSimpleNameNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSimpleNameNode categoriesFor: #identifierToken!generated!public! !
!CSSimpleNameNode categoriesFor: #identifierToken:!generated!public! !
!CSSimpleNameNode categoriesFor: #nodeVariables!generated!public! !
!CSSimpleNameNode categoriesFor: #tokenVariables!generated!public! !
!CSSimpleNameNode categoriesFor: #typeArguments!generated!public! !
!CSSimpleNameNode categoriesFor: #typeArguments:!generated!public! !

CSSizeofExpressionNode guid: (GUID fromString: '{057C01C2-AD4C-4440-B18F-8B5CDF258CC5}')!
CSSizeofExpressionNode comment: ''!
!CSSizeofExpressionNode categoriesForClass!Unclassified! !
!CSSizeofExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSizeofExpression: self!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#type)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

sizeofToken
	^sizeofToken!

sizeofToken: aSmaCCToken
	sizeofToken := aSmaCCToken!

tokenVariables
	^#(#sizeofToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSSizeofExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSizeofExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSSizeofExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSSizeofExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSSizeofExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSSizeofExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSSizeofExpressionNode categoriesFor: #sizeofToken!generated!public! !
!CSSizeofExpressionNode categoriesFor: #sizeofToken:!generated!public! !
!CSSizeofExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSSizeofExpressionNode categoriesFor: #type!generated!public! !
!CSSizeofExpressionNode categoriesFor: #type:!generated!public! !

CSThisAccessNode guid: (GUID fromString: '{F4AF62D8-40F9-49F6-9B75-39721907CF73}')!
CSThisAccessNode comment: ''!
!CSThisAccessNode categoriesForClass!Unclassified! !
!CSThisAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThisAccess: self!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#thisToken)! !
!CSThisAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!CSThisAccessNode categoriesFor: #thisToken!generated!public! !
!CSThisAccessNode categoriesFor: #thisToken:!generated!public! !
!CSThisAccessNode categoriesFor: #tokenVariables!generated!public! !

CSTypeofExpressionNode guid: (GUID fromString: '{7F811769-8D03-45AF-936D-23B1073A4F3D}')!
CSTypeofExpressionNode comment: ''!
!CSTypeofExpressionNode categoriesForClass!Unclassified! !
!CSTypeofExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeofExpression: self!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#type)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#typeofToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSProgramNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSProgramNode.
	self type notNil ifTrue: [self type parent: self]!

typeofToken
	^typeofToken!

typeofToken: aSmaCCToken
	typeofToken := aSmaCCToken! !
!CSTypeofExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeofExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSTypeofExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSTypeofExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSTypeofExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSTypeofExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSTypeofExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSTypeofExpressionNode categoriesFor: #type!generated!public! !
!CSTypeofExpressionNode categoriesFor: #type:!generated!public! !
!CSTypeofExpressionNode categoriesFor: #typeofToken!generated!public! !
!CSTypeofExpressionNode categoriesFor: #typeofToken:!generated!public! !

CSUncheckedExpressionNode guid: (GUID fromString: '{C6951501-534D-4840-A3CA-319F3385C3F8}')!
CSUncheckedExpressionNode comment: ''!
!CSUncheckedExpressionNode categoriesForClass!Unclassified! !
!CSUncheckedExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUncheckedExpression: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

tokenVariables
	^#(#uncheckedToken #leftParenToken #rightParenToken)!

uncheckedToken
	^uncheckedToken!

uncheckedToken: aSmaCCToken
	uncheckedToken := aSmaCCToken! !
!CSUncheckedExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #expression!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #expression:!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #leftParenToken!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #leftParenToken:!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #nodeVariables!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #rightParenToken!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #rightParenToken:!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #tokenVariables!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #uncheckedToken!generated!public! !
!CSUncheckedExpressionNode categoriesFor: #uncheckedToken:!generated!public! !

CSBlockStatementNode guid: (GUID fromString: '{8108DE3B-BB2B-42E2-8FF6-3E45E6A368EE}')!
CSBlockStatementNode comment: ''!
!CSBlockStatementNode categoriesForClass!Unclassified! !
!CSBlockStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBlockStatement: self!

compositeNodeVariables
	^#(#statements)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#leftBraceToken #rightBraceToken)! !
!CSBlockStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSBlockStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSBlockStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSBlockStatementNode categoriesFor: #leftBraceToken!generated!public! !
!CSBlockStatementNode categoriesFor: #leftBraceToken:!generated!public! !
!CSBlockStatementNode categoriesFor: #rightBraceToken!generated!public! !
!CSBlockStatementNode categoriesFor: #rightBraceToken:!generated!public! !
!CSBlockStatementNode categoriesFor: #statements!generated!public! !
!CSBlockStatementNode categoriesFor: #statements:!generated!public! !
!CSBlockStatementNode categoriesFor: #tokenVariables!generated!public! !

CSBreakStatementNode guid: (GUID fromString: '{C9AF5FEB-C7AA-4579-8260-B3B19AB8E021}')!
CSBreakStatementNode comment: ''!
!CSBreakStatementNode categoriesForClass!Unclassified! !
!CSBreakStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBreakStatement: self!

breakToken
	^breakToken!

breakToken: aSmaCCToken
	breakToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#breakToken)! !
!CSBreakStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSBreakStatementNode categoriesFor: #breakToken!generated!public! !
!CSBreakStatementNode categoriesFor: #breakToken:!generated!public! !
!CSBreakStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSBreakStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSBreakStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSBreakStatementNode categoriesFor: #tokenVariables!generated!public! !

CSCheckedStatementNode guid: (GUID fromString: '{6628D837-91F4-42C0-8BEF-6703AEF469D7}')!
CSCheckedStatementNode comment: ''!
!CSCheckedStatementNode categoriesForClass!Unclassified! !
!CSCheckedStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCheckedStatement: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

checkedToken
	^checkedToken!

checkedToken: aSmaCCToken
	checkedToken := aSmaCCToken!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#checkedToken)! !
!CSCheckedStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSCheckedStatementNode categoriesFor: #block!generated!public! !
!CSCheckedStatementNode categoriesFor: #block:!generated!public! !
!CSCheckedStatementNode categoriesFor: #checkedToken!generated!public! !
!CSCheckedStatementNode categoriesFor: #checkedToken:!generated!public! !
!CSCheckedStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSCheckedStatementNode categoriesFor: #tokenVariables!generated!public! !

CSContinueStatementNode guid: (GUID fromString: '{A3FE439B-8E87-4B35-928E-B48FF69380E5}')!
CSContinueStatementNode comment: ''!
!CSContinueStatementNode categoriesForClass!Unclassified! !
!CSContinueStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitContinueStatement: self!

continueToken
	^continueToken!

continueToken: aSmaCCToken
	continueToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#continueToken)! !
!CSContinueStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSContinueStatementNode categoriesFor: #continueToken!generated!public! !
!CSContinueStatementNode categoriesFor: #continueToken:!generated!public! !
!CSContinueStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSContinueStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSContinueStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSContinueStatementNode categoriesFor: #tokenVariables!generated!public! !

CSDeclarationStatementNode guid: (GUID fromString: '{0FFC5F30-9162-4F2D-B9E6-2A9F0870226A}')!
CSDeclarationStatementNode comment: ''!
!CSDeclarationStatementNode categoriesForClass!Unclassified! !
!CSDeclarationStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDeclarationStatement: self!

declaration
	^declaration!

declaration: aCSDeclarationNode
	self declaration notNil ifTrue: [self declaration parent: nil].
	declaration := aCSDeclarationNode.
	self declaration notNil ifTrue: [self declaration parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#declaration)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken! !
!CSDeclarationStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDeclarationStatementNode categoriesFor: #declaration!generated!public! !
!CSDeclarationStatementNode categoriesFor: #declaration:!generated!public! !
!CSDeclarationStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSDeclarationStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSDeclarationStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSDeclarationStatementNode categoriesFor: #semicolonToken:!generated!public! !

CSDoStatementNode guid: (GUID fromString: '{E57E0C5F-CC14-4A62-8E1E-86DA63F67ED4}')!
CSDoStatementNode comment: ''!
!CSDoStatementNode categoriesForClass!Unclassified! !
!CSDoStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDoStatement: self!

doToken
	^doToken!

doToken: aSmaCCToken
	doToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#statement #expression)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#doToken #whileToken #leftParenToken #rightParenToken)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!CSDoStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSDoStatementNode categoriesFor: #doToken!generated!public! !
!CSDoStatementNode categoriesFor: #doToken:!generated!public! !
!CSDoStatementNode categoriesFor: #expression!generated!public! !
!CSDoStatementNode categoriesFor: #expression:!generated!public! !
!CSDoStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSDoStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSDoStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSDoStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSDoStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSDoStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSDoStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSDoStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSDoStatementNode categoriesFor: #statement!generated!public! !
!CSDoStatementNode categoriesFor: #statement:!generated!public! !
!CSDoStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSDoStatementNode categoriesFor: #whileToken!generated!public! !
!CSDoStatementNode categoriesFor: #whileToken:!generated!public! !

CSEmptyStatementNode guid: (GUID fromString: '{1571E769-6959-424A-B0E3-EE8A96EF3AD0}')!
CSEmptyStatementNode comment: ''!
!CSEmptyStatementNode categoriesForClass!Unclassified! !
!CSEmptyStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEmptyStatement: self!

ignoredTokenVariables
	^#(#semicolonToken)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken! !
!CSEmptyStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSEmptyStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSEmptyStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSEmptyStatementNode categoriesFor: #semicolonToken:!generated!public! !

CSExpressionStatementNode guid: (GUID fromString: '{103830E0-29A1-402F-9DC5-1C1D29D846D1}')!
CSExpressionStatementNode comment: ''!
!CSExpressionStatementNode categoriesForClass!Unclassified! !
!CSExpressionStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpressionStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#expression)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken! !
!CSExpressionStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSExpressionStatementNode categoriesFor: #expression!generated!public! !
!CSExpressionStatementNode categoriesFor: #expression:!generated!public! !
!CSExpressionStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSExpressionStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSExpressionStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSExpressionStatementNode categoriesFor: #semicolonToken:!generated!public! !

CSFixedStatementNode guid: (GUID fromString: '{6C545070-5AF2-4AFB-AB97-F4613E5B4ECB}')!
CSFixedStatementNode comment: ''!
!CSFixedStatementNode categoriesForClass!Unclassified! !
!CSFixedStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFixedStatement: self!

commaTokens
	^commaTokens!

commaTokens: anOrderedCollection
	commaTokens := anOrderedCollection!

compositeNodeVariables
	^#(#declarators)!

declarators
	^declarators!

declarators: anOrderedCollection
	self setParents: self declarators to: nil.
	declarators := anOrderedCollection.
	self setParents: self declarators to: self!

fixedToken
	^fixedToken!

fixedToken: aSmaCCToken
	fixedToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commaTokens)!

initialize
	super initialize.
	declarators := OrderedCollection new: 2.
	commaTokens := OrderedCollection new: 2.!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#type #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#fixedToken #leftParenToken #rightParenToken)!

type
	^type!

type: aCSPointerTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSPointerTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSFixedStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSFixedStatementNode categoriesFor: #commaTokens!generated!public! !
!CSFixedStatementNode categoriesFor: #commaTokens:!generated!public! !
!CSFixedStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSFixedStatementNode categoriesFor: #declarators!generated!public! !
!CSFixedStatementNode categoriesFor: #declarators:!generated!public! !
!CSFixedStatementNode categoriesFor: #fixedToken!generated!public! !
!CSFixedStatementNode categoriesFor: #fixedToken:!generated!public! !
!CSFixedStatementNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSFixedStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSFixedStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSFixedStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSFixedStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSFixedStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSFixedStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSFixedStatementNode categoriesFor: #statement!generated!public! !
!CSFixedStatementNode categoriesFor: #statement:!generated!public! !
!CSFixedStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSFixedStatementNode categoriesFor: #type!generated!public! !
!CSFixedStatementNode categoriesFor: #type:!generated!public! !

CSForeachStatementNode guid: (GUID fromString: '{C4D5CA64-AFF4-47B8-ADA1-0D0C10FC76B3}')!
CSForeachStatementNode comment: ''!
!CSForeachStatementNode categoriesForClass!Unclassified! !
!CSForeachStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForeachStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

foreachToken
	^foreachToken!

foreachToken: aSmaCCToken
	foreachToken := aSmaCCToken!

inToken
	^inToken!

inToken: aSmaCCToken
	inToken := aSmaCCToken!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #expression #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#foreachToken #leftParenToken #name #inToken #rightParenToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSForeachStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSForeachStatementNode categoriesFor: #expression!generated!public! !
!CSForeachStatementNode categoriesFor: #expression:!generated!public! !
!CSForeachStatementNode categoriesFor: #foreachToken!generated!public! !
!CSForeachStatementNode categoriesFor: #foreachToken:!generated!public! !
!CSForeachStatementNode categoriesFor: #inToken!generated!public! !
!CSForeachStatementNode categoriesFor: #inToken:!generated!public! !
!CSForeachStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSForeachStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSForeachStatementNode categoriesFor: #name!generated!public! !
!CSForeachStatementNode categoriesFor: #name:!generated!public! !
!CSForeachStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSForeachStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSForeachStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSForeachStatementNode categoriesFor: #statement!generated!public! !
!CSForeachStatementNode categoriesFor: #statement:!generated!public! !
!CSForeachStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSForeachStatementNode categoriesFor: #type!generated!public! !
!CSForeachStatementNode categoriesFor: #type:!generated!public! !

CSForStatementNode guid: (GUID fromString: '{80AF6353-DE36-41C1-B37B-BEBDA496F1CF}')!
CSForStatementNode comment: ''!
!CSForStatementNode categoriesForClass!Unclassified! !
!CSForStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForStatement: self!

condition
	^condition!

condition: aCSExpressionNode
	self condition notNil ifTrue: [self condition parent: nil].
	condition := aCSExpressionNode.
	self condition notNil ifTrue: [self condition parent: self]!

forToken
	^forToken!

forToken: aSmaCCToken
	forToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#semicolonTokens)!

initialize
	super initialize.
	semicolonTokens := OrderedCollection new: 2.!

initializer
	^initializer!

initializer: aCSProgramNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aCSProgramNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

iterator
	^iterator!

iterator: aCSStatementListNode
	self iterator notNil ifTrue: [self iterator parent: nil].
	iterator := aCSStatementListNode.
	self iterator notNil ifTrue: [self iterator parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#initializer #condition #iterator #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

semicolonTokens
	^semicolonTokens!

semicolonTokens: anOrderedCollection
	semicolonTokens := anOrderedCollection!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#forToken #leftParenToken #rightParenToken)! !
!CSForStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSForStatementNode categoriesFor: #condition!generated!public! !
!CSForStatementNode categoriesFor: #condition:!generated!public! !
!CSForStatementNode categoriesFor: #forToken!generated!public! !
!CSForStatementNode categoriesFor: #forToken:!generated!public! !
!CSForStatementNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!CSForStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSForStatementNode categoriesFor: #initializer!generated!public! !
!CSForStatementNode categoriesFor: #initializer:!generated!public! !
!CSForStatementNode categoriesFor: #iterator!generated!public! !
!CSForStatementNode categoriesFor: #iterator:!generated!public! !
!CSForStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSForStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSForStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSForStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSForStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSForStatementNode categoriesFor: #semicolonTokens!generated!public! !
!CSForStatementNode categoriesFor: #semicolonTokens:!generated!public! !
!CSForStatementNode categoriesFor: #statement!generated!public! !
!CSForStatementNode categoriesFor: #statement:!generated!public! !
!CSForStatementNode categoriesFor: #tokenVariables!generated!public! !

CSGotoStatementNode guid: (GUID fromString: '{47CCB8C5-665C-41C7-B9FB-EEF9F0D3FAE3}')!
CSGotoStatementNode comment: ''!
!CSGotoStatementNode categoriesForClass!Unclassified! !
!CSGotoStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitGotoStatement: self!

caseToken
	^caseToken!

caseToken: aSmaCCToken
	caseToken := aSmaCCToken!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

gotoToken
	^gotoToken!

gotoToken: aSmaCCToken
	gotoToken := aSmaCCToken!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#expression)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#gotoToken #identifierToken #caseToken #defaultToken)! !
!CSGotoStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSGotoStatementNode categoriesFor: #caseToken!generated!public! !
!CSGotoStatementNode categoriesFor: #caseToken:!generated!public! !
!CSGotoStatementNode categoriesFor: #defaultToken!generated!public! !
!CSGotoStatementNode categoriesFor: #defaultToken:!generated!public! !
!CSGotoStatementNode categoriesFor: #expression!generated!public! !
!CSGotoStatementNode categoriesFor: #expression:!generated!public! !
!CSGotoStatementNode categoriesFor: #gotoToken!generated!public! !
!CSGotoStatementNode categoriesFor: #gotoToken:!generated!public! !
!CSGotoStatementNode categoriesFor: #identifierToken!generated!public! !
!CSGotoStatementNode categoriesFor: #identifierToken:!generated!public! !
!CSGotoStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSGotoStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSGotoStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSGotoStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSGotoStatementNode categoriesFor: #tokenVariables!generated!public! !

CSIfStatementNode guid: (GUID fromString: '{5D08DD61-CD58-4ED1-A19A-4912BC8DB2B4}')!
CSIfStatementNode comment: ''!
!CSIfStatementNode categoriesForClass!Unclassified! !
!CSIfStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIfStatement: self!

elseStatement
	^elseStatement!

elseStatement: aCSStatementNode
	self elseStatement notNil ifTrue: [self elseStatement parent: nil].
	elseStatement := aCSStatementNode.
	self elseStatement notNil ifTrue: [self elseStatement parent: self]!

elseToken
	^elseToken!

elseToken: aSmaCCToken
	elseToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ifToken
	^ifToken!

ifToken: aSmaCCToken
	ifToken := aSmaCCToken!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression #thenStatement #elseStatement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

thenStatement
	^thenStatement!

thenStatement: aCSStatementNode
	self thenStatement notNil ifTrue: [self thenStatement parent: nil].
	thenStatement := aCSStatementNode.
	self thenStatement notNil ifTrue: [self thenStatement parent: self]!

tokenVariables
	^#(#ifToken #leftParenToken #rightParenToken #elseToken)! !
!CSIfStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSIfStatementNode categoriesFor: #elseStatement!generated!public! !
!CSIfStatementNode categoriesFor: #elseStatement:!generated!public! !
!CSIfStatementNode categoriesFor: #elseToken!generated!public! !
!CSIfStatementNode categoriesFor: #elseToken:!generated!public! !
!CSIfStatementNode categoriesFor: #expression!generated!public! !
!CSIfStatementNode categoriesFor: #expression:!generated!public! !
!CSIfStatementNode categoriesFor: #ifToken!generated!public! !
!CSIfStatementNode categoriesFor: #ifToken:!generated!public! !
!CSIfStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSIfStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSIfStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSIfStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSIfStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSIfStatementNode categoriesFor: #thenStatement!generated!public! !
!CSIfStatementNode categoriesFor: #thenStatement:!generated!public! !
!CSIfStatementNode categoriesFor: #tokenVariables!generated!public! !

CSLabeledStatementNode guid: (GUID fromString: '{872C6CE9-ED20-49DF-92AD-C0B9EA863254}')!
CSLabeledStatementNode comment: ''!
!CSLabeledStatementNode categoriesForClass!Unclassified! !
!CSLabeledStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLabeledStatement: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

identifierToken
	^identifierToken!

identifierToken: aSmaCCToken
	identifierToken := aSmaCCToken!

nodeVariables
	^#(#statement)!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#identifierToken #colonToken)! !
!CSLabeledStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLabeledStatementNode categoriesFor: #colonToken!generated!public! !
!CSLabeledStatementNode categoriesFor: #colonToken:!generated!public! !
!CSLabeledStatementNode categoriesFor: #identifierToken!generated!public! !
!CSLabeledStatementNode categoriesFor: #identifierToken:!generated!public! !
!CSLabeledStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSLabeledStatementNode categoriesFor: #statement!generated!public! !
!CSLabeledStatementNode categoriesFor: #statement:!generated!public! !
!CSLabeledStatementNode categoriesFor: #tokenVariables!generated!public! !

CSLockStatementNode guid: (GUID fromString: '{7D1D3E77-E7FE-4B22-8B87-B7682CD6D0DA}')!
CSLockStatementNode comment: ''!
!CSLockStatementNode categoriesForClass!Unclassified! !
!CSLockStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLockStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

lockToken
	^lockToken!

lockToken: aSmaCCToken
	lockToken := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#lockToken #leftParenToken #rightParenToken)! !
!CSLockStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSLockStatementNode categoriesFor: #expression!generated!public! !
!CSLockStatementNode categoriesFor: #expression:!generated!public! !
!CSLockStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSLockStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSLockStatementNode categoriesFor: #lockToken!generated!public! !
!CSLockStatementNode categoriesFor: #lockToken:!generated!public! !
!CSLockStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSLockStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSLockStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSLockStatementNode categoriesFor: #statement!generated!public! !
!CSLockStatementNode categoriesFor: #statement:!generated!public! !
!CSLockStatementNode categoriesFor: #tokenVariables!generated!public! !

CSReturnStatementNode guid: (GUID fromString: '{2FCA8750-41E6-47F6-84FB-04270F888D41}')!
CSReturnStatementNode comment: ''!
!CSReturnStatementNode categoriesForClass!Unclassified! !
!CSReturnStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitReturnStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#expression)!

returnToken
	^returnToken!

returnToken: aSmaCCToken
	returnToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#returnToken)! !
!CSReturnStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSReturnStatementNode categoriesFor: #expression!generated!public! !
!CSReturnStatementNode categoriesFor: #expression:!generated!public! !
!CSReturnStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSReturnStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSReturnStatementNode categoriesFor: #returnToken!generated!public! !
!CSReturnStatementNode categoriesFor: #returnToken:!generated!public! !
!CSReturnStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSReturnStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSReturnStatementNode categoriesFor: #tokenVariables!generated!public! !

CSSwitchStatementNode guid: (GUID fromString: '{7A6567D6-CF12-4E4D-99F4-ACC01740D58E}')!
CSSwitchStatementNode comment: ''!
!CSSwitchStatementNode categoriesForClass!Unclassified! !
!CSSwitchStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchStatement: self!

compositeNodeVariables
	^#(#sections)!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

initialize
	super initialize.
	sections := OrderedCollection new: 2.!

leftBraceToken
	^leftBraceToken!

leftBraceToken: aSmaCCToken
	leftBraceToken := aSmaCCToken!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightBraceToken
	^rightBraceToken!

rightBraceToken: aSmaCCToken
	rightBraceToken := aSmaCCToken!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

sections
	^sections!

sections: anOrderedCollection
	self setParents: self sections to: nil.
	sections := anOrderedCollection.
	self setParents: self sections to: self!

switchToken
	^switchToken!

switchToken: aSmaCCToken
	switchToken := aSmaCCToken!

tokenVariables
	^#(#switchToken #leftParenToken #rightParenToken #leftBraceToken #rightBraceToken)! !
!CSSwitchStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSwitchStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSSwitchStatementNode categoriesFor: #expression!generated!public! !
!CSSwitchStatementNode categoriesFor: #expression:!generated!public! !
!CSSwitchStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSSwitchStatementNode categoriesFor: #leftBraceToken!generated!public! !
!CSSwitchStatementNode categoriesFor: #leftBraceToken:!generated!public! !
!CSSwitchStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSSwitchStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSSwitchStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSSwitchStatementNode categoriesFor: #rightBraceToken!generated!public! !
!CSSwitchStatementNode categoriesFor: #rightBraceToken:!generated!public! !
!CSSwitchStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSSwitchStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSSwitchStatementNode categoriesFor: #sections!generated!public! !
!CSSwitchStatementNode categoriesFor: #sections:!generated!public! !
!CSSwitchStatementNode categoriesFor: #switchToken!generated!public! !
!CSSwitchStatementNode categoriesFor: #switchToken:!generated!public! !
!CSSwitchStatementNode categoriesFor: #tokenVariables!generated!public! !

CSThrowStatementNode guid: (GUID fromString: '{8521E9E6-B050-4E43-8EE6-403EB7857CD4}')!
CSThrowStatementNode comment: ''!
!CSThrowStatementNode categoriesForClass!Unclassified! !
!CSThrowStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThrowStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#expression)!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

throwToken
	^throwToken!

throwToken: aSmaCCToken
	throwToken := aSmaCCToken!

tokenVariables
	^#(#throwToken)! !
!CSThrowStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSThrowStatementNode categoriesFor: #expression!generated!public! !
!CSThrowStatementNode categoriesFor: #expression:!generated!public! !
!CSThrowStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSThrowStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSThrowStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSThrowStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSThrowStatementNode categoriesFor: #throwToken!generated!public! !
!CSThrowStatementNode categoriesFor: #throwToken:!generated!public! !
!CSThrowStatementNode categoriesFor: #tokenVariables!generated!public! !

CSTryStatementNode guid: (GUID fromString: '{3E928013-66C0-41CD-8296-4A19EED6B3FA}')!
CSTryStatementNode comment: ''!
!CSTryStatementNode categoriesForClass!Unclassified! !
!CSTryStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTryStatement: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

clauses
	^clauses!

clauses: anOrderedCollection
	self setParents: self clauses to: nil.
	clauses := anOrderedCollection.
	self setParents: self clauses to: self!

compositeNodeVariables
	^#(#clauses)!

finally
	^finally!

finally: aCSFinallyClauseNode
	self finally notNil ifTrue: [self finally parent: nil].
	finally := aCSFinallyClauseNode.
	self finally notNil ifTrue: [self finally parent: self]!

initialize
	super initialize.
	clauses := OrderedCollection new: 2.!

nodeVariables
	^#(#block #finally)!

tokenVariables
	^#(#tryToken)!

tryToken
	^tryToken!

tryToken: aSmaCCToken
	tryToken := aSmaCCToken! !
!CSTryStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTryStatementNode categoriesFor: #block!generated!public! !
!CSTryStatementNode categoriesFor: #block:!generated!public! !
!CSTryStatementNode categoriesFor: #clauses!generated!public! !
!CSTryStatementNode categoriesFor: #clauses:!generated!public! !
!CSTryStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSTryStatementNode categoriesFor: #finally!generated!public! !
!CSTryStatementNode categoriesFor: #finally:!generated!public! !
!CSTryStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSTryStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSTryStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSTryStatementNode categoriesFor: #tryToken!generated!public! !
!CSTryStatementNode categoriesFor: #tryToken:!generated!public! !

CSUncheckedStatementNode guid: (GUID fromString: '{FFECEED2-DBE3-4B24-B0F9-03D29FAA2DBE}')!
CSUncheckedStatementNode comment: ''!
!CSUncheckedStatementNode categoriesForClass!Unclassified! !
!CSUncheckedStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUncheckedStatement: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#uncheckedToken)!

uncheckedToken
	^uncheckedToken!

uncheckedToken: aSmaCCToken
	uncheckedToken := aSmaCCToken! !
!CSUncheckedStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUncheckedStatementNode categoriesFor: #block!generated!public! !
!CSUncheckedStatementNode categoriesFor: #block:!generated!public! !
!CSUncheckedStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSUncheckedStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSUncheckedStatementNode categoriesFor: #uncheckedToken!generated!public! !
!CSUncheckedStatementNode categoriesFor: #uncheckedToken:!generated!public! !

CSUnsafeStatementNode guid: (GUID fromString: '{03115043-6CB4-467C-94C2-8BEE8DFACBB1}')!
CSUnsafeStatementNode comment: ''!
!CSUnsafeStatementNode categoriesForClass!Unclassified! !
!CSUnsafeStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnsafeStatement: self!

block
	^block!

block: aCSBlockStatementNode
	self block notNil ifTrue: [self block parent: nil].
	block := aCSBlockStatementNode.
	self block notNil ifTrue: [self block parent: self]!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#unsafeToken)!

unsafeToken
	^unsafeToken!

unsafeToken: aSmaCCToken
	unsafeToken := aSmaCCToken! !
!CSUnsafeStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUnsafeStatementNode categoriesFor: #block!generated!public! !
!CSUnsafeStatementNode categoriesFor: #block:!generated!public! !
!CSUnsafeStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSUnsafeStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSUnsafeStatementNode categoriesFor: #unsafeToken!generated!public! !
!CSUnsafeStatementNode categoriesFor: #unsafeToken:!generated!public! !

CSUsingStatementNode guid: (GUID fromString: '{F52FAA33-CC4A-40BE-96E8-7E4EBEE42BCE}')!
CSUsingStatementNode comment: ''!
!CSUsingStatementNode categoriesForClass!Unclassified! !
!CSUsingStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUsingStatement: self!

expression
	^expression!

expression: aCSProgramNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSProgramNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#usingToken #leftParenToken #rightParenToken)!

usingToken
	^usingToken!

usingToken: aSmaCCToken
	usingToken := aSmaCCToken! !
!CSUsingStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSUsingStatementNode categoriesFor: #expression!generated!public! !
!CSUsingStatementNode categoriesFor: #expression:!generated!public! !
!CSUsingStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSUsingStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSUsingStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSUsingStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSUsingStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSUsingStatementNode categoriesFor: #statement!generated!public! !
!CSUsingStatementNode categoriesFor: #statement:!generated!public! !
!CSUsingStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSUsingStatementNode categoriesFor: #usingToken!generated!public! !
!CSUsingStatementNode categoriesFor: #usingToken:!generated!public! !

CSWhileStatementNode guid: (GUID fromString: '{2C9378A5-0A7F-4AD3-BBFD-2A41B6F38BDA}')!
CSWhileStatementNode comment: ''!
!CSWhileStatementNode categoriesForClass!Unclassified! !
!CSWhileStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitWhileStatement: self!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParenToken
	^leftParenToken!

leftParenToken: aSmaCCToken
	leftParenToken := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

rightParenToken
	^rightParenToken!

rightParenToken: aSmaCCToken
	rightParenToken := aSmaCCToken!

statement
	^statement!

statement: aCSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aCSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#whileToken #leftParenToken #rightParenToken)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!CSWhileStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSWhileStatementNode categoriesFor: #expression!generated!public! !
!CSWhileStatementNode categoriesFor: #expression:!generated!public! !
!CSWhileStatementNode categoriesFor: #leftParenToken!generated!public! !
!CSWhileStatementNode categoriesFor: #leftParenToken:!generated!public! !
!CSWhileStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSWhileStatementNode categoriesFor: #rightParenToken!generated!public! !
!CSWhileStatementNode categoriesFor: #rightParenToken:!generated!public! !
!CSWhileStatementNode categoriesFor: #statement!generated!public! !
!CSWhileStatementNode categoriesFor: #statement:!generated!public! !
!CSWhileStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSWhileStatementNode categoriesFor: #whileToken!generated!public! !
!CSWhileStatementNode categoriesFor: #whileToken:!generated!public! !

CSYieldStatementNode guid: (GUID fromString: '{A44A654C-2968-4EFC-9F4F-8F8EAA5908E7}')!
CSYieldStatementNode comment: ''!
!CSYieldStatementNode categoriesForClass!Unclassified! !
!CSYieldStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitYieldStatement: self!

breakToken
	^breakToken!

breakToken: aSmaCCToken
	breakToken := aSmaCCToken!

expression
	^expression!

expression: aCSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aCSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolonToken)!

nodeVariables
	^#(#expression)!

returnToken
	^returnToken!

returnToken: aSmaCCToken
	returnToken := aSmaCCToken!

semicolonToken
	^semicolonToken!

semicolonToken: aSmaCCToken
	semicolonToken := aSmaCCToken!

tokenVariables
	^#(#yieldToken #returnToken #breakToken)!

yieldToken
	^yieldToken!

yieldToken: aSmaCCToken
	yieldToken := aSmaCCToken! !
!CSYieldStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!CSYieldStatementNode categoriesFor: #breakToken!generated!public! !
!CSYieldStatementNode categoriesFor: #breakToken:!generated!public! !
!CSYieldStatementNode categoriesFor: #expression!generated!public! !
!CSYieldStatementNode categoriesFor: #expression:!generated!public! !
!CSYieldStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!CSYieldStatementNode categoriesFor: #nodeVariables!generated!public! !
!CSYieldStatementNode categoriesFor: #returnToken!generated!public! !
!CSYieldStatementNode categoriesFor: #returnToken:!generated!public! !
!CSYieldStatementNode categoriesFor: #semicolonToken!generated!public! !
!CSYieldStatementNode categoriesFor: #semicolonToken:!generated!public! !
!CSYieldStatementNode categoriesFor: #tokenVariables!generated!public! !
!CSYieldStatementNode categoriesFor: #yieldToken!generated!public! !
!CSYieldStatementNode categoriesFor: #yieldToken:!generated!public! !

CSArrayTypeNode guid: (GUID fromString: '{905BC9AA-CFD6-408D-9ABB-AC902FA68DE2}')!
CSArrayTypeNode comment: ''!
!CSArrayTypeNode categoriesForClass!Unclassified! !
!CSArrayTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayType: self!

compositeNodeVariables
	^#(#rankSpecifiers)!

initialize
	super initialize.
	rankSpecifiers := OrderedCollection new: 2.!

nodeVariables
	^#(#type)!

rankSpecifiers
	^rankSpecifiers!

rankSpecifiers: anOrderedCollection
	self setParents: self rankSpecifiers to: nil.
	rankSpecifiers := anOrderedCollection.
	self setParents: self rankSpecifiers to: self!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSArrayTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSArrayTypeNode categoriesFor: #compositeNodeVariables!generated!public! !
!CSArrayTypeNode categoriesFor: #initialize!generated-initialize-release!public! !
!CSArrayTypeNode categoriesFor: #nodeVariables!generated!public! !
!CSArrayTypeNode categoriesFor: #rankSpecifiers!generated!public! !
!CSArrayTypeNode categoriesFor: #rankSpecifiers:!generated!public! !
!CSArrayTypeNode categoriesFor: #type!generated!public! !
!CSArrayTypeNode categoriesFor: #type:!generated!public! !

CSNullableTypeNode guid: (GUID fromString: '{1FA8BF8D-D0B0-4F8C-9A9F-B7D5CB245A40}')!
CSNullableTypeNode comment: ''!
!CSNullableTypeNode categoriesForClass!Unclassified! !
!CSNullableTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNullableType: self!

nodeVariables
	^#(#type)!

questionMarkToken
	^questionMarkToken!

questionMarkToken: aSmaCCToken
	questionMarkToken := aSmaCCToken!

tokenVariables
	^#(#questionMarkToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSNullableTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSNullableTypeNode categoriesFor: #nodeVariables!generated!public! !
!CSNullableTypeNode categoriesFor: #questionMarkToken!generated!public! !
!CSNullableTypeNode categoriesFor: #questionMarkToken:!generated!public! !
!CSNullableTypeNode categoriesFor: #tokenVariables!generated!public! !
!CSNullableTypeNode categoriesFor: #type!generated!public! !
!CSNullableTypeNode categoriesFor: #type:!generated!public! !

CSPointerTypeNode guid: (GUID fromString: '{42B30146-51E9-432B-8186-FA923CE48C5C}')!
CSPointerTypeNode comment: ''!
!CSPointerTypeNode categoriesForClass!Unclassified! !
!CSPointerTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPointerType: self!

nodeVariables
	^#(#type)!

timesToken
	^timesToken!

timesToken: aSmaCCToken
	timesToken := aSmaCCToken!

tokenVariables
	^#(#timesToken)!

type
	^type!

type: aCSTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aCSTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!CSPointerTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSPointerTypeNode categoriesFor: #nodeVariables!generated!public! !
!CSPointerTypeNode categoriesFor: #timesToken!generated!public! !
!CSPointerTypeNode categoriesFor: #timesToken:!generated!public! !
!CSPointerTypeNode categoriesFor: #tokenVariables!generated!public! !
!CSPointerTypeNode categoriesFor: #type!generated!public! !
!CSPointerTypeNode categoriesFor: #type:!generated!public! !

CSQualifiedAliasMemberNode guid: (GUID fromString: '{4FEF68F3-3672-4DFF-A2D1-AB3E56BEB16D}')!
CSQualifiedAliasMemberNode comment: ''!
!CSQualifiedAliasMemberNode categoriesForClass!Unclassified! !
!CSQualifiedAliasMemberNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitQualifiedAliasMember: self!

colonColonToken
	^colonColonToken!

colonColonToken: aSmaCCToken
	colonColonToken := aSmaCCToken!

global
	^global!

global: aSmaCCToken
	global := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#typeArguments)!

tokenVariables
	^#(#global #colonColonToken #name)!

typeArguments
	^typeArguments!

typeArguments: aCSTypeArgumentListNode
	self typeArguments notNil ifTrue: [self typeArguments parent: nil].
	typeArguments := aCSTypeArgumentListNode.
	self typeArguments notNil ifTrue: [self typeArguments parent: self]! !
!CSQualifiedAliasMemberNode categoriesFor: #acceptVisitor:!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #colonColonToken!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #colonColonToken:!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #global!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #global:!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #name!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #name:!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #nodeVariables!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #tokenVariables!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #typeArguments!generated!public! !
!CSQualifiedAliasMemberNode categoriesFor: #typeArguments:!generated!public! !

CSSimpleTypeNode guid: (GUID fromString: '{C8CE2EF4-5917-4B74-8A94-C6307076FBFE}')!
CSSimpleTypeNode comment: ''!
!CSSimpleTypeNode categoriesForClass!Unclassified! !
!CSSimpleTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSimpleType: self!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#token)! !
!CSSimpleTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSSimpleTypeNode categoriesFor: #token!generated!public! !
!CSSimpleTypeNode categoriesFor: #token:!generated!public! !
!CSSimpleTypeNode categoriesFor: #tokenVariables!generated!public! !

CSTypeNameNode guid: (GUID fromString: '{FF333DFD-DB59-48DE-9D47-AFFF1E5F4686}')!
CSTypeNameNode comment: ''!
!CSTypeNameNode categoriesForClass!Unclassified! !
!CSTypeNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeName: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

namespace
	^namespace!

namespace: aCSTypeNode
	self namespace notNil ifTrue: [self namespace parent: nil].
	namespace := aCSTypeNode.
	self namespace notNil ifTrue: [self namespace parent: self]!

nodeVariables
	^#(#typeArguments #namespace)!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

tokenVariables
	^#(#name #periodToken)!

typeArguments
	^typeArguments!

typeArguments: aCSTypeArgumentListNode
	self typeArguments notNil ifTrue: [self typeArguments parent: nil].
	typeArguments := aCSTypeArgumentListNode.
	self typeArguments notNil ifTrue: [self typeArguments parent: self]! !
!CSTypeNameNode categoriesFor: #acceptVisitor:!generated!public! !
!CSTypeNameNode categoriesFor: #name!generated!public! !
!CSTypeNameNode categoriesFor: #name:!generated!public! !
!CSTypeNameNode categoriesFor: #namespace!generated!public! !
!CSTypeNameNode categoriesFor: #namespace:!generated!public! !
!CSTypeNameNode categoriesFor: #nodeVariables!generated!public! !
!CSTypeNameNode categoriesFor: #periodToken!generated!public! !
!CSTypeNameNode categoriesFor: #periodToken:!generated!public! !
!CSTypeNameNode categoriesFor: #tokenVariables!generated!public! !
!CSTypeNameNode categoriesFor: #typeArguments!generated!public! !
!CSTypeNameNode categoriesFor: #typeArguments:!generated!public! !

CSVarTypeNode guid: (GUID fromString: '{2FB0F28B-0909-4ED9-817D-64A75CCAFE27}')!
CSVarTypeNode comment: ''!
!CSVarTypeNode categoriesForClass!Unclassified! !
!CSVarTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVarType: self!

tokenVariables
	^#(#varToken)!

varToken
	^varToken!

varToken: aSmaCCToken
	varToken := aSmaCCToken! !
!CSVarTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSVarTypeNode categoriesFor: #tokenVariables!generated!public! !
!CSVarTypeNode categoriesFor: #varToken!generated!public! !
!CSVarTypeNode categoriesFor: #varToken:!generated!public! !

CSVoidTypeNode guid: (GUID fromString: '{B240511A-2870-463C-B883-CA650579D265}')!
CSVoidTypeNode comment: ''!
!CSVoidTypeNode categoriesForClass!Unclassified! !
!CSVoidTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVoidType: self!

tokenVariables
	^#(#voidToken)!

voidToken
	^voidToken!

voidToken: aSmaCCToken
	voidToken := aSmaCCToken! !
!CSVoidTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!CSVoidTypeNode categoriesFor: #tokenVariables!generated!public! !
!CSVoidTypeNode categoriesFor: #voidToken!generated!public! !
!CSVoidTypeNode categoriesFor: #voidToken:!generated!public! !

CSProgramNodeVisitor guid: (GUID fromString: '{BF0835AD-F88C-4CD6-A9CD-A777FC06E65D}')!
CSProgramNodeVisitor comment: ''!
!CSProgramNodeVisitor categoriesForClass!Unclassified! !
!CSProgramNodeVisitor methodsFor!

visitAddAccessorDeclaration: anAddAccessorDeclaration
	^self visitProgram: anAddAccessorDeclaration!

visitAnonymousFunctionParameter: anAnonymousFunctionParameter
	^self visitProgram: anAnonymousFunctionParameter!

visitAnonymousMethodExpression: anAnonymousMethodExpression
	^self visitExpression: anAnonymousMethodExpression!

visitAnonymousObjectCreationExpression: anAnonymousObjectCreationExpression
	^self visitExpression: anAnonymousObjectCreationExpression!

visitArgument: anArgument
	^self visitProgram: anArgument!

visitArrayCreationExpression: anArrayCreationExpression
	^self visitExpression: anArrayCreationExpression!

visitArrayInitializer: anArrayInitializer
	^self visitProgram: anArrayInitializer!

visitArrayParameter: anArrayParameter
	^self visitProgram: anArrayParameter!

visitArrayType: anArrayType
	^self visitType: anArrayType!

visitAssignment: anAssignment
	^self visitExpression: anAssignment!

visitAttribute: anAttribute
	^self visitProgram: anAttribute!

visitAttributeValue: anAttributeValue
	^self visitProgram: anAttributeValue!

visitBaseAccess: aBaseAccess
	^self visitExpression: aBaseAccess!

visitBinaryExpression: aBinaryExpression
	^self visitExpression: aBinaryExpression!

visitBlockStatement: aBlockStatement
	^self visitStatement: aBlockStatement!

visitBreakStatement: aBreakStatement
	^self visitStatement: aBreakStatement!

visitCastExpression: aCastExpression
	^self visitExpression: aCastExpression!

visitCheckedExpression: aCheckedExpression
	^self visitExpression: aCheckedExpression!

visitCheckedStatement: aCheckedStatement
	^self visitStatement: aCheckedStatement!

visitClassDeclaration: aClassDeclaration
	^self visitDeclaration: aClassDeclaration!

visitCollectionInitializer: aCollectionInitializer
	^self visitProgram: aCollectionInitializer!

visitCompilationUnit: aCompilationUnit
	^self visitProgram: aCompilationUnit!

visitConditionalExpression: aConditionalExpression
	^self visitExpression: aConditionalExpression!

visitConstantDeclaration: aConstantDeclaration
	^self visitDeclaration: aConstantDeclaration!

visitConstantDeclarator: aConstantDeclarator
	^self visitProgram: aConstantDeclarator!

visitConstDeclarator: aConstDeclarator
	^self visitProgram: aConstDeclarator!

visitConstructorConstraint: aConstructorConstraint
	^self visitProgram: aConstructorConstraint!

visitConstructorDeclaration: aConstructorDeclaration
	^self visitDeclaration: aConstructorDeclaration!

visitConstructorInitializer: aConstructorInitializer
	^self visitProgram: aConstructorInitializer!

visitContinueStatement: aContinueStatement
	^self visitStatement: aContinueStatement!

visitDeclaration: aDeclaration
	^self visitProgram: aDeclaration!

visitDeclarationStatement: aDeclarationStatement
	^self visitStatement: aDeclarationStatement!

visitDefaultValueExpression: aDefaultValueExpression
	^self visitExpression: aDefaultValueExpression!

visitDelegateCreationExpression: aDelegateCreationExpression
	^self visitExpression: aDelegateCreationExpression!

visitDelegateDeclaration: aDelegateDeclaration
	^self visitDeclaration: aDelegateDeclaration!

visitDestructorDeclaration: aDestructorDeclaration
	^self visitDeclaration: aDestructorDeclaration!

visitDoStatement: aDoStatement
	^self visitStatement: aDoStatement!

visitElementAccess: anElementAccess
	^self visitExpression: anElementAccess!

visitElementInitializer: anElementInitializer
	^self visitProgram: anElementInitializer!

visitEmptyStatement: anEmptyStatement
	^self visitStatement: anEmptyStatement!

visitEnumDeclaration: anEnumDeclaration
	^self visitDeclaration: anEnumDeclaration!

visitEventDeclaration: anEventDeclaration
	^self visitDeclaration: anEventDeclaration!

visitExplicitAnonymousFunctionSignature: anExplicitAnonymousFunctionSignature
	^self visitProgram: anExplicitAnonymousFunctionSignature!

visitExpression: anExpression
	^self visitProgram: anExpression!

visitExpressionStatement: anExpressionStatement
	^self visitStatement: anExpressionStatement!

visitExternAliasDirective: anExternAliasDirective
	^self visitProgram: anExternAliasDirective!

visitFieldDeclaration: aFieldDeclaration
	^self visitDeclaration: aFieldDeclaration!

visitFinallyClause: aFinallyClause
	^self visitProgram: aFinallyClause!

visitFixedParameter: aFixedParameter
	^self visitProgram: aFixedParameter!

visitFixedPointerDeclarator: aFixedPointerDeclarator
	^self visitProgram: aFixedPointerDeclarator!

visitFixedSizeBufferDeclaration: aFixedSizeBufferDeclaration
	^self visitDeclaration: aFixedSizeBufferDeclaration!

visitFixedSizeBufferDeclarator: aFixedSizeBufferDeclarator
	^self visitProgram: aFixedSizeBufferDeclarator!

visitFixedStatement: aFixedStatement
	^self visitStatement: aFixedStatement!

visitForeachStatement: aForeachStatement
	^self visitStatement: aForeachStatement!

visitForStatement: aForStatement
	^self visitStatement: aForStatement!

visitGeneralCatchClause: aGeneralCatchClause
	^self visitProgram: aGeneralCatchClause!

visitGetAccessorDeclaration: aGetAccessorDeclaration
	^self visitProgram: aGetAccessorDeclaration!

visitGotoStatement: aGotoStatement
	^self visitStatement: aGotoStatement!

visitIfStatement: anIfStatement
	^self visitStatement: anIfStatement!

visitImplicitAnonymousFunctionSignature: anImplicitAnonymousFunctionSignature
	^self visitProgram: anImplicitAnonymousFunctionSignature!

visitIndexerDeclaration: anIndexerDeclaration
	^self visitDeclaration: anIndexerDeclaration!

visitInterfaceDeclaration: anInterfaceDeclaration
	^self visitDeclaration: anInterfaceDeclaration!

visitInterfaceEventDeclaration: anInterfaceEventDeclaration
	^self visitDeclaration: anInterfaceEventDeclaration!

visitInterfaceIndexerDeclaration: anInterfaceIndexerDeclaration
	^self visitDeclaration: anInterfaceIndexerDeclaration!

visitInterfaceMethodDeclaration: anInterfaceMethodDeclaration
	^self visitDeclaration: anInterfaceMethodDeclaration!

visitInterfacePropertyAccessor: anInterfacePropertyAccessor
	^self visitProgram: anInterfacePropertyAccessor!

visitInterfacePropertyDeclaration: anInterfacePropertyDeclaration
	^self visitDeclaration: anInterfacePropertyDeclaration!

visitInvocationExpression: anInvocationExpression
	^self visitExpression: anInvocationExpression!

visitLabeledStatement: aLabeledStatement
	^self visitStatement: aLabeledStatement!

visitLambdaExpression: aLambdaExpression
	^self visitExpression: aLambdaExpression!

visitLiteralExpression: aLiteralExpression
	^self visitExpression: aLiteralExpression!

visitLocalConstantDeclaration: aLocalConstantDeclaration
	^self visitDeclaration: aLocalConstantDeclaration!

visitLocalVariableDeclaration: aLocalVariableDeclaration
	^self visitDeclaration: aLocalVariableDeclaration!

visitLocalVariableDeclarator: aLocalVariableDeclarator
	^self visitProgram: aLocalVariableDeclarator!

visitLockStatement: aLockStatement
	^self visitStatement: aLockStatement!

visitMemberAccess: aMemberAccess
	^self visitExpression: aMemberAccess!

visitMemberDeclarator: aMemberDeclarator
	^self visitProgram: aMemberDeclarator!

visitMemberInitializer: aMemberInitializer
	^self visitProgram: aMemberInitializer!

visitMethodBody: aMethodBody
	^self visitProgram: aMethodBody!

visitMethodDeclaration: aMethodDeclaration
	^self visitDeclaration: aMethodDeclaration!

visitMethodHeader: aMethodHeader
	^self visitProgram: aMethodHeader!

visitNamedArgument: aNamedArgument
	^self visitProgram: aNamedArgument!

visitNamespaceDeclaration: aNamespaceDeclaration
	^self visitDeclaration: aNamespaceDeclaration!

visitNullableType: aNullableType
	^self visitType: aNullableType!

visitObjectCreationExpression: anObjectCreationExpression
	^self visitExpression: anObjectCreationExpression!

visitObjectInitializer: anObjectInitializer
	^self visitProgram: anObjectInitializer!

visitOperatorDeclaration: anOperatorDeclaration
	^self visitDeclaration: anOperatorDeclaration!

visitPointerElementAccess: aPointerElementAccess
	^self visitExpression: aPointerElementAccess!

visitPointerMemberAccess: aPointerMemberAccess
	^self visitExpression: aPointerMemberAccess!

visitPointerType: aPointerType
	^self visitType: aPointerType!

visitPostExpression: aPostExpression
	^self visitExpression: aPostExpression!

visitPrefixExpression: aPrefixExpression
	^self visitExpression: aPrefixExpression!

visitPrimaryConstraint: aPrimaryConstraint
	^self visitProgram: aPrimaryConstraint!

visitProgram: aProgram
	^self visitSmaCCParseNode: aProgram!

visitPropertyDeclaration: aPropertyDeclaration
	^self visitDeclaration: aPropertyDeclaration!

visitQualifiedAliasMember: aQualifiedAliasMember
	^self visitType: aQualifiedAliasMember!

visitQualifiedIdentifier: aQualifiedIdentifier
	^self visitProgram: aQualifiedIdentifier!

visitQueryExpression: aQueryExpression
	^self visitExpression: aQueryExpression!

visitRankSpecifier: aRankSpecifier
	^self visitProgram: aRankSpecifier!

visitRemoveAccessorDeclaration: aRemoveAccessorDeclaration
	^self visitProgram: aRemoveAccessorDeclaration!

visitReturnStatement: aReturnStatement
	^self visitStatement: aReturnStatement!

visitSetAccessorDeclaration: aSetAccessorDeclaration
	^self visitProgram: aSetAccessorDeclaration!

visitSimpleName: aSimpleName
	^self visitExpression: aSimpleName!

visitSimpleType: aSimpleType
	^self visitType: aSimpleType!

visitSizeofExpression: aSizeofExpression
	^self visitExpression: aSizeofExpression!

visitSpecificCatchClause: aSpecificCatchClause
	^self visitProgram: aSpecificCatchClause!

visitStackallocInitializer: aStackallocInitializer
	^self visitProgram: aStackallocInitializer!

visitStatement: aStatement
	^self visitProgram: aStatement!

visitStatementList: aStatementList
	^self visitProgram: aStatementList!

visitStaticConstructorDeclaration: aStaticConstructorDeclaration
	^self visitDeclaration: aStaticConstructorDeclaration!

visitStructDeclaration: aStructDeclaration
	^self visitDeclaration: aStructDeclaration!

visitSwitchLabel: aSwitchLabel
	^self visitProgram: aSwitchLabel!

visitSwitchSection: aSwitchSection
	^self visitProgram: aSwitchSection!

visitSwitchStatement: aSwitchStatement
	^self visitStatement: aSwitchStatement!

visitThisAccess: aThisAccess
	^self visitExpression: aThisAccess!

visitThrowStatement: aThrowStatement
	^self visitStatement: aThrowStatement!

visitTryStatement: aTryStatement
	^self visitStatement: aTryStatement!

visitType: aType
	^self visitProgram: aType!

visitTypeArgumentList: aTypeArgumentList
	^self visitProgram: aTypeArgumentList!

visitTypeConstraint: aTypeConstraint
	^self visitProgram: aTypeConstraint!

visitTypeName: aTypeName
	^self visitType: aTypeName!

visitTypeofExpression: aTypeofExpression
	^self visitExpression: aTypeofExpression!

visitTypeParameterConstraintsClause: aTypeParameterConstraintsClause
	^self visitProgram: aTypeParameterConstraintsClause!

visitTypeParameterList: aTypeParameterList
	^self visitProgram: aTypeParameterList!

visitUnboundTypeName: anUnboundTypeName
	^self visitProgram: anUnboundTypeName!

visitUncheckedExpression: anUncheckedExpression
	^self visitExpression: anUncheckedExpression!

visitUncheckedStatement: anUncheckedStatement
	^self visitStatement: anUncheckedStatement!

visitUnsafeStatement: anUnsafeStatement
	^self visitStatement: anUnsafeStatement!

visitUsingAliasDirective: anUsingAliasDirective
	^self visitProgram: anUsingAliasDirective!

visitUsingNamespaceDirective: anUsingNamespaceDirective
	^self visitProgram: anUsingNamespaceDirective!

visitUsingStatement: anUsingStatement
	^self visitStatement: anUsingStatement!

visitVariableDeclarator: aVariableDeclarator
	^self visitProgram: aVariableDeclarator!

visitVarType: aVarType
	^self visitType: aVarType!

visitVoidType: aVoidType
	^self visitType: aVoidType!

visitWhileStatement: aWhileStatement
	^self visitStatement: aWhileStatement!

visitYieldStatement: aYieldStatement
	^self visitStatement: aYieldStatement! !
!CSProgramNodeVisitor categoriesFor: #visitAddAccessorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAnonymousFunctionParameter:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAnonymousMethodExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAnonymousObjectCreationExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitArgument:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitArrayCreationExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitArrayInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitArrayParameter:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitArrayType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAssignment:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAttribute:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitAttributeValue:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitBaseAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitBinaryExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitBlockStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitBreakStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitCastExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitCheckedExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitCheckedStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitClassDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitCollectionInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitCompilationUnit:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConditionalExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstantDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstantDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstructorConstraint:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstructorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitConstructorInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitContinueStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDeclarationStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDefaultValueExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDelegateCreationExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDelegateDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDestructorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitDoStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitElementAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitElementInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitEmptyStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitEnumDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitEventDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitExplicitAnonymousFunctionSignature:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitExpressionStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitExternAliasDirective:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFieldDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFinallyClause:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFixedParameter:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFixedPointerDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFixedSizeBufferDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFixedSizeBufferDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitFixedStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitForeachStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitForStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitGeneralCatchClause:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitGetAccessorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitGotoStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitIfStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitImplicitAnonymousFunctionSignature:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitIndexerDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfaceDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfaceEventDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfaceIndexerDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfaceMethodDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfacePropertyAccessor:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInterfacePropertyDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitInvocationExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLabeledStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLambdaExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLiteralExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLocalConstantDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLocalVariableDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLocalVariableDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitLockStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMemberAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMemberDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMemberInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMethodBody:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMethodDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitMethodHeader:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitNamedArgument:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitNamespaceDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitNullableType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitObjectCreationExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitObjectInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitOperatorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPointerElementAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPointerMemberAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPointerType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPostExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPrefixExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPrimaryConstraint:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitProgram:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitPropertyDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitQualifiedAliasMember:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitQualifiedIdentifier:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitQueryExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitRankSpecifier:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitRemoveAccessorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitReturnStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSetAccessorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSimpleName:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSimpleType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSizeofExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSpecificCatchClause:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitStackallocInitializer:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitStatementList:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitStaticConstructorDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitStructDeclaration:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSwitchLabel:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSwitchSection:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitSwitchStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitThisAccess:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitThrowStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTryStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeArgumentList:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeConstraint:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeName:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeofExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeParameterConstraintsClause:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitTypeParameterList:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUnboundTypeName:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUncheckedExpression:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUncheckedStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUnsafeStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUsingAliasDirective:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUsingNamespaceDirective:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitUsingStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitVariableDeclarator:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitVarType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitVoidType:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitWhileStatement:!generated!public! !
!CSProgramNodeVisitor categoriesFor: #visitYieldStatement:!generated!public! !

CSharpParser guid: (GUID fromString: '{8A38A4DA-9104-43EA-94A4-8E5AA6AEA224}')!
CSharpParser comment: ''!
!CSharpParser categoriesForClass!Unclassified! !
!CSharpParser methodsFor!

actionsForCurrentToken
	| actions |
	actions := super actionsForCurrentToken.
	(actions isEmpty and: [currentToken ids includes: scanner gtgtId])
		ifTrue:
			[currentToken := currentToken class
				value: '>'
				start: currentToken startPosition
				ids: (Array with: scanner gtId).
			self position: currentToken startPosition.
			actions := super actionsForCurrentToken].
	^actions!

ambiguousTransitions
^#(
#[ 0 42 0 46 0 50] 
#[ 0 126 0 130] 
#[ 0 142 5 129] 
#[ 0 146 5 133] 
#[ 0 150 0 154 0 158 0 162 0 166] 
#[ 0 230 4 157] 
#[ 0 145 0 234] 
#[ 0 165 0 234] 
#[ 0 169 0 234] 
#[ 0 173 0 234] 
#[ 0 177 0 234] 
#[ 0 181 0 234] 
#[ 0 189 0 234] 
#[ 0 201 0 234] 
#[ 0 205 0 234] 
#[ 0 238 0 242] 
#[ 0 213 0 234] 
#[ 0 221 0 234] 
#[ 0 225 0 234] 
#[ 0 229 0 234] 
#[ 0 233 0 234] 
#[ 0 234 0 237] 
#[ 0 234 0 241] 
#[ 0 234 5 9] 
#[ 0 130 5 117] 
#[ 1 78 6 225] 
#[ 1 94 1 98 1 102 1 106 1 110] 
#[ 1 94 1 102 1 110] 
#[ 1 94 1 102 1 106 1 110] 
#[ 0 126 0 130 5 117] 
#[ 0 194 8 13] 
#[ 0 194 8 21] 
#[ 0 126 0 130 0 246] 
#[ 1 222 8 129] 
#[ 1 238 1 242] 
#[ 1 254 4 145] 
#[ 2 130 6 225] 
#[ 0 130 2 182] 
#[ 0 126 0 130 2 182] 
#[ 0 170 0 174] 
#[ 3 34 11 13] 
#[ 2 242 11 93] 
#[ 0 178 3 138] 
#[ 3 194 11 209] 
#[ 0 130 13 13] 
#[ 5 66 13 169] 
#[ 0 254 1 198] 
#[ 1 198 5 181] 
#[ 1 198 5 185] 
#[ 1 198 5 189] 
#[ 1 198 5 193] 
#[ 1 198 5 197] 
#[ 1 198 5 201] 
#[ 1 198 5 205] 
#[ 1 198 5 209] 
#[ 1 198 5 213] 
#[ 1 198 5 217] 
#[ 1 198 5 221] 
#[ 0 137 6 110] 
#[ 0 150 0 154] 
#[ 7 10 7 14] 
#[ 7 18 7 22 7 26 7 30] 
#[ 7 14 16 133] 
#[ 7 10 7 14 16 149] 
#[ 0 42 0 46 0 50 7 26] 
#[ 7 10 16 169] 
#[ 7 18 7 22 7 26 7 30 7 42] 
#[ 7 10 17 65] 
#[ 1 94 1 98 1 102 1 106 1 110 7 146 7 150 7 154 7 158 7 162 7 166] 
#[ 7 146 7 150 7 162 7 166] 
#[ 7 150 7 158 7 162 7 166] 
#[ 1 94 7 146 7 150 7 158 7 162] 
#[ 1 94 7 150 7 158 7 162 7 166] 
#[ 1 94 1 102 1 110 7 150] 
#[ 1 94 1 102 1 106 1 110 7 146 7 150 7 158 7 162 7 166] 
#[ 7 150 7 162 7 166 7 174] 
#[ 7 150 7 158 7 162 7 166 7 174 7 178] 
#[ 7 150 7 158 7 162 7 166 7 178] 
#[ 7 150 7 158 7 162 7 170 7 174] 
#[ 7 150 7 158 7 162 7 166 7 170 7 174 7 178] 
#[ 7 150 7 162 7 166 7 174 7 178] 
#[ 7 150 7 162 7 166] 
#[ 7 150 7 158 7 162] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 186] 
#[ 7 150 7 162 7 166 7 186] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 186] 
#[ 1 94 7 150 7 158 7 162 7 186] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 186] 
#[ 7 150 7 162 7 166 7 178 7 186] 
#[ 1 94 7 150 7 158 7 162 7 190] 
#[ 7 150 7 162 7 174 7 190] 
#[ 7 14 7 150 7 158 7 162 7 174 17 149] 
#[ 1 94 7 150 7 158 7 162 7 174 7 190] 
#[ 1 94 7 150 7 158 7 162] 
#[ 1 94 7 150] 
#[ 1 94 7 10 7 150 7 158 7 162 7 174 7 190 17 153] 
#[ 7 10 7 14 7 150 7 162 7 174 7 190] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 198] 
#[ 7 150 7 162 7 166 7 198] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 198] 
#[ 1 94 7 150 7 158 7 162 7 198] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 198] 
#[ 7 150 7 162 7 166 7 178 7 198] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 206] 
#[ 7 150 7 162 7 166 7 174 7 206] 
#[ 7 150 7 158 7 162 7 166 7 174 7 178 7 202] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 206] 
#[ 1 94 7 150 7 158 7 162 7 174 7 202 7 206] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 174 7 178 7 206] 
#[ 7 150 7 162 7 166 7 174 7 178 7 206] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 210] 
#[ 7 150 7 162 7 166 7 210] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 210] 
#[ 1 94 7 150 7 158 7 162 7 210] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 210] 
#[ 7 150 7 162 7 166 7 178 7 210] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 214] 
#[ 7 150 7 162 7 166 7 174 7 214] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 214] 
#[ 1 94 7 150 7 158 7 162 7 174 7 214] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 174 7 178 7 214] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 174 7 178 7 214] 
#[ 7 150 7 162 7 166 7 174 7 178 7 214] 
#[ 7 14 19 29] 
#[ 7 10 19 37] 
#[ 1 94 1 98 1 102 1 106 1 110 7 146 7 150 7 154 7 158 7 162 7 166 8 42] 
#[ 1 94 1 102 1 106 1 110 7 146 7 150 7 158 7 162 7 166 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 186 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 186 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 186 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 198 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 198 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 198 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 206 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 206 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 174 7 178 7 206 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 210 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 210 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 178 7 210 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 214 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 178 7 214 8 42] 
#[ 1 94 1 102 1 106 1 110 7 150 7 158 7 162 7 166 7 174 7 178 7 214 8 42] 
#[ 1 94 1 98 1 102 1 106 1 110 7 150 7 154 7 158 7 162 7 166 7 174 7 178 7 214 8 42] 
#[ 7 14 8 86] 
#[ 4 14 20 9] 
#[ 5 117 8 178] 
#[ 8 242 8 246]
	).!

reduceActionFor_attribute_arguments1: nodes
	| result |
	result := Array new: 4.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_attribute_arguments2: nodes
	| result |
	result := Array new: 4.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 4).
	result at: 2 put: ((nodes at: 1) at: 4).
	^result!

reduceActionFor_attribute_target_specifier1: nodes
	| result |
	result := Array new: 2.
	^result!

reduceActionFor_attribute_target_specifier2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	^result!

reduceActionFor_class_base1: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_class_base2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	^result!

reduceActionFor_explicit_anonymous_function_paramenter_list2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	^result!

reduceActionFor_extern_alias_directives1: nodes
	| result |
	result := OrderedCollection new: 2.
	^result!

reduceActionFor_extern_alias_directives2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	^result!

reduceActionFor_field_modifiers1: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_field_modifiers2: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	^result!

reduceActionFor_generic_dimension_specifier1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_generic_dimension_specifier2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	result at: 3 put: ((nodes at: 1) at: 3).
	^result!

reduceActionFor_implicit_anonymous_function_parameter_list1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_local_variable_declarator_name1: nodes
	| result |
	result := CSSimpleNameNode new.
	result identifierToken: (nodes at: 1).
	^result!

reduceActionFor_query_body_clauses1: nodes
	| result |
	result := Array new: 19.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_query_body_clauses2: nodes
	| result |
	result := Array new: 19.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	self addAll: ((nodes at: 1) at: 10) to: (result at: 10).
	self addAll: ((nodes at: 1) at: 11) to: (result at: 11).
	self addAll: ((nodes at: 1) at: 12) to: (result at: 12).
	self addAll: ((nodes at: 1) at: 13) to: (result at: 13).
	self addAll: ((nodes at: 1) at: 14) to: (result at: 14).
	self addAll: ((nodes at: 1) at: 15) to: (result at: 15).
	self addAll: ((nodes at: 1) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 1) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 19) to: (result at: 19).
	^result!

reduceActionFor_query_continuation1: nodes
	| result |
	result := Array new: 24.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 20 put: (OrderedCollection new: 2).
	result at: 21 put: (OrderedCollection new: 2).
	result at: 22 put: (OrderedCollection new: 2).
	result at: 23 put: (OrderedCollection new: 2).
	result at: 24 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_query_continuation2: nodes
	| result |
	result := Array new: 24.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 20 put: (OrderedCollection new: 2).
	result at: 21 put: (OrderedCollection new: 2).
	result at: 22 put: (OrderedCollection new: 2).
	result at: 23 put: (OrderedCollection new: 2).
	result at: 24 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	self addAll: ((nodes at: 1) at: 10) to: (result at: 10).
	self addAll: ((nodes at: 1) at: 11) to: (result at: 11).
	self addAll: ((nodes at: 1) at: 12) to: (result at: 12).
	self addAll: ((nodes at: 1) at: 13) to: (result at: 13).
	self addAll: ((nodes at: 1) at: 14) to: (result at: 14).
	self addAll: ((nodes at: 1) at: 15) to: (result at: 15).
	self addAll: ((nodes at: 1) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 1) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 19) to: (result at: 19).
	self addAll: ((nodes at: 1) at: 20) to: (result at: 20).
	self addAll: ((nodes at: 1) at: 21) to: (result at: 21).
	self addAll: ((nodes at: 1) at: 22) to: (result at: 22).
	self addAll: ((nodes at: 1) at: 23) to: (result at: 23).
	self addAll: ((nodes at: 1) at: 24) to: (result at: 24).
	^result!

reduceActionFor_struct_interfaces1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	^result!

reduceActionFor_struct_interfaces2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	^result!

reduceActionForaccessor_declarations2: nodes
	| result |
	result := Array new: 2.
	result at: 2 put: (nodes at: 1).
	result at: 1 put: (nodes at: 2).
	^result!

reduceActionForaccessor_modifiers4: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	self add: (nodes at: 2) to: result.
	^result!

reduceActionForadd_accessor_declaration1: nodes
	| result |
	result := CSAddAccessorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addToken: (nodes at: 2).
	result block: (nodes at: 3).
	^result!

reduceActionForanonymous_method_expression1: nodes
	| result |
	result := CSAnonymousMethodExpressionNode new.
	result delegateToken: (nodes at: 1).
	result signature: (nodes at: 2).
	result block: (nodes at: 3).
	^result!

reduceActionForanonymous_object_creation_expression1: nodes
	| result |
	result := CSAnonymousObjectCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result leftBraceToken: ((nodes at: 2) at: 1).
	result addNodes: ((nodes at: 2) at: 2) to: result declarators.
	result addTokens: ((nodes at: 2) at: 3) to: result commaTokens.
	result rightBraceToken: ((nodes at: 2) at: 4).
	^result!

reduceActionForanonymous_object_initializer1: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	result at: 4 put: (nodes at: 3).
	^result!

reduceActionForanonymous_object_initializer2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	self add: (nodes at: 3) to: (result at: 3).
	result at: 4 put: (nodes at: 4).
	^result!

reduceActionForargument1: nodes
	| result |
	result := CSArgumentNode new.
	result expression: (nodes at: 1).
	^result!

reduceActionForargument2: nodes
	| result |
	result := CSArgumentNode new.
	result refToken: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForargument3: nodes
	| result |
	result := CSArgumentNode new.
	result outToken: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForarray_creation_expression1: nodes
	| result |
	result := CSArrayCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result leftBracketToken: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result expressions.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result rightBracketToken: (nodes at: 5).
	result addNodes: (nodes at: 6) to: result rankSpecifiers.
	result arrayInitializer: (nodes at: 7).
	^result!

reduceActionForarray_creation_expression2: nodes
	| result |
	result := CSArrayCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result arrayInitializer: (nodes at: 3).
	^result!

reduceActionForarray_creation_expression3: nodes
	| result |
	result := CSArrayCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result addNode: (nodes at: 2) to: result rankSpecifiers.
	result arrayInitializer: (nodes at: 3).
	^result!

reduceActionForarray_initializer1: nodes
	| result |
	result := CSArrayInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightBraceToken: (nodes at: 3).
	^result!

reduceActionForarray_initializer2: nodes
	| result |
	result := CSArrayInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result addToken: (nodes at: 3) to: result commaTokens.
	result rightBraceToken: (nodes at: 4).
	^result!

reduceActionForarray_type1: nodes
	| result |
	result := CSArrayTypeNode new.
	result type: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result rankSpecifiers.
	^result!

reduceActionForassignment1: nodes
	| result |
	result := CSAssignmentNode new.
	result lhs: (nodes at: 1).
	result operator: (nodes at: 2).
	result rhs: (nodes at: 3).
	^result!

reduceActionForattribute_arguments2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	self add: (nodes at: 3) to: (result at: 3).
	self addAll: ((nodes at: 4) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 4) at: 2) to: (result at: 3).
	result at: 4 put: (nodes at: 5).
	^result!

reduceActionForattribute_section1: nodes
	| result |
	result := CSAttributeNode new.
	result leftBracket: (nodes at: 1).
	result target: ((nodes at: 2) at: 1).
	result colon: ((nodes at: 2) at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result attributeValues.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result rightBracket: (nodes at: 4).
	^result!

reduceActionForattribute_section2: nodes
	| result |
	result := CSAttributeNode new.
	result leftBracket: (nodes at: 1).
	result target: ((nodes at: 2) at: 1).
	result colon: ((nodes at: 2) at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result attributeValues.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result addToken: (nodes at: 4) to: result commas.
	result rightBracket: (nodes at: 5).
	^result!

reduceActionForattribute_target_specifier1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^result!

reduceActionForattribute1: nodes
	| result |
	result := CSAttributeValueNode new.
	result name: (nodes at: 1).
	result leftParen: ((nodes at: 2) at: 1).
	result rightParen: ((nodes at: 2) at: 2).
	result addNodes: ((nodes at: 2) at: 3) to: result arguments.
	result addTokens: ((nodes at: 2) at: 4) to: result commas.
	^result!

reduceActionForbase_access1: nodes
	| result |
	result := CSBaseAccessNode new.
	result baseToken: (nodes at: 1).
	result periodToken: (nodes at: 2).
	result identifier: (nodes at: 3).
	^result!

reduceActionForbase_access2: nodes
	| result |
	result := CSBaseAccessNode new.
	result baseToken: (nodes at: 1).
	result leftBracketToken: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result expressions.
	result addTokens: ((nodes at: 3) at: 2) to: result commaTokens.
	result rightBracketToken: (nodes at: 4).
	^result!

reduceActionForbinary_operator_declarator1: nodes
	| result |
	result := Array new: 8.
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	self add: (nodes at: 5) to: (result at: 5).
	self add: (nodes at: 6) to: (result at: 6).
	result at: 7 put: (nodes at: 7).
	self add: (nodes at: 8) to: (result at: 5).
	self add: (nodes at: 9) to: (result at: 6).
	result at: 8 put: (nodes at: 10).
	^result!

reduceActionForblock1: nodes
	| result |
	result := CSBlockStatementNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statements.
	result rightBraceToken: (nodes at: 3).
	^result!

reduceActionForbreak_statement1: nodes
	| result |
	result := CSBreakStatementNode new.
	result breakToken: (nodes at: 1).
	result semicolonToken: (nodes at: 2).
	^result!

reduceActionForcast_expression1: nodes
	| result |
	result := CSCastExpressionNode new.
	result leftParenToken: (nodes at: 1).
	result type: (nodes at: 2).
	result rightParenToken: (nodes at: 3).
	result expression: (nodes at: 4).
	^result!

reduceActionForchecked_expression1: nodes
	| result |
	result := CSCheckedExpressionNode new.
	result checkedToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionForchecked_statement1: nodes
	| result |
	result := CSCheckedStatementNode new.
	result checkedToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForclass_base1: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	^result!

reduceActionForclass_base2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	^result!

reduceActionForclass_base3: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	result at: 4 put: (nodes at: 3).
	self addAll: ((nodes at: 4) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 4) at: 2) to: (result at: 3).
	^result!

reduceActionForclass_declaration1: nodes
	| result |
	result := CSClassDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result partialToken: (nodes at: 3).
	result classToken: (nodes at: 4).
	result name: (nodes at: 5).
	result typeParameters: (nodes at: 6).
	result colonToken: ((nodes at: 7) at: 1).
	result addNodes: ((nodes at: 7) at: 2) to: result supertypes.
	result addTokens: ((nodes at: 7) at: 3) to: result commas.
	result commaToken: ((nodes at: 7) at: 4).
	result addNodes: (nodes at: 8) to: result constraintClauses.
	result leftBraceToken: ((nodes at: 9) at: 1).
	result addNodes: ((nodes at: 9) at: 2) to: result declarations.
	result rightBraceToken: ((nodes at: 9) at: 3).
	result semicolon: (nodes at: 10).
	^result!

reduceActionForcollection_initializer1: nodes
	| result |
	result := CSCollectionInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightBraceToken: (nodes at: 3).
	^result!

reduceActionForcollection_initializer2: nodes
	| result |
	result := CSCollectionInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result addToken: (nodes at: 3) to: result commaTokens.
	result rightBraceToken: (nodes at: 4).
	^result!

reduceActionForcompilation_unit1: nodes
	| result |
	result := CSCompilationUnitNode new.
	result addNodes: (nodes at: 1) to: result directives.
	result addNodes: (nodes at: 2) to: result directives.
	result addNodes: (nodes at: 3) to: result _attributes.
	result addNodes: (nodes at: 4) to: result declarations.
	^result!

reduceActionForconditional_expression2: nodes
	| result |
	result := CSConditionalExpressionNode new.
	result booleanExpression: (nodes at: 1).
	result questionMarkToken: (nodes at: 2).
	result trueExpression: (nodes at: 3).
	result colonToken: (nodes at: 4).
	result falseExpression: (nodes at: 5).
	^result!

reduceActionForconst_declarator1: nodes
	| result |
	result := CSConstDeclaratorNode new.
	result name: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result expression: (nodes at: 3).
	^result!

reduceActionForconstant_declaration1: nodes
	| result |
	result := CSConstantDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result constToken: (nodes at: 3).
	result type: (nodes at: 4).
	result addNodes: ((nodes at: 5) at: 1) to: result declarators.
	result addTokens: ((nodes at: 5) at: 2) to: result commaTokens.
	result semicolonToken: (nodes at: 6).
	^result!

reduceActionForconstant_declarator1: nodes
	| result |
	result := CSConstantDeclaratorNode new.
	result identifierToken: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result expression: (nodes at: 3).
	^result!

reduceActionForconstructor_constraint1: nodes
	| result |
	result := CSConstructorConstraintNode new.
	result newToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result rightParenToken: (nodes at: 3).
	^result!

reduceActionForconstructor_declaration1: nodes
	| result |
	result := CSConstructorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result identifierToken: ((nodes at: 3) at: 1).
	result leftParenToken: ((nodes at: 3) at: 2).
	result addNodes: ((nodes at: 3) at: 3) to: result parameters.
	result addTokens: ((nodes at: 3) at: 4) to: result commas.
	result rightParenToken: ((nodes at: 3) at: 5).
	result initializer: ((nodes at: 3) at: 6).
	result block: ((nodes at: 4) at: 1).
	result semicolonToken: ((nodes at: 4) at: 2).
	^result!

reduceActionForconstructor_declarator1: nodes
	| result |
	result := Array new: 6.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	self addAll: ((nodes at: 3) at: 1) to: (result at: 3).
	self addAll: ((nodes at: 3) at: 2) to: (result at: 4).
	result at: 5 put: (nodes at: 4).
	result at: 6 put: (nodes at: 5).
	^result!

reduceActionForconstructor_initializer1: nodes
	| result |
	result := CSConstructorInitializerNode new.
	result colonToken: (nodes at: 1).
	result baseToken: (nodes at: 2).
	result leftParenToken: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result arguments.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 5).
	^result!

reduceActionForconstructor_initializer2: nodes
	| result |
	result := CSConstructorInitializerNode new.
	result colonToken: (nodes at: 1).
	result thisToken: (nodes at: 2).
	result leftParenToken: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result arguments.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 5).
	^result!

reduceActionForcontinue_statement1: nodes
	| result |
	result := CSContinueStatementNode new.
	result continueToken: (nodes at: 1).
	result semicolonToken: (nodes at: 2).
	^result!

reduceActionForconversion_operator_declarator1: nodes
	| result |
	result := Array new: 8.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	result at: 6 put: (nodes at: 6).
	result at: 7 put: (nodes at: 7).
	^result!

reduceActionForconversion_operator_declarator2: nodes
	| result |
	result := Array new: 8.
	result at: 8 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	result at: 6 put: (nodes at: 6).
	result at: 7 put: (nodes at: 7).
	^result!

reduceActionFordeclaration_statement1: nodes
	| result |
	result := CSDeclarationStatementNode new.
	result declaration: (nodes at: 1).
	result semicolonToken: (nodes at: 2).
	^result!

reduceActionFordefault_value_expression1: nodes
	| result |
	result := CSDefaultValueExpressionNode new.
	result defaultToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionFordelegate_creation_expression1: nodes
	| result |
	result := CSDelegateCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result leftParenToken: (nodes at: 3).
	result expression: (nodes at: 4).
	result rightParenToken: (nodes at: 5).
	^result!

reduceActionFordelegate_declaration1: nodes
	| result |
	result := CSDelegateDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result delegateToken: (nodes at: 3).
	result type: (nodes at: 4).
	result name: (nodes at: 5).
	result typeParameters: (nodes at: 6).
	result leftParen: (nodes at: 7).
	result addNodes: ((nodes at: 8) at: 1) to: result parameters.
	result addTokens: ((nodes at: 8) at: 2) to: result commas.
	result rightParen: (nodes at: 9).
	result addNodes: (nodes at: 10) to: result constraintClauses.
	result semicolon: (nodes at: 11).
	^result!

reduceActionFordestructor_declaration1: nodes
	| result |
	result := CSDestructorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addToken: (nodes at: 2) to: result modifiers.
	result addToken: (nodes at: 3) to: result modifiers.
	result tildeToken: (nodes at: 4).
	result identifierToken: (nodes at: 5).
	result leftParenToken: (nodes at: 6).
	result rightParenToken: (nodes at: 7).
	result body: (nodes at: 8).
	^result!

reduceActionFordo_statement1: nodes
	| result |
	result := CSDoStatementNode new.
	result doToken: (nodes at: 1).
	result statement: (nodes at: 2).
	result whileToken: (nodes at: 3).
	result leftParenToken: (nodes at: 4).
	result expression: (nodes at: 5).
	result rightParenToken: (nodes at: 6).
	result semicolonToken: (nodes at: 7).
	^result!

reduceActionForelement_access1: nodes
	| result |
	result := CSElementAccessNode new.
	result baseExpression: (nodes at: 1).
	result leftBracketToken: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result expressions.
	result addTokens: ((nodes at: 3) at: 2) to: result commaTokens.
	result rightBracketToken: (nodes at: 4).
	^result!

reduceActionForelement_initializer1: nodes
	| result |
	result := CSElementInitializerNode new.
	result addNode: (nodes at: 1) to: result expressions.
	^result!

reduceActionForelement_initializer2: nodes
	| result |
	result := CSElementInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result expressions.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightBraceToken: (nodes at: 3).
	^result!

reduceActionForempty_statement1: nodes
	| result |
	result := CSEmptyStatementNode new.
	result semicolonToken: (nodes at: 1).
	^result!

reduceActionForenum_declaration1: nodes
	| result |
	result := CSEnumDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result enumToken: (nodes at: 3).
	result name: (nodes at: 4).
	result colonToken: ((nodes at: 5) at: 1).
	result type: ((nodes at: 5) at: 2).
	result leftBrace: ((nodes at: 6) at: 1).
	result addNodes: ((nodes at: 6) at: 2) to: result declarations.
	result addTokens: ((nodes at: 6) at: 3) to: result commas.
	result rightBrace: ((nodes at: 6) at: 4).
	result semicolon: (nodes at: 7).
	^result!

reduceActionForenum_member_declaration1: nodes
	| result |
	result := CSEnumDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result name: (nodes at: 2).
	^result!

reduceActionForenum_member_declaration2: nodes
	| result |
	result := CSEnumDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result name: (nodes at: 2).
	result equal: (nodes at: 3).
	result value: (nodes at: 4).
	^result!

reduceActionForevent_declaration1: nodes
	| result |
	result := CSEventDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result eventToken: (nodes at: 3).
	result type: (nodes at: 4).
	result addNodes: ((nodes at: 5) at: 1) to: result declarators.
	result addTokens: ((nodes at: 5) at: 2) to: result commaTokens.
	result semicolonToken: (nodes at: 6).
	^result!

reduceActionForevent_declaration2: nodes
	| result |
	result := CSEventDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result eventToken: (nodes at: 3).
	result type: (nodes at: 4).
	result name: ((nodes at: 5) at: 1).
	result interface: ((nodes at: 5) at: 2).
	result periodToken: ((nodes at: 5) at: 3).
	result leftBraceToken: (nodes at: 6).
	result addDeclaration: ((nodes at: 7) at: 1).
	result removeDeclaration: ((nodes at: 7) at: 2).
	result rightBraceToken: (nodes at: 8).
	^result!

reduceActionForexplicit_anonymous_function_paramenter1: nodes
	| result |
	result := CSAnonymousFunctionParameterNode new.
	result modifier: (nodes at: 1).
	result type: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForexplicit_anonymous_function_signature1: nodes
	| result |
	result := CSExplicitAnonymousFunctionSignatureNode new.
	result leftParenToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result parameters.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 3).
	^result!

reduceActionForexpression_statement1: nodes
	| result |
	result := CSExpressionStatementNode new.
	result expression: (nodes at: 1).
	result semicolonToken: (nodes at: 2).
	^result!

reduceActionForextern_alias_directive1: nodes
	| result |
	result := CSExternAliasDirectiveNode new.
	result externToken: (nodes at: 1).
	result aliasToken: (nodes at: 2).
	result identifierToken: (nodes at: 3).
	result semicolonToken: (nodes at: 4).
	^result!

reduceActionForextern_alias_directives1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^result!

reduceActionForextern_alias_directives2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	self add: (nodes at: 2) to: result.
	^result!

reduceActionForfield_declaration1: nodes
	| result |
	result := CSFieldDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: ((nodes at: 2) at: 1) to: result newTokens.
	result addTokens: ((nodes at: 2) at: 2) to: result publicTokens.
	result addTokens: ((nodes at: 2) at: 3) to: result protectedTokens.
	result addTokens: ((nodes at: 2) at: 4) to: result internalTokens.
	result addTokens: ((nodes at: 2) at: 5) to: result privateTokens.
	result addTokens: ((nodes at: 2) at: 6) to: result staticTokens.
	result addTokens: ((nodes at: 2) at: 7) to: result readonlyTokens.
	result addTokens: ((nodes at: 2) at: 8) to: result volatileTokens.
	result addTokens: ((nodes at: 2) at: 9) to: result unsafeTokens.
	result type: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result declarators.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result semicolonToken: (nodes at: 5).
	^result!

reduceActionForfield_modifier1: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier2: nodes
	| result |
	result := Array new: 9.
	result at: 2 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier3: nodes
	| result |
	result := Array new: 9.
	result at: 3 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier4: nodes
	| result |
	result := Array new: 9.
	result at: 4 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier5: nodes
	| result |
	result := Array new: 9.
	result at: 5 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier6: nodes
	| result |
	result := Array new: 9.
	result at: 6 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier7: nodes
	| result |
	result := Array new: 9.
	result at: 7 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier8: nodes
	| result |
	result := Array new: 9.
	result at: 8 put: (nodes at: 1).
	^result!

reduceActionForfield_modifier9: nodes
	| result |
	result := Array new: 9.
	result at: 9 put: (nodes at: 1).
	^result!

reduceActionForfield_modifiers1: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	self add: ((nodes at: 1) at: 1) to: (result at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: ((nodes at: 1) at: 3) to: (result at: 3).
	self add: ((nodes at: 1) at: 4) to: (result at: 4).
	self add: ((nodes at: 1) at: 5) to: (result at: 5).
	self add: ((nodes at: 1) at: 6) to: (result at: 6).
	self add: ((nodes at: 1) at: 7) to: (result at: 7).
	self add: ((nodes at: 1) at: 8) to: (result at: 8).
	self add: ((nodes at: 1) at: 9) to: (result at: 9).
	^result!

reduceActionForfield_modifiers2: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	self add: ((nodes at: 2) at: 1) to: (result at: 1).
	self add: ((nodes at: 2) at: 2) to: (result at: 2).
	self add: ((nodes at: 2) at: 3) to: (result at: 3).
	self add: ((nodes at: 2) at: 4) to: (result at: 4).
	self add: ((nodes at: 2) at: 5) to: (result at: 5).
	self add: ((nodes at: 2) at: 6) to: (result at: 6).
	self add: ((nodes at: 2) at: 7) to: (result at: 7).
	self add: ((nodes at: 2) at: 8) to: (result at: 8).
	self add: ((nodes at: 2) at: 9) to: (result at: 9).
	^result!

reduceActionForfinally_clause1: nodes
	| result |
	result := CSFinallyClauseNode new.
	result finallyToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForfixed_parameter1: nodes
	| result |
	result := CSFixedParameterNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result modifier: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	^result!

reduceActionForfixed_pointer_declarator1: nodes
	| result |
	result := CSFixedPointerDeclaratorNode new.
	result identifierToken: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result andToken: ((nodes at: 3) at: 1).
	result expression: ((nodes at: 3) at: 2).
	^result!

reduceActionForfixed_size_buffer_declaration1: nodes
	| result |
	result := CSFixedSizeBufferDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result fixedToken: (nodes at: 3).
	result type: (nodes at: 4).
	result addNodes: (nodes at: 5) to: result declarators.
	result semicolonToken: (nodes at: 6).
	^result!

reduceActionForfixed_size_buffer_declarator1: nodes
	| result |
	result := CSFixedSizeBufferDeclaratorNode new.
	result name: (nodes at: 1).
	result leftBracketToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightBracketToken: (nodes at: 4).
	^result!

reduceActionForfixed_statement1: nodes
	| result |
	result := CSFixedStatementNode new.
	result fixedToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result declarators.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 5).
	result statement: (nodes at: 6).
	^result!

reduceActionForfor_initializer2: nodes
	| result |
	result := CSStatementListNode new.
	result addNodes: ((nodes at: 1) at: 1) to: result expressions.
	result addTokens: ((nodes at: 1) at: 2) to: result commaTokens.
	^result!

reduceActionForfor_statement1: nodes
	| result |
	result := CSForStatementNode new.
	result forToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result initializer: (nodes at: 3).
	result addToken: (nodes at: 4) to: result semicolonTokens.
	result condition: (nodes at: 5).
	result addToken: (nodes at: 6) to: result semicolonTokens.
	result iterator: (nodes at: 7).
	result rightParenToken: (nodes at: 8).
	result statement: (nodes at: 9).
	^result!

reduceActionForforeach_statement1: nodes
	| result |
	result := CSForeachStatementNode new.
	result foreachToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	result inToken: (nodes at: 5).
	result expression: (nodes at: 6).
	result rightParenToken: (nodes at: 7).
	result statement: (nodes at: 8).
	^result!

reduceActionForfrom_clause1: nodes
	| result |
	result := Array new: 5.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	^result!

reduceActionForgeneral_catch_clause1: nodes
	| result |
	result := CSGeneralCatchClauseNode new.
	result catchToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForgeneric_dimension_specifier1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	result at: 3 put: (nodes at: 3).
	^result!

reduceActionForget_accessor_declaration1: nodes
	| result |
	result := CSGetAccessorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result getToken: (nodes at: 3).
	result body: ((nodes at: 4) at: 1).
	result semicolonToken: ((nodes at: 4) at: 2).
	^result!

reduceActionForgoto_statement1: nodes
	| result |
	result := CSGotoStatementNode new.
	result gotoToken: (nodes at: 1).
	result identifierToken: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceActionForgoto_statement2: nodes
	| result |
	result := CSGotoStatementNode new.
	result gotoToken: (nodes at: 1).
	result caseToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result semicolonToken: (nodes at: 4).
	^result!

reduceActionForgoto_statement3: nodes
	| result |
	result := CSGotoStatementNode new.
	result gotoToken: (nodes at: 1).
	result defaultToken: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceActionForif_statement1: nodes
	| result |
	result := CSIfStatementNode new.
	result ifToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result thenStatement: (nodes at: 5).
	^result!

reduceActionForif_statement2: nodes
	| result |
	result := CSIfStatementNode new.
	result ifToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result thenStatement: (nodes at: 5).
	result elseToken: (nodes at: 6).
	result elseStatement: (nodes at: 7).
	^result!

reduceActionForimplicit_anonymous_function_signature1: nodes
	| result |
	result := CSImplicitAnonymousFunctionSignatureNode new.
	result leftParenToken: (nodes at: 1).
	result addTokens: ((nodes at: 2) at: 1) to: result names.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 3).
	^result!

reduceActionForimplicit_anonymous_function_signature2: nodes
	| result |
	result := CSImplicitAnonymousFunctionSignatureNode new.
	result addToken: (nodes at: 1) to: result names.
	^result!

reduceActionForindexer_declaration1: nodes
	| result |
	result := CSIndexerDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result returnType: ((nodes at: 3) at: 1).
	result thisToken: ((nodes at: 3) at: 2).
	result leftBracketToken: ((nodes at: 3) at: 3).
	result addNodes: ((nodes at: 3) at: 4) to: result parameters.
	result addTokens: ((nodes at: 3) at: 5) to: result commas.
	result rightBracketToken: ((nodes at: 3) at: 6).
	result type: ((nodes at: 3) at: 7).
	result periodToken: ((nodes at: 3) at: 8).
	result leftBraceToken: (nodes at: 4).
	result getAccessor: ((nodes at: 5) at: 1).
	result setAccessor: ((nodes at: 5) at: 2).
	result rightBraceToken: (nodes at: 6).
	^result!

reduceActionForindexer_declarator1: nodes
	| result |
	result := Array new: 8.
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	self addAll: ((nodes at: 4) at: 1) to: (result at: 4).
	self addAll: ((nodes at: 4) at: 2) to: (result at: 5).
	result at: 6 put: (nodes at: 5).
	^result!

reduceActionForindexer_declarator2: nodes
	| result |
	result := Array new: 8.
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 7 put: (nodes at: 2).
	result at: 8 put: (nodes at: 3).
	result at: 2 put: (nodes at: 4).
	result at: 3 put: (nodes at: 5).
	self addAll: ((nodes at: 6) at: 1) to: (result at: 4).
	self addAll: ((nodes at: 6) at: 2) to: (result at: 5).
	result at: 6 put: (nodes at: 7).
	^result!

reduceActionForinterface_declaration1: nodes
	| result |
	result := CSInterfaceDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result partialToken: (nodes at: 3).
	result interfaceToken: (nodes at: 4).
	result name: (nodes at: 5).
	result typeParameters: (nodes at: 6).
	result colon: ((nodes at: 7) at: 1).
	result addNodes: ((nodes at: 7) at: 2) to: result supertypes.
	result addTokens: ((nodes at: 7) at: 3) to: result commas.
	result addNodes: (nodes at: 8) to: result constraintClauses.
	result leftBrace: ((nodes at: 9) at: 1).
	result addNodes: ((nodes at: 9) at: 2) to: result declarations.
	result rightBrace: ((nodes at: 9) at: 3).
	result semicolon: (nodes at: 10).
	^result!

reduceActionForinterface_event_declaration1: nodes
	| result |
	result := CSInterfaceEventDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result modifier: (nodes at: 2).
	result eventToken: (nodes at: 3).
	result type: (nodes at: 4).
	result name: (nodes at: 5).
	result semicolon: (nodes at: 6).
	^result!

reduceActionForinterface_get_accessor1: nodes
	| result |
	result := CSInterfacePropertyAccessorNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result accessorType: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForinterface_indexer_declaration1: nodes
	| result |
	result := CSInterfaceIndexerDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result modifier: (nodes at: 2).
	result type: (nodes at: 3).
	result thisToken: (nodes at: 4).
	result leftBracket: (nodes at: 5).
	result addNodes: ((nodes at: 6) at: 1) to: result parameters.
	result addTokens: ((nodes at: 6) at: 2) to: result commas.
	result rightBracket: (nodes at: 7).
	result leftBrace: (nodes at: 8).
	result getAccessor: ((nodes at: 9) at: 1).
	result setAccessor: ((nodes at: 9) at: 2).
	result rightBrace: (nodes at: 10).
	^result!

reduceActionForinterface_method_declaration1: nodes
	| result |
	result := CSInterfaceMethodDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result modifier: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	result typeParameters: (nodes at: 5).
	result leftParen: (nodes at: 6).
	result addNodes: ((nodes at: 7) at: 1) to: result parameters.
	result addTokens: ((nodes at: 7) at: 2) to: result commas.
	result rightParen: (nodes at: 8).
	result addNodes: (nodes at: 9) to: result constraintClauses.
	result semicolon: (nodes at: 10).
	^result!

reduceActionForinterface_property_declaration1: nodes
	| result |
	result := CSInterfacePropertyDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result modifier: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	result leftBrace: (nodes at: 5).
	result getAccessor: ((nodes at: 6) at: 1).
	result setAccessor: ((nodes at: 6) at: 2).
	result rightBrace: (nodes at: 7).
	^result!

reduceActionForinvocation_expression1: nodes
	| result |
	result := CSInvocationExpressionNode new.
	result expression: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result arguments.
	result addTokens: ((nodes at: 3) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionForjoin_clause1: nodes
	| result |
	result := Array new: 9.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	result at: 6 put: (nodes at: 6).
	result at: 7 put: (nodes at: 7).
	result at: 8 put: (nodes at: 8).
	result at: 9 put: (nodes at: 9).
	^result!

reduceActionForjoin_into_clause1: nodes
	| result |
	result := Array new: 10.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	self add: (nodes at: 3) to: (result at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	result at: 6 put: (nodes at: 6).
	result at: 7 put: (nodes at: 7).
	result at: 8 put: (nodes at: 8).
	result at: 9 put: (nodes at: 9).
	result at: 10 put: (nodes at: 10).
	self add: (nodes at: 11) to: (result at: 3).
	^result!

reduceActionForlabeled_statement1: nodes
	| result |
	result := CSLabeledStatementNode new.
	result identifierToken: (nodes at: 1).
	result colonToken: (nodes at: 2).
	result statement: (nodes at: 3).
	^result!

reduceActionForlambda_expression1: nodes
	| result |
	result := CSLambdaExpressionNode new.
	result signature: (nodes at: 1).
	result equalGreaterThanToken: (nodes at: 2).
	result body: (nodes at: 3).
	^result!

reduceActionForlet_clause1: nodes
	| result |
	result := Array new: 4.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	^result!

reduceActionForliteral2: nodes
	| result |
	result := CSLiteralExpressionNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForlocal_constant_declaration1: nodes
	| result |
	result := CSLocalConstantDeclarationNode new.
	result constToken: (nodes at: 1).
	result type: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result declarators.
	result addTokens: ((nodes at: 3) at: 2) to: result commaTokens.
	^result!

reduceActionForlocal_variable_declaration1: nodes
	| result |
	result := CSLocalVariableDeclarationNode new.
	result type: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result declarators.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	^result!

reduceActionForlocal_variable_declarator1: nodes
	| result |
	result := CSLocalVariableDeclaratorNode new.
	result name: (nodes at: 1).
	^result!

reduceActionForlocal_variable_declarator2: nodes
	| result |
	result := CSLocalVariableDeclaratorNode new.
	result name: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result expression: (nodes at: 3).
	^result!

reduceActionForlocal_variable_declarators1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	^result!

reduceActionForlocal_variable_declarators2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: (nodes at: 2) to: (result at: 2).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionForlocal_variable_type2: nodes
	| result |
	result := CSVarTypeNode new.
	result varToken: (nodes at: 1).
	^result!

reduceActionForlock_statement1: nodes
	| result |
	result := CSLockStatementNode new.
	result lockToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceActionFormember_access1: nodes
	| result |
	result := CSMemberAccessNode new.
	result expression: (nodes at: 1).
	result periodToken: (nodes at: 2).
	result identifier: (nodes at: 3).
	result typeArguments: (nodes at: 4).
	^result!

reduceActionFormember_access3: nodes
	| result |
	result := CSMemberAccessNode new.
	result expression: (nodes at: 1).
	result periodToken: (nodes at: 2).
	result identifier: (nodes at: 3).
	^result!

reduceActionFormember_declarator1: nodes
	| result |
	result := CSMemberDeclaratorNode new.
	result name: (nodes at: 1).
	^result!

reduceActionFormember_declarator2: nodes
	| result |
	result := CSMemberDeclaratorNode new.
	result access: (nodes at: 1).
	^result!

reduceActionFormember_declarator3: nodes
	| result |
	result := CSMemberDeclaratorNode new.
	result identifierToken: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionFormember_initializer1: nodes
	| result |
	result := CSMemberInitializerNode new.
	result identifier: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionFormember_name1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	^result!

reduceActionFormember_name2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (nodes at: 1).
	result at: 3 put: (nodes at: 2).
	result at: 1 put: (nodes at: 3).
	^result!

reduceActionFormethod_body1: nodes
	| result |
	result := CSMethodBodyNode new.
	result block: (nodes at: 1).
	^result!

reduceActionFormethod_body2: nodes
	| result |
	result := CSMethodBodyNode new.
	result semicolonToken: (nodes at: 1).
	^result!

reduceActionFormethod_declaration1: nodes
	| result |
	result := CSMethodDeclarationNode new.
	result header: (nodes at: 1).
	result body: (nodes at: 2).
	^result!

reduceActionFormethod_header1: nodes
	| result |
	result := CSMethodHeaderNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result partialToken: (nodes at: 3).
	result returnType: (nodes at: 4).
	result name: ((nodes at: 5) at: 1).
	result interface: ((nodes at: 5) at: 2).
	result periodToken: ((nodes at: 5) at: 3).
	result typeParameters: (nodes at: 6).
	result leftParenToken: (nodes at: 7).
	result addNodes: ((nodes at: 8) at: 1) to: result parameters.
	result addTokens: ((nodes at: 8) at: 2) to: result commas.
	result rightParenToken: (nodes at: 9).
	result addNodes: (nodes at: 10) to: result constraintClauses.
	^result!

reduceActionFormultiplicative_expression2: nodes
	| result |
	result := CSBinaryExpressionNode new.
	result left: (nodes at: 1).
	result operator: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionFornamed_argument1: nodes
	| result |
	result := CSNamedArgumentNode new.
	result name: (nodes at: 1).
	result equal: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionFornamespace_body1: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	self addAll: (nodes at: 3) to: (result at: 2).
	self addAll: (nodes at: 4) to: (result at: 3).
	result at: 4 put: (nodes at: 5).
	^result!

reduceActionFornamespace_declaration1: nodes
	| result |
	result := CSNamespaceDeclarationNode new.
	result namespaceToken: (nodes at: 1).
	result identifier: (nodes at: 2).
	result leftBraceToken: ((nodes at: 3) at: 1).
	result addNodes: ((nodes at: 3) at: 2) to: result directives.
	result addNodes: ((nodes at: 3) at: 3) to: result declarations.
	result rightBraceToken: ((nodes at: 3) at: 4).
	result semicolon: (nodes at: 4).
	^result!

reduceActionFornamespace_member_declaration1: nodes
	^nodes at: 1!

reduceActionFornamespace_or_type_name1: nodes
	| result |
	result := CSTypeNameNode new.
	result name: (nodes at: 1).
	result typeArguments: (nodes at: 2).
	^result!

reduceActionFornamespace_or_type_name2: nodes
	| result |
	result := CSTypeNameNode new.
	result namespace: (nodes at: 1).
	result periodToken: (nodes at: 2).
	result name: (nodes at: 3).
	result typeArguments: (nodes at: 4).
	^result!

reduceActionFornullable_type1: nodes
	| result |
	result := CSNullableTypeNode new.
	result type: (nodes at: 1).
	result questionMarkToken: (nodes at: 2).
	^result!

reduceActionForobject_creation_expression1: nodes
	| result |
	result := CSObjectCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result leftParenToken: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result arguments.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	result rightParenToken: (nodes at: 5).
	result initializer: (nodes at: 6).
	^result!

reduceActionForobject_creation_expression2: nodes
	| result |
	result := CSObjectCreationExpressionNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result initializer: (nodes at: 3).
	^result!

reduceActionForobject_initializer1: nodes
	| result |
	result := CSObjectInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result rightBraceToken: (nodes at: 3).
	^result!

reduceActionForobject_initializer2: nodes
	| result |
	result := CSObjectInitializerNode new.
	result leftBraceToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result addToken: (nodes at: 3) to: result commaTokens.
	result rightBraceToken: (nodes at: 4).
	^result!

reduceActionForoperator_declaration1: nodes
	| result |
	result := CSOperatorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result returnType: ((nodes at: 3) at: 1).
	result operatorToken: ((nodes at: 3) at: 2).
	result operator: ((nodes at: 3) at: 3).
	result leftParenToken: ((nodes at: 3) at: 4).
	result addNodes: ((nodes at: 3) at: 5) to: result types.
	result addTokens: ((nodes at: 3) at: 6) to: result arguments.
	result rightParenToken: ((nodes at: 3) at: 7).
	result commaToken: ((nodes at: 3) at: 8).
	result implicitToken: ((nodes at: 3) at: 9).
	result explicitToken: ((nodes at: 3) at: 10).
	result body: (nodes at: 4).
	^result!

reduceActionForoperator_declarator1: nodes
	| result |
	result := Array new: 10.
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	result at: 3 put: ((nodes at: 1) at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	self add: ((nodes at: 1) at: 5) to: (result at: 5).
	self add: ((nodes at: 1) at: 6) to: (result at: 6).
	result at: 7 put: ((nodes at: 1) at: 7).
	^result!

reduceActionForoperator_declarator2: nodes
	| result |
	result := Array new: 10.
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	result at: 3 put: ((nodes at: 1) at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	result at: 8 put: ((nodes at: 1) at: 7).
	result at: 7 put: ((nodes at: 1) at: 8).
	^result!

reduceActionForoperator_declarator3: nodes
	| result |
	result := Array new: 10.
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 9 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	result at: 1 put: ((nodes at: 1) at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	self add: ((nodes at: 1) at: 5) to: (result at: 5).
	self add: ((nodes at: 1) at: 6) to: (result at: 6).
	result at: 7 put: ((nodes at: 1) at: 7).
	result at: 10 put: ((nodes at: 1) at: 8).
	^result!

reduceActionFororderby_clause1: nodes
	| result |
	result := Array new: 5.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	self addAll: ((nodes at: 2) at: 3) to: (result at: 4).
	self addAll: ((nodes at: 2) at: 4) to: (result at: 5).
	^result!

reduceActionForordering_direction1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	^result!

reduceActionForordering_direction2: nodes
	| result |
	result := Array new: 2.
	result at: 2 put: (nodes at: 1).
	^result!

reduceActionForordering1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: ((nodes at: 2) at: 1).
	result at: 3 put: ((nodes at: 2) at: 2).
	^result!

reduceActionFororderings1: nodes
	| result |
	result := Array new: 4.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	self add: ((nodes at: 1) at: 1) to: (result at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: ((nodes at: 1) at: 3) to: (result at: 3).
	^result!

reduceActionFororderings2: nodes
	| result |
	result := Array new: 4.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self add: (nodes at: 2) to: (result at: 4).
	self add: ((nodes at: 3) at: 1) to: (result at: 1).
	self add: ((nodes at: 3) at: 2) to: (result at: 2).
	self add: ((nodes at: 3) at: 3) to: (result at: 3).
	^result!

reduceActionForparameter_array1: nodes
	| result |
	result := CSArrayParameterNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result paramsToken: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	^result!

reduceActionForparenthesized_expression1: nodes
	| result |
	result := nodes at: 2.
	result addFirstToken: (nodes at: 1) to: result _leftParens.
	result addToken: (nodes at: 3) to: result _rightParens.
	^result!

reduceActionForpointer_element_access1: nodes
	| result |
	result := CSPointerElementAccessNode new.
	result expression: (nodes at: 1).
	result leftBracketToken: (nodes at: 2).
	result indexExpression: (nodes at: 3).
	result rightBracketToken: (nodes at: 4).
	^result!

reduceActionForpointer_indirection_expression1: nodes
	| result |
	result := CSPrefixExpressionNode new.
	result operator: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForpointer_member_access1: nodes
	| result |
	result := CSPointerMemberAccessNode new.
	result expression: (nodes at: 1).
	result arrowToken: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForpointer_type2: nodes
	| result |
	result := CSPointerTypeNode new.
	result type: (nodes at: 1).
	result timesToken: (nodes at: 2).
	^result!

reduceActionForpost_increment_expression1: nodes
	| result |
	result := CSPostExpressionNode new.
	result expression: (nodes at: 1).
	result operator: (nodes at: 2).
	^result!

reduceActionForprimary_constraint1: nodes
	| result |
	result := CSTypeConstraintNode new.
	result type: (nodes at: 1).
	^result!

reduceActionForprimary_constraint2: nodes
	| result |
	result := CSPrimaryConstraintNode new.
	result classToken: (nodes at: 1).
	^result!

reduceActionForprimary_constraint3: nodes
	| result |
	result := CSPrimaryConstraintNode new.
	result structToken: (nodes at: 1).
	^result!

reduceActionForproperty_declaration1: nodes
	| result |
	result := CSPropertyDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result type: (nodes at: 3).
	result name: ((nodes at: 4) at: 1).
	result interface: ((nodes at: 4) at: 2).
	result periodToken: ((nodes at: 4) at: 3).
	result leftBraceToken: (nodes at: 5).
	result getAccessor: ((nodes at: 6) at: 1).
	result setAccessor: ((nodes at: 6) at: 2).
	result rightBraceToken: (nodes at: 7).
	^result!

reduceActionForqualified_alias_member1: nodes
	| result |
	result := CSQualifiedAliasMemberNode new.
	result global: (nodes at: 1).
	result colonColonToken: (nodes at: 2).
	result name: (nodes at: 3).
	result typeArguments: (nodes at: 4).
	^result!

reduceActionForqualified_identifier1: nodes
	| result |
	result := CSQualifiedIdentifierNode new.
	result addToken: (nodes at: 1) to: result names.
	^result!

reduceActionForqualified_identifier2: nodes
	| result |
	result := nodes at: 1.
	result addToken: (nodes at: 2) to: result periodTokens.
	result addToken: (nodes at: 3) to: result names.
	^result!

reduceActionForquery_body_clause1: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	self add: ((nodes at: 1) at: 3) to: (result at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	self add: ((nodes at: 1) at: 5) to: (result at: 5).
	^result!

reduceActionForquery_body_clause2: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 6 put: ((nodes at: 1) at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 3).
	result at: 7 put: ((nodes at: 1) at: 3).
	self add: ((nodes at: 1) at: 4) to: (result at: 5).
	^result!

reduceActionForquery_body_clause3: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 8 put: ((nodes at: 1) at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 5).
	^result!

reduceActionForquery_body_clause4: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 9 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	self add: ((nodes at: 1) at: 3) to: (result at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	result at: 10 put: ((nodes at: 1) at: 5).
	result at: 11 put: ((nodes at: 1) at: 6).
	result at: 12 put: ((nodes at: 1) at: 7).
	result at: 13 put: ((nodes at: 1) at: 8).
	result at: 14 put: ((nodes at: 1) at: 9).
	^result!

reduceActionForquery_body_clause5: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 9 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	result at: 4 put: ((nodes at: 1) at: 4).
	result at: 10 put: ((nodes at: 1) at: 5).
	result at: 11 put: ((nodes at: 1) at: 6).
	result at: 12 put: ((nodes at: 1) at: 7).
	result at: 13 put: ((nodes at: 1) at: 8).
	result at: 14 put: ((nodes at: 1) at: 9).
	result at: 15 put: ((nodes at: 1) at: 10).
	^result!

reduceActionForquery_body_clause6: nodes
	| result |
	result := Array new: 19.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 16 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 19).
	^result!

reduceActionForquery_body_clauses1: nodes
	| result |
	result := Array new: 19.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	self add: ((nodes at: 1) at: 1) to: (result at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self add: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self add: ((nodes at: 1) at: 6) to: (result at: 6).
	self add: ((nodes at: 1) at: 7) to: (result at: 7).
	self add: ((nodes at: 1) at: 8) to: (result at: 8).
	self add: ((nodes at: 1) at: 9) to: (result at: 9).
	self add: ((nodes at: 1) at: 10) to: (result at: 10).
	self add: ((nodes at: 1) at: 11) to: (result at: 11).
	self add: ((nodes at: 1) at: 12) to: (result at: 12).
	self add: ((nodes at: 1) at: 13) to: (result at: 13).
	self add: ((nodes at: 1) at: 14) to: (result at: 14).
	self add: ((nodes at: 1) at: 15) to: (result at: 15).
	self add: ((nodes at: 1) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 1) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 19) to: (result at: 19).
	^result!

reduceActionForquery_body_clauses2: nodes
	| result |
	result := Array new: 19.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	self addAll: ((nodes at: 1) at: 10) to: (result at: 10).
	self addAll: ((nodes at: 1) at: 11) to: (result at: 11).
	self addAll: ((nodes at: 1) at: 12) to: (result at: 12).
	self addAll: ((nodes at: 1) at: 13) to: (result at: 13).
	self addAll: ((nodes at: 1) at: 14) to: (result at: 14).
	self addAll: ((nodes at: 1) at: 15) to: (result at: 15).
	self addAll: ((nodes at: 1) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 1) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 19) to: (result at: 19).
	self add: ((nodes at: 2) at: 1) to: (result at: 1).
	self add: ((nodes at: 2) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 3) to: (result at: 3).
	self add: ((nodes at: 2) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 2) at: 5) to: (result at: 5).
	self add: ((nodes at: 2) at: 6) to: (result at: 6).
	self add: ((nodes at: 2) at: 7) to: (result at: 7).
	self add: ((nodes at: 2) at: 8) to: (result at: 8).
	self add: ((nodes at: 2) at: 9) to: (result at: 9).
	self add: ((nodes at: 2) at: 10) to: (result at: 10).
	self add: ((nodes at: 2) at: 11) to: (result at: 11).
	self add: ((nodes at: 2) at: 12) to: (result at: 12).
	self add: ((nodes at: 2) at: 13) to: (result at: 13).
	self add: ((nodes at: 2) at: 14) to: (result at: 14).
	self add: ((nodes at: 2) at: 15) to: (result at: 15).
	self add: ((nodes at: 2) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 2) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 2) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 2) at: 19) to: (result at: 19).
	^result!

reduceActionForquery_body1: nodes
	| result |
	result := Array new: 24.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 20 put: (OrderedCollection new: 2).
	result at: 21 put: (OrderedCollection new: 2).
	result at: 22 put: (OrderedCollection new: 2).
	result at: 23 put: (OrderedCollection new: 2).
	result at: 24 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self addAll: ((nodes at: 1) at: 4) to: (result at: 4).
	self addAll: ((nodes at: 1) at: 5) to: (result at: 5).
	self addAll: ((nodes at: 1) at: 6) to: (result at: 6).
	self addAll: ((nodes at: 1) at: 7) to: (result at: 7).
	self addAll: ((nodes at: 1) at: 8) to: (result at: 8).
	self addAll: ((nodes at: 1) at: 9) to: (result at: 9).
	self addAll: ((nodes at: 1) at: 10) to: (result at: 10).
	self addAll: ((nodes at: 1) at: 11) to: (result at: 11).
	self addAll: ((nodes at: 1) at: 12) to: (result at: 12).
	self addAll: ((nodes at: 1) at: 13) to: (result at: 13).
	self addAll: ((nodes at: 1) at: 14) to: (result at: 14).
	self addAll: ((nodes at: 1) at: 15) to: (result at: 15).
	self addAll: ((nodes at: 1) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 1) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 1) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 1) at: 19) to: (result at: 19).
	self add: ((nodes at: 2) at: 1) to: (result at: 20).
	self add: ((nodes at: 2) at: 2) to: (result at: 5).
	self add: ((nodes at: 2) at: 3) to: (result at: 21).
	self add: ((nodes at: 2) at: 4) to: (result at: 22).
	self add: ((nodes at: 2) at: 5) to: (result at: 23).
	self add: ((nodes at: 2) at: 6) to: (result at: 24).
	self addAll: ((nodes at: 3) at: 1) to: (result at: 15).
	self addAll: ((nodes at: 3) at: 2) to: (result at: 3).
	self addAll: ((nodes at: 3) at: 3) to: (result at: 1).
	self addAll: ((nodes at: 3) at: 4) to: (result at: 2).
	self addAll: ((nodes at: 3) at: 5) to: (result at: 4).
	self addAll: ((nodes at: 3) at: 6) to: (result at: 5).
	self addAll: ((nodes at: 3) at: 7) to: (result at: 6).
	self addAll: ((nodes at: 3) at: 8) to: (result at: 7).
	self addAll: ((nodes at: 3) at: 9) to: (result at: 8).
	self addAll: ((nodes at: 3) at: 10) to: (result at: 9).
	self addAll: ((nodes at: 3) at: 11) to: (result at: 10).
	self addAll: ((nodes at: 3) at: 12) to: (result at: 11).
	self addAll: ((nodes at: 3) at: 13) to: (result at: 12).
	self addAll: ((nodes at: 3) at: 14) to: (result at: 13).
	self addAll: ((nodes at: 3) at: 15) to: (result at: 14).
	self addAll: ((nodes at: 3) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 3) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 3) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 3) at: 19) to: (result at: 19).
	self addAll: ((nodes at: 3) at: 20) to: (result at: 20).
	self addAll: ((nodes at: 3) at: 21) to: (result at: 21).
	self addAll: ((nodes at: 3) at: 22) to: (result at: 22).
	self addAll: ((nodes at: 3) at: 23) to: (result at: 23).
	self addAll: ((nodes at: 3) at: 24) to: (result at: 24).
	^result!

reduceActionForquery_continuation1: nodes
	| result |
	result := Array new: 24.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 6 put: (OrderedCollection new: 2).
	result at: 7 put: (OrderedCollection new: 2).
	result at: 8 put: (OrderedCollection new: 2).
	result at: 9 put: (OrderedCollection new: 2).
	result at: 10 put: (OrderedCollection new: 2).
	result at: 11 put: (OrderedCollection new: 2).
	result at: 12 put: (OrderedCollection new: 2).
	result at: 13 put: (OrderedCollection new: 2).
	result at: 14 put: (OrderedCollection new: 2).
	result at: 15 put: (OrderedCollection new: 2).
	result at: 16 put: (OrderedCollection new: 2).
	result at: 17 put: (OrderedCollection new: 2).
	result at: 18 put: (OrderedCollection new: 2).
	result at: 19 put: (OrderedCollection new: 2).
	result at: 20 put: (OrderedCollection new: 2).
	result at: 21 put: (OrderedCollection new: 2).
	result at: 22 put: (OrderedCollection new: 2).
	result at: 23 put: (OrderedCollection new: 2).
	result at: 24 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	self addAll: ((nodes at: 3) at: 1) to: (result at: 3).
	self addAll: ((nodes at: 3) at: 2) to: (result at: 4).
	self addAll: ((nodes at: 3) at: 3) to: (result at: 2).
	self addAll: ((nodes at: 3) at: 4) to: (result at: 5).
	self addAll: ((nodes at: 3) at: 5) to: (result at: 6).
	self addAll: ((nodes at: 3) at: 6) to: (result at: 7).
	self addAll: ((nodes at: 3) at: 7) to: (result at: 8).
	self addAll: ((nodes at: 3) at: 8) to: (result at: 9).
	self addAll: ((nodes at: 3) at: 9) to: (result at: 10).
	self addAll: ((nodes at: 3) at: 10) to: (result at: 11).
	self addAll: ((nodes at: 3) at: 11) to: (result at: 12).
	self addAll: ((nodes at: 3) at: 12) to: (result at: 13).
	self addAll: ((nodes at: 3) at: 13) to: (result at: 14).
	self addAll: ((nodes at: 3) at: 14) to: (result at: 15).
	self addAll: ((nodes at: 3) at: 15) to: (result at: 1).
	self addAll: ((nodes at: 3) at: 16) to: (result at: 16).
	self addAll: ((nodes at: 3) at: 17) to: (result at: 17).
	self addAll: ((nodes at: 3) at: 18) to: (result at: 18).
	self addAll: ((nodes at: 3) at: 19) to: (result at: 19).
	self addAll: ((nodes at: 3) at: 20) to: (result at: 20).
	self addAll: ((nodes at: 3) at: 21) to: (result at: 21).
	self addAll: ((nodes at: 3) at: 22) to: (result at: 22).
	self addAll: ((nodes at: 3) at: 23) to: (result at: 23).
	self addAll: ((nodes at: 3) at: 24) to: (result at: 24).
	^result!

reduceActionForquery_expression1: nodes
	| result |
	result := CSQueryExpressionNode new.
	result addToken: ((nodes at: 1) at: 1) to: result fromTokens.
	result addNode: ((nodes at: 1) at: 2) to: result types.
	result addToken: ((nodes at: 1) at: 3) to: result identifierTokens.
	result addToken: ((nodes at: 1) at: 4) to: result inTokens.
	result addNode: ((nodes at: 1) at: 5) to: result expressions.
	result addTokens: ((nodes at: 2) at: 1) to: result fromTokens.
	result addNodes: ((nodes at: 2) at: 2) to: result types.
	result addTokens: ((nodes at: 2) at: 3) to: result identifierTokens.
	result addTokens: ((nodes at: 2) at: 4) to: result inTokens.
	result addNodes: ((nodes at: 2) at: 5) to: result expressions.
	result addTokens: ((nodes at: 2) at: 6) to: result letTokens.
	result addTokens: ((nodes at: 2) at: 7) to: result equalTokens.
	result addTokens: ((nodes at: 2) at: 8) to: result whereTokens.
	result addTokens: ((nodes at: 2) at: 9) to: result joinTokens.
	result addNodes: ((nodes at: 2) at: 10) to: result joinInExpressions.
	result addTokens: ((nodes at: 2) at: 11) to: result onTokens.
	result addNodes: ((nodes at: 2) at: 12) to: result joinOnExpressions.
	result addTokens: ((nodes at: 2) at: 13) to: result equalsTokens.
	result addNodes: ((nodes at: 2) at: 14) to: result joinEqualsExpressions.
	result addTokens: ((nodes at: 2) at: 15) to: result intoTokens.
	result addTokens: ((nodes at: 2) at: 16) to: result orderbyTokens.
	result addTokens: ((nodes at: 2) at: 17) to: result ascendingTokens.
	result addTokens: ((nodes at: 2) at: 18) to: result descendingTokens.
	result addTokens: ((nodes at: 2) at: 19) to: result commaTokens.
	result addTokens: ((nodes at: 2) at: 20) to: result selectTokens.
	result addTokens: ((nodes at: 2) at: 21) to: result groupTokens.
	result addNodes: ((nodes at: 2) at: 22) to: result groupExpressions.
	result addTokens: ((nodes at: 2) at: 23) to: result byTokens.
	result addNodes: ((nodes at: 2) at: 24) to: result groupByExpressions.
	^result!

reduceActionForrank_specifier1: nodes
	| result |
	result := CSRankSpecifierNode new.
	result leftBracketToken: (nodes at: 1).
	result addTokens: (nodes at: 2) to: result commaTokens.
	result rightBracketToken: (nodes at: 3).
	^result!

reduceActionForremove_accessor_declaration1: nodes
	| result |
	result := CSRemoveAccessorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result removeToken: (nodes at: 2).
	result block: (nodes at: 3).
	^result!

reduceActionForreturn_statement1: nodes
	| result |
	result := CSReturnStatementNode new.
	result returnToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceActionForselect_or_group_clause1: nodes
	| result |
	result := Array new: 6.
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	^result!

reduceActionForselect_or_group_clause2: nodes
	| result |
	result := Array new: 6.
	result at: 3 put: ((nodes at: 1) at: 1).
	result at: 4 put: ((nodes at: 1) at: 2).
	result at: 5 put: ((nodes at: 1) at: 3).
	result at: 6 put: ((nodes at: 1) at: 4).
	^result!

reduceActionForset_accessor_declaration1: nodes
	| result |
	result := CSSetAccessorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result setToken: (nodes at: 3).
	result body: ((nodes at: 4) at: 1).
	result semicolonToken: ((nodes at: 4) at: 2).
	^result!

reduceActionForsimple_name1: nodes
	| result |
	result := CSSimpleNameNode new.
	result identifierToken: (nodes at: 1).
	result typeArguments: (nodes at: 2).
	^result!

reduceActionForsimple_type2: nodes
	| result |
	result := CSSimpleTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForsizeof_expression1: nodes
	| result |
	result := CSSizeofExpressionNode new.
	result sizeofToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionForspecific_catch_clause1: nodes
	| result |
	result := CSSpecificCatchClauseNode new.
	result catchToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result name: (nodes at: 4).
	result rightParenToken: (nodes at: 5).
	result block: (nodes at: 6).
	^result!

reduceActionForstackalloc_initializer1: nodes
	| result |
	result := CSStackallocInitializerNode new.
	result stackallocToken: (nodes at: 1).
	result type: (nodes at: 2).
	result leftBracketToken: (nodes at: 3).
	result expression: (nodes at: 4).
	result rightBracketToken: (nodes at: 5).
	^result!

reduceActionForstatic_constructor_declaration1: nodes
	| result |
	result := CSStaticConstructorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: ((nodes at: 2) at: 1) to: result modifiers.
	result staticToken: ((nodes at: 2) at: 2).
	result unsafeToken: ((nodes at: 2) at: 3).
	result identifierToken: (nodes at: 3).
	result leftParenToken: (nodes at: 4).
	result rightParenToken: (nodes at: 5).
	result block: ((nodes at: 6) at: 1).
	result semicolonToken: ((nodes at: 6) at: 2).
	^result!

reduceActionForstatic_constructor_modifiers1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	result at: 2 put: (nodes at: 2).
	^result!

reduceActionForstatic_constructor_modifiers2: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (nodes at: 1).
	self add: (nodes at: 2) to: (result at: 1).
	^result!

reduceActionForstatic_constructor_modifiers3: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 1).
	result at: 2 put: (nodes at: 3).
	^result!

reduceActionForstatic_constructor_modifiers5: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	^result!

reduceActionForstatic_constructor_modifiers6: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	result at: 2 put: (nodes at: 2).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionForstatic_constructor_modifiers7: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (nodes at: 1).
	self add: (nodes at: 2) to: (result at: 1).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionForstruct_declaration1: nodes
	| result |
	result := CSStructDeclarationNode new.
	result addNodes: (nodes at: 1) to: result _attributes.
	result addTokens: (nodes at: 2) to: result modifiers.
	result partialToken: (nodes at: 3).
	result structToken: (nodes at: 4).
	result identifierToken: (nodes at: 5).
	result typeParameters: (nodes at: 6).
	result colonToken: ((nodes at: 7) at: 1).
	result addNodes: ((nodes at: 7) at: 2) to: result supertypes.
	result addTokens: ((nodes at: 7) at: 3) to: result commas.
	result addNodes: (nodes at: 8) to: result constraintClauses.
	result leftBraceToken: ((nodes at: 9) at: 1).
	result addNodes: ((nodes at: 9) at: 2) to: result declarations.
	result rightBraceToken: ((nodes at: 9) at: 3).
	result semicolon: (nodes at: 10).
	^result!

reduceActionForstruct_interfaces1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	^result!

reduceActionForswitch_label1: nodes
	| result |
	result := CSSwitchLabelNode new.
	result caseToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result colonToken: (nodes at: 3).
	^result!

reduceActionForswitch_label2: nodes
	| result |
	result := CSSwitchLabelNode new.
	result defaultToken: (nodes at: 1).
	result colonToken: (nodes at: 2).
	^result!

reduceActionForswitch_section1: nodes
	| result |
	result := CSSwitchSectionNode new.
	result addNodes: (nodes at: 1) to: result labels.
	result addNodes: (nodes at: 2) to: result statements.
	^result!

reduceActionForswitch_statement1: nodes
	| result |
	result := CSSwitchStatementNode new.
	result switchToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result leftBraceToken: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result sections.
	result rightBraceToken: ((nodes at: 5) at: 3).
	^result!

reduceActionForthis_access1: nodes
	| result |
	result := CSThisAccessNode new.
	result thisToken: (nodes at: 1).
	^result!

reduceActionForthrow_statement1: nodes
	| result |
	result := CSThrowStatementNode new.
	result throwToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceActionFortry_statement1: nodes
	| result |
	result := CSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result block: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result clauses.
	^result!

reduceActionFortry_statement2: nodes
	| result |
	result := CSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result block: (nodes at: 2).
	result finally: (nodes at: 3).
	^result!

reduceActionFortry_statement3: nodes
	| result |
	result := CSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result block: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result clauses.
	result finally: (nodes at: 4).
	^result!

reduceActionFortype_argument_list1: nodes
	| result |
	result := CSTypeArgumentListNode new.
	result lessThanToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result types.
	result addTokens: ((nodes at: 2) at: 2) to: result commaTokens.
	result greaterThanToken: (nodes at: 3).
	^result!

reduceActionFortype_parameter_constraints_clause1: nodes
	| result |
	result := CSTypeParameterConstraintsClauseNode new.
	result whereToken: (nodes at: 1).
	result parameter: (nodes at: 2).
	result colon: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result constraints.
	result addTokens: ((nodes at: 4) at: 2) to: result commaTokens.
	^result!

reduceActionFortype_parameter_constraints4: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	self addAll: ((nodes at: 3) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 3) at: 2) to: (result at: 2).
	^result!

reduceActionFortype_parameter_constraints5: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionFortype_parameter_constraints7: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	self addAll: ((nodes at: 3) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 3) at: 2) to: (result at: 2).
	self add: (nodes at: 4) to: (result at: 2).
	self add: (nodes at: 5) to: (result at: 1).
	^result!

reduceActionFortype_parameter_list1: nodes
	| result |
	result := CSTypeParameterListNode new.
	result lessThan: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result _attributes.
	result addNodes: ((nodes at: 2) at: 2) to: result parameters.
	result addTokens: ((nodes at: 2) at: 3) to: result commaTokens.
	result greaterThan: (nodes at: 3).
	^result!

reduceActionFortype_parameter1: nodes
	| result |
	result := CSTypeNameNode new.
	result name: (nodes at: 1).
	^result!

reduceActionFortype_parameters1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	self addAll: (nodes at: 1) to: (result at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	^result!

reduceActionFortype_parameters2: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self add: (nodes at: 2) to: (result at: 3).
	self addAll: (nodes at: 3) to: (result at: 1).
	self add: (nodes at: 4) to: (result at: 2).
	^result!

reduceActionFortypeof_expression1: nodes
	| result |
	result := CSTypeofExpressionNode new.
	result typeofToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result type: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionForunary_operator_declarator1: nodes
	| result |
	result := Array new: 7.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	result at: 6 put: (nodes at: 6).
	result at: 7 put: (nodes at: 7).
	^result!

reduceActionForunbound_type_name1: nodes
	| result |
	result := CSUnboundTypeNameNode new.
	result addToken: (nodes at: 1) to: result identifierTokens.
	result addToken: ((nodes at: 2) at: 1) to: result lessThanTokens.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result addToken: ((nodes at: 2) at: 3) to: result gtTokens.
	^result!

reduceActionForunbound_type_name2: nodes
	| result |
	result := CSUnboundTypeNameNode new.
	result addToken: (nodes at: 1) to: result identifierTokens.
	result colonColonToken: (nodes at: 2).
	result addToken: (nodes at: 3) to: result identifierTokens.
	result addToken: ((nodes at: 4) at: 1) to: result lessThanTokens.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: ((nodes at: 4) at: 3) to: result gtTokens.
	^result!

reduceActionForunbound_type_name3: nodes
	| result |
	result := nodes at: 1.
	result addToken: (nodes at: 2) to: result periodTokens.
	result addToken: (nodes at: 3) to: result identifierTokens.
	result addToken: ((nodes at: 4) at: 1) to: result lessThanTokens.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: ((nodes at: 4) at: 3) to: result gtTokens.
	^result!

reduceActionForunchecked_expression1: nodes
	| result |
	result := CSUncheckedExpressionNode new.
	result uncheckedToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	^result!

reduceActionForunchecked_statement1: nodes
	| result |
	result := CSUncheckedStatementNode new.
	result uncheckedToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForunsafe_statement1: nodes
	| result |
	result := CSUnsafeStatementNode new.
	result unsafeToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForusing_alias_directive1: nodes
	| result |
	result := CSUsingAliasDirectiveNode new.
	result usingToken: (nodes at: 1).
	result name: (nodes at: 2).
	result equalToken: (nodes at: 3).
	result namespace: (nodes at: 4).
	result semicolonToken: (nodes at: 5).
	^result!

reduceActionForusing_namespace_directive1: nodes
	| result |
	result := CSUsingNamespaceDirectiveNode new.
	result usingToken: (nodes at: 1).
	result namespace: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceActionForusing_statement1: nodes
	| result |
	result := CSUsingStatementNode new.
	result usingToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceActionForvariable_declarator1: nodes
	| result |
	result := CSVariableDeclaratorNode new.
	result identifierToken: (nodes at: 1).
	^result!

reduceActionForvariable_declarator2: nodes
	| result |
	result := CSVariableDeclaratorNode new.
	result identifierToken: (nodes at: 1).
	result equalToken: (nodes at: 2).
	result initializer: (nodes at: 3).
	^result!

reduceActionForvoid_type1: nodes
	| result |
	result := CSVoidTypeNode new.
	result voidToken: (nodes at: 1).
	^result!

reduceActionForwhile_statement1: nodes
	| result |
	result := CSWhileStatementNode new.
	result whileToken: (nodes at: 1).
	result leftParenToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParenToken: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceActionForyield_statement1: nodes
	| result |
	result := CSYieldStatementNode new.
	result yieldToken: (nodes at: 1).
	result returnToken: (nodes at: 2).
	result expression: (nodes at: 3).
	result semicolonToken: (nodes at: 4).
	^result!

reduceActionForyield_statement2: nodes
	| result |
	result := CSYieldStatementNode new.
	result yieldToken: (nodes at: 1).
	result breakToken: (nodes at: 2).
	result semicolonToken: (nodes at: 3).
	^result!

reduceTable
^#(
	#(538 0 #reduceActionFor_extern_alias_directives1:) 
	#(376 0 #reduceActionFor_extern_alias_directives1:) 
	#(538 1 #reduceActionFor_extern_alias_directives2:) 
	#(168 1 #reduceActionForextern_alias_directives1:) 
	#(537 0 #reduceActionFor_extern_alias_directives1:) 
	#(523 0 #reduceActionFor_attribute_target_specifier1:) 
	#(565 1 #reduceActionFornamespace_member_declaration1:) 
	#(177 1 #reduceActionFornamespace_member_declaration1:) 
	#(511 0 #reduceActionFor_extern_alias_directives1:) 
	#(474 0 #reduceActionFor_extern_alias_directives1:) 
	#(485 0 #reduceActionFor_extern_alias_directives1:) 
	#(377 0 #reduceActionFor_extern_alias_directives1:) 
	#(502 0 #reduceActionFor_extern_alias_directives1:) 
	#(376 1 #reduceActionFor_extern_alias_directives2:) 
	#(520 1 #reduceActionFor_extern_alias_directives2:) 
	#(521 1 #reduceActionForextern_alias_directives1:) 
	#(257 1 #reduceActionForvoid_type1:) 
	#(281 0 #nil) 
	#(193 1 #reduceActionForsimple_type2:) 
	#(237 1 #reduceActionForsimple_type2:) 
	#(195 1 #reduceActionFornamespace_member_declaration1:) 
	#(196 1 #reduceActionFornamespace_member_declaration1:) 
	#(320 1 #reduceActionForempty_statement1:) 
	#(331 0 #reduceActionFor_extern_alias_directives1:) 
	#(199 1 #reduceActionForsimple_type2:) 
	#(225 1 #reduceActionForthis_access1:) 
	#(197 1 #reduceActionFornamespace_member_declaration1:) 
	#(536 1 #reduceActionFornamespace_member_declaration1:) 
	#(335 1 #reduceActionForlocal_variable_type2:) 
	#(315 0 #nil) 
	#(190 1 #reduceActionFortype_parameter1:) 
	#(183 0 #nil) 
	#(219 1 #reduceActionForliteral2:) 
	#(324 1 #reduceActionFornamespace_member_declaration1:) 
	#(185 1 #reduceActionFornamespace_member_declaration1:) 
	#(174 1 #reduceActionFornamespace_member_declaration1:) 
	#(199 1 #reduceActionFornamespace_member_declaration1:) 
	#(200 1 #reduceActionFornamespace_member_declaration1:) 
	#(191 1 #reduceActionFornamespace_member_declaration1:) 
	#(202 1 #reduceActionFornamespace_member_declaration1:) 
	#(192 1 #reduceActionFornamespace_member_declaration1:) 
	#(545 1 #reduceActionFornamespace_member_declaration1:) 
	#(203 1 #reduceActionFornamespace_member_declaration1:) 
	#(198 1 #reduceActionFornamespace_member_declaration1:) 
	#(335 1 #reduceActionFornamespace_member_declaration1:) 
	#(186 1 #reduceActionFornamespace_member_declaration1:) 
	#(188 1 #reduceActionFornamespace_member_declaration1:) 
	#(189 1 #reduceActionFornamespace_member_declaration1:) 
	#(218 1 #reduceActionFornamespace_member_declaration1:) 
	#(262 1 #reduceActionFornamespace_member_declaration1:) 
	#(216 1 #reduceActionFornamespace_member_declaration1:) 
	#(342 1 #reduceActionFornamespace_member_declaration1:) 
	#(541 1 #reduceActionFornamespace_member_declaration1:) 
	#(319 1 #reduceActionFornamespace_member_declaration1:) 
	#(322 1 #reduceActionFornamespace_member_declaration1:) 
	#(323 1 #reduceActionFornamespace_member_declaration1:) 
	#(187 0 #nil) 
	#(287 0 #nil) 
	#(289 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(566 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(290 1 #reduceActionFornamespace_member_declaration1:) 
	#(540 1 #reduceActionFornamespace_member_declaration1:) 
	#(266 1 #reduceActionFornamespace_member_declaration1:) 
	#(267 1 #reduceActionFornamespace_member_declaration1:) 
	#(268 1 #reduceActionFornamespace_member_declaration1:) 
	#(269 1 #reduceActionFornamespace_member_declaration1:) 
	#(270 1 #reduceActionFornamespace_member_declaration1:) 
	#(271 1 #reduceActionFornamespace_member_declaration1:) 
	#(272 1 #reduceActionFornamespace_member_declaration1:) 
	#(273 1 #reduceActionFornamespace_member_declaration1:) 
	#(274 1 #reduceActionFornamespace_member_declaration1:) 
	#(275 1 #reduceActionFornamespace_member_declaration1:) 
	#(276 1 #reduceActionFornamespace_member_declaration1:) 
	#(277 1 #reduceActionFornamespace_member_declaration1:) 
	#(249 1 #reduceActionFornamespace_member_declaration1:) 
	#(278 1 #reduceActionFornamespace_member_declaration1:) 
	#(283 1 #reduceActionForimplicit_anonymous_function_signature2:) 
	#(295 0 #reduceActionFor_query_body_clauses1:) 
	#(168 2 #reduceActionForextern_alias_directives2:) 
	#(537 1 #reduceActionFor_extern_alias_directives2:) 
	#(170 1 #reduceActionForextern_alias_directives1:) 
	#(171 1 #reduceActionFornamespace_member_declaration1:) 
	#(284 0 #reduceActionFor_extern_alias_directives1:) 
	#(164 1 #reduceActionForqualified_identifier1:) 
	#(525 1 #reduceActionFornamespace_member_declaration1:) 
	#(523 1 #reduceActionFor_attribute_target_specifier2:) 
	#(384 1 #reduceActionFornamespace_member_declaration1:) 
	#(509 1 #reduceActionFornamespace_member_declaration1:) 
	#(489 1 #reduceActionFornamespace_member_declaration1:) 
	#(513 1 #reduceActionFornamespace_member_declaration1:) 
	#(478 1 #reduceActionFornamespace_member_declaration1:) 
	#(378 0 #nil) 
	#(377 1 #reduceActionFor_extern_alias_directives2:) 
	#(383 1 #reduceActionForextern_alias_directives1:) 
	#(474 1 #reduceActionFor_extern_alias_directives2:) 
	#(477 1 #reduceActionForextern_alias_directives1:) 
	#(485 1 #reduceActionFor_extern_alias_directives2:) 
	#(488 1 #reduceActionForextern_alias_directives1:) 
	#(502 1 #reduceActionFor_extern_alias_directives2:) 
	#(508 1 #reduceActionForextern_alias_directives1:) 
	#(511 1 #reduceActionFor_extern_alias_directives2:) 
	#(512 1 #reduceActionForextern_alias_directives1:) 
	#(521 2 #reduceActionForextern_alias_directives2:) 
	#(549 2 #reduceActionForpointer_indirection_expression1:) 
	#(262 2 #reduceActionForpointer_indirection_expression1:) 
	#(253 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(207 0 #reduceActionFor_extern_alias_directives1:) 
	#(231 2 #reduceActionForanonymous_object_creation_expression1:) 
	#(327 2 #reduceActionForunchecked_statement1:) 
	#(326 2 #reduceActionForchecked_statement1:) 
	#(263 2 #reduceActionForpointer_indirection_expression1:) 
	#(281 1 #reduceActionFornamespace_member_declaration1:) 
	#(550 2 #reduceActionForpointer_indirection_expression1:) 
	#(264 2 #reduceActionForpointer_indirection_expression1:) 
	#(331 1 #reduceActionFor_extern_alias_directives2:) 
	#(332 1 #reduceActionForextern_alias_directives1:) 
	#(543 2 #reduceActionForunsafe_statement1:) 
	#(315 1 #reduceActionFornamespace_member_declaration1:) 
	#(371 0 #reduceActionFor_extern_alias_directives1:) 
	#(355 0 #nil) 
	#(363 2 #reduceActionForcontinue_statement1:) 
	#(362 2 #reduceActionForbreak_statement1:) 
	#(174 2 #reduceActionFornamespace_or_type_name1:) 
	#(220 2 #reduceActionForsimple_name1:) 
	#(183 1 #reduceActionFornamespace_member_declaration1:) 
	#(194 2 #reduceActionFornullable_type1:) 
	#(201 2 #reduceActionForarray_type1:) 
	#(204 1 #reduceActionForextern_alias_directives1:) 
	#(227 2 #reduceActionForpost_increment_expression1:) 
	#(228 2 #reduceActionForpost_increment_expression1:) 
	#(214 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(544 2 #reduceActionForpointer_type2:) 
	#(313 1 #reduceActionFornamespace_member_declaration1:) 
	#(318 2 #reduceActionFordeclaration_statement1:) 
	#(338 1 #reduceActionFor_local_variable_declarator_name1:) 
	#(333 2 #reduceActionForlocal_variable_declaration1:) 
	#(336 1 #reduceActionForlocal_variable_declarators1:) 
	#(337 1 #reduceActionForlocal_variable_declarator1:) 
	#(321 2 #reduceActionForexpression_statement1:) 
	#(187 1 #reduceActionFornamespace_member_declaration1:) 
	#(288 1 #reduceActionFornamespace_member_declaration1:) 
	#(566 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(285 1 #reduceActionForlocal_variable_declarators1:) 
	#(287 1 #reduceActionFornamespace_member_declaration1:) 
	#(291 1 #reduceActionForlocal_variable_declarators1:) 
	#(289 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(299 1 #reduceActionForquery_body_clause1:) 
	#(294 2 #reduceActionForquery_expression1:) 
	#(295 1 #reduceActionFor_query_body_clauses2:) 
	#(298 1 #reduceActionForquery_body_clauses1:) 
	#(299 1 #reduceActionForquery_body_clause2:) 
	#(299 1 #reduceActionForquery_body_clause3:) 
	#(299 1 #reduceActionForquery_body_clause4:) 
	#(299 1 #reduceActionForquery_body_clause5:) 
	#(299 1 #reduceActionForquery_body_clause6:) 
	#(175 1 #reduceActionFornamespace_member_declaration1:) 
	#(170 2 #reduceActionForextern_alias_directives2:) 
	#(567 0 #reduceActionFor_extern_alias_directives1:) 
	#(284 1 #reduceActionFor_extern_alias_directives2:) 
	#(514 1 #reduceActionFor_extern_alias_directives2:) 
	#(515 1 #reduceActionForextern_alias_directives1:) 
	#(166 0 #nil) 
	#(527 1 #reduceActionFornamespace_member_declaration1:) 
	#(518 1 #reduceActionForlocal_variable_declarators1:) 
	#(528 0 #reduceActionFor_attribute_arguments1:) 
	#(524 2 #reduceActionForattribute_target_specifier1:) 
	#(378 1 #reduceActionFornamespace_member_declaration1:) 
	#(383 2 #reduceActionForextern_alias_directives2:) 
	#(477 2 #reduceActionForextern_alias_directives2:) 
	#(488 2 #reduceActionForextern_alias_directives2:) 
	#(508 2 #reduceActionForextern_alias_directives2:) 
	#(512 2 #reduceActionForextern_alias_directives2:) 
	#(258 0 #reduceActionFor_generic_dimension_specifier1:) 
	#(255 1 #reduceActionFormember_declarator1:) 
	#(255 1 #reduceActionFormember_declarator2:) 
	#(253 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(254 1 #reduceActionForlocal_variable_declarators1:) 
	#(208 1 #reduceActionForextern_alias_directives1:) 
	#(207 1 #reduceActionFor_extern_alias_directives2:) 
	#(243 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(229 3 #reduceActionForobject_creation_expression2:) 
	#(240 1 #reduceActionFornamespace_member_declaration1:) 
	#(483 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(217 3 #reduceActionForarray_creation_expression2:) 
	#(217 3 #reduceActionForarray_creation_expression3:) 
	#(236 3 #reduceActionForanonymous_method_expression1:) 
	#(226 3 #reduceActionForbase_access1:) 
	#(238 1 #reduceActionForlocal_variable_declarators1:) 
	#(539 3 #reduceActionForblock1:) 
	#(332 2 #reduceActionForextern_alias_directives2:) 
	#(375 1 #reduceActionFornamespace_member_declaration1:) 
	#(221 3 #reduceActionForparenthesized_expression1:) 
	#(305 1 #reduceActionFornamespace_member_declaration1:) 
	#(334 3 #reduceActionForlocal_constant_declaration1:) 
	#(340 1 #reduceActionForlocal_variable_declarators1:) 
	#(366 3 #reduceActionForthrow_statement1:) 
	#(325 3 #reduceActionFortry_statement1:) 
	#(325 3 #reduceActionFortry_statement2:) 
	#(370 0 #nil) 
	#(371 1 #reduceActionFor_extern_alias_directives2:) 
	#(369 1 #reduceActionForextern_alias_directives1:) 
	#(330 3 #reduceActionForyield_statement2:) 
	#(365 3 #reduceActionForreturn_statement1:) 
	#(358 1 #reduceActionFornamespace_member_declaration1:) 
	#(359 1 #reduceActionForlocal_variable_declarators1:) 
	#(355 1 #reduceActionFornamespace_member_declaration1:) 
	#(358 1 #reduceActionForfor_initializer2:) 
	#(163 3 #reduceActionForgoto_statement3:) 
	#(316 1 #reduceActionFornamespace_member_declaration1:) 
	#(163 3 #reduceActionForgoto_statement1:) 
	#(317 3 #reduceActionForlabeled_statement1:) 
	#(211 1 #reduceActionFornamespace_member_declaration1:) 
	#(209 1 #reduceActionForlocal_variable_declarators1:) 
	#(222 3 #reduceActionFormember_access3:) 
	#(204 2 #reduceActionForextern_alias_directives2:) 
	#(214 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(213 1 #reduceActionForlocal_variable_declarators1:) 
	#(215 1 #reduceActionForargument1:) 
	#(546 3 #reduceActionForpointer_member_access1:) 
	#(314 3 #reduceActionForassignment1:) 
	#(283 3 #reduceActionForimplicit_anonymous_function_signature1:) 
	#(282 3 #reduceActionForexplicit_anonymous_function_signature1:) 
	#(266 3 #reduceActionFormultiplicative_expression2:) 
	#(267 3 #reduceActionFormultiplicative_expression2:) 
	#(268 3 #reduceActionFormultiplicative_expression2:) 
	#(269 3 #reduceActionFormultiplicative_expression2:) 
	#(270 3 #reduceActionFormultiplicative_expression2:) 
	#(271 3 #reduceActionFormultiplicative_expression2:) 
	#(272 3 #reduceActionFormultiplicative_expression2:) 
	#(273 3 #reduceActionFormultiplicative_expression2:) 
	#(274 3 #reduceActionFormultiplicative_expression2:) 
	#(276 3 #reduceActionFormultiplicative_expression2:) 
	#(275 3 #reduceActionFormultiplicative_expression2:) 
	#(280 3 #reduceActionForlambda_expression1:) 
	#(279 1 #reduceActionFornamespace_member_declaration1:) 
	#(301 2 #reduceActionForattribute_target_specifier1:) 
	#(304 2 #reduceActionFororderby_clause1:) 
	#(306 1 #reduceActionFororderings1:) 
	#(308 0 #reduceActionFor_attribute_target_specifier1:) 
	#(297 0 #reduceActionFor_query_continuation1:) 
	#(296 1 #reduceActionForselect_or_group_clause1:) 
	#(296 1 #reduceActionForselect_or_group_clause2:) 
	#(298 2 #reduceActionForquery_body_clauses2:) 
	#(169 4 #reduceActionForextern_alias_directive1:) 
	#(173 3 #reduceActionForusing_namespace_directive1:) 
	#(519 1 #reduceActionFornamespace_member_declaration1:) 
	#(567 1 #reduceActionFor_extern_alias_directives2:) 
	#(176 1 #reduceActionForextern_alias_directives1:) 
	#(162 4 #reduceActionForcompilation_unit1:) 
	#(515 2 #reduceActionForextern_alias_directives2:) 
	#(164 3 #reduceActionForqualified_identifier2:) 
	#(166 1 #reduceActionFornamespace_member_declaration1:) 
	#(167 4 #reduceActionFornamespace_declaration1:) 
	#(522 4 #reduceActionForattribute_section1:) 
	#(530 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(526 2 #reduceActionForattribute1:) 
	#(528 1 #reduceActionFor_attribute_arguments2:) 
	#(503 0 #reduceActionFor_attribute_target_specifier1:) 
	#(423 1 #reduceActionFornamespace_member_declaration1:) 
	#(260 0 #reduceActionFor_extern_alias_directives1:) 
	#(256 2 #reduceActionForunbound_type_name1:) 
	#(258 1 #reduceActionFor_generic_dimension_specifier2:) 
	#(232 4 #reduceActionFortypeof_expression1:) 
	#(252 3 #reduceActionForanonymous_object_initializer1:) 
	#(206 3 #reduceActionForrank_specifier1:) 
	#(208 2 #reduceActionForextern_alias_directives2:) 
	#(243 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(244 1 #reduceActionForlocal_variable_declarators1:) 
	#(247 1 #reduceActionForlocal_variable_declarators1:) 
	#(248 1 #reduceActionForelement_initializer1:) 
	#(419 1 #reduceActionFornamespace_member_declaration1:) 
	#(484 1 #reduceActionForlocal_variable_declarators1:) 
	#(483 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(234 4 #reduceActionForunchecked_expression1:) 
	#(233 4 #reduceActionForchecked_expression1:) 
	#(235 4 #reduceActionFordefault_value_expression1:) 
	#(226 4 #reduceActionForbase_access2:) 
	#(265 4 #reduceActionForcast_expression1:) 
	#(548 4 #reduceActionForsizeof_expression1:) 
	#(552 1 #reduceActionForlocal_variable_declarators1:) 
	#(368 2 #reduceActionForfinally_clause1:) 
	#(325 4 #reduceActionFortry_statement3:) 
	#(367 2 #reduceActionForextern_alias_directives2:) 
	#(370 1 #reduceActionFornamespace_member_declaration1:) 
	#(369 2 #reduceActionForextern_alias_directives2:) 
	#(330 4 #reduceActionForyield_statement1:) 
	#(356 0 #nil) 
	#(163 4 #reduceActionForgoto_statement2:) 
	#(184 4 #reduceActionForqualified_alias_member1:) 
	#(210 3 #reduceActionFortype_argument_list1:) 
	#(174 4 #reduceActionFornamespace_or_type_name2:) 
	#(224 4 #reduceActionForelement_access1:) 
	#(547 4 #reduceActionForpointer_element_access1:) 
	#(222 4 #reduceActionFormember_access1:) 
	#(215 2 #reduceActionForargument2:) 
	#(212 1 #reduceActionFornamespace_member_declaration1:) 
	#(215 2 #reduceActionForargument3:) 
	#(223 4 #reduceActionForinvocation_expression1:) 
	#(336 3 #reduceActionForlocal_variable_declarators2:) 
	#(339 1 #reduceActionFornamespace_member_declaration1:) 
	#(337 3 #reduceActionForlocal_variable_declarator2:) 
	#(285 3 #reduceActionForlocal_variable_declarators2:) 
	#(286 3 #reduceActionForexplicit_anonymous_function_paramenter1:) 
	#(291 3 #reduceActionForlocal_variable_declarators2:) 
	#(309 1 #reduceActionForordering_direction1:) 
	#(309 1 #reduceActionForordering_direction2:) 
	#(307 2 #reduceActionForordering1:) 
	#(308 1 #reduceActionFor_attribute_target_specifier2:) 
	#(310 2 #reduceActionForattribute_target_specifier1:) 
	#(293 3 #reduceActionForquery_body1:) 
	#(297 1 #reduceActionFor_query_continuation2:) 
	#(517 2 #reduceActionForattribute_target_specifier1:) 
	#(176 2 #reduceActionForextern_alias_directives2:) 
	#(522 5 #reduceActionForattribute_section2:) 
	#(518 3 #reduceActionForlocal_variable_declarators2:) 
	#(530 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(531 1 #reduceActionForlocal_variable_declarators1:) 
	#(533 1 #reduceActionFornamespace_member_declaration1:) 
	#(532 1 #reduceActionForlocal_variable_declarators1:) 
	#(534 1 #reduceActionFornamespace_member_declaration1:) 
	#(379 0 #nil) 
	#(503 1 #reduceActionFor_attribute_target_specifier2:) 
	#(261 1 #reduceActionForextern_alias_directives1:) 
	#(260 1 #reduceActionFor_extern_alias_directives2:) 
	#(255 3 #reduceActionFormember_declarator3:) 
	#(252 4 #reduceActionForanonymous_object_initializer2:) 
	#(254 3 #reduceActionForlocal_variable_declarators2:) 
	#(241 3 #reduceActionForobject_initializer1:) 
	#(242 3 #reduceActionForcollection_initializer1:) 
	#(239 0 #nil) 
	#(251 3 #reduceActionForarray_initializer1:) 
	#(230 5 #reduceActionFordelegate_creation_expression1:) 
	#(205 0 #reduceActionFor_extern_alias_directives1:) 
	#(238 3 #reduceActionForlocal_variable_declarators2:) 
	#(329 5 #reduceActionForusing_statement1:) 
	#(343 5 #reduceActionForif_statement1:) 
	#(341 3 #reduceActionForconst_declarator1:) 
	#(340 3 #reduceActionForlocal_variable_declarators2:) 
	#(374 0 #nil) 
	#(372 2 #reduceActionForgeneral_catch_clause1:) 
	#(346 0 #reduceActionFor_extern_alias_directives1:) 
	#(344 5 #reduceActionForswitch_statement1:) 
	#(328 5 #reduceActionForlock_statement1:) 
	#(351 5 #reduceActionForwhile_statement1:) 
	#(360 1 #reduceActionFornamespace_member_declaration1:) 
	#(356 1 #reduceActionFornamespace_member_declaration1:) 
	#(359 3 #reduceActionForlocal_variable_declarators2:) 
	#(209 3 #reduceActionForlocal_variable_declarators2:) 
	#(213 3 #reduceActionForlocal_variable_declarators2:) 
	#(292 5 #reduceActionForfrom_clause1:) 
	#(277 5 #reduceActionForconditional_expression2:) 
	#(300 4 #reduceActionForlet_clause1:) 
	#(306 3 #reduceActionFororderings2:) 
	#(172 5 #reduceActionForusing_alias_directive1:) 
	#(516 4 #reduceActionForattribute_section1:) 
	#(529 3 #reduceActionForanonymous_object_initializer1:) 
	#(380 0 #reduceActionFor_class_base1:) 
	#(379 1 #reduceActionFornamespace_member_declaration1:) 
	#(475 0 #reduceActionFor_struct_interfaces1:) 
	#(486 0 #reduceActionFor_struct_interfaces1:) 
	#(505 2 #reduceActionForattribute_target_specifier1:) 
	#(506 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(256 4 #reduceActionForunbound_type_name2:) 
	#(259 3 #reduceActionForgeneric_dimension_specifier1:) 
	#(261 2 #reduceActionForextern_alias_directives2:) 
	#(256 4 #reduceActionForunbound_type_name3:) 
	#(248 3 #reduceActionForelement_initializer2:) 
	#(246 1 #reduceActionFornamespace_member_declaration1:) 
	#(245 3 #reduceActionFormember_initializer1:) 
	#(241 4 #reduceActionForobject_initializer2:) 
	#(244 3 #reduceActionForlocal_variable_declarators2:) 
	#(242 4 #reduceActionForcollection_initializer2:) 
	#(247 3 #reduceActionForlocal_variable_declarators2:) 
	#(229 6 #reduceActionForobject_creation_expression1:) 
	#(239 1 #reduceActionFornamespace_member_declaration1:) 
	#(251 4 #reduceActionForarray_initializer2:) 
	#(484 3 #reduceActionForlocal_variable_declarators2:) 
	#(205 1 #reduceActionFor_extern_alias_directives2:) 
	#(250 0 #nil) 
	#(554 1 #reduceActionForordering_direction2:) 
	#(553 3 #reduceActionForfixed_pointer_declarator1:) 
	#(552 3 #reduceActionForlocal_variable_declarators2:) 
	#(551 6 #reduceActionForfixed_statement1:) 
	#(374 1 #reduceActionFornamespace_member_declaration1:) 
	#(346 1 #reduceActionFor_extern_alias_directives2:) 
	#(347 1 #reduceActionForextern_alias_directives1:) 
	#(349 1 #reduceActionForextern_alias_directives1:) 
	#(357 0 #nil) 
	#(311 4 #reduceActionForlet_clause1:) 
	#(312 3 #reduceActionForquery_continuation1:) 
	#(516 5 #reduceActionForattribute_section2:) 
	#(165 5 #reduceActionFornamespace_body1:) 
	#(535 3 #reduceActionFornamed_argument1:) 
	#(531 3 #reduceActionForlocal_variable_declarators2:) 
	#(532 3 #reduceActionForlocal_variable_declarators2:) 
	#(381 0 #reduceActionFor_extern_alias_directives1:) 
	#(380 1 #reduceActionFor_class_base2:) 
	#(475 1 #reduceActionFor_struct_interfaces2:) 
	#(486 1 #reduceActionFor_struct_interfaces2:) 
	#(506 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(507 1 #reduceActionForlocal_variable_declarators1:) 
	#(181 7 #reduceActionForenum_declaration1:) 
	#(425 0 #reduceActionFor_implicit_anonymous_function_parameter_list1:) 
	#(217 7 #reduceActionForarray_creation_expression1:) 
	#(250 1 #reduceActionFornamespace_member_declaration1:) 
	#(554 2 #reduceActionForattribute_target_specifier1:) 
	#(343 7 #reduceActionForif_statement2:) 
	#(350 2 #reduceActionForswitch_label2:) 
	#(345 3 #reduceActionForgeneric_dimension_specifier1:) 
	#(347 2 #reduceActionForextern_alias_directives2:) 
	#(348 2 #reduceActionForswitch_section1:) 
	#(349 2 #reduceActionForextern_alias_directives2:) 
	#(361 1 #reduceActionForfor_initializer2:) 
	#(357 1 #reduceActionFornamespace_member_declaration1:) 
	#(352 7 #reduceActionFordo_statement1:) 
	#(529 5 #reduceActionForattribute_arguments2:) 
	#(386 2 #reduceActionFortype_parameters1:) 
	#(385 3 #reduceActionFortype_parameter_list1:) 
	#(387 2 #reduceActionForclass_base1:) 
	#(388 1 #reduceActionForlocal_variable_declarators1:) 
	#(387 2 #reduceActionForclass_base2:) 
	#(381 1 #reduceActionFor_extern_alias_directives2:) 
	#(389 1 #reduceActionForextern_alias_directives1:) 
	#(479 2 #reduceActionForstruct_interfaces1:) 
	#(490 2 #reduceActionForstruct_interfaces1:) 
	#(510 2 #reduceActionForenum_member_declaration1:) 
	#(504 3 #reduceActionForanonymous_object_initializer1:) 
	#(432 0 #nil) 
	#(425 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(428 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(428 1 #reduceActionForlocal_variable_declarators1:) 
	#(429 1 #reduceActionForlocal_variable_declarators1:) 
	#(373 6 #reduceActionForspecific_catch_clause1:) 
	#(350 3 #reduceActionForswitch_label1:) 
	#(354 8 #reduceActionForforeach_statement1:) 
	#(562 5 #reduceActionForstackalloc_initializer1:) 
	#(396 0 #reduceActionFor_extern_alias_directives1:) 
	#(389 2 #reduceActionForextern_alias_directives2:) 
	#(480 0 #reduceActionFor_extern_alias_directives1:) 
	#(491 0 #reduceActionFor_extern_alias_directives1:) 
	#(504 4 #reduceActionForanonymous_object_initializer2:) 
	#(507 3 #reduceActionForlocal_variable_declarators2:) 
	#(433 1 #reduceActionFornamespace_member_declaration1:) 
	#(432 1 #reduceActionFornamespace_member_declaration1:) 
	#(353 9 #reduceActionForfor_statement1:) 
	#(386 4 #reduceActionFortype_parameters2:) 
	#(387 4 #reduceActionForclass_base3:) 
	#(388 3 #reduceActionForlocal_variable_declarators2:) 
	#(398 1 #reduceActionFornamespace_member_declaration1:) 
	#(473 0 #nil) 
	#(542 0 #nil) 
	#(434 0 #reduceActionFor_extern_alias_directives1:) 
	#(451 0 #reduceActionFor_extern_alias_directives1:) 
	#(422 0 #reduceActionFor_extern_alias_directives1:) 
	#(414 0 #reduceActionFor_field_modifiers1:) 
	#(445 0 #reduceActionFor_extern_alias_directives1:) 
	#(409 0 #reduceActionFor_extern_alias_directives1:) 
	#(464 0 #reduceActionFor_extern_alias_directives1:) 
	#(396 1 #reduceActionFor_extern_alias_directives2:) 
	#(397 1 #reduceActionForextern_alias_directives1:) 
	#(178 10 #reduceActionForclass_declaration1:) 
	#(482 1 #reduceActionFornamespace_member_declaration1:) 
	#(556 0 #reduceActionFor_extern_alias_directives1:) 
	#(480 1 #reduceActionFor_extern_alias_directives2:) 
	#(481 1 #reduceActionForextern_alias_directives1:) 
	#(179 10 #reduceActionForstruct_declaration1:) 
	#(498 0 #nil) 
	#(491 1 #reduceActionFor_extern_alias_directives2:) 
	#(492 1 #reduceActionForextern_alias_directives1:) 
	#(493 1 #reduceActionFornamespace_member_declaration1:) 
	#(180 10 #reduceActionForinterface_declaration1:) 
	#(510 4 #reduceActionForenum_member_declaration2:) 
	#(428 3 #reduceActionForlocal_variable_declarators2:) 
	#(429 3 #reduceActionForlocal_variable_declarators2:) 
	#(302 9 #reduceActionForjoin_clause1:) 
	#(392 1 #reduceActionForprimary_constraint3:) 
	#(392 1 #reduceActionForprimary_constraint2:) 
	#(393 1 #reduceActionForlocal_variable_declarators1:) 
	#(392 1 #reduceActionForprimary_constraint1:) 
	#(395 1 #reduceActionForprimary_constraint1:) 
	#(390 4 #reduceActionFortype_parameter_constraints_clause1:) 
	#(391 1 #reduceActionForlocal_variable_declarators1:) 
	#(391 1 #reduceActionFor_explicit_anonymous_function_paramenter_list2:) 
	#(417 1 #reduceActionForfield_modifier1:) 
	#(427 1 #reduceActionFornamespace_member_declaration1:) 
	#(412 1 #reduceActionFornamespace_member_declaration1:) 
	#(448 1 #reduceActionFornamespace_member_declaration1:) 
	#(437 1 #reduceActionFornamespace_member_declaration1:) 
	#(454 1 #reduceActionFornamespace_member_declaration1:) 
	#(473 1 #reduceActionFornamespace_member_declaration1:) 
	#(458 1 #reduceActionFornamespace_member_declaration1:) 
	#(468 1 #reduceActionFornamespace_member_declaration1:) 
	#(417 1 #reduceActionForfield_modifier8:) 
	#(417 1 #reduceActionForfield_modifier5:) 
	#(417 1 #reduceActionForfield_modifier6:) 
	#(417 1 #reduceActionForfield_modifier7:) 
	#(417 1 #reduceActionForfield_modifier3:) 
	#(542 1 #reduceActionFornamespace_member_declaration1:) 
	#(417 1 #reduceActionForfield_modifier9:) 
	#(417 1 #reduceActionForfield_modifier4:) 
	#(417 1 #reduceActionForfield_modifier2:) 
	#(409 1 #reduceActionFor_extern_alias_directives2:) 
	#(411 1 #reduceActionForextern_alias_directives1:) 
	#(414 1 #reduceActionFor_field_modifiers2:) 
	#(416 1 #reduceActionForfield_modifiers1:) 
	#(422 1 #reduceActionFor_extern_alias_directives2:) 
	#(426 1 #reduceActionForextern_alias_directives1:) 
	#(434 1 #reduceActionFor_extern_alias_directives2:) 
	#(436 1 #reduceActionForextern_alias_directives1:) 
	#(445 1 #reduceActionFor_extern_alias_directives2:) 
	#(447 1 #reduceActionForextern_alias_directives1:) 
	#(451 1 #reduceActionFor_extern_alias_directives2:) 
	#(453 1 #reduceActionForextern_alias_directives1:) 
	#(455 1 #reduceActionForextern_alias_directives1:) 
	#(464 1 #reduceActionFor_extern_alias_directives2:) 
	#(467 1 #reduceActionForextern_alias_directives1:) 
	#(382 3 #reduceActionForgeneric_dimension_specifier1:) 
	#(397 2 #reduceActionForextern_alias_directives2:) 
	#(421 1 #reduceActionFormethod_body2:) 
	#(401 2 #reduceActionFormethod_declaration1:) 
	#(421 1 #reduceActionFormethod_body1:) 
	#(560 1 #reduceActionFornamespace_member_declaration1:) 
	#(556 1 #reduceActionFor_extern_alias_directives2:) 
	#(559 1 #reduceActionForextern_alias_directives1:) 
	#(476 3 #reduceActionForgeneric_dimension_specifier1:) 
	#(481 2 #reduceActionForextern_alias_directives2:) 
	#(498 1 #reduceActionFornamespace_member_declaration1:) 
	#(487 3 #reduceActionForgeneric_dimension_specifier1:) 
	#(492 2 #reduceActionForextern_alias_directives2:) 
	#(430 4 #reduceActionForparameter_array1:) 
	#(431 4 #reduceActionForfixed_parameter1:) 
	#(182 11 #reduceActionFordelegate_declaration1:) 
	#(471 2 #reduceActionForstatic_constructor_modifiers2:) 
	#(411 2 #reduceActionForextern_alias_directives2:) 
	#(416 2 #reduceActionForfield_modifiers2:) 
	#(426 2 #reduceActionForextern_alias_directives2:) 
	#(436 2 #reduceActionForextern_alias_directives2:) 
	#(447 2 #reduceActionForextern_alias_directives2:) 
	#(453 2 #reduceActionForextern_alias_directives2:) 
	#(455 2 #reduceActionForextern_alias_directives2:) 
	#(456 1 #reduceActionForoperator_declarator1:) 
	#(456 1 #reduceActionForoperator_declarator2:) 
	#(456 1 #reduceActionForoperator_declarator3:) 
	#(467 2 #reduceActionForextern_alias_directives2:) 
	#(471 2 #reduceActionForstatic_constructor_modifiers1:) 
	#(559 2 #reduceActionForextern_alias_directives2:) 
	#(303 11 #reduceActionForjoin_into_clause1:) 
	#(394 3 #reduceActionForconstructor_constraint1:) 
	#(391 3 #reduceActionFortype_parameter_constraints4:) 
	#(391 3 #reduceActionFortype_parameter_constraints5:) 
	#(393 3 #reduceActionForlocal_variable_declarators2:) 
	#(391 3 #reduceActionForlocal_variable_declarators2:) 
	#(471 3 #reduceActionForstatic_constructor_modifiers7:) 
	#(418 1 #reduceActionForvariable_declarator1:) 
	#(415 1 #reduceActionForlocal_variable_declarators1:) 
	#(424 1 #reduceActionFormember_name1:) 
	#(457 1 #reduceActionFormethod_body2:) 
	#(405 4 #reduceActionForoperator_declaration1:) 
	#(457 1 #reduceActionFormethod_body1:) 
	#(466 1 #reduceActionForordering_direction2:) 
	#(406 4 #reduceActionForconstructor_declaration1:) 
	#(466 1 #reduceActionForordering_direction1:) 
	#(471 3 #reduceActionForstatic_constructor_modifiers5:) 
	#(471 3 #reduceActionForstatic_constructor_modifiers3:) 
	#(471 3 #reduceActionForstatic_constructor_modifiers6:) 
	#(557 1 #reduceActionFornamespace_member_declaration1:) 
	#(410 1 #reduceActionForlocal_variable_declarators1:) 
	#(400 5 #reduceActionForfield_declaration1:) 
	#(442 0 #reduceActionFor_extern_alias_directives1:) 
	#(439 0 #nil) 
	#(441 0 #nil) 
	#(463 1 #reduceActionFornamespace_member_declaration1:) 
	#(462 1 #reduceActionFornamespace_member_declaration1:) 
	#(558 1 #reduceActionForextern_alias_directives1:) 
	#(391 5 #reduceActionFortype_parameter_constraints7:) 
	#(399 6 #reduceActionForconstant_declaration1:) 
	#(418 3 #reduceActionForvariable_declarator2:) 
	#(415 3 #reduceActionForlocal_variable_declarators2:) 
	#(424 3 #reduceActionFormember_name2:) 
	#(403 6 #reduceActionForevent_declaration1:) 
	#(444 1 #reduceActionForextern_alias_directives1:) 
	#(442 1 #reduceActionFor_extern_alias_directives2:) 
	#(404 6 #reduceActionForindexer_declaration1:) 
	#(435 2 #reduceActionForattribute_target_specifier1:) 
	#(439 1 #reduceActionFornamespace_member_declaration1:) 
	#(441 1 #reduceActionFornamespace_member_declaration1:) 
	#(435 2 #reduceActionForaccessor_declarations2:) 
	#(469 0 #nil) 
	#(472 1 #reduceActionForordering_direction2:) 
	#(408 6 #reduceActionForstatic_constructor_declaration1:) 
	#(472 1 #reduceActionForordering_direction1:) 
	#(555 6 #reduceActionForfixed_size_buffer_declaration1:) 
	#(558 2 #reduceActionForextern_alias_directives2:) 
	#(496 6 #reduceActionForinterface_event_declaration1:) 
	#(499 1 #reduceActionForordering_direction1:) 
	#(499 1 #reduceActionForordering_direction2:) 
	#(413 3 #reduceActionForconstant_declarator1:) 
	#(410 3 #reduceActionForlocal_variable_declarators2:) 
	#(402 7 #reduceActionForproperty_declaration1:) 
	#(452 5 #reduceActionForindexer_declarator1:) 
	#(444 2 #reduceActionForaccessor_modifiers4:) 
	#(465 5 #reduceActionForconstructor_declarator1:) 
	#(469 1 #reduceActionFornamespace_member_declaration1:) 
	#(495 7 #reduceActionForinterface_property_declaration1:) 
	#(499 2 #reduceActionForattribute_target_specifier1:) 
	#(499 2 #reduceActionForaccessor_declarations2:) 
	#(403 8 #reduceActionForevent_declaration2:) 
	#(446 2 #reduceActionForattribute_target_specifier1:) 
	#(446 2 #reduceActionForaccessor_declarations2:) 
	#(443 1 #reduceActionForordering_direction2:) 
	#(438 4 #reduceActionForget_accessor_declaration1:) 
	#(443 1 #reduceActionForordering_direction1:) 
	#(440 4 #reduceActionForset_accessor_declaration1:) 
	#(407 8 #reduceActionFordestructor_declaration1:) 
	#(561 4 #reduceActionForfixed_size_buffer_declarator1:) 
	#(500 3 #reduceActionForinterface_get_accessor1:) 
	#(501 3 #reduceActionForinterface_get_accessor1:) 
	#(449 3 #reduceActionForadd_accessor_declaration1:) 
	#(450 3 #reduceActionForremove_accessor_declaration1:) 
	#(452 7 #reduceActionForindexer_declarator2:) 
	#(461 7 #reduceActionForconversion_operator_declarator2:) 
	#(461 7 #reduceActionForconversion_operator_declarator1:) 
	#(459 7 #reduceActionForunary_operator_declarator1:) 
	#(420 10 #reduceActionFormethod_header1:) 
	#(497 10 #reduceActionForinterface_indexer_declaration1:) 
	#(494 10 #reduceActionForinterface_method_declaration1:) 
	#(470 5 #reduceActionForconstructor_initializer1:) 
	#(470 5 #reduceActionForconstructor_initializer2:) 
	#(460 10 #reduceActionForbinary_operator_declarator1:)
	).!

symbolTypes
	^#(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #CSCompilationUnitNode #CSGotoStatementNode #CSQualifiedIdentifierNode #OrderedCollection #SmaCCToken #CSNamespaceDeclarationNode #OrderedCollection #CSExternAliasDirectiveNode #OrderedCollection #CSProgramNode #CSUsingAliasDirectiveNode #CSUsingNamespaceDirectiveNode #CSTypeNode #CSTypeNode #OrderedCollection #CSDeclarationNode #CSClassDeclarationNode #CSStructDeclarationNode #CSInterfaceDeclarationNode #CSEnumDeclarationNode #CSDelegateDeclarationNode #CSTypeArgumentListNode #CSQualifiedAliasMemberNode #CSTypeNode #CSTypeNode #CSTypeNode #CSTypeNode #CSTypeNode #CSTypeNameNode #CSTypeNode #CSTypeNode #CSSimpleTypeNode #CSNullableTypeNode #SmaCCToken #SmaCCToken #SmaCCToken #CSTypeNode #CSTypeNode #CSTypeNode #CSArrayTypeNode #CSTypeNode #CSTypeNode #OrderedCollection #OrderedCollection #CSRankSpecifierNode #OrderedCollection #OrderedCollection #OrderedCollection #CSTypeArgumentListNode #CSTypeNode #CSExpressionNode #OrderedCollection #OrderedCollection #CSArgumentNode #CSExpressionNode #CSArrayCreationExpressionNode #CSExpressionNode #CSLiteralExpressionNode #CSSimpleNameNode #CSExpressionNode #CSMemberAccessNode #CSInvocationExpressionNode #CSElementAccessNode #CSThisAccessNode #CSBaseAccessNode #CSPostExpressionNode #CSPostExpressionNode #CSObjectCreationExpressionNode #CSDelegateCreationExpressionNode #CSAnonymousObjectCreationExpressionNode #CSTypeofExpressionNode #CSCheckedExpressionNode #CSUncheckedExpressionNode #CSDefaultValueExpressionNode #CSAnonymousMethodExpressionNode #CSSimpleTypeNode #OrderedCollection #CSProgramNode #CSProgramNode #CSObjectInitializerNode #CSCollectionInitializerNode #OrderedCollection #OrderedCollection #CSMemberInitializerNode #CSProgramNode #OrderedCollection #CSElementInitializerNode #CSExpressionNode #CSArrayInitializerNode #CSArrayInitializerNode #OrderedCollection #OrderedCollection #OrderedCollection #CSMemberDeclaratorNode #CSUnboundTypeNameNode #CSVoidTypeNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #CSExpressionNode #CSPrefixExpressionNode #CSPrefixExpressionNode #CSCastExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSExpressionNode #CSProgramNode #CSProgramNode #CSLambdaExpressionNode #CSExplicitAnonymousFunctionSignatureNode #CSExplicitAnonymousFunctionSignatureNode #CSImplicitAnonymousFunctionSignatureNode #OrderedCollection #OrderedCollection #CSAnonymousFunctionParameterNode #SmaCCToken #SmaCCToken #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #CSQueryExpressionNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #CSExpressionNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSAssignmentNode #CSExpressionNode #CSExpressionNode #CSLabeledStatementNode #CSDeclarationStatementNode #CSStatementNode #CSEmptyStatementNode #CSExpressionStatementNode #CSStatementNode #CSStatementNode #CSStatementNode #CSTryStatementNode #CSCheckedStatementNode #CSUncheckedStatementNode #CSLockStatementNode #CSUsingStatementNode #CSYieldStatementNode #OrderedCollection #OrderedCollection #CSLocalVariableDeclarationNode #CSLocalConstantDeclarationNode #CSTypeNode #OrderedCollection #CSLocalVariableDeclaratorNode #CSSimpleNameNode #CSProgramNode #OrderedCollection #CSConstDeclaratorNode #CSExpressionNode #CSIfStatementNode #CSSwitchStatementNode #OrderedCollection #OrderedCollection #OrderedCollection #CSSwitchSectionNode #OrderedCollection #CSSwitchLabelNode #CSWhileStatementNode #CSDoStatementNode #CSForStatementNode #CSForeachStatementNode #CSProgramNode #CSExpressionNode #CSStatementListNode #CSProgramNode #OrderedCollection #CSExpressionNode #CSStatementListNode #CSBreakStatementNode #CSContinueStatementNode #CSCompilationUnitNode #CSReturnStatementNode #CSThrowStatementNode #OrderedCollection #CSFinallyClauseNode #OrderedCollection #CSGeneralCatchClauseNode #OrderedCollection #CSGeneralCatchClauseNode #CSSpecificCatchClauseNode #SmaCCToken #CSProgramNode #OrderedCollection #OrderedCollection #SmaCCToken #CSTypeParameterListNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSTypeParameterListNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #CSTypeParameterConstraintsClauseNode #OrderedCollection #CSProgramNode #OrderedCollection #CSConstructorConstraintNode #CSTypeConstraintNode #OrderedCollection #OrderedCollection #CSDeclarationNode #CSConstantDeclarationNode #CSFieldDeclarationNode #CSMethodDeclarationNode #CSPropertyDeclarationNode #CSEventDeclarationNode #CSIndexerDeclarationNode #CSOperatorDeclarationNode #CSConstructorDeclarationNode #CSDestructorDeclarationNode #CSStaticConstructorDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSConstantDeclaratorNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #CSVariableDeclaratorNode #CSProgramNode #CSMethodHeaderNode #CSMethodBodyNode #OrderedCollection #CSTypeNode #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #CSArrayParameterNode #CSFixedParameterNode #SmaCCToken #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSGetAccessorDeclarationNode #CSSetAccessorDeclarationNode #CSSetAccessorDeclarationNode #CSGetAccessorDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSAddAccessorDeclarationNode #CSRemoveAccessorDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #CSMethodBodyNode #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSConstructorInitializerNode #CSConstructorInitializerNode #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #CSDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #CSDeclarationNode #CSInterfaceMethodDeclarationNode #CSInterfacePropertyDeclarationNode #CSInterfaceEventDeclarationNode #CSInterfaceIndexerDeclarationNode #SmaCCToken #OrderedCollection #CSInterfacePropertyAccessorNode #CSInterfacePropertyAccessorNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #SmaCCToken #CSEnumDeclarationNode #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #CSAttributeNode #OrderedCollection #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #CSAttributeNode #OrderedCollection #OrderedCollection #SmaCCToken #CSAttributeValueNode #CSTypeNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #CSExpressionNode #CSExpressionNode #CSNamedArgumentNode #SmaCCToken #OrderedCollection #OrderedCollection #CSBlockStatementNode #CSExpressionNode #CSStatementNode #SmaCCToken #CSUnsafeStatementNode #CSPointerTypeNode #CSTypeNode #CSPointerMemberAccessNode #CSPointerElementAccessNode #CSSizeofExpressionNode #CSPrefixExpressionNode #CSPrefixExpressionNode #CSFixedStatementNode #OrderedCollection #CSFixedPointerDeclaratorNode #OrderedCollection #CSFixedSizeBufferDeclarationNode #OrderedCollection #CSTypeNode #OrderedCollection #OrderedCollection #SmaCCToken #CSFixedSizeBufferDeclaratorNode #CSStackallocInitializerNode #SmaCCToken #SmaCCToken #CSDeclarationNode #OrderedCollection #OrderedCollection)!

transitionTable
^#(
#[1 0 6 0 11 0 6 0 27 0 6 0 49 0 6 0 52 0 25 0 55 0 6 0 71 0 6 0 87 0 6 0 88 0 6 0 89 0 6 0 93 0 6 0 95 0 6 0 97 0 6 0 98 0 6 0 104 0 6 0 105 0 6 0 108 0 6 0 110 0 6 0 119 0 6 0 133 0 29 0 162 0 33 0 168 0 37 0 169 0 41 2 26 0 6 2 51] 
#[1 0 10 0 11 0 10 0 27 0 45 0 49 0 49 0 71 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 133 0 53 0 167 0 57 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 0 81 1 120 0 85 2 8 0 89 2 9 0 93 2 10 0 97 2 53] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 157 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 3 137 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 193 0 51 3 141 2 27] 
#[0 3 145 0 54] 
#[0 0 0 2 51] 
#[1 0 14 0 11 0 14 0 27 0 14 0 49 0 14 0 50 0 14 0 52 0 25 0 55 0 14 0 71 0 14 0 87 0 14 0 88 0 14 0 89 0 14 0 93 0 14 0 95 0 14 0 97 0 14 0 98 0 14 0 104 0 14 0 105 0 14 0 108 0 14 0 110 0 14 0 119 0 14 0 133 3 149 0 169 0 14 2 51] 
#[0 0 18 0 11 0 27 0 49 0 50 0 52 0 55 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 0 22 0 11 0 22 0 27 0 22 0 49 3 153 0 52 0 22 0 71 0 22 0 87 0 22 0 88 0 22 0 89 0 22 0 93 0 22 0 95 0 22 0 97 0 22 0 98 0 22 0 104 0 22 0 105 0 22 0 108 0 22 0 110 0 22 0 119 0 22 0 133 3 157 0 170 3 161 0 171 3 165 0 172 3 169 0 173 3 173 2 25 0 22 2 51] 
#[1 3 177 0 154 3 181 0 164] 
#[1 3 185 0 80 3 189 0 96 3 193 0 102 3 197 0 103 3 201 0 109 3 205 0 111 3 209 0 141 0 26 0 154 3 213 2 11 3 217 2 12 3 221 2 13] 
#[0 0 30 0 11 0 27 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 0 30 0 11 0 27 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 0 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 0 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 0 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 0 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 0 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[1 3 225 0 11 0 38 0 27 3 229 0 87 3 233 0 88 3 237 0 89 0 42 0 93 3 241 0 95 0 7 0 97 3 245 0 98 3 249 0 104 0 46 0 105 0 54 0 108 3 253 0 110 0 50 0 119 4 1 0 133 4 5 1 121 4 9 1 127 4 13 1 128 4 17 1 218 4 21 1 221 4 25 1 222 4 29 1 229 4 33 1 232 4 37 1 233 4 41 1 246 4 45 1 252 4 49 1 253 4 53 1 255 4 57 2 0 4 61 2 1] 
#[0 0 58 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 60 0 61 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 62 0 8 0 62 0 11 0 62 0 24 0 62 0 27 0 62 0 40 0 62 0 41 0 62 0 42 0 62 0 43 0 62 0 44 0 62 0 47 0 62 0 53 0 62 0 55 0 62 0 56 0 62 0 60 0 62 0 61 0 62 0 64 0 62 0 66 0 62 0 67 0 62 0 68 0 62 0 69 0 62 0 70 0 49 0 71 0 62 0 73 0 62 0 75 0 62 0 77 0 62 0 78 0 62 0 79 0 62 0 80 0 62 0 81 0 62 0 82 0 62 0 83 0 62 0 84 0 62 0 87 0 62 0 88 0 62 0 89 0 62 0 90 0 62 0 92 0 62 0 93 0 62 0 95 0 62 0 97 0 62 0 98 0 62 0 101 0 62 0 104 0 62 0 105 0 62 0 108 0 62 0 110 0 62 0 119 0 62 0 129 0 62 0 133 0 62 0 154 4 65 2 10] 
#[0 0 66 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 60 0 61 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 0 0 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 73 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 77 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 81 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 85 0 62] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 113 0 51 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 145 0 71 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 4 165 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 4 169 0 201 4 173 0 202 4 177 0 203 4 181 0 206 4 185 0 252 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 193 0 51 4 189 0 62 4 193 2 27] 
#[1 0 193 0 51 4 197 0 62 4 201 2 27] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 205 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 209 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 213 0 62] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 217 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 0 70 0 1 0 63 0 154] 
#[1 0 74 0 51 4 221 0 62 4 225 1 25 4 229 1 26] 
#[1 4 233 0 48 4 237 0 71] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 241 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 4 245 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 78 0 1 0 82 0 48 0 78 0 63 0 78 0 71 0 78 0 74 0 78 0 154] 
#[1 0 86 0 1 0 82 0 48 0 86 0 63 0 86 0 71 0 86 0 74 0 86 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[0 0 94 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 0 98 0 50 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 4 249 1 75 4 253 1 76 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 5 1 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 5 5 0 62] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 189 0 47 0 201 0 53 0 205 0 56 2 241 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 1 1 0 100 5 9 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 101 0 174 1 105 0 184 1 109 0 185 5 13 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 2 13 1 1 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 5 17 2 28 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 102 0 1 0 82 0 48 0 102 0 63 0 102 0 71 0 102 0 74 0 102 0 154] 
#[0 0 106 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[1 0 110 0 1 0 82 0 48 0 110 0 63 0 110 0 71 0 110 0 74 0 110 0 154] 
#[1 0 110 0 1 0 82 0 48 0 110 0 63 0 110 0 71 0 110 0 74 0 110 0 154] 
#[1 0 102 0 1 0 82 0 48 0 102 0 63 0 102 0 71 0 102 0 74 0 102 0 154] 
#[1 0 90 0 1 0 82 0 48 0 90 0 63 0 90 0 71 0 90 0 74 0 90 0 154] 
#[0 0 114 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 114 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 193 0 51 5 21 2 27] 
#[0 5 25 0 62] 
#[0 5 29 0 62] 
#[0 0 118 0 154] 
#[0 5 33 0 62] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 5 37 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 122 0 45 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 5 41 1 59 2 149 2 24 5 45 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 193 0 51 5 49 2 27] 
#[0 5 53 0 62] 
#[0 5 57 0 62] 
#[1 5 61 0 141 5 65 0 148] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 122 0 45 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 5 69 1 59 2 149 2 24 5 45 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 73 0 62] 
#[0 5 77 0 62] 
#[1 5 81 0 17 5 85 0 144 5 89 0 154] 
#[0 5 93 0 45] 
#[0 5 97 0 45] 
#[0 5 101 0 62] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 5 105 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[1 0 11 0 1 0 130 0 19 5 109 0 26 0 130 0 34 5 113 0 39 0 130 0 46 0 130 0 48 5 117 0 59 0 130 0 62 0 11 0 71 0 11 0 74 0 130 0 99 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 11 0 154 5 121 0 183 5 125 0 210] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 138 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 142 0 1 0 142 0 5 0 142 0 6 0 142 0 9 0 142 0 15 0 142 0 18 0 142 0 20 0 142 0 22 0 142 0 23 0 142 0 25 0 142 0 26 0 142 0 29 0 142 0 30 0 142 0 31 0 142 0 32 0 142 0 35 0 142 0 36 0 142 0 37 0 142 0 38 0 142 0 45 0 15 0 48 0 142 0 50 0 142 0 51 0 142 0 57 0 142 0 58 0 142 0 59 0 142 0 62 0 142 0 63 0 142 0 65 0 142 0 66 0 142 0 71 0 142 0 72 0 142 0 74 0 142 0 86 0 142 0 91 0 142 0 114 0 142 0 124 0 142 0 125 0 142 0 126 0 142 0 127 0 142 0 151 0 142 0 154 0 142 2 51] 
#[1 0 146 0 1 0 19 0 48 0 146 0 63 0 146 0 71 0 146 0 74 0 146 0 154] 
#[0 0 23 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 0 182 0 154] 
#[0 0 186 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 186 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 186 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 190 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 190 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 158 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 158 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 78 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 86 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 86 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 5 137 0 74] 
#[0 0 194 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 194 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 194 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 194 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 4 145 0 71 5 141 0 204 5 145 0 206] 
#[1 0 198 0 1 0 198 0 2 0 198 0 3 0 198 0 4 0 198 0 5 0 198 0 6 0 198 0 7 0 198 0 9 0 198 0 15 0 198 0 16 0 198 0 18 0 198 0 19 0 198 0 20 0 198 0 22 0 198 0 23 0 198 0 25 0 198 0 26 0 198 0 29 0 198 0 30 0 198 0 31 0 198 0 32 0 198 0 34 0 198 0 35 0 198 0 36 0 198 0 37 0 198 0 38 0 198 0 45 0 198 0 46 0 198 0 48 0 198 0 50 0 198 0 57 0 198 0 58 0 198 0 59 0 198 0 62 0 198 0 63 0 198 0 65 5 149 0 71 0 198 0 72 0 198 0 74 0 198 0 86 0 198 0 99 0 198 0 114 0 198 0 115 0 198 0 116 0 198 0 117 0 198 0 118 0 198 0 121 0 198 0 122 0 198 0 124 0 198 0 125 0 198 0 126 0 198 0 127 0 198 0 128 0 198 0 130 0 198 0 131 0 198 0 132 0 198 0 151 0 198 0 152 0 198 2 51] 
#[0 0 198 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 202 0 1 0 202 0 2 0 202 0 3 0 202 0 4 0 202 0 5 0 202 0 6 0 202 0 7 0 202 0 9 0 202 0 15 0 202 0 16 0 202 0 18 5 153 0 19 0 202 0 20 0 202 0 22 0 202 0 23 0 202 0 25 0 202 0 26 0 202 0 29 0 202 0 30 0 202 0 31 0 202 0 32 5 157 0 34 0 202 0 35 0 202 0 36 0 202 0 37 0 202 0 38 0 202 0 45 0 202 0 46 5 161 0 48 0 202 0 50 0 202 0 57 0 202 0 58 0 202 0 59 5 165 0 62 0 202 0 63 0 202 0 65 0 202 0 72 0 202 0 74 0 202 0 86 5 169 0 99 0 202 0 114 0 202 0 115 0 202 0 116 0 202 0 117 0 202 0 118 0 202 0 121 0 202 0 122 0 202 0 124 0 202 0 125 0 202 0 126 0 202 0 127 0 202 0 128 0 202 0 130 0 202 0 131 0 202 0 132 0 202 0 151 0 202 0 152 0 202 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 206 0 19 0 206 0 34 0 210 0 45 0 206 0 46 0 206 0 48 0 210 0 58 0 206 0 62 0 210 0 63 0 206 0 71 0 206 0 99 0 206 0 115 0 206 0 116 0 206 0 117 0 206 0 118 0 206 0 121 0 206 0 122 0 206 0 128 0 206 0 130 0 206 0 131 0 206 0 132] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 206 0 19 0 206 0 34 0 210 0 45 0 206 0 46 0 206 0 48 0 210 0 58 0 206 0 62 0 210 0 63 0 206 0 71 0 206 0 99 0 206 0 115 0 206 0 116 0 206 0 117 0 206 0 118 0 206 0 121 0 206 0 122 0 206 0 128 0 206 0 130 0 206 0 131 0 206 0 132] 
#[1 0 206 0 19 0 206 0 34 0 210 0 45 0 206 0 46 0 206 0 48 0 210 0 58 0 206 0 62 0 210 0 63 0 206 0 71 0 206 0 99 0 206 0 115 0 206 0 116 0 206 0 117 0 206 0 118 0 206 0 121 0 206 0 122 0 206 0 128 0 206 0 130 0 206 0 131 0 206 0 132] 
#[1 0 206 0 19 0 206 0 34 0 210 0 45 0 206 0 46 0 206 0 48 0 210 0 58 0 206 0 62 0 210 0 63 0 206 0 71 0 206 0 99 0 206 0 115 0 206 0 116 0 206 0 117 0 206 0 118 0 206 0 121 0 206 0 122 0 206 0 128 0 206 0 130 0 206 0 131 0 206 0 132] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 173 0 48] 
#[0 5 177 0 1] 
#[1 5 181 0 46 5 185 0 115 5 189 0 116 5 193 0 117 5 197 0 118 5 201 0 121 5 205 0 122 5 209 0 128 5 213 0 130 5 217 0 131 5 221 0 132 5 225 1 57] 
#[1 0 210 0 45 0 202 0 46 0 210 0 58 0 210 0 63 0 202 0 115 0 202 0 116 0 202 0 117 0 202 0 118 0 202 0 121 0 202 0 122 0 202 0 128 0 202 0 130 0 202 0 131 0 202 0 132] 
#[1 0 210 0 45 0 202 0 46 0 210 0 58 0 210 0 63 0 202 0 115 0 202 0 116 0 202 0 117 0 202 0 118 0 202 0 121 0 202 0 122 0 202 0 128 0 202 0 130 0 202 0 131 0 202 0 132] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 210 0 45 0 58 0 63] 
#[0 0 214 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 214 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 214 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 5 229 0 45] 
#[0 5 233 0 45] 
#[1 5 237 0 154 5 241 1 80 5 245 1 81 5 249 1 82] 
#[0 5 253 0 45] 
#[0 0 222 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 222 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 226 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 226 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 226 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 226 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 138 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 138 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 138 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 138 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 134 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 0 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 0 186 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 6 1 0 1] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 218 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 4 189 0 62] 
#[0 4 197 0 62] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 0 27 0 154 1 101 0 174 4 161 0 184 1 109 0 185 6 5 0 186 6 9 0 187 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 31 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 35 0 40 0 39 0 41 0 43 0 42 0 47 0 43 0 51 0 44 0 55 0 47 0 59 0 53 0 63 0 56 6 13 0 60 6 17 0 61 2 241 0 62 0 67 0 63 0 71 0 64 0 217 0 66 0 75 0 67 0 79 0 68 0 83 0 69 0 87 0 70 0 91 0 73 0 95 0 75 0 245 0 85 0 249 0 94 1 1 0 100 0 99 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 101 0 174 1 105 0 184 1 109 0 185 5 13 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 2 13 1 1 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 6 21 1 29 6 25 1 30 6 29 1 31 6 33 1 32 6 37 1 33 6 41 1 34 6 45 1 35 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 5 17 2 28 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 6 49 2 54] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[0 0 82 0 48] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 246 0 33 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 5 113 0 39 0 130 0 45 0 130 0 46 0 130 0 48 0 130 0 50 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 99 0 130 0 114 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 6 53 0 183 5 125 0 210 0 130 2 51] 
#[0 5 133 0 48] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 206 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 250 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[1 0 254 0 1 0 254 0 2 0 254 0 3 0 254 0 4 0 254 0 5 0 254 0 6 0 254 0 7 0 254 0 9 0 254 0 15 0 254 0 16 0 254 0 18 0 254 0 20 0 254 0 22 0 254 0 23 0 254 0 25 0 254 0 26 0 254 0 29 0 254 0 30 0 254 0 31 0 254 0 32 0 254 0 35 0 254 0 36 0 254 0 37 0 254 0 38 0 254 0 45 5 181 0 46 0 254 0 50 0 254 0 57 0 254 0 58 0 254 0 59 0 254 0 63 0 254 0 65 0 254 0 72 0 254 0 74 0 254 0 86 0 254 0 114 5 185 0 115 5 189 0 116 5 193 0 117 5 197 0 118 5 201 0 121 5 205 0 122 0 254 0 124 0 254 0 125 0 254 0 126 0 254 0 127 5 209 0 128 5 213 0 130 5 217 0 131 5 221 0 132 0 254 0 151 0 254 0 152 5 225 1 57 0 254 2 51] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 0 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 6 57 0 1 6 61 0 2 6 65 0 3 1 2 0 4 1 2 0 5 1 2 0 6 1 2 0 7 1 2 0 9 1 2 0 15 1 2 0 16 1 2 0 18 1 2 0 20 1 2 0 22 1 2 0 23 1 2 0 25 1 2 0 26 1 2 0 29 1 2 0 30 1 2 0 31 1 2 0 32 1 2 0 35 1 2 0 36 1 2 0 37 1 2 0 38 1 2 0 45 1 2 0 50 1 2 0 57 1 2 0 58 1 2 0 59 1 2 0 63 1 2 0 65 1 2 0 72 1 2 0 74 1 2 0 86 1 2 0 114 1 2 0 124 1 2 0 125 1 2 0 126 1 2 0 127 1 2 0 151 1 2 0 152 1 2 2 51] 
#[1 1 6 0 4 1 6 0 5 1 6 0 6 6 69 0 7 1 6 0 9 1 6 0 15 6 73 0 16 1 6 0 18 1 6 0 20 1 6 0 22 1 6 0 23 1 6 0 25 1 6 0 26 1 6 0 29 1 6 0 30 1 6 0 31 1 6 0 32 1 6 0 35 1 6 0 36 1 6 0 37 1 6 0 38 1 6 0 45 1 6 0 50 1 6 0 57 1 6 0 58 1 6 0 59 1 6 0 63 1 6 0 65 1 6 0 72 1 6 0 74 1 6 0 86 1 6 0 114 1 6 0 124 1 6 0 125 1 6 0 126 1 6 0 127 1 6 0 151 1 6 0 152 1 6 2 51] 
#[1 6 77 0 4 1 10 0 5 1 10 0 6 1 10 0 9 1 10 0 15 1 10 0 18 1 10 0 20 1 10 0 22 1 10 0 23 1 10 0 25 1 10 0 26 1 10 0 29 1 10 0 30 1 10 0 31 1 10 0 32 1 10 0 35 1 10 0 36 1 10 0 37 1 10 0 38 1 10 0 45 1 10 0 50 1 10 0 57 1 10 0 58 1 10 0 59 1 10 0 63 1 10 0 65 1 10 0 72 1 10 0 74 1 10 0 86 1 10 0 114 1 10 0 124 1 10 0 125 1 10 0 126 1 10 0 127 1 10 0 151 6 81 0 152 1 10 2 51] 
#[1 6 85 0 5 6 89 0 6 6 93 0 9 6 97 0 15 1 14 0 18 1 14 0 20 1 14 0 22 1 14 0 23 1 14 0 25 1 14 0 26 1 14 0 29 1 14 0 30 1 14 0 31 1 14 0 32 1 14 0 35 1 14 0 36 1 14 0 37 1 14 0 38 1 14 0 45 1 14 0 50 1 14 0 57 1 14 0 58 6 101 0 59 1 14 0 63 1 14 0 65 1 14 0 72 1 14 0 74 1 14 0 86 1 14 0 114 1 14 0 124 1 14 0 125 1 14 0 126 1 14 0 127 6 105 0 151 1 14 2 51] 
#[1 6 109 0 18 1 18 0 20 1 18 0 22 1 18 0 23 1 18 0 25 1 18 0 26 1 18 0 29 1 18 0 30 1 18 0 31 1 18 0 32 1 18 0 35 1 18 0 36 6 113 0 37 1 18 0 38 1 18 0 45 1 18 0 50 1 18 0 57 1 18 0 58 1 18 0 63 1 18 0 65 1 18 0 72 1 18 0 74 1 18 0 86 1 18 0 114 1 18 0 124 1 18 0 125 1 18 0 126 1 18 0 127 1 18 2 51] 
#[1 1 22 0 20 1 22 0 22 1 22 0 23 1 22 0 25 1 22 0 26 1 22 0 29 6 117 0 30 1 22 0 31 1 22 0 32 1 22 0 35 1 22 0 36 1 22 0 38 1 22 0 45 1 22 0 50 1 22 0 57 1 22 0 58 1 22 0 63 1 22 0 65 1 22 0 72 1 22 0 74 1 22 0 86 1 22 0 114 1 22 0 124 1 22 0 125 1 22 0 126 1 22 0 127 1 22 2 51] 
#[1 1 26 0 20 1 26 0 22 1 26 0 23 1 26 0 25 1 26 0 26 6 121 0 29 1 26 0 31 1 26 0 32 1 26 0 35 1 26 0 36 1 26 0 38 1 26 0 45 1 26 0 50 1 26 0 57 1 26 0 58 1 26 0 63 1 26 0 65 1 26 0 72 1 26 0 74 1 26 0 86 1 26 0 114 1 26 0 124 1 26 0 125 1 26 0 126 1 26 0 127 1 26 2 51] 
#[1 1 30 0 20 1 30 0 22 1 30 0 23 1 30 0 25 1 30 0 26 1 30 0 31 6 125 0 32 1 30 0 35 1 30 0 36 1 30 0 38 1 30 0 45 1 30 0 50 1 30 0 57 1 30 0 58 1 30 0 63 1 30 0 65 1 30 0 72 1 30 0 74 1 30 0 86 1 30 0 114 1 30 0 124 1 30 0 125 1 30 0 126 1 30 0 127 1 30 2 51] 
#[1 1 34 0 20 1 34 0 22 1 34 0 23 1 34 0 25 1 34 0 26 6 129 0 31 1 34 0 35 1 34 0 36 1 34 0 38 1 34 0 45 1 34 0 50 1 34 0 57 1 34 0 58 1 34 0 63 1 34 0 65 1 34 0 72 1 34 0 74 1 34 0 86 1 34 0 114 1 34 0 124 1 34 0 125 1 34 0 126 1 34 0 127 1 34 2 51] 
#[1 1 38 0 20 1 38 0 22 1 38 0 23 1 38 0 25 1 38 0 26 6 133 0 35 6 137 0 36 1 38 0 38 1 38 0 45 1 38 0 50 1 38 0 57 1 38 0 58 1 38 0 63 1 38 0 65 1 38 0 72 1 38 0 74 1 38 0 86 1 38 0 114 1 38 0 124 1 38 0 125 1 38 0 126 1 38 0 127 1 38 2 51] 
#[1 1 42 0 20 1 42 0 22 1 42 0 23 1 42 0 25 1 42 0 26 1 42 0 38 1 42 0 45 1 42 0 50 1 42 0 57 1 42 0 58 1 42 0 63 1 42 0 65 1 42 0 72 6 141 0 74 1 42 0 86 1 42 0 114 1 42 0 124 1 42 0 125 1 42 0 126 1 42 0 127 1 42 2 51] 
#[0 1 46 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 6 145 0 33] 
#[0 1 46 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 1 50 0 33] 
#[0 1 50 0 33] 
#[0 1 54 0 33] 
#[1 2 205 0 20 6 149 0 22 6 153 0 23 6 157 0 57 6 161 0 114 1 58 0 124 1 58 0 127 6 165 1 36 6 169 1 37 6 173 1 39 6 177 1 42 6 181 1 43 6 185 1 44 6 189 1 45 6 193 1 46 6 197 1 47 6 201 1 48] 
#[0 1 46 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 0 250 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 0 0 2 51] 
#[0 0 0 2 51] 
#[0 6 205 0 154] 
#[0 1 62 0 11 0 27 0 49 0 50 0 52 0 55 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 6 209 0 154 6 213 0 174 6 217 0 175 4 161 0 184] 
#[1 1 66 0 11 1 66 0 27 1 66 0 49 1 66 0 50 3 153 0 52 1 66 0 71 1 66 0 87 1 66 0 88 1 66 0 89 1 66 0 93 1 66 0 95 1 66 0 97 1 66 0 98 1 66 0 104 1 66 0 105 1 66 0 108 1 66 0 110 1 66 0 119 1 66 0 133 6 221 0 171 3 165 0 172 3 169 0 173 1 66 2 51] 
#[0 1 70 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 1 74 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 1 74 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 1 78 0 11 1 78 0 27 1 78 0 49 0 107 0 71 1 78 0 87 1 78 0 88 1 78 0 89 1 78 0 93 1 78 0 95 1 78 0 97 1 78 0 98 1 78 0 104 1 78 0 105 1 78 0 108 1 78 0 110 1 78 0 119 1 78 0 133 6 229 1 28 6 233 2 2 6 237 2 3 6 241 2 4 1 78 2 51] 
#[0 1 82 0 48 0 51] 
#[1 6 245 0 48 6 249 0 51 6 253 0 165] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[0 1 86 0 26] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 7 5 0 185 7 9 2 6 7 13 2 14 7 17 2 15] 
#[0 1 90 0 154] 
#[0 7 21 0 26] 
#[1 0 111 0 11 1 106 0 27 0 111 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 111 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 1 98 0 108 0 111 0 110 1 94 0 119 0 111 0 133] 
#[1 0 111 0 11 1 106 0 27 0 111 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 111 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 1 98 0 108 0 111 0 110 1 94 0 119 0 111 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[1 0 111 0 11 1 106 0 27 0 111 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 111 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 1 98 0 108 0 111 0 110 1 94 0 119 0 111 0 133] 
#[1 0 119 0 11 1 106 0 27 0 119 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 119 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 0 119 0 110 1 94 0 119 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[1 0 111 0 11 1 106 0 27 0 111 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 111 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 1 98 0 108 0 111 0 110 1 94 0 119 0 111 0 133] 
#[1 0 111 0 11 1 106 0 27 0 111 0 87 1 94 0 88 1 94 0 89 1 110 0 93 0 111 0 95 0 115 0 97 0 119 0 98 1 94 0 104 1 102 0 105 1 98 0 108 0 111 0 110 1 94 0 119 0 111 0 133] 
#[1 7 25 0 97 1 114 0 119 7 29 1 122] 
#[1 7 33 0 11 7 37 0 87 3 233 0 88 3 237 0 89 7 41 0 95 1 118 0 97 7 45 0 98 3 249 0 104 7 49 0 110 1 118 0 119 7 53 0 133 7 57 1 128] 
#[0 1 122 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[1 1 114 0 93 7 25 0 97 7 61 1 122] 
#[1 7 65 0 11 7 69 0 87 1 126 0 93 7 73 0 95 1 126 0 97 7 77 0 98 7 81 0 110 7 85 0 133 7 89 1 222] 
#[0 1 130 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[1 7 25 0 97 1 114 0 105 7 93 1 122] 
#[1 7 97 0 11 7 101 0 87 7 105 0 95 1 134 0 97 7 109 0 98 1 134 0 105 7 113 0 110 7 117 0 133 7 121 1 233] 
#[0 1 138 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 7 125 0 108] 
#[1 7 129 0 11 7 133 0 87 7 137 0 95 1 142 0 108 7 141 0 110 7 145 0 133 7 149 1 253] 
#[0 1 146 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 7 153 0 27] 
#[1 7 157 0 11 1 150 0 27 7 161 0 87 7 165 0 95 7 169 0 98 7 173 0 110 7 177 0 133 7 181 2 1] 
#[0 1 154 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 158 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 60 0 61 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 5 113 0 39 0 130 0 45 0 130 0 46 0 130 0 48 0 130 0 50 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 99 0 130 0 114 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 6 53 0 183 5 125 0 210 0 130 2 51] 
#[0 1 162 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 7 185 0 154 1 101 0 174 4 161 0 184 1 109 0 185 7 189 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 7 193 1 0 7 197 1 1 2 165 2 32 2 169 2 33] 
#[0 0 78 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 86 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 137 0 17 0 149 0 27 0 153 0 28 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 1 170 0 50 2 233 0 53 2 237 0 56 7 201 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 7 205 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 7 209 0 218 1 193 0 219 7 213 0 220 1 201 0 221 7 217 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 7 221 0 253 7 225 0 254 7 229 0 255 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 102 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 110 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 110 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 7 233 0 58 1 174 0 65 7 237 0 207 7 241 0 208] 
#[0 0 102 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 0 90 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 11 0 1 0 11 0 5 0 11 0 6 0 11 0 9 0 11 0 15 0 11 0 18 0 11 0 20 0 11 0 22 0 11 0 23 0 11 0 25 0 11 0 26 0 11 0 29 0 11 0 30 0 11 0 31 0 11 0 32 0 11 0 35 0 11 0 36 0 11 0 37 0 11 0 38 5 113 0 39 0 11 0 45 0 130 0 48 0 11 0 50 0 11 0 51 0 11 0 57 0 11 0 58 0 123 0 59 0 11 0 62 0 11 0 63 0 11 0 65 0 11 0 66 0 11 0 71 0 11 0 72 0 11 0 74 0 11 0 86 0 11 0 91 0 11 0 114 0 11 0 124 0 11 0 125 0 11 0 126 0 11 0 127 0 11 0 151 0 11 0 154 7 245 0 183 5 125 0 210 0 11 2 51] 
#[0 0 146 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 170 0 1 7 249 0 51 7 253 0 62 0 174 0 71 0 178 0 74 8 1 0 240 8 5 0 241 8 9 0 242] 
#[1 0 194 0 1 0 127 0 51 0 194 0 62 0 194 0 71 0 194 0 74 8 17 0 251] 
#[1 0 194 0 1 0 194 0 51 0 131 0 62 0 194 0 71 0 194 0 74] 
#[1 8 25 0 71 5 141 0 204 5 145 0 206] 
#[1 8 13 0 51 8 29 0 251] 
#[0 1 178 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 1 182 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 37 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 1 186 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 1 166 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 41 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 1 190 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 234 0 24 0 234 0 40 0 234 0 41 0 234 0 42 0 234 0 43 0 234 0 44 0 234 0 47 0 234 0 53 0 234 0 56 6 13 0 60 6 17 0 61 0 242 0 63 0 234 0 64 0 234 0 67 0 234 0 68 0 234 0 69 0 234 0 70 0 234 0 73 0 234 0 75 0 234 0 154 6 21 1 29 6 25 1 30 6 29 1 31 6 33 1 32 6 49 2 54] 
#[1 0 193 0 51 8 45 2 27] 
#[0 1 194 0 51] 
#[0 8 49 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 8 53 0 238 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 57 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 1 198 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 1 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 8 61 0 50] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 1 206 0 50 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 8 65 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 1 210 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 189 0 47 0 201 0 53 0 205 0 56 2 241 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 1 1 0 100 1 9 0 120 5 9 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 2 13 1 1 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 8 69 1 77 2 101 1 79 8 73 1 119 2 149 2 24 8 77 2 28 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 11 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 246 0 33 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 5 113 0 39 0 130 0 46 0 130 0 48 0 246 0 58 0 103 0 59 0 130 0 62 0 135 0 63 0 11 0 71 0 11 0 74 0 130 0 99 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 0 11 0 154 5 121 0 183 5 125 0 210] 
#[1 0 170 0 1 8 81 0 63 0 174 0 71 0 178 0 74] 
#[0 8 85 0 63] 
#[0 1 214 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 89 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 8 93 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 89 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 8 97 2 32 2 169 2 33] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 8 101 1 49 3 133 1 58 2 149 2 24 8 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 8 109 0 154 8 113 1 84 8 117 1 85] 
#[0 8 121 0 45] 
#[0 1 218 0 45] 
#[1 8 125 0 137 0 139 0 140 8 133 1 111 8 137 1 112 8 141 1 113 8 145 1 115 8 149 1 117] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 153 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 157 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 161 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 8 165 0 45] 
#[0 8 169 0 45] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 8 173 1 49 3 133 1 58 2 149 2 24 8 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 1 226 0 45 0 189 0 47 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 1 1 0 100 1 9 0 120 8 177 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 8 181 1 77 2 101 1 79 8 185 1 86 8 189 1 99 8 193 1 102 8 197 1 103 2 149 2 24 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 8 201 0 45] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 8 205 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 8 213 0 45] 
#[0 1 230 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 1 234 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 1 9 0 120 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 8 217 1 79 2 165 2 32 2 169 2 33] 
#[0 8 221 0 143] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 8 225 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 8 229 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 233 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 8 237 0 209 8 241 0 211 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 143 0 1 1 242 0 2 1 242 0 3 1 242 0 4 1 242 0 5 1 242 0 6 1 242 0 7 1 242 0 9 1 242 0 15 1 242 0 16 1 242 0 18 1 242 0 19 1 242 0 29 1 242 0 30 1 242 0 31 1 242 0 32 1 242 0 34 1 242 0 35 1 242 0 36 1 242 0 37 1 242 0 46 0 143 0 48 1 242 0 59 1 242 0 62 0 143 0 63 0 143 0 71 0 143 0 74 1 242 0 99 1 242 0 115 1 242 0 116 1 242 0 117 1 242 0 118 1 242 0 121 1 242 0 122 1 242 0 128 1 242 0 130 1 242 0 131 1 242 0 132 1 242 0 151 1 242 0 152 1 238 0 154] 
#[0 1 246 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 0 154 2 51] 
#[0 8 245 0 154] 
#[0 8 249 0 154] 
#[0 1 250 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 1 254 0 1 1 254 0 5 1 254 0 6 1 254 0 9 1 254 0 15 1 254 0 18 1 254 0 20 1 254 0 22 1 254 0 23 1 254 0 25 1 254 0 26 1 254 0 29 1 254 0 30 1 254 0 31 1 254 0 32 1 254 0 35 1 254 0 36 1 254 0 37 1 254 0 38 1 254 0 45 1 254 0 50 1 254 0 51 1 254 0 57 1 254 0 58 1 254 0 59 1 254 0 62 1 254 0 63 1 254 0 65 1 254 0 66 0 147 0 71 1 254 0 72 1 254 0 74 1 254 0 86 1 254 0 91 1 254 0 114 1 254 0 124 1 254 0 125 1 254 0 126 1 254 0 127 1 254 0 151 1 254 0 154 8 253 0 206 1 254 2 51] 
#[0 2 2 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 0 154 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 1 0 238 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 5 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 6 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 2 10 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 9 9 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 9 13 0 60 9 17 0 61 2 241 0 62 2 14 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 9 21 0 213 9 25 0 214 9 29 0 215 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 9 37 0 154] 
#[0 9 41 0 154] 
#[0 2 18 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 22 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 20 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 100 0 154 0 155 0 156 0 157 0 158 0 159] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 45 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 26 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 2 26 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 2 30 0 45 0 46 0 58 0 63] 
#[1 2 34 0 45 9 49 0 58 2 34 0 63] 
#[0 2 38 0 45 0 58 0 63] 
#[1 2 42 0 45 9 53 0 46 2 42 0 58 2 42 0 63] 
#[0 2 46 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 2 18 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 2 50 0 154] 
#[0 9 57 0 154] 
#[0 2 54 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[0 2 54 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[1 9 61 0 58 2 58 0 63] 
#[0 2 62 0 58 0 63] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 9 65 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 2 66 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[0 9 69 0 63] 
#[1 1 54 0 33 2 70 0 58 2 70 0 63] 
#[1 9 73 0 58 2 74 0 63] 
#[0 9 77 0 63] 
#[0 1 242 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 81 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 85 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 89 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 9 97 1 10 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 9 101 1 10 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 9 105 1 11 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 9 109 1 11 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 9 113 1 12 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 9 117 1 12 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 9 121 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 9 125 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 9 129 1 12 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 9 133 1 12 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 9 137 1 13 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 9 141 1 13 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 9 145 1 14 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 9 149 1 15 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 9 153 1 16 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 9 157 1 17 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 9 161 1 20 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 9 165 1 18 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 169 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 0 193 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 9 173 1 23 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 177 2 27 9 181 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 9 185 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 9 189 1 49 3 133 1 58 2 149 2 24 8 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 0 27 0 154 1 101 0 174 4 161 0 184 1 109 0 185 6 5 0 186 9 193 0 187 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 9 197 1 50 9 201 1 51 3 133 1 58 2 149 2 24 9 205 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 78 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 82 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[1 9 209 0 124 9 213 0 127 9 217 1 40 9 221 1 54 9 225 1 55] 
#[1 2 205 0 20 6 149 0 22 6 153 0 23 6 157 0 57 6 161 0 114 2 86 0 124 2 86 0 127 6 165 1 36 9 229 1 43 6 185 1 44 6 189 1 45 6 193 1 46 6 197 1 47 6 201 1 48] 
#[0 2 90 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 94 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 98 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 102 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 106 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 2 110 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 9 233 0 45] 
#[1 5 113 0 39 0 130 0 45 9 237 0 46 0 130 0 48 5 117 0 59 7 245 0 183 5 125 0 210] 
#[1 2 114 0 45 5 129 0 48] 
#[0 9 241 0 45] 
#[0 2 118 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 9 245 0 107 9 249 0 112 9 253 2 5 10 1 2 7] 
#[1 0 10 0 11 0 10 0 27 0 45 0 49 0 49 0 71 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 133 0 53 0 167 10 5 0 176 0 57 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 0 81 1 120 0 85 2 8 0 89 2 9 0 93 2 10 2 122 2 51 10 9 2 53 10 13 2 55] 
#[0 2 126 0 11 0 27 0 49 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 2 130 0 11 2 130 0 27 2 130 0 49 0 151 0 71 2 130 0 87 2 130 0 88 2 130 0 89 2 130 0 93 2 130 0 95 2 130 0 97 2 130 0 98 2 130 0 104 2 130 0 105 2 130 0 108 2 130 0 110 2 130 0 119 2 130 0 133 10 17 2 4 2 130 2 51] 
#[0 2 134 0 11 0 27 0 49 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 10 21 0 154] 
#[1 0 6 0 11 0 6 0 27 0 6 0 49 0 6 0 50 0 6 0 52 0 25 0 55 0 6 0 71 0 6 0 87 0 6 0 88 0 6 0 89 0 6 0 93 0 6 0 95 0 6 0 97 0 6 0 98 0 6 0 104 0 6 0 105 0 6 0 108 0 6 0 110 0 6 0 119 0 6 0 133 0 33 0 168 0 37 0 169 10 25 2 26] 
#[1 2 138 0 11 2 138 0 27 10 29 0 45 2 138 0 49 2 138 0 50 2 138 0 71 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 93 2 138 0 95 2 138 0 97 2 138 0 98 2 138 0 104 2 138 0 105 2 138 0 108 2 138 0 110 2 138 0 119 2 138 0 133 10 33 0 166 2 138 2 51] 
#[1 0 130 0 23 5 113 0 39 0 130 0 45 0 130 0 48 0 130 0 51 0 130 0 58 5 117 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 154 7 245 0 183 5 125 0 210] 
#[0 2 142 0 58 0 62 0 65] 
#[1 10 37 0 58 10 41 0 65] 
#[0 2 146 0 58 0 65] 
#[1 2 150 0 58 10 45 0 62 2 150 0 65 10 49 2 16 10 53 2 17] 
#[0 2 154 0 154] 
#[0 2 158 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 93 0 105 0 119 0 154] 
#[0 10 57 0 119] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 1 94 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 2 162 0 11 0 87 0 88 0 89 0 95 0 97 0 98 0 104 0 110 0 119 0 133] 
#[0 10 61 0 93] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 1 110 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 2 166 0 11 0 87 0 93 0 95 0 97 0 98 0 110 0 133] 
#[0 10 65 0 105] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 1 102 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 2 170 0 11 0 87 0 95 0 97 0 98 0 105 0 110 0 133] 
#[0 10 69 0 154] 
#[0 1 98 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 1 98 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 1 98 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 1 98 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 1 98 0 11 0 87 0 95 0 108 0 110 0 133] 
#[0 2 174 0 11 0 87 0 95 0 108 0 110 0 133] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 10 73 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 10 77 1 1 10 81 1 167 2 165 2 32 2 169 2 33] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 1 106 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[0 2 178 0 11 0 27 0 87 0 95 0 98 0 110 0 133] 
#[1 0 11 0 1 10 85 0 39 0 155 0 48 10 89 0 59 0 159 0 63 0 11 0 71 0 11 0 74 7 245 0 183 5 125 0 210 10 93 1 2 10 97 1 3] 
#[1 0 170 0 1 10 101 0 63 0 174 0 71 0 178 0 74] 
#[1 10 105 0 48 10 109 0 63] 
#[1 5 177 0 1 10 113 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 5 17 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 130 0 19 0 130 0 34 5 113 0 39 10 117 0 46 0 130 0 48 0 130 0 50 0 130 0 58 5 117 0 59 0 130 0 62 0 130 0 71 0 130 0 99 6 53 0 183 5 125 0 210] 
#[1 5 153 0 19 5 157 0 34 5 161 0 48 5 165 0 62 5 169 0 99] 
#[1 0 206 0 19 0 206 0 34 0 206 0 48 2 186 0 50 2 186 0 58 0 206 0 62 0 206 0 71 0 206 0 99] 
#[1 0 206 0 19 0 206 0 34 0 206 0 48 2 190 0 50 2 190 0 58 0 206 0 62 0 206 0 71 0 206 0 99] 
#[0 10 121 0 50] 
#[1 2 194 0 50 10 125 0 58] 
#[0 2 198 0 50 0 58] 
#[0 2 202 0 58 0 65] 
#[0 10 129 0 65] 
#[1 10 133 0 58 2 206 0 65] 
#[0 1 238 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 210 0 50 10 137 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 10 141 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 10 145 0 243 10 149 0 244 10 153 0 245 10 157 0 247 10 161 0 248 10 165 0 249 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 9 13 0 60 9 17 0 61 2 241 0 62 2 14 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 9 21 0 213 10 169 0 214 9 29 0 215 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 214 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 2 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 2 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 222 0 50 8 13 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 10 173 0 251 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 10 177 1 163 10 181 1 227 10 185 1 228 2 149 2 24 10 189 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 226 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 10 193 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 7 233 0 58 2 241 0 62 2 245 0 64 1 174 0 65 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 7 237 0 207 7 241 0 208 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 10 197 0 238 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 57 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 2 230 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 10 201 0 63] 
#[0 10 205 0 63] 
#[1 0 170 0 1 10 209 0 63 0 174 0 71 0 178 0 74] 
#[0 2 234 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 2 238 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 10 213 0 58 10 217 0 65] 
#[0 2 242 0 50 0 58 0 65] 
#[0 2 246 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 8 0 9 0 10 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 22 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 40 0 41 0 42 0 43 0 44 0 45 0 46 0 47 0 48 0 50 0 51 0 52 0 53 0 55 0 56 0 57 0 58 0 59 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 85 0 86 0 87 0 88 0 89 0 90 0 92 0 93 0 94 0 95 0 97 0 98 0 99 0 100 0 101 0 104 0 105 0 108 0 110 0 114 0 115 0 116 0 117 0 118 0 119 0 120 0 121 0 122 0 123 0 124 0 125 0 126 0 127 0 128 0 129 0 130 0 131 0 132 0 133 0 134 0 135 0 136 0 137 0 138 0 139 0 140 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 151 0 152 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 2 250 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 2 254 0 63] 
#[0 10 221 0 63] 
#[0 2 254 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 10 225 1 6 3 49 1 7 3 53 1 8 2 29 1 9 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 3 2 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 170 0 1 0 170 0 63 0 163 0 71 0 178 0 74] 
#[1 6 1 0 1 10 229 0 63] 
#[1 0 186 0 1 0 186 0 71 0 186 0 74 10 233 0 154 10 237 2 40 10 241 2 41] 
#[0 10 245 0 63] 
#[0 3 6 0 20 0 22 0 23 0 45 0 57 0 63 0 114 0 124 0 127] 
#[0 10 249 0 46] 
#[1 3 10 0 45 10 253 0 58] 
#[0 3 14 0 45 0 58] 
#[0 3 18 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 193 0 51 11 1 2 27] 
#[0 11 5 0 62] 
#[1 3 22 0 1 3 22 0 7 3 22 0 8 3 22 0 10 3 22 0 11 3 22 0 12 3 22 0 13 3 22 0 14 3 22 0 16 3 22 0 17 3 22 0 19 3 22 0 24 3 22 0 27 3 22 0 28 3 22 0 30 3 22 0 34 3 22 0 40 3 22 0 41 3 22 0 42 3 22 0 43 3 22 0 44 3 22 0 45 3 22 0 47 3 22 0 50 3 22 0 51 3 22 0 52 3 22 0 53 3 22 0 56 3 22 0 62 3 22 0 64 3 22 0 66 3 22 0 67 3 22 0 68 3 22 0 69 3 22 0 70 3 22 0 73 3 22 0 75 3 22 0 85 3 22 0 94 3 22 0 98 3 22 0 100 3 22 0 101 3 22 0 120 3 22 0 123 3 22 0 129 3 22 0 134 3 22 0 135 3 22 0 136 8 125 0 137 3 22 0 138 3 22 0 139 3 22 0 141 3 22 0 142 3 22 0 143 3 22 0 144 3 22 0 145 3 22 0 146 3 22 0 147 3 22 0 148 3 22 0 149 3 22 0 150 3 22 0 154 3 22 0 155 3 22 0 156 3 22 0 157 3 22 0 158 3 22 0 159 11 9 1 112 3 22 2 51] 
#[0 3 26 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 3 30 0 1 3 30 0 7 3 30 0 8 3 30 0 10 3 30 0 11 3 30 0 12 3 30 0 13 3 30 0 14 3 30 0 16 3 30 0 17 3 30 0 19 3 30 0 24 3 30 0 27 3 30 0 28 3 30 0 30 3 30 0 34 3 30 0 40 3 30 0 41 3 30 0 42 3 30 0 43 3 30 0 44 3 30 0 45 3 30 0 47 3 30 0 50 3 30 0 51 3 30 0 52 3 30 0 53 3 30 0 56 3 30 0 62 3 30 0 64 3 30 0 66 3 30 0 67 3 30 0 68 3 30 0 69 3 30 0 70 3 30 0 73 3 30 0 75 3 30 0 85 3 30 0 94 3 30 0 98 3 30 0 100 3 30 0 101 3 30 0 120 3 30 0 123 3 30 0 129 3 30 0 134 3 30 0 135 3 30 0 136 3 30 0 137 3 30 0 138 3 30 0 139 0 167 0 140 3 30 0 141 3 30 0 142 3 30 0 143 3 30 0 144 3 30 0 145 3 30 0 146 3 30 0 147 3 30 0 148 3 30 0 149 3 30 0 150 3 30 0 154 3 30 0 155 3 30 0 156 3 30 0 157 3 30 0 158 3 30 0 159 11 17 1 114 11 21 1 116 11 25 1 117 3 30 2 51] 
#[1 11 29 0 140 11 33 1 116] 
#[0 3 38 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 140 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 11 37 0 63] 
#[0 11 41 0 63] 
#[0 11 45 0 45] 
#[0 3 42 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 3 46 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 11 49 0 63] 
#[1 0 11 0 1 0 130 0 19 0 130 0 34 5 113 0 39 0 130 0 46 0 130 0 48 5 117 0 59 0 130 0 62 0 11 0 71 0 11 0 74 0 130 0 99 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 11 0 154 5 121 0 183 5 125 0 210] 
#[0 3 50 0 45] 
#[0 3 54 0 45 0 58 0 63] 
#[0 11 53 0 45] 
#[0 3 58 0 45] 
#[1 3 62 0 45 11 57 0 58] 
#[0 3 66 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 11 61 0 45] 
#[0 3 70 0 26 0 45 0 50 0 58 0 65] 
#[0 3 74 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 11 65 0 154] 
#[0 11 69 0 62] 
#[0 3 78 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 130 0 1 0 130 0 5 0 130 0 6 0 130 0 9 0 130 0 15 0 130 0 18 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 0 130 0 45 0 130 0 48 0 130 0 50 0 130 0 51 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 66 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 91 0 130 0 114 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 151 0 130 0 154 11 73 0 183 5 125 0 210 0 130 2 51] 
#[1 0 170 0 1 3 82 0 58 0 174 0 71 0 178 0 74 3 82 0 151] 
#[1 11 77 0 58 11 81 0 151] 
#[0 3 86 0 58 0 151] 
#[1 0 130 0 1 0 130 0 5 0 130 0 6 0 130 0 9 0 130 0 15 0 130 0 18 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 0 130 0 45 0 130 0 48 0 130 0 50 0 130 0 51 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 66 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 91 0 130 0 114 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 151 0 130 0 154 11 85 0 183 5 125 0 210 0 130 2 51] 
#[0 3 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 3 94 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 0 154 2 51] 
#[1 10 213 0 58 11 89 0 65] 
#[1 2 242 0 58 0 171 0 65] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 0 130 0 45 0 130 0 46 0 130 0 48 0 130 0 50 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 99 0 130 0 114 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 11 97 0 183 5 125 0 210 0 130 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 11 101 0 212 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 11 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 11 109 0 212 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 11 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 11 113 0 58 3 98 0 63] 
#[0 11 117 0 63] 
#[0 3 102 0 58 0 63] 
#[0 3 106 0 58 0 63] 
#[0 3 110 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 20 0 130 0 22 0 130 0 23 0 130 0 25 0 130 0 26 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 0 130 0 38 0 130 0 45 0 130 0 46 0 130 0 48 0 130 0 50 0 130 0 57 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 65 0 130 0 71 0 130 0 72 0 130 0 74 0 130 0 86 0 130 0 99 0 130 0 114 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 124 0 130 0 125 0 130 0 126 0 130 0 127 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 11 121 0 183 5 125 0 210 0 130 2 51] 
#[0 3 114 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[1 5 237 0 154 11 125 1 81 5 249 1 82] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 8 13 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 11 129 0 76 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 11 133 0 251 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 11 137 1 83 2 149 2 24 11 141 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 11 145 2 50] 
#[0 11 149 0 21] 
#[1 0 234 0 24 0 234 0 40 0 234 0 41 0 234 0 42 0 234 0 43 0 234 0 44 0 234 0 47 0 234 0 53 0 234 0 56 6 13 0 60 6 17 0 61 0 234 0 64 0 234 0 67 0 234 0 68 0 234 0 69 0 234 0 70 0 234 0 73 0 234 0 75 0 234 0 154 11 153 1 30 6 29 1 31 6 33 1 32] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 11 157 0 154] 
#[0 3 118 0 33] 
#[1 11 161 0 154 11 165 1 34] 
#[0 3 122 0 33 0 51] 
#[0 3 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 124 0 125 0 126 0 127 0 151 0 152 2 51] 
#[0 3 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 124 0 125 0 126 0 127 0 151 0 152 2 51] 
#[0 3 126 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 124 0 125 0 126 0 127 0 151 0 152 2 51] 
#[0 0 254 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 124 0 125 0 126 0 127 0 151 0 152 2 51] 
#[1 6 57 0 1 6 61 0 2 6 65 0 3 3 130 0 4 3 130 0 5 3 130 0 6 3 130 0 7 3 130 0 9 3 130 0 15 3 130 0 16 3 130 0 18 3 130 0 20 3 130 0 22 3 130 0 23 3 130 0 25 3 130 0 26 3 130 0 29 3 130 0 30 3 130 0 31 3 130 0 32 3 130 0 35 3 130 0 36 3 130 0 37 3 130 0 38 3 130 0 45 3 130 0 50 3 130 0 57 3 130 0 58 3 130 0 59 3 130 0 63 3 130 0 65 3 130 0 72 3 130 0 74 3 130 0 86 3 130 0 114 3 130 0 124 3 130 0 125 3 130 0 126 3 130 0 127 3 130 0 151 3 130 0 152 3 130 2 51] 
#[1 6 57 0 1 6 61 0 2 6 65 0 3 3 130 0 4 3 130 0 5 3 130 0 6 3 130 0 7 3 130 0 9 3 130 0 15 3 130 0 16 3 130 0 18 3 130 0 20 3 130 0 22 3 130 0 23 3 130 0 25 3 130 0 26 3 130 0 29 3 130 0 30 3 130 0 31 3 130 0 32 3 130 0 35 3 130 0 36 3 130 0 37 3 130 0 38 3 130 0 45 3 130 0 50 3 130 0 57 3 130 0 58 3 130 0 59 3 130 0 63 3 130 0 65 3 130 0 72 3 130 0 74 3 130 0 86 3 130 0 114 3 130 0 124 3 130 0 125 3 130 0 126 3 130 0 127 3 130 0 151 3 130 0 152 3 130 2 51] 
#[1 3 134 0 4 3 134 0 5 3 134 0 6 6 69 0 7 3 134 0 9 3 134 0 15 6 73 0 16 3 134 0 18 3 134 0 20 3 134 0 22 3 134 0 23 3 134 0 25 3 134 0 26 3 134 0 29 3 134 0 30 3 134 0 31 3 134 0 32 3 134 0 35 3 134 0 36 3 134 0 37 3 134 0 38 3 134 0 45 3 134 0 50 3 134 0 57 3 134 0 58 3 134 0 59 3 134 0 63 3 134 0 65 3 134 0 72 3 134 0 74 3 134 0 86 3 134 0 114 3 134 0 124 3 134 0 125 3 134 0 126 3 134 0 127 3 134 0 151 3 134 0 152 3 134 2 51] 
#[1 3 134 0 4 3 134 0 5 3 134 0 6 6 69 0 7 3 134 0 9 3 134 0 15 6 73 0 16 3 134 0 18 3 134 0 20 3 134 0 22 3 134 0 23 3 134 0 25 3 134 0 26 3 134 0 29 3 134 0 30 3 134 0 31 3 134 0 32 3 134 0 35 3 134 0 36 3 134 0 37 3 134 0 38 3 134 0 45 3 134 0 50 3 134 0 57 3 134 0 58 3 134 0 59 3 134 0 63 3 134 0 65 3 134 0 72 3 134 0 74 3 134 0 86 3 134 0 114 3 134 0 124 3 134 0 125 3 134 0 126 3 134 0 127 3 134 0 151 3 134 0 152 3 134 2 51] 
#[1 6 77 0 4 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 3 138 0 72 3 138 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 6 81 0 152 3 138 2 51] 
#[1 6 77 0 4 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 3 138 0 72 3 138 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 6 81 0 152 3 138 2 51] 
#[1 0 170 0 1 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 0 174 0 71 3 138 0 72 0 175 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 3 138 2 51] 
#[1 0 170 0 1 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 0 174 0 71 3 138 0 72 0 175 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 3 138 2 51] 
#[1 6 77 0 4 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 3 138 0 72 3 138 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 6 81 0 152 3 138 2 51] 
#[1 6 77 0 4 3 138 0 5 3 138 0 6 3 138 0 9 3 138 0 15 3 138 0 18 3 138 0 20 3 138 0 22 3 138 0 23 3 138 0 25 3 138 0 26 3 138 0 29 3 138 0 30 3 138 0 31 3 138 0 32 3 138 0 35 3 138 0 36 3 138 0 37 3 138 0 38 3 138 0 45 3 138 0 50 3 138 0 57 3 138 0 58 3 138 0 59 3 138 0 63 3 138 0 65 3 138 0 72 3 138 0 74 3 138 0 86 3 138 0 114 3 138 0 124 3 138 0 125 3 138 0 126 3 138 0 127 3 138 0 151 6 81 0 152 3 138 2 51] 
#[1 6 85 0 5 6 89 0 6 6 93 0 9 6 97 0 15 3 142 0 18 3 142 0 20 3 142 0 22 3 142 0 23 3 142 0 25 3 142 0 26 3 142 0 29 3 142 0 30 3 142 0 31 3 142 0 32 3 142 0 35 3 142 0 36 3 142 0 37 3 142 0 38 3 142 0 45 3 142 0 50 3 142 0 57 3 142 0 58 6 101 0 59 3 142 0 63 3 142 0 65 3 142 0 72 3 142 0 74 3 142 0 86 3 142 0 114 3 142 0 124 3 142 0 125 3 142 0 126 3 142 0 127 6 105 0 151 3 142 2 51] 
#[1 6 85 0 5 6 89 0 6 6 93 0 9 6 97 0 15 3 142 0 18 3 142 0 20 3 142 0 22 3 142 0 23 3 142 0 25 3 142 0 26 3 142 0 29 3 142 0 30 3 142 0 31 3 142 0 32 3 142 0 35 3 142 0 36 3 142 0 37 3 142 0 38 3 142 0 45 3 142 0 50 3 142 0 57 3 142 0 58 6 101 0 59 3 142 0 63 3 142 0 65 3 142 0 72 3 142 0 74 3 142 0 86 3 142 0 114 3 142 0 124 3 142 0 125 3 142 0 126 3 142 0 127 6 105 0 151 3 142 2 51] 
#[1 6 109 0 18 3 146 0 20 3 146 0 22 3 146 0 23 3 146 0 25 3 146 0 26 3 146 0 29 3 146 0 30 3 146 0 31 3 146 0 32 3 146 0 35 3 146 0 36 6 113 0 37 3 146 0 38 3 146 0 45 3 146 0 50 3 146 0 57 3 146 0 58 3 146 0 63 3 146 0 65 3 146 0 72 3 146 0 74 3 146 0 86 3 146 0 114 3 146 0 124 3 146 0 125 3 146 0 126 3 146 0 127 3 146 2 51] 
#[1 3 150 0 20 3 150 0 22 3 150 0 23 3 150 0 25 3 150 0 26 3 150 0 29 6 117 0 30 3 150 0 31 3 150 0 32 3 150 0 35 3 150 0 36 3 150 0 38 3 150 0 45 3 150 0 50 3 150 0 57 3 150 0 58 3 150 0 63 3 150 0 65 3 150 0 72 3 150 0 74 3 150 0 86 3 150 0 114 3 150 0 124 3 150 0 125 3 150 0 126 3 150 0 127 3 150 2 51] 
#[1 3 154 0 20 3 154 0 22 3 154 0 23 3 154 0 25 3 154 0 26 6 121 0 29 3 154 0 31 3 154 0 32 3 154 0 35 3 154 0 36 3 154 0 38 3 154 0 45 3 154 0 50 3 154 0 57 3 154 0 58 3 154 0 63 3 154 0 65 3 154 0 72 3 154 0 74 3 154 0 86 3 154 0 114 3 154 0 124 3 154 0 125 3 154 0 126 3 154 0 127 3 154 2 51] 
#[1 3 158 0 20 3 158 0 22 3 158 0 23 3 158 0 25 3 158 0 26 3 158 0 31 6 125 0 32 3 158 0 35 3 158 0 36 3 158 0 38 3 158 0 45 3 158 0 50 3 158 0 57 3 158 0 58 3 158 0 63 3 158 0 65 3 158 0 72 3 158 0 74 3 158 0 86 3 158 0 114 3 158 0 124 3 158 0 125 3 158 0 126 3 158 0 127 3 158 2 51] 
#[0 3 162 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 74 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[1 3 166 0 20 3 166 0 22 3 166 0 23 3 166 0 25 3 166 0 26 6 129 0 31 3 166 0 35 3 166 0 36 3 166 0 38 3 166 0 45 3 166 0 50 3 166 0 57 3 166 0 58 3 166 0 63 3 166 0 65 3 166 0 72 3 166 0 74 3 166 0 86 3 166 0 114 3 166 0 124 3 166 0 125 3 166 0 126 3 166 0 127 3 166 2 51] 
#[0 11 169 0 26] 
#[0 3 170 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 3 174 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 3 174 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 11 173 0 46] 
#[0 3 178 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 11 177 0 154] 
#[1 3 182 0 20 3 182 0 22 3 182 0 23 3 182 0 57 11 181 0 58 3 182 0 114 3 182 0 124 3 182 0 127] 
#[0 3 186 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[1 3 190 0 20 3 190 0 22 3 190 0 23 3 190 0 57 3 190 0 58 11 185 0 86 3 190 0 114 3 190 0 124 11 189 0 125 3 190 0 127 11 193 1 52 11 197 1 53] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 11 201 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 11 205 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 3 194 0 20 3 194 0 22 3 194 0 23 3 194 0 25 3 194 0 26 0 179 0 38 3 194 0 45 3 194 0 50 3 194 0 57 3 194 0 58 3 194 0 63 3 194 0 65 3 194 0 72 3 194 0 86 3 194 0 114 3 194 0 124 3 194 0 125 3 194 0 126 3 194 0 127 11 213 1 41 11 217 1 56 3 194 2 51] 
#[0 3 198 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 3 202 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 3 206 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 3 210 0 11 0 27 0 49 0 50 0 52 0 55 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 7 1 0 154 11 221 0 174 4 161 0 184] 
#[0 3 214 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 3 218 0 26] 
#[0 3 218 0 26] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 7 5 0 185 11 225 2 6 7 13 2 14 7 17 2 15] 
#[0 11 229 0 26] 
#[1 0 10 0 11 0 10 0 27 0 45 0 49 3 222 0 50 0 49 0 71 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 133 0 53 0 167 0 57 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 0 81 1 120 0 85 2 8 0 89 2 9 0 93 2 10 3 222 2 51 11 233 2 53] 
#[0 3 226 0 11 0 27 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 3 230 2 51] 
#[0 3 234 0 11 0 27 0 49 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 3 238 0 48 0 51] 
#[1 0 22 0 11 0 22 0 27 0 22 0 49 0 22 0 50 3 153 0 52 0 22 0 71 0 22 0 87 0 22 0 88 0 22 0 89 0 22 0 93 0 22 0 95 0 22 0 97 0 22 0 98 0 22 0 104 0 22 0 105 0 22 0 108 0 22 0 110 0 22 0 119 0 22 0 133 3 157 0 170 3 161 0 171 3 165 0 172 3 169 0 173 11 237 2 25] 
#[0 3 242 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 3 246 0 11 0 27 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 11 241 0 65 7 1 0 154 1 101 0 174 4 161 0 184 7 5 0 185 11 245 2 14 7 17 2 15] 
#[0 3 250 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 60 0 61 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 3 254 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 11 249 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 11 253 2 18 12 1 2 19 12 5 2 20 12 9 2 21 12 13 2 22 12 17 2 23 2 149 2 24 12 21 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 2 0 58 0 65] 
#[0 4 6 0 58 0 65] 
#[0 12 25 0 154] 
#[0 12 29 0 154] 
#[0 12 33 0 154] 
#[1 12 37 0 26 4 10 0 51 12 41 1 247 12 45 1 249] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 4 14 0 154] 
#[1 5 177 0 1 4 14 0 154] 
#[0 12 49 0 154] 
#[0 12 53 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 12 57 0 58 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 18 0 151 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 233 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 8 237 0 209 8 241 0 211 2 13 1 1 12 61 1 4 12 65 1 5 2 165 2 32 2 169 2 33] 
#[0 4 22 0 48 0 63] 
#[0 4 26 0 48 0 63] 
#[0 4 30 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 12 69 0 154] 
#[0 4 30 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 30 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 12 73 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 34 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 137 0 17 0 149 0 27 0 153 0 28 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 12 77 0 50 2 233 0 53 2 237 0 56 7 201 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 7 205 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 7 209 0 218 1 193 0 219 7 213 0 220 1 201 0 221 7 217 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 12 81 0 255 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36] 
#[0 4 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 0 154 2 51] 
#[0 4 42 0 58 0 65] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 12 85 0 238 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 8 57 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 246 0 33 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 5 113 0 39 12 89 0 46 0 130 0 48 0 130 0 50 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 71 0 130 0 74 0 130 0 99 0 130 0 151 0 130 0 152 6 53 0 183 5 125 0 210] 
#[0 12 93 0 50] 
#[1 4 46 0 50 12 97 0 58] 
#[0 4 50 0 50 0 58] 
#[1 12 101 0 50 12 105 0 58] 
#[0 4 54 0 50 0 58] 
#[0 4 58 0 50 0 58] 
#[0 12 109 0 63] 
#[0 4 62 0 45 0 50 0 58] 
#[0 4 66 0 50 0 58] 
#[0 12 113 0 50] 
#[1 4 70 0 50 12 117 0 58] 
#[0 4 62 0 45 0 50 0 58] 
#[0 12 121 0 63] 
#[1 10 213 0 58 12 125 0 65] 
#[0 4 74 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 78 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 82 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 12 129 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 12 133 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 4 90 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 46 0 50 0 57 0 58 0 59 0 63 0 65 0 72 0 74 0 86 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 94 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 12 137 0 46] 
#[1 12 141 0 58 12 145 0 63] 
#[0 4 98 0 58 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 12 149 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 12 153 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 8 109 0 154 12 157 1 85] 
#[0 4 102 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 4 125 0 64 4 149 0 73 7 1 0 154 1 101 0 174 4 161 0 184 12 161 0 185 12 165 0 199] 
#[0 4 106 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 193 0 51 11 5 0 62 12 169 2 27] 
#[0 4 110 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 4 114 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 4 118 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 140 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 193 0 51 12 169 2 27] 
#[0 4 110 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 12 173 0 51 12 177 1 89] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 12 181 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 4 122 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 12 185 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 4 126 0 45 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 12 189 1 49 3 133 1 58 12 193 1 100 12 197 1 104 2 149 2 24 8 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 12 201 1 86 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 130 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 12 205 0 21] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 12 209 1 49 3 133 1 58 2 149 2 24 8 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 134 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 233 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 12 213 0 211 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 4 138 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 0 154 2 51] 
#[0 4 142 0 1 0 5 0 6 0 9 0 15 0 18 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 35 0 36 0 37 0 38 0 45 0 48 0 50 0 51 0 57 0 58 0 59 0 62 0 63 0 65 0 66 0 71 0 72 0 74 0 86 0 91 0 114 0 124 0 125 0 126 0 127 0 151 0 154 2 51] 
#[0 4 146 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 150 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 154 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 158 0 58 0 63] 
#[0 4 162 0 58 0 63] 
#[0 4 166 0 58 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 9 13 0 60 9 17 0 61 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 12 217 0 215 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 170 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 154 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 4 174 0 45 0 58 0 63] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 89 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 12 221 2 33] 
#[0 4 178 0 45 0 58 0 63] 
#[0 4 182 0 45 0 58 0 63] 
#[0 4 178 0 45 0 58 0 63] 
#[0 4 178 0 45 0 58 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 12 225 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 186 0 58 0 63] 
#[0 4 190 0 58 0 63] 
#[0 0 246 0 58 0 63] 
#[0 4 194 0 58 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 12 229 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 12 233 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 12 237 0 21] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 12 241 1 51 3 133 1 58 2 149 2 24 9 205 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 4 198 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[0 4 202 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[0 4 206 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[0 4 210 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[0 4 214 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 12 245 0 126] 
#[0 12 249 0 154] 
#[0 4 218 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 4 222 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[1 12 253 0 45 5 129 0 48] 
#[1 13 1 0 58 13 5 0 65] 
#[0 4 226 0 154] 
#[0 4 230 0 11 0 27 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 0 10 0 11 0 10 0 27 0 45 0 49 2 122 0 50 0 49 0 71 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 133 0 53 0 167 10 5 0 176 0 57 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 0 81 1 120 0 85 2 8 0 89 2 9 0 93 2 10 10 9 2 53 13 9 2 55] 
#[0 4 234 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 60 0 61 0 64 0 66 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 4 238 0 58 0 65] 
#[1 0 130 0 1 0 130 0 2 0 130 0 3 0 130 0 4 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 9 0 130 0 15 0 130 0 16 0 130 0 18 0 130 0 19 0 130 0 29 0 130 0 30 0 130 0 31 0 130 0 32 0 246 0 33 0 130 0 34 0 130 0 35 0 130 0 36 0 130 0 37 5 113 0 39 0 183 0 46 0 130 0 48 0 130 0 58 0 103 0 59 0 130 0 62 0 130 0 63 0 130 0 71 0 130 0 74 0 130 0 99 0 130 0 115 0 130 0 116 0 130 0 117 0 130 0 118 0 130 0 121 0 130 0 122 0 130 0 128 0 130 0 130 0 130 0 131 0 130 0 132 0 130 0 151 0 130 0 152 6 53 0 183 5 125 0 210] 
#[0 13 17 0 63] 
#[1 13 21 0 58 4 242 0 63] 
#[1 13 25 0 58 13 29 0 63] 
#[0 4 246 0 58 0 63] 
#[0 4 250 0 58 0 63] 
#[0 4 254 0 58 0 63] 
#[0 5 2 0 58 0 63] 
#[1 5 6 0 23 5 6 0 26 5 6 0 51 13 33 0 59 13 37 1 123 13 41 1 129] 
#[1 5 6 0 23 5 6 0 26 5 6 0 51 13 33 0 59 13 45 1 123 13 41 1 129] 
#[1 5 6 0 23 5 6 0 26 5 6 0 51 13 33 0 59 13 49 1 123 13 41 1 129] 
#[1 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 129 0 67 4 133 0 68 4 153 0 75 13 53 0 196] 
#[1 13 57 0 51 13 61 1 248] 
#[0 5 10 0 51] 
#[1 13 33 0 59 5 6 0 62 13 65 1 123 13 41 1 129] 
#[1 0 130 0 1 0 155 0 48 10 89 0 59 0 155 0 63 0 130 0 71 0 130 0 74 11 73 0 183 5 125 0 210 13 69 1 2 10 97 1 3] 
#[0 5 14 0 58 0 151] 
#[0 13 73 0 151] 
#[1 13 77 0 58 5 18 0 151] 
#[1 2 182 0 48 13 81 0 59 2 182 0 63 13 85 1 2 10 97 1 3] 
#[0 5 22 0 50 0 58] 
#[0 5 26 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 30 0 50 0 58] 
#[1 13 89 0 50 10 213 0 58] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 7 249 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 13 93 0 240 8 5 0 241 8 9 0 242 13 97 0 246 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 13 101 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 34 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 13 105 0 50 13 109 0 154 13 113 0 245] 
#[0 5 38 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 13 117 0 50 10 137 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 13 121 0 248 10 165 0 249 9 93 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 5 42 0 1 5 42 0 2 5 42 0 3 5 42 0 4 5 42 0 5 5 42 0 6 5 42 0 7 5 42 0 9 5 42 0 15 5 42 0 16 5 42 0 18 5 42 0 19 5 42 0 20 5 42 0 22 5 42 0 23 5 42 0 25 5 42 0 26 5 42 0 29 5 42 0 30 5 42 0 31 5 42 0 32 5 42 0 34 5 42 0 35 5 42 0 36 5 42 0 37 5 42 0 38 5 42 0 45 5 42 0 46 5 42 0 48 5 42 0 50 7 249 0 51 5 42 0 57 5 42 0 58 5 42 0 59 5 42 0 62 5 42 0 63 5 42 0 65 5 42 0 71 5 42 0 72 5 42 0 74 5 42 0 86 5 42 0 99 5 42 0 114 5 42 0 115 5 42 0 116 5 42 0 117 5 42 0 118 5 42 0 121 5 42 0 122 5 42 0 124 5 42 0 125 5 42 0 126 5 42 0 127 5 42 0 128 5 42 0 130 5 42 0 131 5 42 0 132 5 42 0 151 5 42 0 152 13 125 0 239 13 129 0 240 8 5 0 241 8 9 0 242 5 42 2 51] 
#[0 5 46 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 13 133 0 50 8 13 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 10 173 0 251 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 13 137 1 163 2 149 2 24 10 189 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 50 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[1 5 54 0 1 5 54 0 2 5 54 0 3 5 54 0 4 5 54 0 5 5 54 0 6 5 54 0 7 5 54 0 9 5 54 0 15 5 54 0 16 5 54 0 18 5 54 0 19 5 54 0 20 5 54 0 22 5 54 0 23 5 54 0 25 5 54 0 26 5 54 0 29 5 54 0 30 5 54 0 31 5 54 0 32 5 54 0 34 5 54 0 35 5 54 0 36 5 54 0 37 5 54 0 38 5 54 0 45 5 54 0 46 5 54 0 48 5 54 0 50 5 54 0 51 5 54 0 57 5 54 0 58 5 54 0 59 5 54 0 62 5 54 0 63 5 54 0 65 4 145 0 71 5 54 0 72 5 54 0 74 5 54 0 86 5 54 0 99 5 54 0 114 5 54 0 115 5 54 0 116 5 54 0 117 5 54 0 118 5 54 0 121 5 54 0 122 5 54 0 124 5 54 0 125 5 54 0 126 5 54 0 127 5 54 0 128 5 54 0 130 5 54 0 131 5 54 0 132 5 54 0 151 5 54 0 152 13 141 0 204 13 145 0 205 5 145 0 206 5 54 2 51] 
#[0 5 58 0 50 0 58 0 65] 
#[0 5 62 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 13 149 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 13 153 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 13 157 2 42] 
#[1 10 233 0 154 13 161 2 41] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 13 165 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[1 5 66 0 1 5 66 0 7 5 66 0 8 5 66 0 10 5 66 0 11 5 66 0 12 5 66 0 13 5 66 0 14 5 66 0 16 5 66 0 17 5 66 0 19 5 66 0 24 5 66 0 27 5 66 0 28 5 66 0 30 5 66 0 34 5 66 0 40 5 66 0 41 5 66 0 42 5 66 0 43 5 66 0 44 5 66 0 45 5 66 0 47 5 66 0 50 5 66 0 51 5 66 0 52 5 66 0 53 5 66 0 56 5 66 0 62 5 66 0 64 5 66 0 66 5 66 0 67 5 66 0 68 5 66 0 69 5 66 0 70 5 66 0 73 5 66 0 75 5 66 0 85 5 66 0 94 5 66 0 98 5 66 0 100 5 66 0 101 5 66 0 120 5 66 0 123 5 66 0 129 5 66 0 134 5 66 0 135 5 66 0 136 5 66 0 138 5 66 0 139 5 66 0 141 0 187 0 142 5 66 0 143 5 66 0 144 5 66 0 145 5 66 0 146 5 66 0 147 5 66 0 148 5 66 0 149 5 66 0 150 5 66 0 154 5 66 0 155 5 66 0 156 5 66 0 157 5 66 0 158 5 66 0 159 5 66 2 51] 
#[0 5 70 0 45 0 58] 
#[0 5 74 0 45 0 58] 
#[0 0 150 0 63 0 154] 
#[1 5 78 0 63 13 173 0 154 13 177 1 118] 
#[0 5 82 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 13 181 0 17 5 86 0 50 13 185 0 144 13 189 1 90 13 193 1 91 13 197 1 92 13 201 1 93 13 205 1 94] 
#[0 5 90 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 5 94 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 5 98 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 5 102 0 45] 
#[0 13 209 0 45] 
#[0 5 106 0 45] 
#[0 5 110 0 45 0 58 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 13 213 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 13 217 0 63] 
#[0 5 114 0 58 0 151] 
#[0 5 118 0 58 0 63] 
#[1 6 1 0 1 13 221 0 71] 
#[0 5 122 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 5 126 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 5 130 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 13 225 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 134 0 20 0 22 0 23 0 57 0 58 0 114 0 124 0 127] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 13 229 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 2 205 0 20 6 149 0 22 6 153 0 23 6 157 0 57 6 161 0 114 1 58 0 124 1 58 0 127 6 165 1 36 13 233 1 37 6 173 1 39 6 177 1 42 6 181 1 43 6 185 1 44 6 189 1 45 6 193 1 46 6 197 1 47 6 201 1 48] 
#[0 5 138 0 11 0 27 0 49 0 50 0 52 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[1 13 237 0 65 7 1 0 154 1 101 0 174 4 161 0 184 7 5 0 185 11 245 2 14 7 17 2 15] 
#[0 5 142 0 11 0 27 0 49 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 13 241 0 50] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 13 245 2 22 2 149 2 24 12 21 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 146 0 58 0 65] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 11 249 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 13 249 2 20 13 253 2 21 12 13 2 22 12 17 2 23 2 149 2 24 12 21 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 14 1 0 154 14 5 2 23] 
#[0 5 146 0 58 0 65] 
#[1 0 49 0 71 0 10 0 154 14 9 1 120 14 13 1 130 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 5 150 0 23 14 17 0 26 5 150 0 51 14 21 1 124 14 25 1 131] 
#[0 5 154 0 23 0 26 0 51 0 62] 
#[1 5 158 0 23 14 29 0 26 5 158 0 51 14 33 1 219 14 37 1 223] 
#[1 5 162 0 23 14 41 0 26 5 162 0 51 14 45 1 230 14 49 1 234] 
#[0 5 166 0 51] 
#[1 5 170 0 50 0 49 0 71 0 10 0 154 14 53 1 120 14 57 1 250 14 61 1 251 14 65 1 254 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 2 138 0 8 2 138 0 11 2 138 0 24 2 138 0 27 2 138 0 40 2 138 0 41 2 138 0 42 2 138 0 43 2 138 0 44 10 29 0 45 2 138 0 47 2 138 0 49 2 138 0 50 2 138 0 53 2 138 0 55 2 138 0 56 2 138 0 64 2 138 0 67 2 138 0 68 2 138 0 69 2 138 0 70 2 138 0 71 2 138 0 73 2 138 0 75 2 138 0 80 2 138 0 83 2 138 0 84 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 90 2 138 0 92 2 138 0 93 2 138 0 95 2 138 0 97 2 138 0 98 2 138 0 101 2 138 0 104 2 138 0 105 2 138 0 108 2 138 0 110 2 138 0 119 2 138 0 129 2 138 0 133 2 138 0 154 14 69 0 166 2 138 2 51] 
#[0 14 73 0 62] 
#[0 5 174 0 48 0 63] 
#[0 5 178 0 48 0 63] 
#[0 5 182 0 58 0 151] 
#[1 12 57 0 58 4 18 0 151 12 61 1 4 12 65 1 5] 
#[0 5 186 0 48 0 63] 
#[0 5 190 0 50 0 58] 
#[0 5 194 0 50 0 58] 
#[0 5 198 0 50 0 58] 
#[0 5 194 0 50 0 58] 
#[0 5 202 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 12 89 0 46] 
#[0 5 206 0 50 0 58] 
#[0 5 210 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 214 0 50 0 58] 
#[0 5 218 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 222 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 71 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 226 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 5 230 0 50 0 58] 
#[1 5 234 0 1 5 234 0 2 5 234 0 3 5 234 0 4 5 234 0 5 5 234 0 6 5 234 0 7 5 234 0 9 5 234 0 15 5 234 0 16 5 234 0 18 5 234 0 19 5 234 0 20 5 234 0 22 5 234 0 23 5 234 0 25 5 234 0 26 5 234 0 29 5 234 0 30 5 234 0 31 5 234 0 32 5 234 0 34 5 234 0 35 5 234 0 36 5 234 0 37 5 234 0 38 5 234 0 45 5 234 0 46 5 234 0 48 5 234 0 50 5 234 0 51 5 234 0 57 5 234 0 58 5 234 0 59 5 234 0 62 5 234 0 63 5 234 0 65 4 145 0 71 5 234 0 72 5 234 0 74 5 234 0 86 5 234 0 99 5 234 0 114 5 234 0 115 5 234 0 116 5 234 0 117 5 234 0 118 5 234 0 121 5 234 0 122 5 234 0 124 5 234 0 125 5 234 0 126 5 234 0 127 5 234 0 128 5 234 0 130 5 234 0 131 5 234 0 132 5 234 0 151 5 234 0 152 8 253 0 206 5 234 2 51] 
#[1 5 238 0 1 5 238 0 2 5 238 0 3 5 238 0 4 5 238 0 5 5 238 0 6 5 238 0 7 5 238 0 9 5 238 0 15 5 238 0 16 5 238 0 18 5 238 0 19 5 238 0 20 5 238 0 22 5 238 0 23 5 238 0 25 5 238 0 26 5 238 0 29 5 238 0 30 5 238 0 31 5 238 0 32 5 238 0 34 5 238 0 35 5 238 0 36 5 238 0 37 5 238 0 38 5 238 0 45 5 238 0 46 5 238 0 48 5 238 0 50 8 13 0 51 5 238 0 57 5 238 0 58 5 238 0 59 5 238 0 62 5 238 0 63 5 238 0 65 5 238 0 72 5 238 0 74 5 238 0 86 5 238 0 99 5 238 0 114 5 238 0 115 5 238 0 116 5 238 0 117 5 238 0 118 5 238 0 121 5 238 0 122 5 238 0 124 5 238 0 125 5 238 0 126 5 238 0 127 5 238 0 128 5 238 0 130 5 238 0 131 5 238 0 132 5 238 0 151 5 238 0 152 14 77 0 250 14 81 0 251 5 238 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 14 85 0 212 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 14 89 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 11 105 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 5 242 0 58 0 63] 
#[0 5 246 0 58 0 63] 
#[0 5 250 0 58 0 63] 
#[0 5 254 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 14 93 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 6 2 0 63] 
#[0 14 97 0 63] 
#[0 14 101 0 26] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 14 105 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 14 109 0 50] 
#[1 13 181 0 17 6 6 0 50 13 185 0 144 14 113 1 92 13 201 1 93 13 205 1 94] 
#[0 6 10 0 17 0 50 0 144] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 14 117 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 13 185 0 144 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 14 121 1 76 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 14 125 1 94 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 5 1 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 6 14 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 0 209 0 62 6 18 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 8 185 1 86 14 129 1 101 14 133 1 103 14 137 1 105 2 149 2 24 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 14 141 0 63] 
#[0 14 145 0 45] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 14 149 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 14 153 0 25] 
#[0 6 22 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 6 26 0 20 0 22 0 23 0 25 0 26 0 38 0 45 0 50 0 57 0 58 0 63 0 65 0 72 0 86 0 114 0 124 0 125 0 126 0 127 2 51] 
#[0 6 30 0 11 0 27 0 49 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 6 34 0 11 0 27 0 45 0 49 0 50 0 71 0 87 0 88 0 89 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 133 2 51] 
#[0 6 38 0 58 0 63] 
#[1 13 25 0 58 14 157 0 63] 
#[0 6 42 0 58 0 63] 
#[0 13 13 0 46] 
#[0 6 46 0 58 0 63] 
#[1 14 161 0 154 14 165 0 190] 
#[1 14 169 0 58 14 173 0 151] 
#[1 4 125 0 64 4 149 0 73 7 1 0 154 1 101 0 174 4 161 0 184 14 177 0 185 14 181 0 199 14 185 0 200 14 189 1 132] 
#[1 14 193 0 23 6 50 0 51 14 197 1 125 14 201 1 133 14 205 1 134] 
#[0 6 54 0 23 0 51] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 14 209 0 185 14 185 0 200 14 213 1 132] 
#[1 14 193 0 23 6 50 0 51 14 217 1 125 14 201 1 133 14 205 1 134] 
#[0 6 58 0 23 0 51] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 14 209 0 185 14 185 0 200 14 221 1 132] 
#[1 14 193 0 23 6 50 0 51 14 225 1 125 14 201 1 133 14 205 1 134] 
#[0 6 62 0 23 0 51] 
#[0 14 229 0 154] 
#[0 14 233 0 50] 
#[1 6 66 0 50 14 237 0 58] 
#[0 6 70 0 50 0 58] 
#[0 6 74 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 6 78 0 63 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 14 245 1 169 14 249 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 6 82 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 6 86 0 1 0 2 0 3 0 4 0 5 0 6 0 7 0 9 0 15 0 16 0 18 0 19 0 20 0 22 0 23 0 25 0 26 0 29 0 30 0 31 0 32 0 34 0 35 0 36 0 37 0 38 0 45 0 46 0 48 0 50 0 57 0 58 0 59 0 62 0 63 0 65 0 72 0 74 0 86 0 99 0 114 0 115 0 116 0 117 0 118 0 121 0 122 0 124 0 125 0 126 0 127 0 128 0 130 0 131 0 132 0 151 0 152 2 51] 
#[0 6 90 0 58 0 63] 
#[1 0 191 0 1 0 191 0 2 0 191 0 3 0 191 0 4 0 191 0 5 0 191 0 6 0 191 0 7 0 191 0 9 0 191 0 15 0 191 0 16 0 191 0 18 0 191 0 29 0 191 0 30 0 191 0 31 0 191 0 32 0 191 0 35 0 191 0 36 0 191 0 37 0 195 0 46 0 191 0 58 0 191 0 59 0 191 0 63 0 191 0 74 0 199 0 115 0 203 0 116 0 207 0 117 0 211 0 118 0 215 0 121 0 219 0 122 0 223 0 128 0 227 0 130 0 231 0 131 0 235 0 132 0 191 0 151 0 191 0 152 5 225 1 57] 
#[0 6 94 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 193 0 51 15 9 2 27] 
#[0 6 98 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 15 13 0 26] 
#[0 6 102 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 6 106 0 17 0 50 0 144] 
#[1 14 101 0 26 4 213 0 62] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 239 0 17 0 141 0 19 0 145 0 24 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 0 165 0 40 0 169 0 41 0 173 0 42 0 177 0 43 0 181 0 44 0 185 0 45 0 189 0 47 6 110 0 50 0 193 0 51 0 197 0 52 0 201 0 53 0 205 0 56 0 209 0 62 0 213 0 64 0 217 0 66 0 221 0 67 0 225 0 68 0 229 0 69 0 233 0 70 0 237 0 73 0 241 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 9 0 120 1 13 0 123 1 17 0 129 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 6 110 0 144 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 1 73 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 1 101 0 174 1 105 0 184 1 109 0 185 1 113 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 13 1 1 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 2 37 1 61 2 41 1 62 2 45 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 93 1 77 2 97 1 78 2 101 1 79 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 8 65 2 29 2 161 2 31 2 165 2 32 2 169 2 33 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 6 114 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[0 15 17 0 63] 
#[1 11 57 0 58 6 118 0 63] 
#[0 6 122 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 15 21 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 6 126 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 15 25 0 65] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 15 29 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 6 130 0 58 0 65] 
#[0 0 126 0 26 0 58 0 151] 
#[0 6 134 0 58 0 151] 
#[1 0 49 0 71 0 10 0 154 15 33 1 120 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 6 138 0 23 0 26 0 51 0 62] 
#[0 0 243 0 23 0 45 0 51 0 58] 
#[1 6 142 0 23 6 142 0 51 15 37 0 58] 
#[0 6 146 0 23 0 51 0 58] 
#[1 6 150 0 23 6 150 0 51 15 41 0 58] 
#[1 14 161 0 154 15 45 0 190] 
#[1 15 49 0 51 15 53 1 126] 
#[1 14 193 0 23 6 154 0 45 6 154 0 51 15 57 1 134] 
#[0 6 158 0 23 0 45 0 51] 
#[0 0 154 0 23 0 45 0 48 0 51 0 58] 
#[1 6 162 0 23 6 162 0 51 15 41 0 58] 
#[1 15 61 0 51 15 65 1 220] 
#[1 6 166 0 23 6 166 0 51 15 41 0 58] 
#[1 15 69 0 51 15 73 1 231] 
#[1 15 77 0 46 6 170 0 50 6 170 0 58] 
#[0 6 174 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[1 15 81 0 50 0 49 0 71 0 10 0 154 14 53 1 120 15 85 1 254 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 6 178 0 24 6 178 0 40 6 178 0 41 6 178 0 42 6 178 0 43 6 178 0 44 6 178 0 47 6 178 0 53 6 178 0 56 15 89 0 60 15 93 0 61 6 178 0 64 15 97 0 66 6 178 0 67 6 178 0 68 6 178 0 69 6 178 0 70 6 178 0 73 6 178 0 75 15 101 0 77 6 178 0 154 15 105 1 176 15 109 1 177] 
#[0 15 113 0 63] 
#[0 6 182 0 63] 
#[1 15 117 0 58 6 186 0 63 6 186 0 65] 
#[0 6 190 0 63 0 65] 
#[0 6 194 0 58 0 63 0 65] 
#[0 6 198 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 137 0 138 0 139 0 140 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 6 202 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 0 121 0 12 0 125 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 0 185 0 45 2 229 0 47 0 193 0 51 0 197 0 52 2 233 0 53 2 237 0 56 0 209 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 0 253 0 98 1 1 0 100 1 5 0 101 1 13 0 123 1 21 0 134 1 25 0 135 1 29 0 136 1 33 0 138 1 37 0 139 1 41 0 141 1 45 0 143 1 49 0 145 1 53 0 146 1 57 0 147 1 61 0 148 1 65 0 149 1 69 0 150 4 69 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 1 97 0 163 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 1 209 0 223 1 213 0 224 1 217 0 225 1 221 0 226 1 225 0 227 1 229 0 228 1 233 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 2 17 1 6 2 21 1 7 2 25 1 8 2 29 1 9 2 33 1 58 15 121 1 63 2 49 1 64 2 53 1 65 2 57 1 66 2 61 1 67 2 65 1 68 2 69 1 69 2 73 1 70 2 77 1 71 2 81 1 72 2 85 1 73 2 89 1 74 2 105 1 86 2 109 1 87 2 113 1 88 2 117 1 95 2 121 1 96 2 125 1 97 2 129 1 98 2 133 1 106 2 137 1 107 2 141 1 109 2 145 1 110 2 149 2 24 2 153 2 27 2 161 2 31 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38 2 193 2 39] 
#[0 6 206 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[0 6 210 0 45 0 58 0 63] 
#[0 15 125 0 72] 
#[1 14 161 0 154 15 129 0 190] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 14 209 0 185 14 185 0 200 15 133 1 132] 
#[1 7 1 0 154 1 101 0 174 4 161 0 184 14 209 0 185 15 137 0 200] 
#[0 15 141 0 26] 
#[1 0 10 0 8 0 10 0 11 0 10 0 24 0 10 0 27 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 6 214 0 50 0 10 0 53 0 10 0 55 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 83 0 10 0 84 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 90 0 10 0 92 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 129 0 10 0 133 0 10 0 154 15 145 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 15 149 1 120 15 153 1 140 15 157 1 141 15 161 1 142 15 165 1 143 15 169 1 144 15 173 1 145 15 177 1 146 15 181 1 147 15 185 1 148 15 189 1 149 15 193 1 150 15 197 1 151 15 201 1 152 15 205 1 164 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 2 138 0 8 2 138 0 11 2 138 0 24 2 138 0 27 2 138 0 40 2 138 0 41 2 138 0 42 2 138 0 43 2 138 0 44 10 29 0 45 2 138 0 47 2 138 0 49 2 138 0 50 2 138 0 53 2 138 0 55 2 138 0 56 2 138 0 64 2 138 0 67 2 138 0 68 2 138 0 69 2 138 0 70 2 138 0 71 2 138 0 73 2 138 0 75 2 138 0 80 2 138 0 83 2 138 0 84 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 90 2 138 0 92 2 138 0 93 2 138 0 95 2 138 0 97 2 138 0 98 2 138 0 101 2 138 0 104 2 138 0 105 2 138 0 108 2 138 0 110 2 138 0 119 2 138 0 129 2 138 0 133 2 138 0 154 15 209 0 166 2 138 2 51] 
#[0 6 218 0 23 0 45 0 51] 
#[1 0 10 0 11 0 10 0 24 0 10 0 27 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 6 222 0 50 0 10 0 53 0 10 0 55 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 83 0 10 0 84 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 90 0 10 0 92 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 101 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 129 0 10 0 133 0 10 0 154 15 213 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 15 217 1 120 15 221 1 143 15 225 1 144 15 229 1 145 15 233 1 146 15 237 1 147 15 241 1 148 15 245 1 149 15 249 1 150 15 253 1 152 15 205 1 164 16 1 1 224 16 5 1 225 16 9 1 226 0 85 2 8 0 89 2 9 0 93 2 10 16 13 2 43] 
#[1 2 138 0 8 2 138 0 11 2 138 0 24 2 138 0 27 2 138 0 40 2 138 0 41 2 138 0 42 2 138 0 43 2 138 0 44 10 29 0 45 2 138 0 47 2 138 0 49 2 138 0 50 2 138 0 53 2 138 0 55 2 138 0 56 2 138 0 64 2 138 0 67 2 138 0 68 2 138 0 69 2 138 0 70 2 138 0 71 2 138 0 73 2 138 0 75 2 138 0 80 2 138 0 83 2 138 0 84 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 90 2 138 0 92 2 138 0 93 2 138 0 95 2 138 0 97 2 138 0 98 2 138 0 101 2 138 0 104 2 138 0 105 2 138 0 108 2 138 0 110 2 138 0 119 2 138 0 129 2 138 0 133 2 138 0 154 16 17 0 166 2 138 2 51] 
#[1 0 10 0 11 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 6 226 0 50 0 10 0 53 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 154 16 21 1 120 16 25 1 235 16 29 1 236 16 33 1 237 16 37 1 238 16 41 1 239 16 45 1 240 16 49 1 241 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 2 138 0 8 2 138 0 11 2 138 0 24 2 138 0 27 2 138 0 40 2 138 0 41 2 138 0 42 2 138 0 43 2 138 0 44 10 29 0 45 2 138 0 47 2 138 0 49 2 138 0 50 2 138 0 53 2 138 0 55 2 138 0 56 2 138 0 64 2 138 0 67 2 138 0 68 2 138 0 69 2 138 0 70 2 138 0 71 2 138 0 73 2 138 0 75 2 138 0 80 2 138 0 83 2 138 0 84 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 90 2 138 0 92 2 138 0 93 2 138 0 95 2 138 0 97 2 138 0 98 2 138 0 101 2 138 0 104 2 138 0 105 2 138 0 108 2 138 0 110 2 138 0 119 2 138 0 129 2 138 0 133 2 138 0 154 16 53 0 166 2 138 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 16 57 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 6 230 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 6 234 0 50 0 58] 
#[0 6 238 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[0 6 238 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[0 6 238 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 8 89 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 16 61 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 16 65 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 6 242 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 154] 
#[1 14 193 0 23 6 50 0 45 16 69 1 125 14 201 1 133 14 205 1 134] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 16 73 1 174 16 77 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 6 246 0 1 0 7 0 8 0 10 0 11 0 12 0 13 0 14 0 16 0 17 0 19 0 24 0 27 0 28 0 30 0 34 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 50 0 51 0 52 0 53 0 56 0 62 0 64 0 66 0 67 0 68 0 69 0 70 0 73 0 75 0 85 0 94 0 98 0 100 0 101 0 120 0 123 0 129 0 134 0 135 0 136 0 138 0 139 0 141 0 142 0 143 0 144 0 145 0 146 0 147 0 148 0 149 0 150 0 154 0 155 0 156 0 157 0 158 0 159 2 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 16 81 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 6 250 0 58 0 151] 
#[1 6 254 0 23 6 254 0 51 15 41 0 58] 
#[0 7 2 0 23 0 51 0 58] 
#[1 16 85 0 11 4 125 0 64 4 149 0 73 16 89 0 93 16 93 0 119 4 157 0 154 1 101 0 174 4 161 0 184 14 177 0 185 16 97 0 190 16 101 0 199 16 105 0 200 16 109 1 135 16 113 1 136 16 117 1 137 16 121 1 138 16 125 1 139] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 247 0 8 16 129 0 11 0 251 0 24 0 38 0 27 0 251 0 40 0 251 0 41 0 251 0 42 0 251 0 43 0 251 0 44 0 251 0 47 0 251 0 53 0 255 0 55 0 251 0 56 0 251 0 64 0 251 0 67 0 251 0 68 0 251 0 69 0 251 0 70 0 251 0 73 0 251 0 75 7 34 0 80 16 137 0 83 16 141 0 84 16 145 0 87 1 3 0 88 16 153 0 89 16 157 0 90 16 161 0 92 0 42 0 93 16 165 0 95 1 7 0 97 1 11 0 98 16 173 0 104 0 46 0 105 0 54 0 108 16 177 0 110 0 50 0 119 7 38 0 129 16 181 0 133 1 15 0 154 4 5 1 121 4 9 1 127 4 13 1 128 16 185 1 153 16 189 1 155 16 193 1 156 16 197 1 158 16 201 1 160 16 205 1 161 16 209 1 166 16 213 1 170 16 217 1 171 16 221 1 178 16 225 1 180 16 229 1 181 16 233 1 189 16 237 1 191 16 241 1 192 16 245 1 195 16 249 1 197 16 253 1 198 17 1 1 199 17 5 1 202 17 9 1 208 17 13 1 211 17 17 1 212 17 21 1 215 17 25 1 217 4 17 1 218 4 21 1 221 4 25 1 222 4 29 1 229 4 33 1 232 4 37 1 233 4 41 1 246 4 45 1 252 4 49 1 253 4 53 1 255 4 57 2 0 4 61 2 1 17 29 2 30] 
#[0 17 33 0 50] 
#[1 0 10 0 8 0 10 0 11 0 10 0 24 0 10 0 27 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 7 46 0 50 0 10 0 53 0 10 0 55 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 83 0 10 0 84 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 90 0 10 0 92 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 129 0 10 0 133 0 10 0 154 15 145 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 15 149 1 120 17 37 1 142 15 165 1 143 15 169 1 144 15 173 1 145 15 177 1 146 15 181 1 147 15 185 1 148 15 189 1 149 15 193 1 150 15 197 1 151 15 201 1 152 15 205 1 164 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 7 50 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 6 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 17 41 0 45 0 193 0 51 17 45 1 165 17 49 2 27] 
#[0 7 54 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 17 53 0 11 0 251 0 24 0 38 0 27 0 251 0 40 0 251 0 41 0 251 0 42 0 251 0 43 0 251 0 44 0 251 0 47 0 251 0 53 0 255 0 55 0 251 0 56 0 251 0 64 0 251 0 67 0 251 0 68 0 251 0 69 0 251 0 70 0 251 0 73 0 251 0 75 7 34 0 80 16 137 0 83 16 141 0 84 17 57 0 87 1 3 0 88 16 153 0 89 16 157 0 90 16 161 0 92 0 42 0 93 17 61 0 95 1 7 0 97 1 19 0 98 7 62 0 101 16 173 0 104 0 46 0 105 0 54 0 108 17 69 0 110 0 50 0 119 7 38 0 129 17 73 0 133 1 15 0 154 4 5 1 121 4 9 1 127 4 13 1 128 16 185 1 153 16 189 1 155 16 193 1 156 16 197 1 158 16 201 1 160 16 205 1 161 16 209 1 166 16 213 1 170 16 217 1 171 16 221 1 178 16 225 1 180 16 229 1 181 16 233 1 189 16 237 1 191 16 241 1 192 16 245 1 195 16 249 1 197 16 253 1 198 17 1 1 199 17 5 1 202 17 9 1 208 17 13 1 211 17 17 1 212 17 21 1 215 17 77 1 217 4 17 1 218 4 21 1 221 4 25 1 222 4 29 1 229 4 33 1 232 4 37 1 233 4 41 1 246 4 45 1 252 4 49 1 253 4 53 1 255 4 57 2 0 4 61 2 1 17 81 2 30 17 85 2 44 17 89 2 47 17 93 2 48] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 17 97 0 50] 
#[1 0 10 0 11 0 10 0 24 0 10 0 27 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 7 66 0 50 0 10 0 53 0 10 0 55 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 83 0 10 0 84 0 10 0 87 0 10 0 88 0 10 0 89 0 10 0 90 0 10 0 92 0 10 0 93 0 10 0 95 0 10 0 97 0 10 0 98 0 10 0 101 0 10 0 104 0 10 0 105 0 10 0 108 0 10 0 110 0 10 0 119 0 10 0 129 0 10 0 133 0 10 0 154 15 213 0 177 0 61 0 178 0 65 0 179 0 69 0 180 0 73 0 181 0 77 0 182 15 217 1 120 15 221 1 143 15 225 1 144 15 229 1 145 15 233 1 146 15 237 1 147 15 241 1 148 15 245 1 149 15 249 1 150 15 253 1 152 15 205 1 164 17 101 1 226 0 85 2 8 0 89 2 9 0 93 2 10 16 13 2 43] 
#[0 7 70 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 7 74 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[1 17 105 0 11 7 78 0 24 7 78 0 40 7 78 0 41 7 78 0 42 7 78 0 43 7 78 0 44 7 78 0 47 7 78 0 53 7 78 0 56 7 78 0 64 7 78 0 67 7 78 0 68 7 78 0 69 7 78 0 70 7 78 0 73 7 78 0 75 7 78 0 80 7 78 0 154 17 109 1 242] 
#[0 17 113 0 50] 
#[1 0 10 0 11 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 7 82 0 50 0 10 0 53 0 10 0 56 0 10 0 64 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 80 0 10 0 154 16 21 1 120 17 117 1 237 16 37 1 238 16 41 1 239 16 45 1 240 16 49 1 241 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 7 86 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 7 90 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 7 90 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 7 90 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 7 90 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 7 94 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 7 98 0 50 0 58] 
#[1 0 194 0 1 0 194 0 71 0 194 0 74 17 121 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 17 125 0 154] 
#[0 17 129 0 45] 
#[0 7 102 0 63 0 65] 
#[0 7 106 0 58 0 63 0 65] 
#[1 7 110 0 20 7 110 0 22 7 110 0 23 17 133 0 38 7 110 0 57 7 110 0 114 7 110 0 124 7 110 0 127] 
#[0 17 137 0 62] 
#[0 7 114 0 23 0 45 0 51 0 58] 
#[0 7 118 0 23 0 45 0 51 0 58] 
#[0 7 122 0 23 0 45 0 51 0 58] 
#[0 7 126 0 23 0 45 0 51 0 58] 
#[0 7 130 0 23 0 45 0 51 0 58] 
#[0 7 134 0 23 0 45 0 51] 
#[1 7 138 0 23 7 138 0 45 7 138 0 51 17 141 0 58] 
#[1 7 142 0 23 7 142 0 45 7 142 0 51 17 145 0 58] 
#[0 7 138 0 23 0 45 0 51] 
#[0 7 122 0 23 0 45 0 51 0 58] 
#[1 1 23 0 11 1 27 0 24 1 106 0 27 1 27 0 40 1 27 0 41 1 27 0 42 1 27 0 43 1 27 0 44 1 27 0 47 1 27 0 53 1 31 0 55 1 27 0 56 1 27 0 64 1 27 0 67 1 27 0 68 1 27 0 69 1 27 0 70 1 27 0 73 1 27 0 75 7 158 0 80 7 146 0 83 1 31 0 84 1 23 0 87 1 35 0 88 1 39 0 89 1 31 0 90 7 146 0 92 1 110 0 93 1 23 0 95 1 43 0 97 1 47 0 98 1 39 0 104 1 102 0 105 1 98 0 108 1 23 0 110 1 94 0 119 7 154 0 129 1 23 0 133 1 27 0 154] 
#[1 7 170 0 8 1 31 0 11 1 51 0 24 1 51 0 40 1 51 0 41 1 51 0 42 1 51 0 43 1 51 0 44 1 51 0 47 1 51 0 53 1 55 0 55 1 51 0 56 1 51 0 64 1 51 0 67 1 51 0 68 1 51 0 69 1 51 0 70 1 51 0 73 1 51 0 75 7 158 0 80 1 31 0 84 1 59 0 87 1 63 0 88 1 31 0 89 1 31 0 90 1 59 0 95 7 150 0 97 1 67 0 98 1 31 0 104 7 174 0 106 1 59 0 110 7 174 0 113 1 55 0 133 1 71 0 154] 
#[0 7 182 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[1 1 31 0 11 1 75 0 24 1 75 0 40 1 75 0 41 1 75 0 42 1 75 0 43 1 75 0 44 1 75 0 47 1 75 0 53 1 31 0 55 1 75 0 56 1 75 0 64 1 75 0 67 1 75 0 68 1 75 0 69 1 75 0 70 1 75 0 73 1 75 0 75 7 158 0 80 1 31 0 84 1 31 0 87 1 79 0 88 1 31 0 89 1 31 0 90 1 31 0 95 7 150 0 97 1 31 0 98 1 31 0 104 1 31 0 110 1 31 0 133 1 75 0 154] 
#[1 1 83 0 11 1 87 0 24 1 106 0 27 1 87 0 40 1 87 0 41 1 87 0 42 1 87 0 43 1 87 0 44 1 87 0 47 1 87 0 53 1 59 0 55 1 87 0 56 1 87 0 64 1 87 0 67 1 87 0 68 1 87 0 69 1 87 0 70 1 87 0 73 1 87 0 75 7 158 0 80 7 186 0 83 1 31 0 84 1 91 0 87 1 95 0 88 1 39 0 89 1 31 0 90 7 186 0 92 1 110 0 93 1 91 0 95 1 43 0 97 1 99 0 98 1 39 0 104 1 102 0 105 1 98 0 108 1 91 0 110 1 94 0 119 7 154 0 129 1 91 0 133 1 103 0 154] 
#[1 1 107 0 11 1 111 0 24 1 111 0 40 1 111 0 41 1 111 0 42 1 111 0 43 1 111 0 44 1 111 0 47 1 111 0 53 1 115 0 55 1 111 0 56 1 111 0 64 1 111 0 67 1 111 0 68 1 111 0 69 1 111 0 70 1 111 0 73 1 111 0 75 7 158 0 80 7 190 0 83 1 79 0 84 1 107 0 87 1 119 0 88 1 123 0 89 1 79 0 90 7 190 0 92 1 107 0 95 1 127 0 97 1 131 0 98 1 123 0 104 7 174 0 106 1 107 0 110 7 174 0 113 1 94 0 119 1 119 0 133 1 135 0 154 17 157 1 217 17 161 2 30] 
#[1 1 39 0 11 1 75 0 24 1 75 0 40 1 75 0 41 1 75 0 42 1 75 0 43 1 75 0 44 1 75 0 47 1 75 0 53 1 31 0 55 1 75 0 56 1 75 0 64 1 75 0 67 1 75 0 68 1 75 0 69 1 75 0 70 1 75 0 73 1 75 0 75 7 158 0 80 1 31 0 84 1 39 0 87 1 123 0 88 1 39 0 89 1 31 0 90 1 39 0 95 1 127 0 97 1 39 0 98 1 39 0 104 1 39 0 110 1 94 0 119 1 39 0 133 1 75 0 154] 
#[1 1 31 0 11 1 75 0 24 1 75 0 40 1 75 0 41 1 75 0 42 1 75 0 43 1 75 0 44 1 75 0 47 1 75 0 53 1 31 0 55 1 75 0 56 1 75 0 64 1 75 0 67 1 75 0 68 1 75 0 69 1 75 0 70 1 75 0 73 1 75 0 75 7 158 0 80 1 31 0 84 1 31 0 87 1 79 0 88 1 31 0 89 1 31 0 90 1 31 0 95 7 150 0 97 1 31 0 98 1 31 0 104 1 31 0 110 1 31 0 133 1 75 0 154] 
#[0 7 194 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[1 1 139 0 11 1 143 0 24 1 106 0 27 1 143 0 40 1 143 0 41 1 143 0 42 1 143 0 43 1 143 0 44 1 143 0 47 1 143 0 53 1 59 0 55 1 143 0 56 1 143 0 64 1 143 0 67 1 143 0 68 1 143 0 69 1 143 0 70 1 143 0 73 1 143 0 75 7 158 0 80 7 198 0 83 1 31 0 84 1 147 0 87 1 151 0 88 1 39 0 89 1 31 0 90 7 198 0 92 1 110 0 93 1 147 0 95 1 43 0 97 1 155 0 98 1 39 0 104 1 102 0 105 1 98 0 108 1 147 0 110 1 94 0 119 7 154 0 129 1 147 0 133 1 159 0 154] 
#[1 7 202 0 8 1 163 0 11 1 167 0 24 1 106 0 27 1 167 0 40 1 167 0 41 1 167 0 42 1 167 0 43 1 167 0 44 1 167 0 47 1 167 0 53 1 171 0 55 1 167 0 56 1 167 0 64 1 167 0 67 1 167 0 68 1 167 0 69 1 167 0 70 1 167 0 73 1 167 0 75 7 158 0 80 7 206 0 83 1 31 0 84 1 175 0 87 1 179 0 88 1 39 0 89 1 31 0 90 7 206 0 92 1 110 0 93 1 175 0 95 1 43 0 97 1 183 0 98 1 39 0 104 1 102 0 105 7 174 0 106 1 175 0 110 7 174 0 113 1 94 0 119 1 183 0 133 1 187 0 154] 
#[1 1 39 0 11 1 75 0 24 1 75 0 40 1 75 0 41 1 75 0 42 1 75 0 43 1 75 0 44 1 75 0 47 1 75 0 53 1 31 0 55 1 75 0 56 1 75 0 64 1 75 0 67 1 75 0 68 1 75 0 69 1 75 0 70 1 75 0 73 1 75 0 75 7 158 0 80 1 31 0 84 1 39 0 87 1 123 0 88 1 39 0 89 1 31 0 90 1 39 0 95 1 127 0 97 1 39 0 98 1 39 0 104 1 39 0 110 1 94 0 119 1 39 0 133 1 75 0 154] 
#[1 1 191 0 11 1 195 0 24 1 106 0 27 1 195 0 40 1 195 0 41 1 195 0 42 1 195 0 43 1 195 0 44 1 195 0 47 1 195 0 53 1 59 0 55 1 195 0 56 1 195 0 64 1 195 0 67 1 195 0 68 1 195 0 69 1 195 0 70 1 195 0 73 1 195 0 75 7 158 0 80 7 210 0 83 1 31 0 84 1 199 0 87 1 203 0 88 1 39 0 89 1 31 0 90 7 210 0 92 1 110 0 93 1 199 0 95 1 43 0 97 1 207 0 98 1 39 0 104 1 102 0 105 1 98 0 108 1 199 0 110 1 94 0 119 7 154 0 129 1 199 0 133 1 211 0 154] 
#[1 1 215 0 11 1 219 0 24 1 106 0 27 1 219 0 40 1 219 0 41 1 219 0 42 1 219 0 43 1 219 0 44 1 219 0 47 1 219 0 53 1 55 0 55 1 219 0 56 1 219 0 64 1 219 0 67 1 219 0 68 1 219 0 69 1 219 0 70 1 219 0 73 1 219 0 75 7 158 0 80 7 214 0 83 1 31 0 84 1 223 0 87 1 227 0 88 1 39 0 89 1 31 0 90 7 214 0 92 1 110 0 93 1 223 0 95 1 43 0 97 1 231 0 98 1 39 0 104 1 102 0 105 7 174 0 106 1 98 0 108 1 223 0 110 7 174 0 113 1 94 0 119 7 154 0 129 1 235 0 133 1 239 0 154] 
#[0 17 165 0 129] 
#[1 17 169 0 11 17 173 0 87 17 177 0 95 17 181 0 110 7 218 0 129 17 185 0 133 17 189 1 156] 
#[0 7 222 0 11 0 87 0 95 0 110 0 129 0 133] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 17 193 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 17 197 0 11 7 226 0 24 7 226 0 40 7 226 0 41 7 226 0 42 7 226 0 43 7 226 0 44 7 226 0 47 7 226 0 53 7 226 0 56 7 226 0 64 7 226 0 67 7 226 0 68 7 226 0 69 7 226 0 70 7 226 0 73 7 226 0 75 16 137 0 83 17 201 0 87 17 205 0 88 16 161 0 92 17 209 0 95 17 213 0 98 17 217 0 110 17 221 0 133 7 226 0 154 17 225 1 161] 
#[0 7 230 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[1 1 114 0 24 1 114 0 40 1 114 0 41 1 114 0 42 1 114 0 43 1 114 0 44 1 114 0 47 1 114 0 53 1 114 0 56 1 114 0 64 1 114 0 67 1 114 0 68 1 114 0 69 1 114 0 70 1 114 0 73 1 114 0 75 7 25 0 97 1 114 0 154 17 229 1 122] 
#[1 17 233 0 11 7 234 0 24 7 234 0 40 7 234 0 41 7 234 0 42 7 234 0 43 7 234 0 44 7 234 0 47 7 234 0 53 17 237 0 55 7 234 0 56 7 234 0 64 7 234 0 67 7 234 0 68 7 234 0 69 7 234 0 70 7 234 0 73 7 234 0 75 17 241 0 84 17 245 0 87 17 249 0 88 17 253 0 89 18 1 0 90 18 5 0 95 7 234 0 97 18 9 0 98 18 13 0 104 18 17 0 110 18 21 0 133 7 234 0 154 18 25 1 171] 
#[0 7 238 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 18 29 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 18 33 0 11 7 242 0 24 7 242 0 40 7 242 0 41 7 242 0 42 7 242 0 43 7 242 0 44 7 242 0 47 7 242 0 53 18 37 0 55 7 242 0 56 7 242 0 64 7 242 0 67 7 242 0 68 7 242 0 69 7 242 0 70 7 242 0 73 7 242 0 75 18 41 0 84 18 45 0 87 18 49 0 88 18 53 0 89 18 57 0 90 18 61 0 95 18 65 0 98 18 69 0 104 18 73 0 110 18 77 0 133 7 242 0 154 18 81 1 181] 
#[0 7 246 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 18 85 0 80] 
#[1 18 89 0 11 18 93 0 55 7 250 0 80 18 97 0 84 18 101 0 87 18 105 0 88 18 109 0 89 18 113 0 90 18 117 0 95 18 121 0 98 18 125 0 104 18 129 0 110 18 133 0 133 18 137 1 192] 
#[0 7 254 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 18 141 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 18 145 1 196 2 165 2 32 2 169 2 33] 
#[1 18 149 0 11 8 2 0 24 8 2 0 40 8 2 0 41 8 2 0 42 8 2 0 43 8 2 0 44 8 2 0 47 8 2 0 53 18 153 0 55 8 2 0 56 8 2 0 64 8 2 0 67 8 2 0 68 8 2 0 69 8 2 0 70 8 2 0 73 8 2 0 75 18 157 0 84 18 161 0 87 18 165 0 89 18 169 0 90 18 173 0 95 18 177 0 98 18 181 0 104 18 185 0 110 18 189 0 133 8 2 0 154 18 193 1 198] 
#[0 8 6 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 18 197 0 55 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 18 201 0 88 18 205 0 98 18 209 0 106 18 213 0 113 18 217 0 133 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 18 221 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 18 225 1 200 18 229 1 202 18 233 1 203 18 237 1 204 18 241 1 205 2 165 2 32 2 169 2 33] 
#[0 8 10 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[1 18 245 0 154 18 249 1 209] 
#[1 18 253 0 55 19 1 0 87 19 5 0 95 19 9 0 98 19 13 0 110 19 17 0 133 8 14 0 154 19 21 1 212] 
#[0 8 18 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 19 25 0 154] 
#[1 7 14 0 8 1 243 0 88 17 153 0 98 19 33 2 30] 
#[1 7 10 0 8 17 149 0 55 1 247 0 88 19 41 1 217] 
#[0 8 22 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 8 26 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 30 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 34 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 38 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 1 251 0 11 1 27 0 24 1 106 0 27 1 27 0 40 1 27 0 41 1 27 0 42 1 27 0 43 1 27 0 44 1 27 0 47 1 27 0 53 1 31 0 55 1 27 0 56 1 27 0 64 1 27 0 67 1 27 0 68 1 27 0 69 1 27 0 70 1 27 0 73 1 27 0 75 7 158 0 80 7 146 0 83 1 31 0 84 1 251 0 87 1 35 0 88 1 39 0 89 1 31 0 90 7 146 0 92 1 110 0 93 1 251 0 95 1 43 0 97 1 255 0 98 8 42 0 101 1 39 0 104 1 102 0 105 1 98 0 108 1 251 0 110 1 94 0 119 7 154 0 129 1 251 0 133 1 27 0 154] 
#[1 2 3 0 11 1 87 0 24 1 106 0 27 1 87 0 40 1 87 0 41 1 87 0 42 1 87 0 43 1 87 0 44 1 87 0 47 1 87 0 53 1 59 0 55 1 87 0 56 1 87 0 64 1 87 0 67 1 87 0 68 1 87 0 69 1 87 0 70 1 87 0 73 1 87 0 75 7 158 0 80 7 186 0 83 1 31 0 84 2 7 0 87 1 95 0 88 1 39 0 89 1 31 0 90 7 186 0 92 1 110 0 93 2 7 0 95 1 43 0 97 2 11 0 98 8 42 0 101 1 39 0 104 1 102 0 105 1 98 0 108 2 7 0 110 1 94 0 119 7 154 0 129 2 7 0 133 1 103 0 154] 
#[1 2 15 0 11 1 143 0 24 1 106 0 27 1 143 0 40 1 143 0 41 1 143 0 42 1 143 0 43 1 143 0 44 1 143 0 47 1 143 0 53 1 59 0 55 1 143 0 56 1 143 0 64 1 143 0 67 1 143 0 68 1 143 0 69 1 143 0 70 1 143 0 73 1 143 0 75 7 158 0 80 7 198 0 83 1 31 0 84 2 19 0 87 1 151 0 88 1 39 0 89 1 31 0 90 7 198 0 92 1 110 0 93 2 19 0 95 1 43 0 97 2 23 0 98 8 42 0 101 1 39 0 104 1 102 0 105 1 98 0 108 2 19 0 110 1 94 0 119 7 154 0 129 2 19 0 133 1 159 0 154] 
#[1 2 27 0 11 1 167 0 24 1 106 0 27 1 167 0 40 1 167 0 41 1 167 0 42 1 167 0 43 1 167 0 44 1 167 0 47 1 167 0 53 1 171 0 55 1 167 0 56 1 167 0 64 1 167 0 67 1 167 0 68 1 167 0 69 1 167 0 70 1 167 0 73 1 167 0 75 7 158 0 80 7 206 0 83 1 31 0 84 2 31 0 87 1 179 0 88 1 39 0 89 1 31 0 90 7 206 0 92 1 110 0 93 2 31 0 95 1 43 0 97 2 35 0 98 8 42 0 101 1 39 0 104 1 102 0 105 7 174 0 106 2 31 0 110 7 174 0 113 1 94 0 119 2 35 0 133 1 187 0 154] 
#[1 2 39 0 11 1 195 0 24 1 106 0 27 1 195 0 40 1 195 0 41 1 195 0 42 1 195 0 43 1 195 0 44 1 195 0 47 1 195 0 53 1 59 0 55 1 195 0 56 1 195 0 64 1 195 0 67 1 195 0 68 1 195 0 69 1 195 0 70 1 195 0 73 1 195 0 75 7 158 0 80 7 210 0 83 1 31 0 84 2 43 0 87 1 203 0 88 1 39 0 89 1 31 0 90 7 210 0 92 1 110 0 93 2 43 0 95 1 43 0 97 2 47 0 98 8 42 0 101 1 39 0 104 1 102 0 105 1 98 0 108 2 43 0 110 1 94 0 119 7 154 0 129 2 43 0 133 1 211 0 154] 
#[1 2 51 0 11 1 219 0 24 1 106 0 27 1 219 0 40 1 219 0 41 1 219 0 42 1 219 0 43 1 219 0 44 1 219 0 47 1 219 0 53 1 55 0 55 1 219 0 56 1 219 0 64 1 219 0 67 1 219 0 68 1 219 0 69 1 219 0 70 1 219 0 73 1 219 0 75 7 158 0 80 7 214 0 83 1 31 0 84 2 55 0 87 1 227 0 88 1 39 0 89 1 31 0 90 7 214 0 92 1 110 0 93 2 55 0 95 1 43 0 97 2 59 0 98 8 42 0 101 1 39 0 104 1 102 0 105 7 174 0 106 1 98 0 108 2 55 0 110 7 174 0 113 1 94 0 119 7 154 0 129 2 63 0 133 1 239 0 154] 
#[1 1 243 0 88 17 153 0 98 19 45 2 30] 
#[1 17 149 0 55 1 247 0 88 19 49 1 217] 
#[0 19 53 0 101] 
#[1 19 57 0 11 19 61 0 87 19 65 0 95 19 69 0 98 8 46 0 101 19 73 0 110 19 77 0 133 19 81 2 48] 
#[0 8 50 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 54 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 8 58 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 62 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 80 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 19 85 0 80 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 19 89 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 10 77 1 1 19 93 1 167 2 165 2 32 2 169 2 33] 
#[0 8 66 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 45 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 8 70 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 8 74 0 63 0 65] 
#[0 8 78 0 58 0 63 0 65] 
#[0 8 82 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 49 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154 2 51] 
#[0 19 97 0 154] 
#[0 19 101 0 63] 
#[1 16 85 0 11 4 157 0 154 1 101 0 174 4 161 0 184 14 209 0 185 16 97 0 190 16 105 0 200 19 105 1 137 19 109 1 138 16 125 1 139] 
#[1 16 85 0 11 4 157 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 113 0 190 16 105 0 200 19 117 1 138 19 121 1 139] 
#[0 7 170 0 8 0 88 0 98 0 154] 
#[0 7 202 0 8 0 55 0 88 0 154] 
#[1 17 153 0 98 2 67 0 154 19 125 2 30] 
#[1 17 149 0 55 7 10 0 154 19 129 1 217] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 19 133 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 7 154 0 11 0 87 0 95 0 110 0 129 0 133] 
#[0 7 154 0 11 0 87 0 95 0 110 0 129 0 133] 
#[0 7 154 0 11 0 87 0 95 0 110 0 129 0 133] 
#[0 7 154 0 11 0 87 0 95 0 110 0 129 0 133] 
#[0 7 154 0 11 0 87 0 95 0 110 0 129 0 133] 
#[0 8 90 0 11 0 87 0 95 0 110 0 129 0 133] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 19 137 0 154 19 141 1 159 19 145 1 162] 
#[0 7 146 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 186 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 190 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 198 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 206 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 210 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 7 214 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[0 8 94 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 83 0 87 0 88 0 92 0 95 0 98 0 110 0 133 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 10 73 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 10 77 1 1 19 149 1 167 2 165 2 32 2 169 2 33] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 7 150 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[0 8 98 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 97 0 98 0 104 0 110 0 133 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 19 153 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 157 0 200 19 161 1 168] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 162 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 8 102 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 19 165 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 7 158 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[0 8 106 0 11 0 55 0 80 0 84 0 87 0 88 0 89 0 90 0 95 0 98 0 104 0 110 0 133] 
#[1 0 170 0 1 19 169 0 66 0 174 0 71 0 178 0 74 7 1 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 173 0 200] 
#[0 19 177 0 51] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 166 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 8 110 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 84 0 87 0 89 0 90 0 95 0 98 0 104 0 110 0 133 0 154] 
#[0 7 174 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[0 7 174 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[0 7 174 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[0 19 181 0 91] 
#[0 19 185 0 91] 
#[0 7 174 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 19 189 0 91] 
#[1 19 193 0 45 0 193 0 51 19 197 1 201 19 201 2 27] 
#[0 8 114 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 73 0 75 0 88 0 98 0 106 0 113 0 133 0 154] 
#[0 8 118 0 45 0 51] 
#[0 8 122 0 45 0 51] 
#[0 8 126 0 45 0 51] 
#[0 19 205 0 62] 
#[1 19 209 0 45 0 193 0 51 19 213 1 210 19 217 2 27] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 7 178 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 8 130 0 55 0 87 0 95 0 98 0 110 0 133 0 154] 
#[0 19 221 0 62] 
#[1 19 225 0 98 8 134 0 154] 
#[1 19 229 0 8 19 233 0 88] 
#[1 17 149 0 55 7 10 0 154 19 237 1 217] 
#[1 19 241 0 8 19 245 0 88] 
#[0 19 233 0 88] 
#[0 19 245 0 88] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 19 249 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33 19 253 2 45] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 42 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[0 8 138 0 11 0 87 0 95 0 98 0 101 0 110 0 133] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 20 1 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 170 0 1 20 5 0 66 0 174 0 71 0 178 0 74 2 71 0 154] 
#[0 20 13 0 154] 
#[0 8 142 0 20 0 22 0 23 0 57 0 114 0 124 0 127] 
#[0 8 146 0 23 0 45 0 51] 
#[1 8 150 0 23 8 150 0 45 8 150 0 51 20 17 0 58] 
#[0 8 154 0 23 0 45 0 51] 
#[0 8 158 0 23 0 45 0 51 0 58] 
#[0 8 162 0 23 0 45 0 51] 
#[0 8 158 0 23 0 45 0 51 0 58] 
#[0 8 166 0 154] 
#[0 8 166 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 20 21 0 154 20 25 1 154 20 29 1 157] 
#[1 8 170 0 45 20 33 0 46 8 170 0 58] 
#[1 20 37 0 45 20 41 0 58] 
#[0 8 174 0 45 0 58] 
#[1 19 153 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 157 0 200 20 45 1 168] 
#[1 5 113 0 39 0 130 0 48 8 178 0 51 2 75 0 59 8 178 0 62 7 245 0 183 5 125 0 210] 
#[0 20 49 0 48] 
#[0 20 53 0 51] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 20 57 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 157 0 200 20 61 1 159 19 145 1 162 20 65 1 168] 
#[0 20 69 0 71] 
#[0 20 73 0 48] 
#[1 0 49 0 71 0 10 0 78 0 10 0 79 0 10 0 87 0 10 0 95 0 10 0 110 20 77 1 120 20 81 1 179 20 85 1 182 20 89 1 184 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 20 93 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 20 97 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 20 101 0 1 20 105 0 2 20 109 0 3 20 113 0 4 20 117 0 5 20 121 0 6 20 125 0 7 20 129 0 8 20 133 0 14 20 137 0 16 20 141 0 18 20 145 0 19 20 149 0 29 20 153 0 30 20 157 0 32 20 161 0 34 20 165 0 37 20 169 0 59 20 173 0 85 20 177 0 94 20 181 0 151 20 185 0 152 20 189 1 206 20 193 1 207] 
#[0 8 182 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 186 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 190 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 6 78 0 63 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 20 197 1 169 14 249 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 8 194 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 198 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 8 202 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 20 201 0 63] 
#[0 8 206 0 154] 
#[0 20 205 0 154] 
#[0 8 210 0 154] 
#[0 8 214 0 154] 
#[0 20 209 0 154] 
#[0 8 210 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 8 218 0 154] 
#[1 20 213 0 154 20 217 2 46 20 221 2 49] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 20 225 0 154] 
#[0 20 229 0 71] 
#[0 20 233 0 51] 
#[1 13 33 0 59 5 6 0 62 20 237 1 123 13 41 1 129] 
#[1 16 85 0 11 4 157 0 154 1 101 0 174 4 161 0 184 14 209 0 185 19 113 0 190 16 105 0 200 20 241 1 138 19 121 1 139] 
#[0 20 245 0 46] 
#[1 20 249 0 45 20 253 0 58] 
#[0 8 222 0 45 0 58] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 8 13 0 51 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 10 173 0 251 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 21 1 1 163 2 149 2 24 10 189 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 8 226 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 19 137 0 154 21 5 1 162] 
#[1 13 33 0 59 5 6 0 62 21 9 1 123 13 41 1 129] 
#[0 21 13 0 154] 
#[1 0 49 0 71 0 10 0 78 0 10 0 79 0 10 0 87 0 10 0 95 0 10 0 110 20 77 1 120 21 17 1 179 20 85 1 182 20 89 1 184 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 5 113 0 39 8 170 0 45 20 33 0 46 0 130 0 48 8 178 0 51 8 170 0 58 5 117 0 59 7 245 0 183 5 125 0 210] 
#[1 21 21 0 45 20 41 0 58] 
#[0 21 25 0 51] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 21 29 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 21 33 0 66] 
#[1 8 230 0 78 8 230 0 79 21 37 0 87 21 41 0 95 21 45 0 110 21 49 1 186 21 53 1 188] 
#[0 21 57 0 50] 
#[1 8 234 0 50 0 49 0 71 0 10 0 79 0 10 0 87 0 10 0 95 0 10 0 110 21 61 1 120 21 65 1 183 21 69 1 184 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 8 238 0 50 0 49 0 71 0 10 0 78 0 10 0 87 0 10 0 95 0 10 0 110 21 73 1 120 21 77 1 182 21 81 1 185 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 0 170 0 1 21 85 0 62 0 174 0 71 0 178 0 74] 
#[1 0 170 0 1 21 89 0 62 0 174 0 71 0 178 0 74] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 2 79 0 62] 
#[0 8 246 0 62] 
#[0 8 246 0 62] 
#[0 2 79 0 62] 
#[0 8 242 0 62] 
#[0 8 246 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 246 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 8 246 0 62] 
#[0 8 246 0 62] 
#[0 8 242 0 62] 
#[0 8 242 0 62] 
#[0 21 93 0 62] 
#[0 21 97 0 62] 
#[0 21 101 0 63] 
#[1 21 105 0 45 0 193 0 51 21 109 1 216 21 113 2 27] 
#[0 21 117 0 62] 
#[0 21 121 0 62] 
#[0 21 125 0 71] 
#[1 21 129 0 45 20 213 0 154 21 133 2 49] 
#[0 8 250 0 45 0 154] 
#[0 21 137 0 45] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 21 141 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 0 49 0 71 0 10 0 78 0 10 0 79 21 145 1 120 21 149 1 243 21 153 1 244 21 157 1 245 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 21 161 0 62] 
#[0 8 254 0 23 0 45 0 51] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 21 165 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 9 2 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 20 21 0 154 21 169 1 157] 
#[0 9 6 0 45 0 58] 
#[0 9 10 0 45 0 58] 
#[0 21 173 0 62] 
#[0 9 14 0 51 0 59 0 62] 
#[0 21 177 0 50] 
#[0 9 18 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 0 49 0 71 0 10 0 81 0 10 0 82 21 181 1 120 21 185 1 190 21 189 1 193 21 193 1 194 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 21 197 0 65] 
#[0 21 201 0 71] 
#[0 9 22 0 78 0 79] 
#[1 9 22 0 78 9 22 0 79 21 205 0 110] 
#[1 9 22 0 78 9 22 0 79 21 209 0 95] 
#[1 21 213 0 78 21 217 0 79] 
#[0 9 26 0 78 0 79] 
#[0 9 30 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 8 230 0 79 21 37 0 87 21 41 0 95 21 45 0 110 21 221 1 186 21 53 1 188] 
#[0 9 34 0 50] 
#[0 9 38 0 50] 
#[1 8 230 0 78 21 37 0 87 21 41 0 95 21 45 0 110 21 225 1 186 21 53 1 188] 
#[0 9 42 0 50] 
#[0 9 46 0 50] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 21 229 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 21 233 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 21 237 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 21 241 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 21 245 0 26 9 50 0 45 9 50 0 51 21 249 1 213 21 253 1 214] 
#[0 9 54 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 9 58 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 9 62 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 22 1 0 63] 
#[0 22 5 0 63] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 2 241 0 62 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 22 9 1 60 2 149 2 24 8 209 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 9 66 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 9 70 0 45 0 154] 
#[0 9 74 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 22 13 0 65] 
#[1 22 17 0 78 22 21 0 79] 
#[0 22 25 0 50] 
#[1 9 78 0 50 0 49 0 71 0 10 0 79 22 29 1 120 22 33 1 245 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 9 82 0 50 0 49 0 71 0 10 0 78 22 37 1 120 22 41 1 244 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 6 78 0 63 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 22 45 1 169 14 249 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 9 86 0 45 0 58] 
#[0 9 90 0 45 0 58] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 6 78 0 63 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 22 49 1 169 14 249 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 9 94 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[1 22 53 0 81 22 57 0 82] 
#[0 22 61 0 50] 
#[1 0 49 0 71 0 10 0 82 22 65 1 120 22 69 1 194 0 85 2 8 0 89 2 9 0 93 2 10] 
#[1 0 49 0 71 0 10 0 81 22 73 1 120 22 77 1 193 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 9 98 0 51] 
#[1 0 10 0 24 0 10 0 40 0 10 0 41 0 10 0 42 0 10 0 43 0 10 0 44 0 10 0 47 0 10 0 53 0 10 0 56 0 10 0 60 0 10 0 61 0 10 0 64 0 10 0 66 0 10 0 67 0 10 0 68 0 10 0 69 0 10 0 70 0 49 0 71 0 10 0 73 0 10 0 75 0 10 0 77 0 10 0 154 14 241 1 120 22 81 1 172 14 253 1 173 15 1 1 174 15 5 1 175 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 9 102 0 78 0 79] 
#[0 9 102 0 78 0 79] 
#[1 22 85 0 45 0 193 0 51 22 89 1 187 22 93 2 27] 
#[1 22 85 0 45 0 193 0 51 22 97 1 187 22 93 2 27] 
#[0 21 217 0 79] 
#[0 21 213 0 78] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 22 101 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 22 105 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 22 109 0 154] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 22 113 0 154] 
#[1 22 117 0 28 22 121 0 66] 
#[0 9 106 0 45 0 51] 
#[0 9 110 0 45 0 51] 
#[1 17 41 0 45 0 193 0 51 22 125 1 165 17 49 2 27] 
#[1 17 41 0 45 0 193 0 51 22 129 1 165 17 49 2 27] 
#[0 22 133 0 65] 
#[0 22 137 0 51] 
#[0 22 141 0 45] 
#[0 22 145 0 45] 
#[0 9 114 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 22 21 0 79] 
#[0 9 118 0 50] 
#[0 22 17 0 78] 
#[0 9 122 0 50] 
#[0 22 149 0 63] 
#[0 22 153 0 63] 
#[1 0 193 0 51 22 157 2 27] 
#[1 0 193 0 51 22 161 2 27] 
#[0 9 126 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 101 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 22 57 0 82] 
#[0 9 130 0 50] 
#[0 22 53 0 81] 
#[0 9 134 0 50] 
#[0 22 165 0 65] 
#[0 9 138 0 50 0 71 0 78 0 79 0 87 0 95 0 110] 
#[0 9 142 0 50 0 71 0 79 0 87 0 95 0 110] 
#[0 9 146 0 50 0 71 0 78 0 79 0 87 0 95 0 110] 
#[0 9 150 0 50 0 71 0 78 0 87 0 95 0 110] 
#[0 22 169 0 63] 
#[0 22 173 0 63] 
#[0 22 177 0 63] 
#[0 22 181 0 58] 
#[0 22 185 0 62] 
#[0 22 189 0 62] 
#[0 9 154 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 9 154 0 8 0 11 0 24 0 27 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 55 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 83 0 84 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 97 0 98 0 104 0 105 0 108 0 110 0 119 0 129 0 133 0 154] 
#[0 9 158 0 45 0 154] 
#[1 0 49 0 71 0 10 0 78 0 10 0 79 21 145 1 120 22 193 1 243 21 153 1 244 21 157 1 245 0 85 2 8 0 89 2 9 0 93 2 10] 
#[0 9 162 0 50 0 71 0 79] 
#[0 9 166 0 50 0 71 0 78] 
#[1 14 193 0 23 6 50 0 45 22 197 1 125 14 201 1 133 14 205 1 134] 
#[1 14 193 0 23 6 50 0 45 6 50 0 51 22 201 1 125 14 201 1 133 14 205 1 134] 
#[0 9 170 0 50 0 71 0 82] 
#[0 9 174 0 50 0 71 0 81] 
#[0 9 178 0 51] 
#[0 9 182 0 45 0 51] 
#[0 9 186 0 45 0 51] 
#[0 9 190 0 45 0 51] 
#[1 0 145 0 24 4 89 0 40 4 93 0 41 4 97 0 42 4 101 0 43 4 105 0 44 4 109 0 47 4 117 0 53 4 121 0 56 4 125 0 64 4 129 0 67 4 133 0 68 4 137 0 69 4 141 0 70 4 149 0 73 4 153 0 75 4 157 0 154 1 101 0 174 4 161 0 184 1 109 0 185 22 205 0 186 1 117 0 188 1 121 0 189 1 125 0 190 1 129 0 191 1 133 0 192 1 137 0 193 1 141 0 194 1 145 0 195 1 149 0 196 1 153 0 197 1 157 0 198 1 161 0 199 1 165 0 200 1 169 0 201 1 173 0 202 1 177 0 203 2 13 1 1 2 165 2 32 2 169 2 33] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 9 13 0 60 9 17 0 61 2 241 0 62 2 14 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 9 21 0 213 22 209 0 214 9 29 0 215 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[1 0 101 0 1 0 105 0 7 0 109 0 8 0 113 0 10 0 117 0 11 2 197 0 12 2 201 0 13 0 129 0 14 0 133 0 16 0 137 0 17 0 141 0 19 2 205 0 20 0 149 0 27 0 153 0 28 0 157 0 30 0 161 0 34 2 209 0 40 2 213 0 41 2 217 0 42 2 221 0 43 2 225 0 44 2 229 0 47 2 233 0 53 2 237 0 56 9 13 0 60 9 17 0 61 2 241 0 62 2 14 0 63 2 245 0 64 0 217 0 66 2 249 0 67 2 253 0 68 3 1 0 69 3 5 0 70 3 9 0 73 3 13 0 75 0 245 0 85 0 249 0 94 1 1 0 100 3 17 0 154 1 77 0 155 1 81 0 156 1 85 0 157 1 89 0 158 1 93 0 159 3 21 0 184 9 21 0 213 22 213 0 214 9 29 0 215 1 181 0 216 1 185 0 217 1 189 0 218 1 193 0 219 1 197 0 220 1 201 0 221 1 205 0 222 3 25 0 223 1 213 0 224 1 217 0 225 1 221 0 226 3 29 0 227 3 33 0 228 3 37 0 229 1 237 0 230 1 241 0 231 1 245 0 232 1 249 0 233 1 253 0 234 2 1 0 235 2 5 0 236 2 9 0 237 3 41 0 249 3 45 1 6 3 49 1 7 3 53 1 8 2 29 1 9 3 57 1 10 3 61 1 11 3 65 1 12 3 69 1 13 3 73 1 14 3 77 1 15 3 81 1 16 3 85 1 17 3 89 1 18 3 93 1 19 3 97 1 20 3 101 1 21 3 105 1 22 3 109 1 24 3 113 1 26 3 117 1 27 3 121 1 34 3 125 1 36 3 129 1 38 3 133 1 58 2 149 2 24 9 33 2 28 2 173 2 34 2 177 2 35 2 181 2 36 2 185 2 37 2 189 2 38] 
#[0 22 217 0 50] 
#[0 22 221 0 45] 
#[0 9 194 0 45 0 51] 
#[1 0 170 0 1 0 174 0 71 0 178 0 74 22 225 0 154] 
#[0 22 229 0 63] 
#[0 22 233 0 63] 
#[0 9 198 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 9 202 0 11 0 24 0 40 0 41 0 42 0 43 0 44 0 47 0 50 0 53 0 56 0 64 0 67 0 68 0 69 0 70 0 71 0 73 0 75 0 80 0 154] 
#[0 22 237 0 63] 
#[0 9 206 0 45 0 51] 
#[0 9 210 0 45 0 51] 
#[0 9 214 0 45 0 51]
	).!

tryAllTokens
	| id ids |
	id := scanner IdentifierId.
	ids := currentToken ids.
	^(ids includes: id)
		ifTrue:
			[ids first = id ifTrue: [^false].
			^(##(#('abstract' 'as' 'base' 'bool' 'break' 'byte' 'case' 'catch' 'char' 'checked' 'class' 'const' 'continue' 'decimal' 'default' 'delegate' 'do' 'double' 'else' 'enum' 'event' 'explicit' 'extern' 'false' 'finally' 'fixed' 'float' 'for' 'foreach' 'goto' 'if' 'implicit' 'in' 'int' 'interface' 'internal' 'is' 'lock' 'long' 'namespace' 'new' 'null' 'object' 'operator' 'out' 'override' 'params' 'private' 'protected' 'public' 'readonly' 'ref' 'return' 'sbyte' 'sealed' 'short' 'sizeof' 'stackalloc' 'static' 'string' 'struct' 'switch' 'this' 'throw' 'true' 'try' 'typeof' 'uint' 'ulong' 'unchecked' 'unsafe' 'ushort' 'using' 'virtual' 'void' 'volatile' 'while')
					asSet) includes: currentToken value) not]
		ifFalse: [^false]! !
!CSharpParser categoriesFor: #actionsForCurrentToken!private! !
!CSharpParser categoriesFor: #ambiguousTransitions!generated!public! !
!CSharpParser categoriesFor: #reduceActionFor_attribute_arguments1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_attribute_arguments2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_attribute_target_specifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_attribute_target_specifier2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_class_base1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_class_base2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_explicit_anonymous_function_paramenter_list2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_extern_alias_directives1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_extern_alias_directives2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_field_modifiers1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_field_modifiers2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_generic_dimension_specifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_generic_dimension_specifier2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_implicit_anonymous_function_parameter_list1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_local_variable_declarator_name1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_query_body_clauses1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_query_body_clauses2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_query_continuation1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_query_continuation2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_struct_interfaces1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFor_struct_interfaces2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForaccessor_declarations2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForaccessor_modifiers4:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForadd_accessor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForanonymous_method_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForanonymous_object_creation_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForanonymous_object_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForanonymous_object_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForargument1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForargument2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForargument3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_creation_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_creation_expression2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_creation_expression3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForarray_type1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForassignment1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForattribute_arguments2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForattribute_section1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForattribute_section2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForattribute_target_specifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForattribute1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForbase_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForbase_access2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForbinary_operator_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForblock1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForbreak_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForcast_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForchecked_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForchecked_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForclass_base1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForclass_base2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForclass_base3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForclass_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForcollection_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForcollection_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForcompilation_unit1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconditional_expression2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconst_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstant_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstant_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstructor_constraint1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstructor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstructor_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstructor_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconstructor_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForcontinue_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconversion_operator_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForconversion_operator_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordeclaration_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordefault_value_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordelegate_creation_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordelegate_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordestructor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFordo_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForelement_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForelement_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForelement_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForempty_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForenum_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForenum_member_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForenum_member_declaration2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForevent_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForevent_declaration2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForexplicit_anonymous_function_paramenter1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForexplicit_anonymous_function_signature1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForexpression_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForextern_alias_directive1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForextern_alias_directives1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForextern_alias_directives2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier4:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier5:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier6:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier7:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier8:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifier9:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifiers1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfield_modifiers2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfinally_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfixed_parameter1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfixed_pointer_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfixed_size_buffer_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfixed_size_buffer_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfixed_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfor_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfor_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForforeach_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForfrom_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForgeneral_catch_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForgeneric_dimension_specifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForget_accessor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForgoto_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForgoto_statement2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForgoto_statement3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForif_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForif_statement2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForimplicit_anonymous_function_signature1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForimplicit_anonymous_function_signature2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForindexer_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForindexer_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForindexer_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_event_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_get_accessor1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_indexer_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_method_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinterface_property_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForinvocation_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForjoin_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForjoin_into_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlabeled_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlambda_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlet_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForliteral2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_constant_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_declarators1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_declarators2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlocal_variable_type2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForlock_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_access3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_declarator3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_name1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormember_name2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormethod_body1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormethod_body2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormethod_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormethod_header1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFormultiplicative_expression2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamed_argument1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamespace_body1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamespace_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamespace_member_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamespace_or_type_name1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornamespace_or_type_name2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFornullable_type1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForobject_creation_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForobject_creation_expression2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForobject_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForobject_initializer2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForoperator_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForoperator_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForoperator_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForoperator_declarator3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFororderby_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForordering_direction1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForordering_direction2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForordering1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFororderings1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFororderings2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForparameter_array1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForparenthesized_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForpointer_element_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForpointer_indirection_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForpointer_member_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForpointer_type2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForpost_increment_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForprimary_constraint1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForprimary_constraint2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForprimary_constraint3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForproperty_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForqualified_alias_member1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForqualified_identifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForqualified_identifier2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause4:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause5:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clause6:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clauses1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body_clauses2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_body1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_continuation1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForquery_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForrank_specifier1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForremove_accessor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForreturn_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForselect_or_group_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForselect_or_group_clause2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForset_accessor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForsimple_name1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForsimple_type2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForsizeof_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForspecific_catch_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstackalloc_initializer1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers5:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers6:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstatic_constructor_modifiers7:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstruct_declaration1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForstruct_interfaces1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForswitch_label1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForswitch_label2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForswitch_section1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForswitch_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForthis_access1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForthrow_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortry_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortry_statement2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortry_statement3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_argument_list1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter_constraints_clause1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter_constraints4:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter_constraints5:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter_constraints7:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter_list1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameter1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameters1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortype_parameters2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionFortypeof_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunary_operator_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunbound_type_name1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunbound_type_name2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunbound_type_name3:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunchecked_expression1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunchecked_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForunsafe_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForusing_alias_directive1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForusing_namespace_directive1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForusing_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForvariable_declarator1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForvariable_declarator2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForvoid_type1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForwhile_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForyield_statement1:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceActionForyield_statement2:!generated-reduction actions!public! !
!CSharpParser categoriesFor: #reduceTable!generated!public! !
!CSharpParser categoriesFor: #symbolTypes!generated!public! !
!CSharpParser categoriesFor: #transitionTable!generated!public! !
!CSharpParser categoriesFor: #tryAllTokens!private! !

!CSharpParser class methodsFor!

definitionComment
"%glr;
%id <Identifier> <gt> <gtgt>;

%start compilation_unit namespace_member_declaration statement expression block;

%ignore_variables commaToken _leftParen _rightParen semicolonToken;

%root Program;
%prefix CS;
%suffix Node;

%annotate_tokens;

%hierarchy Declaration (
	ClassDeclaration
	ConstantDeclaration
	ConstructorDeclaration
	DelegateDeclaration
	DestructorDeclaration
	EnumDeclaration
	EventDeclaration
	FieldDeclaration
	FixedSizeBufferDeclaration
	IndexerDeclaration
	InterfaceDeclaration
	InterfaceEventDeclaration
	InterfaceIndexerDeclaration
	InterfaceMethodDeclaration
	InterfacePropertyDeclaration
	LocalConstantDeclaration
	LocalVariableDeclaration
	MethodDeclaration
	NamespaceDeclaration
	OperatorDeclaration
	PropertyDeclaration
	StaticConstructorDeclaration
	StructDeclaration
);
%hierarchy Statement (
	BlockStatement
	BreakStatement
	CheckedStatement
	ContinueStatement
	DeclarationStatement
	DoStatement
	EmptyStatement
	ExpressionStatement
	FixedStatement
	ForeachStatement
	ForStatement
	GotoStatement
	IfStatement
	LabeledStatement
	LockStatement
	ReturnStatement
	SwitchStatement
	ThrowStatement
	TryStatement
	UncheckedStatement
	UnsafeStatement
	UsingStatement
	WhileStatement
	YieldStatement
);
%hierarchy Expression (
	AnonymousMethodExpression
	AnonymousObjectCreationExpression
	ArrayCreationExpression
	Assignment
	BaseAccess
	BinaryExpression
	CastExpression
	CheckedExpression
	ConditionalExpression
	DefaultValueExpression
	DelegateCreationExpression
	ElementAccess
	InvocationExpression
	LambdaExpression
	LiteralExpression
	MemberAccess
	ObjectCreationExpression
	PrefixExpression
	PointerElementAccess
	PointerMemberAccess
	PostExpression
	QueryExpression
	SimpleName
	SizeofExpression
	ThisAccess
	TypeofExpression
	UncheckedExpression
);
%hierarchy Type (
	ArrayType
	NullableType
	PointerType
	QualifiedAliasMember
	SimpleType
	TypeName
	VarType
	VoidType
);

<gt>
	: \>
	;
<gtgt>
	: <gt> <gt>
	;
<LineTerminator>
	: \r
	| \n
	| \r\n
#	| \x85
#	| \x2028
#	| \x2029
	;
<comment>
	: \/\/ [^\r\n]*
	| (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/)
	;
<Identifier>
	: (<isLetter> | _) (<isLetter> | <isDigit> | _)*
	| \@ (<isLetter> | _) (<isLetter> | <isDigit> | _)*
	;
<IntegerSuffix>
	: [Uu]
	| [Ll]
	| [Uu][Ll]
	| [Ll][Uu]
	;
<IntegerLiteral>
	: \d+ <IntegerSuffix>?
	| 0[Xx] [0-9A-Fa-f]+ <IntegerSuffix>?
	;
<ExponentPart>
	: [Ee] [\+\-]? \d+
	;
<RealSuffix>
	: [Ff]
	| [Dd]
	| [Mm]
	;
<RealLiteral>
	: \d* \. \d+ <ExponentPart>? <RealSuffix>?
	| \d+ <ExponentPart>? <RealSuffix>?
	| \d+ <RealSuffix>
	;
<SimpleEscapeSequence>
	: \\\'
	| \\\""
	| \\\\
	| \\0
	| \\a
	| \\b
	| \\f
	| \\n
	| \\r
	| \\t
	| \\v
	;
<HexadecimalEscapeSequence>
	: \\x [0-9A-Fa-f]{1,4}
	;
<UnicodeCharacterEscapeSequence>
	: \\[Uu] ([0-9A-Fa-f]{4,4}){1,2}
	;
<Character>
	: [^\'\\\n]
	| <SimpleEscapeSequence>
	| <HexadecimalEscapeSequence>
	| <UnicodeCharacterEscapeSequence>
	;
<CharacterLiteral>
	: \' <Character> \'
	;
<SingleRegularStringLiteralCharacter>
	: [^\""\\\n]
	;
<RegularStringLiteralCharacter>
	: <SingleRegularStringLiteralCharacter>
	| <SimpleEscapeSequence>
	| <HexadecimalEscapeSequence>
	| <UnicodeCharacterEscapeSequence>
	;
<RegularStringLiteral>
	: \"" <RegularStringLiteralCharacter>* \""
	;
<VerbatimStringLiteralCharacter>
	: [^\""]
	| \""\""
	;
<VerbatimStringLiteral>
	: \@\"" <VerbatimStringLiteralCharacter>* \""
	;
<StringLiteral>
	: <RegularStringLiteral>
	| <VerbatimStringLiteral>
	;
<NullLiteral>
	: null
	;
<whitespace>
	: \s+
	| \# [^\r\n]*
	;


<patternToken>
	: (\`  [^\`]* \`)+
	;

# B.2

# B.2.6 Namespaces
compilation_unit
	: _extern_alias_directives _using_directives _global_attributes _namespace_member_declarations {{}}
	;
namespace_declaration
	: ""namespace"" qualified_identifier 'identifier' namespace_body _semicolon {{}}
	;
qualified_identifier
	: <Identifier> 'name' {{}}
	| qualified_identifier ""."" <Identifier> 'name' {{}}
	;
namespace_body
	: ""{"" _extern_alias_directives _using_directives _namespace_member_declarations ""}""
	;
_extern_alias_directives
	:
	| extern_alias_directives
	;
extern_alias_directives
	: extern_alias_directive 'directive'
	| extern_alias_directives extern_alias_directive 'directive'
	;
extern_alias_directive
	: ""extern"" ""alias"" <Identifier> "";"" {{}}
	;
_using_directives
	:
	| using_directives
	;
using_directives
	: using_directive 'directive'
	| using_directives using_directive 'directive'
	;
using_directive
	: using_alias_directive
	| using_namespace_directive
	;
using_alias_directive
	: ""using"" <Identifier> 'name' ""="" namespace_or_type_name 'namespace' "";"" {{}}
	;
using_namespace_directive
	: ""using"" namespace_name 'namespace' "";"" {{}}
	;
_namespace_member_declarations
	: 
	| namespace_member_declarations
	;
namespace_member_declarations
	: namespace_member_declaration 'declaration'
	| namespace_member_declarations namespace_member_declaration 'declaration'
	;
namespace_member_declaration
	: namespace_declaration
	| type_declaration
	;
type_declaration
	: class_declaration
	| struct_declaration
	| interface_declaration
	| enum_declaration
	| delegate_declaration
	;
qualified_alias_member
	: <Identifier> 'global' ""::"" <Identifier> 'name' _type_argument_list 'typeArguments' {{}}
	;

# B.2.1
namespace_name
	: namespace_or_type_name
	;
type_name
	: namespace_or_type_name
	;
namespace_or_type_name
	: <Identifier> 'name' _type_argument_list 'typeArguments' {{TypeName}}
	| namespace_or_type_name 'namespace' ""."" <Identifier> 'name' _type_argument_list 'typeArguments' {{TypeName}}
	| qualified_alias_member 
	;

# B.2.2
_type
	:
	| type 'type'
	;
type
	: value_type
	| reference_type
	| type_parameter
	;
value_type
	: struct_type
	| enum_type
	;
struct_type
	: type_name
	| simple_type
	| nullable_type
	;
simple_type
	: numeric_type 'token' {{}}
	| ""bool"" 'token' {{}}
	;
numeric_type
	: integral_type
	| floating_point_type
	| ""decimal""
	;
integral_type
	: ""sbyte""
	| ""byte""
	| ""short""
	| ""ushort""
	| ""int""
	| ""uint""
	| ""long""
	| ""ulong""
	| ""char""
	;
floating_point_type
	: ""float""
	| ""double""
	;
nullable_type
	: non_nullable_value_type 'type' ""?"" {{}}
	;
non_nullable_value_type
	: type
	;
enum_type
	: type_name
	;
reference_type
	: class_type
	| interface_type
	| array_type
	| delegate_type
	;
class_type
	: type_name
	| ""object"" 'token' {{SimpleType}}
	| ""string"" 'token' {{SimpleType}}
	;
interface_type
	: type_name
	;
array_type
	: non_array_type 'type' rank_specifiers {{}}
	;
non_array_type
	: type
	;
_rank_specifiers
	: 
	| rank_specifiers
	;
rank_specifiers
	: rank_specifier 'rankSpecifier'
	| rank_specifiers rank_specifier 'rankSpecifier'
	;
rank_specifier
	: ""["" _dim_separators ""]"" {{}}
	;
_dim_separators
	: 
	| dim_separators
	;
dim_separators
	: "",""
	| dim_separators "",""
	;
delegate_type
	: type_name
	;
type_argument_list
	: ""<"" type_arguments <gt> 'greaterThanToken' {{}}
	;
type_arguments
	: type_argument 'type'
	| type_arguments "","" type_argument 'type'
	;
type_argument
	: type
	;

# B.2.3 Variables
variable_reference
	: expression
	;

# B.2.4 Expressions
_argument_list
	:
	| argument_list
	;

# B.2.4
argument_list
	: argument 'argument'
	| argument_list "","" argument 'argument'
	;
argument
	: expression 'expression' {{}}
	| ""ref"" variable_reference 'expression' {{}}
	| ""out"" variable_reference 'expression' {{}}
	;
primary_expression
	: primary_no_array_creation_expression
	| array_creation_expression
	;
primary_no_array_creation_expression
	: literal 
	| simple_name 
	| parenthesized_expression 
	| member_access 
	| invocation_expression 
	| element_access 
	| this_access 
	| base_access 
	| post_increment_expression 
	| post_decrement_expression 
	| object_creation_expression 
	| delegate_creation_expression 
	| anonymous_object_creation_expression 
	| typeof_expression 
	| checked_expression 
	| unchecked_expression 
	| default_value_expression 
	| anonymous_method_expression 
	;
simple_name
	: <Identifier> _type_argument_list 'typeArguments' {{}}
	;
_type_argument_list
	: 
	| type_argument_list
	;
parenthesized_expression
	: ""("" '_leftParen' expression "")"" '_rightParen' {{Expression}}
	;
member_access
	: primary_expression 'expression' ""."" <Identifier> 'identifier' _type_argument_list 'typeArguments' {{}}
	| predefined_type 'expression' ""."" <Identifier> 'identifier' _type_argument_list 'typeArguments' {{}}
	| qualified_alias_member 'expression' ""."" <Identifier> 'identifier' {{}}
	;
predefined_type
	: ""bool"" 'token' {{SimpleType}}
	| ""byte"" 'token' {{SimpleType}}
	| ""char"" 'token' {{SimpleType}}
	| ""decimal"" 'token' {{SimpleType}}
	| ""double"" 'token' {{SimpleType}}
	| ""float"" 'token' {{SimpleType}}
	| ""int"" 'token' {{SimpleType}}
	| ""long"" 'token' {{SimpleType}}
	| ""object"" 'token' {{SimpleType}}
	| ""sbyte"" 'token' {{SimpleType}}
	| ""short"" 'token' {{SimpleType}}
	| ""string"" 'token' {{SimpleType}}
	| ""uint"" 'token' {{SimpleType}}
	| ""ulong"" 'token' {{SimpleType}}
	| ""ushort"" 'token' {{SimpleType}}
	;
invocation_expression
	: primary_expression 'expression' ""("" _argument_list "")"" {{}}
	;
element_access
	: primary_no_array_creation_expression 'baseExpression' ""["" expression_list ""]"" {{}}
	;
expression_list
	: expression 'expression'
	| expression_list	"","" expression 'expression'
	;
this_access
	: ""this"" {{}}
	;
base_access
	: ""base"" ""."" <Identifier> 'identifier' {{}}
	| ""base"" ""["" expression_list ""]"" {{}}
	;
post_increment_expression
	: primary_expression 'expression' ""++"" 'operator' {{PostExpression}}
	;
post_decrement_expression
	: primary_expression 'expression' ""--"" 'operator' {{PostExpression}}
	;
object_creation_expression
	: ""new"" type 'type' ""("" _argument_list "")"" _object_or_collection_initializer 'initializer' {{}}
	| ""new"" type 'type' object_or_collection_initializer 'initializer' {{}}
	;
_object_or_collection_initializer
	:
	| object_or_collection_initializer
	;
object_or_collection_initializer
	: object_initializer
	| collection_initializer
	;
object_initializer
	: ""{"" _member_initializer_list ""}"" {{}}
	| ""{"" member_initializer_list "","" ""}"" {{}}
	;
_member_initializer_list
	: 
	| member_initializer_list
	;
member_initializer_list
	: member_initializer 'initializer'
	| member_initializer_list "","" member_initializer 'initializer'
	;
member_initializer
	: <Identifier> 'identifier' ""="" initializer_value 'value' {{}}
	;
initializer_value
	: expression
	| object_or_collection_initializer
	;
collection_initializer
	: ""{"" element_initializer_list ""}"" {{}}
	| ""{"" element_initializer_list "","" ""}"" {{}}
	;
element_initializer_list
	: element_initializer 'initializer'
	| element_initializer_list "","" element_initializer 'initializer'
	;
element_initializer
	: non_assignment_expression 'expression' {{}}
	| ""{"" expression_list ""}"" {{}}
	;
array_creation_expression
	: ""new"" non_array_type 'type' ""["" expression_list ""]"" _rank_specifiers _array_initializer 'arrayInitializer' {{}}
	| ""new"" array_type 'type' array_initializer 'arrayInitializer' {{}}
	| ""new"" rank_specifier 'rankSpecifier' array_initializer 'arrayInitializer' {{}}
	;
delegate_creation_expression
	: ""new"" delegate_type 'type' ""("" expression 'expression' "")"" {{}}
	;
anonymous_object_creation_expression
	: ""new"" anonymous_object_initializer {{}}
	;
anonymous_object_initializer
	: ""{"" _member_declarator_list ""}""
	| ""{"" member_declarator_list "","" ""}""
	;
_member_declarator_list
	: 
	| member_declarator_list
	;
member_declarator_list
	: member_declarator 'declarator'
	| member_declarator_list "","" member_declarator 'declarator'
	;
member_declarator
	: simple_name 'name' {{}}
	| member_access 'access' {{}}
	| <Identifier> ""="" expression 'value' {{}}
	;
typeof_expression
	: ""typeof"" ""("" type 'type' "")"" {{}}
	| ""typeof"" ""("" unbound_type_name 'type' "")"" {{}}
	| ""typeof"" ""("" void_type 'type' "")"" {{}}
	;
unbound_type_name
	: <Identifier> _generic_dimension_specifier {{}}
	| <Identifier> ""::"" <Identifier> _generic_dimension_specifier {{}}
	| unbound_type_name ""."" <Identifier> _generic_dimension_specifier {{}}
	;
_generic_dimension_specifier
	: 
	| generic_dimension_specifier
	;
generic_dimension_specifier
	: ""<"" _commas <gt>
	;
_commas
	: 
	| commas
	;
commas
	: "","" 'comma'
	| commas "","" 'comma'
	;
checked_expression
	: ""checked"" ""("" expression 'expression' "")"" {{}}
	;
unchecked_expression
	: ""unchecked"" ""("" expression 'expression' "")"" {{}}
	;
default_value_expression
	: ""default"" ""("" type 'type' "")"" {{}}
	;
unary_expression
	: primary_expression
	| ""+"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	| ""-"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	| ""!!"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	| ""~"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	| pre_increment_expression
	| pre_decrement_expression
	| cast_expression
	;
pre_increment_expression
	: ""++"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	;
pre_decrement_expression
	: ""--"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	;
cast_expression
	: ""("" type 'type' "")"" unary_expression 'expression' {{}}
	;
multiplicative_expression
	: unary_expression
	| multiplicative_expression 'left' ""*"" 'operator' unary_expression 'right' {{BinaryExpression}}
	| multiplicative_expression 'left' ""/"" 'operator' unary_expression 'right' {{BinaryExpression}}
	| multiplicative_expression 'left' ""%"" 'operator' unary_expression 'right' {{BinaryExpression}}
	;
additive_expression
	: multiplicative_expression
	| additive_expression 'left' ""+"" 'operator' multiplicative_expression 'right' {{BinaryExpression}}
	| additive_expression 'left' ""-"" 'operator' multiplicative_expression 'right' {{BinaryExpression}}
	;
shift_expression
	: additive_expression
	| shift_expression 'left' ""<<"" 'operator' additive_expression 'right' {{BinaryExpression}}
	| shift_expression 'left' <gtgt> 'operator' additive_expression 'right' {{BinaryExpression}}
	;
relational_expression
	: shift_expression
	| relational_expression 'left' ""<"" 'operator' shift_expression 'right' {{BinaryExpression}}
	| relational_expression 'left' <gt> 'operator' shift_expression 'right' {{BinaryExpression}}
	| relational_expression 'left' ""<="" 'operator' shift_expression 'right' {{BinaryExpression}}
	| relational_expression 'left' "">="" 'operator' shift_expression 'right' {{BinaryExpression}}
	| relational_expression 'left' ""is"" 'operator' type 'right' {{BinaryExpression}}
	| relational_expression 'left' ""as"" 'operator' type 'right' {{BinaryExpression}}
	;
equality_expression
	: relational_expression
	| equality_expression 'left' ""=="" 'operator' relational_expression 'right' {{BinaryExpression}}
	| equality_expression 'left' ""!!="" 'operator' relational_expression 'right' {{BinaryExpression}}
	;
and_expression
	: equality_expression
	| and_expression 'left' ""&"" 'operator' equality_expression 'right' {{BinaryExpression}}
	;
exclusive_or_expression
	: and_expression
	| exclusive_or_expression 'left' ""^"" 'operator' and_expression 'right' {{BinaryExpression}}
	;
inclusive_or_expression
	: exclusive_or_expression
	| inclusive_or_expression 'left' ""|"" 'operator' exclusive_or_expression 'right' {{BinaryExpression}}
	;
conditional_and_expression
	: inclusive_or_expression
	| conditional_and_expression 'left' ""&&"" 'operator' inclusive_or_expression 'right' {{BinaryExpression}}
	;
conditional_or_expression
	: conditional_and_expression
	| conditional_or_expression 'left' ""||"" 'operator' conditional_and_expression 'right' {{BinaryExpression}}
	;
null_coalescing_expression
	: conditional_or_expression
	| conditional_or_expression 'left' ""??"" 'operator' null_coalescing_expression 'right' {{BinaryExpression}}
	;
conditional_expression
	: null_coalescing_expression
	| null_coalescing_expression 'booleanExpression' ""?"" expression 'trueExpression' "":"" expression 'falseExpression' {{}}
	;
lambda_expression
	: anonymous_function_signature 'signature' ""=>"" anonymous_function_body 'body' {{}}
	;
anonymous_method_expression
	: ""delegate"" _explicit_anonymous_function_signature 'signature' block 'block' {{}}
	;
anonymous_function_signature
	: explicit_anonymous_function_signature
	| implicit_anonymous_function_signature
	;
_explicit_anonymous_function_signature
	:
	| explicit_anonymous_function_signature
	;
explicit_anonymous_function_signature
	: ""("" _explicit_anonymous_function_paramenter_list "")"" {{}}
	;
_explicit_anonymous_function_paramenter_list
	: 
	| explicit_anonymous_function_paramenter_list
	;
explicit_anonymous_function_paramenter_list
	: explicit_anonymous_function_paramenter 'parameter'
	| explicit_anonymous_function_paramenter_list "","" explicit_anonymous_function_paramenter 'parameter'
	;
explicit_anonymous_function_paramenter
	: _anonymous_function_parameter_modifier type 'type' <Identifier> 'name' {{AnonymousFunctionParameter}}
	;
_anonymous_function_parameter_modifier
	: 
	| anonymous_function_parameter_modifier 'modifier'
	;
anonymous_function_parameter_modifier
	: ""ref""
	| ""out""
	;
implicit_anonymous_function_signature
	: ""("" _implicit_anonymous_function_parameter_list "")"" {{}}
	| implicit_anonymous_function_parameter 'name' {{}}
	;
_implicit_anonymous_function_parameter_list
	: 
	| implicit_anonymous_function_parameter_list
	;
implicit_anonymous_function_parameter_list
	: implicit_anonymous_function_parameter 'name'
	| implicit_anonymous_function_parameter_list "","" implicit_anonymous_function_parameter 'name'
	;
implicit_anonymous_function_parameter
	: <Identifier>
	;
anonymous_function_body
	: expression
	| block
	;
query_expression
	: from_clause query_body {{}}
	;
from_clause
	: ""from"" _type <Identifier> ""in"" expression 'expression'
	;
query_body
	: _query_body_clauses select_or_group_clause _query_continuation
	;
_query_body_clauses
	: 
	| query_body_clauses
	;
query_body_clauses
	: query_body_clause
	| query_body_clauses query_body_clause
	;
query_body_clause
	: from_clause
	| let_clause
	| where_clause
	| join_clause
	| join_into_clause
	| orderby_clause
	;
let_clause
	: ""let"" <Identifier> ""="" expression 'expression'
	;
where_clause
	: ""where"" boolean_expression 'expression'
	;
join_clause
	: ""join"" _type <Identifier> ""in"" expression 'joinInExpression'""on"" expression 'joinOnExpression' ""equals"" expression 'joinEqualsExpression'
	;
join_into_clause
	: ""join"" _type <Identifier> ""in"" expression 'joinInExpression' ""on"" expression 'joinOnExpression' ""equals"" expression 'joinEqualsExpression' ""into"" <Identifier>
	;
orderby_clause
	: ""orderby"" orderings
	;
orderings
	: ordering
	| orderings "","" ordering
	;
ordering
	: expression 'expression' _ordering_direction
	;
_ordering_direction
	: 
	| ordering_direction
	;
ordering_direction
	: ""ascending""
	| ""descending""
	;
select_or_group_clause
	: select_clause
	| group_clause
	;
select_clause
	: ""select"" expression 'expression'
	;
group_clause
	: ""group"" expression 'groupExpression' ""by"" expression 'groupByExpression'
	;
_query_continuation
	: 
	| query_continuation
	;
query_continuation
	: ""into"" <Identifier> query_body
	;
assignment
	: unary_expression 'lhs' assignment_operator 'operator' expression 'rhs' {{}}
	;
assignment_operator
	: ""=""
	| ""+=""
	| ""-=""
	| ""*=""
	| ""/=""
	| ""%=""
	| ""&=""
	| ""|=""
	| ""^=""
	| ""<<=""
	| "">>=""
	;
_expression
	:
	| expression 'expression'
	;
expression
	: non_assignment_expression 
	| assignment 
	;
non_assignment_expression
	: conditional_expression 
	| lambda_expression 
	| query_expression 
	;
constant_expression
	: expression
	;
boolean_expression
	: expression
	;

# B.2.5 Statements
statement
	: labeled_statement
	| declaration_statement
	| embedded_statement
	;
embedded_statement
	: block
	| empty_statement
	| expression_statement
	| selection_statement
	| iteration_statement
	| jump_statement
	| try_statement
	| checked_statement
	| unchecked_statement
	| lock_statement
	| using_statement
	| yield_statement
	;
block
	: ""{"" _statement_list ""}"" {{BlockStatement}}
	;
_statement_list
	: 
	| statement_list
	;
statement_list
	: statement 'statement'
	| statement_list statement 'statement'
	;
empty_statement
	: "";"" {{}}
	;
labeled_statement
	: <Identifier> "":"" statement 'statement' {{}}
	;
declaration_statement
	: local_variable_declaration 'declaration' "";"" {{}}
	| local_constant_declaration 'declaration' "";"" {{}}
	;
local_variable_declaration
	: local_variable_type 'type' local_variable_declarators {{}}
	;
local_variable_type
	: type
	| ""var"" {{VarType}}
	;
local_variable_declarators
	: local_variable_declarator 'declarator'
	| local_variable_declarators "","" local_variable_declarator 'declarator'
	;
local_variable_declarator
#	: <Identifier> 'name' {{}}
#	| <Identifier> 'name' ""="" local_variable_initializer 'expression' {{}}
	: _local_variable_declarator_name 'name' {{}}
	| _local_variable_declarator_name 'name' ""="" local_variable_initializer 'expression' {{}}
	;
_local_variable_declarator_name	# Here to create a parse node
	: <Identifier> {{SimpleName}}
	;
local_variable_initializer
	: expression
	| array_initializer
	;
local_constant_declaration
	: ""const"" type 'type' const_declarators {{}}
	;
const_declarators
	: const_declarator 'declarator' 
	| const_declarators "","" const_declarator 'declarator'
	;
const_declarator
	: <Identifier> 'name' ""="" constant_expression 'expression' {{}}
	;
expression_statement
	: statement_expression 'expression' "";"" {{}}
	;
statement_expression
	: invocation_expression
	| object_creation_expression
	| assignment
	| post_increment_expression
	| post_decrement_expression
	| pre_increment_expression
	| pre_decrement_expression
	;
selection_statement
	: if_statement
	| switch_statement
	;
if_statement
	: ""if"" ""("" boolean_expression 'expression' "")"" embedded_statement 'thenStatement' {{}}
	| ""if"" ""("" boolean_expression 'expression' "")"" embedded_statement 'thenStatement' ""else"" embedded_statement 'elseStatement' {{}}
	;
switch_statement
	: ""switch"" ""("" expression 'expression' "")"" switch_block {{}}
	;
switch_block
	: ""{"" _switch_sections ""}""
	;
_switch_sections
	:
	| switch_sections
	;
switch_sections
	: switch_section 'section'
	| switch_sections switch_section 'section'
	;
switch_section
	: switch_labels statement_list {{}}
	;
switch_labels
	: switch_label 'label'
	| switch_labels switch_label 'label'
	;
switch_label
	: ""case"" constant_expression 'expression' "":"" {{}}
	| ""default"" "":"" {{}}
	;
iteration_statement
	: while_statement
	| do_statement
	| for_statement
	| foreach_statement
	;
while_statement
	: ""while"" ""("" boolean_expression 'expression' "")"" embedded_statement 'statement' {{}}
	;
do_statement
	: ""do"" embedded_statement 'statement' ""while"" ""("" boolean_expression 'expression' "")"" "";"" {{}}
	;
for_statement
	: ""for"" ""("" _for_initializer "";"" _for_condition "";"" _for_iterator "")"" embedded_statement 'statement' {{}}
	;
_for_initializer
	: 
	| for_initializer 'initializer'
	;
for_initializer
	: local_variable_declaration
	| statement_expression_list {{StatementList}}
	;
_for_condition
	:
	| for_condition 'condition'
	;
for_condition
	: boolean_expression
	;
_for_iterator
	: 
	| for_iterator 'iterator'
	;
for_iterator
	: statement_expression_list {{StatementList}}
	;
statement_expression_list
	: statement_expression 'expression'
	| statement_expression_list "","" statement_expression 'expression'
	;
foreach_statement
	: ""foreach"" ""("" local_variable_type 'type' <Identifier> 'name' ""in"" expression 'expression' "")"" embedded_statement 'statement' {{}}
	;
jump_statement
	: break_statement
	| continue_statement
	| goto_statement
	| return_statement
	| throw_statement
	;
break_statement
	: ""break"" "";"" {{}}
	;
continue_statement
	: ""continue"" "";"" {{}}
	;
goto_statement
	: ""goto"" <Identifier> "";"" {{}}
	| ""goto"" ""case"" constant_expression 'expression' "";"" {{}}
	| ""goto"" ""default"" "";"" {{}}
	;
return_statement
	: ""return"" _expression "";"" {{}}
	;
throw_statement
	: ""throw"" _expression "";"" {{}}
	;
try_statement
	: ""try"" block 'block' catch_clauses {{}}
	| ""try"" block 'block' finally_clause 'finally' {{}}
	| ""try"" block 'block' catch_clauses finally_clause 'finally' {{}}
	;
catch_clauses
	: specific_catch_clauses _general_catch_clause
	| _specific_catch_clauses general_catch_clause 'clause'
	;
_specific_catch_clauses
	: 
	| specific_catch_clauses
	;
specific_catch_clauses
	: specific_catch_clause 'clause'
	| specific_catch_clauses specific_catch_clause 'clause'
	;
specific_catch_clause
	: ""catch"" ""("" class_type 'type' _identifier "")"" block 'block' {{}}
	;
_general_catch_clause
	:
	| general_catch_clause 'clause'
	;
general_catch_clause
	: ""catch"" block 'block' {{}}
	;
finally_clause
	: ""finally"" block 'block' {{}}
	;
checked_statement
	: ""checked"" block 'block' {{}}
	;
unchecked_statement
	: ""unchecked"" block 'block' {{}}
	;
lock_statement
	: ""lock"" ""("" expression 'expression' "")"" embedded_statement 'statement' {{}}
	;
using_statement
	: ""using"" ""("" resource_acquisition 'expression' "")"" embedded_statement 'statement' {{}}
	;
resource_acquisition
	: local_variable_declaration
	| expression
	;
yield_statement
	: ""yield"" ""return"" expression 'expression' "";"" {{}}
	| ""yield"" ""break"" "";"" {{}}
	;


# B.2.7 Classes
class_declaration
	: _attributes _class_modifiers _partial ""class"" <Identifier> 'name' _type_parameter_list _class_base _type_parameter_constraints_clauses class_body _semicolon {{}}
	;
_class_modifiers
	:
	| class_modifiers
	;
class_modifiers
	: class_modifier 'modifier'
	| class_modifiers class_modifier 'modifier'
	;
class_modifier
	: ""new"" 
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""abstract""
	| ""sealed""
	| ""static""
	;
_type_parameter_list
	: 
	| type_parameter_list 'typeParameters'
	;
type_parameter_list
	: ""<"" 'lessThan' type_parameters <gt> 'greaterThan' {{}}
	;
type_parameters
	: _attributes type_parameter 'parameter'
	| type_parameters "","" _attributes type_parameter 'parameter'
	;
type_parameter
	: <Identifier> 'name'  {{TypeName}}
	;
_class_base
	: 
	| class_base
	;
class_base
	: "":"" class_type 'supertype'
	| "":"" interface_type_list
	| "":"" class_type 'supertype' "","" interface_type_list
	;
interface_type_list
	: interface_type 'supertype'
	| interface_type_list "","" 'comma' interface_type 'supertype'
	;
_type_parameter_constraints_clauses
	: 
	| type_parameter_constraints_clauses
	;
type_parameter_constraints_clauses
	: type_parameter_constraints_clause 'constraintClause'
	| type_parameter_constraints_clauses type_parameter_constraints_clause 'constraintClause'
	;
type_parameter_constraints_clause
	: ""where"" 'whereToken' type_parameter 'parameter' "":"" 'colon' type_parameter_constraints {{}}
	;
type_parameter_constraints
	: primary_constraint  'constraint'
	| secondary_constraints
	| constructor_constraint 'constraint'
	| primary_constraint 'constraint' "","" secondary_constraints
	| primary_constraint 'constraint' "","" constructor_constraint 'constraint'
	| secondary_constraints "","" constructor_constraint 'constraint'
	| primary_constraint 'constraint' "","" secondary_constraints "","" constructor_constraint 'constraint'
	;
primary_constraint
	: class_type 'type' {{TypeConstraint}}
	| ""class"" {{}}
	| ""struct"" {{}}
	;
secondary_constraints
	: interface_type_constraint 'constraint'
	| type_parameter 'constraint'
	| secondary_constraints "","" interface_type_constraint 'constraint'
	| secondary_constraints "","" type_parameter 'constraint'
	;
## added Interface_type_constraint
interface_type_constraint
	: interface_type 'type' {{TypeConstraint}}
	;
constructor_constraint
	: ""new"" ""("" "")"" {{}}
	;
class_body
	: ""{"" _class_member_declarations ""}""
	;
_class_member_declarations
	: 
	| class_member_declarations
	;
class_member_declarations
	: class_member_declaration 'declaration'
	| class_member_declarations class_member_declaration 'declaration'
	;
class_member_declaration
	: constant_declaration
	| field_declaration
	| method_declaration
	| property_declaration
	| event_declaration
	| indexer_declaration
	| operator_declaration
	| constructor_declaration
	| destructor_declaration
	| static_constructor_declaration
	| type_declaration
	;
constant_declaration
	: _attributes _constant_modifiers ""const"" type 'type' constant_declarators "";"" {{}}
	;
_constant_modifiers
	: 
	| constant_modifers
	;
constant_modifers
	: constant_modifer 'modifier'
	| constant_modifers constant_modifer 'modifier'
	;
constant_modifer
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	;
constant_declarators
	: constant_declarator 'declarator'
	| constant_declarators "","" constant_declarator 'declarator'
	;
constant_declarator
	: <Identifier> ""="" constant_expression 'expression' {{}}
	;
field_declaration
	: _attributes _field_modifiers type 'type' variable_declarators "";"" {{}}
	;
_field_modifiers
	: 
	| field_modifiers
	;
field_modifiers
	: field_modifier
	| field_modifiers field_modifier
	;
field_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""static""
	| ""readonly""
	| ""volatile""
	;
variable_declarators
	: variable_declarator 'declarator'
	| variable_declarators "","" variable_declarator 'declarator'
	;
variable_declarator
	: <Identifier> {{}}
	| <Identifier> ""="" variable_initializer 'initializer' {{}}
	;
variable_initializer
	: expression
	| array_initializer
	;
method_declaration
	: method_header 'header' method_body 'body' {{}}
	;
method_header
	: _attributes _method_modifiers _partial return_type 'returnType' member_name _type_parameter_list ""("" _formal_parameters_list "")"" _type_parameter_constraints_clauses {{}}
	;
_method_modifiers
	: 
	| method_modifiers
	;
method_modifiers
	: method_modifier 'modifier'
	| method_modifiers method_modifier 'modifier'
	;
method_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""static""
	| ""virtual""
	| ""sealed""
	| ""override""
	| ""abstract""
	| ""extern""
	;
return_type
	: type
	| void_type
	;
member_name
	: <Identifier> 'name'
	| interface_type 'interface' ""."" <Identifier> 'name'
	;
method_body
	: block 'block' {{}}
	| "";"" {{}}
	;
_formal_parameters_list
	: 
	| formal_parameters_list
	;
formal_parameters_list
	: fixed_parameters
	| fixed_parameters "","" 'comma' parameter_array 'parameter'
	| parameter_array 'parameter'
	;
fixed_parameters
	: fixed_parameter 'parameter'
	| fixed_parameters "","" 'comma' fixed_parameter 'parameter'
	;
fixed_parameter
	: _attributes _parameter_modifier type 'type' <Identifier> 'name' {{FixedParameter}}
	;
_parameter_modifier
	:
	| parameter_modifier 'modifier'
	;
parameter_modifier
	: ""ref"" 
	| ""out""
	| ""this""
	;
parameter_array
	: _attributes ""params"" 'paramsToken' array_type 'type' <Identifier> 'name' {{ArrayParameter}}
	;
property_declaration
	: _attributes _property_modifiers type 'type' member_name ""{"" accessor_declarations ""}"" {{}}
	;
_property_modifiers
	:
	| property_modifiers
	;
property_modifiers
	: property_modifier 'modifier'
	| property_modifiers property_modifier 'modifier'
	;
property_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""static""
	| ""virtual""
	| ""sealed""
	| ""override""
	| ""abstract""
	| ""extern""
	;
accessor_declarations
	: get_accessor_declaration 'getAccessor' _set_accessor_declaration 'setAccessor'
	| set_accessor_declaration 'setAccessor' _get_accessor_declaration 'getAccessor'
	;
_get_accessor_declaration
	:
	| get_accessor_declaration
	;
get_accessor_declaration
	: _attributes _accessor_modifiers ""get"" accessor_body {{}}
	;
_set_accessor_declaration
	:
	| set_accessor_declaration
	;
set_accessor_declaration
	: _attributes _accessor_modifiers ""set"" accessor_body {{}}
	;
_accessor_modifiers
	:
	| accessor_modifiers
	;
accessor_modifiers
	: ""protected"" 'modifier'
	| ""internal"" 'modifier'
	| ""private"" 'modifier'
	| ""protected"" 'modifier' ""internal"" 'modifier'
	| ""internal"" 'modifier' ""protected"" 'modifier'
	;
accessor_body
	: block 'body'
	| "";""
	;
event_declaration
	: _attributes _event_modifiers ""event"" type 'type' variable_declarators "";"" {{}}
	| _attributes _event_modifiers ""event"" type 'type' member_name ""{"" event_accessor_declarations ""}"" {{}}
	;
_event_modifiers
	:
	| event_modifiers
	;
event_modifiers
	: event_modifier 'modifier'
	| event_modifiers event_modifier 'modifier'
	;
event_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""static""
	| ""virtual""
	| ""sealed""
	| ""override""
	| ""abstract""
	| ""extern""
	;
event_accessor_declarations
	: add_accessor_declaration 'addDeclaration' remove_accessor_declaration 'removeDeclaration'
	| remove_accessor_declaration 'removeDeclaration' add_accessor_declaration 'addDeclaration'
	;
add_accessor_declaration
	: _attributes ""add"" block 'block' {{}}
	;
remove_accessor_declaration
	: _attributes ""remove"" block 'block' {{}}
	;
indexer_declaration
	: _attributes _indexer_modifiers indexer_declarator ""{"" accessor_declarations ""}"" {{}}
	;
_indexer_modifiers
	:
	| indexer_modifiers
	;
indexer_modifiers
	: indexer_modifier 'modifier'
	| indexer_modifiers indexer_modifier 'modifier'
	;
indexer_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""virtual""
	| ""sealed""
	| ""override""
	| ""abstract""
	| ""extern""
	;
indexer_declarator
	: type 'returnType' ""this"" ""["" formal_parameters_list ""]""
	| type 'returnType' interface_type 'type' ""."" ""this"" ""["" formal_parameters_list ""]""
	;
operator_declaration
	: _attributes operator_modifiers operator_declarator operator_body 'body' {{}}
	;
operator_modifiers
	: operator_modifier 'modifier'
	| operator_modifiers operator_modifier 'modifier'
	;
operator_modifier
	: ""public""
	| ""static""
	| ""extern""
	;
operator_declarator
	: unary_operator_declarator
	| binary_operator_declarator
	| conversion_operator_declarator
	;
unary_operator_declarator
	: type 'returnType' ""operator"" overloadable_unary_operator 'operator' ""("" type 'type' <Identifier> 'argument' "")""
	;
overloadable_unary_operator
	: ""+""
	| ""-""
	| ""!!""
	| ""~""
	| ""++""
	| ""--""
	| ""true""
	| ""false""
	;
binary_operator_declarator
	: type 'returnType' ""operator"" overloadable_binary_operator 'operator' ""("" type 'type' <Identifier> 'argument' "","" type 'type' <Identifier> 'argument' "")""
	;
overloadable_binary_operator
	: ""+""
	| ""-""
	| ""*""
	| ""/""
	| ""%""
	| ""&""
	| ""|""
	| ""^""
	| ""<<""
	| <gtgt>
	| ""==""
	| ""!!=""
	| <gt>
	| ""<""
	| "">=""
	| ""<=""
	;
conversion_operator_declarator
	: ""implicit"" ""operator"" type 'returnType' ""("" type 'type' <Identifier> 'argument' "")""
	| ""explicit"" ""operator"" type 'returnType' ""("" type 'type' <Identifier> 'argument' "")""
	;
operator_body
	: block 'block' {{MethodBody}}
	| "";"" {{MethodBody}}
	;
constructor_declaration
	: _attributes _constructor_modifiers constructor_declarator constructor_body {{}}
	;
_constructor_modifiers
	: 
	| constructor_modifiers
	;
constructor_modifiers
	: constructor_modifier 'modifier'
	| constructor_modifiers constructor_modifier 'modifier'
	;
constructor_modifier
	: ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""extern""
	;
constructor_declarator
	: <Identifier> ""("" _formal_parameters_list "")"" _constructor_initializer
	;
_constructor_initializer
	: 
	| constructor_initializer 'initializer'
	;
constructor_initializer
	: "":"" ""base"" ""("" _argument_list "")"" {{}}
	| "":"" ""this"" ""("" _argument_list "")"" {{}}
	;
constructor_body
	: block 'block'
	| "";""
	;
static_constructor_declaration
	: _attributes static_constructor_modifiers <Identifier> ""("" "")"" static_constructor_body {{}}
	;
# redefined in the unsafe section
static_constructor_modifiers
	: _extern ""static""
	| ""static"" _extern
	;
static_constructor_body
	: block 'block'
	| "";""
	;
# redefined in the unsafe section
#destructor_declaration
#	: _attributes _extern ""~"" <Identifier> ""("" "")"" destructor_body
#	;
#destructor_body
#	: block
#	| "";""
#	;

# B.2.8 Structs
struct_declaration
	: _attributes _struct_modifiers _partial ""struct"" <Identifier> _type_parameter_list _struct_interfaces _type_parameter_constraints_clauses struct_body _semicolon {{}}
	;
_struct_modifiers
	: 
	| struct_modifiers
	;
struct_modifiers
	: struct_modifier 'modifier'
	| struct_modifiers struct_modifier 'modifier'
	;
struct_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	;
_struct_interfaces
	:
	| struct_interfaces
	;
struct_interfaces
	: "":"" interface_type_list
	;
struct_body
	: ""{"" _struct_member_declarations ""}""
	;
_struct_member_declarations
	: 
	| struct_member_declarations
	;
struct_member_declarations
	: struct_member_declaration 'declaration'
	| struct_member_declarations struct_member_declaration 'declaration'
	;
struct_member_declaration
	: constant_declaration
	| field_declaration
	| method_declaration
	| property_declaration
	| event_declaration
	| indexer_declaration
	| operator_declaration
	| constructor_declaration
	| static_constructor_declaration
	| type_declaration
	;

# B.2.9 Arrays
_array_initializer
	:
	| array_initializer
	;
array_initializer
	: ""{"" _variable_initializer_list ""}"" {{}}
	| ""{"" variable_initializer_list "","" ""}"" {{}}
	;
_variable_initializer_list
	:
	| variable_initializer_list
	;
variable_initializer_list
	: variable_initializer 'initializer'
	| variable_initializer_list "","" variable_initializer 'initializer'
	;
variable_initializer
	: expression
	| array_initializer
	;

# B.2.10 Interfaces
interface_declaration
	: _attributes _interface_modifiers _partial ""interface"" 'interfaceToken' <Identifier> 'name' _type_parameter_list _interface_base _type_parameter_constraints_clauses interface_body _semicolon {{}}
	;
_interface_modifiers
	:
	| interface_modifiers
	;
interface_modifiers
	: interface_modifier 'modifier'
	| interface_modifiers interface_modifier 'modifier'
	;
interface_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	;
_interface_base
	: 
	| interface_base
	;
interface_base
	: "":"" 'colon' interface_type_list
	;
interface_body
	: ""{"" 'leftBrace' _interface_member_declarations ""}"" 'rightBrace'
	;
_interface_member_declarations
	:
	| interface_member_declarations
	;
interface_member_declarations
	: interface_member_declaration 'declaration'
	| interface_member_declarations interface_member_declaration 'declaration'
	;
interface_member_declaration
	: interface_method_declaration
	| interface_property_declaration
	| interface_event_declaration
	| interface_indexer_declaration
	;
interface_method_declaration
	: _attributes _new 'modifier' return_type 'type' <Identifier> 'name' _type_parameter_list ""("" 'leftParen' _formal_parameters_list "")"" 'rightParen' _type_parameter_constraints_clauses "";"" 'semicolon' {{}}
	;
interface_property_declaration
	: _attributes _new 'modifier' type 'type' <Identifier> 'name' ""{"" 'leftBrace' interface_accessors ""}"" 'rightBrace' {{}}
	;
interface_accessors	#This was changed to use the interface_(g/s)et_accessor
	: interface_get_accessor 'getAccessor'
	| interface_set_accessor 'setAccessor'
	| interface_get_accessor 'getAccessor' interface_set_accessor 'setAccessor'
	| interface_set_accessor 'setAccessor' interface_get_accessor 'getAccessor'
	;
interface_get_accessor
	: _attributes ""get"" 'accessorType' "";"" 'semicolon' {{InterfacePropertyAccessor}}
	;
interface_set_accessor
	: _attributes ""set"" 'accessorType' "";"" 'semicolon' {{InterfacePropertyAccessor}}
	;
interface_event_declaration
	: _attributes _new 'modifier' ""event"" 'eventToken' type 'type' <Identifier> 'name' "";"" 'semicolon' {{}}
	;
interface_indexer_declaration
	: _attributes _new 'modifier' type 'type' ""this"" 'thisToken' ""["" 'leftBracket' formal_parameters_list ""]"" 'rightBracket' ""{"" 'leftBrace' interface_accessors ""}"" 'rightBrace' {{}}
	;

# B.2.11 Enums
enum_declaration
	: _attributes _enum_modifers ""enum"" 'enumToken' <Identifier> 'name' _enum_base enum_body _semicolon {{}}
	;
_enum_base
	:
	| enum_base
	;
enum_base
	: "":"" integral_type 'type'
	;
enum_body
	: ""{"" 'leftBrace' _enum_member_declarations ""}"" 'rightBrace'
	| ""{"" 'leftBrace' enum_member_declarations "","" 'comma' ""}"" 'rightBrace'
	;
_enum_modifers
	:
	| enum_modifers
	;
enum_modifers
	: enum_modifer 'modifier'
	| enum_modifers enum_modifer 'modifier'
	;
enum_modifer
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	;
_enum_member_declarations
	:
	| enum_member_declarations
	;
enum_member_declarations
	: enum_member_declaration 'declaration'
	| enum_member_declarations "","" 'comma' enum_member_declaration 'declaration'
	;
enum_member_declaration
	: _attributes <Identifier> 'name' {{EnumDeclaration}}
	| _attributes <Identifier> 'name' ""="" 'equal' constant_expression 'value' {{EnumDeclaration}}
	;

# B.2.12 Delegates
delegate_declaration
	: _attributes _delegate_modifiers ""delegate"" 'delegateToken' return_type 'type' <Identifier> 'name' _type_parameter_list ""("" 'leftParen' _formal_parameters_list "")"" 'rightParen' _type_parameter_constraints_clauses "";"" 'semicolon' {{}}
	;
_delegate_modifiers
	:
	| delegate_modifiers
	;
delegate_modifiers
	: delegate_modifier 'modifier'
	| delegate_modifiers delegate_modifier 'modifier'
	;
delegate_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	;

# B.2.13 Attributes
_global_attributes
	:
	| global_attributes
	;
global_attributes
	: global_attribute_sections
	;
global_attribute_sections
	: global_attribute_section 'attribute'
	| global_attribute_sections global_attribute_section 'attribute'
	;
global_attribute_section
	: ""["" 'leftBracket' global_attribute_target_specifier attribute_list ""]"" 'rightBracket' {{Attribute}}
	| ""["" 'leftBracket' global_attribute_target_specifier attribute_list "","" 'comma' ""]"" 'rightBracket' {{Attribute}}
	;
global_attribute_target_specifier
	: global_attribute_target 'target' "":"" 'colon'
	;
global_attribute_target
	: ""assembly""
	| ""module""
	;
_attributes
	:
	| attributes
	;
attributes
	: attribute_sections
	;
attribute_sections
	: attribute_section 'attribute'
	| attribute_sections attribute_section 'attribute'
	;
attribute_section
	: ""["" 'leftBracket' _attribute_target_specifier attribute_list ""]"" 'rightBracket' {{Attribute}}
	| ""["" 'leftBracket' _attribute_target_specifier attribute_list "","" 'comma' ""]"" 'rightBracket' {{Attribute}}
	;
_attribute_target_specifier
	: 
	| attribute_target_specifier
	;
attribute_target_specifier
	: attribute_target 'target' "":"" 'colon'
	;
attribute_target
	: ""field""
	| ""event""
	| ""method""
	| ""param""
	| ""property""
	| ""return""
	| ""type""
	;
attribute_list
	: attribute 'attributeValue'
	| attribute_list "","" 'comma' attribute 'attributeValue'
	;
attribute
	: attribute_name 'name' _attribute_arguments {{AttributeValue}}
	;
attribute_name
	: type_name
	;
_attribute_arguments
	: 
	| attribute_arguments
	;
attribute_arguments
	: ""("" 'leftParen' _positional_argument_list "")"" 'rightParen'
	| ""("" 'leftParen' positional_argument_list "","" 'comma' named_argument_list "")"" 'rightParen'
	| ""("" 'leftParen' named_argument_list "")"" 'rightParen'
	;
_positional_argument_list
	:
	| positional_argument_list
	;
positional_argument_list
	: positional_argument 'argument'
	| positional_argument_list "","" 'comma' positional_argument 'argument'
	;
positional_argument
	: attribute_argument_expression
	;
named_argument_list
	: named_argument 'argument'
	| named_argument_list "","" 'comma' named_argument 'argument'
	;
named_argument
	: <Identifier> 'name' ""="" 'equal' attribute_argument_expression 'value' {{NamedArgument}}
	;
attribute_argument_expression
	: expression
	;

# B.1.8 Literals
literal
	: boolean_literal 'token' {{LiteralExpression}}
	| <IntegerLiteral> 'token' {{LiteralExpression}}
	| <RealLiteral> 'token' {{LiteralExpression}}
	| <CharacterLiteral> 'token' {{LiteralExpression}}
	| <StringLiteral> 'token' {{LiteralExpression}}
	| <NullLiteral> 'token' {{LiteralExpression}}
	;
boolean_literal
	: ""true""
	| ""false""
	;

# Misc
_semicolon
	:
	| "";"" 'semicolon'
	;
_new
	:
	| ""new""
	;
_partial
	:
	| ""partial"" 'partialToken'
	;
_extern
	:
	| ""extern"" 'modifier'
	;
_identifier
	:
	| <Identifier> 'name'
	;

# B.3 Unsafe code
class_modifier
	: ""unsafe""
	;
struct_modifier
	: ""unsafe""
	;
interface_modifier
	: ""unsafe""
	;
delegate_modifier
	: ""unsafe""
	;
field_modifier
	: ""unsafe""
	;
method_modifier
	: ""unsafe""
	;
property_modifier
	: ""unsafe""
	;
event_modifier
	: ""unsafe""
	;
indexer_modifier
	: ""unsafe""
	;
operator_modifier
	: ""unsafe""
	;
constructor_modifier
	: ""unsafe""
	;
destructor_declaration	# Changed from destructor_body to method_body since they are the same
	: _attributes _extern _unsafe ""~"" <Identifier> ""("" "")"" method_body 'body' {{}}
	| _attributes _unsafe _extern ""~"" <Identifier> ""("" "")"" method_body 'body' {{}}
	;
_unsafe
	:
	| ""unsafe"" 'modifier'
	;
static_constructor_modifiers
	: _extern _unsafe ""static""
	| _unsafe _extern ""static""
	| _extern ""static"" ""unsafe""
	| _unsafe ""static"" _extern
	| ""static"" _extern _unsafe
	| ""static"" _unsafe _extern
	;
embedded_statement
	: unsafe_statement
	;
unsafe_statement
	: ""unsafe"" block 'block' {{UnsafeStatement}}
	;
type
	: pointer_type
	;
pointer_type
	: unmanaged_type 'type' ""*"" {{}}
	| void_type 'type' ""*"" {{}}
	;
unmanaged_type
	: type
	;
primary_no_array_creation_expression
	: pointer_member_access
	| pointer_element_access
	| sizeof_expression
	;
unary_expression
	: pointer_indirection_expression
	| addressof_expression
	;
pointer_indirection_expression
	: ""*"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	;
pointer_member_access
	: primary_expression 'expression' ""->"" 'arrowToken' <Identifier> 'name' {{}}
	;
pointer_element_access
	: primary_no_array_creation_expression 'expression' ""["" expression 'indexExpression' ""]"" {{}}
	;
addressof_expression
	: ""&"" 'operator' unary_expression 'expression' {{PrefixExpression}}
	;
sizeof_expression
	: ""sizeof"" ""("" unmanaged_type 'type' "")"" {{}}
	;
embedded_statement
	: fixed_statement
	;
fixed_statement
	: ""fixed"" ""("" pointer_type 'type' fixed_pointer_declarators "")"" embedded_statement 'statement' {{}}
	;
fixed_pointer_declarators
	: fixed_pointer_declarator 'declarator'
	| fixed_pointer_declarators "","" fixed_pointer_declarator 'declarator'
	;
fixed_pointer_declarator
	: <Identifier> ""="" fixed_pointer_initializer {{}}
	;
fixed_pointer_initializer
	: ""&"" variable_reference 'expression'
	| expression 'expression'
	;
struct_member_declaration
	: fixed_size_buffer_declaration
	;
fixed_size_buffer_declaration
	: _attributes _fixed_size_buffer_modifiers ""fixed"" buffer_element_type 'type' fixed_size_buffer_declarators "";"" {{}}
	;
_fixed_size_buffer_modifiers
	: 
	| fixed_size_buffer_modifiers
	;
fixed_size_buffer_modifiers
	: fixed_size_buffer_modifier 'modifier'
	| fixed_size_buffer_modifiers fixed_size_buffer_modifier 'modifier'
	;
fixed_size_buffer_modifier
	: ""new""
	| ""public""
	| ""protected""
	| ""internal""
	| ""private""
	| ""unsafe""
	;
buffer_element_type
	: type
	;
fixed_size_buffer_declarators
	: fixed_size_buffer_declarator 'declarator'
	| fixed_size_buffer_declarators fixed_size_buffer_declarator 'declarator'
	;
fixed_size_buffer_declarator
	: <Identifier> 'name' ""["" constant_expression 'expression' ""]"" {{}}
	;
local_variable_initializer
	: stackalloc_initializer
	;
stackalloc_initializer
	: ""stackalloc"" unmanaged_type 'type' ""["" expression 'expression' ""]"" {{}}
	;
# Additions
void_type
	: ""void"" {{}}
	;"!

fileExtension
	^'.cs'!

fileExtensionType
	^'C# files'!

parseBlock: aString onError: aBlock 
	^self 
		parse: aString
		startingAt: self startingStateForblock
		onError: aBlock!

scannerClass
	^CSharpScanner!

startingStateForblock
	^5!

startingStateForcompilation_unit
	^1!

startingStateForexpression
	^4!

startingStateFornamespace_member_declaration
	^2!

startingStateForstatement
	^3! !
!CSharpParser class categoriesFor: #definitionComment!generated!public! !
!CSharpParser class categoriesFor: #fileExtension!file types!public! !
!CSharpParser class categoriesFor: #fileExtensionType!file types!public! !
!CSharpParser class categoriesFor: #parseBlock:onError:!accessing!public! !
!CSharpParser class categoriesFor: #scannerClass!generated-accessing!public! !
!CSharpParser class categoriesFor: #startingStateForblock!generated!public! !
!CSharpParser class categoriesFor: #startingStateForcompilation_unit!generated!public! !
!CSharpParser class categoriesFor: #startingStateForexpression!generated!public! !
!CSharpParser class categoriesFor: #startingStateFornamespace_member_declaration!generated!public! !
!CSharpParser class categoriesFor: #startingStateForstatement!generated!public! !

CSharpScanner guid: (GUID fromString: '{EBCBE406-F7FE-4D18-AC28-7045F3247261}')!
CSharpScanner comment: ''!
!CSharpScanner categoriesForClass!Unclassified! !
!CSharpScanner methodsFor!

emptySymbolTokenId
	^563!

errorTokenId
	^564!

gtgtId
	^152!

gtId
	^151!

IdentifierId
	^154!

scan1
	[self step.
	currentCharacter == $" ifTrue: [^self recordAndReportMatch: #(158)].
	currentCharacter == $\
		ifTrue:
			[self step.
			currentCharacter == $x ifTrue: [^self scan2].
			('Uu' includes: currentCharacter)
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[2
								timesRepeat:
									[self step.
									(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
							^self scan2].
					^self reportLastMatch].
			(('"''0\' includes: currentCharacter)
				or: [(currentCharacter between: $a and: $b) or: ['fnrtv' includes: currentCharacter]]) ifTrue: [^self scan1].
			^self reportLastMatch].
	currentCharacter <= ##(Character value: 9)
		or:
			[(currentCharacter between: ##(Character value: 11) and: $!!)
				or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]]] whileTrue.
	^self reportLastMatch!

scan10
	self recordMatch: #(155).
	self step.
	('Uu' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(155)].
	^self reportLastMatch!

scan11
	self recordMatch: #(155).
	self step.
	('Ll' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(155)].
	^self reportLastMatch!

scan12
	[self step.
	currentCharacter == $"
		ifTrue:
			[self recordMatch: #(158).
			self step.
			currentCharacter == $" ifTrue: [^self scan12].
			^self reportLastMatch]] repeat!

scan13
	[self step.
	currentCharacter == $`
		ifTrue:
			[self recordMatch: #(161).
			self step.
			currentCharacter == $` ifTrue: [^self scan13].
			^self reportLastMatch]] repeat!

scan2
	self step.
	(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifTrue: [^self scan1].
	^self reportLastMatch!

scan3
	self step.
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(157)].
	^self reportLastMatch!

scan4
	[self recordMatch: #(156).
	self step.
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan5].
	('DFMdfm' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(156)].
	^self reportLastMatch!

scan5
	self step.
	('+-' includes: currentCharacter) ifTrue: [self step].
	currentCharacter isDigit ifTrue: [^self scan6].
	^self reportLastMatch!

scan6
	[self recordMatch: #(156).
	self step.
	currentCharacter isDigit] whileTrue.
	('DFMdfm' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(156)].
	^self reportLastMatch!

scan7
	[self step.
	currentCharacter == $*
		ifTrue:
			[[self step.
			currentCharacter == $*] whileTrue.
			currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(153)].
			^self scan7]] repeat!

scan8
	self step.
	currentCharacter isDigit ifTrue: [^self scan4].
	^self reportLastMatch!

scan9
	[self recordMatch: #(155 156).
	self step.
	currentCharacter == $. ifTrue: [^self scan8].
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan5].
	('Ll' includes: currentCharacter) ifTrue: [^self scan10].
	('Uu' includes: currentCharacter) ifTrue: [^self scan11].
	('DFMdfm' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(156)].
	^self reportLastMatch!

scanForToken
	self step.
	currentCharacter == $!!
		ifTrue:
			[self recordMatch: #(14).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(37)].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $#
		ifTrue:
			[[self recordMatch: #(160).
			self step.
			currentCharacter <= ##(Character value: 9)
				or:
					[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
						or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
			^self reportLastMatch].
	currentCharacter == $%
		ifTrue:
			[self recordMatch: #(3).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(122)].
			^self reportLastMatch].
	currentCharacter == $&
		ifTrue:
			[self recordMatch: #(30).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(31)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(115)].
			^self reportLastMatch].
	currentCharacter == $'
		ifTrue:
			[self step.
			currentCharacter == $\
				ifTrue:
					[self step.
					currentCharacter == $x
						ifTrue:
							[self step.
							(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
								ifTrue:
									[3
										timesRepeat:
											[self step.
											currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(157)].
											(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
									^self scan3].
							^self reportLastMatch].
					('Uu' includes: currentCharacter)
						ifTrue:
							[self step.
							(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
								ifTrue:
									[3
										timesRepeat:
											[self step.
											(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
									self step.
									currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(157)].
									(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
										ifTrue:
											[3
												timesRepeat:
													[self step.
													(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
											^self scan3]].
							^self reportLastMatch].
					(('"''0\' includes: currentCharacter)
						or: [(currentCharacter between: $a and: $b) or: ['fnrtv' includes: currentCharacter]]) ifTrue: [^self scan3].
					^self reportLastMatch].
			(currentCharacter <= ##(Character value: 9)
				or:
					[(currentCharacter between: ##(Character value: 11) and: $&)
						or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]) ifTrue: [^self scan3].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(62)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(63)].
	currentCharacter == $*
		ifTrue:
			[self recordMatch: #(1).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(121)].
			^self reportLastMatch].
	currentCharacter == $+
		ifTrue:
			[self recordMatch: #(16).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(19)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(131)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(58)].
	currentCharacter == $-
		ifTrue:
			[self recordMatch: #(7).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(34)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(130)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(99)].
			^self reportLastMatch].
	currentCharacter == $.
		ifTrue:
			[self recordMatch: #(48).
			self step.
			currentCharacter isDigit ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $/
		ifTrue:
			[self recordMatch: #(2).
			self step.
			currentCharacter == $* ifTrue: [^self scan7].
			currentCharacter == $/
				ifTrue:
					[[self recordMatch: #(153).
					self step.
					currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(128)].
			^self reportLastMatch].
	currentCharacter == $0
		ifTrue:
			[self recordMatch: #(155 156).
			self step.
			currentCharacter == $. ifTrue: [^self scan8].
			currentCharacter isDigit ifTrue: [^self scan9].
			('Ee' includes: currentCharacter) ifTrue: [^self scan5].
			('Ll' includes: currentCharacter) ifTrue: [^self scan10].
			('Uu' includes: currentCharacter) ifTrue: [^self scan11].
			('Xx' includes: currentCharacter)
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[[self recordMatch: #(155).
							self step.
							('Ll' includes: currentCharacter) ifTrue: [^self scan10].
							('Uu' includes: currentCharacter) ifTrue: [^self scan11].
							currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]] whileTrue].
					^self reportLastMatch].
			('DFMdfm' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(156)].
			^self reportLastMatch].
	currentCharacter == $:
		ifTrue:
			[self recordMatch: #(26).
			self step.
			currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(39)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(45)].
	currentCharacter == $<
		ifTrue:
			[self recordMatch: #(59).
			self step.
			currentCharacter == $<
				ifTrue:
					[self recordMatch: #(4).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(118)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(5)].
			^self reportLastMatch].
	currentCharacter == $=
		ifTrue:
			[self recordMatch: #(46).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(18)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(33)].
			^self reportLastMatch].
	currentCharacter == $>
		ifTrue:
			[self recordMatch: #(151).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(6)].
			currentCharacter == $>
				ifTrue:
					[self recordMatch: #(152).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(132)]].
			^self reportLastMatch].
	currentCharacter == $?
		ifTrue:
			[self recordMatch: #(74).
			self step.
			currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(35)].
			^self reportLastMatch].
	currentCharacter == $@
		ifTrue:
			[self step.
			currentCharacter == $" ifTrue: [^self scan12].
			(currentCharacter isLetter or: [currentCharacter == $_])
				ifTrue:
					[[self recordMatch: #(154).
					self step.
					currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(71)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(65)].
	currentCharacter == $^
		ifTrue:
			[self recordMatch: #(29).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(117)].
			^self reportLastMatch].
	currentCharacter == $` ifTrue: [^self scan13].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(51)].
	currentCharacter == $|
		ifTrue:
			[self recordMatch: #(32).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(116)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(36)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(50)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter isDigit ifTrue: [^self scan9].
	currentCharacter isWhitespace
		ifTrue:
			[[self recordMatch: #(160).
			self step.
			currentCharacter isWhitespace] whileTrue.
			^self reportLastMatch].
	(currentCharacter isLetter or: [currentCharacter == $_])
		ifTrue:
			[[self recordMatch: #(154).
			self step.
			currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
	^self reportLastMatch!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #comment nil nil nil nil nil nil #whitespace #patternToken)! !
!CSharpScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!CSharpScanner categoriesFor: #errorTokenId!generated!public! !
!CSharpScanner categoriesFor: #gtgtId!generated!public! !
!CSharpScanner categoriesFor: #gtId!generated!public! !
!CSharpScanner categoriesFor: #IdentifierId!generated!public! !
!CSharpScanner categoriesFor: #scan1!generated!public! !
!CSharpScanner categoriesFor: #scan10!generated!public! !
!CSharpScanner categoriesFor: #scan11!generated!public! !
!CSharpScanner categoriesFor: #scan12!generated!public! !
!CSharpScanner categoriesFor: #scan13!generated!public! !
!CSharpScanner categoriesFor: #scan2!generated!public! !
!CSharpScanner categoriesFor: #scan3!generated!public! !
!CSharpScanner categoriesFor: #scan4!generated!public! !
!CSharpScanner categoriesFor: #scan5!generated!public! !
!CSharpScanner categoriesFor: #scan6!generated!public! !
!CSharpScanner categoriesFor: #scan7!generated!public! !
!CSharpScanner categoriesFor: #scan8!generated!public! !
!CSharpScanner categoriesFor: #scan9!generated!public! !
!CSharpScanner categoriesFor: #scanForToken!generated!public! !
!CSharpScanner categoriesFor: #tokenActions!generated!public! !

!CSharpScanner class methodsFor!

initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(154 'abstract' 104) #(154 'add' 81) #(154 'alias' 54) #(154 'as' 9) #(154 'ascending' 86) #(154 'assembly' 107) #(154 'base' 28) #(154 'bool' 40) #(154 'break' 148) #(154 'by' 126) #(154 'byte' 43) #(154 'case' 144) #(154 'catch' 140) #(154 'char' 67) #(154 'checked' 13) #(154 'class' 119) #(154 'const' 129) #(154 'continue' 147) #(154 'decimal' 41) #(154 'default' 17) #(154 'delegate' 27) #(154 'descending' 125) #(154 'do' 150) #(154 'double' 69) #(154 'else' 142) #(154 'enum' 108) #(154 'equals' 72) #(154 'event' 80) #(154 'explicit' 106) #(154 'extern' 55) #(154 'false' 94) #(154 'field' 111) #(154 'finally' 137) #(154 'fixed' 101) #(154 'float' 70) #(154 'for' 145) #(154 'foreach' 149) #(154 'from' 20) #(154 'get' 78) #(154 'goto' 146) #(154 'group' 127) #(154 'if' 123) #(154 'implicit' 113) #(154 'in' 21) #(154 'int' 47) #(154 'interface' 105) #(154 'internal' 110) #(154 'into' 38) #(154 'is' 15) #(154 'join' 57) #(154 'let' 22) #(154 'lock' 138) #(154 'long' 75) #(154 'method' 102) #(154 'module' 112) #(154 'namespace' 49) #(154 'new' 11) #(154 'null' 159) #(154 'object' 73) #(154 'on' 25) #(154 'operator' 91) #(154 'orderby' 114) #(154 'out' 61) #(154 'override' 84) #(154 'param' 109) #(154 'params' 77) #(154 'partial' 97) #(154 'private' 87) #(154 'property' 103) #(154 'protected' 95) #(154 'public' 133) #(154 'readonly' 92) #(154 'ref' 60) #(154 'remove' 82) #(154 'return' 141) #(154 'sbyte' 42) #(154 'sealed' 89) #(154 'select' 124) #(154 'set' 79) #(154 'short' 44) #(154 'sizeof' 100) #(154 'stackalloc' 76) #(154 'static' 88) #(154 'string' 64) #(154 'struct' 93) #(154 'switch' 136) #(154 'this' 66) #(154 'throw' 134) #(154 'true' 85) #(154 'try' 135) #(154 'type' 96) #(154 'typeof' 10) #(154 'uint' 56) #(154 'ulong' 68) #(154 'unchecked' 12) #(154 'unsafe' 98) #(154 'ushort' 53) #(154 'using' 52) #(154 'var' 120) #(154 'virtual' 90) #(154 'void' 24) #(154 'volatile' 83) #(154 'where' 23) #(154 'while' 143) #(154 'yield' 139))
		do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last].
	^keywordMap! !
!CSharpScanner class categoriesFor: #initializeKeywordMap!generated-initialization!public! !

"Binary Globals"!

