| package |
package := Package name: 'SmaCC Development'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains the classes used to create a new parser. It is only needed when developing parsers. While these classes can be used directly, it is suggested that you use the GUI in the SmaCC Development UI package to create your parsers. If you wish to use the code directly, you can browse the code in the SmaCC Tests for examples. 

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #SmaCCAcceptAction;
	add: #SmaCCAction;
	add: #SmaCCAmbiguousAction;
	add: #SmaCCCharacterEdge;
	add: #SmaCCCharacterRENode;
	add: #SmaCCCharacterSet;
	add: #SmaCCClassDefinition;
	add: #SmaCCCodeGenerator;
	add: #SmaCCCompilationNotification;
	add: #SmaCCCompositeAction;
	add: #SmaCCCreateNodeReduceCode;
	add: #SmaCCDefaultNodeReduceCode;
	add: #SmaCCDefaultReduceCode;
	add: #SmaCCDefinitionParser;
	add: #SmaCCDefinitionScanner;
	add: #SmaCCDuplicateNodeEliminator;
	add: #SmaCCEdge;
	add: #SmaCCEpsilonRemoval;
	add: #SmaCCGrammar;
	add: #SmaCCGrammarCompiler;
	add: #SmaCCGrammarItem;
	add: #SmaCCGraphAlgorithm;
	add: #SmaCCIntegerSet;
	add: #SmaCCItemSet;
	add: #SmaCCLR1Item;
	add: #SmaCCNFAtoDFA;
	add: #SmaCCNode;
	add: #SmaCCNodeCalculation;
	add: #SmaCCNodeClassDefinition;
	add: #SmaCCNonTerminalSymbol;
	add: #SmaCCNotRENode;
	add: #SmaCCOrRENode;
	add: #SmaCCPreferredCompositeAction;
	add: #SmaCCPrimitiveAction;
	add: #SmaCCReduceAction;
	add: #SmaCCReduceActionGenerator;
	add: #SmaCCReduceCode;
	add: #SmaCCRegularExpressionNode;
	add: #SmaCCRejectAction;
	add: #SmaCCRepeatingRENode;
	add: #SmaCCRHS;
	add: #SmaCCScannerCompiler;
	add: #SmaCCScannerDefinition;
	add: #SmaCCSequenceRENode;
	add: #SmaCCSet;
	add: #SmaCCShiftAction;
	add: #SmaCCSingleVariableReduceCode;
	add: #SmaCCSmalltalkCodeGenerator;
	add: #SmaCCSourceReduceCode;
	add: #SmaCCStartingSymbol;
	add: #SmaCCStateEdge;
	add: #SmaCCSymbol;
	add: #SmaCCSymbolSet;
	add: #SmaCCSymbolTableIndex;
	add: #SmaCCTerminalSymbol;
	add: #SmaCCVariableCalculation;
	add: #SmaCCVariableDefinition;
	add: #SmaCCVariableReduceCode;
	add: #SmaCCVisitorClassDefinition;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\..\Refactoring Browser\Change Objects\RBChangeObjects';
	add: '..\..\Refactoring Browser\Parser\RBParser';
	add: '..\..\Refactoring Browser\Refactorings\RBRefactorings';
	add: '..\SmaCC GLR Runtime\SmaCC GLR Runtime';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	add: '..\..\..\Object Arts\Dolphin\System\Compiler\Smalltalk Parser';
	yourself).

package!

"Class Definitions"!

Object subclass: #SmaCCAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCClassDefinition
	instanceVariableNames: 'name subclasses grammar class superclass isRoot'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCCodeGenerator
	instanceVariableNames: 'parserClass scannerClass model codeStream reduceActionCache ambiguousActions grammar'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: 'codeTemplates'!
Object subclass: #SmaCCEdge
	instanceVariableNames: 'toNode transitionObjects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCGrammar
	instanceVariableNames: 'type shiftReduceTable symbols scannerDefinition otherStartingSymbols classDefinitions prefix suffix codeGenerator isGLR ignoreCase ignoredVariables annotateTokens errorSymbol emptySymbol sentinelSymbol'
	classVariableNames: 'MaximumCharacterValue TokenNameBlock TokenNameMap'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCGrammarCompiler
	instanceVariableNames: 'shiftTable itemSets startingStateMap actions parserDefinitionString scannerCompiler grammar codeGenerator reduceTable'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCGrammarItem
	instanceVariableNames: 'variableDefinitions grammar'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCGraphAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCLR1Item
	instanceVariableNames: 'rhs location followers itemSet'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCNode
	instanceVariableNames: 'transitions action id'
	classVariableNames: 'NextId'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCNodeCalculation
	instanceVariableNames: 'grammar classes variableSymbols singleVariableSymbols'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCReduceActionGenerator
	instanceVariableNames: 'rhs index generator variableName currentIndex currentSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCReduceCode
	instanceVariableNames: 'rhs cachedTypes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCRegularExpressionNode
	instanceVariableNames: 'action position states'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCScannerCompiler
	instanceVariableNames: 'grammar codeGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCScannerDefinition
	instanceVariableNames: 'tokens states excludeStates'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCSymbolTableIndex
	instanceVariableNames: 'index symbol'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCVariableCalculation
	instanceVariableNames: 'grammar todo dependentsMap newVariables ourType currentRHS previousVariables'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Object subclass: #SmaCCVariableDefinition
	instanceVariableNames: 'variableName isCollection baseType isAlwaysAssigned getterMethodName setterMethodName index'
	classVariableNames: 'PluralNameBlock PluralNames'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Collection subclass: #SmaCCIntegerSet
	instanceVariableNames: 'start run data'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Collection subclass: #SmaCCSet
	instanceVariableNames: 'characters objects'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Set variableSubclass: #SmaCCItemSet
	instanceVariableNames: 'type previousItemSets grammar'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCIntegerSet subclass: #SmaCCCharacterSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Notification subclass: #SmaCCCompilationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
Model subclass: #SmaCCSymbolSet
	instanceVariableNames: 'symbols components dependents'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCAction subclass: #SmaCCCompositeAction
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCAction subclass: #SmaCCPrimitiveAction
	instanceVariableNames: 'lr1Item'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCCompositeAction subclass: #SmaCCAmbiguousAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCCompositeAction subclass: #SmaCCPreferredCompositeAction
	instanceVariableNames: 'preferredAction'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCPrimitiveAction subclass: #SmaCCAcceptAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCPrimitiveAction subclass: #SmaCCReduceAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCPrimitiveAction subclass: #SmaCCRejectAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCPrimitiveAction subclass: #SmaCCShiftAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCClassDefinition subclass: #SmaCCNodeClassDefinition
	instanceVariableNames: 'productions variables extraAttributes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCClassDefinition subclass: #SmaCCVisitorClassDefinition
	instanceVariableNames: 'nodeClassDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCCodeGenerator subclass: #SmaCCSmalltalkCodeGenerator
	instanceVariableNames: 'isExpressions parseTreeCache'
	classVariableNames: 'MaxJumpSize'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCEdge subclass: #SmaCCCharacterEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCEdge subclass: #SmaCCStateEdge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGrammarItem subclass: #SmaCCRHS
	instanceVariableNames: 'collection reduceAction variableNameMap nodeClassDefinition productionSymbol'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGrammarItem subclass: #SmaCCSymbol
	instanceVariableNames: 'name precedence firstTerminals'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCSymbol subclass: #SmaCCNonTerminalSymbol
	instanceVariableNames: 'productions'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCSymbol subclass: #SmaCCTerminalSymbol
	instanceVariableNames: 'regularExpression createIdMethod'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCNonTerminalSymbol subclass: #SmaCCStartingSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGraphAlgorithm subclass: #SmaCCDuplicateNodeEliminator
	instanceVariableNames: 'comparisonState root'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGraphAlgorithm subclass: #SmaCCEpsilonRemoval
	instanceVariableNames: 'nodeMap'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGraphAlgorithm subclass: #SmaCCNFAtoDFA
	instanceVariableNames: 'mergedStates'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParser subclass: #SmaCCDefinitionParser
	instanceVariableNames: 'scannerDefinition grammar defaultClasses'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCCreateNodeReduceCode
	instanceVariableNames: 'classDefinition index'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCDefaultNodeReduceCode
	instanceVariableNames: 'index'
	classVariableNames: 'IsCaching'
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCDefaultReduceCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCSingleVariableReduceCode
	instanceVariableNames: 'indices'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCSourceReduceCode
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCReduceCode subclass: #SmaCCVariableReduceCode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRegularExpressionNode subclass: #SmaCCCharacterRENode
	instanceVariableNames: 'characters ignoreCase'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRegularExpressionNode subclass: #SmaCCNotRENode
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRegularExpressionNode subclass: #SmaCCOrRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRegularExpressionNode subclass: #SmaCCRepeatingRENode
	instanceVariableNames: 'node minimumMatches maximumMatches'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCRegularExpressionNode subclass: #SmaCCSequenceRENode
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #SmaCCDefinitionScanner
	instanceVariableNames: 'parseSourceSelector'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

SmaCCAction guid: (GUID fromString: '{53F89C76-610A-4C4F-AB54-97F9592D8A5E}')!
SmaCCAction comment: 'SmaCCAction is an abstract class that represent actions (shift, reduce, accept, reject) in the LR parser to be performed for a specific state/symbol pair. 

Subclasses must implement the following messages:
	accessing
		id
		lr1Item
	private
		mergeWith:prefer:

'!
!SmaCCAction categoriesForClass!Unclassified! !
!SmaCCAction methodsFor!

= anObject
	^self class = anObject class and: [self symbol = anObject symbol and: [self rhs = anObject rhs]]!

hash
	^self symbol hash bitXor: self rhs hash!

id
	^self subclassResponsibility!

isAmbiguous
	^false!

isReduce
	^false!

isReject
	^false!

isShift
	^false!

lr1Item
	^self subclassResponsibility!

mergeWith: aSmaCCAction prefer: aClass
	^self subclassResponsibility!

precedence
	^self lr1Item precedence!

preferredAction
	^self!

rhs
	^self lr1Item rhs!

signalAllWarnings!

size
	^self rhs size!

symbol
	^self rhs productionSymbol! !
!SmaCCAction categoriesFor: #=!comparing!private! !
!SmaCCAction categoriesFor: #hash!comparing!private! !
!SmaCCAction categoriesFor: #id!accessing!private! !
!SmaCCAction categoriesFor: #isAmbiguous!private!testing! !
!SmaCCAction categoriesFor: #isReduce!private!testing! !
!SmaCCAction categoriesFor: #isReject!private!testing! !
!SmaCCAction categoriesFor: #isShift!private!testing! !
!SmaCCAction categoriesFor: #lr1Item!accessing!private! !
!SmaCCAction categoriesFor: #mergeWith:prefer:!merging!private! !
!SmaCCAction categoriesFor: #precedence!accessing!private! !
!SmaCCAction categoriesFor: #preferredAction!accessing!private! !
!SmaCCAction categoriesFor: #rhs!accessing!private! !
!SmaCCAction categoriesFor: #signalAllWarnings!error handling!private! !
!SmaCCAction categoriesFor: #size!accessing!private! !
!SmaCCAction categoriesFor: #symbol!accessing!private! !

!SmaCCAction class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCAction class categoriesFor: #new!instance creation!private! !

SmaCCClassDefinition guid: (GUID fromString: '{C8A46140-D68C-4A00-A81E-52D45FC5061A}')!
SmaCCClassDefinition comment: 'SmaCCClassDefinition is an abstract class that represents a class to be created when compiling the parser''s parse trees.

Instance Variables:
	class	<RBClass>	the model''s class object that is created
	grammar	<SmaCCGrammar>	the grammar that owns this class
	isRoot	<Boolean>	is this the root class that we are generating
	name	<String>	the name of the class
	subclasses	<Collection of: SmaCCNodeClassDefinition>	our subclasses
	superclass	<SmaCCNodeClassDefinition>	our superclass

'!
!SmaCCClassDefinition categoriesForClass!Unclassified! !
!SmaCCClassDefinition methodsFor!

addSubclass: aSmaCCClassDefinition 
	subclasses add: aSmaCCClassDefinition!

beRoot
	isRoot := true!

codeGenerator
	^grammar codeGenerator!

commonSuperclass: aSmaCCClassDefinition
	(aSmaCCClassDefinition hierarchyIncludes: self) ifTrue: [^self].
	superclass isNil ifTrue: [^nil].
	^superclass commonSuperclass: aSmaCCClassDefinition!

compileMethodsAndVariables!

fullName
	^self codeGenerator namespaceName , self name!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar!

hierarchyCount
	^superclass isNil ifTrue: [0] ifFalse: [superclass hierarchyCount + 1]!

hierarchyIncludes: aSmaCCClassDefinition
	^self = aSmaCCClassDefinition or: [superclass notNil and: [superclass hierarchyIncludes: aSmaCCClassDefinition]]!

initialize
	super initialize.
	isRoot := false.
	subclasses := OrderedCollection new!

isRoot
	^isRoot!

isSortedBefore: aSmaCCClassDefinition
	^self hierarchyCount < aSmaCCClassDefinition hierarchyCount
		or:
			[self hierarchyCount = aSmaCCClassDefinition hierarchyCount
				and: [self name < aSmaCCClassDefinition name]]!

modelClass
	^class!

modelClass: aRBClass
	class := aRBClass!

name
	^name!

name: anObject
	name := anObject!

printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPutAll: '-class(';
		nextPutAll: self name;
		nextPut: $)!

removeSubclass: aSmaCCClassDefinition
	subclasses remove: aSmaCCClassDefinition ifAbsent: []!

rootClassName
	^Object fullName!

subclasses
	^subclasses!

superclass
	^superclass!

superclass: anObject
	superclass notNil ifTrue: [superclass removeSubclass: self].
	superclass := anObject.
	superclass notNil ifTrue: [superclass addSubclass: self]!

superclassName
	^self isRoot ifTrue: [self rootClassName] ifFalse: [superclass fullName]!

temporaryNameFor: fullName
	^(fullName first isVowel ifTrue: ['an'] ifFalse: ['a']) , fullName!

temporaryVariableName
	^self temporaryNameFor: self name!

withAllSubclasses
	| classes index |
	classes := OrderedCollection with: self.
	index := 1.
	[index <= classes size]
		whileTrue:
			[classes addAll: (classes at: index) subclasses.
			index := index + 1].
	^classes! !
!SmaCCClassDefinition categoriesFor: #addSubclass:!accessing-hierarchy!private! !
!SmaCCClassDefinition categoriesFor: #beRoot!accessing!private! !
!SmaCCClassDefinition categoriesFor: #codeGenerator!accessing!private! !
!SmaCCClassDefinition categoriesFor: #commonSuperclass:!accessing-hierarchy!private! !
!SmaCCClassDefinition categoriesFor: #compileMethodsAndVariables!compiling!private! !
!SmaCCClassDefinition categoriesFor: #fullName!accessing!private! !
!SmaCCClassDefinition categoriesFor: #grammar:!initialize-release!private! !
!SmaCCClassDefinition categoriesFor: #hierarchyCount!accessing-hierarchy!private! !
!SmaCCClassDefinition categoriesFor: #hierarchyIncludes:!private!testing! !
!SmaCCClassDefinition categoriesFor: #initialize!initialize-release!public! !
!SmaCCClassDefinition categoriesFor: #isRoot!private!testing! !
!SmaCCClassDefinition categoriesFor: #isSortedBefore:!private!testing! !
!SmaCCClassDefinition categoriesFor: #modelClass!accessing!private! !
!SmaCCClassDefinition categoriesFor: #modelClass:!initialize-release!private! !
!SmaCCClassDefinition categoriesFor: #name!accessing!private! !
!SmaCCClassDefinition categoriesFor: #name:!initialize-release!private! !
!SmaCCClassDefinition categoriesFor: #printOn:!printing!private! !
!SmaCCClassDefinition categoriesFor: #removeSubclass:!accessing-hierarchy!private! !
!SmaCCClassDefinition categoriesFor: #rootClassName!private! !
!SmaCCClassDefinition categoriesFor: #subclasses!accessing-hierarchy!private! !
!SmaCCClassDefinition categoriesFor: #superclass!accessing!private! !
!SmaCCClassDefinition categoriesFor: #superclass:!initialize-release!private! !
!SmaCCClassDefinition categoriesFor: #superclassName!accessing!private! !
!SmaCCClassDefinition categoriesFor: #temporaryNameFor:!compiling!private! !
!SmaCCClassDefinition categoriesFor: #temporaryVariableName!accessing!private! !
!SmaCCClassDefinition categoriesFor: #withAllSubclasses!accessing-hierarchy!private! !

!SmaCCClassDefinition class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCClassDefinition class categoriesFor: #new!instance creation!private! !

SmaCCCodeGenerator guid: (GUID fromString: '{3D6A315F-DE64-4EBC-964D-B79573A80274}')!
SmaCCCodeGenerator comment: 'SmaCCCodeGenerator is an abstract class that is used to generate code. Subclasses are used to generate code for a particular language (e.g., Smalltalk, Java, etc.).

Subclasses must implement the following messages:
	code generation templates
		comment:
		method:type:
		method:type:argumentName:argumentType:
		method:type:argumentName:argumentType:argumentName:argumentType:
		reduceAction:
		send:to:with:
		send:to:with:with:
		send:to:with:with:with:
		superMessage:
		superMessage:argument:
		superMessage:argument:argument:
		variableReference:in:
	compiling
		compileChanges
		compileMethodWithoutFormattingIn:
		compileScannerClassIntoParser
		outputStreamClass
		removeOldMethods
	compiling-nodes
		compileInitializeMethod:
	compiling-scanner
		acceptStateEdge:
		closestIsExpressionsFor:seen:
		compileKeywordInitializerUsing:
		defineClass:asSubclassOf:
		outputInvertedMatchFor:on:
		outputIsSelector:on:
		outputMatchFor:on:without:
		scannerActionFor:
		scannerClass:
		selectorMap:
		writeMatchingCodeFor:
	private
		addVariable:forDefinition:
		defaultNodeReductionSource:
		removeOldMethodsFrom:
		send:to:
		writeTransitionTableEntry:on:firstIsType:
	reduction table
		basicCompileSourceFor:
		defaultReductionSource

Instance Variables
	ambiguousActions	<SequenceableCollection of: SequenceableCollection>	the ambiguous actions for the grammar
	codeStream	<Stream>	a stream for writing the code
	grammar	<SmaCCGrammar>	the grammar we are compiling
	model	<RBRootNamespace>	the model for the system that we are compiling
	parserClass	<RBClass>	the model''s class for the parser
	reduceActionCache	<Dictionary key: SmaCCReduceAction value: String>	mapping from reduce actions to their code
	scannerClass	<RBClass>	the model''s class for the scanner'!
!SmaCCCodeGenerator categoriesForClass!Unclassified! !
!SmaCCCodeGenerator methodsFor!

acceptCharacterEdge: aSmaCCCharacterEdge seen: aCollection
	| stream |
	stream := WriteStream with: String new.
	aSmaCCCharacterEdge transitionObjects size + aCollection size > SmaCCGrammar maximumCharacterValue
		ifTrue: [^self trueValue].
	stream nextPut: $(.
	aSmaCCCharacterEdge transitionObjects size = SmaCCGrammar maximumCharacterValue
		ifTrue: [self outputInvertedMatchFor: aSmaCCCharacterEdge on: stream]
		ifFalse:
			[self
				outputMatchFor: aSmaCCCharacterEdge
				seen: aCollection
				on: stream].
	stream nextPut: $).
	^stream contents!

acceptStateEdge: aSmaCCStateEdge
	self subclassResponsibility!

addParentAssignmentFor: aSmaCCVariableDefinition to: valueString
	aSmaCCVariableDefinition isBaseNodeType ifFalse: [^self].
	aSmaCCVariableDefinition isCollection
		ifTrue:
			[self
				nextPutStatement:
					(self
						send: #setParents:to:
						to: self receiverName
						with:
							(self cast: (self variableReference: aSmaCCVariableDefinition in: self receiverName) to: self collectionType)
						with: valueString)]
		ifFalse:
			[self nextPutLine: (self notNilCheckFor: (self variableReference: aSmaCCVariableDefinition in: self receiverName)).
			self
				nextPutStatement:
					(self
						send: #parent:
						to: (self cast: (self variableReference: aSmaCCVariableDefinition in: self receiverName) to: 'ParseNode')
						with: valueString).
			self nextPutStatement: self endConditionalString]!

addVariable: aSmaCCVariableDefinition forDefinition: aSmaCCNodeClassDefinition
	self subclassResponsibility!

ambiguousTableEntryFor: aCollection
	| entry |
	entry := aCollection asArray.
	^ambiguousActions
		indexOf: entry
		ifAbsent:
			[ambiguousActions add: entry.
			ambiguousActions size]!

argumentIndex: anInteger
	^self at: 'nodes' index: anInteger!

argumentIndex: anInteger subIndex: subIndex
	^self at: (self cast: (self argumentIndex: anInteger) to: self collectionType) index: subIndex!

assignVariable: variableName in: aSmaCCRHS at: key
	| variableIndex value |
	variableIndex := aSmaCCRHS productionSymbol indexOfVariable: variableName.
	value := self argumentIndex: key.
	self
		nextPutStatement:
			((aSmaCCRHS productionSymbol isCollection: variableName)
				ifTrue: [self addSendTo: (self cast: (self at: 'result' index: variableIndex) to: self collectionType) with: value]
				ifFalse:
					[self
						assignArray: 'result'
						index: variableIndex
						to: value])!

asStatement: methodMap forNode: aSmaCCNode lastNeedsReturn: aBoolean
	| transitions seen |
	aSmaCCNode hasSimpleLoop ifTrue: [self nextPutLine: self startDoWhileLoop].
	self writeMatchingCodeFor: aSmaCCNode.
	transitions := self sortedTransitionsForNode: aSmaCCNode.
	seen := (transitions notEmpty ifTrue: [transitions first setClass] ifFalse: [Set]) new.
	transitions
		do:
			[:each | 
			each to = aSmaCCNode
				ifTrue: [self nextPutStatement: (self endDoWhileLoopWithClause: (each dispatchTo: self seen: seen))]
				ifFalse:
					[self nextPutLine: (self startIfWithClause: (each dispatchTo: self seen: seen)).
					(methodMap at: each to ifAbsent: [nil])
						ifNil:
							[self
								asStatement: methodMap
								forNode: each to
								lastNeedsReturn: each ~= transitions last]
						ifNotNil: [:methodCall | self nextPutStatement: (self return: (self send: methodCall to: self receiverName))].
					self nextPutStatement: self endConditionalString].
			seen addAll: each transitionObjects].
	(aBoolean and: [aSmaCCNode transitions notEmpty or: [aSmaCCNode action isNil]])
		ifTrue: [self nextPutStatement: (self return: (self send: #reportLastMatch to: self receiverName))]!

basicCompileSourceFor: aSmaCCReduceAction
	self subclassResponsibility!

closestIsExpressionsFor: aSmaCCCharacterEdge seen: anObject
	self subclassResponsibility!

codeStream
	codeStream isNil ifTrue: [codeStream := self outputStream].
	^codeStream!

comment: aString
	self subclassResponsibility!

commonSupertypeBetween: modelClass and: anotherModelClass
	^(anotherModelClass includesClass: modelClass)
		ifTrue: [modelClass]
		ifFalse:
			[(modelClass includesClass: anotherModelClass)
				ifTrue: [anotherModelClass]
				ifFalse: [self commonSupertypeBetween: modelClass superclass and: anotherModelClass]]!

commonSupertypeOf: aCollection
	aCollection isEmpty ifTrue: [^model classFor: Object].
	^aCollection inject: aCollection anyOne into: [:sum :each | self commonSupertypeBetween: sum and: each]!

compileAcceptNodeMethodFor: aSmaCCVisitorClassDefinition rootNode: aSmaCCClassDefinition
	"Only needed if we are using a brain dead type system"!

compileAcceptVisitorMethod: aSmaCCNodeClassDefinition visitor: aSmaCCVisitorClassDefinition
	aSmaCCNodeClassDefinition isRoot ifTrue: [self startPublicVirtualMethod] ifFalse: [self startPublicOverrideMethod].
	self
		nextPutLine:
				(self
						method: #acceptVisitor:
						type: self objectType
						argumentName: aSmaCCNodeClassDefinition tempNodeName , 'Visitor'
						argumentType: aSmaCCVisitorClassDefinition fullName);
		nextPutStatement:
				(self
						return:
							(self
								send: 'visit' , aSmaCCNodeClassDefinition name , ':'
								to: aSmaCCNodeClassDefinition tempNodeName , 'Visitor'
								with: self receiverName));
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileAmbiguousTransitions
	| stream |
	ambiguousActions isEmpty ifTrue: [^self].
	stream := self outputStream.
	stream nextPutAll: self newUnsignedShortArrayArray.
	ambiguousActions do: 
			[:each | 
			self 
				writeTransitionTableEntry: each
				on: stream
				firstIsType: false]
		separatedBy: [stream nextPutAll: self literalArraySeparator].
	stream
		cr;
		tab;
		nextPutAll: self endLiteralArray.
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'ambiguousTransitions' type: self unsignedShortArrayArray);
		nextPutStatement: (self return: stream contents);
		endMethod;
		compileMethodWithoutFormattingIn: parserClass!

compileChanges
	self subclassResponsibility!

compileChildrenMethod: aSmaCCNodeClassDefinition
	aSmaCCNodeClassDefinition nodeVariableDefinitions isEmpty ifTrue: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'children' type: self collectionType);
		nextPutLine: (self variableDeclaration: 'children' ofType: self collectionType);
		nextPutStatement: (self assignmentTo: 'children' from: (self superMessage: 'children')).
	aSmaCCNodeClassDefinition nodeVariableDefinitions
		do:
			[:each | 
			each isAlwaysAssigned
				ifFalse: [self nextPutLine: (self notNilCheckFor: (self variableReference: each in: self receiverName))].
			each isCollection
				ifTrue:
					[each isNodeCollectionType
						ifTrue:
							[self nextPutStatement: (self addAllSendTo: 'children' with: (self variableReference: each in: self receiverName))]
						ifFalse:
							[self
								nextPutLine: (self iterateObjects: (self variableReference: each in: self receiverName) name: 'each');
								nextPutLine: (self isKindOfTest: 'each' class: aSmaCCNodeClassDefinition grammar rootDefinition fullName);
								nextPutLine: (self addSendTo: 'children' with: 'each');
								nextPutLine: self endConditionalString;
								nextPutStatement: self endIteratorString]]
				ifFalse:
					[each isNodeType
						ifFalse:
							[self
								nextPutLine:
									(self
										isKindOfTest: (self variableReference: each in: self receiverName)
										class: aSmaCCNodeClassDefinition grammar rootDefinition fullName)].
					self nextPutStatement: (self addSendTo: 'children' with: (self variableReference: each in: self receiverName)).
					each isNodeType ifFalse: [self nextPutStatement: self endConditionalString]].
			each isAlwaysAssigned ifFalse: [self nextPutStatement: self endConditionalString]].
	self
		nextPutStatement: (self return: 'children');
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileCopyInContextMethod: aSmaCCNodeClassDefinition
	aSmaCCNodeClassDefinition nodeVariableDefinitions isEmpty ifTrue: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine:
				(self
						method: #copyInContext:
						type: 'ParseNode'
						argumentName: 'aDictionary'
						argumentType: self dictionaryType);
		nextPutLine: (self variableDeclaration: aSmaCCNodeClassDefinition copyName ofType: aSmaCCNodeClassDefinition fullName);
		nextPutStatement:
				(self
						assignmentTo: aSmaCCNodeClassDefinition copyName
						from: (self cast: (self superMessage: #copyInContext: argument: 'aDictionary') to: aSmaCCNodeClassDefinition fullName)).
	aSmaCCNodeClassDefinition nodeVariableDefinitions
		do:
			[:each | 
			self
				possiblyGuardNil: each
				around:
					[each isPossibleNodeType
						ifTrue:
							[each isNodeType
								ifFalse:
									[self
										nextPutLine:
											(self isKindOfTest: (self variableReference: each in: self receiverName) class: (model classFor: SmaCCParseNode) name)].
							self
								nextPutStatement:
									(self
										send: each setterMethodName
										to: aSmaCCNodeClassDefinition copyName
										with:
											(self
												cast:
													(self
														send: #copyInContext:
														to: (self variableReference: each in: self receiverName)
														with: 'aDictionary')
												to: each type name)).
							each isNodeType ifFalse: [self nextPutStatement: self endConditionalString]]
						ifFalse:
							[self
								nextPutStatement:
									(self
										send: each setterMethodName
										to: aSmaCCNodeClassDefinition copyName
										with:
											(self
												copy: (self variableReference: each in: self receiverName)
												inContext: 'aDictionary'
												onlyNodes: each isNodeCollectionType))]]].
	self
		nextPutStatement: (self return: aSmaCCNodeClassDefinition copyName);
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileDefinitionComment: aString
	self
		startPublicVirtualMethod;
		nextPutLine: (self method: #definitionComment type: self voidType);
		nextPutLine: (self comment: aString);
		endMethod.
	self compileMethodWithoutFormattingIn: parserClass metaclass!

compileEmptySymbolTokenId: emptySymbolId 
	self compileTokenIdMethodNamed: 'emptySymbolToken' withId: emptySymbolId!

compileEqualMethod: aSmaCCNodeClassDefinition
	aSmaCCNodeClassDefinition variableDefinitions isEmpty ifTrue: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine:
				(self
						method: '='
						type: self booleanType
						argumentName: 'anObject'
						argumentType: self objectType);
		nextPutStatement: (self ifFalseReturn: (self superMessage: '=' argument: 'anObject')).
	aSmaCCNodeClassDefinition variableDefinitions
		do:
			[:each | 
			self
				nextPutStatement:
					(self
						ifFalseReturn:
							(self
								compareEqual: (self variableReference: each in: self receiverName)
								to: (self variableReference: each in: (self cast: 'anObject' to: aSmaCCNodeClassDefinition fullName))))].
	self
		nextPutStatement: (self return: self trueValue);
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileErrorSymbolTokenId: errorTokenId
	self compileTokenIdMethodNamed: 'errorToken' withId: errorTokenId!

compileGetterAndSetter: aSmaCCVariableDefinition forDefinition: aSmaCCNodeClassDefinition
	| type typeName variableName |
	variableName := self nonKeywordNameFor: aSmaCCVariableDefinition sourceVariableName.
	type := aSmaCCVariableDefinition type.
	self setGetterMethodNameTo: aSmaCCVariableDefinition withName: variableName.
	(aSmaCCNodeClassDefinition modelClass definesMethod: variableName asSymbol)
		ifFalse:
			[self
				startPublicVirtualMethod;
				nextPutLine: (self method: aSmaCCVariableDefinition getterMethodName type: type name);
				nextPutStatement: (self return: (self variableReference: aSmaCCVariableDefinition));
				endMethod;
				compileMethodIn: aSmaCCNodeClassDefinition modelClass].
	aSmaCCVariableDefinition setterMethodName: variableName , ':'.
	(aSmaCCNodeClassDefinition modelClass definesMethod: aSmaCCVariableDefinition setterMethodName asSymbol)
		ifTrue: [^self].
	typeName := aSmaCCNodeClassDefinition temporaryNameFor: type name.
	self
		startPublicVirtualMethod;
		nextPutLine:
				(self
						method: aSmaCCVariableDefinition setterMethodName
						type: self voidType
						argumentName: typeName
						argumentType: type name);
		addParentAssignmentFor: aSmaCCVariableDefinition to: self undefinedObject;
		nextPutStatement: (self assignmentTo: variableName from: typeName);
		addParentAssignmentFor: aSmaCCVariableDefinition to: self receiverName;
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileHashMethod: aSmaCCNodeClassDefinition
	| hashString |
	aSmaCCNodeClassDefinition variableDefinitions isEmpty ifTrue: [^self].
	hashString := aSmaCCNodeClassDefinition variableDefinitions
		inject: (self superMessage: 'hash')
		into: [:sum :each | self bitXor: sum with: (self hashFor: (self variableReference: each in: self receiverName))].
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'hash' type: self integerType);
		nextPutStatement: (self return: hashString);
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileIgnoreCaseMethods
	self grammar ignoreCase ifFalse: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine:
				(self
						method: #keywordFor:
						type: self stringType
						argumentName: 'aString'
						argumentType: self stringType);
		nextPutStatement: (self return: (self uppercaseString: 'aString'));
		endMethod;
		compileMethodIn: scannerClass!

compileInitializeMethod: aSmaCCNodeClassDefinition
	self subclassResponsibility!

compileKeywordInitializerUsing: keywordMapDictionary 
	self subclassResponsibility!

compileMatchInContextMethod: aSmaCCNodeClassDefinition
	aSmaCCNodeClassDefinition nodeVariableDefinitions isEmpty ifTrue: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine:
				(self
						method: #match:inContext:
						type: self booleanType
						argumentName: aSmaCCNodeClassDefinition tempNodeName
						argumentType: self nodeType
						argumentName: 'aDictionary'
						argumentType: self dictionaryType);
		nextPutStatement:
				(self
						ifFalseReturn:
							(self
								superMessage: #match:inContext:
								argument: aSmaCCNodeClassDefinition tempNodeName
								argument: 'aDictionary')).
	aSmaCCNodeClassDefinition nodeVariableDefinitions
		do:
			[:each | 
			self
				possiblyGuardNil: each
				around:
					[each isPossibleNodeType
						ifTrue:
							[each isNodeType
								ifFalse:
									[self nextPutLine: (self isKindOfTest: (self variableReference: each in: self receiverName) class: self nodeType)].
							self
								nextPutStatement:
									(self
										ifFalseReturn:
											(self
												send: #match:inContext:
												to: (self variableReference: each in: self receiverName)
												with:
													(self variableReference: each in: (self cast: aSmaCCNodeClassDefinition tempNodeName to: aSmaCCNodeClassDefinition fullName))
												with: 'aDictionary')).
							each isNodeType ifFalse: [self nextPutStatement: self endConditionalString]]
						ifFalse:
							[self
								nextPutStatement:
									(self
										ifFalseReturn:
											(self
												send: #matchCollection:to:inContext:
												to: self receiverName
												with: (self variableReference: each in: self receiverName)
												with:
													(self variableReference: each in: (self cast: aSmaCCNodeClassDefinition tempNodeName to: aSmaCCNodeClassDefinition fullName))
												with: 'aDictionary'))]]].
	self
		nextPutStatement: (self return: self trueValue);
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileMethodIn: modelClass
	self compileMethodWithoutFormattingIn: modelClass!

compileMethodWithoutFormattingIn: modelClass
	self subclassResponsibility!

compileNode: aSmaCCNode
	| methodNodes methodMap |
	methodNodes := self statesToMakeIntoMethodsFor: aSmaCCNode.
	methodMap := self methodNameMap: aSmaCCNode forMethods: methodNodes.
	methodNodes
		do:
			[:each | 
			each = aSmaCCNode ifTrue: [self startProtectedOverrideMethod] ifFalse: [self startProtectedVirtualMethod].
			self nextPutLine: (self method: (methodMap at: each) type: (model classFor: SmaCCToken) name).
			self
				asStatement: methodMap
				forNode: each
				lastNeedsReturn: true.
			self endMethod.
			self compileOptimizedMethodIn: scannerClass]!

compileNodeClassDefinition: aSmaCCClassDefinition
	| class |
	class := self
		defineClass: aSmaCCClassDefinition fullName
		asSubclassOf: (self model classNamed: aSmaCCClassDefinition superclassName asSymbol).
	aSmaCCClassDefinition modelClass: class.
	self removeOldMethodsFrom: class.
	self removeOldMethodsFrom: class metaclass!

compileOptimizedMethodIn: modelClass
	self compileMethodIn: modelClass!

compilePostCopyMethod: aSmaCCNodeClassDefinition
	aSmaCCNodeClassDefinition variableDefinitions isEmpty ifTrue: [^self].
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'postCopy' type: self voidType);
		nextPutStatement: (self superMessage: 'postCopy').
	aSmaCCNodeClassDefinition variableDefinitions
		do:
			[:each | 
			| copySelector |
			self
				possiblyGuardNil: each
				around:
					[copySelector := each isPossibleNodeCollectionType ifTrue: [#copyNodeCollection:] ifFalse: [#copyNode:].
					self
						nextPutStatement:
							(self
								send: each setterMethodName
								to: self receiverName
								with:
									(self cast: (self perform: copySelector with: (self send: each getterMethodName to: self receiverName)) to: each type name))]].
	self
		endMethod;
		compileMethodIn: aSmaCCNodeClassDefinition modelClass!

compileReductionActions!

compileReductionTable: reductionTable 
	| stream |
	stream := self outputStream.
	stream nextPutAll: self reduceActionLiteralStart.
	reductionTable do: 
			[:each | 
			stream
				cr;
				tab;
				nextPutAll: (self reduceAction: each)]
		separatedBy: [stream nextPutAll: self literalArraySeparator].
	stream
		cr;
		tab;
		nextPutAll: self endLiteralArray.
	self
		startProtectedOverrideMethod;
		nextPutLine: (self method: 'reduceTable' type: self reduceActionArrayType);
		nextPutStatement: (self return: stream contents);
		endMethod;
		compileMethodWithoutFormattingIn: parserClass!

compileScannerClassIntoParser
	self subclassResponsibility!

compileSourceFor: aSmaCCReduceAction
	^reduceActionCache at: aSmaCCReduceAction ifAbsentPut: [self basicCompileSourceFor: aSmaCCReduceAction]!

compileStartingStateIds: startingStates
	startingStates
		keysAndValuesDo:
			[:symbol :position | 
			self
				startStaticMethod;
				nextPutLine: (self method: 'startingStateFor' , symbol compileName type: self unsignedShort);
				nextPutStatement: (self return: position printString);
				endMethod;
				compileMethodIn: parserClass metaclass]!

compileSymbolTypes
	| names |
	names := grammar symbols
		collect:
			[:each | 
			| types previousSize |
			types := each modelTypes.
			previousSize := types size.
			types remove: (self model classFor: nil class) ifAbsent: [].
			(types isEmpty and: [previousSize = 1]) ifTrue: [nil] ifFalse: [(self commonSupertypeOf: types) name]].
	self compileSymbolTypes: names asArray!

compileSymbolTypes: anArray!

compileTokenIdMethodNamed: aString withId: symbolId
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: aString , 'Id' type: self unsignedShort);
		nextPutStatement: (self return: symbolId printString);
		endMethod;
		compileMethodIn: scannerClass!

compileTransitionTable: transitionTable
	| stream |
	stream := self outputStream.
	stream nextPutAll: self newUnsignedShortArrayArray.
	transitionTable
		do:
			[:each | 
			self
				writeTransitionTableEntry: each
				on: stream
				firstIsType: true]
		separatedBy: [stream nextPutAll: self literalArraySeparator].
	stream
		cr;
		tab;
		nextPutAll: self endLiteralArray.
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'transitionTable' type: self unsignedShortArrayArray);
		nextPutStatement: (self return: stream contents);
		endMethod;
		compileMethodWithoutFormattingIn: parserClass.
	self compileAmbiguousTransitions!

compileVariablesMethods: aSmaCCNodeClassDefinition!

compileVisitMethodFor: aSmaCCNodeClassDefinition visitor: aSmaCCVisitorClassDefinition
	| tempName |
	self compileAcceptVisitorMethod: aSmaCCNodeClassDefinition visitor: aSmaCCVisitorClassDefinition.
	tempName := aSmaCCNodeClassDefinition temporaryVariableName.
	self
		startPublicVirtualMethod;
		nextPutLine:
				(self
						method: 'visit' , aSmaCCNodeClassDefinition name , ':'
						type: self objectType
						argumentName: tempName
						argumentType: aSmaCCNodeClassDefinition fullName).
	self
		nextPutStatement:
				(self
						return:
							(self
								send:
									(aSmaCCNodeClassDefinition superclass notNil
										ifTrue: ['visit' , aSmaCCNodeClassDefinition superclass name , ':']
										ifFalse: ['visitSmaCCParseNode:'])
								to: self receiverName
								with: tempName));
		endMethod;
		compileMethodIn: aSmaCCVisitorClassDefinition modelClass!

createNodeReduceAction: aSmaCCRHS 
	^self createNodeReduceAction: aSmaCCRHS pullUpFrom: 0.!

createNodeReduceAction: aSmaCCRHS pullUpFrom: anInteger
	self resetCodeStream.
	self nextPutLine: (self variableDeclaration: 'result' ofType: aSmaCCRHS modelType name).
	self
		nextPutStatement:
			(self
				assignmentTo: 'result'
				from:
					(anInteger isZero
						ifTrue: [self newObject: aSmaCCRHS modelType name]
						ifFalse: [self cast: (self argumentIndex: anInteger) to: aSmaCCRHS modelType name])).
	SmaCCReduceActionGenerator
		generate: aSmaCCRHS
		pullUp: anInteger
		on: self.
	self nextPutStatement: (self return: 'result').
	^self codeStream contents!

createVariableArrayFor: aSmaCCRHS
	self nextPutLine: (self variableDeclaration: 'result' ofType: self arrayType).
	self nextPutStatement: (self assignmentTo: 'result' from: (self initializeResultForReduceAction: aSmaCCRHS)).
	self initializeArrayContentsToNull: aSmaCCRHS.
	aSmaCCRHS productionSymbol collectionVariableDefinitions
		do:
			[:each | 
			self
				nextPutStatement:
					(self
						assignArray: 'result'
						index: each index
						to: (self newCollectionOfSize: 2))]!

defaultNodeReductionSource: aReduction
	self subclassResponsibility!

defaultReductionSource
	self subclassResponsibility!

defineClass: aString asSubclassOf: aSmaCCClass
	self subclassResponsibility!

doesNotUnderstand: failedMessage
	"Use the code templates to expand the string."

	^(self class codeTemplates at: failedMessage selector ifAbsent: [^super doesNotUnderstand: failedMessage])
		expandMacrosWithArguments: failedMessage arguments!

endIteratorString
	^self endConditionalString!

endMethod
	self codeStream nextPutAll: self endMethodString!

glrParserClass: aClassOrString
	| name existingClass superclass |
	name := (aClassOrString isKindOf: Behavior) ifTrue: [aClassOrString name] ifFalse: [aClassOrString].
	superclass := SmaCCGLRParser.
	existingClass := Smalltalk at: name ifAbsent: [nil].
	(existingClass notNil and: [existingClass superclass includesBehavior: superclass])
		ifTrue: [superclass := existingClass superclass].
	parserClass := self defineClass: name asSubclassOf: superclass!

grammar
	^grammar!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar!

initialize
	super initialize.
	reduceActionCache := Dictionary new.
	ambiguousActions := OrderedCollection new!

initializeArrayContentsToNull: aSmaCCRHS!

initializeResultForReduceAction: aSmaCCRHS
	^self newArrayOfSize: aSmaCCRHS productionSymbol variableDefinitions size!

initialMethodStatesFor: aSmaCCNode
	| allStates incoming |
	allStates := aSmaCCNode allStates.
	incoming := Dictionary new.
	allStates do: 
			[:each |
			each transitions do: 
					[:edge |
					each ~= edge to
						ifTrue: [(incoming at: edge to ifAbsentPut: [Set new]) add: each]]].
	^allStates select: 
			[:each |
			aSmaCCNode = each or: 
					[each isTerminalNode not
						and: [(incoming at: each ifAbsent: [#()]) size > 1]]]!

keywords
	^#()!

maxJumpSize
	^SmallInteger maximum!

method: aString type: typeString
	self subclassResponsibility!

method: aString type: anObject argumentName: argumentNameString argumentType: argumentTypeString
	self subclassResponsibility!

method: aString type: anObject argumentName: firstArgumentNameString argumentType: firstArgumentTypeString argumentName: secondArgumentNameString argumentType: secondArgumentTypeString
	self subclassResponsibility!

methodNameFor: aString
	^aString!

methodNameMap: aSmaCCNode forMethods: methodNodes
	| index methodMap |
	methodMap := Dictionary new.
	index := 0.
	methodNodes
		do:
			[:value | 
			methodMap
				at: value
				put: (value = aSmaCCNode ifTrue: [#scanForToken] ifFalse: ['scan' , (index := index + 1) printString])].
	^methodMap!

minMaxPairsFor: aSmaCCCharacterEdge without: isSelectors
	| start last pairs charsLeft |
	charsLeft := aSmaCCCharacterEdge transitionObjects reject: [:ch | isSelectors anySatisfy: [:each | ch perform: each]].
	pairs := OrderedCollection new.
	charsLeft isEmpty ifTrue: [^pairs].
	last := charsLeft first.
	start := nil.
	charsLeft
		do:
			[:each | 
			last asInteger + 1 = each asInteger
				ifFalse:
					[start notNil ifTrue: [pairs add: (Array with: start with: last)].
					start := each].
			last := each].
	pairs add: (Array with: start with: last).
	^pairs!

model
	^model!

namespaceName
	^''!

nextPut: aCharacter
	self codeStream nextPut: aCharacter!

nextPutLine: aString
	(self codeStream)
		nextPutAll: aString;
		cr!

nextPutStatement: aString
	(self codeStream)
		nextPutAll: aString;
		nextPutAll: self statementSeparator;
		cr!

nodeType
	^(model classFor: SmaCCParseNode) name!

nonKeywordNameFor: aString
	| word |
	word := aString.
	[self keywords includes: word] whileTrue: [word := '_' , word].
	^word!

outputInvertedMatchFor: aSmaCCCharacterEdge on: stream
	self subclassResponsibility!

outputIsSelector: isSelector on: stream 
	self subclassResponsibility!

outputMatchFor: aSmaCCCharacterEdge on: aStream without: aSelector 
	self subclassResponsibility!

outputMatchFor: aSmaCCCharacterEdge seen: aCollection on: stream
	| isSelectors |
	isSelectors := self closestIsExpressionsFor: aSmaCCCharacterEdge seen: aCollection.
	isSelectors do: [:each | self outputIsSelector: each on: stream] separatedBy: [stream nextPutAll: ' or: ['].
	self
		outputMatchFor: aSmaCCCharacterEdge
		on: stream
		without: isSelectors!

outputStream
	^self outputStreamClass with: String new!

outputStreamClass
	self subclassResponsibility!

parserClass
	^parserClass!

parserClass: aClassOrString
	| name existingClass superclass |
	name := (aClassOrString isKindOf: Behavior) ifTrue: [aClassOrString name] ifFalse: [aClassOrString].
	superclass := SmaCCParser.
	existingClass := Smalltalk at: name ifAbsent: [nil].
	(existingClass notNil
		and:
			[(existingClass superclass includesBehavior: superclass) and: [(existingClass includesBehavior: SmaCCGLRParser) not]])
		ifTrue: [superclass := existingClass superclass].
	parserClass := self defineClass: name asSubclassOf: superclass!

parseSourceSelector
	^self class parseSourceSelector!

possiblyGuardNil: each around: aBlock
	each isAlwaysAssigned
		ifTrue: [aBlock value]
		ifFalse:
			[self nextPutLine: (self notNilCheckFor: (self variableReference: each in: self receiverName)).
			aBlock ensure: [self nextPutStatement: self endConditionalString]]!

processTransitionTable: transitionTable
	| table |
	table := OrderedCollection new.
	transitionTable do: [:each | table addLast: each].
	^table!

pullUpVariableFrom: aSmaCCSymbol into: aSmaCCRHS index: anInteger
	| variableValue rhsIndex variable |
	variable := aSmaCCSymbol variableDefinitions first.
	variableValue := self argumentIndex: anInteger.
	rhsIndex := aSmaCCRHS productionSymbol indexOfVariable: variable variableName.
	self
		nextPutStatement: ((aSmaCCRHS productionSymbol
				isCollection: variable variableName)
					ifTrue: 
						[| collectionValue |
						collectionValue := self cast: (self at: 'result' index: rhsIndex)
									to: self collectionType.
						(aSmaCCSymbol isCollection: variable variableName)
							ifTrue: 
								[self addAllSendTo: collectionValue
									with: (self cast: variableValue to: self collectionType)]
							ifFalse: [self addSendTo: collectionValue with: variableValue]]
					ifFalse: [self assignArray: 'result' index: rhsIndex to: variableValue])!

pullUpVariablesFrom: aSmaCCSymbol into: aSmaCCRHS index: anInteger
	aSmaCCSymbol variableDefinitions
		do:
			[:each | 
			| variableValue rhsIndex |
			variableValue := self argumentIndex: anInteger subIndex: (aSmaCCSymbol indexOfVariable: each variableName).
			rhsIndex := aSmaCCRHS productionSymbol indexOfVariable: each variableName.
			self
				nextPutStatement:
					((aSmaCCRHS productionSymbol isCollection: each variableName)
						ifTrue:
							[| collectionValue |
							collectionValue := self cast: (self at: 'result' index: rhsIndex) to: self collectionType.
							(aSmaCCSymbol isCollection: each variableName)
								ifTrue: [self addAllSendTo: collectionValue with: (self cast: variableValue to: self collectionType)]
								ifFalse: [self addSendTo: collectionValue with: variableValue]]
						ifFalse:
							[self
								assignArray: 'result'
								index: rhsIndex
								to: variableValue])]!

reduceAction: anArray
	self subclassResponsibility!

removeOldMethods
	self subclassResponsibility!

removeOldMethodsFrom: aRBClass
	self subclassResponsibility!

resetCodeStream
	codeStream := nil!

scannerActionFor: aString 
	self subclassResponsibility!

scannerClass: aString 
	self subclassResponsibility!

selectorMap: aDictionary 
	self subclassResponsibility!

send: selector to: aString
	self subclassResponsibility!

send: selectorString to: receiverString with: argumentString
	self subclassResponsibility!

send: selectorString to: receiverString with: firstArgumentString with: secondArgumentString
	self subclassResponsibility!

send: selectorString to: receiverString with: firstArgumentString with: secondArgumentString with: thirdArgumentString
	self subclassResponsibility!

setGetterMethodNameTo: aSmaCCVariableDefinition withName: variableName
	aSmaCCVariableDefinition getterMethodName: (self methodNameFor: variableName)!

singleVariableCollectionFor: reduceCode
	| variable |
	variable := reduceCode rhs productionSymbol variableDefinitions asArray first variableName.
	self resetCodeStream.
	self nextPutLine: (self variableDeclaration: 'result' ofType: self arrayType).
	self nextPutStatement: (self assignmentTo: 'result' from: (self newCollectionOfSize: 2)).
	reduceCode indices
		do:
			[:i | 
			| symbol |
			symbol := reduceCode rhs at: i.
			self
				nextPutStatement:
					((symbol isNode not and: [symbol isCollection: variable])
						ifTrue: [self addAllSendTo: 'result' with: (self argumentIndex: i)]
						ifFalse: [self addSendTo: 'result' with: (self argumentIndex: i)])].
	self nextPutStatement: (self return: 'result').
	self nextPutLine: ''.
	^self codeStream contents!

sortedTransitionsForNode: aSmaCCNode
	^aSmaCCNode transitions
		asSortedCollection:
			[:a :b | 
			a isCharacterTransition
				and:
					[b isCharacterTransition not
						or:
							[| aPairs bPairs |
							aPairs := self minMaxPairsFor: a without: #().
							bPairs := self minMaxPairsFor: b without: #().
							aPairs size < bPairs size
								or:
									[aPairs size = bPairs size
										and:
											[a transitionObjects size < b transitionObjects size
												or: [a transitionObjects size = b transitionObjects size and: [a <= b]]]]]]]!

splitLargeNodes: methodStates
	"Split nodes that might generate long jumps that may not compile (longer than 16 bit offset)."

	| todo |
	todo := OrderedCollection withAll: methodStates.
	[todo notEmpty] whileTrue: 
			[| node |
			node := todo removeFirst.
			node transitions do: 
					[:edge |
					(edge to codeSizeEstimate: methodStates) > self maxJumpSize
						ifTrue: 
							[methodStates add: edge to.
							todo addLast: edge to]]]!

startProtectedOverrideMethod
	self resetCodeStream.
	(self codeStream)
		nextPutAll: self protected;
		nextPutAll: self override!

startProtectedVirtualMethod
	self resetCodeStream.
	(self codeStream)
		nextPutAll: self protected;
		nextPutAll: self virtual!

startPublicOverrideMethod
	self resetCodeStream.
	(self codeStream)
		nextPutAll: self public;
		nextPutAll: self override!

startPublicVirtualMethod
	self resetCodeStream.
	(self codeStream)
		nextPutAll: self public;
		nextPutAll: self virtual!

startStaticMethod
	self resetCodeStream.
	self codeStream nextPutAll: self static!

startStaticPrivateMethod
	self resetCodeStream.
	(self codeStream)
		nextPutAll: self static;
		nextPutAll: self private!

statesToMakeIntoMethodsFor: aSmaCCNode
	| methodStates |
	methodStates := self initialMethodStatesFor: aSmaCCNode.
	self splitLargeNodes: methodStates.
	^methodStates asSortedCollection: [:a :b | a id < b id]!

superMessage: aString
	self subclassResponsibility!

superMessage: aString argument: argumentString
	self subclassResponsibility!

superMessage: aString argument: firstArgumentString argument: secondArgumentString
	self subclassResponsibility!

variableArrayAction: aSmaCCRHS
	self resetCodeStream.
	self createVariableArrayFor: aSmaCCRHS.
	aSmaCCRHS collection keysAndValuesDo: 
			[:key :value |
			| variableName |
			variableName := aSmaCCRHS variableNameForIndex: key.
			variableName isNil
				ifTrue: 
					[value returnsVariableCollection
						ifTrue: [self pullUpVariablesFrom: value into: aSmaCCRHS index: key]
						ifFalse: 
							[value returnsSingleVariable
								ifTrue: [self pullUpVariableFrom: value into: aSmaCCRHS index: key]
								ifFalse: 
									[value modelType = (self model classFor: nil class)
										ifFalse: [aSmaCCRHS generateUnnamedSymbolWarningFor: key]]]]
				ifFalse: 
					[value returnsVariableCollection
						ifTrue: [aSmaCCRHS generateNamedVariableCollectionWarningFor: key].
					self assignVariable: variableName in: aSmaCCRHS at: key]].
	self nextPutStatement: (self return: 'result').
	self nextPutLine: ''.
	^self codeStream contents!

variableReference: aSmaCCVariableDefinition
	^self nonKeywordNameFor: aSmaCCVariableDefinition sourceVariableName!

variableReference: aSmaCCVariableDefinition in: aString
	self subclassResponsibility!

writeMatchingCodeFor: aSmaCCNode
	self subclassResponsibility!

writeTransitionTableEntry: anArray on: aStream firstIsType: aBoolean
	self subclassResponsibility!

writeTransitionTableMethod: stream withIndex: index withArray: array
	self
		startStaticPrivateMethod;
		nextPutLine:
				(self
						method: 'transitionTable' , index printString
						type: self voidType
						argumentName: array
						argumentType: self unsignedShortArrayArray);
		nextPutStatement: stream contents;
		endMethod;
		compileMethodWithoutFormattingIn: parserClass! !
!SmaCCCodeGenerator categoriesFor: #acceptCharacterEdge:seen:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #acceptStateEdge:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #addParentAssignmentFor:to:!private! !
!SmaCCCodeGenerator categoriesFor: #addVariable:forDefinition:!private! !
!SmaCCCodeGenerator categoriesFor: #ambiguousTableEntryFor:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #argumentIndex:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #argumentIndex:subIndex:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #assignVariable:in:at:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #asStatement:forNode:lastNeedsReturn:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #basicCompileSourceFor:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #closestIsExpressionsFor:seen:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #codeStream!private! !
!SmaCCCodeGenerator categoriesFor: #comment:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #commonSupertypeBetween:and:!accessing!private! !
!SmaCCCodeGenerator categoriesFor: #commonSupertypeOf:!accessing!private! !
!SmaCCCodeGenerator categoriesFor: #compileAcceptNodeMethodFor:rootNode:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileAcceptVisitorMethod:visitor:!private! !
!SmaCCCodeGenerator categoriesFor: #compileAmbiguousTransitions!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileChanges!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileChildrenMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileCopyInContextMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileDefinitionComment:!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileEmptySymbolTokenId:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileEqualMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileErrorSymbolTokenId:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileGetterAndSetter:forDefinition:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileHashMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileIgnoreCaseMethods!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileInitializeMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileKeywordInitializerUsing:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileMatchInContextMethod:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileMethodIn:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileMethodWithoutFormattingIn:!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileNode:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileNodeClassDefinition:!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileOptimizedMethodIn:!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compilePostCopyMethod:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileReductionActions!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileReductionTable:!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileScannerClassIntoParser!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #compileSourceFor:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #compileStartingStateIds:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileSymbolTypes!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileSymbolTypes:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileTokenIdMethodNamed:withId:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #compileTransitionTable:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #compileVariablesMethods:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #compileVisitMethodFor:visitor:!compiling-nodes!private! !
!SmaCCCodeGenerator categoriesFor: #createNodeReduceAction:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #createNodeReduceAction:pullUpFrom:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #createVariableArrayFor:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #defaultNodeReductionSource:!private! !
!SmaCCCodeGenerator categoriesFor: #defaultReductionSource!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #defineClass:asSubclassOf:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #doesNotUnderstand:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #endIteratorString!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #endMethod!private! !
!SmaCCCodeGenerator categoriesFor: #glrParserClass:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #grammar!accessing!private! !
!SmaCCCodeGenerator categoriesFor: #grammar:!accessing!private! !
!SmaCCCodeGenerator categoriesFor: #initialize!initialize-release!public! !
!SmaCCCodeGenerator categoriesFor: #initializeArrayContentsToNull:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #initializeResultForReduceAction:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #initialMethodStatesFor:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #keywords!private! !
!SmaCCCodeGenerator categoriesFor: #maxJumpSize!private! !
!SmaCCCodeGenerator categoriesFor: #method:type:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #method:type:argumentName:argumentType:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #method:type:argumentName:argumentType:argumentName:argumentType:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #methodNameFor:!private! !
!SmaCCCodeGenerator categoriesFor: #methodNameMap:forMethods:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #minMaxPairsFor:without:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #model!private! !
!SmaCCCodeGenerator categoriesFor: #namespaceName!accessing!private! !
!SmaCCCodeGenerator categoriesFor: #nextPut:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #nextPutLine:!private! !
!SmaCCCodeGenerator categoriesFor: #nextPutStatement:!private! !
!SmaCCCodeGenerator categoriesFor: #nodeType!private! !
!SmaCCCodeGenerator categoriesFor: #nonKeywordNameFor:!private! !
!SmaCCCodeGenerator categoriesFor: #outputInvertedMatchFor:on:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #outputIsSelector:on:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #outputMatchFor:on:without:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #outputMatchFor:seen:on:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #outputStream!private! !
!SmaCCCodeGenerator categoriesFor: #outputStreamClass!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #parserClass!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #parserClass:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #parseSourceSelector!private! !
!SmaCCCodeGenerator categoriesFor: #possiblyGuardNil:around:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #processTransitionTable:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #pullUpVariableFrom:into:index:!public!reduction table! !
!SmaCCCodeGenerator categoriesFor: #pullUpVariablesFrom:into:index:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #reduceAction:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #removeOldMethods!compiling!private! !
!SmaCCCodeGenerator categoriesFor: #removeOldMethodsFrom:!private! !
!SmaCCCodeGenerator categoriesFor: #resetCodeStream!private! !
!SmaCCCodeGenerator categoriesFor: #scannerActionFor:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #scannerClass:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #selectorMap:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #send:to:!private! !
!SmaCCCodeGenerator categoriesFor: #send:to:with:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #send:to:with:with:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #send:to:with:with:with:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #setGetterMethodNameTo:withName:!compiling-parser!private! !
!SmaCCCodeGenerator categoriesFor: #singleVariableCollectionFor:!public!reduction table! !
!SmaCCCodeGenerator categoriesFor: #sortedTransitionsForNode:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #splitLargeNodes:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #startProtectedOverrideMethod!private! !
!SmaCCCodeGenerator categoriesFor: #startProtectedVirtualMethod!private! !
!SmaCCCodeGenerator categoriesFor: #startPublicOverrideMethod!private! !
!SmaCCCodeGenerator categoriesFor: #startPublicVirtualMethod!private! !
!SmaCCCodeGenerator categoriesFor: #startStaticMethod!private! !
!SmaCCCodeGenerator categoriesFor: #startStaticPrivateMethod!private! !
!SmaCCCodeGenerator categoriesFor: #statesToMakeIntoMethodsFor:!compiling-scanner!public! !
!SmaCCCodeGenerator categoriesFor: #superMessage:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #superMessage:argument:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #superMessage:argument:argument:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #variableArrayAction:!private!reduction table! !
!SmaCCCodeGenerator categoriesFor: #variableReference:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #variableReference:in:!code generation templates!private! !
!SmaCCCodeGenerator categoriesFor: #writeMatchingCodeFor:!compiling-scanner!private! !
!SmaCCCodeGenerator categoriesFor: #writeTransitionTableEntry:on:firstIsType:!private! !
!SmaCCCodeGenerator categoriesFor: #writeTransitionTableMethod:withIndex:withArray:!private! !

!SmaCCCodeGenerator class methodsFor!

codeTemplates
	^codeTemplates
		ifNil:
			[codeTemplates := IdentityDictionary new.
			self codeTemplatesArray do: [:each | codeTemplates at: each first put: each last].
			codeTemplates]!

codeTemplatesArray
	^#(
		#(#override '')
		#(#trueValue 'true')
	)!

new
	^(super new)
		initialize;
		yourself!

parseSourceSelector
	self subclassResponsibility!

reset
	"self reset"

	codeTemplates := nil.
	self allSubclassesDo: [:each | each reset]!

typeName
	^nil! !
!SmaCCCodeGenerator class categoriesFor: #codeTemplates!code generation templates!private! !
!SmaCCCodeGenerator class categoriesFor: #codeTemplatesArray!code generation templates!private! !
!SmaCCCodeGenerator class categoriesFor: #new!instance creation!private! !
!SmaCCCodeGenerator class categoriesFor: #parseSourceSelector!accessing!private! !
!SmaCCCodeGenerator class categoriesFor: #reset!class initialization!private! !
!SmaCCCodeGenerator class categoriesFor: #typeName!accessing!private! !

SmaCCEdge guid: (GUID fromString: '{00E17E5C-9725-44F4-B6D1-8A86496D52F1}')!
SmaCCEdge comment: 'SmaCCEdge is an edge in the DFA/NFA for the scanner. It contains the objects (characters or symbols) that we transition on and the node we transition to.

Subclasses must implement the following messages:
	private
		dispatchTo:seen:

Instance Variables:
	toNode	<SmaCCNode>	the next node in the graph
	transitionObjects	<Collection of: (Character | Symbol))>	the characters or states that we transition on

'!
!SmaCCEdge categoriesForClass!Unclassified! !
!SmaCCEdge methodsFor!

<= aSmaCCEdge 
	^true!

= aSmaCCEdge
	^self class = aSmaCCEdge class
		and: [self to = aSmaCCEdge to and: [self transitionObjects = aSmaCCEdge transitionObjects]]!

canMergeWith: aSmaCCEdge 
	^self class = aSmaCCEdge class!

codeSizeEstimate
	"Estimate how many bytecodes will be used to generate the comparison."
	
	^self subclassResponsibility!

dispatchTo: aSmaCCCodeGenerator seen: aCollection
	^self subclassResponsibility!

edgeLabel
	^transitionObjects isNil
		ifTrue: ['epsilon']
		ifFalse: [transitionObjects inject: '' into: [:sum :each | sum , each printString]]!

hash
	^(self to hash bitShift: 14) bitXor: transitionObjects hash!

includes: anObject
	^transitionObjects includes: anObject!

isCharacterTransition
	^false!

isEmpty
	^transitionObjects isEmpty!

isEpsilonTransition
	^transitionObjects isNil!

mergeWith: aSmaCCEdge
	transitionObjects := Array
		withAll: (transitionObjects , aSmaCCEdge transitionObjects) asSet asSortedCollection!

printOn: aStream
	aStream
		nextPutAll: '---';
		nextPutAll: self edgeLabel;
		nextPutAll: '--->';
		nextPutAll: toNode printString!

remove: aCollection
	transitionObjects := transitionObjects
				reject: [:each | aCollection includes: each]!

setClass
	^Set!

to
	^toNode!

to: aSmaCCNode
	toNode := aSmaCCNode!

to: aSmaCCNode on: aStringOrNil
	toNode := aSmaCCNode.
	transitionObjects := aStringOrNil!

transitionObjects
	^transitionObjects! !
!SmaCCEdge categoriesFor: #<=!comparing!private! !
!SmaCCEdge categoriesFor: #=!comparing!private! !
!SmaCCEdge categoriesFor: #canMergeWith:!private!testing! !
!SmaCCEdge categoriesFor: #codeSizeEstimate!compiling!public! !
!SmaCCEdge categoriesFor: #dispatchTo:seen:!compiling!private! !
!SmaCCEdge categoriesFor: #edgeLabel!printing!private! !
!SmaCCEdge categoriesFor: #hash!comparing!private! !
!SmaCCEdge categoriesFor: #includes:!public!testing! !
!SmaCCEdge categoriesFor: #isCharacterTransition!private!testing! !
!SmaCCEdge categoriesFor: #isEmpty!private!testing! !
!SmaCCEdge categoriesFor: #isEpsilonTransition!private!testing! !
!SmaCCEdge categoriesFor: #mergeWith:!merging!private! !
!SmaCCEdge categoriesFor: #printOn:!printing!private! !
!SmaCCEdge categoriesFor: #remove:!private! !
!SmaCCEdge categoriesFor: #setClass!accessing!public! !
!SmaCCEdge categoriesFor: #to!accessing!private! !
!SmaCCEdge categoriesFor: #to:!initialize-release!private! !
!SmaCCEdge categoriesFor: #to:on:!initialize-release!private! !
!SmaCCEdge categoriesFor: #transitionObjects!accessing!private! !

!SmaCCEdge class methodsFor!

to: aSmaCCNode on: aCollectionOrNil 
	| edge |
	edge := self new.
	edge to: aSmaCCNode on: aCollectionOrNil.
	^edge! !
!SmaCCEdge class categoriesFor: #to:on:!instance creation!private! !

SmaCCGrammar guid: (GUID fromString: '{052CFD38-FF4E-43FC-879B-9064FC255599}')!
SmaCCGrammar comment: ''!
!SmaCCGrammar categoriesForClass!Unclassified! !
!SmaCCGrammar methodsFor!

addExtraSymbols
	self addSymbol: self emptySymbol.
	self addSymbol: self errorSymbol!

addStartingSymbol: aSmaCCSymbol
	(otherStartingSymbols includes: aSmaCCSymbol) ifFalse: [otherStartingSymbols add: aSmaCCSymbol]!

addSymbol: aSmaCCSymbol
	aSmaCCSymbol grammar: self.
	self symbols add: aSmaCCSymbol.
	^aSmaCCSymbol!

addSymbolFirst: aSmaCCSymbol
	aSmaCCSymbol grammar: self.
	^self symbols addFirst: aSmaCCSymbol!

allStartingSymbols
	"Return all starting symbols with the default starting symbol listed first."

	| startingSymbols default |
	default := self startSymbol.
	startingSymbols := otherStartingSymbols copy.
	startingSymbols remove: default symbol ifAbsent: [].
	startingSymbols := startingSymbols
		collect:
			[:each | 
			(self newStartingSymbolNamed: each name)
				addProduction:
						((self newRHS)
								add: each;
								yourself);
				yourself].
	startingSymbols addFirst: default.
	^startingSymbols!

annotateTokens: aBoolean
	annotateTokens := aBoolean!

calculateFirstSets
	| changed |
	changed := true.
	[changed]
		whileTrue:
			[changed := false.
			self symbols do: [:each | changed := changed | each calculateFirstTerminals]]!

classDefinitions
	| defs root |
	root := self rootDefinition.
	(root isNil and: [classDefinitions notEmpty])
		ifTrue:
			[SmaCCCompilationNotification
				signal: 'Node generation'
				with: 'Cannot generate node classes without specifying a "%root" node.'].
	root isNil ifTrue: [^#()].
	defs := classDefinitions asOrderedCollection.
	defs do: [:each | (each isRoot not and: [each superclass isNil]) ifTrue: [each superclass: root]].
	^defs!

classNamed: aSymbol
	^classDefinitions at: aSymbol ifAbsentPut: [SmaCCNodeClassDefinition named: aSymbol grammar: self]!

codeGenerator
	^codeGenerator!

codeGenerator: aSmaCCCodeGenerator
	codeGenerator := aSmaCCCodeGenerator.
	aSmaCCCodeGenerator grammar: self!

emptySymbol
	^emptySymbol ifNil: [emptySymbol := self newTerminalSymbolNamed: 'E O F']!

emptySymbols
	^self symbols select: [:each | each isTerminal not and: [each isEmpty]]!

errorSymbol
	^errorSymbol ifNil: [errorSymbol := self newTerminalSymbolNamed: 'error']!

findSymbolNamed: aString ifAbsent: aBlock
	^self symbols detect: [:each | each name = aString] ifNone: aBlock!

findSymbolNamed: aString ifAbsentAdd: aBlock
	^self findSymbolNamed: aString ifAbsent: [self addSymbol: aBlock value]!

findSymbolNamed: aString ifAbsentAddFirst: aBlock
	^self findSymbolNamed: aString ifAbsent: [self addSymbolFirst: aBlock value]!

finishBuilding
	self ignoreCase
		ifTrue:
			[self symbols do: [:each | each makeCaseInsensitive].
			self mergeCaseSensitiveKeywords].
	annotateTokens ifTrue: [self symbols do: [:each | each annotateTokenVariables: self class tokenNameBlock]]!

ignoreCase
	^ignoreCase!

ignoreCase: aBoolean
	ignoreCase := aBoolean!

ignoredVariables
	^ignoredVariables!

ignoredVariables: aCollection
	ignoredVariables := aCollection asSet!

initialItemSetFor: aSmaCCSymbol
	^(aSmaCCSymbol asLRItemSet)
		type: type;
		yourself!

initialize
	super initialize.
	type := #LALR1.
	symbols := OrderedCollection new.
	shiftReduceTable := Dictionary new.
	otherStartingSymbols := OrderedCollection new.
	classDefinitions := Dictionary new.
	prefix := suffix := ''.
	isGLR := false.
	ignoreCase := false.
	ignoredVariables := Set new.
	annotateTokens := false!

isGLR
	^isGLR!

isGLR: aBoolean
	isGLR := aBoolean!

keywordRegularExpressionFor: aString
	| regularExpressionString regex |
	regularExpressionString := (aString copyFrom: 2 to: aString size - 1)
		copyReplaceAll: '""'
		with: '"'.
	regex := regularExpressionString
		inject: nil
		into:
			[:sum :each | 
			sum isNil
				ifTrue: [SmaCCCharacterRENode characters: (String with: each)]
				ifFalse: [sum , (SmaCCCharacterRENode characters: (String with: each))]].
	regex addStates: scannerDefinition states.
	^regex!

keywordTerminalNamed: aString
	^self
		findSymbolNamed: aString
		ifAbsentAddFirst:
			[(self newTerminalSymbolNamed: aString)
				regularExpression: (self keywordRegularExpressionFor: aString);
				yourself]!

leftPrecedenceFor: aSmaCCSymbol
	shiftReduceTable at: aSmaCCSymbol put: SmaCCReduceAction!

makeTokenIdMethodFor: aString
	| token |
	token := (scannerDefinition includesTokenNamed: aString)
		ifTrue: [self terminalSymbolNamed: aString]
		ifFalse: [self findSymbolNamed: aString ifAbsentAdd: [self newTerminalSymbolNamed: aString]].
	token createIdMethod: true!

mergeAll: anOrderedCollection
	| new first set |
	first := anOrderedCollection first.
	new := self newTerminalSymbolNamed: first name asUppercase.
	new regularExpression: first regularExpression.
	symbols add: new before: first.
	symbols removeAll: anOrderedCollection.
	set := anOrderedCollection asSet.
	self rhsDo: [:each | 1 to: each size do: [:i | (set includes: (each at: i)) ifTrue: [each collection at: i put: new]]]!

mergeCaseSensitiveKeywords
	| duplicateMap |
	duplicateMap := Dictionary new.
	self symbols
		do:
			[:each | 
			(each isTerminal and: [each name first = $"])
				ifTrue: [(duplicateMap at: each name asUppercase ifAbsentPut: [OrderedCollection new]) add: each]].
	duplicateMap keysAndValuesDo: [:name :value | value size > 1 ifTrue: [self mergeAll: value]]!

newItemSet
	^(SmaCCItemSet new)
		grammar: self;
		yourself!

newNonTerminalSymbolNamed: aString
	^(SmaCCNonTerminalSymbol name: aString)
		grammar: self;
		yourself!

newRHS
	^(SmaCCRHS new)
		grammar: self;
		yourself!

newStartingSymbolNamed: aString
	^(SmaCCStartingSymbol name: 'B e g i n' , aString)
		grammar: self;
		yourself!

newTerminalSymbolNamed: aString
	^(SmaCCTerminalSymbol name: aString)
		grammar: self;
		yourself!

nonAssociativePrecedenceFor: aSmaCCSymbol
	shiftReduceTable at: aSmaCCSymbol put: SmaCCRejectAction!

nonTerminalSymbolNamed: aString
	^self findSymbolNamed: aString ifAbsentAdd: [self newNonTerminalSymbolNamed: aString]!

preferredActionFor: aSmaCCSymbol
	^shiftReduceTable at: aSmaCCSymbol ifAbsent: [nil]!

prefix
	^prefix!

prefix: aString
	prefix := aString!

rhsDo: aBlock
	self symbols do: [:each | each productionsDo: aBlock]!

rightPrecedenceFor: aSmaCCSymbol
	shiftReduceTable at: aSmaCCSymbol put: SmaCCShiftAction!

rootDefinition
	^classDefinitions detect: [:each | each isRoot] ifNone: [nil]!

scannerDefinition: aSmaCCScannerDefinition
	scannerDefinition := aSmaCCScannerDefinition!

sentinelSymbol
	^sentinelSymbol ifNil: [sentinelSymbol := self newTerminalSymbolNamed: 'S e n t i n e l']!

setOperatorPrecedenceFor: aSmaCCSymbol to: anInteger
	aSmaCCSymbol precedence: anInteger!

setStartSymbolIfNone: aSmaCCSymbol
	| startSymbol |
	self startSymbol notNil ifTrue: [^self].
	startSymbol := self newStartingSymbolNamed: ''.
	self addSymbol: startSymbol.
	startSymbol
		addProduction:
			((self newRHS)
				add: aSmaCCSymbol;
				yourself)!

startSymbol
	^self symbols detect: [:each | each isStartingSymbol] ifNone: [nil]!

suffix
	^suffix!

suffix: aString
	suffix := aString!

symbols
	^symbols!

symbols: aCollection
	symbols := aCollection!

terminalSymbolNamed: aString
	^self
		findSymbolNamed: aString
		ifAbsentAdd:
			[(self newTerminalSymbolNamed: aString)
				regularExpression: (scannerDefinition tokenNamed: aString);
				yourself]!

tokens
	^scannerDefinition tokens!

type: aSmaCCSymbol
	type := aSmaCCSymbol!

unusedSymbols
	| nonTerminals problemSymbols todo |
	nonTerminals := self symbols reject: [:each | each isTerminal].
	todo := OrderedCollection withAll: self allStartingSymbols.
	problemSymbols := nonTerminals asSet reject: [:each | todo includes: each].
	[todo isEmpty]
		whileFalse:
			[todo removeFirst
				productionsDo:
					[:rhs | 
					rhs
						do:
							[:each | 
							(problemSymbols includes: each)
								ifTrue:
									[todo add: each.
									problemSymbols remove: each]]]].
	^problemSymbols! !
!SmaCCGrammar categoriesFor: #addExtraSymbols!accessing!public! !
!SmaCCGrammar categoriesFor: #addStartingSymbol:!accessing!private! !
!SmaCCGrammar categoriesFor: #addSymbol:!private! !
!SmaCCGrammar categoriesFor: #addSymbolFirst:!private! !
!SmaCCGrammar categoriesFor: #allStartingSymbols!accessing!public! !
!SmaCCGrammar categoriesFor: #annotateTokens:!accessing!private! !
!SmaCCGrammar categoriesFor: #calculateFirstSets!private! !
!SmaCCGrammar categoriesFor: #classDefinitions!accessing!public! !
!SmaCCGrammar categoriesFor: #classNamed:!accessing!private! !
!SmaCCGrammar categoriesFor: #codeGenerator!accessing!private! !
!SmaCCGrammar categoriesFor: #codeGenerator:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #emptySymbol!accessing!public! !
!SmaCCGrammar categoriesFor: #emptySymbols!accessing!private! !
!SmaCCGrammar categoriesFor: #errorSymbol!accessing!public! !
!SmaCCGrammar categoriesFor: #findSymbolNamed:ifAbsent:!private! !
!SmaCCGrammar categoriesFor: #findSymbolNamed:ifAbsentAdd:!private! !
!SmaCCGrammar categoriesFor: #findSymbolNamed:ifAbsentAddFirst:!private! !
!SmaCCGrammar categoriesFor: #finishBuilding!private! !
!SmaCCGrammar categoriesFor: #ignoreCase!private!testing! !
!SmaCCGrammar categoriesFor: #ignoreCase:!private! !
!SmaCCGrammar categoriesFor: #ignoredVariables!private! !
!SmaCCGrammar categoriesFor: #ignoredVariables:!private! !
!SmaCCGrammar categoriesFor: #initialItemSetFor:!accessing!private! !
!SmaCCGrammar categoriesFor: #initialize!initialize-release!public! !
!SmaCCGrammar categoriesFor: #isGLR!private!testing! !
!SmaCCGrammar categoriesFor: #isGLR:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #keywordRegularExpressionFor:!private! !
!SmaCCGrammar categoriesFor: #keywordTerminalNamed:!private! !
!SmaCCGrammar categoriesFor: #leftPrecedenceFor:!precedence!private! !
!SmaCCGrammar categoriesFor: #makeTokenIdMethodFor:!accessing!public! !
!SmaCCGrammar categoriesFor: #mergeAll:!private! !
!SmaCCGrammar categoriesFor: #mergeCaseSensitiveKeywords!private! !
!SmaCCGrammar categoriesFor: #newItemSet!item creation!public! !
!SmaCCGrammar categoriesFor: #newNonTerminalSymbolNamed:!item creation!public! !
!SmaCCGrammar categoriesFor: #newRHS!item creation!public! !
!SmaCCGrammar categoriesFor: #newStartingSymbolNamed:!item creation!public! !
!SmaCCGrammar categoriesFor: #newTerminalSymbolNamed:!item creation!public! !
!SmaCCGrammar categoriesFor: #nonAssociativePrecedenceFor:!precedence!private! !
!SmaCCGrammar categoriesFor: #nonTerminalSymbolNamed:!private! !
!SmaCCGrammar categoriesFor: #preferredActionFor:!accessing!private! !
!SmaCCGrammar categoriesFor: #prefix!accessing!private! !
!SmaCCGrammar categoriesFor: #prefix:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #rhsDo:!accessing!private! !
!SmaCCGrammar categoriesFor: #rightPrecedenceFor:!precedence!private! !
!SmaCCGrammar categoriesFor: #rootDefinition!accessing!private! !
!SmaCCGrammar categoriesFor: #scannerDefinition:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #sentinelSymbol!accessing!public! !
!SmaCCGrammar categoriesFor: #setOperatorPrecedenceFor:to:!precedence!private! !
!SmaCCGrammar categoriesFor: #setStartSymbolIfNone:!accessing!public! !
!SmaCCGrammar categoriesFor: #startSymbol!accessing!private! !
!SmaCCGrammar categoriesFor: #suffix!accessing!private! !
!SmaCCGrammar categoriesFor: #suffix:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #symbols!private! !
!SmaCCGrammar categoriesFor: #symbols:!private! !
!SmaCCGrammar categoriesFor: #terminalSymbolNamed:!private! !
!SmaCCGrammar categoriesFor: #tokens!accessing!private! !
!SmaCCGrammar categoriesFor: #type:!initialize-release!private! !
!SmaCCGrammar categoriesFor: #unusedSymbols!accessing!public! !

!SmaCCGrammar class methodsFor!

allCharacters
	^String withAll: ((0 to: self maximumCharacterValue) 
				collect: [:each | Character value: each])!

defaultTokenNameFor: aString
	| stream string |
	stream := WriteStream on: String new.
	aString
		do:
			[:each | 
			| value |
			value := self tokenNameMap at: each ifAbsent: [each].
			value isString
				ifTrue: [stream nextPutAll: (stream position = 0 ifTrue: [value] ifFalse: [value capitalized])]
				ifFalse: [stream nextPut: (value isAlphaNumeric ifTrue: [value] ifFalse: [$_])]].
	string := stream contents.
	string first isDigit ifTrue: [string := '_' , string].
	string first isUppercase ifTrue: [string at: 1 put: string first asLowercase].
	^string , 'Token'!

defaultTokenNameMap
	| map |
	map := Dictionary new.
	#(#($< 'lessThan') #($> 'greaterThan') #($= 'equal') #($( 'leftParen') #($) 'rightParen') #(${ 'leftBrace') #($} 'rightBrace') #($[ 'leftBracket') #($] 'rightBracket') #($, 'comma') #($; 'semicolon') #($- 'minus') #($+ 'plus') #($* 'times') #($/ 'divide') #($: 'colon') #($. 'period') #($? 'questionMark') #($!! 'bang') #($% 'percent') #($^ 'upArrow') #($& 'and') #($| 'or') #($~ 'tilde'))
		do: [:each | map at: each first put: each last].
	^map!

implicitToken: aString 
	| symbol node |
	symbol := (aString copyFrom: 2 to: aString size - 1) asSymbol.
	(Character canUnderstand: symbol) ifFalse: [^nil].
	node := SmaCCCharacterRENode 
				characters: (self allCharacters select: [:each | each perform: symbol]).
	node position: SmallInteger maximum.	"Implicit nodes have least precedence"
	^node!

initialize
	self maximumCharacterValue: 255!

maximumCharacterValue
	^MaximumCharacterValue!

maximumCharacterValue: anInteger 
	MaximumCharacterValue := anInteger!

new
	^(super new)
		initialize;
		yourself!

tokenNameBlock
	^TokenNameBlock ifNil: [[:string | self defaultTokenNameFor: string]]!

tokenNameBlock: aBlock
	TokenNameBlock := aBlock!

tokenNameMap
	^TokenNameMap ifNil: [TokenNameMap := self defaultTokenNameMap]!

tokenNameMap: aDictionary
	TokenNameMap := aDictionary! !
!SmaCCGrammar class categoriesFor: #allCharacters!accessing!private! !
!SmaCCGrammar class categoriesFor: #defaultTokenNameFor:!accessing!private! !
!SmaCCGrammar class categoriesFor: #defaultTokenNameMap!accessing!private! !
!SmaCCGrammar class categoriesFor: #implicitToken:!accessing!private! !
!SmaCCGrammar class categoriesFor: #initialize!class initialization!private! !
!SmaCCGrammar class categoriesFor: #maximumCharacterValue!accessing!private! !
!SmaCCGrammar class categoriesFor: #maximumCharacterValue:!accessing!private! !
!SmaCCGrammar class categoriesFor: #new!instance creation!private! !
!SmaCCGrammar class categoriesFor: #tokenNameBlock!accessing!private! !
!SmaCCGrammar class categoriesFor: #tokenNameBlock:!accessing!public! !
!SmaCCGrammar class categoriesFor: #tokenNameMap!accessing!private! !
!SmaCCGrammar class categoriesFor: #tokenNameMap:!accessing!private! !

SmaCCGrammarCompiler guid: (GUID fromString: '{959CEB2C-C5D5-4747-8FCD-88E671E76D18}')!
SmaCCGrammarCompiler comment: ''!
!SmaCCGrammarCompiler categoriesForClass!Unclassified! !
!SmaCCGrammarCompiler methodsFor!

actionForState: anInteger on: aSmaCCSymbol
	| action |
	action := (itemSets at: anInteger) action: aSmaCCSymbol prefer: (grammar preferredActionFor: aSmaCCSymbol).
	^self
		idForAction: action
		state: anInteger
		on: aSmaCCSymbol!

buildDefinition: definitionString
	| parser |
	scannerCompiler grammar: self grammar.
	parserDefinitionString := definitionString.
	parser := SmaCCDefinitionParser on: (ReadStream on: definitionString).
	parser scanner parseSourceSelector: self codeGenerator parseSourceSelector.
	parser grammar: grammar.
	parser parse.
	grammar finishBuilding!

checkFor: problemSymbols errorMessage: errorMessage
	| stream |
	problemSymbols isEmpty ifTrue: [^self].
	stream := WriteStream with: String new.
	problemSymbols do: [:each | stream nextPutAll: each printString] separatedBy: [stream space].
	SmaCCCompilationNotification signal: errorMessage with: stream contents!

checkForEmptySymbols
	self checkFor: grammar emptySymbols errorMessage: 'Missing non-terminal productions'!

checkForUnusedSymbols
	self checkFor: grammar unusedSymbols errorMessage: 'Unused non-terminal symbols'!

codeGenerator
	^codeGenerator ifNil: [self codeGenerator: SmaCCSmalltalkCodeGenerator new]!

codeGenerator: aSmaCCCodeGenerator
	codeGenerator := aSmaCCCodeGenerator.
	self grammar codeGenerator: aSmaCCCodeGenerator.
	scannerCompiler codeGenerator: aSmaCCCodeGenerator.
	^codeGenerator!

compileInto: sClass andParser: pClass
	self scannerClass: sClass.
	self parserClass: pClass.
	self createChanges.
	self codeGenerator compileChanges!

compileNodeClasses
	SmaCCNodeCalculation compileForGrammar: grammar!

compileParser
	self compileNodeClasses.
	(self codeGenerator)
		compileTransitionTable: self transitionTable;
		compileStartingStateIds: startingStateMap;
		compileReductionTable: self reduceTable;
		compileReductionActions;
		compileScannerClassIntoParser!

compileScanner
	scannerCompiler compileScanner!

compressedRowStream
	^WriteStream with: Array new!

compressTable: table
	^table collect: [:row | self compressTableRow: row]!

compressTableRow: row
	| uniqueItems |
	uniqueItems := self uniqueNonErrorActionsForTableRow: row.
	^uniqueItems size = 1
		ifTrue: [self singleActionTableRow: row forAction: uniqueItems first]
		ifFalse: [self multipleActionTableRow: row]!

createChanges
	self codeGenerator removeOldMethods.
	self checkForEmptySymbols.
	self checkForUnusedSymbols.
	self compileScanner.
	self compileParser.
	self codeGenerator compileDefinitionComment: parserDefinitionString!

createItemSets
	| itemSet newState index |
	startingStateMap := Dictionary new.
	grammar calculateFirstSets.
	itemSets := OrderedCollection new.
	grammar allStartingSymbols
		do:
			[:each | 
			itemSets add: (grammar initialItemSetFor: each).
			startingStateMap at: each put: itemSets size].
	shiftTable := Dictionary new.
	index := 1.
	[index <= itemSets size]
		whileTrue:
			[itemSet := itemSets at: index.
			grammar symbols
				do:
					[:each | 
					newState := itemSet moveOn: each.
					newState notEmpty
						ifTrue: [shiftTable at: (self shiftTableKeyForIndex: index symbol: each) put: (self indexOfState: newState)]].
			index := index + 1]!

createTransitionTable
	| table |
	table := (1 to: itemSets size)
		collect: [:index | scannerCompiler symbols collect: [:each | self actionForState: index on: each]].
	actions := self compressTable: table!

grammar
	^grammar isNil ifTrue: [grammar := SmaCCGrammar new] ifFalse: [grammar]!

idForAction: aSmaCCAction state: anInteger on: aSmaCCSymbol
	| index preferredAction newStateIndex |
	(aSmaCCAction isAmbiguous and: [grammar isGLR])
		ifTrue:
			[index := codeGenerator
				ambiguousTableEntryFor:
					(aSmaCCAction actions
						collect:
							[:each | 
							self
								idForAction: each
								state: anInteger
								on: aSmaCCSymbol]) asSet asSortedCollection.
			^(index bitShift: 2) + 3]
		ifFalse:
			[preferredAction := aSmaCCAction preferredAction.
			preferredAction isShift
				ifTrue:
					[newStateIndex := shiftTable at: (self shiftTableKeyForIndex: anInteger symbol: aSmaCCSymbol).
					^(newStateIndex bitShift: 2) + preferredAction id].
			preferredAction isReduce ifTrue: [^((self reduceTableIndexFor: preferredAction) bitShift: 2) + preferredAction id].
			^aSmaCCAction id]!

indexOfState: newState
	| newStateIndex |
	newStateIndex := itemSets indexOf: newState.
	newStateIndex = 0
		ifTrue:
			[itemSets add: newState.
			newStateIndex := itemSets size]
		ifFalse: [(itemSets at: newStateIndex) mergeWith: newState].
	^newStateIndex!

initialize
	super initialize.
	scannerCompiler := SmaCCScannerCompiler new.
	startingStateMap := Dictionary new.
	reduceTable := OrderedCollection new!

itemSetsComment
	| stream |
	stream := WriteStream on: String new.
	itemSets
		keysAndValuesDo:
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: each printString;
				cr].
	^stream contents!

multipleActionTableRow: row
	| stream |
	stream := self compressedRowStream.
	stream nextPut: 1.
	row
		keysAndValuesDo:
			[:index :each | 
			each ~= 3
				ifTrue:
					[self writeInteger: each on: stream.
					self writeInteger: index on: stream]].
	^stream contents!

parserClass
	^self codeGenerator parserClass!

parserClass: aClassOrString
	grammar isGLR
		ifTrue: [self codeGenerator glrParserClass: aClassOrString]
		ifFalse: [self codeGenerator parserClass: aClassOrString]!

reduceTable
	^reduceTable!

reduceTableIndexFor: aSmaCCReduceAction 
	| value |
	value := Array 
				with: (scannerCompiler symbols indexOf: aSmaCCReduceAction symbol)
				with: aSmaCCReduceAction rhs size
				with: (self codeGenerator compileSourceFor: aSmaCCReduceAction).
	^reduceTable indexOf: value
		ifAbsent: 
			[reduceTable
				add: value;
				size]!

scannerClass: aClassOrString
	self codeGenerator scannerClass: aClassOrString!

shiftTableKeyForIndex: anInteger symbol: aSmaCCSymbol
	^SmaCCSymbolTableIndex forIndex: anInteger symbol: aSmaCCSymbol!

singleActionTableRow: row forAction: anInteger
	| stream |
	stream := self compressedRowStream.
	stream nextPut: 0.
	self writeInteger: anInteger on: stream.
	row keysAndValuesDo: [:index :each | each ~= 3 ifTrue: [self writeInteger: index on: stream]].
	^stream contents!

symbolsComment
	| stream |
	stream := WriteStream on: String new.
	scannerCompiler symbols
		keysAndValuesDo:
			[:index :each | 
			stream
				nextPutAll: index printString;
				nextPutAll: '. ';
				nextPutAll: each printString;
				cr].
	^stream contents!

transitionTable
	actions isNil
		ifTrue:
			[self createItemSets.
			self createTransitionTable].
	^actions!

uniqueNonErrorActionsForTableRow: row
	^(row asSet)
		remove: 3 ifAbsent: [];
		asArray!

writeInteger: anInteger on: aStream
	aStream nextPut: anInteger! !
!SmaCCGrammarCompiler categoriesFor: #actionForState:on:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #buildDefinition:!initialize-release!private! !
!SmaCCGrammarCompiler categoriesFor: #checkFor:errorMessage:!private! !
!SmaCCGrammarCompiler categoriesFor: #checkForEmptySymbols!private! !
!SmaCCGrammarCompiler categoriesFor: #checkForUnusedSymbols!private! !
!SmaCCGrammarCompiler categoriesFor: #codeGenerator!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #codeGenerator:!initialize-release!private! !
!SmaCCGrammarCompiler categoriesFor: #compileInto:andParser:!compiling!private! !
!SmaCCGrammarCompiler categoriesFor: #compileNodeClasses!compiling!private! !
!SmaCCGrammarCompiler categoriesFor: #compileParser!compiling!private! !
!SmaCCGrammarCompiler categoriesFor: #compileScanner!compiling!private! !
!SmaCCGrammarCompiler categoriesFor: #compressedRowStream!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #compressTable:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #compressTableRow:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #createChanges!compiling!public! !
!SmaCCGrammarCompiler categoriesFor: #createItemSets!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #createTransitionTable!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #grammar!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #idForAction:state:on:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #indexOfState:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #initialize!initialize-release!public! !
!SmaCCGrammarCompiler categoriesFor: #itemSetsComment!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #multipleActionTableRow:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #parserClass!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #parserClass:!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #reduceTable!private!reduction table! !
!SmaCCGrammarCompiler categoriesFor: #reduceTableIndexFor:!private!reduction table! !
!SmaCCGrammarCompiler categoriesFor: #scannerClass:!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #shiftTableKeyForIndex:symbol:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #singleActionTableRow:forAction:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #symbolsComment!accessing!private! !
!SmaCCGrammarCompiler categoriesFor: #transitionTable!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #uniqueNonErrorActionsForTableRow:!action table!private! !
!SmaCCGrammarCompiler categoriesFor: #writeInteger:on:!action table!private! !

!SmaCCGrammarCompiler class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCGrammarCompiler class categoriesFor: #new!instance creation!private! !

SmaCCGrammarItem guid: (GUID fromString: '{FD13C6D1-F337-44E3-8B06-D28BA2A44B6A}')!
SmaCCGrammarItem comment: 'SmaCCGrammarItem is an abstract class that represents something defined by the grammar.

Subclasses must implement the following messages:
	accessing
		modelTypes:
	private
		annotateTokenVariables:
		basicModelTypesForVariable:into:seen:
		firstTerminals

Instance Variables
	grammar	<SmaCCGrammar>	the grammar that we are defined in
	variableDefinitions	<OrderedCollection of: SmaCCVariableDefinition>	the variables defined by this item'!
!SmaCCGrammarItem categoriesForClass!Unclassified! !
!SmaCCGrammarItem methodsFor!

annotateTokenVariables: aBlock
	self subclassResponsibility!

basicModelTypesForVariable: aString into: aCollection seen: anIdentitySet
	self subclassResponsibility!

collectionVariableDefinitions
	^self variableDefinitions select: [:each | each isCollection]!

computeVariableDefinitions
	^#()!

firstTerminals
	^self subclassResponsibility!

grammar
	^grammar!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar!

hasVariableNamed: aString
	^self variableDefinitions anySatisfy: [:each | each variableName = aString]!

indexOfVariable: aString
	self variableDefinitions keysAndValuesDo: [:index :each | each variableName = aString ifTrue: [^index]].
	self error: 'Variable not found'!

isCollection: aString
	^self collectionVariableDefinitions anySatisfy: [:each | each variableName = aString]!

isNode
	^self modelType includesClass: (self model classFor: SmaCCParseNode)!

isSubtypeOf: aSmaCCGrammarItem
	^self modelType includesClass: aSmaCCGrammarItem modelType!

model
	^self grammar codeGenerator model!

modelType
	^self modelType: IdentitySet new!

modelType: anIdentitySet
	| types |
	types := self modelTypes: anIdentitySet.
	^self grammar codeGenerator commonSupertypeOf: types!

modelTypes
	^self modelTypes: IdentitySet new!

modelTypes: anIdentitySet
	^self subclassResponsibility!

modelTypesForVariable: aString
	^self modelTypesForVariable: aString seen: IdentitySet new!

modelTypesForVariable: aString seen: anIdentitySet
	| productionTypes |
	(anIdentitySet includes: self) ifTrue: [^#()].
	anIdentitySet add: self.
	productionTypes := Set new.
	self
		basicModelTypesForVariable: aString
		into: productionTypes
		seen: anIdentitySet.
	^productionTypes!

nodeType
	^self nodeType: IdentitySet new!

nodeType: anIdentitySet
	| node rootType |
	rootType := self modelType: anIdentitySet.
	node := nil.
	(rootType includesClass: (self model classNamed: #SmaCCParseNode))
		ifTrue: [node := self grammar classDefinitions detect: [:e | e modelClass = rootType] ifNone: [nil]].
	^node!

returnsSingleVariable
	^false!

returnsVariableCollection
	^false!

variableDefinitions
	^variableDefinitions ifNil: [self computeVariableDefinitions]! !
!SmaCCGrammarItem categoriesFor: #annotateTokenVariables:!private! !
!SmaCCGrammarItem categoriesFor: #basicModelTypesForVariable:into:seen:!private! !
!SmaCCGrammarItem categoriesFor: #collectionVariableDefinitions!private!variables! !
!SmaCCGrammarItem categoriesFor: #computeVariableDefinitions!private!variables! !
!SmaCCGrammarItem categoriesFor: #firstTerminals!private! !
!SmaCCGrammarItem categoriesFor: #grammar!accessing!public! !
!SmaCCGrammarItem categoriesFor: #grammar:!initialize-release!public! !
!SmaCCGrammarItem categoriesFor: #hasVariableNamed:!private!variables! !
!SmaCCGrammarItem categoriesFor: #indexOfVariable:!private!variables! !
!SmaCCGrammarItem categoriesFor: #isCollection:!private!variables! !
!SmaCCGrammarItem categoriesFor: #isNode!private!reduce actions! !
!SmaCCGrammarItem categoriesFor: #isSubtypeOf:!private!testing! !
!SmaCCGrammarItem categoriesFor: #model!accessing!private! !
!SmaCCGrammarItem categoriesFor: #modelType!private!reduce actions! !
!SmaCCGrammarItem categoriesFor: #modelType:!private!reduce actions! !
!SmaCCGrammarItem categoriesFor: #modelTypes!accessing!private! !
!SmaCCGrammarItem categoriesFor: #modelTypes:!accessing!private! !
!SmaCCGrammarItem categoriesFor: #modelTypesForVariable:!private! !
!SmaCCGrammarItem categoriesFor: #modelTypesForVariable:seen:!private! !
!SmaCCGrammarItem categoriesFor: #nodeType!private!reduce actions! !
!SmaCCGrammarItem categoriesFor: #nodeType:!private!reduce actions! !
!SmaCCGrammarItem categoriesFor: #returnsSingleVariable!public!testing! !
!SmaCCGrammarItem categoriesFor: #returnsVariableCollection!public!testing! !
!SmaCCGrammarItem categoriesFor: #variableDefinitions!private!variables! !

!SmaCCGrammarItem class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCGrammarItem class categoriesFor: #new!instance creation!private! !

SmaCCGraphAlgorithm guid: (GUID fromString: '{6D67E991-E7B4-476F-AE3E-9F49C59B2E19}')!
SmaCCGraphAlgorithm comment: ''!
!SmaCCGraphAlgorithm categoriesForClass!Unclassified! !
!SmaCCGraphAlgorithm methodsFor!

createMergedNodeFrom: nodeCollection
	| newNode |
	newNode := SmaCCNode new.
	self mergeTransitionsFrom: nodeCollection into: newNode.
	self mergeActionsFrom: nodeCollection into: newNode.
	^newNode!

mergeActionsFrom: nodeCollection into: aSmaCCNode
	nodeCollection do: [:each | aSmaCCNode addActions: each action]!

mergeTransitionsFrom: nodeCollection into: aSmaCCNode
	| transitions |
	transitions := Set new.
	nodeCollection do: [:each | each transitions do: [:edge | transitions add: edge copy]].
	aSmaCCNode transitions: transitions.
	aSmaCCNode mergeTransitions! !
!SmaCCGraphAlgorithm categoriesFor: #createMergedNodeFrom:!nodes!private! !
!SmaCCGraphAlgorithm categoriesFor: #mergeActionsFrom:into:!nodes!private! !
!SmaCCGraphAlgorithm categoriesFor: #mergeTransitionsFrom:into:!nodes!private! !

!SmaCCGraphAlgorithm class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCGraphAlgorithm class categoriesFor: #new!instance creation!private! !

SmaCCLR1Item guid: (GUID fromString: '{64254C5A-3620-4D5C-AD4C-FEFE15D00EB3}')!
SmaCCLR1Item comment: ''!
!SmaCCLR1Item categoriesForClass!Unclassified! !
!SmaCCLR1Item methodsFor!

= aSmaCCLR1Item
	^self class == aSmaCCLR1Item class
		and: [location = aSmaCCLR1Item location and: [rhs == aSmaCCLR1Item rhs and: [self symbol == aSmaCCLR1Item symbol]]]!

action: aSmaCCSymbol
	self isAtEnd
		ifTrue:
			[(self symbol isStartingSymbol and: [aSmaCCSymbol isEmptySymbol]) ifTrue: [^SmaCCAcceptAction item: self].
			(followers includes: aSmaCCSymbol) ifTrue: [^SmaCCReduceAction item: self]]
		ifFalse: [(rhs at: location) = aSmaCCSymbol ifTrue: [^SmaCCShiftAction item: self]].
	^SmaCCRejectAction item: self!

followers
	^followers!

followers: aSmaCCSymbolSet
	followers := aSmaCCSymbolSet!

grammar
	^rhs grammar!

hash
	^(self symbol identityHash bitXor: (location bitShift: 14)) bitXor: rhs identityHash!

isAtEnd
	^location > rhs size!

isLR1EqualTo: aSmaCCLR1Item
	^self followers size = aSmaCCLR1Item followers size
		and: [self followers allSatisfy: [:each | aSmaCCLR1Item followers includes: each]]!

itemSet: aSmaCCItemSet
	itemSet := aSmaCCItemSet!

location
	^location!

location: anInteger
	location := anInteger!

mergeWith: aSmaCCLR1Item
	followers mergeWith: aSmaCCLR1Item followers!

moveNext
	^(self copy)
		followers: (followers class basedOn: followers);
		location: location + 1;
		yourself!

nextSymbol
	^location > rhs size ifTrue: [self grammar sentinelSymbol] ifFalse: [rhs at: location]!

path
	^itemSet path!

precedence
	| max |
	self isAtEnd
		ifTrue:
			[max := -1.	"If we don't have a precedence, then assume we are the lowest precedence (which will cause a shift action)."
			rhs do: [:each | max := max max: (each precedence ifNil: [max])].
			^max]
		ifFalse: [^(rhs at: location) precedence]!

printOn: aStream
	| i |
	aStream
		nextPut: $[;
		nextPutAll: self symbol printString;
		nextPutAll: ' :'.
	i := 1.
	rhs
		do:
			[:each | 
			i = location ifTrue: [aStream nextPutAll: ' . '].
			aStream
				space;
				nextPutAll: each printString.
			i := i + 1].
	location > rhs size ifTrue: [aStream nextPutAll: ' . '].
	aStream nextPut: $;.
	followers printOn: aStream.
	aStream nextPut: $]!

rest
	| newRHS |
	newRHS := self grammar newRHS.
	location + 1 to: rhs size do: [:each | newRHS add: (rhs at: each)].
	^newRHS!

rhs
	^rhs!

rhs: aSmaCCRHS follow: aSmaCCSymbolCollection
	rhs := aSmaCCRHS.
	location := 1.
	followers := aSmaCCSymbolCollection!

symbol
	^self rhs productionSymbol! !
!SmaCCLR1Item categoriesFor: #=!comparing!private! !
!SmaCCLR1Item categoriesFor: #action:!accessing!private! !
!SmaCCLR1Item categoriesFor: #followers!accessing!private! !
!SmaCCLR1Item categoriesFor: #followers:!initialize-release!private! !
!SmaCCLR1Item categoriesFor: #grammar!accessing!public! !
!SmaCCLR1Item categoriesFor: #hash!comparing!private! !
!SmaCCLR1Item categoriesFor: #isAtEnd!accessing!private! !
!SmaCCLR1Item categoriesFor: #isLR1EqualTo:!private!testing! !
!SmaCCLR1Item categoriesFor: #itemSet:!accessing!private! !
!SmaCCLR1Item categoriesFor: #location!accessing!private! !
!SmaCCLR1Item categoriesFor: #location:!initialize-release!private! !
!SmaCCLR1Item categoriesFor: #mergeWith:!accessing!private! !
!SmaCCLR1Item categoriesFor: #moveNext!accessing!private! !
!SmaCCLR1Item categoriesFor: #nextSymbol!accessing!public! !
!SmaCCLR1Item categoriesFor: #path!accessing!private! !
!SmaCCLR1Item categoriesFor: #precedence!accessing!private! !
!SmaCCLR1Item categoriesFor: #printOn:!printing!private! !
!SmaCCLR1Item categoriesFor: #rest!accessing!public! !
!SmaCCLR1Item categoriesFor: #rhs!accessing!private! !
!SmaCCLR1Item categoriesFor: #rhs:follow:!initialize-release!private! !
!SmaCCLR1Item categoriesFor: #symbol!accessing!private! !

!SmaCCLR1Item class methodsFor!

rhs: aSmaCCRHS follow: aSmaCCSymbolCollection
	^(self new)
		rhs: aSmaCCRHS follow: aSmaCCSymbolCollection;
		yourself! !
!SmaCCLR1Item class categoriesFor: #rhs:follow:!instance creation!private! !

SmaCCNode guid: (GUID fromString: '{B6CA11AA-39F4-4E2B-A491-C1939D391559}')!
SmaCCNode comment: ''!
!SmaCCNode categoriesForClass!Unclassified! !
!SmaCCNode methodsFor!

<= aSmaCCNode
	^self id <= aSmaCCNode id!

= anObject
	^self class = anObject class and: [self id = anObject id]!

action
	^action!

action: anObject
	anObject isNil ifTrue: [^self].
	action := anObject isSymbol ifTrue: [anObject] ifFalse: [SortedCollection with: anObject]!

actionForSpecificRegularExpression: aSmaCCRegularExpression
	| matchedAction strings startingStates first |
	strings := aSmaCCRegularExpression possibleMatches.
	startingStates := transitions first isCharacterTransition
		ifTrue: [Array with: self]
		ifFalse:
			[aSmaCCRegularExpression states
				collect: [:each | (transitions detect: [:edge | edge includes: each] ifNone: [nil]) ifNotNil: [:edge | edge to]]].
	(startingStates includes: nil) ifTrue: [^nil].
	first := true.
	strings
		do:
			[:each | 
			startingStates
				do:
					[:node | 
					first
						ifTrue:
							[matchedAction := node simulate: (ReadStream on: each).
							first := false]
						ifFalse: [matchedAction = (node simulate: (ReadStream on: each)) ifFalse: [^nil]]]].
	^matchedAction!

addActions: aCollection
	aCollection isNil ifTrue: [^self].
	action isNil ifTrue: [^action := aCollection copy].
	action isSymbol ifTrue: [^self].
	aCollection isSymbol ifTrue: [^action := aCollection].
	aCollection do: [:each | (action includes: each) ifFalse: [action add: each]]!

addEdgeTo: aSmaCCNode
	transitions add: (SmaCCEdge to: aSmaCCNode on: nil)!

addEdgeTo: aSmaCCNode onCharacters: characterCollection
	transitions add: (SmaCCCharacterEdge to: aSmaCCNode on: characterCollection)!

addEdgeTo: aSmaCCNode onStates: symbolCollection
	transitions add: (SmaCCStateEdge to: aSmaCCNode on: symbolCollection)!

allStates
	| nodes |
	nodes := Set new.
	self allStatesInto: nodes.
	^nodes!

allStatesInto: aSet
	(aSet includes: self) ifTrue: [^self].
	aSet add: self.
	transitions do: [:each | each to allStatesInto: aSet]!

asDFA
	| new |
	new := (SmaCCNFAtoDFA convertToDFA: self asNFAWithoutEpsilonTransitions)
		startingNodeWithoutUnnecessaryDefaultTransition.
	new removeDuplicateNodes.
	new orderNodes.
	^new!

asDOTstring
	| nodeStream mapStream |
	nodeStream := WriteStream on: String new.
	nodeStream
		nextPutAll: 'digraph finite_state_machine {
	rankdir=LR;
	size="100,100"';
		cr.
	mapStream := WriteStream on: String new.
	self allStates do: 
			[:each | 
			nodeStream
				nextPutAll: 'node [ style=filled, shape = circle, fillcolor = ';
				nextPutAll: (each action notNil ifTrue: ['green'] ifFalse: ['white']);
				nextPutAll: '];';
				nextPutAll: each id printString;
				nextPut: $;;
				cr.
			each transitions do: 
					[:trans | 
					| edge |
					mapStream
						nextPutAll: each id printString;
						nextPutAll: ' -> ';
						nextPutAll: trans to id printString;
						nextPutAll: '[ label = "'.
					edge := trans edgeLabel displayString.
					edge size > 100 ifTrue: [edge := '...'].
					mapStream
						nextPutAll: edge;
						nextPutAll: '"];';
						cr]].
	mapStream nextPut: $}.
	^nodeStream contents , mapStream contents!

asNFAWithoutEpsilonTransitions
	^SmaCCEpsilonRemoval removeEpsilonEdgesFrom: self!

codeSizeEstimate: methodStates
	"Estimate how many bytecodes will be generated from this node and its containing nodes."
	
	^8 + (self transitions inject: 0
				into: 
					[:sum :each |
					sum + (each codeSizeEstimate
								+ ((self == each to or: [methodStates includes: each to])
										ifTrue: [4]
										ifFalse: [each to codeSizeEstimate: methodStates]))])!

getId
	^NextId := NextId + 1!

groupedTransitions
	^transitions
		inject: OrderedCollection new
		into:
			[:sum :each | 
			(sum
				detect: [:edgeCollection | edgeCollection first canMergeWith: each]
				ifNone: [sum add: OrderedCollection new]) add: each.
			sum]!

hash
	^id bitShift: 4!

hasSimpleLoop
	^transitions anySatisfy: [:each | each to = self]!

id
	^id!

initialize
	super initialize.
	id := self getId.
	transitions := SortedCollection new!

isTerminalNode
	^transitions isEmpty or: [transitions size = 1 and: [self hasSimpleLoop]]!

mergeTransitions
	self groupedTransitions
		do:
			[:edges | 
			| toMap |
			toMap := Dictionary new.
			edges
				do:
					[:each | 
					(toMap includesKey: each to)
						ifTrue:
							[(toMap at: each to) mergeWith: each.
							transitions remove: each]
						ifFalse: [toMap at: each to put: each]]]!

mergeWith: aSmaCCNode
	id := aSmaCCNode id.
	transitions := aSmaCCNode transitions.
	action := aSmaCCNode action!

orderNodes
	self orderNodesWithId: NextId map: Dictionary new!

orderNodesWithId: anInteger map: aDictionary
	anInteger <= id ifTrue: [^self].
	id := aDictionary at: id ifAbsentPut: [self getId].
	self sortedTransitions do: [:each | each to orderNodesWithId: anInteger map: aDictionary]!

printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		nextPutAll: id printString;
		nextPut: $)!

removeDuplicateNodes
	^SmaCCDuplicateNodeEliminator removeDuplicateNodesIn: self!

shallowCopy
	| copy |
	copy := self class new.
	copy action: action.
	^copy!

simulate: aStream
	| char |
	aStream atEnd ifTrue: [^action].
	char := aStream next.
	transitions do: [:each | (each includes: char) ifTrue: [^each to simulate: aStream]].
	^nil!

sortedTransitions
	^transitions asSortedCollection: [:a :b | a <= b]!

startingNodeWithoutUnnecessaryDefaultTransition
	| edge |
	self transitions size = 1 ifFalse: [^self].
	edge := self transitions first.
	(edge includes: #default) ifTrue: [^edge to].
	^self!

transitions
	^transitions!

transitions: aCollection
	transitions size
		to: 1
		by: -1
		do: [:i | transitions removeAtIndex: i].
	transitions addAll: aCollection! !
!SmaCCNode categoriesFor: #<=!comparing!private! !
!SmaCCNode categoriesFor: #=!comparing!private! !
!SmaCCNode categoriesFor: #action!accessing!private! !
!SmaCCNode categoriesFor: #action:!initialize-release!private! !
!SmaCCNode categoriesFor: #actionForSpecificRegularExpression:!compiling-scanner!private! !
!SmaCCNode categoriesFor: #addActions:!accessing!private! !
!SmaCCNode categoriesFor: #addEdgeTo:!edges!private! !
!SmaCCNode categoriesFor: #addEdgeTo:onCharacters:!edges!private! !
!SmaCCNode categoriesFor: #addEdgeTo:onStates:!edges!private! !
!SmaCCNode categoriesFor: #allStates!accessing!private! !
!SmaCCNode categoriesFor: #allStatesInto:!accessing!private! !
!SmaCCNode categoriesFor: #asDFA!converting!private! !
!SmaCCNode categoriesFor: #asDOTstring!accessing!private! !
!SmaCCNode categoriesFor: #asNFAWithoutEpsilonTransitions!converting!private! !
!SmaCCNode categoriesFor: #codeSizeEstimate:!compiling-scanner!public! !
!SmaCCNode categoriesFor: #getId!initialize-release!private! !
!SmaCCNode categoriesFor: #groupedTransitions!accessing!private! !
!SmaCCNode categoriesFor: #hash!comparing!private! !
!SmaCCNode categoriesFor: #hasSimpleLoop!private!testing! !
!SmaCCNode categoriesFor: #id!accessing!private! !
!SmaCCNode categoriesFor: #initialize!initialize-release!public! !
!SmaCCNode categoriesFor: #isTerminalNode!private!testing! !
!SmaCCNode categoriesFor: #mergeTransitions!accessing!private! !
!SmaCCNode categoriesFor: #mergeWith:!accessing!private! !
!SmaCCNode categoriesFor: #orderNodes!converting!private! !
!SmaCCNode categoriesFor: #orderNodesWithId:map:!converting!private! !
!SmaCCNode categoriesFor: #printOn:!printing!private! !
!SmaCCNode categoriesFor: #removeDuplicateNodes!accessing!private! !
!SmaCCNode categoriesFor: #shallowCopy!copying!private! !
!SmaCCNode categoriesFor: #simulate:!private!simulating! !
!SmaCCNode categoriesFor: #sortedTransitions!converting!private! !
!SmaCCNode categoriesFor: #startingNodeWithoutUnnecessaryDefaultTransition!accessing!private! !
!SmaCCNode categoriesFor: #transitions!accessing!private! !
!SmaCCNode categoriesFor: #transitions:!accessing!private! !

!SmaCCNode class methodsFor!

initialize
	NextId := 0!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCNode class categoriesFor: #initialize!class initialization!private! !
!SmaCCNode class categoriesFor: #new!instance creation!private! !

SmaCCNodeCalculation guid: (GUID fromString: '{54B97073-E26B-4BE3-8FAA-655FB3AB7D2E}')!
SmaCCNodeCalculation comment: ''!
!SmaCCNodeCalculation categoriesForClass!Unclassified! !
!SmaCCNodeCalculation methodsFor!

calculateReduceActions
	variableSymbols do: [:each | each productionsDo: [:rhs | rhs reduceAction: (SmaCCVariableReduceCode onRHS: rhs)]].
	singleVariableSymbols do: [:each | each productionsDo: [:rhs | rhs reduceAction: (SmaCCSingleVariableReduceCode onRHS: rhs)]].
	grammar rhsDo: 
			[:each |
			each hasNodeClassDefinition
				ifTrue: [each reduceAction: (SmaCCCreateNodeReduceCode onRHS: each)]
				ifFalse: [each hasReduceAction ifFalse: [each reduceAction: (SmaCCDefaultNodeReduceCode onRHS: each)]]]!

calculateVariables
	SmaCCVariableCalculation calculateVariablesForGrammar: grammar!

calculateVariableSymbols
	variableSymbols := Set new.
	grammar symbols
		do:
			[:each | 
			each requiresNodeType
				ifTrue: [each productionsDo: [:rhs | rhs unnamedSymbolsDo: [:sym | self calculateVariableSymbolsFor: sym]]]].
	variableSymbols := variableSymbols select: [:each | self hasVariables: each seen: IdentitySet new].
	singleVariableSymbols := variableSymbols select: [:each | self hasSingleVariableName: each].
	variableSymbols removeAll: singleVariableSymbols!

calculateVariableSymbolsFor: aSmaCCSymbol
	aSmaCCSymbol isTerminal ifTrue: [^self].
	aSmaCCSymbol requiresNodeType ifTrue: [^self].
	(variableSymbols includes: aSmaCCSymbol) ifTrue: [^self].
	variableSymbols add: aSmaCCSymbol.
	aSmaCCSymbol productionsDo: [:rhs | rhs unnamedSymbolsDo: [:each | self calculateVariableSymbolsFor: each]]!

codeGenerator
	^grammar codeGenerator!

compileMethodsAndVariables
	self sortedClasses do: [:each | each compileMethodsAndVariables]!

compileNodeClasses
	self sortedClasses isEmpty ifTrue: [^self].
	self defineNodeClasses.
	self calculateVariableSymbols.
	self calculateReduceActions.
	self calculateVariables.
	self compileMethodsAndVariables.
	self compileVisitor.
	self compileTypes!

compileTypes
	self codeGenerator compileSymbolTypes!

compileVisitor
	| class |
	class := self codeGenerator
		defineClass: grammar rootDefinition fullName , 'Visitor'
		asSubclassOf: (self codeGenerator model classFor: SmaCCParseNodeVisitor).
	self codeGenerator removeOldMethodsFrom: class.
	self codeGenerator removeOldMethodsFrom: class metaclass.
	(SmaCCVisitorClassDefinition forClassDefinitions: self sortedClasses)
		grammar: grammar;
		modelClass: class;
		compileMethodsAndVariables!

defineNodeClasses
	self sortedClasses do: [:each | self codeGenerator compileNodeClassDefinition: each]!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar!

hasSingleVariableName: aSymbol
	^self
		hasSingleVariableName: aSymbol
		using: Set new
		seen: IdentitySet new!

hasSingleVariableName: aSymbol using: nameSet seen: seen
	(seen includes: aSymbol) ifTrue: [^true].
	seen add: aSymbol.
	aSymbol
		productionsDo:
			[:rhs | 
			nameSet addAll: rhs variableNames.
			nameSet size > 1 ifTrue: [^false].
			rhs
				unnamedSymbolsDo:
					[:sym | 
					(self
						hasSingleVariableName: sym
						using: nameSet
						seen: seen) ifFalse: [^false]]].
	^true!

hasVariables: aSmaCCSymbol seen: aSet
	aSmaCCSymbol requiresNodeType ifTrue: [^false].
	(aSet includes: aSmaCCSymbol) ifTrue: [^false].
	aSet add: aSmaCCSymbol.
	aSmaCCSymbol
		productionsDo:
			[:each | 
			each hasNamedVariable ifTrue: [^true].
			each do: [:symbol | (self hasVariables: symbol seen: aSet) ifTrue: [^true]]].
	^false!

sortedClasses
	^classes ifNil: [classes := grammar classDefinitions asSortedCollection: [:a :b | a isSortedBefore: b]]! !
!SmaCCNodeCalculation categoriesFor: #calculateReduceActions!private! !
!SmaCCNodeCalculation categoriesFor: #calculateVariables!private! !
!SmaCCNodeCalculation categoriesFor: #calculateVariableSymbols!private! !
!SmaCCNodeCalculation categoriesFor: #calculateVariableSymbolsFor:!private! !
!SmaCCNodeCalculation categoriesFor: #codeGenerator!private! !
!SmaCCNodeCalculation categoriesFor: #compileMethodsAndVariables!private! !
!SmaCCNodeCalculation categoriesFor: #compileNodeClasses!private! !
!SmaCCNodeCalculation categoriesFor: #compileTypes!private! !
!SmaCCNodeCalculation categoriesFor: #compileVisitor!private! !
!SmaCCNodeCalculation categoriesFor: #defineNodeClasses!private! !
!SmaCCNodeCalculation categoriesFor: #grammar:!private! !
!SmaCCNodeCalculation categoriesFor: #hasSingleVariableName:!private! !
!SmaCCNodeCalculation categoriesFor: #hasSingleVariableName:using:seen:!private! !
!SmaCCNodeCalculation categoriesFor: #hasVariables:seen:!private! !
!SmaCCNodeCalculation categoriesFor: #sortedClasses!private! !

!SmaCCNodeCalculation class methodsFor!

compileForGrammar: aSmaCCGrammar
	(self new)
		grammar: aSmaCCGrammar;
		compileNodeClasses! !
!SmaCCNodeCalculation class categoriesFor: #compileForGrammar:!accessing!private! !

SmaCCReduceActionGenerator guid: (GUID fromString: '{BE5CD98D-385D-4676-982C-FF4D6223E1C5}')!
SmaCCReduceActionGenerator comment: ''!
!SmaCCReduceActionGenerator categoriesForClass!Unclassified! !
!SmaCCReduceActionGenerator methodsFor!

compileAddToVariable: aSmaCCVariableDefinition from: argument collection: isCollection
	^aSmaCCVariableDefinition isCollection
		ifTrue:
			[| selector var |
			var := rhs nodeType variableDefinitionNamed: aSmaCCVariableDefinition variableName.
			selector := 'add'.
			currentIndex < index ifTrue: [selector := selector , 'First'].
			selector := selector
				, (var isBaseNodeType ifTrue: ['Node'] ifFalse: [var isBaseTokenType ifTrue: ['Token'] ifFalse: ['Object']]).
			isCollection ifTrue: [selector := selector , 's'].
			selector := (selector , ':to:') asSymbol.
			generator
				send: selector
				to: 'result'
				with: argument
				with: (generator send: var getterMethodName to: 'result')]
		ifFalse:
			[generator
				send: aSmaCCVariableDefinition setterMethodName
				to: 'result'
				with: argument]!

connectChild
	| variableDefinition argument symbol isCollection |
	variableDefinition := rhs nodeType variableDefinitionNamed: variableName.
	argument := generator cast: (generator argumentIndex: currentIndex) to: variableDefinition baseType name.
	isCollection := false.
	symbol := rhs at: currentIndex.
	symbol returnsSingleVariable ifTrue: [isCollection := symbol isCollection: symbol variableName].
	^self
		compileAddToVariable: variableDefinition
		from: argument
		collection: isCollection!

generate: aSmaCCRHS pullUp: anInteger on: aCodeGenerator
	rhs := aSmaCCRHS.
	index := anInteger.
	generator := aCodeGenerator.
	rhs collection
		keysAndValuesDo:
			[:i :each | 
			currentIndex := i.
			currentSymbol := each.
			index ~= currentIndex
				ifTrue:
					[variableName := rhs variableNameForIndex: currentIndex.
					variableName notNil
						ifTrue:
							[currentSymbol returnsVariableCollection ifTrue: [rhs generateNamedVariableCollectionWarningFor: currentIndex].
							generator nextPutStatement: self connectChild]
						ifFalse: [self pullUpChildren]]]!

getSubIndex: subIndex ofType: collectionType
	^generator cast: (generator argumentIndex: currentIndex subIndex: subIndex) to: collectionType!

pullUpChildren
	currentSymbol returnsVariableCollection
		ifTrue: [^self pullUpVariableArray].
	currentSymbol returnsSingleVariable ifTrue: [^self pullUpVariable].
	currentSymbol modelType = (generator model classFor: nil class)
		ifFalse: [rhs generateUnnamedSymbolWarningFor: currentIndex]!

pullUpVariable
	currentSymbol variableDefinitions keysAndValuesDo: 
			[:subIndex :var |
			generator nextPutStatement: (var isCollection
						ifTrue: 
							[self
								compileAddToVariable: var
								from: (generator cast: (generator argumentIndex: currentIndex)
										to: generator collectionType)
								collection: true]
						ifFalse: 
							[| nodesVariable |
							nodesVariable := rhs nodeType variableDefinitionNamed: var variableName.
							nodesVariable isCollection
								ifTrue: 
									[self
										compileAddToVariable: nodesVariable
										from: (generator cast: (generator argumentIndex: currentIndex)
												to: nodesVariable type name)
										collection: false]
								ifFalse: 
									[generator
										send: nodesVariable setterMethodName
										to: 'result'
										with: (generator cast: (generator argumentIndex: currentIndex)
												to: nodesVariable type name)]])]!

pullUpVariableArray
	currentSymbol variableDefinitions
		keysAndValuesDo:
			[:subIndex :var | 
			generator
				nextPutStatement:
					(var isCollection
						ifTrue:
							[| collectionType |
							collectionType := generator collectionType.
							self
								compileAddToVariable: var
								from: (self getSubIndex: subIndex ofType: collectionType)
								collection: true]
						ifFalse:
							[| nodesVariable |
							nodesVariable := rhs nodeType variableDefinitionNamed: var variableName.
							nodesVariable isCollection
								ifTrue:
									[self
										compileAddToVariable: nodesVariable
										from: (self getSubIndex: subIndex ofType: nodesVariable type name)
										collection: false]
								ifFalse:
									[generator
										send: nodesVariable setterMethodName
										to: 'result'
										with: (generator cast: (generator argumentIndex: currentIndex subIndex: subIndex) to: nodesVariable type name)]])]! !
!SmaCCReduceActionGenerator categoriesFor: #compileAddToVariable:from:collection:!private!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #connectChild!private!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #generate:pullUp:on:!private!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #getSubIndex:ofType:!private!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #pullUpChildren!private!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #pullUpVariable!public!reduction table! !
!SmaCCReduceActionGenerator categoriesFor: #pullUpVariableArray!private!reduction table! !

!SmaCCReduceActionGenerator class methodsFor!

generate: aSmaCCRHS pullUp: anInteger on: aCodeGenerator 
	^self new 
		generate: aSmaCCRHS
		pullUp: anInteger
		on: aCodeGenerator! !
!SmaCCReduceActionGenerator class categoriesFor: #generate:pullUp:on:!accessing!private! !

SmaCCReduceCode guid: (GUID fromString: '{A5FABACD-9F9B-4CCF-BAEE-A917F3460055}')!
SmaCCReduceCode comment: 'SmaCCReduceCode represents the code to be run when we match the rhs.

Subclasses must implement the following messages:
	accessing
		source - returns the code to be run after matching the rhs
	private
		basicModelTypes: - returns the types the source can return (e.g., OrderedCollection, SmaCCToken, etc.)

Instance Variables
	cachedTypes	<Collection of: RBClass>	the type of object that is returned when this reduce action is run
	rhs	<SmaCCRHS>	the RHS that contains this reduce code
'!
!SmaCCReduceCode categoriesForClass!Unclassified! !
!SmaCCReduceCode methodsFor!

= anObject
	^self class = anObject class and: [self rhs == anObject rhs]!

baseClassType
	^rhs grammar rootDefinition!

basicModelTypes: aSet
	self subclassResponsibility!

basicModelTypes: aSet forIndex: index
	^(rhs at: index) modelTypes: aSet!

codeGenerator
	^rhs grammar codeGenerator!

hash
	^self class hash bitXor: self rhs hash!

hasReduceAction
	^true!

model
	^rhs model!

modelTypes: anIdentitySet
	cachedTypes isNil ifTrue: [cachedTypes := self basicModelTypes: anIdentitySet].
	^cachedTypes!

nodeType: anIdentitySet
	| index |
	index := self returnedNodeIndex.
	^index notNil ifTrue: [(rhs at: index) nodeType: anIdentitySet] ifFalse: [self baseClassType]!

reduceExpressionParseTree
	^SmalltalkParser parseExpression: self source!

returnedNodeIndex
	| parseTree index |
	parseTree := self reduceExpressionParseTree.
	parseTree isCascade ifTrue: [parseTree := parseTree messages last].
	(parseTree isMessage and: [parseTree selector == #yourself])
		ifTrue: [parseTree := parseTree receiver].
	(parseTree isVariable or: [parseTree isLiteralNode]) ifFalse: [^nil].
	parseTree isVariable ifTrue: [^rhs indexOfVariable: parseTree name].
	parseTree value isString ifFalse: [^nil].
	(parseTree value allSatisfy: [:each | each isDigit])
		ifTrue:
			[index := Integer readFrom: (ReadStream on: parseTree value).
			(index between: 1 and: rhs size) ifTrue: [^index]].
	^nil!

returnsSingleVariable
	^false!

returnsVariableCollection
	^false!

rhs
	^rhs!

rhs: aSmaCCRHS
	rhs := aSmaCCRHS!

source
	^self subclassResponsibility! !
!SmaCCReduceCode categoriesFor: #=!comparing!private! !
!SmaCCReduceCode categoriesFor: #baseClassType!private! !
!SmaCCReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCReduceCode categoriesFor: #basicModelTypes:forIndex:!private! !
!SmaCCReduceCode categoriesFor: #codeGenerator!accessing!private! !
!SmaCCReduceCode categoriesFor: #hash!comparing!private! !
!SmaCCReduceCode categoriesFor: #hasReduceAction!private!testing! !
!SmaCCReduceCode categoriesFor: #model!accessing!private! !
!SmaCCReduceCode categoriesFor: #modelTypes:!accessing-types!private! !
!SmaCCReduceCode categoriesFor: #nodeType:!accessing-types!private! !
!SmaCCReduceCode categoriesFor: #reduceExpressionParseTree!public!reduce actions! !
!SmaCCReduceCode categoriesFor: #returnedNodeIndex!private! !
!SmaCCReduceCode categoriesFor: #returnsSingleVariable!public!testing! !
!SmaCCReduceCode categoriesFor: #returnsVariableCollection!public!testing! !
!SmaCCReduceCode categoriesFor: #rhs!accessing!private! !
!SmaCCReduceCode categoriesFor: #rhs:!initialize-release!private! !
!SmaCCReduceCode categoriesFor: #source!accessing!private! !

!SmaCCReduceCode class methodsFor!

onRHS: aSmaCCRHS
	^(self new)
		rhs: aSmaCCRHS;
		yourself! !
!SmaCCReduceCode class categoriesFor: #onRHS:!instance creation!private! !

SmaCCRegularExpressionNode guid: (GUID fromString: '{29DFEF96-2A84-4654-95BA-A3334119BBB6}')!
SmaCCRegularExpressionNode comment: 'SmaCCRegularExpressionNode is an abstract class that is used during the construction of the scanner. When the scanner definition is parsed, it creates the SmaCCRegularExpressionNode objects. These objects are then converted to an NFA graph that is converted to a DFA that is compiled.

Subclasses must implement the following messages:
	accessing
		possibleMatchesSize
	private
		asNFAStartingWith:
		possibleMatchesDo:on:

Instance Variables:
	action	<Object>	this is a symbol that is performed on the scanner, an integer for the token id, or nil if we can''t accept a token at this position
	position	<Integer>	the position in the scanner definition for this RE -- this is only used for overlapping tokens. Tokens that are defined earlier in the definition are preferred over later ones (except for those used in the parser''s definition)
	states	<Collection of: Symbol>	the states where this RE is valid
'!
!SmaCCRegularExpressionNode categoriesForClass!Unclassified! !
!SmaCCRegularExpressionNode methodsFor!

, aSmaCCRegularExpressionNode
	^SmaCCSequenceRENode nodes: (OrderedCollection with: self with: aSmaCCRegularExpressionNode)!

| aSmaCCRegularExpressionNode
	^SmaCCOrRENode nodes: (OrderedCollection with: self with: aSmaCCRegularExpressionNode)!

action
	^action!

action: aString
	action := aString!

addState: aSymbol
	states add: aSymbol!

addStates: aCollection
	states addAll: aCollection!

addStateTransitionsTo: aSmaCCNode
	| endNode |
	states isEmpty ifTrue: [^aSmaCCNode].
	endNode := SmaCCNode new.
	aSmaCCNode addEdgeTo: endNode onStates: states asSortedCollection asArray.
	^endNode!

asDFA
	| startNode |
	startNode := self asNFA.
	^startNode asDFA!

asNFA
	| startNode |
	startNode := SmaCCNode new.
	self asNFAStartingWith: startNode.
	^startNode!

asNFAStartingWith: aSmaCCNode
	^self subclassResponsibility!

initialize
	super initialize.
	states := Set new!

isKeywordLiteral
	^self possibleMatchesSize < 50
		and:
			[self possibleMatchesDo: [:each | each size > 1 ifTrue: [^true]].
			false]!

makeCaseInsensitive!

position
	^position!

position: anInteger
	position := anInteger!

possibleMatches
	| matches |
	matches := OrderedCollection new.
	self possibleMatchesDo: [:each | matches add: each].
	^matches!

possibleMatchesDo: aBlock
	| stream |
	stream := WriteStream with: String new.
	self possibleMatchesDo: [aBlock value: stream contents] on: stream!

possibleMatchesDo: aBlock on: aStream
	self subclassResponsibility!

possibleMatchesSize
	^self subclassResponsibility!

postCopy
	super postCopy.
	states := Set new!

repeat
	^SmaCCRepeatingRENode component: self!

repeatFor: minimum to: maximum
	^SmaCCRepeatingRENode
		component: self
		minimum: minimum
		maximum: maximum!

repeatForAtLeast: minimum
	^SmaCCRepeatingRENode component: self minimum: minimum!

states
	^states! !
!SmaCCRegularExpressionNode categoriesFor: #,!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #|!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #action!accessing!private! !
!SmaCCRegularExpressionNode categoriesFor: #action:!initialize-release!private! !
!SmaCCRegularExpressionNode categoriesFor: #addState:!accessing-states!private! !
!SmaCCRegularExpressionNode categoriesFor: #addStates:!accessing-states!private! !
!SmaCCRegularExpressionNode categoriesFor: #addStateTransitionsTo:!private! !
!SmaCCRegularExpressionNode categoriesFor: #asDFA!converting!private! !
!SmaCCRegularExpressionNode categoriesFor: #asNFA!converting!private! !
!SmaCCRegularExpressionNode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCRegularExpressionNode categoriesFor: #initialize!initialize-release!public! !
!SmaCCRegularExpressionNode categoriesFor: #isKeywordLiteral!private!testing! !
!SmaCCRegularExpressionNode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #position!accessing!private! !
!SmaCCRegularExpressionNode categoriesFor: #position:!initialize-release!private! !
!SmaCCRegularExpressionNode categoriesFor: #possibleMatches!accessing!private! !
!SmaCCRegularExpressionNode categoriesFor: #possibleMatchesDo:!accessing!private! !
!SmaCCRegularExpressionNode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCRegularExpressionNode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCRegularExpressionNode categoriesFor: #postCopy!copying!private! !
!SmaCCRegularExpressionNode categoriesFor: #repeat!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #repeatFor:to:!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #repeatForAtLeast:!constructing!private! !
!SmaCCRegularExpressionNode categoriesFor: #states!accessing-states!private! !

!SmaCCRegularExpressionNode class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCRegularExpressionNode class categoriesFor: #new!instance creation!private! !

SmaCCScannerCompiler guid: (GUID fromString: '{B3219985-C836-4B44-9550-44421CCC013A}')!
SmaCCScannerCompiler comment: ''!
!SmaCCScannerCompiler categoriesForClass!Unclassified! !
!SmaCCScannerCompiler methodsFor!

addActions
	self symbols
		keysAndValuesDo:
			[:index :each | each regularExpression ifNotNil: [:eachRegex | eachRegex action: index]]!

addActionsFrom: aRegularExpression to: aKeywordMap at: states
	^states
		do:
			[:state | 
			state ~= aRegularExpression action
				ifTrue:
					[aRegularExpression
						possibleMatchesDo:
							[:string | (aKeywordMap at: state ifAbsentPut: [Dictionary new]) at: string put: aRegularExpression action]]]!

addNormalSymbols
	grammar symbols: (self symbols asSortedCollection: self filePositionSortBlock)!

addSpecialSymbols
	grammar tokens
		keysDo:
			[:each | (codeGenerator scannerActionFor: each) notNil ifTrue: [grammar terminalSymbolNamed: each]]!

addSpecificREsWithoutActionsTo: aRegularExpression
	| dfa regex |
	regex := aRegularExpression.
	dfa := regex isNil ifTrue: [nil] ifFalse: [regex asDFA].
	self
		specificRegularExpressionsDo:
			[:each | 
			| actions |
			actions := dfa isNil ifTrue: [nil] ifFalse: [dfa actionForSpecificRegularExpression: each].
			actions isNil ifTrue: [regex := regex isNil ifTrue: [each] ifFalse: [regex | each]]].
	^regex!

codeGenerator: aSmaCCCodeGenerator
	codeGenerator := aSmaCCCodeGenerator!

combinedGeneralRegexes
	| combinedRegex |
	combinedRegex := nil.
	self
		generalRegularExpressionsDo:
			[:each | combinedRegex := combinedRegex isNil ifTrue: [each] ifFalse: [combinedRegex | each]].
	^combinedRegex!

compileMethodsFor: regex
	| keywordmap dfa selectorMap |
	dfa := regex asDFA.
	selectorMap := self computeSelectorMap.
	keywordmap := self computeKeywordMapFor: dfa.
	codeGenerator selectorMap: selectorMap.
	codeGenerator compileKeywordInitializerUsing: keywordmap.
	codeGenerator compileNode: dfa.
	codeGenerator compileEmptySymbolTokenId: (self symbols indexOf: grammar emptySymbol).
	codeGenerator compileErrorSymbolTokenId: (self symbols indexOf: grammar errorSymbol).
	codeGenerator compileIgnoreCaseMethods!

compileScanner
	| regex |
	regex := self createRegex.
	self compileTokenIdMethods.
	self compileMethodsFor: regex!

compileTokenIdMethods
	(self symbols select: [:each | each createIdMethod])
		do:
			[:each | codeGenerator compileTokenIdMethodNamed: each safeMethodName withId: (self symbols indexOf: each)]!

computeKeywordMapFor: dfa
	| keywordmap |
	keywordmap := Dictionary new.
	self
		specificRegularExpressionsDo:
			[:each | 
			| actions |
			actions := dfa actionForSpecificRegularExpression: each.
			actions isNil
				ifFalse:
					[self
						addActionsFrom: each
						to: keywordmap
						at: actions]].
	^keywordmap!

computeSelectorMap
	| selectorMap |
	selectorMap := Dictionary new.
	self symbols
		keysAndValuesDo:
			[:index :each | 
			(codeGenerator scannerActionFor: each name)
				ifNotNil: [:selector | selectorMap at: index put: selector]].
	^selectorMap!

createRegex
	self addSpecialSymbols.
	self addNormalSymbols.
	self addActions.
	^self addSpecificREsWithoutActionsTo: self combinedGeneralRegexes!

filePositionSortBlock
	^[:a :b | 
	| aRegex bRegex |
	aRegex := a regularExpression.
	bRegex := b regularExpression.
	bRegex isNil or: [aRegex notNil and: [(aRegex position ifNil: [0]) < (bRegex position ifNil: [0])]]]!

generalRegularExpressionsDo: aBlock
	self regularExpressionsDo: [:each | each isKeywordLiteral ifFalse: [aBlock value: each]]!

grammar: aGrammar
	grammar := aGrammar!

regularExpressionsDo: aBlock
	self symbols do: [:each | each regularExpression ifNotNil: aBlock]!

specificRegularExpressionsDo: aBlock
	self regularExpressionsDo: [:each | each isKeywordLiteral ifTrue: [aBlock value: each]]!

symbols
	^grammar symbols! !
!SmaCCScannerCompiler categoriesFor: #addActions!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #addActionsFrom:to:at:!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #addNormalSymbols!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #addSpecialSymbols!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #addSpecificREsWithoutActionsTo:!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #codeGenerator:!initialize-release!private! !
!SmaCCScannerCompiler categoriesFor: #combinedGeneralRegexes!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #compileMethodsFor:!compiling-scanner!public! !
!SmaCCScannerCompiler categoriesFor: #compileScanner!compiling-scanner!private! !
!SmaCCScannerCompiler categoriesFor: #compileTokenIdMethods!compiling-scanner!private! !
!SmaCCScannerCompiler categoriesFor: #computeKeywordMapFor:!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #computeSelectorMap!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #createRegex!compiling-scanner!private! !
!SmaCCScannerCompiler categoriesFor: #filePositionSortBlock!compiling-scanner!private! !
!SmaCCScannerCompiler categoriesFor: #generalRegularExpressionsDo:!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #grammar:!initialize-release!private! !
!SmaCCScannerCompiler categoriesFor: #regularExpressionsDo:!compiling-scanner!private! !
!SmaCCScannerCompiler categoriesFor: #specificRegularExpressionsDo:!private!regular expression construction! !
!SmaCCScannerCompiler categoriesFor: #symbols!accessing!private! !

SmaCCScannerDefinition guid: (GUID fromString: '{3BF1776D-ED4F-443D-BF1D-4E055726B79D}')!
SmaCCScannerDefinition comment: ''!
!SmaCCScannerDefinition categoriesForClass!Unclassified! !
!SmaCCScannerDefinition methodsFor!

addExcludeState: aSymbol
	excludeStates add: aSymbol.
	self addState: aSymbol!

addState: aSymbol
	states add: aSymbol!

addToken: aSmaCCRENode withName: aString
	tokens at: aString put: aSmaCCRENode!

defaultState
	^#default!

includesTokenNamed: aString
	^tokens includesKey: aString!

initialize
	super initialize.
	tokens := Dictionary new.
	states := Set with: self defaultState.
	excludeStates := Set new!

isExcludeState: aSymbol
	^excludeStates includes: aSymbol!

nonExcludeStates
	| nonExcludeStates |
	nonExcludeStates := states reject: [:each | self isExcludeState: each].
	nonExcludeStates add: self defaultState.
	^nonExcludeStates!

states
	^states!

tokenNamed: aString
	^tokens at: aString!

tokenNamed: aString ifAbsentPut: aBlock 
	^tokens at: aString ifAbsentPut: aBlock!

tokens
	^tokens! !
!SmaCCScannerDefinition categoriesFor: #addExcludeState:!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #addState:!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #addToken:withName:!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #defaultState!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #includesTokenNamed:!private!testing! !
!SmaCCScannerDefinition categoriesFor: #initialize!initialize-release!public! !
!SmaCCScannerDefinition categoriesFor: #isExcludeState:!private!testing! !
!SmaCCScannerDefinition categoriesFor: #nonExcludeStates!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #states!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #tokenNamed:!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #tokenNamed:ifAbsentPut:!accessing!private! !
!SmaCCScannerDefinition categoriesFor: #tokens!accessing!private! !

!SmaCCScannerDefinition class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCScannerDefinition class categoriesFor: #new!instance creation!private! !

SmaCCSymbolTableIndex guid: (GUID fromString: '{94BA3CFC-FC3D-45B9-A986-836137B49DB9}')!
SmaCCSymbolTableIndex comment: ''!
!SmaCCSymbolTableIndex categoriesForClass!Unclassified! !
!SmaCCSymbolTableIndex methodsFor!

= anObject
	^self class = anObject class and: [self index = anObject index and: [self symbol = anObject symbol]]!

hash
	^(index bitShift: 14) + symbol hash!

index
	^index!

index: anObject
	index := anObject!

symbol
	^symbol!

symbol: anObject
	symbol := anObject! !
!SmaCCSymbolTableIndex categoriesFor: #=!comparing!public! !
!SmaCCSymbolTableIndex categoriesFor: #hash!comparing!public! !
!SmaCCSymbolTableIndex categoriesFor: #index!accessing!private! !
!SmaCCSymbolTableIndex categoriesFor: #index:!accessing!private! !
!SmaCCSymbolTableIndex categoriesFor: #symbol!accessing!private! !
!SmaCCSymbolTableIndex categoriesFor: #symbol:!accessing!private! !

!SmaCCSymbolTableIndex class methodsFor!

forIndex: anInteger symbol: aSmaCCSymbol
	^(self new)
		index: anInteger;
		symbol: aSmaCCSymbol;
		yourself! !
!SmaCCSymbolTableIndex class categoriesFor: #forIndex:symbol:!instance creation!public! !

SmaCCVariableCalculation guid: (GUID fromString: '{8B1F4363-66A5-4F39-8DED-AE2906DB22BC}')!
SmaCCVariableCalculation comment: ''!
!SmaCCVariableCalculation categoriesForClass!Unclassified! !
!SmaCCVariableCalculation methodsFor!

addDependent: dependentSmaCCRHS to: aSmaCCRHS
	(dependentsMap at: aSmaCCRHS ifAbsentPut: [IdentitySet new]) add: dependentSmaCCRHS!

addExternallyDefinedVariablesFrom: aSmaCCRHS
	aSmaCCRHS variableDefinitions
		do:
			[:each | 
			| variable |
			variable := self variableNamed: each variableName.
			(each isCollection
				or: [(currentRHS locallyDefinesVariable: each variableName) or: [previousVariables includes: each variableName]])
				ifTrue: [variable isCollection: true]]!

addLocallyDefinedVariable: aString
	(self hasVariableNamed: aString)
		ifTrue: [(self variableNamed: aString) isCollection: true]
		ifFalse: [self addVariableNamed: aString]!

addRenamedVariableName: aString from: symbol
	(self hasVariableNamed: aString)
		ifTrue: [(self variableNamed: aString) isCollection: true]
		ifFalse:
			[| variable |
			variable := self addVariableNamed: aString.
			variable isCollection
				ifFalse:
					[symbol returnsSingleVariable
						ifTrue:
							[symbol
								productionsDo:
									[:rhs | rhs variableDefinitions notEmpty ifTrue: [variable isCollection: (variable isCollection or: [rhs variableDefinitions first isCollection])]]]]]!

addRHS: aSmaCCRHS
	(todo identityIncludes: aSmaCCRHS) ifTrue: [^self].
	todo add: aSmaCCRHS!

addVariableNamed: aString
	^newVariables add: (SmaCCVariableDefinition variableName: aString)!

assignVariables
	currentRHS variableDefinitions: newVariables!

calculateNewVariables
	ourType := currentRHS nodeType.
	newVariables := OrderedCollection new.
	previousVariables := #().
	currentRHS
		variablesAndSymbolsDo:
			[:variable :symbol | 
			variable isNil
				ifTrue: [self processUnnamedSymbol: symbol]
				ifFalse:
					[symbol returnsSingleVariable ifTrue: [self addRenamedVariableName: variable from: symbol] ifFalse: [self addLocallyDefinedVariable: variable]].
			previousVariables := newVariables collect: [:each | each variableName]]!

calculateVariables
	self rhsDo: [:each | self addRHS: each].
	[todo notEmpty] whileTrue: [self calculateVariablesFor: todo removeFirst]!

calculateVariablesFor: aSmaCCRHS
	currentRHS := aSmaCCRHS.
	self calculateNewVariables.
	self hasVariableChanges
		ifTrue:
			[self assignVariables.
			self recalculateDependents]!

calculateVariablesForGrammar: aSmaCCGrammar
	grammar := aSmaCCGrammar.
	dependentsMap := IdentityDictionary new.
	todo := OrderedCollection new.
	self setupVariableDependents.
	self calculateVariables!

hasVariableChanges
	^newVariables anySatisfy: [:each | (currentRHS variableDefinitions includes: each) not]!

hasVariableNamed: aString
	^newVariables anySatisfy: [:each | each variableName = aString]!

processUnnamedSymbol: aSmaCCSymbol
	aSmaCCSymbol
		productionsDo:
			[:rhs | (self shouldAddVariablesFrom: rhs) ifTrue: [self addExternallyDefinedVariablesFrom: rhs]]!

recalculateDependents
	(dependentsMap at: currentRHS ifAbsent: [#()]) do: [:each | self addRHS: each]!

rhsDo: aBlock
	grammar symbols do: [:each | each isStartingSymbol ifFalse: [each productionsDo: aBlock]]!

setupVariableDependents
	self rhsDo: [:rhs | self setupVariableDependentsFor: rhs]!

setupVariableDependentsFor: aSmaCCRHS
	aSmaCCRHS
		variablesAndSymbolsDo:
			[:variable :symbol | (variable isNil or: [symbol returnsSingleVariable]) ifTrue: [symbol productionsDo: [:rhs | self addDependent: aSmaCCRHS to: rhs]]]!

shouldAddVariablesFrom: aSmaCCRHS
	| theirType |
	ourType isNil ifTrue: [^true].
	theirType := aSmaCCRHS nodeType.
	theirType isNil ifTrue: [^true].
	ourType = theirType ifTrue: [^true].
	^(theirType hierarchyIncludes: ourType) not!

variableNamed: aString
	^newVariables
		detect: [:each | each variableName = aString]
		ifNone: [self addVariableNamed: aString]! !
!SmaCCVariableCalculation categoriesFor: #addDependent:to:!private! !
!SmaCCVariableCalculation categoriesFor: #addExternallyDefinedVariablesFrom:!private! !
!SmaCCVariableCalculation categoriesFor: #addLocallyDefinedVariable:!private! !
!SmaCCVariableCalculation categoriesFor: #addRenamedVariableName:from:!private! !
!SmaCCVariableCalculation categoriesFor: #addRHS:!private! !
!SmaCCVariableCalculation categoriesFor: #addVariableNamed:!private! !
!SmaCCVariableCalculation categoriesFor: #assignVariables!private! !
!SmaCCVariableCalculation categoriesFor: #calculateNewVariables!private! !
!SmaCCVariableCalculation categoriesFor: #calculateVariables!private! !
!SmaCCVariableCalculation categoriesFor: #calculateVariablesFor:!private! !
!SmaCCVariableCalculation categoriesFor: #calculateVariablesForGrammar:!private! !
!SmaCCVariableCalculation categoriesFor: #hasVariableChanges!private! !
!SmaCCVariableCalculation categoriesFor: #hasVariableNamed:!private! !
!SmaCCVariableCalculation categoriesFor: #processUnnamedSymbol:!private! !
!SmaCCVariableCalculation categoriesFor: #recalculateDependents!private! !
!SmaCCVariableCalculation categoriesFor: #rhsDo:!private! !
!SmaCCVariableCalculation categoriesFor: #setupVariableDependents!private! !
!SmaCCVariableCalculation categoriesFor: #setupVariableDependentsFor:!private! !
!SmaCCVariableCalculation categoriesFor: #shouldAddVariablesFrom:!private! !
!SmaCCVariableCalculation categoriesFor: #variableNamed:!private! !

!SmaCCVariableCalculation class methodsFor!

calculateVariablesForGrammar: aSmaCCGrammar
	self new calculateVariablesForGrammar: aSmaCCGrammar! !
!SmaCCVariableCalculation class categoriesFor: #calculateVariablesForGrammar:!accessing!private! !

SmaCCVariableDefinition guid: (GUID fromString: '{8B755338-BDC7-4C3E-8DD2-7E7B5EDF4395}')!
SmaCCVariableDefinition comment: 'SmaCCVariableDefinition represents a variable for a node class.

Instance Variables
	baseType	<RBAbstractClass>	the type of the variable
	getterMethodName	<Symbol>	the getter selector
	index	<Integer>	the index of the variable (if we are pulling up a collection of variables from a symbol)
	isAlwaysAssigned	<Boolean>	does the variable always have a value or can it be nil
	isCollection	<Boolean>	does the variable represent a collection of values
	setterMethodName	<Symbol>	the setter selector
	variableName	<String>	the name of the variable
'!
!SmaCCVariableDefinition categoriesForClass!Unclassified! !
!SmaCCVariableDefinition methodsFor!

= anObject
	^self class = anObject class
		and: [self variableName = anObject variableName and: [self isCollection = anObject isCollection]]!

baseType
	^baseType!

baseType: modelClass
	baseType := modelClass!

collectionType
	^self baseType model classFor: OrderedCollection!

getterMethodName
	^getterMethodName!

getterMethodName: aString
	getterMethodName := aString!

hash
	^self variableName hash bitXor: self isCollection hash!

index
	^index!

index: anInteger
	index := anInteger!

isAlwaysAssigned
	^isAlwaysAssigned or: [self isCollection]!

isAlwaysAssigned: aBoolean
	isAlwaysAssigned := aBoolean!

isBaseNodeType
	^self baseType includesClass: (self baseType model classFor: SmaCCParseNode)!

isBasePossibleNodeType
	^self isBaseNodeType
		or: [(self baseType model classFor: SmaCCParseNode) includesClass: self baseType]!

isBaseTokenType
	^self baseType includesClass: (self baseType model classFor: SmaCCToken)!

isCollection
	^isCollection!

isCollection: aBoolean
	isCollection := aBoolean!

isNodeCollectionType
	^self isCollection and: [self isBaseNodeType]!

isNodeType
	^self isCollection not and: [self isBaseNodeType]!

isPossibleNodeCollectionType
	^self isCollection and: [self isBasePossibleNodeType]!

isPossibleNodeType
	^self isCollection not and: [self isBasePossibleNodeType]!

setterMethodName
	^setterMethodName!

setterMethodName: aString
	setterMethodName := aString!

sourceVariableName
	^self isCollection ifTrue: [self class pluralNameFor: variableName] ifFalse: [variableName]!

type
	^self isCollection ifTrue: [self collectionType] ifFalse: [self baseType]!

variableName
	^variableName!

variableName: aString
	variableName := aString! !
!SmaCCVariableDefinition categoriesFor: #=!comparing!private! !
!SmaCCVariableDefinition categoriesFor: #baseType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #baseType:!initialize-release!private! !
!SmaCCVariableDefinition categoriesFor: #collectionType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #getterMethodName!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #getterMethodName:!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #hash!comparing!private! !
!SmaCCVariableDefinition categoriesFor: #index!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #index:!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isAlwaysAssigned!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isAlwaysAssigned:!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isBaseNodeType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isBasePossibleNodeType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isBaseTokenType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isCollection!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isCollection:!initialize-release!private! !
!SmaCCVariableDefinition categoriesFor: #isNodeCollectionType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isNodeType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isPossibleNodeCollectionType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #isPossibleNodeType!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #setterMethodName!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #setterMethodName:!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #sourceVariableName!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #type!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #variableName!accessing!private! !
!SmaCCVariableDefinition categoriesFor: #variableName:!initialize-release!private! !

!SmaCCVariableDefinition class methodsFor!

assignIndices: aCollection
	aCollection keysAndValuesDo: [:index :each | each index: index]!

pluralNameBlock
	^PluralNameBlock ifNil: [^[:value | nil]]!

pluralNameBlock: aBlock
	PluralNameBlock := aBlock!

pluralNameFor: aString
	| size |
	(self pluralNameBlock value: aString) ifNotNil: [:result | ^result].
	size := aString size.
	1
		to: size
		do:
			[:i | 
			(self pluralNames at: (aString copyFrom: size - i + 1 to: size) ifAbsent: [nil])
				ifNotNil: [:ending | ^(aString copyFrom: 1 to: size - i) , ending]].
	^aString copyWith: $s!

pluralNames
	PluralNames isNil
		ifTrue:
			[PluralNames := Dictionary new.
			PluralNames
				at: 's' put: 'ses';
				at: 'y' put: 'ies';
				at: 'x' put: 'xes';
				at: 'ch' put: 'ches'].
	^PluralNames!

pluralNames: aDictionary
	PluralNames := aDictionary!

variableName: aString
	^(self new)
		variableName: aString;
		isCollection: false;
		yourself! !
!SmaCCVariableDefinition class categoriesFor: #assignIndices:!accessing!private! !
!SmaCCVariableDefinition class categoriesFor: #pluralNameBlock!accessing!private! !
!SmaCCVariableDefinition class categoriesFor: #pluralNameBlock:!accessing!private! !
!SmaCCVariableDefinition class categoriesFor: #pluralNameFor:!private! !
!SmaCCVariableDefinition class categoriesFor: #pluralNames!accessing!private! !
!SmaCCVariableDefinition class categoriesFor: #pluralNames:!accessing!private! !
!SmaCCVariableDefinition class categoriesFor: #variableName:!instance creation!private! !

SmaCCIntegerSet guid: (GUID fromString: '{E858FC39-BCF7-468F-AA44-DDA69CCDCC7A}')!
SmaCCIntegerSet comment: ''!
!SmaCCIntegerSet categoriesForClass!Unclassified! !
!SmaCCIntegerSet methodsFor!

< aSmaCCIntegerCollection
	| myItems i |
	self first < aSmaCCIntegerCollection first ifTrue: [^true].
	self first > aSmaCCIntegerCollection first ifTrue: [^false].
	myItems := OrderedCollection new.
	self do: [:each | myItems add: each].
	i := 1.
	aSmaCCIntegerCollection do: 
			[:each |
			| current |
			i > myItems size ifTrue: [^true].
			current := myItems at: i.
			current < each ifTrue: [^true].
			current > each ifTrue: [^false].
			i := i + 1].
	^false!

<= aSmaCCIntegerCollection
	^(aSmaCCIntegerCollection < self) not!

= anObject
	| myItems i |
	self class = anObject class ifFalse: [^false].
	(self start = anObject start and: [self run = anObject run]) ifTrue: [^self data = anObject data].
	self first = anObject first ifFalse: [^false].
	myItems := OrderedCollection new.
	self do: [:each | myItems add: each].
	i := 1.
	anObject do: 
			[:each |
			| current |
			i > myItems size ifTrue: [^false].
			current := myItems at: i.
			current < each ifTrue: [^false].
			current > each ifTrue: [^false].
			i := i + 1].
	^true!

> aSmaCCIntegerCollection
	^aSmaCCIntegerCollection < self!

>= aSmaCCIntegerCollection
	^(self < aSmaCCIntegerCollection) not!

add: anInteger
	| newData |
	[anInteger < start] whileTrue: 
			[run := run * self defaultRunSize.
			start := start - run.
			data == 0
				ifFalse: 
					[newData := Array new: self defaultRunSize withAll: 0.
					newData at: 2 put: data.
					data := newData]].
	[self defaultRunSize * run + start <= anInteger] whileTrue: 
			[run := run * self defaultRunSize.
			data == 0
				ifFalse: 
					[newData := Array new: self defaultRunSize withAll: 0.
					newData at: 1 put: data.
					data := newData]].
	data := self
				add: anInteger
				to: data
				startingAt: start
				withRun: run.
	^anInteger!

add: anInteger to: currentData startingAt: currentStart withRun: currentRun
	| newData isBits offset |
	currentData == 1 ifTrue: [^1].
	isBits := currentRun = self byteSize.
	newData := currentData == 0 ifTrue: [(isBits ifTrue: [ByteArray] ifFalse: [Array]) new: self defaultRunSize withAll: 0] ifFalse: [currentData].
	offset := (anInteger - currentStart) // currentRun + 1.
	^isBits
		ifTrue: 
			[newData at: offset put: ((newData at: offset) bitOr: (1 bitShift: (anInteger - currentStart) \\ currentRun)).
			(newData allSatisfy: [:each | each == 16rFF]) ifTrue: [1] ifFalse: [newData]]
		ifFalse: 
			[newData at: offset
				put: (self
						add: anInteger
						to: (newData at: offset)
						startingAt: currentStart + ((offset - 1) * currentRun)
						withRun: (self nextRunFrom: currentRun)).
			(newData allSatisfy: [:each | each == 1]) ifTrue: [1] ifFalse: [newData]]!

byteSize
	^8!

copyData: anObject
	| copy |
	^(anObject isKindOf: Collection)
		ifTrue: 
			[copy := anObject copy.
			1 to: copy size do: [:i | copy at: i put: (self copyData: (copy at: i))].
			copy]
		ifFalse: [anObject]!

data
	^data!

defaultRunSize
	^32!

do: aBlock
	self
		do: aBlock
		over: data
		startingAt: start
		withRun: run!

do: aBlock over: currentData startingAt: currentStart withRun: currentRun
	| index offset nextRun |
	currentData = 0 ifTrue: [^self].
	currentData = 1 ifTrue: [^currentStart to: currentStart + (currentRun * self defaultRunSize) - 1 do: [:i | aBlock value: i]].
	index := currentStart.
	currentRun = self byteSize
		ifTrue: 
			[currentData do: 
					[:each |
					| bits |
					bits := each.
					offset := 0.
					[bits = 0] whileFalse: 
							[bits odd ifTrue: [aBlock value: offset + index].
							offset := offset + 1.
							bits := bits bitShift: -1].
					index := index + currentRun].
			^self].
	nextRun := self nextRunFrom: currentRun.
	currentData do: 
			[:each |
			self
				do: aBlock
				over: each
				startingAt: index
				withRun: nextRun.
			index := index + currentRun]!

first
	self do: [:each | ^each].
	self error: 'Collection is empty'!

hash
	| hash |
	hash := self class hash.
	self do: [:each | hash := hash bitXor: ((each hash bitShift: -8) bitOr: ((each hash bitAnd: 16rFF) bitShift: 8))].
	^hash!

includes: anInteger
	anInteger < start ifTrue: [^false].
	self defaultRunSize * run + start <= anInteger ifTrue: [^false].
	^self
		includes: anInteger
		in: data
		startingAt: start
		withRun: run!

includes: anInteger in: currentData startingAt: currentStart withRun: currentRun
	| isBits offset |
	currentData = 1 ifTrue: [^true].
	currentData = 0 ifTrue: [^false].
	isBits := currentRun = self byteSize.
	offset := (anInteger - currentStart) // currentRun + 1.
	^isBits
		ifTrue: [((currentData at: offset) bitAnd: (1 bitShift: (anInteger - currentStart) \\ currentRun)) ~= 0]
		ifFalse: 
			[^self
				includes: anInteger
				in: (currentData at: offset)
				startingAt: currentStart + ((offset - 1) * currentRun)
				withRun: (self nextRunFrom: currentRun)]!

initialize
	start := 0.
	run := self byteSize.
	data := 0!

nextRunFrom: currentRun
	^currentRun // self defaultRunSize!

postCopy
	super postCopy.
	data := self copyData: data!

remove: anInteger from: currentData startingAt: currentStart withRun: currentRun
	| newData isBits offset |
	currentData == 0 ifTrue: [^0].
	isBits := currentRun = self byteSize.
	newData := currentData == 1
		ifTrue:
			[isBits ifTrue: [ByteArray new: self defaultRunSize withAll: 16rFF] ifFalse: [Array new: self defaultRunSize withAll: 1]]
		ifFalse: [currentData].
	offset := (anInteger - currentStart) // currentRun + 1.
	^isBits
		ifTrue:
			[newData at: offset put: ((newData at: offset) bitAt: (anInteger - currentStart) \\ currentRun + 1 put: 0).
			(newData allSatisfy: [:each | each == 0]) ifTrue: [0] ifFalse: [newData]]
		ifFalse:
			[newData
				at: offset
				put:
					(self
						remove: anInteger
						from: (newData at: offset)
						startingAt: currentStart + ((offset - 1) * currentRun)
						withRun: (self nextRunFrom: currentRun)).
			(newData allSatisfy: [:each | each == 0]) ifTrue: [0] ifFalse: [newData]]!

remove: anInteger ifAbsent: aBlock
	(self includes: anInteger) ifFalse: [^aBlock value].
	data := self
				remove: anInteger
				from: data
				startingAt: start
				withRun: run.
	^anInteger!

run
	^run!

start
	^start! !
!SmaCCIntegerSet categoriesFor: #<!comparing!public! !
!SmaCCIntegerSet categoriesFor: #<=!comparing!public! !
!SmaCCIntegerSet categoriesFor: #=!comparing!public! !
!SmaCCIntegerSet categoriesFor: #>!comparing!public! !
!SmaCCIntegerSet categoriesFor: #>=!comparing!public! !
!SmaCCIntegerSet categoriesFor: #add:!adding!public! !
!SmaCCIntegerSet categoriesFor: #add:to:startingAt:withRun:!private! !
!SmaCCIntegerSet categoriesFor: #byteSize!private! !
!SmaCCIntegerSet categoriesFor: #copyData:!private! !
!SmaCCIntegerSet categoriesFor: #data!private! !
!SmaCCIntegerSet categoriesFor: #defaultRunSize!private! !
!SmaCCIntegerSet categoriesFor: #do:!enumerating!public! !
!SmaCCIntegerSet categoriesFor: #do:over:startingAt:withRun:!private! !
!SmaCCIntegerSet categoriesFor: #first!accessing!public! !
!SmaCCIntegerSet categoriesFor: #hash!comparing!public! !
!SmaCCIntegerSet categoriesFor: #includes:!public!testing! !
!SmaCCIntegerSet categoriesFor: #includes:in:startingAt:withRun:!private! !
!SmaCCIntegerSet categoriesFor: #initialize!initialize-release!public! !
!SmaCCIntegerSet categoriesFor: #nextRunFrom:!private! !
!SmaCCIntegerSet categoriesFor: #postCopy!copying!public! !
!SmaCCIntegerSet categoriesFor: #remove:from:startingAt:withRun:!private! !
!SmaCCIntegerSet categoriesFor: #remove:ifAbsent:!public!removing! !
!SmaCCIntegerSet categoriesFor: #run!private! !
!SmaCCIntegerSet categoriesFor: #start!private! !

!SmaCCIntegerSet class methodsFor!

new
	^(super new)
		initialize;
		yourself!

new: aSize
	^self new! !
!SmaCCIntegerSet class categoriesFor: #new!instance creation!public! !
!SmaCCIntegerSet class categoriesFor: #new:!instance creation!public! !

SmaCCSet guid: (GUID fromString: '{B2526D5D-A31A-479A-843B-4F90C815412F}')!
SmaCCSet comment: ''!
!SmaCCSet categoriesForClass!Unclassified! !
!SmaCCSet methodsFor!

add: newObject
	^(newObject isKindOf: Character)
		ifTrue:
			[| index mask |
			index := newObject asInteger // 8 + 1.
			mask := 1 bitShift: newObject asInteger \\ 8.
			characters at: index put: ((characters at: index) bitOr: mask).
			newObject]
		ifFalse: [objects add: newObject]!

do: aBlock
	objects do: aBlock.
	characters
		keysAndValuesDo:
			[:key :value | 
			1
				to: 8
				do:
					[:j | 
					((value bitShift: 1 - j) bitAnd: 1) = 1
						ifTrue: [aBlock value: (Character value: (key - 1) * 8 + j - 1)]]]!

includes: anObject
	^(anObject isKindOf: Character)
		ifTrue:
			[| index mask |
			index := anObject asInteger // 8 + 1.
			mask := 1 bitShift: anObject asInteger \\ 8.
			^((characters at: index) bitAnd: mask) = mask]
		ifFalse: [objects includes: anObject]!

initialize
	super initialize.
	characters := ByteArray new: 16r10000 / 8.
	objects := Set new!

remove: oldObject ifAbsent: aBlock
	(oldObject isKindOf: Character)
		ifTrue:
			[| index mask |
			index := oldObject asInteger // 8 + 1.
			mask := 1 bitShift: oldObject asInteger \\ 8.
			((characters at: index) bitAnd: mask) = mask
				ifTrue:
					[characters at: index put: ((characters at: index) bitXor: mask).
					^oldObject]
				ifFalse: [^aBlock value]]
		ifFalse: [^objects remove: oldObject ifAbsent: aBlock]! !
!SmaCCSet categoriesFor: #add:!adding!private! !
!SmaCCSet categoriesFor: #do:!enumerating!private! !
!SmaCCSet categoriesFor: #includes:!private!testing! !
!SmaCCSet categoriesFor: #initialize!initialize-release!public! !
!SmaCCSet categoriesFor: #remove:ifAbsent:!private!removing! !

!SmaCCSet class methodsFor!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCSet class categoriesFor: #new!instance creation!private! !

SmaCCItemSet guid: (GUID fromString: '{DD317804-EB2B-471D-8C2C-7A252C84CB72}')!
SmaCCItemSet comment: ''!
!SmaCCItemSet categoriesForClass!Unclassified! !
!SmaCCItemSet methodsFor!

= aSmaCCItemSet
	self class = aSmaCCItemSet class
		ifTrue:
			[type == #LALR1
				ifTrue: [^self isLALREqualTo: aSmaCCItemSet]
				ifFalse: [^self isLREqualTo: aSmaCCItemSet]].
	^false!

action: aSmaCCSymbol prefer: aClass
	| action |
	action := nil.
	self
		do:
			[:each | 
			| eachAction |
			eachAction := each action: aSmaCCSymbol.
			action := action isNil ifTrue: [eachAction] ifFalse: [action mergeWith: eachAction prefer: aClass]].
	action signalAllWarnings.
	^action!

add: aSmaCCLR1Item
	| index item |
	aSmaCCLR1Item isNil ifTrue: [^aSmaCCLR1Item].
	index := self findElementOrNil: aSmaCCLR1Item.
	item := self basicAt: index.
	item isNil
		ifTrue:
			[self privateAt: index put: aSmaCCLR1Item.
			aSmaCCLR1Item itemSet: self.
			self performClosureOn: aSmaCCLR1Item]
		ifFalse: [item mergeWith: aSmaCCLR1Item].
	^aSmaCCLR1Item!

addPrevious: aSmaCCItemSet
	previousItemSets add: aSmaCCItemSet!

copyEmpty: anInteger
	^(super copyEmpty: anInteger)
		type: type;
		previousItemSets: previousItemSets;
		grammar: grammar;
		yourself!

grammar
	^grammar!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar!

hash
	^self inject: self class hash into: [:sum :each | sum bitXor: each hash]!

initialize
	(self class superclass canUnderstand: #initialize) ifTrue: [super initialize].
	type := #LALR1.
	previousItemSets := OrderedCollection new!

isLALREqualTo: aSmaCCItemSet
	^aSmaCCItemSet size = self size and: [self allSatisfy: [:each | aSmaCCItemSet includes: each]]!

isLREqualTo: anItemSet
	^anItemSet size = self size
		and:
			[self
				allSatisfy:
					[:each | 
					| item |
					(item := anItemSet itemFor: each) notNil and: [each isLR1EqualTo: item]]]!

itemFor: anObject
	^self basicAt: (self findElementOrNil: anObject)!

mergeWith: aSmaCCItemSet
	self == aSmaCCItemSet ifTrue: [^self].
	self addAll: aSmaCCItemSet.
	previousItemSets addAll: aSmaCCItemSet previousItemSets!

moveOn: aSmaCCSymbol
	| anItemSet |
	anItemSet := self class new.
	anItemSet grammar: grammar.
	anItemSet addPrevious: self.
	anItemSet type: type.
	self do: [:each | each nextSymbol == aSmaCCSymbol ifTrue: [anItemSet add: each moveNext]].
	^anItemSet!

path
	| result |
	result := OrderedCollection new.
	self pathInto: result.
	^result!

pathInto: anOrderedCollection
	| item |
	self previousState isNil ifTrue: [^self].
	self previousState pathInto: anOrderedCollection.
	item := self detect: [:each | each location > 1].
	anOrderedCollection add: (item rhs at: item location - 1)!

performClosureOn: aSmaCCLR1Item
	| nextSymbol rest first followers |
	nextSymbol := aSmaCCLR1Item nextSymbol.
	nextSymbol isTerminal ifTrue: [^self].
	rest := aSmaCCLR1Item rest.
	first := rest firstTerminals.
	followers := SmaCCSymbolSet new.
	(first includes: grammar emptySymbol)
		ifTrue:
			[first remove: grammar emptySymbol.
			followers baseOn: aSmaCCLR1Item followers].
	followers addAll: first.
	nextSymbol productionsDo: [:each | self add: (SmaCCLR1Item rhs: each follow: followers)]!

previousItemSets
	^previousItemSets!

previousItemSets: aCollection
	previousItemSets := aCollection!

previousState
	"Pick some previous item set"

	previousItemSets isEmpty ifTrue: [^nil].
	^previousItemSets first!

printOn: aStream
	| strings |
	strings := OrderedCollection new: self size.
	self do: [:each | strings add: each printString].
	strings asSortedCollection
		do:
			[:each | 
			aStream
				tab;
				nextPutAll: each;
				cr]!

type: aSymbol
	type := aSymbol! !
!SmaCCItemSet categoriesFor: #=!comparing!private! !
!SmaCCItemSet categoriesFor: #action:prefer:!accessing!private! !
!SmaCCItemSet categoriesFor: #add:!adding!private! !
!SmaCCItemSet categoriesFor: #addPrevious:!accessing!private! !
!SmaCCItemSet categoriesFor: #copyEmpty:!copying!public! !
!SmaCCItemSet categoriesFor: #grammar!accessing!public! !
!SmaCCItemSet categoriesFor: #grammar:!accessing!public! !
!SmaCCItemSet categoriesFor: #hash!comparing!private! !
!SmaCCItemSet categoriesFor: #initialize!initialize-release!private! !
!SmaCCItemSet categoriesFor: #isLALREqualTo:!private!testing! !
!SmaCCItemSet categoriesFor: #isLREqualTo:!private!testing! !
!SmaCCItemSet categoriesFor: #itemFor:!private! !
!SmaCCItemSet categoriesFor: #mergeWith:!accessing!private! !
!SmaCCItemSet categoriesFor: #moveOn:!accessing!public! !
!SmaCCItemSet categoriesFor: #path!accessing!private! !
!SmaCCItemSet categoriesFor: #pathInto:!accessing!private! !
!SmaCCItemSet categoriesFor: #performClosureOn:!private! !
!SmaCCItemSet categoriesFor: #previousItemSets!accessing!private! !
!SmaCCItemSet categoriesFor: #previousItemSets:!accessing!private! !
!SmaCCItemSet categoriesFor: #previousState!accessing!private! !
!SmaCCItemSet categoriesFor: #printOn:!printing!private! !
!SmaCCItemSet categoriesFor: #type:!initialize-release!public! !

!SmaCCItemSet class methodsFor!

new: anInteger 
	^(super new: anInteger)
		initialize;
		yourself! !
!SmaCCItemSet class categoriesFor: #new:!instance creation!private! !

SmaCCCharacterSet guid: (GUID fromString: '{DDDD9C0F-B2D1-4196-A755-C8E307D014D1}')!
SmaCCCharacterSet comment: ''!
!SmaCCCharacterSet categoriesForClass!Unclassified! !
!SmaCCCharacterSet methodsFor!

add: aCharacter
	super add: aCharacter asInteger.
	^aCharacter!

asString
	^String withAll: self!

do: aBlock
	^super do: [:each | aBlock value: (Character value: each)]!

includes: aCharacter
	^super includes: aCharacter asInteger!

remove: aCharacter ifAbsent: aBlock
	(self includes: aCharacter) ifFalse: [^aBlock value].
	super remove: aCharacter asInteger ifAbsent: aBlock.
	^aCharacter! !
!SmaCCCharacterSet categoriesFor: #add:!adding!public! !
!SmaCCCharacterSet categoriesFor: #asString!converting!public! !
!SmaCCCharacterSet categoriesFor: #do:!enumerating!public! !
!SmaCCCharacterSet categoriesFor: #includes:!public!testing! !
!SmaCCCharacterSet categoriesFor: #remove:ifAbsent:!public!removing! !

SmaCCCompilationNotification guid: (GUID fromString: '{253FC052-AC0E-4FF8-9E33-5C641073D603}')!
SmaCCCompilationNotification comment: 'SmaCCCompilationNotification is a Notification that is signaled when a problem occurs when compiling the parser. It is mainly used to show the user problems with their grammar.'!
!SmaCCCompilationNotification categoriesForClass!Unclassified! !
SmaCCSymbolSet guid: (GUID fromString: '{6E938F04-4A55-41A5-8048-4179BB054BD6}')!
SmaCCSymbolSet comment: ''!
!SmaCCSymbolSet categoriesForClass!Unclassified! !
!SmaCCSymbolSet methodsFor!

add: aSmaCCSymbol
	(symbols includes: aSmaCCSymbol) ifTrue: [^self].
	symbols add: aSmaCCSymbol.
	self changed!

addAll: aCollection
	| todo |
	todo := OrderedCollection with: self.
	[todo notEmpty]
		whileTrue:
			[| oldSize current |
			current := todo removeFirst.
			oldSize := current symbols size.
			current symbols addAll: aCollection.
			oldSize ~= current symbols size ifTrue: [todo addAll: current dependents]]!

addComponent: aSmaCCSymbolSet
	(aSmaCCSymbolSet = self or: [components includes: aSmaCCSymbolSet]) ifTrue: [^self].
	components add: aSmaCCSymbolSet.
	aSmaCCSymbolSet addDependent: self.
	self addAll: aSmaCCSymbolSet symbols!

addComponentsFrom: aSmaCCSymbolSet
	aSmaCCSymbolSet components do: [:each | self addComponent: each]!

allSatisfy: aBlock
	^symbols allSatisfy: aBlock!

baseOn: aSmaCCSymbolSet
	self addComponent: aSmaCCSymbolSet.
	self addAll: aSmaCCSymbolSet symbols!

components
	^components!

getDependents
	^dependents!

includes: aSmaCCSymbol
	^symbols includes: aSmaCCSymbol!

initialize
	super initialize.
	symbols := Set new.
	components := Set new!

mergeWith: aSmaCCSymbolSet
	self addAll: aSmaCCSymbolSet symbols.
	self addComponentsFrom: aSmaCCSymbolSet!

printOn: aStream
	(symbols asSortedCollection: [:a :b | a name < b name])
		do: [:each | aStream nextPutAll: each printString]
		separatedBy: [aStream space]!

setDependents: aCollection
	^dependents := aCollection!

size
	^symbols size!

symbols
	^symbols!

update: anAspectSymbol with: aParameter from: aSender
	(components includes: aSender) ifTrue: [self addAll: aSender symbols]! !
!SmaCCSymbolSet categoriesFor: #add:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #addAll:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #addComponent:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #addComponentsFrom:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #allSatisfy:!private!testing! !
!SmaCCSymbolSet categoriesFor: #baseOn:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #components!accessing!private! !
!SmaCCSymbolSet categoriesFor: #getDependents!public! !
!SmaCCSymbolSet categoriesFor: #includes:!private!testing! !
!SmaCCSymbolSet categoriesFor: #initialize!initialize-release!public! !
!SmaCCSymbolSet categoriesFor: #mergeWith:!accessing!private! !
!SmaCCSymbolSet categoriesFor: #printOn:!printing!private! !
!SmaCCSymbolSet categoriesFor: #setDependents:!public! !
!SmaCCSymbolSet categoriesFor: #size!accessing!private! !
!SmaCCSymbolSet categoriesFor: #symbols!accessing!private! !
!SmaCCSymbolSet categoriesFor: #update:with:from:!private!updating! !

!SmaCCSymbolSet class methodsFor!

basedOn: aSmaCCSymbolSet 
	^(self new)
		baseOn: aSmaCCSymbolSet;
		yourself!

new
	^(super new)
		initialize;
		yourself! !
!SmaCCSymbolSet class categoriesFor: #basedOn:!instance creation!private! !
!SmaCCSymbolSet class categoriesFor: #new!instance creation!private! !

SmaCCCompositeAction guid: (GUID fromString: '{F00F0EAD-09B8-4EC3-AF4E-A446D4BC04CE}')!
SmaCCCompositeAction comment: 'SmaCCCompositeAction is an abstract class that represents multiple actions. 

Subclasses must implement the following messages:
	accessing
		errorType
		preferredAction

Instance Variables:
	actions	<Collection of: SmaCCAction>	all valid non-reject actions

'!
!SmaCCCompositeAction categoriesForClass!Unclassified! !
!SmaCCCompositeAction methodsFor!

actions
	^actions!

addAction: aSmaCCAction
	actions add: aSmaCCAction!

addActions: aSmaCCActionCollection
	actions addAll: aSmaCCActionCollection!

errorType
	self subclassResponsibility!

id
	^self preferredAction id!

initialize
	super initialize.
	actions := OrderedCollection new!

lr1Item
	^self preferredAction lr1Item!

preferredAction
	self subclassResponsibility!

printPathOn: aStream
	self lr1Item path do: [:each | aStream nextPutAll: each name] separatedBy: [aStream space]!

raiseXReduceNotification
	| stream |
	stream := WriteStream with: String new.
	actions
		do:
			[:each | 
			stream nextPutAll: each lr1Item printString.
			each == self preferredAction ifTrue: [stream nextPutAll: '	*****'].
			stream cr].
	stream cr.
	self printPathOn: stream.
	SmaCCCompilationNotification signal: self errorType with: stream contents!

signalAllWarnings
	self raiseXReduceNotification! !
!SmaCCCompositeAction categoriesFor: #actions!accessing-actions!private! !
!SmaCCCompositeAction categoriesFor: #addAction:!accessing-actions!private! !
!SmaCCCompositeAction categoriesFor: #addActions:!accessing-actions!private! !
!SmaCCCompositeAction categoriesFor: #errorType!error handling!private! !
!SmaCCCompositeAction categoriesFor: #id!accessing!private! !
!SmaCCCompositeAction categoriesFor: #initialize!initialize-release!private! !
!SmaCCCompositeAction categoriesFor: #lr1Item!accessing!private! !
!SmaCCCompositeAction categoriesFor: #preferredAction!accessing!private! !
!SmaCCCompositeAction categoriesFor: #printPathOn:!printing!private! !
!SmaCCCompositeAction categoriesFor: #raiseXReduceNotification!error handling!private! !
!SmaCCCompositeAction categoriesFor: #signalAllWarnings!error handling!private! !

SmaCCPrimitiveAction guid: (GUID fromString: '{3C5FE529-3CAD-454B-97F3-5EB4B14F86E5}')!
SmaCCPrimitiveAction comment: 'SmaCCPrimitiveAction is an abstract class that represents a basic LR state/symbol action (shift, reduce, accept, or reject).

Instance Variables:
	lr1Item	<SmaCCLR1Item>	the item that the action is for

'!
!SmaCCPrimitiveAction categoriesForClass!Unclassified! !
!SmaCCPrimitiveAction methodsFor!

lr1Item
	^lr1Item!

lr1Item: aSmaCCLR1Item
	lr1Item := aSmaCCLR1Item! !
!SmaCCPrimitiveAction categoriesFor: #lr1Item!accessing!private! !
!SmaCCPrimitiveAction categoriesFor: #lr1Item:!initialize-release!private! !

!SmaCCPrimitiveAction class methodsFor!

item: aSmaCCLR1Item
	^(self new)
		lr1Item: aSmaCCLR1Item;
		yourself! !
!SmaCCPrimitiveAction class categoriesFor: #item:!instance creation!private! !

SmaCCAmbiguousAction guid: (GUID fromString: '{02E5B0F9-CE7E-4F81-953A-3277D1110D7D}')!
SmaCCAmbiguousAction comment: 'SmaCCAmbiguousAction represents several conflicting actions for a state/symbol. If we are creating a GLR parser then all actions will be performed. Otherwise, we''ll pick one of the actions to be performed preferring shift actions over reduce actions.'!
!SmaCCAmbiguousAction categoriesForClass!Unclassified! !
!SmaCCAmbiguousAction methodsFor!

addAction: aSmaCCAction
	aSmaCCAction isAmbiguous
		ifTrue: [actions addAll: aSmaCCAction actions]
		ifFalse: [super addAction: aSmaCCAction]!

errorType
	| sortedActions |
	sortedActions := self sortedActions.
	^sortedActions first class = sortedActions last class ifTrue: ['Reduce/Reduce Conflict'] ifFalse: ['Shift/Reduce Conflict']!

isAmbiguous
	^true!

mergeWith: aSmaCCAction prefer: aClass
	aSmaCCAction isReject ifTrue: [^self].
	aSmaCCAction isAmbiguous ifTrue: [actions addAll: aSmaCCAction actions] ifFalse: [actions add: aSmaCCAction].
	^self!

preferredAction
	^self sortedActions first!

sortedActions
	"When in doubt shift the token"

	^actions asSortedCollection: [:a :b | a id <= b id]! !
!SmaCCAmbiguousAction categoriesFor: #addAction:!accessing-actions!private! !
!SmaCCAmbiguousAction categoriesFor: #errorType!error handling!private! !
!SmaCCAmbiguousAction categoriesFor: #isAmbiguous!private!testing! !
!SmaCCAmbiguousAction categoriesFor: #mergeWith:prefer:!merging!private! !
!SmaCCAmbiguousAction categoriesFor: #preferredAction!accessing!private! !
!SmaCCAmbiguousAction categoriesFor: #sortedActions!accessing!private! !

SmaCCPreferredCompositeAction guid: (GUID fromString: '{677DCB79-F0A7-437E-AF01-8F87BFD08C9D}')!
SmaCCPreferredCompositeAction comment: 'SmaCCPreferredCompositeAction is a composite action that has a preferred action. The preferred action is used in the state/symbol table.

Instance Variables:
	preferredAction	<SmaCCAction>	the preferred action

'!
!SmaCCPreferredCompositeAction categoriesForClass!Unclassified! !
!SmaCCPreferredCompositeAction methodsFor!

errorType
	^'Shift/Reduce Conflict (handled by precedence rules)'!

mergeWith: aSmaCCAction prefer: aClass
	aSmaCCAction isReduce
		ifTrue:
			[self reduceAction = aSmaCCAction ifTrue: [^self].
			^(SmaCCAmbiguousAction new)
				addAction: aSmaCCAction;
				addActions: actions;
				yourself].
	aSmaCCAction isShift
		ifTrue:
			[self addAction: aSmaCCAction.
			^self].
	^aSmaCCAction mergeWith: self prefer: aClass!

preferredAction
	^preferredAction!

preferredAction: aSmaCCAction
	preferredAction := aSmaCCAction!

reduceAction
	^actions detect: [:each | each isReduce]! !
!SmaCCPreferredCompositeAction categoriesFor: #errorType!error handling!private! !
!SmaCCPreferredCompositeAction categoriesFor: #mergeWith:prefer:!merging!private! !
!SmaCCPreferredCompositeAction categoriesFor: #preferredAction!accessing!private! !
!SmaCCPreferredCompositeAction categoriesFor: #preferredAction:!initialize-release!private! !
!SmaCCPreferredCompositeAction categoriesFor: #reduceAction!private! !

SmaCCAcceptAction guid: (GUID fromString: '{D3EADC15-63AB-4FC7-B0E5-14EAC82CFBDF}')!
SmaCCAcceptAction comment: 'SmaCCAcceptAction represents the LR accept action.

'!
!SmaCCAcceptAction categoriesForClass!Unclassified! !
!SmaCCAcceptAction methodsFor!

id
	^2r00!

mergeWith: aSmaCCAction prefer: aClass
	^self! !
!SmaCCAcceptAction categoriesFor: #id!accessing!private! !
!SmaCCAcceptAction categoriesFor: #mergeWith:prefer:!merging!private! !

SmaCCReduceAction guid: (GUID fromString: '{7BE501B1-7D30-4446-9796-2C9A12C5B40C}')!
SmaCCReduceAction comment: 'SmaCCReduceAction represents the LR reduce action.
'!
!SmaCCReduceAction categoriesForClass!Unclassified! !
!SmaCCReduceAction methodsFor!

id
	^2r10!

isReduce
	^true!

mergeWith: aSmaCCAction prefer: aClass
	aSmaCCAction isReduce ifTrue: [^self mergeWithReduceAction: aSmaCCAction].
	^aSmaCCAction mergeWith: self prefer: aClass!

mergeWithReduceAction: aSmaCCAction
	self = aSmaCCAction ifTrue: [^self].
	^(SmaCCAmbiguousAction new)
		addAction: self;
		addAction: aSmaCCAction;
		yourself! !
!SmaCCReduceAction categoriesFor: #id!accessing!private! !
!SmaCCReduceAction categoriesFor: #isReduce!private!testing! !
!SmaCCReduceAction categoriesFor: #mergeWith:prefer:!merging!private! !
!SmaCCReduceAction categoriesFor: #mergeWithReduceAction:!merging!private! !

!SmaCCReduceAction class methodsFor!

rhs: aSmaCCRHS
	^(self new)
		rhs: aSmaCCRHS;
		yourself! !
!SmaCCReduceAction class categoriesFor: #rhs:!instance creation!private! !

SmaCCRejectAction guid: (GUID fromString: '{A2951C83-3B6D-4630-BC8B-C0886F8A85F7}')!
SmaCCRejectAction comment: 'SmaCCRejectAction represents the LR reject action.

'!
!SmaCCRejectAction categoriesForClass!Unclassified! !
!SmaCCRejectAction methodsFor!

id
	^2r11!

isReject
	^true!

mergeWith: aSmaCCAction prefer: aClass
	^aSmaCCAction! !
!SmaCCRejectAction categoriesFor: #id!accessing!private! !
!SmaCCRejectAction categoriesFor: #isReject!private!testing! !
!SmaCCRejectAction categoriesFor: #mergeWith:prefer:!merging!private! !

SmaCCShiftAction guid: (GUID fromString: '{3588055E-39E0-46E9-83AF-E2AEA500EAF2}')!
SmaCCShiftAction comment: 'SmaCCShiftAction represents the LR shift action.'!
!SmaCCShiftAction categoriesForClass!Unclassified! !
!SmaCCShiftAction methodsFor!

id
	^2r01!

isShift
	^true!

mergeWith: aSmaCCAction prefer: aClass
	aSmaCCAction isShift ifTrue: [^self].
	aSmaCCAction isReduce ifTrue: [^self mergeWithReduceAction: aSmaCCAction prefer: aClass].
	^aSmaCCAction mergeWith: self prefer: aClass!

mergeWithReduceAction: aSmaCCAction prefer: aClass
	| result |
	(self precedence isNil or: [aSmaCCAction precedence isNil])
		ifTrue:
			[^(SmaCCAmbiguousAction new)
				addAction: self;
				addAction: aSmaCCAction;
				yourself].
	result := self.
	self precedence < aSmaCCAction precedence ifTrue: [result := aSmaCCAction].
	self precedence = aSmaCCAction precedence
		ifTrue:
			[aSmaCCAction class = aClass ifTrue: [result := aSmaCCAction].
			aClass = SmaCCRejectAction ifTrue: [result := SmaCCRejectAction item: self lr1Item]].
	^(SmaCCPreferredCompositeAction new)
		addAction: self;
		addAction: aSmaCCAction;
		preferredAction: result;
		yourself! !
!SmaCCShiftAction categoriesFor: #id!accessing!private! !
!SmaCCShiftAction categoriesFor: #isShift!private!testing! !
!SmaCCShiftAction categoriesFor: #mergeWith:prefer:!merging!private! !
!SmaCCShiftAction categoriesFor: #mergeWithReduceAction:prefer:!merging!private! !

SmaCCNodeClassDefinition guid: (GUID fromString: '{F5FB0436-DB26-4CE8-A362-D1639E5D48ED}')!
SmaCCNodeClassDefinition comment: 'SmaCCNodeClassDefinition represents a class to compile.

Instance Variables
	extraAttributes	<Collection of: SmaCCVariableDefinition>	extra variables that should be added to the class
	productions	<Collection of: SmaCCRHS>	all of the rhs that return/create this class
	variables	<Collection of: SmaCCVariableDefinition>	the variables defined by the grammar for this class
'!
!SmaCCNodeClassDefinition categoriesForClass!Unclassified! !
!SmaCCNodeClassDefinition methodsFor!

addProduction: aSmaCCRHS
	productions add: aSmaCCRHS.
	aSmaCCRHS nodeClassDefinition: self!

addVariable: aSmaCCVariableDefinition
	self codeGenerator addVariable: aSmaCCVariableDefinition forDefinition: self!

allVariableDefinitions
	| defs |
	defs := OrderedCollection new.
	superclass notNil ifTrue: [defs addAll: superclass variableDefinitions].
	defs addAll: self variableDefinitions.
	^defs!

baseTypeOf: aVariableName
	| allTypes aRBRootNamespace |
	aRBRootNamespace := class model.
	allTypes := self modelTypesForVariable: aVariableName.
	allTypes remove: (aRBRootNamespace classFor: nil class) ifAbsent: [nil].
	allTypes isEmpty ifTrue: [^aRBRootNamespace classFor: Object].
	allTypes := allTypes asOrderedCollection.
	^allTypes
		inject: allTypes first
		into:
			[:sum :each | 
			| current |
			current := sum.
			[current notNil and: [(each includesClass: current) not]] whileTrue: [current := current superclass].
			current]!

calculateCommonSubclassVariables
	| allSubclassVars includedVariables |
	allSubclassVars := Bag new.
	subclasses do: [:each | allSubclassVars addAll: each variableDefinitions].
	includedVariables := allSubclassVars asSet select: [:each | (allSubclassVars occurrencesOf: each) = subclasses size].
	^self subclassProductionVariables select: [:each | includedVariables includes: each]!

collectionGetterForVariableName: aString
	self variableDefinitionInHierarchyNamed: aString do: [:var | var isCollection ifTrue: [^var getterMethodName asSymbol]].
	^nil!

collectionVariableDefinitions
	^self variableDefinitions select: [:each | each isCollection]!

compileChildrenMethod
	self codeGenerator compileChildrenMethod: self!

compileCopyInContextMethod
	self codeGenerator compileCopyInContextMethod: self!

compileEqualMethod
	self codeGenerator compileEqualMethod: self!

compileGetterAndSetter: aSmaCCVariableDefinition
	self codeGenerator compileGetterAndSetter: aSmaCCVariableDefinition forDefinition: self!

compileHashMethod
	self codeGenerator compileHashMethod: self!

compileInitializeMethod
	self codeGenerator compileInitializeMethod: self!

compileMatchInContextMethod
	self codeGenerator compileMatchInContextMethod: self!

compileMethodsAndVariables
	self
		compileVariablesAndAccessors;
		compileInitializeMethod;
		compileHashMethod;
		compileEqualMethod;
		compilePostCopyMethod;
		compileChildrenMethod;
		compileCopyInContextMethod;
		compileMatchInContextMethod;
		compileVariablesMethods!

compilePostCopyMethod
	self codeGenerator compilePostCopyMethod: self!

compileVariableAndAccessor: aSmaCCVariableDefinition
	aSmaCCVariableDefinition baseType: (self baseTypeOf: aSmaCCVariableDefinition variableName).
	aSmaCCVariableDefinition
		isAlwaysAssigned: (self isAlwaysAssigned: aSmaCCVariableDefinition variableName).
	self addVariable: aSmaCCVariableDefinition.
	self compileGetterAndSetter: aSmaCCVariableDefinition!

compileVariablesAndAccessors
	self variableDefinitions do: [:each | self compileVariableAndAccessor: each].
	self extraAttributes do: [:each | self compileVariableAndAccessor: each]!

compileVariablesMethods
	self codeGenerator compileVariablesMethods: self!

copyName
	^self findNameUsing: #('copy' 'new')!

extraAttributes
	^extraAttributes!

extraAttributes: aCollection
	extraAttributes := aCollection!

findNameUsing: aCollection
	| string index indexString |
	index := 0.
	indexString := ''.
	[string := aCollection
		detect: [:each | (self hierarchyDefinesVariable: each , indexString) not]
		ifNone: [nil].
	string notNil ifTrue: [^string , indexString].
	index := index + 1.
	indexString := index printString] repeat!

fullName
	^self codeGenerator namespaceName , grammar prefix , name , grammar suffix!

grammar
	^grammar!

hasVariable: aString
	^(variables anySatisfy: [:each | each variableName = aString])
		or: [superclass notNil and: [superclass hasVariable: aString]]!

hierarchyDefinesVariable: aString
	^self withAllSubclasses anySatisfy: [:cls | cls instanceVariableNames includes: aString]!

initialize
	super initialize.
	productions := OrderedCollection new.
	extraAttributes := OrderedCollection new!

instanceVariableNames
	^self variableDefinitions collect: [:each | each variableName]!

isAlwaysAssigned: aString
	^((self modelTypesForVariable: aString) includes: (class model classFor: nil class))
		and:
			[self withAllSubclasses allSatisfy: [:sub | sub productions allSatisfy: [:each | each locallyDefinesVariable: aString]]]!

isCollectionVariable: aVariableName
	| definition |
	definition := self variableDefinitionNamed: aVariableName.
	definition notNil ifTrue: [^definition isCollection].
	^superclass notNil and: [superclass isCollectionVariable: aVariableName]!

isLocalVariable: aSmaCCVariableDefinition
	^superclass isNil or: [(superclass variableDefinitionNamed: aSmaCCVariableDefinition variableName) isNil]!

modelTypesForVariable: aVariableName
	| allTypes |
	allTypes := Set new.
	self withAllSubclasses do: [:each | each productions do: [:production | allTypes addAll: (production modelTypesForVariable: aVariableName)]].
	^allTypes!

nodeVariableDefinitions
	^self variableDefinitions select: [:each | each isBasePossibleNodeType]!

objectGetterForVariableName: aString
	self variableDefinitionInHierarchyNamed: aString do: [:var | var isCollection ifFalse: [^var getterMethodName asSymbol]].
	^nil!

productions
	^productions!

productionVariables
	| vars |
	vars := productions collect: [:each | each variableDefinitions].
	^SmaCCSymbol mergeOrderedVariableDefinitions: vars!

removeDuplicateSubclassVariables
	variables do: [:each | self withAllSubclasses do: [:sub | sub == self ifFalse: [sub removeInstanceVariable: each variableName]]]!

removeInstanceVariable: aString
	| variable |
	variable := self variableDefinitions detect: [:each | each variableName = aString] ifNone: [nil].
	variable isNil ifTrue: [^self].
	variables remove: variable.
	SmaCCVariableDefinition assignIndices: variables!

rootClassName
	^SmaCCParseNode name!

subclassProductionVariables
	| vars |
	vars := self withAllSubclasses collect: [:sub | sub productionVariables].
	^SmaCCSymbol mergeOrderedVariableDefinitions: vars!

tempNodeName
	^self temporaryNameFor: grammar rootDefinition name!

variableDefinitionInHierarchyNamed: aString do: aBlock
	self withAllSubclasses do: [:cls | (cls variableDefinitionNamed: aString) ifNotNil: aBlock]!

variableDefinitionNamed: aString
	^self variableDefinitions
		detect: [:each | each variableName = aString]
		ifNone: [superclass isNil ifTrue: [nil] ifFalse: [superclass variableDefinitionNamed: aString]]!

variableDefinitions
	variables isNil
		ifTrue:
			[variables := productions isEmpty ifTrue: [self calculateCommonSubclassVariables] ifFalse: [self productionVariables].
			self removeDuplicateSubclassVariables.
			SmaCCVariableDefinition assignIndices: variables].
	^variables!

variables
	^superclass isNil
		ifTrue: [self instanceVariableNames copy]
		ifFalse:
			[(superclass variables)
				addAll: self instanceVariableNames;
				yourself]! !
!SmaCCNodeClassDefinition categoriesFor: #addProduction:!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #addVariable:!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #allVariableDefinitions!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #baseTypeOf:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #calculateCommonSubclassVariables!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #collectionGetterForVariableName:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #collectionVariableDefinitions!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #compileChildrenMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileCopyInContextMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileEqualMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileGetterAndSetter:!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileHashMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileInitializeMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileMatchInContextMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileMethodsAndVariables!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compilePostCopyMethod!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileVariableAndAccessor:!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileVariablesAndAccessors!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #compileVariablesMethods!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #copyName!private! !
!SmaCCNodeClassDefinition categoriesFor: #extraAttributes!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #extraAttributes:!initialize-release!private! !
!SmaCCNodeClassDefinition categoriesFor: #findNameUsing:!private! !
!SmaCCNodeClassDefinition categoriesFor: #fullName!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #grammar!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #hasVariable:!private!testing! !
!SmaCCNodeClassDefinition categoriesFor: #hierarchyDefinesVariable:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #initialize!initialize-release!private! !
!SmaCCNodeClassDefinition categoriesFor: #instanceVariableNames!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #isAlwaysAssigned:!private!testing! !
!SmaCCNodeClassDefinition categoriesFor: #isCollectionVariable:!private!testing! !
!SmaCCNodeClassDefinition categoriesFor: #isLocalVariable:!private!testing! !
!SmaCCNodeClassDefinition categoriesFor: #modelTypesForVariable:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #nodeVariableDefinitions!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #objectGetterForVariableName:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #productions!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #productionVariables!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #removeDuplicateSubclassVariables!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #removeInstanceVariable:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #rootClassName!private! !
!SmaCCNodeClassDefinition categoriesFor: #subclassProductionVariables!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #tempNodeName!compiling!private! !
!SmaCCNodeClassDefinition categoriesFor: #variableDefinitionInHierarchyNamed:do:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #variableDefinitionNamed:!private!private-variables! !
!SmaCCNodeClassDefinition categoriesFor: #variableDefinitions!accessing!private! !
!SmaCCNodeClassDefinition categoriesFor: #variables!accessing!private! !

!SmaCCNodeClassDefinition class methodsFor!

named: aSymbol grammar: aSmaCCGrammar 
	^(self new)
		name: aSymbol;
		grammar: aSmaCCGrammar;
		yourself! !
!SmaCCNodeClassDefinition class categoriesFor: #named:grammar:!instance creation!private! !

SmaCCVisitorClassDefinition guid: (GUID fromString: '{AFAAA57A-2310-455D-AB97-E323AFD9A058}')!
SmaCCVisitorClassDefinition comment: 'SmaCCVisitorClassDefinition represents the visitor class for the grammar.

Instance Variables
	nodeClassDefinitions	<Collection of: SmaCCNodeClassDefinition>	the node classes to create the visitor for'!
!SmaCCVisitorClassDefinition categoriesForClass!Unclassified! !
!SmaCCVisitorClassDefinition methodsFor!

compileMethodsAndVariables
	nodeClassDefinitions do: [:each | self compileVisitMethodFor: each].
	self codeGenerator compileAcceptNodeMethodFor: self rootNode: grammar rootDefinition!

compileVisitMethodFor: aSmaCCNodeClassDefinition
	self codeGenerator compileVisitMethodFor: aSmaCCNodeClassDefinition visitor: self!

name
	^self modelClass name!

nodeClassDefinitions: aCollection
	nodeClassDefinitions := aCollection!

rootClassName
	^SmaCCParseNodeVisitor fullName! !
!SmaCCVisitorClassDefinition categoriesFor: #compileMethodsAndVariables!compiling!private! !
!SmaCCVisitorClassDefinition categoriesFor: #compileVisitMethodFor:!compiling!private! !
!SmaCCVisitorClassDefinition categoriesFor: #name!accessing!private! !
!SmaCCVisitorClassDefinition categoriesFor: #nodeClassDefinitions:!initialize-release!private! !
!SmaCCVisitorClassDefinition categoriesFor: #rootClassName!private! !

!SmaCCVisitorClassDefinition class methodsFor!

forClassDefinitions: aCollection 
	^(self new)
		nodeClassDefinitions: aCollection;
		yourself! !
!SmaCCVisitorClassDefinition class categoriesFor: #forClassDefinitions:!instance creation!private! !

SmaCCSmalltalkCodeGenerator guid: (GUID fromString: '{8E795A9C-1996-41C1-A950-CB3402CF0D7E}')!
SmaCCSmalltalkCodeGenerator comment: 'SmaCCSmalltalkCodeGenerator represents a code generator for Smalltalk.

Instance Variables
	isExpressions	<Dictionary key: String value: Symbol>	a map of strings to is??? methods on String that answer true for those strings (e.g., ''0123456789'' -> #isDigit)
	parseTreeCache	<Dictionary key: Symbol value: RBProgramNode>	mapping from selector names to code compiled in the method
'!
!SmaCCSmalltalkCodeGenerator categoriesForClass!Unclassified! !
!SmaCCSmalltalkCodeGenerator methodsFor!

acceptStateEdge: aSmaCCStateEdge
	^aSmaCCStateEdge transitionObjects size = 1
		ifTrue: ['state == #' , aSmaCCStateEdge transitionObjects asArray first]
		ifFalse: ['(' , aSmaCCStateEdge transitionObjects asArray storeString , ' includes: state)']!

addImplementationSpecificRewritesTo: rewriter
	rewriter
		replace:
				'`{:node :dict | (node isLiteralNode and: [(node value isKindOf: Character) and: [(node value codePoint between: 32 and: 126) not]]) ifTrue: [dict at: ''literal'' put: node. true] ifFalse: [false]}'
			with: '##(Character value: `{:dict | RBLiteralNode value: (dict at: ''literal'') value codePoint})';
		replace:
				'``@.Stmts1.
				(`@a ifTrue: [``@.Stmts2]) `{:node :dictionary | | index myStatements |
						index := node parent statements indexOf: node.
						myStatements := node parent statements.
						dictionary at: #size put: ``@.Stmts2 size - (myStatements size - index).
						index ~~  myStatements size and: [``@.Stmts2 size >= (myStatements size - index) and: [
							(index + 1 to: myStatements size) allSatisfy: [:each | 
								(myStatements at: each) = (``@.Stmts2 at: ``@.Stmts2 size - (myStatements size - each))]]]
						}.
				``@.Stmts3'
			with:
				'``@.Stmts1.
				`{:dictionary | RBMessageNode receiver: `@a selector: #ifTrue: arguments: (Array with: (RBBlockNode body: (RBSequenceNode statements: (``@.Stmts2 copyFrom: 1 to: (dictionary at: #size)))))}.
				``@.Stmts3';
		replace: 'currentCharacter == `#l1 or: [currentCharacter == `#l2]'
			with: '`{RBLiteralNode value: (String with: `#l1 value with: `#l2 value)} includes: currentCharacter';
		replace: 'currentCharacter == `#l1 or: [currentCharacter == `#l2 or: `@a]'
			with: '(`{RBLiteralNode value: (String with: `#l1 value with: `#l2 value)} includes: currentCharacter) or: `@a';
		replace: '(`#l1 includes: currentCharacter) or: [currentCharacter == `#l2]'
			with: '`{RBLiteralNode value: `#l1 value , (String with: `#l2 value)} includes: currentCharacter';
		replace: '(`#l1 includes: currentCharacter) or: [currentCharacter == `#l2 or: `@a]'
			with: '(`{RBLiteralNode value: `#l1 value , (String with: `#l2 value)} includes: currentCharacter) or: `@a';
		replace:
				'`@.Stmts1.
				currentCharacter isLiteral ifTrue: [`@.Stmts2].
				`@.Stmts3'
			with:
				'`@.Stmts1.
				`@.Stmts2'!

addVariable: aSmaCCVariableDefinition forDefinition: aSmaCCNodeClassDefinition
	| instVarName |
	instVarName := self nonKeywordNameFor: aSmaCCVariableDefinition sourceVariableName.
	(aSmaCCNodeClassDefinition modelClass definesInstanceVariable: instVarName) ifTrue: [^self].
	aSmaCCNodeClassDefinition modelClass addInstanceVariable: instVarName!

basicCompileSourceFor: aSmaCCReduceAction
	| parseTree rewriter methodName existing |
	parseTree := SmalltalkParser parseExpression: aSmaCCReduceAction rhs reduceAction source.
	(parseTree isLiteralNode
		and:
			[parseTree value isSymbol
				and: [parseTree value argumentCount <= 1 and: [self parserClass definesMethod: parseTree value]]])
		ifTrue: [^parseTree value].
	rewriter := self parseTreeRewriterFor: aSmaCCReduceAction rhs.
	rewriter executeTree: parseTree.
	parseTree := rewriter tree.
	methodName := ('reduceActionFor' , aSmaCCReduceAction symbol safeMethodName
		, (aSmaCCReduceAction symbol positionOf: aSmaCCReduceAction rhs) printString , ':') asSymbol.
	parseTree isSequence ifFalse: [parseTree := RBSequenceNode statements: (Array with: parseTree)].
	parseTree := RBMethodNode
		selector: methodName
		arguments: (Array with: (RBVariableNode named: 'nodes'))
		body: parseTree.
	parseTree addReturn.
	existing := self findExistingMethodFor: parseTree.
	existing notNil ifTrue: [^existing].
	self parserClass compile: parseTree formattedCode classified: 'generated-reduction actions'.
	^methodName!

changes
	^model changes!

closestIsExpressionsFor: aSmaCCCharacterEdge seen: aCollection 
	| expressions |
	expressions := OrderedCollection new.
	isExpressions keysAndValuesDo: 
			[:string :selector | 
			| isInString |
			isInString := false.
			((string allSatisfy: 
					[:each | 
					(aSmaCCCharacterEdge transitionObjects includes: each) 
						ifTrue: [isInString := true]
						ifFalse: [aCollection includes: each]]) 
				and: [isInString]) ifTrue: [expressions add: selector]].
	(expressions isEmpty or: 
			[(self minMaxPairsFor: aSmaCCCharacterEdge without: expressions) size 
				> (self minMaxPairsFor: aSmaCCCharacterEdge without: #()) size]) 
		ifTrue: [^#()].
	expressions size > 1 
		ifTrue: 
			[| strings newExpressions |
			strings := expressions collect: 
							[:each | 
							each -> ((isExpressions keyAtValue: each) 
										select: [:char | aSmaCCCharacterEdge transitionObjects includes: char])].
			strings := strings asSortedCollection: 
							[:a :b | 
							a value size > b value size or: 
									[a value size = b value size and: 
											[(isExpressions keyAtValue: a key) size 
												< (isExpressions keyAtValue: b key) size]]].
			newExpressions := OrderedCollection with: strings first.
			2 to: strings size
				do: 
					[:i | 
					| left |
					left := (strings at: i) value.
					newExpressions 
						do: [:each | left := left reject: [:char | each value includes: char]].
					left notEmpty ifTrue: [newExpressions add: (strings at: i)]].
			expressions := newExpressions collect: [:each | each key]].
	^expressions!

comment: aString
	^'"' , (aString trimBlanks copyReplaceAll: '"' with: '""') , '"'!

commonIfTrueCodeRewriter
	^(ParseTreeRewriter new)
		replace: '``@.Stmts1.
				(`@a ifTrue: ``@block) `{:node :dictionary | | index myStatements |
						index := node parent statements indexOf: node.
						myStatements := node parent statements.
						dictionary at: #size put: ``@block body statements size - (myStatements size - index).
						index ~~  myStatements size and: [``@block body statements size >= (myStatements size - index) and: [
							(index + 1 to: myStatements size) allSatisfy: [:each | 
								(myStatements at: each) = (``@block body statements at: ``@block body statements size - (myStatements size - each))]]]
						}.
				``@.Stmts3'
			with: '``@.Stmts1.
				`{:dictionary | RBMessageNode receiver: `@a selector: #ifTrue: arguments: (Array with: (RBBlockNode body: (RBSequenceNode statements: (``@block body statements copyFrom: 1 to: (dictionary at: #size)))))}.
				``@.Stmts3';
		yourself!

compileChanges
	self removeUnnecessaryChanges.
	RefactoryChangeManager instance performChange: self changes.
	parserClass realClass ifNotNil: [:each | each resetCaches].
	scannerClass realClass ifNotNil: [:each | each initializeKeywordMap]!

compileChildrenMethod: aSmaCCNodeClassDefinition!

compileCopyInContextMethod: aSmaCCNodeClassDefinition!

compileEqualMethod: aSmaCCNodeClassDefinition!

compileHashMethod: aSmaCCNodeClassDefinition!

compileIgnoreCaseMethods
	super compileIgnoreCaseMethods.
	self grammar ignoreCase ifFalse: [^self].
	scannerClass
		compile:
			'tokenClass
	^SmaCCCaseInsensitiveToken'
		classified: #generated!

compileInitializeMethod: aSmaCCNodeClassDefinition
	| stream |
	((aSmaCCNodeClassDefinition modelClass definesMethod: #initialize)
		and: [aSmaCCNodeClassDefinition collectionVariableDefinitions isEmpty]) ifTrue: [^self].
	stream := WriteStream on: String new.
	stream nextPutAll: 'initialize'.
	(aSmaCCNodeClassDefinition modelClass superclass definesMethod: #initialize)
		ifTrue:
			[stream
				cr;
				tab;
				nextPutAll: 'super initialize.'].
	aSmaCCNodeClassDefinition collectionVariableDefinitions
		do:
			[:each | 
			stream
				cr;
				tab;
				nextPutAll: (self nonKeywordNameFor: each sourceVariableName);
				nextPutAll: ' := OrderedCollection new: 2.'].
	aSmaCCNodeClassDefinition modelClass compile: stream contents classified: #'generated-initialize-release'!

compileKeywordInitializerUsing: keywordMapDictionary
	| stream dataStream |
	keywordMapDictionary isEmpty ifTrue: [^self].
	stream := WriteStream with: String new.
	stream nextPutAll: 'initializeKeywordMap'.
	stream nextPutAll: ' keywordMap :=  Dictionary new. '.
	dataStream := WriteStream with: Array new.
	keywordMapDictionary
		keysAndValuesDo:
			[:key :value | 
			value keys asSortedCollection
				do:
					[:each | 
					dataStream
						nextPut:
							(Array
								with: key
								with: each
								with: (value at: each))]].
	stream
		nextPutAll: '#(';
		cr.
	dataStream contents
		do:
			[:each | 
			stream nextPutAll: '#('.
			each do: [:item | item storeOn: stream] separatedBy: [stream nextPut: $ ].
			stream nextPut: $)]
		separatedBy: [stream cr].
	stream nextPut: $).
	stream
		nextPutAll:
			' do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last]. ^keywordMap'.
	scannerClass metaclass
		compile: (SmalltalkParser parseMethod: stream contents) formattedCode
		classified: #'generated-initialization'!

compileMatchInContextMethod: aSmaCCNodeClassDefinition!

compileMethodIn: modelClass
	modelClass compile: self formattedCode classified: #generated!

compileMethodWithoutFormattingIn: modelClass
	| code |
	code := self codeStream contents.
	code := code trimBlanks.
	modelClass compile: code classified: #generated!

compileOptimizedMethodIn: modelClass
	| tree |
	tree := SmalltalkParser parseMethod: self codeStream contents.
	self rewriters
		do: [:each | [each executeTree: tree] whileTrue: [tree := each tree]].
	modelClass compile: tree formattedCode classified: #generated!

compilePostCopyMethod: aSmaCCNodeClassDefinition!

compileScannerClassIntoParser
	| stream |
	stream := WriteStream with: String new.
	stream
		nextPutAll: 'scannerClass';
		cr;
		tab;
		nextPutAll: '^';
		nextPutAll: scannerClass name.
	parserClass metaclass compile: stream contents classified: #'generated-accessing'!

compileSymbolTypes: anArray
	self
		startPublicVirtualMethod;
		nextPutLine: (self method: 'symbolTypes' type: self arrayType);
		nextPutStatement: (self return: anArray storeString);
		endMethod;
		compileMethodIn: self parserClass!

compileVariablesMethods: aSmaCCNodeClassDefinition
	| compileBlock allVariables class |
	allVariables := OrderedCollection new.
	class := aSmaCCNodeClassDefinition.
	[class notNil]
		whileTrue:
			[allVariables addAll: class variableDefinitions.
			class := class superclass].
	compileBlock := [:variables :methodName | 
	| vars ignoredVars |
	ignoredVars := variables select: [:each | grammar ignoredVariables includes: each variableName].
	vars := variables reject: [:each | grammar ignoredVariables includes: each variableName].
	(vars anySatisfy: [:each | aSmaCCNodeClassDefinition isLocalVariable: each])
		ifTrue:
			[self
				startPublicOverrideMethod;
				nextPutLine: (self method: methodName type: self collectionType);
				nextPutStatement: (self return: (vars collect: [:each | each getterMethodName asSymbol]) asArray storeString);
				endMethod;
				compileMethodIn: aSmaCCNodeClassDefinition modelClass].
	(ignoredVars anySatisfy: [:each | aSmaCCNodeClassDefinition isLocalVariable: each])
		ifTrue:
			[| ignoredMethodName |
			ignoredMethodName := methodName copy.
			ignoredMethodName at: 1 put: ignoredMethodName first asUppercase.
			ignoredMethodName := 'ignored' , ignoredMethodName.
			self
				startPublicOverrideMethod;
				nextPutLine: (self method: ignoredMethodName type: self collectionType);
				nextPutStatement: (self return: (ignoredVars collect: [:each | each getterMethodName asSymbol]) asArray storeString);
				endMethod;
				compileMethodIn: aSmaCCNodeClassDefinition modelClass]].
	compileBlock
		value: (allVariables select: [:each | each isBaseNodeType and: [each isCollection not]]) value: 'nodeVariables';
		value: (allVariables select: [:each | each isBaseNodeType and: [each isCollection]]) value: 'compositeNodeVariables';
		value: (allVariables select: [:each | each isBaseTokenType and: [each isCollection not]]) value: 'tokenVariables';
		value: (allVariables select: [:each | each isBaseTokenType and: [each isCollection]])
			value: 'compositeTokenVariables';
		value: (allVariables select: [:each | each isBaseTokenType not and: [each isBaseNodeType not]])
			value: 'otherVariables'!

defaultNodeReductionSource: aReduction
	aReduction index = 0 ifTrue: [^'nil'].
	^'''' , aReduction index printString , ''''!

defaultReductionSource
	^'#reduceFor:'!

defineClass: aString asSubclassOf: aBehavior
	| current variables |
	current := Smalltalk at: aString asSymbol ifAbsent: [Object].
	variables := ''.
	(current includesBehavior: SmaCCParser) | (current includesBehavior: SmaCCScanner)
		ifTrue:
			[| stream |
			stream := WriteStream on: String new.
			current instVarNames
				do:
					[:each | 
					stream
						nextPutAll: each;
						space].
			variables := stream contents].
	model
		defineClass:
			aBehavior name , ' subclass: #' , aString , ' instanceVariableNames: ''' , variables
				, ''' classVariableNames: '''' poolDictionaries: '''' '.
	^model classNamed: aString asSymbol!

findExistingMethodFor: aRBMethodNode
	| potentialSelectors |
	potentialSelectors := #(#liftFirstValue: #liftLastValue: #liftSecondValue: #nil #stringValue:) asSet.
	potentialSelectors addAll: (self parserClass selectors select: [:each | each argumentCount <= 1]).
	^potentialSelectors
		detect:
			[:each | 
			| parseTree |
			parseTree := self parserParseTreeFor: each.
			parseTree notNil and: [aRBMethodNode body equalTo: parseTree body exceptForVariables: aRBMethodNode argumentNames]]
		ifNone: [nil]!

formattedCode
	^(SmalltalkParser parseMethod: self codeStream contents) formattedCode!

generateCharacterSetFor: aSelector
	| stream |
	stream := WriteStream with: String new.
	0
		to: SmaCCGrammar maximumCharacterValue
		do:
			[:i | 
			| ch |
			ch := Character value: i.
			(ch perform: aSelector) ifTrue: [stream nextPut: ch]].
	^stream contents!

generatedMethodsIn: aRBClass
	^aRBClass selectors
		select:
			[:each | 
			(aRBClass protocolsFor: each)
				anySatisfy: [:protocol | protocol notNil and: ['generated*' match: protocol]]]!

hasLiteralByteArrays
	^true!

initialize
	super initialize.
	model := (RBNamespace new)
		name: 'Compile Scanner/Parser';
		yourself.
	self initializeIsExpressions.
	parseTreeCache := Dictionary new!

initializeIsExpressions
	"Creates a map from sets of characters to selectors that start with 'is' on Character. This allows generated scanners to take
	full advantage of selectors that are already implemented on Character"

	| selectors |
	isExpressions := Dictionary new.
	selectors := Character selectors
		select:
			[:each | ('is*' match: each) and: [each argumentCount = 0 and: [(each at: 3) isUppercase]]].
	selectors
		do:
			[:sel | 
			| string |
			string := self generateCharacterSetFor: sel.
			string isEmpty ifFalse: [isExpressions at: string put: sel]]!

keywords
	"While Smalltalk doesn't have many keywords, we don't want to overwrite any existing method."

	^##(SmaCCParseNode allSelectors
			inject: #('self' 'super' 'nil' 'true' 'false') asSet
			into:
				[:sum :each | 
				(each argumentCount <= 1 and: [each isInfix not])
					ifTrue: [sum add: (each last = $: ifTrue: [each first: each size - 1] ifFalse: [each]) asString].
				sum])!

maxJumpSize
	^MaxJumpSize!

method: aString type: typeString
	^aString!

method: aString type: anObject argumentName: argumentNameString argumentType: argumentTypeString
	^aString , ' ' , argumentNameString!

method: aString type: anObject argumentName: firstArgumentNameString argumentType: firstArgumentTypeString argumentName: secondArgumentNameString argumentType: secondArgumentTypeString
	| keywords |
	keywords := aString asSymbol keywords.
	^keywords first , ' ' , firstArgumentNameString , ' ' , keywords last , ' '
		, secondArgumentNameString!

namespaceName
	^''!

optimizationRewriter
	| rewriter |
	rewriter := ParseTreeRewriter new.
	rewriter
		replace: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				currentCharacter == `#l ifTrue: [`@.Stmts3. ^`@r3].
				`@.Stmts4'
			with: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				`@.Stmts3. ^`@r3';
		replace: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				currentCharacter == `#l ifTrue: [`@.Stmts3].
				`@.Stmts4'
			with: '`@.Stmts1.
				[`@.Stmts2.
				currentCharacter ~~ `#l] whileTrue.
				`@.Stmts3. 
				`@.Stmts4';
		replaceMethod: '`name
					`@.Stmts1.
					`@a ifTrue: [^self `name].
					`@.Stmts3'
			with: '`name
					[`@.Stmts1.
					`@a] whileTrue.
					`@.Stmts3';
		replaceMethod: '`name
					`@.Stmts1.
					`@a ifTrue: [`@.Stmts2.
							^self `name].
					`@.Stmts3'
			with: '`name
					[`@.Stmts1.
					`@a] whileTrue: [`@.Stmts2].
					`@.Stmts3';
		replace: '`@.Stmts1.
				currentCharacter isLiteral ifTrue: [`@.Stmts2].
				`@.Stmts3' with: '`@.Stmts1.
				`@.Stmts2';
		replace: '`@.Stmts1.
				`.Stmt.
				`@.Stmts.
				`@a ifTrue: [self step. `.Stmt. `@.Stmts].
				`@.Stmts2'
			with: '`@.Stmts1.
				`@a ifTrue: [self step].
				`.Stmt.
				`@.Stmts.
				`@.Stmts2';
		replace: '`@.Stmts1.
				true ifTrue: [`@.Stmts2. ^`@obj].
				`@.Stmts3' with: '`@.Stmts1.
				`@.Stmts2.
				^`@obj';
		replace: '`@.Stmts1.
				[`@.Stmts2. true] whileTrue.
				`@.Stmts3' with: '`@.Stmts1.
				[`@.Stmts2] repeat'.
	self addImplementationSpecificRewritesTo: rewriter.
	^rewriter!

outputGreaterThanMatch: each on: stream
	stream
		nextPutAll: 'currentCharacter >= ';
		nextPutAll: each first storeString!

outputInvertedMatchFor: aSmaCCCharacterEdge on: stream
	| char |
	char := Character
		value:
			((0 to: SmaCCGrammar maximumCharacterValue)
				detect: [:each | (aSmaCCCharacterEdge transitionObjects includes: (Character value: each)) not]).
	stream
		nextPutAll: 'currentCharacter ~~ ';
		nextPutAll: char storeString!

outputIsSelector: isSelector on: stream 
	stream nextPutAll: 'currentCharacter ' , isSelector!

outputLessThanMatch: each on: stream 
	stream
		nextPutAll: 'currentCharacter <= ';
		nextPutAll: each last storeString!

outputMatchFor: aSmaCCCharacterEdge on: stream without: isSelectors
	| pairs |
	pairs := self minMaxPairsFor: aSmaCCCharacterEdge without: isSelectors.
	pairs isEmpty
		ifTrue:
			[stream next: isSelectors size - 1 put: $].
			^self].
	isSelectors notEmpty ifTrue: [stream nextPutAll: ' or: ['].
	pairs do: [:each | self outputMatchForTransition: each on: stream] separatedBy: [stream nextPutAll: ' or: ['].
	stream next: pairs size - 1 put: $].
	stream next: isSelectors size put: $]!

outputMatchForTransition: each on: stream
	each first = each last ifTrue: [^self outputSingleCharacterMatch: each on: stream].
	each first = (Character value: 0) ifTrue: [^self outputLessThanMatch: each on: stream].
	each last = (Character value: SmaCCGrammar maximumCharacterValue)
		ifTrue: [^self outputGreaterThanMatch: each on: stream].
	self outputRangeMatch: each on: stream!

outputRangeMatch: each on: stream 
	stream
		nextPutAll: '(currentCharacter between: ';
		nextPutAll: each first storeString;
		nextPutAll: ' and: ';
		nextPutAll: each last storeString;
		nextPutAll: ')'!

outputSingleCharacterMatch: each on: stream 
	stream
		nextPutAll: 'currentCharacter == ';
		nextPutAll: each first storeString!

outputStreamClass
	^WriteStream!

parserParseTreeFor: aSelector
	^parseTreeCache
		at: aSelector
		ifAbsentPut:
			[| definingClass |
			definingClass := self parserClass whoDefinesMethod: aSelector.
			definingClass parseTreeFor: aSelector]!

parseTreeRewriterFor: aSmaCCRHS
	| rewriter |
	rewriter := ParseTreeRewriter new.
	1
		to: aSmaCCRHS size
		do:
			[:i | 
			rewriter replace: i printString storeString with: '(nodes at: ' , i printString , ')'.
			(aSmaCCRHS variableNameForIndex: i)
				ifNotNil: [:name | rewriter replace: name with: '(nodes at: ' , i printString , ')']].
	^rewriter!

reduceAction: anArray
	^'#(' , anArray first storeString , ' ' , (anArray at: 2) storeString , ' ' , anArray last storeString , ')'!

removeChange: aRBChange
	| index |
	index := self changes changes identityIndexOf: aRBChange.
	index > 0 ifFalse: [^self].
	self changes changes removeAtIndex: index!

removeOldMethods
	self
		removeOldMethodsFrom: scannerClass;
		removeOldMethodsFrom: scannerClass metaclass;
		removeOldMethodsFrom: parserClass;
		removeOldMethodsFrom: parserClass metaclass!

removeOldMethodsFrom: aRBClass
	(self generatedMethodsIn: aRBClass) do: [:each | aRBClass removeMethod: each]!

removeUnnecessaryChanges
	self removeUnnecessaryMethodChanges.
	self removeUnnecessaryClassChanges!

removeUnnecessaryClassChanges
	| allChanges classChanges |
	allChanges := self changes changes copy.
	(allChanges allSatisfy: [:each | (each isKindOf: CompositeRefactoryChange) not]) ifFalse: [^self].
	classChanges := allChanges
		select:
			[:each | 
			(each isKindOf: AddClassChange)
				and: [each changeClass notNil and: [each changeClass superclass name = each superclassName]]].
	classChanges
		do:
			[:each | 
			| addVars variables existingVariables |
			addVars := allChanges
				select: [:change | (change isKindOf: AddInstanceVariableChange) and: [each changeClass = change changeClass]].
			variables := addVars
				inject: Set new
				into:
					[:sum :change | 
					sum
						add: change variable;
						yourself].
			variables addAll: each instanceVariableNames.
			existingVariables := each changeClass instVarNames.
			(existingVariables size = variables size
				and: [existingVariables asSortedCollection asArray = variables asSortedCollection asArray])
				ifTrue:
					[self removeChange: each.
					addVars do: [:change | self removeChange: change]]]!

removeUnnecessaryMethodChanges
	| allChanges |
	allChanges := self changes changes copy.
	(allChanges allSatisfy: [:each | (each isKindOf: CompositeRefactoryChange) not]) ifFalse: [^self].
	allChanges
		keysAndValuesDo:
			[:key :each | 
			(each isKindOf: RemoveMethodChange)
				ifTrue:
					[key + 1
						to: allChanges size
						do:
							[:i | 
							| other |
							other := allChanges at: i.
							[((other isKindOf: AddMethodChange)
								and:
									[each selector = other selector
										and:
											[each changeClassName = other changeClassName
												and: [(other changeClass sourceCodeAt: other selector) asString = other parseTree source asString]]])
								ifTrue:
									[self
										removeChange: each;
										removeChange: other]] on: Error do: [:ex | ex return]]]]!

rewriters
	| rewriters |
	rewriters := OrderedCollection new.
	rewriters add: self commonIfTrueCodeRewriter.
	rewriters add: self optimizationRewriter.
	rewriters add: self scanStringRewriter.
	rewriters add: self timesRepeatRewriter.
	^rewriters!

scannerActionFor: aString 
	| selector current |
	aString size > 2 ifFalse: [^nil].
	selector := (aString copyFrom: 2 to: aString size - 1) asSymbol.
	selector argumentCount = 0 ifFalse: [^nil].
	current := scannerClass.
	[current notNil and: [current superclass notNil]] whileTrue: 
			[(current directlyDefinesMethod: selector) ifTrue: [^selector].
			current := current superclass].
	^nil!

scannerClass
	^scannerClass!

scannerClass: aClassOrString
	(aClassOrString isKindOf: Behavior)
		ifTrue: [scannerClass := model classFor: aClassOrString]
		ifFalse:
			[scannerClass := model classNamed: aClassOrString.
			scannerClass isNil
				ifTrue: [scannerClass := self defineClass: aClassOrString asSubclassOf: SmaCCScanner]]!

scanStringRewriter
	^(ParseTreeRewriter new)
		replace: 'self step. currentCharacter == `#l1 ifTrue: [self step. currentCharacter == `#l2 ifTrue: `@b]. `@.Stmts'
			with: '(self scanForString: `{RBLiteralNode value: (String with: `#l1 value with: `#l2 value)}) ifTrue: `@b. `@.Stmts';
		replace: '(self scanForString: `#l1) ifTrue: [self step. currentCharacter == `#l2 ifTrue: `@b]. `@.Stmts'
			with: '(self scanForString: `{RBLiteralNode value: (`#l1 value copyWith: `#l2 value)}) ifTrue: `@b. `@.Stmts';
		replace: 'self recordMatch: `@m. self step. currentCharacter == `#l1 ifTrue: [self recordMatch: `@m. self step. currentCharacter == `#l2 ifTrue: `@b]. `@.Stmts'
			with: 'self recordMatch: `@m. (self scanForString: `{RBLiteralNode value: (String with: `#l1 value with: `#l2 value)}) ifTrue: `@b. `@.Stmts';
		replace: 'self recordMatch: `@m. (self scanForString: `#l1) ifTrue: [self recordMatch: `@m. self step. currentCharacter == `#l2 ifTrue: `@b]. `@.Stmts'
			with: 'self recordMatch: `@m. (self scanForString: `{RBLiteralNode value: (`#l1 value copyWith: `#l2 value)}) ifTrue: `@b. `@.Stmts';
		yourself!

selectorMap: aDictionary
	| arrayMap |
	aDictionary isEmpty ifTrue: [^self].
	arrayMap := Array new: aDictionary keys asSortedCollection last.
	aDictionary keysAndValuesDo: [:key :value | arrayMap at: key put: value].
	self
		startPublicOverrideMethod;
		nextPutLine: (self method: 'tokenActions' type: self collectionType);
		nextPutStatement: (self return: arrayMap storeString);
		endMethod;
		compileMethodIn: self scannerClass!

send: selector to: aString
	^'(' , aString , ') ' , selector!

send: selectorString to: receiverString with: argumentString
	^'(' , receiverString , ') ' , selectorString , ' (' , argumentString , ')'!

send: selectorString to: receiverString with: firstArgumentString with: secondArgumentString
	| keywords |
	keywords := selectorString asSymbol keywords.
	^'(' , receiverString , ') ' , keywords first , ' (' , firstArgumentString , ') ' , keywords last , ' ('
		, secondArgumentString , ')'!

send: selectorString to: receiverString with: firstArgumentString with: secondArgumentString with: thirdArgumentString
	| keywords |
	keywords := selectorString asSymbol keywords.
	^'(' , receiverString , ') ' , keywords first , ' (' , firstArgumentString , ') ' , (keywords at: 2) , ' ('
		, secondArgumentString , ') ' , keywords last , ' (' , thirdArgumentString , ')'!

superMessage: aString
	^'super ' , aString!

superMessage: aString argument: argumentString
	^'super ' , aString , ' (' , argumentString , ')'!

superMessage: aString argument: firstArgumentString argument: secondArgumentString
	| keywords |
	keywords := aString asSymbol keywords.
	^'super ' , keywords first , ' (' , firstArgumentString , ') ' , keywords last , ' ('
		, secondArgumentString , ')'!

supportsOptimizedExpressions
	"Do we support ##() expressions"

	^true!

timesRepeatRewriter
	^(ParseTreeRewriter new)
		replace: '`@.StmtsBefore.
				`@.Common.
				`@a ifTrue: 
					[`@.Common.
					`@a ifTrue: [`@.After].
					`@.CommonAfter.
					^self reportLastMatch].
				`@.CommonAfter'
			with: '`@.StmtsBefore.
				2 timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter. ^self reportLastMatch]].
				`@.After';
		replace: '`@.StmtsBefore.
				`@.Common.
				`@a ifTrue: 
					[`@.Common.
					`@a ifTrue: [`@.After].
					`@.CommonAfter].
				`@.CommonAfter'
			with: '`@.StmtsBefore.
				2 timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter. `{(`@.CommonAfter notEmpty and: [`@.CommonAfter last isReturn]) ifTrue: [#()] ifFalse: [Array with: (RBParser parseExpression: ''^self reportLastMatch'')]}]].
				`@.After';
		replace: '`@.StmtsBefore.
				`#l timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter. ^self reportLastMatch]].
				`@.Common.
				`@a ifTrue: [`@.After].
				`@.CommonAfter'
			with: '`@.StmtsBefore.
				`{RBLiteralNode value: `#l value + 1} timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter. ^self reportLastMatch]].
				`@.After';
		replace: '`@.StmtsBefore.
				`#l timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter]].
				`@.Common.
				`@a ifTrue: [`@.After].
				`@.CommonAfter'
			with: '`@.StmtsBefore.
				`{RBLiteralNode value: `#l value + 1} timesRepeat: [
					`@.Common.
					`@a ifFalse: [`@.CommonAfter]].
				`@.After';
		replace: '`@.StmtsBefore.
				`#l1 timesRepeat: `@b.
				`#l2 timesRepeat: `@b.
				`@.StmtsAfter'
			with: '`@.StmtsBefore.
				`{RBLiteralNode value: `#l1 value + `#l2 value} timesRepeat: `@b.
				`@.StmtsAfter';
		yourself!

variableReference: aSmaCCVariableDefinition in: aString
	^'(' , aString , ') ' , aSmaCCVariableDefinition getterMethodName!

writeMatchingCodeFor: aSmaCCNode
	| matchedItem |
	(aSmaCCNode action notNil and: [aSmaCCNode action size > 0])
		ifTrue:
			[matchedItem := aSmaCCNode action asArray.
			self codeStream
				nextPutAll: (aSmaCCNode transitions isEmpty ifTrue: ['^self recordAndReportMatch:'] ifFalse: ['self recordMatch: ']).
			matchedItem isSymbol
				ifTrue: [self codeStream nextPutAll: matchedItem storeString]
				ifFalse:
					[self codeStream nextPutAll: '#('.
					matchedItem do: [:each | self codeStream nextPutAll: each storeString] separatedBy: [self codeStream nextPut: $ ].
					self codeStream nextPut: $)].
			(self codeStream)
				nextPut: $.;
				cr].
	(aSmaCCNode transitions anySatisfy: [:each | each isCharacterTransition]) ifTrue: [self nextPutLine: 'self step.']!

writeTransitionTableEntry: anArray on: aStream firstIsType: aBoolean
	| startIndex |
	aStream cr.
	self hasLiteralByteArrays
		ifTrue:
			[aStream nextPutAll: '#['.
			aBoolean
				ifTrue:
					[aStream print: anArray first.
					startIndex := 2]
				ifFalse: [startIndex := 1].
			startIndex
				to: anArray size
				do:
					[:i | 
					aStream
						nextPutAll: self literalArraySeparator;
						print: ((anArray at: i) bitShift: -8);
						nextPutAll: self literalArraySeparator;
						print: ((anArray at: i) bitAnd: 16rFF)].
			aStream nextPut: $]]
		ifFalse:
			[aStream nextPutAll: '#('.
			anArray do: [:each | aStream print: each] separatedBy: [aStream nextPutAll: self literalArraySeparator].
			aStream nextPut: $)]! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #acceptStateEdge:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #addImplementationSpecificRewritesTo:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #addVariable:forDefinition:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #basicCompileSourceFor:!public!reduction table! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #changes!accessing!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #closestIsExpressionsFor:seen:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #comment:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #commonIfTrueCodeRewriter!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileChanges!compiling!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileChildrenMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileCopyInContextMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileEqualMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileHashMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileIgnoreCaseMethods!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileInitializeMethod:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileKeywordInitializerUsing:!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileMatchInContextMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileMethodIn:!compiling!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileMethodWithoutFormattingIn:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileOptimizedMethodIn:!compiling!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compilePostCopyMethod:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileScannerClassIntoParser!compiling-parser!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileSymbolTypes:!compiling-parser!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #compileVariablesMethods:!compiling-nodes!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #defaultNodeReductionSource:!private!reduction table! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #defaultReductionSource!private!reduction table! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #defineClass:asSubclassOf:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #findExistingMethodFor:!public!reduction table! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #formattedCode!compiling!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #generateCharacterSetFor:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #generatedMethodsIn:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #hasLiteralByteArrays!private!testing! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #initialize!initialize-release!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #initializeIsExpressions!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #keywords!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #maxJumpSize!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #method:type:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #method:type:argumentName:argumentType:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #method:type:argumentName:argumentType:argumentName:argumentType:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #namespaceName!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #optimizationRewriter!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputGreaterThanMatch:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputInvertedMatchFor:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputIsSelector:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputLessThanMatch:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputMatchFor:on:without:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputMatchForTransition:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputRangeMatch:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputSingleCharacterMatch:on:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #outputStreamClass!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #parserParseTreeFor:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #parseTreeRewriterFor:!private!reduction table! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #reduceAction:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeChange:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeOldMethods!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeOldMethodsFrom:!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeUnnecessaryChanges!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeUnnecessaryClassChanges!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #removeUnnecessaryMethodChanges!compiling!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #rewriters!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #scannerActionFor:!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #scannerClass!accessing!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #scannerClass:!accessing!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #scanStringRewriter!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #selectorMap:!accessing!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #send:to:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #send:to:with:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #send:to:with:with:!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #send:to:with:with:with:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #superMessage:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #superMessage:argument:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #superMessage:argument:argument:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #supportsOptimizedExpressions!public!testing! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #timesRepeatRewriter!compiling-scanner!public! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #variableReference:in:!code generation templates!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #writeMatchingCodeFor:!compiling-scanner!private! !
!SmaCCSmalltalkCodeGenerator categoriesFor: #writeTransitionTableEntry:on:firstIsType:!compiling-parser!private! !

!SmaCCSmalltalkCodeGenerator class methodsFor!

codeTemplatesArray
	^super codeTemplatesArray ,
		#(
			#(#addAllSendTo:with: 'self addAll: (<2s>) to: (<1s>)')
			#(#addSendTo:with: 'self add: (<2s>) to: (<1s>)')
			#(#arrayType '')
			#(#assignArray:index:to: '(<1s>) at: (<2p>) put: (<3s>)')
			#(#assignmentTo:from: '<1s> := <2s>')
			#(#at:index: '(<1s>) at: <2p>')
			#(#bitXor:with: '(<1s>) bitXor: (<2s>)')
			#(#booleanType '')
			#(#cast:to: '<1s>')
			#(#collectionType '')
			#(#collectionVariableItemsIn:forCollectionGetter:andVariableGetter: 'SmaCCParseNode collectionVariableIn: (<1s>) collectionGetter: <2p> variableGetter: <3p>')
			#(#compareEqual:to: '(<1s>) = (<2s>)')
			#(#copy:inContext:onlyNodes: '<1s> collect: [:each | <3?:(each isKindOf: SmaCCParseNode) ifTrue: [>each copyInContext: <2s>]<3?:]>')
			#(#copyNode: '(<1s>) copy')
			#(#copyNodeCollection: '(<1s>) collect: [:each | each copy]')
			#(#dictionaryType '')
			#(#endConditionalString ']')
			#(#endDoWhileLoopWithClause: '<1s>] whileTrue')
			#(#endLiteralArray ')')
			#(#endMethodString '')
			#(#hashFor: '(<1s>) hash')
			#(#ifFalseReturn: '(<1s>) ifFalse: [^false]')
			#(#integerType '')
			#(#isKindOfTest:class: '(<1s> isKindOf: <2s>) ifTrue: [')
			#(#iterateObjects:name: '(<1s>) do: [:<2s> |')
			#(#literalArraySeparator ' ')
			#(#newArrayOfSize: 'Array new: <1p>')
			#(#newCollectionOfSize: 'OrderedCollection new: <1p>')
			#(#newObject: '<1s> new')
			#(#newUnsignedShortArrayArray '#(')
			#(#nodeCollectionType 'OrderedCollection')
			#(#notNilCheckFor: '(<1s>) notNil ifTrue: [')
			#(#objectType 'Object')
			#(#private '')
			#(#protected '')
			#(#public '')
			#(#receiverName 'self')
			#(#reduceActionArrayType '')
			#(#reduceActionLiteralStart '#(')
			#(#return: '^<1s>')
			#(#startDoWhileLoop '[')
			#(#startIfWithClause: '(<1s>) ifTrue: [')
			#(#statementSeparator '.')
			#(#static '')
			#(#stringType '')
			#(#undefinedObject 'nil')
			#(#unsignedShort '')
			#(#unsignedShortArrayArray '')
			#(#uppercaseString: '(<1s>) asUppercase')
			#(#variableDeclaration:ofType: '| <1s> |')
			#(#variableItemIn:forVariableGetter: 'SmaCCParseNode variableIn: (<1s>) getter: <2p>')
			#(#virtual '')
			#(#voidType '')
		)!

initialize
	MaxJumpSize := 50000!

parseSourceSelector
	^#canParseSmalltalk:!

typeName
	^#Smalltalk! !
!SmaCCSmalltalkCodeGenerator class categoriesFor: #codeTemplatesArray!accessing!private! !
!SmaCCSmalltalkCodeGenerator class categoriesFor: #initialize!class initialization!public! !
!SmaCCSmalltalkCodeGenerator class categoriesFor: #parseSourceSelector!accessing!private! !
!SmaCCSmalltalkCodeGenerator class categoriesFor: #typeName!accessing!private! !

SmaCCCharacterEdge guid: (GUID fromString: '{03EC1070-8C09-4FD5-9488-2EAD2FF8DB07}')!
SmaCCCharacterEdge comment: 'SmaCCCharacterEdge is a SmaCCEdge for Characters.
'!
!SmaCCCharacterEdge categoriesForClass!Unclassified! !
!SmaCCCharacterEdge methodsFor!

<= aSmaCCEdge
	^self class = aSmaCCEdge class and: [self transitionObjects <= aSmaCCEdge transitionObjects]!

codeSizeEstimate
	| last size |
	size := 1.
	last := transitionObjects first asInteger - 1.
	transitionObjects do: 
			[:each |
			each asInteger - 1 = last ifFalse: [size := size + 1].
			last := each asInteger].
	^(size * 8) + 4!

dispatchTo: aSmaCCCodeGenerator seen: aCollection
	^aSmaCCCodeGenerator acceptCharacterEdge: self seen: aCollection!

edgeLabel
	^transitionObjects asString!

isCharacterTransition
	^true!

mergeWith: aSmaCCEdge
	transitionObjects := transitionObjects copy.
	transitionObjects addAll: aSmaCCEdge transitionObjects!

remove: aCollection
	transitionObjects := transitionObjects copy.
	aCollection do: [:each | transitionObjects remove: each ifAbsent: []]!

setClass
	^SmaCCCharacterSet!

to: aSmaCCNode on: aStringOrNil
	toNode := aSmaCCNode.
	transitionObjects := aStringOrNil notNil ifTrue: [SmaCCCharacterSet withAll: aStringOrNil] ifFalse: [nil]! !
!SmaCCCharacterEdge categoriesFor: #<=!comparing!private! !
!SmaCCCharacterEdge categoriesFor: #codeSizeEstimate!compiling!public! !
!SmaCCCharacterEdge categoriesFor: #dispatchTo:seen:!compiling!private! !
!SmaCCCharacterEdge categoriesFor: #edgeLabel!printing!public! !
!SmaCCCharacterEdge categoriesFor: #isCharacterTransition!private!testing! !
!SmaCCCharacterEdge categoriesFor: #mergeWith:!merging!public! !
!SmaCCCharacterEdge categoriesFor: #remove:!private! !
!SmaCCCharacterEdge categoriesFor: #setClass!accessing!public! !
!SmaCCCharacterEdge categoriesFor: #to:on:!initialize-release!public! !

SmaCCStateEdge guid: (GUID fromString: '{88B0C7F8-ACA9-45D6-8994-E7D218A743AE}')!
SmaCCStateEdge comment: 'SmaCCStateEdge is a SmaCCEdge on states (that are represented by symbols) in the scanner.'!
!SmaCCStateEdge categoriesForClass!Unclassified! !
!SmaCCStateEdge methodsFor!

<= aSmaCCEdge
	^self class ~= aSmaCCEdge class
		or: [self transitionObjects first <= aSmaCCEdge transitionObjects first]!

codeSizeEstimate
	^4 * transitionObjects size!

dispatchTo: aSmaCCCodeGenerator seen: aCollection
	^aSmaCCCodeGenerator acceptStateEdge: self! !
!SmaCCStateEdge categoriesFor: #<=!comparing!private! !
!SmaCCStateEdge categoriesFor: #codeSizeEstimate!compiling!public! !
!SmaCCStateEdge categoriesFor: #dispatchTo:seen:!compiling!private! !

SmaCCRHS guid: (GUID fromString: '{15B1733C-610C-4EEF-B4A6-D81E74FFEF5C}')!
SmaCCRHS comment: ''!
!SmaCCRHS categoriesForClass!Unclassified! !
!SmaCCRHS methodsFor!

= aSmaCCRHS
	^self class = aSmaCCRHS class and: [collection = aSmaCCRHS collection]!

add: aSmaCCSymbol
	collection add: aSmaCCSymbol!

annotateTokenVariables: aBlock
	collection
		keysAndValuesDo:
			[:i :each | 
			(each isTerminal and: [(self variableNameForIndex: i) isNil])
				ifTrue: [(aBlock value: each unsafeMethodName) ifNotNil: [:value | (variableNameMap at: value ifAbsentPut: [OrderedCollection new]) add: i]]]!

at: anInteger
	^collection at: anInteger!

basicModelTypesForVariable: aString into: productionTypes seen: aSet
	(self symbolsForVariableName: aString)
		do:
			[:symbol | 
			symbol returnsSingleVariable
				ifTrue: [productionTypes addAll: (symbol modelTypesForVariable: symbol variableName)]
				ifFalse: [productionTypes addAll: symbol modelTypes]].
	self unnamedSymbolsDo: [:each | (each hasVariableNamed: aString) ifTrue: [productionTypes addAll: (each modelTypesForVariable: aString seen: aSet)]]!

collection
	^collection!

componentIndex
	collection
		keysAndValuesDo:
			[:index :each | ((self variableNameForIndex: index) isNil and: [each isSubtypeOf: self]) ifTrue: [^index]].
	^0!

do: aBlock
	collection do: aBlock!

firstTerminals
	| items |
	collection isEmpty ifTrue: [^Set with: self grammar emptySymbol].
	items := Set new.
	1
		to: collection size
		do:
			[:index | 
			items addAll: (collection at: index) firstTerminals.
			(items includes: self grammar emptySymbol) ifTrue: [index < collection size ifTrue: [items remove: self grammar emptySymbol]] ifFalse: [^items]].
	^items!

generateNamedVariableCollectionWarningFor: problemIndex
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll:
				'Non terminal symbol that returns a variable collection is assigned to a variable. The non terminal should be changed to return an AST node:';
		cr;
		cr;
		nextPutAll: self productionSymbol name;
		nextPutAll: ' : '.
	1
		to: self size
		do:
			[:i | 
			i == problemIndex ifTrue: [stream nextPutAll: '>>>'].
			stream nextPutAll: (self at: i) name.
			i == problemIndex ifTrue: [stream nextPutAll: '<<<'].
			stream space].
	SmaCCCompilationNotification signal: 'Node creation' with: stream contents!

generateUnnamedSymbolWarningFor: problemIndex
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'Unnamed symbol in production. Without a variable name the value will be dropped from the parsed AST.';
		cr;
		cr;
		nextPutAll: self productionSymbol name;
		nextPutAll: ' : '.
	1
		to: self size
		do:
			[:i | 
			i == problemIndex ifTrue: [stream nextPutAll: '>>>'].
			stream nextPutAll: (self at: i) name.
			i == problemIndex ifTrue: [stream nextPutAll: '<<<'].
			stream space].
	SmaCCCompilationNotification signal: 'Node creation' with: stream contents!

hash
	^self class hash bitXor: (collection hash bitShift: 14)!

hasNamedVariable
	^variableNameMap notEmpty!

hasNodeClassDefinition
	^self nodeClassDefinition notNil!

hasReduceAction
	^reduceAction hasReduceAction!

indexOfVariable: aString
	^(variableNameMap at: aString ifAbsent: [^nil]) first!

initialize
	super initialize.
	collection := OrderedCollection new.
	reduceAction := SmaCCDefaultReduceCode onRHS: self.
	variableNameMap := Dictionary new!

locallyDefinesVariable: aString
	^(self indexOfVariable: aString) notNil!

modelTypes: anIdentitySet
	^reduceAction modelTypes: anIdentitySet!

nameLastItem: aString
	(variableNameMap at: aString ifAbsentPut: [OrderedCollection new]) add: collection size!

nodeClassDefinition
	^nodeClassDefinition!

nodeClassDefinition: aSmaCCNodeClassDefinition
	nodeClassDefinition := aSmaCCNodeClassDefinition!

printOn: aStream
	^collection do: [:each | each printOn: aStream] separatedBy: [aStream space]!

productionSymbol
	^productionSymbol!

reduceAction
	^reduceAction!

reduceAction: aSmaCCReduceCode
	reduceAction := aSmaCCReduceCode!

reduceActionSource: aString
	reduceAction := SmaCCSourceReduceCode onRHS: self source: aString!

returnsSingleVariable
	^reduceAction returnsSingleVariable!

returnsVariableCollection
	^reduceAction returnsVariableCollection!

size
	^collection size!

symbol: aSmaCCNonTerminalSymbol
	productionSymbol := aSmaCCNonTerminalSymbol!

symbolsForVariableName: aString
	| indices |
	indices := variableNameMap at: aString ifAbsent: [#()].
	^indices collect: [:i | self at: i]!

unnamedSymbolsDo: aBlock
	self variablesAndSymbolsDo: [:var :each | var isNil ifTrue: [aBlock value: each]]!

variableDefinitions: aCollection
	variableDefinitions := aCollection.
	SmaCCVariableDefinition assignIndices: variableDefinitions!

variableNameForIndex: anInteger
	variableNameMap keysAndValuesDo: [:key :value | (value includes: anInteger) ifTrue: [^key]].
	^nil!

variableNames
	^variableNameMap keys!

variablesAndSymbolsDo: aBlock
	collection
		keysAndValuesDo: [:key :value | aBlock value: (self variableNameForIndex: key) value: value]! !
!SmaCCRHS categoriesFor: #=!comparing!private! !
!SmaCCRHS categoriesFor: #add:!accessing!private! !
!SmaCCRHS categoriesFor: #annotateTokenVariables:!private! !
!SmaCCRHS categoriesFor: #at:!accessing!private! !
!SmaCCRHS categoriesFor: #basicModelTypesForVariable:into:seen:!private! !
!SmaCCRHS categoriesFor: #collection!private! !
!SmaCCRHS categoriesFor: #componentIndex!private!reduce actions! !
!SmaCCRHS categoriesFor: #do:!accessing!private! !
!SmaCCRHS categoriesFor: #firstTerminals!private! !
!SmaCCRHS categoriesFor: #generateNamedVariableCollectionWarningFor:!public!reduce actions! !
!SmaCCRHS categoriesFor: #generateUnnamedSymbolWarningFor:!public!reduce actions! !
!SmaCCRHS categoriesFor: #hash!comparing!private! !
!SmaCCRHS categoriesFor: #hasNamedVariable!private!testing! !
!SmaCCRHS categoriesFor: #hasNodeClassDefinition!private!testing! !
!SmaCCRHS categoriesFor: #hasReduceAction!private!testing! !
!SmaCCRHS categoriesFor: #indexOfVariable:!private!variables! !
!SmaCCRHS categoriesFor: #initialize!initialize-release!private! !
!SmaCCRHS categoriesFor: #locallyDefinesVariable:!private!testing! !
!SmaCCRHS categoriesFor: #modelTypes:!accessing!private! !
!SmaCCRHS categoriesFor: #nameLastItem:!accessing!private! !
!SmaCCRHS categoriesFor: #nodeClassDefinition!accessing!private! !
!SmaCCRHS categoriesFor: #nodeClassDefinition:!accessing!private! !
!SmaCCRHS categoriesFor: #printOn:!printing!private! !
!SmaCCRHS categoriesFor: #productionSymbol!accessing!private! !
!SmaCCRHS categoriesFor: #reduceAction!private!reduce actions! !
!SmaCCRHS categoriesFor: #reduceAction:!private!reduce actions! !
!SmaCCRHS categoriesFor: #reduceActionSource:!private!reduce actions! !
!SmaCCRHS categoriesFor: #returnsSingleVariable!public!testing! !
!SmaCCRHS categoriesFor: #returnsVariableCollection!private!testing! !
!SmaCCRHS categoriesFor: #size!accessing!private! !
!SmaCCRHS categoriesFor: #symbol:!initialize-release!private! !
!SmaCCRHS categoriesFor: #symbolsForVariableName:!accessing!public! !
!SmaCCRHS categoriesFor: #unnamedSymbolsDo:!private! !
!SmaCCRHS categoriesFor: #variableDefinitions:!accessing!private! !
!SmaCCRHS categoriesFor: #variableNameForIndex:!private! !
!SmaCCRHS categoriesFor: #variableNames!private! !
!SmaCCRHS categoriesFor: #variablesAndSymbolsDo:!private! !

SmaCCSymbol guid: (GUID fromString: '{0E901068-5A10-4901-8376-160338B315F7}')!
SmaCCSymbol comment: 'SmaCCSymbol is an abstract class that represents a symbol in our grammar. Symbols can be either terminal or non-terminal. Terminal symbols are mapped to tokens in the grammar and non-terminals are made up of other symbols.

Subclasses must implement the following messages:
	accessing
		calculateFirstTerminals
	testing
		isTerminal

Instance Variables
	firstTerminals	<Set of: SmaCCTerminalSymbol>	the first terminal symbol that this can produce
	name	<String>	the name of the symbol
	precedence	<Integer>	the precedence for the symbol used for shift/reduce conflicts
'!
!SmaCCSymbol categoriesForClass!Unclassified! !
!SmaCCSymbol methodsFor!

annotateTokenVariables: aBlock
	self productionsDo: [:each | each annotateTokenVariables: aBlock]!

basicModelTypesForVariable: aString into: productionTypes seen: aSet
	self productionsDo: [:each | productionTypes addAll: (each modelTypesForVariable: aString seen: aSet)]!

calculateFirstTerminals
	^self subclassResponsibility!

computeVariableDefinitions
	| variableCollections |
	variableCollections := OrderedCollection new.
	self productionsDo: [:each | variableCollections add: each variableDefinitions].
	variableDefinitions := self class mergeOrderedVariableDefinitions: variableCollections.
	SmaCCVariableDefinition assignIndices: variableDefinitions.
	^variableDefinitions!

createIdMethod
	^false!

firstTerminals
	^firstTerminals!

initialize
	super initialize.
	firstTerminals := Set new!

isEmptySymbol
	^self = grammar emptySymbol!

isStartingSymbol
	^false!

isTerminal
	^self subclassResponsibility!

makeCaseInsensitive!

name
	^name!

name: aString
	name := aString!

precedence
	^precedence!

precedence: anInteger
	precedence := anInteger!

printOn: aStream 
	aStream nextPutAll: name!

productionsDo: aBlock!

regularExpression
	^nil!

requiresNodeType
	self productionsDo: [:each | each hasNodeClassDefinition ifTrue: [^true]].
	^false!

safeMethodName
	^self unsafeMethodName collect: [:each | each isAlphaNumeric ifTrue: [each] ifFalse: [$_]]!

size
	^0!

unsafeMethodName
	^self printString! !
!SmaCCSymbol categoriesFor: #annotateTokenVariables:!private! !
!SmaCCSymbol categoriesFor: #basicModelTypesForVariable:into:seen:!private! !
!SmaCCSymbol categoriesFor: #calculateFirstTerminals!accessing!private! !
!SmaCCSymbol categoriesFor: #computeVariableDefinitions!private!variables! !
!SmaCCSymbol categoriesFor: #createIdMethod!accessing!private! !
!SmaCCSymbol categoriesFor: #firstTerminals!accessing!public! !
!SmaCCSymbol categoriesFor: #initialize!initialize-release!public! !
!SmaCCSymbol categoriesFor: #isEmptySymbol!accessing!public! !
!SmaCCSymbol categoriesFor: #isStartingSymbol!private!testing! !
!SmaCCSymbol categoriesFor: #isTerminal!private!testing! !
!SmaCCSymbol categoriesFor: #makeCaseInsensitive!private! !
!SmaCCSymbol categoriesFor: #name!accessing!private! !
!SmaCCSymbol categoriesFor: #name:!initialize-release!private! !
!SmaCCSymbol categoriesFor: #precedence!accessing!private! !
!SmaCCSymbol categoriesFor: #precedence:!accessing!private! !
!SmaCCSymbol categoriesFor: #printOn:!printing!private! !
!SmaCCSymbol categoriesFor: #productionsDo:!accessing!private! !
!SmaCCSymbol categoriesFor: #regularExpression!accessing!private! !
!SmaCCSymbol categoriesFor: #requiresNodeType!private!testing! !
!SmaCCSymbol categoriesFor: #safeMethodName!accessing!private! !
!SmaCCSymbol categoriesFor: #size!accessing!private! !
!SmaCCSymbol categoriesFor: #unsafeMethodName!private! !

!SmaCCSymbol class methodsFor!

mergeOrderedVariableDefinitions: newVariableDefinitions
	| result |
	result := OrderedCollection new.
	newVariableDefinitions do: [:collection | self mergeVariableDefinitions: collection into: result].
	^result!

mergeVariableDefinitions: collection into: result
	collection
		do:
			[:each | 
			| variable |
			variable := result detect: [:def | def variableName = each variableName] ifNone: [result add: each copy].
			each getterMethodName notNil ifTrue: [variable getterMethodName: each getterMethodName].
			each setterMethodName notNil ifTrue: [variable setterMethodName: each setterMethodName].
			each isCollection ifTrue: [variable isCollection: true]]!

name: aString 
	^(self new)
		name: aString;
		yourself! !
!SmaCCSymbol class categoriesFor: #mergeOrderedVariableDefinitions:!private!variables! !
!SmaCCSymbol class categoriesFor: #mergeVariableDefinitions:into:!private!variables! !
!SmaCCSymbol class categoriesFor: #name:!instance creation!private! !

SmaCCNonTerminalSymbol guid: (GUID fromString: '{BC25EC88-C8BA-4E1E-9ED7-2D71E59561D9}')!
SmaCCNonTerminalSymbol comment: ''!
!SmaCCNonTerminalSymbol categoriesForClass!Unclassified! !
!SmaCCNonTerminalSymbol methodsFor!

addProduction: aSmaCCRHS
	productions add: aSmaCCRHS.
	aSmaCCRHS symbol: self!

calculateFirstTerminals
	| initialSize |
	initialSize := firstTerminals size.
	productions isEmpty ifTrue: [firstTerminals add: grammar emptySymbol] ifFalse: [productions do: [:each | firstTerminals addAll: each firstTerminals]].
	^initialSize ~= firstTerminals size!

initialize
	super initialize.
	productions := OrderedCollection new!

isEmpty
	^productions isEmpty!

isTerminal
	^false!

modelTypes: anIdentitySet
	| types |
	(anIdentitySet includes: self) ifTrue: [^#()].
	anIdentitySet add: self.
	types := Set new.
	productions do: [:each | types addAll: (each modelTypes: anIdentitySet)].
	anIdentitySet remove: self.
	^types!

positionOf: aSmaCCRHS
	^productions indexOf: aSmaCCRHS!

productionsDo: aBlock
	productions do: aBlock!

returnsSingleVariable
	^productions anySatisfy: [:each | each returnsSingleVariable]!

returnsVariableCollection
	^productions anySatisfy: [:each | each returnsVariableCollection]!

size
	^productions size!

variableName
	self
		productionsDo:
			[:each | 
			| vars |
			vars := each variableNames asArray.
			vars notEmpty ifTrue: [^vars first]].
	^self error: 'No variable found -- should only be called when returnsSingleVariable is true'! !
!SmaCCNonTerminalSymbol categoriesFor: #addProduction:!accessing!private! !
!SmaCCNonTerminalSymbol categoriesFor: #calculateFirstTerminals!accessing!public! !
!SmaCCNonTerminalSymbol categoriesFor: #initialize!initialize-release!private! !
!SmaCCNonTerminalSymbol categoriesFor: #isEmpty!private!testing! !
!SmaCCNonTerminalSymbol categoriesFor: #isTerminal!private!testing! !
!SmaCCNonTerminalSymbol categoriesFor: #modelTypes:!accessing!private! !
!SmaCCNonTerminalSymbol categoriesFor: #positionOf:!accessing!private! !
!SmaCCNonTerminalSymbol categoriesFor: #productionsDo:!accessing!private! !
!SmaCCNonTerminalSymbol categoriesFor: #returnsSingleVariable!public!testing! !
!SmaCCNonTerminalSymbol categoriesFor: #returnsVariableCollection!public!testing! !
!SmaCCNonTerminalSymbol categoriesFor: #size!accessing!private! !
!SmaCCNonTerminalSymbol categoriesFor: #variableName!accessing!public! !

SmaCCTerminalSymbol guid: (GUID fromString: '{3E1AF020-D2F9-419F-9605-68C323D2DC76}')!
SmaCCTerminalSymbol comment: ''!
!SmaCCTerminalSymbol categoriesForClass!Unclassified! !
!SmaCCTerminalSymbol methodsFor!

calculateFirstTerminals
	^false!

createIdMethod
	^createIdMethod!

createIdMethod: aBoolean
	createIdMethod := aBoolean!

initialize
	super initialize.
	firstTerminals add: self.
	createIdMethod := false!

isTerminal
	^true!

makeCaseInsensitive
	regularExpression notNil ifTrue: [regularExpression makeCaseInsensitive]!

modelTypes: anIdentitySet
	^Set with: (self model classFor: SmaCCToken)!

regularExpression
	^regularExpression!

regularExpression: aSmaCCRegularExpressionNode
	regularExpression := aSmaCCRegularExpressionNode!

unsafeMethodName
	^name copyFrom: 2 to: name size - 1! !
!SmaCCTerminalSymbol categoriesFor: #calculateFirstTerminals!private! !
!SmaCCTerminalSymbol categoriesFor: #createIdMethod!accessing!private! !
!SmaCCTerminalSymbol categoriesFor: #createIdMethod:!accessing!private! !
!SmaCCTerminalSymbol categoriesFor: #initialize!initialize-release!public! !
!SmaCCTerminalSymbol categoriesFor: #isTerminal!private!testing! !
!SmaCCTerminalSymbol categoriesFor: #makeCaseInsensitive!private! !
!SmaCCTerminalSymbol categoriesFor: #modelTypes:!accessing!private! !
!SmaCCTerminalSymbol categoriesFor: #regularExpression!accessing!private! !
!SmaCCTerminalSymbol categoriesFor: #regularExpression:!accessing!private! !
!SmaCCTerminalSymbol categoriesFor: #unsafeMethodName!private! !

SmaCCStartingSymbol guid: (GUID fromString: '{54535D83-2E75-4926-9EFE-0F92BD268DB6}')!
SmaCCStartingSymbol comment: ''!
!SmaCCStartingSymbol categoriesForClass!Unclassified! !
!SmaCCStartingSymbol methodsFor!

asLRItemSet
	| itemSet |
	itemSet := self grammar newItemSet.
	productions
		do:
			[:each | 
			itemSet
				add:
					(SmaCCLR1Item
						rhs: each
						follow:
							((SmaCCSymbolSet new)
								add: grammar emptySymbol;
								yourself))].
	^itemSet!

compileName
	^(productions first at: 1) safeMethodName!

isStartingSymbol
	^true!

symbol
	^productions first at: 1! !
!SmaCCStartingSymbol categoriesFor: #asLRItemSet!accessing!public! !
!SmaCCStartingSymbol categoriesFor: #compileName!accessing!private! !
!SmaCCStartingSymbol categoriesFor: #isStartingSymbol!private!testing! !
!SmaCCStartingSymbol categoriesFor: #symbol!public! !

SmaCCDuplicateNodeEliminator guid: (GUID fromString: '{F6DC3612-170F-493A-9BA5-DFD1C6A8C5DE}')!
SmaCCDuplicateNodeEliminator comment: 'SmaCCDuplicateNodeEliminator removes duplicate nodes from a scanner''s DFA.

Instance Variables:
	comparisonState	<Dictionary>	a dictionary of "equal" objects when testing nodes for equality
	root	<SmaCCNode>	the root node for the DFA

'!
!SmaCCDuplicateNodeEliminator categoriesForClass!Unclassified! !
!SmaCCDuplicateNodeEliminator methodsFor!

copyEdgesWith: aDictionary
	| todo |
	todo := OrderedCollection with: root.
	[todo notEmpty]
		whileTrue:
			[| node |
			node := todo removeFirst.
			(aDictionary at: node)
				transitions:
					(node sortedTransitions
						do:
							[:each | 
							| copy |
							copy := each copy.
							copy to: (aDictionary at: each to).
							copy])]!

copyGraph
	| map |
	map := Dictionary new.
	self copyNodesInto: map.
	self copyEdgesWith: map.
	^map at: root!

copyNodesInto: aDictionary
	root allStates do: [:each | aDictionary at: each put: each shallowCopy]!

isNode: firstSmaCCNode equivalentTo: secondSmaCCNode
	firstSmaCCNode = secondSmaCCNode ifTrue: [^true].
	firstSmaCCNode transitions size = secondSmaCCNode transitions size ifFalse: [^false].
	firstSmaCCNode action = secondSmaCCNode action ifFalse: [^false].
	((comparisonState at: firstSmaCCNode ifAbsent: [#()]) includes: secondSmaCCNode) ifTrue: [^true].
	(comparisonState at: firstSmaCCNode ifAbsentPut: [Set new]) add: secondSmaCCNode.
	(comparisonState at: secondSmaCCNode ifAbsentPut: [Set new]) add: firstSmaCCNode.
	firstSmaCCNode sortedTransitions
		with: secondSmaCCNode sortedTransitions
		do:
			[:first :second | 
			first transitionObjects = second transitionObjects ifFalse: [^false].
			(self isNode: first to equivalentTo: second to) ifFalse: [^false]].
	^true!

mergeAllTransitions
	root allStates do: [:each | each mergeTransitions]!

mergeNodeUsing: aDictionary
	| seen todo mappings |
	mappings := Dictionary new.
	aDictionary keysAndValuesDo: [:key :value | value do: [:each | mappings at: each put: key]].
	seen := IdentitySet new.
	todo := OrderedCollection with: root.
	[todo notEmpty]
		whileTrue:
			[| node mergedNode |
			node := todo removeFirst.
			node transitions
				do:
					[:each | 
					(seen includes: each to)
						ifFalse:
							[todo add: each to.
							seen add: each to]].
			mergedNode := mappings at: node ifAbsent: [nil].
			mergedNode notNil ifTrue: [node mergeWith: mergedNode]]!

pairsDo: aBlock
	| nodes |
	nodes := root allStates asSortedCollection.
	1 to: nodes size - 1 do: [:i | i + 1 to: nodes size do: [:j | aBlock value: (nodes at: i) value: (nodes at: j)]]!

removeDuplicateNodesIn: aSmaCCNode
	root := aSmaCCNode.
	self removeDuplicates.
	self copyGraph.
	^root!

removeDuplicates
	| toMerge |
	[toMerge := Dictionary new.
	self mergeAllTransitions.
	self
		pairsDo:
			[:firstNode :secondNode | 
			comparisonState := Dictionary new.
			(self isNode: firstNode equivalentTo: secondNode)
				ifTrue: [(toMerge at: firstNode ifAbsentPut: [Set new]) add: secondNode]].
	toMerge notEmpty]
		whileTrue:
			[toMerge values do: [:each | each do: [:node | toMerge removeKey: node ifAbsent: []]].
			self mergeNodeUsing: toMerge]! !
!SmaCCDuplicateNodeEliminator categoriesFor: #copyEdgesWith:!graph copying!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #copyGraph!graph copying!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #copyNodesInto:!graph copying!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #isNode:equivalentTo:!private!testing! !
!SmaCCDuplicateNodeEliminator categoriesFor: #mergeAllTransitions!algorithm!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #mergeNodeUsing:!algorithm!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #pairsDo:!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #removeDuplicateNodesIn:!algorithm!private! !
!SmaCCDuplicateNodeEliminator categoriesFor: #removeDuplicates!algorithm!private! !

!SmaCCDuplicateNodeEliminator class methodsFor!

removeDuplicateNodesIn: aSmaCCNode 
	^self new removeDuplicateNodesIn: aSmaCCNode! !
!SmaCCDuplicateNodeEliminator class categoriesFor: #removeDuplicateNodesIn:!algorithm!private! !

SmaCCEpsilonRemoval guid: (GUID fromString: '{277CB109-A293-4E0F-8E68-2BDF52CD7579}')!
SmaCCEpsilonRemoval comment: 'SmaCCEpsilonRemoval removes all epsilon edges from the scanner''s NFA.

Instance Variables:
	nodeMap	<Dictionary key: SmaCCNode value: SmaCCNode>	map from nodes in old graph to nodes in new graph

'!
!SmaCCEpsilonRemoval categoriesForClass!Unclassified! !
!SmaCCEpsilonRemoval methodsFor!

createNodeWithoutEpsilonEdges: aSmaCCNode
	| newNode newTransitions |
	newNode := self createMergedNodeFrom: (self epsilonReachableNodesFrom: aSmaCCNode).
	nodeMap at: aSmaCCNode put: newNode.
	newTransitions := OrderedCollection new.
	newNode transitions
		do:
			[:each | 
			each isEpsilonTransition
				ifFalse:
					[newTransitions
						add: (each class to: (self removeEpsilonEdgesFrom: each to) on: each transitionObjects)]].
	newNode transitions: newTransitions.
	^newNode!

epsilonReachableNodesFrom: aSmaCCNode
	| todo reachable node |
	reachable := Set with: aSmaCCNode.
	todo := OrderedCollection with: aSmaCCNode.
	[todo notEmpty]
		whileTrue:
			[node := todo removeLast.
			node transitions
				do:
					[:each | 
					(each isEpsilonTransition and: [(reachable includes: each to) not])
						ifTrue:
							[reachable add: each to.
							todo add: each to]]].
	^reachable!

initialize
	super initialize.
	nodeMap := Dictionary new!

removeEpsilonEdgesFrom: aSmaCCNode
	^nodeMap at: aSmaCCNode ifAbsent: [self createNodeWithoutEpsilonEdges: aSmaCCNode]! !
!SmaCCEpsilonRemoval categoriesFor: #createNodeWithoutEpsilonEdges:!algorithm!private! !
!SmaCCEpsilonRemoval categoriesFor: #epsilonReachableNodesFrom:!algorithm!private! !
!SmaCCEpsilonRemoval categoriesFor: #initialize!initialize-release!private! !
!SmaCCEpsilonRemoval categoriesFor: #removeEpsilonEdgesFrom:!algorithm!private! !

!SmaCCEpsilonRemoval class methodsFor!

removeEpsilonEdgesFrom: aSmaCCNode 
	"Returns an equivalent graph to aSmaCCNode that doesn't contain any epsilon transitions"

	^self new removeEpsilonEdgesFrom: aSmaCCNode! !
!SmaCCEpsilonRemoval class categoriesFor: #removeEpsilonEdgesFrom:!algorithm!private! !

SmaCCNFAtoDFA guid: (GUID fromString: '{3D0CA39A-CD42-4B6F-A79F-FC7D06C30404}')!
SmaCCNFAtoDFA comment: ''!
!SmaCCNFAtoDFA categoriesForClass!Unclassified! !
!SmaCCNFAtoDFA methodsFor!

commonTransitionObjectsForEdges: edgeCollection
	^edgeCollection
		inject: edgeCollection first transitionObjects
		into: [:sum :each | sum select: [:char | each includes: char]]!

convertToDFA: aSmaCCNode
	^self mergedNodeFor: (Array with: aSmaCCNode)!

createEdgeMerging: conflictingEdgeCollection
	| newNode common newEdge |
	newNode := self mergedNodeFor: (conflictingEdgeCollection collect: [:each | each to]).
	common := self commonTransitionObjectsForEdges: conflictingEdgeCollection.
	newEdge := conflictingEdgeCollection first class to: newNode on: common.
	conflictingEdgeCollection do: [:each | each remove: common].
	^newEdge!

eliminateDuplicateTransitionsIn: aSmaCCNode
	| newTransitions conflictingObject |
	newTransitions := aSmaCCNode transitions collect: [:each | each copy].
	[conflictingObject := self someDuplicateIn: newTransitions.
	conflictingObject notNil]
		whileTrue:
			[| conflictingEdges newEdge |
			conflictingEdges := newTransitions select: [:each | each includes: conflictingObject].
			newEdge := self createEdgeMerging: conflictingEdges.
			newTransitions add: newEdge].
	self setTransitionsOn: aSmaCCNode to: newTransitions!

initialize
	super initialize.
	mergedStates := Dictionary new!

mergedNodeFor: nodeCollection 
	| mergedNodes |
	mergedNodes := nodeCollection asSortedCollection asArray.
	^mergedStates at: mergedNodes
		ifAbsent: 
			[| newNode |
			newNode := self createMergedNodeFrom: mergedNodes.
			mergedStates
				at: mergedNodes put: newNode;
				at: (Array with: newNode) put: newNode.
			self eliminateDuplicateTransitionsIn: newNode.
			newNode]!

setTransitionsOn: aSmaCCNode to: edgeCollection 
	aSmaCCNode transitions: (edgeCollection reject: [:each | each isEmpty]).
	aSmaCCNode transitions do: [:each | each to: (self convertToDFA: each to)]!

someDuplicateIn: edgeCollection
	| objects |
	objects := SmaCCSet new.
	edgeCollection
		do:
			[:edge | 
			edge transitionObjects do: [:each | (objects includes: each) ifTrue: [^each]].
			objects addAll: edge transitionObjects].
	^nil! !
!SmaCCNFAtoDFA categoriesFor: #commonTransitionObjectsForEdges:!edges!private! !
!SmaCCNFAtoDFA categoriesFor: #convertToDFA:!algorithm!private! !
!SmaCCNFAtoDFA categoriesFor: #createEdgeMerging:!edges!private! !
!SmaCCNFAtoDFA categoriesFor: #eliminateDuplicateTransitionsIn:!merging nodes!private! !
!SmaCCNFAtoDFA categoriesFor: #initialize!initialize-release!private! !
!SmaCCNFAtoDFA categoriesFor: #mergedNodeFor:!merging nodes!private! !
!SmaCCNFAtoDFA categoriesFor: #setTransitionsOn:to:!edges!private! !
!SmaCCNFAtoDFA categoriesFor: #someDuplicateIn:!edges!private! !

!SmaCCNFAtoDFA class methodsFor!

convertToDFA: aSmaCCNode 
	"Returns an equivalent DFA from the NFA specified by aSmaCCNode -- the NFA must not contain epsilon edges."

	^self new convertToDFA: aSmaCCNode! !
!SmaCCNFAtoDFA class categoriesFor: #convertToDFA:!accessing!private! !

SmaCCDefinitionParser guid: (GUID fromString: '{AB9EF558-4708-4C61-AD6C-30F7474B5F14}')!
SmaCCDefinitionParser comment: 'SmaCCDefinitionParser is a SmaCCParser that parses a parser''s definition.

Instance Variables:
	grammar	<SmaCCGrammar>	we create the grammar object from the parser''s definition
	scannerDefinition	<SmaCCScannerDefinition>	we also create the scanner definition object from the parser''s definition'!
!SmaCCDefinitionParser categoriesForClass!Unclassified! !
!SmaCCDefinitionParser methodsFor!

allCharacters
	^SmaCCGrammar allCharacters!

carriageReturnString
	^String with: (Character value: 13)!

charactersFor: aStream in: aToken
	| characters char endCharacters |
	aStream atEnd ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	char := aStream next.
	characters := char == $\
		ifTrue: [(self nodeFor: aStream) characters]
		ifFalse: [OrderedCollection with: char].
	(characters size = 1 and: [aStream peekFor: $-]) ifFalse: [^characters].
	endCharacters := self charactersFor: aStream in: aToken.
	endCharacters size > 1 ifTrue: [self reportCharacterBlockErrorForToken: aToken].
	^(characters first asInteger to: endCharacters first asInteger)
		collect: [:each | Character value: each]!

createClass: aSymbol for: aSmaCCRHS 
	(grammar classNamed: aSymbol) addProduction: aSmaCCRHS.
	^aSmaCCRHS!

createDefaultClassesForSymbol: aString
	| className index |
	className := aString capitalized.
	[index := className indexOf: $_.
	index > 0 and: [className size > 1]]
		whileTrue:
			[className := (className copyFrom: 1 to: index - 1) , (className copyFrom: index + 1 to: className size) capitalized].
	className := className asSymbol.
	defaultClasses do: [:each | self createClass: className for: each].
	defaultClasses := OrderedCollection new!

createDefaultClassFor: aSmaCCRHS
	defaultClasses add: aSmaCCRHS.
	^aSmaCCRHS!

formFeedString
	^String with: (Character value: 12)!

generateImplicitToken: aSmaCCToken
	| node |
	node := SmaCCGrammar implicitToken: aSmaCCToken value.
	node isNil
		ifTrue:
			[currentToken := aSmaCCToken.
			self reportErrorMessage: 'Token not specified'].
	^node!

grammar: aSmaCCGrammar
	grammar := aSmaCCGrammar.
	scannerDefinition := SmaCCScannerDefinition new.
	grammar scannerDefinition: scannerDefinition!

hexStringFrom: aStream
	^String with: (Character value: (self hexValueFrom: aStream))!

hexValueFrom: aStream
	| char value count |
	count := value := 0.
	[aStream atEnd not
		and:
			[count < 4
				and:
					[char := aStream peek.
					(char between: $0 and: $9) or: [(char between: $A and: $F) or: [char between: $a and: $f]]]]]
		whileTrue:
			[count := count + 1.
			value := value * 16 + aStream next digitValue].
	^value!

initialize
	super initialize.
	self grammar: SmaCCGrammar new.
	defaultClasses := OrderedCollection new!

isDigit: each
	^each between: $0 and: $9!

isLetterOrDigit: each
	^(each between: $a and: $z) or: [(each between: $A and: $Z) or: [(each between: $0 and: $9) or: [each == $_]]]!

isWhitespace: each
	^self whitespaceValues includes: each asInteger!

newlineString
	^String with: (Character value: 10)!

nodeFor: aStream
	| block char |
	block := nil.
	char := aStream next.
	char == $f ifTrue: [^SmaCCCharacterRENode characters: self formFeedString].
	char == $n ifTrue: [^SmaCCCharacterRENode characters: self newlineString].
	char == $r ifTrue: [^SmaCCCharacterRENode characters: self carriageReturnString].
	char == $t ifTrue: [^SmaCCCharacterRENode characters: self tabString].
	char == $v ifTrue: [^SmaCCCharacterRENode characters: self verticalTabString].
	char == $c
		ifTrue: [^SmaCCCharacterRENode characters: (String with: (Character value: aStream next asInteger - $A asInteger))].
	char == $x ifTrue: [^SmaCCCharacterRENode characters: (self hexStringFrom: aStream)].
	char == $d ifTrue: [block := [:each | self isDigit: each]].
	char == $D ifTrue: [block := [:each | (self isDigit: each) not]].
	char == $s ifTrue: [block := [:each | self isWhitespace: each]].
	char == $S ifTrue: [block := [:each | (self isWhitespace: each) not]].
	char == $w ifTrue: [block := [:each | self isLetterOrDigit: each]].
	char == $W ifTrue: [block := [:each | (self isLetterOrDigit: each) not]].
	block isNil ifTrue: [^SmaCCCharacterRENode characters: (String with: char)].
	^SmaCCCharacterRENode characters: (String withAll: (self allCharacters select: block))!

parseCharacterBlock: aToken
	| characters aStream invert node |
	aStream := ReadStream on: (aToken value copyFrom: 2 to: aToken value size - 1).
	characters := OrderedCollection new.
	invert := aStream peekFor: $^.
	[aStream atEnd] whileFalse: [characters addAll: (self charactersFor: aStream in: aToken)].
	node := SmaCCCharacterRENode characters: (String withAll: characters).
	invert ifTrue: [node := SmaCCNotRENode on: node].
	^node!

reduceActionForAnnotateTokens1: nodes
	^grammar annotateTokens: true!

reduceActionForAttributesLine1: nodes
	^(grammar classNamed: (nodes at: 2) value asSymbol)
		extraAttributes: ((nodes at: 4) collect: [:each | SmaCCVariableDefinition variableName: each])!

reduceActionForClassList1: nodes
	^OrderedCollection new!

reduceActionForClassList2: nodes
	^(nodes at: 1)
		add: (nodes at: 2) value asSymbol;
		yourself!

reduceActionForEndDirective1: nodes
	^self state: #default!

reduceActionForExcludeStates2: nodes
	^scannerDefinition addExcludeState: (nodes at: 2)!

reduceActionForFile1: nodes
	^grammar
		addExtraSymbols;
		yourself!

reduceActionForGLR1: nodes
	^grammar isGLR: true!

reduceActionForIdMethodLine1: nodes
	(nodes at: 2) do: [:each | grammar makeTokenIdMethodFor: each].
	^nil!

reduceActionForIdTokens1: nodes
	^OrderedCollection with: (nodes at: 1) value!

reduceActionForIdTokens2: nodes
	^(nodes at: 1)
		add: (nodes at: 2) value;
		yourself!

reduceActionForIgnoreCase1: nodes
	^grammar ignoreCase: true!

reduceActionForIgnoredVariableList2: nodes
	(nodes at: 1) add: (nodes at: 2) value.
	^nodes at: 1!

reduceActionForIgnoredVariables1: nodes
	^grammar ignoredVariables: (nodes at: 3)!

reduceActionForLeftLine1: nodes
	(nodes at: 2)
		do:
			[:each | 
			grammar
				leftPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil!

reduceActionForNonAssociativeLine1: nodes
	(nodes at: 2)
		do:
			[:each | 
			grammar
				nonAssociativePrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil!

reduceActionForParserRule1: nodes
	^nodes at: 1!

reduceActionForParserRule2: nodes
	^self verifyCodeToken: (nodes at: 2) for: (nodes at: 1)!

reduceActionForParserRule3: nodes
	^self createClass: (nodes at: 3) value asSymbol for: (nodes at: 1)!

reduceActionForParserRule4: nodes
	^self createDefaultClassFor: (nodes at: 1)!

reduceActionForParserRules1: nodes
	^(nodes at: 1)
		add: (nodes at: 3);
		yourself!

reduceActionForPrefixLine1: nodes
	^grammar prefix: (nodes at: 2) value!

reduceActionForProductionRule1: nodes
	| symbol |
	symbol := grammar nonTerminalSymbolNamed: (nodes at: 1) value.
	(nodes at: 4) do: [:each | symbol addProduction: each].
	self createDefaultClassesForSymbol: (nodes at: 1) value.
	^symbol!

reduceActionForRegex2: nodes
	^(nodes at: 1) | (nodes at: 3)!

reduceActionForRegex3: nodes
	^(nodes at: 1) , (nodes at: 2)!

reduceActionForRegexRule1: nodes
	| symbol |
	(nodes at: 4) position: (nodes at: 2) startPosition.
	scannerDefinition addToken: (nodes at: 4) withName: (nodes at: 2) value.
	symbol := grammar findSymbolNamed: (nodes at: 2) value ifAbsent: [nil].
	symbol notNil ifTrue: [symbol regularExpression: (nodes at: 4)].
	^nodes at: 4!

reduceActionForRegexRule2: nodes
	^(nodes at: 2)
		addState: (nodes at: 1);
		yourself!

reduceActionForRegexTerm10: nodes
	^(nodes at: 1) repeatForAtLeast: 1!

reduceActionForRegexTerm11: nodes
	^(nodes at: 1) repeatFor: 0 to: 1!

reduceActionForRegexTerm12: nodes
	| readStream start stop |
	readStream := ReadStream on: ((nodes at: 2) value copyFrom: 2 to: (nodes at: 2) value size - 1).
	start := readStream upTo: $,.
	stop := readStream upToEnd.
	^(nodes at: 1)
		repeatFor: (start isEmpty ifTrue: [0] ifFalse: [start asNumber])
		to: (stop isEmpty ifTrue: [1 bitShift: 31] ifFalse: [stop asNumber])!

reduceActionForRegexTerm2: nodes
	^SmaCCCharacterRENode characters: (nodes at: 1) value!

reduceActionForRegexTerm3: nodes
	^SmaCCCharacterRENode characters: self allCharacters!

reduceActionForRegexTerm4: nodes
	^self nodeFor: (ReadStream on: ((nodes at: 1) value copyFrom: 2 to: (nodes at: 1) value size))!

reduceActionForRegexTerm6: nodes
	^self parseCharacterBlock: (nodes at: 1)!

reduceActionForRegexTerm7: nodes
	^(scannerDefinition tokenNamed: (nodes at: 1) value ifAbsentPut: [self generateImplicitToken: (nodes at: 1)]) copy!

reduceActionForRegexTerm8: nodes
	^SmaCCSequenceRENode
		nodes:
			((nodes at: 1) value asOrderedCollection collect: [:each | SmaCCCharacterRENode characters: (String with: each)])!

reduceActionForRegexTerm9: nodes
	^(nodes at: 1) repeat!

reduceActionForRightLine1: nodes
	(nodes at: 2)
		do:
			[:each | 
			grammar
				rightPrecedenceFor: each;
				setOperatorPrecedenceFor: each to: scanner lineNumber].
	^nil!

reduceActionForRootClassLine1: nodes
	^(grammar classNamed: (nodes at: 2) value asSymbol) beRoot!

reduceActionForRule1: nodes
	^grammar setStartSymbolIfNone: (nodes at: 1)!

reduceActionForRule3: nodes
	^(nodes at: 1) states isEmpty ifTrue: [(nodes at: 1) addStates: scannerDefinition nonExcludeStates]!

reduceActionForStartDirective1: nodes
	^self state: #directives!

reduceActionForStartingTokens1: nodes
	^grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 1) value)!

reduceActionForStartingTokens2: nodes
	^grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: (nodes at: 2) value)!

reduceActionForStartProduction1: nodes
	^self state: #parser!

reduceActionForStartRegex1: nodes
	^self state: #scanner!

reduceActionForStates2: nodes
	^scannerDefinition addState: (nodes at: 2)!

reduceActionForSuffixLine1: nodes
	^grammar suffix: (nodes at: 2) value!

reduceActionForSuperclassLine1: nodes
	^(nodes at: 4) do: [:each | (grammar classNamed: each) superclass: (grammar classNamed: (nodes at: 2) value asSymbol)]!

reduceActionForSymbol1: nodes
	^(nodes at: 1) value asSymbol!

reduceActionForTerm1: nodes
	^grammar keywordTerminalNamed: (nodes at: 1) value!

reduceActionForTerm2: nodes
	^grammar
		findSymbolNamed: (nodes at: 1) value
		ifAbsentAdd:
			[| node symbol |
			symbol := grammar newTerminalSymbolNamed: (nodes at: 1) value.
			(scannerDefinition includesTokenNamed: (nodes at: 1) value)
				ifTrue: [symbol regularExpression: (scannerDefinition tokenNamed: (nodes at: 1) value)]
				ifFalse:
					[node := SmaCCGrammar implicitToken: (nodes at: 1) value.
					node notNil
						ifTrue:
							[node addStates: scannerDefinition nonExcludeStates.
							symbol regularExpression: node]].
			symbol]!

reduceActionForTerm3: nodes
	^grammar nonTerminalSymbolNamed: (nodes at: 1) value!

reduceActionForTerm4: nodes
	^grammar errorSymbol!

reduceActionForTerms1: nodes
	^grammar newRHS!

reduceActionForTerms2: nodes
	^(nodes at: 1)
		add: (nodes at: 2);
		yourself!

reduceActionForTerms3: nodes
	^(nodes at: 1)
		add: (nodes at: 2);
		nameLastItem: ((nodes at: 3) value copyFrom: 2 to: (nodes at: 3) value size - 1);
		yourself!

reduceTable
^#(
	#(75 0 #reduceActionForStartRegex1:) 
	#(74 0 #reduceActionForStartDirective1:) 
	#(51 1 #reduceActionForSymbol1:) 
	#(79 0 #reduceActionForStartProduction1:) 
	#(73 1 #reduceFor:) 
	#(56 1 #reduceActionForRule1:) 
	#(56 1 #reduceActionForRule3:) 
	#(56 1 #reduceFor:) 
	#(44 1 #reduceActionForFile1:) 
	#(70 2 #reduceActionForRegexRule2:) 
	#(73 2 #reduceFor:) 
	#(59 0 #reduceActionForEndDirective1:) 
	#(83 0 #reduceActionForTerms1:) 
	#(41 0 #reduceFor:) 
	#(53 0 #reduceFor:) 
	#(60 1 #reduceActionForGLR1:) 
	#(46 1 #reduceActionForIgnoreCase1:) 
	#(65 1 #reduceActionForAnnotateTokens1:) 
	#(52 1 #reduceFor:) 
	#(81 0 #reduceActionForEndDirective1:) 
	#(80 1 #reduceFor:) 
	#(82 1 #reduceActionForParserRule1:) 
	#(55 2 #reduceFor:) 
	#(57 2 #reduceFor:) 
	#(54 2 #reduceActionForRootClassLine1:) 
	#(47 2 #reduceActionForPrefixLine1:) 
	#(45 2 #reduceActionForSuffixLine1:) 
	#(64 1 #reduceActionForTerm4:) 
	#(64 1 #reduceActionForTerm2:) 
	#(64 1 #reduceActionForTerm3:) 
	#(64 1 #reduceActionForTerm1:) 
	#(61 2 #reduceActionForLeftLine1:) 
	#(62 1 #reduceFor:) 
	#(50 2 #reduceActionForRightLine1:) 
	#(42 2 #reduceActionForNonAssociativeLine1:) 
	#(66 1 #reduceActionForIdTokens1:) 
	#(43 2 #reduceActionForIdMethodLine1:) 
	#(69 1 #reduceActionForStartingTokens1:) 
	#(86 2 #reduceFor:) 
	#(78 1 #reduceActionForRegexTerm7:) 
	#(78 1 #reduceActionForRegexTerm8:) 
	#(78 1 #reduceActionForRegexTerm2:) 
	#(78 1 #reduceActionForRegexTerm4:) 
	#(78 1 #reduceActionForRegexTerm6:) 
	#(78 1 #reduceActionForRegexTerm3:) 
	#(77 0 #reduceActionForEndDirective1:) 
	#(76 1 #reduceActionForParserRule1:) 
	#(82 2 #reduceActionForParserRule2:) 
	#(83 2 #reduceActionForTerms2:) 
	#(41 2 #reduceActionForStates2:) 
	#(53 2 #reduceActionForExcludeStates2:) 
	#(67 0 #reduceActionForClassList1:) 
	#(58 0 #reduceActionForClassList1:) 
	#(62 2 #reduceFor:) 
	#(66 2 #reduceActionForIdTokens2:) 
	#(69 2 #reduceActionForStartingTokens2:) 
	#(71 5 #reduceFor:) 
	#(72 1 #reduceActionForIdTokens1:) 
	#(63 3 #reduceActionForIgnoredVariables1:) 
	#(76 2 #reduceActionForRegex3:) 
	#(78 2 #reduceActionForRegexTerm9:) 
	#(78 2 #reduceActionForRegexTerm10:) 
	#(78 2 #reduceActionForRegexTerm11:) 
	#(78 2 #reduceActionForRegexTerm12:) 
	#(80 3 #reduceActionForParserRules1:) 
	#(68 6 #reduceActionForProductionRule1:) 
	#(82 3 #reduceActionForParserRule4:) 
	#(83 3 #reduceActionForTerms3:) 
	#(72 2 #reduceActionForIgnoredVariableList2:) 
	#(78 3 #liftSecondValue:) 
	#(76 3 #reduceActionForRegex2:) 
	#(70 6 #reduceActionForRegexRule1:) 
	#(82 4 #reduceActionForParserRule3:) 
	#(49 5 #reduceActionForSuperclassLine1:) 
	#(67 2 #reduceActionForClassList2:) 
	#(48 5 #reduceActionForAttributesLine1:) 
	#(58 2 #reduceActionForIdTokens2:)
	).!

reportCharacterBlockErrorForToken: aToken
	currentToken := aToken.
	self reportErrorMessage: 'Invalid character block'!

tabString
	^'	'!

transitionTable
^#(
#[1 0 6 0 25 0 9 0 26 0 10 0 32 0 13 0 44 0 17 0 51 0 21 0 56 0 25 0 68 0 29 0 70 0 33 0 71 0 37 0 73 0 41 0 74 0 45 0 75] 
#[1 0 14 0 25 0 14 0 26 0 18 0 31 0 49 0 79] 
#[0 0 0 0 84] 
#[1 0 6 0 25 0 53 0 26 0 17 0 51 0 57 0 70 0 45 0 75] 
#[0 0 22 0 25 0 26 0 32 0 84] 
#[0 0 26 0 25 0 26 0 32 0 84] 
#[0 0 30 0 25 0 26 0 32 0 84] 
#[0 0 34 0 25 0 26 0 32 0 84] 
#[1 0 6 0 25 0 9 0 26 0 10 0 32 0 17 0 51 0 61 0 56 0 25 0 68 0 29 0 70 0 33 0 71 0 41 0 74 0 45 0 75 0 38 0 84] 
#[0 0 65 0 32] 
#[0 0 69 0 25] 
#[0 0 73 0 31] 
#[0 0 14 0 25 0 26 0 33] 
#[0 0 42 0 25 0 26 0 32 0 84] 
#[0 0 46 0 25 0 26 0 32 0 84] 
#[1 0 77 0 8 0 81 0 9 0 85 0 10 0 89 0 11 0 93 0 12 0 97 0 13 0 101 0 14 0 105 0 15 0 109 0 16 0 113 0 17 0 117 0 18 0 121 0 19 0 125 0 20 0 129 0 21 0 50 0 22 0 133 0 23 0 137 0 42 0 141 0 43 0 145 0 45 0 149 0 46 0 153 0 47 0 157 0 48 0 161 0 49 0 165 0 50 0 169 0 52 0 173 0 54 0 177 0 55 0 181 0 57 0 185 0 59 0 189 0 60 0 193 0 61 0 197 0 63 0 201 0 65 0 205 0 86] 
#[0 0 209 0 31] 
#[1 0 54 0 1 0 54 0 7 0 54 0 25 0 54 0 26 0 54 0 27 0 54 0 29 0 54 0 33 0 54 0 39 0 213 0 80 0 217 0 82 0 221 0 83] 
#[1 0 58 0 26 0 58 0 33 0 225 0 41] 
#[1 0 62 0 26 0 62 0 33 0 229 0 53] 
#[0 0 233 0 26] 
#[0 0 237 0 26] 
#[0 0 241 0 26] 
#[0 0 245 0 26] 
#[0 0 249 0 26] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 1 13 0 62 1 17 0 64] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 1 21 0 62 1 17 0 64] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 1 25 0 62 1 17 0 64] 
#[1 1 29 0 25 1 33 0 66] 
#[1 1 37 0 26 1 41 0 69] 
#[0 0 66 0 33] 
#[0 0 70 0 33] 
#[0 0 74 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[1 0 50 0 33 1 45 0 59] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 1 49 0 22] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[0 0 78 0 33] 
#[1 1 53 0 2 1 57 0 25 1 61 0 26 1 65 0 32 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 85 0 76 1 89 0 78] 
#[1 1 93 0 1 0 82 0 33 1 97 0 81] 
#[0 0 86 0 1 0 33] 
#[1 0 90 0 1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 1 101 0 29 0 90 0 33 1 105 0 39 1 109 0 64] 
#[1 0 53 0 26 0 94 0 33 1 113 0 51] 
#[1 0 53 0 26 0 98 0 33 1 117 0 51] 
#[0 0 102 0 33] 
#[0 1 121 0 2] 
#[0 1 125 0 2] 
#[0 0 106 0 33] 
#[0 0 110 0 33] 
#[0 0 114 0 1 0 7 0 25 0 26 0 27 0 29 0 30 0 33 0 39] 
#[0 0 118 0 1 0 7 0 25 0 26 0 27 0 29 0 30 0 33 0 39] 
#[0 0 122 0 1 0 7 0 25 0 26 0 27 0 29 0 30 0 33 0 39] 
#[0 0 126 0 1 0 7 0 25 0 26 0 27 0 29 0 30 0 33 0 39] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 0 130 0 33 1 129 0 64] 
#[0 0 134 0 7 0 25 0 26 0 27 0 33] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 0 138 0 33 1 129 0 64] 
#[1 0 253 0 7 1 1 0 25 1 5 0 26 1 9 0 27 0 142 0 33 1 129 0 64] 
#[0 0 146 0 25 0 33] 
#[1 1 133 0 25 0 150 0 33] 
#[0 0 154 0 26 0 33] 
#[1 1 137 0 26 0 158 0 33] 
#[0 1 141 0 33] 
#[1 1 145 0 26 1 149 0 72] 
#[1 1 53 0 2 1 57 0 25 1 61 0 26 1 65 0 32 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 153 0 76 1 89 0 78] 
#[0 0 162 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 166 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 170 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 174 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 178 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 170 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 182 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[1 1 157 0 1 1 53 0 2 1 57 0 25 1 61 0 26 1 65 0 32 0 186 0 33 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 161 0 77 1 165 0 78] 
#[1 0 190 0 1 0 190 0 2 1 169 0 3 1 173 0 4 1 177 0 5 0 190 0 6 0 190 0 25 0 190 0 26 0 190 0 32 0 190 0 33 0 190 0 34 0 190 0 35 1 181 0 36 0 190 0 37 0 190 0 38] 
#[1 0 54 0 1 0 54 0 7 0 54 0 25 0 54 0 26 0 54 0 27 0 54 0 29 0 54 0 33 0 54 0 39 1 185 0 82 0 221 0 83] 
#[0 1 189 0 33] 
#[0 0 194 0 1 0 33] 
#[1 1 193 0 26 1 197 0 40] 
#[1 0 198 0 1 0 198 0 7 0 198 0 25 0 198 0 26 0 198 0 27 0 198 0 29 1 201 0 30 0 198 0 33 0 198 0 39] 
#[0 0 202 0 26 0 33] 
#[0 0 206 0 26 0 33] 
#[1 0 210 0 6 0 210 0 26 1 205 0 67] 
#[1 0 214 0 6 0 214 0 26 1 209 0 58] 
#[0 0 218 0 7 0 25 0 26 0 27 0 33] 
#[0 0 222 0 25 0 33] 
#[0 0 226 0 26 0 33] 
#[0 0 230 0 25 0 26 0 32 0 84] 
#[0 0 234 0 26 0 33] 
#[1 1 213 0 26 0 238 0 33] 
#[1 1 157 0 1 1 53 0 2 1 217 0 6 1 57 0 25 1 61 0 26 1 65 0 32 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 165 0 78] 
#[1 1 53 0 2 1 57 0 25 1 61 0 26 1 65 0 32 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 221 0 76 1 89 0 78] 
#[0 1 225 0 33] 
#[1 0 242 0 1 0 242 0 2 1 169 0 3 1 173 0 4 1 177 0 5 0 242 0 6 0 242 0 25 0 242 0 26 0 242 0 32 0 242 0 33 0 242 0 34 0 242 0 35 1 181 0 36 0 242 0 37 0 242 0 38] 
#[0 0 246 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 250 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 0 254 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 1 2 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[0 1 6 0 1 0 33] 
#[0 1 10 0 25 0 26 0 32 0 84] 
#[0 1 229 0 40] 
#[0 1 14 0 1 0 33] 
#[0 1 18 0 1 0 7 0 25 0 26 0 27 0 29 0 33 0 39] 
#[1 1 233 0 6 1 237 0 26] 
#[1 1 241 0 6 1 245 0 26] 
#[0 1 22 0 26 0 33] 
#[0 1 26 0 1 0 2 0 3 0 4 0 5 0 6 0 25 0 26 0 32 0 33 0 34 0 35 0 36 0 37 0 38] 
#[1 1 30 0 1 1 53 0 2 1 30 0 6 1 57 0 25 1 61 0 26 1 65 0 32 1 30 0 33 1 69 0 34 1 73 0 35 1 77 0 37 1 81 0 38 1 165 0 78] 
#[0 1 34 0 25 0 26 0 32 0 84] 
#[0 1 38 0 1 0 33] 
#[0 1 42 0 33] 
#[0 1 46 0 6 0 26] 
#[0 1 50 0 33] 
#[0 1 54 0 6 0 26]
	).!

verifyCodeToken: codeToken for: aSmaCCRHS
	| code |
	code := codeToken value copyFrom: 2 to: codeToken value size - 1.
	SmalltalkParser
		parseExpression: code
		onError:
			[:string :position | 
			currentToken := nil.
			self position: codeToken startPosition + position.
			self reportErrorMessage: string].
	aSmaCCRHS reduceActionSource: code.
	^aSmaCCRHS!

verticalTabString
	^String with: (Character value: 11)!

whitespaceValues
	^#[9 10 11 12 13 32]! !
!SmaCCDefinitionParser categoriesFor: #allCharacters!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #carriageReturnString!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #charactersFor:in:!private! !
!SmaCCDefinitionParser categoriesFor: #createClass:for:!private! !
!SmaCCDefinitionParser categoriesFor: #createDefaultClassesForSymbol:!private! !
!SmaCCDefinitionParser categoriesFor: #createDefaultClassFor:!private! !
!SmaCCDefinitionParser categoriesFor: #formFeedString!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #generateImplicitToken:!private! !
!SmaCCDefinitionParser categoriesFor: #grammar:!initialize-release!private! !
!SmaCCDefinitionParser categoriesFor: #hexStringFrom:!private! !
!SmaCCDefinitionParser categoriesFor: #hexValueFrom:!private! !
!SmaCCDefinitionParser categoriesFor: #initialize!initialize-release!private! !
!SmaCCDefinitionParser categoriesFor: #isDigit:!private!testing! !
!SmaCCDefinitionParser categoriesFor: #isLetterOrDigit:!private!testing! !
!SmaCCDefinitionParser categoriesFor: #isWhitespace:!private!testing! !
!SmaCCDefinitionParser categoriesFor: #newlineString!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #nodeFor:!private! !
!SmaCCDefinitionParser categoriesFor: #parseCharacterBlock:!private! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForAnnotateTokens1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForAttributesLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForClassList1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForClassList2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForEndDirective1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForExcludeStates2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForFile1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForGLR1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIdMethodLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIdTokens1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIdTokens2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIgnoreCase1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIgnoredVariableList2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForIgnoredVariables1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForLeftLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForNonAssociativeLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForParserRule1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForParserRule2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForParserRule3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForParserRule4:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForParserRules1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForPrefixLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForProductionRule1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegex2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegex3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexRule1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexRule2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm10:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm11:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm12:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm4:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm6:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm7:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm8:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRegexTerm9:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRightLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRootClassLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRule1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForRule3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStartDirective1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStartingTokens1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStartingTokens2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStartProduction1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStartRegex1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForStates2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForSuffixLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForSuperclassLine1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForSymbol1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerm1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerm2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerm3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerm4:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerms1:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerms2:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceActionForTerms3:!generated-reduction actions!public! !
!SmaCCDefinitionParser categoriesFor: #reduceTable!generated!public! !
!SmaCCDefinitionParser categoriesFor: #reportCharacterBlockErrorForToken:!private! !
!SmaCCDefinitionParser categoriesFor: #tabString!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #transitionTable!generated!public! !
!SmaCCDefinitionParser categoriesFor: #verifyCodeToken:for:!private! !
!SmaCCDefinitionParser categoriesFor: #verticalTabString!private!private-strings! !
!SmaCCDefinitionParser categoriesFor: #whitespaceValues!private! !

!SmaCCDefinitionParser class methodsFor!

definitionComment
"%states default scanner directives parser;

directives <states>
	: states 
	;
directives <excludes> 
	: excludes 
	;
directives <root> 
	: root 
	;
directives <hierarchy> 
	: hierarchy 
	;
directives <attributes>
	: attributes
	;
directives <prefix> 
	: prefix 
	;
directives <suffix> 
	: suffix 
	;
directives <left> 
	: left 
	;
directives <right> 
	: right 
	;
directives <nonassoc> 
	: nonassoc 
	;
directives <id> 
	: id 
	;
directives <start> 
	: start 
	;
directives <glr>
	: glr
	;
directives <ignorecase>
	: ignorecase
	;
directives <ignorevariables>
	: ignore_variables
	;
directives <annotate_tokens>
	: annotate_tokens
	;
<name> 
	: (<isLetter> | _) (<isLetter> | _ | <isDigit>)*
	;
<directive> 
	: \%
	;
<whitespace>
	: \s+ 
	;
<tokenname>
	: \< <name> \>
	;
<symbolname>
	: <name>
	 ;
<keyword>
	: (\"" [^\""]* \"") + 
	;
<comment>
	: (\# [^\r\n]*) 
	| (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/)
	;
<code>
	: \{ 
	;
<variablename>
	: \' <name> \' 
	;
<production>
	: \: (\: \=)? 
	;
<directive>
	: % 
	;
<semicolon>
	: \; 
	;
scanner <backslashcharacter>
	: \\ [^cx] 
	| \\ c [A-Z] 
	| \\ x [0-9A-Fa-f]{1,4}
	;
scanner <characterblock>
	: \[ ([^\]\\] | <backslashcharacter> )+ \] 
	;
scanner <repeat>
	: \{ [0-9]* \, [0-9]* \}
	;
scanner <character>
	: [^\ \t\v\\\r\n\{\(\[\.]
	; 
scanner <anycharacter>
	: \.
	;
parser <optionalLeft>
	: \[
	;
parser <optionalRight>
	: \] 
	;
parser <repeatLeft> 
	: \<\% 
	;
parser <repeatRight> 
	: \%\> 
	;
parser <classLeft> 
	: \{\{ 
	;
parser <classRight> 
	: \}\} 
	;

%id <code> <keyword> <symbolname> <tokenname> <variablename> <semicolon>
	<directive> <production> <classLeft> <classRight>;
%left	""|"";
%left ""("" <character> <backslashcharacter> <characterblock> <anycharacter> <tokenname> <symbolname> <directive>;
%left ""*"" ""+"" ""?"" <repeat> ;

File
	: Rules 
			{grammar 
				addExtraSymbols; 
				yourself}
	;
Rules
	: Rule
	| Rules Rule
	;
Rule 
	: ProductionRule 
			{grammar setStartSymbolIfNone: '1'}
	| DirectiveLine
	| RegexRule 
			{'1' states isEmpty ifTrue: ['1' addStates: scannerDefinition nonExcludeStates]}
	;
# Directives
DirectiveLine 
	: StartDirective <directive> Directive EndDirective <semicolon>
	;
Directive 
	: ExcludeStatesLine 
	| StatesLine
	| RootClassLine
	| SuperclassLine
	| AttributesLine
	| PrefixLine
	| SuffixLine
	| LeftLine 
	| RightLine 
	| NonAssociativeLine
	| IdMethodLine
	| StartLine 
	| GLR
	| IgnoreCase
	| IgnoredVariables
	| AnnotateTokens
	;
StartDirective 
	: 		{self state: #directives}
	;
EndDirective 
	: 		{self state: #default}
	;
StatesLine 
	: <states> States
	;
States 
	: 
	| States Symbol 
			{scannerDefinition addState: '2'}
	;
ExcludeStatesLine 
	: <excludes> ExcludeStates
	;
ExcludeStates 
:
	| ExcludeStates Symbol 
			{scannerDefinition addExcludeState: '2'}
	;
RootClassLine 
	: <root> <symbolname> 'root' 
			{(grammar classNamed: root value asSymbol) beRoot}
	;
SuperclassLine
	: <hierarchy> <symbolname> 'superclass' ""("" ClassList 'classes' "")""
			{classes do: [:each | (grammar classNamed: each) superclass: (grammar classNamed: superclass value asSymbol)]}
	;
AttributesLine
	: <attributes> <symbolname> 'aClass' ""("" IvarList 'ivars' "")""
			{(grammar classNamed: aClass value asSymbol)  extraAttributes: (ivars collect: [:each | SmaCCVariableDefinition variableName: each ])} ;
IvarList	
	:		{OrderedCollection new}
	| IvarList 'list' <symbolname> 'name'	
			{list add: name value; yourself} 
	;
ClassList 
	: 		{OrderedCollection new}
	| ClassList 'list' <symbolname> 'name' 
			{list 
				add: name value asSymbol; 
				yourself}
	;
PrefixLine
	: <prefix> <symbolname> 'prefix' 
			{grammar prefix: prefix value}
	;
SuffixLine
	: <suffix> <symbolname> 'suffix' 
			{grammar suffix: suffix value}
	;
LeftLine
	: <left> TokenList 'tokens' 
			{tokens 
				do: 
					[:each | 
					grammar 
						leftPrecedenceFor: each; 
						setOperatorPrecedenceFor: each to: scanner lineNumber].
			nil}
	;
RightLine
	: <right> TokenList 'tokens' 
			{tokens 
				do: 
					[:each | 
					grammar 
						rightPrecedenceFor: each; 
						setOperatorPrecedenceFor: each to: scanner lineNumber].
			nil}
	;
NonAssociativeLine
	: <nonassoc> TokenList 'tokens'
			{tokens 
				do: 
					[:each | 
					grammar 
						nonAssociativePrecedenceFor: each; 
						setOperatorPrecedenceFor: each to: scanner lineNumber].
			nil}
	;
TokenList
	: Term
	| TokenList Term
	;
IdMethodLine
	: <id> IdTokens 'tokens' 
			{tokens do: [:each | grammar makeTokenIdMethodFor: each]. nil}
	;
IdTokens
	: <tokenname> 
			{OrderedCollection with: '1' value}
	| IdTokens <tokenname> 
			{'1' 
				add: '2' value; 
				yourself}
	;
StartLine
	: <start> StartingTokens
	;
StartingTokens
	: <symbolname> 'symbol' 
			{grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)}
	| StartingTokens <symbolname> 'symbol' 
			{grammar addStartingSymbol: (grammar nonTerminalSymbolNamed: symbol value)}
	;
GLR
	: <glr>
			{grammar isGLR: true}
	;
IgnoredVariables
	: EndDirective <ignorevariables> IgnoredVariableList 'variables'
			{grammar ignoredVariables: variables}
	;
IgnoredVariableList
	: <symbolname> 'name'
			{OrderedCollection with: name value}
	| IgnoredVariableList 'variables' <symbolname> 'name'
			{variables add: name value.
			variables}
	;
IgnoreCase
	: <ignorecase>
			{grammar ignoreCase: true}
	;
AnnotateTokens
	: <annotate_tokens>
			{grammar annotateTokens: true}
	;
# Scanner
RegexRule 
	: StartRegex <tokenname> 'token' <production> Regex 'regex' EndRegex <semicolon>
			{| symbol |
			regex position: token startPosition. 
			scannerDefinition addToken: regex withName: token value. 
			symbol := grammar findSymbolNamed: token value ifAbsent: [nil].
			symbol notNil ifTrue: [symbol regularExpression: regex].
			regex}
	| Symbol 'state' RegexRule 'rule'
			{rule
				addState: state; 
				yourself}
	;
StartRegex
	: 		{self state: #scanner}
	;
EndRegex
	: 		{self state: #default}
	;
Symbol 
	: <symbolname> 
			{'1' value asSymbol}
	;
Regex
	: RegexTerm 
			{'1'}
	| Regex ""|"" Regex 
			{'1' | '3'}
	| Regex RegexTerm 
			{'1' , '2'}
	;
RegexTerm
	: <character> 
			{SmaCCCharacterRENode characters: '1' value}
	| <directive>
			{SmaCCCharacterRENode characters: '1' value}
	| <anycharacter> 
			{SmaCCCharacterRENode characters: self allCharacters}
	| <backslashcharacter> 
			{self nodeFor: (ReadStream on: ('1' value copyFrom: 2 to: '1' value size))} 
	| ""("" Regex "")"" 
			{'2'}
	| <characterblock> 
			{self parseCharacterBlock: '1'}
	| <tokenname> 
			{(scannerDefinition tokenNamed: '1' value ifAbsentPut: [self generateImplicitToken: '1']) copy}
	| <symbolname> 
			{SmaCCSequenceRENode nodes: ('1' value asOrderedCollection collect: [:each | SmaCCCharacterRENode characters: (String with: each)])}
	| RegexTerm ""*""	
			{'1' repeat}
	| RegexTerm ""+"" 
			{'1' repeatForAtLeast: 1}
	| RegexTerm ""?"" 
			{'1' repeatFor: 0 to: 1}
	| RegexTerm <repeat> 
			{| readStream start stop | 
			readStream := ReadStream on: ('2' value copyFrom: 2 to: '2' value size - 1). 
			start := readStream upTo: $,. 
			stop := readStream upToEnd.
			'1' repeatFor: (start isEmpty ifTrue: [0] ifFalse: [start asNumber]) to: (stop isEmpty ifTrue: [(1 bitShift: 31)] ifFalse: [stop asNumber])}
	;
# Parser 
ProductionRule
	: <symbolname> 'symbolName' StartProduction <production> ParserRules 'rules' EndProduction <semicolon>
			{| symbol | 
			symbol := grammar nonTerminalSymbolNamed: symbolName value. 
			rules do: [:each | symbol addProduction: each]. 
			self createDefaultClassesForSymbol: symbolName value.
			symbol}
	;
StartProduction
	: 		{self state: #parser}
	;
EndProduction
	: 		{self state: #default}
	;
ParserRules
	: ParserRules ""|"" ParserRule 
			{'1' 
				add: '3'; 
				yourself}
	| ParserRule
	;
ParserRule 
	: Terms 'rhs' 
			{rhs}
	| Terms 'rhs' <code> 'code' 
			{self verifyCodeToken: code for: rhs} 
	| Terms 'rhs' <classLeft> <symbolname> 'className' <classRight>
			{self createClass: className value asSymbol for: rhs}
	| Terms 'rhs' <classLeft> <classRight>
			{self createDefaultClassFor: rhs}
	;
Terms 
	: 		{grammar newRHS}
	| Terms 'rhs' Term 'term'
			{rhs 
				add: term; 
				yourself}	
	| Terms 'rhs' Term 'term' <variablename> 'variableNameToken'
			{rhs 
				add: term; 
				nameLastItem: (variableNameToken value copyFrom: 2 to: variableNameToken value size - 1); 
				yourself}	
	;
Term
	: <keyword> 
			{grammar keywordTerminalNamed: '1' value}
	| <tokenname>
			{grammar
				findSymbolNamed: '1' value
				ifAbsentAdd: 
					[| node symbol |
					symbol := grammar newTerminalSymbolNamed: '1' value.
					(scannerDefinition includesTokenNamed: '1' value) 
						ifTrue: [symbol regularExpression: (scannerDefinition tokenNamed: '1' value)]
						ifFalse:
							[node := SmaCCGrammar implicitToken: '1' value.
							node notNil
								ifTrue: 
									[node addStates: scannerDefinition nonExcludeStates.
									symbol regularExpression: node]].
					symbol]}
	| <symbolname> 
			{grammar nonTerminalSymbolNamed: '1' value}
	| ""error"" 
			{grammar errorSymbol}
	;"!

scannerClass
	^SmaCCDefinitionScanner!

startingStateForFile
	^1! !
!SmaCCDefinitionParser class categoriesFor: #definitionComment!generated!public! !
!SmaCCDefinitionParser class categoriesFor: #scannerClass!generated-accessing!public! !
!SmaCCDefinitionParser class categoriesFor: #startingStateForFile!generated!public! !

SmaCCCreateNodeReduceCode guid: (GUID fromString: '{9FA76C1F-E04D-4B56-A41B-8E42F9BAE7C0}')!
SmaCCCreateNodeReduceCode comment: 'SmaCCCreateNodeReduceCode represents a reduce action that creates a parse node.

Instance Variables
	classDefinition	<SmaCCClassDefinition>	the parse node class to create
	index	<Integer>	index in the RHS of a symbol that returns parse node, if no symbol returns the parse node, then the index = 0'!
!SmaCCCreateNodeReduceCode categoriesForClass!Unclassified! !
!SmaCCCreateNodeReduceCode methodsFor!

= anObject
	^super = anObject and: [self classDefinition = anObject classDefinition and: [self index = anObject index]]!

basicModelTypes: aSet
	^Array with: self classDefinition modelClass!

classDefinition
	classDefinition isNil ifTrue: [classDefinition := rhs nodeClassDefinition ifNil: [rhs nodeType]].
	^classDefinition!

index
	^index ifNil: [index := rhs componentIndex]!

index: anInteger
	index := anInteger!

isPullUpAction
	^self index > 0!

nodeType: anIdentitySet
	^self classDefinition!

source
	^self isPullUpAction
		ifTrue: [self codeGenerator createNodeReduceAction: rhs pullUpFrom: self index]
		ifFalse: [self codeGenerator createNodeReduceAction: rhs]! !
!SmaCCCreateNodeReduceCode categoriesFor: #=!comparing!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #classDefinition!accessing!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #index!accessing!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #index:!initialize-release!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #isPullUpAction!private!testing! !
!SmaCCCreateNodeReduceCode categoriesFor: #nodeType:!accessing-types!private! !
!SmaCCCreateNodeReduceCode categoriesFor: #source!accessing!private! !

SmaCCDefaultNodeReduceCode guid: (GUID fromString: '{24A98B09-5A4D-40D9-84EE-6AA59DBA17DE}')!
SmaCCDefaultNodeReduceCode comment: 'SmaCCDefaultNodeReduceCode represents a reduce action that returns an item in the rhs. It returns the first symbol that is a non-terminal. If all symbols are terminals, then it returns the first terminal symbol. If there aren''t any symbols, then it returns nil.

Instance Variables
	index	<Integer>	the index in the rhs to return; if 0 then return nil
'!
!SmaCCDefaultNodeReduceCode categoriesForClass!Unclassified! !
!SmaCCDefaultNodeReduceCode methodsFor!

= anObject
	^super = anObject and: [self index = anObject index]!

basicModelTypes: aSet
	^self index = 0
		ifTrue: [Array with: (self model classFor: nil class)]
		ifFalse: [self basicModelTypes: aSet forIndex: self index]!

index
	index isNil
		ifTrue:
			[rhs size
				to: 1
				by: -1
				do: [:i | (rhs at: i) isTerminal ifFalse: [index := i]].
			index isNil ifTrue: [index := 1 min: rhs size].
			(rhs size = index and: [index <= 1]) ifFalse: [self signalNodeCreationWarning]].
	^index!

modelTypes: anIdentitySet
	"Yes, I know it is a hack"

	IsCaching ifTrue: [^self basicModelTypes: anIdentitySet].
	IsCaching := true.
	^[super modelTypes: anIdentitySet] ensure: [IsCaching := false]!

returnedNodeIndex
	self index = 0 ifTrue: [^nil].
	^self index!

signalNodeCreationWarning
	| stream |
	stream := WriteStream on: String new.
	stream
		nextPutAll: 'Unable to determine what should be returned from the production. ';
		nextPutAll: (index > 0 ifTrue: ['A default item has been chosen, and all other '] ifFalse: ['All ']);
		nextPutAll: 'values will be dropped from the AST:';
		cr;
		cr;
		nextPutAll: rhs productionSymbol name;
		nextPutAll: ' : '.
	1
		to: rhs size
		do:
			[:i | 
			i == index ifTrue: [stream nextPutAll: '>>>'].
			stream nextPutAll: (rhs at: i) name.
			i == index ifTrue: [stream nextPutAll: '<<<'].
			stream space].
	SmaCCCompilationNotification signal: 'Node creation' with: stream contents!

source
	^self codeGenerator defaultNodeReductionSource: self! !
!SmaCCDefaultNodeReduceCode categoriesFor: #=!comparing!private! !
!SmaCCDefaultNodeReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCDefaultNodeReduceCode categoriesFor: #index!accessing!private! !
!SmaCCDefaultNodeReduceCode categoriesFor: #modelTypes:!public! !
!SmaCCDefaultNodeReduceCode categoriesFor: #returnedNodeIndex!private! !
!SmaCCDefaultNodeReduceCode categoriesFor: #signalNodeCreationWarning!accessing!private! !
!SmaCCDefaultNodeReduceCode categoriesFor: #source!accessing!private! !

!SmaCCDefaultNodeReduceCode class methodsFor!

initialize
	IsCaching := false! !
!SmaCCDefaultNodeReduceCode class categoriesFor: #initialize!class initialization!public! !

SmaCCDefaultReduceCode guid: (GUID fromString: '{FD229395-25C6-4E9B-9C41-071829CB9118}')!
SmaCCDefaultReduceCode comment: 'SmaCCDefaultReduceCode represents a reduce action that returns a collection of all items in the rhs.'!
!SmaCCDefaultReduceCode categoriesForClass!Unclassified! !
!SmaCCDefaultReduceCode methodsFor!

basicModelTypes: aSet
	^Array with: (self model classFor: OrderedCollection)!

hasReduceAction
	^false!

source
	^self codeGenerator defaultReductionSource! !
!SmaCCDefaultReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCDefaultReduceCode categoriesFor: #hasReduceAction!private!testing! !
!SmaCCDefaultReduceCode categoriesFor: #source!accessing!private! !

SmaCCSingleVariableReduceCode guid: (GUID fromString: '{8B0E361D-6EDC-4410-AE3A-BADAFD3B7E62}')!
SmaCCSingleVariableReduceCode comment: ''!
!SmaCCSingleVariableReduceCode categoriesForClass!Unclassified! !
!SmaCCSingleVariableReduceCode methodsFor!

basicModelTypes: aSet
	| types isCollection |
	isCollection := false.
	types := Set new.
	self indices size <= 1
		ifTrue:
			[rhs productionSymbol
				productionsDo:
					[:each | 
					(isCollection := isCollection or: [each reduceAction indices size > 1])
						ifFalse:
							[each reduceAction indices notEmpty ifTrue: [types addAll: (each reduceAction basicModelTypes: aSet forIndex: each reduceAction indices first)]]]]
		ifFalse: [isCollection := true].
	^isCollection ifTrue: [Array with: (self model classFor: OrderedCollection)] ifFalse: [types asArray]!

computeIndices
	indices := OrderedCollection new.
	1
		to: rhs size
		do:
			[:i | 
			| symbol |
			symbol := rhs at: i.
			(rhs variableNameForIndex: i) notNil ifTrue: [indices add: i] ifFalse: [symbol returnsSingleVariable ifTrue: [indices add: i]]].
	^indices!

index
	^indices isEmpty ifTrue: [0] ifFalse: [indices first]!

indices
	^indices ifNil: [self computeIndices]!

returnsSingleVariable
	^true!

source
	^(indices size < 2
		and: [rhs productionSymbol variableDefinitions asArray first isCollection not])
			ifTrue: [self codeGenerator defaultNodeReductionSource: self]
			ifFalse: [self codeGenerator singleVariableCollectionFor: self]! !
!SmaCCSingleVariableReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCSingleVariableReduceCode categoriesFor: #computeIndices!private! !
!SmaCCSingleVariableReduceCode categoriesFor: #index!accessing!public! !
!SmaCCSingleVariableReduceCode categoriesFor: #indices!accessing!public! !
!SmaCCSingleVariableReduceCode categoriesFor: #returnsSingleVariable!public!testing! !
!SmaCCSingleVariableReduceCode categoriesFor: #source!accessing!public! !

SmaCCSourceReduceCode guid: (GUID fromString: '{1878F4B4-576A-498B-A412-D5B06328741F}')!
SmaCCSourceReduceCode comment: 'SmaCCSourceReduceCode represents a reduce action that is specified in the grammar. In this case, it outputs the code directly into the parser.

Instance Variables
	source	<String>	the source to output

'!
!SmaCCSourceReduceCode categoriesForClass!Unclassified! !
!SmaCCSourceReduceCode methodsFor!

= anObject
	^super = anObject and: [self source = anObject source]!

basicModelTypes: aSet
	| index parseTree |
	index := self returnedNodeIndex.
	index notNil ifTrue: [^self basicModelTypes: aSet forIndex: index].
	parseTree := SmalltalkParser parseExpression: self source onError: [:e :p | ^Array with: (self model classFor: Object)].
	^self typesForTree: parseTree!

source
	^source!

source: aString
	source := aString!

typesForTree: aRBProgramNode
	aRBProgramNode isReturn ifTrue: [^self typesForTree: aRBProgramNode value].
	(aRBProgramNode isSequence and: [aRBProgramNode statements notEmpty])
		ifTrue:
			[| types |
			types := Set withAll: (self typesForTree: aRBProgramNode statements last).
			aRBProgramNode nodesDo: [:each | each isReturn ifTrue: [types addAll: (self typesForTree: each value)]].
			^types asArray].
	aRBProgramNode isLiteralNode ifTrue: [^Array with: (self model classFor: aRBProgramNode value class)].
	(aRBProgramNode isMessage and: [aRBProgramNode receiver isVariable and: [aRBProgramNode receiver name = 'SmaCCToken']])
		ifTrue: [^Array with: (self model classFor: SmaCCToken)].
	^Array with: (self model classFor: Object)! !
!SmaCCSourceReduceCode categoriesFor: #=!comparing!private! !
!SmaCCSourceReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCSourceReduceCode categoriesFor: #source!accessing!private! !
!SmaCCSourceReduceCode categoriesFor: #source:!initialize-release!private! !
!SmaCCSourceReduceCode categoriesFor: #typesForTree:!private! !

!SmaCCSourceReduceCode class methodsFor!

onRHS: aSmaCCRHS source: aString
	^(self onRHS: aSmaCCRHS)
		source: aString;
		yourself! !
!SmaCCSourceReduceCode class categoriesFor: #onRHS:source:!instance creation!private! !

SmaCCVariableReduceCode guid: (GUID fromString: '{397A9FA3-5A5F-41A4-8C75-FC8CCA78F57E}')!
SmaCCVariableReduceCode comment: 'SmaCCVariableReduceCode represents a reduce action that returns a collection of objects that represent the variables defined by the rhs. When this is pulled up into a create node, it will use the variable collection to create the node.
'!
!SmaCCVariableReduceCode categoriesForClass!Unclassified! !
!SmaCCVariableReduceCode methodsFor!

basicModelTypes: aSet
	^Array with: (self model classFor: OrderedCollection)!

returnsVariableCollection
	^true!

source
	^self codeGenerator variableArrayAction: rhs! !
!SmaCCVariableReduceCode categoriesFor: #basicModelTypes:!private! !
!SmaCCVariableReduceCode categoriesFor: #returnsVariableCollection!public! !
!SmaCCVariableReduceCode categoriesFor: #source!accessing!private! !

SmaCCCharacterRENode guid: (GUID fromString: '{A9CBA0E6-1120-4711-A7AD-68C2DC51F4C2}')!
SmaCCCharacterRENode comment: 'SmaCCCharacterRENode is a SmaCCRegularExpressionNode that matches a character.

Instance Variables:
	characters	<String>	the characters we accept
	ignoreCase	<Boolean>	should we ignore case when accepting the characters

'!
!SmaCCCharacterRENode categoriesForClass!Unclassified! !
!SmaCCCharacterRENode methodsFor!

| aSmaCCRegularExpressionNode
	| newCharacters |
	(self canMergeWith: aSmaCCRegularExpressionNode) ifFalse: [^super | aSmaCCRegularExpressionNode].
	newCharacters := (characters , aSmaCCRegularExpressionNode characters) asSet.
	self assignCharacters: newCharacters.
	^self!

asNFAStartingWith: aSmaCCNode
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	startNode addEdgeTo: endNode onCharacters: characters.
	^endNode!

assignCharacters: newCharacters
	| sortedCharacters stream |
	sortedCharacters := newCharacters asSortedCollection: [:a :b | a asInteger < b asInteger].
	stream := WriteStream with: String new.
	sortedCharacters
		inject: nil
		into:
			[:sum :each | 
			(sum = each or: [each asInteger > SmaCCGrammar maximumCharacterValue]) ifFalse: [stream nextPut: each].
			each].
	characters := stream contents!

canMergeWith: aSmaCCRegularExpressionNode
	^self class = aSmaCCRegularExpressionNode class
		and:
			[characters notNil
				and:
					[aSmaCCRegularExpressionNode characters notNil
						and: [self action = aSmaCCRegularExpressionNode action]]]!

characters
	^characters!

characters: aString
	characters := aString!

initialize
	super initialize.
	ignoreCase := false!

makeCaseInsensitive
	| newCharacters |
	ignoreCase := true.
	newCharacters := Set new.
	characters
		do:
			[:each | 
			newCharacters
				add: each asLowercase;
				add: each asUppercase].
	self assignCharacters: newCharacters!

matchingCharacters
	^ignoreCase ifTrue: [characters reject: [:each | each isLowercase]] ifFalse: [characters]!

possibleMatchesDo: aBlock on: aStream
	self matchingCharacters
		do:
			[:each | 
			aStream nextPut: each.
			aBlock value.
			aStream skip: -1]!

possibleMatchesSize
	^self matchingCharacters size!

printCharacter: aCharacter on: aStream
	(aCharacter asInteger between: 32 and: 126) ifTrue: [^aStream nextPut: aCharacter].
	aStream nextPutAll: '\x'.
	aCharacter asInteger
		printOn: aStream
		base: 16
		showRadix: false!

printOn: aStream
	| allCharacters |
	characters size = 1 ifTrue: [^self printCharacter: characters first on: aStream].
	aStream nextPut: $[.
	allCharacters := characters.
	characters size > 128
		ifTrue:
			[aStream nextPut: $^.
			allCharacters := ((0 to: SmaCCGrammar maximumCharacterValue)
				collect: [:each | Character value: each]) reject: [:each | characters includes: each]].
	allCharacters do: [:each | self printCharacter: each on: aStream].
	aStream nextPut: $]! !
!SmaCCCharacterRENode categoriesFor: #|!constructing!private! !
!SmaCCCharacterRENode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCCharacterRENode categoriesFor: #assignCharacters:!private! !
!SmaCCCharacterRENode categoriesFor: #canMergeWith:!private!testing! !
!SmaCCCharacterRENode categoriesFor: #characters!accessing!private! !
!SmaCCCharacterRENode categoriesFor: #characters:!initialize-release!private! !
!SmaCCCharacterRENode categoriesFor: #initialize!initialize-release!private! !
!SmaCCCharacterRENode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCCharacterRENode categoriesFor: #matchingCharacters!accessing!private! !
!SmaCCCharacterRENode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCCharacterRENode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCCharacterRENode categoriesFor: #printCharacter:on:!printing!private! !
!SmaCCCharacterRENode categoriesFor: #printOn:!printing!private! !

!SmaCCCharacterRENode class methodsFor!

characters: aString
	^(self new)
		assignCharacters: aString;
		yourself! !
!SmaCCCharacterRENode class categoriesFor: #characters:!instance creation!private! !

SmaCCNotRENode guid: (GUID fromString: '{B793BD3F-9A87-4887-830B-3E7937B8E551}')!
SmaCCNotRENode comment: 'SmaCCNotRENode is a SmaCCRegularExpressionNode that inverts another SmaCCRegularExpressionNode matches.

Instance Variables:
	node	<SmaCCRegularExpressionNode>	the node whose match is being inverted

'!
!SmaCCNotRENode categoriesForClass!Unclassified! !
!SmaCCNotRENode methodsFor!

asNFAStartingWith: aSmaCCNode
	^self characterNode asNFAStartingWith: aSmaCCNode!

characterNode
	^(SmaCCCharacterRENode characters: self characters)
		addStates: states;
		action: action;
		yourself!

characters
	^SmaCCGrammar allCharacters reject: [:each | node characters includes: each]!

makeCaseInsensitive
	node makeCaseInsensitive!

node: aSmaCCCharacterRENode
	node := aSmaCCCharacterRENode!

possibleMatchesDo: aBlock on: aStream
	self characterNode possibleMatchesDo: aBlock on: aStream!

possibleMatchesSize
	^self characterNode possibleMatchesSize!

printOn: aStream
	self characterNode printOn: aStream! !
!SmaCCNotRENode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCNotRENode categoriesFor: #characterNode!private! !
!SmaCCNotRENode categoriesFor: #characters!private! !
!SmaCCNotRENode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCNotRENode categoriesFor: #node:!initialize-release!private! !
!SmaCCNotRENode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCNotRENode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCNotRENode categoriesFor: #printOn:!printing!private! !

!SmaCCNotRENode class methodsFor!

on: aSmaCCCharacterRENode
	^(self new)
		node: aSmaCCCharacterRENode;
		yourself! !
!SmaCCNotRENode class categoriesFor: #on:!instance creation!private! !

SmaCCOrRENode guid: (GUID fromString: '{59229635-AA10-43B4-AE15-69653AEDAB56}')!
SmaCCOrRENode comment: 'SmaCCOrRENode is a SmaCCRegularExpressionNode that represents several possible regular expression choices. For example, we may have an SmaCCOrRENode that contains a character RE that matches letters when the state is #foo, and another character RE that matches whitespace when the state is #bar.

Instance Variables:
	nodes	<Collection of: SmaCCRegularExpressionNode>	all RE nodes that are being ORed together'!
!SmaCCOrRENode categoriesForClass!Unclassified! !
!SmaCCOrRENode methodsFor!

| aSmaCCRegularExpressionNode
	self action = aSmaCCRegularExpressionNode action ifFalse: [^super | aSmaCCRegularExpressionNode].
	nodes add: aSmaCCRegularExpressionNode.
	^self!

asNFAStartingWith: aSmaCCNode
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	nodes
		do:
			[:each | 
			| componentStart |
			componentStart := SmaCCNode new.
			startNode addEdgeTo: componentStart.
			(each asNFAStartingWith: componentStart) addEdgeTo: endNode].
	^endNode!

makeCaseInsensitive
	nodes do: [:each | each makeCaseInsensitive]!

nodes: aCollection
	nodes := aCollection!

possibleMatchesDo: aBlock on: aStream
	nodes
		do:
			[:each | 
			| pos |
			pos := aStream position.
			each possibleMatchesDo: aBlock on: aStream.
			aStream position: pos]!

possibleMatchesSize
	^nodes inject: 0 into: [:sum :each | sum + each possibleMatchesSize]!

postCopy
	super postCopy.
	nodes := nodes copy!

printOn: aStream
	aStream nextPut: $(.
	nodes do: [:each | each printOn: aStream] separatedBy: [aStream nextPutAll: ' | '].
	aStream nextPut: $)! !
!SmaCCOrRENode categoriesFor: #|!constructing!private! !
!SmaCCOrRENode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCOrRENode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCOrRENode categoriesFor: #nodes:!initialize-release!private! !
!SmaCCOrRENode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCOrRENode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCOrRENode categoriesFor: #postCopy!copying!private! !
!SmaCCOrRENode categoriesFor: #printOn:!printing!private! !

!SmaCCOrRENode class methodsFor!

nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !
!SmaCCOrRENode class categoriesFor: #nodes:!instance creation!private! !

SmaCCRepeatingRENode guid: (GUID fromString: '{98680728-23A3-47A0-9F69-3B332BC9E2DB}')!
SmaCCRepeatingRENode comment: 'SmaCCRepeatingRENode is a SmaCCRegularExpressionNode that matches a particular RE node multiple times.

Instance Variables:
	maximumMatches	<Integer>	the maximum amount of matches (or #finiteInfinity if we can repeat unlimited number of times)
	minimumMatches	<Integer>	the minimum amount of matches we must accept
	node	<SmaCCRegularExpressionNode>	the node we are matching'!
!SmaCCRepeatingRENode categoriesForClass!Unclassified! !
!SmaCCRepeatingRENode methodsFor!

asNFAStartingWith: aSmaCCNode
	| endNode start |
	start := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	minimumMatches timesRepeat: [start := node asNFAStartingWith: start].
	start addEdgeTo: endNode.
	maximumMatches < self class finiteInfinity
		ifTrue:
			[maximumMatches - minimumMatches
				timesRepeat:
					[start := node asNFAStartingWith: start.
					start addEdgeTo: endNode]]
		ifFalse: [(node asNFAStartingWith: start) addEdgeTo: start].
	^endNode!

component: aSmaCCRegularExpressionNode minimum: minInteger maximum: maxInteger
	node := aSmaCCRegularExpressionNode.
	minimumMatches := minInteger.
	maximumMatches := maxInteger!

makeCaseInsensitive
	node makeCaseInsensitive!

possibleMatchesDo: aBlock on: aStream
	self
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 0!

possibleMatchesDo: aBlock on: aStream startingAt: anInteger
	(anInteger between: minimumMatches and: maximumMatches) ifTrue: [aBlock value].
	anInteger < maximumMatches
		ifTrue:
			[node
				possibleMatchesDo:
					[self
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]!

possibleMatchesSize
	"This does not return the exact number for expressions with over 50 potential matches since we don't need that detail and computing the exact value may be expensive."

	| baseSize |
	baseSize := node possibleMatchesSize.
	baseSize = 1 ifTrue: [^node possibleMatchesSize * (maximumMatches - minimumMatches + 1)].
	maximumMatches >= 6 ifTrue: [^SmallInteger maximum].
	^(minimumMatches to: maximumMatches) inject: 0 into: [:sum :each | sum + (baseSize raisedTo: each)]!

printOn: aStream
	aStream nextPut: $(.
	node printOn: aStream.
	aStream nextPut: $).
	maximumMatches = (1 bitShift: 31)
		ifTrue:
			[minimumMatches = 0 ifTrue: [^aStream nextPut: $*].
			minimumMatches = 1 ifTrue: [^aStream nextPut: $+].
			^aStream
				nextPut: ${;
				nextPutAll: minimumMatches printString;
				nextPutAll: ',}'].
	aStream
		nextPut: ${;
		nextPutAll: minimumMatches printString;
		nextPut: $,;
		nextPutAll: maximumMatches printString;
		nextPut: $}! !
!SmaCCRepeatingRENode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCRepeatingRENode categoriesFor: #component:minimum:maximum:!initialize-release!private! !
!SmaCCRepeatingRENode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCRepeatingRENode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCRepeatingRENode categoriesFor: #possibleMatchesDo:on:startingAt:!private! !
!SmaCCRepeatingRENode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCRepeatingRENode categoriesFor: #printOn:!printing!private! !

!SmaCCRepeatingRENode class methodsFor!

component: aSmaCCRegularExpressionNode 
	^self component: aSmaCCRegularExpressionNode minimum: 0!

component: aSmaCCRegularExpressionNode minimum: anInteger 
	^self 
		component: aSmaCCRegularExpressionNode
		minimum: anInteger
		maximum: self finiteInfinity!

component: aSmaCCRegularExpressionNode minimum: minInteger maximum: maxInteger 
	^(self new)
		component: aSmaCCRegularExpressionNode
			minimum: minInteger
			maximum: maxInteger;
		yourself!

finiteInfinity
	"The number that we consider to be 'infinite'"

	^2147483648! !
!SmaCCRepeatingRENode class categoriesFor: #component:!instance creation!private! !
!SmaCCRepeatingRENode class categoriesFor: #component:minimum:!instance creation!private! !
!SmaCCRepeatingRENode class categoriesFor: #component:minimum:maximum:!instance creation!private! !
!SmaCCRepeatingRENode class categoriesFor: #finiteInfinity!constants!private! !

SmaCCSequenceRENode guid: (GUID fromString: '{B3396C67-0307-4667-8564-3AD34EC388F9}')!
SmaCCSequenceRENode comment: 'SmaCCSequenceRENode is a SmaCCRegularExpressionNode that matches a sequence of other RE nodes.

Instance Variables:
	nodes	<SequenceableCollection of: SmaCCRegularExpressionNode>	an ordered list of nodes to match

'!
!SmaCCSequenceRENode categoriesForClass!Unclassified! !
!SmaCCSequenceRENode methodsFor!

, aSmaCCRegularExpressionNode
	self action = aSmaCCRegularExpressionNode action ifFalse: [^super , aSmaCCRegularExpressionNode].
	nodes add: aSmaCCRegularExpressionNode.
	^self!

asNFAStartingWith: aSmaCCNode
	| endNode startNode |
	startNode := self addStateTransitionsTo: aSmaCCNode.
	endNode := SmaCCNode new.
	endNode action: action.
	(nodes inject: startNode into: [:sum :each | each asNFAStartingWith: sum]) addEdgeTo: endNode.
	^endNode!

makeCaseInsensitive
	nodes do: [:each | each makeCaseInsensitive]!

nodes: aCollection
	nodes := aCollection!

possibleMatchesDo: aBlock on: aStream
	self
		possibleMatchesDo: aBlock
		on: aStream
		startingAt: 1!

possibleMatchesDo: aBlock on: aStream startingAt: anInteger
	| node |
	node := nodes at: anInteger.
	nodes size = anInteger
		ifTrue: [node possibleMatchesDo: aBlock on: aStream]
		ifFalse:
			[node
				possibleMatchesDo:
					[self
						possibleMatchesDo: aBlock
						on: aStream
						startingAt: anInteger + 1]
				on: aStream]!

possibleMatchesSize
	^nodes inject: 1 into: [:sum :each | sum * each possibleMatchesSize]!

postCopy
	super postCopy.
	nodes := nodes copy!

printOn: aStream
	nodes do: [:each | each printOn: aStream] separatedBy: [aStream space]! !
!SmaCCSequenceRENode categoriesFor: #,!constructing!private! !
!SmaCCSequenceRENode categoriesFor: #asNFAStartingWith:!private! !
!SmaCCSequenceRENode categoriesFor: #makeCaseInsensitive!constructing!private! !
!SmaCCSequenceRENode categoriesFor: #nodes:!initialize-release!private! !
!SmaCCSequenceRENode categoriesFor: #possibleMatchesDo:on:!private! !
!SmaCCSequenceRENode categoriesFor: #possibleMatchesDo:on:startingAt:!private! !
!SmaCCSequenceRENode categoriesFor: #possibleMatchesSize!accessing!private! !
!SmaCCSequenceRENode categoriesFor: #postCopy!copying!private! !
!SmaCCSequenceRENode categoriesFor: #printOn:!printing!private! !

!SmaCCSequenceRENode class methodsFor!

nodes: aCollection 
	^(self new)
		nodes: aCollection;
		yourself! !
!SmaCCSequenceRENode class categoriesFor: #nodes:!instance creation!private! !

SmaCCDefinitionScanner guid: (GUID fromString: '{3F4247F6-B732-4CBB-9E92-74AB3F586397}')!
SmaCCDefinitionScanner comment: 'SmaCCDefinitionScanner is the SmaCCScanner for the parser definition.

Instance Variables:
	parseSourceSelector	<Symbol>	a symbol that can be performed to parse the code inside the {} reduce actions

'!
!SmaCCDefinitionScanner categoriesForClass!Unclassified! !
!SmaCCDefinitionScanner methodsFor!

canParse: aString
	^self perform: parseSourceSelector with: aString!

canParseSmalltalk: aString
	SmalltalkParser parseExpression: aString onError: [:error :pos | ^false].
	^true!

classLeftId
	^39!

classRightId
	^40!

code
	| code |
	code := ''.
	[code := code , (stream upTo: $}).
	self canParse: code]
		whileFalse:
			[stream atEnd ifTrue: [^self scannerError].
			code := code , '}'].
	matchActions := Array with: self codeId.
	^self createTokenFor: '{' , code , '}'!

codeId
	^29!

directiveId
	^32!

emptySymbolTokenId
	^84!

errorTokenId
	^85!

initialize
	super initialize.
	parseSourceSelector := #canParseSmalltalk:!

keywordId
	^27!

parseSourceSelector: aSymbol 
	parseSourceSelector := aSymbol!

productionId
	^31!

scan1
	[self step.
	currentCharacter == $" ifTrue: [^self scan2]] repeat!

scan10
	[self step.
	currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(25)].
	currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue.
	^self reportLastMatch!

scan11
	self recordMatch: #(26).
	self step.
	currentCharacter == $r ifTrue: [^self scan12].
	(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
		ifTrue:
			[[self recordMatch: #(26).
			self step.
			currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
	^self reportLastMatch!

scan12
	self recordMatch: #(26).
	(self scanForString: 'ror')
		ifTrue:
			[self recordMatch: #(7 26).
			self step].
	(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
		ifTrue:
			[[self recordMatch: #(26).
			self step.
			currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
	^self reportLastMatch!

scan13
	[self step.
	currentCharacter == $\ ifTrue: [^self scan14].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(35)]] repeat!

scan14
	self step.
	currentCharacter == $c
		ifTrue:
			[self step.
			(currentCharacter between: $A and: $Z) ifTrue: [^self scan13].
			^self reportLastMatch].
	currentCharacter == $x
		ifTrue:
			[self step.
			(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifTrue: [^self scan13].
			^self reportLastMatch].
	^self scan13!

scan15
	[self step.
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(36)].
	currentCharacter isDigit] whileTrue.
	^self reportLastMatch!

scan2
	self recordMatch: #(27).
	self step.
	currentCharacter == $" ifTrue: [^self scan1].
	^self reportLastMatch!

scan3
	self step.
	(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan4].
	^self reportLastMatch!

scan4
	[self step.
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(30)].
	currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue.
	^self reportLastMatch!

scan5
	self step.
	currentCharacter == $* ifTrue: [^self scan6].
	^self reportLastMatch!

scan6
	[self step.
	currentCharacter == $*
		ifTrue:
			[[self step.
			currentCharacter == $*] whileTrue.
			currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(28)].
			^self scan6]] repeat!

scan7
	self recordMatch: #(31).
	self step.
	currentCharacter == $: ifTrue: [^self scan8].
	^self reportLastMatch!

scan8
	self step.
	currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(31)].
	^self reportLastMatch!

scan9
	self step.
	(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan10].
	^self reportLastMatch!

scanForToken
	state == #scanner
		ifTrue:
			[self step.
			currentCharacter == ##(Character value: 12)
				ifTrue:
					[self recordMatch: #(24 37).
					self step.
					currentCharacter isWhitespace
						ifTrue:
							[[self recordMatch: #(24).
							self step.
							currentCharacter isWhitespace] whileTrue].
					^self reportLastMatch].
			currentCharacter == $"
				ifTrue:
					[self recordMatch: #(37).
					self step.
					currentCharacter == $" ifTrue: [^self scan2].
					^self scan1].
			currentCharacter == $#
				ifTrue:
					[self recordMatch: #(28 37).
					self step.
					(currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]])
						ifTrue:
							[[self recordMatch: #(28).
							self step.
							currentCharacter <= ##(Character value: 9)
								or:
									[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
										or: [currentCharacter >= ##(Character value: 14)]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(32 37)].
			currentCharacter == $'
				ifTrue:
					[self recordMatch: #(37).
					self step.
					(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan4].
					^self reportLastMatch].
			currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(6 37)].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(3 37)].
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(4 37)].
			currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(38)].
			currentCharacter == $/
				ifTrue:
					[self recordMatch: #(37).
					self step.
					currentCharacter == $* ifTrue: [^self scan6].
					^self reportLastMatch].
			currentCharacter == $:
				ifTrue:
					[self recordMatch: #(31 37).
					self step.
					currentCharacter == $: ifTrue: [^self scan8].
					^self reportLastMatch].
			currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(33 37)].
			currentCharacter == $<
				ifTrue:
					[self recordMatch: #(37).
					self step.
					(currentCharacter isLetter or: [currentCharacter == $_]) ifTrue: [^self scan10].
					^self reportLastMatch].
			currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(5 37)].
			currentCharacter == $[
				ifTrue:
					[self step.
					currentCharacter == $\ ifTrue: [^self scan14].
					(currentCharacter <= $[ or: [currentCharacter >= $^]) ifTrue: [^self scan13].
					^self reportLastMatch].
			currentCharacter == $\
				ifTrue:
					[self step.
					currentCharacter == $c
						ifTrue:
							[self step.
							(currentCharacter between: $A and: $Z) ifTrue: [^self recordAndReportMatch: #(34)].
							^self reportLastMatch].
					currentCharacter == $x
						ifTrue:
							[self step.
							(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
								ifTrue:
									[3
										timesRepeat:
											[self recordMatch: #(34).
											self step.
											(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
									^self recordAndReportMatch: #(34)].
							^self reportLastMatch].
					^self recordAndReportMatch: #(34)].
			currentCharacter == $e
				ifTrue:
					[self recordMatch: #(26 37).
					self step.
					currentCharacter == $r ifTrue: [^self scan12].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == ${
				ifTrue:
					[self recordMatch: #(29).
					self step.
					currentCharacter == $, ifTrue: [^self scan15].
					currentCharacter isDigit
						ifTrue:
							[[self step.
							currentCharacter == $, ifTrue: [^self scan15].
							currentCharacter isDigit] whileTrue].
					^self reportLastMatch].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(1 37)].
			currentCharacter isWhitespace
				ifTrue:
					[[self recordMatch: #(24).
					self step.
					currentCharacter isWhitespace] whileTrue.
					^self reportLastMatch].
			(currentCharacter isLetter or: [currentCharacter == $_])
				ifTrue:
					[self recordMatch: #(26 37).
					self step.
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			^self recordAndReportMatch: #(37)].
	state == #parser
		ifTrue:
			[self step.
			currentCharacter == $" ifTrue: [^self scan1].
			currentCharacter == $#
				ifTrue:
					[[self recordMatch: #(28).
					self step.
					currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
					^self reportLastMatch].
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(32)].
			currentCharacter == $' ifTrue: [^self scan3].
			currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(6)].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(3)].
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(4)].
			currentCharacter == $/ ifTrue: [^self scan5].
			currentCharacter == $: ifTrue: [^self scan7].
			currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(33)].
			currentCharacter == $< ifTrue: [^self scan9].
			currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(5)].
			currentCharacter == $e ifTrue: [^self scan11].
			currentCharacter == ${
				ifTrue:
					[self recordMatch: #(29).
					self step.
					currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(39)].
					^self reportLastMatch].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(1)].
			currentCharacter == $}
				ifTrue:
					[self step.
					currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(40)].
					^self reportLastMatch].
			currentCharacter isWhitespace
				ifTrue:
					[[self recordMatch: #(24).
					self step.
					currentCharacter isWhitespace] whileTrue.
					^self reportLastMatch].
			(currentCharacter isLetter or: [currentCharacter == $_])
				ifTrue:
					[[self recordMatch: #(26).
					self step.
					currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
			^self reportLastMatch].
	state == #directives
		ifTrue:
			[self step.
			currentCharacter == $" ifTrue: [^self scan1].
			currentCharacter == $#
				ifTrue:
					[[self recordMatch: #(28).
					self step.
					currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
					^self reportLastMatch].
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(32)].
			currentCharacter == $' ifTrue: [^self scan3].
			currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(6)].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(3)].
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(4)].
			currentCharacter == $/ ifTrue: [^self scan5].
			currentCharacter == $: ifTrue: [^self scan7].
			currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(33)].
			currentCharacter == $< ifTrue: [^self scan9].
			currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(5)].
			currentCharacter == $a
				ifTrue:
					[self recordMatch: #(26).
					self step.
					currentCharacter == $n
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'notate')
								ifTrue:
									[self recordMatch: #(26).
									self step.
									currentCharacter == $_
										ifTrue:
											[self recordMatch: #(26).
											(self scanForString: 'tokens')
												ifTrue:
													[self recordMatch: #(23 26).
													self step].
											(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
												ifTrue:
													[[self recordMatch: #(26).
													self step.
													currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
											^self reportLastMatch].
									(currentCharacter isLetter or: [currentCharacter isHexDigit])
										ifTrue:
											[[self recordMatch: #(26).
											self step.
											currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
									^self reportLastMatch].
							(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
								ifTrue:
									[[self recordMatch: #(26).
									self step.
									currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
							^self reportLastMatch].
					currentCharacter == $t
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'tributes')
								ifTrue:
									[self recordMatch: #(12 26).
									self step]].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $e
				ifTrue:
					[self recordMatch: #(26).
					self step.
					currentCharacter == $r ifTrue: [^self scan12].
					currentCharacter == $x
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'cludes')
								ifTrue:
									[self recordMatch: #(9 26).
									self step]].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $g
				ifTrue:
					[self recordMatch: #(26).
					(self scanForString: 'lr')
						ifTrue:
							[self recordMatch: #(20 26).
							self step].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $h
				ifTrue:
					[self recordMatch: #(26).
					(self scanForString: 'ierarchy')
						ifTrue:
							[self recordMatch: #(11 26).
							self step].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $i
				ifTrue:
					[self recordMatch: #(26).
					self step.
					currentCharacter == $d
						ifTrue:
							[self recordMatch: #(18 26).
							self step.
							(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
								ifTrue:
									[[self recordMatch: #(26).
									self step.
									currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
							^self reportLastMatch].
					currentCharacter == $g
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'nore')
								ifTrue:
									[self recordMatch: #(26).
									self step.
									currentCharacter == $_
										ifTrue:
											[self recordMatch: #(26).
											(self scanForString: 'variables')
												ifTrue:
													[self recordMatch: #(22 26).
													self step].
											(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
												ifTrue:
													[[self recordMatch: #(26).
													self step.
													currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
											^self reportLastMatch].
									currentCharacter == $c
										ifTrue:
											[self recordMatch: #(26).
											(self scanForString: 'ase')
												ifTrue:
													[self recordMatch: #(21 26).
													self step].
											(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
												ifTrue:
													[[self recordMatch: #(26).
													self step.
													currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
											^self reportLastMatch].
									(currentCharacter isLetter or: [currentCharacter isHexDigit])
										ifTrue:
											[[self recordMatch: #(26).
											self step.
											currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
									^self reportLastMatch]].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $l
				ifTrue:
					[self recordMatch: #(26).
					(self scanForString: 'eft')
						ifTrue:
							[self recordMatch: #(15 26).
							self step].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $n
				ifTrue:
					[self recordMatch: #(26).
					(self scanForString: 'onassoc')
						ifTrue:
							[self recordMatch: #(17 26).
							self step].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $p
				ifTrue:
					[self recordMatch: #(26).
					(self scanForString: 'refix')
						ifTrue:
							[self recordMatch: #(13 26).
							self step].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $r
				ifTrue:
					[self recordMatch: #(26).
					self step.
					currentCharacter == $i
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'ght')
								ifTrue:
									[self recordMatch: #(16 26).
									self step].
							(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
								ifTrue:
									[[self recordMatch: #(26).
									self step.
									currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
							^self reportLastMatch].
					currentCharacter == $o
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'ot')
								ifTrue:
									[self recordMatch: #(10 26).
									self step]].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == $s
				ifTrue:
					[self recordMatch: #(26).
					self step.
					currentCharacter == $t
						ifTrue:
							[self recordMatch: #(26).
							self step.
							currentCharacter == $a
								ifTrue:
									[self recordMatch: #(26).
									self step.
									currentCharacter == $r
										ifTrue:
											[self recordMatch: #(26).
											self step.
											currentCharacter == $t
												ifTrue:
													[self recordMatch: #(19 26).
													self step].
											(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
												ifTrue:
													[[self recordMatch: #(26).
													self step.
													currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
											^self reportLastMatch].
									currentCharacter == $t
										ifTrue:
											[self recordMatch: #(26).
											(self scanForString: 'es')
												ifTrue:
													[self recordMatch: #(8 26).
													self step]]].
							(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
								ifTrue:
									[[self recordMatch: #(26).
									self step.
									currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
							^self reportLastMatch].
					currentCharacter == $u
						ifTrue:
							[self recordMatch: #(26).
							(self scanForString: 'ffix')
								ifTrue:
									[self recordMatch: #(14 26).
									self step]].
					(currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]])
						ifTrue:
							[[self recordMatch: #(26).
							self step.
							currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
					^self reportLastMatch].
			currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(29)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(1)].
			currentCharacter isWhitespace
				ifTrue:
					[[self recordMatch: #(24).
					self step.
					currentCharacter isWhitespace] whileTrue.
					^self reportLastMatch].
			(currentCharacter isLetter or: [currentCharacter == $_])
				ifTrue:
					[[self recordMatch: #(26).
					self step.
					currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue].
			^self reportLastMatch].
	state == #default
		ifTrue:
			[self step.
			currentCharacter == $" ifTrue: [^self scan1].
			currentCharacter == $#
				ifTrue:
					[[self recordMatch: #(28).
					self step.
					currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
					^self reportLastMatch].
			currentCharacter == $% ifTrue: [^self recordAndReportMatch: #(32)].
			currentCharacter == $' ifTrue: [^self scan3].
			currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(6)].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(3)].
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(4)].
			currentCharacter == $/ ifTrue: [^self scan5].
			currentCharacter == $: ifTrue: [^self scan7].
			currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(33)].
			currentCharacter == $< ifTrue: [^self scan9].
			currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(5)].
			currentCharacter == $e ifTrue: [^self scan11].
			currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(29)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(1)].
			currentCharacter isWhitespace
				ifTrue:
					[[self recordMatch: #(24).
					self step.
					currentCharacter isWhitespace] whileTrue.
					^self reportLastMatch].
			(currentCharacter isLetter or: [currentCharacter == $_])
				ifTrue:
					[[self recordMatch: #(26).
					self step.
					currentCharacter isLetter or: [currentCharacter isHexDigit or: [currentCharacter == $_]]] whileTrue]].
	^self reportLastMatch!

semicolonId
	^33!

symbolnameId
	^26!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #whitespace nil nil nil #comment #code)!

tokennameId
	^25!

variablenameId
	^30! !
!SmaCCDefinitionScanner categoriesFor: #canParse:!private!testing! !
!SmaCCDefinitionScanner categoriesFor: #canParseSmalltalk:!public!testing! !
!SmaCCDefinitionScanner categoriesFor: #classLeftId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #classRightId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #code!private!token-actions! !
!SmaCCDefinitionScanner categoriesFor: #codeId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #directiveId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #errorTokenId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #initialize!initialize-release!private! !
!SmaCCDefinitionScanner categoriesFor: #keywordId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #parseSourceSelector:!initialize-release!private! !
!SmaCCDefinitionScanner categoriesFor: #productionId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan1!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan10!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan11!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan12!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan13!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan14!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan15!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan2!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan3!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan4!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan5!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan6!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan7!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan8!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scan9!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #scanForToken!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #semicolonId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #symbolnameId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #tokenActions!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #tokennameId!generated!public! !
!SmaCCDefinitionScanner categoriesFor: #variablenameId!generated!public! !

!SmaCCDefinitionScanner class methodsFor!

needsLineNumbers
	"Redefine to return true, if you need line number information"

	^true! !
!SmaCCDefinitionScanner class categoriesFor: #needsLineNumbers!private!testing! !

"Binary Globals"!

