| package |
package := Package name: 'SmaCC Java'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains code to parse Java code.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #JavaAbstractMethodDeclarationNode;
	add: #JavaAnnotationInterfaceNode;
	add: #JavaAnnotationMethodDeclarationNode;
	add: #JavaAnnotationNode;
	add: #JavaArrayAccessNode;
	add: #JavaArrayInitializerNode;
	add: #JavaArrayMethodDeclaratorNode;
	add: #JavaArrayTypeNode;
	add: #JavaArrayVariableNameNode;
	add: #JavaAssertStatementNode;
	add: #JavaAssignmentNode;
	add: #JavaBinaryExpressionNode;
	add: #JavaBlockNode;
	add: #JavaBooleanLiteralNode;
	add: #JavaBooleanTypeNode;
	add: #JavaBreakStatementNode;
	add: #JavaByteTypeNode;
	add: #JavaCastExpressionNode;
	add: #JavaCatchClauseNode;
	add: #JavaCharacterLiteralNode;
	add: #JavaCharTypeNode;
	add: #JavaClassDeclarationNode;
	add: #JavaClassPropertyNode;
	add: #JavaClassTypeNode;
	add: #JavaConditionalExpressionNode;
	add: #JavaConstructorBodyNode;
	add: #JavaConstructorDeclarationNode;
	add: #JavaContinueStatementNode;
	add: #JavaDefaultLabelNode;
	add: #JavaDimensionExpressionNode;
	add: #JavaDoubleTypeNode;
	add: #JavaDoWhileStatementNode;
	add: #JavaElementArrayInitializerNode;
	add: #JavaElementValuePairNode;
	add: #JavaEmptyDeclarationNode;
	add: #JavaEmptyMethodBodyNode;
	add: #JavaEmptyStatementNode;
	add: #JavaEnumConstantNode;
	add: #JavaEnumDeclarationNode;
	add: #JavaExpressionNode;
	add: #JavaExpressionStatementNode;
	add: #JavaFieldAccessNode;
	add: #JavaFieldDeclarationNode;
	add: #JavaFinallyClauseNode;
	add: #JavaFloatLiteralNode;
	add: #JavaFloatTypeNode;
	add: #JavaForEachStatementNode;
	add: #JavaForStatementNode;
	add: #JavaIfElseStatementNode;
	add: #JavaIfStatementNode;
	add: #JavaInitializedVariableDeclarationNode;
	add: #JavaIntegerLiteralNode;
	add: #JavaInterfaceNode;
	add: #JavaIntTypeNode;
	add: #JavaLabeledStatementNode;
	add: #JavaLambdaExpressionNode;
	add: #JavaLiteralNode;
	add: #JavaLocalVariableDeclarationNode;
	add: #JavaLocalVariableDeclarationStatementNode;
	add: #JavaLongTypeNode;
	add: #JavaMethodDeclarationNode;
	add: #JavaMethodDeclaratorNode;
	add: #JavaMethodInvocationNode;
	add: #JavaModifierNode;
	add: #JavaNameNode;
	add: #JavaNewArrayNode;
	add: #JavaNewClassNode;
	add: #JavaNewNode;
	add: #JavaNullNode;
	add: #JavaPackageDeclarationNode;
	add: #JavaParameterNode;
	add: #JavaParser;
	add: #JavaPostDecrementExpressionNode;
	add: #JavaPostIncrementExpressionNode;
	add: #JavaPreDecrementExpressionNode;
	add: #JavaPreIncrementExpressionNode;
	add: #JavaPrimitiveTypeNode;
	add: #JavaProgramFileNode;
	add: #JavaProgramNode;
	add: #JavaProgramNodeVisitor;
	add: #JavaQualifiedNameNode;
	add: #JavaQualifiedTypeNameNode;
	add: #JavaReturnStatementNode;
	add: #JavaScanner;
	add: #JavaShortTypeNode;
	add: #JavaSingleTypeImportDeclarationNode;
	add: #JavaStatementExpressionListNode;
	add: #JavaStatementNode;
	add: #JavaStaticInitializerNode;
	add: #JavaStringLiteralNode;
	add: #JavaSuperConstructorInvocationNode;
	add: #JavaSwitchBlockNode;
	add: #JavaSwitchBlockStatementGroupNode;
	add: #JavaSwitchLabelNode;
	add: #JavaSwitchStatementNode;
	add: #JavaSynchronizedStatementNode;
	add: #JavaThisConstructorInvocationNode;
	add: #JavaThrowsNode;
	add: #JavaThrowStatementNode;
	add: #JavaTryStatementNode;
	add: #JavaTypeArgumentNode;
	add: #JavaTypeImportOnDemandDeclarationNode;
	add: #JavaTypeNameNode;
	add: #JavaTypeNode;
	add: #JavaTypeParameterNode;
	add: #JavaTypeParametersNode;
	add: #JavaUnaryAdditionNode;
	add: #JavaUnaryBitInvertNode;
	add: #JavaUnaryNotNode;
	add: #JavaUnarySubtractionNode;
	add: #JavaVariableArgumentParameterNode;
	add: #JavaVariableDeclarationNode;
	add: #JavaVariableNameNode;
	add: #JavaVoidTypeNode;
	add: #JavaWhileStatementNode;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\SmaCC GLR Runtime\SmaCC GLR Runtime';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	yourself).

package!

"Class Definitions"!

SmaCCParseNode subclass: #JavaProgramNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaAbstractMethodDeclarationNode
	instanceVariableNames: 'modifiers typeParameters type declarator throws semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaAnnotationInterfaceNode
	instanceVariableNames: 'modifiers atToken interfaceToken name left declarations right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaAnnotationNode
	instanceVariableNames: '_at name left values commas right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaArrayInitializerNode
	instanceVariableNames: 'left initializers commas right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaArrayMethodDeclaratorNode
	instanceVariableNames: 'declarator left right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaArrayVariableNameNode
	instanceVariableNames: 'variable left right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaCatchClauseNode
	instanceVariableNames: 'catchToken left parameter right block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaClassDeclarationNode
	instanceVariableNames: 'modifiers classToken name typeParameters extendsToken superclass implementsToken interfaces commas left declarations right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaConstructorBodyNode
	instanceVariableNames: 'left constructorInvocation statements right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaConstructorDeclarationNode
	instanceVariableNames: 'modifiers typeParameters name left parameters commas right throws body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaDefaultLabelNode
	instanceVariableNames: 'defaultToken colon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaDimensionExpressionNode
	instanceVariableNames: 'left expression right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaElementArrayInitializerNode
	instanceVariableNames: 'left values commas right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaElementValuePairNode
	instanceVariableNames: 'name equals value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaEmptyDeclarationNode
	instanceVariableNames: 'semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaEmptyMethodBodyNode
	instanceVariableNames: 'semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaEnumConstantNode
	instanceVariableNames: 'annotations name leftParen expressions commas rightParen left declarations right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaEnumDeclarationNode
	instanceVariableNames: 'modifiers enumToken name implementsToken interfaces commas left constants semicolon declarations right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaExpressionNode
	instanceVariableNames: 'lefts rights'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaFieldDeclarationNode
	instanceVariableNames: 'modifiers type variableDeclarations commas semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaFinallyClauseNode
	instanceVariableNames: 'finallyToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaInterfaceNode
	instanceVariableNames: 'modifiers interfaceToken name typeParameters extendsToken interfaceTypes commas left declarations right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaLocalVariableDeclarationNode
	instanceVariableNames: 'modifiers type variableDeclarations commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaMethodDeclarationNode
	instanceVariableNames: 'modifiers typeParameters type declarator throws body'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaMethodDeclaratorNode
	instanceVariableNames: 'name left parameters commas right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaModifierNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaPackageDeclarationNode
	instanceVariableNames: 'annotations packageToken name semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaParameterNode
	instanceVariableNames: 'modifiers type variable'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaProgramFileNode
	instanceVariableNames: 'packageDeclaration imports typeDeclarations'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaQualifiedTypeNameNode
	instanceVariableNames: 'nspace period name typeArgLeft arguments commas typeArgRight'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaSingleTypeImportDeclarationNode
	instanceVariableNames: 'importToken staticToken name semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaStatementExpressionListNode
	instanceVariableNames: 'expressions commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaStatementNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaStaticInitializerNode
	instanceVariableNames: 'staticToken block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaSuperConstructorInvocationNode
	instanceVariableNames: 'superToken left expressions commas right semicolon primary period'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaSwitchBlockNode
	instanceVariableNames: 'left statementGroups labels right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaSwitchBlockStatementGroupNode
	instanceVariableNames: 'labels statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaSwitchLabelNode
	instanceVariableNames: 'caseToken constant colon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaThisConstructorInvocationNode
	instanceVariableNames: 'thisToken left expressions commas right semicolon primary period'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaThrowsNode
	instanceVariableNames: 'throwsToken classTypes commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaTypeArgumentNode
	instanceVariableNames: 'type questionMark token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaTypeNameNode
	instanceVariableNames: 'name typeArgLeft arguments commas typeArgRight'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaTypeParameterNode
	instanceVariableNames: 'name extendsToken types amps'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaTypeParametersNode
	instanceVariableNames: 'left parameters commas right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaVariableDeclarationNode
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaVariableNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaProgramNode subclass: #JavaVoidTypeNode
	instanceVariableNames: 'voidToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaAbstractMethodDeclarationNode subclass: #JavaAnnotationMethodDeclarationNode
	instanceVariableNames: 'defaultToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaArrayAccessNode
	instanceVariableNames: 'array expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaAssignmentNode
	instanceVariableNames: 'variable op value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaBinaryExpressionNode
	instanceVariableNames: 'leftExpression op rightExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaCastExpressionNode
	instanceVariableNames: 'type expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaClassPropertyNode
	instanceVariableNames: 'type period classToken name thisToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaConditionalExpressionNode
	instanceVariableNames: 'testExpression questionMark trueExpression colon falseExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaFieldAccessNode
	instanceVariableNames: 'receiver period name superToken superPeriod'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaLambdaExpressionNode
	instanceVariableNames: 'leftParen parameters commas rightParen arrowToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaLiteralNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaMethodInvocationNode
	instanceVariableNames: 'typeArgLeft arguments commas typeArgRight name expressions receiver period superToken superPeriod'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaNameNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaNewArrayNode
	instanceVariableNames: 'newToken type dimExpressions initializer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaNewNode
	instanceVariableNames: 'newToken type expressions commas primary period name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaPostDecrementExpressionNode
	instanceVariableNames: 'expression minusMinus'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaPostIncrementExpressionNode
	instanceVariableNames: 'expression plusPlus'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaPreDecrementExpressionNode
	instanceVariableNames: 'minusMinus expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaPreIncrementExpressionNode
	instanceVariableNames: 'plusPlus expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaUnaryAdditionNode
	instanceVariableNames: 'plus expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaUnaryBitInvertNode
	instanceVariableNames: 'tilde expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaUnaryNotNode
	instanceVariableNames: 'bang expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaExpressionNode subclass: #JavaUnarySubtractionNode
	instanceVariableNames: 'minus expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaBooleanLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaCharacterLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaFloatLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaIntegerLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaNullNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaLiteralNode subclass: #JavaStringLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaNameNode subclass: #JavaQualifiedNameNode
	instanceVariableNames: 'nspace period'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaNewNode subclass: #JavaNewClassNode
	instanceVariableNames: 'declarations'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaParameterNode subclass: #JavaVariableArgumentParameterNode
	instanceVariableNames: 'varArgsToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaSingleTypeImportDeclarationNode subclass: #JavaTypeImportOnDemandDeclarationNode
	instanceVariableNames: 'period star'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaAssertStatementNode
	instanceVariableNames: 'assertToken testExpression semicolon colon messageExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaBlockNode
	instanceVariableNames: 'left statements right'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaBreakStatementNode
	instanceVariableNames: 'breakToken identifier semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaContinueStatementNode
	instanceVariableNames: 'continueToken identifier semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaDoWhileStatementNode
	instanceVariableNames: 'doToken statement whileToken left expression right semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaEmptyStatementNode
	instanceVariableNames: 'semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaExpressionStatementNode
	instanceVariableNames: 'expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaForEachStatementNode
	instanceVariableNames: 'forToken left modifiers type name colon expression right statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaForStatementNode
	instanceVariableNames: 'forToken left initial firstSemicolon test secondSemicolon _update right statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaIfStatementNode
	instanceVariableNames: 'ifToken left expression right trueStatement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaLabeledStatementNode
	instanceVariableNames: 'identifier colon statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaLocalVariableDeclarationStatementNode
	instanceVariableNames: 'declaration semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaReturnStatementNode
	instanceVariableNames: 'returnToken expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaSwitchStatementNode
	instanceVariableNames: 'switchToken left expression right block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaSynchronizedStatementNode
	instanceVariableNames: 'synchronizedToken left expression right block'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaThrowStatementNode
	instanceVariableNames: 'throwToken expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaTryStatementNode
	instanceVariableNames: 'tryToken block catches finally'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaStatementNode subclass: #JavaWhileStatementNode
	instanceVariableNames: 'whileToken left expression right statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaIfStatementNode subclass: #JavaIfElseStatementNode
	instanceVariableNames: 'elseToken falseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaTypeNode subclass: #JavaArrayTypeNode
	instanceVariableNames: 'baseType lefts rights'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaTypeNode subclass: #JavaClassTypeNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaTypeNode subclass: #JavaPrimitiveTypeNode
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaBooleanTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaByteTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaCharTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaDoubleTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaFloatTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaIntTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaLongTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaPrimitiveTypeNode subclass: #JavaShortTypeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JavaVariableDeclarationNode subclass: #JavaInitializedVariableDeclarationNode
	instanceVariableNames: 'equals initializer'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNodeVisitor subclass: #JavaProgramNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGLRParser subclass: #JavaParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #JavaScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

JavaProgramNode guid: (GUID fromString: '{05B054A3-416A-4D8A-B16D-FF6F05C0D279}')!
JavaProgramNode comment: ''!
!JavaProgramNode categoriesForClass!Unclassified! !
!JavaProgramNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitProgram: self! !
!JavaProgramNode categoriesFor: #acceptVisitor:!generated!public! !

JavaAbstractMethodDeclarationNode guid: (GUID fromString: '{7449E765-0DE3-4BB4-B181-1881AD60BE46}')!
JavaAbstractMethodDeclarationNode comment: ''!
!JavaAbstractMethodDeclarationNode categoriesForClass!Unclassified! !
!JavaAbstractMethodDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAbstractMethodDeclaration: self!

compositeNodeVariables
	^#(#modifiers)!

declarator
	^declarator!

declarator: aJavaProgramNode
	self declarator notNil ifTrue: [self declarator parent: nil].
	declarator := aJavaProgramNode.
	self declarator notNil ifTrue: [self declarator parent: self]!

ignoredTokenVariables
	^#(#semicolon)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

nodeVariables
	^#(#typeParameters #type #declarator #throws)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

throws
	^throws!

throws: aJavaThrowsNode
	self throws notNil ifTrue: [self throws parent: nil].
	throws := aJavaThrowsNode.
	self throws notNil ifTrue: [self throws parent: self]!

type
	^type!

type: aJavaProgramNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaProgramNode.
	self type notNil ifTrue: [self type parent: self]!

typeParameters
	^typeParameters!

typeParameters: aJavaTypeParametersNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aJavaTypeParametersNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!JavaAbstractMethodDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #declarator!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #declarator:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #semicolon:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #throws!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #throws:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #type!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #type:!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #typeParameters!generated!public! !
!JavaAbstractMethodDeclarationNode categoriesFor: #typeParameters:!generated!public! !

JavaAnnotationInterfaceNode guid: (GUID fromString: '{AFF6D05E-AF3E-4DE9-BB18-3BD9A7257275}')!
JavaAnnotationInterfaceNode comment: ''!
!JavaAnnotationInterfaceNode categoriesForClass!Unclassified! !
!JavaAnnotationInterfaceNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnnotationInterface: self!

atToken
	^atToken!

atToken: aSmaCCToken
	atToken := aSmaCCToken!

compositeNodeVariables
	^#(#modifiers #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

interfaceToken
	^interfaceToken!

interfaceToken: aSmaCCToken
	interfaceToken := aSmaCCToken!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#atToken #interfaceToken #name)! !
!JavaAnnotationInterfaceNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #atToken!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #atToken:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #declarations!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #declarations:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaAnnotationInterfaceNode categoriesFor: #interfaceToken!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #interfaceToken:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #left!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #left:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #modifiers!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #modifiers:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #name!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #name:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #right!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #right:!generated!public! !
!JavaAnnotationInterfaceNode categoriesFor: #tokenVariables!generated!public! !

JavaAnnotationNode guid: (GUID fromString: '{0241E784-2D95-452E-B27A-0C6AF8C58430}')!
JavaAnnotationNode comment: ''!
!JavaAnnotationNode categoriesForClass!Unclassified! !
!JavaAnnotationNode methodsFor!

_at
	^_at!

_at: aSmaCCToken
	_at := aSmaCCToken!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnnotation: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#values)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	values := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

name
	^name!

name: aJavaNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#_at)!

values
	^values!

values: anOrderedCollection
	self setParents: self values to: nil.
	values := anOrderedCollection.
	self setParents: self values to: self! !
!JavaAnnotationNode categoriesFor: #_at!generated!public! !
!JavaAnnotationNode categoriesFor: #_at:!generated!public! !
!JavaAnnotationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAnnotationNode categoriesFor: #commas!generated!public! !
!JavaAnnotationNode categoriesFor: #commas:!generated!public! !
!JavaAnnotationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaAnnotationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaAnnotationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaAnnotationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaAnnotationNode categoriesFor: #left!generated!public! !
!JavaAnnotationNode categoriesFor: #left:!generated!public! !
!JavaAnnotationNode categoriesFor: #name!generated!public! !
!JavaAnnotationNode categoriesFor: #name:!generated!public! !
!JavaAnnotationNode categoriesFor: #nodeVariables!generated!public! !
!JavaAnnotationNode categoriesFor: #right!generated!public! !
!JavaAnnotationNode categoriesFor: #right:!generated!public! !
!JavaAnnotationNode categoriesFor: #tokenVariables!generated!public! !
!JavaAnnotationNode categoriesFor: #values!generated!public! !
!JavaAnnotationNode categoriesFor: #values:!generated!public! !

JavaArrayInitializerNode guid: (GUID fromString: '{562C885C-AC8B-4D61-9EDE-FB30A4F316D8}')!
JavaArrayInitializerNode comment: ''!
!JavaArrayInitializerNode categoriesForClass!Unclassified! !
!JavaArrayInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayInitializer: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#initializers)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	initializers := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

initializers
	^initializers!

initializers: anOrderedCollection
	self setParents: self initializers to: nil.
	initializers := anOrderedCollection.
	self setParents: self initializers to: self!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken! !
!JavaArrayInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaArrayInitializerNode categoriesFor: #commas!generated!public! !
!JavaArrayInitializerNode categoriesFor: #commas:!generated!public! !
!JavaArrayInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaArrayInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaArrayInitializerNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaArrayInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaArrayInitializerNode categoriesFor: #initializers!generated!public! !
!JavaArrayInitializerNode categoriesFor: #initializers:!generated!public! !
!JavaArrayInitializerNode categoriesFor: #left!generated!public! !
!JavaArrayInitializerNode categoriesFor: #left:!generated!public! !
!JavaArrayInitializerNode categoriesFor: #right!generated!public! !
!JavaArrayInitializerNode categoriesFor: #right:!generated!public! !

JavaArrayMethodDeclaratorNode guid: (GUID fromString: '{E6465DBA-E50C-43D8-A3E3-F037EBCC12BB}')!
JavaArrayMethodDeclaratorNode comment: ''!
!JavaArrayMethodDeclaratorNode categoriesForClass!Unclassified! !
!JavaArrayMethodDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayMethodDeclarator: self!

declarator
	^declarator!

declarator: aJavaProgramNode
	self declarator notNil ifTrue: [self declarator parent: nil].
	declarator := aJavaProgramNode.
	self declarator notNil ifTrue: [self declarator parent: self]!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#declarator)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken! !
!JavaArrayMethodDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #declarator!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #declarator:!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #left!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #left:!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #nodeVariables!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #right!generated!public! !
!JavaArrayMethodDeclaratorNode categoriesFor: #right:!generated!public! !

JavaArrayVariableNameNode guid: (GUID fromString: '{412571DD-982C-4A1A-81D1-2FDEE5B989D8}')!
JavaArrayVariableNameNode comment: ''!
!JavaArrayVariableNameNode categoriesForClass!Unclassified! !
!JavaArrayVariableNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayVariableName: self!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#variable)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

variable
	^variable!

variable: aJavaProgramNode
	self variable notNil ifTrue: [self variable parent: nil].
	variable := aJavaProgramNode.
	self variable notNil ifTrue: [self variable parent: self]! !
!JavaArrayVariableNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #left!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #left:!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #nodeVariables!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #right!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #right:!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #variable!generated!public! !
!JavaArrayVariableNameNode categoriesFor: #variable:!generated!public! !

JavaCatchClauseNode guid: (GUID fromString: '{8E6CCCB1-B23A-434F-9899-A358EF70324C}')!
JavaCatchClauseNode comment: ''!
!JavaCatchClauseNode categoriesForClass!Unclassified! !
!JavaCatchClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCatchClause: self!

block
	^block!

block: aJavaBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaBlockNode.
	self block notNil ifTrue: [self block parent: self]!

catchToken
	^catchToken!

catchToken: aSmaCCToken
	catchToken := aSmaCCToken!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#parameter #block)!

parameter
	^parameter!

parameter: aJavaParameterNode
	self parameter notNil ifTrue: [self parameter parent: nil].
	parameter := aJavaParameterNode.
	self parameter notNil ifTrue: [self parameter parent: self]!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#catchToken)! !
!JavaCatchClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaCatchClauseNode categoriesFor: #block!generated!public! !
!JavaCatchClauseNode categoriesFor: #block:!generated!public! !
!JavaCatchClauseNode categoriesFor: #catchToken!generated!public! !
!JavaCatchClauseNode categoriesFor: #catchToken:!generated!public! !
!JavaCatchClauseNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaCatchClauseNode categoriesFor: #left!generated!public! !
!JavaCatchClauseNode categoriesFor: #left:!generated!public! !
!JavaCatchClauseNode categoriesFor: #nodeVariables!generated!public! !
!JavaCatchClauseNode categoriesFor: #parameter!generated!public! !
!JavaCatchClauseNode categoriesFor: #parameter:!generated!public! !
!JavaCatchClauseNode categoriesFor: #right!generated!public! !
!JavaCatchClauseNode categoriesFor: #right:!generated!public! !
!JavaCatchClauseNode categoriesFor: #tokenVariables!generated!public! !

JavaClassDeclarationNode guid: (GUID fromString: '{BA4AAA77-5C76-4F90-9076-FFD85CD33897}')!
JavaClassDeclarationNode comment: ''!
!JavaClassDeclarationNode categoriesForClass!Unclassified! !
!JavaClassDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitClassDeclaration: self!

classToken
	^classToken!

classToken: aSmaCCToken
	classToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #interfaces #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

extendsToken
	^extendsToken!

extendsToken: aSmaCCToken
	extendsToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

implementsToken
	^implementsToken!

implementsToken: aSmaCCToken
	implementsToken := aSmaCCToken!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	interfaces := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

interfaces
	^interfaces!

interfaces: anOrderedCollection
	self setParents: self interfaces to: nil.
	interfaces := anOrderedCollection.
	self setParents: self interfaces to: self!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#typeParameters #superclass)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

superclass
	^superclass!

superclass: aJavaClassTypeNode
	self superclass notNil ifTrue: [self superclass parent: nil].
	superclass := aJavaClassTypeNode.
	self superclass notNil ifTrue: [self superclass parent: self]!

tokenVariables
	^#(#classToken #name #extendsToken #implementsToken)!

typeParameters
	^typeParameters!

typeParameters: aJavaTypeParametersNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aJavaTypeParametersNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!JavaClassDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #classToken!generated!public! !
!JavaClassDeclarationNode categoriesFor: #classToken:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #commas!generated!public! !
!JavaClassDeclarationNode categoriesFor: #commas:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaClassDeclarationNode categoriesFor: #declarations!generated!public! !
!JavaClassDeclarationNode categoriesFor: #declarations:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #extendsToken!generated!public! !
!JavaClassDeclarationNode categoriesFor: #extendsToken:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaClassDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaClassDeclarationNode categoriesFor: #implementsToken!generated!public! !
!JavaClassDeclarationNode categoriesFor: #implementsToken:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaClassDeclarationNode categoriesFor: #interfaces!generated!public! !
!JavaClassDeclarationNode categoriesFor: #interfaces:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #left!generated!public! !
!JavaClassDeclarationNode categoriesFor: #left:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaClassDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #name!generated!public! !
!JavaClassDeclarationNode categoriesFor: #name:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaClassDeclarationNode categoriesFor: #right!generated!public! !
!JavaClassDeclarationNode categoriesFor: #right:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #superclass!generated!public! !
!JavaClassDeclarationNode categoriesFor: #superclass:!generated!public! !
!JavaClassDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!JavaClassDeclarationNode categoriesFor: #typeParameters!generated!public! !
!JavaClassDeclarationNode categoriesFor: #typeParameters:!generated!public! !

JavaConstructorBodyNode guid: (GUID fromString: '{485D6829-54CE-4153-B337-8C849E7149DB}')!
JavaConstructorBodyNode comment: ''!
!JavaConstructorBodyNode categoriesForClass!Unclassified! !
!JavaConstructorBodyNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstructorBody: self!

compositeNodeVariables
	^#(#statements)!

constructorInvocation
	^constructorInvocation!

constructorInvocation: aJavaProgramNode
	self constructorInvocation notNil ifTrue: [self constructorInvocation parent: nil].
	constructorInvocation := aJavaProgramNode.
	self constructorInvocation notNil ifTrue: [self constructorInvocation parent: self]!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#constructorInvocation)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self! !
!JavaConstructorBodyNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaConstructorBodyNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaConstructorBodyNode categoriesFor: #constructorInvocation!generated!public! !
!JavaConstructorBodyNode categoriesFor: #constructorInvocation:!generated!public! !
!JavaConstructorBodyNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaConstructorBodyNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaConstructorBodyNode categoriesFor: #left!generated!public! !
!JavaConstructorBodyNode categoriesFor: #left:!generated!public! !
!JavaConstructorBodyNode categoriesFor: #nodeVariables!generated!public! !
!JavaConstructorBodyNode categoriesFor: #right!generated!public! !
!JavaConstructorBodyNode categoriesFor: #right:!generated!public! !
!JavaConstructorBodyNode categoriesFor: #statements!generated!public! !
!JavaConstructorBodyNode categoriesFor: #statements:!generated!public! !

JavaConstructorDeclarationNode guid: (GUID fromString: '{633479D4-48BC-4BF2-9047-AAB019211484}')!
JavaConstructorDeclarationNode comment: ''!
!JavaConstructorDeclarationNode categoriesForClass!Unclassified! !
!JavaConstructorDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConstructorDeclaration: self!

body
	^body!

body: aJavaConstructorBodyNode
	self body notNil ifTrue: [self body parent: nil].
	body := aJavaConstructorBodyNode.
	self body notNil ifTrue: [self body parent: self]!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #parameters)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aJavaNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#typeParameters #name #throws #body)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

throws
	^throws!

throws: aJavaThrowsNode
	self throws notNil ifTrue: [self throws parent: nil].
	throws := aJavaThrowsNode.
	self throws notNil ifTrue: [self throws parent: self]!

typeParameters
	^typeParameters!

typeParameters: aJavaTypeParametersNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aJavaTypeParametersNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!JavaConstructorDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #body!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #body:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #commas!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #commas:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaConstructorDeclarationNode categoriesFor: #left!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #left:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #name!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #name:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #parameters!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #parameters:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #right!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #right:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #throws!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #throws:!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #typeParameters!generated!public! !
!JavaConstructorDeclarationNode categoriesFor: #typeParameters:!generated!public! !

JavaDefaultLabelNode guid: (GUID fromString: '{08C0FE18-2AE6-4E3E-8199-B0B89F5930B9}')!
JavaDefaultLabelNode comment: ''!
!JavaDefaultLabelNode categoriesForClass!Unclassified! !
!JavaDefaultLabelNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDefaultLabel: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

tokenVariables
	^#(#defaultToken #colon)! !
!JavaDefaultLabelNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaDefaultLabelNode categoriesFor: #colon!generated!public! !
!JavaDefaultLabelNode categoriesFor: #colon:!generated!public! !
!JavaDefaultLabelNode categoriesFor: #defaultToken!generated!public! !
!JavaDefaultLabelNode categoriesFor: #defaultToken:!generated!public! !
!JavaDefaultLabelNode categoriesFor: #tokenVariables!generated!public! !

JavaDimensionExpressionNode guid: (GUID fromString: '{95AFF8F3-1E72-45A5-9101-B47982E30962}')!
JavaDimensionExpressionNode comment: ''!
!JavaDimensionExpressionNode categoriesForClass!Unclassified! !
!JavaDimensionExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDimensionExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken! !
!JavaDimensionExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #expression!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #expression:!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #left!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #left:!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #right!generated!public! !
!JavaDimensionExpressionNode categoriesFor: #right:!generated!public! !

JavaElementArrayInitializerNode guid: (GUID fromString: '{1EDF616B-A931-4C38-B51F-A69CD3105C6B}')!
JavaElementArrayInitializerNode comment: ''!
!JavaElementArrayInitializerNode categoriesForClass!Unclassified! !
!JavaElementArrayInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitElementArrayInitializer: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#values)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	values := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

values
	^values!

values: anOrderedCollection
	self setParents: self values to: nil.
	values := anOrderedCollection.
	self setParents: self values to: self! !
!JavaElementArrayInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #commas!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #commas:!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaElementArrayInitializerNode categoriesFor: #left!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #left:!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #right!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #right:!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #values!generated!public! !
!JavaElementArrayInitializerNode categoriesFor: #values:!generated!public! !

JavaElementValuePairNode guid: (GUID fromString: '{6092CF8A-03C4-4C33-BE12-6A6EAE8865E9}')!
JavaElementValuePairNode comment: ''!
!JavaElementValuePairNode categoriesForClass!Unclassified! !
!JavaElementValuePairNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitElementValuePair: self!

equals
	^equals!

equals: aSmaCCToken
	equals := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#value)!

tokenVariables
	^#(#name #equals)!

value
	^value!

value: aJavaProgramNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJavaProgramNode.
	self value notNil ifTrue: [self value parent: self]! !
!JavaElementValuePairNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaElementValuePairNode categoriesFor: #equals!generated!public! !
!JavaElementValuePairNode categoriesFor: #equals:!generated!public! !
!JavaElementValuePairNode categoriesFor: #name!generated!public! !
!JavaElementValuePairNode categoriesFor: #name:!generated!public! !
!JavaElementValuePairNode categoriesFor: #nodeVariables!generated!public! !
!JavaElementValuePairNode categoriesFor: #tokenVariables!generated!public! !
!JavaElementValuePairNode categoriesFor: #value!generated!public! !
!JavaElementValuePairNode categoriesFor: #value:!generated!public! !

JavaEmptyDeclarationNode guid: (GUID fromString: '{06DFD674-0843-4AB5-95B1-FA5EA76429B5}')!
JavaEmptyDeclarationNode comment: ''!
!JavaEmptyDeclarationNode categoriesForClass!Unclassified! !
!JavaEmptyDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEmptyDeclaration: self!

ignoredTokenVariables
	^#(#semicolon)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken! !
!JavaEmptyDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaEmptyDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaEmptyDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaEmptyDeclarationNode categoriesFor: #semicolon:!generated!public! !

JavaEmptyMethodBodyNode guid: (GUID fromString: '{5D3EC165-BAEF-478C-A959-D72C9876F7EA}')!
JavaEmptyMethodBodyNode comment: ''!
!JavaEmptyMethodBodyNode categoriesForClass!Unclassified! !
!JavaEmptyMethodBodyNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEmptyMethodBody: self!

ignoredTokenVariables
	^#(#semicolon)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken! !
!JavaEmptyMethodBodyNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaEmptyMethodBodyNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaEmptyMethodBodyNode categoriesFor: #semicolon!generated!public! !
!JavaEmptyMethodBodyNode categoriesFor: #semicolon:!generated!public! !

JavaEnumConstantNode guid: (GUID fromString: '{04816964-9225-48EF-9385-92C43DE28F4F}')!
JavaEnumConstantNode comment: ''!
!JavaEnumConstantNode categoriesForClass!Unclassified! !
!JavaEnumConstantNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEnumConstant: self!

annotations
	^annotations!

annotations: anOrderedCollection
	self setParents: self annotations to: nil.
	annotations := anOrderedCollection.
	self setParents: self annotations to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#annotations #expressions #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	annotations := OrderedCollection new: 2.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

tokenVariables
	^#(#name #leftParen #rightParen)! !
!JavaEnumConstantNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaEnumConstantNode categoriesFor: #annotations!generated!public! !
!JavaEnumConstantNode categoriesFor: #annotations:!generated!public! !
!JavaEnumConstantNode categoriesFor: #commas!generated!public! !
!JavaEnumConstantNode categoriesFor: #commas:!generated!public! !
!JavaEnumConstantNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaEnumConstantNode categoriesFor: #declarations!generated!public! !
!JavaEnumConstantNode categoriesFor: #declarations:!generated!public! !
!JavaEnumConstantNode categoriesFor: #expressions!generated!public! !
!JavaEnumConstantNode categoriesFor: #expressions:!generated!public! !
!JavaEnumConstantNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaEnumConstantNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaEnumConstantNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaEnumConstantNode categoriesFor: #left!generated!public! !
!JavaEnumConstantNode categoriesFor: #left:!generated!public! !
!JavaEnumConstantNode categoriesFor: #leftParen!generated!public! !
!JavaEnumConstantNode categoriesFor: #leftParen:!generated!public! !
!JavaEnumConstantNode categoriesFor: #name!generated!public! !
!JavaEnumConstantNode categoriesFor: #name:!generated!public! !
!JavaEnumConstantNode categoriesFor: #right!generated!public! !
!JavaEnumConstantNode categoriesFor: #right:!generated!public! !
!JavaEnumConstantNode categoriesFor: #rightParen!generated!public! !
!JavaEnumConstantNode categoriesFor: #rightParen:!generated!public! !
!JavaEnumConstantNode categoriesFor: #tokenVariables!generated!public! !

JavaEnumDeclarationNode guid: (GUID fromString: '{81196E01-15B3-4A55-9EB5-F44FD4EE5E76}')!
JavaEnumDeclarationNode comment: ''!
!JavaEnumDeclarationNode categoriesForClass!Unclassified! !
!JavaEnumDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEnumDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #interfaces #constants #declarations)!

constants
	^constants!

constants: anOrderedCollection
	self setParents: self constants to: nil.
	constants := anOrderedCollection.
	self setParents: self constants to: self!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

enumToken
	^enumToken!

enumToken: aSmaCCToken
	enumToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #semicolon #right)!

implementsToken
	^implementsToken!

implementsToken: aSmaCCToken
	implementsToken := aSmaCCToken!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	interfaces := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	constants := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

interfaces
	^interfaces!

interfaces: anOrderedCollection
	self setParents: self interfaces to: nil.
	interfaces := anOrderedCollection.
	self setParents: self interfaces to: self!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#enumToken #name #implementsToken)! !
!JavaEnumDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #commas!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #commas:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #constants!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #constants:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #declarations!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #declarations:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #enumToken!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #enumToken:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #implementsToken!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #implementsToken:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaEnumDeclarationNode categoriesFor: #interfaces!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #interfaces:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #left!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #left:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #name!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #name:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #right!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #right:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #semicolon:!generated!public! !
!JavaEnumDeclarationNode categoriesFor: #tokenVariables!generated!public! !

JavaExpressionNode guid: (GUID fromString: '{E1CB23DC-987B-4489-A182-EAF87F1B5724}')!
JavaExpressionNode comment: ''!
!JavaExpressionNode categoriesForClass!Unclassified! !
!JavaExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpression: self!

ignoredCompositeTokenVariables
	^#(#lefts #rights)!

initialize
	super initialize.
	lefts := OrderedCollection new: 2.
	rights := OrderedCollection new: 2.!

lefts
	^lefts!

lefts: anOrderedCollection
	lefts := anOrderedCollection!

rights
	^rights!

rights: anOrderedCollection
	rights := anOrderedCollection! !
!JavaExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaExpressionNode categoriesFor: #lefts!generated!public! !
!JavaExpressionNode categoriesFor: #lefts:!generated!public! !
!JavaExpressionNode categoriesFor: #rights!generated!public! !
!JavaExpressionNode categoriesFor: #rights:!generated!public! !

JavaFieldDeclarationNode guid: (GUID fromString: '{C39BFEDE-42E3-4160-8DB1-48DFB99EBB70}')!
JavaFieldDeclarationNode comment: ''!
!JavaFieldDeclarationNode categoriesForClass!Unclassified! !
!JavaFieldDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFieldDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #variableDeclarations)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#semicolon)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	variableDeclarations := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

nodeVariables
	^#(#type)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]!

variableDeclarations
	^variableDeclarations!

variableDeclarations: anOrderedCollection
	self setParents: self variableDeclarations to: nil.
	variableDeclarations := anOrderedCollection.
	self setParents: self variableDeclarations to: self! !
!JavaFieldDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #commas!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #commas:!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaFieldDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #semicolon:!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #type!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #type:!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #variableDeclarations!generated!public! !
!JavaFieldDeclarationNode categoriesFor: #variableDeclarations:!generated!public! !

JavaFinallyClauseNode guid: (GUID fromString: '{506C5033-70FE-40CC-9C94-7D20093752E8}')!
JavaFinallyClauseNode comment: ''!
!JavaFinallyClauseNode categoriesForClass!Unclassified! !
!JavaFinallyClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFinallyClause: self!

block
	^block!

block: aJavaBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaBlockNode.
	self block notNil ifTrue: [self block parent: self]!

finallyToken
	^finallyToken!

finallyToken: aSmaCCToken
	finallyToken := aSmaCCToken!

nodeVariables
	^#(#block)!

tokenVariables
	^#(#finallyToken)! !
!JavaFinallyClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaFinallyClauseNode categoriesFor: #block!generated!public! !
!JavaFinallyClauseNode categoriesFor: #block:!generated!public! !
!JavaFinallyClauseNode categoriesFor: #finallyToken!generated!public! !
!JavaFinallyClauseNode categoriesFor: #finallyToken:!generated!public! !
!JavaFinallyClauseNode categoriesFor: #nodeVariables!generated!public! !
!JavaFinallyClauseNode categoriesFor: #tokenVariables!generated!public! !

JavaInterfaceNode guid: (GUID fromString: '{EFDEE9A3-FD3D-4CAA-AA34-E4A401FE67DB}')!
JavaInterfaceNode comment: ''!
!JavaInterfaceNode categoriesForClass!Unclassified! !
!JavaInterfaceNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInterface: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #interfaceTypes #declarations)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

extendsToken
	^extendsToken!

extendsToken: aSmaCCToken
	extendsToken := aSmaCCToken!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	interfaceTypes := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	declarations := OrderedCollection new: 2.!

interfaceToken
	^interfaceToken!

interfaceToken: aSmaCCToken
	interfaceToken := aSmaCCToken!

interfaceTypes
	^interfaceTypes!

interfaceTypes: anOrderedCollection
	self setParents: self interfaceTypes to: nil.
	interfaceTypes := anOrderedCollection.
	self setParents: self interfaceTypes to: self!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#typeParameters)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#interfaceToken #name #extendsToken)!

typeParameters
	^typeParameters!

typeParameters: aJavaTypeParametersNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aJavaTypeParametersNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!JavaInterfaceNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaInterfaceNode categoriesFor: #commas!generated!public! !
!JavaInterfaceNode categoriesFor: #commas:!generated!public! !
!JavaInterfaceNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaInterfaceNode categoriesFor: #declarations!generated!public! !
!JavaInterfaceNode categoriesFor: #declarations:!generated!public! !
!JavaInterfaceNode categoriesFor: #extendsToken!generated!public! !
!JavaInterfaceNode categoriesFor: #extendsToken:!generated!public! !
!JavaInterfaceNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaInterfaceNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaInterfaceNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaInterfaceNode categoriesFor: #interfaceToken!generated!public! !
!JavaInterfaceNode categoriesFor: #interfaceToken:!generated!public! !
!JavaInterfaceNode categoriesFor: #interfaceTypes!generated!public! !
!JavaInterfaceNode categoriesFor: #interfaceTypes:!generated!public! !
!JavaInterfaceNode categoriesFor: #left!generated!public! !
!JavaInterfaceNode categoriesFor: #left:!generated!public! !
!JavaInterfaceNode categoriesFor: #modifiers!generated!public! !
!JavaInterfaceNode categoriesFor: #modifiers:!generated!public! !
!JavaInterfaceNode categoriesFor: #name!generated!public! !
!JavaInterfaceNode categoriesFor: #name:!generated!public! !
!JavaInterfaceNode categoriesFor: #nodeVariables!generated!public! !
!JavaInterfaceNode categoriesFor: #right!generated!public! !
!JavaInterfaceNode categoriesFor: #right:!generated!public! !
!JavaInterfaceNode categoriesFor: #tokenVariables!generated!public! !
!JavaInterfaceNode categoriesFor: #typeParameters!generated!public! !
!JavaInterfaceNode categoriesFor: #typeParameters:!generated!public! !

JavaLocalVariableDeclarationNode guid: (GUID fromString: '{FED462BD-A0A3-4855-910F-FB06AA508D7D}')!
JavaLocalVariableDeclarationNode comment: ''!
!JavaLocalVariableDeclarationNode categoriesForClass!Unclassified! !
!JavaLocalVariableDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLocalVariableDeclaration: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#modifiers #variableDeclarations)!

ignoredCompositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.
	variableDeclarations := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

nodeVariables
	^#(#type)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]!

variableDeclarations
	^variableDeclarations!

variableDeclarations: anOrderedCollection
	self setParents: self variableDeclarations to: nil.
	variableDeclarations := anOrderedCollection.
	self setParents: self variableDeclarations to: self! !
!JavaLocalVariableDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #commas!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #commas:!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #type!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #type:!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #variableDeclarations!generated!public! !
!JavaLocalVariableDeclarationNode categoriesFor: #variableDeclarations:!generated!public! !

JavaMethodDeclarationNode guid: (GUID fromString: '{DF6EC8B0-D700-4442-8D89-0575BB112778}')!
JavaMethodDeclarationNode comment: ''!
!JavaMethodDeclarationNode categoriesForClass!Unclassified! !
!JavaMethodDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodDeclaration: self!

body
	^body!

body: aJavaProgramNode
	self body notNil ifTrue: [self body parent: nil].
	body := aJavaProgramNode.
	self body notNil ifTrue: [self body parent: self]!

compositeNodeVariables
	^#(#modifiers)!

declarator
	^declarator!

declarator: aJavaProgramNode
	self declarator notNil ifTrue: [self declarator parent: nil].
	declarator := aJavaProgramNode.
	self declarator notNil ifTrue: [self declarator parent: self]!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

nodeVariables
	^#(#typeParameters #type #declarator #throws #body)!

throws
	^throws!

throws: aJavaThrowsNode
	self throws notNil ifTrue: [self throws parent: nil].
	throws := aJavaThrowsNode.
	self throws notNil ifTrue: [self throws parent: self]!

type
	^type!

type: aJavaProgramNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaProgramNode.
	self type notNil ifTrue: [self type parent: self]!

typeParameters
	^typeParameters!

typeParameters: aJavaTypeParametersNode
	self typeParameters notNil ifTrue: [self typeParameters parent: nil].
	typeParameters := aJavaTypeParametersNode.
	self typeParameters notNil ifTrue: [self typeParameters parent: self]! !
!JavaMethodDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #body!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #body:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #declarator!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #declarator:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaMethodDeclarationNode categoriesFor: #modifiers!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #modifiers:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #throws!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #throws:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #type!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #type:!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #typeParameters!generated!public! !
!JavaMethodDeclarationNode categoriesFor: #typeParameters:!generated!public! !

JavaMethodDeclaratorNode guid: (GUID fromString: '{7F8FF459-F404-4D6D-B6C4-245A741474FA}')!
JavaMethodDeclaratorNode comment: ''!
!JavaMethodDeclaratorNode categoriesForClass!Unclassified! !
!JavaMethodDeclaratorNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodDeclarator: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#parameters)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#name)! !
!JavaMethodDeclaratorNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #commas!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #commas:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaMethodDeclaratorNode categoriesFor: #left!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #left:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #name!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #name:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #parameters!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #parameters:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #right!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #right:!generated!public! !
!JavaMethodDeclaratorNode categoriesFor: #tokenVariables!generated!public! !

JavaModifierNode guid: (GUID fromString: '{7EED5979-990F-437D-BAF0-A9B28B05073A}')!
JavaModifierNode comment: ''!
!JavaModifierNode categoriesForClass!Unclassified! !
!JavaModifierNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitModifier: self!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#token)! !
!JavaModifierNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaModifierNode categoriesFor: #token!generated!public! !
!JavaModifierNode categoriesFor: #token:!generated!public! !
!JavaModifierNode categoriesFor: #tokenVariables!generated!public! !

JavaPackageDeclarationNode guid: (GUID fromString: '{34244A6A-B046-4075-81E9-D42474E0FE64}')!
JavaPackageDeclarationNode comment: ''!
!JavaPackageDeclarationNode categoriesForClass!Unclassified! !
!JavaPackageDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPackageDeclaration: self!

annotations
	^annotations!

annotations: anOrderedCollection
	self setParents: self annotations to: nil.
	annotations := anOrderedCollection.
	self setParents: self annotations to: self!

compositeNodeVariables
	^#(#annotations)!

ignoredTokenVariables
	^#(#semicolon)!

initialize
	super initialize.
	annotations := OrderedCollection new: 2.!

name
	^name!

name: aJavaNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name)!

packageToken
	^packageToken!

packageToken: aSmaCCToken
	packageToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#packageToken)! !
!JavaPackageDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #annotations!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #annotations:!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaPackageDeclarationNode categoriesFor: #name!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #name:!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #packageToken!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #packageToken:!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #semicolon:!generated!public! !
!JavaPackageDeclarationNode categoriesFor: #tokenVariables!generated!public! !

JavaParameterNode guid: (GUID fromString: '{75D895AC-76B4-4575-A57B-9C3FF06602D2}')!
JavaParameterNode comment: ''!
!JavaParameterNode categoriesForClass!Unclassified! !
!JavaParameterNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitParameter: self!

compositeNodeVariables
	^#(#modifiers)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

nodeVariables
	^#(#type #variable)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]!

variable
	^variable!

variable: aJavaProgramNode
	self variable notNil ifTrue: [self variable parent: nil].
	variable := aJavaProgramNode.
	self variable notNil ifTrue: [self variable parent: self]! !
!JavaParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaParameterNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaParameterNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaParameterNode categoriesFor: #modifiers!generated!public! !
!JavaParameterNode categoriesFor: #modifiers:!generated!public! !
!JavaParameterNode categoriesFor: #nodeVariables!generated!public! !
!JavaParameterNode categoriesFor: #type!generated!public! !
!JavaParameterNode categoriesFor: #type:!generated!public! !
!JavaParameterNode categoriesFor: #variable!generated!public! !
!JavaParameterNode categoriesFor: #variable:!generated!public! !

JavaProgramFileNode guid: (GUID fromString: '{6758B82E-03CF-45BC-AE0F-475BD977566C}')!
JavaProgramFileNode comment: ''!
!JavaProgramFileNode categoriesForClass!Unclassified! !
!JavaProgramFileNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitProgramFile: self!

compositeNodeVariables
	^#(#imports #typeDeclarations)!

imports
	^imports!

imports: anOrderedCollection
	self setParents: self imports to: nil.
	imports := anOrderedCollection.
	self setParents: self imports to: self!

initialize
	super initialize.
	imports := OrderedCollection new: 2.
	typeDeclarations := OrderedCollection new: 2.!

nodeVariables
	^#(#packageDeclaration)!

packageDeclaration
	^packageDeclaration!

packageDeclaration: aJavaPackageDeclarationNode
	self packageDeclaration notNil ifTrue: [self packageDeclaration parent: nil].
	packageDeclaration := aJavaPackageDeclarationNode.
	self packageDeclaration notNil ifTrue: [self packageDeclaration parent: self]!

typeDeclarations
	^typeDeclarations!

typeDeclarations: anOrderedCollection
	self setParents: self typeDeclarations to: nil.
	typeDeclarations := anOrderedCollection.
	self setParents: self typeDeclarations to: self! !
!JavaProgramFileNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaProgramFileNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaProgramFileNode categoriesFor: #imports!generated!public! !
!JavaProgramFileNode categoriesFor: #imports:!generated!public! !
!JavaProgramFileNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaProgramFileNode categoriesFor: #nodeVariables!generated!public! !
!JavaProgramFileNode categoriesFor: #packageDeclaration!generated!public! !
!JavaProgramFileNode categoriesFor: #packageDeclaration:!generated!public! !
!JavaProgramFileNode categoriesFor: #typeDeclarations!generated!public! !
!JavaProgramFileNode categoriesFor: #typeDeclarations:!generated!public! !

JavaQualifiedTypeNameNode guid: (GUID fromString: '{D618C1A8-6E26-497A-BF57-FE7730D4E2FA}')!
JavaQualifiedTypeNameNode comment: ''!
!JavaQualifiedTypeNameNode categoriesForClass!Unclassified! !
!JavaQualifiedTypeNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitQualifiedTypeName: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

ignoredCompositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#nspace)!

nspace
	^nspace!

nspace: aJavaProgramNode
	self nspace notNil ifTrue: [self nspace parent: nil].
	nspace := aJavaProgramNode.
	self nspace notNil ifTrue: [self nspace parent: self]!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

tokenVariables
	^#(#period #name #typeArgLeft #typeArgRight)!

typeArgLeft
	^typeArgLeft!

typeArgLeft: aSmaCCToken
	typeArgLeft := aSmaCCToken!

typeArgRight
	^typeArgRight!

typeArgRight: aSmaCCToken
	typeArgRight := aSmaCCToken! !
!JavaQualifiedTypeNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #arguments!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #arguments:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #commas!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #commas:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaQualifiedTypeNameNode categoriesFor: #name!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #name:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #nodeVariables!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #nspace!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #nspace:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #period!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #period:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #tokenVariables!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #typeArgLeft!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #typeArgLeft:!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #typeArgRight!generated!public! !
!JavaQualifiedTypeNameNode categoriesFor: #typeArgRight:!generated!public! !

JavaSingleTypeImportDeclarationNode guid: (GUID fromString: '{BA885BC8-A41B-4E24-9ED0-F2C00DF7676E}')!
JavaSingleTypeImportDeclarationNode comment: ''!
!JavaSingleTypeImportDeclarationNode categoriesForClass!Unclassified! !
!JavaSingleTypeImportDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSingleTypeImportDeclaration: self!

ignoredTokenVariables
	^#(#semicolon)!

importToken
	^importToken!

importToken: aSmaCCToken
	importToken := aSmaCCToken!

name
	^name!

name: aJavaNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

staticToken
	^staticToken!

staticToken: aSmaCCToken
	staticToken := aSmaCCToken!

tokenVariables
	^#(#importToken #staticToken)! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #importToken!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #importToken:!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #name!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #name:!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #semicolon!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #semicolon:!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #staticToken!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #staticToken:!generated!public! !
!JavaSingleTypeImportDeclarationNode categoriesFor: #tokenVariables!generated!public! !

JavaStatementExpressionListNode guid: (GUID fromString: '{27BFF058-0938-4C87-AE87-27EF4E3BA4AD}')!
JavaStatementExpressionListNode comment: ''!
!JavaStatementExpressionListNode categoriesForClass!Unclassified! !
!JavaStatementExpressionListNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStatementExpressionList: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.! !
!JavaStatementExpressionListNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #commas!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #commas:!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #expressions!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #expressions:!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaStatementExpressionListNode categoriesFor: #initialize!generated-initialize-release!public! !

JavaStatementNode guid: (GUID fromString: '{162945E7-715C-462A-96D0-E6C03E4893B1}')!
JavaStatementNode comment: ''!
!JavaStatementNode categoriesForClass!Unclassified! !
!JavaStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStatement: self! !
!JavaStatementNode categoriesFor: #acceptVisitor:!generated!public! !

JavaStaticInitializerNode guid: (GUID fromString: '{F264A862-0B64-49D8-B973-1C718FC9B05C}')!
JavaStaticInitializerNode comment: ''!
!JavaStaticInitializerNode categoriesForClass!Unclassified! !
!JavaStaticInitializerNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStaticInitializer: self!

block
	^block!

block: aJavaBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaBlockNode.
	self block notNil ifTrue: [self block parent: self]!

nodeVariables
	^#(#block)!

staticToken
	^staticToken!

staticToken: aSmaCCToken
	staticToken := aSmaCCToken!

tokenVariables
	^#(#staticToken)! !
!JavaStaticInitializerNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaStaticInitializerNode categoriesFor: #block!generated!public! !
!JavaStaticInitializerNode categoriesFor: #block:!generated!public! !
!JavaStaticInitializerNode categoriesFor: #nodeVariables!generated!public! !
!JavaStaticInitializerNode categoriesFor: #staticToken!generated!public! !
!JavaStaticInitializerNode categoriesFor: #staticToken:!generated!public! !
!JavaStaticInitializerNode categoriesFor: #tokenVariables!generated!public! !

JavaSuperConstructorInvocationNode guid: (GUID fromString: '{CB3D85F8-32CC-4DD0-8E74-DA1A1DAF16F5}')!
JavaSuperConstructorInvocationNode comment: ''!
!JavaSuperConstructorInvocationNode categoriesForClass!Unclassified! !
!JavaSuperConstructorInvocationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSuperConstructorInvocation: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right #semicolon)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#primary)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

primary
	^primary!

primary: aJavaExpressionNode
	self primary notNil ifTrue: [self primary parent: nil].
	primary := aJavaExpressionNode.
	self primary notNil ifTrue: [self primary parent: self]!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

superToken
	^superToken!

superToken: aSmaCCToken
	superToken := aSmaCCToken!

tokenVariables
	^#(#superToken #period)! !
!JavaSuperConstructorInvocationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #commas!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #commas:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #expressions!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #expressions:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #left!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #left:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #nodeVariables!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #period!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #period:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #primary!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #primary:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #right!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #right:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #semicolon!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #semicolon:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #superToken!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #superToken:!generated!public! !
!JavaSuperConstructorInvocationNode categoriesFor: #tokenVariables!generated!public! !

JavaSwitchBlockNode guid: (GUID fromString: '{974F740D-681C-4590-893C-4BF834A2B0B1}')!
JavaSwitchBlockNode comment: ''!
!JavaSwitchBlockNode categoriesForClass!Unclassified! !
!JavaSwitchBlockNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchBlock: self!

compositeNodeVariables
	^#(#statementGroups #labels)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	statementGroups := OrderedCollection new: 2.
	labels := OrderedCollection new: 2.!

labels
	^labels!

labels: anOrderedCollection
	self setParents: self labels to: nil.
	labels := anOrderedCollection.
	self setParents: self labels to: self!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

statementGroups
	^statementGroups!

statementGroups: anOrderedCollection
	self setParents: self statementGroups to: nil.
	statementGroups := anOrderedCollection.
	self setParents: self statementGroups to: self! !
!JavaSwitchBlockNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSwitchBlockNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaSwitchBlockNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaSwitchBlockNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaSwitchBlockNode categoriesFor: #labels!generated!public! !
!JavaSwitchBlockNode categoriesFor: #labels:!generated!public! !
!JavaSwitchBlockNode categoriesFor: #left!generated!public! !
!JavaSwitchBlockNode categoriesFor: #left:!generated!public! !
!JavaSwitchBlockNode categoriesFor: #right!generated!public! !
!JavaSwitchBlockNode categoriesFor: #right:!generated!public! !
!JavaSwitchBlockNode categoriesFor: #statementGroups!generated!public! !
!JavaSwitchBlockNode categoriesFor: #statementGroups:!generated!public! !

JavaSwitchBlockStatementGroupNode guid: (GUID fromString: '{515630BD-28E3-461C-89FA-941CE42FC45E}')!
JavaSwitchBlockStatementGroupNode comment: ''!
!JavaSwitchBlockStatementGroupNode categoriesForClass!Unclassified! !
!JavaSwitchBlockStatementGroupNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchBlockStatementGroup: self!

compositeNodeVariables
	^#(#labels #statements)!

initialize
	super initialize.
	labels := OrderedCollection new: 2.
	statements := OrderedCollection new: 2.!

labels
	^labels!

labels: anOrderedCollection
	self setParents: self labels to: nil.
	labels := anOrderedCollection.
	self setParents: self labels to: self!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #labels!generated!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #labels:!generated!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #statements!generated!public! !
!JavaSwitchBlockStatementGroupNode categoriesFor: #statements:!generated!public! !

JavaSwitchLabelNode guid: (GUID fromString: '{616D07F6-317C-46E3-AB24-293CEFBB309C}')!
JavaSwitchLabelNode comment: ''!
!JavaSwitchLabelNode categoriesForClass!Unclassified! !
!JavaSwitchLabelNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchLabel: self!

caseToken
	^caseToken!

caseToken: aSmaCCToken
	caseToken := aSmaCCToken!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

constant
	^constant!

constant: aJavaExpressionNode
	self constant notNil ifTrue: [self constant parent: nil].
	constant := aJavaExpressionNode.
	self constant notNil ifTrue: [self constant parent: self]!

nodeVariables
	^#(#constant)!

tokenVariables
	^#(#caseToken #colon)! !
!JavaSwitchLabelNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSwitchLabelNode categoriesFor: #caseToken!generated!public! !
!JavaSwitchLabelNode categoriesFor: #caseToken:!generated!public! !
!JavaSwitchLabelNode categoriesFor: #colon!generated!public! !
!JavaSwitchLabelNode categoriesFor: #colon:!generated!public! !
!JavaSwitchLabelNode categoriesFor: #constant!generated!public! !
!JavaSwitchLabelNode categoriesFor: #constant:!generated!public! !
!JavaSwitchLabelNode categoriesFor: #nodeVariables!generated!public! !
!JavaSwitchLabelNode categoriesFor: #tokenVariables!generated!public! !

JavaThisConstructorInvocationNode guid: (GUID fromString: '{F1888DE8-C9DA-4705-B703-33D5A814AD14}')!
JavaThisConstructorInvocationNode comment: ''!
!JavaThisConstructorInvocationNode categoriesForClass!Unclassified! !
!JavaThisConstructorInvocationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThisConstructorInvocation: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right #semicolon)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#primary)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

primary
	^primary!

primary: aJavaExpressionNode
	self primary notNil ifTrue: [self primary parent: nil].
	primary := aJavaExpressionNode.
	self primary notNil ifTrue: [self primary parent: self]!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#thisToken #period)! !
!JavaThisConstructorInvocationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #commas!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #commas:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #expressions!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #expressions:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaThisConstructorInvocationNode categoriesFor: #left!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #left:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #nodeVariables!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #period!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #period:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #primary!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #primary:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #right!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #right:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #semicolon!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #semicolon:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #thisToken!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #thisToken:!generated!public! !
!JavaThisConstructorInvocationNode categoriesFor: #tokenVariables!generated!public! !

JavaThrowsNode guid: (GUID fromString: '{42E10A86-A6B5-4B34-81BA-E1BF702F968F}')!
JavaThrowsNode comment: ''!
!JavaThrowsNode categoriesForClass!Unclassified! !
!JavaThrowsNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThrows: self!

classTypes
	^classTypes!

classTypes: anOrderedCollection
	self setParents: self classTypes to: nil.
	classTypes := anOrderedCollection.
	self setParents: self classTypes to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#classTypes)!

ignoredCompositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	classTypes := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

throwsToken
	^throwsToken!

throwsToken: aSmaCCToken
	throwsToken := aSmaCCToken!

tokenVariables
	^#(#throwsToken)! !
!JavaThrowsNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaThrowsNode categoriesFor: #classTypes!generated!public! !
!JavaThrowsNode categoriesFor: #classTypes:!generated!public! !
!JavaThrowsNode categoriesFor: #commas!generated!public! !
!JavaThrowsNode categoriesFor: #commas:!generated!public! !
!JavaThrowsNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaThrowsNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaThrowsNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaThrowsNode categoriesFor: #throwsToken!generated!public! !
!JavaThrowsNode categoriesFor: #throwsToken:!generated!public! !
!JavaThrowsNode categoriesFor: #tokenVariables!generated!public! !

JavaTypeArgumentNode guid: (GUID fromString: '{6F2BCE18-341E-4700-A1D4-53C09AE5DA70}')!
JavaTypeArgumentNode comment: ''!
!JavaTypeArgumentNode categoriesForClass!Unclassified! !
!JavaTypeArgumentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeArgument: self!

nodeVariables
	^#(#type)!

questionMark
	^questionMark!

questionMark: aSmaCCToken
	questionMark := aSmaCCToken!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#questionMark #token)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaTypeArgumentNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTypeArgumentNode categoriesFor: #nodeVariables!generated!public! !
!JavaTypeArgumentNode categoriesFor: #questionMark!generated!public! !
!JavaTypeArgumentNode categoriesFor: #questionMark:!generated!public! !
!JavaTypeArgumentNode categoriesFor: #token!generated!public! !
!JavaTypeArgumentNode categoriesFor: #token:!generated!public! !
!JavaTypeArgumentNode categoriesFor: #tokenVariables!generated!public! !
!JavaTypeArgumentNode categoriesFor: #type!generated!public! !
!JavaTypeArgumentNode categoriesFor: #type:!generated!public! !

JavaTypeNameNode guid: (GUID fromString: '{FA7BC288-FA03-43C7-A8CD-C79F04CEB672}')!
JavaTypeNameNode comment: ''!
!JavaTypeNameNode categoriesForClass!Unclassified! !
!JavaTypeNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeName: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

ignoredCompositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

tokenVariables
	^#(#name #typeArgLeft #typeArgRight)!

typeArgLeft
	^typeArgLeft!

typeArgLeft: aSmaCCToken
	typeArgLeft := aSmaCCToken!

typeArgRight
	^typeArgRight!

typeArgRight: aSmaCCToken
	typeArgRight := aSmaCCToken! !
!JavaTypeNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTypeNameNode categoriesFor: #arguments!generated!public! !
!JavaTypeNameNode categoriesFor: #arguments:!generated!public! !
!JavaTypeNameNode categoriesFor: #commas!generated!public! !
!JavaTypeNameNode categoriesFor: #commas:!generated!public! !
!JavaTypeNameNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaTypeNameNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaTypeNameNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaTypeNameNode categoriesFor: #name!generated!public! !
!JavaTypeNameNode categoriesFor: #name:!generated!public! !
!JavaTypeNameNode categoriesFor: #tokenVariables!generated!public! !
!JavaTypeNameNode categoriesFor: #typeArgLeft!generated!public! !
!JavaTypeNameNode categoriesFor: #typeArgLeft:!generated!public! !
!JavaTypeNameNode categoriesFor: #typeArgRight!generated!public! !
!JavaTypeNameNode categoriesFor: #typeArgRight:!generated!public! !

JavaTypeNode guid: (GUID fromString: '{C1270F37-E47E-42B3-A62A-4683E7563A6C}')!
JavaTypeNode comment: ''!
!JavaTypeNode categoriesForClass!Unclassified! !
!JavaTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitType: self! !
!JavaTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaTypeParameterNode guid: (GUID fromString: '{A7D7F768-FD83-4400-8D16-50B3C82FCEDB}')!
JavaTypeParameterNode comment: ''!
!JavaTypeParameterNode categoriesForClass!Unclassified! !
!JavaTypeParameterNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeParameter: self!

amps
	^amps!

amps: anOrderedCollection
	amps := anOrderedCollection!

compositeNodeVariables
	^#(#types)!

compositeTokenVariables
	^#(#amps)!

extendsToken
	^extendsToken!

extendsToken: aSmaCCToken
	extendsToken := aSmaCCToken!

initialize
	super initialize.
	types := OrderedCollection new: 2.
	amps := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

tokenVariables
	^#(#name #extendsToken)!

types
	^types!

types: anOrderedCollection
	self setParents: self types to: nil.
	types := anOrderedCollection.
	self setParents: self types to: self! !
!JavaTypeParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTypeParameterNode categoriesFor: #amps!generated!public! !
!JavaTypeParameterNode categoriesFor: #amps:!generated!public! !
!JavaTypeParameterNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaTypeParameterNode categoriesFor: #compositeTokenVariables!generated!public! !
!JavaTypeParameterNode categoriesFor: #extendsToken!generated!public! !
!JavaTypeParameterNode categoriesFor: #extendsToken:!generated!public! !
!JavaTypeParameterNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaTypeParameterNode categoriesFor: #name!generated!public! !
!JavaTypeParameterNode categoriesFor: #name:!generated!public! !
!JavaTypeParameterNode categoriesFor: #tokenVariables!generated!public! !
!JavaTypeParameterNode categoriesFor: #types!generated!public! !
!JavaTypeParameterNode categoriesFor: #types:!generated!public! !

JavaTypeParametersNode guid: (GUID fromString: '{D24DFA81-A43F-4BB7-9FE1-15A692464954}')!
JavaTypeParametersNode comment: ''!
!JavaTypeParametersNode categoriesForClass!Unclassified! !
!JavaTypeParametersNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeParameters: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#parameters)!

ignoredCompositeTokenVariables
	^#(#commas)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken! !
!JavaTypeParametersNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTypeParametersNode categoriesFor: #commas!generated!public! !
!JavaTypeParametersNode categoriesFor: #commas:!generated!public! !
!JavaTypeParametersNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaTypeParametersNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaTypeParametersNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaTypeParametersNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaTypeParametersNode categoriesFor: #left!generated!public! !
!JavaTypeParametersNode categoriesFor: #left:!generated!public! !
!JavaTypeParametersNode categoriesFor: #parameters!generated!public! !
!JavaTypeParametersNode categoriesFor: #parameters:!generated!public! !
!JavaTypeParametersNode categoriesFor: #right!generated!public! !
!JavaTypeParametersNode categoriesFor: #right:!generated!public! !

JavaVariableDeclarationNode guid: (GUID fromString: '{35F3FB52-2BF3-4ADD-A21F-4EF61368E023}')!
JavaVariableDeclarationNode comment: ''!
!JavaVariableDeclarationNode categoriesForClass!Unclassified! !
!JavaVariableDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableDeclaration: self!

nodeVariables
	^#(#variable)!

variable
	^variable!

variable: aJavaProgramNode
	self variable notNil ifTrue: [self variable parent: nil].
	variable := aJavaProgramNode.
	self variable notNil ifTrue: [self variable parent: self]! !
!JavaVariableDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaVariableDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaVariableDeclarationNode categoriesFor: #variable!generated!public! !
!JavaVariableDeclarationNode categoriesFor: #variable:!generated!public! !

JavaVariableNameNode guid: (GUID fromString: '{522722E8-4717-46D8-9C32-7012B74D58EC}')!
JavaVariableNameNode comment: ''!
!JavaVariableNameNode categoriesForClass!Unclassified! !
!JavaVariableNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableName: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

tokenVariables
	^#(#name)! !
!JavaVariableNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaVariableNameNode categoriesFor: #name!generated!public! !
!JavaVariableNameNode categoriesFor: #name:!generated!public! !
!JavaVariableNameNode categoriesFor: #tokenVariables!generated!public! !

JavaVoidTypeNode guid: (GUID fromString: '{91E5892D-9FBC-4449-926B-743539104B1D}')!
JavaVoidTypeNode comment: ''!
!JavaVoidTypeNode categoriesForClass!Unclassified! !
!JavaVoidTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVoidType: self!

tokenVariables
	^#(#voidToken)!

voidToken
	^voidToken!

voidToken: aSmaCCToken
	voidToken := aSmaCCToken! !
!JavaVoidTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaVoidTypeNode categoriesFor: #tokenVariables!generated!public! !
!JavaVoidTypeNode categoriesFor: #voidToken!generated!public! !
!JavaVoidTypeNode categoriesFor: #voidToken:!generated!public! !

JavaAnnotationMethodDeclarationNode guid: (GUID fromString: '{0AAD638D-6A60-4DF0-BDDC-A3F74B5615B6}')!
JavaAnnotationMethodDeclarationNode comment: ''!
!JavaAnnotationMethodDeclarationNode categoriesForClass!Unclassified! !
!JavaAnnotationMethodDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAnnotationMethodDeclaration: self!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

nodeVariables
	^#(#value #typeParameters #type #declarator #throws)!

tokenVariables
	^#(#defaultToken)!

value
	^value!

value: aJavaProgramNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJavaProgramNode.
	self value notNil ifTrue: [self value parent: self]! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #defaultToken!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #defaultToken:!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #value!generated!public! !
!JavaAnnotationMethodDeclarationNode categoriesFor: #value:!generated!public! !

JavaArrayAccessNode guid: (GUID fromString: '{4BCBF698-DE88-4C32-B1DA-8CB7C930EE17}')!
JavaArrayAccessNode comment: ''!
!JavaArrayAccessNode categoriesForClass!Unclassified! !
!JavaArrayAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayAccess: self!

array
	^array!

array: aJavaExpressionNode
	self array notNil ifTrue: [self array parent: nil].
	array := aJavaExpressionNode.
	self array notNil ifTrue: [self array parent: self]!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#array #expression)! !
!JavaArrayAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaArrayAccessNode categoriesFor: #array!generated!public! !
!JavaArrayAccessNode categoriesFor: #array:!generated!public! !
!JavaArrayAccessNode categoriesFor: #expression!generated!public! !
!JavaArrayAccessNode categoriesFor: #expression:!generated!public! !
!JavaArrayAccessNode categoriesFor: #nodeVariables!generated!public! !

JavaAssignmentNode guid: (GUID fromString: '{A9D01B3F-C0DC-4323-933E-DC0D47980ECC}')!
JavaAssignmentNode comment: ''!
!JavaAssignmentNode categoriesForClass!Unclassified! !
!JavaAssignmentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAssignment: self!

nodeVariables
	^#(#variable #value)!

op
	^op!

op: aSmaCCToken
	op := aSmaCCToken!

tokenVariables
	^#(#op)!

value
	^value!

value: aJavaExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJavaExpressionNode.
	self value notNil ifTrue: [self value parent: self]!

variable
	^variable!

variable: aJavaExpressionNode
	self variable notNil ifTrue: [self variable parent: nil].
	variable := aJavaExpressionNode.
	self variable notNil ifTrue: [self variable parent: self]! !
!JavaAssignmentNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAssignmentNode categoriesFor: #nodeVariables!generated!public! !
!JavaAssignmentNode categoriesFor: #op!generated!public! !
!JavaAssignmentNode categoriesFor: #op:!generated!public! !
!JavaAssignmentNode categoriesFor: #tokenVariables!generated!public! !
!JavaAssignmentNode categoriesFor: #value!generated!public! !
!JavaAssignmentNode categoriesFor: #value:!generated!public! !
!JavaAssignmentNode categoriesFor: #variable!generated!public! !
!JavaAssignmentNode categoriesFor: #variable:!generated!public! !

JavaBinaryExpressionNode guid: (GUID fromString: '{C60BC34D-45E3-4805-805F-B5785D11DE64}')!
JavaBinaryExpressionNode comment: ''!
!JavaBinaryExpressionNode categoriesForClass!Unclassified! !
!JavaBinaryExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBinaryExpression: self!

leftExpression
	^leftExpression!

leftExpression: aJavaExpressionNode
	self leftExpression notNil ifTrue: [self leftExpression parent: nil].
	leftExpression := aJavaExpressionNode.
	self leftExpression notNil ifTrue: [self leftExpression parent: self]!

nodeVariables
	^#(#leftExpression #rightExpression)!

op
	^op!

op: aSmaCCToken
	op := aSmaCCToken!

rightExpression
	^rightExpression!

rightExpression: aJavaProgramNode
	self rightExpression notNil ifTrue: [self rightExpression parent: nil].
	rightExpression := aJavaProgramNode.
	self rightExpression notNil ifTrue: [self rightExpression parent: self]!

tokenVariables
	^#(#op)! !
!JavaBinaryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #leftExpression!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #leftExpression:!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #op!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #op:!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #rightExpression!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #rightExpression:!generated!public! !
!JavaBinaryExpressionNode categoriesFor: #tokenVariables!generated!public! !

JavaCastExpressionNode guid: (GUID fromString: '{030A76A4-9BB8-42AF-987A-5BB1115DB48F}')!
JavaCastExpressionNode comment: ''!
!JavaCastExpressionNode categoriesForClass!Unclassified! !
!JavaCastExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCastExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#type #expression)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaCastExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaCastExpressionNode categoriesFor: #expression!generated!public! !
!JavaCastExpressionNode categoriesFor: #expression:!generated!public! !
!JavaCastExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaCastExpressionNode categoriesFor: #type!generated!public! !
!JavaCastExpressionNode categoriesFor: #type:!generated!public! !

JavaClassPropertyNode guid: (GUID fromString: '{F0215797-A11F-4E97-A28D-777EB606BA41}')!
JavaClassPropertyNode comment: ''!
!JavaClassPropertyNode categoriesForClass!Unclassified! !
!JavaClassPropertyNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitClassProperty: self!

classToken
	^classToken!

classToken: aSmaCCToken
	classToken := aSmaCCToken!

name
	^name!

name: aJavaNameNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaNameNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#type #name)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#period #classToken #thisToken)!

type
	^type!

type: aJavaProgramNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaProgramNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaClassPropertyNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaClassPropertyNode categoriesFor: #classToken!generated!public! !
!JavaClassPropertyNode categoriesFor: #classToken:!generated!public! !
!JavaClassPropertyNode categoriesFor: #name!generated!public! !
!JavaClassPropertyNode categoriesFor: #name:!generated!public! !
!JavaClassPropertyNode categoriesFor: #nodeVariables!generated!public! !
!JavaClassPropertyNode categoriesFor: #period!generated!public! !
!JavaClassPropertyNode categoriesFor: #period:!generated!public! !
!JavaClassPropertyNode categoriesFor: #thisToken!generated!public! !
!JavaClassPropertyNode categoriesFor: #thisToken:!generated!public! !
!JavaClassPropertyNode categoriesFor: #tokenVariables!generated!public! !
!JavaClassPropertyNode categoriesFor: #type!generated!public! !
!JavaClassPropertyNode categoriesFor: #type:!generated!public! !

JavaConditionalExpressionNode guid: (GUID fromString: '{407D8514-69F7-4EC9-B1CA-E9833B3CEDDC}')!
JavaConditionalExpressionNode comment: ''!
!JavaConditionalExpressionNode categoriesForClass!Unclassified! !
!JavaConditionalExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConditionalExpression: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

falseExpression
	^falseExpression!

falseExpression: aJavaExpressionNode
	self falseExpression notNil ifTrue: [self falseExpression parent: nil].
	falseExpression := aJavaExpressionNode.
	self falseExpression notNil ifTrue: [self falseExpression parent: self]!

nodeVariables
	^#(#testExpression #trueExpression #falseExpression)!

questionMark
	^questionMark!

questionMark: aSmaCCToken
	questionMark := aSmaCCToken!

testExpression
	^testExpression!

testExpression: aJavaExpressionNode
	self testExpression notNil ifTrue: [self testExpression parent: nil].
	testExpression := aJavaExpressionNode.
	self testExpression notNil ifTrue: [self testExpression parent: self]!

tokenVariables
	^#(#questionMark #colon)!

trueExpression
	^trueExpression!

trueExpression: aJavaExpressionNode
	self trueExpression notNil ifTrue: [self trueExpression parent: nil].
	trueExpression := aJavaExpressionNode.
	self trueExpression notNil ifTrue: [self trueExpression parent: self]! !
!JavaConditionalExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #colon!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #colon:!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #falseExpression!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #falseExpression:!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #questionMark!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #questionMark:!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #testExpression!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #testExpression:!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #tokenVariables!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #trueExpression!generated!public! !
!JavaConditionalExpressionNode categoriesFor: #trueExpression:!generated!public! !

JavaFieldAccessNode guid: (GUID fromString: '{70593FDF-24F3-48A1-99C2-540ED022F961}')!
JavaFieldAccessNode comment: ''!
!JavaFieldAccessNode categoriesForClass!Unclassified! !
!JavaFieldAccessNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFieldAccess: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#receiver)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

receiver
	^receiver!

receiver: aJavaExpressionNode
	self receiver notNil ifTrue: [self receiver parent: nil].
	receiver := aJavaExpressionNode.
	self receiver notNil ifTrue: [self receiver parent: self]!

superPeriod
	^superPeriod!

superPeriod: aSmaCCToken
	superPeriod := aSmaCCToken!

superToken
	^superToken!

superToken: aSmaCCToken
	superToken := aSmaCCToken!

tokenVariables
	^#(#period #name #superToken #superPeriod)! !
!JavaFieldAccessNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaFieldAccessNode categoriesFor: #name!generated!public! !
!JavaFieldAccessNode categoriesFor: #name:!generated!public! !
!JavaFieldAccessNode categoriesFor: #nodeVariables!generated!public! !
!JavaFieldAccessNode categoriesFor: #period!generated!public! !
!JavaFieldAccessNode categoriesFor: #period:!generated!public! !
!JavaFieldAccessNode categoriesFor: #receiver!generated!public! !
!JavaFieldAccessNode categoriesFor: #receiver:!generated!public! !
!JavaFieldAccessNode categoriesFor: #superPeriod!generated!public! !
!JavaFieldAccessNode categoriesFor: #superPeriod:!generated!public! !
!JavaFieldAccessNode categoriesFor: #superToken!generated!public! !
!JavaFieldAccessNode categoriesFor: #superToken:!generated!public! !
!JavaFieldAccessNode categoriesFor: #tokenVariables!generated!public! !

JavaLambdaExpressionNode guid: (GUID fromString: '{7122A74C-D219-4973-B17A-0290C68FAC6A}')!
JavaLambdaExpressionNode comment: ''!
!JavaLambdaExpressionNode categoriesForClass!Unclassified! !
!JavaLambdaExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLambdaExpression: self!

arrowToken
	^arrowToken!

arrowToken: aSmaCCToken
	arrowToken := aSmaCCToken!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#parameters)!

ignoredCompositeTokenVariables
	^#(#commas #lefts #rights)!

initialize
	super initialize.
	parameters := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#value)!

parameters
	^parameters!

parameters: anOrderedCollection
	self setParents: self parameters to: nil.
	parameters := anOrderedCollection.
	self setParents: self parameters to: self!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

tokenVariables
	^#(#leftParen #rightParen #arrowToken)!

value
	^value!

value: aJavaProgramNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJavaProgramNode.
	self value notNil ifTrue: [self value parent: self]! !
!JavaLambdaExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #arrowToken!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #arrowToken:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #commas!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #commas:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaLambdaExpressionNode categoriesFor: #leftParen!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #leftParen:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #parameters!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #parameters:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #rightParen!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #rightParen:!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #tokenVariables!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #value!generated!public! !
!JavaLambdaExpressionNode categoriesFor: #value:!generated!public! !

JavaLiteralNode guid: (GUID fromString: '{DCE10993-F22E-49D4-BBCC-DE1A945C22C5}')!
JavaLiteralNode comment: ''!
!JavaLiteralNode categoriesForClass!Unclassified! !
!JavaLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLiteral: self!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#token)! !
!JavaLiteralNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaLiteralNode categoriesFor: #token!generated!public! !
!JavaLiteralNode categoriesFor: #token:!generated!public! !
!JavaLiteralNode categoriesFor: #tokenVariables!generated!public! !

JavaMethodInvocationNode guid: (GUID fromString: '{15D6B378-2478-41D3-BB01-F01183BF985D}')!
JavaMethodInvocationNode comment: ''!
!JavaMethodInvocationNode categoriesForClass!Unclassified! !
!JavaMethodInvocationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitMethodInvocation: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments #expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas #lefts #rights)!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	expressions := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#receiver)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

receiver
	^receiver!

receiver: aJavaExpressionNode
	self receiver notNil ifTrue: [self receiver parent: nil].
	receiver := aJavaExpressionNode.
	self receiver notNil ifTrue: [self receiver parent: self]!

superPeriod
	^superPeriod!

superPeriod: aSmaCCToken
	superPeriod := aSmaCCToken!

superToken
	^superToken!

superToken: aSmaCCToken
	superToken := aSmaCCToken!

tokenVariables
	^#(#typeArgLeft #typeArgRight #name #period #superToken #superPeriod)!

typeArgLeft
	^typeArgLeft!

typeArgLeft: aSmaCCToken
	typeArgLeft := aSmaCCToken!

typeArgRight
	^typeArgRight!

typeArgRight: aSmaCCToken
	typeArgRight := aSmaCCToken! !
!JavaMethodInvocationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #arguments!generated!public! !
!JavaMethodInvocationNode categoriesFor: #arguments:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #commas!generated!public! !
!JavaMethodInvocationNode categoriesFor: #commas:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaMethodInvocationNode categoriesFor: #expressions!generated!public! !
!JavaMethodInvocationNode categoriesFor: #expressions:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaMethodInvocationNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaMethodInvocationNode categoriesFor: #name!generated!public! !
!JavaMethodInvocationNode categoriesFor: #name:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #nodeVariables!generated!public! !
!JavaMethodInvocationNode categoriesFor: #period!generated!public! !
!JavaMethodInvocationNode categoriesFor: #period:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #receiver!generated!public! !
!JavaMethodInvocationNode categoriesFor: #receiver:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #superPeriod!generated!public! !
!JavaMethodInvocationNode categoriesFor: #superPeriod:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #superToken!generated!public! !
!JavaMethodInvocationNode categoriesFor: #superToken:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #tokenVariables!generated!public! !
!JavaMethodInvocationNode categoriesFor: #typeArgLeft!generated!public! !
!JavaMethodInvocationNode categoriesFor: #typeArgLeft:!generated!public! !
!JavaMethodInvocationNode categoriesFor: #typeArgRight!generated!public! !
!JavaMethodInvocationNode categoriesFor: #typeArgRight:!generated!public! !

JavaNameNode guid: (GUID fromString: '{2A43EB7C-07D0-4788-9C82-A1898CA77EA0}')!
JavaNameNode comment: ''!
!JavaNameNode categoriesForClass!Unclassified! !
!JavaNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitName: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

tokenVariables
	^#(#name)! !
!JavaNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaNameNode categoriesFor: #name!generated!public! !
!JavaNameNode categoriesFor: #name:!generated!public! !
!JavaNameNode categoriesFor: #tokenVariables!generated!public! !

JavaNewArrayNode guid: (GUID fromString: '{C9314E7A-F478-47A8-82F9-20A9325967A6}')!
JavaNewArrayNode comment: ''!
!JavaNewArrayNode categoriesForClass!Unclassified! !
!JavaNewArrayNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNewArray: self!

compositeNodeVariables
	^#(#dimExpressions)!

dimExpressions
	^dimExpressions!

dimExpressions: anOrderedCollection
	self setParents: self dimExpressions to: nil.
	dimExpressions := anOrderedCollection.
	self setParents: self dimExpressions to: self!

initialize
	super initialize.
	dimExpressions := OrderedCollection new: 2.!

initializer
	^initializer!

initializer: aJavaArrayInitializerNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aJavaArrayInitializerNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#type #initializer)!

tokenVariables
	^#(#newToken)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaNewArrayNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaNewArrayNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaNewArrayNode categoriesFor: #dimExpressions!generated!public! !
!JavaNewArrayNode categoriesFor: #dimExpressions:!generated!public! !
!JavaNewArrayNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaNewArrayNode categoriesFor: #initializer!generated!public! !
!JavaNewArrayNode categoriesFor: #initializer:!generated!public! !
!JavaNewArrayNode categoriesFor: #newToken!generated!public! !
!JavaNewArrayNode categoriesFor: #newToken:!generated!public! !
!JavaNewArrayNode categoriesFor: #nodeVariables!generated!public! !
!JavaNewArrayNode categoriesFor: #tokenVariables!generated!public! !
!JavaNewArrayNode categoriesFor: #type!generated!public! !
!JavaNewArrayNode categoriesFor: #type:!generated!public! !

JavaNewNode guid: (GUID fromString: '{C08A4FAE-AC03-497A-BFF1-7536F96F8627}')!
JavaNewNode comment: ''!
!JavaNewNode categoriesForClass!Unclassified! !
!JavaNewNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNew: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

ignoredCompositeTokenVariables
	^#(#commas #lefts #rights)!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#type #primary)!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

primary
	^primary!

primary: aJavaExpressionNode
	self primary notNil ifTrue: [self primary parent: nil].
	primary := aJavaExpressionNode.
	self primary notNil ifTrue: [self primary parent: self]!

tokenVariables
	^#(#newToken #period #name)!

type
	^type!

type: aJavaClassTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaClassTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaNewNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaNewNode categoriesFor: #commas!generated!public! !
!JavaNewNode categoriesFor: #commas:!generated!public! !
!JavaNewNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaNewNode categoriesFor: #expressions!generated!public! !
!JavaNewNode categoriesFor: #expressions:!generated!public! !
!JavaNewNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaNewNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaNewNode categoriesFor: #name!generated!public! !
!JavaNewNode categoriesFor: #name:!generated!public! !
!JavaNewNode categoriesFor: #newToken!generated!public! !
!JavaNewNode categoriesFor: #newToken:!generated!public! !
!JavaNewNode categoriesFor: #nodeVariables!generated!public! !
!JavaNewNode categoriesFor: #period!generated!public! !
!JavaNewNode categoriesFor: #period:!generated!public! !
!JavaNewNode categoriesFor: #primary!generated!public! !
!JavaNewNode categoriesFor: #primary:!generated!public! !
!JavaNewNode categoriesFor: #tokenVariables!generated!public! !
!JavaNewNode categoriesFor: #type!generated!public! !
!JavaNewNode categoriesFor: #type:!generated!public! !

JavaPostDecrementExpressionNode guid: (GUID fromString: '{3EFA4D99-E703-4C91-9890-39339A5A281C}')!
JavaPostDecrementExpressionNode comment: ''!
!JavaPostDecrementExpressionNode categoriesForClass!Unclassified! !
!JavaPostDecrementExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPostDecrementExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

minusMinus
	^minusMinus!

minusMinus: aSmaCCToken
	minusMinus := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#minusMinus)! !
!JavaPostDecrementExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #expression!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #expression:!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #minusMinus!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #minusMinus:!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaPostDecrementExpressionNode categoriesFor: #tokenVariables!generated!public! !

JavaPostIncrementExpressionNode guid: (GUID fromString: '{9C5C2E92-E124-47B5-A6D8-F392A95A4471}')!
JavaPostIncrementExpressionNode comment: ''!
!JavaPostIncrementExpressionNode categoriesForClass!Unclassified! !
!JavaPostIncrementExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPostIncrementExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

plusPlus
	^plusPlus!

plusPlus: aSmaCCToken
	plusPlus := aSmaCCToken!

tokenVariables
	^#(#plusPlus)! !
!JavaPostIncrementExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #expression!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #expression:!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #plusPlus!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #plusPlus:!generated!public! !
!JavaPostIncrementExpressionNode categoriesFor: #tokenVariables!generated!public! !

JavaPreDecrementExpressionNode guid: (GUID fromString: '{ADDD48C5-31A9-4C60-BF91-5350A3128D69}')!
JavaPreDecrementExpressionNode comment: ''!
!JavaPreDecrementExpressionNode categoriesForClass!Unclassified! !
!JavaPreDecrementExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPreDecrementExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

minusMinus
	^minusMinus!

minusMinus: aSmaCCToken
	minusMinus := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#minusMinus)! !
!JavaPreDecrementExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #expression!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #expression:!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #minusMinus!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #minusMinus:!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaPreDecrementExpressionNode categoriesFor: #tokenVariables!generated!public! !

JavaPreIncrementExpressionNode guid: (GUID fromString: '{B2A7C57E-0AAF-4216-9859-DAFDB6F64F37}')!
JavaPreIncrementExpressionNode comment: ''!
!JavaPreIncrementExpressionNode categoriesForClass!Unclassified! !
!JavaPreIncrementExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPreIncrementExpression: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

plusPlus
	^plusPlus!

plusPlus: aSmaCCToken
	plusPlus := aSmaCCToken!

tokenVariables
	^#(#plusPlus)! !
!JavaPreIncrementExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #expression!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #expression:!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #plusPlus!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #plusPlus:!generated!public! !
!JavaPreIncrementExpressionNode categoriesFor: #tokenVariables!generated!public! !

JavaUnaryAdditionNode guid: (GUID fromString: '{2D738C6F-8F0C-46B4-851F-BA59F94C9E65}')!
JavaUnaryAdditionNode comment: ''!
!JavaUnaryAdditionNode categoriesForClass!Unclassified! !
!JavaUnaryAdditionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnaryAddition: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

plus
	^plus!

plus: aSmaCCToken
	plus := aSmaCCToken!

tokenVariables
	^#(#plus)! !
!JavaUnaryAdditionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #expression!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #expression:!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #nodeVariables!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #plus!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #plus:!generated!public! !
!JavaUnaryAdditionNode categoriesFor: #tokenVariables!generated!public! !

JavaUnaryBitInvertNode guid: (GUID fromString: '{EA34AFE1-C099-4AA7-AD75-F03590610AF6}')!
JavaUnaryBitInvertNode comment: ''!
!JavaUnaryBitInvertNode categoriesForClass!Unclassified! !
!JavaUnaryBitInvertNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnaryBitInvert: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

tilde
	^tilde!

tilde: aSmaCCToken
	tilde := aSmaCCToken!

tokenVariables
	^#(#tilde)! !
!JavaUnaryBitInvertNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #expression!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #expression:!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #nodeVariables!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #tilde!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #tilde:!generated!public! !
!JavaUnaryBitInvertNode categoriesFor: #tokenVariables!generated!public! !

JavaUnaryNotNode guid: (GUID fromString: '{E5029220-6FF4-4FAF-B08A-A73E28BF0CCC}')!
JavaUnaryNotNode comment: ''!
!JavaUnaryNotNode categoriesForClass!Unclassified! !
!JavaUnaryNotNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnaryNot: self!

bang
	^bang!

bang: aSmaCCToken
	bang := aSmaCCToken!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#bang)! !
!JavaUnaryNotNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaUnaryNotNode categoriesFor: #bang!generated!public! !
!JavaUnaryNotNode categoriesFor: #bang:!generated!public! !
!JavaUnaryNotNode categoriesFor: #expression!generated!public! !
!JavaUnaryNotNode categoriesFor: #expression:!generated!public! !
!JavaUnaryNotNode categoriesFor: #nodeVariables!generated!public! !
!JavaUnaryNotNode categoriesFor: #tokenVariables!generated!public! !

JavaUnarySubtractionNode guid: (GUID fromString: '{D5194956-F47A-49BC-B33A-7DAB44C7445D}')!
JavaUnarySubtractionNode comment: ''!
!JavaUnarySubtractionNode categoriesForClass!Unclassified! !
!JavaUnarySubtractionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnarySubtraction: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

minus
	^minus!

minus: aSmaCCToken
	minus := aSmaCCToken!

nodeVariables
	^#(#expression)!

tokenVariables
	^#(#minus)! !
!JavaUnarySubtractionNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #expression!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #expression:!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #minus!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #minus:!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #nodeVariables!generated!public! !
!JavaUnarySubtractionNode categoriesFor: #tokenVariables!generated!public! !

JavaBooleanLiteralNode guid: (GUID fromString: '{E87C9760-C200-4C34-8648-F3C04A74B98C}')!
JavaBooleanLiteralNode comment: ''!
!JavaBooleanLiteralNode categoriesForClass!Unclassified! !
!JavaBooleanLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBooleanLiteral: self! !
!JavaBooleanLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JavaCharacterLiteralNode guid: (GUID fromString: '{2BA9BF6F-059F-41FC-93A5-B042564DCEC5}')!
JavaCharacterLiteralNode comment: ''!
!JavaCharacterLiteralNode categoriesForClass!Unclassified! !
!JavaCharacterLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCharacterLiteral: self! !
!JavaCharacterLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JavaFloatLiteralNode guid: (GUID fromString: '{343AE92A-C0C2-441E-A909-E2E59442A927}')!
JavaFloatLiteralNode comment: ''!
!JavaFloatLiteralNode categoriesForClass!Unclassified! !
!JavaFloatLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFloatLiteral: self! !
!JavaFloatLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JavaIntegerLiteralNode guid: (GUID fromString: '{ADA6F4D3-0398-4F55-BE60-9255257321AB}')!
JavaIntegerLiteralNode comment: ''!
!JavaIntegerLiteralNode categoriesForClass!Unclassified! !
!JavaIntegerLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIntegerLiteral: self! !
!JavaIntegerLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JavaNullNode guid: (GUID fromString: '{E98BCA86-9A39-41B9-A364-1EF1E79F04BF}')!
JavaNullNode comment: ''!
!JavaNullNode categoriesForClass!Unclassified! !
!JavaNullNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNull: self! !
!JavaNullNode categoriesFor: #acceptVisitor:!generated!public! !

JavaStringLiteralNode guid: (GUID fromString: '{CF414D4D-A489-4D08-B818-925868D3727D}')!
JavaStringLiteralNode comment: ''!
!JavaStringLiteralNode categoriesForClass!Unclassified! !
!JavaStringLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStringLiteral: self! !
!JavaStringLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JavaQualifiedNameNode guid: (GUID fromString: '{0D07D8F1-6869-48A5-9875-52F0B7313C21}')!
JavaQualifiedNameNode comment: ''!
!JavaQualifiedNameNode categoriesForClass!Unclassified! !
!JavaQualifiedNameNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitQualifiedName: self!

nodeVariables
	^#(#nspace)!

nspace
	^nspace!

nspace: aJavaNameNode
	self nspace notNil ifTrue: [self nspace parent: nil].
	nspace := aJavaNameNode.
	self nspace notNil ifTrue: [self nspace parent: self]!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

tokenVariables
	^#(#period #name)! !
!JavaQualifiedNameNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaQualifiedNameNode categoriesFor: #nodeVariables!generated!public! !
!JavaQualifiedNameNode categoriesFor: #nspace!generated!public! !
!JavaQualifiedNameNode categoriesFor: #nspace:!generated!public! !
!JavaQualifiedNameNode categoriesFor: #period!generated!public! !
!JavaQualifiedNameNode categoriesFor: #period:!generated!public! !
!JavaQualifiedNameNode categoriesFor: #tokenVariables!generated!public! !

JavaNewClassNode guid: (GUID fromString: '{86704424-9D4F-4ACB-B51D-F9D690525F68}')!
JavaNewClassNode comment: ''!
!JavaNewClassNode categoriesForClass!Unclassified! !
!JavaNewClassNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNewClass: self!

compositeNodeVariables
	^#(#declarations #expressions)!

declarations
	^declarations!

declarations: anOrderedCollection
	self setParents: self declarations to: nil.
	declarations := anOrderedCollection.
	self setParents: self declarations to: self!

initialize
	super initialize.
	declarations := OrderedCollection new: 2.! !
!JavaNewClassNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaNewClassNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaNewClassNode categoriesFor: #declarations!generated!public! !
!JavaNewClassNode categoriesFor: #declarations:!generated!public! !
!JavaNewClassNode categoriesFor: #initialize!generated-initialize-release!public! !

JavaVariableArgumentParameterNode guid: (GUID fromString: '{94A75B45-199D-4A37-B63C-DF125E232F51}')!
JavaVariableArgumentParameterNode comment: ''!
!JavaVariableArgumentParameterNode categoriesForClass!Unclassified! !
!JavaVariableArgumentParameterNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableArgumentParameter: self!

tokenVariables
	^#(#varArgsToken)!

varArgsToken
	^varArgsToken!

varArgsToken: aSmaCCToken
	varArgsToken := aSmaCCToken! !
!JavaVariableArgumentParameterNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaVariableArgumentParameterNode categoriesFor: #tokenVariables!generated!public! !
!JavaVariableArgumentParameterNode categoriesFor: #varArgsToken!generated!public! !
!JavaVariableArgumentParameterNode categoriesFor: #varArgsToken:!generated!public! !

JavaTypeImportOnDemandDeclarationNode guid: (GUID fromString: '{3DA76143-C368-4FED-8991-43FF222208EB}')!
JavaTypeImportOnDemandDeclarationNode comment: ''!
!JavaTypeImportOnDemandDeclarationNode categoriesForClass!Unclassified! !
!JavaTypeImportOnDemandDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTypeImportOnDemandDeclaration: self!

period
	^period!

period: aSmaCCToken
	period := aSmaCCToken!

star
	^star!

star: aSmaCCToken
	star := aSmaCCToken!

tokenVariables
	^#(#period #star #importToken #staticToken)! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #period!generated!public! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #period:!generated!public! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #star!generated!public! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #star:!generated!public! !
!JavaTypeImportOnDemandDeclarationNode categoriesFor: #tokenVariables!generated!public! !

JavaAssertStatementNode guid: (GUID fromString: '{467D63F8-E54E-445F-8DD3-D7562BAF4AEB}')!
JavaAssertStatementNode comment: ''!
!JavaAssertStatementNode categoriesForClass!Unclassified! !
!JavaAssertStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAssertStatement: self!

assertToken
	^assertToken!

assertToken: aSmaCCToken
	assertToken := aSmaCCToken!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolon)!

messageExpression
	^messageExpression!

messageExpression: aJavaExpressionNode
	self messageExpression notNil ifTrue: [self messageExpression parent: nil].
	messageExpression := aJavaExpressionNode.
	self messageExpression notNil ifTrue: [self messageExpression parent: self]!

nodeVariables
	^#(#testExpression #messageExpression)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

testExpression
	^testExpression!

testExpression: aJavaExpressionNode
	self testExpression notNil ifTrue: [self testExpression parent: nil].
	testExpression := aJavaExpressionNode.
	self testExpression notNil ifTrue: [self testExpression parent: self]!

tokenVariables
	^#(#assertToken #colon)! !
!JavaAssertStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaAssertStatementNode categoriesFor: #assertToken!generated!public! !
!JavaAssertStatementNode categoriesFor: #assertToken:!generated!public! !
!JavaAssertStatementNode categoriesFor: #colon!generated!public! !
!JavaAssertStatementNode categoriesFor: #colon:!generated!public! !
!JavaAssertStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaAssertStatementNode categoriesFor: #messageExpression!generated!public! !
!JavaAssertStatementNode categoriesFor: #messageExpression:!generated!public! !
!JavaAssertStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaAssertStatementNode categoriesFor: #semicolon!generated!public! !
!JavaAssertStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaAssertStatementNode categoriesFor: #testExpression!generated!public! !
!JavaAssertStatementNode categoriesFor: #testExpression:!generated!public! !
!JavaAssertStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaBlockNode guid: (GUID fromString: '{7904DFB9-3D55-4F74-A4AF-81B8A0D69385}')!
JavaBlockNode comment: ''!
!JavaBlockNode categoriesForClass!Unclassified! !
!JavaBlockNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBlock: self!

compositeNodeVariables
	^#(#statements)!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self! !
!JavaBlockNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaBlockNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaBlockNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaBlockNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaBlockNode categoriesFor: #left!generated!public! !
!JavaBlockNode categoriesFor: #left:!generated!public! !
!JavaBlockNode categoriesFor: #right!generated!public! !
!JavaBlockNode categoriesFor: #right:!generated!public! !
!JavaBlockNode categoriesFor: #statements!generated!public! !
!JavaBlockNode categoriesFor: #statements:!generated!public! !

JavaBreakStatementNode guid: (GUID fromString: '{002DD141-B94F-4691-B81E-C9951FA7ECF0}')!
JavaBreakStatementNode comment: ''!
!JavaBreakStatementNode categoriesForClass!Unclassified! !
!JavaBreakStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBreakStatement: self!

breakToken
	^breakToken!

breakToken: aSmaCCToken
	breakToken := aSmaCCToken!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolon)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#breakToken #identifier)! !
!JavaBreakStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaBreakStatementNode categoriesFor: #breakToken!generated!public! !
!JavaBreakStatementNode categoriesFor: #breakToken:!generated!public! !
!JavaBreakStatementNode categoriesFor: #identifier!generated!public! !
!JavaBreakStatementNode categoriesFor: #identifier:!generated!public! !
!JavaBreakStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaBreakStatementNode categoriesFor: #semicolon!generated!public! !
!JavaBreakStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaBreakStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaContinueStatementNode guid: (GUID fromString: '{EC3BA45F-4699-44D2-B8B2-0688770403C4}')!
JavaContinueStatementNode comment: ''!
!JavaContinueStatementNode categoriesForClass!Unclassified! !
!JavaContinueStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitContinueStatement: self!

continueToken
	^continueToken!

continueToken: aSmaCCToken
	continueToken := aSmaCCToken!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

ignoredTokenVariables
	^#(#semicolon)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#continueToken #identifier)! !
!JavaContinueStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaContinueStatementNode categoriesFor: #continueToken!generated!public! !
!JavaContinueStatementNode categoriesFor: #continueToken:!generated!public! !
!JavaContinueStatementNode categoriesFor: #identifier!generated!public! !
!JavaContinueStatementNode categoriesFor: #identifier:!generated!public! !
!JavaContinueStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaContinueStatementNode categoriesFor: #semicolon!generated!public! !
!JavaContinueStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaContinueStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaDoWhileStatementNode guid: (GUID fromString: '{FFC36445-4F3E-4FA6-AFD0-A53D4FB7B304}')!
JavaDoWhileStatementNode comment: ''!
!JavaDoWhileStatementNode categoriesForClass!Unclassified! !
!JavaDoWhileStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDoWhileStatement: self!

doToken
	^doToken!

doToken: aSmaCCToken
	doToken := aSmaCCToken!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#left #right #semicolon)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#statement #expression)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

statement
	^statement!

statement: aJavaStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJavaStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#doToken #whileToken)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!JavaDoWhileStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #doToken!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #doToken:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #expression!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #expression:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #left!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #left:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #right!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #right:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #semicolon!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #statement!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #statement:!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #tokenVariables!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #whileToken!generated!public! !
!JavaDoWhileStatementNode categoriesFor: #whileToken:!generated!public! !

JavaEmptyStatementNode guid: (GUID fromString: '{D4214FB5-69A1-4231-9685-702182492C2A}')!
JavaEmptyStatementNode comment: ''!
!JavaEmptyStatementNode categoriesForClass!Unclassified! !
!JavaEmptyStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEmptyStatement: self!

ignoredTokenVariables
	^#(#semicolon)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken! !
!JavaEmptyStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaEmptyStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaEmptyStatementNode categoriesFor: #semicolon!generated!public! !
!JavaEmptyStatementNode categoriesFor: #semicolon:!generated!public! !

JavaExpressionStatementNode guid: (GUID fromString: '{AA2802AB-922D-464A-9F29-A90F0667FEB7}')!
JavaExpressionStatementNode comment: ''!
!JavaExpressionStatementNode categoriesForClass!Unclassified! !
!JavaExpressionStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpressionStatement: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolon)!

nodeVariables
	^#(#expression)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken! !
!JavaExpressionStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaExpressionStatementNode categoriesFor: #expression!generated!public! !
!JavaExpressionStatementNode categoriesFor: #expression:!generated!public! !
!JavaExpressionStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaExpressionStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaExpressionStatementNode categoriesFor: #semicolon!generated!public! !
!JavaExpressionStatementNode categoriesFor: #semicolon:!generated!public! !

JavaForEachStatementNode guid: (GUID fromString: '{CABDE4A8-3069-40DF-895C-70B60E4FD3AF}')!
JavaForEachStatementNode comment: ''!
!JavaForEachStatementNode categoriesForClass!Unclassified! !
!JavaForEachStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForEachStatement: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

compositeNodeVariables
	^#(#modifiers)!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

forToken
	^forToken!

forToken: aSmaCCToken
	forToken := aSmaCCToken!

ignoredTokenVariables
	^#(#left #right)!

initialize
	super initialize.
	modifiers := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

modifiers
	^modifiers!

modifiers: anOrderedCollection
	self setParents: self modifiers to: nil.
	modifiers := anOrderedCollection.
	self setParents: self modifiers to: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#type #expression #statement)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

statement
	^statement!

statement: aJavaStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJavaStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#forToken #name #colon)!

type
	^type!

type: aJavaTypeNode
	self type notNil ifTrue: [self type parent: nil].
	type := aJavaTypeNode.
	self type notNil ifTrue: [self type parent: self]! !
!JavaForEachStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaForEachStatementNode categoriesFor: #colon!generated!public! !
!JavaForEachStatementNode categoriesFor: #colon:!generated!public! !
!JavaForEachStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaForEachStatementNode categoriesFor: #expression!generated!public! !
!JavaForEachStatementNode categoriesFor: #expression:!generated!public! !
!JavaForEachStatementNode categoriesFor: #forToken!generated!public! !
!JavaForEachStatementNode categoriesFor: #forToken:!generated!public! !
!JavaForEachStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaForEachStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaForEachStatementNode categoriesFor: #left!generated!public! !
!JavaForEachStatementNode categoriesFor: #left:!generated!public! !
!JavaForEachStatementNode categoriesFor: #modifiers!generated!public! !
!JavaForEachStatementNode categoriesFor: #modifiers:!generated!public! !
!JavaForEachStatementNode categoriesFor: #name!generated!public! !
!JavaForEachStatementNode categoriesFor: #name:!generated!public! !
!JavaForEachStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaForEachStatementNode categoriesFor: #right!generated!public! !
!JavaForEachStatementNode categoriesFor: #right:!generated!public! !
!JavaForEachStatementNode categoriesFor: #statement!generated!public! !
!JavaForEachStatementNode categoriesFor: #statement:!generated!public! !
!JavaForEachStatementNode categoriesFor: #tokenVariables!generated!public! !
!JavaForEachStatementNode categoriesFor: #type!generated!public! !
!JavaForEachStatementNode categoriesFor: #type:!generated!public! !

JavaForStatementNode guid: (GUID fromString: '{6E215789-AB60-4C64-90DA-64CE2A75CCCC}')!
JavaForStatementNode comment: ''!
!JavaForStatementNode categoriesForClass!Unclassified! !
!JavaForStatementNode methodsFor!

_update
	^_update!

_update: aJavaStatementExpressionListNode
	self _update notNil ifTrue: [self _update parent: nil].
	_update := aJavaStatementExpressionListNode.
	self _update notNil ifTrue: [self _update parent: self]!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForStatement: self!

firstSemicolon
	^firstSemicolon!

firstSemicolon: aSmaCCToken
	firstSemicolon := aSmaCCToken!

forToken
	^forToken!

forToken: aSmaCCToken
	forToken := aSmaCCToken!

ignoredTokenVariables
	^#(#left #right)!

initial
	^initial!

initial: aJavaProgramNode
	self initial notNil ifTrue: [self initial parent: nil].
	initial := aJavaProgramNode.
	self initial notNil ifTrue: [self initial parent: self]!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#initial #test #_update #statement)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

secondSemicolon
	^secondSemicolon!

secondSemicolon: aSmaCCToken
	secondSemicolon := aSmaCCToken!

statement
	^statement!

statement: aJavaStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJavaStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

test
	^test!

test: aJavaExpressionNode
	self test notNil ifTrue: [self test parent: nil].
	test := aJavaExpressionNode.
	self test notNil ifTrue: [self test parent: self]!

tokenVariables
	^#(#forToken #firstSemicolon #secondSemicolon)! !
!JavaForStatementNode categoriesFor: #_update!generated!public! !
!JavaForStatementNode categoriesFor: #_update:!generated!public! !
!JavaForStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaForStatementNode categoriesFor: #firstSemicolon!generated!public! !
!JavaForStatementNode categoriesFor: #firstSemicolon:!generated!public! !
!JavaForStatementNode categoriesFor: #forToken!generated!public! !
!JavaForStatementNode categoriesFor: #forToken:!generated!public! !
!JavaForStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaForStatementNode categoriesFor: #initial!generated!public! !
!JavaForStatementNode categoriesFor: #initial:!generated!public! !
!JavaForStatementNode categoriesFor: #left!generated!public! !
!JavaForStatementNode categoriesFor: #left:!generated!public! !
!JavaForStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaForStatementNode categoriesFor: #right!generated!public! !
!JavaForStatementNode categoriesFor: #right:!generated!public! !
!JavaForStatementNode categoriesFor: #secondSemicolon!generated!public! !
!JavaForStatementNode categoriesFor: #secondSemicolon:!generated!public! !
!JavaForStatementNode categoriesFor: #statement!generated!public! !
!JavaForStatementNode categoriesFor: #statement:!generated!public! !
!JavaForStatementNode categoriesFor: #test!generated!public! !
!JavaForStatementNode categoriesFor: #test:!generated!public! !
!JavaForStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaIfStatementNode guid: (GUID fromString: '{82531E0F-0101-4FDC-82E5-24F4C088B9BD}')!
JavaIfStatementNode comment: ''!
!JavaIfStatementNode categoriesForClass!Unclassified! !
!JavaIfStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIfStatement: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ifToken
	^ifToken!

ifToken: aSmaCCToken
	ifToken := aSmaCCToken!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression #trueStatement)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#ifToken)!

trueStatement
	^trueStatement!

trueStatement: aJavaStatementNode
	self trueStatement notNil ifTrue: [self trueStatement parent: nil].
	trueStatement := aJavaStatementNode.
	self trueStatement notNil ifTrue: [self trueStatement parent: self]! !
!JavaIfStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaIfStatementNode categoriesFor: #expression!generated!public! !
!JavaIfStatementNode categoriesFor: #expression:!generated!public! !
!JavaIfStatementNode categoriesFor: #ifToken!generated!public! !
!JavaIfStatementNode categoriesFor: #ifToken:!generated!public! !
!JavaIfStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaIfStatementNode categoriesFor: #left!generated!public! !
!JavaIfStatementNode categoriesFor: #left:!generated!public! !
!JavaIfStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaIfStatementNode categoriesFor: #right!generated!public! !
!JavaIfStatementNode categoriesFor: #right:!generated!public! !
!JavaIfStatementNode categoriesFor: #tokenVariables!generated!public! !
!JavaIfStatementNode categoriesFor: #trueStatement!generated!public! !
!JavaIfStatementNode categoriesFor: #trueStatement:!generated!public! !

JavaLabeledStatementNode guid: (GUID fromString: '{3792CBF3-4B20-412C-803B-47D3DC54F53B}')!
JavaLabeledStatementNode comment: ''!
!JavaLabeledStatementNode categoriesForClass!Unclassified! !
!JavaLabeledStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLabeledStatement: self!

colon
	^colon!

colon: aSmaCCToken
	colon := aSmaCCToken!

identifier
	^identifier!

identifier: aSmaCCToken
	identifier := aSmaCCToken!

nodeVariables
	^#(#statement)!

statement
	^statement!

statement: aJavaStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJavaStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#identifier #colon)! !
!JavaLabeledStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaLabeledStatementNode categoriesFor: #colon!generated!public! !
!JavaLabeledStatementNode categoriesFor: #colon:!generated!public! !
!JavaLabeledStatementNode categoriesFor: #identifier!generated!public! !
!JavaLabeledStatementNode categoriesFor: #identifier:!generated!public! !
!JavaLabeledStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaLabeledStatementNode categoriesFor: #statement!generated!public! !
!JavaLabeledStatementNode categoriesFor: #statement:!generated!public! !
!JavaLabeledStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaLocalVariableDeclarationStatementNode guid: (GUID fromString: '{ACFFDC69-D84B-4F15-8F55-98F29D182F3A}')!
JavaLocalVariableDeclarationStatementNode comment: ''!
!JavaLocalVariableDeclarationStatementNode categoriesForClass!Unclassified! !
!JavaLocalVariableDeclarationStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLocalVariableDeclarationStatement: self!

declaration
	^declaration!

declaration: aJavaLocalVariableDeclarationNode
	self declaration notNil ifTrue: [self declaration parent: nil].
	declaration := aJavaLocalVariableDeclarationNode.
	self declaration notNil ifTrue: [self declaration parent: self]!

ignoredTokenVariables
	^#(#semicolon)!

nodeVariables
	^#(#declaration)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #declaration!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #declaration:!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #semicolon!generated!public! !
!JavaLocalVariableDeclarationStatementNode categoriesFor: #semicolon:!generated!public! !

JavaReturnStatementNode guid: (GUID fromString: '{6714A660-A68D-4D4F-A10E-3EDA8DF96474}')!
JavaReturnStatementNode comment: ''!
!JavaReturnStatementNode categoriesForClass!Unclassified! !
!JavaReturnStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitReturnStatement: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolon)!

nodeVariables
	^#(#expression)!

returnToken
	^returnToken!

returnToken: aSmaCCToken
	returnToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#returnToken)! !
!JavaReturnStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaReturnStatementNode categoriesFor: #expression!generated!public! !
!JavaReturnStatementNode categoriesFor: #expression:!generated!public! !
!JavaReturnStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaReturnStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaReturnStatementNode categoriesFor: #returnToken!generated!public! !
!JavaReturnStatementNode categoriesFor: #returnToken:!generated!public! !
!JavaReturnStatementNode categoriesFor: #semicolon!generated!public! !
!JavaReturnStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaReturnStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaSwitchStatementNode guid: (GUID fromString: '{C0AF5F49-94AD-4FA3-B4E8-C97ADF8F601C}')!
JavaSwitchStatementNode comment: ''!
!JavaSwitchStatementNode categoriesForClass!Unclassified! !
!JavaSwitchStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchStatement: self!

block
	^block!

block: aJavaSwitchBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaSwitchBlockNode.
	self block notNil ifTrue: [self block parent: self]!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression #block)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

switchToken
	^switchToken!

switchToken: aSmaCCToken
	switchToken := aSmaCCToken!

tokenVariables
	^#(#switchToken)! !
!JavaSwitchStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #block!generated!public! !
!JavaSwitchStatementNode categoriesFor: #block:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #expression!generated!public! !
!JavaSwitchStatementNode categoriesFor: #expression:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaSwitchStatementNode categoriesFor: #left!generated!public! !
!JavaSwitchStatementNode categoriesFor: #left:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaSwitchStatementNode categoriesFor: #right!generated!public! !
!JavaSwitchStatementNode categoriesFor: #right:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #switchToken!generated!public! !
!JavaSwitchStatementNode categoriesFor: #switchToken:!generated!public! !
!JavaSwitchStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaSynchronizedStatementNode guid: (GUID fromString: '{CB68DCFF-96E1-4927-93F6-B6451573868F}')!
JavaSynchronizedStatementNode comment: ''!
!JavaSynchronizedStatementNode categoriesForClass!Unclassified! !
!JavaSynchronizedStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSynchronizedStatement: self!

block
	^block!

block: aJavaBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaBlockNode.
	self block notNil ifTrue: [self block parent: self]!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression #block)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

synchronizedToken
	^synchronizedToken!

synchronizedToken: aSmaCCToken
	synchronizedToken := aSmaCCToken!

tokenVariables
	^#(#synchronizedToken)! !
!JavaSynchronizedStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #block!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #block:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #expression!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #expression:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #left!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #left:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #right!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #right:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #synchronizedToken!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #synchronizedToken:!generated!public! !
!JavaSynchronizedStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaThrowStatementNode guid: (GUID fromString: '{EB647C85-EED7-4304-8022-2108595FFA40}')!
JavaThrowStatementNode comment: ''!
!JavaThrowStatementNode categoriesForClass!Unclassified! !
!JavaThrowStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThrowStatement: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#semicolon)!

nodeVariables
	^#(#expression)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

throwToken
	^throwToken!

throwToken: aSmaCCToken
	throwToken := aSmaCCToken!

tokenVariables
	^#(#throwToken)! !
!JavaThrowStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaThrowStatementNode categoriesFor: #expression!generated!public! !
!JavaThrowStatementNode categoriesFor: #expression:!generated!public! !
!JavaThrowStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaThrowStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaThrowStatementNode categoriesFor: #semicolon!generated!public! !
!JavaThrowStatementNode categoriesFor: #semicolon:!generated!public! !
!JavaThrowStatementNode categoriesFor: #throwToken!generated!public! !
!JavaThrowStatementNode categoriesFor: #throwToken:!generated!public! !
!JavaThrowStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaTryStatementNode guid: (GUID fromString: '{92AC65F7-1AB9-4FCA-A964-AFE40D8D117E}')!
JavaTryStatementNode comment: ''!
!JavaTryStatementNode categoriesForClass!Unclassified! !
!JavaTryStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTryStatement: self!

block
	^block!

block: aJavaBlockNode
	self block notNil ifTrue: [self block parent: nil].
	block := aJavaBlockNode.
	self block notNil ifTrue: [self block parent: self]!

catches
	^catches!

catches: anOrderedCollection
	self setParents: self catches to: nil.
	catches := anOrderedCollection.
	self setParents: self catches to: self!

compositeNodeVariables
	^#(#catches)!

finally
	^finally!

finally: aJavaFinallyClauseNode
	self finally notNil ifTrue: [self finally parent: nil].
	finally := aJavaFinallyClauseNode.
	self finally notNil ifTrue: [self finally parent: self]!

initialize
	super initialize.
	catches := OrderedCollection new: 2.!

nodeVariables
	^#(#block #finally)!

tokenVariables
	^#(#tryToken)!

tryToken
	^tryToken!

tryToken: aSmaCCToken
	tryToken := aSmaCCToken! !
!JavaTryStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaTryStatementNode categoriesFor: #block!generated!public! !
!JavaTryStatementNode categoriesFor: #block:!generated!public! !
!JavaTryStatementNode categoriesFor: #catches!generated!public! !
!JavaTryStatementNode categoriesFor: #catches:!generated!public! !
!JavaTryStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JavaTryStatementNode categoriesFor: #finally!generated!public! !
!JavaTryStatementNode categoriesFor: #finally:!generated!public! !
!JavaTryStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaTryStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaTryStatementNode categoriesFor: #tokenVariables!generated!public! !
!JavaTryStatementNode categoriesFor: #tryToken!generated!public! !
!JavaTryStatementNode categoriesFor: #tryToken:!generated!public! !

JavaWhileStatementNode guid: (GUID fromString: '{205EE1F6-D9D2-494F-BE90-E2229FEA34F1}')!
JavaWhileStatementNode comment: ''!
!JavaWhileStatementNode categoriesForClass!Unclassified! !
!JavaWhileStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitWhileStatement: self!

expression
	^expression!

expression: aJavaExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJavaExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ignoredTokenVariables
	^#(#left #right)!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

statement
	^statement!

statement: aJavaStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJavaStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#whileToken)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!JavaWhileStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaWhileStatementNode categoriesFor: #expression!generated!public! !
!JavaWhileStatementNode categoriesFor: #expression:!generated!public! !
!JavaWhileStatementNode categoriesFor: #ignoredTokenVariables!generated!public! !
!JavaWhileStatementNode categoriesFor: #left!generated!public! !
!JavaWhileStatementNode categoriesFor: #left:!generated!public! !
!JavaWhileStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaWhileStatementNode categoriesFor: #right!generated!public! !
!JavaWhileStatementNode categoriesFor: #right:!generated!public! !
!JavaWhileStatementNode categoriesFor: #statement!generated!public! !
!JavaWhileStatementNode categoriesFor: #statement:!generated!public! !
!JavaWhileStatementNode categoriesFor: #tokenVariables!generated!public! !
!JavaWhileStatementNode categoriesFor: #whileToken!generated!public! !
!JavaWhileStatementNode categoriesFor: #whileToken:!generated!public! !

JavaIfElseStatementNode guid: (GUID fromString: '{DE15B9AA-E8E0-468B-AE87-63C400FA7D7A}')!
JavaIfElseStatementNode comment: ''!
!JavaIfElseStatementNode categoriesForClass!Unclassified! !
!JavaIfElseStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIfElseStatement: self!

elseToken
	^elseToken!

elseToken: aSmaCCToken
	elseToken := aSmaCCToken!

falseStatement
	^falseStatement!

falseStatement: aJavaStatementNode
	self falseStatement notNil ifTrue: [self falseStatement parent: nil].
	falseStatement := aJavaStatementNode.
	self falseStatement notNil ifTrue: [self falseStatement parent: self]!

nodeVariables
	^#(#falseStatement #expression #trueStatement)!

tokenVariables
	^#(#elseToken #ifToken)! !
!JavaIfElseStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaIfElseStatementNode categoriesFor: #elseToken!generated!public! !
!JavaIfElseStatementNode categoriesFor: #elseToken:!generated!public! !
!JavaIfElseStatementNode categoriesFor: #falseStatement!generated!public! !
!JavaIfElseStatementNode categoriesFor: #falseStatement:!generated!public! !
!JavaIfElseStatementNode categoriesFor: #nodeVariables!generated!public! !
!JavaIfElseStatementNode categoriesFor: #tokenVariables!generated!public! !

JavaArrayTypeNode guid: (GUID fromString: '{0CAEA1A8-8E65-4DEB-B21A-185654C5BD1F}')!
JavaArrayTypeNode comment: ''!
!JavaArrayTypeNode categoriesForClass!Unclassified! !
!JavaArrayTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayType: self!

baseType
	^baseType!

baseType: aJavaProgramNode
	self baseType notNil ifTrue: [self baseType parent: nil].
	baseType := aJavaProgramNode.
	self baseType notNil ifTrue: [self baseType parent: self]!

ignoredCompositeTokenVariables
	^#(#lefts #rights)!

initialize
	super initialize.
	lefts := OrderedCollection new: 2.
	rights := OrderedCollection new: 2.!

lefts
	^lefts!

lefts: anOrderedCollection
	lefts := anOrderedCollection!

nodeVariables
	^#(#baseType)!

rights
	^rights!

rights: anOrderedCollection
	rights := anOrderedCollection! !
!JavaArrayTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaArrayTypeNode categoriesFor: #baseType!generated!public! !
!JavaArrayTypeNode categoriesFor: #baseType:!generated!public! !
!JavaArrayTypeNode categoriesFor: #ignoredCompositeTokenVariables!generated!public! !
!JavaArrayTypeNode categoriesFor: #initialize!generated-initialize-release!public! !
!JavaArrayTypeNode categoriesFor: #lefts!generated!public! !
!JavaArrayTypeNode categoriesFor: #lefts:!generated!public! !
!JavaArrayTypeNode categoriesFor: #nodeVariables!generated!public! !
!JavaArrayTypeNode categoriesFor: #rights!generated!public! !
!JavaArrayTypeNode categoriesFor: #rights:!generated!public! !

JavaClassTypeNode guid: (GUID fromString: '{E099642F-427A-401C-8440-3013C95BDFC0}')!
JavaClassTypeNode comment: ''!
!JavaClassTypeNode categoriesForClass!Unclassified! !
!JavaClassTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitClassType: self!

name
	^name!

name: aJavaProgramNode
	self name notNil ifTrue: [self name parent: nil].
	name := aJavaProgramNode.
	self name notNil ifTrue: [self name parent: self]!

nodeVariables
	^#(#name)! !
!JavaClassTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaClassTypeNode categoriesFor: #name!generated!public! !
!JavaClassTypeNode categoriesFor: #name:!generated!public! !
!JavaClassTypeNode categoriesFor: #nodeVariables!generated!public! !

JavaPrimitiveTypeNode guid: (GUID fromString: '{E96AA99E-D550-4616-92F7-3A0914A890E5}')!
JavaPrimitiveTypeNode comment: ''!
!JavaPrimitiveTypeNode categoriesForClass!Unclassified! !
!JavaPrimitiveTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPrimitiveType: self!

token
	^token!

token: aSmaCCToken
	token := aSmaCCToken!

tokenVariables
	^#(#token)! !
!JavaPrimitiveTypeNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaPrimitiveTypeNode categoriesFor: #token!generated!public! !
!JavaPrimitiveTypeNode categoriesFor: #token:!generated!public! !
!JavaPrimitiveTypeNode categoriesFor: #tokenVariables!generated!public! !

JavaBooleanTypeNode guid: (GUID fromString: '{3B46C28F-E919-45DF-BFDD-CCC236692812}')!
JavaBooleanTypeNode comment: ''!
!JavaBooleanTypeNode categoriesForClass!Unclassified! !
!JavaBooleanTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBooleanType: self! !
!JavaBooleanTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaByteTypeNode guid: (GUID fromString: '{8B257C86-B8B1-464B-B0E0-93BC836F316E}')!
JavaByteTypeNode comment: ''!
!JavaByteTypeNode categoriesForClass!Unclassified! !
!JavaByteTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitByteType: self! !
!JavaByteTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaCharTypeNode guid: (GUID fromString: '{54A82B13-9AC9-472B-8F60-A6F0DC57A56F}')!
JavaCharTypeNode comment: ''!
!JavaCharTypeNode categoriesForClass!Unclassified! !
!JavaCharTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCharType: self! !
!JavaCharTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaDoubleTypeNode guid: (GUID fromString: '{74C8C9C4-A0A6-48AA-A807-21990C34D7FA}')!
JavaDoubleTypeNode comment: ''!
!JavaDoubleTypeNode categoriesForClass!Unclassified! !
!JavaDoubleTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDoubleType: self! !
!JavaDoubleTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaFloatTypeNode guid: (GUID fromString: '{6B5C60B6-C7BE-40AF-8281-16344552D2BD}')!
JavaFloatTypeNode comment: ''!
!JavaFloatTypeNode categoriesForClass!Unclassified! !
!JavaFloatTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFloatType: self! !
!JavaFloatTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaIntTypeNode guid: (GUID fromString: '{53278D43-70B9-408B-96D9-99BBA6C426B1}')!
JavaIntTypeNode comment: ''!
!JavaIntTypeNode categoriesForClass!Unclassified! !
!JavaIntTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIntType: self! !
!JavaIntTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaLongTypeNode guid: (GUID fromString: '{D905E7EB-D097-4946-9344-ABB4146ED3C2}')!
JavaLongTypeNode comment: ''!
!JavaLongTypeNode categoriesForClass!Unclassified! !
!JavaLongTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLongType: self! !
!JavaLongTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaShortTypeNode guid: (GUID fromString: '{13DE8D8B-43A9-46FF-B647-1EBAC32A512D}')!
JavaShortTypeNode comment: ''!
!JavaShortTypeNode categoriesForClass!Unclassified! !
!JavaShortTypeNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitShortType: self! !
!JavaShortTypeNode categoriesFor: #acceptVisitor:!generated!public! !

JavaInitializedVariableDeclarationNode guid: (GUID fromString: '{6D627C18-95C8-46C1-B43F-DD05E3F69581}')!
JavaInitializedVariableDeclarationNode comment: ''!
!JavaInitializedVariableDeclarationNode categoriesForClass!Unclassified! !
!JavaInitializedVariableDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitInitializedVariableDeclaration: self!

equals
	^equals!

equals: aSmaCCToken
	equals := aSmaCCToken!

initializer
	^initializer!

initializer: aJavaProgramNode
	self initializer notNil ifTrue: [self initializer parent: nil].
	initializer := aJavaProgramNode.
	self initializer notNil ifTrue: [self initializer parent: self]!

nodeVariables
	^#(#initializer #variable)!

tokenVariables
	^#(#equals)! !
!JavaInitializedVariableDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #equals!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #equals:!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #initializer!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #initializer:!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JavaInitializedVariableDeclarationNode categoriesFor: #tokenVariables!generated!public! !

JavaProgramNodeVisitor guid: (GUID fromString: '{A98AB771-F2C4-450C-8D75-0E81931F30CA}')!
JavaProgramNodeVisitor comment: ''!
!JavaProgramNodeVisitor categoriesForClass!Unclassified! !
!JavaProgramNodeVisitor methodsFor!

visitAbstractMethodDeclaration: anAbstractMethodDeclaration
	^self visitProgram: anAbstractMethodDeclaration!

visitAnnotation: anAnnotation
	^self visitProgram: anAnnotation!

visitAnnotationInterface: anAnnotationInterface
	^self visitProgram: anAnnotationInterface!

visitAnnotationMethodDeclaration: anAnnotationMethodDeclaration
	^self visitAbstractMethodDeclaration: anAnnotationMethodDeclaration!

visitArrayAccess: anArrayAccess
	^self visitExpression: anArrayAccess!

visitArrayInitializer: anArrayInitializer
	^self visitProgram: anArrayInitializer!

visitArrayMethodDeclarator: anArrayMethodDeclarator
	^self visitProgram: anArrayMethodDeclarator!

visitArrayType: anArrayType
	^self visitType: anArrayType!

visitArrayVariableName: anArrayVariableName
	^self visitProgram: anArrayVariableName!

visitAssertStatement: anAssertStatement
	^self visitStatement: anAssertStatement!

visitAssignment: anAssignment
	^self visitExpression: anAssignment!

visitBinaryExpression: aBinaryExpression
	^self visitExpression: aBinaryExpression!

visitBlock: aBlock
	^self visitStatement: aBlock!

visitBooleanLiteral: aBooleanLiteral
	^self visitLiteral: aBooleanLiteral!

visitBooleanType: aBooleanType
	^self visitPrimitiveType: aBooleanType!

visitBreakStatement: aBreakStatement
	^self visitStatement: aBreakStatement!

visitByteType: aByteType
	^self visitPrimitiveType: aByteType!

visitCastExpression: aCastExpression
	^self visitExpression: aCastExpression!

visitCatchClause: aCatchClause
	^self visitProgram: aCatchClause!

visitCharacterLiteral: aCharacterLiteral
	^self visitLiteral: aCharacterLiteral!

visitCharType: aCharType
	^self visitPrimitiveType: aCharType!

visitClassDeclaration: aClassDeclaration
	^self visitProgram: aClassDeclaration!

visitClassProperty: aClassProperty
	^self visitExpression: aClassProperty!

visitClassType: aClassType
	^self visitType: aClassType!

visitConditionalExpression: aConditionalExpression
	^self visitExpression: aConditionalExpression!

visitConstructorBody: aConstructorBody
	^self visitProgram: aConstructorBody!

visitConstructorDeclaration: aConstructorDeclaration
	^self visitProgram: aConstructorDeclaration!

visitContinueStatement: aContinueStatement
	^self visitStatement: aContinueStatement!

visitDefaultLabel: aDefaultLabel
	^self visitProgram: aDefaultLabel!

visitDimensionExpression: aDimensionExpression
	^self visitProgram: aDimensionExpression!

visitDoubleType: aDoubleType
	^self visitPrimitiveType: aDoubleType!

visitDoWhileStatement: aDoWhileStatement
	^self visitStatement: aDoWhileStatement!

visitElementArrayInitializer: anElementArrayInitializer
	^self visitProgram: anElementArrayInitializer!

visitElementValuePair: anElementValuePair
	^self visitProgram: anElementValuePair!

visitEmptyDeclaration: anEmptyDeclaration
	^self visitProgram: anEmptyDeclaration!

visitEmptyMethodBody: anEmptyMethodBody
	^self visitProgram: anEmptyMethodBody!

visitEmptyStatement: anEmptyStatement
	^self visitStatement: anEmptyStatement!

visitEnumConstant: anEnumConstant
	^self visitProgram: anEnumConstant!

visitEnumDeclaration: anEnumDeclaration
	^self visitProgram: anEnumDeclaration!

visitExpression: anExpression
	^self visitProgram: anExpression!

visitExpressionStatement: anExpressionStatement
	^self visitStatement: anExpressionStatement!

visitFieldAccess: aFieldAccess
	^self visitExpression: aFieldAccess!

visitFieldDeclaration: aFieldDeclaration
	^self visitProgram: aFieldDeclaration!

visitFinallyClause: aFinallyClause
	^self visitProgram: aFinallyClause!

visitFloatLiteral: aFloatLiteral
	^self visitLiteral: aFloatLiteral!

visitFloatType: aFloatType
	^self visitPrimitiveType: aFloatType!

visitForEachStatement: aForEachStatement
	^self visitStatement: aForEachStatement!

visitForStatement: aForStatement
	^self visitStatement: aForStatement!

visitIfElseStatement: anIfElseStatement
	^self visitIfStatement: anIfElseStatement!

visitIfStatement: anIfStatement
	^self visitStatement: anIfStatement!

visitInitializedVariableDeclaration: anInitializedVariableDeclaration
	^self visitVariableDeclaration: anInitializedVariableDeclaration!

visitIntegerLiteral: anIntegerLiteral
	^self visitLiteral: anIntegerLiteral!

visitInterface: anInterface
	^self visitProgram: anInterface!

visitIntType: anIntType
	^self visitPrimitiveType: anIntType!

visitLabeledStatement: aLabeledStatement
	^self visitStatement: aLabeledStatement!

visitLambdaExpression: aLambdaExpression
	^self visitExpression: aLambdaExpression!

visitLiteral: aLiteral
	^self visitExpression: aLiteral!

visitLocalVariableDeclaration: aLocalVariableDeclaration
	^self visitProgram: aLocalVariableDeclaration!

visitLocalVariableDeclarationStatement: aLocalVariableDeclarationStatement
	^self visitStatement: aLocalVariableDeclarationStatement!

visitLongType: aLongType
	^self visitPrimitiveType: aLongType!

visitMethodDeclaration: aMethodDeclaration
	^self visitProgram: aMethodDeclaration!

visitMethodDeclarator: aMethodDeclarator
	^self visitProgram: aMethodDeclarator!

visitMethodInvocation: aMethodInvocation
	^self visitExpression: aMethodInvocation!

visitModifier: aModifier
	^self visitProgram: aModifier!

visitName: aName
	^self visitExpression: aName!

visitNew: aNew
	^self visitExpression: aNew!

visitNewArray: aNewArray
	^self visitExpression: aNewArray!

visitNewClass: aNewClass
	^self visitNew: aNewClass!

visitNull: aNull
	^self visitLiteral: aNull!

visitPackageDeclaration: aPackageDeclaration
	^self visitProgram: aPackageDeclaration!

visitParameter: aParameter
	^self visitProgram: aParameter!

visitPostDecrementExpression: aPostDecrementExpression
	^self visitExpression: aPostDecrementExpression!

visitPostIncrementExpression: aPostIncrementExpression
	^self visitExpression: aPostIncrementExpression!

visitPreDecrementExpression: aPreDecrementExpression
	^self visitExpression: aPreDecrementExpression!

visitPreIncrementExpression: aPreIncrementExpression
	^self visitExpression: aPreIncrementExpression!

visitPrimitiveType: aPrimitiveType
	^self visitType: aPrimitiveType!

visitProgram: aProgram
	^self visitSmaCCParseNode: aProgram!

visitProgramFile: aProgramFile
	^self visitProgram: aProgramFile!

visitQualifiedName: aQualifiedName
	^self visitName: aQualifiedName!

visitQualifiedTypeName: aQualifiedTypeName
	^self visitProgram: aQualifiedTypeName!

visitReturnStatement: aReturnStatement
	^self visitStatement: aReturnStatement!

visitShortType: aShortType
	^self visitPrimitiveType: aShortType!

visitSingleTypeImportDeclaration: aSingleTypeImportDeclaration
	^self visitProgram: aSingleTypeImportDeclaration!

visitStatement: aStatement
	^self visitProgram: aStatement!

visitStatementExpressionList: aStatementExpressionList
	^self visitProgram: aStatementExpressionList!

visitStaticInitializer: aStaticInitializer
	^self visitProgram: aStaticInitializer!

visitStringLiteral: aStringLiteral
	^self visitLiteral: aStringLiteral!

visitSuperConstructorInvocation: aSuperConstructorInvocation
	^self visitProgram: aSuperConstructorInvocation!

visitSwitchBlock: aSwitchBlock
	^self visitProgram: aSwitchBlock!

visitSwitchBlockStatementGroup: aSwitchBlockStatementGroup
	^self visitProgram: aSwitchBlockStatementGroup!

visitSwitchLabel: aSwitchLabel
	^self visitProgram: aSwitchLabel!

visitSwitchStatement: aSwitchStatement
	^self visitStatement: aSwitchStatement!

visitSynchronizedStatement: aSynchronizedStatement
	^self visitStatement: aSynchronizedStatement!

visitThisConstructorInvocation: aThisConstructorInvocation
	^self visitProgram: aThisConstructorInvocation!

visitThrows: aThrows
	^self visitProgram: aThrows!

visitThrowStatement: aThrowStatement
	^self visitStatement: aThrowStatement!

visitTryStatement: aTryStatement
	^self visitStatement: aTryStatement!

visitType: aType
	^self visitProgram: aType!

visitTypeArgument: aTypeArgument
	^self visitProgram: aTypeArgument!

visitTypeImportOnDemandDeclaration: aTypeImportOnDemandDeclaration
	^self visitSingleTypeImportDeclaration: aTypeImportOnDemandDeclaration!

visitTypeName: aTypeName
	^self visitProgram: aTypeName!

visitTypeParameter: aTypeParameter
	^self visitProgram: aTypeParameter!

visitTypeParameters: aTypeParameters
	^self visitProgram: aTypeParameters!

visitUnaryAddition: anUnaryAddition
	^self visitExpression: anUnaryAddition!

visitUnaryBitInvert: anUnaryBitInvert
	^self visitExpression: anUnaryBitInvert!

visitUnaryNot: anUnaryNot
	^self visitExpression: anUnaryNot!

visitUnarySubtraction: anUnarySubtraction
	^self visitExpression: anUnarySubtraction!

visitVariableArgumentParameter: aVariableArgumentParameter
	^self visitParameter: aVariableArgumentParameter!

visitVariableDeclaration: aVariableDeclaration
	^self visitProgram: aVariableDeclaration!

visitVariableName: aVariableName
	^self visitProgram: aVariableName!

visitVoidType: aVoidType
	^self visitProgram: aVoidType!

visitWhileStatement: aWhileStatement
	^self visitStatement: aWhileStatement! !
!JavaProgramNodeVisitor categoriesFor: #visitAbstractMethodDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitAnnotation:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitAnnotationInterface:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitAnnotationMethodDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitArrayAccess:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitArrayInitializer:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitArrayMethodDeclarator:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitArrayType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitArrayVariableName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitAssertStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitAssignment:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitBinaryExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitBlock:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitBooleanLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitBooleanType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitBreakStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitByteType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitCastExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitCatchClause:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitCharacterLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitCharType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitClassDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitClassProperty:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitClassType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitConditionalExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitConstructorBody:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitConstructorDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitContinueStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitDefaultLabel:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitDimensionExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitDoubleType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitDoWhileStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitElementArrayInitializer:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitElementValuePair:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitEmptyDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitEmptyMethodBody:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitEmptyStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitEnumConstant:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitEnumDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitExpressionStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitFieldAccess:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitFieldDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitFinallyClause:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitFloatLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitFloatType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitForEachStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitForStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitIfElseStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitIfStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitInitializedVariableDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitIntegerLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitInterface:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitIntType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLabeledStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLambdaExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLocalVariableDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLocalVariableDeclarationStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitLongType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitMethodDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitMethodDeclarator:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitMethodInvocation:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitModifier:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitNew:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitNewArray:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitNewClass:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitNull:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPackageDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitParameter:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPostDecrementExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPostIncrementExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPreDecrementExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPreIncrementExpression:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitPrimitiveType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitProgram:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitProgramFile:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitQualifiedName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitQualifiedTypeName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitReturnStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitShortType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSingleTypeImportDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitStatementExpressionList:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitStaticInitializer:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitStringLiteral:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSuperConstructorInvocation:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSwitchBlock:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSwitchBlockStatementGroup:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSwitchLabel:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSwitchStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitSynchronizedStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitThisConstructorInvocation:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitThrows:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitThrowStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTryStatement:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTypeArgument:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTypeImportOnDemandDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTypeName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTypeParameter:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitTypeParameters:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitUnaryAddition:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitUnaryBitInvert:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitUnaryNot:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitUnarySubtraction:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitVariableArgumentParameter:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitVariableDeclaration:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitVariableName:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitVoidType:!generated!public! !
!JavaProgramNodeVisitor categoriesFor: #visitWhileStatement:!generated!public! !

JavaParser guid: (GUID fromString: '{34FE368F-5819-422A-A5AB-61BFCF69446F}')!
JavaParser comment: ''!
!JavaParser categoriesForClass!Unclassified! !
!JavaParser methodsFor!

ambiguousTransitions
^#(
#[ 0 6 0 10] 
#[ 0 18 0 57] 
#[ 0 18 0 85] 
#[ 0 18 0 89] 
#[ 0 18 0 93] 
#[ 0 18 0 97] 
#[ 0 18 0 101] 
#[ 0 18 0 105] 
#[ 0 18 0 109] 
#[ 0 18 0 113] 
#[ 0 18 0 129] 
#[ 0 18 0 22 0 229] 
#[ 0 22 1 237] 
#[ 0 14 0 57] 
#[ 0 22 0 229] 
#[ 0 22 3 49] 
#[ 0 22 0 122] 
#[ 0 57 0 158] 
#[ 0 18 0 22 1 237] 
#[ 0 122 0 194] 
#[ 0 22 0 122 0 194] 
#[ 0 122 0 153] 
#[ 0 202 0 206] 
#[ 0 226 4 29] 
#[ 0 226 4 33] 
#[ 0 226 4 37] 
#[ 0 230 4 41] 
#[ 0 230 4 45] 
#[ 0 234 4 49] 
#[ 0 234 4 53] 
#[ 0 234 4 57] 
#[ 0 238 4 61] 
#[ 0 238 4 65] 
#[ 0 238 4 69] 
#[ 0 238 4 73] 
#[ 0 238 4 77] 
#[ 0 242 4 81] 
#[ 0 242 4 85] 
#[ 0 246 4 89] 
#[ 0 250 4 93] 
#[ 0 254 4 97] 
#[ 1 2 4 101] 
#[ 1 6 4 105] 
#[ 1 6 4 109] 
#[ 0 22 4 165] 
#[ 0 22 0 153] 
#[ 0 18 0 22 3 49] 
#[ 0 22 5 93] 
#[ 0 22 5 137] 
#[ 0 22 6 41] 
#[ 0 18 5 117] 
#[ 2 110 4 29] 
#[ 2 110 4 33] 
#[ 2 110 4 37] 
#[ 2 114 4 41] 
#[ 2 114 4 45] 
#[ 2 118 4 49] 
#[ 2 118 4 53] 
#[ 2 118 4 57] 
#[ 2 122 4 61] 
#[ 2 122 4 65] 
#[ 2 122 4 69] 
#[ 2 122 4 73] 
#[ 2 122 4 77] 
#[ 2 126 4 81] 
#[ 2 126 4 85] 
#[ 2 130 4 89] 
#[ 2 134 4 93] 
#[ 2 138 4 97] 
#[ 2 142 4 101] 
#[ 0 122 7 53] 
#[ 0 22 7 153] 
#[ 3 2 8 13] 
#[ 3 186 9 141] 
#[ 0 85 2 62] 
#[ 0 89 2 62] 
#[ 0 93 2 62] 
#[ 0 97 2 62] 
#[ 0 101 2 62] 
#[ 0 105 2 62] 
#[ 0 109 2 62] 
#[ 0 113 2 62] 
#[ 2 62 2 201]
	).!

performParsingStep
	| actions position token |
	(currentToken value = '>>' or: [currentToken value = '>>>'])
		ifTrue:
			[actions := OrderedCollection new.
			self addActionsFor: scanner GREATER_THANId to: actions.
			actions notEmpty
				ifTrue:
					[position := scanner position.
					token := currentToken.
					scanner position: scanner position - (currentToken value size - 1).
					currentToken := SmaCCToken
						value: '>'
						start: currentToken startPosition
						ids: (Array with: scanner GREATER_THANId).
					actions do: [:each | self splitWithAction: each].
					currentToken := token.
					scanner position: position]].
	^super performParsingStep!

reduceActionForabstract_method_declaration1: nodes
	| result |
	result := JavaAbstractMethodDeclarationNode new.
	result addNodes: ((nodes at: 1) at: 1) to: result modifiers.
	result typeParameters: ((nodes at: 1) at: 2).
	result type: ((nodes at: 1) at: 3).
	result declarator: ((nodes at: 1) at: 4).
	result throws: ((nodes at: 1) at: 5).
	result semicolon: (nodes at: 2).
	^result!

reduceActionForannotation_interface_body1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	result at: 3 put: (nodes at: 3).
	^result!

reduceActionForannotation_interface_declaration1: nodes
	| result |
	result := JavaAnnotationInterfaceNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result atToken: (nodes at: 2).
	result interfaceToken: (nodes at: 3).
	result name: (nodes at: 4).
	result left: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result declarations.
	result right: ((nodes at: 5) at: 3).
	^result!

reduceActionForannotation_method_declaration2: nodes
	| result |
	result := JavaAnnotationMethodDeclarationNode new.
	result addNodes: ((nodes at: 1) at: 1) to: result modifiers.
	result typeParameters: ((nodes at: 1) at: 2).
	result type: ((nodes at: 1) at: 3).
	result declarator: ((nodes at: 1) at: 4).
	result throws: ((nodes at: 1) at: 5).
	result defaultToken: (nodes at: 2).
	result value: (nodes at: 3).
	result semicolon: (nodes at: 4).
	^result!

reduceActionForannotation1: nodes
	| result |
	result := JavaAnnotationNode new.
	result _at: (nodes at: 1).
	result name: (nodes at: 2).
	result left: ((nodes at: 3) at: 1).
	result addNodes: ((nodes at: 3) at: 2) to: result values.
	result addTokens: ((nodes at: 3) at: 3) to: result commas.
	result right: ((nodes at: 3) at: 4).
	^result!

reduceActionForannotations1: nodes
	| result |
	result := OrderedCollection new: 2.
	^result!

reduceActionForannotations2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	self add: (nodes at: 2) to: result.
	^result!

reduceActionForarray_access1: nodes
	| result |
	result := JavaArrayAccessNode new.
	result array: (nodes at: 1).
	result addToken: (nodes at: 2) to: result lefts.
	result expression: (nodes at: 3).
	result addToken: (nodes at: 4) to: result rights.
	^result!

reduceActionForarray_creation_expression1: nodes
	| result |
	result := JavaNewArrayNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result dimExpressions.
	result addTokens: ((nodes at: 4) at: 1) to: result lefts.
	result addTokens: ((nodes at: 4) at: 2) to: result rights.
	^result!

reduceActionForarray_creation_expression3: nodes
	| result |
	result := JavaNewArrayNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result addTokens: ((nodes at: 3) at: 1) to: result lefts.
	result addTokens: ((nodes at: 3) at: 2) to: result rights.
	result initializer: (nodes at: 4).
	^result!

reduceActionForarray_initializer1: nodes
	| result |
	result := JavaArrayInitializerNode new.
	result left: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result addToken: (nodes at: 3) to: result commas.
	result right: (nodes at: 4).
	^result!

reduceActionForarray_initializer2: nodes
	| result |
	result := JavaArrayInitializerNode new.
	result left: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result initializers.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result right: (nodes at: 3).
	^result!

reduceActionForarray_initializer3: nodes
	| result |
	result := JavaArrayInitializerNode new.
	result left: (nodes at: 1).
	result addToken: (nodes at: 2) to: result commas.
	result right: (nodes at: 3).
	^result!

reduceActionForarray_initializer4: nodes
	| result |
	result := JavaArrayInitializerNode new.
	result left: (nodes at: 1).
	result right: (nodes at: 2).
	^result!

reduceActionForarray_type1: nodes
	| result |
	result := JavaArrayTypeNode new.
	result baseType: (nodes at: 1).
	result addTokens: ((nodes at: 2) at: 1) to: result lefts.
	result addTokens: ((nodes at: 2) at: 2) to: result rights.
	^result!

reduceActionForassert_statement1: nodes
	| result |
	result := JavaAssertStatementNode new.
	result assertToken: (nodes at: 1).
	result testExpression: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForassert_statement2: nodes
	| result |
	result := JavaAssertStatementNode new.
	result assertToken: (nodes at: 1).
	result testExpression: (nodes at: 2).
	result colon: (nodes at: 3).
	result messageExpression: (nodes at: 4).
	result semicolon: (nodes at: 5).
	^result!

reduceActionForassignment1: nodes
	| result |
	result := JavaAssignmentNode new.
	result variable: (nodes at: 1).
	result op: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionForblock1: nodes
	| result |
	result := JavaBlockNode new.
	result left: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statements.
	result right: (nodes at: 3).
	^result!

reduceActionForbreak_statement1: nodes
	| result |
	result := JavaBreakStatementNode new.
	result breakToken: (nodes at: 1).
	result identifier: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForcast_expression1: nodes
	| result |
	result := JavaCastExpressionNode new.
	result addToken: (nodes at: 1) to: result lefts.
	result type: (nodes at: 2).
	result addToken: (nodes at: 3) to: result rights.
	result expression: (nodes at: 4).
	^result!

reduceActionForcatch_clause1: nodes
	| result |
	result := JavaCatchClauseNode new.
	result catchToken: (nodes at: 1).
	result left: (nodes at: 2).
	result parameter: (nodes at: 3).
	result right: (nodes at: 4).
	result block: (nodes at: 5).
	^result!

reduceActionForclass_body_opt1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionForclass_body_opt2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	result at: 3 put: ((nodes at: 1) at: 3).
	^result!

reduceActionForclass_declaration1: nodes
	| result |
	result := JavaClassDeclarationNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result classToken: (nodes at: 2).
	result name: (nodes at: 3).
	result typeParameters: (nodes at: 4).
	result extendsToken: ((nodes at: 5) at: 1).
	result superclass: ((nodes at: 5) at: 2).
	result implementsToken: ((nodes at: 6) at: 1).
	result addNodes: ((nodes at: 6) at: 2) to: result interfaces.
	result addTokens: ((nodes at: 6) at: 3) to: result commas.
	result left: ((nodes at: 7) at: 1).
	result addNodes: ((nodes at: 7) at: 2) to: result declarations.
	result right: ((nodes at: 7) at: 3).
	^result!

reduceActionForclass_instance_creation_expression1: nodes
	| result |
	result := JavaNewNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result addToken: (nodes at: 3) to: result lefts.
	result addNodes: ((nodes at: 4) at: 1) to: result expressions.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: (nodes at: 5) to: result rights.
	^result!

reduceActionForclass_instance_creation_expression2: nodes
	| result |
	result := JavaNewClassNode new.
	result newToken: (nodes at: 1).
	result type: (nodes at: 2).
	result addToken: (nodes at: 3) to: result lefts.
	result addNodes: ((nodes at: 4) at: 1) to: result expressions.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: (nodes at: 5) to: result rights.
	result addToken: ((nodes at: 6) at: 1) to: result lefts.
	result addNodes: ((nodes at: 6) at: 2) to: result declarations.
	result addToken: ((nodes at: 6) at: 3) to: result rights.
	^result!

reduceActionForclass_instance_creation_expression3: nodes
	| result |
	result := JavaNewNode new.
	result primary: (nodes at: 1).
	result period: (nodes at: 2).
	result newToken: (nodes at: 3).
	result name: (nodes at: 4).
	result addToken: (nodes at: 5) to: result lefts.
	result addNodes: ((nodes at: 6) at: 1) to: result expressions.
	result addTokens: ((nodes at: 6) at: 2) to: result commas.
	result addToken: (nodes at: 7) to: result rights.
	^result!

reduceActionForclass_instance_creation_expression4: nodes
	| result |
	result := JavaNewClassNode new.
	result primary: (nodes at: 1).
	result period: (nodes at: 2).
	result newToken: (nodes at: 3).
	result name: (nodes at: 4).
	result addToken: (nodes at: 5) to: result lefts.
	result addNodes: ((nodes at: 6) at: 1) to: result expressions.
	result addTokens: ((nodes at: 6) at: 2) to: result commas.
	result addToken: (nodes at: 7) to: result rights.
	result addToken: ((nodes at: 8) at: 1) to: result lefts.
	result addNodes: ((nodes at: 8) at: 2) to: result declarations.
	result addToken: ((nodes at: 8) at: 3) to: result rights.
	^result!

reduceActionForclass_or_interface_type1: nodes
	| result |
	result := JavaClassTypeNode new.
	result name: (nodes at: 1).
	^result!

reduceActionForcompilation_unit1: nodes
	| result |
	result := JavaProgramFileNode new.
	result packageDeclaration: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result imports.
	result addNodes: (nodes at: 3) to: result typeDeclarations.
	^result!

reduceActionForconditional_expression2: nodes
	| result |
	result := JavaConditionalExpressionNode new.
	result testExpression: (nodes at: 1).
	result questionMark: (nodes at: 2).
	result trueExpression: (nodes at: 3).
	result colon: (nodes at: 4).
	result falseExpression: (nodes at: 5).
	^result!

reduceActionForconstructor_body1: nodes
	| result |
	result := JavaConstructorBodyNode new.
	result left: (nodes at: 1).
	result constructorInvocation: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result statements.
	result right: (nodes at: 4).
	^result!

reduceActionForconstructor_body2: nodes
	| result |
	result := JavaConstructorBodyNode new.
	result left: (nodes at: 1).
	result constructorInvocation: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionForconstructor_body3: nodes
	| result |
	result := JavaConstructorBodyNode new.
	result left: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statements.
	result right: (nodes at: 3).
	^result!

reduceActionForconstructor_body4: nodes
	| result |
	result := JavaConstructorBodyNode new.
	result left: (nodes at: 1).
	result right: (nodes at: 2).
	^result!

reduceActionForconstructor_declaration1: nodes
	| result |
	result := JavaConstructorDeclarationNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result typeParameters: ((nodes at: 2) at: 1).
	result name: ((nodes at: 2) at: 2).
	result left: ((nodes at: 2) at: 3).
	result addNodes: ((nodes at: 2) at: 4) to: result parameters.
	result addTokens: ((nodes at: 2) at: 5) to: result commas.
	result right: ((nodes at: 2) at: 6).
	result throws: (nodes at: 3).
	result body: (nodes at: 4).
	^result!

reduceActionForconstructor_declarator1: nodes
	| result |
	result := Array new: 6.
	result at: 4 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	self addAll: ((nodes at: 4) at: 1) to: (result at: 4).
	self addAll: ((nodes at: 4) at: 2) to: (result at: 5).
	result at: 6 put: (nodes at: 5).
	^result!

reduceActionForcontinue_statement1: nodes
	| result |
	result := JavaContinueStatementNode new.
	result continueToken: (nodes at: 1).
	result identifier: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionFordim_expr1: nodes
	| result |
	result := JavaDimensionExpressionNode new.
	result left: (nodes at: 1).
	result expression: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionFordims1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: ((nodes at: 1) at: 1) to: (result at: 1).
	self add: ((nodes at: 1) at: 2) to: (result at: 2).
	^result!

reduceActionFordims2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: ((nodes at: 2) at: 1) to: (result at: 1).
	self add: ((nodes at: 2) at: 2) to: (result at: 2).
	^result!

reduceActionFordo_statement1: nodes
	| result |
	result := JavaDoWhileStatementNode new.
	result doToken: (nodes at: 1).
	result statement: (nodes at: 2).
	result whileToken: (nodes at: 3).
	result left: (nodes at: 4).
	result expression: (nodes at: 5).
	result right: (nodes at: 6).
	result semicolon: (nodes at: 7).
	^result!

reduceActionForelementValueArrayInitializer1: nodes
	| result |
	result := JavaElementArrayInitializerNode new.
	result left: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result values.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result addToken: (nodes at: 3) to: result commas.
	result right: (nodes at: 4).
	^result!

reduceActionForelementValuePair1: nodes
	| result |
	result := JavaElementValuePairNode new.
	result name: (nodes at: 1).
	result equals: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionForempty_dim_expr1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^result!

reduceActionForempty_statement1: nodes
	| result |
	result := JavaEmptyStatementNode new.
	result semicolon: (nodes at: 1).
	^result!

reduceActionForenum_body_declarations_opt1: nodes
	| result |
	result := Array new: 2.
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionForenum_body_declarations_opt2: nodes
	| result |
	result := Array new: 2.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	^result!

reduceActionForenum_body_declarations1: nodes
	| result |
	result := Array new: 2.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	^result!

reduceActionForenum_body1: nodes
	| result |
	result := Array new: 6.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 5 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	self add: (nodes at: 3) to: (result at: 3).
	result at: 4 put: ((nodes at: 4) at: 1).
	self addAll: ((nodes at: 4) at: 2) to: (result at: 5).
	result at: 6 put: (nodes at: 5).
	^result!

reduceActionForenum_constant1: nodes
	| result |
	result := JavaEnumConstantNode new.
	result addNodes: (nodes at: 1) to: result annotations.
	result name: (nodes at: 2).
	result leftParen: ((nodes at: 3) at: 1).
	result addNodes: ((nodes at: 3) at: 2) to: result expressions.
	result addTokens: ((nodes at: 3) at: 3) to: result commas.
	result rightParen: ((nodes at: 3) at: 4).
	result left: ((nodes at: 4) at: 1).
	result addNodes: ((nodes at: 4) at: 2) to: result declarations.
	result right: ((nodes at: 4) at: 3).
	^result!

reduceActionForenum_declaration1: nodes
	| result |
	result := JavaEnumDeclarationNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result enumToken: (nodes at: 2).
	result name: (nodes at: 3).
	result implementsToken: ((nodes at: 4) at: 1).
	result addNodes: ((nodes at: 4) at: 2) to: result interfaces.
	result addTokens: ((nodes at: 4) at: 3) to: result commas.
	result left: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result constants.
	result addTokens: ((nodes at: 5) at: 3) to: result commas.
	result semicolon: ((nodes at: 5) at: 4).
	result addNodes: ((nodes at: 5) at: 5) to: result declarations.
	result right: ((nodes at: 5) at: 6).
	^result!

reduceActionForexplicit_constructor_invocation1: nodes
	| result |
	result := JavaThisConstructorInvocationNode new.
	result thisToken: (nodes at: 1).
	result left: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result expressions.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result right: (nodes at: 4).
	result semicolon: (nodes at: 5).
	^result!

reduceActionForexplicit_constructor_invocation2: nodes
	| result |
	result := JavaSuperConstructorInvocationNode new.
	result superToken: (nodes at: 1).
	result left: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result expressions.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result right: (nodes at: 4).
	result semicolon: (nodes at: 5).
	^result!

reduceActionForexplicit_constructor_invocation3: nodes
	| result |
	result := JavaThisConstructorInvocationNode new.
	result primary: (nodes at: 1).
	result period: (nodes at: 2).
	result thisToken: (nodes at: 3).
	result left: (nodes at: 4).
	result addNodes: ((nodes at: 5) at: 1) to: result expressions.
	result addTokens: ((nodes at: 5) at: 2) to: result commas.
	result right: (nodes at: 6).
	result semicolon: (nodes at: 7).
	^result!

reduceActionForexplicit_constructor_invocation4: nodes
	| result |
	result := JavaSuperConstructorInvocationNode new.
	result primary: (nodes at: 1).
	result period: (nodes at: 2).
	result superToken: (nodes at: 3).
	result left: (nodes at: 4).
	result addNodes: ((nodes at: 5) at: 1) to: result expressions.
	result addTokens: ((nodes at: 5) at: 2) to: result commas.
	result right: (nodes at: 6).
	result semicolon: (nodes at: 7).
	^result!

reduceActionForexpression_statement1: nodes
	| result |
	result := JavaExpressionStatementNode new.
	result expression: (nodes at: 1).
	result semicolon: (nodes at: 2).
	^result!

reduceActionForextends_interfaces1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self add: (nodes at: 2) to: (result at: 2).
	^result!

reduceActionForextends_interfaces2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	self add: (nodes at: 2) to: (result at: 3).
	self add: (nodes at: 3) to: (result at: 2).
	^result!

reduceActionForfield_access1: nodes
	| result |
	result := JavaFieldAccessNode new.
	result receiver: (nodes at: 1).
	result period: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForfield_access2: nodes
	| result |
	result := JavaFieldAccessNode new.
	result superToken: (nodes at: 1).
	result period: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForfield_access3: nodes
	| result |
	result := JavaFieldAccessNode new.
	result receiver: (nodes at: 1).
	result superPeriod: (nodes at: 2).
	result superToken: (nodes at: 3).
	result period: (nodes at: 4).
	result name: (nodes at: 5).
	^result!

reduceActionForfield_declaration1: nodes
	| result |
	result := JavaFieldDeclarationNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result type: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result variableDeclarations.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result semicolon: (nodes at: 4).
	^result!

reduceActionForfinally1: nodes
	| result |
	result := JavaFinallyClauseNode new.
	result finallyToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForfloating_point_type1: nodes
	| result |
	result := JavaFloatTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForfloating_point_type2: nodes
	| result |
	result := JavaDoubleTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForfor_statement1: nodes
	| result |
	result := JavaForStatementNode new.
	result forToken: (nodes at: 1).
	result left: (nodes at: 2).
	result initial: (nodes at: 3).
	result firstSemicolon: (nodes at: 4).
	result test: (nodes at: 5).
	result secondSemicolon: (nodes at: 6).
	result _update: (nodes at: 7).
	result right: (nodes at: 8).
	result statement: (nodes at: 9).
	^result!

reduceActionForforeach_statement1: nodes
	| result |
	result := JavaForEachStatementNode new.
	result forToken: (nodes at: 1).
	result left: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result modifiers.
	result type: (nodes at: 4).
	result name: (nodes at: 5).
	result colon: (nodes at: 6).
	result expression: (nodes at: 7).
	result right: (nodes at: 8).
	result statement: (nodes at: 9).
	^result!

reduceActionForformal_parameter1: nodes
	| result |
	result := JavaParameterNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result type: (nodes at: 2).
	result variable: (nodes at: 3).
	^result!

reduceActionForformal_parameter2: nodes
	| result |
	result := JavaVariableArgumentParameterNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result type: (nodes at: 2).
	result varArgsToken: (nodes at: 3).
	result variable: (nodes at: 4).
	^result!

reduceActionForif_then_else_statement1: nodes
	| result |
	result := JavaIfElseStatementNode new.
	result ifToken: (nodes at: 1).
	result left: (nodes at: 2).
	result expression: (nodes at: 3).
	result right: (nodes at: 4).
	result trueStatement: (nodes at: 5).
	result elseToken: (nodes at: 6).
	result falseStatement: (nodes at: 7).
	^result!

reduceActionForif_then_statement1: nodes
	| result |
	result := JavaIfStatementNode new.
	result ifToken: (nodes at: 1).
	result left: (nodes at: 2).
	result expression: (nodes at: 3).
	result right: (nodes at: 4).
	result trueStatement: (nodes at: 5).
	^result!

reduceActionForintegral_type1: nodes
	| result |
	result := JavaByteTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForintegral_type2: nodes
	| result |
	result := JavaShortTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForintegral_type3: nodes
	| result |
	result := JavaIntTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForintegral_type4: nodes
	| result |
	result := JavaLongTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForintegral_type5: nodes
	| result |
	result := JavaCharTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForinterface_declaration1: nodes
	| result |
	result := JavaInterfaceNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result interfaceToken: (nodes at: 2).
	result name: (nodes at: 3).
	result typeParameters: (nodes at: 4).
	result extendsToken: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result interfaceTypes.
	result addTokens: ((nodes at: 5) at: 3) to: result commas.
	result left: ((nodes at: 6) at: 1).
	result addNodes: ((nodes at: 6) at: 2) to: result declarations.
	result right: ((nodes at: 6) at: 3).
	^result!

reduceActionForinterfaces_opt1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	^result!

reduceActionForinterfaces_opt2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: ((nodes at: 1) at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self addAll: ((nodes at: 1) at: 3) to: (result at: 3).
	^result!

reduceActionForinterfaces1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	^result!

reduceActionForlabeled_statement1: nodes
	| result |
	result := JavaLabeledStatementNode new.
	result identifier: (nodes at: 1).
	result colon: (nodes at: 2).
	result statement: (nodes at: 3).
	^result!

reduceActionForlambda_expression1: nodes
	| result |
	result := JavaLambdaExpressionNode new.
	result leftParen: ((nodes at: 1) at: 1).
	result addNodes: ((nodes at: 1) at: 2) to: result parameters.
	result addTokens: ((nodes at: 1) at: 3) to: result commas.
	result rightParen: ((nodes at: 1) at: 4).
	result arrowToken: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionForlambda_parameter_list_opt1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionForlambda_parameter_list_opt2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	^result!

reduceActionForlambda_parameters2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 2).
	^result!

reduceActionForliteral1: nodes
	| result |
	result := JavaIntegerLiteralNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForliteral2: nodes
	| result |
	result := JavaFloatLiteralNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForliteral3: nodes
	| result |
	result := JavaBooleanLiteralNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForliteral4: nodes
	| result |
	result := JavaCharacterLiteralNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForliteral5: nodes
	| result |
	result := JavaStringLiteralNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForliteral6: nodes
	| result |
	result := JavaNullNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForlocal_variable_declaration_statement1: nodes
	| result |
	result := JavaLocalVariableDeclarationStatementNode new.
	result declaration: (nodes at: 1).
	result semicolon: (nodes at: 2).
	^result!

reduceActionForlocal_variable_declaration1: nodes
	| result |
	result := JavaLocalVariableDeclarationNode new.
	result addNodes: (nodes at: 1) to: result modifiers.
	result type: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result variableDeclarations.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	^result!

reduceActionFormethod_body2: nodes
	| result |
	result := JavaEmptyMethodBodyNode new.
	result semicolon: (nodes at: 1).
	^result!

reduceActionFormethod_declaration1: nodes
	| result |
	result := JavaMethodDeclarationNode new.
	result addNodes: ((nodes at: 1) at: 1) to: result modifiers.
	result typeParameters: ((nodes at: 1) at: 2).
	result type: ((nodes at: 1) at: 3).
	result declarator: ((nodes at: 1) at: 4).
	result throws: ((nodes at: 1) at: 5).
	result body: (nodes at: 2).
	^result!

reduceActionFormethod_declarator1: nodes
	| result |
	result := JavaMethodDeclaratorNode new.
	result name: (nodes at: 1).
	result left: (nodes at: 2).
	result addNodes: ((nodes at: 3) at: 1) to: result parameters.
	result addTokens: ((nodes at: 3) at: 2) to: result commas.
	result right: (nodes at: 4).
	^result!

reduceActionFormethod_declarator2: nodes
	| result |
	result := JavaArrayMethodDeclaratorNode new.
	result declarator: (nodes at: 1).
	result left: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionFormethod_header1: nodes
	| result |
	result := Array new: 5.
	result at: 1 put: (OrderedCollection new: 2).
	self addAll: (nodes at: 1) to: (result at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	^result!

reduceActionFormethod_invocation1: nodes
	| result |
	result := JavaMethodInvocationNode new.
	result typeArgLeft: ((nodes at: 1) at: 1).
	result addNodes: ((nodes at: 1) at: 2) to: result arguments.
	result addTokens: ((nodes at: 1) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 1) at: 4).
	result name: (nodes at: 2).
	result addToken: (nodes at: 3) to: result lefts.
	result addNodes: ((nodes at: 4) at: 1) to: result expressions.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: (nodes at: 5) to: result rights.
	^result!

reduceActionFormethod_invocation3: nodes
	| result |
	result := JavaMethodInvocationNode new.
	result receiver: (nodes at: 1).
	result period: (nodes at: 2).
	result typeArgLeft: ((nodes at: 3) at: 1).
	result addNodes: ((nodes at: 3) at: 2) to: result arguments.
	result addTokens: ((nodes at: 3) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 3) at: 4).
	result name: (nodes at: 4).
	result addToken: (nodes at: 5) to: result lefts.
	result addNodes: ((nodes at: 6) at: 1) to: result expressions.
	result addTokens: ((nodes at: 6) at: 2) to: result commas.
	result addToken: (nodes at: 7) to: result rights.
	^result!

reduceActionFormethod_invocation4: nodes
	| result |
	result := JavaMethodInvocationNode new.
	result superToken: (nodes at: 1).
	result period: (nodes at: 2).
	result typeArgLeft: ((nodes at: 3) at: 1).
	result addNodes: ((nodes at: 3) at: 2) to: result arguments.
	result addTokens: ((nodes at: 3) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 3) at: 4).
	result name: (nodes at: 4).
	result addToken: (nodes at: 5) to: result lefts.
	result addNodes: ((nodes at: 6) at: 1) to: result expressions.
	result addTokens: ((nodes at: 6) at: 2) to: result commas.
	result addToken: (nodes at: 7) to: result rights.
	^result!

reduceActionFormethod_invocation5: nodes
	| result |
	result := JavaMethodInvocationNode new.
	result receiver: (nodes at: 1).
	result superPeriod: (nodes at: 2).
	result superToken: (nodes at: 3).
	result period: (nodes at: 4).
	result typeArgLeft: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result arguments.
	result addTokens: ((nodes at: 5) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 5) at: 4).
	result name: (nodes at: 6).
	result addToken: (nodes at: 7) to: result lefts.
	result addNodes: ((nodes at: 8) at: 1) to: result expressions.
	result addTokens: ((nodes at: 8) at: 2) to: result commas.
	result addToken: (nodes at: 9) to: result rights.
	^result!

reduceActionFormodifier11: nodes
	| result |
	result := JavaModifierNode new.
	result token: (nodes at: 1).
	^result!

reduceActionFormodifiers_opt2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	^result!

reduceActionFormodifiers1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^result!

reduceActionFormultiplicative_expression2: nodes
	| result |
	result := JavaBinaryExpressionNode new.
	result leftExpression: (nodes at: 1).
	result op: (nodes at: 2).
	result rightExpression: (nodes at: 3).
	^result!

reduceActionForpackage_declaration_opt1: nodes
	^nodes at: 1!

reduceActionForpackage_declaration1: nodes
	| result |
	result := JavaPackageDeclarationNode new.
	result addNodes: (nodes at: 1) to: result annotations.
	result packageToken: (nodes at: 2).
	result name: (nodes at: 3).
	result semicolon: (nodes at: 4).
	^result!

reduceActionForpostdecrement_expression1: nodes
	| result |
	result := JavaPostDecrementExpressionNode new.
	result expression: (nodes at: 1).
	result minusMinus: (nodes at: 2).
	^result!

reduceActionForpostincrement_expression1: nodes
	| result |
	result := JavaPostIncrementExpressionNode new.
	result expression: (nodes at: 1).
	result plusPlus: (nodes at: 2).
	^result!

reduceActionForpredecrement_expression1: nodes
	| result |
	result := JavaPreDecrementExpressionNode new.
	result minusMinus: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForpreincrement_expression1: nodes
	| result |
	result := JavaPreIncrementExpressionNode new.
	result plusPlus: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForprimary_no_new_array11: nodes
	| result |
	result := JavaClassPropertyNode new.
	result name: (nodes at: 1).
	result period: (nodes at: 2).
	result classToken: (nodes at: 3).
	^result!

reduceActionForprimary_no_new_array12: nodes
	| result |
	result := JavaClassPropertyNode new.
	result name: (nodes at: 1).
	result period: (nodes at: 2).
	result thisToken: (nodes at: 3).
	^result!

reduceActionForprimary_no_new_array2: nodes
	| result |
	result := JavaNameNode new.
	result name: (nodes at: 1).
	^result!

reduceActionForprimary_no_new_array3: nodes
	| result |
	result := nodes at: 2.
	result addFirstToken: (nodes at: 1) to: result lefts.
	result addToken: (nodes at: 3) to: result rights.
	^result!

reduceActionForprimary_no_new_array8: nodes
	| result |
	result := JavaClassPropertyNode new.
	result type: (nodes at: 1).
	result period: (nodes at: 2).
	result classToken: (nodes at: 3).
	^result!

reduceActionForprimitive_type2: nodes
	| result |
	result := JavaBooleanTypeNode new.
	result token: (nodes at: 1).
	^result!

reduceActionForqualified_name1: nodes
	| result |
	result := JavaQualifiedNameNode new.
	result nspace: (nodes at: 1).
	result period: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForqualified_type_name1: nodes
	| result |
	result := JavaQualifiedTypeNameNode new.
	result nspace: (nodes at: 1).
	result period: (nodes at: 2).
	result name: (nodes at: 3).
	result typeArgLeft: ((nodes at: 4) at: 1).
	result addNodes: ((nodes at: 4) at: 2) to: result arguments.
	result addTokens: ((nodes at: 4) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 4) at: 4).
	^result!

reduceActionForreturn_statement1: nodes
	| result |
	result := JavaReturnStatementNode new.
	result returnToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForsimple_type_name1: nodes
	| result |
	result := JavaTypeNameNode new.
	result name: (nodes at: 1).
	result typeArgLeft: ((nodes at: 2) at: 1).
	result addNodes: ((nodes at: 2) at: 2) to: result arguments.
	result addTokens: ((nodes at: 2) at: 3) to: result commas.
	result typeArgRight: ((nodes at: 2) at: 4).
	^result!

reduceActionForsingle_type_import_declaration1: nodes
	| result |
	result := JavaSingleTypeImportDeclarationNode new.
	result importToken: (nodes at: 1).
	result staticToken: (nodes at: 2).
	result name: (nodes at: 3).
	result semicolon: (nodes at: 4).
	^result!

reduceActionForstatement_expression_list1: nodes
	| result |
	result := JavaStatementExpressionListNode new.
	result addNode: (nodes at: 1) to: result expressions.
	^result!

reduceActionForstatement_expression_list2: nodes
	| result |
	result := nodes at: 1.
	result addToken: (nodes at: 2) to: result commas.
	result addNode: (nodes at: 3) to: result expressions.
	^result!

reduceActionForstatic_initializer1: nodes
	| result |
	result := JavaStaticInitializerNode new.
	result staticToken: (nodes at: 1).
	result block: (nodes at: 2).
	^result!

reduceActionForsuper_opt2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	^result!

reduceActionForswitch_block_statement_group1: nodes
	| result |
	result := JavaSwitchBlockStatementGroupNode new.
	result addNodes: (nodes at: 1) to: result labels.
	result addNodes: (nodes at: 2) to: result statements.
	^result!

reduceActionForswitch_block1: nodes
	| result |
	result := JavaSwitchBlockNode new.
	result left: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statementGroups.
	result addNodes: (nodes at: 3) to: result labels.
	result right: (nodes at: 4).
	^result!

reduceActionForswitch_block2: nodes
	| result |
	result := JavaSwitchBlockNode new.
	result left: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statementGroups.
	result right: (nodes at: 3).
	^result!

reduceActionForswitch_block3: nodes
	| result |
	result := JavaSwitchBlockNode new.
	result left: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result labels.
	result right: (nodes at: 3).
	^result!

reduceActionForswitch_block4: nodes
	| result |
	result := JavaSwitchBlockNode new.
	result left: (nodes at: 1).
	result right: (nodes at: 2).
	^result!

reduceActionForswitch_label1: nodes
	| result |
	result := JavaSwitchLabelNode new.
	result caseToken: (nodes at: 1).
	result constant: (nodes at: 2).
	result colon: (nodes at: 3).
	^result!

reduceActionForswitch_label2: nodes
	| result |
	result := JavaDefaultLabelNode new.
	result defaultToken: (nodes at: 1).
	result colon: (nodes at: 2).
	^result!

reduceActionForswitch_statement1: nodes
	| result |
	result := JavaSwitchStatementNode new.
	result switchToken: (nodes at: 1).
	result left: (nodes at: 2).
	result expression: (nodes at: 3).
	result right: (nodes at: 4).
	result block: (nodes at: 5).
	^result!

reduceActionForsynchronized_statement1: nodes
	| result |
	result := JavaSynchronizedStatementNode new.
	result synchronizedToken: (nodes at: 1).
	result left: (nodes at: 2).
	result expression: (nodes at: 3).
	result right: (nodes at: 4).
	result block: (nodes at: 5).
	^result!

reduceActionForthrow_statement1: nodes
	| result |
	result := JavaThrowStatementNode new.
	result throwToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForthrows1: nodes
	| result |
	result := JavaThrowsNode new.
	result throwsToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result classTypes.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	^result!

reduceActionFortry_statement1: nodes
	| result |
	result := JavaTryStatementNode new.
	result tryToken: (nodes at: 1).
	result block: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result catches.
	^result!

reduceActionFortry_statement2: nodes
	| result |
	result := JavaTryStatementNode new.
	result tryToken: (nodes at: 1).
	result block: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result catches.
	result finally: (nodes at: 4).
	^result!

reduceActionFortype_argument_type3: nodes
	| result |
	result := Array new: 2.
	^result!

reduceActionFortype_argument1: nodes
	| result |
	result := JavaTypeArgumentNode new.
	result type: (nodes at: 1).
	^result!

reduceActionFortype_argument2: nodes
	| result |
	result := JavaTypeArgumentNode new.
	result questionMark: (nodes at: 1).
	result token: ((nodes at: 2) at: 1).
	result type: ((nodes at: 2) at: 2).
	^result!

reduceActionFortype_arguments_opt1: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	^result!

reduceActionFortype_arguments_opt2: nodes
	| result |
	result := Array new: 4.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 2).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 3).
	result at: 4 put: (nodes at: 3).
	^result!

reduceActionFortype_arguments1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	^result!

reduceActionFortype_arguments2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: (nodes at: 2) to: (result at: 2).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionFortype_declaration4: nodes
	| result |
	result := JavaEmptyDeclarationNode new.
	result semicolon: (nodes at: 1).
	^result!

reduceActionFortype_import_on_demand_declaration1: nodes
	| result |
	result := JavaTypeImportOnDemandDeclarationNode new.
	result importToken: (nodes at: 1).
	result staticToken: (nodes at: 2).
	result name: (nodes at: 3).
	result period: (nodes at: 4).
	result star: (nodes at: 5).
	result semicolon: (nodes at: 6).
	^result!

reduceActionFortype_parameter1: nodes
	| result |
	result := JavaTypeParameterNode new.
	result name: (nodes at: 1).
	result extendsToken: ((nodes at: 2) at: 1).
	result addNodes: ((nodes at: 2) at: 2) to: result types.
	result addTokens: ((nodes at: 2) at: 3) to: result amps.
	^result!

reduceActionFortype_parameters_opt2: nodes
	| result |
	result := JavaTypeParametersNode new.
	result left: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result parameters.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result right: (nodes at: 3).
	^result!

reduceActionForunary_expression_not_plus_minus2: nodes
	| result |
	result := JavaUnaryBitInvertNode new.
	result tilde: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForunary_expression_not_plus_minus3: nodes
	| result |
	result := JavaUnaryNotNode new.
	result bang: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForunary_expression3: nodes
	| result |
	result := JavaUnaryAdditionNode new.
	result plus: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForunary_expression4: nodes
	| result |
	result := JavaUnarySubtractionNode new.
	result minus: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForuntyped_lambda_parameter1: nodes
	| result |
	result := JavaParameterNode new.
	result variable: (nodes at: 1).
	^result!

reduceActionForvariable_declarator_id1: nodes
	| result |
	result := JavaVariableNameNode new.
	result name: (nodes at: 1).
	^result!

reduceActionForvariable_declarator_id2: nodes
	| result |
	result := JavaArrayVariableNameNode new.
	result variable: (nodes at: 1).
	result left: (nodes at: 2).
	result right: (nodes at: 3).
	^result!

reduceActionForvariable_declarator1: nodes
	| result |
	result := JavaVariableDeclarationNode new.
	result variable: (nodes at: 1).
	^result!

reduceActionForvariable_declarator2: nodes
	| result |
	result := JavaInitializedVariableDeclarationNode new.
	result variable: (nodes at: 1).
	result equals: (nodes at: 2).
	result initializer: (nodes at: 3).
	^result!

reduceActionForvoid1: nodes
	| result |
	result := JavaVoidTypeNode new.
	result voidToken: (nodes at: 1).
	^result!

reduceActionForwhile_statement1: nodes
	| result |
	result := JavaWhileStatementNode new.
	result whileToken: (nodes at: 1).
	result left: (nodes at: 2).
	result expression: (nodes at: 3).
	result right: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceTable
^#(
	#(127 0 #nil) 
	#(134 0 #reduceActionForannotations1:) 
	#(142 0 #reduceActionForannotations1:) 
	#(175 0 #reduceActionForannotations1:) 
	#(261 0 #reduceActionFortype_arguments_opt1:) 
	#(128 0 #reduceActionForannotations1:) 
	#(127 1 #reduceActionForpackage_declaration_opt1:) 
	#(108 1 #reduceActionForpackage_declaration_opt1:) 
	#(198 0 #reduceActionForannotations1:) 
	#(143 1 #reduceActionFormodifier11:) 
	#(171 1 #reduceActionForvoid1:) 
	#(245 1 #reduceActionForprimary_no_new_array2:) 
	#(115 1 #reduceActionForintegral_type4:) 
	#(115 1 #reduceActionForintegral_type5:) 
	#(116 1 #reduceActionForfloating_point_type1:) 
	#(115 1 #reduceActionForintegral_type2:) 
	#(115 1 #reduceActionForintegral_type3:) 
	#(116 1 #reduceActionForfloating_point_type2:) 
	#(111 1 #reduceActionForprimitive_type2:) 
	#(115 1 #reduceActionForintegral_type1:) 
	#(109 1 #reduceActionForempty_statement1:) 
	#(235 0 #nil) 
	#(240 0 #nil) 
	#(110 1 #reduceActionForliteral1:) 
	#(110 1 #reduceActionForliteral2:) 
	#(110 1 #reduceActionForliteral3:) 
	#(110 1 #reduceActionForliteral4:) 
	#(110 1 #reduceActionForliteral5:) 
	#(110 1 #reduceActionForliteral6:) 
	#(123 1 #reduceActionForprimary_no_new_array2:) 
	#(202 1 #reduceActionForpackage_declaration_opt1:) 
	#(245 1 #reduceActionForpackage_declaration_opt1:) 
	#(111 1 #reduceActionForpackage_declaration_opt1:) 
	#(114 1 #reduceActionForpackage_declaration_opt1:) 
	#(125 1 #reduceActionForpackage_declaration_opt1:) 
	#(262 1 #reduceActionForpackage_declaration_opt1:) 
	#(278 1 #reduceActionForpackage_declaration_opt1:) 
	#(309 1 #reduceActionForpackage_declaration_opt1:) 
	#(142 1 #reduceActionFormodifiers_opt2:) 
	#(141 1 #reduceActionFormodifiers1:) 
	#(143 1 #reduceActionForpackage_declaration_opt1:) 
	#(138 1 #reduceActionForpackage_declaration_opt1:) 
	#(200 1 #reduceActionForpackage_declaration_opt1:) 
	#(220 1 #reduceActionForpackage_declaration_opt1:) 
	#(183 1 #reduceActionForpackage_declaration_opt1:) 
	#(119 1 #reduceActionForpackage_declaration_opt1:) 
	#(252 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(164 1 #reduceActionForvariable_declarator_id1:) 
	#(253 1 #reduceActionForuntyped_lambda_parameter1:) 
	#(263 1 #reduceActionForpackage_declaration_opt1:) 
	#(277 1 #reduceActionForpackage_declaration_opt1:) 
	#(156 1 #reduceActionForpackage_declaration_opt1:) 
	#(249 1 #reduceActionForlambda_parameters2:) 
	#(264 1 #reduceActionForpackage_declaration_opt1:) 
	#(266 1 #reduceActionForpackage_declaration_opt1:) 
	#(267 1 #reduceActionForpackage_declaration_opt1:) 
	#(268 1 #reduceActionForpackage_declaration_opt1:) 
	#(269 1 #reduceActionForpackage_declaration_opt1:) 
	#(270 1 #reduceActionForpackage_declaration_opt1:) 
	#(271 1 #reduceActionForpackage_declaration_opt1:) 
	#(272 1 #reduceActionForpackage_declaration_opt1:) 
	#(273 1 #reduceActionForpackage_declaration_opt1:) 
	#(274 1 #reduceActionForpackage_declaration_opt1:) 
	#(275 1 #reduceActionForpackage_declaration_opt1:) 
	#(276 1 #reduceActionForpackage_declaration_opt1:) 
	#(126 1 #reduceActionFortype_declaration4:) 
	#(126 1 #reduceActionForpackage_declaration_opt1:) 
	#(137 0 #nil) 
	#(129 0 #reduceActionForannotations1:) 
	#(128 1 #reduceActionFormodifiers_opt2:) 
	#(131 1 #reduceActionFormodifiers1:) 
	#(133 1 #reduceActionForpackage_declaration_opt1:) 
	#(134 2 #reduceActionForannotations2:) 
	#(198 1 #reduceActionFormodifiers_opt2:) 
	#(181 1 #reduceActionFormodifiers1:) 
	#(280 0 #reduceActionFortype_arguments_opt1:) 
	#(303 0 #reduceActionFortype_argument_type3:) 
	#(113 1 #reduceActionForpackage_declaration_opt1:) 
	#(302 1 #reduceActionFortype_argument1:) 
	#(112 1 #reduceActionForpackage_declaration_opt1:) 
	#(117 1 #reduceActionForclass_or_interface_type1:) 
	#(301 1 #reduceActionFortype_arguments1:) 
	#(235 1 #reduceActionForpackage_declaration_opt1:) 
	#(242 0 #reduceActionForannotations1:) 
	#(240 1 #reduceActionForpackage_declaration_opt1:) 
	#(234 0 #nil) 
	#(120 1 #reduceActionForpackage_declaration_opt1:) 
	#(222 2 #reduceActionForpreincrement_expression1:) 
	#(223 2 #reduceActionForpredecrement_expression1:) 
	#(304 2 #reduceActionForsimple_type_name1:) 
	#(118 2 #reduceActionForarray_type1:) 
	#(122 1 #reduceActionFordims1:) 
	#(141 2 #reduceActionForannotations2:) 
	#(306 1 #reduceActionFormodifier11:) 
	#(306 1 #reduceActionForpackage_declaration_opt1:) 
	#(175 2 #reduceActionForannotations2:) 
	#(199 2 #reduceActionForlocal_variable_declaration_statement1:) 
	#(210 2 #reduceActionForexpression_statement1:) 
	#(224 2 #reduceActionForpostincrement_expression1:) 
	#(225 2 #reduceActionForpostdecrement_expression1:) 
	#(279 1 #reduceActionForpackage_declaration_opt1:) 
	#(255 1 #reduceActionForpackage_declaration_opt1:) 
	#(252 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(254 1 #reduceActionFortype_arguments1:) 
	#(264 2 #reduceActionForunary_expression_not_plus_minus2:) 
	#(264 2 #reduceActionForunary_expression_not_plus_minus3:) 
	#(263 2 #reduceActionForunary_expression3:) 
	#(263 2 #reduceActionForunary_expression4:) 
	#(137 1 #reduceActionForpackage_declaration_opt1:) 
	#(132 1 #reduceActionFormodifiers1:) 
	#(209 3 #reduceActionForcompilation_unit1:) 
	#(129 1 #reduceActionFormodifiers_opt2:) 
	#(131 2 #reduceActionForannotations2:) 
	#(181 2 #reduceActionForannotations2:) 
	#(159 3 #reduceActionForblock1:) 
	#(281 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(144 3 #reduceActionForannotation1:) 
	#(247 3 #reduceActionForfield_access2:) 
	#(245 3 #reduceActionForprimary_no_new_array3:) 
	#(302 2 #reduceActionFortype_argument2:) 
	#(261 3 #reduceActionFortype_arguments_opt2:) 
	#(215 3 #reduceActionForreturn_statement1:) 
	#(217 3 #reduceActionForthrow_statement1:) 
	#(218 3 #reduceActionFortry_statement1:) 
	#(242 1 #reduceActionFormodifiers_opt2:) 
	#(241 1 #reduceActionFormodifiers1:) 
	#(213 3 #reduceActionForbreak_statement1:) 
	#(214 3 #reduceActionForcontinue_statement1:) 
	#(237 1 #reduceActionForpackage_declaration_opt1:) 
	#(238 1 #reduceActionForstatement_expression_list1:) 
	#(234 1 #reduceActionForpackage_declaration_opt1:) 
	#(219 3 #reduceActionForassert_statement1:) 
	#(258 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(257 1 #reduceActionFormodifiers1:) 
	#(182 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(203 3 #reduceActionForlabeled_statement1:) 
	#(260 2 #reduceActionForempty_dim_expr1:) 
	#(245 3 #reduceActionForprimary_no_new_array8:) 
	#(122 2 #reduceActionFordims2:) 
	#(245 3 #reduceActionForprimary_no_new_array11:) 
	#(245 3 #reduceActionForprimary_no_new_array12:) 
	#(124 3 #reduceActionForqualified_name1:) 
	#(145 0 #nil) 
	#(147 0 #reduceActionForinterfaces_opt1:) 
	#(201 3 #reduceActionForlocal_variable_declaration1:) 
	#(162 1 #reduceActionFortype_arguments1:) 
	#(163 1 #reduceActionForvariable_declarator1:) 
	#(247 3 #reduceActionForfield_access1:) 
	#(221 3 #reduceActionForassignment1:) 
	#(249 3 #reduceActionFortype_arguments_opt2:) 
	#(164 3 #reduceActionForvariable_declarator_id2:) 
	#(250 1 #reduceActionForpackage_declaration_opt1:) 
	#(251 3 #reduceActionForlambda_expression1:) 
	#(266 3 #reduceActionFormultiplicative_expression2:) 
	#(267 3 #reduceActionFormultiplicative_expression2:) 
	#(268 3 #reduceActionFormultiplicative_expression2:) 
	#(269 3 #reduceActionFormultiplicative_expression2:) 
	#(270 3 #reduceActionFormultiplicative_expression2:) 
	#(271 3 #reduceActionFormultiplicative_expression2:) 
	#(272 3 #reduceActionFormultiplicative_expression2:) 
	#(273 3 #reduceActionFormultiplicative_expression2:) 
	#(274 3 #reduceActionFormultiplicative_expression2:) 
	#(275 3 #reduceActionFormultiplicative_expression2:) 
	#(132 2 #reduceActionForannotations2:) 
	#(130 4 #reduceActionForpackage_declaration1:) 
	#(286 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(283 1 #reduceActionForpackage_declaration_opt1:) 
	#(281 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(281 1 #reduceActionFortype_arguments1:) 
	#(282 1 #reduceActionFortype_arguments1:) 
	#(303 2 #reduceActionForempty_dim_expr1:) 
	#(301 3 #reduceActionFortype_arguments2:) 
	#(241 2 #reduceActionForannotations2:) 
	#(218 4 #reduceActionFortry_statement2:) 
	#(246 4 #reduceActionForarray_creation_expression3:) 
	#(258 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(246 4 #reduceActionForarray_creation_expression1:) 
	#(257 2 #reduceActionForannotations2:) 
	#(256 1 #reduceActionFortype_arguments1:) 
	#(182 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(305 4 #reduceActionForqualified_type_name1:) 
	#(248 4 #reduceActionForarray_access1:) 
	#(146 0 #reduceActionFortype_argument_type3:) 
	#(147 1 #reduceActionForinterfaces_opt2:) 
	#(184 0 #reduceActionForinterfaces_opt1:) 
	#(265 4 #reduceActionForcast_expression1:) 
	#(174 3 #reduceActionForformal_parameter1:) 
	#(254 3 #reduceActionFortype_arguments2:) 
	#(135 4 #reduceActionForsingle_type_import_declaration1:) 
	#(288 1 #reduceActionFortype_arguments1:) 
	#(287 0 #nil) 
	#(286 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(280 3 #reduceActionFortype_arguments_opt2:) 
	#(216 5 #reduceActionForsynchronized_statement1:) 
	#(204 5 #reduceActionForif_then_statement1:) 
	#(211 5 #reduceActionForswitch_statement1:) 
	#(243 2 #reduceActionForfinally1:) 
	#(206 5 #reduceActionForwhile_statement1:) 
	#(238 3 #reduceActionForstatement_expression_list2:) 
	#(219 5 #reduceActionForassert_statement2:) 
	#(259 3 #reduceActionFordim_expr1:) 
	#(166 2 #reduceActionForarray_initializer4:) 
	#(165 1 #reduceActionForpackage_declaration_opt1:) 
	#(197 1 #reduceActionFortype_arguments1:) 
	#(227 5 #reduceActionForclass_instance_creation_expression1:) 
	#(247 5 #reduceActionForfield_access3:) 
	#(299 0 #reduceActionForinterfaces_opt1:) 
	#(297 1 #reduceActionFortype_arguments1:) 
	#(146 1 #reduceActionForsuper_opt2:) 
	#(121 1 #reduceActionForpackage_declaration_opt1:) 
	#(151 1 #reduceActionFortype_arguments1:) 
	#(152 2 #reduceActionForinterfaces1:) 
	#(290 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(149 5 #reduceActionForenum_declaration1:) 
	#(184 1 #reduceActionForinterfaces_opt2:) 
	#(162 3 #reduceActionFortype_arguments2:) 
	#(163 3 #reduceActionForvariable_declarator2:) 
	#(226 5 #reduceActionFormethod_invocation1:) 
	#(174 4 #reduceActionForformal_parameter2:) 
	#(276 5 #reduceActionForconditional_expression2:) 
	#(187 0 #reduceActionForannotations1:) 
	#(140 5 #reduceActionForannotation_interface_declaration1:) 
	#(287 1 #reduceActionForpackage_declaration_opt1:) 
	#(284 3 #reduceActionForelementValuePair1:) 
	#(282 3 #reduceActionFortype_arguments2:) 
	#(228 2 #reduceActionForswitch_block4:) 
	#(229 1 #reduceActionFormodifiers1:) 
	#(230 1 #reduceActionFormodifiers1:) 
	#(236 0 #nil) 
	#(166 3 #reduceActionForarray_initializer3:) 
	#(166 3 #reduceActionForarray_initializer2:) 
	#(153 0 #reduceActionForannotations1:) 
	#(227 6 #reduceActionForclass_instance_creation_expression2:) 
	#(256 3 #reduceActionFortype_arguments2:) 
	#(298 2 #reduceActionFortype_parameter1:) 
	#(145 3 #reduceActionFortype_parameters_opt2:) 
	#(150 2 #reduceActionForempty_dim_expr1:) 
	#(290 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(292 1 #reduceActionFortype_arguments1:) 
	#(192 2 #reduceActionForextends_interfaces1:) 
	#(193 0 #reduceActionForannotations1:) 
	#(139 6 #reduceActionForinterface_declaration1:) 
	#(189 1 #reduceActionForpackage_declaration_opt1:) 
	#(187 1 #reduceActionFormodifiers_opt2:) 
	#(188 1 #reduceActionFormodifiers1:) 
	#(190 1 #reduceActionForpackage_declaration_opt1:) 
	#(136 6 #reduceActionFortype_import_on_demand_declaration1:) 
	#(285 4 #reduceActionForelementValueArrayInitializer1:) 
	#(288 3 #reduceActionFortype_arguments2:) 
	#(226 7 #reduceActionFormethod_invocation4:) 
	#(205 7 #reduceActionForif_then_else_statement1:) 
	#(232 2 #reduceActionForswitch_label2:) 
	#(233 1 #reduceActionForpackage_declaration_opt1:) 
	#(228 3 #reduceActionForswitch_block2:) 
	#(229 2 #reduceActionForannotations2:) 
	#(228 3 #reduceActionForswitch_block3:) 
	#(231 2 #reduceActionForswitch_block_statement_group1:) 
	#(230 2 #reduceActionForannotations2:) 
	#(244 5 #reduceActionForcatch_clause1:) 
	#(212 7 #reduceActionFordo_statement1:) 
	#(239 1 #reduceActionForpackage_declaration_opt1:) 
	#(236 1 #reduceActionForpackage_declaration_opt1:) 
	#(166 4 #reduceActionForarray_initializer1:) 
	#(197 3 #reduceActionFortype_arguments2:) 
	#(310 1 #reduceActionForpackage_declaration_opt1:) 
	#(153 1 #reduceActionFormodifiers_opt2:) 
	#(154 1 #reduceActionFormodifiers1:) 
	#(155 1 #reduceActionForpackage_declaration_opt1:) 
	#(226 7 #reduceActionFormethod_invocation3:) 
	#(300 1 #reduceActionFortype_arguments1:) 
	#(299 2 #reduceActionForinterfaces1:) 
	#(297 3 #reduceActionFortype_arguments2:) 
	#(138 7 #reduceActionForclass_declaration1:) 
	#(151 3 #reduceActionFortype_arguments2:) 
	#(294 0 #reduceActionFortype_arguments_opt1:) 
	#(291 0 #reduceActionForenum_body_declarations_opt1:) 
	#(195 1 #reduceActionForpackage_declaration_opt1:) 
	#(196 1 #reduceActionForpackage_declaration_opt1:) 
	#(193 1 #reduceActionFormodifiers_opt2:) 
	#(194 1 #reduceActionFormodifiers1:) 
	#(192 3 #reduceActionForextends_interfaces2:) 
	#(227 7 #reduceActionForclass_instance_creation_expression3:) 
	#(191 2 #reduceActionForabstract_method_declaration1:) 
	#(186 3 #reduceActionForannotation_interface_body1:) 
	#(188 2 #reduceActionForannotations2:) 
	#(232 3 #reduceActionForswitch_label1:) 
	#(228 4 #reduceActionForswitch_block1:) 
	#(157 2 #reduceActionForstatic_initializer1:) 
	#(170 0 #nil) 
	#(148 3 #reduceActionForannotation_interface_body1:) 
	#(154 2 #reduceActionForannotations2:) 
	#(168 1 #reduceActionFormethod_body2:) 
	#(168 1 #reduceActionForpackage_declaration_opt1:) 
	#(161 2 #reduceActionFormethod_declaration1:) 
	#(295 0 #reduceActionForclass_body_opt1:) 
	#(291 1 #reduceActionForenum_body_declarations_opt2:) 
	#(292 3 #reduceActionFortype_arguments2:) 
	#(185 3 #reduceActionForannotation_interface_body1:) 
	#(194 2 #reduceActionForannotations2:) 
	#(227 8 #reduceActionForclass_instance_creation_expression4:) 
	#(208 9 #reduceActionForforeach_statement1:) 
	#(207 9 #reduceActionForfor_statement1:) 
	#(170 1 #reduceActionForpackage_declaration_opt1:) 
	#(226 9 #reduceActionFormethod_invocation5:) 
	#(300 3 #reduceActionFortype_arguments2:) 
	#(295 1 #reduceActionForclass_body_opt2:) 
	#(293 4 #reduceActionForenum_constant1:) 
	#(296 2 #reduceActionForenum_body_declarations1:) 
	#(289 5 #reduceActionForenum_body1:) 
	#(160 4 #reduceActionForfield_declaration1:) 
	#(190 4 #reduceActionForannotation_method_declaration2:) 
	#(172 0 #reduceActionForlambda_parameter_list_opt1:) 
	#(177 1 #reduceActionFortype_arguments1:) 
	#(176 2 #reduceActionForthrows1:) 
	#(158 4 #reduceActionForconstructor_declaration1:) 
	#(294 3 #reduceActionFortype_arguments_opt2:) 
	#(167 5 #reduceActionFormethod_header1:) 
	#(172 1 #reduceActionForlambda_parameter_list_opt2:) 
	#(173 1 #reduceActionFortype_arguments1:) 
	#(179 2 #reduceActionForconstructor_body4:) 
	#(169 3 #reduceActionFormethod_declarator2:) 
	#(178 5 #reduceActionForconstructor_declarator1:) 
	#(177 3 #reduceActionFortype_arguments2:) 
	#(179 3 #reduceActionForconstructor_body2:) 
	#(179 3 #reduceActionForconstructor_body3:) 
	#(169 4 #reduceActionFormethod_declarator1:) 
	#(173 3 #reduceActionFortype_arguments2:) 
	#(179 4 #reduceActionForconstructor_body1:) 
	#(180 5 #reduceActionForexplicit_constructor_invocation1:) 
	#(180 5 #reduceActionForexplicit_constructor_invocation2:) 
	#(180 7 #reduceActionForexplicit_constructor_invocation3:) 
	#(180 7 #reduceActionForexplicit_constructor_invocation4:)
	).!

symbolTypes
	^#(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #JavaProgramFileNode #JavaEmptyStatementNode #JavaLiteralNode #JavaPrimitiveTypeNode #JavaTypeNode #JavaTypeNode #JavaPrimitiveTypeNode #JavaPrimitiveTypeNode #JavaPrimitiveTypeNode #JavaClassTypeNode #JavaArrayTypeNode #JavaProgramNode #JavaClassTypeNode #JavaClassTypeNode #OrderedCollection #JavaNameNode #JavaQualifiedNameNode #JavaNameNode #JavaProgramNode #JavaPackageDeclarationNode #OrderedCollection #OrderedCollection #JavaPackageDeclarationNode #OrderedCollection #OrderedCollection #JavaSingleTypeImportDeclarationNode #OrderedCollection #JavaSingleTypeImportDeclarationNode #JavaTypeImportOnDemandDeclarationNode #SmaCCToken #JavaProgramNode #JavaInterfaceNode #JavaAnnotationInterfaceNode #OrderedCollection #OrderedCollection #JavaProgramNode #JavaAnnotationNode #JavaTypeParametersNode #OrderedCollection #OrderedCollection #OrderedCollection #JavaEnumDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JavaProgramNode #JavaExpressionNode #JavaStaticInitializerNode #JavaConstructorDeclarationNode #JavaBlockNode #JavaFieldDeclarationNode #JavaMethodDeclarationNode #OrderedCollection #JavaVariableDeclarationNode #JavaProgramNode #JavaProgramNode #JavaArrayInitializerNode #OrderedCollection #JavaProgramNode #JavaProgramNode #JavaThrowsNode #JavaVoidTypeNode #OrderedCollection #OrderedCollection #JavaParameterNode #OrderedCollection #JavaThrowsNode #OrderedCollection #OrderedCollection #JavaConstructorBodyNode #JavaProgramNode #OrderedCollection #OrderedCollection #JavaExpressionNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JavaProgramNode #JavaAbstractMethodDeclarationNode #JavaAbstractMethodDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #JavaProgramNode #JavaFieldDeclarationNode #OrderedCollection #OrderedCollection #JavaLocalVariableDeclarationStatementNode #JavaStatementNode #JavaLocalVariableDeclarationNode #JavaStatementNode #JavaLabeledStatementNode #JavaIfStatementNode #JavaIfElseStatementNode #JavaWhileStatementNode #JavaForStatementNode #JavaForEachStatementNode #JavaProgramFileNode #JavaExpressionStatementNode #JavaSwitchStatementNode #JavaDoWhileStatementNode #JavaBreakStatementNode #JavaContinueStatementNode #JavaReturnStatementNode #JavaSynchronizedStatementNode #JavaThrowStatementNode #JavaTryStatementNode #JavaAssertStatementNode #JavaExpressionNode #JavaAssignmentNode #JavaPreIncrementExpressionNode #JavaPreDecrementExpressionNode #JavaPostIncrementExpressionNode #JavaPostDecrementExpressionNode #JavaMethodInvocationNode #JavaNewNode #JavaSwitchBlockNode #OrderedCollection #OrderedCollection #JavaSwitchBlockStatementGroupNode #JavaProgramNode #JavaExpressionNode #JavaProgramNode #JavaExpressionNode #JavaStatementExpressionListNode #JavaProgramNode #JavaStatementExpressionListNode #JavaStatementExpressionListNode #SmaCCToken #OrderedCollection #OrderedCollection #JavaFinallyClauseNode #JavaCatchClauseNode #JavaExpressionNode #JavaNewArrayNode #JavaFieldAccessNode #JavaArrayAccessNode #OrderedCollection #JavaProgramNode #JavaLambdaExpressionNode #OrderedCollection #JavaParameterNode #OrderedCollection #JavaParameterNode #OrderedCollection #OrderedCollection #OrderedCollection #JavaDimensionExpressionNode #OrderedCollection #OrderedCollection #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaCastExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #JavaExpressionNode #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #JavaProgramNode #JavaElementValuePairNode #JavaElementArrayInitializerNode #OrderedCollection #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JavaEnumConstantNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JavaTypeParameterNode #OrderedCollection #OrderedCollection #OrderedCollection #JavaTypeArgumentNode #OrderedCollection #JavaTypeNameNode #JavaQualifiedTypeNameNode #JavaProgramNode #SmaCCToken #SmaCCToken #JavaProgramNode #JavaProgramNode #JavaProgramFileNode)!

transitionTable
^#(
#[1 0 6 0 8 0 6 0 9 0 6 0 12 0 6 0 13 0 7 0 14 0 6 0 18 0 6 0 19 0 10 0 35 0 6 0 37 0 6 0 38 0 6 0 39 0 6 0 40 0 6 0 41 0 6 0 42 0 6 0 43 0 6 0 44 0 6 0 46 0 6 0 47 0 21 0 108 0 25 0 127 0 29 0 130 0 33 0 134 0 37 0 209 0 6 1 51] 
#[1 0 41 0 1 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 1 213 1 53] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 241 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 45 0 8 0 14 0 9 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 2 105 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 2 121 0 142 1 37 0 143 1 41 0 144 1 45 0 149] 
#[0 0 0 1 51] 
#[1 0 26 0 8 0 26 0 9 0 26 0 12 0 26 0 13 0 26 0 14 0 26 0 18 0 26 0 19 0 26 0 37 0 26 0 38 0 26 0 39 0 26 0 40 0 26 0 41 0 26 0 42 0 26 0 43 2 125 0 44 0 26 0 46 0 26 0 47 2 129 0 128 2 133 0 131 2 137 0 133 2 141 0 135 2 145 0 136 0 26 1 51] 
#[0 0 30 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[1 0 57 0 14 2 149 0 35 2 153 0 144] 
#[0 0 34 1 51] 
#[1 0 41 0 1 0 38 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 2 157 0 181 1 61 0 183 2 161 0 198 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 2 165 1 53] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 46 0 30 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[1 2 169 0 104 1 9 0 123 1 13 0 124 2 173 0 125] 
#[0 0 50 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 177 0 30] 
#[1 0 42 0 8 0 42 0 9 0 42 0 12 0 42 0 13 0 42 0 14 0 42 0 18 0 42 0 19 2 181 0 23 0 42 0 37 0 42 0 38 0 42 0 39 0 42 0 40 0 42 0 41 0 42 0 42 0 42 0 43 0 42 0 46] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 185 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 2 189 0 23] 
#[0 0 54 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 58 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 62 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 66 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 70 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 74 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 78 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 82 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 2 193 0 23] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 86 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 197 0 54 2 201 0 104 2 205 0 111 2 209 0 112 2 213 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 2 229 1 45 2 233 1 46 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 90 0 47 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 237 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 2 241 0 235 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 245 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 41 0 1 2 249 0 159] 
#[1 0 94 0 47 2 253 0 104 3 1 0 240] 
#[1 0 94 0 47 2 253 0 104 3 5 0 240] 
#[0 3 9 0 23] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 3 17 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 21 0 23] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 3 25 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 3 29 0 111 0 245 0 114 0 249 0 115 0 253 0 116 3 33 0 117 3 37 0 119 3 41 0 120 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 3 57 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 3 61 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 0 98 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 102 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 106 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 110 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 114 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 118 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 0 122 0 3 0 71 0 7 0 71 0 30 0 122 0 48 0 122 0 59 0 153 0 60 0 122 0 61 0 122 0 62 0 122 0 63 0 122 0 64 0 122 0 65 0 122 0 68 0 122 0 69 0 122 0 70 0 122 0 71 3 65 0 72 0 122 0 92 0 122 0 93 3 69 1 5] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 130 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 3 73 0 7 3 77 0 30 3 81 0 122 3 85 1 4] 
#[0 0 134 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 138 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 0 138 0 5 0 7 0 20 0 21 0 30 0 53 0 95 0 104] 
#[0 3 89 0 30] 
#[1 3 73 0 7 3 93 0 30 3 97 0 122 3 85 1 4] 
#[0 0 142 0 2 0 3 0 5 0 6 0 7 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[0 0 142 0 2 0 3 0 5 0 6 0 7 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[1 0 146 0 2 0 150 0 3 0 146 0 5 0 146 0 6 3 101 0 7 0 146 0 20 3 105 0 30 0 146 0 45 0 146 0 47 0 150 0 48 0 146 0 49 0 146 0 50 0 146 0 51 0 146 0 52 0 146 0 53 0 146 0 54 0 146 0 55 0 146 0 56 0 146 0 57 0 146 0 58 0 150 0 59 0 146 0 60 0 150 0 61 0 150 0 62 0 150 0 63 0 150 0 64 0 150 0 65 0 146 0 66 0 146 0 67 0 150 0 68 0 150 0 69 0 150 0 70 0 150 0 71 0 146 0 72 0 146 0 87 0 146 0 88 0 146 0 89 0 146 0 90 0 146 0 92 0 146 0 93 0 146 0 95 0 146 0 96 0 146 0 97 0 146 1 51] 
#[0 0 154 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 154 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 45 0 8 0 158 0 9 0 158 0 11 0 53 0 12 0 158 0 13 0 75 0 14 2 97 0 18 0 73 0 19 0 158 0 25 0 158 0 26 0 158 0 27 0 158 0 28 0 158 0 29 0 158 0 31 0 158 0 33 0 158 0 34 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 158 0 43 0 145 0 46 0 158 0 60 0 158 0 104 3 109 0 143 1 41 0 144] 
#[1 3 113 0 9 3 117 0 13 3 121 0 43] 
#[0 0 162 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 166 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 0 170 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 125 0 30] 
#[1 0 57 0 14 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 3 129 0 39 2 201 0 104 2 205 0 111 2 209 0 112 3 133 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 3 137 0 144 1 205 1 48 1 209 1 49 3 141 1 50] 
#[1 0 146 0 2 0 146 0 5 0 146 0 6 0 146 0 20 3 145 0 30 0 146 0 45 0 146 0 47 0 146 0 49 0 146 0 50 0 146 0 51 0 146 0 52 0 146 0 53 0 146 0 54 0 146 0 55 0 146 0 56 0 146 0 57 0 146 0 58 0 146 0 60 0 146 0 66 0 146 0 67 0 146 0 72 0 146 0 87 0 146 0 88 0 146 0 89 0 146 0 90 0 146 0 92 0 146 0 93 0 146 0 95 0 146 0 96 0 146 0 97 0 146 1 51] 
#[0 0 154 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 154 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 149 0 47] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 174 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 0 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 153 0 47] 
#[0 0 178 0 5 0 20 0 47] 
#[0 0 178 0 5 0 20 0 47] 
#[0 0 178 0 5 0 20 0 47] 
#[1 0 178 0 5 0 178 0 20 0 178 0 47 0 146 0 92 0 146 0 93] 
#[1 0 178 0 5 0 178 0 20 0 178 0 47 0 146 0 92 0 146 0 93] 
#[1 0 178 0 5 0 130 0 7 0 178 0 20 0 130 0 30 0 178 0 47 0 130 0 92 0 130 0 93] 
#[1 0 178 0 5 0 130 0 7 0 178 0 20 0 130 0 30 0 178 0 47 0 130 0 92 0 130 0 93] 
#[1 0 182 0 2 0 182 0 5 0 182 0 6 3 157 0 7 0 182 0 20 0 182 0 30 0 182 0 45 0 182 0 47 0 182 0 49 0 182 0 50 0 182 0 51 0 182 0 52 0 182 0 53 0 182 0 54 0 182 0 55 0 182 0 56 0 182 0 57 0 182 0 58 0 182 0 60 0 182 0 66 0 182 0 67 0 182 0 72 0 182 0 87 0 182 0 88 0 182 0 89 0 182 0 90 0 182 0 92 0 182 0 93 0 182 0 95 0 182 0 96 0 182 0 97 0 182 1 51] 
#[0 0 182 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 0 130 0 2 0 150 0 3 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 20 0 130 0 30 0 130 0 45 0 130 0 47 0 150 0 48 0 130 0 49 0 130 0 50 0 130 0 51 0 130 0 52 0 130 0 53 0 130 0 54 0 130 0 55 0 130 0 56 0 130 0 57 0 130 0 58 0 150 0 59 0 130 0 60 0 150 0 61 0 150 0 62 0 150 0 63 0 150 0 64 0 150 0 65 0 130 0 66 0 130 0 67 0 150 0 68 0 150 0 69 0 150 0 70 0 150 0 71 0 130 0 72 0 130 0 87 0 130 0 88 0 130 0 89 0 130 0 90 0 130 0 92 0 130 0 93 0 130 0 95 0 130 0 96 0 130 0 97 0 130 1 51] 
#[1 0 130 0 2 0 150 0 3 0 130 0 5 0 130 0 6 0 130 0 7 0 130 0 20 0 130 0 30 0 130 0 45 0 130 0 47 0 150 0 48 0 130 0 49 0 130 0 50 0 130 0 51 0 130 0 52 0 130 0 53 0 130 0 54 0 130 0 55 0 130 0 56 0 130 0 57 0 130 0 58 0 150 0 59 0 130 0 60 0 150 0 61 0 150 0 62 0 150 0 63 0 150 0 64 0 150 0 65 0 130 0 66 0 130 0 67 0 150 0 68 0 150 0 69 0 150 0 70 0 150 0 71 0 130 0 72 0 130 0 87 0 130 0 88 0 130 0 89 0 130 0 90 0 130 0 92 0 130 0 93 0 130 0 95 0 130 0 96 0 130 0 97 0 130 1 51] 
#[0 3 161 0 104] 
#[1 3 165 0 92 3 169 0 93] 
#[1 3 173 0 3 3 177 0 48 3 181 0 59 3 185 0 61 3 189 0 62 3 193 0 63 3 197 0 64 3 201 0 65 3 205 0 68 3 209 0 69 3 213 0 70 3 217 0 71 3 221 1 23] 
#[0 0 186 0 1 0 2 0 4 0 5 0 6 0 7 0 15 0 20 0 21 0 23 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 0 186 0 1 0 2 0 4 0 5 0 6 0 7 0 15 0 20 0 21 0 23 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 0 0 1 51] 
#[1 0 49 0 11 0 18 0 14 0 61 0 16 0 65 0 17 0 190 0 20 1 217 0 23 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 18 0 39 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 79 0 104 0 237 0 110 3 225 0 111 2 209 0 112 3 229 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 3 233 0 118 2 225 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 185 0 156 1 245 0 164 1 53 0 171 3 237 0 174 3 241 0 175 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 3 245 0 252 3 249 0 253 3 253 0 254 4 1 0 255 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 4 5 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 4 9 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 4 13 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 4 17 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 122 0 2 0 122 0 3 0 83 0 5 0 122 0 6 0 87 0 7 0 87 0 20 0 71 0 30 0 122 0 45 0 122 0 47 0 122 0 48 0 122 0 49 0 122 0 50 0 122 0 51 0 122 0 52 0 122 0 53 0 122 0 54 0 122 0 55 0 122 0 56 0 122 0 57 0 122 0 58 0 122 0 59 0 91 0 60 0 122 0 61 0 122 0 62 0 122 0 63 0 122 0 64 0 122 0 65 0 122 0 66 0 122 0 67 0 122 0 68 0 122 0 69 0 122 0 70 0 122 0 71 0 122 0 72 0 122 0 87 0 122 0 88 0 122 0 89 0 122 0 90 0 122 0 92 0 122 0 93 0 194 0 94 0 122 0 95 0 122 0 96 0 122 0 97 3 69 1 5 0 122 1 51] 
#[0 0 0 1 51] 
#[1 0 198 0 5 4 21 0 7 0 198 0 20 0 198 0 94] 
#[0 0 95 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 202 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 202 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 146 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 146 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 130 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 130 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 4 25 0 94] 
#[0 0 210 0 2 0 5 0 6 0 20 0 47 0 72 1 51] 
#[0 0 214 0 94] 
#[1 0 218 0 2 0 218 0 5 0 218 0 6 0 218 0 20 0 218 0 45 0 218 0 47 0 218 0 49 0 218 0 50 0 218 0 51 0 218 0 52 0 218 0 53 0 218 0 54 0 218 0 55 0 218 0 56 0 218 0 57 0 218 0 58 0 218 0 60 0 218 0 66 0 218 0 67 0 218 0 72 0 218 0 87 0 218 0 88 0 218 0 89 0 218 0 90 3 165 0 92 3 169 0 93 0 218 0 95 0 218 0 96 0 218 0 97 0 218 1 51] 
#[0 0 222 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 202 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 218 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 0 226 0 2 0 226 0 5 0 226 0 6 0 226 0 20 0 99 0 45 0 226 0 47 0 226 0 49 0 226 0 50 0 226 0 51 0 226 0 52 0 226 0 53 0 226 0 54 0 226 0 55 0 226 0 56 0 226 0 57 0 226 0 58 0 226 0 60 0 226 0 66 0 226 0 67 0 226 0 72 0 103 0 87 0 226 0 88 0 226 0 89 0 107 0 90 0 226 0 95 0 226 0 96 0 226 0 97 0 226 1 51] 
#[1 0 230 0 2 0 230 0 5 0 230 0 6 0 230 0 20 0 230 0 45 0 230 0 47 0 230 0 49 0 230 0 50 0 230 0 51 0 230 0 52 0 230 0 53 0 230 0 54 0 230 0 55 0 230 0 56 0 230 0 57 0 230 0 58 0 230 0 60 0 230 0 66 0 230 0 67 0 230 0 72 0 230 0 87 0 111 0 88 0 115 0 89 0 230 0 90 0 230 0 95 0 230 0 96 0 230 0 97 0 230 1 51] 
#[1 0 234 0 2 0 234 0 5 0 234 0 6 0 234 0 20 0 234 0 45 0 234 0 47 0 234 0 49 0 234 0 50 0 234 0 51 0 234 0 52 0 234 0 53 0 234 0 54 0 234 0 55 0 234 0 56 0 234 0 57 0 234 0 58 0 234 0 60 0 119 0 66 0 234 0 67 0 234 0 72 0 234 0 87 0 234 0 88 0 234 0 89 0 234 0 90 0 234 0 95 0 123 0 96 0 127 0 97 0 234 1 51] 
#[1 0 238 0 2 0 238 0 5 0 238 0 6 0 238 0 20 0 238 0 45 0 238 0 47 0 238 0 49 0 238 0 50 0 238 0 51 0 238 0 52 0 238 0 53 0 238 0 54 0 238 0 55 0 131 0 56 0 135 0 57 0 238 0 58 0 139 0 60 0 238 0 66 0 143 0 67 0 238 0 72 0 238 0 87 0 238 0 88 0 238 0 89 0 238 0 90 0 147 0 95 0 238 0 96 0 238 0 97 0 238 1 51] 
#[1 0 242 0 2 0 242 0 5 0 242 0 6 0 242 0 20 0 242 0 45 0 242 0 47 0 242 0 49 0 242 0 50 0 242 0 51 0 151 0 52 0 242 0 53 0 242 0 54 0 242 0 55 0 242 0 56 0 242 0 57 0 155 0 58 0 242 0 60 0 242 0 66 0 242 0 67 0 242 0 72 0 242 0 87 0 242 0 88 0 242 0 89 0 242 0 90 0 242 0 95 0 242 0 96 0 242 0 97 0 242 1 51] 
#[1 0 246 0 2 0 246 0 5 0 246 0 6 0 246 0 20 0 246 0 45 0 246 0 47 0 246 0 49 0 246 0 50 0 246 0 51 0 246 0 52 0 159 0 53 0 246 0 54 0 246 0 55 0 246 0 56 0 246 0 57 0 246 0 58 0 246 0 60 0 246 0 66 0 246 0 67 0 246 0 72 0 246 0 87 0 246 0 88 0 246 0 89 0 246 0 90 0 246 0 95 0 246 0 96 0 246 0 97 0 246 1 51] 
#[1 0 250 0 2 0 250 0 5 0 250 0 6 0 250 0 20 0 250 0 45 0 250 0 47 0 163 0 49 0 250 0 50 0 250 0 51 0 250 0 52 0 250 0 53 0 250 0 54 0 250 0 55 0 250 0 56 0 250 0 57 0 250 0 58 0 250 0 60 0 250 0 66 0 250 0 67 0 250 0 72 0 250 0 87 0 250 0 88 0 250 0 89 0 250 0 90 0 250 0 95 0 250 0 96 0 250 0 97 0 250 1 51] 
#[1 0 254 0 2 0 254 0 5 0 254 0 6 0 254 0 20 0 254 0 45 0 254 0 47 0 254 0 49 0 167 0 50 0 254 0 51 0 254 0 52 0 254 0 53 0 254 0 54 0 254 0 55 0 254 0 56 0 254 0 57 0 254 0 58 0 254 0 60 0 254 0 66 0 254 0 67 0 254 0 72 0 254 0 87 0 254 0 88 0 254 0 89 0 254 0 90 0 254 0 95 0 254 0 96 0 254 0 97 0 254 1 51] 
#[1 1 2 0 2 1 2 0 5 1 2 0 6 1 2 0 20 1 2 0 45 1 2 0 47 1 2 0 49 1 2 0 50 0 171 0 51 1 2 0 52 1 2 0 53 1 2 0 54 1 2 0 55 1 2 0 56 1 2 0 57 1 2 0 58 1 2 0 60 1 2 0 66 1 2 0 67 1 2 0 72 1 2 0 87 1 2 0 88 1 2 0 89 1 2 0 90 1 2 0 95 1 2 0 96 1 2 0 97 1 2 1 51] 
#[1 1 6 0 2 1 6 0 5 1 6 0 6 1 6 0 20 1 6 0 45 1 6 0 47 1 6 0 49 1 6 0 50 1 6 0 51 1 6 0 52 1 6 0 53 0 175 0 54 0 179 0 55 1 6 0 56 1 6 0 57 1 6 0 58 1 6 0 60 1 6 0 66 1 6 0 67 1 6 0 72 1 6 0 87 1 6 0 88 1 6 0 89 1 6 0 90 1 6 0 95 1 6 0 96 1 6 0 97 1 6 1 51] 
#[0 0 206 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 0 210 0 2 0 5 0 6 0 20 0 47 0 72 1 51] 
#[0 0 42 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 1 10 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[0 0 0 1 51] 
#[0 1 14 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[0 1 14 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[0 1 14 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[1 3 113 0 9 3 117 0 13 4 113 0 14 3 121 0 43] 
#[1 4 117 0 37 1 18 0 104 4 121 0 137] 
#[1 0 45 0 8 0 14 0 9 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 4 125 0 126 4 129 0 129 4 133 0 132 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 2 121 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 22 1 51] 
#[1 1 26 0 8 1 26 0 9 1 26 0 12 1 26 0 13 1 26 0 14 1 26 0 18 1 26 0 19 1 26 0 37 1 26 0 38 1 26 0 39 1 26 0 40 1 26 0 41 1 26 0 42 1 26 0 43 2 125 0 44 1 26 0 46 1 26 0 47 4 137 0 133 2 141 0 135 2 145 0 136 1 26 1 51] 
#[0 1 30 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[0 1 34 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[0 1 34 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[1 2 169 0 104 1 9 0 123 1 13 0 124 4 141 0 125] 
#[0 1 38 0 14 0 35 0 104] 
#[1 0 41 0 1 1 42 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 4 145 1 53] 
#[0 4 149 0 2] 
#[0 1 46 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 0 122 0 2 0 5 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 1 50 0 2 1 50 0 5 1 50 0 8 1 50 0 9 1 50 0 11 1 50 0 12 1 50 0 13 1 50 0 14 1 50 0 18 1 50 0 19 1 50 0 20 4 153 0 23 1 50 0 25 1 50 0 26 1 50 0 27 1 50 0 28 1 50 0 29 4 157 0 30 1 50 0 31 1 50 0 33 1 50 0 34 1 50 0 35 1 50 0 37 1 50 0 38 1 50 0 39 1 50 0 40 1 50 0 41 1 50 0 42 1 50 0 43 1 50 0 46 1 50 0 60 1 50 0 104 4 161 1 24] 
#[1 0 153 0 60 0 183 0 104 4 169 1 5] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 4 173 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 4 177 0 20] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 4 181 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 4 185 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 1 54 0 5 4 189 0 10 4 193 0 17 1 54 0 95 4 197 1 47] 
#[1 0 22 0 1 0 22 0 2 0 22 0 4 0 22 0 5 0 22 0 6 0 22 0 7 0 22 0 15 0 22 0 20 0 22 0 21 0 22 0 23 0 22 0 30 0 22 0 45 0 22 0 47 0 22 0 49 0 22 0 50 0 22 0 51 0 22 0 52 0 22 0 53 0 22 0 54 0 22 0 55 0 22 0 56 0 22 0 57 0 22 0 58 0 187 0 60 0 22 0 66 0 22 0 67 0 22 0 72 0 22 0 87 0 22 0 88 0 22 0 89 0 22 0 90 0 22 0 95 0 22 0 96 0 22 0 97 0 22 0 104 3 69 1 5 0 22 1 51] 
#[1 1 58 0 5 3 73 0 7 1 58 0 21 1 58 0 53 1 58 0 95 1 58 0 104 3 81 0 122 3 85 1 4] 
#[0 1 58 0 5 0 20 0 21 0 53 0 95 0 104] 
#[0 1 62 0 5 0 95] 
#[0 1 66 0 2 0 5 0 6 0 20 0 21 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 1 66 0 2 0 5 0 6 0 20 0 21 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[1 1 70 0 2 1 70 0 5 1 70 0 6 3 73 0 7 1 70 0 20 1 70 0 21 3 93 0 30 1 70 0 45 1 70 0 47 1 70 0 49 1 70 0 50 1 70 0 51 1 70 0 52 1 70 0 53 1 70 0 54 1 70 0 55 1 70 0 56 1 70 0 57 1 70 0 58 1 70 0 60 1 70 0 66 1 70 0 67 1 70 0 72 1 70 0 87 1 70 0 88 1 70 0 89 1 70 0 90 1 70 0 95 1 70 0 96 1 70 0 97 1 70 0 104 3 97 0 122 3 85 1 4 1 70 1 51] 
#[1 4 201 0 5 4 205 0 95] 
#[0 1 74 0 5 0 95] 
#[0 1 78 0 47] 
#[0 4 209 0 47] 
#[0 4 213 0 47] 
#[1 1 82 0 78 4 217 0 79 4 221 0 241 4 225 0 242 4 229 0 244] 
#[0 1 86 0 47] 
#[0 4 233 0 47] 
#[0 4 237 0 47] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 4 241 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 2 181 0 23] 
#[0 4 245 0 80] 
#[1 0 49 0 11 0 18 0 14 0 61 0 16 0 65 0 17 0 77 0 23 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 18 0 39 1 90 0 47 0 153 0 60 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 191 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 4 249 0 175 1 61 0 183 4 253 0 201 5 1 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 5 5 0 234 5 9 0 237 5 13 0 238 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 5 17 0 47 5 21 0 72] 
#[1 5 25 0 7 5 29 0 122 5 33 1 1 5 37 1 3 3 85 1 4] 
#[1 5 25 0 7 1 94 0 23 5 41 0 122 5 45 1 1 5 37 1 3 3 85 1 4] 
#[1 1 70 0 1 1 70 0 4 1 70 0 5 1 70 0 7 1 70 0 15 1 70 0 23 3 93 0 30 1 70 0 47] 
#[0 5 49 0 23] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 3 225 0 111 2 209 0 112 3 229 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 3 233 0 118 2 225 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 185 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 122 0 2 0 122 0 3 0 122 0 5 0 122 0 6 0 71 0 7 0 122 0 20 0 122 0 23 0 71 0 30 0 122 0 45 0 122 0 47 0 122 0 48 0 122 0 49 0 122 0 50 0 122 0 51 0 122 0 52 0 122 0 53 0 122 0 54 0 122 0 55 0 122 0 56 0 122 0 57 0 122 0 58 0 122 0 59 0 91 0 60 0 122 0 61 0 122 0 62 0 122 0 63 0 122 0 64 0 122 0 65 0 122 0 66 0 122 0 67 0 122 0 68 0 122 0 69 0 122 0 70 0 122 0 71 0 122 0 72 0 122 0 87 0 122 0 88 0 122 0 89 0 122 0 90 0 122 0 92 0 122 0 93 0 122 0 95 0 122 0 96 0 122 0 97 0 22 0 104 3 69 1 5 0 122 1 51] 
#[0 0 202 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 1 98 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 1 102 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 5 53 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 1 106 0 1 0 2 0 4 0 5 0 6 0 7 0 15 0 20 0 21 0 23 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 5 57 0 6] 
#[0 5 61 0 9] 
#[1 1 110 0 2 1 110 0 5 1 110 0 6 3 73 0 7 1 110 0 20 1 110 0 21 1 110 0 30 1 110 0 45 1 110 0 47 1 110 0 49 1 110 0 50 1 110 0 51 1 110 0 52 1 110 0 53 1 110 0 54 1 110 0 55 1 110 0 56 1 110 0 57 1 110 0 58 1 110 0 60 1 110 0 66 1 110 0 67 1 110 0 72 1 110 0 87 1 110 0 88 1 110 0 89 1 110 0 90 1 110 0 95 1 110 0 96 1 110 0 97 1 110 0 104 5 65 1 4 1 110 1 51] 
#[0 1 114 0 1 0 2 0 5 0 6 0 7 0 20 0 21 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[0 5 69 0 9] 
#[0 5 73 0 104] 
#[1 1 110 0 2 1 110 0 5 1 110 0 6 3 73 0 7 1 110 0 20 1 110 0 21 1 110 0 30 1 110 0 45 1 110 0 47 1 110 0 49 1 110 0 50 1 110 0 51 1 110 0 52 1 110 0 53 1 110 0 54 1 110 0 55 1 110 0 56 1 110 0 57 1 110 0 58 1 110 0 60 1 110 0 66 1 110 0 67 1 110 0 72 1 110 0 87 1 110 0 88 1 110 0 89 1 110 0 90 1 110 0 95 1 110 0 96 1 110 0 97 1 110 0 104 5 65 1 4 1 110 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 5 77 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 5 81 0 9 5 85 0 16 5 89 0 17 0 153 0 60 0 195 0 104 5 97 1 5] 
#[0 1 118 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 5 101 0 104] 
#[0 5 105 0 104] 
#[0 5 109 0 104] 
#[0 5 113 0 9] 
#[0 1 122 0 14 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 39 0 104] 
#[1 5 117 0 104 5 121 0 162 5 125 0 163 5 129 0 164] 
#[0 1 126 0 14 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 39 0 104] 
#[0 1 130 0 14 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 39 0 104] 
#[1 0 153 0 60 5 133 0 91 0 199 0 104 5 141 1 5] 
#[0 1 134 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 1 138 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 5 145 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 5 149 0 23] 
#[0 1 142 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 1 146 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 150 0 11 0 16 0 17 0 23 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 60 0 85 0 86 0 88 0 89 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 5 153 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 3 73 0 7 1 58 0 20 3 77 0 30 3 81 0 122 3 85 1 4] 
#[0 5 157 0 20] 
#[1 1 66 0 20 3 89 0 30] 
#[0 1 154 0 5 0 20] 
#[1 0 57 0 14 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 3 129 0 39 2 201 0 104 2 205 0 111 2 209 0 112 5 161 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 3 137 0 144 1 205 1 48 1 209 1 49 3 141 1 50] 
#[0 5 165 0 20] 
#[1 1 154 0 5 1 154 0 20 0 214 0 94] 
#[1 5 169 0 5 1 158 0 20] 
#[0 1 162 0 5 0 20] 
#[0 1 166 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 1 170 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 1 174 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 1 178 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 5 173 0 6] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 5 177 0 156 5 181 0 159 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 5 185 0 250 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 5 189 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 5 193 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 5 197 1 7 2 41 1 8 2 45 1 9 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 5 201 1 10 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 5 205 1 10 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 5 209 1 11 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 5 213 1 11 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 5 217 1 11 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 5 221 1 12 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 5 225 0 111 5 229 0 112 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 5 233 1 12 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 5 237 1 12 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 5 241 1 12 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 5 245 1 13 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 5 249 1 13 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 5 253 1 14 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 6 1 1 15 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 6 5 1 16 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 6 9 1 17 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 13 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 6 17 1 18 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 6 21 0 43] 
#[0 1 182 0 104] 
#[1 2 169 0 104 1 9 0 123 1 13 0 124 6 25 0 125] 
#[0 1 186 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 1 51] 
#[0 1 190 1 51] 
#[1 0 45 0 8 0 14 0 9 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 6 29 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 2 121 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 194 1 51] 
#[0 1 198 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[1 4 157 0 30 6 33 0 47] 
#[0 1 202 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 1 206 0 1 0 2 0 5 0 6 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 6 37 0 1 0 49 0 11 0 57 0 14 0 61 0 16 0 65 0 17 1 210 0 20 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 203 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 45 0 144 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 6 49 1 20 1 201 1 22 6 53 1 25 6 57 1 26 6 61 1 27 6 65 1 28 6 69 1 29 1 205 1 48 1 209 1 49] 
#[0 5 93 0 104] 
#[0 1 214 0 2 0 5 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[0 1 218 0 2 0 3 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 6 73 0 104] 
#[0 6 77 0 20] 
#[0 1 222 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 6 81 0 20] 
#[0 6 85 0 20] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 2 205 0 111 2 209 0 112 6 89 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 1 205 1 48 1 209 1 49] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 2 205 0 111 2 209 0 112 6 93 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 1 205 1 48 1 209 1 49] 
#[0 1 226 0 5 0 95] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 197 0 54 2 201 0 104 2 205 0 111 2 209 0 112 2 213 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 6 97 1 46 1 205 1 48 1 209 1 49] 
#[0 1 230 0 1 0 2 0 4 0 5 0 6 0 7 0 15 0 20 0 21 0 23 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 1 234 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 1 238 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 6 101 0 23] 
#[1 1 242 0 1 1 242 0 2 1 242 0 8 1 242 0 9 1 242 0 11 1 242 0 12 1 242 0 13 1 242 0 14 1 242 0 15 1 242 0 16 1 242 0 17 1 242 0 18 1 242 0 19 1 242 0 23 1 242 0 24 1 242 0 25 1 242 0 26 1 242 0 27 1 242 0 28 1 242 0 29 1 242 0 31 1 242 0 32 1 242 0 33 1 242 0 34 1 242 0 36 1 242 0 37 1 242 0 38 1 242 0 39 1 242 0 40 1 242 0 41 1 242 0 42 1 242 0 43 1 242 0 46 1 242 0 47 1 242 0 60 1 242 0 73 1 242 0 74 1 242 0 75 1 242 0 76 1 242 0 77 1 246 0 78 4 217 0 79 1 242 0 80 1 242 0 81 1 242 0 82 1 242 0 83 1 242 0 84 1 242 0 91 1 242 0 92 1 242 0 93 1 242 0 98 1 242 0 99 1 242 0 100 1 242 0 101 1 242 0 102 1 242 0 103 1 242 0 104 6 105 0 244 1 242 1 51] 
#[1 6 109 0 78 6 113 0 243] 
#[0 1 250 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 1 254 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 2 2 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 6 117 0 20] 
#[0 6 121 0 23] 
#[1 0 57 0 14 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 3 129 0 39 2 201 0 104 2 205 0 111 2 209 0 112 6 125 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 3 137 0 144 1 205 1 48 1 209 1 49 3 141 1 50] 
#[0 2 6 0 47] 
#[0 2 10 0 5 0 20 0 47] 
#[0 6 129 0 47] 
#[0 2 14 0 47] 
#[1 6 133 0 5 2 6 0 47] 
#[0 2 18 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 137 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 5 57 0 6 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 141 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 6 145 0 1 3 73 0 7 6 149 0 166 5 65 1 4] 
#[1 2 22 0 2 2 22 0 5 2 22 0 6 5 25 0 7 2 22 0 20 2 22 0 30 2 22 0 45 2 22 0 47 2 22 0 49 2 22 0 50 2 22 0 51 2 22 0 52 2 22 0 53 2 22 0 54 2 22 0 55 2 22 0 56 2 22 0 57 2 22 0 58 2 22 0 60 2 22 0 66 2 22 0 67 2 22 0 72 2 22 0 87 2 22 0 88 2 22 0 89 2 22 0 90 2 22 0 92 2 22 0 93 2 22 0 95 2 22 0 96 2 22 0 97 6 153 0 122 6 157 1 2 6 161 1 3 3 85 1 4 2 22 1 51] 
#[0 2 26 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 6 145 0 1 3 73 0 7 6 165 0 166 5 65 1 4] 
#[1 2 22 0 2 2 22 0 5 2 22 0 6 5 25 0 7 2 22 0 20 2 22 0 30 2 22 0 45 2 22 0 47 2 22 0 49 2 22 0 50 2 22 0 51 2 22 0 52 2 22 0 53 2 22 0 54 2 22 0 55 2 22 0 56 2 22 0 57 2 22 0 58 2 22 0 60 2 22 0 66 2 22 0 67 2 22 0 72 2 22 0 87 2 22 0 88 2 22 0 89 2 22 0 90 2 22 0 92 2 22 0 93 2 22 0 95 2 22 0 96 2 22 0 97 6 153 0 122 6 169 1 2 6 161 1 3 3 85 1 4 2 22 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 6 177 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 2 34 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 2 38 0 1 0 2 0 5 0 6 0 7 0 20 0 21 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[0 2 42 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 46 0 1 0 2 0 5 0 6 0 7 0 20 0 21 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[0 2 42 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 0 22 0 1 0 22 0 2 0 22 0 4 0 22 0 5 0 22 0 6 0 22 0 7 0 22 0 15 0 22 0 20 0 22 0 21 0 22 0 23 0 22 0 30 0 22 0 45 0 22 0 47 0 22 0 49 0 22 0 50 0 22 0 51 0 22 0 52 0 22 0 53 0 22 0 54 0 22 0 55 0 22 0 56 0 22 0 57 0 22 0 58 0 187 0 60 0 22 0 66 0 22 0 67 0 22 0 72 0 22 0 87 0 22 0 88 0 22 0 89 0 22 0 90 0 22 0 95 0 22 0 96 0 22 0 97 0 22 0 104 6 185 1 5 0 22 1 51] 
#[0 6 189 0 6] 
#[0 2 50 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 54 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 6 193 0 30] 
#[0 2 58 0 2 0 3 0 5 0 6 0 7 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 23 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 0 104 1 51] 
#[0 6 197 0 104] 
#[1 2 62 0 1 2 62 0 4 2 62 0 10 6 201 0 60 6 205 0 145] 
#[1 2 66 0 1 6 209 0 4 6 213 0 147 6 217 0 152] 
#[1 2 62 0 1 2 62 0 10 6 201 0 60 6 221 0 145] 
#[0 2 42 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 194 0 3 0 5 0 7 0 20 0 47] 
#[1 6 225 0 5 2 70 0 47] 
#[0 2 74 0 5 0 47] 
#[1 6 229 0 3 2 78 0 5 4 21 0 7 2 78 0 47] 
#[0 6 233 0 104] 
#[0 2 82 0 2 0 3 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 6 237 0 104] 
#[0 6 241 0 6] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 6 245 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 2 86 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 0 193 0 91 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 6 249 0 125 1 53 0 171 1 61 0 183 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 6 253 0 247 7 1 0 248 1 193 1 5 2 33 1 6 7 5 1 8 2 45 1 9 1 205 1 48 1 209 1 49] 
#[1 7 9 0 21 5 117 0 104 7 13 0 164] 
#[0 2 90 0 94] 
#[1 0 18 0 14 0 18 0 25 0 18 0 26 0 18 0 27 0 18 0 28 0 18 0 29 0 18 0 31 0 18 0 33 0 18 0 34 0 18 0 39 0 207 0 104 1 245 0 164 3 237 0 174 3 241 0 175 7 17 0 253 7 21 0 255] 
#[0 2 94 0 3 0 5 0 7 0 20 0 47 0 94] 
#[0 2 98 0 2 0 5 0 6 0 20 0 47 0 72 1 51] 
#[0 2 98 0 2 0 5 0 6 0 20 0 47 0 72 1 51] 
#[0 2 102 0 2 0 5 0 6 0 20 0 47 0 72 1 51] 
#[0 2 106 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 2 106 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[0 2 106 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 2 110 0 2 2 110 0 5 2 110 0 6 2 110 0 20 0 211 0 45 2 110 0 47 2 110 0 49 2 110 0 50 2 110 0 51 2 110 0 52 2 110 0 53 2 110 0 54 2 110 0 55 2 110 0 56 2 110 0 57 2 110 0 58 2 110 0 60 2 110 0 66 2 110 0 67 2 110 0 72 0 215 0 87 2 110 0 88 2 110 0 89 0 219 0 90 2 110 0 95 2 110 0 96 2 110 0 97 2 110 1 51] 
#[1 2 110 0 2 2 110 0 5 2 110 0 6 2 110 0 20 0 211 0 45 2 110 0 47 2 110 0 49 2 110 0 50 2 110 0 51 2 110 0 52 2 110 0 53 2 110 0 54 2 110 0 55 2 110 0 56 2 110 0 57 2 110 0 58 2 110 0 60 2 110 0 66 2 110 0 67 2 110 0 72 0 215 0 87 2 110 0 88 2 110 0 89 0 219 0 90 2 110 0 95 2 110 0 96 2 110 0 97 2 110 1 51] 
#[1 2 114 0 2 2 114 0 5 2 114 0 6 2 114 0 20 2 114 0 45 2 114 0 47 2 114 0 49 2 114 0 50 2 114 0 51 2 114 0 52 2 114 0 53 2 114 0 54 2 114 0 55 2 114 0 56 2 114 0 57 2 114 0 58 2 114 0 60 2 114 0 66 2 114 0 67 2 114 0 72 2 114 0 87 0 223 0 88 0 227 0 89 2 114 0 90 2 114 0 95 2 114 0 96 2 114 0 97 2 114 1 51] 
#[1 2 114 0 2 2 114 0 5 2 114 0 6 2 114 0 20 2 114 0 45 2 114 0 47 2 114 0 49 2 114 0 50 2 114 0 51 2 114 0 52 2 114 0 53 2 114 0 54 2 114 0 55 2 114 0 56 2 114 0 57 2 114 0 58 2 114 0 60 2 114 0 66 2 114 0 67 2 114 0 72 2 114 0 87 0 223 0 88 0 227 0 89 2 114 0 90 2 114 0 95 2 114 0 96 2 114 0 97 2 114 1 51] 
#[1 2 114 0 2 2 114 0 5 2 114 0 6 2 114 0 20 2 114 0 45 2 114 0 47 2 114 0 49 2 114 0 50 2 114 0 51 2 114 0 52 2 114 0 53 2 114 0 54 2 114 0 55 2 114 0 56 2 114 0 57 2 114 0 58 2 114 0 60 2 114 0 66 2 114 0 67 2 114 0 72 2 114 0 87 0 223 0 88 0 227 0 89 2 114 0 90 2 114 0 95 2 114 0 96 2 114 0 97 2 114 1 51] 
#[1 2 118 0 2 2 118 0 5 2 118 0 6 2 118 0 20 2 118 0 45 2 118 0 47 2 118 0 49 2 118 0 50 2 118 0 51 2 118 0 52 2 118 0 53 2 118 0 54 2 118 0 55 2 118 0 56 2 118 0 57 2 118 0 58 2 118 0 60 0 231 0 66 2 118 0 67 2 118 0 72 2 118 0 87 2 118 0 88 2 118 0 89 2 118 0 90 2 118 0 95 0 235 0 96 0 239 0 97 2 118 1 51] 
#[1 3 73 0 7 3 81 0 122 3 85 1 4] 
#[0 2 118 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 2 118 0 2 2 118 0 5 2 118 0 6 2 118 0 20 2 118 0 45 2 118 0 47 2 118 0 49 2 118 0 50 2 118 0 51 2 118 0 52 2 118 0 53 2 118 0 54 2 118 0 55 2 118 0 56 2 118 0 57 2 118 0 58 2 118 0 60 0 231 0 66 2 118 0 67 2 118 0 72 2 118 0 87 2 118 0 88 2 118 0 89 2 118 0 90 2 118 0 95 0 235 0 96 0 239 0 97 2 118 1 51] 
#[1 2 118 0 2 2 118 0 5 2 118 0 6 2 118 0 20 2 118 0 45 2 118 0 47 2 118 0 49 2 118 0 50 2 118 0 51 2 118 0 52 2 118 0 53 2 118 0 54 2 118 0 55 2 118 0 56 2 118 0 57 2 118 0 58 2 118 0 60 0 231 0 66 2 118 0 67 2 118 0 72 2 118 0 87 2 118 0 88 2 118 0 89 2 118 0 90 2 118 0 95 0 235 0 96 0 239 0 97 2 118 1 51] 
#[1 2 118 0 2 2 118 0 5 2 118 0 6 2 118 0 20 2 118 0 45 2 118 0 47 2 118 0 49 2 118 0 50 2 118 0 51 2 118 0 52 2 118 0 53 2 118 0 54 2 118 0 55 2 118 0 56 2 118 0 57 2 118 0 58 2 118 0 60 0 231 0 66 2 118 0 67 2 118 0 72 2 118 0 87 2 118 0 88 2 118 0 89 2 118 0 90 2 118 0 95 0 235 0 96 0 239 0 97 2 118 1 51] 
#[1 2 122 0 2 2 122 0 5 2 122 0 6 2 122 0 20 2 122 0 45 2 122 0 47 2 122 0 49 2 122 0 50 2 122 0 51 2 122 0 52 2 122 0 53 2 122 0 54 2 122 0 55 0 243 0 56 0 247 0 57 2 122 0 58 0 251 0 60 2 122 0 66 0 255 0 67 2 122 0 72 2 122 0 87 2 122 0 88 2 122 0 89 2 122 0 90 1 3 0 95 2 122 0 96 2 122 0 97 2 122 1 51] 
#[1 2 122 0 2 2 122 0 5 2 122 0 6 2 122 0 20 2 122 0 45 2 122 0 47 2 122 0 49 2 122 0 50 2 122 0 51 2 122 0 52 2 122 0 53 2 122 0 54 2 122 0 55 0 243 0 56 0 247 0 57 2 122 0 58 0 251 0 60 2 122 0 66 0 255 0 67 2 122 0 72 2 122 0 87 2 122 0 88 2 122 0 89 2 122 0 90 1 3 0 95 2 122 0 96 2 122 0 97 2 122 1 51] 
#[1 2 126 0 2 2 126 0 5 2 126 0 6 2 126 0 20 2 126 0 45 2 126 0 47 2 126 0 49 2 126 0 50 2 126 0 51 1 7 0 52 2 126 0 53 2 126 0 54 2 126 0 55 2 126 0 56 2 126 0 57 1 11 0 58 2 126 0 60 2 126 0 66 2 126 0 67 2 126 0 72 2 126 0 87 2 126 0 88 2 126 0 89 2 126 0 90 2 126 0 95 2 126 0 96 2 126 0 97 2 126 1 51] 
#[1 2 130 0 2 2 130 0 5 2 130 0 6 2 130 0 20 2 130 0 45 2 130 0 47 2 130 0 49 2 130 0 50 2 130 0 51 2 130 0 52 1 15 0 53 2 130 0 54 2 130 0 55 2 130 0 56 2 130 0 57 2 130 0 58 2 130 0 60 2 130 0 66 2 130 0 67 2 130 0 72 2 130 0 87 2 130 0 88 2 130 0 89 2 130 0 90 2 130 0 95 2 130 0 96 2 130 0 97 2 130 1 51] 
#[1 2 134 0 2 2 134 0 5 2 134 0 6 2 134 0 20 2 134 0 45 2 134 0 47 1 19 0 49 2 134 0 50 2 134 0 51 2 134 0 52 2 134 0 53 2 134 0 54 2 134 0 55 2 134 0 56 2 134 0 57 2 134 0 58 2 134 0 60 2 134 0 66 2 134 0 67 2 134 0 72 2 134 0 87 2 134 0 88 2 134 0 89 2 134 0 90 2 134 0 95 2 134 0 96 2 134 0 97 2 134 1 51] 
#[1 2 138 0 2 2 138 0 5 2 138 0 6 2 138 0 20 2 138 0 45 2 138 0 47 2 138 0 49 1 23 0 50 2 138 0 51 2 138 0 52 2 138 0 53 2 138 0 54 2 138 0 55 2 138 0 56 2 138 0 57 2 138 0 58 2 138 0 60 2 138 0 66 2 138 0 67 2 138 0 72 2 138 0 87 2 138 0 88 2 138 0 89 2 138 0 90 2 138 0 95 2 138 0 96 2 138 0 97 2 138 1 51] 
#[0 7 25 0 72] 
#[1 2 142 0 2 2 142 0 5 2 142 0 6 2 142 0 20 2 142 0 45 2 142 0 47 2 142 0 49 2 142 0 50 1 27 0 51 2 142 0 52 2 142 0 53 2 142 0 54 2 142 0 55 2 142 0 56 2 142 0 57 2 142 0 58 2 142 0 60 2 142 0 66 2 142 0 67 2 142 0 72 2 142 0 87 2 142 0 88 2 142 0 89 2 142 0 90 2 142 0 95 2 142 0 96 2 142 0 97 2 142 1 51] 
#[0 7 29 0 104] 
#[1 7 33 0 30 7 37 0 47] 
#[0 2 146 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 1 51] 
#[0 2 150 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[1 6 37 0 1 2 154 0 2 2 154 0 5 0 49 0 11 0 57 0 14 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 45 0 144 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 6 49 1 20 1 201 1 22 7 41 1 27 6 69 1 29 7 45 1 30 7 49 1 32 1 205 1 48 1 209 1 49] 
#[1 1 31 0 3 0 71 0 7 0 122 0 20 0 71 0 30 0 122 0 45 0 122 0 48 0 122 0 49 0 122 0 50 0 122 0 51 0 122 0 52 0 122 0 53 0 122 0 54 0 122 0 55 0 122 0 56 0 122 0 57 0 122 0 58 0 122 0 59 0 91 0 60 0 122 0 61 0 122 0 62 0 122 0 63 0 122 0 64 0 122 0 65 0 122 0 66 0 122 0 67 0 122 0 68 0 122 0 69 0 122 0 70 0 122 0 71 0 122 0 87 0 122 0 88 0 122 0 89 0 122 0 90 0 122 0 92 0 122 0 93 0 122 0 95 0 122 0 96 0 122 0 97 3 69 1 5] 
#[0 2 158 0 2 0 5 0 20] 
#[0 2 158 0 2 0 5 0 20] 
#[0 7 57 0 20] 
#[1 7 61 0 5 2 162 0 20] 
#[0 2 166 0 20] 
#[0 2 170 0 5 0 20] 
#[0 2 158 0 2 0 5 0 20] 
#[0 7 65 0 23] 
#[1 0 41 0 1 7 69 0 159] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 7 73 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 7 77 0 1 7 81 0 228] 
#[0 2 174 0 5 0 95] 
#[0 2 174 0 5 0 95] 
#[0 2 178 0 5 0 95] 
#[1 0 18 0 14 0 18 0 25 0 18 0 26 0 18 0 27 0 18 0 28 0 18 0 29 0 18 0 31 0 18 0 33 0 18 0 34 0 18 0 39 0 18 0 104 7 85 0 174 3 241 0 175] 
#[0 2 182 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 41 0 1 7 89 0 159] 
#[0 2 186 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 7 93 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 7 97 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 7 101 0 104 5 121 0 162 5 125 0 163 5 129 0 164] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 90 0 47 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 2 237 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 7 105 0 235 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 0 77 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 7 109 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 7 113 0 47] 
#[0 7 117 0 6] 
#[1 6 145 0 1 7 121 0 2 7 125 0 5 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 7 129 0 156 1 245 0 164 7 133 0 165 7 137 0 166 1 53 0 171 1 61 0 183 7 141 0 197 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 2 190 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 2 194 0 2 2 194 0 5 2 194 0 6 3 73 0 7 2 194 0 20 2 194 0 30 2 194 0 45 2 194 0 47 2 194 0 49 2 194 0 50 2 194 0 51 2 194 0 52 2 194 0 53 2 194 0 54 2 194 0 55 2 194 0 56 2 194 0 57 2 194 0 58 2 194 0 60 2 194 0 66 2 194 0 67 2 194 0 72 2 194 0 87 2 194 0 88 2 194 0 89 2 194 0 90 2 194 0 92 2 194 0 93 2 194 0 95 2 194 0 96 2 194 0 97 5 65 1 4 2 194 1 51] 
#[0 2 198 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 202 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 190 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 198 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 206 0 5 0 20] 
#[0 7 145 0 20] 
#[1 7 149 0 5 2 210 0 20] 
#[0 2 214 0 1 0 2 0 4 0 5 0 6 0 7 0 15 0 20 0 21 0 23 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 0 104 1 51] 
#[0 2 218 0 2 0 3 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 0 153 0 60 1 35 0 104 7 157 1 5] 
#[0 7 161 0 23] 
#[1 7 165 0 104 7 169 1 41 7 173 1 42] 
#[1 2 222 0 1 2 222 0 4 7 177 0 10 7 181 0 146 7 185 0 150] 
#[1 2 201 0 104 7 189 0 117 3 37 0 119 7 193 0 121 7 197 0 151 1 205 1 48 1 209 1 49] 
#[1 7 201 0 1 7 205 1 33] 
#[0 2 226 0 1] 
#[1 2 230 0 1 7 209 0 10 7 213 0 184 7 217 0 192] 
#[1 5 117 0 104 7 221 0 163 5 129 0 164] 
#[1 6 145 0 1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 7 129 0 156 1 245 0 164 7 225 0 165 7 137 0 166 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 7 229 0 23] 
#[0 7 233 0 23] 
#[0 2 218 0 2 0 3 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 7 237 0 20] 
#[1 0 146 0 2 0 146 0 5 0 146 0 6 3 101 0 7 0 146 0 20 3 105 0 30 0 146 0 45 0 146 0 47 0 146 0 49 0 146 0 50 0 146 0 51 0 146 0 52 0 146 0 53 0 146 0 54 0 146 0 55 0 146 0 56 0 146 0 57 0 146 0 58 0 146 0 60 0 146 0 66 0 146 0 67 0 146 0 72 0 146 0 87 0 146 0 88 0 146 0 89 0 146 0 90 0 146 0 92 0 146 0 93 0 146 0 95 0 146 0 96 0 146 0 97 0 146 1 51] 
#[0 0 130 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 0 130 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 2 234 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 5 117 0 104 7 241 0 164] 
#[1 2 238 0 5 4 21 0 7 2 238 0 20] 
#[0 1 154 0 5 0 20] 
#[0 2 242 0 5 0 20] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 7 245 1 20 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 7 249 0 1 7 253 0 186] 
#[1 8 1 0 45 5 93 0 104] 
#[0 2 246 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[0 2 250 0 2 0 5] 
#[1 2 254 0 2 8 5 0 5 8 9 1 31] 
#[1 3 2 0 2 1 39 0 5] 
#[1 6 37 0 1 0 49 0 11 0 57 0 14 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 45 0 144 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 6 49 1 20 1 201 1 22 8 17 1 27 6 69 1 29 1 205 1 48 1 209 1 49] 
#[0 3 6 0 2 0 5 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 20 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 35 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 60 0 104] 
#[1 8 21 0 104 8 25 1 28] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 8 29 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 10 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 3 14 0 1 3 14 0 2 3 14 0 8 3 14 0 9 3 14 0 11 3 14 0 12 3 14 0 13 3 14 0 14 3 14 0 15 3 14 0 16 3 14 0 17 3 14 0 18 3 14 0 19 3 14 0 23 3 14 0 24 3 14 0 25 3 14 0 26 3 14 0 27 3 14 0 28 3 14 0 29 3 14 0 31 8 33 0 32 3 14 0 33 3 14 0 34 3 14 0 36 3 14 0 37 3 14 0 38 3 14 0 39 3 14 0 40 3 14 0 41 3 14 0 42 3 14 0 43 3 14 0 46 3 14 0 47 3 14 0 60 3 14 0 73 3 14 0 74 3 14 0 75 3 14 0 76 3 14 0 77 3 14 0 80 3 14 0 81 3 14 0 82 3 14 0 83 3 14 0 84 3 14 0 91 3 14 0 92 3 14 0 93 3 14 0 98 3 14 0 99 3 14 0 100 3 14 0 101 3 14 0 102 3 14 0 103 3 14 0 104 3 14 1 51] 
#[1 8 37 0 2 8 41 0 15 8 45 0 84 8 49 0 229 8 53 0 230 8 57 0 231 8 61 0 232] 
#[0 3 18 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 8 65 0 20] 
#[0 3 22 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 26 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 8 69 0 20] 
#[1 0 194 0 3 0 194 0 5 0 194 0 7 0 194 0 47 8 73 0 72] 
#[0 8 77 0 47] 
#[0 3 30 0 5 0 20 0 47] 
#[0 3 34 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 38 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 3 42 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 8 81 0 2] 
#[0 3 46 0 2 0 5 0 47] 
#[0 3 50 0 2 0 5] 
#[0 3 46 0 2 0 5 0 47] 
#[1 8 85 0 2 8 89 0 5] 
#[1 8 93 0 1 3 54 0 2 3 54 0 5 3 54 0 6 3 54 0 7 3 54 0 20 3 54 0 30 3 54 0 45 3 54 0 47 3 54 0 49 3 54 0 50 3 54 0 51 3 54 0 52 3 54 0 53 3 54 0 54 3 54 0 55 3 54 0 56 3 54 0 57 3 54 0 58 3 54 0 60 3 54 0 66 3 54 0 67 3 54 0 72 3 54 0 87 3 54 0 88 3 54 0 89 3 54 0 90 3 54 0 92 3 54 0 93 3 54 0 95 3 54 0 96 3 54 0 97 8 97 0 148 3 54 1 51] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 8 101 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 58 0 2 0 3 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 59 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 68 0 69 0 70 0 71 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 8 105 0 104] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 8 109 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 3 62 0 5 8 113 0 10 3 62 0 95 8 117 1 43] 
#[1 8 121 0 5 8 125 0 95] 
#[0 3 66 0 5 0 95] 
#[1 2 201 0 104 8 129 0 117 3 37 0 119 8 133 0 120 1 205 1 48 1 209 1 49] 
#[1 2 66 0 1 6 209 0 4 8 137 0 147 6 217 0 152] 
#[0 3 70 0 1 0 4] 
#[0 3 74 0 1 0 5] 
#[0 3 78 0 1 0 5] 
#[1 3 82 0 1 8 141 0 5] 
#[1 3 86 0 2 3 86 0 5 0 10 0 14 3 86 0 47 0 10 0 104 8 145 0 134 8 149 1 34 8 153 1 36 8 157 1 37] 
#[0 3 90 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 2 201 0 104 7 189 0 117 3 37 0 119 8 161 0 121 1 205 1 48 1 209 1 49] 
#[1 8 165 0 1 8 169 0 185] 
#[1 3 94 0 1 8 173 0 5] 
#[0 3 98 0 5 0 47] 
#[0 3 102 0 5 0 47] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 8 177 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 8 181 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 106 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 3 110 0 5 4 21 0 7 3 110 0 20] 
#[0 3 114 0 2 0 5 0 6 0 20 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 95 0 96 0 97 1 51] 
#[1 3 118 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 8 185 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 8 189 0 142 1 37 0 143 1 41 0 144 1 45 0 149 8 193 0 160 8 197 0 167 8 201 0 187 8 205 0 188 8 209 0 189 8 213 0 190 8 217 0 191] 
#[0 3 122 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[0 8 221 0 47] 
#[0 3 126 0 2 0 47] 
#[0 8 225 0 2] 
#[1 6 37 0 1 0 49 0 11 0 57 0 14 0 61 0 16 0 65 0 17 3 45 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 45 0 144 1 53 0 171 1 61 0 183 3 53 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 6 49 1 20 1 201 1 22 8 229 1 27 6 69 1 29 1 205 1 48 1 209 1 49] 
#[0 3 130 0 5 0 20] 
#[0 7 53 0 3] 
#[0 3 134 0 5 0 20] 
#[0 8 233 0 20] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 8 237 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 138 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 8 241 0 72] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 8 245 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 8 249 0 233 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 8 253 0 2 8 41 0 15 8 45 0 84 9 1 0 230 9 5 0 231 8 61 0 232] 
#[1 0 41 0 1 9 9 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 8 41 0 15 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 8 45 0 84 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 9 13 0 181 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 9 17 0 232 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 2 165 1 53] 
#[0 3 142 0 2 0 15 0 84] 
#[0 3 146 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[1 0 41 0 1 9 21 0 159] 
#[0 9 25 0 47] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 9 29 0 156 1 245 0 164 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 3 150 0 20 0 77 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 67 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 53 0 171 1 61 0 183 5 1 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 9 33 0 236 9 37 0 238 9 41 0 239 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 3 154 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 3 158 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 6 145 0 1 9 45 0 2 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 7 129 0 156 1 245 0 164 9 49 0 165 7 137 0 166 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 41 0 1 3 162 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 9 53 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 9 57 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 9 61 0 142 1 37 0 143 1 41 0 144 1 45 0 149 9 65 0 153 9 69 0 154 9 73 0 155 9 77 0 157 9 81 0 158 9 85 0 159 9 89 0 160 9 93 0 161 9 97 0 167 9 101 1 54] 
#[0 3 166 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 3 170 0 5 0 20] 
#[0 9 105 0 23] 
#[0 9 109 0 20] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 2 205 0 111 2 209 0 112 9 113 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 9 117 1 44 1 205 1 48 1 209 1 49] 
#[0 3 174 0 5 0 95] 
#[1 7 165 0 104 9 121 1 42] 
#[0 3 178 0 1 0 4 0 10 0 11 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 104] 
#[0 1 94 0 1 0 4 0 5 0 15 0 47] 
#[0 3 182 0 1 0 4] 
#[1 8 93 0 1 9 125 0 148] 
#[1 2 201 0 104 7 189 0 117 3 37 0 119 9 129 0 121 1 205 1 48 1 209 1 49] 
#[1 0 57 0 14 9 133 0 104 2 153 0 144] 
#[1 2 254 0 2 8 5 0 5 2 254 0 47 9 137 1 31] 
#[1 3 186 0 2 1 43 0 5 3 186 0 47] 
#[0 3 190 0 2 0 5 0 47] 
#[0 3 194 0 1 0 5] 
#[1 3 198 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 9 145 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 8 189 0 142 1 37 0 143 1 41 0 144 1 45 0 149 9 149 0 160 9 153 0 167 9 157 0 191 9 161 0 193 9 165 0 194 9 169 0 195 9 173 0 196] 
#[0 3 202 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 2 201 0 104 7 189 0 117 3 37 0 119 9 177 0 121 1 205 1 48 1 209 1 49] 
#[0 9 181 0 20] 
#[0 9 185 0 20] 
#[0 3 206 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 3 113 0 9 2 62 0 11 3 117 0 13 4 113 0 14 1 47 0 25 1 51 0 26 1 55 0 27 1 59 0 28 1 63 0 29 1 67 0 31 1 71 0 33 1 75 0 34 3 121 0 43 6 201 0 60 1 79 0 104 2 205 0 111 2 209 0 112 9 189 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 9 193 0 145 1 205 1 48 1 209 1 49] 
#[0 3 206 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 9 197 0 15 9 201 0 47] 
#[0 9 205 0 2] 
#[1 3 210 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 8 185 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 8 189 0 142 1 37 0 143 1 41 0 144 1 45 0 149 8 193 0 160 8 197 0 167 9 209 0 189 8 213 0 190 8 217 0 191] 
#[0 3 214 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 3 206 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 3 218 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 3 222 0 8 0 9 0 12 0 13 0 14 0 18 0 19 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 1 51] 
#[0 3 226 0 2 0 5 0 20] 
#[0 3 230 0 2 0 5] 
#[0 3 234 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 3 238 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 3 242 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 3 246 0 72] 
#[0 9 213 0 72] 
#[0 3 250 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 41 0 1 9 217 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 8 41 0 15 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 8 45 0 84 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 9 13 0 181 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 9 17 0 232 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 2 165 1 53] 
#[0 3 254 0 2 0 15 0 84] 
#[0 4 2 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 41 0 1 4 6 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 4 6 0 15 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 4 6 0 84 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 4 145 1 53] 
#[0 4 10 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 4 14 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 18 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 9 221 0 20] 
#[0 9 225 0 20] 
#[1 6 133 0 5 4 22 0 20] 
#[0 4 26 0 20] 
#[0 4 30 0 2 0 5 0 6 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 4 34 0 2 0 5] 
#[1 0 41 0 1 0 42 0 8 0 42 0 9 0 42 0 11 0 42 0 12 0 42 0 13 0 42 0 14 0 42 0 18 0 42 0 19 0 42 0 25 0 42 0 26 0 42 0 27 0 42 0 28 0 42 0 29 0 42 0 31 0 42 0 33 0 42 0 34 0 42 0 37 0 42 0 38 0 42 0 39 0 42 0 40 0 42 0 41 0 42 0 42 0 42 0 43 0 42 0 46 0 42 0 60 0 42 0 104 9 229 0 159] 
#[0 4 38 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 3 113 0 9 2 62 0 11 3 117 0 13 4 113 0 14 1 47 0 25 1 51 0 26 1 55 0 27 1 59 0 28 1 63 0 29 1 67 0 31 1 71 0 33 1 75 0 34 3 121 0 43 6 201 0 60 1 79 0 104 2 205 0 111 2 209 0 112 9 189 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 9 233 0 145 9 237 0 178 1 205 1 48 1 209 1 49] 
#[0 9 241 0 2] 
#[1 0 41 0 1 4 42 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 9 53 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 9 57 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 9 61 0 142 1 37 0 143 1 41 0 144 1 45 0 149 9 245 0 155 9 77 0 157 9 81 0 158 9 85 0 159 9 89 0 160 9 93 0 161 9 97 0 167 9 101 1 54] 
#[0 4 46 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 50 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 50 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 50 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 38 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 38 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 41 0 1 9 249 0 47 9 253 0 159 10 1 0 168] 
#[0 4 50 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 10 5 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 4 54 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 4 58 0 5 0 53 0 95] 
#[1 4 62 0 5 10 9 0 53 4 62 0 95] 
#[0 4 66 0 5 0 95] 
#[0 4 70 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 74 0 1 0 5] 
#[1 4 78 0 1 4 78 0 2 4 78 0 5 10 13 0 23 4 78 0 47 10 17 1 38] 
#[1 4 82 0 2 10 21 0 47 10 25 1 35 10 29 1 40] 
#[1 0 10 0 14 0 10 0 104 8 145 0 134 10 33 1 37] 
#[0 4 86 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 90 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 9 201 0 47] 
#[0 4 86 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 10 37 0 2] 
#[1 4 94 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 0 121 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 9 145 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 8 189 0 142 1 37 0 143 1 41 0 144 1 45 0 149 9 149 0 160 9 153 0 167 9 157 0 191 10 41 0 195 9 173 0 196] 
#[0 4 98 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 86 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 102 0 1 0 5] 
#[1 8 93 0 1 4 106 0 2 4 106 0 5 4 106 0 6 4 106 0 7 4 106 0 20 4 106 0 30 4 106 0 45 4 106 0 47 4 106 0 49 4 106 0 50 4 106 0 51 4 106 0 52 4 106 0 53 4 106 0 54 4 106 0 55 4 106 0 56 4 106 0 57 4 106 0 58 4 106 0 60 4 106 0 66 4 106 0 67 4 106 0 72 4 106 0 87 4 106 0 88 4 106 0 89 4 106 0 90 4 106 0 92 4 106 0 93 4 106 0 95 4 106 0 96 4 106 0 97 10 45 0 148 4 106 1 51] 
#[0 4 54 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 5 117 0 104 10 49 0 162 5 125 0 163 5 129 0 164] 
#[1 0 49 0 11 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 2 205 0 111 2 209 0 112 10 53 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 10 57 0 171 1 205 1 48 1 209 1 49] 
#[1 6 145 0 1 0 49 0 11 0 61 0 16 0 65 0 17 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 7 129 0 156 1 245 0 164 10 61 0 165 7 137 0 166 1 53 0 171 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 4 110 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 114 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104 1 51] 
#[0 4 118 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 122 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 4 126 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 10 65 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 41 0 1 0 49 0 11 0 61 0 16 0 65 0 17 3 13 0 18 0 77 0 23 0 81 0 24 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 117 0 36 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 63 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 49 0 159 1 53 0 171 1 61 0 183 10 69 0 200 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 4 130 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 49 0 11 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 3 49 0 104 2 205 0 111 2 209 0 112 10 53 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 10 73 0 123 10 57 0 171 1 205 1 48 1 209 1 49] 
#[1 4 134 0 1 10 77 0 22 10 81 0 170 10 85 0 176] 
#[0 4 138 0 1 0 2 0 5 0 6 0 7 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 20 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 45 0 46 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 87 0 88 0 89 0 90 0 91 0 92 0 93 0 95 0 96 0 97 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 142 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 146 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 150 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 154 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 10 89 0 20] 
#[1 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 2 201 0 104 2 205 0 111 2 209 0 112 10 93 0 113 0 245 0 114 0 249 0 115 0 253 0 116 2 217 0 117 2 221 0 118 2 225 0 119 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 10 97 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 8 93 0 1 4 158 0 2 4 158 0 5 4 158 0 47 10 101 0 148 10 105 1 39] 
#[1 0 41 0 1 3 162 0 2 0 45 0 8 0 14 0 9 0 14 0 11 0 53 0 12 0 14 0 13 0 59 0 14 2 97 0 18 0 73 0 19 0 14 0 25 0 14 0 26 0 14 0 27 0 14 0 28 0 14 0 29 0 14 0 31 0 14 0 33 0 14 0 34 9 53 0 37 0 125 0 38 0 129 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 2 101 0 47 0 14 0 60 0 14 0 104 9 57 0 126 2 109 0 138 2 113 0 139 2 117 0 140 1 29 0 141 9 61 0 142 1 37 0 143 1 41 0 144 1 45 0 149 10 109 0 153 9 69 0 154 9 73 0 155 9 77 0 157 9 81 0 158 9 85 0 159 9 89 0 160 9 93 0 161 9 97 0 167 9 101 1 54] 
#[0 10 113 0 2] 
#[0 4 162 0 2] 
#[0 4 166 0 2 0 5 0 47] 
#[0 4 170 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 174 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 178 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[1 6 225 0 5 10 117 0 47] 
#[1 10 121 0 104 10 125 0 169] 
#[1 10 121 0 104 10 129 0 169] 
#[0 10 133 0 47] 
#[0 4 182 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 186 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 32 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 10 137 0 23] 
#[1 2 201 0 104 8 129 0 117 3 37 0 119 10 141 0 120 10 145 0 177 1 205 1 48 1 209 1 49] 
#[1 10 149 0 1 10 153 0 179] 
#[0 4 190 0 1 0 15 0 47] 
#[0 4 194 0 2 0 5 0 6 0 7 0 20 0 30 0 45 0 47 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 58 0 60 0 66 0 67 0 72 0 87 0 88 0 89 0 90 0 92 0 93 0 95 0 96 0 97 1 51] 
#[0 4 198 0 5 0 53 0 95] 
#[0 10 157 0 20] 
#[0 4 202 0 2 0 5 0 47] 
#[0 4 206 0 2 0 5 0 47] 
#[0 4 210 0 2] 
#[0 4 214 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 84 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104 1 51] 
#[0 4 218 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 10 161 0 23] 
#[1 4 134 0 1 10 165 0 7 4 134 0 15 10 77 0 22 4 134 0 47 10 169 0 170 10 85 0 176] 
#[1 4 134 0 1 10 165 0 7 4 134 0 15 10 77 0 22 4 134 0 47 10 173 0 170 10 85 0 176] 
#[0 4 222 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 18 0 14 4 226 0 20 0 18 0 25 0 18 0 26 0 18 0 27 0 18 0 28 0 18 0 29 0 18 0 31 0 18 0 33 0 18 0 34 0 18 0 39 0 18 0 104 10 177 0 172 10 181 0 173 10 185 0 174 3 241 0 175] 
#[0 4 230 0 1 0 5 0 15 0 47] 
#[1 4 234 0 1 10 189 0 5 4 234 0 15 4 234 0 47] 
#[1 0 41 0 1 10 193 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 10 197 0 16 10 201 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 10 205 0 180 10 209 0 181 10 213 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 2 165 1 53] 
#[0 4 238 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 4 242 0 1 0 2 0 5 0 47] 
#[1 0 18 0 14 4 226 0 20 0 18 0 25 0 18 0 26 0 18 0 27 0 18 0 28 0 18 0 29 0 18 0 31 0 18 0 33 0 18 0 34 0 18 0 39 0 18 0 104 10 217 0 172 10 181 0 173 10 185 0 174 3 241 0 175] 
#[0 10 221 0 6] 
#[0 4 246 0 1 0 15 0 47] 
#[0 4 246 0 1 0 15 0 47] 
#[0 10 225 0 20] 
#[1 10 229 0 5 4 250 0 20] 
#[0 4 254 0 5 0 20] 
#[1 2 201 0 104 8 129 0 117 3 37 0 119 10 233 0 120 1 205 1 48 1 209 1 49] 
#[0 5 2 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 50 0 7 10 237 0 23 0 50 0 30 0 50 0 92 0 50 0 93] 
#[1 10 241 0 23 2 177 0 30] 
#[1 0 41 0 1 10 245 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 10 249 0 181 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 2 165 1 53] 
#[1 0 41 0 1 10 253 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 4 145 1 53] 
#[1 11 1 0 30 0 146 0 92 0 146 0 93] 
#[0 11 5 0 20] 
#[0 5 6 0 1 0 7 0 15 0 22 0 47] 
#[0 5 10 0 1 0 22] 
#[1 0 18 0 14 0 18 0 25 0 18 0 26 0 18 0 27 0 18 0 28 0 18 0 29 0 18 0 31 0 18 0 33 0 18 0 34 0 18 0 39 0 18 0 104 11 9 0 174 3 241 0 175] 
#[0 5 14 0 1 0 5 0 15 0 47] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 11 13 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 11 17 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 5 18 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 0 41 0 1 11 21 0 2 0 45 0 8 0 14 0 9 0 49 0 11 0 53 0 12 0 14 0 13 0 11 0 14 0 61 0 16 0 65 0 17 0 69 0 18 0 73 0 19 0 77 0 23 0 81 0 24 0 15 0 25 0 19 0 26 0 23 0 27 0 27 0 28 0 31 0 29 0 35 0 31 0 39 0 33 0 43 0 34 0 117 0 36 0 121 0 37 0 125 0 38 0 47 0 39 0 133 0 40 0 137 0 41 0 141 0 42 0 14 0 43 0 145 0 46 0 149 0 47 0 153 0 60 0 157 0 73 0 161 0 74 0 165 0 75 0 169 0 76 0 173 0 77 0 177 0 80 0 181 0 81 0 185 0 82 0 189 0 83 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 51 0 104 0 233 0 109 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 1 21 0 138 1 25 0 139 1 29 0 141 1 33 0 142 1 37 0 143 1 41 0 144 1 45 0 149 1 49 0 159 1 53 0 171 1 57 0 175 1 61 0 183 1 65 0 199 1 69 0 200 1 73 0 201 1 77 0 202 1 81 0 203 1 85 0 204 1 89 0 205 1 93 0 206 1 97 0 207 1 101 0 208 1 105 0 210 1 109 0 211 1 113 0 212 1 117 0 213 1 121 0 214 1 125 0 215 1 129 0 216 1 133 0 217 1 137 0 218 1 141 0 219 1 145 0 220 1 149 0 221 1 153 0 222 1 157 0 223 1 161 0 224 1 165 0 225 1 169 0 226 1 173 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 1 193 1 5 1 197 1 6 1 201 1 22 1 205 1 48 1 209 1 49 4 145 1 53] 
#[0 5 22 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[1 11 25 0 16 11 29 0 17 0 153 0 60 5 133 0 91 0 199 0 104 5 141 1 5] 
#[0 5 26 0 1 0 7 0 15 0 22 0 47] 
#[0 5 30 0 5 0 20] 
#[0 11 33 0 20] 
#[0 11 37 0 20] 
#[0 5 34 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 18 0 19 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 104] 
#[0 11 41 0 23] 
#[0 11 45 0 23] 
#[0 11 49 0 47] 
#[0 11 53 0 47] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 11 57 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[1 0 49 0 11 0 61 0 16 0 65 0 17 2 30 0 20 1 217 0 23 0 85 0 25 0 89 0 26 0 93 0 27 0 97 0 28 0 101 0 29 0 105 0 31 0 109 0 33 0 113 0 34 0 153 0 60 1 221 0 85 1 225 0 86 1 229 0 88 1 233 0 89 0 193 0 91 0 197 0 92 0 201 0 93 0 205 0 98 0 209 0 99 0 213 0 100 0 217 0 101 0 221 0 102 0 225 0 103 0 55 0 104 0 237 0 110 0 241 0 111 0 245 0 114 0 249 0 115 0 253 0 116 1 1 0 118 1 5 0 119 1 9 0 123 1 13 0 124 1 17 0 125 6 173 0 156 1 245 0 164 1 53 0 171 11 61 0 182 1 61 0 183 1 249 0 221 1 253 0 222 2 1 0 223 2 5 0 224 2 9 0 225 2 13 0 226 2 17 0 227 1 177 0 245 1 181 0 246 1 185 0 247 1 189 0 248 2 21 0 249 2 25 0 251 2 29 0 253 6 181 1 0 1 193 1 5 2 33 1 6 2 37 1 7 2 41 1 8 2 45 1 9 2 49 1 10 2 53 1 11 2 57 1 12 2 61 1 13 2 65 1 14 2 69 1 15 2 73 1 16 2 77 1 17 2 81 1 18 2 85 1 19 2 89 1 20 2 93 1 21 1 201 1 22 1 205 1 48 1 209 1 49] 
#[0 5 38 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 5 42 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 11 65 0 20] 
#[0 11 69 0 20] 
#[0 11 73 0 47] 
#[0 11 77 0 47] 
#[0 5 46 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104] 
#[0 5 50 0 1 0 2 0 8 0 9 0 11 0 12 0 13 0 14 0 16 0 17 0 18 0 19 0 23 0 24 0 25 0 26 0 27 0 28 0 29 0 31 0 33 0 34 0 36 0 37 0 38 0 39 0 40 0 41 0 42 0 43 0 46 0 47 0 60 0 73 0 74 0 75 0 76 0 77 0 80 0 81 0 82 0 83 0 91 0 92 0 93 0 98 0 99 0 100 0 101 0 102 0 103 0 104]
	).!

tryAllTokens
	^(##(#('return' 'public' 'private' 'super' 'throw' 'null' 'else') asSet) includes: currentToken value) not! !
!JavaParser categoriesFor: #ambiguousTransitions!generated!public! !
!JavaParser categoriesFor: #performParsingStep!private! !
!JavaParser categoriesFor: #reduceActionForabstract_method_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotation_interface_body1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotation_interface_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotation_method_declaration2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotation1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotations1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForannotations2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_access1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_creation_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_creation_expression3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_initializer1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_initializer2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_initializer3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_initializer4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForarray_type1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForassert_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForassert_statement2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForassignment1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForblock1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForbreak_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForcast_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForcatch_clause1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_body_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_body_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_instance_creation_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_instance_creation_expression2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_instance_creation_expression3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_instance_creation_expression4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForclass_or_interface_type1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForcompilation_unit1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconditional_expression2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_body1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_body2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_body3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_body4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForconstructor_declarator1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForcontinue_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFordim_expr1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFordims1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFordims2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFordo_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForelementValueArrayInitializer1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForelementValuePair1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForempty_dim_expr1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForempty_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_body_declarations_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_body_declarations_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_body_declarations1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_body1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_constant1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForenum_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForexplicit_constructor_invocation1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForexplicit_constructor_invocation2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForexplicit_constructor_invocation3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForexplicit_constructor_invocation4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForexpression_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForextends_interfaces1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForextends_interfaces2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfield_access1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfield_access2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfield_access3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfield_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfinally1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfloating_point_type1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfloating_point_type2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForfor_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForforeach_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForformal_parameter1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForformal_parameter2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForif_then_else_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForif_then_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForintegral_type1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForintegral_type2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForintegral_type3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForintegral_type4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForintegral_type5:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForinterface_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForinterfaces_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForinterfaces_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForinterfaces1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlabeled_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlambda_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlambda_parameter_list_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlambda_parameter_list_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlambda_parameters2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral5:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForliteral6:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlocal_variable_declaration_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForlocal_variable_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_body2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_declarator1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_declarator2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_header1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_invocation1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_invocation3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_invocation4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormethod_invocation5:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormodifier11:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormodifiers_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormodifiers1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFormultiplicative_expression2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpackage_declaration_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpackage_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpostdecrement_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpostincrement_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpredecrement_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForpreincrement_expression1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimary_no_new_array11:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimary_no_new_array12:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimary_no_new_array2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimary_no_new_array3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimary_no_new_array8:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForprimitive_type2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForqualified_name1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForqualified_type_name1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForreturn_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForsimple_type_name1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForsingle_type_import_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForstatement_expression_list1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForstatement_expression_list2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForstatic_initializer1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForsuper_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_block_statement_group1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_block1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_block2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_block3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_block4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_label1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_label2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForswitch_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForsynchronized_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForthrow_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForthrows1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortry_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortry_statement2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_argument_type3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_argument1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_argument2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_arguments_opt1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_arguments_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_arguments1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_arguments2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_declaration4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_import_on_demand_declaration1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_parameter1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionFortype_parameters_opt2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForunary_expression_not_plus_minus2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForunary_expression_not_plus_minus3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForunary_expression3:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForunary_expression4:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForuntyped_lambda_parameter1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForvariable_declarator_id1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForvariable_declarator_id2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForvariable_declarator1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForvariable_declarator2:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForvoid1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceActionForwhile_statement1:!generated-reduction actions!public! !
!JavaParser categoriesFor: #reduceTable!generated!public! !
!JavaParser categoriesFor: #symbolTypes!generated!public! !
!JavaParser categoriesFor: #transitionTable!generated!public! !
!JavaParser categoriesFor: #tryAllTokens!private! !

!JavaParser class methodsFor!

definitionComment
"%start goal block_statement expression type_declaration;
%glr;
%right ""else"";

%id <UNSIGNED_RIGHT_SHIFT> <SIGNED_RIGHT_SHIFT> <GREATER_THAN>;

%ignore_variables semicolon comma left right;

%prefix Java ;
%suffix Node ;
%root Program ;

%hierarchy IfStatement (IfElseStatement);
%hierarchy New (NewClass);
%hierarchy Literal (IntegerLiteral FloatLiteral BooleanLiteral CharacterLiteral StringLiteral Null);
%hierarchy PrimitiveType (BooleanType ByteType ShortType IntType LongType CharType FloatType DoubleType) ;
%hierarchy Type (PrimitiveType ClassType ArrayType) ;
%hierarchy Statement (Block LocalVariableDeclarationStatement EmptyStatement LabeledStatement
					ExpressionStatement IfStatement SwitchStatement WhileStatement DoWhileStatement
					ForStatement ForEachStatement BreakStatement ContinueStatement ReturnStatement ThrowStatement
					SynchronizedStatement TryStatement AssertStatement);
%hierarchy Expression (PostIncrementExpression PostDecrementExpression UnaryAddition UnarySubtraction
					PreIncrementExpression PreDecrementExpression UnaryBitInvert UnaryNot
					CastExpression BinaryExpression ConditionalExpression Assignment 
					ClassProperty FieldAccess MethodInvocation ArrayAccess
					New Literal Name NewArray LambdaExpression);
%hierarchy Name (QualifiedName) ;
%hierarchy SingleTypeImportDeclaration (TypeImportOnDemandDeclaration);
%hierarchy VariableDeclaration (InitializedVariableDeclaration) ;
%hierarchy Parameter (VariableArgumentParameter);
%hierarchy AbstractMethodDeclaration (AnnotationMethodDeclaration);

<GREATER_THAN>
	: >
	;
<SIGNED_RIGHT_SHIFT>
	: >>
	;
<UNSIGNED_RIGHT_SHIFT>
	: >>>
	;
<DECIMAL_INTEGER>
	: 0 | [1-9] [0-9]*	
	;
<HEX_INTEGER>
	: 0[xX][0-9a-fA-F]+	
	;
<OCTAL_INTEGER>
	: 0[0-7]+	
	;
<EXPONENT>
	: [eE] [\-\+]? [0-9]+ 	
	;
<FLOAT_TYPE>
	: [fFdD]	
	;
<ESCAPE_SEQUENCE>
	: \\ ([btnfr\""\'\\] | ([0-3] [0-7]{0,2} | [4-7][0-7]?) | (u [0-9a-fA-F]{4,4}))	
	;
<INTEGER_LITERAL>
	: (<DECIMAL_INTEGER> | <HEX_INTEGER> | <OCTAL_INTEGER>) [lL]?	
	;
<FLOATING_POINT_LITERAL>
	: [0-9]+ \. [0-9]* <EXPONENT>? <FLOAT_TYPE>? 
	| \. [0-9]+ <EXPONENT>? <FLOAT_TYPE>? 
	| [0-9]+ <EXPONENT> <FLOAT_TYPE>? 
	| [0-9]+ <FLOAT_TYPE>	
	| <HEX_INTEGER> \. [0-9a-fA-F]+ [pP] [\-\+]? [0-9]+ <FLOAT_TYPE>?
	;
<BOOLEAN_LITERAL>
	: true 
	| false	
	;
<CHARACTER_LITERAL>
	: \' ([^\\\'] | <ESCAPE_SEQUENCE> ) \'	
	;
<STRING_LITERAL>
	: \"" ([^\\\""] | <ESCAPE_SEQUENCE> )* \""	
	;
<NULL_LITERAL>
	: null	
	;
<IDENTIFIER>
	: [a-zA-Z_$] (\w|$)*	
	;

<eol>
	: \r 
	| \n 
	| \r\n
	;
<whitespace>
	: \s+
	;
<comment>
	: \/\/ [^\r\n]* <eol> 
	| /\*([^*]|[\r\n]|(\*+([^*/]|[\r\n])))*\*+/
 	;
<patternToken>
	: (\`  [^\`]* \`)+
	;

goal 
	: compilation_unit 
	;
# 19.3) Lexical Structure.
literal 
	: <INTEGER_LITERAL> 'token' {{IntegerLiteral}}
	| <FLOATING_POINT_LITERAL> 'token' {{FloatLiteral}}
	| <BOOLEAN_LITERAL> 'token' {{BooleanLiteral}}
	| <CHARACTER_LITERAL> 'token' {{CharacterLiteral}}
	| <STRING_LITERAL> 'token' {{StringLiteral}}
	| <NULL_LITERAL> 'token' {{Null}}
	;
# 19.4) Types, Values, and Variables
type
	: primitive_type 
	| reference_type 
	;
primitive_type 
	: numeric_type 
	| ""boolean"" 'token' {{BooleanType}}
	;
numeric_type
	: integral_type 
	| floating_point_type 
	;
integral_type 
	: ""byte"" 'token' {{ByteType}}
	| ""short"" 'token' {{ShortType}}
	| ""int"" 'token' {{IntType}}
	| ""long"" 'token' {{LongType}}
	| ""char"" 'token' {{CharType}}
	;
floating_point_type 
	: ""float"" 'token' {{FloatType}}
	| ""double"" 'token' {{DoubleType}}
	;
reference_type 
	: class_or_interface_type 
	| array_type 
	;
class_or_interface_type 
	: type_name 'name' {{ClassType}}
	;
class_type 
	: class_or_interface_type 
	;
interface_type 
	: class_or_interface_type 
	;		
array_type 
	: primitive_type 'baseType' dims {{ArrayType}}
	| type_name 'baseType' dims {{ArrayType}}
	;
# 19.5) Names
name
	: simple_name 
	| qualified_name 
	;
simple_name 
	: <IDENTIFIER> 'name' {{Name}}
	;
qualified_name 
	: name 'nspace' ""."" 'period' <IDENTIFIER> 'name' {{QualifiedName}}
	;
# 19.6) ""package""s
compilation_unit 
	: package_declaration_opt 'packageDeclaration'
		import_declarations_opt 
		type_declarations_opt {{ProgramFile}}
	;
package_declaration_opt 
	: package_declaration
	|
	;
import_declarations_opt 
	: import_declarations
	|
	;
type_declarations_opt 
	: type_declarations 
	|
	;
import_declarations 
	: import_declaration 'import' 
	| import_declarations import_declaration 'import'
	;
type_declarations 
	: type_declaration 'typeDeclaration' 
	| type_declarations type_declaration 'typeDeclaration' 
	;
package_declaration 
	: annotations ""package"" 'packageToken' name 'name' "";"" 'semicolon' {{PackageDeclaration}}
	;
import_declaration 
	: single_type_import_declaration 
	| type_import_on_demand_declaration 
	;
single_type_import_declaration 
	: ""import"" 'importToken' static_opt name 'name' "";"" 'semicolon' {{SingleTypeImportDeclaration}}
	;
type_import_on_demand_declaration 
	: ""import"" 'importToken' static_opt name 'name' ""."" 'period' ""*"" 'star' "";"" 'semicolon' {{TypeImportOnDemandDeclaration}}
	;
type_declaration 
	: class_declaration 
	| interface_declaration 
	| annotation_interface_declaration
	| "";"" 'semicolon' {{EmptyDeclaration}}
	;
# 19.7) Productions used only in the LALR(1) grammar

modifiers_opt
	:
	| modifiers 
	;
modifiers 
	: modifier 'modifier'
	| modifiers modifier 'modifier'
	;
modifier 
	: ""public"" 'token' {{Modifier}}
	| ""protected"" 'token' {{Modifier}}
	| ""private"" 'token' {{Modifier}}
	| ""static"" 'token' {{Modifier}}
	| ""abstract"" 'token' {{Modifier}}
	| ""final"" 'token' {{Modifier}}
	| ""native"" 'token' {{Modifier}}
	| ""synchronized"" 'token' {{Modifier}}
	| ""transient"" 'token' {{Modifier}}
	| ""volatile"" 'token' {{Modifier}}
	| ""strictfp"" 'token' {{Modifier}} # note that semantic analysis must check that the
	                 # context of the modifier allows strictfp.
	| annotation
	;
# 19.8) Classes
# 19.8.1) Class Declaration:
class_declaration 
	: modifiers_opt ""class"" 'classToken' <IDENTIFIER> 'name' type_parameters_opt 'typeParameters' super_opt interfaces_opt class_body {{ClassDeclaration}}
	| enum_declaration
	;
super 
	: ""extends"" 'extendsToken' class_type 'superclass'
	;
super_opt 
	: 
	| super 
	;
interfaces 
	: ""implements"" 'implementsToken' interface_type_list
	;
interfaces_opt
	: 
	| interfaces 
	;
interface_type_list 
	: interface_type 'interface' 
	| interface_type_list "","" 'comma' interface_type 'interface' 
	;
class_body 
	: ""{"" 'left' class_body_declarations_opt ""}"" 'right'
	;
class_body_declarations_opt 
	: 
	| class_body_declarations
	;
class_body_declarations 
	: class_body_declaration 'declaration' 
	| class_body_declarations class_body_declaration 'declaration' 
	;
class_body_declaration 
	: class_member_declaration 
	| static_initializer 
	| constructor_declaration 
	| block 
	;
class_member_declaration 
	: field_declaration 
	| method_declaration 
	| type_declaration
	;
# 19.8.2) Field Declarations
field_declaration 
	: modifiers_opt type 'type' variable_declarators "";"" 'semicolon' {{FieldDeclaration}}
	;
variable_declarators 
	: variable_declarator 'variableDeclaration' 
	| variable_declarators "","" 'comma' variable_declarator 'variableDeclaration'
	;
variable_declarator 
	: variable_declarator_id 'variable' {{VariableDeclaration}}
	| variable_declarator_id 'variable' ""="" 'equals' variable_initializer 'initializer' {{InitializedVariableDeclaration}}
	;
variable_declarator_id 
	: <IDENTIFIER> 'name' {{VariableName}}
	| variable_declarator_id 'variable' ""["" 'left' ""]"" 'right' {{ArrayVariableName}}
	;
variable_initializer 
	: expression 
	| array_initializer 
	;
# 19.8.3) Method Declarations
method_declaration 
	: method_header method_body 'body' {{MethodDeclaration}}
	;
method_header 
	: modifiers_opt type_parameters_opt 'typeParameters' type 'type' method_declarator 'declarator' throws_opt 'throws'
	| modifiers_opt type_parameters_opt 'typeParameters' void 'type' method_declarator 'declarator' throws_opt 'throws'
	;
####
void 
	: ""void"" 'voidToken' {{VoidType}} 
	;
####
method_declarator 
	: <IDENTIFIER> 'name' ""("" 'left' formal_parameter_list_opt "")"" 'right' {{MethodDeclarator}}
	| method_declarator 'declarator' ""["" 'left' ""]"" 'right' {{ArrayMethodDeclarator}} # deprecated
	# be careful; the above production also allows 'void foo() []'
	;
formal_parameter_list_opt 
	: 
	| formal_parameter_list 
	;
formal_parameter_list 
	: formal_parameter 'parameter' 
	| formal_parameter_list "","" 'comma' formal_parameter 'parameter' 
	;
formal_parameter 
	: variable_modifiers type 'type' variable_declarator_id 'variable' {{Parameter}}
	| variable_modifiers type 'type' ""..."" 'varArgsToken' variable_declarator_id 'variable' {{VariableArgumentParameter}}
	;
throws_opt 
	: 
	| throws 
	;
throws 
	: ""throws"" 'throwsToken' class_type_list {{Throws}}
	;
class_type_list 
	: class_type 'classType'
	| class_type_list "","" 'comma' class_type 'classType' 
	;
method_body 
	: block 
	| "";"" 'semicolon' {{EmptyMethodBody}}
	;
# 19.8.4) Static Initializers
static_initializer 
	: ""static"" 'staticToken' block 'block' {{StaticInitializer}}
	;
# 19.8.5) Constructor Declarations
constructor_declaration 
	: modifiers_opt constructor_declarator throws_opt 'throws'
			constructor_body 'body' {{ConstructorDeclaration}}
	;
constructor_declarator 
	: type_parameters_opt 'typeParameters' simple_name 'name' ""("" 'left' formal_parameter_list_opt "")"" 'right'
	;
constructor_body 
	: ""{"" 'left' explicit_constructor_invocation 'constructorInvocation'
			block_statements ""}"" 'right' {{ConstructorBody}}
	| ""{"" 'left' explicit_constructor_invocation 'constructorInvocation' ""}"" 'right' {{ConstructorBody}}
	| ""{"" 'left' block_statements ""}"" 'right' {{ConstructorBody}}
	| ""{"" 'left' ""}"" 'right' {{ConstructorBody}}
	;
explicit_constructor_invocation 
	: ""this"" 'thisToken' ""("" 'left' argument_list_opt "")"" 'right' "";"" 'semicolon' {{ThisConstructorInvocation}}
	| ""super"" 'superToken' ""("" 'left' argument_list_opt "")"" 'right' "";"" 'semicolon' {{SuperConstructorInvocation}}
	| primary 'primary' ""."" 'period' ""this"" 'thisToken' ""("" 'left' argument_list_opt "")"" 'right' "";"" 'semicolon' {{ThisConstructorInvocation}}
	| primary 'primary' ""."" 'period' ""super"" 'superToken' ""("" 'left' argument_list_opt "")"" 'right' "";"" 'semicolon' {{SuperConstructorInvocation}}
	;
# 19.9) Interfaces
# 19.9.1) Interface Declarations
interface_declaration 
	: modifiers_opt ""interface"" 'interfaceToken' <IDENTIFIER> 'name' type_parameters_opt 'typeParameters' extends_interfaces_opt 
			interface_body {{Interface}}
	;
annotation_interface_declaration
	: modifiers_opt ""@"" 'atToken' ""interface"" 'interfaceToken' <IDENTIFIER> 'name' annotation_interface_body {{AnnotationInterface}}
	;
annotation_interface_body
	: ""{"" 'left' annotation_interface_member_declarations_opt ""}"" 'right'
	;
annotation_interface_member_declarations_opt
	: 
	| annotation_interface_member_declarations
	;
annotation_interface_member_declarations
	: annotation_interface_member_declaration 'declaration'
	| annotation_interface_member_declarations annotation_interface_member_declaration 'declaration'
	;
annotation_interface_member_declaration
	: annotation_method_declaration
	| type_declaration
	| field_declaration
	;
annotation_method_declaration
	: abstract_method_declaration
	| method_header ""default"" 'defaultToken' variable_initializer 'value' "";"" 'semicolon' {{AnnotationMethodDeclaration}}
	;
extends_interfaces_opt 
	: 
	| extends_interfaces 
	;
extends_interfaces 
	: ""extends"" 'extendsToken' interface_type 'interfaceType' 
	| extends_interfaces "","" 'comma' interface_type 'interfaceType' 
	;
interface_body 
	: ""{"" 'left' interface_member_declarations_opt ""}"" 'right'
	;
interface_member_declarations_opt 
	: 
	| interface_member_declarations 
	;
interface_member_declarations 
	: interface_member_declaration 'declaration'
	| interface_member_declarations interface_member_declaration 'declaration'
	;
interface_member_declaration 
	: constant_declaration 
	| abstract_method_declaration 
	| type_declaration
	;
constant_declaration 
	: field_declaration 
	# need to semantically check that modifiers of field declaration
	# include only PUBLIC, ""static"", or ""final"". Other modifiers are
	# disallowed.
	;
abstract_method_declaration 
	: method_header "";"" 'semicolon' {{AbstractMethodDeclaration}}
	;
# 19.10) Arrays
array_initializer 
	: ""{"" 'left' variable_initializers "","" 'comma' ""}"" 'right' {{ArrayInitializer}}
	| ""{"" 'left' variable_initializers ""}"" 'right' {{ArrayInitializer}}
	| ""{"" 'left' "","" 'comma' ""}"" 'right' {{ArrayInitializer}}
	| ""{"" 'left' ""}"" 'right' {{ArrayInitializer}}
	;
variable_initializers 
	: variable_initializer 'initializer' 
	| variable_initializers "","" 'comma' variable_initializer 'initializer'
	;
# 19.11) Blocks and Statements
block 
	:	""{"" 'left' block_statements_opt ""}"" 'right' {{Block}}
	;
block_statements_opt 
	: 
	| block_statements 
	;
block_statements 
	: block_statement 'statement' 
	| block_statements block_statement 'statement' 
	;
block_statement 
	: local_variable_declaration_statement 
	| statement 
	| class_declaration 
	| interface_declaration 
	;
local_variable_declaration_statement 
	: local_variable_declaration 'declaration' "";"" 'semicolon' {{LocalVariableDeclarationStatement}}
	;
local_variable_declaration 
	: variable_modifiers type 'type' variable_declarators {{LocalVariableDeclaration}}
	;
statement 
	: statement_without_trailing_substatement 
	| labeled_statement 
	| if_then_statement 
	| if_then_else_statement 
	| while_statement 
	| for_statement
	| foreach_statement
	;
statement_without_trailing_substatement 
	: block 
	| empty_statement 
	| expression_statement 
	| switch_statement 
	| do_statement 
	| break_statement 
	| continue_statement 
	| return_statement 
	| synchronized_statement 
	| throw_statement 
	| try_statement 
	| assert_statement
	;
empty_statement 
	: "";"" 'semicolon' {{EmptyStatement}}
	;
labeled_statement 
	: <IDENTIFIER> 'identifier' "":"" 'colon' statement 'statement' {{LabeledStatement}}
	;
expression_statement 
	: statement_expression 'expression' "";"" 'semicolon' {{ExpressionStatement}}
	;
statement_expression 
	: assignment 
	| preincrement_expression 
	| predecrement_expression 
	| postincrement_expression 
	| postdecrement_expression 
	| method_invocation 
	| class_instance_creation_expression 
	;
if_then_statement 
	: ""if"" 'ifToken' ""("" 'left' expression 'expression' "")"" 'right' statement 'trueStatement' {{IfStatement}}
	;
if_then_else_statement 
	: ""if"" 'ifToken' ""("" 'left' expression 'expression' "")"" 'right' statement 'trueStatement'
			""else"" 'elseToken' statement 'falseStatement' {{IfElseStatement}}
	;
switch_statement 
	: ""switch"" 'switchToken' ""("" 'left' expression 'expression' "")"" 'right' switch_block 'block' {{SwitchStatement}}
	;
switch_block 
	: ""{"" 'left' switch_block_statement_groups switch_labels ""}"" 'right' {{SwitchBlock}}
	| ""{"" 'left' switch_block_statement_groups ""}"" 'right' {{SwitchBlock}}
	| ""{"" 'left' switch_labels ""}"" 'right' {{SwitchBlock}}
	| ""{"" 'left' ""}"" 'right' {{SwitchBlock}}
	;
switch_block_statement_groups 
	: switch_block_statement_group 'statementGroup' 
	| switch_block_statement_groups switch_block_statement_group 'statementGroup' 
	;
switch_block_statement_group 
	: switch_labels block_statements {{SwitchBlockStatementGroup}}
	;
switch_labels 
	: switch_label 'label' 
	| switch_labels switch_label 'label'
	;
switch_label 
	: ""case"" 'caseToken' constant_expression 'constant' "":"" 'colon' {{SwitchLabel}}
	| ""default"" 'defaultToken' "":"" 'colon' {{DefaultLabel}}
	;
while_statement 
	: ""while"" 'whileToken' ""("" 'left' expression 'expression' "")"" 'right' statement 'statement' {{WhileStatement}}
	;
do_statement 
	: ""do"" 'doToken' statement 'statement' ""while"" 'whileToken' ""("" 'left' expression 'expression' "")"" 'right' "";"" 'semicolon' {{DoWhileStatement}}
	;
for_statement 
	: ""for"" 'forToken' ""("" 'left' for_init_opt 'initial' "";"" 'firstSemicolon' expression_opt 'test' "";"" 'secondSemicolon'
			for_update_opt 'update' "")"" 'right' statement 'statement' {{ForStatement}}
	;
for_init_opt 
	: 
	| for_init 
	;
for_init 
	: statement_expression_list 
	| local_variable_declaration 
	;
for_update_opt 
	: 
	| for_update 
	;
for_update 
	: statement_expression_list 
	;
statement_expression_list 
	: statement_expression 'expression' {{StatementExpressionList}}
	| statement_expression_list "","" 'comma' statement_expression 'expression' {{StatementExpressionList}}
	;
identifier_opt 
	: 
	| <IDENTIFIER> 
	;
break_statement 
	: ""break"" 'breakToken' identifier_opt 'identifier' "";"" 'semicolon' {{BreakStatement}}
	;
continue_statement 
	: ""continue"" 'continueToken' identifier_opt 'identifier' "";"" 'semicolon' {{ContinueStatement}}
	;
return_statement 
	: ""return"" 'returnToken' expression_opt 'expression' "";"" 'semicolon' {{ReturnStatement}}
	;
throw_statement 
	: ""throw"" 'throwToken' expression 'expression' "";"" 'semicolon' {{ThrowStatement}}
	;
synchronized_statement 
	: ""synchronized"" 'synchronizedToken' ""("" 'left' expression 'expression' "")"" 'right' block 'block' {{SynchronizedStatement}}
	;
try_statement 
	: ""try"" 'tryToken' block 'block' catches {{TryStatement}}
	| ""try"" 'tryToken' block 'block' catches_opt finally 'finally' {{TryStatement}}
	;
catches_opt 
	: 
	| catches 
	;
catches 
	: catch_clause 'catch'
	| catches catch_clause 'catch'
	;
catch_clause 
	: ""catch"" 'catchToken' ""("" 'left' formal_parameter 'parameter' "")"" 'right' block 'block' {{CatchClause}}
	;
finally 
	: ""finally"" 'finallyToken' block 'block' {{FinallyClause}}
	;
assert_statement
	: ""assert"" 'assertToken' expression 'testExpression' "";"" 'semicolon' {{AssertStatement}}
	| ""assert"" 'assertToken' expression 'testExpression' "":"" 'colon' expression 'messageExpression' "";"" 'semicolon' {{AssertStatement}}
	;
# 19.12) Expressions
primary 
	: primary_no_new_array 
	| array_creation_expression 
	;
primary_no_new_array 
	: literal 
	| ""this"" 'name' {{Name}}
	| ""("" 'left' expression "")"" 'right' {{Expression}}
	| class_instance_creation_expression 
	| field_access 
	| method_invocation 
	| array_access 
	| primitive_type 'type' ""."" 'period' ""class"" 'classToken' {{ClassProperty}}
	| void 'type' ""."" 'period' ""class"" 'classToken' {{ClassProperty}}
	| array_type 'type' ""."" 'period' ""class"" 'classToken' {{ClassProperty}}
	| name 'name' ""."" 'period' ""class"" 'classToken' {{ClassProperty}} ###???
	| name 'name' ""."" 'period' ""this"" 'thisToken' {{ClassProperty}} ###???
	;
lambda_expression
	: lambda_parameters ""->"" 'arrowToken' lambda_function {{LambdaExpression}}
	;
lambda_parameters
	: ""("" 'leftParen' lambda_parameter_list_opt "")"" 'rightParen' 
	| untyped_lambda_parameter 'parameter'
	;
lambda_parameter_list_opt
	:
	| lambda_parameter_list
	;
lambda_parameter_list
	: lambda_parameter 'parameter'
	| lambda_parameter_list "","" 'comma' lambda_parameter 'parameter'
	;
lambda_parameter
	: formal_parameter
	| untyped_lambda_parameter
	;
untyped_lambda_parameter
	: variable_declarator_id 'variable' {{Parameter}}
	;
lambda_function
	: block 'value'
	| expression 'value'
	;
class_instance_creation_expression 
	: ""new"" 'newToken' class_type 'type' ""("" 'left' argument_list_opt "")"" 'right' {{New}}
	| ""new"" 'newToken' class_type 'type' ""("" 'left' argument_list_opt "")"" 'right' class_body {{NewClass}}
	| primary 'primary' ""."" 'period' ""new"" 'newToken' <IDENTIFIER> 'name' 
			""("" 'left' argument_list_opt "")"" 'right' {{New}}
	| primary 'primary' ""."" 'period' ""new"" 'newToken' <IDENTIFIER> 'name' 
			""("" 'left' argument_list_opt "")"" 'right' class_body {{NewClass}}
	;
argument_list_opt 
	: 
	| argument_list 
	;
argument_list 
	: expression 'expression' 
	| argument_list "","" 'comma' expression 'expression'
	;
array_creation_expression 
	: ""new"" 'newToken' primitive_type 'type' dim_exprs dims_opt {{NewArray}}
	| ""new"" 'newToken' class_or_interface_type 'type' dim_exprs dims_opt {{NewArray}}
	| ""new"" 'newToken' primitive_type 'type' dims array_initializer 'initializer' {{NewArray}}
	| ""new"" 'newToken' class_or_interface_type 'type' dims array_initializer 'initializer' {{NewArray}}
	;
dim_exprs 
	: dim_expr 'dimExpression' 
	| dim_exprs dim_expr 'dimExpression' 
	;
dim_expr 
	: ""["" 'left' expression 'expression' ""]"" 'right' {{DimensionExpression}}
	;
dims_opt 
	: 
	| dims 
	;
dims 
	: empty_dim_expr
	| dims empty_dim_expr
	;
empty_dim_expr
	: ""["" 'left' ""]"" 'right'
	;
field_access 
	: primary 'receiver' ""."" 'period' <IDENTIFIER> 'name' {{FieldAccess}}
	| ""super"" 'superToken' ""."" 'period' <IDENTIFIER> 'name' {{FieldAccess}}
	| name 'receiver' ""."" 'superPeriod' ""super"" 'superToken' ""."" 'period' <IDENTIFIER> 'name' {{FieldAccess}}###???
	;
method_invocation 
	: type_arguments_opt <IDENTIFIER> 'name' ""("" 'left' argument_list_opt "")"" 'right' {{MethodInvocation}}
	| primary 'receiver' ""."" 'period' type_arguments_opt <IDENTIFIER> 'name' ""("" 'left' argument_list_opt "")"" 'right' {{MethodInvocation}}
	| name 'receiver' ""."" 'period' type_arguments_opt <IDENTIFIER> 'name' ""("" 'left' argument_list_opt "")"" 'right' {{MethodInvocation}}
	| ""super"" 'superToken' ""."" 'period' type_arguments_opt <IDENTIFIER> 'name' ""("" 'left' argument_list_opt "")"" 'right' {{MethodInvocation}}
	| name 'receiver' ""."" 'superPeriod' ""super"" 'superToken' ""."" 'period' type_arguments_opt <IDENTIFIER> 'name' ""("" 'left' argument_list_opt "")"" 'right' {{MethodInvocation}}
	;
array_access 
	: name 'array' ""["" 'left' expression 'expression' ""]"" 'right' {{ArrayAccess}}
	| primary_no_new_array 'array' ""["" 'left' expression 'expression' ""]"" 'right' {{ArrayAccess}}
	;
postfix_expression 
	: primary 
	| name 
	| postincrement_expression 
	| postdecrement_expression 
	;
postincrement_expression 
	: postfix_expression 'expression' ""++"" 'plusPlus' {{PostIncrementExpression}}
	;
postdecrement_expression 
	: postfix_expression 'expression' ""--"" 'minusMinus' {{PostDecrementExpression}}
	;
unary_expression 
	: preincrement_expression 
	| predecrement_expression 
	| ""+"" 'plus' unary_expression 'expression' {{UnaryAddition}}
	| ""-"" 'minus' unary_expression 'expression' {{UnarySubtraction}}
	| unary_expression_not_plus_minus 
| assignment # HACK for VAGEN
	;
preincrement_expression 
	: ""++"" 'plusPlus' unary_expression 'expression' {{PreIncrementExpression}}
	;
predecrement_expression 
	: ""--"" 'minusMinus' unary_expression 'expression' {{PreDecrementExpression}}
	;
unary_expression_not_plus_minus 
	: postfix_expression 
	| ""~"" 'tilde' unary_expression 'expression' {{UnaryBitInvert}}
	| ""!!"" 'bang' unary_expression 'expression' {{UnaryNot}}
	| cast_expression 
	;
cast_expression 
	: ""("" 'left' type 'type' "")"" 'right' unary_expression_not_plus_minus 'expression' {{CastExpression}}
	;
multiplicative_expression 
	: unary_expression 
	| multiplicative_expression 'leftExpression' ""*"" 'op' unary_expression 'rightExpression' {{BinaryExpression}}
	| multiplicative_expression 'leftExpression' ""/"" 'op' unary_expression 'rightExpression' {{BinaryExpression}}
	| multiplicative_expression 'leftExpression' ""%"" 'op' unary_expression 'rightExpression' {{BinaryExpression}}
	;
additive_expression 
	: multiplicative_expression 
	| additive_expression 'leftExpression' ""+"" 'op' multiplicative_expression 'rightExpression' {{BinaryExpression}}
	| additive_expression 'leftExpression' ""-"" 'op' multiplicative_expression 'rightExpression' {{BinaryExpression}}
	;
shift_expression 
	: additive_expression 
	| shift_expression 'leftExpression' ""<<"" 'op' additive_expression 'rightExpression' {{BinaryExpression}}
	| shift_expression 'leftExpression' <SIGNED_RIGHT_SHIFT> 'op' additive_expression 'rightExpression' {{BinaryExpression}}
	| shift_expression 'leftExpression' <UNSIGNED_RIGHT_SHIFT> 'op' additive_expression 'rightExpression' {{BinaryExpression}}
	;
relational_expression 
	: shift_expression 
	| relational_expression 'leftExpression' ""<"" 'op' shift_expression 'rightExpression' {{BinaryExpression}}
	| relational_expression 'leftExpression' <GREATER_THAN> 'op' shift_expression 'rightExpression' {{BinaryExpression}}
	| relational_expression 'leftExpression' ""<="" 'op' shift_expression 'rightExpression' {{BinaryExpression}}
	| relational_expression 'leftExpression' "">="" 'op' shift_expression 'rightExpression' {{BinaryExpression}}
	| relational_expression 'leftExpression' ""instanceof"" 'op' reference_type 'rightExpression' {{BinaryExpression}}
	;
equality_expression 
	: relational_expression 
	| equality_expression 'leftExpression' ""=="" 'op' relational_expression 'rightExpression' {{BinaryExpression}}
	| equality_expression 'leftExpression' ""!!="" 'op' relational_expression 'rightExpression' {{BinaryExpression}}
	;
and_expression 
	: equality_expression 
	| and_expression 'leftExpression' ""&"" 'op' equality_expression 'rightExpression' {{BinaryExpression}}
	;
exclusive_or_expression 
	: and_expression 
	| exclusive_or_expression 'leftExpression' ""^"" 'op' and_expression 'rightExpression' {{BinaryExpression}}
	;
inclusive_or_expression 
	: exclusive_or_expression 
	| inclusive_or_expression 'leftExpression' ""|"" 'op' exclusive_or_expression 'rightExpression' {{BinaryExpression}}
	;
conditional_and_expression 
	: inclusive_or_expression 
	| conditional_and_expression 'leftExpression' ""&&"" 'op' inclusive_or_expression 'rightExpression' {{BinaryExpression}}
	;
conditional_or_expression 
	: conditional_and_expression 
	| conditional_or_expression 'leftExpression' ""||"" 'op' conditional_and_expression 'rightExpression' {{BinaryExpression}}
	;
conditional_expression 
	: conditional_or_expression 
	| conditional_or_expression 'testExpression' ""?"" 'questionMark' expression 'trueExpression'
			"":"" 'colon' conditional_expression 'falseExpression' {{ConditionalExpression}}
	;
assignment_expression 
	: conditional_expression 
	| assignment 
	;
assignment 
	: left_hand_side 'variable' assignment_operator 'op' assignment_expression 'value' {{Assignment}}
	;
left_hand_side 
	: name 
	| field_access 
	| array_access 
	;
assignment_operator 
	: ""="" 
	| ""*="" 
	| ""/="" 
	| ""%="" 
	| ""+="" 
	| ""-="" 
	| ""<<="" 
	| "">>="" 
	| "">>>="" 
	| ""&="" 
	| ""^="" 
	| ""|="" 
	;
expression_opt 
	: 
	| expression 
	;
expression 
	: assignment_expression 
	| lambda_expression
	;
constant_expression 
	: expression 
	;
####
annotations
	:
	| annotations annotation 'annotation'
	;
annotation
	: ""@"" 'at' name 'name' annotation_args_opt {{Annotation}}
	;
annotation_args_opt
	:
	| ""("" 'left' annotation_args "")"" 'right'
	;
annotation_args
	: 
	| elementValuePairs
	| elementValue 'value'
	;
elementValuePairs
	: elementValuePair 'value'
	| elementValuePairs "","" 'comma' elementValuePair 'value'
	;
elementValuePair
	: <IDENTIFIER> 'name' ""="" 'equals' elementValue 'value' {{ElementValuePair}}
	;
elementValue
	: conditional_expression
	| annotation
	| elementValueArrayInitializer
	;
elementValueArrayInitializer
	: ""{"" 'left' elementValues_opt comma_opt ""}"" 'right' {{ElementArrayInitializer}}
	;
elementValues_opt
	:
	| elementValues
	;
elementValues
	: elementValue 'value'
	| elementValues "","" 'comma' elementValue 'value'
	;
comma_opt
	:
	| "","" 'comma'
	;
static_opt
	:
	| ""static"" 'staticToken'
	;
enum_declaration
	: modifiers_opt ""enum"" 'enumToken' <IDENTIFIER> 'name' interfaces_opt enum_body {{EnumDeclaration}}
	;
enum_body
	: ""{"" 'left' enum_constants_opt comma_opt enum_body_declarations_opt ""}"" 'right'
	;
enum_constants_opt
	:
	| enum_constants
	;
enum_constants
	: enum_constant 'constant'
	| enum_constants "","" 'comma' enum_constant 'constant'
	;
enum_constant
	: annotations <IDENTIFIER> 'name' arguments_opt class_body_opt {{EnumConstant}}
	;
arguments_opt
	:
	| ""("" 'leftParen' argument_list_opt "")"" 'rightParen'
	;
class_body_opt
	:
	| class_body
	;
enum_body_declarations_opt
	:
	| enum_body_declarations
	;
enum_body_declarations
	: "";"" 'semicolon' class_body_declarations_opt
	;
type_parameters_opt
	:
	| ""<"" 'left' type_parameters <GREATER_THAN> 'right' {{TypeParameters}}
	;
type_parameters
	: type_parameter 'parameter'
	| type_parameters "","" 'comma' type_parameter 'parameter'
	;
type_parameter
	: <IDENTIFIER> 'name' extends_type_parameter_opt {{TypeParameter}}
	;
extends_type_parameter_opt
	:
	| ""extends"" 'extendsToken' type_bound 
	;
type_bound
	: type 'type'
	| type_bound ""&"" 'amp' type 'type'
	;
type_arguments_opt
	:
	| ""<"" 'typeArgLeft' type_arguments <GREATER_THAN> 'typeArgRight'
	;
type_arguments
	: type_argument 'argument'
	| type_arguments "","" 'comma' type_argument 'argument'
	;
type_argument
	: type 'type' {{TypeArgument}}
	| ""?"" 'questionMark' type_argument_type {{TypeArgument}}
	;
type_argument_type
	: ""extends"" 'token' type 'type'
	| ""super"" 'token' type 'type'
	|
	;
type_name
	: simple_type_name 
	| qualified_type_name 
	;
simple_type_name 
	: <IDENTIFIER> 'name' type_arguments_opt {{TypeName}}
	;
qualified_type_name 
	: type_name 'nspace' ""."" 'period' <IDENTIFIER> 'name' type_arguments_opt {{QualifiedTypeName}}
	;
foreach_statement 
	: ""for"" 'forToken' ""("" 'left' variable_modifiers type 'type' <IDENTIFIER> 'name' "":"" 'colon' expression 'expression' "")"" 'right' statement 'statement' {{ForEachStatement}}
	;
variable_modifiers
	: 
	| variable_modifiers variable_modifier 'modifier'
	;
variable_modifier
	: ""final"" 'token' {{Modifier}}
	| annotation
	;"!

fileExtension
	^'.java'!

fileExtensionType
	^'Java files'!

scannerClass
	^JavaScanner!

startingStateForblock_statement
	^2!

startingStateForexpression
	^3!

startingStateForgoal
	^1!

startingStateFortype_declaration
	^4! !
!JavaParser class categoriesFor: #definitionComment!generated!public! !
!JavaParser class categoriesFor: #fileExtension!file types!public! !
!JavaParser class categoriesFor: #fileExtensionType!file types!public! !
!JavaParser class categoriesFor: #scannerClass!generated-accessing!public! !
!JavaParser class categoriesFor: #startingStateForblock_statement!generated!public! !
!JavaParser class categoriesFor: #startingStateForexpression!generated!public! !
!JavaParser class categoriesFor: #startingStateForgoal!generated!public! !
!JavaParser class categoriesFor: #startingStateFortype_declaration!generated!public! !

JavaScanner guid: (GUID fromString: '{7E5186F5-8BB6-4D55-BB46-C1D3D817DD92}')!
JavaScanner comment: ''!
!JavaScanner categoriesForClass!Unclassified! !
!JavaScanner methodsFor!

emptySymbolTokenId
	^307!

errorTokenId
	^308!

GREATER_THANId
	^95!

scan1
	[self step.
	currentCharacter == $" ifTrue: [^self recordAndReportMatch: #(102)].
	currentCharacter == $\
		ifTrue:
			[self step.
			currentCharacter == $u
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[3
								timesRepeat:
									[self step.
									(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
							^self scan1].
					^self reportLastMatch].
			(('"''' includes: currentCharacter)
				or: [(currentCharacter between: $0 and: $7) or: ['\bfnrt' includes: currentCharacter]]) ifTrue: [^self scan1].
			^self reportLastMatch]] repeat!

scan2
	self step.
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(101)].
	^self reportLastMatch!

scan3
	self step.
	currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(101)].
	(currentCharacter between: $0 and: $7) ifTrue: [^self scan2].
	^self reportLastMatch!

scan4
	[self recordMatch: #(99).
	self step.
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan5].
	('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
	^self reportLastMatch!

scan5
	self step.
	('+-' includes: currentCharacter) ifTrue: [self step].
	currentCharacter isDigit ifTrue: [^self scan6].
	^self reportLastMatch!

scan6
	[self recordMatch: #(99).
	self step.
	currentCharacter isDigit] whileTrue.
	('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
	^self reportLastMatch!

scan7
	[self step.
	currentCharacter == $*
		ifTrue:
			[[self step.
			currentCharacter == $*] whileTrue.
			currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(106)].
			^self scan7]] repeat!

scan8
	[self step.
	currentCharacter == $. ifTrue: [^self scan4].
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan5].
	('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
	^self reportLastMatch!

scan9
	[self step.
	currentCharacter == $`
		ifTrue:
			[self recordMatch: #(107).
			self step.
			currentCharacter == $` ifTrue: [^self scan9].
			^self reportLastMatch]] repeat!

scanForToken
	self step.
	currentCharacter == $!!
		ifTrue:
			[self recordMatch: #(86).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(52)].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $%
		ifTrue:
			[self recordMatch: #(90).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(68)].
			^self reportLastMatch].
	currentCharacter == $&
		ifTrue:
			[self recordMatch: #(53).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(51)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(62)].
			^self reportLastMatch].
	currentCharacter == $'
		ifTrue:
			[self step.
			currentCharacter == $\
				ifTrue:
					[self step.
					currentCharacter == $u
						ifTrue:
							[self step.
							(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
								ifTrue:
									[3
										timesRepeat:
											[self step.
											(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
									^self scan2].
							^self reportLastMatch].
					(currentCharacter between: $0 and: $3)
						ifTrue:
							[self step.
							currentCharacter == $' ifTrue: [^self recordAndReportMatch: #(101)].
							(currentCharacter between: $0 and: $7) ifTrue: [^self scan3].
							^self reportLastMatch].
					(currentCharacter between: $4 and: $7) ifTrue: [^self scan3].
					('"''\bfnrt' includes: currentCharacter) ifTrue: [^self scan2].
					^self reportLastMatch].
			(currentCharacter <= $& or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]])
				ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(23)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(20)].
	currentCharacter == $*
		ifTrue:
			[self recordMatch: #(45).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(59)].
			^self reportLastMatch].
	currentCharacter == $+
		ifTrue:
			[self recordMatch: #(88).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(92)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(69)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter == $-
		ifTrue:
			[self recordMatch: #(89).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(93)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(70)].
			currentCharacter == $> ifTrue: [^self recordAndReportMatch: #(94)].
			^self reportLastMatch].
	currentCharacter == $.
		ifTrue:
			[self recordMatch: #(30).
			self step.
			currentCharacter == $.
				ifTrue:
					[self step.
					currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(21)].
					^self reportLastMatch].
			currentCharacter isDigit ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $/
		ifTrue:
			[self recordMatch: #(87).
			self step.
			currentCharacter == $* ifTrue: [^self scan7].
			currentCharacter == $/
				ifTrue:
					[[self step.
					currentCharacter isLinefeed ifTrue: [^self recordAndReportMatch: #(106)].
					currentCharacter == ##(Character value: 13)
						ifTrue:
							[self recordMatch: #(106).
							self step.
							currentCharacter isLinefeed ifTrue: [^self recordAndReportMatch: #(106)].
							^self reportLastMatch]] repeat].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(71)].
			^self reportLastMatch].
	currentCharacter == $0
		ifTrue:
			[self recordMatch: #(98).
			self step.
			currentCharacter == $. ifTrue: [^self scan4].
			(currentCharacter between: $8 and: $9) ifTrue: [^self scan8].
			currentCharacter isDigit
				ifTrue:
					[[self recordMatch: #(98).
					self step.
					currentCharacter == $. ifTrue: [^self scan4].
					(currentCharacter between: $8 and: $9) ifTrue: [^self scan8].
					currentCharacter isDigit] whileTrue.
					('Ee' includes: currentCharacter) ifTrue: [^self scan5].
					('Ll' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(98)].
					('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
					^self reportLastMatch].
			('Ee' includes: currentCharacter) ifTrue: [^self scan5].
			('Ll' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(98)].
			('Xx' includes: currentCharacter)
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[[self recordMatch: #(98).
							self step.
							currentCharacter == $.
								ifTrue:
									[self step.
									(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
										ifTrue:
											[[self step.
											('Pp' includes: currentCharacter) ifTrue: [^self scan5].
											currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]] whileTrue].
									^self reportLastMatch].
							('Ll' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(98)].
							currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]] whileTrue].
					^self reportLastMatch].
			('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
			^self reportLastMatch].
	currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(72)].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(47)].
	currentCharacter == $<
		ifTrue:
			[self recordMatch: #(60).
			self step.
			currentCharacter == $<
				ifTrue:
					[self recordMatch: #(66).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(64)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(67)].
			^self reportLastMatch].
	currentCharacter == $=
		ifTrue:
			[self recordMatch: #(3).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(58)].
			^self reportLastMatch].
	currentCharacter == $>
		ifTrue:
			[self recordMatch: #(95).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(56)].
			currentCharacter == $>
				ifTrue:
					[self recordMatch: #(96).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(65)].
					currentCharacter == $>
						ifTrue:
							[self recordMatch: #(97).
							self step.
							currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(61)]]].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(54)].
	currentCharacter == $@ ifTrue: [^self recordAndReportMatch: #(14)].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(7)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(6)].
	currentCharacter == $^
		ifTrue:
			[self recordMatch: #(49).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(63)].
			^self reportLastMatch].
	currentCharacter == $` ifTrue: [^self scan9].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(1)].
	currentCharacter == $|
		ifTrue:
			[self recordMatch: #(50).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(48)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(55)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(2)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(85)].
	currentCharacter isDigit
		ifTrue:
			[[self recordMatch: #(98).
			self step.
			currentCharacter == $. ifTrue: [^self scan4].
			currentCharacter isDigit] whileTrue.
			('Ee' includes: currentCharacter) ifTrue: [^self scan5].
			('Ll' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(98)].
			('DFdf' includes: currentCharacter) ifTrue: [^self recordAndReportMatch: #(99)].
			^self reportLastMatch].
	currentCharacter isWhitespace
		ifTrue:
			[[self recordMatch: #(105).
			self step.
			currentCharacter isWhitespace] whileTrue.
			^self reportLastMatch].
	(currentCharacter == $$
		or: [(currentCharacter between: $A and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]])
		ifTrue:
			[[self recordMatch: #(104).
			self step.
			currentCharacter == $$
				or:
					[(currentCharacter between: $0 and: $9)
						or:
							[(currentCharacter between: $A and: $Z) or: [currentCharacter == $_ or: [currentCharacter between: $a and: $z]]]]]
				whileTrue].
	^self reportLastMatch!

SIGNED_RIGHT_SHIFTId
	^96!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #whitespace #comment #patternToken)!

UNSIGNED_RIGHT_SHIFTId
	^97! !
!JavaScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!JavaScanner categoriesFor: #errorTokenId!generated!public! !
!JavaScanner categoriesFor: #GREATER_THANId!generated!public! !
!JavaScanner categoriesFor: #scan1!generated!public! !
!JavaScanner categoriesFor: #scan2!generated!public! !
!JavaScanner categoriesFor: #scan3!generated!public! !
!JavaScanner categoriesFor: #scan4!generated!public! !
!JavaScanner categoriesFor: #scan5!generated!public! !
!JavaScanner categoriesFor: #scan6!generated!public! !
!JavaScanner categoriesFor: #scan7!generated!public! !
!JavaScanner categoriesFor: #scan8!generated!public! !
!JavaScanner categoriesFor: #scan9!generated!public! !
!JavaScanner categoriesFor: #scanForToken!generated!public! !
!JavaScanner categoriesFor: #SIGNED_RIGHT_SHIFTId!generated!public! !
!JavaScanner categoriesFor: #tokenActions!generated!public! !
!JavaScanner categoriesFor: #UNSIGNED_RIGHT_SHIFTId!generated!public! !

!JavaScanner class methodsFor!

initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(104 'abstract' 38) #(104 'assert' 83) #(104 'boolean' 33) #(104 'break' 76) #(104 'byte' 34) #(104 'case' 84) #(104 'catch' 79) #(104 'char' 26) #(104 'class' 9) #(104 'continue' 77) #(104 'default' 15) #(104 'do' 81) #(104 'double' 31) #(104 'else' 32) #(104 'enum' 13) #(104 'extends' 10) #(104 'false' 100) #(104 'final' 39) #(104 'finally' 78) #(104 'float' 27) #(104 'for' 82) #(104 'if' 24) #(104 'implements' 4) #(104 'import' 44) #(104 'instanceof' 57) #(104 'int' 29) #(104 'interface' 43) #(104 'long' 25) #(104 'native' 42) #(104 'new' 91) #(104 'null' 103) #(104 'package' 35) #(104 'private' 41) #(104 'protected' 40) #(104 'public' 46) #(104 'return' 73) #(104 'short' 28) #(104 'static' 37) #(104 'strictfp' 8) #(104 'super' 17) #(104 'switch' 36) #(104 'synchronized' 18) #(104 'this' 16) #(104 'throw' 74) #(104 'throws' 22) #(104 'transient' 12) #(104 'true' 100) #(104 'try' 75) #(104 'void' 11) #(104 'volatile' 19) #(104 'while' 80))
		do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last].
	^keywordMap! !
!JavaScanner class categoriesFor: #initializeKeywordMap!generated-initialization!public! !

"Binary Globals"!

