| package |
package := Package name: 'SmaCC Javascript Parser'.
package paxVersion: 1;
	basicComment: 'This package is part of the Smalltalk Compiler-Compiler (SmaCC) written by John Brant and Don Roberts. It contains an example JavaScript parser.

If you want more information about SmaCC, visit http://www.refactoryworkers.com/SmaCC/. 
-------------------------------------------------
Copyright (c) 2002-2015 John Brant, Don Roberts

Permission is hereby granted, free of charge, to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction, including without limitation the rights 
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is furnished 
to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS 
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS 
OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
'.


package classNames
	add: #JSArrayLiteralNode;
	add: #JSAssignmentExpressionNode;
	add: #JSBinaryExpressionNode;
	add: #JSBlockStatementNode;
	add: #JSBooleanLiteralNode;
	add: #JSBreakStatementNode;
	add: #JSCallExpressionNode;
	add: #JSCaseClauseNode;
	add: #JSCommaExpressionNode;
	add: #JSConditionalExpressionNode;
	add: #JSContinueStatementNode;
	add: #JSDebuggerStatementNode;
	add: #JSDefaultClauseNode;
	add: #JSDoWhileStatementNode;
	add: #JSEmptyStatementNode;
	add: #JSExpressionNode;
	add: #JSExpressionStatementNode;
	add: #JSFileNode;
	add: #JSForInStatementNode;
	add: #JSForStatementNode;
	add: #JSFunctionNode;
	add: #JSGetPropertyAssignmentNode;
	add: #JSIfStatementNode;
	add: #JSIndexedPropertyExpressionNode;
	add: #JSLabelledStatementNode;
	add: #JSLiteralNode;
	add: #JSNamedPropertyExpressionNode;
	add: #JSNameExpressionNode;
	add: #JSNewExpressionNode;
	add: #JSNullLiteralNode;
	add: #JSNumericLiteralNode;
	add: #JSObjectLiteralNode;
	add: #JSParser;
	add: #JSPostfixExpressionNode;
	add: #JSProgramNode;
	add: #JSProgramNodeVisitor;
	add: #JSPropertyAssignmentNode;
	add: #JSRegularExpressionLiteralNode;
	add: #JSReturnStatementNode;
	add: #JSScanner;
	add: #JSSetPropertyAssignmentNode;
	add: #JSStatementNode;
	add: #JSStringLiteralNode;
	add: #JSSwitchStatementNode;
	add: #JSThisExpressionNode;
	add: #JSThrowStatementNode;
	add: #JSTryStatementNode;
	add: #JSUnaryExpressionNode;
	add: #JSVariableDeclarationNode;
	add: #JSVariableStatementNode;
	add: #JSWhileStatementNode;
	add: #JSWithStatementNode;
	yourself.

package binaryGlobalNames: (Set new
	yourself).

package globalAliases: (Set new
	yourself).

package setPrerequisites: (IdentitySet new
	add: '..\..\..\Object Arts\Dolphin\Base\Dolphin';
	add: '..\SmaCC GLR Runtime\SmaCC GLR Runtime';
	add: '..\SmaCC Runtime\SmaCC Runtime';
	yourself).

package!

"Class Definitions"!

SmaCCParseNode subclass: #JSProgramNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSCaseClauseNode
	instanceVariableNames: 'caseToken caseExpression colonToken statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSDefaultClauseNode
	instanceVariableNames: 'defaultToken colonToken statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSExpressionNode
	instanceVariableNames: 'leftParens rightParens'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSFileNode
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSGetPropertyAssignmentNode
	instanceVariableNames: 'getToken key leftParen rightParen leftBrace statements rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSPropertyAssignmentNode
	instanceVariableNames: 'key colonToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSSetPropertyAssignmentNode
	instanceVariableNames: 'setToken key leftParen variable rightParen leftBrace statements rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSStatementNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSProgramNode subclass: #JSVariableDeclarationNode
	instanceVariableNames: 'variable equalsToken value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSArrayLiteralNode
	instanceVariableNames: 'leftBracket expressions commas rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSAssignmentExpressionNode
	instanceVariableNames: 'lhs operator rhs'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSBinaryExpressionNode
	instanceVariableNames: 'leftExpression operator rightExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSCallExpressionNode
	instanceVariableNames: 'expression left right arguments commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSCommaExpressionNode
	instanceVariableNames: 'expressions comma'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSConditionalExpressionNode
	instanceVariableNames: 'condition questionMarkToken trueExpression colonToken falseExpression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSFunctionNode
	instanceVariableNames: 'functionToken name arguments commas leftBrace statements rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSIndexedPropertyExpressionNode
	instanceVariableNames: 'expression leftBracket fieldExpression rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSLiteralNode
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSNamedPropertyExpressionNode
	instanceVariableNames: 'expression periodToken name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSNameExpressionNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSNewExpressionNode
	instanceVariableNames: 'newToken expression left right arguments commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSObjectLiteralNode
	instanceVariableNames: 'leftBrace rightBrace assignments commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSPostfixExpressionNode
	instanceVariableNames: 'expression operator'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSThisExpressionNode
	instanceVariableNames: 'thisToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSExpressionNode subclass: #JSUnaryExpressionNode
	instanceVariableNames: 'operator expression'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSLiteralNode subclass: #JSBooleanLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSLiteralNode subclass: #JSNullLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSLiteralNode subclass: #JSNumericLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSLiteralNode subclass: #JSRegularExpressionLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSLiteralNode subclass: #JSStringLiteralNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSBlockStatementNode
	instanceVariableNames: 'leftBrace statements rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSBreakStatementNode
	instanceVariableNames: 'breakToken label semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSContinueStatementNode
	instanceVariableNames: 'continueToken label semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSDebuggerStatementNode
	instanceVariableNames: 'debuggerToken semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSDoWhileStatementNode
	instanceVariableNames: 'doToken statement whileToken leftParen expression rightParen semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSEmptyStatementNode
	instanceVariableNames: 'semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSExpressionStatementNode
	instanceVariableNames: 'expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSForInStatementNode
	instanceVariableNames: 'forToken leftParen variable inToken expression rightParen statement varToken'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSForStatementNode
	instanceVariableNames: 'forToken leftParen initialExpression semicolons condition iteratorExpression rightParen statement varToken variables commas'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSIfStatementNode
	instanceVariableNames: 'ifToken leftParen expression rightParen trueStatement elseToken elseStatement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSLabelledStatementNode
	instanceVariableNames: 'label colonToken statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSReturnStatementNode
	instanceVariableNames: 'returnToken expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSSwitchStatementNode
	instanceVariableNames: 'switchToken leftParen expression rightParen leftBrace clauses rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSThrowStatementNode
	instanceVariableNames: 'throwToken expression semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSTryStatementNode
	instanceVariableNames: 'tryToken tryBlock catchToken leftParen exceptionType rightParen catchBlock finallyToken finallyBlock'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSVariableStatementNode
	instanceVariableNames: 'varToken variables commas semicolon'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSWhileStatementNode
	instanceVariableNames: 'whileToken leftParen expression rightParen statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
JSStatementNode subclass: #JSWithStatementNode
	instanceVariableNames: 'withToken leftParen expression rightParen statement'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCParseNodeVisitor subclass: #JSProgramNodeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCGLRParser subclass: #JSParser
	instanceVariableNames: 'lastInsertedSemicolonPosition'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
SmaCCScanner subclass: #JSScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!

"Global Aliases"!


"Loose Methods"!

"End of package definition"!

"Source Globals"!

"Classes"!

JSProgramNode guid: (GUID fromString: '{51CB4C88-5091-4676-B5EC-233A5EDE0B2A}')!
JSProgramNode comment: ''!
!JSProgramNode categoriesForClass!Unclassified! !
!JSProgramNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitProgram: self! !
!JSProgramNode categoriesFor: #acceptVisitor:!generated!public! !

JSCaseClauseNode guid: (GUID fromString: '{DCD880C9-D34D-4E15-82B1-D12B92530B34}')!
JSCaseClauseNode comment: ''!
!JSCaseClauseNode categoriesForClass!Unclassified! !
!JSCaseClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCaseClause: self!

caseExpression
	^caseExpression!

caseExpression: aJSExpressionNode
	self caseExpression notNil ifTrue: [self caseExpression parent: nil].
	caseExpression := aJSExpressionNode.
	self caseExpression notNil ifTrue: [self caseExpression parent: self]!

caseToken
	^caseToken!

caseToken: aSmaCCToken
	caseToken := aSmaCCToken!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

compositeNodeVariables
	^#(#statements)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

nodeVariables
	^#(#caseExpression)!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#caseToken #colonToken)! !
!JSCaseClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!JSCaseClauseNode categoriesFor: #caseExpression!generated!public! !
!JSCaseClauseNode categoriesFor: #caseExpression:!generated!public! !
!JSCaseClauseNode categoriesFor: #caseToken!generated!public! !
!JSCaseClauseNode categoriesFor: #caseToken:!generated!public! !
!JSCaseClauseNode categoriesFor: #colonToken!generated!public! !
!JSCaseClauseNode categoriesFor: #colonToken:!generated!public! !
!JSCaseClauseNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSCaseClauseNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSCaseClauseNode categoriesFor: #nodeVariables!generated!public! !
!JSCaseClauseNode categoriesFor: #statements!generated!public! !
!JSCaseClauseNode categoriesFor: #statements:!generated!public! !
!JSCaseClauseNode categoriesFor: #tokenVariables!generated!public! !

JSDefaultClauseNode guid: (GUID fromString: '{57876175-C3C2-4595-9468-C5E9F8F6D181}')!
JSDefaultClauseNode comment: ''!
!JSDefaultClauseNode categoriesForClass!Unclassified! !
!JSDefaultClauseNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDefaultClause: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

compositeNodeVariables
	^#(#statements)!

defaultToken
	^defaultToken!

defaultToken: aSmaCCToken
	defaultToken := aSmaCCToken!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#defaultToken #colonToken)! !
!JSDefaultClauseNode categoriesFor: #acceptVisitor:!generated!public! !
!JSDefaultClauseNode categoriesFor: #colonToken!generated!public! !
!JSDefaultClauseNode categoriesFor: #colonToken:!generated!public! !
!JSDefaultClauseNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSDefaultClauseNode categoriesFor: #defaultToken!generated!public! !
!JSDefaultClauseNode categoriesFor: #defaultToken:!generated!public! !
!JSDefaultClauseNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSDefaultClauseNode categoriesFor: #statements!generated!public! !
!JSDefaultClauseNode categoriesFor: #statements:!generated!public! !
!JSDefaultClauseNode categoriesFor: #tokenVariables!generated!public! !

JSExpressionNode guid: (GUID fromString: '{EDC84398-9452-4250-9A46-EF1805C267D8}')!
JSExpressionNode comment: ''!
!JSExpressionNode categoriesForClass!Unclassified! !
!JSExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpression: self!

compositeTokenVariables
	^#(#leftParens #rightParens)!

initialize
	super initialize.
	leftParens := OrderedCollection new: 2.
	rightParens := OrderedCollection new: 2.!

leftParens
	^leftParens!

leftParens: anOrderedCollection
	leftParens := anOrderedCollection!

rightParens
	^rightParens!

rightParens: anOrderedCollection
	rightParens := anOrderedCollection! !
!JSExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSExpressionNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSExpressionNode categoriesFor: #leftParens!generated!public! !
!JSExpressionNode categoriesFor: #leftParens:!generated!public! !
!JSExpressionNode categoriesFor: #rightParens!generated!public! !
!JSExpressionNode categoriesFor: #rightParens:!generated!public! !

JSFileNode guid: (GUID fromString: '{AF6AA402-35DC-44D7-BCE8-49E2E65C2082}')!
JSFileNode comment: ''!
!JSFileNode categoriesForClass!Unclassified! !
!JSFileNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFile: self!

compositeNodeVariables
	^#(#statements)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self! !
!JSFileNode categoriesFor: #acceptVisitor:!generated!public! !
!JSFileNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSFileNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSFileNode categoriesFor: #statements!generated!public! !
!JSFileNode categoriesFor: #statements:!generated!public! !

JSGetPropertyAssignmentNode guid: (GUID fromString: '{259C717D-7828-4A3F-A85C-A01DF0B891B5}')!
JSGetPropertyAssignmentNode comment: ''!
!JSGetPropertyAssignmentNode categoriesForClass!Unclassified! !
!JSGetPropertyAssignmentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitGetPropertyAssignment: self!

compositeNodeVariables
	^#(#statements)!

getToken
	^getToken!

getToken: aSmaCCToken
	getToken := aSmaCCToken!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

key
	^key!

key: anObject
	key := anObject!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

otherVariables
	^#(#key)!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#getToken #leftParen #rightParen #leftBrace #rightBrace)! !
!JSGetPropertyAssignmentNode categoriesFor: #acceptVisitor:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #getToken!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #getToken:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSGetPropertyAssignmentNode categoriesFor: #key!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #key:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #leftBrace!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #leftBrace:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #leftParen!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #leftParen:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #otherVariables!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #rightBrace!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #rightBrace:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #rightParen!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #rightParen:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #statements!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #statements:!generated!public! !
!JSGetPropertyAssignmentNode categoriesFor: #tokenVariables!generated!public! !

JSPropertyAssignmentNode guid: (GUID fromString: '{FC81D5EE-281B-4AC7-B43E-3035BBAD1D00}')!
JSPropertyAssignmentNode comment: ''!
!JSPropertyAssignmentNode categoriesForClass!Unclassified! !
!JSPropertyAssignmentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPropertyAssignment: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

key
	^key!

key: anObject
	key := anObject!

nodeVariables
	^#(#value)!

otherVariables
	^#(#key)!

tokenVariables
	^#(#colonToken)!

value
	^value!

value: aJSExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJSExpressionNode.
	self value notNil ifTrue: [self value parent: self]! !
!JSPropertyAssignmentNode categoriesFor: #acceptVisitor:!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #colonToken!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #colonToken:!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #key!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #key:!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #nodeVariables!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #otherVariables!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #tokenVariables!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #value!generated!public! !
!JSPropertyAssignmentNode categoriesFor: #value:!generated!public! !

JSSetPropertyAssignmentNode guid: (GUID fromString: '{95A51288-6249-498C-A3BF-9B2D928D368B}')!
JSSetPropertyAssignmentNode comment: ''!
!JSSetPropertyAssignmentNode categoriesForClass!Unclassified! !
!JSSetPropertyAssignmentNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSetPropertyAssignment: self!

compositeNodeVariables
	^#(#statements)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

key
	^key!

key: anObject
	key := anObject!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

otherVariables
	^#(#key)!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

setToken
	^setToken!

setToken: aSmaCCToken
	setToken := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#setToken #leftParen #variable #rightParen #leftBrace #rightBrace)!

variable
	^variable!

variable: aSmaCCToken
	variable := aSmaCCToken! !
!JSSetPropertyAssignmentNode categoriesFor: #acceptVisitor:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSSetPropertyAssignmentNode categoriesFor: #key!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #key:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #leftBrace!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #leftBrace:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #leftParen!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #leftParen:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #otherVariables!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #rightBrace!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #rightBrace:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #rightParen!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #rightParen:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #setToken!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #setToken:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #statements!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #statements:!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #tokenVariables!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #variable!generated!public! !
!JSSetPropertyAssignmentNode categoriesFor: #variable:!generated!public! !

JSStatementNode guid: (GUID fromString: '{5E82D2EC-D978-4C22-9C5E-A35CAD8B787E}')!
JSStatementNode comment: ''!
!JSStatementNode categoriesForClass!Unclassified! !
!JSStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStatement: self! !
!JSStatementNode categoriesFor: #acceptVisitor:!generated!public! !

JSVariableDeclarationNode guid: (GUID fromString: '{6FB1A9FA-339B-4512-AB73-0D904635513A}')!
JSVariableDeclarationNode comment: ''!
!JSVariableDeclarationNode categoriesForClass!Unclassified! !
!JSVariableDeclarationNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableDeclaration: self!

equalsToken
	^equalsToken!

equalsToken: aSmaCCToken
	equalsToken := aSmaCCToken!

nodeVariables
	^#(#value)!

tokenVariables
	^#(#variable #equalsToken)!

value
	^value!

value: aJSExpressionNode
	self value notNil ifTrue: [self value parent: nil].
	value := aJSExpressionNode.
	self value notNil ifTrue: [self value parent: self]!

variable
	^variable!

variable: aSmaCCToken
	variable := aSmaCCToken! !
!JSVariableDeclarationNode categoriesFor: #acceptVisitor:!generated!public! !
!JSVariableDeclarationNode categoriesFor: #equalsToken!generated!public! !
!JSVariableDeclarationNode categoriesFor: #equalsToken:!generated!public! !
!JSVariableDeclarationNode categoriesFor: #nodeVariables!generated!public! !
!JSVariableDeclarationNode categoriesFor: #tokenVariables!generated!public! !
!JSVariableDeclarationNode categoriesFor: #value!generated!public! !
!JSVariableDeclarationNode categoriesFor: #value:!generated!public! !
!JSVariableDeclarationNode categoriesFor: #variable!generated!public! !
!JSVariableDeclarationNode categoriesFor: #variable:!generated!public! !

JSArrayLiteralNode guid: (GUID fromString: '{DAE9CAD9-96AD-4FEB-A5C5-31C37A3D587B}')!
JSArrayLiteralNode comment: ''!
!JSArrayLiteralNode categoriesForClass!Unclassified! !
!JSArrayLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitArrayLiteral: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#expressions)!

compositeTokenVariables
	^#(#commas #leftParens #rightParens)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBracket
	^leftBracket!

leftBracket: aSmaCCToken
	leftBracket := aSmaCCToken!

rightBracket
	^rightBracket!

rightBracket: aSmaCCToken
	rightBracket := aSmaCCToken!

tokenVariables
	^#(#leftBracket #rightBracket)! !
!JSArrayLiteralNode categoriesFor: #acceptVisitor:!generated!public! !
!JSArrayLiteralNode categoriesFor: #commas!generated!public! !
!JSArrayLiteralNode categoriesFor: #commas:!generated!public! !
!JSArrayLiteralNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSArrayLiteralNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSArrayLiteralNode categoriesFor: #expressions!generated!public! !
!JSArrayLiteralNode categoriesFor: #expressions:!generated!public! !
!JSArrayLiteralNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSArrayLiteralNode categoriesFor: #leftBracket!generated!public! !
!JSArrayLiteralNode categoriesFor: #leftBracket:!generated!public! !
!JSArrayLiteralNode categoriesFor: #rightBracket!generated!public! !
!JSArrayLiteralNode categoriesFor: #rightBracket:!generated!public! !
!JSArrayLiteralNode categoriesFor: #tokenVariables!generated!public! !

JSAssignmentExpressionNode guid: (GUID fromString: '{11853024-3870-4DA1-B161-D77E0128E2A2}')!
JSAssignmentExpressionNode comment: ''!
!JSAssignmentExpressionNode categoriesForClass!Unclassified! !
!JSAssignmentExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitAssignmentExpression: self!

lhs
	^lhs!

lhs: aJSExpressionNode
	self lhs notNil ifTrue: [self lhs parent: nil].
	lhs := aJSExpressionNode.
	self lhs notNil ifTrue: [self lhs parent: self]!

nodeVariables
	^#(#lhs #rhs)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

rhs
	^rhs!

rhs: aJSExpressionNode
	self rhs notNil ifTrue: [self rhs parent: nil].
	rhs := aJSExpressionNode.
	self rhs notNil ifTrue: [self rhs parent: self]!

tokenVariables
	^#(#operator)! !
!JSAssignmentExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #lhs!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #lhs:!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #operator!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #operator:!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #rhs!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #rhs:!generated!public! !
!JSAssignmentExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSBinaryExpressionNode guid: (GUID fromString: '{53A3D7C0-8699-48EE-B804-98E829D61100}')!
JSBinaryExpressionNode comment: ''!
!JSBinaryExpressionNode categoriesForClass!Unclassified! !
!JSBinaryExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBinaryExpression: self!

leftExpression
	^leftExpression!

leftExpression: aJSExpressionNode
	self leftExpression notNil ifTrue: [self leftExpression parent: nil].
	leftExpression := aJSExpressionNode.
	self leftExpression notNil ifTrue: [self leftExpression parent: self]!

nodeVariables
	^#(#leftExpression #rightExpression)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

rightExpression
	^rightExpression!

rightExpression: aJSExpressionNode
	self rightExpression notNil ifTrue: [self rightExpression parent: nil].
	rightExpression := aJSExpressionNode.
	self rightExpression notNil ifTrue: [self rightExpression parent: self]!

tokenVariables
	^#(#operator)! !
!JSBinaryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSBinaryExpressionNode categoriesFor: #leftExpression!generated!public! !
!JSBinaryExpressionNode categoriesFor: #leftExpression:!generated!public! !
!JSBinaryExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSBinaryExpressionNode categoriesFor: #operator!generated!public! !
!JSBinaryExpressionNode categoriesFor: #operator:!generated!public! !
!JSBinaryExpressionNode categoriesFor: #rightExpression!generated!public! !
!JSBinaryExpressionNode categoriesFor: #rightExpression:!generated!public! !
!JSBinaryExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSCallExpressionNode guid: (GUID fromString: '{FCEBCD84-36A3-4C37-8A4E-1A22A262D0E3}')!
JSCallExpressionNode comment: ''!
!JSCallExpressionNode categoriesForClass!Unclassified! !
!JSCallExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCallExpression: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

compositeTokenVariables
	^#(#commas #leftParens #rightParens)!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

nodeVariables
	^#(#expression)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#left #right)! !
!JSCallExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSCallExpressionNode categoriesFor: #arguments!generated!public! !
!JSCallExpressionNode categoriesFor: #arguments:!generated!public! !
!JSCallExpressionNode categoriesFor: #commas!generated!public! !
!JSCallExpressionNode categoriesFor: #commas:!generated!public! !
!JSCallExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSCallExpressionNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSCallExpressionNode categoriesFor: #expression!generated!public! !
!JSCallExpressionNode categoriesFor: #expression:!generated!public! !
!JSCallExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSCallExpressionNode categoriesFor: #left!generated!public! !
!JSCallExpressionNode categoriesFor: #left:!generated!public! !
!JSCallExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSCallExpressionNode categoriesFor: #right!generated!public! !
!JSCallExpressionNode categoriesFor: #right:!generated!public! !
!JSCallExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSCommaExpressionNode guid: (GUID fromString: '{3E1F448C-C157-4849-A806-DB84FCE36ADB}')!
JSCommaExpressionNode comment: ''!
!JSCommaExpressionNode categoriesForClass!Unclassified! !
!JSCommaExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitCommaExpression: self!

comma
	^comma!

comma: aSmaCCToken
	comma := aSmaCCToken!

compositeNodeVariables
	^#(#expressions)!

expressions
	^expressions!

expressions: anOrderedCollection
	self setParents: self expressions to: nil.
	expressions := anOrderedCollection.
	self setParents: self expressions to: self!

initialize
	super initialize.
	expressions := OrderedCollection new: 2.!

tokenVariables
	^#(#comma)! !
!JSCommaExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSCommaExpressionNode categoriesFor: #comma!generated!public! !
!JSCommaExpressionNode categoriesFor: #comma:!generated!public! !
!JSCommaExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSCommaExpressionNode categoriesFor: #expressions!generated!public! !
!JSCommaExpressionNode categoriesFor: #expressions:!generated!public! !
!JSCommaExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSCommaExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSConditionalExpressionNode guid: (GUID fromString: '{BF8A65D3-DBFC-47FD-AB17-224FE2084077}')!
JSConditionalExpressionNode comment: ''!
!JSConditionalExpressionNode categoriesForClass!Unclassified! !
!JSConditionalExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitConditionalExpression: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

condition
	^condition!

condition: aJSExpressionNode
	self condition notNil ifTrue: [self condition parent: nil].
	condition := aJSExpressionNode.
	self condition notNil ifTrue: [self condition parent: self]!

falseExpression
	^falseExpression!

falseExpression: aJSExpressionNode
	self falseExpression notNil ifTrue: [self falseExpression parent: nil].
	falseExpression := aJSExpressionNode.
	self falseExpression notNil ifTrue: [self falseExpression parent: self]!

nodeVariables
	^#(#condition #trueExpression #falseExpression)!

questionMarkToken
	^questionMarkToken!

questionMarkToken: aSmaCCToken
	questionMarkToken := aSmaCCToken!

tokenVariables
	^#(#questionMarkToken #colonToken)!

trueExpression
	^trueExpression!

trueExpression: aJSExpressionNode
	self trueExpression notNil ifTrue: [self trueExpression parent: nil].
	trueExpression := aJSExpressionNode.
	self trueExpression notNil ifTrue: [self trueExpression parent: self]! !
!JSConditionalExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSConditionalExpressionNode categoriesFor: #colonToken!generated!public! !
!JSConditionalExpressionNode categoriesFor: #colonToken:!generated!public! !
!JSConditionalExpressionNode categoriesFor: #condition!generated!public! !
!JSConditionalExpressionNode categoriesFor: #condition:!generated!public! !
!JSConditionalExpressionNode categoriesFor: #falseExpression!generated!public! !
!JSConditionalExpressionNode categoriesFor: #falseExpression:!generated!public! !
!JSConditionalExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSConditionalExpressionNode categoriesFor: #questionMarkToken!generated!public! !
!JSConditionalExpressionNode categoriesFor: #questionMarkToken:!generated!public! !
!JSConditionalExpressionNode categoriesFor: #tokenVariables!generated!public! !
!JSConditionalExpressionNode categoriesFor: #trueExpression!generated!public! !
!JSConditionalExpressionNode categoriesFor: #trueExpression:!generated!public! !

JSFunctionNode guid: (GUID fromString: '{746A76EB-E0E8-4C6B-BA0E-C09871FA729D}')!
JSFunctionNode comment: ''!
!JSFunctionNode categoriesForClass!Unclassified! !
!JSFunctionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitFunction: self!

arguments
	^arguments!

arguments: anOrderedCollection
	arguments := anOrderedCollection!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#statements)!

compositeTokenVariables
	^#(#arguments #commas #leftParens #rightParens)!

functionToken
	^functionToken!

functionToken: aSmaCCToken
	functionToken := aSmaCCToken!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.
	statements := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#functionToken #name #leftBrace #rightBrace)! !
!JSFunctionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSFunctionNode categoriesFor: #arguments!generated!public! !
!JSFunctionNode categoriesFor: #arguments:!generated!public! !
!JSFunctionNode categoriesFor: #commas!generated!public! !
!JSFunctionNode categoriesFor: #commas:!generated!public! !
!JSFunctionNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSFunctionNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSFunctionNode categoriesFor: #functionToken!generated!public! !
!JSFunctionNode categoriesFor: #functionToken:!generated!public! !
!JSFunctionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSFunctionNode categoriesFor: #leftBrace!generated!public! !
!JSFunctionNode categoriesFor: #leftBrace:!generated!public! !
!JSFunctionNode categoriesFor: #name!generated!public! !
!JSFunctionNode categoriesFor: #name:!generated!public! !
!JSFunctionNode categoriesFor: #rightBrace!generated!public! !
!JSFunctionNode categoriesFor: #rightBrace:!generated!public! !
!JSFunctionNode categoriesFor: #statements!generated!public! !
!JSFunctionNode categoriesFor: #statements:!generated!public! !
!JSFunctionNode categoriesFor: #tokenVariables!generated!public! !

JSIndexedPropertyExpressionNode guid: (GUID fromString: '{92C6D0B3-9D30-470C-9E0E-63989C996EFA}')!
JSIndexedPropertyExpressionNode comment: ''!
!JSIndexedPropertyExpressionNode categoriesForClass!Unclassified! !
!JSIndexedPropertyExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIndexedPropertyExpression: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

fieldExpression
	^fieldExpression!

fieldExpression: aJSExpressionNode
	self fieldExpression notNil ifTrue: [self fieldExpression parent: nil].
	fieldExpression := aJSExpressionNode.
	self fieldExpression notNil ifTrue: [self fieldExpression parent: self]!

leftBracket
	^leftBracket!

leftBracket: aSmaCCToken
	leftBracket := aSmaCCToken!

nodeVariables
	^#(#expression #fieldExpression)!

rightBracket
	^rightBracket!

rightBracket: aSmaCCToken
	rightBracket := aSmaCCToken!

tokenVariables
	^#(#leftBracket #rightBracket)! !
!JSIndexedPropertyExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #expression!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #expression:!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #fieldExpression!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #fieldExpression:!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #leftBracket!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #leftBracket:!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #rightBracket!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #rightBracket:!generated!public! !
!JSIndexedPropertyExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSLiteralNode guid: (GUID fromString: '{1524C11A-F3D6-4510-B4E2-F986246B8F71}')!
JSLiteralNode comment: ''!
!JSLiteralNode categoriesForClass!Unclassified! !
!JSLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLiteral: self!

tokenVariables
	^#(#value)!

value
	^value!

value: aSmaCCToken
	value := aSmaCCToken! !
!JSLiteralNode categoriesFor: #acceptVisitor:!generated!public! !
!JSLiteralNode categoriesFor: #tokenVariables!generated!public! !
!JSLiteralNode categoriesFor: #value!generated!public! !
!JSLiteralNode categoriesFor: #value:!generated!public! !

JSNamedPropertyExpressionNode guid: (GUID fromString: '{E81E2118-5C68-4791-BC41-DDA8A9CD8B57}')!
JSNamedPropertyExpressionNode comment: ''!
!JSNamedPropertyExpressionNode categoriesForClass!Unclassified! !
!JSNamedPropertyExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNamedPropertyExpression: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

nodeVariables
	^#(#expression)!

periodToken
	^periodToken!

periodToken: aSmaCCToken
	periodToken := aSmaCCToken!

tokenVariables
	^#(#periodToken #name)! !
!JSNamedPropertyExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #expression!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #expression:!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #name!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #name:!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #periodToken!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #periodToken:!generated!public! !
!JSNamedPropertyExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSNameExpressionNode guid: (GUID fromString: '{F51F77B9-0EE2-4367-8100-FE95832B4719}')!
JSNameExpressionNode comment: ''!
!JSNameExpressionNode categoriesForClass!Unclassified! !
!JSNameExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNameExpression: self!

name
	^name!

name: aSmaCCToken
	name := aSmaCCToken!

tokenVariables
	^#(#name)! !
!JSNameExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSNameExpressionNode categoriesFor: #name!generated!public! !
!JSNameExpressionNode categoriesFor: #name:!generated!public! !
!JSNameExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSNewExpressionNode guid: (GUID fromString: '{881F4B86-C05A-4EF6-8708-4C4133918E89}')!
JSNewExpressionNode comment: ''!
!JSNewExpressionNode categoriesForClass!Unclassified! !
!JSNewExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNewExpression: self!

arguments
	^arguments!

arguments: anOrderedCollection
	self setParents: self arguments to: nil.
	arguments := anOrderedCollection.
	self setParents: self arguments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#arguments)!

compositeTokenVariables
	^#(#commas #leftParens #rightParens)!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

initialize
	super initialize.
	arguments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

left
	^left!

left: aSmaCCToken
	left := aSmaCCToken!

newToken
	^newToken!

newToken: aSmaCCToken
	newToken := aSmaCCToken!

nodeVariables
	^#(#expression)!

right
	^right!

right: aSmaCCToken
	right := aSmaCCToken!

tokenVariables
	^#(#newToken #left #right)! !
!JSNewExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSNewExpressionNode categoriesFor: #arguments!generated!public! !
!JSNewExpressionNode categoriesFor: #arguments:!generated!public! !
!JSNewExpressionNode categoriesFor: #commas!generated!public! !
!JSNewExpressionNode categoriesFor: #commas:!generated!public! !
!JSNewExpressionNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSNewExpressionNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSNewExpressionNode categoriesFor: #expression!generated!public! !
!JSNewExpressionNode categoriesFor: #expression:!generated!public! !
!JSNewExpressionNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSNewExpressionNode categoriesFor: #left!generated!public! !
!JSNewExpressionNode categoriesFor: #left:!generated!public! !
!JSNewExpressionNode categoriesFor: #newToken!generated!public! !
!JSNewExpressionNode categoriesFor: #newToken:!generated!public! !
!JSNewExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSNewExpressionNode categoriesFor: #right!generated!public! !
!JSNewExpressionNode categoriesFor: #right:!generated!public! !
!JSNewExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSObjectLiteralNode guid: (GUID fromString: '{32BB4A8D-1856-48BD-9C40-D34E6EB4C33B}')!
JSObjectLiteralNode comment: ''!
!JSObjectLiteralNode categoriesForClass!Unclassified! !
!JSObjectLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitObjectLiteral: self!

assignments
	^assignments!

assignments: anOrderedCollection
	self setParents: self assignments to: nil.
	assignments := anOrderedCollection.
	self setParents: self assignments to: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#assignments)!

compositeTokenVariables
	^#(#commas #leftParens #rightParens)!

initialize
	super initialize.
	assignments := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

tokenVariables
	^#(#leftBrace #rightBrace)! !
!JSObjectLiteralNode categoriesFor: #acceptVisitor:!generated!public! !
!JSObjectLiteralNode categoriesFor: #assignments!generated!public! !
!JSObjectLiteralNode categoriesFor: #assignments:!generated!public! !
!JSObjectLiteralNode categoriesFor: #commas!generated!public! !
!JSObjectLiteralNode categoriesFor: #commas:!generated!public! !
!JSObjectLiteralNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSObjectLiteralNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSObjectLiteralNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSObjectLiteralNode categoriesFor: #leftBrace!generated!public! !
!JSObjectLiteralNode categoriesFor: #leftBrace:!generated!public! !
!JSObjectLiteralNode categoriesFor: #rightBrace!generated!public! !
!JSObjectLiteralNode categoriesFor: #rightBrace:!generated!public! !
!JSObjectLiteralNode categoriesFor: #tokenVariables!generated!public! !

JSPostfixExpressionNode guid: (GUID fromString: '{97BBABD2-7CA1-4A9E-9E89-F0FFCBE81C02}')!
JSPostfixExpressionNode comment: ''!
!JSPostfixExpressionNode categoriesForClass!Unclassified! !
!JSPostfixExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitPostfixExpression: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

tokenVariables
	^#(#operator)! !
!JSPostfixExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSPostfixExpressionNode categoriesFor: #expression!generated!public! !
!JSPostfixExpressionNode categoriesFor: #expression:!generated!public! !
!JSPostfixExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSPostfixExpressionNode categoriesFor: #operator!generated!public! !
!JSPostfixExpressionNode categoriesFor: #operator:!generated!public! !
!JSPostfixExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSThisExpressionNode guid: (GUID fromString: '{35FE068C-86DD-4B04-9136-5CED047D7D1A}')!
JSThisExpressionNode comment: ''!
!JSThisExpressionNode categoriesForClass!Unclassified! !
!JSThisExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThisExpression: self!

thisToken
	^thisToken!

thisToken: aSmaCCToken
	thisToken := aSmaCCToken!

tokenVariables
	^#(#thisToken)! !
!JSThisExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSThisExpressionNode categoriesFor: #thisToken!generated!public! !
!JSThisExpressionNode categoriesFor: #thisToken:!generated!public! !
!JSThisExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSUnaryExpressionNode guid: (GUID fromString: '{CF2AF013-474E-4515-B72D-B97DFD6D36D5}')!
JSUnaryExpressionNode comment: ''!
!JSUnaryExpressionNode categoriesForClass!Unclassified! !
!JSUnaryExpressionNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitUnaryExpression: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

operator
	^operator!

operator: aSmaCCToken
	operator := aSmaCCToken!

tokenVariables
	^#(#operator)! !
!JSUnaryExpressionNode categoriesFor: #acceptVisitor:!generated!public! !
!JSUnaryExpressionNode categoriesFor: #expression!generated!public! !
!JSUnaryExpressionNode categoriesFor: #expression:!generated!public! !
!JSUnaryExpressionNode categoriesFor: #nodeVariables!generated!public! !
!JSUnaryExpressionNode categoriesFor: #operator!generated!public! !
!JSUnaryExpressionNode categoriesFor: #operator:!generated!public! !
!JSUnaryExpressionNode categoriesFor: #tokenVariables!generated!public! !

JSBooleanLiteralNode guid: (GUID fromString: '{B803FCBC-A6FC-42F6-ADAE-6A3185142FAB}')!
JSBooleanLiteralNode comment: ''!
!JSBooleanLiteralNode categoriesForClass!Unclassified! !
!JSBooleanLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBooleanLiteral: self! !
!JSBooleanLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JSNullLiteralNode guid: (GUID fromString: '{72868BDB-09E5-426C-BABB-B7C6C0FE61A2}')!
JSNullLiteralNode comment: ''!
!JSNullLiteralNode categoriesForClass!Unclassified! !
!JSNullLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNullLiteral: self! !
!JSNullLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JSNumericLiteralNode guid: (GUID fromString: '{53C59676-EA69-4508-B6B8-E8A798D4E6F6}')!
JSNumericLiteralNode comment: ''!
!JSNumericLiteralNode categoriesForClass!Unclassified! !
!JSNumericLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitNumericLiteral: self! !
!JSNumericLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JSRegularExpressionLiteralNode guid: (GUID fromString: '{BE74A175-199C-421F-92CE-B7384031B35B}')!
JSRegularExpressionLiteralNode comment: ''!
!JSRegularExpressionLiteralNode categoriesForClass!Unclassified! !
!JSRegularExpressionLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitRegularExpressionLiteral: self! !
!JSRegularExpressionLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JSStringLiteralNode guid: (GUID fromString: '{B0E3F1B1-DF3F-4A95-875E-0EFE3C88D76B}')!
JSStringLiteralNode comment: ''!
!JSStringLiteralNode categoriesForClass!Unclassified! !
!JSStringLiteralNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitStringLiteral: self! !
!JSStringLiteralNode categoriesFor: #acceptVisitor:!generated!public! !

JSBlockStatementNode guid: (GUID fromString: '{20E80468-3ADD-4375-AE14-CE76C1B4F5BE}')!
JSBlockStatementNode comment: ''!
!JSBlockStatementNode categoriesForClass!Unclassified! !
!JSBlockStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBlockStatement: self!

compositeNodeVariables
	^#(#statements)!

initialize
	super initialize.
	statements := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

statements
	^statements!

statements: anOrderedCollection
	self setParents: self statements to: nil.
	statements := anOrderedCollection.
	self setParents: self statements to: self!

tokenVariables
	^#(#leftBrace #rightBrace)! !
!JSBlockStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSBlockStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSBlockStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSBlockStatementNode categoriesFor: #leftBrace!generated!public! !
!JSBlockStatementNode categoriesFor: #leftBrace:!generated!public! !
!JSBlockStatementNode categoriesFor: #rightBrace!generated!public! !
!JSBlockStatementNode categoriesFor: #rightBrace:!generated!public! !
!JSBlockStatementNode categoriesFor: #statements!generated!public! !
!JSBlockStatementNode categoriesFor: #statements:!generated!public! !
!JSBlockStatementNode categoriesFor: #tokenVariables!generated!public! !

JSBreakStatementNode guid: (GUID fromString: '{75EFC974-F8B6-4DF9-B775-5C89F56A555F}')!
JSBreakStatementNode comment: ''!
!JSBreakStatementNode categoriesForClass!Unclassified! !
!JSBreakStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitBreakStatement: self!

breakToken
	^breakToken!

breakToken: aSmaCCToken
	breakToken := aSmaCCToken!

label
	^label!

label: aSmaCCToken
	label := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#breakToken #label #semicolon)! !
!JSBreakStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSBreakStatementNode categoriesFor: #breakToken!generated!public! !
!JSBreakStatementNode categoriesFor: #breakToken:!generated!public! !
!JSBreakStatementNode categoriesFor: #label!generated!public! !
!JSBreakStatementNode categoriesFor: #label:!generated!public! !
!JSBreakStatementNode categoriesFor: #semicolon!generated!public! !
!JSBreakStatementNode categoriesFor: #semicolon:!generated!public! !
!JSBreakStatementNode categoriesFor: #tokenVariables!generated!public! !

JSContinueStatementNode guid: (GUID fromString: '{F2DF895E-DE4B-434F-A766-C1C67C026502}')!
JSContinueStatementNode comment: ''!
!JSContinueStatementNode categoriesForClass!Unclassified! !
!JSContinueStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitContinueStatement: self!

continueToken
	^continueToken!

continueToken: aSmaCCToken
	continueToken := aSmaCCToken!

label
	^label!

label: aSmaCCToken
	label := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#continueToken #label #semicolon)! !
!JSContinueStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSContinueStatementNode categoriesFor: #continueToken!generated!public! !
!JSContinueStatementNode categoriesFor: #continueToken:!generated!public! !
!JSContinueStatementNode categoriesFor: #label!generated!public! !
!JSContinueStatementNode categoriesFor: #label:!generated!public! !
!JSContinueStatementNode categoriesFor: #semicolon!generated!public! !
!JSContinueStatementNode categoriesFor: #semicolon:!generated!public! !
!JSContinueStatementNode categoriesFor: #tokenVariables!generated!public! !

JSDebuggerStatementNode guid: (GUID fromString: '{69C1540C-A6E9-4552-9B1D-CB515B49D850}')!
JSDebuggerStatementNode comment: ''!
!JSDebuggerStatementNode categoriesForClass!Unclassified! !
!JSDebuggerStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDebuggerStatement: self!

debuggerToken
	^debuggerToken!

debuggerToken: aSmaCCToken
	debuggerToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#debuggerToken #semicolon)! !
!JSDebuggerStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSDebuggerStatementNode categoriesFor: #debuggerToken!generated!public! !
!JSDebuggerStatementNode categoriesFor: #debuggerToken:!generated!public! !
!JSDebuggerStatementNode categoriesFor: #semicolon!generated!public! !
!JSDebuggerStatementNode categoriesFor: #semicolon:!generated!public! !
!JSDebuggerStatementNode categoriesFor: #tokenVariables!generated!public! !

JSDoWhileStatementNode guid: (GUID fromString: '{BC5BB1CB-20A9-4558-9924-DB4CC7218FED}')!
JSDoWhileStatementNode comment: ''!
!JSDoWhileStatementNode categoriesForClass!Unclassified! !
!JSDoWhileStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitDoWhileStatement: self!

doToken
	^doToken!

doToken: aSmaCCToken
	doToken := aSmaCCToken!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#statement #expression)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#doToken #whileToken #leftParen #rightParen #semicolon)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!JSDoWhileStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #doToken!generated!public! !
!JSDoWhileStatementNode categoriesFor: #doToken:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #expression!generated!public! !
!JSDoWhileStatementNode categoriesFor: #expression:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #leftParen!generated!public! !
!JSDoWhileStatementNode categoriesFor: #leftParen:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSDoWhileStatementNode categoriesFor: #rightParen!generated!public! !
!JSDoWhileStatementNode categoriesFor: #rightParen:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #semicolon!generated!public! !
!JSDoWhileStatementNode categoriesFor: #semicolon:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #statement!generated!public! !
!JSDoWhileStatementNode categoriesFor: #statement:!generated!public! !
!JSDoWhileStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSDoWhileStatementNode categoriesFor: #whileToken!generated!public! !
!JSDoWhileStatementNode categoriesFor: #whileToken:!generated!public! !

JSEmptyStatementNode guid: (GUID fromString: '{395BCC3A-ABDE-4987-899E-30B8C0C8E66D}')!
JSEmptyStatementNode comment: ''!
!JSEmptyStatementNode categoriesForClass!Unclassified! !
!JSEmptyStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitEmptyStatement: self!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#semicolon)! !
!JSEmptyStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSEmptyStatementNode categoriesFor: #semicolon!generated!public! !
!JSEmptyStatementNode categoriesFor: #semicolon:!generated!public! !
!JSEmptyStatementNode categoriesFor: #tokenVariables!generated!public! !

JSExpressionStatementNode guid: (GUID fromString: '{FB1A7FD7-BE2B-4B95-9E75-5A11BC3C0096}')!
JSExpressionStatementNode comment: ''!
!JSExpressionStatementNode categoriesForClass!Unclassified! !
!JSExpressionStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitExpressionStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#semicolon)! !
!JSExpressionStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSExpressionStatementNode categoriesFor: #expression!generated!public! !
!JSExpressionStatementNode categoriesFor: #expression:!generated!public! !
!JSExpressionStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSExpressionStatementNode categoriesFor: #semicolon!generated!public! !
!JSExpressionStatementNode categoriesFor: #semicolon:!generated!public! !
!JSExpressionStatementNode categoriesFor: #tokenVariables!generated!public! !

JSForInStatementNode guid: (GUID fromString: '{A369A5B1-6BE7-48E4-AC72-AC3EE6AA2349}')!
JSForInStatementNode comment: ''!
!JSForInStatementNode categoriesForClass!Unclassified! !
!JSForInStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForInStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

forToken
	^forToken!

forToken: aSmaCCToken
	forToken := aSmaCCToken!

inToken
	^inToken!

inToken: aSmaCCToken
	inToken := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#variable #expression #statement)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#forToken #leftParen #inToken #rightParen #varToken)!

variable
	^variable!

variable: aJSProgramNode
	self variable notNil ifTrue: [self variable parent: nil].
	variable := aJSProgramNode.
	self variable notNil ifTrue: [self variable parent: self]!

varToken
	^varToken!

varToken: aSmaCCToken
	varToken := aSmaCCToken! !
!JSForInStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSForInStatementNode categoriesFor: #expression!generated!public! !
!JSForInStatementNode categoriesFor: #expression:!generated!public! !
!JSForInStatementNode categoriesFor: #forToken!generated!public! !
!JSForInStatementNode categoriesFor: #forToken:!generated!public! !
!JSForInStatementNode categoriesFor: #inToken!generated!public! !
!JSForInStatementNode categoriesFor: #inToken:!generated!public! !
!JSForInStatementNode categoriesFor: #leftParen!generated!public! !
!JSForInStatementNode categoriesFor: #leftParen:!generated!public! !
!JSForInStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSForInStatementNode categoriesFor: #rightParen!generated!public! !
!JSForInStatementNode categoriesFor: #rightParen:!generated!public! !
!JSForInStatementNode categoriesFor: #statement!generated!public! !
!JSForInStatementNode categoriesFor: #statement:!generated!public! !
!JSForInStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSForInStatementNode categoriesFor: #variable!generated!public! !
!JSForInStatementNode categoriesFor: #variable:!generated!public! !
!JSForInStatementNode categoriesFor: #varToken!generated!public! !
!JSForInStatementNode categoriesFor: #varToken:!generated!public! !

JSForStatementNode guid: (GUID fromString: '{BE7F937A-6AB3-4AE9-8AB4-3CC1F08A383D}')!
JSForStatementNode comment: ''!
!JSForStatementNode categoriesForClass!Unclassified! !
!JSForStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitForStatement: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#variables)!

compositeTokenVariables
	^#(#semicolons #commas)!

condition
	^condition!

condition: aJSExpressionNode
	self condition notNil ifTrue: [self condition parent: nil].
	condition := aJSExpressionNode.
	self condition notNil ifTrue: [self condition parent: self]!

forToken
	^forToken!

forToken: aSmaCCToken
	forToken := aSmaCCToken!

initialExpression
	^initialExpression!

initialExpression: aJSExpressionNode
	self initialExpression notNil ifTrue: [self initialExpression parent: nil].
	initialExpression := aJSExpressionNode.
	self initialExpression notNil ifTrue: [self initialExpression parent: self]!

initialize
	super initialize.
	semicolons := OrderedCollection new: 2.
	variables := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

iteratorExpression
	^iteratorExpression!

iteratorExpression: aJSExpressionNode
	self iteratorExpression notNil ifTrue: [self iteratorExpression parent: nil].
	iteratorExpression := aJSExpressionNode.
	self iteratorExpression notNil ifTrue: [self iteratorExpression parent: self]!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#initialExpression #condition #iteratorExpression #statement)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

semicolons
	^semicolons!

semicolons: anOrderedCollection
	semicolons := anOrderedCollection!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#forToken #leftParen #rightParen #varToken)!

variables
	^variables!

variables: anOrderedCollection
	self setParents: self variables to: nil.
	variables := anOrderedCollection.
	self setParents: self variables to: self!

varToken
	^varToken!

varToken: aSmaCCToken
	varToken := aSmaCCToken! !
!JSForStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSForStatementNode categoriesFor: #commas!generated!public! !
!JSForStatementNode categoriesFor: #commas:!generated!public! !
!JSForStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSForStatementNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSForStatementNode categoriesFor: #condition!generated!public! !
!JSForStatementNode categoriesFor: #condition:!generated!public! !
!JSForStatementNode categoriesFor: #forToken!generated!public! !
!JSForStatementNode categoriesFor: #forToken:!generated!public! !
!JSForStatementNode categoriesFor: #initialExpression!generated!public! !
!JSForStatementNode categoriesFor: #initialExpression:!generated!public! !
!JSForStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSForStatementNode categoriesFor: #iteratorExpression!generated!public! !
!JSForStatementNode categoriesFor: #iteratorExpression:!generated!public! !
!JSForStatementNode categoriesFor: #leftParen!generated!public! !
!JSForStatementNode categoriesFor: #leftParen:!generated!public! !
!JSForStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSForStatementNode categoriesFor: #rightParen!generated!public! !
!JSForStatementNode categoriesFor: #rightParen:!generated!public! !
!JSForStatementNode categoriesFor: #semicolons!generated!public! !
!JSForStatementNode categoriesFor: #semicolons:!generated!public! !
!JSForStatementNode categoriesFor: #statement!generated!public! !
!JSForStatementNode categoriesFor: #statement:!generated!public! !
!JSForStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSForStatementNode categoriesFor: #variables!generated!public! !
!JSForStatementNode categoriesFor: #variables:!generated!public! !
!JSForStatementNode categoriesFor: #varToken!generated!public! !
!JSForStatementNode categoriesFor: #varToken:!generated!public! !

JSIfStatementNode guid: (GUID fromString: '{880E298A-24D2-45D1-A345-CECDD3803CB3}')!
JSIfStatementNode comment: ''!
!JSIfStatementNode categoriesForClass!Unclassified! !
!JSIfStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitIfStatement: self!

elseStatement
	^elseStatement!

elseStatement: aJSStatementNode
	self elseStatement notNil ifTrue: [self elseStatement parent: nil].
	elseStatement := aJSStatementNode.
	self elseStatement notNil ifTrue: [self elseStatement parent: self]!

elseToken
	^elseToken!

elseToken: aSmaCCToken
	elseToken := aSmaCCToken!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

ifToken
	^ifToken!

ifToken: aSmaCCToken
	ifToken := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#expression #trueStatement #elseStatement)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

tokenVariables
	^#(#ifToken #leftParen #rightParen #elseToken)!

trueStatement
	^trueStatement!

trueStatement: aJSStatementNode
	self trueStatement notNil ifTrue: [self trueStatement parent: nil].
	trueStatement := aJSStatementNode.
	self trueStatement notNil ifTrue: [self trueStatement parent: self]! !
!JSIfStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSIfStatementNode categoriesFor: #elseStatement!generated!public! !
!JSIfStatementNode categoriesFor: #elseStatement:!generated!public! !
!JSIfStatementNode categoriesFor: #elseToken!generated!public! !
!JSIfStatementNode categoriesFor: #elseToken:!generated!public! !
!JSIfStatementNode categoriesFor: #expression!generated!public! !
!JSIfStatementNode categoriesFor: #expression:!generated!public! !
!JSIfStatementNode categoriesFor: #ifToken!generated!public! !
!JSIfStatementNode categoriesFor: #ifToken:!generated!public! !
!JSIfStatementNode categoriesFor: #leftParen!generated!public! !
!JSIfStatementNode categoriesFor: #leftParen:!generated!public! !
!JSIfStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSIfStatementNode categoriesFor: #rightParen!generated!public! !
!JSIfStatementNode categoriesFor: #rightParen:!generated!public! !
!JSIfStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSIfStatementNode categoriesFor: #trueStatement!generated!public! !
!JSIfStatementNode categoriesFor: #trueStatement:!generated!public! !

JSLabelledStatementNode guid: (GUID fromString: '{6F28B22E-A93A-4655-B4F1-2D588F833D6C}')!
JSLabelledStatementNode comment: ''!
!JSLabelledStatementNode categoriesForClass!Unclassified! !
!JSLabelledStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitLabelledStatement: self!

colonToken
	^colonToken!

colonToken: aSmaCCToken
	colonToken := aSmaCCToken!

label
	^label!

label: aSmaCCToken
	label := aSmaCCToken!

nodeVariables
	^#(#statement)!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#label #colonToken)! !
!JSLabelledStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSLabelledStatementNode categoriesFor: #colonToken!generated!public! !
!JSLabelledStatementNode categoriesFor: #colonToken:!generated!public! !
!JSLabelledStatementNode categoriesFor: #label!generated!public! !
!JSLabelledStatementNode categoriesFor: #label:!generated!public! !
!JSLabelledStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSLabelledStatementNode categoriesFor: #statement!generated!public! !
!JSLabelledStatementNode categoriesFor: #statement:!generated!public! !
!JSLabelledStatementNode categoriesFor: #tokenVariables!generated!public! !

JSReturnStatementNode guid: (GUID fromString: '{B400AEEB-8FA7-4086-8CC2-2AB5FA4966D3}')!
JSReturnStatementNode comment: ''!
!JSReturnStatementNode categoriesForClass!Unclassified! !
!JSReturnStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitReturnStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

returnToken
	^returnToken!

returnToken: aSmaCCToken
	returnToken := aSmaCCToken!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#returnToken #semicolon)! !
!JSReturnStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSReturnStatementNode categoriesFor: #expression!generated!public! !
!JSReturnStatementNode categoriesFor: #expression:!generated!public! !
!JSReturnStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSReturnStatementNode categoriesFor: #returnToken!generated!public! !
!JSReturnStatementNode categoriesFor: #returnToken:!generated!public! !
!JSReturnStatementNode categoriesFor: #semicolon!generated!public! !
!JSReturnStatementNode categoriesFor: #semicolon:!generated!public! !
!JSReturnStatementNode categoriesFor: #tokenVariables!generated!public! !

JSSwitchStatementNode guid: (GUID fromString: '{3560F42E-310E-43F9-80AA-6345D9B9E402}')!
JSSwitchStatementNode comment: ''!
!JSSwitchStatementNode categoriesForClass!Unclassified! !
!JSSwitchStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitSwitchStatement: self!

clauses
	^clauses!

clauses: anOrderedCollection
	self setParents: self clauses to: nil.
	clauses := anOrderedCollection.
	self setParents: self clauses to: self!

compositeNodeVariables
	^#(#clauses)!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

initialize
	super initialize.
	clauses := OrderedCollection new: 2.!

leftBrace
	^leftBrace!

leftBrace: aSmaCCToken
	leftBrace := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#expression)!

rightBrace
	^rightBrace!

rightBrace: aSmaCCToken
	rightBrace := aSmaCCToken!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

switchToken
	^switchToken!

switchToken: aSmaCCToken
	switchToken := aSmaCCToken!

tokenVariables
	^#(#switchToken #leftParen #rightParen #leftBrace #rightBrace)! !
!JSSwitchStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSSwitchStatementNode categoriesFor: #clauses!generated!public! !
!JSSwitchStatementNode categoriesFor: #clauses:!generated!public! !
!JSSwitchStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSSwitchStatementNode categoriesFor: #expression!generated!public! !
!JSSwitchStatementNode categoriesFor: #expression:!generated!public! !
!JSSwitchStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSSwitchStatementNode categoriesFor: #leftBrace!generated!public! !
!JSSwitchStatementNode categoriesFor: #leftBrace:!generated!public! !
!JSSwitchStatementNode categoriesFor: #leftParen!generated!public! !
!JSSwitchStatementNode categoriesFor: #leftParen:!generated!public! !
!JSSwitchStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSSwitchStatementNode categoriesFor: #rightBrace!generated!public! !
!JSSwitchStatementNode categoriesFor: #rightBrace:!generated!public! !
!JSSwitchStatementNode categoriesFor: #rightParen!generated!public! !
!JSSwitchStatementNode categoriesFor: #rightParen:!generated!public! !
!JSSwitchStatementNode categoriesFor: #switchToken!generated!public! !
!JSSwitchStatementNode categoriesFor: #switchToken:!generated!public! !
!JSSwitchStatementNode categoriesFor: #tokenVariables!generated!public! !

JSThrowStatementNode guid: (GUID fromString: '{9428BC33-8E1B-4DE1-8DF5-B41579EC0359}')!
JSThrowStatementNode comment: ''!
!JSThrowStatementNode categoriesForClass!Unclassified! !
!JSThrowStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitThrowStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

nodeVariables
	^#(#expression)!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

throwToken
	^throwToken!

throwToken: aSmaCCToken
	throwToken := aSmaCCToken!

tokenVariables
	^#(#throwToken #semicolon)! !
!JSThrowStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSThrowStatementNode categoriesFor: #expression!generated!public! !
!JSThrowStatementNode categoriesFor: #expression:!generated!public! !
!JSThrowStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSThrowStatementNode categoriesFor: #semicolon!generated!public! !
!JSThrowStatementNode categoriesFor: #semicolon:!generated!public! !
!JSThrowStatementNode categoriesFor: #throwToken!generated!public! !
!JSThrowStatementNode categoriesFor: #throwToken:!generated!public! !
!JSThrowStatementNode categoriesFor: #tokenVariables!generated!public! !

JSTryStatementNode guid: (GUID fromString: '{68918F80-759A-4863-BD23-F93052831076}')!
JSTryStatementNode comment: ''!
!JSTryStatementNode categoriesForClass!Unclassified! !
!JSTryStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitTryStatement: self!

catchBlock
	^catchBlock!

catchBlock: aJSBlockStatementNode
	self catchBlock notNil ifTrue: [self catchBlock parent: nil].
	catchBlock := aJSBlockStatementNode.
	self catchBlock notNil ifTrue: [self catchBlock parent: self]!

catchToken
	^catchToken!

catchToken: aSmaCCToken
	catchToken := aSmaCCToken!

exceptionType
	^exceptionType!

exceptionType: aSmaCCToken
	exceptionType := aSmaCCToken!

finallyBlock
	^finallyBlock!

finallyBlock: aJSBlockStatementNode
	self finallyBlock notNil ifTrue: [self finallyBlock parent: nil].
	finallyBlock := aJSBlockStatementNode.
	self finallyBlock notNil ifTrue: [self finallyBlock parent: self]!

finallyToken
	^finallyToken!

finallyToken: aSmaCCToken
	finallyToken := aSmaCCToken!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#tryBlock #catchBlock #finallyBlock)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

tokenVariables
	^#(#tryToken #catchToken #leftParen #exceptionType #rightParen #finallyToken)!

tryBlock
	^tryBlock!

tryBlock: aJSBlockStatementNode
	self tryBlock notNil ifTrue: [self tryBlock parent: nil].
	tryBlock := aJSBlockStatementNode.
	self tryBlock notNil ifTrue: [self tryBlock parent: self]!

tryToken
	^tryToken!

tryToken: aSmaCCToken
	tryToken := aSmaCCToken! !
!JSTryStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSTryStatementNode categoriesFor: #catchBlock!generated!public! !
!JSTryStatementNode categoriesFor: #catchBlock:!generated!public! !
!JSTryStatementNode categoriesFor: #catchToken!generated!public! !
!JSTryStatementNode categoriesFor: #catchToken:!generated!public! !
!JSTryStatementNode categoriesFor: #exceptionType!generated!public! !
!JSTryStatementNode categoriesFor: #exceptionType:!generated!public! !
!JSTryStatementNode categoriesFor: #finallyBlock!generated!public! !
!JSTryStatementNode categoriesFor: #finallyBlock:!generated!public! !
!JSTryStatementNode categoriesFor: #finallyToken!generated!public! !
!JSTryStatementNode categoriesFor: #finallyToken:!generated!public! !
!JSTryStatementNode categoriesFor: #leftParen!generated!public! !
!JSTryStatementNode categoriesFor: #leftParen:!generated!public! !
!JSTryStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSTryStatementNode categoriesFor: #rightParen!generated!public! !
!JSTryStatementNode categoriesFor: #rightParen:!generated!public! !
!JSTryStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSTryStatementNode categoriesFor: #tryBlock!generated!public! !
!JSTryStatementNode categoriesFor: #tryBlock:!generated!public! !
!JSTryStatementNode categoriesFor: #tryToken!generated!public! !
!JSTryStatementNode categoriesFor: #tryToken:!generated!public! !

JSVariableStatementNode guid: (GUID fromString: '{27CE93BC-2816-4DF0-B6AF-56AB81BC3E92}')!
JSVariableStatementNode comment: ''!
!JSVariableStatementNode categoriesForClass!Unclassified! !
!JSVariableStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitVariableStatement: self!

commas
	^commas!

commas: anOrderedCollection
	commas := anOrderedCollection!

compositeNodeVariables
	^#(#variables)!

compositeTokenVariables
	^#(#commas)!

initialize
	super initialize.
	variables := OrderedCollection new: 2.
	commas := OrderedCollection new: 2.!

semicolon
	^semicolon!

semicolon: aSmaCCToken
	semicolon := aSmaCCToken!

tokenVariables
	^#(#varToken #semicolon)!

variables
	^variables!

variables: anOrderedCollection
	self setParents: self variables to: nil.
	variables := anOrderedCollection.
	self setParents: self variables to: self!

varToken
	^varToken!

varToken: aSmaCCToken
	varToken := aSmaCCToken! !
!JSVariableStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSVariableStatementNode categoriesFor: #commas!generated!public! !
!JSVariableStatementNode categoriesFor: #commas:!generated!public! !
!JSVariableStatementNode categoriesFor: #compositeNodeVariables!generated!public! !
!JSVariableStatementNode categoriesFor: #compositeTokenVariables!generated!public! !
!JSVariableStatementNode categoriesFor: #initialize!generated-initialize-release!public! !
!JSVariableStatementNode categoriesFor: #semicolon!generated!public! !
!JSVariableStatementNode categoriesFor: #semicolon:!generated!public! !
!JSVariableStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSVariableStatementNode categoriesFor: #variables!generated!public! !
!JSVariableStatementNode categoriesFor: #variables:!generated!public! !
!JSVariableStatementNode categoriesFor: #varToken!generated!public! !
!JSVariableStatementNode categoriesFor: #varToken:!generated!public! !

JSWhileStatementNode guid: (GUID fromString: '{46684392-8BAE-4BCD-92EC-F9FDED27EFB4}')!
JSWhileStatementNode comment: ''!
!JSWhileStatementNode categoriesForClass!Unclassified! !
!JSWhileStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitWhileStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#whileToken #leftParen #rightParen)!

whileToken
	^whileToken!

whileToken: aSmaCCToken
	whileToken := aSmaCCToken! !
!JSWhileStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSWhileStatementNode categoriesFor: #expression!generated!public! !
!JSWhileStatementNode categoriesFor: #expression:!generated!public! !
!JSWhileStatementNode categoriesFor: #leftParen!generated!public! !
!JSWhileStatementNode categoriesFor: #leftParen:!generated!public! !
!JSWhileStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSWhileStatementNode categoriesFor: #rightParen!generated!public! !
!JSWhileStatementNode categoriesFor: #rightParen:!generated!public! !
!JSWhileStatementNode categoriesFor: #statement!generated!public! !
!JSWhileStatementNode categoriesFor: #statement:!generated!public! !
!JSWhileStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSWhileStatementNode categoriesFor: #whileToken!generated!public! !
!JSWhileStatementNode categoriesFor: #whileToken:!generated!public! !

JSWithStatementNode guid: (GUID fromString: '{7018D32C-DB06-4407-BA0C-0263FDE8F249}')!
JSWithStatementNode comment: ''!
!JSWithStatementNode categoriesForClass!Unclassified! !
!JSWithStatementNode methodsFor!

acceptVisitor: aProgramVisitor
	^aProgramVisitor visitWithStatement: self!

expression
	^expression!

expression: aJSExpressionNode
	self expression notNil ifTrue: [self expression parent: nil].
	expression := aJSExpressionNode.
	self expression notNil ifTrue: [self expression parent: self]!

leftParen
	^leftParen!

leftParen: aSmaCCToken
	leftParen := aSmaCCToken!

nodeVariables
	^#(#expression #statement)!

rightParen
	^rightParen!

rightParen: aSmaCCToken
	rightParen := aSmaCCToken!

statement
	^statement!

statement: aJSStatementNode
	self statement notNil ifTrue: [self statement parent: nil].
	statement := aJSStatementNode.
	self statement notNil ifTrue: [self statement parent: self]!

tokenVariables
	^#(#withToken #leftParen #rightParen)!

withToken
	^withToken!

withToken: aSmaCCToken
	withToken := aSmaCCToken! !
!JSWithStatementNode categoriesFor: #acceptVisitor:!generated!public! !
!JSWithStatementNode categoriesFor: #expression!generated!public! !
!JSWithStatementNode categoriesFor: #expression:!generated!public! !
!JSWithStatementNode categoriesFor: #leftParen!generated!public! !
!JSWithStatementNode categoriesFor: #leftParen:!generated!public! !
!JSWithStatementNode categoriesFor: #nodeVariables!generated!public! !
!JSWithStatementNode categoriesFor: #rightParen!generated!public! !
!JSWithStatementNode categoriesFor: #rightParen:!generated!public! !
!JSWithStatementNode categoriesFor: #statement!generated!public! !
!JSWithStatementNode categoriesFor: #statement:!generated!public! !
!JSWithStatementNode categoriesFor: #tokenVariables!generated!public! !
!JSWithStatementNode categoriesFor: #withToken!generated!public! !
!JSWithStatementNode categoriesFor: #withToken:!generated!public! !

JSProgramNodeVisitor guid: (GUID fromString: '{0B39C238-6319-45A2-A4F7-5574AD978AC0}')!
JSProgramNodeVisitor comment: ''!
!JSProgramNodeVisitor categoriesForClass!Unclassified! !
!JSProgramNodeVisitor methodsFor!

visitArrayLiteral: anArrayLiteral
	^self visitExpression: anArrayLiteral!

visitAssignmentExpression: anAssignmentExpression
	^self visitExpression: anAssignmentExpression!

visitBinaryExpression: aBinaryExpression
	^self visitExpression: aBinaryExpression!

visitBlockStatement: aBlockStatement
	^self visitStatement: aBlockStatement!

visitBooleanLiteral: aBooleanLiteral
	^self visitLiteral: aBooleanLiteral!

visitBreakStatement: aBreakStatement
	^self visitStatement: aBreakStatement!

visitCallExpression: aCallExpression
	^self visitExpression: aCallExpression!

visitCaseClause: aCaseClause
	^self visitProgram: aCaseClause!

visitCommaExpression: aCommaExpression
	^self visitExpression: aCommaExpression!

visitConditionalExpression: aConditionalExpression
	^self visitExpression: aConditionalExpression!

visitContinueStatement: aContinueStatement
	^self visitStatement: aContinueStatement!

visitDebuggerStatement: aDebuggerStatement
	^self visitStatement: aDebuggerStatement!

visitDefaultClause: aDefaultClause
	^self visitProgram: aDefaultClause!

visitDoWhileStatement: aDoWhileStatement
	^self visitStatement: aDoWhileStatement!

visitEmptyStatement: anEmptyStatement
	^self visitStatement: anEmptyStatement!

visitExpression: anExpression
	^self visitProgram: anExpression!

visitExpressionStatement: anExpressionStatement
	^self visitStatement: anExpressionStatement!

visitFile: aFile
	^self visitProgram: aFile!

visitForInStatement: aForInStatement
	^self visitStatement: aForInStatement!

visitForStatement: aForStatement
	^self visitStatement: aForStatement!

visitFunction: aFunction
	^self visitExpression: aFunction!

visitGetPropertyAssignment: aGetPropertyAssignment
	^self visitProgram: aGetPropertyAssignment!

visitIfStatement: anIfStatement
	^self visitStatement: anIfStatement!

visitIndexedPropertyExpression: anIndexedPropertyExpression
	^self visitExpression: anIndexedPropertyExpression!

visitLabelledStatement: aLabelledStatement
	^self visitStatement: aLabelledStatement!

visitLiteral: aLiteral
	^self visitExpression: aLiteral!

visitNamedPropertyExpression: aNamedPropertyExpression
	^self visitExpression: aNamedPropertyExpression!

visitNameExpression: aNameExpression
	^self visitExpression: aNameExpression!

visitNewExpression: aNewExpression
	^self visitExpression: aNewExpression!

visitNullLiteral: aNullLiteral
	^self visitLiteral: aNullLiteral!

visitNumericLiteral: aNumericLiteral
	^self visitLiteral: aNumericLiteral!

visitObjectLiteral: anObjectLiteral
	^self visitExpression: anObjectLiteral!

visitPostfixExpression: aPostfixExpression
	^self visitExpression: aPostfixExpression!

visitProgram: aProgram
	^self visitSmaCCParseNode: aProgram!

visitPropertyAssignment: aPropertyAssignment
	^self visitProgram: aPropertyAssignment!

visitRegularExpressionLiteral: aRegularExpressionLiteral
	^self visitLiteral: aRegularExpressionLiteral!

visitReturnStatement: aReturnStatement
	^self visitStatement: aReturnStatement!

visitSetPropertyAssignment: aSetPropertyAssignment
	^self visitProgram: aSetPropertyAssignment!

visitStatement: aStatement
	^self visitProgram: aStatement!

visitStringLiteral: aStringLiteral
	^self visitLiteral: aStringLiteral!

visitSwitchStatement: aSwitchStatement
	^self visitStatement: aSwitchStatement!

visitThisExpression: aThisExpression
	^self visitExpression: aThisExpression!

visitThrowStatement: aThrowStatement
	^self visitStatement: aThrowStatement!

visitTryStatement: aTryStatement
	^self visitStatement: aTryStatement!

visitUnaryExpression: anUnaryExpression
	^self visitExpression: anUnaryExpression!

visitVariableDeclaration: aVariableDeclaration
	^self visitProgram: aVariableDeclaration!

visitVariableStatement: aVariableStatement
	^self visitStatement: aVariableStatement!

visitWhileStatement: aWhileStatement
	^self visitStatement: aWhileStatement!

visitWithStatement: aWithStatement
	^self visitStatement: aWithStatement! !
!JSProgramNodeVisitor categoriesFor: #visitArrayLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitAssignmentExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitBinaryExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitBlockStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitBooleanLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitBreakStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitCallExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitCaseClause:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitCommaExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitConditionalExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitContinueStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitDebuggerStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitDefaultClause:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitDoWhileStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitEmptyStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitExpressionStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitFile:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitForInStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitForStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitFunction:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitGetPropertyAssignment:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitIfStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitIndexedPropertyExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitLabelledStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitNamedPropertyExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitNameExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitNewExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitNullLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitNumericLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitObjectLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitPostfixExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitProgram:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitPropertyAssignment:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitRegularExpressionLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitReturnStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitSetPropertyAssignment:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitStringLiteral:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitSwitchStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitThisExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitThrowStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitTryStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitUnaryExpression:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitVariableDeclaration:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitVariableStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitWhileStatement:!generated!public! !
!JSProgramNodeVisitor categoriesFor: #visitWithStatement:!generated!public! !

JSParser guid: (GUID fromString: '{8AEB3223-1333-401E-A8FF-897048781DA2}')!
JSParser comment: ''!
!JSParser categoriesForClass!Unclassified! !
!JSParser methodsFor!

actionsForCurrentToken
	| actions |
	actions := super actionsForCurrentToken.
	(currentToken ids first ~= scanner identifierId
		and: [(currentToken ids includes: scanner identifierId) and: [(self keywords includes: currentToken value) not]])
		ifTrue: [self addActionsFor: scanner identifierId to: actions].
	(currentToken ids first == scanner regular_expressionId and: [actions isEmpty])
		ifTrue:
			[(currentToken value at: 2) == $=
				ifTrue:
					[currentToken := scanner tokenClass
						value: '/='
						start: currentToken startPosition
						ids: (Array with: scanner slashEqualId).
					self position: currentToken startPosition + 1]
				ifFalse:
					[currentToken := scanner tokenClass
						value: '/'
						start: currentToken startPosition
						ids: (Array with: scanner slashId).
					self position: currentToken startPosition].
			^self actionsForCurrentToken].
	(actions isEmpty and: [lastInsertedSemicolonPosition < scanner position])
		ifTrue:
			[self addActionsFor: self scanner semicolonId to: actions.
			lastInsertedSemicolonPosition := scanner position.
			actions notEmpty
				ifTrue:
					[self position: currentToken startPosition - 1.
					currentToken := currentToken class
						value: ';'
						start: nil
						ids: (Array with: self scanner semicolonId)]].
	^actions!

ambiguousTransitions
^#(
#[ 0 18 1 173] 
#[ 0 194 2 65]
	).!

handleError: anInteger
	(currentToken value = ';' and: [currentToken startPosition isNil])
		ifTrue:
			[currentToken := nil.
			self getNextToken].
	^super handleError: anInteger!

initialize
	super initialize.
	lastInsertedSemicolonPosition := -1!

keywords
	^##(#(#break #do #instanceof #typeof #case #else #var #catch #finally #return #void #continue #for #switch #while #debugger #function #this #with #default #if #throw #delete #in #try)
			asSet collect: [:each | each asString])!

reduceActionForArguments1: nodes
	| result |
	result := Array new: 4.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^result!

reduceActionForArguments2: nodes
	| result |
	result := Array new: 4.
	result at: 3 put: (OrderedCollection new: 2).
	result at: 4 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: ((nodes at: 2) at: 1) to: (result at: 3).
	self addAll: ((nodes at: 2) at: 2) to: (result at: 4).
	result at: 2 put: (nodes at: 3).
	^result!

reduceActionForArrayLiteral1: nodes
	| result |
	result := JSArrayLiteralNode new.
	result leftBracket: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result expressions.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result rightBracket: (nodes at: 3).
	^result!

reduceActionForAssignmentExpression2: nodes
	| result |
	result := JSAssignmentExpressionNode new.
	result lhs: (nodes at: 1).
	result operator: (nodes at: 2).
	result rhs: (nodes at: 3).
	^result!

reduceActionForBlock1: nodes
	| result |
	result := JSBlockStatementNode new.
	result leftBrace: (nodes at: 1).
	result addNodes: (nodes at: 2) to: result statements.
	result rightBrace: (nodes at: 3).
	^result!

reduceActionForBooleanLiteral2: nodes
	^nodes at: 1!

reduceActionForBreakStatement1: nodes
	| result |
	result := JSBreakStatementNode new.
	result breakToken: (nodes at: 1).
	result label: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForCallExpression1: nodes
	| result |
	result := JSCallExpressionNode new.
	result expression: (nodes at: 1).
	result left: ((nodes at: 2) at: 1).
	result right: ((nodes at: 2) at: 2).
	result addNodes: ((nodes at: 2) at: 3) to: result arguments.
	result addTokens: ((nodes at: 2) at: 4) to: result commas.
	^result!

reduceActionForCaseBlock1: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	result at: 3 put: (nodes at: 3).
	^result!

reduceActionForCaseBlock2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (OrderedCollection new: 2).
	result at: 1 put: (nodes at: 1).
	self addAll: (nodes at: 2) to: (result at: 2).
	self add: (nodes at: 3) to: (result at: 2).
	self addAll: (nodes at: 4) to: (result at: 2).
	result at: 3 put: (nodes at: 5).
	^result!

reduceActionForCaseClause1: nodes
	| result |
	result := JSCaseClauseNode new.
	result caseToken: (nodes at: 1).
	result caseExpression: (nodes at: 2).
	result colonToken: (nodes at: 3).
	result addNodes: (nodes at: 4) to: result statements.
	^result!

reduceActionForCatch1: nodes
	| result |
	result := Array new: 5.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	result at: 3 put: (nodes at: 3).
	result at: 4 put: (nodes at: 4).
	result at: 5 put: (nodes at: 5).
	^result!

reduceActionForConditionalExpression2: nodes
	| result |
	result := JSConditionalExpressionNode new.
	result condition: (nodes at: 1).
	result questionMarkToken: (nodes at: 2).
	result trueExpression: (nodes at: 3).
	result colonToken: (nodes at: 4).
	result falseExpression: (nodes at: 5).
	^result!

reduceActionForContinueStatement1: nodes
	| result |
	result := JSContinueStatementNode new.
	result continueToken: (nodes at: 1).
	result label: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForDebuggerStatement1: nodes
	| result |
	result := JSDebuggerStatementNode new.
	result debuggerToken: (nodes at: 1).
	result semicolon: (nodes at: 2).
	^result!

reduceActionForDefaultClause1: nodes
	| result |
	result := JSDefaultClauseNode new.
	result defaultToken: (nodes at: 1).
	result colonToken: (nodes at: 2).
	result addNodes: (nodes at: 3) to: result statements.
	^result!

reduceActionForElementList1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self add: (nodes at: 1) to: (result at: 1).
	^result!

reduceActionForElementList2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	self add: (nodes at: 2) to: (result at: 2).
	self add: (nodes at: 3) to: (result at: 1).
	^result!

reduceActionForEmptyStatement1: nodes
	| result |
	result := JSEmptyStatementNode new.
	result semicolon: (nodes at: 1).
	^result!

reduceActionForExpression2: nodes
	| result |
	result := JSCommaExpressionNode new.
	result addNode: (nodes at: 1) to: result expressions.
	result comma: (nodes at: 2).
	result addNode: (nodes at: 3) to: result expressions.
	^result!

reduceActionForExpressionStatement1: nodes
	| result |
	result := JSExpressionStatementNode new.
	result expression: (nodes at: 1).
	result semicolon: (nodes at: 2).
	^result!

reduceActionForFinally1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^result!

reduceActionForFormalParameterListopt1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	^result!

reduceActionForFormalParameterListopt2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	self addAll: ((nodes at: 1) at: 1) to: (result at: 1).
	self addAll: ((nodes at: 1) at: 2) to: (result at: 2).
	^result!

reduceActionForFunctionExpression1: nodes
	| result |
	result := JSFunctionNode new.
	result functionToken: (nodes at: 1).
	result name: (nodes at: 2).
	result addToken: (nodes at: 3) to: result leftParens.
	result addTokens: ((nodes at: 4) at: 1) to: result arguments.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: (nodes at: 5) to: result rightParens.
	result leftBrace: (nodes at: 6).
	result addNodes: (nodes at: 7) to: result statements.
	result rightBrace: (nodes at: 8).
	^result!

reduceActionForIfStatement1: nodes
	| result |
	result := JSIfStatementNode new.
	result ifToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result trueStatement: (nodes at: 5).
	result elseToken: (nodes at: 6).
	result elseStatement: (nodes at: 7).
	^result!

reduceActionForIfStatement2: nodes
	| result |
	result := JSIfStatementNode new.
	result ifToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result trueStatement: (nodes at: 5).
	^result!

reduceActionForInitialiseropt1: nodes
	| result |
	result := Array new: 2.
	^result!

reduceActionForInitialiseropt2: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: ((nodes at: 1) at: 1).
	result at: 2 put: ((nodes at: 1) at: 2).
	^result!

reduceActionForIterationStatement1: nodes
	| result |
	result := JSDoWhileStatementNode new.
	result doToken: (nodes at: 1).
	result statement: (nodes at: 2).
	result whileToken: (nodes at: 3).
	result leftParen: (nodes at: 4).
	result expression: (nodes at: 5).
	result rightParen: (nodes at: 6).
	result semicolon: (nodes at: 7).
	^result!

reduceActionForIterationStatement2: nodes
	| result |
	result := JSWhileStatementNode new.
	result whileToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceActionForIterationStatement3: nodes
	| result |
	result := JSForStatementNode new.
	result forToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result initialExpression: (nodes at: 3).
	result addToken: (nodes at: 4) to: result semicolons.
	result condition: (nodes at: 5).
	result addToken: (nodes at: 6) to: result semicolons.
	result iteratorExpression: (nodes at: 7).
	result rightParen: (nodes at: 8).
	result statement: (nodes at: 9).
	^result!

reduceActionForIterationStatement4: nodes
	| result |
	result := JSForStatementNode new.
	result forToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result varToken: (nodes at: 3).
	result addNodes: ((nodes at: 4) at: 1) to: result variables.
	result addTokens: ((nodes at: 4) at: 2) to: result commas.
	result addToken: (nodes at: 5) to: result semicolons.
	result condition: (nodes at: 6).
	result addToken: (nodes at: 7) to: result semicolons.
	result iteratorExpression: (nodes at: 8).
	result rightParen: (nodes at: 9).
	result statement: (nodes at: 10).
	^result!

reduceActionForIterationStatement5: nodes
	| result |
	result := JSForInStatementNode new.
	result forToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result variable: (nodes at: 3).
	result inToken: (nodes at: 4).
	result expression: (nodes at: 5).
	result rightParen: (nodes at: 6).
	result statement: (nodes at: 7).
	^result!

reduceActionForIterationStatement6: nodes
	| result |
	result := JSForInStatementNode new.
	result forToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result varToken: (nodes at: 3).
	result variable: (nodes at: 4).
	result inToken: (nodes at: 5).
	result expression: (nodes at: 6).
	result rightParen: (nodes at: 7).
	result statement: (nodes at: 8).
	^result!

reduceActionForLabelledStatement1: nodes
	| result |
	result := JSLabelledStatementNode new.
	result label: (nodes at: 1).
	result colonToken: (nodes at: 2).
	result statement: (nodes at: 3).
	^result!

reduceActionForLiteral1: nodes
	| result |
	result := JSNullLiteralNode new.
	result value: (nodes at: 1).
	^result!

reduceActionForLiteral2: nodes
	| result |
	result := JSBooleanLiteralNode new.
	result value: (nodes at: 1).
	^result!

reduceActionForLiteral3: nodes
	| result |
	result := JSNumericLiteralNode new.
	result value: (nodes at: 1).
	^result!

reduceActionForLiteral4: nodes
	| result |
	result := JSStringLiteralNode new.
	result value: (nodes at: 1).
	^result!

reduceActionForLiteral5: nodes
	| result |
	result := JSRegularExpressionLiteralNode new.
	result value: (nodes at: 1).
	^result!

reduceActionForMemberExpression3: nodes
	| result |
	result := JSIndexedPropertyExpressionNode new.
	result expression: (nodes at: 1).
	result leftBracket: (nodes at: 2).
	result fieldExpression: (nodes at: 3).
	result rightBracket: (nodes at: 4).
	^result!

reduceActionForMemberExpression4: nodes
	| result |
	result := JSNamedPropertyExpressionNode new.
	result expression: (nodes at: 1).
	result periodToken: (nodes at: 2).
	result name: (nodes at: 3).
	^result!

reduceActionForMemberExpression5: nodes
	| result |
	result := JSNewExpressionNode new.
	result newToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result left: ((nodes at: 3) at: 1).
	result right: ((nodes at: 3) at: 2).
	result addNodes: ((nodes at: 3) at: 3) to: result arguments.
	result addTokens: ((nodes at: 3) at: 4) to: result commas.
	^result!

reduceActionForMultiplicativeExpression4: nodes
	| result |
	result := JSBinaryExpressionNode new.
	result leftExpression: (nodes at: 1).
	result operator: (nodes at: 2).
	result rightExpression: (nodes at: 3).
	^result!

reduceActionForNewExpression2: nodes
	| result |
	result := JSNewExpressionNode new.
	result newToken: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForObjectLiteral1: nodes
	| result |
	result := JSObjectLiteralNode new.
	result leftBrace: (nodes at: 1).
	result rightBrace: (nodes at: 2).
	^result!

reduceActionForObjectLiteral2: nodes
	| result |
	result := JSObjectLiteralNode new.
	result leftBrace: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result assignments.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result rightBrace: (nodes at: 3).
	^result!

reduceActionForObjectLiteral3: nodes
	| result |
	result := JSObjectLiteralNode new.
	result leftBrace: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result assignments.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result addToken: (nodes at: 3) to: result commas.
	result rightBrace: (nodes at: 4).
	^result!

reduceActionForPostfixExpression2: nodes
	| result |
	result := JSPostfixExpressionNode new.
	result expression: (nodes at: 1).
	result operator: (nodes at: 2).
	^result!

reduceActionForPrimaryExpression1: nodes
	| result |
	result := JSThisExpressionNode new.
	result thisToken: (nodes at: 1).
	^result!

reduceActionForPrimaryExpression2: nodes
	| result |
	result := JSNameExpressionNode new.
	result name: (nodes at: 1).
	^result!

reduceActionForPrimaryExpression6: nodes
	| result |
	result := nodes at: 2.
	result addFirstToken: (nodes at: 1) to: result leftParens.
	result addToken: (nodes at: 3) to: result rightParens.
	^result!

reduceActionForProgram1: nodes
	| result |
	result := JSFileNode new.
	result addNodes: (nodes at: 1) to: result statements.
	^result!

reduceActionForPropertyAssignment1: nodes
	| result |
	result := JSPropertyAssignmentNode new.
	result key: (nodes at: 1).
	result colonToken: (nodes at: 2).
	result value: (nodes at: 3).
	^result!

reduceActionForPropertyAssignment2: nodes
	| result |
	result := JSGetPropertyAssignmentNode new.
	result getToken: (nodes at: 1).
	result key: (nodes at: 2).
	result leftParen: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result leftBrace: (nodes at: 5).
	result addNodes: (nodes at: 6) to: result statements.
	result rightBrace: (nodes at: 7).
	^result!

reduceActionForPropertyAssignment3: nodes
	| result |
	result := JSSetPropertyAssignmentNode new.
	result setToken: (nodes at: 1).
	result key: (nodes at: 2).
	result leftParen: (nodes at: 3).
	result variable: (nodes at: 4).
	result rightParen: (nodes at: 5).
	result leftBrace: (nodes at: 6).
	result addNodes: (nodes at: 7) to: result statements.
	result rightBrace: (nodes at: 8).
	^result!

reduceActionForReturnStatement1: nodes
	| result |
	result := JSReturnStatementNode new.
	result returnToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForSourceElements1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^result!

reduceActionForSourceElements2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	self add: (nodes at: 2) to: result.
	^result!

reduceActionForSourceElementsopt1: nodes
	| result |
	result := OrderedCollection new: 2.
	^result!

reduceActionForSourceElementsopt2: nodes
	| result |
	result := OrderedCollection new: 2.
	self addAll: (nodes at: 1) to: result.
	^result!

reduceActionForSwitchStatement1: nodes
	| result |
	result := JSSwitchStatementNode new.
	result switchToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result leftBrace: ((nodes at: 5) at: 1).
	result addNodes: ((nodes at: 5) at: 2) to: result clauses.
	result rightBrace: ((nodes at: 5) at: 3).
	^result!

reduceActionForThrowStatement1: nodes
	| result |
	result := JSThrowStatementNode new.
	result throwToken: (nodes at: 1).
	result expression: (nodes at: 2).
	result semicolon: (nodes at: 3).
	^result!

reduceActionForTryStatement1: nodes
	| result |
	result := JSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result tryBlock: (nodes at: 2).
	result catchToken: ((nodes at: 3) at: 1).
	result leftParen: ((nodes at: 3) at: 2).
	result exceptionType: ((nodes at: 3) at: 3).
	result rightParen: ((nodes at: 3) at: 4).
	result catchBlock: ((nodes at: 3) at: 5).
	^result!

reduceActionForTryStatement2: nodes
	| result |
	result := JSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result tryBlock: (nodes at: 2).
	result finallyToken: ((nodes at: 3) at: 1).
	result finallyBlock: ((nodes at: 3) at: 2).
	^result!

reduceActionForTryStatement3: nodes
	| result |
	result := JSTryStatementNode new.
	result tryToken: (nodes at: 1).
	result tryBlock: (nodes at: 2).
	result catchToken: ((nodes at: 3) at: 1).
	result leftParen: ((nodes at: 3) at: 2).
	result exceptionType: ((nodes at: 3) at: 3).
	result rightParen: ((nodes at: 3) at: 4).
	result catchBlock: ((nodes at: 3) at: 5).
	result finallyToken: ((nodes at: 4) at: 1).
	result finallyBlock: ((nodes at: 4) at: 2).
	^result!

reduceActionForUnaryExpression10: nodes
	| result |
	result := JSUnaryExpressionNode new.
	result operator: (nodes at: 1).
	result expression: (nodes at: 2).
	^result!

reduceActionForVariableDeclaration1: nodes
	| result |
	result := JSVariableDeclarationNode new.
	result variable: (nodes at: 1).
	result equalsToken: ((nodes at: 2) at: 1).
	result value: ((nodes at: 2) at: 2).
	^result!

reduceActionForVariableStatement1: nodes
	| result |
	result := JSVariableStatementNode new.
	result varToken: (nodes at: 1).
	result addNodes: ((nodes at: 2) at: 1) to: result variables.
	result addTokens: ((nodes at: 2) at: 2) to: result commas.
	result semicolon: (nodes at: 3).
	^result!

reduceActionForWithStatement1: nodes
	| result |
	result := JSWithStatementNode new.
	result withToken: (nodes at: 1).
	result leftParen: (nodes at: 2).
	result expression: (nodes at: 3).
	result rightParen: (nodes at: 4).
	result statement: (nodes at: 5).
	^result!

reduceTable
^#(
	#(170 0 #reduceActionForSourceElementsopt1:) 
	#(174 1 #reduceActionForBooleanLiteral2:) 
	#(92 0 #nil) 
	#(148 0 #reduceActionForSourceElementsopt1:) 
	#(90 1 #reduceActionForPrimaryExpression1:) 
	#(159 0 #nil) 
	#(160 0 #nil) 
	#(173 1 #reduceActionForBooleanLiteral2:) 
	#(135 1 #reduceActionForEmptyStatement1:) 
	#(90 1 #reduceActionForPrimaryExpression2:) 
	#(100 1 #reduceActionForBooleanLiteral2:) 
	#(101 1 #reduceActionForBooleanLiteral2:) 
	#(175 1 #reduceActionForBooleanLiteral2:) 
	#(180 1 #reduceActionForBooleanLiteral2:) 
	#(90 1 #reduceActionForBooleanLiteral2:) 
	#(103 1 #reduceActionForBooleanLiteral2:) 
	#(87 1 #reduceActionForBooleanLiteral2:) 
	#(182 1 #reduceActionForLiteral4:) 
	#(182 1 #reduceActionForLiteral3:) 
	#(105 1 #reduceActionForBooleanLiteral2:) 
	#(108 1 #reduceActionForBooleanLiteral2:) 
	#(109 1 #reduceActionForBooleanLiteral2:) 
	#(110 1 #reduceActionForBooleanLiteral2:) 
	#(111 1 #reduceActionForBooleanLiteral2:) 
	#(112 1 #reduceActionForBooleanLiteral2:) 
	#(113 1 #reduceActionForBooleanLiteral2:) 
	#(114 1 #reduceActionForBooleanLiteral2:) 
	#(116 1 #reduceActionForBooleanLiteral2:) 
	#(118 1 #reduceActionForBooleanLiteral2:) 
	#(120 1 #reduceActionForBooleanLiteral2:) 
	#(122 1 #reduceActionForBooleanLiteral2:) 
	#(124 1 #reduceActionForBooleanLiteral2:) 
	#(126 1 #reduceActionForBooleanLiteral2:) 
	#(128 1 #reduceActionForBooleanLiteral2:) 
	#(93 1 #reduceActionForBooleanLiteral2:) 
	#(177 1 #reduceActionForProgram1:) 
	#(172 1 #reduceActionForSourceElements1:) 
	#(170 1 #reduceActionForSourceElementsopt2:) 
	#(182 1 #reduceActionForLiteral1:) 
	#(182 1 #reduceActionForLiteral2:) 
	#(182 1 #reduceActionForLiteral5:) 
	#(176 1 #reduceActionForBooleanLiteral2:) 
	#(171 1 #reduceActionForBooleanLiteral2:) 
	#(110 2 #reduceActionForUnaryExpression10:) 
	#(181 1 #reduceActionForElementList1:) 
	#(92 1 #reduceActionForBooleanLiteral2:) 
	#(89 2 #reduceActionForObjectLiteral1:) 
	#(99 1 #reduceActionForBooleanLiteral2:) 
	#(94 1 #reduceActionForElementList1:) 
	#(96 1 #reduceActionForPrimaryExpression2:) 
	#(96 1 #reduceActionForBooleanLiteral2:) 
	#(148 1 #reduceActionForSourceElementsopt2:) 
	#(149 1 #reduceActionForSourceElements1:) 
	#(105 2 #reduceActionForNewExpression2:) 
	#(159 1 #reduceActionForBooleanLiteral2:) 
	#(160 1 #reduceActionForBooleanLiteral2:) 
	#(147 2 #reduceActionForDebuggerStatement1:) 
	#(158 0 #nil) 
	#(154 0 #reduceActionForInitialiseropt1:) 
	#(150 1 #reduceActionForElementList1:) 
	#(136 2 #reduceActionForExpressionStatement1:) 
	#(106 2 #reduceActionForCallExpression1:) 
	#(109 2 #reduceActionForPostfixExpression2:) 
	#(131 1 #reduceActionForBooleanLiteral2:) 
	#(172 2 #reduceActionForSourceElements2:) 
	#(134 3 #reduceActionForArrayLiteral1:) 
	#(90 3 #reduceActionForPrimaryExpression6:) 
	#(89 3 #reduceActionForObjectLiteral2:) 
	#(133 3 #reduceActionForBlock1:) 
	#(149 2 #reduceActionForSourceElements2:) 
	#(103 3 #reduceActionForMemberExpression5:) 
	#(141 3 #reduceActionForReturnStatement1:) 
	#(140 3 #reduceActionForBreakStatement1:) 
	#(139 3 #reduceActionForContinueStatement1:) 
	#(145 3 #reduceActionForThrowStatement1:) 
	#(168 0 #reduceActionForFormalParameterListopt1:) 
	#(146 3 #reduceActionForTryStatement1:) 
	#(146 3 #reduceActionForTryStatement2:) 
	#(115 1 #reduceActionForBooleanLiteral2:) 
	#(117 1 #reduceActionForBooleanLiteral2:) 
	#(119 1 #reduceActionForBooleanLiteral2:) 
	#(121 1 #reduceActionForBooleanLiteral2:) 
	#(123 1 #reduceActionForBooleanLiteral2:) 
	#(125 1 #reduceActionForBooleanLiteral2:) 
	#(127 1 #reduceActionForBooleanLiteral2:) 
	#(130 1 #reduceActionForBooleanLiteral2:) 
	#(132 1 #reduceActionForBooleanLiteral2:) 
	#(129 1 #reduceActionForBooleanLiteral2:) 
	#(158 1 #reduceActionForBooleanLiteral2:) 
	#(151 2 #reduceActionForVariableDeclaration1:) 
	#(154 1 #reduceActionForInitialiseropt2:) 
	#(88 3 #reduceActionForVariableStatement1:) 
	#(143 3 #reduceActionForLabelledStatement1:) 
	#(87 3 #reduceActionForExpression2:) 
	#(104 2 #reduceActionForArguments1:) 
	#(107 1 #reduceActionForElementList1:) 
	#(103 3 #reduceActionForMemberExpression4:) 
	#(106 3 #reduceActionForMemberExpression4:) 
	#(93 3 #reduceActionForAssignmentExpression2:) 
	#(111 3 #reduceActionForMultiplicativeExpression4:) 
	#(112 3 #reduceActionForMultiplicativeExpression4:) 
	#(113 3 #reduceActionForMultiplicativeExpression4:) 
	#(114 3 #reduceActionForMultiplicativeExpression4:) 
	#(116 3 #reduceActionForMultiplicativeExpression4:) 
	#(118 3 #reduceActionForMultiplicativeExpression4:) 
	#(120 3 #reduceActionForMultiplicativeExpression4:) 
	#(122 3 #reduceActionForMultiplicativeExpression4:) 
	#(124 3 #reduceActionForMultiplicativeExpression4:) 
	#(126 3 #reduceActionForMultiplicativeExpression4:) 
	#(181 3 #reduceActionForElementList2:) 
	#(89 4 #reduceActionForObjectLiteral3:) 
	#(94 3 #reduceActionForElementList2:) 
	#(95 3 #reduceActionForPropertyAssignment1:) 
	#(169 1 #reduceActionForElementList1:) 
	#(168 1 #reduceActionForFormalParameterListopt2:) 
	#(167 2 #reduceActionForFinally1:) 
	#(146 4 #reduceActionForTryStatement3:) 
	#(155 0 #reduceActionForInitialiseropt1:) 
	#(153 1 #reduceActionForElementList1:) 
	#(156 2 #reduceActionForFinally1:) 
	#(150 3 #reduceActionForElementList2:) 
	#(103 4 #reduceActionForMemberExpression3:) 
	#(104 3 #reduceActionForArguments2:) 
	#(106 4 #reduceActionForMemberExpression3:) 
	#(98 1 #reduceActionForBooleanLiteral2:) 
	#(162 0 #reduceActionForSourceElementsopt1:) 
	#(144 5 #reduceActionForSwitchStatement1:) 
	#(142 5 #reduceActionForWithStatement1:) 
	#(138 5 #reduceActionForIterationStatement2:) 
	#(152 2 #reduceActionForVariableDeclaration1:) 
	#(155 1 #reduceActionForInitialiseropt2:) 
	#(129 3 #reduceActionForAssignmentExpression2:) 
	#(115 3 #reduceActionForMultiplicativeExpression4:) 
	#(117 3 #reduceActionForMultiplicativeExpression4:) 
	#(119 3 #reduceActionForMultiplicativeExpression4:) 
	#(121 3 #reduceActionForMultiplicativeExpression4:) 
	#(123 3 #reduceActionForMultiplicativeExpression4:) 
	#(125 3 #reduceActionForMultiplicativeExpression4:) 
	#(127 3 #reduceActionForMultiplicativeExpression4:) 
	#(132 3 #reduceActionForExpression2:) 
	#(137 5 #reduceActionForIfStatement2:) 
	#(107 3 #reduceActionForElementList2:) 
	#(128 5 #reduceActionForConditionalExpression2:) 
	#(165 1 #reduceActionForSourceElements1:) 
	#(162 1 #reduceActionForSourceElementsopt2:) 
	#(169 3 #reduceActionForElementList2:) 
	#(157 2 #reduceActionForFinally1:) 
	#(153 3 #reduceActionForElementList2:) 
	#(97 1 #reduceActionForSourceElementsopt2:) 
	#(161 3 #reduceActionForCaseBlock1:) 
	#(165 2 #reduceActionForSourceElements2:) 
	#(138 7 #reduceActionForIterationStatement1:) 
	#(166 5 #reduceActionForCatch1:) 
	#(138 7 #reduceActionForIterationStatement5:) 
	#(130 5 #reduceActionForConditionalExpression2:) 
	#(137 7 #reduceActionForIfStatement1:) 
	#(95 7 #reduceActionForPropertyAssignment2:) 
	#(102 8 #reduceActionForFunctionExpression1:) 
	#(138 8 #reduceActionForIterationStatement6:) 
	#(95 8 #reduceActionForPropertyAssignment3:) 
	#(164 4 #reduceActionForCaseClause1:) 
	#(163 3 #reduceActionForDefaultClause1:) 
	#(161 5 #reduceActionForCaseBlock2:) 
	#(138 9 #reduceActionForIterationStatement3:) 
	#(138 10 #reduceActionForIterationStatement4:)
	).!

symbolTypes
	^#(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #JSExpressionNode #JSVariableStatementNode #JSObjectLiteralNode #JSExpressionNode #JSFileNode #JSExpressionNode #JSExpressionNode #OrderedCollection #JSProgramNode #Object #OrderedCollection #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #JSFunctionNode #JSExpressionNode #OrderedCollection #JSExpressionNode #JSExpressionNode #OrderedCollection #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #JSExpressionNode #SmaCCToken #JSExpressionNode #JSBlockStatementNode #JSArrayLiteralNode #JSEmptyStatementNode #JSExpressionStatementNode #JSIfStatementNode #JSStatementNode #JSContinueStatementNode #JSBreakStatementNode #JSReturnStatementNode #JSWithStatementNode #JSLabelledStatementNode #JSSwitchStatementNode #JSThrowStatementNode #JSTryStatementNode #JSDebuggerStatementNode #OrderedCollection #OrderedCollection #OrderedCollection #JSVariableDeclarationNode #JSVariableDeclarationNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JSExpressionNode #JSExpressionNode #SmaCCToken #OrderedCollection #OrderedCollection #JSDefaultClauseNode #JSCaseClauseNode #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #OrderedCollection #JSStatementNode #OrderedCollection #SmaCCToken #SmaCCToken #SmaCCToken #JSFileNode #JSFileNode #SmaCCToken #SmaCCToken #JSStatementNode #OrderedCollection #JSLiteralNode)!

transitionTable
^#(
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 93 0 176 1 97 0 177 0 6 0 178 1 101 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 117 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 1 121 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 69 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 125 0 177 0 6 0 178 1 101 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 133 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 137 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 141 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 145 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 0 10 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 149 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 153 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 14 0 21 0 53 0 22 1 109 0 24 0 14 0 25 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 1 157 0 92 1 161 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 165 0 181 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 169 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 7 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 1 177 0 36 1 181 0 37 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 1 185 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 1 189 0 94 1 193 0 95 1 197 0 96 1 201 0 99 1 205 0 100 1 209 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 213 0 148 1 217 0 149 1 81 0 173 1 85 0 174 1 89 0 175 1 221 0 180 1 105 0 182] 
#[0 0 22 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 225 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 229 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 1 233 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 37 0 10 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 1 237 0 103 1 241 0 105 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 0 10 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 1 245 0 22] 
#[0 1 249 0 22] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 0 26 0 77 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 253 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 2 1 0 159 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 30 0 77 2 5 0 81 2 9 0 160] 
#[1 0 30 0 77 2 5 0 81 2 13 0 160] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 2 17 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 2 21 0 180 1 105 0 182] 
#[1 0 30 0 22 2 5 0 81 2 25 0 160] 
#[0 0 34 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 2 29 0 77] 
#[0 2 33 0 22] 
#[1 2 37 0 24 2 41 0 133] 
#[0 2 45 0 22] 
#[1 2 49 0 81 2 53 0 150 2 57 0 151] 
#[0 2 61 0 22] 
#[0 0 38 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 42 0 1 0 42 0 2 0 42 0 3 0 42 0 6 0 42 0 7 0 42 0 8 0 42 0 11 0 42 0 12 0 42 0 13 0 42 0 14 0 42 0 15 0 42 0 16 0 42 0 17 0 42 0 19 0 42 0 20 0 42 0 22 0 42 0 25 0 42 0 30 0 42 0 31 0 42 0 32 0 42 0 34 0 42 0 35 2 65 0 38 0 42 0 45 0 42 0 58 0 42 0 60 0 42 0 61 0 42 0 62 0 42 0 63 0 42 0 64 0 42 0 65 0 42 0 66 0 42 0 67 0 42 0 69 0 42 0 70 0 42 0 71 0 42 0 72 0 42 0 73 0 42 0 74 0 42 0 75 0 42 0 76 0 42 0 77 0 42 0 78 0 42 0 79] 
#[0 0 46 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 50 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 54 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 2 69 0 25 2 73 0 77] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 62 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 66 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 70 0 21 0 23 0 25 0 38 0 77 0 178] 
#[0 0 74 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 78 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 66 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 82 0 1 0 82 0 2 0 82 0 3 0 82 0 6 0 82 0 7 0 82 0 8 0 82 0 11 0 82 0 12 0 82 0 13 0 82 0 14 0 82 0 15 0 82 0 16 0 82 0 17 0 82 0 19 2 77 0 20 0 82 0 21 2 81 0 22 0 82 0 23 0 82 0 25 0 82 0 28 0 82 0 30 0 82 0 31 2 85 0 32 0 82 0 34 0 82 0 35 0 82 0 38 0 82 0 45 0 82 0 58 0 82 0 60 0 82 0 61 0 82 0 62 0 82 0 63 0 82 0 64 0 82 0 65 0 82 0 66 0 82 0 67 0 82 0 69 0 82 0 70 0 82 0 71 0 82 0 72 0 82 0 73 0 82 0 74 0 82 0 75 0 82 0 76 0 82 0 77 0 82 0 78 0 82 0 79 2 89 0 104 0 82 0 178] 
#[0 0 86 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 30 0 31 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 86 0 1 0 86 0 2 0 86 0 3 0 86 0 6 0 86 0 7 0 86 0 8 0 86 0 11 0 86 0 12 0 86 0 13 0 86 0 14 0 86 0 15 0 86 0 16 0 86 0 17 0 86 0 19 2 93 0 20 0 86 0 21 2 81 0 22 0 86 0 23 0 86 0 25 0 86 0 28 0 86 0 30 0 86 0 31 2 97 0 32 0 86 0 34 0 86 0 35 0 86 0 38 0 86 0 45 0 86 0 58 0 86 0 60 0 86 0 61 0 86 0 62 0 86 0 63 0 86 0 64 0 86 0 65 0 86 0 66 0 86 0 67 0 86 0 69 0 86 0 70 0 86 0 71 0 86 0 72 0 86 0 73 0 86 0 74 0 86 0 75 0 86 0 76 0 86 0 77 0 86 0 78 0 86 0 79 2 101 0 104 0 86 0 178] 
#[1 0 90 0 1 0 90 0 2 0 90 0 3 0 90 0 6 0 90 0 7 0 90 0 8 0 90 0 11 0 90 0 12 0 90 0 13 0 90 0 14 0 90 0 15 0 90 0 16 0 90 0 17 0 90 0 19 0 90 0 21 0 90 0 23 0 90 0 25 0 90 0 28 2 105 0 30 2 109 0 31 0 90 0 34 0 90 0 35 0 90 0 38 0 90 0 45 0 90 0 58 2 113 0 60 0 90 0 61 0 90 0 62 2 117 0 63 2 121 0 64 0 90 0 65 0 90 0 66 0 90 0 67 2 125 0 69 2 129 0 70 2 133 0 71 2 137 0 72 2 141 0 73 2 145 0 74 2 149 0 75 2 153 0 76 0 90 0 77 0 90 0 78 2 157 0 79 2 161 0 131 0 90 0 178] 
#[0 0 94 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 98 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[1 0 102 0 1 2 165 0 2 2 169 0 3 0 102 0 6 0 102 0 7 0 102 0 8 0 102 0 11 0 102 0 12 0 102 0 13 0 102 0 14 0 102 0 15 0 102 0 16 0 102 0 17 0 102 0 19 0 102 0 21 0 102 0 23 0 102 0 25 0 102 0 28 0 102 0 34 0 102 0 35 0 102 0 38 0 102 0 45 0 102 0 58 0 102 0 61 0 102 0 62 0 102 0 65 0 102 0 66 0 102 0 67 0 102 0 77 2 173 0 78 0 102 0 178] 
#[1 0 106 0 1 2 177 0 6 0 106 0 7 0 106 0 8 0 106 0 11 0 106 0 12 0 106 0 13 0 106 0 14 2 181 0 15 0 106 0 16 0 106 0 17 0 106 0 19 0 106 0 21 0 106 0 23 0 106 0 25 0 106 0 28 0 106 0 34 0 106 0 35 0 106 0 38 0 106 0 45 0 106 0 58 0 106 0 61 0 106 0 62 0 106 0 65 0 106 0 66 0 106 0 67 0 106 0 77 0 106 0 178] 
#[1 2 185 0 1 0 110 0 7 2 189 0 8 0 110 0 11 0 110 0 12 0 110 0 13 2 193 0 14 0 110 0 16 0 110 0 17 0 110 0 19 0 110 0 21 0 110 0 23 0 110 0 25 0 110 0 28 0 110 0 34 0 110 0 35 0 110 0 38 0 110 0 45 0 110 0 58 0 110 0 61 0 110 0 62 0 110 0 65 0 110 0 66 0 110 0 67 0 110 0 77 0 110 0 178] 
#[1 2 197 0 7 0 114 0 11 2 201 0 12 2 205 0 13 2 209 0 16 2 213 0 17 0 114 0 19 0 114 0 21 0 114 0 23 0 114 0 25 0 114 0 28 2 217 0 34 0 114 0 35 0 114 0 38 0 114 0 45 0 114 0 58 0 114 0 61 0 114 0 62 0 114 0 65 0 114 0 66 0 114 0 67 0 114 0 77 0 114 0 178] 
#[1 2 221 0 11 2 225 0 19 0 118 0 21 0 118 0 23 0 118 0 25 0 118 0 28 2 229 0 35 0 118 0 38 0 118 0 45 2 233 0 58 0 118 0 61 0 118 0 62 0 118 0 65 0 118 0 66 0 118 0 67 0 118 0 77 0 118 0 178] 
#[1 0 122 0 21 0 122 0 23 0 122 0 25 0 122 0 28 0 122 0 38 2 237 0 45 0 122 0 61 0 122 0 62 0 122 0 65 0 122 0 66 0 122 0 67 0 122 0 77 0 122 0 178] 
#[1 0 126 0 21 0 126 0 23 0 126 0 25 0 126 0 28 0 126 0 38 0 126 0 61 0 126 0 62 2 241 0 65 0 126 0 66 0 126 0 67 0 126 0 77 0 126 0 178] 
#[1 0 130 0 21 0 130 0 23 0 130 0 25 0 130 0 28 0 130 0 38 0 130 0 61 0 130 0 62 2 245 0 66 0 130 0 67 0 130 0 77 0 130 0 178] 
#[1 0 134 0 21 0 134 0 23 0 134 0 25 0 134 0 28 0 134 0 38 2 249 0 61 0 134 0 62 0 134 0 67 0 134 0 77 0 134 0 178] 
#[1 0 138 0 21 0 138 0 23 0 138 0 25 0 138 0 28 0 138 0 38 2 253 0 62 3 1 0 67 0 138 0 77 0 138 0 178] 
#[0 0 142 0 21 0 23 0 25 0 28 0 38 0 77 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 62 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 146 0 178] 
#[0 0 150 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 48 0 49 0 50 0 52 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 154 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 3 5 0 171 1 81 0 173 1 85 0 174 1 89 0 175 0 154 0 178 1 101 0 180 1 105 0 182] 
#[0 0 158 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 162 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 166 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 0 0 178] 
#[0 0 170 0 178] 
#[0 0 174 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 48 0 49 0 50 0 52 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 62 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 1 173 0 28 1 177 0 36 1 181 0 37 3 9 0 81 0 153 0 83 0 157 0 84 1 189 0 94 1 193 0 95 1 197 0 96 1 201 0 99 3 13 0 100 3 17 0 101] 
#[0 0 42 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 2 69 0 25 0 0 0 178] 
#[0 0 0 0 178] 
#[0 0 0 0 178] 
#[1 0 90 0 1 0 90 0 2 0 90 0 3 0 90 0 6 0 90 0 7 0 90 0 8 0 90 0 11 0 90 0 12 0 90 0 13 0 90 0 14 0 90 0 15 0 90 0 16 0 90 0 17 0 90 0 19 0 90 0 21 0 90 0 23 0 90 0 25 0 90 0 28 2 105 0 30 2 109 0 31 0 90 0 34 0 90 0 35 0 90 0 38 0 90 0 45 0 90 0 58 0 90 0 61 0 90 0 62 0 90 0 65 0 90 0 66 0 90 0 67 0 90 0 77 0 90 0 78 0 90 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 182 0 21 0 25] 
#[0 0 186 0 21 0 25] 
#[1 3 21 0 21 3 25 0 25] 
#[1 3 29 0 23 2 69 0 25] 
#[0 0 190 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 3 9 0 81 0 153 0 83 0 157 0 84 3 33 0 96 1 201 0 99 3 13 0 100 3 17 0 101] 
#[1 3 9 0 81 0 153 0 83 0 157 0 84 3 37 0 96 1 201 0 99 3 13 0 100 3 17 0 101] 
#[1 0 42 0 1 0 42 0 2 0 42 0 3 0 42 0 6 0 42 0 7 0 42 0 8 0 42 0 11 0 42 0 12 0 42 0 13 0 42 0 14 0 42 0 15 0 42 0 16 0 42 0 17 0 42 0 19 0 42 0 20 0 42 0 22 0 42 0 25 0 42 0 30 0 42 0 31 0 42 0 32 0 42 0 34 0 42 0 35 0 11 0 38 0 42 0 45 0 42 0 58 0 42 0 60 0 42 0 61 0 42 0 62 0 42 0 63 0 42 0 64 0 42 0 65 0 42 0 66 0 42 0 67 0 42 0 69 0 42 0 70 0 42 0 71 0 42 0 72 0 42 0 73 0 42 0 74 0 42 0 75 0 42 0 76 0 42 0 77 0 42 0 78 0 42 0 79] 
#[1 3 41 0 25 3 45 0 28] 
#[0 0 198 0 25 0 28] 
#[0 3 49 0 38] 
#[0 0 202 0 22 0 38] 
#[1 0 74 0 1 0 74 0 2 0 74 0 3 0 74 0 6 0 74 0 7 0 74 0 8 0 74 0 11 0 74 0 12 0 74 0 13 0 74 0 14 0 74 0 15 0 74 0 16 0 74 0 17 0 74 0 19 0 74 0 20 0 74 0 22 0 74 0 25 0 74 0 30 0 74 0 31 0 74 0 32 0 74 0 34 0 74 0 35 0 206 0 38 0 74 0 45 0 74 0 58 0 74 0 60 0 74 0 61 0 74 0 62 0 74 0 63 0 74 0 64 0 74 0 65 0 74 0 66 0 74 0 67 0 74 0 69 0 74 0 70 0 74 0 71 0 74 0 72 0 74 0 73 0 74 0 74 0 74 0 75 0 74 0 76 0 74 0 77 0 74 0 78 0 74 0 79] 
#[1 0 78 0 1 0 78 0 2 0 78 0 3 0 78 0 6 0 78 0 7 0 78 0 8 0 78 0 11 0 78 0 12 0 78 0 13 0 78 0 14 0 78 0 15 0 78 0 16 0 78 0 17 0 78 0 19 0 78 0 20 0 78 0 22 0 78 0 25 0 78 0 30 0 78 0 31 0 78 0 32 0 78 0 34 0 78 0 35 0 206 0 38 0 78 0 45 0 78 0 58 0 78 0 60 0 78 0 61 0 78 0 62 0 78 0 63 0 78 0 64 0 78 0 65 0 78 0 66 0 78 0 67 0 78 0 69 0 78 0 70 0 78 0 71 0 78 0 72 0 78 0 73 0 78 0 74 0 78 0 75 0 78 0 76 0 78 0 77 0 78 0 78 0 78 0 79] 
#[0 3 53 0 28] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 210 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 210 0 47 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 210 0 53 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 3 57 0 180 1 105 0 182] 
#[0 0 214 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 178 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[1 0 82 0 1 0 82 0 2 0 82 0 3 0 82 0 6 0 82 0 7 0 82 0 8 0 82 0 11 0 82 0 12 0 82 0 13 0 82 0 14 0 82 0 15 0 82 0 16 0 82 0 17 0 82 0 19 2 77 0 20 0 82 0 21 2 81 0 22 0 82 0 23 0 82 0 25 0 82 0 28 0 82 0 30 0 82 0 31 2 85 0 32 0 82 0 34 0 82 0 35 0 82 0 38 0 82 0 45 0 82 0 58 0 82 0 60 0 82 0 61 0 82 0 62 0 82 0 63 0 82 0 64 0 82 0 65 0 82 0 66 0 82 0 67 0 82 0 69 0 82 0 70 0 82 0 71 0 82 0 72 0 82 0 73 0 82 0 74 0 82 0 75 0 82 0 76 0 82 0 77 0 82 0 78 0 82 0 79 3 61 0 104 0 82 0 178] 
#[0 0 218 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 30 0 31 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 65 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 69 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 222 0 23 2 69 0 25 0 222 0 77] 
#[0 3 73 0 77] 
#[0 0 226 0 22 0 77] 
#[0 3 77 0 77] 
#[0 3 81 0 77] 
#[1 2 69 0 25 3 85 0 77] 
#[0 3 89 0 54] 
#[0 3 93 0 22] 
#[0 0 230 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 97 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 18 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 213 0 148 1 217 0 149 1 81 0 173 1 85 0 174 1 89 0 175 1 221 0 180 1 105 0 182] 
#[1 3 101 0 51 3 105 0 56 3 109 0 166 3 113 0 167] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 3 117 0 59 0 234 0 77 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 3 121 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 3 157 0 129 3 161 0 130 3 165 0 132 1 13 0 134 3 169 0 158 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 238 0 25 3 173 0 60 0 238 0 77 3 177 0 154 3 181 0 156] 
#[1 3 185 0 25 3 189 0 77] 
#[0 0 242 0 25 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 193 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 3 197 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 3 201 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 0 246 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 205 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 3 209 0 23 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 3 213 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 3 217 0 107 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 3 9 0 81 3 221 0 99] 
#[0 0 250 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 3 225 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 3 9 0 81 3 229 0 99] 
#[0 0 250 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 254 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 0 254 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[0 1 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 29 0 30 0 31 0 33 0 39 0 49 0 50 0 81 0 83 0 84 0 85] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 3 233 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 3 237 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 3 241 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 3 245 0 110 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 3 249 0 111 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 3 253 0 111 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 4 1 0 112 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 4 5 0 112 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 4 9 0 112 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 13 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 17 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 21 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 25 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 29 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 4 33 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 4 37 0 114 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 4 41 0 114 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 4 45 0 114 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 4 49 0 114 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 4 53 0 116 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 4 57 0 118 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 4 61 0 120 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 4 65 0 122 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 4 69 0 124 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 4 73 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 6 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 48 0 49 0 50 0 52 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 0 194 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 0 206 0 22 0 38] 
#[0 0 206 0 22 0 38] 
#[0 1 10 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 14 0 21 0 53 0 22 1 109 0 24 0 14 0 25 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 4 77 0 92 1 161 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 14 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 4 81 0 22] 
#[0 4 85 0 22] 
#[1 4 89 0 28 1 177 0 36 1 181 0 37 3 9 0 81 0 153 0 83 0 157 0 84 4 93 0 95 1 197 0 96 1 201 0 99 3 13 0 100 3 17 0 101] 
#[0 1 18 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 4 97 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 22 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 56 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 1 26 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85] 
#[0 1 30 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 4 101 0 23 2 69 0 25] 
#[1 4 105 0 23 2 69 0 25] 
#[0 1 34 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 1 38 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 1 42 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 1 46 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 4 109 0 22] 
#[1 1 50 0 23 4 113 0 81 4 117 0 168 4 121 0 169] 
#[1 4 125 0 23 2 69 0 25] 
#[1 2 37 0 24 4 129 0 133] 
#[0 4 133 0 22] 
#[1 1 54 0 4 1 54 0 5 1 54 0 6 1 54 0 9 1 54 0 10 1 54 0 15 1 54 0 18 1 54 0 20 1 54 0 22 1 54 0 24 1 54 0 26 1 54 0 27 1 54 0 28 1 54 0 29 1 54 0 30 1 54 0 31 1 54 0 33 1 54 0 39 1 54 0 40 1 54 0 41 1 54 0 42 1 54 0 43 1 54 0 44 1 54 0 46 1 54 0 47 1 54 0 48 1 54 0 49 1 54 0 50 3 101 0 51 1 54 0 52 1 54 0 53 1 54 0 54 1 54 0 55 1 54 0 57 1 54 0 59 1 54 0 68 1 54 0 77 1 54 0 81 1 54 0 83 1 54 0 84 1 54 0 85 4 137 0 167 1 54 0 178] 
#[0 1 58 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 4 141 0 81 4 145 0 152 4 149 0 153] 
#[1 0 90 0 1 0 90 0 2 0 90 0 3 0 90 0 6 0 90 0 7 0 90 0 8 0 90 0 11 0 90 0 12 0 90 0 13 0 90 0 14 0 90 0 15 0 90 0 16 0 90 0 17 0 90 0 19 0 90 0 25 2 105 0 30 2 109 0 31 4 153 0 34 0 90 0 35 0 90 0 45 0 90 0 58 2 113 0 60 0 90 0 61 0 90 0 62 2 117 0 63 2 121 0 64 0 90 0 65 0 90 0 66 0 90 0 67 2 125 0 69 2 129 0 70 2 133 0 71 2 137 0 72 2 141 0 73 2 145 0 74 2 149 0 75 2 153 0 76 0 90 0 77 0 90 0 78 2 157 0 79 4 157 0 131] 
#[1 2 185 0 1 1 62 0 7 2 189 0 8 1 62 0 11 1 62 0 12 1 62 0 13 2 193 0 14 1 62 0 16 1 62 0 17 1 62 0 19 1 62 0 25 1 62 0 34 1 62 0 35 1 62 0 38 1 62 0 45 1 62 0 58 1 62 0 61 1 62 0 62 1 62 0 65 1 62 0 66 1 62 0 67 1 62 0 77] 
#[1 4 161 0 7 1 66 0 11 4 165 0 12 4 169 0 13 4 173 0 16 4 177 0 17 1 66 0 19 1 66 0 25 1 66 0 34 1 66 0 35 1 66 0 38 1 66 0 45 1 66 0 58 1 66 0 61 1 66 0 62 1 66 0 65 1 66 0 66 1 66 0 67 1 66 0 77] 
#[1 4 181 0 11 4 185 0 19 1 70 0 25 1 70 0 34 4 189 0 35 1 70 0 38 1 70 0 45 4 193 0 58 1 70 0 61 1 70 0 62 1 70 0 65 1 70 0 66 1 70 0 67 1 70 0 77] 
#[1 1 74 0 25 1 74 0 34 1 74 0 38 4 197 0 45 1 74 0 61 1 74 0 62 1 74 0 65 1 74 0 66 1 74 0 67 1 74 0 77] 
#[1 1 78 0 25 1 78 0 34 1 78 0 38 1 78 0 61 1 78 0 62 4 201 0 65 1 78 0 66 1 78 0 67 1 78 0 77] 
#[1 1 82 0 25 1 82 0 34 1 82 0 38 1 82 0 61 1 82 0 62 4 205 0 66 1 82 0 67 1 82 0 77] 
#[1 1 86 0 25 1 86 0 34 1 86 0 38 4 209 0 61 1 86 0 62 1 86 0 67 1 86 0 77] 
#[1 1 90 0 25 1 90 0 34 1 90 0 38 4 213 0 62 4 217 0 67 1 90 0 77] 
#[0 1 94 0 25 0 77] 
#[0 1 98 0 25 0 34 0 38 0 77] 
#[1 4 221 0 25 1 102 0 77] 
#[0 4 225 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 4 229 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 106 0 25 0 77] 
#[0 1 110 0 25 0 77] 
#[1 2 49 0 81 4 233 0 151] 
#[0 1 114 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 4 237 0 23 2 69 0 25] 
#[0 1 118 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 1 122 0 21 0 23 0 25 0 38 0 77 0 178] 
#[1 4 241 0 21 2 69 0 25] 
#[0 1 126 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 1 130 0 23 0 25] 
#[1 4 245 0 23 4 249 0 25] 
#[0 1 134 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 4 253 0 21 2 69 0 25] 
#[0 1 138 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 1 142 0 21 0 23 0 25 0 28 0 38 0 77 0 178] 
#[0 1 146 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 1 146 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[0 1 146 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 21 0 23 0 25 0 28 0 34 0 35 0 38 0 45 0 58 0 61 0 62 0 65 0 66 0 67 0 77 0 78 0 178] 
#[1 1 150 0 1 2 165 0 2 2 169 0 3 1 150 0 6 1 150 0 7 1 150 0 8 1 150 0 11 1 150 0 12 1 150 0 13 1 150 0 14 1 150 0 15 1 150 0 16 1 150 0 17 1 150 0 19 1 150 0 21 1 150 0 23 1 150 0 25 1 150 0 28 1 150 0 34 1 150 0 35 1 150 0 38 1 150 0 45 1 150 0 58 1 150 0 61 1 150 0 62 1 150 0 65 1 150 0 66 1 150 0 67 1 150 0 77 2 173 0 78 1 150 0 178] 
#[1 1 150 0 1 2 165 0 2 2 169 0 3 1 150 0 6 1 150 0 7 1 150 0 8 1 150 0 11 1 150 0 12 1 150 0 13 1 150 0 14 1 150 0 15 1 150 0 16 1 150 0 17 1 150 0 19 1 150 0 21 1 150 0 23 1 150 0 25 1 150 0 28 1 150 0 34 1 150 0 35 1 150 0 38 1 150 0 45 1 150 0 58 1 150 0 61 1 150 0 62 1 150 0 65 1 150 0 66 1 150 0 67 1 150 0 77 2 173 0 78 1 150 0 178] 
#[1 1 154 0 1 2 177 0 6 1 154 0 7 1 154 0 8 1 154 0 11 1 154 0 12 1 154 0 13 1 154 0 14 2 181 0 15 1 154 0 16 1 154 0 17 1 154 0 19 1 154 0 21 1 154 0 23 1 154 0 25 1 154 0 28 1 154 0 34 1 154 0 35 1 154 0 38 1 154 0 45 1 154 0 58 1 154 0 61 1 154 0 62 1 154 0 65 1 154 0 66 1 154 0 67 1 154 0 77 1 154 0 178] 
#[1 1 154 0 1 2 177 0 6 1 154 0 7 1 154 0 8 1 154 0 11 1 154 0 12 1 154 0 13 1 154 0 14 2 181 0 15 1 154 0 16 1 154 0 17 1 154 0 19 1 154 0 21 1 154 0 23 1 154 0 25 1 154 0 28 1 154 0 34 1 154 0 35 1 154 0 38 1 154 0 45 1 154 0 58 1 154 0 61 1 154 0 62 1 154 0 65 1 154 0 66 1 154 0 67 1 154 0 77 1 154 0 178] 
#[1 1 154 0 1 2 177 0 6 1 154 0 7 1 154 0 8 1 154 0 11 1 154 0 12 1 154 0 13 1 154 0 14 2 181 0 15 1 154 0 16 1 154 0 17 1 154 0 19 1 154 0 21 1 154 0 23 1 154 0 25 1 154 0 28 1 154 0 34 1 154 0 35 1 154 0 38 1 154 0 45 1 154 0 58 1 154 0 61 1 154 0 62 1 154 0 65 1 154 0 66 1 154 0 67 1 154 0 77 1 154 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 185 0 1 1 158 0 7 2 189 0 8 1 158 0 11 1 158 0 12 1 158 0 13 2 193 0 14 1 158 0 16 1 158 0 17 1 158 0 19 1 158 0 21 1 158 0 23 1 158 0 25 1 158 0 28 1 158 0 34 1 158 0 35 1 158 0 38 1 158 0 45 1 158 0 58 1 158 0 61 1 158 0 62 1 158 0 65 1 158 0 66 1 158 0 67 1 158 0 77 1 158 0 178] 
#[1 2 197 0 7 1 162 0 11 2 201 0 12 2 205 0 13 2 209 0 16 2 213 0 17 1 162 0 19 1 162 0 21 1 162 0 23 1 162 0 25 1 162 0 28 2 217 0 34 1 162 0 35 1 162 0 38 1 162 0 45 1 162 0 58 1 162 0 61 1 162 0 62 1 162 0 65 1 162 0 66 1 162 0 67 1 162 0 77 1 162 0 178] 
#[1 2 197 0 7 1 162 0 11 2 201 0 12 2 205 0 13 2 209 0 16 2 213 0 17 1 162 0 19 1 162 0 21 1 162 0 23 1 162 0 25 1 162 0 28 2 217 0 34 1 162 0 35 1 162 0 38 1 162 0 45 1 162 0 58 1 162 0 61 1 162 0 62 1 162 0 65 1 162 0 66 1 162 0 67 1 162 0 77 1 162 0 178] 
#[1 2 197 0 7 1 162 0 11 2 201 0 12 2 205 0 13 2 209 0 16 2 213 0 17 1 162 0 19 1 162 0 21 1 162 0 23 1 162 0 25 1 162 0 28 2 217 0 34 1 162 0 35 1 162 0 38 1 162 0 45 1 162 0 58 1 162 0 61 1 162 0 62 1 162 0 65 1 162 0 66 1 162 0 67 1 162 0 77 1 162 0 178] 
#[1 2 197 0 7 1 162 0 11 2 201 0 12 2 205 0 13 2 209 0 16 2 213 0 17 1 162 0 19 1 162 0 21 1 162 0 23 1 162 0 25 1 162 0 28 2 217 0 34 1 162 0 35 1 162 0 38 1 162 0 45 1 162 0 58 1 162 0 61 1 162 0 62 1 162 0 65 1 162 0 66 1 162 0 67 1 162 0 77 1 162 0 178] 
#[1 2 221 0 11 2 225 0 19 1 166 0 21 1 166 0 23 1 166 0 25 1 166 0 28 2 229 0 35 1 166 0 38 1 166 0 45 2 233 0 58 1 166 0 61 1 166 0 62 1 166 0 65 1 166 0 66 1 166 0 67 1 166 0 77 1 166 0 178] 
#[1 1 170 0 21 1 170 0 23 1 170 0 25 1 170 0 28 1 170 0 38 2 237 0 45 1 170 0 61 1 170 0 62 1 170 0 65 1 170 0 66 1 170 0 67 1 170 0 77 1 170 0 178] 
#[1 1 174 0 21 1 174 0 23 1 174 0 25 1 174 0 28 1 174 0 38 1 174 0 61 1 174 0 62 2 241 0 65 1 174 0 66 1 174 0 67 1 174 0 77 1 174 0 178] 
#[1 1 178 0 21 1 178 0 23 1 178 0 25 1 178 0 28 1 178 0 38 1 178 0 61 1 178 0 62 2 245 0 66 1 178 0 67 1 178 0 77 1 178 0 178] 
#[1 1 182 0 21 1 182 0 23 1 182 0 25 1 182 0 28 1 182 0 38 2 249 0 61 1 182 0 62 1 182 0 67 1 182 0 77 1 182 0 178] 
#[0 5 1 0 38] 
#[0 1 186 0 21 0 25] 
#[0 5 5 0 23] 
#[1 5 9 0 81 5 13 0 98] 
#[0 1 190 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 1 194 0 25 0 28] 
#[0 1 198 0 25 0 28] 
#[1 5 17 0 24 5 21 0 161] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 5 25 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 5 29 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 202 0 23 0 25] 
#[0 5 33 0 23] 
#[1 1 206 0 23 5 37 0 25] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 5 41 0 180 1 105 0 182] 
#[0 1 210 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 5 45 0 81] 
#[0 1 214 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 1 218 0 25 1 218 0 34 5 49 0 60 1 218 0 77 5 53 0 155 5 57 0 157] 
#[1 1 222 0 25 5 61 0 34 1 222 0 77] 
#[1 5 65 0 25 5 69 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 5 73 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 5 77 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 5 81 0 129 3 161 0 130 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 5 85 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 5 89 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 5 93 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 5 97 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 5 101 0 113 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 5 105 0 115 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 5 109 0 115 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 5 113 0 115 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 5 117 0 115 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 5 121 0 117 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 5 125 0 119 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 5 129 0 121 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 5 133 0 123 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 1 129 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 5 137 0 125 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 5 77 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 5 141 0 129 3 161 0 130 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 5 77 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 5 145 0 129 3 161 0 130 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 0 26 0 77 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 253 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 5 149 0 159 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 226 0 25 0 77] 
#[0 1 230 0 25 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 5 153 0 180 1 105 0 182] 
#[0 1 234 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 1 238 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 5 157 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 1 242 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 5 161 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 5 165 0 24] 
#[0 1 246 0 23] 
#[0 5 169 0 23] 
#[1 1 250 0 28 5 173 0 47 1 250 0 53 5 177 0 162 5 181 0 164 5 185 0 165] 
#[0 1 254 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 2 2 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 5 189 0 23 2 69 0 25] 
#[0 5 193 0 24] 
#[0 5 197 0 81] 
#[0 2 6 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 5 201 0 23] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 5 77 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 5 205 0 129 3 161 0 130 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 2 10 0 25 0 34 0 77] 
#[0 2 14 0 25 0 34 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 5 209 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 4 141 0 81 5 213 0 152] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 0 26 0 77 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 253 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 5 217 0 159 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 5 221 0 23 2 69 0 25] 
#[1 0 90 0 1 0 90 0 2 0 90 0 3 0 90 0 6 0 90 0 7 0 90 0 8 0 90 0 11 0 90 0 12 0 90 0 13 0 90 0 14 0 90 0 15 0 90 0 16 0 90 0 17 0 90 0 19 0 90 0 25 2 105 0 30 2 109 0 31 0 90 0 34 0 90 0 35 0 90 0 38 0 90 0 45 0 90 0 58 2 113 0 60 0 90 0 61 0 90 0 62 2 117 0 63 2 121 0 64 0 90 0 65 0 90 0 66 0 90 0 67 2 125 0 69 2 129 0 70 2 133 0 71 2 137 0 72 2 141 0 73 2 145 0 74 2 149 0 75 2 153 0 76 0 90 0 77 0 90 0 78 2 157 0 79 4 157 0 131] 
#[0 2 18 0 25 0 34 0 38 0 77] 
#[1 2 185 0 1 2 22 0 7 2 189 0 8 2 22 0 11 2 22 0 12 2 22 0 13 2 193 0 14 2 22 0 16 2 22 0 17 2 22 0 19 2 22 0 25 2 22 0 34 2 22 0 35 2 22 0 38 2 22 0 45 2 22 0 58 2 22 0 61 2 22 0 62 2 22 0 65 2 22 0 66 2 22 0 67 2 22 0 77] 
#[1 2 185 0 1 2 22 0 7 2 189 0 8 2 22 0 11 2 22 0 12 2 22 0 13 2 193 0 14 2 22 0 16 2 22 0 17 2 22 0 19 2 22 0 25 2 22 0 34 2 22 0 35 2 22 0 38 2 22 0 45 2 22 0 58 2 22 0 61 2 22 0 62 2 22 0 65 2 22 0 66 2 22 0 67 2 22 0 77] 
#[1 2 185 0 1 2 22 0 7 2 189 0 8 2 22 0 11 2 22 0 12 2 22 0 13 2 193 0 14 2 22 0 16 2 22 0 17 2 22 0 19 2 22 0 25 2 22 0 34 2 22 0 35 2 22 0 38 2 22 0 45 2 22 0 58 2 22 0 61 2 22 0 62 2 22 0 65 2 22 0 66 2 22 0 67 2 22 0 77] 
#[1 2 185 0 1 2 22 0 7 2 189 0 8 2 22 0 11 2 22 0 12 2 22 0 13 2 193 0 14 2 22 0 16 2 22 0 17 2 22 0 19 2 22 0 25 2 22 0 34 2 22 0 35 2 22 0 38 2 22 0 45 2 22 0 58 2 22 0 61 2 22 0 62 2 22 0 65 2 22 0 66 2 22 0 67 2 22 0 77] 
#[1 2 185 0 1 2 22 0 7 2 189 0 8 2 22 0 11 2 22 0 12 2 22 0 13 2 193 0 14 2 22 0 16 2 22 0 17 2 22 0 19 2 22 0 25 2 22 0 34 2 22 0 35 2 22 0 38 2 22 0 45 2 22 0 58 2 22 0 61 2 22 0 62 2 22 0 65 2 22 0 66 2 22 0 67 2 22 0 77] 
#[1 4 161 0 7 2 26 0 11 4 165 0 12 4 169 0 13 4 173 0 16 4 177 0 17 2 26 0 19 2 26 0 25 2 26 0 34 2 26 0 35 2 26 0 38 2 26 0 45 2 26 0 58 2 26 0 61 2 26 0 62 2 26 0 65 2 26 0 66 2 26 0 67 2 26 0 77] 
#[1 4 161 0 7 2 26 0 11 4 165 0 12 4 169 0 13 4 173 0 16 4 177 0 17 2 26 0 19 2 26 0 25 2 26 0 34 2 26 0 35 2 26 0 38 2 26 0 45 2 26 0 58 2 26 0 61 2 26 0 62 2 26 0 65 2 26 0 66 2 26 0 67 2 26 0 77] 
#[1 4 161 0 7 2 26 0 11 4 165 0 12 4 169 0 13 4 173 0 16 4 177 0 17 2 26 0 19 2 26 0 25 2 26 0 34 2 26 0 35 2 26 0 38 2 26 0 45 2 26 0 58 2 26 0 61 2 26 0 62 2 26 0 65 2 26 0 66 2 26 0 67 2 26 0 77] 
#[1 4 161 0 7 2 26 0 11 4 165 0 12 4 169 0 13 4 173 0 16 4 177 0 17 2 26 0 19 2 26 0 25 2 26 0 34 2 26 0 35 2 26 0 38 2 26 0 45 2 26 0 58 2 26 0 61 2 26 0 62 2 26 0 65 2 26 0 66 2 26 0 67 2 26 0 77] 
#[1 4 181 0 11 4 185 0 19 2 30 0 25 2 30 0 34 4 189 0 35 2 30 0 38 2 30 0 45 4 193 0 58 2 30 0 61 2 30 0 62 2 30 0 65 2 30 0 66 2 30 0 67 2 30 0 77] 
#[1 2 34 0 25 2 34 0 34 2 34 0 38 4 197 0 45 2 34 0 61 2 34 0 62 2 34 0 65 2 34 0 66 2 34 0 67 2 34 0 77] 
#[1 2 38 0 25 2 38 0 34 2 38 0 38 2 38 0 61 2 38 0 62 4 201 0 65 2 38 0 66 2 38 0 67 2 38 0 77] 
#[1 2 42 0 25 2 42 0 34 2 42 0 38 2 42 0 61 2 42 0 62 4 205 0 66 2 42 0 67 2 42 0 77] 
#[1 2 46 0 25 2 46 0 34 2 46 0 38 4 209 0 61 2 46 0 62 2 46 0 67 2 46 0 77] 
#[0 5 225 0 38] 
#[0 2 50 0 25 0 77] 
#[0 5 229 0 77] 
#[1 2 54 0 4 2 54 0 5 2 54 0 6 2 54 0 9 2 54 0 10 2 54 0 15 2 54 0 18 2 54 0 20 2 54 0 22 2 54 0 24 5 233 0 26 2 54 0 27 2 54 0 28 2 54 0 29 2 54 0 30 2 54 0 31 2 54 0 33 2 54 0 39 2 54 0 40 2 54 0 41 2 54 0 42 2 54 0 43 2 54 0 44 2 54 0 46 2 54 0 47 2 54 0 48 2 54 0 49 2 54 0 50 2 54 0 52 2 54 0 53 2 54 0 54 2 54 0 55 2 54 0 57 2 54 0 59 2 54 0 68 2 54 0 77 2 54 0 81 2 54 0 83 2 54 0 84 2 54 0 85 2 54 0 178] 
#[0 2 58 0 23 0 25] 
#[0 2 62 0 21 0 23 0 25 0 28 0 38 0 77 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 6 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 5 237 0 97 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 5 241 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 101 0 180 1 105 0 182] 
#[0 5 245 0 24] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 5 249 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 5 253 0 28 6 1 0 53 6 5 0 163] 
#[0 2 66 0 28 0 47 0 53] 
#[1 2 70 0 28 5 173 0 47 2 70 0 53 6 9 0 164] 
#[0 6 13 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 6 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 6 17 0 97 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 5 241 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 101 0 180 1 105 0 182] 
#[0 2 74 0 23 0 25] 
#[1 2 37 0 24 6 21 0 133] 
#[0 2 78 0 25 0 34 0 77] 
#[1 6 25 0 23 2 69 0 25] 
#[0 2 82 0 25 0 77] 
#[0 6 29 0 77] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 6 33 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 173 0 89 0 177 0 90 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 5 77 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 3 125 0 113 3 129 0 115 3 133 0 117 3 137 0 119 3 141 0 121 3 145 0 123 3 149 0 125 3 153 0 127 6 37 0 129 3 161 0 130 1 13 0 134 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 26 0 23 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 253 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 6 41 0 159 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 6 45 0 180 1 105 0 182] 
#[0 6 49 0 28] 
#[0 2 86 0 28] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 6 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 6 53 0 97 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 5 241 0 170 1 73 0 171 1 77 0 172 1 81 0 173 1 85 0 174 1 89 0 175 1 101 0 180 1 105 0 182] 
#[1 2 69 0 25 6 57 0 38] 
#[0 2 90 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 6 61 0 38] 
#[1 1 250 0 28 5 173 0 47 6 65 0 162 5 181 0 164 5 185 0 165] 
#[0 2 94 0 28 0 47 0 53] 
#[0 2 98 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 6 69 0 28] 
#[0 2 102 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 51 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 6 73 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 26 0 23 1 109 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 113 0 49 0 117 0 50 1 113 0 81 0 153 0 83 0 157 0 84 0 161 0 85 1 253 0 87 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 13 0 134 6 77 0 159 1 81 0 173 1 85 0 174 1 89 0 175 1 105 0 182] 
#[0 2 106 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 2 110 0 25 0 34 0 38 0 77] 
#[0 6 81 0 23] 
#[0 2 114 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 2 118 0 25 0 28] 
#[0 6 85 0 28] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 18 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 18 0 47 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 18 0 53 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 6 89 0 148 1 217 0 149 1 81 0 173 1 85 0 174 1 89 0 175 1 221 0 180 1 105 0 182] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 18 0 28 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 18 0 47 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 6 93 0 148 1 217 0 149 1 81 0 173 1 85 0 174 1 89 0 175 1 221 0 180 1 105 0 182] 
#[0 6 97 0 28] 
#[0 2 122 0 1 0 2 0 3 0 6 0 7 0 8 0 11 0 12 0 13 0 14 0 15 0 16 0 17 0 19 0 20 0 21 0 22 0 23 0 25 0 28 0 30 0 31 0 32 0 34 0 35 0 38 0 45 0 58 0 60 0 61 0 62 0 63 0 64 0 65 0 66 0 67 0 69 0 70 0 71 0 72 0 73 0 74 0 75 0 76 0 77 0 78 0 79 0 178] 
#[0 2 126 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 6 101 0 23] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 6 105 0 180 1 105 0 182] 
#[0 2 130 0 25 0 28] 
#[0 2 134 0 28 0 47 0 53] 
#[0 2 138 0 28 0 47] 
#[0 2 142 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[1 0 21 0 4 0 25 0 5 0 29 0 6 0 33 0 9 0 37 0 10 0 41 0 15 0 45 0 18 0 49 0 20 0 53 0 22 0 57 0 24 0 61 0 27 0 65 0 29 0 69 0 30 0 73 0 31 0 77 0 33 0 81 0 39 0 85 0 40 0 89 0 41 0 93 0 42 0 97 0 43 0 101 0 44 0 105 0 46 0 109 0 48 0 113 0 49 0 117 0 50 0 121 0 52 0 125 0 54 0 129 0 55 0 133 0 57 0 137 0 59 0 141 0 68 0 145 0 77 0 149 0 81 0 153 0 83 0 157 0 84 0 161 0 85 0 165 0 87 0 169 0 88 0 173 0 89 0 177 0 90 0 181 0 93 0 185 0 100 0 189 0 101 0 193 0 102 0 197 0 103 0 201 0 105 0 205 0 106 0 209 0 108 0 213 0 109 0 217 0 110 0 221 0 111 0 225 0 112 0 229 0 113 0 233 0 114 0 237 0 116 0 241 0 118 0 245 0 120 0 249 0 122 0 253 0 124 1 1 0 126 1 5 0 128 1 9 0 133 1 13 0 134 1 17 0 135 1 21 0 136 1 25 0 137 1 29 0 138 1 33 0 139 1 37 0 140 1 41 0 141 1 45 0 142 1 49 0 143 1 53 0 144 1 57 0 145 1 61 0 146 1 65 0 147 1 81 0 173 1 85 0 174 1 89 0 175 6 109 0 180 1 105 0 182] 
#[0 2 146 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178] 
#[0 2 150 0 4 0 5 0 6 0 9 0 10 0 15 0 18 0 20 0 22 0 24 0 26 0 27 0 28 0 29 0 30 0 31 0 33 0 39 0 40 0 41 0 42 0 43 0 44 0 46 0 47 0 48 0 49 0 50 0 52 0 53 0 54 0 55 0 57 0 59 0 68 0 77 0 81 0 83 0 84 0 85 0 178]
	).! !
!JSParser categoriesFor: #actionsForCurrentToken!private! !
!JSParser categoriesFor: #ambiguousTransitions!generated!public! !
!JSParser categoriesFor: #handleError:!private! !
!JSParser categoriesFor: #initialize!initialize/release!public! !
!JSParser categoriesFor: #keywords!private! !
!JSParser categoriesFor: #reduceActionForArguments1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForArguments2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForArrayLiteral1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForAssignmentExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForBlock1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForBooleanLiteral2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForBreakStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForCallExpression1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForCaseBlock1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForCaseBlock2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForCaseClause1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForCatch1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForConditionalExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForContinueStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForDebuggerStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForDefaultClause1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForElementList1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForElementList2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForEmptyStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForExpressionStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForFinally1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForFormalParameterListopt1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForFormalParameterListopt2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForFunctionExpression1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIfStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIfStatement2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForInitialiseropt1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForInitialiseropt2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement4:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement5:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForIterationStatement6:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLabelledStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLiteral1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLiteral2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLiteral3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLiteral4:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForLiteral5:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForMemberExpression3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForMemberExpression4:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForMemberExpression5:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForMultiplicativeExpression4:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForNewExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForObjectLiteral1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForObjectLiteral2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForObjectLiteral3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPostfixExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPrimaryExpression1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPrimaryExpression2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPrimaryExpression6:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForProgram1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPropertyAssignment1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPropertyAssignment2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForPropertyAssignment3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForReturnStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForSourceElements1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForSourceElements2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForSourceElementsopt1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForSourceElementsopt2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForSwitchStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForThrowStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForTryStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForTryStatement2:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForTryStatement3:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForUnaryExpression10:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForVariableDeclaration1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForVariableStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceActionForWithStatement1:!generated-reduction actions!public! !
!JSParser categoriesFor: #reduceTable!generated!public! !
!JSParser categoriesFor: #symbolTypes!generated!public! !
!JSParser categoriesFor: #transitionTable!generated!public! !

!JSParser class methodsFor!

definitionComment
"%root Program;
%prefix JS;
%suffix Node;

%start Expression Statement Program ;

%hierarchy Literal (
	NullLiteral 
	BooleanLiteral 
	NumericLiteral 
	StringLiteral
	RegularExpressionLiteral
);
%hierarchy Expression (
	ThisExpression
	Literal
	NameExpression
	ArrayLiteral
	ObjectLiteral
	Function
	IndexedPropertyExpression
	NamedPropertyExpression
	NewExpression
	CallExpression
	PostfixExpression
	UnaryExpression
	BinaryExpression
	ConditionalExpression
	AssignmentExpression
	CommaExpression
);
%hierarchy Statement (
	BlockStatement
	VariableStatement
	EmptyStatement
	ExpressionStatement
	IfStatement
	DoWhileStatement
	WhileStatement
	ForStatement
	ForInStatement
	ContinueStatement
	BreakStatement
	ReturnStatement
	WithStatement
	SwitchStatement
	LabelledStatement
	ThrowStatement
	TryStatement
	DebuggerStatement
);

%glr;

%id <semicolon> <identifier> <slash> <slashEqual> <regular_expression>;

%right ""else"";

<semicolon>
:	\;
;
<slash>
:	\/
;
<slashEqual>
:	\/\=
;

<comment>
	: \/\/ [^\r\n]*
	| (\/\* [^\*]* \*+ ([^\/\*] [^\*]* \*+)* \/)
	;
<hex>
:	[0-9a-fA-F]
;
<identifier_start>
:	<isLetter> | \$ | _ | (\\ u <hex>{4,4})
;
<identifier_part>	#TODO
:	<identifier_start> | <isDigit> 
;
<identifier>
:	<identifier_start> <identifier_part>*
;
<whitespace>
:	<isSeparator>+
;
<escape_sequence>
:	[^\r\n] | (x <hex>{2,2}) | (u <hex>{4,4})
;
<escape>
:	\\  <escape_sequence>
;
<line_continuation>
:	\\ (\r | \n | (\r\n))
;
<string>
:	(\"" ([^\""\\\r\n] | <line_continuation> | <escape>)* \"")+
|	(\' ([^\'\\\r\n] | <line_continuation> | <escape>)* \')+
;
<decimal_integer>
:	0 | ([1-9][0-9]*)
;
<decimal_digits>
:	[0-9]+
;
<exponent_part>
:	[eE] [\+\-]? <decimal_digits>
;
<decimal>
:	(<decimal_integer> \. <decimal_digits>? <exponent_part>?)
|	(\. <decimal_digits> <exponent_part>?)
|	(<decimal_integer> <exponent_part>?)
;
<hex_integer>
:	0 [xX] [0-9A-Fa-f]+
;
<numeric>
:	<decimal> | <hex_integer>
;
<regular_expression_backslash_sequence>
:	\\ [^\r\n]
;
<regular_expression_class_chars>
:	([^\\\]] | <regular_expression_backslash_sequence>)*
;
<regular_expression_class>
:	\[ <regular_expression_class_chars> \]
;
<regular_expression_first_char>
:	[^\\\/\[\*\r\n] | <regular_expression_backslash_sequence> | <regular_expression_class>
;
<regular_expression_char>
:	[^\\\/\[\r\n] | <regular_expression_backslash_sequence> | <regular_expression_class>
;
<regular_expression_chars>
:	<regular_expression_char>*
;
<regular_expression_body>
:	<regular_expression_first_char> <regular_expression_chars>
;
<regular_expression_flags>
:	<identifier>*
;
<regular_expression>
:	\/ <regular_expression_body> \/ <regular_expression_flags>
;
<patternToken>
	: (\`  [^\`]* \`)+
	;

goal : Program;

# A.3 Expressions
PrimaryExpression
:	""this"" 'thisToken' {{ThisExpression}}
|	<identifier> 'name' {{NameExpression}}	# mod
|	Literal 
|	ArrayLiteral 
|	ObjectLiteral 
|	""("" 'leftParen' Expression "")"" 'rightParen' {{Expression}}
;
ArrayLiteral 
#:	""["" Elisionopt ""]"" 
#:	""["" 'leftBracket' ""]"" 'rightBracket' {{}}	# mod
:	""["" 'leftBracket' ElementList ""]"" 'rightBracket' {{}}
#|	""["" ElementList "","" Elisionopt ""]""
;
############OLD############
#ElementList
##:	Elisionopt 
#:	Elision	# mod
#|	AssignmentExpression 
##|	ElementList "","" Elisionopt AssignmentExpression
#|	ElementList "","" Elision	#mod
#|	ElementList "","" AssignmentExpression	#mod
#;
#Elision
#:	"","" 'comma'
##|	Elision "",""
#;
###########################
ElementList
:	ElementExpression 'expression'
|	ElementList "","" 'comma' ElementExpression 'expression'
;
ElementExpression
:
|	AssignmentExpression
;
#####################
ObjectLiteral  
:	""{"" 'leftBrace' ""}"" 'rightBrace' {{}}
|	""{"" 'leftBrace' PropertyNameAndValueList ""}"" 'rightBrace' {{}}
|	""{"" 'leftBrace' PropertyNameAndValueList "","" 'comma' ""}"" 'rightBrace' {{}}
;
PropertyNameAndValueList 
:	PropertyAssignment 'assignment'
|	PropertyNameAndValueList "","" 'comma' PropertyAssignment 'assignment'
;
PropertyAssignment
:	PropertyName 'key' "":"" 'colonToken' AssignmentExpression 'value' {{}}
|	""get"" 'getToken' PropertyName 'key' ""("" 'leftParen' "")"" 'rightParen' ""{"" 'leftBrace' FunctionBody ""}"" 'rightBrace' {{GetPropertyAssignment}}
|	""set"" 'setToken' PropertyName 'key' ""("" 'leftParen' PropertySetParameterList "")"" 'rightParen' ""{"" 'leftBrace' FunctionBody ""}"" 'rightBrace' {{SetPropertyAssignment}}
;
PropertyName 
:	IdentifierName  'name' {{NameExpression}}
|	StringLiteral 
|	NumericLiteral
;
PropertySetParameterList 
:	<identifier>	'variable'	# mod
;
MemberExpression 
:	PrimaryExpression 
|	FunctionExpression 
|	MemberExpression 'expression' ""["" 'leftBracket' Expression 'fieldExpression' ""]"" 'rightBracket' {{IndexedPropertyExpression}}
|	MemberExpression 'expression' ""."" 'periodToken' IdentifierName 'name' {{NamedPropertyExpression}}
|	""new"" 'newToken' MemberExpression 'expression' Arguments {{NewExpression}}
;
NewExpression 
:	MemberExpression 
|	""new"" 'newToken' NewExpression 'expression' {{}}
;
CallExpression 
:	MemberExpression 'expression' Arguments {{}}
|	CallExpression 'expression' Arguments {{}}
|	CallExpression 'expression' ""["" 'leftBracket' Expression 'fieldExpression' ""]"" 'rightBracket' {{IndexedPropertyExpression}}
|	CallExpression 'expression' ""."" 'periodToken' IdentifierName 'name' {{NamedPropertyExpression}}
;
Arguments 
:	""("" 'left' "")"" 'right'
|	""("" 'left' ArgumentList "")"" 'right'
;
ArgumentList 
:	AssignmentExpression 'argument'
|	ArgumentList "","" 'comma' AssignmentExpression 'argument'
;
LeftHandSideExpression 
:	NewExpression 
|	CallExpression
;
PostfixExpression 
:	LeftHandSideExpression 
|	LeftHandSideExpression 'expression' ""++"" 'operator' {{}}
|	LeftHandSideExpression 'expression' ""--"" 'operator' {{}}
;
UnaryExpression 
:	PostfixExpression 
|	""delete"" 'operator' UnaryExpression 'expression' {{}}
|	""void"" 'operator' UnaryExpression 'expression' {{}}
|	""typeof"" 'operator' UnaryExpression 'expression' {{}}
|	""++"" 'operator' UnaryExpression 'expression' {{}}
|	""--"" 'operator' UnaryExpression 'expression' {{}}
|	""+"" 'operator' UnaryExpression 'expression' {{}}
|	""-"" 'operator' UnaryExpression 'expression' {{}}
|	""~"" 'operator' UnaryExpression 'expression' {{}} 
|	""!!"" 'operator' UnaryExpression 'expression' {{}}
;
MultiplicativeExpression 
:	UnaryExpression 
|	MultiplicativeExpression 'leftExpression' ""*"" 'operator' UnaryExpression 'rightExpression' {{BinaryExpression}}
|	MultiplicativeExpression 'leftExpression' <slash> 'operator' UnaryExpression 'rightExpression' {{BinaryExpression}}
|	MultiplicativeExpression 'leftExpression' ""%"" 'operator' UnaryExpression 'rightExpression' {{BinaryExpression}}
;
AdditiveExpression 
:	MultiplicativeExpression 
|	AdditiveExpression 'leftExpression' ""+"" 'operator' MultiplicativeExpression 'rightExpression' {{BinaryExpression}}
|	AdditiveExpression 'leftExpression' ""-"" 'operator' MultiplicativeExpression 'rightExpression' {{BinaryExpression}}
;
ShiftExpression 
:	AdditiveExpression 
|	ShiftExpression 'leftExpression' ""<<"" 'operator' AdditiveExpression 'rightExpression' {{BinaryExpression}}
|	ShiftExpression 'leftExpression' "">>"" 'operator' AdditiveExpression 'rightExpression' {{BinaryExpression}}
|	ShiftExpression 'leftExpression' "">>>"" 'operator' AdditiveExpression 'rightExpression' {{BinaryExpression}}
;
RelationalExpression 
:	ShiftExpression 
|	RelationalExpression 'leftExpression' ""<"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpression 'leftExpression' "">"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpression 'leftExpression' ""<="" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpression 'leftExpression' "">="" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpression 'leftExpression' ""instanceof"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpression 'leftExpression' ""in"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
;
RelationalExpressionNoIn 
:	ShiftExpression 
|	RelationalExpressionNoIn 'leftExpression' ""<"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpressionNoIn 'leftExpression' "">"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpressionNoIn 'leftExpression' ""<="" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpressionNoIn 'leftExpression' "">="" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
|	RelationalExpressionNoIn 'leftExpression' ""instanceof"" 'operator' ShiftExpression 'rightExpression' {{BinaryExpression}}
;
EqualityExpression 
:	RelationalExpression 
|	EqualityExpression 'leftExpression' ""=="" 'operator' RelationalExpression 'rightExpression' {{BinaryExpression}}
|	EqualityExpression 'leftExpression' ""!!="" 'operator' RelationalExpression 'rightExpression' {{BinaryExpression}}
|	EqualityExpression 'leftExpression' ""==="" 'operator' RelationalExpression 'rightExpression' {{BinaryExpression}}
|	EqualityExpression 'leftExpression' ""!!=="" 'operator' RelationalExpression 'rightExpression' {{BinaryExpression}}
;
EqualityExpressionNoIn 
:	RelationalExpressionNoIn 
|	EqualityExpressionNoIn 'leftExpression' ""=="" 'operator' RelationalExpressionNoIn 'rightExpression' {{BinaryExpression}}
|	EqualityExpressionNoIn 'leftExpression' ""!!="" 'operator' RelationalExpressionNoIn 'rightExpression' {{BinaryExpression}}
|	EqualityExpressionNoIn 'leftExpression' ""==="" 'operator' RelationalExpressionNoIn 'rightExpression' {{BinaryExpression}}
|	EqualityExpressionNoIn 'leftExpression' ""!!=="" 'operator' RelationalExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
BitwiseANDExpression 
:	EqualityExpression 
|	BitwiseANDExpression 'leftExpression'""&"" 'operator' EqualityExpression 'rightExpression' {{BinaryExpression}}
;
BitwiseANDExpressionNoIn 
:	EqualityExpressionNoIn 
|	BitwiseANDExpressionNoIn 'leftExpression' ""&"" 'operator' EqualityExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
BitwiseXORExpression 
:	BitwiseANDExpression 
|	BitwiseXORExpression 'leftExpression' ""^"" 'operator' BitwiseANDExpression 'rightExpression' {{BinaryExpression}}
;
BitwiseXORExpressionNoIn 
:	BitwiseANDExpressionNoIn 
|	BitwiseXORExpressionNoIn 'leftExpression' ""^"" 'operator' BitwiseANDExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
BitwiseORExpression 
:	BitwiseXORExpression 
|	BitwiseORExpression 'leftExpression' ""|"" 'operator' BitwiseXORExpression 'rightExpression' {{BinaryExpression}}
;
BitwiseORExpressionNoIn 
:	BitwiseXORExpressionNoIn 
|	BitwiseORExpressionNoIn 'leftExpression' ""|"" 'operator' BitwiseXORExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
LogicalANDExpression 
:	BitwiseORExpression 
|	LogicalANDExpression 'leftExpression' ""&&"" 'operator' BitwiseORExpression 'rightExpression' {{BinaryExpression}}
;
LogicalANDExpressionNoIn 
:	BitwiseORExpressionNoIn 
|	LogicalANDExpressionNoIn 'leftExpression' ""&&"" 'operator' BitwiseORExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
LogicalORExpression 
:	LogicalANDExpression 
|	LogicalORExpression 'leftExpression' ""||"" 'operator' LogicalANDExpression 'rightExpression' {{BinaryExpression}}
;
LogicalORExpressionNoIn 
:	LogicalANDExpressionNoIn 
|	LogicalORExpressionNoIn 'leftExpression' ""||"" 'operator' LogicalANDExpressionNoIn 'rightExpression' {{BinaryExpression}}
;
ConditionalExpression 
:	LogicalORExpression 
|	LogicalORExpression 'condition' ""?"" 'questionMarkToken' AssignmentExpression 'trueExpression' "":"" 'colonToken' AssignmentExpression 'falseExpression' {{}}
;
ConditionalExpressionNoIn 
:	LogicalORExpressionNoIn 
|	LogicalORExpressionNoIn 'condition' ""?"" 'questionMarkToken' AssignmentExpressionNoIn 'trueExpression' "":"" 'colonToken' AssignmentExpressionNoIn 'falseExpression' {{ConditionalExpression}}
;
AssignmentExpression 
:	ConditionalExpression 
|	LeftHandSideExpression 'lhs' AssignmentOperator 'operator' AssignmentExpression 'rhs' {{}}
;
AssignmentExpressionNoIn 
:	ConditionalExpressionNoIn 
|	LeftHandSideExpression 'lhs' AssignmentOperator 'operator' AssignmentExpressionNoIn 'rhs' {{AssignmentExpression}}
;
AssignmentOperator
:	""=""
|	""*=""
|	<slashEqual>
|	""%=""
|	""+=""
|	""-=""
|	""<<=""
|	"">>=""
|	"">>>=""
|	""&=""
|	""^=""
|	""|=""
;
Expression
:	AssignmentExpression 
|	Expression 'expression' "","" 'comma' AssignmentExpression 'expression' {{CommaExpression}}
;
ExpressionNoIn
:	AssignmentExpressionNoIn 
|	ExpressionNoIn 'expression' "","" 'comma' AssignmentExpressionNoIn 'expression' {{CommaExpression}}
;
#A.4 Statements
Statement 
:	Block 
|	VariableStatement 
|	EmptyStatement 
|	ExpressionStatement 
|	IfStatement 
|	IterationStatement 
|	ContinueStatement 
|	BreakStatement 
|	ReturnStatement 
|	WithStatement 
|	LabelledStatement 
|	SwitchStatement 
|	ThrowStatement 
|	TryStatement 
|	DebuggerStatement
;
Block 
:	""{"" 'leftBrace' StatementListopt ""}"" 'rightBrace' {{BlockStatement}}
;
StatementList 
:	Statement 'statement'
|	StatementList Statement 'statement'
;
VariableStatement 
:	""var"" 'varToken' VariableDeclarationList <semicolon> 'semicolon' {{}}
;
VariableDeclarationList 
:	VariableDeclaration 'variable'
|	VariableDeclarationList "","" 'comma' VariableDeclaration 'variable'
;
VariableDeclarationListNoIn 
:	VariableDeclarationNoIn 'variable'
|	VariableDeclarationListNoIn "","" 'comma' VariableDeclarationNoIn 'variable'
;
VariableDeclaration 
:	<identifier> 'variable' Initialiseropt {{VariableDeclaration}}	# mod
;
VariableDeclarationNoIn 
:	<identifier> 'variable' InitialiserNoInopt {{VariableDeclaration}}	# mod
;
Initialiser 
:	""="" 'equalsToken' AssignmentExpression 'value'
;
InitialiserNoIn 
:	""="" 'equalsToken' AssignmentExpressionNoIn 'value'
;
EmptyStatement 
:	<semicolon> 'semicolon' {{}}
;
ExpressionStatement 
:	Expression 'expression' <semicolon> 'semicolon' {{}}
;
IfStatement 
:	""if"" 'ifToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' Statement 'trueStatement' ""else"" 'elseToken' Statement 'elseStatement' {{}}
|	""if"" 'ifToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' Statement 'trueStatement' {{}}
;
IterationStatement 
:	""do"" 'doToken' Statement 'statement' ""while"" 'whileToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' <semicolon> 'semicolon' {{DoWhileStatement}}
|	""while"" 'whileToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' Statement 'statement' {{WhileStatement}}
|	""for"" 'forToken' ""("" 'leftParen' ExpressionNoInopt 'initialExpression'<semicolon> 'semicolon' Expressionopt 'condition'<semicolon> 'semicolon' Expressionopt 'iteratorExpression' "")"" 'rightParen' Statement 'statement' {{ForStatement}}
|	""for"" 'forToken' ""("" 'leftParen' ""var"" 'varToken' VariableDeclarationListNoIn <semicolon> 'semicolon' Expressionopt 'condition' <semicolon> 'semicolon' Expressionopt 'iteratorExpression' "")"" 'rightParen' Statement 'statement' {{ForStatement}}
|	""for"" 'forToken' ""("" 'leftParen' LeftHandSideExpression 'variable' ""in"" 'inToken' Expression 'expression' "")"" 'rightParen' Statement 'statement' {{ForInStatement}}
|	""for"" 'forToken' ""("" 'leftParen' ""var"" 'varToken' VariableDeclarationNoIn 'variable' ""in"" 'inToken' Expression 'expression' "")"" 'rightParen' Statement  'statement' {{ForInStatement}}
;
ContinueStatement 
:	""continue"" 'continueToken' Identifieropt 'label' <semicolon> 'semicolon' {{}}
;
BreakStatement 
:	""break"" 'breakToken' Identifieropt 'label' <semicolon> 'semicolon' {{}}
;
ReturnStatement  
:	""return"" 'returnToken' Expressionopt 'expression' <semicolon> 'semicolon' {{}}
;
WithStatement 
:	""with"" 'withToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' Statement 'statement' {{}}
;
SwitchStatement 
:	""switch"" 'switchToken' ""("" 'leftParen' Expression 'expression' "")"" 'rightParen' CaseBlock {{}}
;
CaseBlock 
:	""{"" 'leftBrace' CaseClausesopt ""}"" 'rightBrace' 
|	""{"" 'leftBrace' CaseClausesopt DefaultClause 'clause' CaseClausesopt ""}"" 'rightBrace'
;
CaseClauses 
:	CaseClause 'clause'
|	CaseClauses CaseClause 'clause'
;
CaseClause 
:	""case"" 'caseToken' Expression 'caseExpression' "":"" 'colonToken' StatementListopt {{}}
;
DefaultClause 
:	""default"" 'defaultToken' "":"" 'colonToken' StatementListopt  {{}}
;
LabelledStatement 
:	<identifier> 'label' "":"" 'colonToken' Statement 'statement' {{}}	# mod
;
ThrowStatement 
:	""throw"" 'throwToken' Expression 'expression' <semicolon> 'semicolon' {{}}
;
TryStatement 
:	""try"" 'tryToken' Block 'tryBlock' Catch {{}}
|	""try"" 'tryToken' Block 'tryBlock' Finally {{}}
|	""try"" 'tryToken' Block 'tryBlock' Catch Finally {{}}
;
Catch 
:	""catch"" 'catchToken' ""("" 'leftParen' <identifier> 'exceptionType' "")"" 'rightParen' Block 'catchBlock'	# mod
;
Finally 
:	""finally"" 'finallyToken' Block 'finallyBlock'
;
DebuggerStatement 
:	""debugger"" 'debuggerToken' <semicolon> 'semicolon' {{}}
;
#A.5 Functions and Programs
#FunctionDeclaration 
#:	""function"" 'functionToken' <identifier> 'name' ""("" 'leftParen' FormalParameterListopt "")"" 'rightParen' ""{"" 'leftBrace' FunctionBody ""}"" 'rightBrace' {{FunctionDeclaration}}
#;
FunctionExpression 
:	""function"" 'functionToken' Identifieropt 'name' ""("" 'leftParen' FormalParameterListopt "")"" 'rightParen' ""{"" 'leftBrace' FunctionBody ""}"" 'rightBrace' {{Function}}
;
FormalParameterList 
:	<identifier> 'argument'	# mod
|	FormalParameterList "","" 'comma' <identifier> 'argument'	# mod
;
FunctionBody 
:	SourceElementsopt
;
Program  
:	SourceElementsopt  {{File}}
;
SourceElements 
:	SourceElement 'statement'
|	SourceElements SourceElement 'statement'
;
SourceElement  
:	Statement 
#|	FunctionDeclaration
;

#Optional
CaseClausesopt
:
|	CaseClauses
;
Expressionopt
:
|	Expression
;
ExpressionNoInopt
:
|	ExpressionNoIn
;
FormalParameterListopt
:
|	FormalParameterList
;
Identifieropt
:
|	<identifier>
;
Initialiseropt
:
|	Initialiser
;
InitialiserNoInopt
:
|	InitialiserNoIn
;
SourceElementsopt
:
|	SourceElements
;
StatementListopt
:
|	StatementList
;


Literal
:	NullLiteral 'value' {{NullLiteral}}
|	BooleanLiteral 'value' {{BooleanLiteral}}
|	NumericLiteral 'value' {{NumericLiteral}}
|	StringLiteral 'value' {{StringLiteral}}
|	RegularExpressionLiteral 'value' {{RegularExpressionLiteral}}
;
NullLiteral
:	""null""
;
BooleanLiteral
:	""true""
|	""false""
;

#Identifier
#:	IdentifierName
#;
IdentifierName
:	<identifier>
;
StringLiteral
:	<string>
;
NumericLiteral
:	<numeric>
;
RegularExpressionLiteral
:	<regular_expression>
;"!

fileExtension
	^'.js'!

fileExtensionType
	^'Javascript files'!

scannerClass
	^JSScanner!

startingStateForExpression
	^2!

startingStateForgoal
	^1!

startingStateForProgram
	^4!

startingStateForStatement
	^3! !
!JSParser class categoriesFor: #definitionComment!generated!public! !
!JSParser class categoriesFor: #fileExtension!file types!public! !
!JSParser class categoriesFor: #fileExtensionType!file types!public! !
!JSParser class categoriesFor: #scannerClass!generated-accessing!public! !
!JSParser class categoriesFor: #startingStateForExpression!generated!public! !
!JSParser class categoriesFor: #startingStateForgoal!generated!public! !
!JSParser class categoriesFor: #startingStateForProgram!generated!public! !
!JSParser class categoriesFor: #startingStateForStatement!generated!public! !

JSScanner guid: (GUID fromString: '{C18137D8-D724-41F7-9F23-7C9766DA8CC2}')!
JSScanner comment: ''!
!JSScanner categoriesForClass!Unclassified! !
!JSScanner methodsFor!

emptySymbolTokenId
	^178!

errorTokenId
	^179!

identifierId
	^81!

regular_expressionId
	^85!

scan1
	[self step.
	currentCharacter == $" ifTrue: [^self scan2].
	currentCharacter == $\ ifTrue: [^self scan3].
	currentCharacter <= ##(Character value: 9)
		or:
			[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
				or:
					[(currentCharacter between: ##(Character value: 14) and: $!!)
						or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]]]] whileTrue.
	^self reportLastMatch!

scan10
	self step.
	currentCharacter isDigit
		ifTrue:
			[[self recordMatch: #(84).
			self step.
			currentCharacter isDigit] whileTrue.
			^self reportLastMatch].
	('+-' includes: currentCharacter)
		ifTrue:
			[self step.
			currentCharacter isDigit
				ifTrue:
					[[self recordMatch: #(84).
					self step.
					currentCharacter isDigit] whileTrue]].
	^self reportLastMatch!

scan11
	[self step.
	currentCharacter == $/ ifTrue: [^self scan12].
	currentCharacter == $[ ifTrue: [^self scan15].
	currentCharacter == $\ ifTrue: [^self scan16].
	currentCharacter <= ##(Character value: 9)
		or:
			[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
				or:
					[(currentCharacter between: ##(Character value: 14) and: $.)
						or: [(currentCharacter between: $0 and: $Z) or: [currentCharacter >= $]]]]]] whileTrue.
	^self reportLastMatch!

scan12
	self recordMatch: #(85).
	self step.
	currentCharacter == $\ ifTrue: [^self scan14].
	(currentCharacter isLetter or: ['$_' includes: currentCharacter]) ifTrue: [^self scan13].
	^self reportLastMatch!

scan13
	[self recordMatch: #(85).
	self step.
	currentCharacter == $\ ifTrue: [^self scan14].
	currentCharacter isLetter or: [currentCharacter isHexDigit or: ['$_' includes: currentCharacter]]] whileTrue.
	^self reportLastMatch!

scan14
	self step.
	currentCharacter == $u
		ifTrue:
			[4
				timesRepeat:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
			^self scan13].
	^self reportLastMatch!

scan15
	[self step.
	currentCharacter == $\
		ifTrue:
			[self step.
			(currentCharacter <= ##(Character value: 9)
				or:
					[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
						or: [currentCharacter >= ##(Character value: 14)]]) ifTrue: [^self scan15].
			^self reportLastMatch].
	currentCharacter == $] ifTrue: [^self scan11]] repeat!

scan16
	self step.
	(currentCharacter <= ##(Character value: 9)
		or:
			[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
				or: [currentCharacter >= ##(Character value: 14)]]) ifTrue: [^self scan11].
	^self reportLastMatch!

scan17
	[self step.
	currentCharacter == $*
		ifTrue:
			[[self step.
			currentCharacter == $*] whileTrue.
			currentCharacter == $/ ifTrue: [^self recordAndReportMatch: #(80)].
			^self scan17]] repeat!

scan18
	[self step.
	currentCharacter == $`
		ifTrue:
			[self recordMatch: #(86).
			self step.
			currentCharacter == $` ifTrue: [^self scan18].
			^self reportLastMatch]] repeat!

scan2
	self recordMatch: #(83).
	self step.
	currentCharacter == $" ifTrue: [^self scan1].
	^self reportLastMatch!

scan3
	self step.
	currentCharacter == ##(Character value: 13)
		ifTrue:
			[self step.
			currentCharacter == $" ifTrue: [^self scan2].
			currentCharacter == $\ ifTrue: [^self scan3].
			(currentCharacter <= ##(Character value: 12)
				or:
					[(currentCharacter between: ##(Character value: 14) and: $!!)
						or: [(currentCharacter between: $# and: $[) or: [currentCharacter >= $]]]]) ifTrue: [^self scan1].
			^self reportLastMatch].
	^self scan1!

scan4
	[self recordMatch: #(81).
	self step.
	currentCharacter == $\ ifTrue: [^self scan5].
	currentCharacter isLetter or: [currentCharacter isHexDigit or: ['$_' includes: currentCharacter]]] whileTrue.
	^self reportLastMatch!

scan5
	self step.
	currentCharacter == $u
		ifTrue:
			[4
				timesRepeat:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]) ifFalse: [^self reportLastMatch]].
			^self scan4].
	^self reportLastMatch!

scan6
	[self step.
	currentCharacter == $' ifTrue: [^self scan7].
	currentCharacter == $\ ifTrue: [^self scan8].
	currentCharacter <= ##(Character value: 9)
		or:
			[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
				or:
					[(currentCharacter between: ##(Character value: 14) and: $&)
						or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]]] whileTrue.
	^self reportLastMatch!

scan7
	self recordMatch: #(83).
	self step.
	currentCharacter == $' ifTrue: [^self scan6].
	^self reportLastMatch!

scan8
	self step.
	currentCharacter == ##(Character value: 13)
		ifTrue:
			[self step.
			currentCharacter == $' ifTrue: [^self scan7].
			currentCharacter == $\ ifTrue: [^self scan8].
			(currentCharacter <= ##(Character value: 12)
				or:
					[(currentCharacter between: ##(Character value: 14) and: $&)
						or: [(currentCharacter between: $( and: $[) or: [currentCharacter >= $]]]]) ifTrue: [^self scan6].
			^self reportLastMatch].
	^self scan6!

scan9
	[self recordMatch: #(84).
	self step.
	currentCharacter isDigit] whileTrue.
	('Ee' includes: currentCharacter) ifTrue: [^self scan10].
	^self reportLastMatch!

scanForToken
	self step.
	currentCharacter == $!!
		ifTrue:
			[self recordMatch: #(4).
			self step.
			currentCharacter == $=
				ifTrue:
					[self recordMatch: #(35).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(58)]].
			^self reportLastMatch].
	currentCharacter == $" ifTrue: [^self scan1].
	currentCharacter == $%
		ifTrue:
			[self recordMatch: #(2).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(63)].
			^self reportLastMatch].
	currentCharacter == $&
		ifTrue:
			[self recordMatch: #(45).
			self step.
			currentCharacter == $& ifTrue: [^self recordAndReportMatch: #(61)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(72)].
			^self reportLastMatch].
	currentCharacter == $' ifTrue: [^self scan6].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(22)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(23)].
	currentCharacter == $*
		ifTrue:
			[self recordMatch: #(3).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(64)].
			^self reportLastMatch].
	currentCharacter == $+
		ifTrue:
			[self recordMatch: #(15).
			self step.
			currentCharacter == $+ ifTrue: [^self recordAndReportMatch: #(30)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(69)].
			^self reportLastMatch].
	currentCharacter == $, ifTrue: [^self recordAndReportMatch: #(25)].
	currentCharacter == $-
		ifTrue:
			[self recordMatch: #(6).
			self step.
			currentCharacter == $- ifTrue: [^self recordAndReportMatch: #(31)].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(73)].
			^self reportLastMatch].
	currentCharacter == $.
		ifTrue:
			[self recordMatch: #(32).
			self step.
			currentCharacter isDigit ifTrue: [^self scan9].
			^self reportLastMatch].
	currentCharacter == $/
		ifTrue:
			[self recordMatch: #(78).
			self step.
			currentCharacter == $* ifTrue: [^self scan17].
			currentCharacter == $/
				ifTrue:
					[[self recordMatch: #(80).
					self step.
					currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or: [currentCharacter >= ##(Character value: 14)]]] whileTrue.
					^self reportLastMatch].
			currentCharacter == $=
				ifTrue:
					[self recordMatch: #(79).
					self step.
					currentCharacter == $/ ifTrue: [^self scan12].
					currentCharacter == $[ ifTrue: [^self scan15].
					currentCharacter == $\ ifTrue: [^self scan16].
					(currentCharacter <= ##(Character value: 9)
						or:
							[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
								or:
									[(currentCharacter between: ##(Character value: 14) and: $.)
										or: [(currentCharacter between: $0 and: $Z) or: [currentCharacter >= $]]]]]) ifTrue: [^self scan11].
					^self reportLastMatch].
			currentCharacter == $[ ifTrue: [^self scan15].
			currentCharacter == $\ ifTrue: [^self scan16].
			(currentCharacter <= ##(Character value: 9)
				or:
					[(currentCharacter between: ##(Character value: 11) and: ##(Character value: 12))
						or:
							[(currentCharacter between: ##(Character value: 14) and: $))
								or:
									[(currentCharacter between: $+ and: $.)
										or:
											[(currentCharacter between: $0 and: $<) or: [(currentCharacter between: $> and: $Z) or: [currentCharacter >= $]]]]]]])
				ifTrue: [^self scan11].
			^self reportLastMatch].
	currentCharacter == $0
		ifTrue:
			[self recordMatch: #(84).
			self step.
			currentCharacter == $. ifTrue: [^self scan9].
			('Ee' includes: currentCharacter) ifTrue: [^self scan10].
			('Xx' includes: currentCharacter)
				ifTrue:
					[self step.
					(currentCharacter isHexDigit or: [currentCharacter between: $a and: $f])
						ifTrue:
							[[self recordMatch: #(84).
							self step.
							currentCharacter isHexDigit or: [currentCharacter between: $a and: $f]] whileTrue]].
			^self reportLastMatch].
	currentCharacter == $: ifTrue: [^self recordAndReportMatch: #(38)].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(77)].
	currentCharacter == $<
		ifTrue:
			[self recordMatch: #(7).
			self step.
			currentCharacter == $<
				ifTrue:
					[self recordMatch: #(1).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(74)].
					^self reportLastMatch].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(17)].
			^self reportLastMatch].
	currentCharacter == $=
		ifTrue:
			[self recordMatch: #(60).
			self step.
			currentCharacter == $=
				ifTrue:
					[self recordMatch: #(11).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(19)]].
			^self reportLastMatch].
	currentCharacter == $>
		ifTrue:
			[self recordMatch: #(16).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(12)].
			currentCharacter == $>
				ifTrue:
					[self recordMatch: #(8).
					self step.
					currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(75)].
					currentCharacter == $>
						ifTrue:
							[self recordMatch: #(14).
							self step.
							currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(71)]]].
			^self reportLastMatch].
	currentCharacter == $? ifTrue: [^self recordAndReportMatch: #(67)].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(20)].
	currentCharacter == $\ ifTrue: [^self scan5].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(21)].
	currentCharacter == $^
		ifTrue:
			[self recordMatch: #(65).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(76)].
			^self reportLastMatch].
	currentCharacter == $` ifTrue: [^self scan18].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(24)].
	currentCharacter == $|
		ifTrue:
			[self recordMatch: #(66).
			self step.
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(70)].
			currentCharacter == $| ifTrue: [^self recordAndReportMatch: #(62)].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(28)].
	currentCharacter == $~ ifTrue: [^self recordAndReportMatch: #(5)].
	currentCharacter isDigit
		ifTrue:
			[[self recordMatch: #(84).
			self step.
			currentCharacter == $. ifTrue: [^self scan9].
			currentCharacter isDigit] whileTrue.
			('Ee' includes: currentCharacter) ifTrue: [^self scan10].
			^self reportLastMatch].
	currentCharacter isWhitespace
		ifTrue:
			[[self recordMatch: #(82).
			self step.
			currentCharacter isWhitespace] whileTrue.
			^self reportLastMatch].
	(currentCharacter isLetter or: ['$_' includes: currentCharacter]) ifTrue: [^self scan4].
	^self reportLastMatch!

semicolonId
	^77!

slashEqualId
	^79!

slashId
	^78!

tokenActions
	^#(nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil nil #comment nil #whitespace nil nil nil #patternToken)! !
!JSScanner categoriesFor: #emptySymbolTokenId!generated!public! !
!JSScanner categoriesFor: #errorTokenId!generated!public! !
!JSScanner categoriesFor: #identifierId!generated!public! !
!JSScanner categoriesFor: #regular_expressionId!generated!public! !
!JSScanner categoriesFor: #scan1!generated!public! !
!JSScanner categoriesFor: #scan10!generated!public! !
!JSScanner categoriesFor: #scan11!generated!public! !
!JSScanner categoriesFor: #scan12!generated!public! !
!JSScanner categoriesFor: #scan13!generated!public! !
!JSScanner categoriesFor: #scan14!generated!public! !
!JSScanner categoriesFor: #scan15!generated!public! !
!JSScanner categoriesFor: #scan16!generated!public! !
!JSScanner categoriesFor: #scan17!generated!public! !
!JSScanner categoriesFor: #scan18!generated!public! !
!JSScanner categoriesFor: #scan2!generated!public! !
!JSScanner categoriesFor: #scan3!generated!public! !
!JSScanner categoriesFor: #scan4!generated!public! !
!JSScanner categoriesFor: #scan5!generated!public! !
!JSScanner categoriesFor: #scan6!generated!public! !
!JSScanner categoriesFor: #scan7!generated!public! !
!JSScanner categoriesFor: #scan8!generated!public! !
!JSScanner categoriesFor: #scan9!generated!public! !
!JSScanner categoriesFor: #scanForToken!generated!public! !
!JSScanner categoriesFor: #semicolonId!generated!public! !
!JSScanner categoriesFor: #slashEqualId!generated!public! !
!JSScanner categoriesFor: #slashId!generated!public! !
!JSScanner categoriesFor: #tokenActions!generated!public! !

!JSScanner class methodsFor!

initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(81 'break' 43) #(81 'case' 47) #(81 'catch' 56) #(81 'continue' 44) #(81 'debugger' 52) #(81 'default' 53) #(81 'delete' 18) #(81 'do' 48) #(81 'else' 26) #(81 'false' 10) #(81 'finally' 51) #(81 'for' 57) #(81 'function' 49) #(81 'get' 36) #(81 'if' 68) #(81 'in' 34) #(81 'instanceof' 13) #(81 'new' 33) #(81 'null' 50) #(81 'return' 42) #(81 'set' 37) #(81 'switch' 40) #(81 'this' 27) #(81 'throw' 46) #(81 'true' 39) #(81 'try' 55) #(81 'typeof' 9) #(81 'var' 59) #(81 'void' 29) #(81 'while' 54) #(81 'with' 41))
		do: [:each | (keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2) put: each last].
	^keywordMap! !
!JSScanner class categoriesFor: #initializeKeywordMap!generated-initialization!public! !

"Binary Globals"!

